/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* AMDGPUPostLegalizerCombinerImpl Combiner Match Table                       *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GICOMBINER_DEPS
#include "llvm/ADT/SparseBitVector.h"
namespace llvm {
extern cl::OptionCategory GICombinerOptionCategory;
} // end namespace llvm
#endif // ifdef GET_GICOMBINER_DEPS

#ifdef GET_GICOMBINER_TYPES
struct AMDGPUPostLegalizerCombinerImplRuleConfig {
  SparseBitVector<> DisabledRules;

  bool isRuleEnabled(unsigned RuleID) const;
  bool parseCommandLineOption();
  bool setRuleEnabled(StringRef RuleIdentifier);
  bool setRuleDisabled(StringRef RuleIdentifier);
};

static std::optional<uint64_t> getRuleIdxForIdentifier(StringRef RuleIdentifier) {
  uint64_t I;
  // getAtInteger(...) returns false on success
  bool Parsed = !RuleIdentifier.getAsInteger(0, I);
  if (Parsed)
    return I;

#ifndef NDEBUG
  switch (RuleIdentifier.size()) {
  default: break;
  case 7:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "smulu64", 7) != 0)
      break;
    return 225;	 // "smulu64"
  case 9:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "opy_prop", 8) != 0)
        break;
      return 13;	 // "copy_prop"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ors", 7) != 0)
          break;
        return 194;	 // "match_ors"
      case 'u':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "lo_by_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case '0':	 // 1 string to match.
          return 144;	 // "mulo_by_0"
        case '2':	 // 1 string to match.
          return 143;	 // "mulo_by_2"
        }
        break;
      }
      break;
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "neg_zext", 8) != 0)
        break;
      return 199;	 // "nneg_zext"
    }
    break;
  case 10:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2p_to_p2i", 9) != 0)
        break;
      return 89;	 // "i2p_to_p2i"
    case 'm':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_ands", 8) != 0)
          break;
        return 193;	 // "match_ands"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_to_shl", 8) != 0)
          break;
        return 14;	 // "mul_to_shl"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2i_to_i2p", 9) != 0)
        break;
      return 88;	 // "p2i_to_i2p"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_trunc", 8) != 0)
          break;
        return 197;	 // "sext_trunc"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_to_add", 8) != 0)
          break;
        return 15;	 // "sub_to_add"
      }
      break;
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc", 9) != 0)
        break;
      return 198;	 // "zext_trunc"
    }
    break;
  case 11:	 // 5 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_sub_reg", 10) != 0)
        break;
      return 94;	 // "add_sub_reg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_addos", 10) != 0)
        break;
      return 213;	 // "match_addos"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ub_add_reg", 10) != 0)
        break;
      return 188;	 // "sub_add_reg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_shift", 10) != 0)
        break;
      return 131;	 // "trunc_shift"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_cst", 10) != 0)
        break;
      return 207;	 // "unmerge_cst"
    }
    break;
  case 12:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinusB", 11) != 0)
        break;
      return 2;	 // "APlusBMinusB"
    case 'B':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusAPlusA", 11) != 0)
        break;
      return 3;	 // "BMinusAPlusA"
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dde_to_addo", 11) != 0)
        break;
      return 145;	 // "adde_to_addo"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "sub_to_fneg", 11) != 0)
        break;
      return 190;	 // "fsub_to_fneg"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ulh_to_lshr", 11) != 0)
        break;
      return 171;	 // "mulh_to_lshr"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ot_cmp_fold", 11) != 0)
        break;
      return 132;	 // "not_cmp_fold"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_or", 11) != 0)
        break;
      return 127;	 // "redundant_or"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_pow2", 10) != 0)
          break;
        return 185;	 // "sdiv_by_pow2"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "xt_of_sext", 10) != 0)
          break;
        return 48;	 // "sext_of_sext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "div_by_pow2", 11) != 0)
        break;
      return 184;	 // "udiv_by_pow2"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_zext", 11) != 0)
        break;
      return 46;	 // "zext_of_zext"
    }
    break;
  case 13:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dd_of_vscale", 12) != 0)
        break;
      return 37;	 // "add_of_vscale"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_shift", 12) != 0)
        break;
      return 161;	 // "commute_shift"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oldable_fneg", 12) != 0)
        break;
      return 221;	 // "foldable_fneg"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_and_mask", 12) != 0)
        break;
      return 69;	 // "load_and_mask"
    case 'm':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "tch_selects", 11) != 0)
          break;
        return 124;	 // "match_selects"
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "rge_unmerge", 11) != 0)
          break;
        return 206;	 // "merge_unmerge"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 38;	 // "mul_of_vscale"
      }
      break;
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_and", 12) != 0)
        break;
      return 125;	 // "redundant_and"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 187;	 // "sdiv_by_const"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "l_of_vscale", 11) != 0)
          break;
        return 39;	 // "shl_of_vscale"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "b_of_vscale", 11) != 0)
          break;
        return 40;	 // "sub_of_vscale"
      }
      break;
    case 'u':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_const", 11) != 0)
          break;
        return 186;	 // "udiv_by_const"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "merge_", 6) != 0)
          break;
        switch (RuleIdentifier[8]) {
        default: break;
        case 'm':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "erge", 4) != 0)
            break;
          return 205;	 // "unmerge_merge"
        case 'u':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+9, "ndef", 4) != 0)
            break;
          return 208;	 // "unmerge_undef"
        }
        break;
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_by_const", 11) != 0)
          break;
        return 183;	 // "urem_by_const"
      }
      break;
    }
    break;
  case 14:	 // 17 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1PlusC2", 12) != 0)
          break;
        return 12;	 // "AMinusC1PlusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusC1MinusC2", 12) != 0)
          break;
        return 8;	 // "APlusC1MinusC2"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "2MinusAPlusC1", 13) != 0)
        break;
      return 9;	 // "C2MinusAPlusC1"
    case 'a':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_", 9) != 0)
        break;
      switch (RuleIdentifier[10]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 52;	 // "anyext_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+11, "ext", 3) != 0)
          break;
        return 51;	 // "anyext_of_zext"
      }
      break;
    case 'b':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'i')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "op_same_val", 11) != 0)
          break;
        return 85;	 // "binop_same_val"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "reverse_shl", 11) != 0)
          break;
        return 159;	 // "bitreverse_shl"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "vt_f32_ubyteN", 13) != 0)
        break;
      return 219;	 // "cvt_f32_ubyteN"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "bs_fneg_fold", 12) != 0)
          break;
        return 170;	 // "fabs_fneg_fold"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "eg_fneg_fold", 12) != 0)
          break;
        return 91;	 // "fneg_fneg_fold"
      }
      break;
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ul_by_neg_one", 13) != 0)
        break;
      return 17;	 // "mul_by_neg_one"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eassoc_ptradd", 13) != 0)
        break;
      return 106;	 // "reassoc_ptradd"
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 2 strings to match.
        switch (RuleIdentifier[2]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "ect_of_zext", 11) != 0)
            break;
          return 54;	 // "select_of_zext"
        case 'x':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+3, "t_of_anyext", 11) != 0)
            break;
          return 49;	 // "sext_of_anyext"
        }
        break;
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ifts_too_big", 12) != 0)
          break;
        return 105;	 // "shifts_too_big"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "char_to_float", 13) != 0)
        break;
      return 218;	 // "uchar_to_float"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_of_anyext", 13) != 0)
        break;
      return 47;	 // "zext_of_anyext"
    }
    break;
  case 15:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'M':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "inusC1MinusC2", 13) != 0)
          break;
        return 10;	 // "AMinusC1MinusC2"
      case 'P':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lusZeroMinusB", 13) != 0)
          break;
        return 1;	 // "APlusZeroMinusB"
      }
      break;
    case 'C':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "1Minus2MinusC2", 14) != 0)
        break;
      return 11;	 // "C1Minus2MinusC2"
    case 'Z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eroMinusAPlusB", 14) != 0)
        break;
      return 0;	 // "ZeroMinusAPlusB"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itreverse_lshr", 14) != 0)
        break;
      return 160;	 // "bitreverse_lshr"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtending_loads", 14) != 0)
        break;
      return 68;	 // "extending_loads"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "dempotent_prop", 14) != 0)
        break;
      return 18;	 // "idempotent_prop"
    case 'l':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oad_or_combine", 14) != 0)
        break;
      return 152;	 // "load_or_combine"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_or", 14) != 0)
        break;
      return 62;	 // "narrow_binop_or"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "verlapping_and", 14) != 0)
        break;
      return 142;	 // "overlapping_and"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cp_sqrt_to_rsq", 14) != 0)
        break;
      return 222;	 // "rcp_sqrt_to_rsq"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_same_val", 14) != 0)
        break;
      return 83;	 // "select_same_val"
    case 'z':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_trunc_fold", 14) != 0)
        break;
      return 129;	 // "zext_trunc_fold"
    }
    break;
  case 16:	 // 12 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nyext_of_anyext", 15) != 0)
        break;
      return 50;	 // "anyext_of_anyext"
    case 'n':	 // 5 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_", 12) != 0)
        break;
      switch (RuleIdentifier[13]) {
      default: break;
      case 'a':	 // 2 strings to match.
        switch (RuleIdentifier[14]) {
        default: break;
        case 'd':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 58;	 // "narrow_binop_add"
        case 'n':	 // 1 string to match.
          if (RuleIdentifier[15] != 'd')
            break;
          return 61;	 // "narrow_binop_and"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ul", 2) != 0)
          break;
        return 60;	 // "narrow_binop_mul"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "ub", 2) != 0)
          break;
        return 59;	 // "narrow_binop_sub"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+14, "or", 2) != 0)
          break;
        return 63;	 // "narrow_binop_xor"
      }
      break;
    case 's':	 // 3 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "elect_", 6) != 0)
        break;
      switch (RuleIdentifier[7]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "f_anyext", 8) != 0)
          break;
        return 55;	 // "select_of_anyext"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "o_minmax", 8) != 0)
          break;
        return 189;	 // "select_to_minmax"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+8, "ndef_cmp", 8) != 0)
          break;
        return 121;	 // "select_undef_cmp"
      }
      break;
    case 't':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_", 11) != 0)
        break;
      switch (RuleIdentifier[12]) {
      default: break;
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 44;	 // "truncate_of_sext"
      case 'z':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+13, "ext", 3) != 0)
          break;
        return 43;	 // "truncate_of_zext"
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ndef_to_fp_zero", 15) != 0)
        break;
      return 71;	 // "undef_to_fp_zero"
    }
    break;
  case 17:	 // 14 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "PlusBMinus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'A':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "plusC", 5) != 0)
          break;
        return 6;	 // "APlusBMinusAplusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "PlusA", 5) != 0)
          break;
        return 7;	 // "APlusBMinusCPlusA"
      }
      break;
    case 'a':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "d_p2i_to_ptradd", 15) != 0)
          break;
        return 16;	 // "add_p2i_to_ptradd"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "yext_trunc_fold", 15) != 0)
          break;
        return 90;	 // "anyext_trunc_fold"
      }
      break;
    case 'c':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'a':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nonicalize_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 110;	 // "canonicalize_fcmp"
        case 'i':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "cmp", 3) != 0)
            break;
          return 109;	 // "canonicalize_icmp"
        }
        break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nstant_fold_fma", 15) != 0)
          break;
        return 168;	 // "constant_fold_fma"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "iv_rem_to_divrem", 16) != 0)
        break;
      return 153;	 // "div_rem_to_divrem"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "rase_undef_store", 16) != 0)
        break;
      return 81;	 // "erase_undef_store"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_with_zero", 16) != 0)
        break;
      return 149;	 // "ptr_add_with_zero"
    case 's':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_to_iminmax", 15) != 0)
          break;
        return 123;	 // "select_to_iminmax"
      case 'h':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ift_immed_chain", 15) != 0)
          break;
        return 150;	 // "shift_immed_chain"
      }
      break;
    case 'u':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "def_to_int_zero", 15) != 0)
          break;
        return 72;	 // "undef_to_int_zero"
      case 'r':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "em_pow2_to_mask", 15) != 0)
          break;
        return 128;	 // "urem_pow2_to_mask"
      }
      break;
    }
    break;
  case 18:	 // 11 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'A':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "MinusBPlus", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'B':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusC", 6) != 0)
          break;
        return 5;	 // "AMinusBPlusBMinusC"
      case 'C':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "MinusA", 6) != 0)
          break;
        return 4;	 // "AMinusBPlusCMinusA"
      }
      break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_to_zero", 17) != 0)
        break;
      return 86;	 // "binop_left_to_zero"
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_minmax_nan", 15) != 0)
          break;
        return 146;	 // "combine_minmax_nan"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_f", 12) != 0)
          break;
        switch (RuleIdentifier[15]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "bs", 2) != 0)
            break;
          return 135;	 // "constant_fold_fabs"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+16, "eg", 2) != 0)
            break;
          return 134;	 // "constant_fold_fneg"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_const_fpowi", 17) != 0)
        break;
      return 147;	 // "expand_const_fpowi"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ptrunc_fpext_fold", 17) != 0)
        break;
      return 99;	 // "fptrunc_fpext_fold"
    case 's':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'l':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ect_of_truncate", 15) != 0)
          break;
        return 56;	 // "select_of_truncate"
      case 'x':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "t_inreg_of_load", 15) != 0)
          break;
        return 118;	 // "sext_inreg_of_load"
      }
      break;
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runcate_of_anyext", 17) != 0)
        break;
      return 45;	 // "truncate_of_anyext"
    }
    break;
  case 19:	 // 15 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_to_zero", 18) != 0)
        break;
      return 87;	 // "binop_right_to_zero"
    case 'c':	 // 4 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "onst", 4) != 0)
        break;
      switch (RuleIdentifier[5]) {
      default: break;
      case '_':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+6, "ptradd_to_i2p", 13) != 0)
          break;
        return 141;	 // "const_ptradd_to_i2p"
      case 'a':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+6, "nt_fold_", 8) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'b':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "inop", 4) != 0)
            break;
          return 166;	 // "constant_fold_binop"
        case 'f':	 // 2 strings to match.
          switch (RuleIdentifier[15]) {
          default: break;
          case 'l':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "og2", 3) != 0)
              break;
            return 137;	 // "constant_fold_flog2"
          case 's':	 // 1 string to match.
            if (memcmp(RuleIdentifier.data()+16, "qrt", 3) != 0)
              break;
            return 136;	 // "constant_fold_fsqrt"
          }
          break;
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtend_through_phis", 18) != 0)
        break;
      return 102;	 // "extend_through_phis"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nteger_of_truncate", 18) != 0)
        break;
      return 64;	 // "integer_of_truncate"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_zero", 18) != 0)
        break;
      return 212;	 // "merge_of_x_and_zero"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "tr_add_immed_chain", 18) != 0)
        break;
      return 108;	 // "ptr_add_immed_chain"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "assoc_comm_binops", 17) != 0)
          break;
        return 107;	 // "reassoc_comm_binops"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_zero", 17) != 0)
          break;
        return 84;	 // "right_identity_zero"
      }
      break;
    case 's':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "lect_constant_cmp", 17) != 0)
          break;
        return 122;	 // "select_constant_cmp"
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "mplify_", 7) != 0)
          break;
        switch (RuleIdentifier[9]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "dd_to_sub", 9) != 0)
            break;
          return 103;	 // "simplify_add_to_sub"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+10, "eg_minmax", 9) != 0)
            break;
          return 195;	 // "simplify_neg_minmax"
        }
        break;
      }
      break;
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nary_undef_to_zero", 18) != 0)
        break;
      return 76;	 // "unary_undef_to_zero"
    }
    break;
  case 20:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nd_or_disjoint_mask", 19) != 0)
        break;
      return 173;	 // "and_or_disjoint_mask"
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itcast_bitcast_fold", 19) != 0)
        break;
      return 98;	 // "bitcast_bitcast_fold"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "erge_of_x_and_undef", 19) != 0)
        break;
      return 211;	 // "merge_of_x_and_undef"
    case 'r':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'e')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 2 strings to match.
        if (RuleIdentifier[3] != 'u')
          break;
        switch (RuleIdentifier[4]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "e_shl_of_extend", 15) != 0)
            break;
          return 119;	 // "reduce_shl_of_extend"
        case 'n':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+5, "dant_sext_inreg", 15) != 0)
            break;
          return 126;	 // "redundant_sext_inreg"
        }
        break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ove_fcanonicalize", 17) != 0)
          break;
        return 220;	 // "remove_fcanonicalize"
      }
      break;
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ry_undef_to_undef", 17) != 0)
          break;
        return 77;	 // "unary_undef_to_undef"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_zext_to_zext", 17) != 0)
          break;
        return 210;	 // "unmerge_zext_to_zext"
      }
      break;
    }
    break;
  case 21:	 // 9 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 3 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_concat_vector", 18) != 0)
          break;
        return 196;	 // "combine_concat_vector"
      case 'n':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_", 11) != 0)
          break;
        switch (RuleIdentifier[14]) {
        default: break;
        case 'c':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ast_op", 6) != 0)
            break;
          return 169;	 // "constant_fold_cast_op"
        case 'f':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+15, "ptrunc", 6) != 0)
            break;
          return 138;	 // "constant_fold_fptrunc"
        }
        break;
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xpand_promoted_fmed3", 20) != 0)
        break;
      return 216;	 // "expand_promoted_fmed3"
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_elt_oob", 20) != 0)
        break;
      return 24;	 // "insert_vector_elt_oob"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_one_fp", 20) != 0)
        break;
      return 93;	 // "right_identity_one_fp"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ign_extension_in_reg", 20) != 0)
        break;
      return 224;	 // "sign_extension_in_reg"
    case 'u':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'n')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "ef_to_negative_one", 18) != 0)
          break;
        return 73;	 // "undef_to_negative_one"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "erge_dead_to_trunc", 18) != 0)
          break;
        return 209;	 // "unmerge_dead_to_trunc"
      }
      break;
    }
    break;
  case 22:	 // 13 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (RuleIdentifier[1] != 'o')
        break;
      switch (RuleIdentifier[2]) {
      default: break;
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "bine_shuffle_concat", 19) != 0)
          break;
        return 200;	 // "combine_shuffle_concat"
      case 'n':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+3, "stant_fold_fp_binop", 19) != 0)
          break;
        return 167;	 // "constant_fold_fp_binop"
      }
      break;
    case 'f':	 // 4 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ld_binop_into_select", 20) != 0)
          break;
        return 182;	 // "fold_binop_into_select"
      case 'u':	 // 3 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_", 11) != 0)
          break;
        switch (RuleIdentifier[13]) {
        default: break;
        case 'l':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "eft_zero", 8) != 0)
            break;
          return 157;	 // "funnel_shift_left_zero"
        case 'o':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "vershift", 8) != 0)
            break;
          return 158;	 // "funnel_shift_overshift"
        case 't':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+14, "o_rotate", 8) != 0)
            break;
          return 155;	 // "funnel_shift_to_rotate"
        }
        break;
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_lhs_known_bits", 21) != 0)
        break;
      return 112;	 // "icmp_to_lhs_known_bits"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_subo_no_overflow", 21) != 0)
        break;
      return 214;	 // "match_subo_no_overflow"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_any_op", 21) != 0)
        break;
      return 78;	 // "propagate_undef_any_op"
    case 'r':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "dundant_neg_operands", 20) != 0)
          break;
        return 172;	 // "redundant_neg_operands"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ght_identity_one_int", 20) != 0)
          break;
        return 92;	 // "right_identity_one_int"
      }
      break;
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hl_ashr_to_sext_inreg", 21) != 0)
        break;
      return 116;	 // "shl_ashr_to_sext_inreg"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_buildvector_fold", 21) != 0)
        break;
      return 96;	 // "trunc_buildvector_fold"
    }
    break;
  case 23:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "uildvector_of_truncate", 22) != 0)
        break;
      return 57;	 // "buildvector_of_truncate"
    case 'f':	 // 2 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'd':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "iv_by_sqrt_to_rsq_f16", 21) != 0)
          break;
        return 223;	 // "fdiv_by_sqrt_to_rsq_f16"
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "nnel_shift_right_zero", 21) != 0)
          break;
        return 156;	 // "funnel_shift_right_zero"
      }
      break;
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "tof_const_zero_fold_", 20) != 0)
        break;
      switch (RuleIdentifier[21]) {
      default: break;
      case 's':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 139;	 // "itof_const_zero_fold_si"
      case 'u':	 // 1 string to match.
        if (RuleIdentifier[22] != 'i')
          break;
        return 140;	 // "itof_const_zero_fold_ui"
      }
      break;
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_all_ops", 22) != 0)
        break;
      return 79;	 // "propagate_undef_all_ops"
    }
    break;
  case 24:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_left_undef_to_zero", 23) != 0)
        break;
      return 74;	 // "binop_left_undef_to_zero"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element", 23) != 0)
        break;
      return 23;	 // "match_extract_of_element"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "arrow_binop_feeding_and", 23) != 0)
        break;
      return 120;	 // "narrow_binop_feeding_and"
    case 's':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ext_inreg_", 10) != 0)
        break;
      switch (RuleIdentifier[11]) {
      default: break;
      case 'o':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "f_sext_inreg", 12) != 0)
          break;
        return 53;	 // "sext_inreg_of_sext_inreg"
      case 't':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+12, "o_zext_inreg", 12) != 0)
          break;
        return 130;	 // "sext_inreg_to_zext_inreg"
      }
      break;
    case 'x':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "or_of_and_with_same_reg", 23) != 0)
        break;
      return 148;	 // "xor_of_and_with_same_reg"
    }
    break;
  case 25:	 // 7 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 3 strings to match.
      switch (RuleIdentifier[1]) {
      default: break;
      case 'i':	 // 2 strings to match.
        if (memcmp(RuleIdentifier.data()+2, "tfield_extract_from_", 20) != 0)
          break;
        switch (RuleIdentifier[22]) {
        default: break;
        case 'a':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "nd", 2) != 0)
            break;
          return 163;	 // "bitfield_extract_from_and"
        case 's':	 // 1 string to match.
          if (memcmp(RuleIdentifier.data()+23, "hr", 2) != 0)
            break;
          return 164;	 // "bitfield_extract_from_shr"
        }
        break;
      case 'u':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+2, "ildvector_identity_fold", 23) != 0)
          break;
        return 95;	 // "buildvector_identity_fold"
      }
      break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_shuffle_undef_rhs", 24) != 0)
        break;
      return 201;	 // "combine_shuffle_undef_rhs"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vec_elt_build_vec", 24) != 0)
        break;
      return 66;	 // "extract_vec_elt_build_vec"
    case 'n':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "eg_and_one_to_sext_inreg", 24) != 0)
        break;
      return 117;	 // "neg_and_one_to_sext_inreg"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_one_fp", 24) != 0)
        break;
      return 101;	 // "right_identity_neg_one_fp"
    }
    break;
  case 26:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "inop_right_undef_to_undef", 25) != 0)
        break;
      return 75;	 // "binop_right_undef_to_undef"
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ommute_fp_constant_to_rhs", 25) != 0)
        break;
      return 192;	 // "commute_fp_constant_to_rhs"
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "unnel_shift_from_or_shift", 25) != 0)
        break;
      return 154;	 // "funnel_shift_from_or_shift"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ight_identity_neg_zero_fp", 25) != 0)
        break;
      return 100;	 // "right_identity_neg_zero_fp"
    }
    break;
  case 27:	 // 6 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "om", 2) != 0)
        break;
      switch (RuleIdentifier[3]) {
      default: break;
      case 'b':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ine_use_vector_truncate", 23) != 0)
          break;
        return 203;	 // "combine_use_vector_truncate"
      case 'm':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+4, "ute_int_constant_to_rhs", 23) != 0)
          break;
        return 191;	 // "commute_int_constant_to_rhs"
      }
      break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_or_combine", 26) != 0)
        break;
      return 114;	 // "double_icmp_zero_or_combine"
    case 'r':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "edundant_binop_in_equality", 26) != 0)
        break;
      return 115;	 // "redundant_binop_in_equality"
    case 't':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "runc_lshr_buildvector_fold", 26) != 0)
        break;
      return 97;	 // "trunc_lshr_buildvector_fold"
    case 'u':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nmerge_anyext_build_vector", 26) != 0)
        break;
      return 204;	 // "unmerge_anyext_build_vector"
    }
    break;
  case 28:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'd':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ouble_icmp_zero_and_combine", 27) != 0)
        break;
      return 113;	 // "double_icmp_zero_and_combine"
    case 'o':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "pt_brcond_by_inverting_cond", 27) != 0)
        break;
      return 133;	 // "opt_brcond_by_inverting_cond"
    case 'p':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ropagate_undef_shuffle_mask", 27) != 0)
        break;
      return 80;	 // "propagate_undef_shuffle_mask"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "hift_of_shifted_logic_chain", 27) != 0)
        break;
      return 151;	 // "shift_of_shifted_logic_chain"
    }
    break;
  case 29:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_shr_and", 28) != 0)
        break;
      return 165;	 // "bitfield_extract_from_shr_and"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "xtracted_vector_load", 20) != 0)
          break;
        return 70;	 // "combine_extracted_vector_load"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "huffle_disjoint_mask", 20) != 0)
          break;
        return 202;	 // "combine_shuffle_disjoint_mask"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_to_true_false_known_bits", 28) != 0)
        break;
      return 111;	 // "icmp_to_true_false_known_bits"
    }
    break;
  case 30:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "freeze_of_non_undef_non_poison", 30) != 0)
      break;
    return 41;	 // "freeze_of_non_undef_non_poison"
  case 31:	 // 3 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'f':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "cmp_select_to_fmin_fmax_legacy", 30) != 0)
        break;
      return 215;	 // "fcmp_select_to_fmin_fmax_legacy"
    case 'i':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_vector_element_", 21) != 0)
        break;
      switch (RuleIdentifier[22]) {
      default: break;
      case 'e':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "lt_undef", 8) != 0)
          break;
        return 22;	 // "insert_vector_element_elt_undef"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+23, "dx_undef", 8) != 0)
          break;
        return 21;	 // "insert_vector_element_idx_undef"
      }
      break;
    }
    break;
  case 32:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'b':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "itfield_extract_from_sext_inreg", 31) != 0)
        break;
      return 162;	 // "bitfield_extract_from_sext_inreg"
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_f", 8) != 0)
        break;
      switch (RuleIdentifier[9]) {
      default: break;
      case 'a':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "dd_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 174;	 // "combine_fadd_fmul_to_fmad_or_fma"
      case 's':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+10, "ub_fmul_to_fmad_or_fma", 22) != 0)
          break;
        return 178;	 // "combine_fsub_fmul_to_fmad_or_fma"
      }
      break;
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_not_const", 31) != 0)
        break;
      return 25;	 // "extract_vector_element_not_const"
    }
    break;
  case 34:	 // 2 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fmul_with_select_to_fldexp", 33) != 0)
        break;
      return 217;	 // "combine_fmul_with_select_to_fldexp"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_all_elts_from_build_vector", 33) != 0)
        break;
      return 67;	 // "extract_all_elts_from_build_vector"
    }
    break;
  case 35:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_build_vector", 35) != 0)
      break;
    return 27;	 // "extract_vector_element_build_vector"
  case 36:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 2 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_", 7) != 0)
        break;
      switch (RuleIdentifier[8]) {
      default: break;
      case 'f':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "add_fma_fmul_to_fmad_or_fma", 27) != 0)
          break;
        return 176;	 // "combine_fadd_fma_fmul_to_fmad_or_fma"
      case 'i':	 // 1 string to match.
        if (memcmp(RuleIdentifier.data()+9, "nsert_vec_elts_build_vector", 27) != 0)
          break;
        return 65;	 // "combine_insert_vec_elts_build_vector"
      }
      break;
    case 'i':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "nsert_extract_vec_elt_out_of_bounds", 35) != 0)
        break;
      return 82;	 // "insert_extract_vec_elt_out_of_bounds"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_index", 35) != 0)
        break;
      return 20;	 // "match_extract_of_element_undef_index"
    }
    break;
  case 37:	 // 4 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fsub_fneg_fmul_to_fmad_or_fma", 36) != 0)
        break;
      return 179;	 // "combine_fsub_fneg_fmul_to_fmad_or_fma"
    case 'e':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_shuffle_vector", 36) != 0)
        break;
      return 35;	 // "extract_vector_element_shuffle_vector"
    case 'h':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "oist_logic_op_with_same_opcode_hands", 36) != 0)
        break;
      return 104;	 // "hoist_logic_op_with_same_opcode_hands"
    case 'm':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "atch_extract_of_element_undef_vector", 36) != 0)
        break;
      return 19;	 // "match_extract_of_element_undef_vector"
    }
    break;
  case 38:	 // 2 strings to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_f", 9) != 0)
      break;
    switch (RuleIdentifier[9]) {
    default: break;
    case 'a':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "dd_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 175;	 // "combine_fadd_fpext_fmul_to_fmad_or_fma"
    case 's':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+10, "ub_fpext_fmul_to_fmad_or_fma", 28) != 0)
        break;
      return 180;	 // "combine_fsub_fpext_fmul_to_fmad_or_fma"
    }
    break;
  case 40:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "extract_vector_element_different_indices", 40) != 0)
      break;
    return 26;	 // "extract_vector_element_different_indices"
  case 42:	 // 8 strings to match.
    switch (RuleIdentifier[0]) {
    default: break;
    case 'c':	 // 1 string to match.
      if (memcmp(RuleIdentifier.data()+1, "ombine_fadd_fpext_fma_fmul_to_fmad_or_fma", 41) != 0)
        break;
      return 177;	 // "combine_fadd_fpext_fma_fmul_to_fmad_or_fma"
    case 'e':	 // 7 strings to match.
      if (memcmp(RuleIdentifier.data()+1, "xtract_vector_element_build_vector_trunc", 40) != 0)
        break;
      switch (RuleIdentifier[41]) {
      default: break;
      case '2':	 // 1 string to match.
        return 28;	 // "extract_vector_element_build_vector_trunc2"
      case '3':	 // 1 string to match.
        return 29;	 // "extract_vector_element_build_vector_trunc3"
      case '4':	 // 1 string to match.
        return 30;	 // "extract_vector_element_build_vector_trunc4"
      case '5':	 // 1 string to match.
        return 31;	 // "extract_vector_element_build_vector_trunc5"
      case '6':	 // 1 string to match.
        return 32;	 // "extract_vector_element_build_vector_trunc6"
      case '7':	 // 1 string to match.
        return 33;	 // "extract_vector_element_build_vector_trunc7"
      case '8':	 // 1 string to match.
        return 34;	 // "extract_vector_element_build_vector_trunc8"
      }
      break;
    }
    break;
  case 43:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma", 43) != 0)
      break;
    return 181;	 // "combine_fsub_fpext_fneg_fmul_to_fmad_or_fma"
  case 44:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "insert_vector_element_extract_vector_element", 44) != 0)
      break;
    return 36;	 // "insert_vector_element_extract_vector_element"
  case 46:	 // 1 string to match.
    if (memcmp(RuleIdentifier.data()+0, "push_freeze_to_prevent_poison_from_propagating", 46) != 0)
      break;
    return 42;	 // "push_freeze_to_prevent_poison_from_propagating"
  }
#endif // ifndef NDEBUG

  return std::nullopt;
}
static std::optional<std::pair<uint64_t, uint64_t>> getRuleRangeForIdentifier(StringRef RuleIdentifier) {
  std::pair<StringRef, StringRef> RangePair = RuleIdentifier.split('-');
  if (!RangePair.second.empty()) {
    const auto First = getRuleIdxForIdentifier(RangePair.first);
    const auto Last = getRuleIdxForIdentifier(RangePair.second);
    if (!First || !Last)
      return std::nullopt;
    if (First >= Last)
      report_fatal_error("Beginning of range should be before end of range");
    return {{*First, *Last + 1}};
  }
  if (RangePair.first == "*") {
    return {{0, 226}};
  }
  const auto I = getRuleIdxForIdentifier(RangePair.first);
  if (!I)
    return std::nullopt;
  return {{*I, *I + 1}};
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleEnabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.reset(I);
  return true;
}

bool AMDGPUPostLegalizerCombinerImplRuleConfig::setRuleDisabled(StringRef RuleIdentifier) {
  auto MaybeRange = getRuleRangeForIdentifier(RuleIdentifier);
  if (!MaybeRange)
    return false;
  for (auto I = MaybeRange->first; I < MaybeRange->second; ++I)
    DisabledRules.set(I);
  return true;
}

static std::vector<std::string> AMDGPUPostLegalizerCombinerOption;
static cl::list<std::string> AMDGPUPostLegalizerCombinerDisableOption(
    "amdgpupostlegalizercombiner-disable-rule",
    cl::desc("Disable one or more combiner rules temporarily in the AMDGPUPostLegalizerCombiner pass"),
    cl::CommaSeparated,
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &Str) {
      AMDGPUPostLegalizerCombinerOption.push_back(Str);
    }));
static cl::list<std::string> AMDGPUPostLegalizerCombinerOnlyEnableOption(
    "amdgpupostlegalizercombiner-only-enable-rule",
    cl::desc("Disable all rules in the AMDGPUPostLegalizerCombiner pass then re-enable the specified ones"),
    cl::Hidden,
    cl::cat(GICombinerOptionCategory),
    cl::callback([](const std::string &CommaSeparatedArg) {
      StringRef Str = CommaSeparatedArg;
      AMDGPUPostLegalizerCombinerOption.push_back("*");
      do {
        auto X = Str.split(",");
        AMDGPUPostLegalizerCombinerOption.push_back(("!" + X.first).str());
        Str = X.second;
      } while (!Str.empty());
    }));


bool AMDGPUPostLegalizerCombinerImplRuleConfig::isRuleEnabled(unsigned RuleID) const {
    return  !DisabledRules.test(RuleID);
}
bool AMDGPUPostLegalizerCombinerImplRuleConfig::parseCommandLineOption() {
  for (StringRef Identifier : AMDGPUPostLegalizerCombinerOption) {
    bool Enabled = Identifier.consume_front("!");
    if (Enabled && !setRuleEnabled(Identifier))
      return false;
    if (!Enabled && !setRuleDisabled(Identifier))
      return false;
  }
  return true;
}

#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_TYPES
const unsigned MAX_SUBTARGET_PREDICATES = 3;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GICOMBINER_TYPES

#ifdef GET_GICOMBINER_CLASS_MEMBERS
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS
#ifdef GET_GICOMBINER_CLASS_MEMBERS
  mutable MatcherState State;
  typedef ComplexRendererFns(AMDGPUPostLegalizerCombinerImpl::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AMDGPUPostLegalizerCombinerImpl::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn ComplexPredicateFns[];
  static AMDGPUPostLegalizerCombinerImpl::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GICOMBINER_CLASS_MEMBERS

#ifdef GET_GICOMBINER_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_Has16BitInstsBit = 1,
  Feature_NotHasMed3_16Bit = 2,
  Feature_HasFminFmaxLegacyBit = 0,
};

PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableModuleFeatures(const AMDGPUSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->has16BitInsts())
    Features.set(Feature_Has16BitInstsBit);
  if (!Subtarget->hasMed3_16())
    Features.set(Feature_NotHasMed3_16Bit);
  if (Subtarget->hasFminFmaxLegacy())
    Features.set(Feature_HasFminFmaxLegacyBit);
  return Features;
}

void AMDGPUPostLegalizerCombinerImpl::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AMDGPUSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AMDGPUPostLegalizerCombinerImpl::
computeAvailableFunctionFeatures(const AMDGPUSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasFminFmaxLegacy,
  GIFBS_Has16BitInsts_NotHasMed3_16,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasFminFmaxLegacyBit, },
  {Feature_Has16BitInstsBit, Feature_NotHasMed3_16Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

AMDGPUPostLegalizerCombinerImpl::ComplexMatcherMemFn
AMDGPUPostLegalizerCombinerImpl::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

enum {
  GICXXPred_MI_Predicate_GICombiner0 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_GICombiner1,
  GICXXPred_MI_Predicate_GICombiner2,
  GICXXPred_MI_Predicate_GICombiner3,
  GICXXPred_MI_Predicate_GICombiner4,
  GICXXPred_MI_Predicate_GICombiner5,
  GICXXPred_MI_Predicate_GICombiner6,
  GICXXPred_MI_Predicate_GICombiner7,
  GICXXPred_MI_Predicate_GICombiner8,
  GICXXPred_MI_Predicate_GICombiner9,
};
bool AMDGPUPostLegalizerCombinerImpl::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_GICombiner0: {
    return isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner1: {
    return isGuaranteedNotToBeUndefOrPoison(State.MIs[0]->getOperand(1).getReg(), MRI);
  }
  case GICXXPred_MI_Predicate_GICombiner2: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), 1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner3: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -0.0);
  }
  case GICXXPred_MI_Predicate_GICombiner4: {
    return Helper.matchConstantFPOp(State.MIs[0]->getOperand(2), -1.0);
  }
  case GICXXPred_MI_Predicate_GICombiner5: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_EQ &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner6: {
    return State.MIs[1]->getOperand(1).getPredicate() == CmpInst::ICMP_NE &&
                               !MRI.getType(State.MIs[1]->getOperand(2).getReg()).getScalarType().isPointer() &&
                               (MRI.getType(State.MIs[1]->getOperand(2).getReg()) ==
                                   MRI.getType(State.MIs[2]->getOperand(2).getReg()));
  }
  case GICXXPred_MI_Predicate_GICombiner7: {
    return MRI.hasOneNonDBGUse(State.MIs[0]->getOperand(2).getReg()) &&
                    Helper.isLegalOrBeforeLegalizer(
                      {TargetOpcode::G_SEXT_INREG, {MRI.getType(State.MIs[1]->getOperand(1).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner8: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_LSHR,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  case GICXXPred_MI_Predicate_GICombiner9: {
    return Helper.isLegalOrBeforeLegalizer({TargetOpcode::G_SHL,
                                                           {MRI.getType(State.MIs[2]->getOperand(1).getReg()),
                                                            MRI.getType(State.MIs[1]->getOperand(2).getReg())}});
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AMDGPUPostLegalizerCombinerImpl::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
enum {
  GICXXPred_Simple_IsRule0Enabled = GICXXPred_Invalid + 1,
  GICXXPred_Simple_IsRule1Enabled,
  GICXXPred_Simple_IsRule2Enabled,
  GICXXPred_Simple_IsRule3Enabled,
  GICXXPred_Simple_IsRule4Enabled,
  GICXXPred_Simple_IsRule5Enabled,
  GICXXPred_Simple_IsRule6Enabled,
  GICXXPred_Simple_IsRule7Enabled,
  GICXXPred_Simple_IsRule8Enabled,
  GICXXPred_Simple_IsRule9Enabled,
  GICXXPred_Simple_IsRule10Enabled,
  GICXXPred_Simple_IsRule11Enabled,
  GICXXPred_Simple_IsRule12Enabled,
  GICXXPred_Simple_IsRule13Enabled,
  GICXXPred_Simple_IsRule14Enabled,
  GICXXPred_Simple_IsRule15Enabled,
  GICXXPred_Simple_IsRule16Enabled,
  GICXXPred_Simple_IsRule17Enabled,
  GICXXPred_Simple_IsRule18Enabled,
  GICXXPred_Simple_IsRule19Enabled,
  GICXXPred_Simple_IsRule20Enabled,
  GICXXPred_Simple_IsRule21Enabled,
  GICXXPred_Simple_IsRule22Enabled,
  GICXXPred_Simple_IsRule23Enabled,
  GICXXPred_Simple_IsRule24Enabled,
  GICXXPred_Simple_IsRule25Enabled,
  GICXXPred_Simple_IsRule26Enabled,
  GICXXPred_Simple_IsRule27Enabled,
  GICXXPred_Simple_IsRule28Enabled,
  GICXXPred_Simple_IsRule29Enabled,
  GICXXPred_Simple_IsRule30Enabled,
  GICXXPred_Simple_IsRule31Enabled,
  GICXXPred_Simple_IsRule32Enabled,
  GICXXPred_Simple_IsRule33Enabled,
  GICXXPred_Simple_IsRule34Enabled,
  GICXXPred_Simple_IsRule35Enabled,
  GICXXPred_Simple_IsRule36Enabled,
  GICXXPred_Simple_IsRule37Enabled,
  GICXXPred_Simple_IsRule38Enabled,
  GICXXPred_Simple_IsRule39Enabled,
  GICXXPred_Simple_IsRule40Enabled,
  GICXXPred_Simple_IsRule41Enabled,
  GICXXPred_Simple_IsRule42Enabled,
  GICXXPred_Simple_IsRule43Enabled,
  GICXXPred_Simple_IsRule44Enabled,
  GICXXPred_Simple_IsRule45Enabled,
  GICXXPred_Simple_IsRule46Enabled,
  GICXXPred_Simple_IsRule47Enabled,
  GICXXPred_Simple_IsRule48Enabled,
  GICXXPred_Simple_IsRule49Enabled,
  GICXXPred_Simple_IsRule50Enabled,
  GICXXPred_Simple_IsRule51Enabled,
  GICXXPred_Simple_IsRule52Enabled,
  GICXXPred_Simple_IsRule53Enabled,
  GICXXPred_Simple_IsRule54Enabled,
  GICXXPred_Simple_IsRule55Enabled,
  GICXXPred_Simple_IsRule56Enabled,
  GICXXPred_Simple_IsRule57Enabled,
  GICXXPred_Simple_IsRule58Enabled,
  GICXXPred_Simple_IsRule59Enabled,
  GICXXPred_Simple_IsRule60Enabled,
  GICXXPred_Simple_IsRule61Enabled,
  GICXXPred_Simple_IsRule62Enabled,
  GICXXPred_Simple_IsRule63Enabled,
  GICXXPred_Simple_IsRule64Enabled,
  GICXXPred_Simple_IsRule65Enabled,
  GICXXPred_Simple_IsRule66Enabled,
  GICXXPred_Simple_IsRule67Enabled,
  GICXXPred_Simple_IsRule68Enabled,
  GICXXPred_Simple_IsRule69Enabled,
  GICXXPred_Simple_IsRule70Enabled,
  GICXXPred_Simple_IsRule71Enabled,
  GICXXPred_Simple_IsRule72Enabled,
  GICXXPred_Simple_IsRule73Enabled,
  GICXXPred_Simple_IsRule74Enabled,
  GICXXPred_Simple_IsRule75Enabled,
  GICXXPred_Simple_IsRule76Enabled,
  GICXXPred_Simple_IsRule77Enabled,
  GICXXPred_Simple_IsRule78Enabled,
  GICXXPred_Simple_IsRule79Enabled,
  GICXXPred_Simple_IsRule80Enabled,
  GICXXPred_Simple_IsRule81Enabled,
  GICXXPred_Simple_IsRule82Enabled,
  GICXXPred_Simple_IsRule83Enabled,
  GICXXPred_Simple_IsRule84Enabled,
  GICXXPred_Simple_IsRule85Enabled,
  GICXXPred_Simple_IsRule86Enabled,
  GICXXPred_Simple_IsRule87Enabled,
  GICXXPred_Simple_IsRule88Enabled,
  GICXXPred_Simple_IsRule89Enabled,
  GICXXPred_Simple_IsRule90Enabled,
  GICXXPred_Simple_IsRule91Enabled,
  GICXXPred_Simple_IsRule92Enabled,
  GICXXPred_Simple_IsRule93Enabled,
  GICXXPred_Simple_IsRule94Enabled,
  GICXXPred_Simple_IsRule95Enabled,
  GICXXPred_Simple_IsRule96Enabled,
  GICXXPred_Simple_IsRule97Enabled,
  GICXXPred_Simple_IsRule98Enabled,
  GICXXPred_Simple_IsRule99Enabled,
  GICXXPred_Simple_IsRule100Enabled,
  GICXXPred_Simple_IsRule101Enabled,
  GICXXPred_Simple_IsRule102Enabled,
  GICXXPred_Simple_IsRule103Enabled,
  GICXXPred_Simple_IsRule104Enabled,
  GICXXPred_Simple_IsRule105Enabled,
  GICXXPred_Simple_IsRule106Enabled,
  GICXXPred_Simple_IsRule107Enabled,
  GICXXPred_Simple_IsRule108Enabled,
  GICXXPred_Simple_IsRule109Enabled,
  GICXXPred_Simple_IsRule110Enabled,
  GICXXPred_Simple_IsRule111Enabled,
  GICXXPred_Simple_IsRule112Enabled,
  GICXXPred_Simple_IsRule113Enabled,
  GICXXPred_Simple_IsRule114Enabled,
  GICXXPred_Simple_IsRule115Enabled,
  GICXXPred_Simple_IsRule116Enabled,
  GICXXPred_Simple_IsRule117Enabled,
  GICXXPred_Simple_IsRule118Enabled,
  GICXXPred_Simple_IsRule119Enabled,
  GICXXPred_Simple_IsRule120Enabled,
  GICXXPred_Simple_IsRule121Enabled,
  GICXXPred_Simple_IsRule122Enabled,
  GICXXPred_Simple_IsRule123Enabled,
  GICXXPred_Simple_IsRule124Enabled,
  GICXXPred_Simple_IsRule125Enabled,
  GICXXPred_Simple_IsRule126Enabled,
  GICXXPred_Simple_IsRule127Enabled,
  GICXXPred_Simple_IsRule128Enabled,
  GICXXPred_Simple_IsRule129Enabled,
  GICXXPred_Simple_IsRule130Enabled,
  GICXXPred_Simple_IsRule131Enabled,
  GICXXPred_Simple_IsRule132Enabled,
  GICXXPred_Simple_IsRule133Enabled,
  GICXXPred_Simple_IsRule134Enabled,
  GICXXPred_Simple_IsRule135Enabled,
  GICXXPred_Simple_IsRule136Enabled,
  GICXXPred_Simple_IsRule137Enabled,
  GICXXPred_Simple_IsRule138Enabled,
  GICXXPred_Simple_IsRule139Enabled,
  GICXXPred_Simple_IsRule140Enabled,
  GICXXPred_Simple_IsRule141Enabled,
  GICXXPred_Simple_IsRule142Enabled,
  GICXXPred_Simple_IsRule143Enabled,
  GICXXPred_Simple_IsRule144Enabled,
  GICXXPred_Simple_IsRule145Enabled,
  GICXXPred_Simple_IsRule146Enabled,
  GICXXPred_Simple_IsRule147Enabled,
  GICXXPred_Simple_IsRule148Enabled,
  GICXXPred_Simple_IsRule149Enabled,
  GICXXPred_Simple_IsRule150Enabled,
  GICXXPred_Simple_IsRule151Enabled,
  GICXXPred_Simple_IsRule152Enabled,
  GICXXPred_Simple_IsRule153Enabled,
  GICXXPred_Simple_IsRule154Enabled,
  GICXXPred_Simple_IsRule155Enabled,
  GICXXPred_Simple_IsRule156Enabled,
  GICXXPred_Simple_IsRule157Enabled,
  GICXXPred_Simple_IsRule158Enabled,
  GICXXPred_Simple_IsRule159Enabled,
  GICXXPred_Simple_IsRule160Enabled,
  GICXXPred_Simple_IsRule161Enabled,
  GICXXPred_Simple_IsRule162Enabled,
  GICXXPred_Simple_IsRule163Enabled,
  GICXXPred_Simple_IsRule164Enabled,
  GICXXPred_Simple_IsRule165Enabled,
  GICXXPred_Simple_IsRule166Enabled,
  GICXXPred_Simple_IsRule167Enabled,
  GICXXPred_Simple_IsRule168Enabled,
  GICXXPred_Simple_IsRule169Enabled,
  GICXXPred_Simple_IsRule170Enabled,
  GICXXPred_Simple_IsRule171Enabled,
  GICXXPred_Simple_IsRule172Enabled,
  GICXXPred_Simple_IsRule173Enabled,
  GICXXPred_Simple_IsRule174Enabled,
  GICXXPred_Simple_IsRule175Enabled,
  GICXXPred_Simple_IsRule176Enabled,
  GICXXPred_Simple_IsRule177Enabled,
  GICXXPred_Simple_IsRule178Enabled,
  GICXXPred_Simple_IsRule179Enabled,
  GICXXPred_Simple_IsRule180Enabled,
  GICXXPred_Simple_IsRule181Enabled,
  GICXXPred_Simple_IsRule182Enabled,
  GICXXPred_Simple_IsRule183Enabled,
  GICXXPred_Simple_IsRule184Enabled,
  GICXXPred_Simple_IsRule185Enabled,
  GICXXPred_Simple_IsRule186Enabled,
  GICXXPred_Simple_IsRule187Enabled,
  GICXXPred_Simple_IsRule188Enabled,
  GICXXPred_Simple_IsRule189Enabled,
  GICXXPred_Simple_IsRule190Enabled,
  GICXXPred_Simple_IsRule191Enabled,
  GICXXPred_Simple_IsRule192Enabled,
  GICXXPred_Simple_IsRule193Enabled,
  GICXXPred_Simple_IsRule194Enabled,
  GICXXPred_Simple_IsRule195Enabled,
  GICXXPred_Simple_IsRule196Enabled,
  GICXXPred_Simple_IsRule197Enabled,
  GICXXPred_Simple_IsRule198Enabled,
  GICXXPred_Simple_IsRule199Enabled,
  GICXXPred_Simple_IsRule200Enabled,
  GICXXPred_Simple_IsRule201Enabled,
  GICXXPred_Simple_IsRule202Enabled,
  GICXXPred_Simple_IsRule203Enabled,
  GICXXPred_Simple_IsRule204Enabled,
  GICXXPred_Simple_IsRule205Enabled,
  GICXXPred_Simple_IsRule206Enabled,
  GICXXPred_Simple_IsRule207Enabled,
  GICXXPred_Simple_IsRule208Enabled,
  GICXXPred_Simple_IsRule209Enabled,
  GICXXPred_Simple_IsRule210Enabled,
  GICXXPred_Simple_IsRule211Enabled,
  GICXXPred_Simple_IsRule212Enabled,
  GICXXPred_Simple_IsRule213Enabled,
  GICXXPred_Simple_IsRule214Enabled,
  GICXXPred_Simple_IsRule215Enabled,
  GICXXPred_Simple_IsRule216Enabled,
  GICXXPred_Simple_IsRule217Enabled,
  GICXXPred_Simple_IsRule218Enabled,
  GICXXPred_Simple_IsRule219Enabled,
  GICXXPred_Simple_IsRule220Enabled,
  GICXXPred_Simple_IsRule221Enabled,
  GICXXPred_Simple_IsRule222Enabled,
  GICXXPred_Simple_IsRule223Enabled,
  GICXXPred_Simple_IsRule224Enabled,
  GICXXPred_Simple_IsRule225Enabled,
};

bool AMDGPUPostLegalizerCombinerImpl::testSimplePredicate(unsigned Predicate) const {
    return RuleConfig.isRuleEnabled(Predicate - GICXXPred_Invalid - 1);
}
// Custom renderers.
enum {
  GICR_Invalid,
};
AMDGPUPostLegalizerCombinerImpl::CustomRendererFn
AMDGPUPostLegalizerCombinerImpl::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool AMDGPUPostLegalizerCombinerImpl::tryCombineAllImpl(MachineInstr &I) const {
  const TargetSubtargetInfo &ST = MF.getSubtarget();
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  B.setInstrAndDebugLoc(I);
  State.MIs.clear();
  State.MIs.push_back(&I);
  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), *ST.getInstrInfo(), MRI, *MRI.getTargetRegisterInfo(), *ST.getRegBankInfo(), AvailableFeatures, /*CoverageInfo*/ nullptr)) {
    return true;
  }

  return false;
}

enum {
  GICXXCustomAction_GICombiner0 = GICXXCustomAction_Invalid + 1,
  GICXXCustomAction_GICombiner1,
  GICXXCustomAction_GICombiner2,
  GICXXCustomAction_GICombiner3,
  GICXXCustomAction_GICombiner4,
  GICXXCustomAction_GICombiner5,
  GICXXCustomAction_GICombiner6,
  GICXXCustomAction_GICombiner7,
  GICXXCustomAction_GICombiner8,
  GICXXCustomAction_GICombiner9,
  GICXXCustomAction_GICombiner10,
  GICXXCustomAction_GICombiner11,
  GICXXCustomAction_GICombiner12,
  GICXXCustomAction_GICombiner13,
  GICXXCustomAction_GICombiner14,
  GICXXCustomAction_GICombiner15,
  GICXXCustomAction_GICombiner16,
  GICXXCustomAction_GICombiner17,
  GICXXCustomAction_GICombiner18,
  GICXXCustomAction_GICombiner19,
  GICXXCustomAction_GICombiner20,
  GICXXCustomAction_GICombiner21,
  GICXXCustomAction_GICombiner22,
  GICXXCustomAction_GICombiner23,
  GICXXCustomAction_GICombiner24,
  GICXXCustomAction_GICombiner25,
  GICXXCustomAction_GICombiner26,
  GICXXCustomAction_GICombiner27,
  GICXXCustomAction_GICombiner28,
  GICXXCustomAction_GICombiner29,
  GICXXCustomAction_GICombiner30,
  GICXXCustomAction_GICombiner31,
  GICXXCustomAction_GICombiner32,
  GICXXCustomAction_GICombiner33,
  GICXXCustomAction_GICombiner34,
  GICXXCustomAction_GICombiner35,
  GICXXCustomAction_GICombiner36,
  GICXXCustomAction_GICombiner37,
  GICXXCustomAction_GICombiner38,
  GICXXCustomAction_GICombiner39,
  GICXXCustomAction_GICombiner40,
  GICXXCustomAction_GICombiner41,
  GICXXCustomAction_GICombiner42,
  GICXXCustomAction_GICombiner43,
  GICXXCustomAction_GICombiner44,
  GICXXCustomAction_GICombiner45,
  GICXXCustomAction_GICombiner46,
  GICXXCustomAction_GICombiner47,
  GICXXCustomAction_GICombiner48,
  GICXXCustomAction_GICombiner49,
  GICXXCustomAction_GICombiner50,
  GICXXCustomAction_GICombiner51,
  GICXXCustomAction_GICombiner52,
  GICXXCustomAction_GICombiner53,
  GICXXCustomAction_GICombiner54,
  GICXXCustomAction_GICombiner55,
  GICXXCustomAction_GICombiner56,
  GICXXCustomAction_GICombiner57,
  GICXXCustomAction_GICombiner58,
  GICXXCustomAction_GICombiner59,
  GICXXCustomAction_GICombiner60,
  GICXXCustomAction_GICombiner61,
  GICXXCustomAction_GICombiner62,
  GICXXCustomAction_GICombiner63,
  GICXXCustomAction_GICombiner64,
  GICXXCustomAction_GICombiner65,
  GICXXCustomAction_GICombiner66,
  GICXXCustomAction_GICombiner67,
  GICXXCustomAction_GICombiner68,
  GICXXCustomAction_GICombiner69,
  GICXXCustomAction_GICombiner70,
  GICXXCustomAction_GICombiner71,
  GICXXCustomAction_GICombiner72,
  GICXXCustomAction_GICombiner73,
  GICXXCustomAction_GICombiner74,
  GICXXCustomAction_GICombiner75,
  GICXXCustomAction_GICombiner76,
  GICXXCustomAction_GICombiner77,
  GICXXCustomAction_GICombiner78,
  GICXXCustomAction_GICombiner79,
  GICXXCustomAction_GICombiner80,
  GICXXCustomAction_GICombiner81,
  GICXXCustomAction_GICombiner82,
  GICXXCustomAction_GICombiner83,
  GICXXCustomAction_GICombiner84,
  GICXXCustomAction_GICombiner85,
  GICXXCustomAction_GICombiner86,
  GICXXCustomAction_GICombiner87,
  GICXXCustomAction_GICombiner88,
  GICXXCustomAction_GICombiner89,
  GICXXCustomAction_GICombiner90,
  GICXXCustomAction_GICombiner91,
  GICXXCustomAction_GICombiner92,
  GICXXCustomAction_GICombiner93,
  GICXXCustomAction_GICombiner94,
  GICXXCustomAction_GICombiner95,
  GICXXCustomAction_GICombiner96,
  GICXXCustomAction_GICombiner97,
  GICXXCustomAction_GICombiner98,
  GICXXCustomAction_GICombiner99,
  GICXXCustomAction_GICombiner100,
  GICXXCustomAction_GICombiner101,
  GICXXCustomAction_GICombiner102,
  GICXXCustomAction_GICombiner103,
  GICXXCustomAction_GICombiner104,
  GICXXCustomAction_GICombiner105,
  GICXXCustomAction_GICombiner106,
  GICXXCustomAction_GICombiner107,
  GICXXCustomAction_GICombiner108,
  GICXXCustomAction_GICombiner109,
  GICXXCustomAction_GICombiner110,
  GICXXCustomAction_GICombiner111,
  GICXXCustomAction_GICombiner112,
  GICXXCustomAction_GICombiner113,
  GICXXCustomAction_GICombiner114,
  GICXXCustomAction_GICombiner115,
  GICXXCustomAction_GICombiner116,
  GICXXCustomAction_GICombiner117,
  GICXXCustomAction_GICombiner118,
  GICXXCustomAction_GICombiner119,
  GICXXCustomAction_GICombiner120,
  GICXXCustomAction_GICombiner121,
  GICXXCustomAction_GICombiner122,
  GICXXCustomAction_GICombiner123,
  GICXXCustomAction_GICombiner124,
  GICXXCustomAction_GICombiner125,
  GICXXCustomAction_GICombiner126,
  GICXXCustomAction_GICombiner127,
  GICXXCustomAction_GICombiner128,
  GICXXCustomAction_GICombiner129,
  GICXXCustomAction_GICombiner130,
  GICXXCustomAction_GICombiner131,
  GICXXCustomAction_GICombiner132,
  GICXXCustomAction_GICombiner133,
  GICXXCustomAction_GICombiner134,
  GICXXCustomAction_GICombiner135,
  GICXXCustomAction_GICombiner136,
  GICXXCustomAction_GICombiner137,
  GICXXCustomAction_GICombiner138,
  GICXXCustomAction_GICombiner139,
  GICXXCustomAction_GICombiner140,
  GICXXCustomAction_GICombiner141,
  GICXXCustomAction_GICombiner142,
  GICXXCustomAction_GICombiner143,
  GICXXCustomAction_GICombiner144,
  GICXXCustomAction_GICombiner145,
  GICXXCustomAction_GICombiner146,
  GICXXCustomAction_GICombiner147,
  GICXXCustomAction_GICombiner148,
  GICXXCustomAction_GICombiner149,
  GICXXCustomAction_GICombiner150,
  GICXXCustomAction_GICombiner151,
  GICXXCustomAction_GICombiner152,
  GICXXCustomAction_GICombiner153,
  GICXXCustomAction_GICombiner154,
  GICXXCustomAction_GICombiner155,
  GICXXCustomAction_GICombiner156,
  GICXXCustomAction_GICombiner157,
  GICXXCustomAction_GICombiner158,
  GICXXCustomAction_GICombiner159,
  GICXXCustomAction_GICombiner160,
  GICXXCustomAction_GICombiner161,
};
bool AMDGPUPostLegalizerCombinerImpl::runCustomAction(unsigned ApplyID, const MatcherState &State, NewMIVector &OutMIs) const {
  Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
  switch(ApplyID) {
  case GICXXCustomAction_GICombiner0:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAPlusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner1:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC2MinusAPlusC1(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner2:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner3:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldC1Minus2MinusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner4:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldAMinusC1PlusC2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner5:{
    // Match Patterns
    if(![&](){return Helper.matchCombineCopy(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineCopy(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner6:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineMulToShl(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner7:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineSubToAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner8:{
    std::pair<Register, bool> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineAddP2IToPtrAdd(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner9:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElement(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner10:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchInsertVectorElementOOB(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner11:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithDifferentIndices(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner12:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner13:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithBuildVectorTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner14:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVectorElementWithShuffleVector(*State.MIs[0], *State.MIs[1],
              GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner15:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner16:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner17:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShlOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner18:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubOfVScale(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner19:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return !isGuaranteedNotToBePoison(State.MIs[0]->getOperand(1).getReg(), MRI) && Helper.matchFreezeOfSingleMaybePoisonOperand(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner20:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncateOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner21:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtOfExt(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner22:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantSextInReg(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner23:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfSelect(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner24:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfBuildVector(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner25:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinop(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner26:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCastOfInteger(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner27:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineInsertVecElts(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineInsertVecElts(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner28:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractVecEltBuildVec(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner29:{
    SmallVector<std::pair<Register, MachineInstr*>> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtractAllEltsFromBuildVector(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner30:{
    PreferredTuple GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineExtendingLoads(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner31:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineLoadWithAndMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner32:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineExtractedVectorLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner33:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner34:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner35:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], -1);
    return true;
  }
  case GICXXCustomAction_GICombiner36:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], 0);
    return true;
  }
  case GICXXCustomAction_GICombiner37:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsUndef(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner38:{
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]->getOperand(0).getParent());
    return true;
  }
  case GICXXCustomAction_GICombiner39:{
    // Match Patterns
    if(![&](){return Helper.matchAnyExplicitUseIsUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner40:{
    // Match Patterns
    if(![&](){return Helper.matchAllExplicitUsesAreUndef(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner41:{
    // Match Patterns
    if(![&](){return Helper.matchUndefShuffleVectorMask(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner42:{
    // Match Patterns
    if(![&](){return Helper.matchUndefStore(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.eraseInst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner43:{
    // Match Patterns
    if(![&](){return Helper.matchInsertExtractVecEltOutOfBounds(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithUndef(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner44:{
    // Match Patterns
    if(![&](){return Helper.matchSelectSameVal(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 2);
    return true;
  }
  case GICXXCustomAction_GICombiner45:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsZero(*State.MIs[0], 1);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner46:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineI2PToP2I(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineI2PToP2I(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner47:{
    Register GIMatchData_info;
    // Match Patterns
    if(![&](){GIMatchData_info = State.MIs[1]->getOperand(1).getReg(); return true;}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineP2IToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner48:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineAnyExtTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner49:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchBuildVectorIdentityFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner50:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner51:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchTruncLshrBuildVectorFold(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner52:{
    // Match Patterns
    if(![&](){return MRI.getType(State.MIs[1]->getOperand(1).getReg()) == MRI.getType(State.MIs[0]->getOperand(0).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner53:{
    MachineInstr* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExtendThroughPhis(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner54:{
    std::tuple<Register, Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyAddToSub(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyAddToSub(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner55:{
    InstructionStepsMatchInfo GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchHoistLogicOpWithSameOpcodeHands(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildInstructionSteps(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner56:{
    std::optional<int64_t> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftsTooBig(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    if (GIMatchData_matchinfo) {
              Helper.replaceInstWithConstant(*State.MIs[0], *GIMatchData_matchinfo);
            } else {
              Helper.replaceInstWithUndef(*State.MIs[0]);
            }
    return true;
  }
  case GICXXCustomAction_GICombiner57:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocPtrAdd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner58:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchReassocCommBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner59:{
    PtrAddChain GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner60:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeICmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner61:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCanonicalizeFCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner62:{
    int64_t GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchICmpToTrueFalseKnownBits(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner63:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchICmpToLHSKnownBits(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner64:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchRedundantBinOpInEquality(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner65:{
    std::tuple<Register, int64_t> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAshrShlToSextInreg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyAshShlToSextInreg(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner66:{
    std::tuple<Register, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySextInRegOfLoad(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner67:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShlOfExtend(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner68:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNarrowBinopFeedingAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner69:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantSelectCmp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner70:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSelectIMinMax(State.MIs[0]->getOperand(0), GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner71:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSelect(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner72:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner73:{
    // Match Patterns
    if(![&](){return Helper.matchRedundantSExtInReg(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], 1);
    return true;
  }
  case GICXXCustomAction_GICombiner74:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner75:{
    // Match Patterns
    if(![&](){return Helper.matchOperandIsKnownToBeAPowerOfTwo(*State.MIs[0], 2);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySimplifyURemByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner76:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineZextTrunc(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner77:{
    // Match Patterns
    if(![&](){unsigned BitWidth = MRI.getType(State.MIs[0]->getOperand(1).getReg()).getScalarSizeInBits();
                return Helper.getValueTracking()->maskedValueIsZero(State.MIs[0]->getOperand(1).getReg(),
                         APInt::getOneBitSet(BitWidth, State.MIs[0]->getOperand(2).getImm() - 1));}()) {
      return false;
    }
    // Apply Patterns
    Helper.getBuilder().setInstrAndDebugLoc(*State.MIs[0]);
              Helper.getBuilder().buildZExtInReg(State.MIs[0]->getOperand(0), State.MIs[0]->getOperand(1), State.MIs[0]->getOperand(2).getImm());
              State.MIs[0]->eraseFromParent();
    return true;
  }
  case GICXXCustomAction_GICombiner78:{
    std::pair<MachineInstr*, LLT> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineTruncOfShift(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner79:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchNotCmp(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyNotCmp(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner80:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyOptBrCondByInvertingCond(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner81:{
    // Apply Patterns
    Helper.applyCombineConstantFoldFpUnary(*State.MIs[0], State.MIs[1]->getOperand(1).getFPImm());
    return true;
  }
  case GICXXCustomAction_GICombiner82:{
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0]->getOperand(0).getParent(), 0.0);
    return true;
  }
  case GICXXCustomAction_GICombiner83:{
    APInt GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConstPtrAddToI2P(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner84:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOverlappingAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner85:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy2(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner86:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMulOBy0(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner87:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddEToAddO(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner88:{
    unsigned GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFMinMaxNaN(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithOperand(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner89:{
    // Match Patterns
    if(![&](){return Helper.matchFPowIExpansion(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandFPowI(*State.MIs[0], State.MIs[1]->getOperand(1).getCImm()->getSExtValue());
    return true;
  }
  case GICXXCustomAction_GICombiner90:{
    std::pair<Register, Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyXorOfAndWithSameReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner91:{
    // Match Patterns
    if(![&](){return Helper.matchPtrAddZero(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyPtrAddZero(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner92:{
    RegisterImmPair GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftImmedChain(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner93:{
    ShiftOfShiftedLogic GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyShiftOfShiftedLogic(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner94:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchLoadOrCombine(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner95:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineDivRem(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner96:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchOrShiftToFunnelShift(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner97:{
    // Match Patterns
    if(![&](){return Helper.matchFunnelShiftToRotate(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftToRotate(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner98:{
    // Match Patterns
    if(![&](){return Helper.matchConstantLargerBitWidth(*State.MIs[0], 3);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFunnelShiftConstantModulo(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner99:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCommuteShift(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner100:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromSExtInReg(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner101:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner102:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShr(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner103:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchBitfieldExtractFromShrAnd(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner104:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner105:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFPBinOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner106:{
    ConstantFP* GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldFMA(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithFConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner107:{
    APInt GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchConstantFoldCastOp(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceInstWithConstant(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner108:{
    // Match Patterns
    if(![&](){return Helper.matchUMulHToLShr(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUMulHToLShr(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner109:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchRedundantNegOperands(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner110:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchAndOrDisjointMask(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnNoErase(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner111:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner112:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner113:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFMAFMulToFMadOrFMA(*State.MIs[0],
                                                                     GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner114:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFAddFpExtFMulToFMadOrFMAAggressive(
                                                          *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner115:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFMulToFMadOrFMA(*State.MIs[0],
                                                                  GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner116:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFNegFMulToFMadOrFMA(*State.MIs[0],
                                                                      GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner117:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFMulToFMadOrFMA(*State.MIs[0],
                                                                       GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner118:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineFSubFpExtFNegFMulToFMadOrFMA(
                                                    *State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner119:{
    unsigned GIMatchData_select_op_no;
    // Match Patterns
    if(![&](){return Helper.matchFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldBinOpIntoSelect(*State.MIs[0], GIMatchData_select_op_no);
    return true;
  }
  case GICXXCustomAction_GICombiner120:{
    // Match Patterns
    if(![&](){return Helper.matchUDivorURemByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivorURemByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner121:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/false);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner122:{
    // Match Patterns
    if(![&](){return Helper.matchDivByPow2(*State.MIs[0], /*IsSigned=*/true);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByPow2(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner123:{
    // Match Patterns
    if(![&](){return Helper.matchSDivByConst(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applySDivByConst(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner124:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSubAddSameReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner125:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchSimplifySelectToMinMax(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner126:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFsubToFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner127:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner128:{
    // Match Patterns
    if(![&](){return Helper.matchCommuteFPConstantToRHS(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCommuteBinOpOperands(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner129:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAnd(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner130:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchOr(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner131:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSimplifyNegMinMax(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner132:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineConcatVectors(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner133:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner134:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchZextOfTrunc(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner135:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchNonNegZext(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFnMO(State.MIs[0]->getOperand(0), GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner136:{
    SmallVector<Register> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineShuffleConcat(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner137:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleUndefRHS(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner138:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchShuffleDisjointMask(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner139:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyUseVectorTruncate(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner140:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchUnmergeValuesAnyExtBuildVector(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner141:{
    SmallVector<Register> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeMergeToPlainValues(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner142:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineMergeUnmerge(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner143:{
    SmallVector<APInt, 8> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeConstant(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner144:{
    std::function<void(MachineIRBuilder &)> GIMatchData_info;
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeUndef(*State.MIs[0], GIMatchData_info);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_info);
    return true;
  }
  case GICXXCustomAction_GICombiner145:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeWithDeadLanesToTrunc(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner146:{
    // Match Patterns
    if(![&](){return Helper.matchCombineUnmergeZExtToZExt(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyCombineUnmergeZExtToZExt(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner147:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndUndef(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner148:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchMergeXAndZero(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner149:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchAddOverflow(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner150:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchSuboCarryOut(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner151:{
    FMinFMaxLegacyInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchFMinFMaxLegacy(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applySelectFCmpToFMinFMaxLegacy(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner152:{
    // Match Patterns
    if(![&](){return Helper.matchExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyExpandPromotedF16FMed3(*State.MIs[0], State.MIs[1]->getOperand(1).getReg(), State.MIs[1]->getOperand(2).getReg(), State.MIs[1]->getOperand(3).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner153:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchCombineFmulWithSelectToFldexp(*State.MIs[0], *State.MIs[1], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner154:{
    // Match Patterns
    if(![&](){return matchUCharToFloat(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyUCharToFloat(*State.MIs[0]);
    return true;
  }
  case GICXXCustomAction_GICombiner155:{
    CvtF32UByteMatchInfo GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCvtF32UByteN(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner156:{
    Register GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRemoveFcanonicalize(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceSingleDefInstWithReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner157:{
    MachineInstr * GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return Helper.matchFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyFoldableFneg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner158:{
    std::function<void(MachineIRBuilder &)> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchRcpSqrtToRsq(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.applyBuildFn(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner159:{
    // Match Patterns
    if(![&](){return matchFDivSqrtToRsqF16(*State.MIs[0]);}()) {
      return false;
    }
    // Apply Patterns
    applyFDivSqrtToRsqF16(*State.MIs[0], State.MIs[1]->getOperand(1).getReg());
    return true;
  }
  case GICXXCustomAction_GICombiner160:{
    std::pair<MachineInstr *, unsigned> GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    applyCombineSignExtendInReg(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  case GICXXCustomAction_GICombiner161:{
    unsigned GIMatchData_matchinfo;
    // Match Patterns
    if(![&](){return matchCombine_s_mul_u64(*State.MIs[0], GIMatchData_matchinfo);}()) {
      return false;
    }
    // Apply Patterns
    Helper.replaceOpcodeWith(*State.MIs[0], GIMatchData_matchinfo);
    return true;
  }
  }
  llvm_unreachable("Unknown Apply Action");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AMDGPUPostLegalizerCombinerImpl::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(20), GIMT_Encode2(3784), /*)*//*default:*//*Label 100*/ GIMT_Encode4(21358),
     /*    10 */ /*TargetOpcode::COPY*//*Label 0*/ GIMT_Encode4(15066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   142 */ /*TargetOpcode::G_ADD*//*Label 1*/ GIMT_Encode4(15078),
     /*   146 */ /*TargetOpcode::G_SUB*//*Label 2*/ GIMT_Encode4(15635),
     /*   150 */ /*TargetOpcode::G_MUL*//*Label 3*/ GIMT_Encode4(15953),
     /*   154 */ /*TargetOpcode::G_SDIV*//*Label 4*/ GIMT_Encode4(16130),
     /*   158 */ /*TargetOpcode::G_UDIV*//*Label 5*/ GIMT_Encode4(16203),
     /*   162 */ /*TargetOpcode::G_SREM*//*Label 6*/ GIMT_Encode4(16287),
     /*   166 */ /*TargetOpcode::G_UREM*//*Label 7*/ GIMT_Encode4(16332), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   178 */ /*TargetOpcode::G_AND*//*Label 8*/ GIMT_Encode4(16410),
     /*   182 */ /*TargetOpcode::G_OR*//*Label 9*/ GIMT_Encode4(16691),
     /*   186 */ /*TargetOpcode::G_XOR*//*Label 10*/ GIMT_Encode4(16936), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   202 */ /*TargetOpcode::G_PHI*//*Label 11*/ GIMT_Encode4(17037), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   226 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 12*/ GIMT_Encode4(17049), GIMT_Encode4(0),
     /*   234 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 13*/ GIMT_Encode4(17116),
     /*   238 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 14*/ GIMT_Encode4(17190),
     /*   242 */ /*TargetOpcode::G_BUILD_VECTOR_TRUNC*//*Label 15*/ GIMT_Encode4(17238),
     /*   246 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 16*/ GIMT_Encode4(17250),
     /*   250 */ /*TargetOpcode::G_PTRTOINT*//*Label 17*/ GIMT_Encode4(17262),
     /*   254 */ /*TargetOpcode::G_INTTOPTR*//*Label 18*/ GIMT_Encode4(17305),
     /*   258 */ /*TargetOpcode::G_BITCAST*//*Label 19*/ GIMT_Encode4(17338),
     /*   262 */ /*TargetOpcode::G_FREEZE*//*Label 20*/ GIMT_Encode4(17381), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(17445),
     /*   306 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(17457),
     /*   310 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(17469), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   326 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(17481), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   446 */ /*TargetOpcode::G_INTRINSIC*//*Label 25*/ GIMT_Encode4(17493), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   462 */ /*TargetOpcode::G_ANYEXT*//*Label 26*/ GIMT_Encode4(17505),
     /*   466 */ /*TargetOpcode::G_TRUNC*//*Label 27*/ GIMT_Encode4(17633), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   498 */ /*TargetOpcode::G_SEXT*//*Label 28*/ GIMT_Encode4(17991),
     /*   502 */ /*TargetOpcode::G_SEXT_INREG*//*Label 29*/ GIMT_Encode4(18066),
     /*   506 */ /*TargetOpcode::G_ZEXT*//*Label 30*/ GIMT_Encode4(18143),
     /*   510 */ /*TargetOpcode::G_SHL*//*Label 31*/ GIMT_Encode4(18273),
     /*   514 */ /*TargetOpcode::G_LSHR*//*Label 32*/ GIMT_Encode4(18442),
     /*   518 */ /*TargetOpcode::G_ASHR*//*Label 33*/ GIMT_Encode4(18565),
     /*   522 */ /*TargetOpcode::G_FSHL*//*Label 34*/ GIMT_Encode4(18699),
     /*   526 */ /*TargetOpcode::G_FSHR*//*Label 35*/ GIMT_Encode4(18742),
     /*   530 */ /*TargetOpcode::G_ROTR*//*Label 36*/ GIMT_Encode4(18785),
     /*   534 */ /*TargetOpcode::G_ROTL*//*Label 37*/ GIMT_Encode4(18809),
     /*   538 */ /*TargetOpcode::G_ICMP*//*Label 38*/ GIMT_Encode4(18833),
     /*   542 */ /*TargetOpcode::G_FCMP*//*Label 39*/ GIMT_Encode4(18878), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   554 */ /*TargetOpcode::G_SELECT*//*Label 40*/ GIMT_Encode4(18890),
     /*   558 */ /*TargetOpcode::G_UADDO*//*Label 41*/ GIMT_Encode4(19012),
     /*   562 */ /*TargetOpcode::G_UADDE*//*Label 42*/ GIMT_Encode4(19035),
     /*   566 */ /*TargetOpcode::G_USUBO*//*Label 43*/ GIMT_Encode4(19047),
     /*   570 */ /*TargetOpcode::G_USUBE*//*Label 44*/ GIMT_Encode4(19059),
     /*   574 */ /*TargetOpcode::G_SADDO*//*Label 45*/ GIMT_Encode4(19071),
     /*   578 */ /*TargetOpcode::G_SADDE*//*Label 46*/ GIMT_Encode4(19094),
     /*   582 */ /*TargetOpcode::G_SSUBO*//*Label 47*/ GIMT_Encode4(19106),
     /*   586 */ /*TargetOpcode::G_SSUBE*//*Label 48*/ GIMT_Encode4(19118),
     /*   590 */ /*TargetOpcode::G_UMULO*//*Label 49*/ GIMT_Encode4(19130),
     /*   594 */ /*TargetOpcode::G_SMULO*//*Label 50*/ GIMT_Encode4(19164),
     /*   598 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(19198),
     /*   602 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(19221),
     /*   606 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(19233),
     /*   610 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(19245), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   622 */ /*TargetOpcode::G_USHLSAT*//*Label 55*/ GIMT_Encode4(19257),
     /*   626 */ /*TargetOpcode::G_SSHLSAT*//*Label 56*/ GIMT_Encode4(19280),
     /*   630 */ /*TargetOpcode::G_SMULFIX*//*Label 57*/ GIMT_Encode4(19303),
     /*   634 */ /*TargetOpcode::G_UMULFIX*//*Label 58*/ GIMT_Encode4(19315),
     /*   638 */ /*TargetOpcode::G_SMULFIXSAT*//*Label 59*/ GIMT_Encode4(19327),
     /*   642 */ /*TargetOpcode::G_UMULFIXSAT*//*Label 60*/ GIMT_Encode4(19339), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   662 */ /*TargetOpcode::G_FADD*//*Label 61*/ GIMT_Encode4(19351),
     /*   666 */ /*TargetOpcode::G_FSUB*//*Label 62*/ GIMT_Encode4(19463),
     /*   670 */ /*TargetOpcode::G_FMUL*//*Label 63*/ GIMT_Encode4(19552),
     /*   674 */ /*TargetOpcode::G_FMA*//*Label 64*/ GIMT_Encode4(19661),
     /*   678 */ /*TargetOpcode::G_FMAD*//*Label 65*/ GIMT_Encode4(19684),
     /*   682 */ /*TargetOpcode::G_FDIV*//*Label 66*/ GIMT_Encode4(19707),
     /*   686 */ /*TargetOpcode::G_FREM*//*Label 67*/ GIMT_Encode4(19780), GIMT_Encode4(0),
     /*   694 */ /*TargetOpcode::G_FPOWI*//*Label 68*/ GIMT_Encode4(19792), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   714 */ /*TargetOpcode::G_FLOG2*//*Label 69*/ GIMT_Encode4(19814), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   730 */ /*TargetOpcode::G_FNEG*//*Label 70*/ GIMT_Encode4(19836), GIMT_Encode4(0),
     /*   738 */ /*TargetOpcode::G_FPTRUNC*//*Label 71*/ GIMT_Encode4(19898),
     /*   742 */ /*TargetOpcode::G_FPTOSI*//*Label 72*/ GIMT_Encode4(19965),
     /*   746 */ /*TargetOpcode::G_FPTOUI*//*Label 73*/ GIMT_Encode4(19987),
     /*   750 */ /*TargetOpcode::G_SITOFP*//*Label 74*/ GIMT_Encode4(20009),
     /*   754 */ /*TargetOpcode::G_UITOFP*//*Label 75*/ GIMT_Encode4(20047), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   766 */ /*TargetOpcode::G_FABS*//*Label 76*/ GIMT_Encode4(20085), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   778 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 77*/ GIMT_Encode4(20164),
     /*   782 */ /*TargetOpcode::G_FMINNUM*//*Label 78*/ GIMT_Encode4(20205),
     /*   786 */ /*TargetOpcode::G_FMAXNUM*//*Label 79*/ GIMT_Encode4(20239),
     /*   790 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 80*/ GIMT_Encode4(20273),
     /*   794 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 81*/ GIMT_Encode4(20285),
     /*   798 */ /*TargetOpcode::G_FMINIMUM*//*Label 82*/ GIMT_Encode4(20297),
     /*   802 */ /*TargetOpcode::G_FMAXIMUM*//*Label 83*/ GIMT_Encode4(20331), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   842 */ /*TargetOpcode::G_PTR_ADD*//*Label 84*/ GIMT_Encode4(20365), GIMT_Encode4(0),
     /*   850 */ /*TargetOpcode::G_SMIN*//*Label 85*/ GIMT_Encode4(20455),
     /*   854 */ /*TargetOpcode::G_SMAX*//*Label 86*/ GIMT_Encode4(20489),
     /*   858 */ /*TargetOpcode::G_UMIN*//*Label 87*/ GIMT_Encode4(20523),
     /*   862 */ /*TargetOpcode::G_UMAX*//*Label 88*/ GIMT_Encode4(20557),
     /*   866 */ /*TargetOpcode::G_ABS*//*Label 89*/ GIMT_Encode4(20591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   878 */ /*TargetOpcode::G_BR*//*Label 90*/ GIMT_Encode4(20603), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   898 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(20615),
     /*   902 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 92*/ GIMT_Encode4(20745),
     /*   906 */ /*TargetOpcode::G_SHUFFLE_VECTOR*//*Label 93*/ GIMT_Encode4(21122), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   946 */ /*TargetOpcode::G_BITREVERSE*//*Label 94*/ GIMT_Encode4(21188), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   998 */ /*TargetOpcode::G_FSQRT*//*Label 95*/ GIMT_Encode4(21277), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 15050 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE0*//*Label 96*/ GIMT_Encode4(21310),
     /* 15054 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE1*//*Label 97*/ GIMT_Encode4(21322),
     /* 15058 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE2*//*Label 98*/ GIMT_Encode4(21334),
     /* 15062 */ /*AMDGPU::G_AMDGPU_CVT_F32_UBYTE3*//*Label 99*/ GIMT_Encode4(21346),
     /* 15066 */ // Label 0: @15066
     /* 15066 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(15077), // Rule ID 13 //
     /* 15071 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule13Enabled),
     /* 15074 */   // MIs[0] d
     /* 15074 */   // No operand predicates
     /* 15074 */   // MIs[0] s
     /* 15074 */   // No operand predicates
     /* 15074 */   // Combiner Rule #13: copy_prop
     /* 15074 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner5),
     /* 15077 */ // Label 101: @15077
     /* 15077 */ GIM_Reject,
     /* 15078 */ // Label 1: @15078
     /* 15078 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(15089), // Rule ID 16 //
     /* 15083 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule16Enabled),
     /* 15086 */   // Combiner Rule #16: add_p2i_to_ptradd; wip_match_opcode 'G_ADD'
     /* 15086 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner8),
     /* 15089 */ // Label 102: @15089
     /* 15089 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(15100), // Rule ID 94 //
     /* 15094 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 15097 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_ADD'
     /* 15097 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 15100 */ // Label 103: @15100
     /* 15100 */ GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(15111), // Rule ID 141 //
     /* 15105 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule103Enabled),
     /* 15108 */   // Combiner Rule #103: simplify_add_to_sub; wip_match_opcode 'G_ADD'
     /* 15108 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner54),
     /* 15111 */ // Label 104: @15111
     /* 15111 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(15122), // Rule ID 231 //
     /* 15116 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 15119 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ADD'
     /* 15119 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 15122 */ // Label 105: @15122
     /* 15122 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(15133), // Rule ID 275 //
     /* 15127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 15130 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_ADD'
     /* 15130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 15133 */ // Label 106: @15133
     /* 15133 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(15144), // Rule ID 309 //
     /* 15138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 15141 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_ADD'
     /* 15141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 15144 */ // Label 107: @15144
     /* 15144 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(15178), // Rule ID 0 //
     /* 15149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule0Enabled),
     /* 15152 */   // MIs[0] root
     /* 15152 */   // No operand predicates
     /* 15152 */   // MIs[0] sub
     /* 15152 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15156 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15160 */   // MIs[1] Operand 1
     /* 15160 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 15164 */   // MIs[1] A
     /* 15164 */   // No operand predicates
     /* 15164 */   // MIs[0] B
     /* 15164 */   // No operand predicates
     /* 15164 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15166 */   // Combiner Rule #0: ZeroMinusAPlusB
     /* 15166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15169 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15171 */   GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 15173 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /* 15177 */   GIR_EraseRootFromParent_Done,
     /* 15178 */ // Label 108: @15178
     /* 15178 */ GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(15215), // Rule ID 12 //
     /* 15183 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule12Enabled),
     /* 15186 */   // MIs[0] root
     /* 15186 */   // No operand predicates
     /* 15186 */   // MIs[0] sub
     /* 15186 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15194 */   // MIs[1] A
     /* 15194 */   // No operand predicates
     /* 15194 */   // MIs[1] c1
     /* 15194 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15198 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15202 */   // MIs[2] imm1
     /* 15202 */   // No operand predicates
     /* 15202 */   // MIs[0] c2
     /* 15202 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15206 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15210 */   // MIs[3] imm2
     /* 15210 */   // No operand predicates
     /* 15210 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15212 */   // Combiner Rule #12: AMinusC1PlusC2
     /* 15212 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner4),
     /* 15215 */ // Label 109: @15215
     /* 15215 */ GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(15249), // Rule ID 3 //
     /* 15220 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule3Enabled),
     /* 15223 */   // MIs[0] root
     /* 15223 */   // No operand predicates
     /* 15223 */   // MIs[0] sub
     /* 15223 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15227 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15231 */   // MIs[1] B
     /* 15231 */   // No operand predicates
     /* 15231 */   // MIs[1] A
     /* 15231 */   // No operand predicates
     /* 15231 */   // MIs[0] A
     /* 15231 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 15236 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15241 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15243 */   // Combiner Rule #3: BMinusAPlusA
     /* 15243 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15248 */   GIR_EraseRootFromParent_Done,
     /* 15249 */ // Label 110: @15249
     /* 15249 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(15283), // Rule ID 131 //
     /* 15254 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 15257 */   // MIs[0] dst
     /* 15257 */   // No operand predicates
     /* 15257 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 15257 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15265 */   // MIs[1] src
     /* 15265 */   // No operand predicates
     /* 15265 */   // MIs[1] __add_sub_reg_match_0.x
     /* 15265 */   // No operand predicates
     /* 15265 */   // MIs[0] __add_sub_reg_match_0.x
     /* 15265 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 15270 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15275 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15277 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[1]]
     /* 15277 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15282 */   GIR_EraseRootFromParent_Done,
     /* 15283 */ // Label 111: @15283
     /* 15283 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(15328), // Rule ID 5 //
     /* 15288 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule5Enabled),
     /* 15291 */   // MIs[0] root
     /* 15291 */   // No operand predicates
     /* 15291 */   // MIs[0] sub1
     /* 15291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15299 */   // MIs[1] A
     /* 15299 */   // No operand predicates
     /* 15299 */   // MIs[1] B
     /* 15299 */   // No operand predicates
     /* 15299 */   // MIs[0] sub2
     /* 15299 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15303 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15307 */   // MIs[2] B
     /* 15307 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 15312 */   // MIs[2] C
     /* 15312 */   // No operand predicates
     /* 15312 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15314 */   // Combiner Rule #5: AMinusBPlusBMinusC
     /* 15314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15317 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15319 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 15323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 15327 */   GIR_EraseRootFromParent_Done,
     /* 15328 */ // Label 112: @15328
     /* 15328 */ GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(15373), // Rule ID 4 //
     /* 15333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule4Enabled),
     /* 15336 */   // MIs[0] root
     /* 15336 */   // No operand predicates
     /* 15336 */   // MIs[0] sub1
     /* 15336 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15344 */   // MIs[1] A
     /* 15344 */   // No operand predicates
     /* 15344 */   // MIs[1] B
     /* 15344 */   // No operand predicates
     /* 15344 */   // MIs[0] sub2
     /* 15344 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15348 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15352 */   // MIs[2] C
     /* 15352 */   // No operand predicates
     /* 15352 */   // MIs[2] A
     /* 15352 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 15357 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15359 */   // Combiner Rule #4: AMinusBPlusCMinusA
     /* 15359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15362 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15364 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15368 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15372 */   GIR_EraseRootFromParent_Done,
     /* 15373 */ // Label 113: @15373
     /* 15373 */ GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(15408), // Rule ID 39 //
     /* 15378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule37Enabled),
     /* 15381 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15387 */   // MIs[0] root
     /* 15387 */   // No operand predicates
     /* 15387 */   // MIs[0] left
     /* 15387 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15395 */   // MIs[1] imm1
     /* 15395 */   // No operand predicates
     /* 15395 */   // MIs[0] right
     /* 15395 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15399 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15403 */   // MIs[2] imm2
     /* 15403 */   // No operand predicates
     /* 15403 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15405 */   // Combiner Rule #37: add_of_vscale
     /* 15405 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner15),
     /* 15408 */ // Label 114: @15408
     /* 15408 */ GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(15442), // Rule ID 1 //
     /* 15413 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule1Enabled),
     /* 15416 */   // MIs[0] root
     /* 15416 */   // No operand predicates
     /* 15416 */   // MIs[0] A
     /* 15416 */   // No operand predicates
     /* 15416 */   // MIs[0] sub
     /* 15416 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15420 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15424 */   // MIs[1] Operand 1
     /* 15424 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /* 15428 */   // MIs[1] B
     /* 15428 */   // No operand predicates
     /* 15428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15430 */   // Combiner Rule #1: APlusZeroMinusB
     /* 15430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15433 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15435 */   GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 15437 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /* 15441 */   GIR_EraseRootFromParent_Done,
     /* 15442 */ // Label 115: @15442
     /* 15442 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(15476), // Rule ID 2 //
     /* 15447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule2Enabled),
     /* 15450 */   // MIs[0] root
     /* 15450 */   // No operand predicates
     /* 15450 */   // MIs[0] A
     /* 15450 */   // No operand predicates
     /* 15450 */   // MIs[0] sub
     /* 15450 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15458 */   // MIs[1] B
     /* 15458 */   // No operand predicates
     /* 15458 */   // MIs[1] A
     /* 15458 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15463 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15468 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15470 */   // Combiner Rule #2: APlusBMinusB
     /* 15470 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15475 */   GIR_EraseRootFromParent_Done,
     /* 15476 */ // Label 116: @15476
     /* 15476 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(15510), // Rule ID 130 //
     /* 15481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule94Enabled),
     /* 15484 */   // MIs[0] dst
     /* 15484 */   // No operand predicates
     /* 15484 */   // MIs[0] __add_sub_reg_match_0.x
     /* 15484 */   // No operand predicates
     /* 15484 */   // MIs[0] __add_sub_reg_match_0.tmp
     /* 15484 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15488 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15492 */   // MIs[1] src
     /* 15492 */   // No operand predicates
     /* 15492 */   // MIs[1] __add_sub_reg_match_0.x
     /* 15492 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15497 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15504 */   // Combiner Rule #94: add_sub_reg @ [__add_sub_reg_match_0[0]]
     /* 15504 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 15509 */   GIR_EraseRootFromParent_Done,
     /* 15510 */ // Label 117: @15510
     /* 15510 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(15555), // Rule ID 6 //
     /* 15515 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule6Enabled),
     /* 15518 */   // MIs[0] root
     /* 15518 */   // No operand predicates
     /* 15518 */   // MIs[0] A
     /* 15518 */   // No operand predicates
     /* 15518 */   // MIs[0] sub1
     /* 15518 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15526 */   // MIs[1] B
     /* 15526 */   // No operand predicates
     /* 15526 */   // MIs[1] add1
     /* 15526 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15530 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15534 */   // MIs[2] A
     /* 15534 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15539 */   // MIs[2] C
     /* 15539 */   // No operand predicates
     /* 15539 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15541 */   // Combiner Rule #6: APlusBMinusAplusC
     /* 15541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15544 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15546 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15550 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // C
     /* 15554 */   GIR_EraseRootFromParent_Done,
     /* 15555 */ // Label 118: @15555
     /* 15555 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(15600), // Rule ID 7 //
     /* 15560 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule7Enabled),
     /* 15563 */   // MIs[0] root
     /* 15563 */   // No operand predicates
     /* 15563 */   // MIs[0] A
     /* 15563 */   // No operand predicates
     /* 15563 */   // MIs[0] sub1
     /* 15563 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15567 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15571 */   // MIs[1] B
     /* 15571 */   // No operand predicates
     /* 15571 */   // MIs[1] add1
     /* 15571 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15575 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15579 */   // MIs[2] C
     /* 15579 */   // No operand predicates
     /* 15579 */   // MIs[2] A
     /* 15579 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 15584 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 15586 */   // Combiner Rule #7: APlusBMinusCPlusA
     /* 15586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15589 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 15591 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 15595 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /* 15599 */   GIR_EraseRootFromParent_Done,
     /* 15600 */ // Label 119: @15600
     /* 15600 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(15623), // Rule ID 105 //
     /* 15605 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 15608 */   // MIs[0] dst
     /* 15608 */   // No operand predicates
     /* 15608 */   // MIs[0] lhs
     /* 15608 */   // No operand predicates
     /* 15608 */   // MIs[0] Operand 2
     /* 15608 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15612 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15617 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[1]]
     /* 15617 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15622 */   GIR_EraseRootFromParent_Done,
     /* 15623 */ // Label 120: @15623
     /* 15623 */ GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(15634), // Rule ID 149 //
     /* 15628 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule107Enabled),
     /* 15631 */   // MIs[0] root
     /* 15631 */   // No operand predicates
     /* 15631 */   // MIs[0] src1
     /* 15631 */   // No operand predicates
     /* 15631 */   // MIs[0] src2
     /* 15631 */   // No operand predicates
     /* 15631 */   // Combiner Rule #107: reassoc_comm_binops
     /* 15631 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner58),
     /* 15634 */ // Label 121: @15634
     /* 15634 */ GIM_Reject,
     /* 15635 */ // Label 2: @15635
     /* 15635 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(15646), // Rule ID 95 //
     /* 15640 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 15643 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_SUB'
     /* 15643 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 15646 */ // Label 122: @15646
     /* 15646 */ GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(15657), // Rule ID 239 //
     /* 15651 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 15654 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SUB'
     /* 15654 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 15657 */ // Label 123: @15657
     /* 15657 */ GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(15668), // Rule ID 276 //
     /* 15662 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 15665 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SUB'
     /* 15665 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 15668 */ // Label 124: @15668
     /* 15668 */ GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(15679), // Rule ID 306 //
     /* 15673 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule188Enabled),
     /* 15676 */   // Combiner Rule #188: sub_add_reg; wip_match_opcode 'G_SUB'
     /* 15676 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner124),
     /* 15679 */ // Label 125: @15679
     /* 15679 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(15690), // Rule ID 340 //
     /* 15684 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule195Enabled),
     /* 15687 */   // Combiner Rule #195: simplify_neg_minmax; wip_match_opcode 'G_SUB'
     /* 15687 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner131),
     /* 15690 */ // Label 126: @15690
     /* 15690 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(15727), // Rule ID 8 //
     /* 15695 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule8Enabled),
     /* 15698 */   // MIs[0] root
     /* 15698 */   // No operand predicates
     /* 15698 */   // MIs[0] add
     /* 15698 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15706 */   // MIs[1] A
     /* 15706 */   // No operand predicates
     /* 15706 */   // MIs[1] c1
     /* 15706 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15710 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15714 */   // MIs[2] imm1
     /* 15714 */   // No operand predicates
     /* 15714 */   // MIs[0] c2
     /* 15714 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15718 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15722 */   // MIs[3] imm2
     /* 15722 */   // No operand predicates
     /* 15722 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15724 */   // Combiner Rule #8: APlusC1MinusC2
     /* 15724 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner0),
     /* 15727 */ // Label 127: @15727
     /* 15727 */ GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(15764), // Rule ID 11 //
     /* 15732 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule11Enabled),
     /* 15735 */   // MIs[0] root
     /* 15735 */   // No operand predicates
     /* 15735 */   // MIs[0] sub1
     /* 15735 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15743 */   // MIs[1] c1
     /* 15743 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 15747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15751 */   // MIs[2] imm1
     /* 15751 */   // No operand predicates
     /* 15751 */   // MIs[1] A
     /* 15751 */   // No operand predicates
     /* 15751 */   // MIs[0] c2
     /* 15751 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15755 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15759 */   // MIs[3] imm2
     /* 15759 */   // No operand predicates
     /* 15759 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15761 */   // Combiner Rule #11: C1Minus2MinusC2
     /* 15761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner3),
     /* 15764 */ // Label 128: @15764
     /* 15764 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(15801), // Rule ID 10 //
     /* 15769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule10Enabled),
     /* 15772 */   // MIs[0] root
     /* 15772 */   // No operand predicates
     /* 15772 */   // MIs[0] sub1
     /* 15772 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15776 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 15780 */   // MIs[1] A
     /* 15780 */   // No operand predicates
     /* 15780 */   // MIs[1] c1
     /* 15780 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 15784 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15788 */   // MIs[2] imm1
     /* 15788 */   // No operand predicates
     /* 15788 */   // MIs[0] c2
     /* 15788 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 15792 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15796 */   // MIs[3] imm2
     /* 15796 */   // No operand predicates
     /* 15796 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15798 */   // Combiner Rule #10: AMinusC1MinusC2
     /* 15798 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner2),
     /* 15801 */ // Label 129: @15801
     /* 15801 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(15844), // Rule ID 159 //
     /* 15806 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule117Enabled),
     /* 15809 */   // MIs[0] dst
     /* 15809 */   // No operand predicates
     /* 15809 */   // MIs[0] Operand 1
     /* 15809 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 15813 */   // MIs[0] and
     /* 15813 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 15821 */   // MIs[1] x
     /* 15821 */   // No operand predicates
     /* 15821 */   // MIs[1] Operand 2
     /* 15821 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 15825 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner7),
     /* 15829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15831 */   // Combiner Rule #117: neg_and_one_to_sext_inreg
     /* 15831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 15834 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 15836 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 15840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 15843 */   GIR_EraseRootFromParent_Done,
     /* 15844 */ // Label 130: @15844
     /* 15844 */ GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(15881), // Rule ID 9 //
     /* 15849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule9Enabled),
     /* 15852 */   // MIs[0] root
     /* 15852 */   // No operand predicates
     /* 15852 */   // MIs[0] c2
     /* 15852 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 15856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15860 */   // MIs[1] imm2
     /* 15860 */   // No operand predicates
     /* 15860 */   // MIs[0] add
     /* 15860 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 15864 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 15868 */   // MIs[2] A
     /* 15868 */   // No operand predicates
     /* 15868 */   // MIs[2] c1
     /* 15868 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 15872 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15876 */   // MIs[3] imm1
     /* 15876 */   // No operand predicates
     /* 15876 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 15878 */   // Combiner Rule #9: C2MinusAPlusC1
     /* 15878 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner1),
     /* 15881 */ // Label 131: @15881
     /* 15881 */ GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(15908), // Rule ID 42 //
     /* 15886 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule40Enabled),
     /* 15889 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 15895 */   // MIs[0] root
     /* 15895 */   // No operand predicates
     /* 15895 */   // MIs[0] x
     /* 15895 */   // No operand predicates
     /* 15895 */   // MIs[0] right
     /* 15895 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 15903 */   // MIs[1] imm
     /* 15903 */   // No operand predicates
     /* 15903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15905 */   // Combiner Rule #40: sub_of_vscale
     /* 15905 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner18),
     /* 15908 */ // Label 132: @15908
     /* 15908 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(15931), // Rule ID 104 //
     /* 15913 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 15916 */   // MIs[0] dst
     /* 15916 */   // No operand predicates
     /* 15916 */   // MIs[0] lhs
     /* 15916 */   // No operand predicates
     /* 15916 */   // MIs[0] Operand 2
     /* 15916 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 15920 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15925 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[0]]
     /* 15925 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 15930 */   GIR_EraseRootFromParent_Done,
     /* 15931 */ // Label 133: @15931
     /* 15931 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(15952), // Rule ID 15 //
     /* 15936 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule15Enabled),
     /* 15939 */   // MIs[0] d
     /* 15939 */   // No operand predicates
     /* 15939 */   // MIs[0] op1
     /* 15939 */   // No operand predicates
     /* 15939 */   // MIs[0] c
     /* 15939 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 15943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 15947 */   // MIs[1] imm
     /* 15947 */   // No operand predicates
     /* 15947 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15949 */   // Combiner Rule #15: sub_to_add
     /* 15949 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner7),
     /* 15952 */ // Label 134: @15952
     /* 15952 */ GIM_Reject,
     /* 15953 */ // Label 3: @15953
     /* 15953 */ GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(15964), // Rule ID 78 //
     /* 15958 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 15961 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_MUL'
     /* 15961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 15964 */ // Label 135: @15964
     /* 15964 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(15975), // Rule ID 236 //
     /* 15969 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 15972 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_MUL'
     /* 15972 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 15975 */ // Label 136: @15975
     /* 15975 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(15986), // Rule ID 310 //
     /* 15980 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 15983 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_MUL'
     /* 15983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 15986 */ // Label 137: @15986
     /* 15986 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(15997), // Rule ID 377 //
     /* 15991 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule225Enabled),
     /* 15994 */   // Combiner Rule #225: smulu64; wip_match_opcode 'G_MUL'
     /* 15994 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner161),
     /* 15997 */ // Label 138: @15997
     /* 15997 */ GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(16037), // Rule ID 17 //
     /* 16002 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule17Enabled),
     /* 16005 */   // MIs[0] dst
     /* 16005 */   GIM_RecordRegType, /*MI*/0, /*Op*/0, /*TempTypeIdx*/uint8_t(-1),
     /* 16009 */   // MIs[0] x
     /* 16009 */   // No operand predicates
     /* 16009 */   // MIs[0] Operand 2
     /* 16009 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /* 16013 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16016 */   GIR_BuildConstant, /*TempRegID*/0, /*Val*/GIMT_Encode8(0),
     /* 16026 */   // Combiner Rule #17: mul_by_neg_one
     /* 16026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SUB),
     /* 16029 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 16031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16034 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 16036 */   GIR_EraseRootFromParent_Done,
     /* 16037 */ // Label 139: @16037
     /* 16037 */ GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(16072), // Rule ID 40 //
     /* 16042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule38Enabled),
     /* 16045 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 16051 */   // MIs[0] root
     /* 16051 */   // No operand predicates
     /* 16051 */   // MIs[0] left
     /* 16051 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 16059 */   // MIs[1] scale
     /* 16059 */   // No operand predicates
     /* 16059 */   // MIs[0] x
     /* 16059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16063 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16067 */   // MIs[2] imm1
     /* 16067 */   // No operand predicates
     /* 16067 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16069 */   // Combiner Rule #38: mul_of_vscale
     /* 16069 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner16),
     /* 16072 */ // Label 140: @16072
     /* 16072 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(16095), // Rule ID 123 //
     /* 16077 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule87Enabled),
     /* 16080 */   // MIs[0] dst
     /* 16080 */   // No operand predicates
     /* 16080 */   // MIs[0] lhs
     /* 16080 */   // No operand predicates
     /* 16080 */   // MIs[0] zero
     /* 16080 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16084 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 16089 */   // Combiner Rule #87: binop_right_to_zero
     /* 16089 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/2,
     /* 16094 */   GIR_EraseRootFromParent_Done,
     /* 16095 */ // Label 141: @16095
     /* 16095 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(16118), // Rule ID 128 //
     /* 16100 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule92Enabled),
     /* 16103 */   // MIs[0] dst
     /* 16103 */   // No operand predicates
     /* 16103 */   // MIs[0] x
     /* 16103 */   // No operand predicates
     /* 16103 */   // MIs[0] Operand 2
     /* 16103 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 16107 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16112 */   // Combiner Rule #92: right_identity_one_int
     /* 16112 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16117 */   GIR_EraseRootFromParent_Done,
     /* 16118 */ // Label 142: @16118
     /* 16118 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(16129), // Rule ID 14 //
     /* 16123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule14Enabled),
     /* 16126 */   // MIs[0] d
     /* 16126 */   // No operand predicates
     /* 16126 */   // MIs[0] op1
     /* 16126 */   // No operand predicates
     /* 16126 */   // MIs[0] op2
     /* 16126 */   // No operand predicates
     /* 16126 */   // Combiner Rule #14: mul_to_shl
     /* 16126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner6),
     /* 16129 */ // Label 143: @16129
     /* 16129 */ GIM_Reject,
     /* 16130 */ // Label 4: @16130
     /* 16130 */ GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(16141), // Rule ID 119 //
     /* 16135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 16138 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SDIV'
     /* 16138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16141 */ // Label 144: @16141
     /* 16141 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(16152), // Rule ID 211 //
     /* 16146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 16149 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SDIV'
     /* 16149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16152 */ // Label 145: @16152
     /* 16152 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(16163), // Rule ID 242 //
     /* 16157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16160 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SDIV'
     /* 16160 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16163 */ // Label 146: @16163
     /* 16163 */ GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(16174), // Rule ID 281 //
     /* 16168 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16171 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SDIV'
     /* 16171 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16174 */ // Label 147: @16174
     /* 16174 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(16191), // Rule ID 303 //
     /* 16179 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule185Enabled),
     /* 16182 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 16188 */   // MIs[0] dst
     /* 16188 */   // No operand predicates
     /* 16188 */   // MIs[0] x
     /* 16188 */   // No operand predicates
     /* 16188 */   // MIs[0] y
     /* 16188 */   // No operand predicates
     /* 16188 */   // Combiner Rule #185: sdiv_by_pow2
     /* 16188 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner122),
     /* 16191 */ // Label 148: @16191
     /* 16191 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(16202), // Rule ID 305 //
     /* 16196 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule187Enabled),
     /* 16199 */   // MIs[0] dst
     /* 16199 */   // No operand predicates
     /* 16199 */   // MIs[0] x
     /* 16199 */   // No operand predicates
     /* 16199 */   // MIs[0] y
     /* 16199 */   // No operand predicates
     /* 16199 */   // Combiner Rule #187: sdiv_by_const
     /* 16199 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner123),
     /* 16202 */ // Label 149: @16202
     /* 16202 */ GIM_Reject,
     /* 16203 */ // Label 5: @16203
     /* 16203 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(16214), // Rule ID 81 //
     /* 16208 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 16211 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UDIV'
     /* 16211 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 16214 */ // Label 150: @16214
     /* 16214 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(16225), // Rule ID 120 //
     /* 16219 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 16222 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UDIV'
     /* 16222 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16225 */ // Label 151: @16225
     /* 16225 */ GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(16236), // Rule ID 212 //
     /* 16230 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 16233 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UDIV'
     /* 16233 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16236 */ // Label 152: @16236
     /* 16236 */ GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(16247), // Rule ID 241 //
     /* 16241 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16244 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UDIV'
     /* 16244 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16247 */ // Label 153: @16247
     /* 16247 */ GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(16258), // Rule ID 283 //
     /* 16252 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16255 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UDIV'
     /* 16255 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16258 */ // Label 154: @16258
     /* 16258 */ GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(16275), // Rule ID 302 //
     /* 16263 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule184Enabled),
     /* 16266 */   GIM_MIFlagsNot, /*MI*/0, GIMT_Encode4(MachineInstr::IsExact),
     /* 16272 */   // MIs[0] dst
     /* 16272 */   // No operand predicates
     /* 16272 */   // MIs[0] x
     /* 16272 */   // No operand predicates
     /* 16272 */   // MIs[0] y
     /* 16272 */   // No operand predicates
     /* 16272 */   // Combiner Rule #184: udiv_by_pow2
     /* 16272 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner121),
     /* 16275 */ // Label 155: @16275
     /* 16275 */ GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(16286), // Rule ID 304 //
     /* 16280 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule186Enabled),
     /* 16283 */   // MIs[0] dst
     /* 16283 */   // No operand predicates
     /* 16283 */   // MIs[0] x
     /* 16283 */   // No operand predicates
     /* 16283 */   // MIs[0] y
     /* 16283 */   // No operand predicates
     /* 16283 */   // Combiner Rule #186: udiv_by_const
     /* 16283 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 16286 */ // Label 156: @16286
     /* 16286 */ GIM_Reject,
     /* 16287 */ // Label 6: @16287
     /* 16287 */ GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(16298), // Rule ID 121 //
     /* 16292 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 16295 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SREM'
     /* 16295 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16298 */ // Label 157: @16298
     /* 16298 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(16309), // Rule ID 213 //
     /* 16303 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 16306 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_SREM'
     /* 16306 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16309 */ // Label 158: @16309
     /* 16309 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(16320), // Rule ID 244 //
     /* 16314 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16317 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SREM'
     /* 16317 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16320 */ // Label 159: @16320
     /* 16320 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(16331), // Rule ID 282 //
     /* 16325 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16328 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SREM'
     /* 16328 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16331 */ // Label 160: @16331
     /* 16331 */ GIM_Reject,
     /* 16332 */ // Label 7: @16332
     /* 16332 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(16343), // Rule ID 82 //
     /* 16337 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 16340 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_UREM'
     /* 16340 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 16343 */ // Label 161: @16343
     /* 16343 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(16354), // Rule ID 122 //
     /* 16348 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 16351 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_UREM'
     /* 16351 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 16354 */ // Label 162: @16354
     /* 16354 */ GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(16365), // Rule ID 170 //
     /* 16359 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule128Enabled),
     /* 16362 */   // Combiner Rule #128: urem_pow2_to_mask; wip_match_opcode 'G_UREM'
     /* 16362 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner75),
     /* 16365 */ // Label 163: @16365
     /* 16365 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(16376), // Rule ID 214 //
     /* 16370 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule153Enabled),
     /* 16373 */   // Combiner Rule #153: div_rem_to_divrem; wip_match_opcode 'G_UREM'
     /* 16373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner95),
     /* 16376 */ // Label 164: @16376
     /* 16376 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(16387), // Rule ID 243 //
     /* 16381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16384 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UREM'
     /* 16384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16387 */ // Label 165: @16387
     /* 16387 */ GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(16398), // Rule ID 284 //
     /* 16392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16395 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UREM'
     /* 16395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16398 */ // Label 166: @16398
     /* 16398 */ GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(16409), // Rule ID 301 //
     /* 16403 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule183Enabled),
     /* 16406 */   // MIs[0] dst
     /* 16406 */   // No operand predicates
     /* 16406 */   // MIs[0] x
     /* 16406 */   // No operand predicates
     /* 16406 */   // MIs[0] y
     /* 16406 */   // No operand predicates
     /* 16406 */   // Combiner Rule #183: urem_by_const
     /* 16406 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner120),
     /* 16409 */ // Label 167: @16409
     /* 16409 */ GIM_Reject,
     /* 16410 */ // Label 8: @16410
     /* 16410 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(16421), // Rule ID 73 //
     /* 16415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule69Enabled),
     /* 16418 */   // Combiner Rule #69: load_and_mask; wip_match_opcode 'G_AND'
     /* 16418 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner31),
     /* 16421 */ // Label 168: @16421
     /* 16421 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(16432), // Rule ID 77 //
     /* 16426 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule72Enabled),
     /* 16429 */   // Combiner Rule #72: undef_to_int_zero; wip_match_opcode 'G_AND'
     /* 16429 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner34),
     /* 16432 */ // Label 169: @16432
     /* 16432 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(16443), // Rule ID 142 //
     /* 16437 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 16440 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_AND'
     /* 16440 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 16443 */ // Label 170: @16443
     /* 16443 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(16454), // Rule ID 162 //
     /* 16448 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule120Enabled),
     /* 16451 */   // Combiner Rule #120: narrow_binop_feeding_and; wip_match_opcode 'G_AND'
     /* 16451 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner68),
     /* 16454 */ // Label 171: @16454
     /* 16454 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(16465), // Rule ID 167 //
     /* 16459 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule125Enabled),
     /* 16462 */   // Combiner Rule #125: redundant_and; wip_match_opcode 'G_AND'
     /* 16462 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner72),
     /* 16465 */ // Label 172: @16465
     /* 16465 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(16476), // Rule ID 184 //
     /* 16470 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule142Enabled),
     /* 16473 */   // Combiner Rule #142: overlapping_and; wip_match_opcode 'G_AND'
     /* 16473 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner84),
     /* 16476 */ // Label 173: @16476
     /* 16476 */ GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(16487), // Rule ID 233 //
     /* 16481 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16484 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_AND'
     /* 16484 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16487 */ // Label 174: @16487
     /* 16487 */ GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(16498), // Rule ID 266 //
     /* 16492 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule173Enabled),
     /* 16495 */   // Combiner Rule #173: and_or_disjoint_mask; wip_match_opcode 'G_AND'
     /* 16495 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner110),
     /* 16498 */ // Label 175: @16498
     /* 16498 */ GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(16509), // Rule ID 278 //
     /* 16503 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16506 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_AND'
     /* 16506 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16509 */ // Label 176: @16509
     /* 16509 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(16520), // Rule ID 311 //
     /* 16514 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 16517 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_AND'
     /* 16517 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 16520 */ // Label 177: @16520
     /* 16520 */ GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(16531), // Rule ID 338 //
     /* 16525 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule193Enabled),
     /* 16528 */   // Combiner Rule #193: match_ands; wip_match_opcode 'G_AND'
     /* 16528 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner129),
     /* 16531 */ // Label 178: @16531
     /* 16531 */ GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(16629), // Rule ID 155 //
     /* 16536 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule113Enabled),
     /* 16539 */   // MIs[0] root
     /* 16539 */   // No operand predicates
     /* 16539 */   // MIs[0] d1
     /* 16539 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16547 */   // MIs[1] p
     /* 16547 */   // No operand predicates
     /* 16547 */   // MIs[1] s1
     /* 16547 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16551 */   // MIs[1] Operand 3
     /* 16551 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16555 */   // MIs[0] d2
     /* 16555 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16559 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16563 */   // MIs[2] p
     /* 16563 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16568 */   // MIs[2] s2
     /* 16568 */   // No operand predicates
     /* 16568 */   // MIs[2] Operand 3
     /* 16568 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16572 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner5),
     /* 16576 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16578 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16581 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16594 */   // Combiner Rule #113: double_icmp_zero_and_combine
     /* 16594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16597 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16602 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16610 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16614 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16618 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16622 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16625 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16628 */   GIR_EraseRootFromParent_Done,
     /* 16629 */ // Label 179: @16629
     /* 16629 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(16666), // Rule ID 226 //
     /* 16634 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule163Enabled),
     /* 16637 */   // MIs[0] root
     /* 16637 */   // No operand predicates
     /* 16637 */   // MIs[0] shift
     /* 16637 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 16645 */   // MIs[1] x
     /* 16645 */   // No operand predicates
     /* 16645 */   // MIs[1] lsb
     /* 16645 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 16649 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16653 */   // MIs[2] imm1
     /* 16653 */   // No operand predicates
     /* 16653 */   // MIs[0] mask
     /* 16653 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 16657 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 16661 */   // MIs[3] imm2
     /* 16661 */   // No operand predicates
     /* 16661 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 16663 */   // Combiner Rule #163: bitfield_extract_from_and
     /* 16663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner101),
     /* 16666 */ // Label 180: @16666
     /* 16666 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(16690), // Rule ID 114 //
     /* 16671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 16674 */   // MIs[0] dst
     /* 16674 */   // No operand predicates
     /* 16674 */   // MIs[0] src
     /* 16674 */   // No operand predicates
     /* 16674 */   // MIs[0] src
     /* 16674 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16679 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16684 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[0]]
     /* 16684 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16689 */   GIR_EraseRootFromParent_Done,
     /* 16690 */ // Label 181: @16690
     /* 16690 */ GIM_Reject,
     /* 16691 */ // Label 9: @16691
     /* 16691 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(16702), // Rule ID 79 //
     /* 16696 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule73Enabled),
     /* 16699 */   // Combiner Rule #73: undef_to_negative_one; wip_match_opcode 'G_OR'
     /* 16699 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner35),
     /* 16702 */ // Label 182: @16702
     /* 16702 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(16713), // Rule ID 143 //
     /* 16707 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 16710 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_OR'
     /* 16710 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 16713 */ // Label 183: @16713
     /* 16713 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(16724), // Rule ID 169 //
     /* 16718 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule127Enabled),
     /* 16721 */   // Combiner Rule #127: redundant_or; wip_match_opcode 'G_OR'
     /* 16721 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner74),
     /* 16724 */ // Label 184: @16724
     /* 16724 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(16735), // Rule ID 210 //
     /* 16729 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule152Enabled),
     /* 16732 */   // Combiner Rule #152: load_or_combine; wip_match_opcode 'G_OR'
     /* 16732 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner94),
     /* 16735 */ // Label 185: @16735
     /* 16735 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(16746), // Rule ID 215 //
     /* 16740 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule154Enabled),
     /* 16743 */   // Combiner Rule #154: funnel_shift_from_or_shift; wip_match_opcode 'G_OR'
     /* 16743 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner96),
     /* 16746 */ // Label 186: @16746
     /* 16746 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(16757), // Rule ID 237 //
     /* 16751 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16754 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_OR'
     /* 16754 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16757 */ // Label 187: @16757
     /* 16757 */ GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(16768), // Rule ID 279 //
     /* 16762 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16765 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_OR'
     /* 16765 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 16768 */ // Label 188: @16768
     /* 16768 */ GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(16779), // Rule ID 312 //
     /* 16773 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 16776 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_OR'
     /* 16776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 16779 */ // Label 189: @16779
     /* 16779 */ GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(16790), // Rule ID 339 //
     /* 16784 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule194Enabled),
     /* 16787 */   // Combiner Rule #194: match_ors; wip_match_opcode 'G_OR'
     /* 16787 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner130),
     /* 16790 */ // Label 190: @16790
     /* 16790 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(16888), // Rule ID 156 //
     /* 16795 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule114Enabled),
     /* 16798 */   // MIs[0] root
     /* 16798 */   // No operand predicates
     /* 16798 */   // MIs[0] d1
     /* 16798 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 16802 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16806 */   // MIs[1] p
     /* 16806 */   // No operand predicates
     /* 16806 */   // MIs[1] s1
     /* 16806 */   GIM_RecordRegType, /*MI*/1, /*Op*/2, /*TempTypeIdx*/uint8_t(-1),
     /* 16810 */   // MIs[1] Operand 3
     /* 16810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 16814 */   // MIs[0] d2
     /* 16814 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 16818 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16822 */   // MIs[2] p
     /* 16822 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 16827 */   // MIs[2] s2
     /* 16827 */   // No operand predicates
     /* 16827 */   // MIs[2] Operand 3
     /* 16827 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/3, 0,
     /* 16831 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner6),
     /* 16835 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 16837 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/uint8_t(-1),
     /* 16840 */   GIR_BuildConstant, /*TempRegID*/1, /*Val*/GIMT_Encode8(0),
     /* 16850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/uint8_t(-1),
     /* 16853 */   // Combiner Rule #114: double_icmp_zero_or_combine
     /* 16853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_OR),
     /* 16856 */   GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16861 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 16865 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s2
     /* 16869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16873 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // root
     /* 16877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // p
     /* 16881 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/0,
     /* 16884 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 16887 */   GIR_EraseRootFromParent_Done,
     /* 16888 */ // Label 191: @16888
     /* 16888 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(16912), // Rule ID 115 //
     /* 16893 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule85Enabled),
     /* 16896 */   // MIs[0] dst
     /* 16896 */   // No operand predicates
     /* 16896 */   // MIs[0] src
     /* 16896 */   // No operand predicates
     /* 16896 */   // MIs[0] src
     /* 16896 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 16901 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16906 */   // Combiner Rule #85: binop_same_val @ [__binop_same_val_match_0[1]]
     /* 16906 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16911 */   GIR_EraseRootFromParent_Done,
     /* 16912 */ // Label 192: @16912
     /* 16912 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(16935), // Rule ID 106 //
     /* 16917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 16920 */   // MIs[0] dst
     /* 16920 */   // No operand predicates
     /* 16920 */   // MIs[0] lhs
     /* 16920 */   // No operand predicates
     /* 16920 */   // MIs[0] Operand 2
     /* 16920 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 16924 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16929 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[2]]
     /* 16929 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 16934 */   GIR_EraseRootFromParent_Done,
     /* 16935 */ // Label 193: @16935
     /* 16935 */ GIM_Reject,
     /* 16936 */ // Label 10: @16936
     /* 16936 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(16947), // Rule ID 96 //
     /* 16941 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule78Enabled),
     /* 16944 */   // Combiner Rule #78: propagate_undef_any_op; wip_match_opcode 'G_XOR'
     /* 16944 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner39),
     /* 16947 */ // Label 194: @16947
     /* 16947 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(16958), // Rule ID 144 //
     /* 16952 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule104Enabled),
     /* 16955 */   // Combiner Rule #104: hoist_logic_op_with_same_opcode_hands; wip_match_opcode 'G_XOR'
     /* 16955 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner55),
     /* 16958 */ // Label 195: @16958
     /* 16958 */ GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(16969), // Rule ID 174 //
     /* 16963 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule132Enabled),
     /* 16966 */   // Combiner Rule #132: not_cmp_fold; wip_match_opcode 'G_XOR'
     /* 16966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner79),
     /* 16969 */ // Label 196: @16969
     /* 16969 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(16980), // Rule ID 198 //
     /* 16974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule148Enabled),
     /* 16977 */   // Combiner Rule #148: xor_of_and_with_same_reg; wip_match_opcode 'G_XOR'
     /* 16977 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner90),
     /* 16980 */ // Label 197: @16980
     /* 16980 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(16991), // Rule ID 240 //
     /* 16985 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 16988 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_XOR'
     /* 16988 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 16991 */ // Label 198: @16991
     /* 16991 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(17002), // Rule ID 280 //
     /* 16996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 16999 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_XOR'
     /* 16999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 17002 */ // Label 199: @17002
     /* 17002 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(17013), // Rule ID 313 //
     /* 17007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 17010 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_XOR'
     /* 17010 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 17013 */ // Label 200: @17013
     /* 17013 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(17036), // Rule ID 107 //
     /* 17018 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 17021 */   // MIs[0] dst
     /* 17021 */   // No operand predicates
     /* 17021 */   // MIs[0] lhs
     /* 17021 */   // No operand predicates
     /* 17021 */   // MIs[0] Operand 2
     /* 17021 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 17025 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17030 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[3]]
     /* 17030 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17035 */   GIR_EraseRootFromParent_Done,
     /* 17036 */ // Label 201: @17036
     /* 17036 */ GIM_Reject,
     /* 17037 */ // Label 11: @17037
     /* 17037 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(17048), // Rule ID 140 //
     /* 17042 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule102Enabled),
     /* 17045 */   // Combiner Rule #102: extend_through_phis; wip_match_opcode 'G_PHI'
     /* 17045 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner53),
     /* 17048 */ // Label 202: @17048
     /* 17048 */ GIM_Reject,
     /* 17049 */ // Label 12: @17049
     /* 17049 */ GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(17060), // Rule ID 349 //
     /* 17054 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule204Enabled),
     /* 17057 */   // Combiner Rule #204: unmerge_anyext_build_vector; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17057 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner140),
     /* 17060 */ // Label 203: @17060
     /* 17060 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(17071), // Rule ID 350 //
     /* 17065 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule205Enabled),
     /* 17068 */   // Combiner Rule #205: unmerge_merge; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17068 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner141),
     /* 17071 */ // Label 204: @17071
     /* 17071 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(17082), // Rule ID 352 //
     /* 17076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule207Enabled),
     /* 17079 */   // Combiner Rule #207: unmerge_cst; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner143),
     /* 17082 */ // Label 205: @17082
     /* 17082 */ GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(17093), // Rule ID 353 //
     /* 17087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule208Enabled),
     /* 17090 */   // Combiner Rule #208: unmerge_undef; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner144),
     /* 17093 */ // Label 206: @17093
     /* 17093 */ GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(17104), // Rule ID 354 //
     /* 17098 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule209Enabled),
     /* 17101 */   // Combiner Rule #209: unmerge_dead_to_trunc; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17101 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner145),
     /* 17104 */ // Label 207: @17104
     /* 17104 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(17115), // Rule ID 355 //
     /* 17109 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule210Enabled),
     /* 17112 */   // Combiner Rule #210: unmerge_zext_to_zext; wip_match_opcode 'G_UNMERGE_VALUES'
     /* 17112 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner146),
     /* 17115 */ // Label 208: @17115
     /* 17115 */ GIM_Reject,
     /* 17116 */ // Label 13: @17116
     /* 17116 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(17127), // Rule ID 351 //
     /* 17121 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule206Enabled),
     /* 17124 */   // Combiner Rule #206: merge_unmerge; wip_match_opcode 'G_MERGE_VALUES'
     /* 17124 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner142),
     /* 17127 */ // Label 209: @17127
     /* 17127 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(17189),
     /* 17132 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 17135 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(17156), // Rule ID 356 //
     /* 17140 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule211Enabled),
     /* 17143 */     // MIs[0] root
     /* 17143 */     // No operand predicates
     /* 17143 */     // MIs[0] x
     /* 17143 */     // No operand predicates
     /* 17143 */     // MIs[0] undef
     /* 17143 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17153 */     // Combiner Rule #211: merge_of_x_and_undef
     /* 17153 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner147),
     /* 17156 */   // Label 211: @17156
     /* 17156 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(17188), // Rule ID 357 //
     /* 17161 */     GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule212Enabled),
     /* 17164 */     // MIs[0] root
     /* 17164 */     // No operand predicates
     /* 17164 */     // MIs[0] x
     /* 17164 */     // No operand predicates
     /* 17164 */     // MIs[0] zero
     /* 17164 */     GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 17168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17172 */     // MIs[1] Operand 1
     /* 17172 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/1, GIMT_Encode8(0),
     /* 17183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17185 */     // Combiner Rule #212: merge_of_x_and_zero
     /* 17185 */     GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner148),
     /* 17188 */   // Label 212: @17188
     /* 17188 */   GIM_Reject,
     /* 17189 */ // Label 210: @17189
     /* 17189 */ GIM_Reject,
     /* 17190 */ // Label 14: @17190
     /* 17190 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(17201), // Rule ID 69 //
     /* 17195 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule67Enabled),
     /* 17198 */   // Combiner Rule #67: extract_all_elts_from_build_vector; wip_match_opcode 'G_BUILD_VECTOR'
     /* 17198 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner29),
     /* 17201 */ // Label 213: @17201
     /* 17201 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(17212), // Rule ID 98 //
     /* 17206 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 17209 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_BUILD_VECTOR'
     /* 17209 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 17212 */ // Label 214: @17212
     /* 17212 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(17223), // Rule ID 133 //
     /* 17217 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 17220 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR'
     /* 17220 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 17223 */ // Label 215: @17223
     /* 17223 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(17237), // Rule ID 348 //
     /* 17228 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule203Enabled),
     /* 17231 */   GIM_CheckNumOperandsGE, /*MI*/0, /*Expected*/2,
     /* 17234 */   // MIs[0] dst
     /* 17234 */   // No operand predicates
     /* 17234 */   // MIs[0] unused
     /* 17234 */   // No operand predicates
     /* 17234 */   // Combiner Rule #203: combine_use_vector_truncate
     /* 17234 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner139),
     /* 17237 */ // Label 216: @17237
     /* 17237 */ GIM_Reject,
     /* 17238 */ // Label 15: @17238
     /* 17238 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(17249), // Rule ID 132 //
     /* 17243 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule95Enabled),
     /* 17246 */   // Combiner Rule #95: buildvector_identity_fold; wip_match_opcode 'G_BUILD_VECTOR_TRUNC'
     /* 17246 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner49),
     /* 17249 */ // Label 217: @17249
     /* 17249 */ GIM_Reject,
     /* 17250 */ // Label 16: @17250
     /* 17250 */ GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(17261), // Rule ID 341 //
     /* 17255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule196Enabled),
     /* 17258 */   // Combiner Rule #196: combine_concat_vector; wip_match_opcode 'G_CONCAT_VECTORS'
     /* 17258 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner132),
     /* 17261 */ // Label 218: @17261
     /* 17261 */ GIM_Reject,
     /* 17262 */ // Label 17: @17262
     /* 17262 */ GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(17283), // Rule ID 125 //
     /* 17267 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule89Enabled),
     /* 17270 */   // MIs[0] dst
     /* 17270 */   // No operand predicates
     /* 17270 */   // MIs[0] t
     /* 17270 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17274 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTTOPTR),
     /* 17278 */   // MIs[1] ptr
     /* 17278 */   // No operand predicates
     /* 17278 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17280 */   // Combiner Rule #89: i2p_to_p2i
     /* 17280 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner47),
     /* 17283 */ // Label 219: @17283
     /* 17283 */ GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(17304), // Rule ID 90 //
     /* 17288 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 17291 */   // MIs[0] dst
     /* 17291 */   // No operand predicates
     /* 17291 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17291 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17301 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[3]]
     /* 17301 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 17304 */ // Label 220: @17304
     /* 17304 */ GIM_Reject,
     /* 17305 */ // Label 18: @17305
     /* 17305 */ GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(17316), // Rule ID 124 //
     /* 17310 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule88Enabled),
     /* 17313 */   // Combiner Rule #88: p2i_to_i2p; wip_match_opcode 'G_INTTOPTR'
     /* 17313 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner46),
     /* 17316 */ // Label 221: @17316
     /* 17316 */ GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(17337), // Rule ID 91 //
     /* 17321 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 17324 */   // MIs[0] dst
     /* 17324 */   // No operand predicates
     /* 17324 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17324 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17334 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[4]]
     /* 17334 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 17337 */ // Label 222: @17337
     /* 17337 */ GIM_Reject,
     /* 17338 */ // Label 19: @17338
     /* 17338 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(17359), // Rule ID 136 //
     /* 17343 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule98Enabled),
     /* 17346 */   // MIs[0] dst
     /* 17346 */   // No operand predicates
     /* 17346 */   // MIs[0] src1
     /* 17346 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17350 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 17354 */   // MIs[1] src0
     /* 17354 */   // No operand predicates
     /* 17354 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17356 */   // Combiner Rule #98: bitcast_bitcast_fold
     /* 17356 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 17359 */ // Label 223: @17359
     /* 17359 */ GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(17380), // Rule ID 88 //
     /* 17364 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 17367 */   // MIs[0] dst
     /* 17367 */   // No operand predicates
     /* 17367 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17367 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17375 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17377 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[1]]
     /* 17377 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 17380 */ // Label 224: @17380
     /* 17380 */ GIM_Reject,
     /* 17381 */ // Label 20: @17381
     /* 17381 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(17410), // Rule ID 18 //
     /* 17386 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 17389 */   // MIs[0] dst
     /* 17389 */   // No operand predicates
     /* 17389 */   // MIs[0] src
     /* 17389 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FREEZE),
     /* 17397 */   // MIs[1] __idempotent_prop_match_0.x
     /* 17397 */   // No operand predicates
     /* 17397 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17402 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17404 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[0]]
     /* 17404 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17409 */   GIR_EraseRootFromParent_Done,
     /* 17410 */ // Label 225: @17410
     /* 17410 */ GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(17433), // Rule ID 43 //
     /* 17415 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule41Enabled),
     /* 17418 */   // MIs[0] root
     /* 17418 */   // No operand predicates
     /* 17418 */   // MIs[0] src
     /* 17418 */   // No operand predicates
     /* 17418 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner1),
     /* 17422 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17427 */   // Combiner Rule #41: freeze_of_non_undef_non_poison
     /* 17427 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 17432 */   GIR_EraseRootFromParent_Done,
     /* 17433 */ // Label 226: @17433
     /* 17433 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(17444), // Rule ID 44 //
     /* 17438 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule42Enabled),
     /* 17441 */   // MIs[0] dst
     /* 17441 */   // No operand predicates
     /* 17441 */   // MIs[0] src
     /* 17441 */   // No operand predicates
     /* 17441 */   // Combiner Rule #42: push_freeze_to_prevent_poison_from_propagating
     /* 17441 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner19),
     /* 17444 */ // Label 227: @17444
     /* 17444 */ GIM_Reject,
     /* 17445 */ // Label 21: @17445
     /* 17445 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(17456), // Rule ID 70 //
     /* 17450 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 17453 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_LOAD'
     /* 17453 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 17456 */ // Label 228: @17456
     /* 17456 */ GIM_Reject,
     /* 17457 */ // Label 22: @17457
     /* 17457 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(17468), // Rule ID 71 //
     /* 17462 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 17465 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_SEXTLOAD'
     /* 17465 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 17468 */ // Label 229: @17468
     /* 17468 */ GIM_Reject,
     /* 17469 */ // Label 23: @17469
     /* 17469 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(17480), // Rule ID 72 //
     /* 17474 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule68Enabled),
     /* 17477 */   // Combiner Rule #68: extending_loads; wip_match_opcode 'G_ZEXTLOAD'
     /* 17477 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner30),
     /* 17480 */ // Label 230: @17480
     /* 17480 */ GIM_Reject,
     /* 17481 */ // Label 24: @17481
     /* 17481 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(17492), // Rule ID 100 //
     /* 17486 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule81Enabled),
     /* 17489 */   // Combiner Rule #81: erase_undef_store; wip_match_opcode 'G_STORE'
     /* 17489 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner42),
     /* 17492 */ // Label 231: @17492
     /* 17492 */ GIM_Reject,
     /* 17493 */ // Label 25: @17493
     /* 17493 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(17504), // Rule ID 373 //
     /* 17498 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 17501 */   // Combiner Rule #222: rcp_sqrt_to_rsq; wip_match_opcode 'G_INTRINSIC'
     /* 17501 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner158),
     /* 17504 */ // Label 232: @17504
     /* 17504 */ GIM_Reject,
     /* 17505 */ // Label 26: @17505
     /* 17505 */ GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(17516), // Rule ID 126 //
     /* 17510 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule90Enabled),
     /* 17513 */   // Combiner Rule #90: anyext_trunc_fold; wip_match_opcode 'G_ANYEXT'
     /* 17513 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner48),
     /* 17516 */ // Label 233: @17516
     /* 17516 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(17527), // Rule ID 257 //
     /* 17521 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 17524 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ANYEXT'
     /* 17524 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 17527 */ // Label 234: @17527
     /* 17527 */ GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(17548), // Rule ID 57 //
     /* 17532 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule55Enabled),
     /* 17535 */   // MIs[0] root
     /* 17535 */   // No operand predicates
     /* 17535 */   // MIs[0] select
     /* 17535 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17543 */   // MIs[1] cond
     /* 17543 */   // No operand predicates
     /* 17543 */   // MIs[1] true
     /* 17543 */   // No operand predicates
     /* 17543 */   // MIs[1] false
     /* 17543 */   // No operand predicates
     /* 17543 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17545 */   // Combiner Rule #55: select_of_anyext
     /* 17545 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 17548 */ // Label 235: @17548
     /* 17548 */ GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(17569), // Rule ID 52 //
     /* 17553 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule50Enabled),
     /* 17556 */   // MIs[0] root
     /* 17556 */   // No operand predicates
     /* 17556 */   // MIs[0] second
     /* 17556 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17560 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17564 */   // MIs[1] src
     /* 17564 */   // No operand predicates
     /* 17564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17566 */   // Combiner Rule #50: anyext_of_anyext
     /* 17566 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17569 */ // Label 236: @17569
     /* 17569 */ GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(17590), // Rule ID 54 //
     /* 17574 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule52Enabled),
     /* 17577 */   // MIs[0] root
     /* 17577 */   // No operand predicates
     /* 17577 */   // MIs[0] second
     /* 17577 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17581 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17585 */   // MIs[1] src
     /* 17585 */   // No operand predicates
     /* 17585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17587 */   // Combiner Rule #52: anyext_of_sext
     /* 17587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17590 */ // Label 237: @17590
     /* 17590 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(17611), // Rule ID 53 //
     /* 17595 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule51Enabled),
     /* 17598 */   // MIs[0] root
     /* 17598 */   // No operand predicates
     /* 17598 */   // MIs[0] second
     /* 17598 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17602 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17606 */   // MIs[1] src
     /* 17606 */   // No operand predicates
     /* 17606 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17608 */   // Combiner Rule #51: anyext_of_zext
     /* 17608 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 17611 */ // Label 238: @17611
     /* 17611 */ GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(17632), // Rule ID 89 //
     /* 17616 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 17619 */   // MIs[0] dst
     /* 17619 */   // No operand predicates
     /* 17619 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17619 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17629 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[2]]
     /* 17629 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 17632 */ // Label 239: @17632
     /* 17632 */ GIM_Reject,
     /* 17633 */ // Label 27: @17633
     /* 17633 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(17644), // Rule ID 134 //
     /* 17638 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule96Enabled),
     /* 17641 */   // Combiner Rule #96: trunc_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17641 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner50),
     /* 17644 */ // Label 240: @17644
     /* 17644 */ GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(17655), // Rule ID 135 //
     /* 17649 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule97Enabled),
     /* 17652 */   // Combiner Rule #97: trunc_lshr_buildvector_fold; wip_match_opcode 'G_TRUNC'
     /* 17652 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner51),
     /* 17655 */ // Label 241: @17655
     /* 17655 */ GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(17666), // Rule ID 173 //
     /* 17660 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule131Enabled),
     /* 17663 */   // Combiner Rule #131: trunc_shift; wip_match_opcode 'G_TRUNC'
     /* 17663 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner78),
     /* 17666 */ // Label 242: @17666
     /* 17666 */ GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(17687), // Rule ID 58 //
     /* 17671 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule56Enabled),
     /* 17674 */   // MIs[0] root
     /* 17674 */   // No operand predicates
     /* 17674 */   // MIs[0] select
     /* 17674 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 17682 */   // MIs[1] cond
     /* 17682 */   // No operand predicates
     /* 17682 */   // MIs[1] true
     /* 17682 */   // No operand predicates
     /* 17682 */   // MIs[1] false
     /* 17682 */   // No operand predicates
     /* 17682 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17684 */   // Combiner Rule #56: select_of_truncate
     /* 17684 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 17687 */ // Label 243: @17687
     /* 17687 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(17716), // Rule ID 60 //
     /* 17692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule58Enabled),
     /* 17695 */   // MIs[0] root
     /* 17695 */   // No operand predicates
     /* 17695 */   // MIs[0] binop
     /* 17695 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 17703 */   // MIs[1] x
     /* 17703 */   // No operand predicates
     /* 17703 */   // MIs[1] const
     /* 17703 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17707 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17711 */   // MIs[2] imm
     /* 17711 */   // No operand predicates
     /* 17711 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17713 */   // Combiner Rule #58: narrow_binop_add
     /* 17713 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17716 */ // Label 244: @17716
     /* 17716 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(17745), // Rule ID 63 //
     /* 17721 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule61Enabled),
     /* 17724 */   // MIs[0] root
     /* 17724 */   // No operand predicates
     /* 17724 */   // MIs[0] binop
     /* 17724 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17728 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 17732 */   // MIs[1] x
     /* 17732 */   // No operand predicates
     /* 17732 */   // MIs[1] const
     /* 17732 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17736 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17740 */   // MIs[2] imm
     /* 17740 */   // No operand predicates
     /* 17740 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17742 */   // Combiner Rule #61: narrow_binop_and
     /* 17742 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17745 */ // Label 245: @17745
     /* 17745 */ GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(17774), // Rule ID 62 //
     /* 17750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule60Enabled),
     /* 17753 */   // MIs[0] root
     /* 17753 */   // No operand predicates
     /* 17753 */   // MIs[0] binop
     /* 17753 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17757 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 17761 */   // MIs[1] x
     /* 17761 */   // No operand predicates
     /* 17761 */   // MIs[1] const
     /* 17761 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17765 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17769 */   // MIs[2] imm
     /* 17769 */   // No operand predicates
     /* 17769 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17771 */   // Combiner Rule #60: narrow_binop_mul
     /* 17771 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17774 */ // Label 246: @17774
     /* 17774 */ GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(17803), // Rule ID 64 //
     /* 17779 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule62Enabled),
     /* 17782 */   // MIs[0] root
     /* 17782 */   // No operand predicates
     /* 17782 */   // MIs[0] binop
     /* 17782 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 17790 */   // MIs[1] x
     /* 17790 */   // No operand predicates
     /* 17790 */   // MIs[1] const
     /* 17790 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17794 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17798 */   // MIs[2] imm
     /* 17798 */   // No operand predicates
     /* 17798 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17800 */   // Combiner Rule #62: narrow_binop_or
     /* 17800 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17803 */ // Label 247: @17803
     /* 17803 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(17832), // Rule ID 61 //
     /* 17808 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule59Enabled),
     /* 17811 */   // MIs[0] root
     /* 17811 */   // No operand predicates
     /* 17811 */   // MIs[0] binop
     /* 17811 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 17819 */   // MIs[1] x
     /* 17819 */   // No operand predicates
     /* 17819 */   // MIs[1] const
     /* 17819 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17823 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17827 */   // MIs[2] imm
     /* 17827 */   // No operand predicates
     /* 17827 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17829 */   // Combiner Rule #59: narrow_binop_sub
     /* 17829 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17832 */ // Label 248: @17832
     /* 17832 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(17861), // Rule ID 65 //
     /* 17837 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule63Enabled),
     /* 17840 */   // MIs[0] root
     /* 17840 */   // No operand predicates
     /* 17840 */   // MIs[0] binop
     /* 17840 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17844 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 17848 */   // MIs[1] x
     /* 17848 */   // No operand predicates
     /* 17848 */   // MIs[1] const
     /* 17848 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 17852 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17856 */   // MIs[2] imm
     /* 17856 */   // No operand predicates
     /* 17856 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 17858 */   // Combiner Rule #63: narrow_binop_xor
     /* 17858 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner25),
     /* 17861 */ // Label 249: @17861
     /* 17861 */ GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(17882), // Rule ID 47 //
     /* 17866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule45Enabled),
     /* 17869 */   // MIs[0] root
     /* 17869 */   // No operand predicates
     /* 17869 */   // MIs[0] ext
     /* 17869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 17877 */   // MIs[1] src
     /* 17877 */   // No operand predicates
     /* 17877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17879 */   // Combiner Rule #45: truncate_of_anyext
     /* 17879 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17882 */ // Label 250: @17882
     /* 17882 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(17906), // Rule ID 59 //
     /* 17887 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule57Enabled),
     /* 17890 */   // MIs[0] root
     /* 17890 */   // No operand predicates
     /* 17890 */   // MIs[0] bv
     /* 17890 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 17898 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 17901 */   // MIs[1] unused
     /* 17901 */   // No operand predicates
     /* 17901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17903 */   // Combiner Rule #57: buildvector_of_truncate
     /* 17903 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner24),
     /* 17906 */ // Label 251: @17906
     /* 17906 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(17927), // Rule ID 46 //
     /* 17911 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule44Enabled),
     /* 17914 */   // MIs[0] root
     /* 17914 */   // No operand predicates
     /* 17914 */   // MIs[0] ext
     /* 17914 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 17922 */   // MIs[1] src
     /* 17922 */   // No operand predicates
     /* 17922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17924 */   // Combiner Rule #44: truncate_of_sext
     /* 17924 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17927 */ // Label 252: @17927
     /* 17927 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(17948), // Rule ID 45 //
     /* 17932 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule43Enabled),
     /* 17935 */   // MIs[0] root
     /* 17935 */   // No operand predicates
     /* 17935 */   // MIs[0] ext
     /* 17935 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 17943 */   // MIs[1] src
     /* 17943 */   // No operand predicates
     /* 17943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17945 */   // Combiner Rule #43: truncate_of_zext
     /* 17945 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner20),
     /* 17948 */ // Label 253: @17948
     /* 17948 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(17969), // Rule ID 87 //
     /* 17953 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 17956 */   // MIs[0] dst
     /* 17956 */   // No operand predicates
     /* 17956 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 17956 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 17964 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17966 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[0]]
     /* 17966 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 17969 */ // Label 254: @17969
     /* 17969 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(17990), // Rule ID 66 //
     /* 17974 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule64Enabled),
     /* 17977 */   // MIs[0] root
     /* 17977 */   // No operand predicates
     /* 17977 */   // MIs[0] int
     /* 17977 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 17981 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 17985 */   // MIs[1] imm
     /* 17985 */   // No operand predicates
     /* 17985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17987 */   // Combiner Rule #64: integer_of_truncate
     /* 17987 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner26),
     /* 17990 */ // Label 255: @17990
     /* 17990 */ GIM_Reject,
     /* 17991 */ // Label 28: @17991
     /* 17991 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(18002), // Rule ID 256 //
     /* 17996 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 17999 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_SEXT'
     /* 17999 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 18002 */ // Label 256: @18002
     /* 18002 */ GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(18023), // Rule ID 51 //
     /* 18007 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule49Enabled),
     /* 18010 */   // MIs[0] root
     /* 18010 */   // No operand predicates
     /* 18010 */   // MIs[0] second
     /* 18010 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 18018 */   // MIs[1] src
     /* 18018 */   // No operand predicates
     /* 18018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18020 */   // Combiner Rule #49: sext_of_anyext
     /* 18020 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 18023 */ // Label 257: @18023
     /* 18023 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(18044), // Rule ID 50 //
     /* 18028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule48Enabled),
     /* 18031 */   // MIs[0] root
     /* 18031 */   // No operand predicates
     /* 18031 */   // MIs[0] second
     /* 18031 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18035 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 18039 */   // MIs[1] src
     /* 18039 */   // No operand predicates
     /* 18039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18041 */   // Combiner Rule #48: sext_of_sext
     /* 18041 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 18044 */ // Label 258: @18044
     /* 18044 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(18065), // Rule ID 342 //
     /* 18049 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule197Enabled),
     /* 18052 */   // MIs[0] root
     /* 18052 */   // No operand predicates
     /* 18052 */   // MIs[0] src
     /* 18052 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 18060 */   // MIs[1] x
     /* 18060 */   // No operand predicates
     /* 18060 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18062 */   // Combiner Rule #197: sext_trunc
     /* 18062 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner133),
     /* 18065 */ // Label 259: @18065
     /* 18065 */ GIM_Reject,
     /* 18066 */ // Label 29: @18066
     /* 18066 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(18077), // Rule ID 160 //
     /* 18071 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule118Enabled),
     /* 18074 */   // Combiner Rule #118: sext_inreg_of_load; wip_match_opcode 'G_SEXT_INREG'
     /* 18074 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner66),
     /* 18077 */ // Label 260: @18077
     /* 18077 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(18088), // Rule ID 168 //
     /* 18082 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule126Enabled),
     /* 18085 */   // Combiner Rule #126: redundant_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 18085 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner73),
     /* 18088 */ // Label 261: @18088
     /* 18088 */ GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(18099), // Rule ID 225 //
     /* 18093 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule162Enabled),
     /* 18096 */   // Combiner Rule #162: bitfield_extract_from_sext_inreg; wip_match_opcode 'G_SEXT_INREG'
     /* 18096 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner100),
     /* 18099 */ // Label 262: @18099
     /* 18099 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(18110), // Rule ID 376 //
     /* 18104 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule224Enabled),
     /* 18107 */   // Combiner Rule #224: sign_extension_in_reg; wip_match_opcode 'G_SEXT_INREG'
     /* 18107 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner160),
     /* 18110 */ // Label 263: @18110
     /* 18110 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(18131), // Rule ID 55 //
     /* 18115 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule53Enabled),
     /* 18118 */   // MIs[0] dst
     /* 18118 */   // No operand predicates
     /* 18118 */   // MIs[0] x
     /* 18118 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 18126 */   // MIs[1] src
     /* 18126 */   // No operand predicates
     /* 18126 */   // MIs[1] a
     /* 18126 */   // No operand predicates
     /* 18126 */   // MIs[0] b
     /* 18126 */   // No operand predicates
     /* 18126 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18128 */   // Combiner Rule #53: sext_inreg_of_sext_inreg
     /* 18128 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner22),
     /* 18131 */ // Label 264: @18131
     /* 18131 */ GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(18142), // Rule ID 172 //
     /* 18136 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule130Enabled),
     /* 18139 */   // MIs[0] dst
     /* 18139 */   // No operand predicates
     /* 18139 */   // MIs[0] src
     /* 18139 */   // No operand predicates
     /* 18139 */   // MIs[0] imm
     /* 18139 */   // No operand predicates
     /* 18139 */   // Combiner Rule #130: sext_inreg_to_zext_inreg
     /* 18139 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner77),
     /* 18142 */ // Label 265: @18142
     /* 18142 */ GIM_Reject,
     /* 18143 */ // Label 30: @18143
     /* 18143 */ GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(18154), // Rule ID 171 //
     /* 18148 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule129Enabled),
     /* 18151 */   // Combiner Rule #129: zext_trunc_fold; wip_match_opcode 'G_ZEXT'
     /* 18151 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner76),
     /* 18154 */ // Label 266: @18154
     /* 18154 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(18165), // Rule ID 255 //
     /* 18159 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule169Enabled),
     /* 18162 */   // Combiner Rule #169: constant_fold_cast_op; wip_match_opcode 'G_ZEXT'
     /* 18162 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner107),
     /* 18165 */ // Label 267: @18165
     /* 18165 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(18186), // Rule ID 56 //
     /* 18170 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule54Enabled),
     /* 18173 */   // MIs[0] root
     /* 18173 */   // No operand predicates
     /* 18173 */   // MIs[0] select
     /* 18173 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 18181 */   // MIs[1] cond
     /* 18181 */   // No operand predicates
     /* 18181 */   // MIs[1] true
     /* 18181 */   // No operand predicates
     /* 18181 */   // MIs[1] false
     /* 18181 */   // No operand predicates
     /* 18181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18183 */   // Combiner Rule #54: select_of_zext
     /* 18183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner23),
     /* 18186 */ // Label 268: @18186
     /* 18186 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(18207), // Rule ID 49 //
     /* 18191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule47Enabled),
     /* 18194 */   // MIs[0] root
     /* 18194 */   // No operand predicates
     /* 18194 */   // MIs[0] second
     /* 18194 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 18202 */   // MIs[1] src
     /* 18202 */   // No operand predicates
     /* 18202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18204 */   // Combiner Rule #47: zext_of_anyext
     /* 18204 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 18207 */ // Label 269: @18207
     /* 18207 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(18234), // Rule ID 343 //
     /* 18212 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule198Enabled),
     /* 18215 */   // MIs[0] root
     /* 18215 */   // No operand predicates
     /* 18215 */   // MIs[0] src
     /* 18215 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18219 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 18223 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::NoUWrap),
     /* 18229 */   // MIs[1] x
     /* 18229 */   // No operand predicates
     /* 18229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18231 */   // Combiner Rule #198: zext_trunc
     /* 18231 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner134),
     /* 18234 */ // Label 270: @18234
     /* 18234 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(18255), // Rule ID 48 //
     /* 18239 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule46Enabled),
     /* 18242 */   // MIs[0] root
     /* 18242 */   // No operand predicates
     /* 18242 */   // MIs[0] second
     /* 18242 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 18250 */   // MIs[1] src
     /* 18250 */   // No operand predicates
     /* 18250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18252 */   // Combiner Rule #46: zext_of_zext
     /* 18252 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner21),
     /* 18255 */ // Label 271: @18255
     /* 18255 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(18272), // Rule ID 344 //
     /* 18260 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule199Enabled),
     /* 18263 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NonNeg),
     /* 18269 */   // MIs[0] root
     /* 18269 */   // No operand predicates
     /* 18269 */   // MIs[0] x
     /* 18269 */   // No operand predicates
     /* 18269 */   // Combiner Rule #199: nneg_zext
     /* 18269 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner135),
     /* 18272 */ // Label 272: @18272
     /* 18272 */ GIM_Reject,
     /* 18273 */ // Label 31: @18273
     /* 18273 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(18284), // Rule ID 80 //
     /* 18278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule74Enabled),
     /* 18281 */   // Combiner Rule #74: binop_left_undef_to_zero; wip_match_opcode 'G_SHL'
     /* 18281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 18284 */ // Label 273: @18284
     /* 18284 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(18295), // Rule ID 83 //
     /* 18289 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 18292 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_SHL'
     /* 18292 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 18295 */ // Label 274: @18295
     /* 18295 */ GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(18306), // Rule ID 116 //
     /* 18300 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 18303 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_SHL'
     /* 18303 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 18306 */ // Label 275: @18306
     /* 18306 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(18317), // Rule ID 200 //
     /* 18311 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 18314 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SHL'
     /* 18314 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18317 */ // Label 276: @18317
     /* 18317 */ GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(18328), // Rule ID 205 //
     /* 18322 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 18325 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SHL'
     /* 18325 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 18328 */ // Label 277: @18328
     /* 18328 */ GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(18339), // Rule ID 224 //
     /* 18333 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule161Enabled),
     /* 18336 */   // Combiner Rule #161: commute_shift; wip_match_opcode 'G_SHL'
     /* 18336 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner99),
     /* 18339 */ // Label 278: @18339
     /* 18339 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(18350), // Rule ID 238 //
     /* 18344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 18347 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SHL'
     /* 18347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 18350 */ // Label 279: @18350
     /* 18350 */ GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(18361), // Rule ID 287 //
     /* 18355 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 18358 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SHL'
     /* 18358 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 18361 */ // Label 280: @18361
     /* 18361 */ GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(18396), // Rule ID 41 //
     /* 18366 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule39Enabled),
     /* 18369 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::NoSWrap),
     /* 18375 */   // MIs[0] root
     /* 18375 */   // No operand predicates
     /* 18375 */   // MIs[0] left
     /* 18375 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VSCALE),
     /* 18383 */   // MIs[1] imm
     /* 18383 */   // No operand predicates
     /* 18383 */   // MIs[0] x
     /* 18383 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 18387 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18391 */   // MIs[2] imm1
     /* 18391 */   // No operand predicates
     /* 18391 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 18393 */   // Combiner Rule #39: shl_of_vscale
     /* 18393 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner17),
     /* 18396 */ // Label 281: @18396
     /* 18396 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(18419), // Rule ID 108 //
     /* 18401 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 18404 */   // MIs[0] dst
     /* 18404 */   // No operand predicates
     /* 18404 */   // MIs[0] lhs
     /* 18404 */   // No operand predicates
     /* 18404 */   // MIs[0] Operand 2
     /* 18404 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18408 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18413 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[4]]
     /* 18413 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18418 */   GIR_EraseRootFromParent_Done,
     /* 18419 */ // Label 282: @18419
     /* 18419 */ GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(18430), // Rule ID 145 //
     /* 18424 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 18427 */   // MIs[0] root
     /* 18427 */   // No operand predicates
     /* 18427 */   // MIs[0] mi.shifted
     /* 18427 */   // No operand predicates
     /* 18427 */   // MIs[0] mi.amt
     /* 18427 */   // No operand predicates
     /* 18427 */   // Combiner Rule #105: shifts_too_big @ [mi[0]]
     /* 18427 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 18430 */ // Label 283: @18430
     /* 18430 */ GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(18441), // Rule ID 161 //
     /* 18435 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule119Enabled),
     /* 18438 */   // MIs[0] dst
     /* 18438 */   // No operand predicates
     /* 18438 */   // MIs[0] src0
     /* 18438 */   // No operand predicates
     /* 18438 */   // MIs[0] src1
     /* 18438 */   // No operand predicates
     /* 18438 */   // Combiner Rule #119: reduce_shl_of_extend
     /* 18438 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner67),
     /* 18441 */ // Label 284: @18441
     /* 18441 */ GIM_Reject,
     /* 18442 */ // Label 32: @18442
     /* 18442 */ GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(18453), // Rule ID 85 //
     /* 18447 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 18450 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_LSHR'
     /* 18450 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 18453 */ // Label 285: @18453
     /* 18453 */ GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(18464), // Rule ID 117 //
     /* 18458 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 18461 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_LSHR'
     /* 18461 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 18464 */ // Label 286: @18464
     /* 18464 */ GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(18475), // Rule ID 202 //
     /* 18469 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 18472 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_LSHR'
     /* 18472 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18475 */ // Label 287: @18475
     /* 18475 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(18486), // Rule ID 207 //
     /* 18480 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 18483 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_LSHR'
     /* 18483 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 18486 */ // Label 288: @18486
     /* 18486 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(18497), // Rule ID 228 //
     /* 18491 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18494 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_LSHR'
     /* 18494 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18497 */ // Label 289: @18497
     /* 18497 */ GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(18508), // Rule ID 230 //
     /* 18502 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 18505 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_LSHR'
     /* 18505 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18508 */ // Label 290: @18508
     /* 18508 */ GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(18519), // Rule ID 235 //
     /* 18513 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 18516 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_LSHR'
     /* 18516 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 18519 */ // Label 291: @18519
     /* 18519 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(18530), // Rule ID 285 //
     /* 18524 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 18527 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_LSHR'
     /* 18527 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 18530 */ // Label 292: @18530
     /* 18530 */ GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(18553), // Rule ID 110 //
     /* 18535 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 18538 */   // MIs[0] dst
     /* 18538 */   // No operand predicates
     /* 18538 */   // MIs[0] lhs
     /* 18538 */   // No operand predicates
     /* 18538 */   // MIs[0] Operand 2
     /* 18538 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18542 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18547 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[6]]
     /* 18547 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18552 */   GIR_EraseRootFromParent_Done,
     /* 18553 */ // Label 293: @18553
     /* 18553 */ GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(18564), // Rule ID 147 //
     /* 18558 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 18561 */   // MIs[0] root
     /* 18561 */   // No operand predicates
     /* 18561 */   // MIs[0] mi.shifted
     /* 18561 */   // No operand predicates
     /* 18561 */   // MIs[0] mi.amt
     /* 18561 */   // No operand predicates
     /* 18561 */   // Combiner Rule #105: shifts_too_big @ [mi[2]]
     /* 18561 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 18564 */ // Label 294: @18564
     /* 18564 */ GIM_Reject,
     /* 18565 */ // Label 33: @18565
     /* 18565 */ GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(18576), // Rule ID 84 //
     /* 18570 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule75Enabled),
     /* 18573 */   // Combiner Rule #75: binop_right_undef_to_undef; wip_match_opcode 'G_ASHR'
     /* 18573 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner37),
     /* 18576 */ // Label 295: @18576
     /* 18576 */ GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(18587), // Rule ID 118 //
     /* 18581 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule86Enabled),
     /* 18584 */   // Combiner Rule #86: binop_left_to_zero; wip_match_opcode 'G_ASHR'
     /* 18584 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner45),
     /* 18587 */ // Label 296: @18587
     /* 18587 */ GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(18598), // Rule ID 158 //
     /* 18592 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule116Enabled),
     /* 18595 */   // Combiner Rule #116: shl_ashr_to_sext_inreg; wip_match_opcode 'G_ASHR'
     /* 18595 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner65),
     /* 18598 */ // Label 297: @18598
     /* 18598 */ GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(18609), // Rule ID 201 //
     /* 18603 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 18606 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_ASHR'
     /* 18606 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 18609 */ // Label 298: @18609
     /* 18609 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(18620), // Rule ID 206 //
     /* 18614 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 18617 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_ASHR'
     /* 18617 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 18620 */ // Label 299: @18620
     /* 18620 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(18631), // Rule ID 227 //
     /* 18625 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule164Enabled),
     /* 18628 */   // Combiner Rule #164: bitfield_extract_from_shr; wip_match_opcode 'G_ASHR'
     /* 18628 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner102),
     /* 18631 */ // Label 300: @18631
     /* 18631 */ GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(18642), // Rule ID 229 //
     /* 18636 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule165Enabled),
     /* 18639 */   // Combiner Rule #165: bitfield_extract_from_shr_and; wip_match_opcode 'G_ASHR'
     /* 18639 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner103),
     /* 18642 */ // Label 301: @18642
     /* 18642 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(18653), // Rule ID 234 //
     /* 18647 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 18650 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_ASHR'
     /* 18650 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 18653 */ // Label 302: @18653
     /* 18653 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(18664), // Rule ID 286 //
     /* 18658 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 18661 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_ASHR'
     /* 18661 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 18664 */ // Label 303: @18664
     /* 18664 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(18687), // Rule ID 109 //
     /* 18669 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 18672 */   // MIs[0] dst
     /* 18672 */   // No operand predicates
     /* 18672 */   // MIs[0] lhs
     /* 18672 */   // No operand predicates
     /* 18672 */   // MIs[0] Operand 2
     /* 18672 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18676 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18681 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[5]]
     /* 18681 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18686 */   GIR_EraseRootFromParent_Done,
     /* 18687 */ // Label 304: @18687
     /* 18687 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(18698), // Rule ID 146 //
     /* 18692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule105Enabled),
     /* 18695 */   // MIs[0] root
     /* 18695 */   // No operand predicates
     /* 18695 */   // MIs[0] mi.shifted
     /* 18695 */   // No operand predicates
     /* 18695 */   // MIs[0] mi.amt
     /* 18695 */   // No operand predicates
     /* 18695 */   // Combiner Rule #105: shifts_too_big @ [mi[1]]
     /* 18695 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner56),
     /* 18698 */ // Label 305: @18698
     /* 18698 */ GIM_Reject,
     /* 18699 */ // Label 34: @18699
     /* 18699 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(18710), // Rule ID 216 //
     /* 18704 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 18707 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHL'
     /* 18707 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18710 */ // Label 306: @18710
     /* 18710 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(18721), // Rule ID 220 //
     /* 18715 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 18718 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHL'
     /* 18718 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 18721 */ // Label 307: @18721
     /* 18721 */ GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(18741), // Rule ID 219 //
     /* 18726 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule157Enabled),
     /* 18729 */   // MIs[0] x
     /* 18729 */   // No operand predicates
     /* 18729 */   // MIs[0] y
     /* 18729 */   // No operand predicates
     /* 18729 */   // MIs[0] z
     /* 18729 */   // No operand predicates
     /* 18729 */   // MIs[0] Operand 3
     /* 18729 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18733 */   // Combiner Rule #157: funnel_shift_left_zero
     /* 18733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18736 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18738 */   GIR_RootToRootCopy, /*OpIdx*/1, // y
     /* 18740 */   GIR_EraseRootFromParent_Done,
     /* 18741 */ // Label 308: @18741
     /* 18741 */ GIM_Reject,
     /* 18742 */ // Label 35: @18742
     /* 18742 */ GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(18753), // Rule ID 217 //
     /* 18747 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule155Enabled),
     /* 18750 */   // Combiner Rule #155: funnel_shift_to_rotate; wip_match_opcode 'G_FSHR'
     /* 18750 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner97),
     /* 18753 */ // Label 309: @18753
     /* 18753 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(18764), // Rule ID 221 //
     /* 18758 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule158Enabled),
     /* 18761 */   // Combiner Rule #158: funnel_shift_overshift; wip_match_opcode 'G_FSHR'
     /* 18761 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner98),
     /* 18764 */ // Label 310: @18764
     /* 18764 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(18784), // Rule ID 218 //
     /* 18769 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule156Enabled),
     /* 18772 */   // MIs[0] x
     /* 18772 */   // No operand predicates
     /* 18772 */   // MIs[0] y
     /* 18772 */   // No operand predicates
     /* 18772 */   // MIs[0] z
     /* 18772 */   // No operand predicates
     /* 18772 */   // MIs[0] Operand 3
     /* 18772 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 18776 */   // Combiner Rule #156: funnel_shift_right_zero
     /* 18776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 18779 */   GIR_RootToRootCopy, /*OpIdx*/0, // x
     /* 18781 */   GIR_RootToRootCopy, /*OpIdx*/2, // z
     /* 18783 */   GIR_EraseRootFromParent_Done,
     /* 18784 */ // Label 311: @18784
     /* 18784 */ GIM_Reject,
     /* 18785 */ // Label 36: @18785
     /* 18785 */ GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(18808), // Rule ID 113 //
     /* 18790 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 18793 */   // MIs[0] dst
     /* 18793 */   // No operand predicates
     /* 18793 */   // MIs[0] lhs
     /* 18793 */   // No operand predicates
     /* 18793 */   // MIs[0] Operand 2
     /* 18793 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18797 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18802 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[9]]
     /* 18802 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18807 */   GIR_EraseRootFromParent_Done,
     /* 18808 */ // Label 312: @18808
     /* 18808 */ GIM_Reject,
     /* 18809 */ // Label 37: @18809
     /* 18809 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(18832), // Rule ID 112 //
     /* 18814 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 18817 */   // MIs[0] dst
     /* 18817 */   // No operand predicates
     /* 18817 */   // MIs[0] lhs
     /* 18817 */   // No operand predicates
     /* 18817 */   // MIs[0] Operand 2
     /* 18817 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 18821 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18826 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[8]]
     /* 18826 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 18831 */   GIR_EraseRootFromParent_Done,
     /* 18832 */ // Label 313: @18832
     /* 18832 */ GIM_Reject,
     /* 18833 */ // Label 38: @18833
     /* 18833 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(18844), // Rule ID 153 //
     /* 18838 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule111Enabled),
     /* 18841 */   // Combiner Rule #111: icmp_to_true_false_known_bits; wip_match_opcode 'G_ICMP'
     /* 18841 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner62),
     /* 18844 */ // Label 314: @18844
     /* 18844 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(18855), // Rule ID 154 //
     /* 18849 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule112Enabled),
     /* 18852 */   // Combiner Rule #112: icmp_to_lhs_known_bits; wip_match_opcode 'G_ICMP'
     /* 18852 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner63),
     /* 18855 */ // Label 315: @18855
     /* 18855 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(18866), // Rule ID 157 //
     /* 18860 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule115Enabled),
     /* 18863 */   // Combiner Rule #115: redundant_binop_in_equality; wip_match_opcode 'G_ICMP'
     /* 18863 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner64),
     /* 18866 */ // Label 316: @18866
     /* 18866 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(18877), // Rule ID 151 //
     /* 18871 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule109Enabled),
     /* 18874 */   // MIs[0] root
     /* 18874 */   // No operand predicates
     /* 18874 */   // MIs[0] pred
     /* 18874 */   // No operand predicates
     /* 18874 */   // MIs[0] lhs
     /* 18874 */   // No operand predicates
     /* 18874 */   // MIs[0] rhs
     /* 18874 */   // No operand predicates
     /* 18874 */   // Combiner Rule #109: canonicalize_icmp
     /* 18874 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner60),
     /* 18877 */ // Label 317: @18877
     /* 18877 */ GIM_Reject,
     /* 18878 */ // Label 39: @18878
     /* 18878 */ GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(18889), // Rule ID 152 //
     /* 18883 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule110Enabled),
     /* 18886 */   // MIs[0] root
     /* 18886 */   // No operand predicates
     /* 18886 */   // MIs[0] pred
     /* 18886 */   // No operand predicates
     /* 18886 */   // MIs[0] lhs
     /* 18886 */   // No operand predicates
     /* 18886 */   // MIs[0] rhs
     /* 18886 */   // No operand predicates
     /* 18886 */   // Combiner Rule #110: canonicalize_fcmp
     /* 18886 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner61),
     /* 18889 */ // Label 318: @18889
     /* 18889 */ GIM_Reject,
     /* 18890 */ // Label 40: @18890
     /* 18890 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(18901), // Rule ID 103 //
     /* 18895 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule83Enabled),
     /* 18898 */   // Combiner Rule #83: select_same_val; wip_match_opcode 'G_SELECT'
     /* 18898 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner44),
     /* 18901 */ // Label 319: @18901
     /* 18901 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(18912), // Rule ID 164 //
     /* 18906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule122Enabled),
     /* 18909 */   // Combiner Rule #122: select_constant_cmp; wip_match_opcode 'G_SELECT'
     /* 18909 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner69),
     /* 18912 */ // Label 320: @18912
     /* 18912 */ GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(18923), // Rule ID 166 //
     /* 18917 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule124Enabled),
     /* 18920 */   // Combiner Rule #124: match_selects; wip_match_opcode 'G_SELECT'
     /* 18920 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner71),
     /* 18923 */ // Label 321: @18923
     /* 18923 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(18934), // Rule ID 307 //
     /* 18928 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule189Enabled),
     /* 18931 */   // Combiner Rule #189: select_to_minmax; wip_match_opcode 'G_SELECT'
     /* 18931 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner125),
     /* 18934 */ // Label 322: @18934
     /* 18934 */ GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(18961), // Rule ID 362 //
     /* 18939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFminFmaxLegacy),
     /* 18942 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule215Enabled),
     /* 18945 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18948 */   // MIs[0] cond
     /* 18948 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18952 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 18956 */   // MIs[1] pred
     /* 18956 */   // No operand predicates
     /* 18956 */   // MIs[1] lhs
     /* 18956 */   // No operand predicates
     /* 18956 */   // MIs[1] rhs
     /* 18956 */   // No operand predicates
     /* 18956 */   // MIs[0] true
     /* 18956 */   // No operand predicates
     /* 18956 */   // MIs[0] false
     /* 18956 */   // No operand predicates
     /* 18956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18958 */   // Combiner Rule #215: fcmp_select_to_fmin_fmax_legacy
     /* 18958 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner151),
     /* 18961 */ // Label 323: @18961
     /* 18961 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18982), // Rule ID 165 //
     /* 18966 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule123Enabled),
     /* 18969 */   // MIs[0] root
     /* 18969 */   // No operand predicates
     /* 18969 */   // MIs[0] tst
     /* 18969 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18973 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 18977 */   // MIs[1] tst1
     /* 18977 */   // No operand predicates
     /* 18977 */   // MIs[1] a
     /* 18977 */   // No operand predicates
     /* 18977 */   // MIs[1] b
     /* 18977 */   // No operand predicates
     /* 18977 */   // MIs[0] x
     /* 18977 */   // No operand predicates
     /* 18977 */   // MIs[0] y
     /* 18977 */   // No operand predicates
     /* 18977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18979 */   // Combiner Rule #123: select_to_iminmax
     /* 18979 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner70),
     /* 18982 */ // Label 324: @18982
     /* 18982 */ GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(19011), // Rule ID 163 //
     /* 18987 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule121Enabled),
     /* 18990 */   // MIs[0] dst
     /* 18990 */   // No operand predicates
     /* 18990 */   // MIs[0] undef
     /* 18990 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 18994 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 18998 */   // MIs[0] x
     /* 18998 */   // No operand predicates
     /* 18998 */   // MIs[0] y
     /* 18998 */   // No operand predicates
     /* 18998 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 19003 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19005 */   // Combiner Rule #121: select_undef_cmp
     /* 19005 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/3,
     /* 19010 */   GIR_EraseRootFromParent_Done,
     /* 19011 */ // Label 325: @19011
     /* 19011 */ GIM_Reject,
     /* 19012 */ // Label 41: @19012
     /* 19012 */ GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(19023), // Rule ID 318 //
     /* 19017 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19020 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDO'
     /* 19020 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19023 */ // Label 326: @19023
     /* 19023 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(19034), // Rule ID 359 //
     /* 19028 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 19031 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_UADDO'
     /* 19031 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 19034 */ // Label 327: @19034
     /* 19034 */ GIM_Reject,
     /* 19035 */ // Label 42: @19035
     /* 19035 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(19046), // Rule ID 189 //
     /* 19040 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19043 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_UADDE'
     /* 19043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19046 */ // Label 328: @19046
     /* 19046 */ GIM_Reject,
     /* 19047 */ // Label 43: @19047
     /* 19047 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(19058), // Rule ID 361 //
     /* 19052 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 19055 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_USUBO'
     /* 19055 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 19058 */ // Label 329: @19058
     /* 19058 */ GIM_Reject,
     /* 19059 */ // Label 44: @19059
     /* 19059 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(19070), // Rule ID 191 //
     /* 19064 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19067 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_USUBE'
     /* 19067 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19070 */ // Label 330: @19070
     /* 19070 */ GIM_Reject,
     /* 19071 */ // Label 45: @19071
     /* 19071 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(19082), // Rule ID 319 //
     /* 19076 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19079 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDO'
     /* 19079 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19082 */ // Label 331: @19082
     /* 19082 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(19093), // Rule ID 358 //
     /* 19087 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule213Enabled),
     /* 19090 */   // Combiner Rule #213: match_addos; wip_match_opcode 'G_SADDO'
     /* 19090 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner149),
     /* 19093 */ // Label 332: @19093
     /* 19093 */ GIM_Reject,
     /* 19094 */ // Label 46: @19094
     /* 19094 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(19105), // Rule ID 190 //
     /* 19099 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19102 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SADDE'
     /* 19102 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19105 */ // Label 333: @19105
     /* 19105 */ GIM_Reject,
     /* 19106 */ // Label 47: @19106
     /* 19106 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(19117), // Rule ID 360 //
     /* 19111 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule214Enabled),
     /* 19114 */   // Combiner Rule #214: match_subo_no_overflow; wip_match_opcode 'G_SSUBO'
     /* 19114 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner150),
     /* 19117 */ // Label 334: @19117
     /* 19117 */ GIM_Reject,
     /* 19118 */ // Label 48: @19118
     /* 19118 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(19129), // Rule ID 192 //
     /* 19123 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule145Enabled),
     /* 19126 */   // Combiner Rule #145: adde_to_addo; wip_match_opcode 'G_SSUBE'
     /* 19126 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner87),
     /* 19129 */ // Label 335: @19129
     /* 19129 */ GIM_Reject,
     /* 19130 */ // Label 49: @19130
     /* 19130 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19141), // Rule ID 185 //
     /* 19135 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 19138 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_UMULO'
     /* 19138 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 19141 */ // Label 336: @19141
     /* 19141 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19152), // Rule ID 187 //
     /* 19146 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19149 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_UMULO'
     /* 19149 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 19152 */ // Label 337: @19152
     /* 19152 */ GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19163), // Rule ID 320 //
     /* 19157 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19160 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULO'
     /* 19160 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19163 */ // Label 338: @19163
     /* 19163 */ GIM_Reject,
     /* 19164 */ // Label 50: @19164
     /* 19164 */ GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19175), // Rule ID 186 //
     /* 19169 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule143Enabled),
     /* 19172 */   // Combiner Rule #143: mulo_by_2; wip_match_opcode 'G_SMULO'
     /* 19172 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner85),
     /* 19175 */ // Label 339: @19175
     /* 19175 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19186), // Rule ID 188 //
     /* 19180 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule144Enabled),
     /* 19183 */   // Combiner Rule #144: mulo_by_0; wip_match_opcode 'G_SMULO'
     /* 19183 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner86),
     /* 19186 */ // Label 340: @19186
     /* 19186 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19197), // Rule ID 321 //
     /* 19191 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19194 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULO'
     /* 19194 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19197 */ // Label 341: @19197
     /* 19197 */ GIM_Reject,
     /* 19198 */ // Label 51: @19198
     /* 19198 */ GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19209), // Rule ID 259 //
     /* 19203 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule171Enabled),
     /* 19206 */   // Combiner Rule #171: mulh_to_lshr; wip_match_opcode 'G_UMULH'
     /* 19206 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner108),
     /* 19209 */ // Label 342: @19209
     /* 19209 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19220), // Rule ID 322 //
     /* 19214 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19217 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULH'
     /* 19217 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19220 */ // Label 343: @19220
     /* 19220 */ GIM_Reject,
     /* 19221 */ // Label 52: @19221
     /* 19221 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19232), // Rule ID 323 //
     /* 19226 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19229 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULH'
     /* 19229 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19232 */ // Label 344: @19232
     /* 19232 */ GIM_Reject,
     /* 19233 */ // Label 53: @19233
     /* 19233 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19244), // Rule ID 324 //
     /* 19238 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19241 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UADDSAT'
     /* 19241 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19244 */ // Label 345: @19244
     /* 19244 */ GIM_Reject,
     /* 19245 */ // Label 54: @19245
     /* 19245 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19256), // Rule ID 325 //
     /* 19250 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19253 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SADDSAT'
     /* 19253 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19256 */ // Label 346: @19256
     /* 19256 */ GIM_Reject,
     /* 19257 */ // Label 55: @19257
     /* 19257 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19268), // Rule ID 204 //
     /* 19262 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 19265 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_USHLSAT'
     /* 19265 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 19268 */ // Label 347: @19268
     /* 19268 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19279), // Rule ID 208 //
     /* 19273 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 19276 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_USHLSAT'
     /* 19276 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 19279 */ // Label 348: @19279
     /* 19279 */ GIM_Reject,
     /* 19280 */ // Label 56: @19280
     /* 19280 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19291), // Rule ID 203 //
     /* 19285 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule150Enabled),
     /* 19288 */   // Combiner Rule #150: shift_immed_chain; wip_match_opcode 'G_SSHLSAT'
     /* 19288 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner92),
     /* 19291 */ // Label 349: @19291
     /* 19291 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19302), // Rule ID 209 //
     /* 19296 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule151Enabled),
     /* 19299 */   // Combiner Rule #151: shift_of_shifted_logic_chain; wip_match_opcode 'G_SSHLSAT'
     /* 19299 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner93),
     /* 19302 */ // Label 350: @19302
     /* 19302 */ GIM_Reject,
     /* 19303 */ // Label 57: @19303
     /* 19303 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19314), // Rule ID 326 //
     /* 19308 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19311 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIX'
     /* 19311 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19314 */ // Label 351: @19314
     /* 19314 */ GIM_Reject,
     /* 19315 */ // Label 58: @19315
     /* 19315 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19326), // Rule ID 327 //
     /* 19320 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19323 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIX'
     /* 19323 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19326 */ // Label 352: @19326
     /* 19326 */ GIM_Reject,
     /* 19327 */ // Label 59: @19327
     /* 19327 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19338), // Rule ID 328 //
     /* 19332 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19335 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMULFIXSAT'
     /* 19335 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19338 */ // Label 353: @19338
     /* 19338 */ GIM_Reject,
     /* 19339 */ // Label 60: @19339
     /* 19339 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19350), // Rule ID 329 //
     /* 19344 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 19347 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMULFIXSAT'
     /* 19347 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 19350 */ // Label 354: @19350
     /* 19350 */ GIM_Reject,
     /* 19351 */ // Label 61: @19351
     /* 19351 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19362), // Rule ID 249 //
     /* 19356 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 19359 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FADD'
     /* 19359 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19362 */ // Label 355: @19362
     /* 19362 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19373), // Rule ID 260 //
     /* 19367 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19370 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FADD'
     /* 19370 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19373 */ // Label 356: @19373
     /* 19373 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(19384), // Rule ID 267 //
     /* 19378 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule174Enabled),
     /* 19381 */   // Combiner Rule #174: combine_fadd_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19381 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner111),
     /* 19384 */ // Label 357: @19384
     /* 19384 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(19395), // Rule ID 268 //
     /* 19389 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule175Enabled),
     /* 19392 */   // Combiner Rule #175: combine_fadd_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19392 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner112),
     /* 19395 */ // Label 358: @19395
     /* 19395 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(19406), // Rule ID 269 //
     /* 19400 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule176Enabled),
     /* 19403 */   // Combiner Rule #176: combine_fadd_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19403 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner113),
     /* 19406 */ // Label 359: @19406
     /* 19406 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(19417), // Rule ID 270 //
     /* 19411 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule177Enabled),
     /* 19414 */   // Combiner Rule #177: combine_fadd_fpext_fma_fmul_to_fmad_or_fma; wip_match_opcode 'G_FADD'
     /* 19414 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner114),
     /* 19417 */ // Label 360: @19417
     /* 19417 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19428), // Rule ID 293 //
     /* 19422 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19425 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FADD'
     /* 19425 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19428 */ // Label 361: @19428
     /* 19428 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19439), // Rule ID 330 //
     /* 19433 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 19436 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FADD'
     /* 19436 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 19439 */ // Label 362: @19439
     /* 19439 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19462), // Rule ID 138 //
     /* 19444 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule100Enabled),
     /* 19447 */   // MIs[0] dst
     /* 19447 */   // No operand predicates
     /* 19447 */   // MIs[0] x
     /* 19447 */   // No operand predicates
     /* 19447 */   // MIs[0] y
     /* 19447 */   // No operand predicates
     /* 19447 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner3),
     /* 19451 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19456 */   // Combiner Rule #100: right_identity_neg_zero_fp
     /* 19456 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19461 */   GIR_EraseRootFromParent_Done,
     /* 19462 */ // Label 363: @19462
     /* 19462 */ GIM_Reject,
     /* 19463 */ // Label 62: @19463
     /* 19463 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19474), // Rule ID 250 //
     /* 19468 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 19471 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FSUB'
     /* 19471 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19474 */ // Label 364: @19474
     /* 19474 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19485), // Rule ID 261 //
     /* 19479 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19482 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FSUB'
     /* 19482 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19485 */ // Label 365: @19485
     /* 19485 */ GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19496), // Rule ID 271 //
     /* 19490 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule178Enabled),
     /* 19493 */   // Combiner Rule #178: combine_fsub_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19493 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner115),
     /* 19496 */ // Label 366: @19496
     /* 19496 */ GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19507), // Rule ID 272 //
     /* 19501 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule179Enabled),
     /* 19504 */   // Combiner Rule #179: combine_fsub_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19504 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner116),
     /* 19507 */ // Label 367: @19507
     /* 19507 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(19518), // Rule ID 273 //
     /* 19512 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule180Enabled),
     /* 19515 */   // Combiner Rule #180: combine_fsub_fpext_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19515 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner117),
     /* 19518 */ // Label 368: @19518
     /* 19518 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(19529), // Rule ID 274 //
     /* 19523 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule181Enabled),
     /* 19526 */   // Combiner Rule #181: combine_fsub_fpext_fneg_fmul_to_fmad_or_fma; wip_match_opcode 'G_FSUB'
     /* 19526 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner118),
     /* 19529 */ // Label 369: @19529
     /* 19529 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(19540), // Rule ID 294 //
     /* 19534 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19537 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FSUB'
     /* 19537 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19540 */ // Label 370: @19540
     /* 19540 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(19551), // Rule ID 308 //
     /* 19545 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule190Enabled),
     /* 19548 */   // Combiner Rule #190: fsub_to_fneg; wip_match_opcode 'G_FSUB'
     /* 19548 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner126),
     /* 19551 */ // Label 371: @19551
     /* 19551 */ GIM_Reject,
     /* 19552 */ // Label 63: @19552
     /* 19552 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(19563), // Rule ID 251 //
     /* 19557 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 19560 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FMUL'
     /* 19560 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19563 */ // Label 372: @19563
     /* 19563 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(19574), // Rule ID 262 //
     /* 19568 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19571 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMUL'
     /* 19571 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19574 */ // Label 373: @19574
     /* 19574 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(19585), // Rule ID 292 //
     /* 19579 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19582 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMUL'
     /* 19582 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19585 */ // Label 374: @19585
     /* 19585 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(19596), // Rule ID 331 //
     /* 19590 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 19593 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMUL'
     /* 19593 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 19596 */ // Label 375: @19596
     /* 19596 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(19617), // Rule ID 364 //
     /* 19601 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule217Enabled),
     /* 19604 */   // MIs[0] dst
     /* 19604 */   // No operand predicates
     /* 19604 */   // MIs[0] x
     /* 19604 */   // No operand predicates
     /* 19604 */   // MIs[0] select
     /* 19604 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19608 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SELECT),
     /* 19612 */   // MIs[1] y
     /* 19612 */   // No operand predicates
     /* 19612 */   // MIs[1] A
     /* 19612 */   // No operand predicates
     /* 19612 */   // MIs[1] B
     /* 19612 */   // No operand predicates
     /* 19612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19614 */   // Combiner Rule #217: combine_fmul_with_select_to_fldexp
     /* 19614 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner153),
     /* 19617 */ // Label 376: @19617
     /* 19617 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(19640), // Rule ID 129 //
     /* 19622 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule93Enabled),
     /* 19625 */   // MIs[0] dst
     /* 19625 */   // No operand predicates
     /* 19625 */   // MIs[0] x
     /* 19625 */   // No operand predicates
     /* 19625 */   // MIs[0] y
     /* 19625 */   // No operand predicates
     /* 19625 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner2),
     /* 19629 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19634 */   // Combiner Rule #93: right_identity_one_fp
     /* 19634 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 19639 */   GIR_EraseRootFromParent_Done,
     /* 19640 */ // Label 377: @19640
     /* 19640 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(19660), // Rule ID 139 //
     /* 19645 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule101Enabled),
     /* 19648 */   // MIs[0] dst
     /* 19648 */   // No operand predicates
     /* 19648 */   // MIs[0] x
     /* 19648 */   // No operand predicates
     /* 19648 */   // MIs[0] y
     /* 19648 */   // No operand predicates
     /* 19648 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner4),
     /* 19652 */   // Combiner Rule #101: right_identity_neg_one_fp
     /* 19652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19655 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 19657 */   GIR_RootToRootCopy, /*OpIdx*/1, // x
     /* 19659 */   GIR_EraseRootFromParent_Done,
     /* 19660 */ // Label 378: @19660
     /* 19660 */ GIM_Reject,
     /* 19661 */ // Label 64: @19661
     /* 19661 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(19672), // Rule ID 254 //
     /* 19666 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 19669 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMA'
     /* 19669 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 19672 */ // Label 379: @19672
     /* 19672 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(19683), // Rule ID 265 //
     /* 19677 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19680 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMA'
     /* 19680 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19683 */ // Label 380: @19683
     /* 19683 */ GIM_Reject,
     /* 19684 */ // Label 65: @19684
     /* 19684 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(19695), // Rule ID 253 //
     /* 19689 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule168Enabled),
     /* 19692 */   // Combiner Rule #168: constant_fold_fma; wip_match_opcode 'G_FMAD'
     /* 19692 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner106),
     /* 19695 */ // Label 381: @19695
     /* 19695 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(19706), // Rule ID 264 //
     /* 19700 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19703 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FMAD'
     /* 19703 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19706 */ // Label 382: @19706
     /* 19706 */ GIM_Reject,
     /* 19707 */ // Label 66: @19707
     /* 19707 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(19718), // Rule ID 252 //
     /* 19712 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule167Enabled),
     /* 19715 */   // Combiner Rule #167: constant_fold_fp_binop; wip_match_opcode 'G_FDIV'
     /* 19715 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner105),
     /* 19718 */ // Label 383: @19718
     /* 19718 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(19729), // Rule ID 263 //
     /* 19723 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule172Enabled),
     /* 19726 */   // Combiner Rule #172: redundant_neg_operands; wip_match_opcode 'G_FDIV'
     /* 19726 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner109),
     /* 19729 */ // Label 384: @19729
     /* 19729 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(19740), // Rule ID 295 //
     /* 19734 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19737 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FDIV'
     /* 19737 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19740 */ // Label 385: @19740
     /* 19740 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(19779), // Rule ID 375 //
     /* 19745 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule223Enabled),
     /* 19748 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 19751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 19754 */   GIM_MIFlags, /*MI*/0, GIMT_Encode4(MachineInstr::FmContract),
     /* 19760 */   // MIs[0] y
     /* 19760 */   // No operand predicates
     /* 19760 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19764 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSQRT),
     /* 19768 */   GIM_MIFlags, /*MI*/1, GIMT_Encode4(MachineInstr::FmContract),
     /* 19774 */   // MIs[1] x
     /* 19774 */   // No operand predicates
     /* 19774 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19776 */   // Combiner Rule #223: fdiv_by_sqrt_to_rsq_f16
     /* 19776 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner159),
     /* 19779 */ // Label 386: @19779
     /* 19779 */ GIM_Reject,
     /* 19780 */ // Label 67: @19780
     /* 19780 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(19791), // Rule ID 296 //
     /* 19785 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 19788 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FREM'
     /* 19788 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 19791 */ // Label 387: @19791
     /* 19791 */ GIM_Reject,
     /* 19792 */ // Label 68: @19792
     /* 19792 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(19813), // Rule ID 197 //
     /* 19797 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule147Enabled),
     /* 19800 */   // MIs[0] dst
     /* 19800 */   // No operand predicates
     /* 19800 */   // MIs[0] float
     /* 19800 */   // No operand predicates
     /* 19800 */   // MIs[0] int
     /* 19800 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 19804 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 19808 */   // MIs[1] imm
     /* 19808 */   // No operand predicates
     /* 19808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19810 */   // Combiner Rule #147: expand_const_fpowi
     /* 19810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner89),
     /* 19813 */ // Label 388: @19813
     /* 19813 */ GIM_Reject,
     /* 19814 */ // Label 69: @19814
     /* 19814 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(19835), // Rule ID 179 //
     /* 19819 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule137Enabled),
     /* 19822 */   // MIs[0] dst
     /* 19822 */   // No operand predicates
     /* 19822 */   // MIs[0] src0
     /* 19822 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19830 */   // MIs[1] cst
     /* 19830 */   // No operand predicates
     /* 19830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19832 */   // Combiner Rule #137: constant_fold_flog2
     /* 19832 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19835 */ // Label 389: @19835
     /* 19835 */ GIM_Reject,
     /* 19836 */ // Label 70: @19836
     /* 19836 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(19847), // Rule ID 372 //
     /* 19841 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule221Enabled),
     /* 19844 */   // Combiner Rule #221: foldable_fneg; wip_match_opcode 'G_FNEG'
     /* 19844 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner157),
     /* 19847 */ // Label 390: @19847
     /* 19847 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(19868), // Rule ID 176 //
     /* 19852 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule134Enabled),
     /* 19855 */   // MIs[0] dst
     /* 19855 */   // No operand predicates
     /* 19855 */   // MIs[0] src0
     /* 19855 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19859 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19863 */   // MIs[1] cst
     /* 19863 */   // No operand predicates
     /* 19863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19865 */   // Combiner Rule #134: constant_fold_fneg
     /* 19865 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19868 */ // Label 391: @19868
     /* 19868 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(19897), // Rule ID 127 //
     /* 19873 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule91Enabled),
     /* 19876 */   // MIs[0] dst
     /* 19876 */   // No operand predicates
     /* 19876 */   // MIs[0] t
     /* 19876 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 19884 */   // MIs[1] src
     /* 19884 */   // No operand predicates
     /* 19884 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19889 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19891 */   // Combiner Rule #91: fneg_fneg_fold
     /* 19891 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/1,
     /* 19896 */   GIR_EraseRootFromParent_Done,
     /* 19897 */ // Label 392: @19897
     /* 19897 */ GIM_Reject,
     /* 19898 */ // Label 71: @19898
     /* 19898 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(19922), // Rule ID 363 //
     /* 19903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has16BitInsts_NotHasMed3_16),
     /* 19906 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule216Enabled),
     /* 19909 */   // MIs[0] fptrunc_dst
     /* 19909 */   // No operand predicates
     /* 19909 */   // MIs[0] fmed3_dst
     /* 19909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AMDGPU::G_AMDGPU_FMED3),
     /* 19917 */   // MIs[1] src0
     /* 19917 */   // No operand predicates
     /* 19917 */   // MIs[1] src1
     /* 19917 */   // No operand predicates
     /* 19917 */   // MIs[1] src2
     /* 19917 */   // No operand predicates
     /* 19917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19919 */   // Combiner Rule #216: expand_promoted_fmed3
     /* 19919 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner152),
     /* 19922 */ // Label 393: @19922
     /* 19922 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(19943), // Rule ID 180 //
     /* 19927 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule138Enabled),
     /* 19930 */   // MIs[0] dst
     /* 19930 */   // No operand predicates
     /* 19930 */   // MIs[0] src0
     /* 19930 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19934 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 19938 */   // MIs[1] cst
     /* 19938 */   // No operand predicates
     /* 19938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19940 */   // Combiner Rule #138: constant_fold_fptrunc
     /* 19940 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 19943 */ // Label 394: @19943
     /* 19943 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(19964), // Rule ID 137 //
     /* 19948 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule99Enabled),
     /* 19951 */   // MIs[0] dst
     /* 19951 */   // No operand predicates
     /* 19951 */   // MIs[0] src1
     /* 19951 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19955 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPEXT),
     /* 19959 */   // MIs[1] src0
     /* 19959 */   // No operand predicates
     /* 19959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19961 */   // Combiner Rule #99: fptrunc_fpext_fold
     /* 19961 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner52),
     /* 19964 */ // Label 395: @19964
     /* 19964 */ GIM_Reject,
     /* 19965 */ // Label 72: @19965
     /* 19965 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(19986), // Rule ID 92 //
     /* 19970 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 19973 */   // MIs[0] dst
     /* 19973 */   // No operand predicates
     /* 19973 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19973 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 19981 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 19983 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[5]]
     /* 19983 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 19986 */ // Label 396: @19986
     /* 19986 */ GIM_Reject,
     /* 19987 */ // Label 73: @19987
     /* 19987 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(20008), // Rule ID 93 //
     /* 19992 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule77Enabled),
     /* 19995 */   // MIs[0] dst
     /* 19995 */   // No operand predicates
     /* 19995 */   // MIs[0] __unary_undef_to_undef_match_0.x
     /* 19995 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 19999 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20003 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20005 */   // Combiner Rule #77: unary_undef_to_undef @ [__unary_undef_to_undef_match_0[6]]
     /* 20005 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner38),
     /* 20008 */ // Label 397: @20008
     /* 20008 */ GIM_Reject,
     /* 20009 */ // Label 74: @20009
     /* 20009 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(20020), // Rule ID 76 //
     /* 20014 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 20017 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_SITOFP'
     /* 20017 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 20020 */ // Label 398: @20020
     /* 20020 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(20031), // Rule ID 366 //
     /* 20025 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 20028 */   // Combiner Rule #218: uchar_to_float; wip_match_opcode 'G_SITOFP'
     /* 20028 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20031 */ // Label 399: @20031
     /* 20031 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(20046), // Rule ID 181 //
     /* 20036 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule139Enabled),
     /* 20039 */   // MIs[0] dst
     /* 20039 */   // No operand predicates
     /* 20039 */   // MIs[0] Operand 1
     /* 20039 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 20043 */   // Combiner Rule #139: itof_const_zero_fold_si
     /* 20043 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 20046 */ // Label 400: @20046
     /* 20046 */ GIM_Reject,
     /* 20047 */ // Label 75: @20047
     /* 20047 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(20058), // Rule ID 75 //
     /* 20052 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule71Enabled),
     /* 20055 */   // Combiner Rule #71: undef_to_fp_zero; wip_match_opcode 'G_UITOFP'
     /* 20055 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner33),
     /* 20058 */ // Label 401: @20058
     /* 20058 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(20069), // Rule ID 365 //
     /* 20063 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule218Enabled),
     /* 20066 */   // Combiner Rule #218: uchar_to_float; wip_match_opcode 'G_UITOFP'
     /* 20066 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner154),
     /* 20069 */ // Label 402: @20069
     /* 20069 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(20084), // Rule ID 182 //
     /* 20074 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule140Enabled),
     /* 20077 */   // MIs[0] dst
     /* 20077 */   // No operand predicates
     /* 20077 */   // MIs[0] Operand 1
     /* 20077 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 20081 */   // Combiner Rule #140: itof_const_zero_fold_ui
     /* 20081 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner82),
     /* 20084 */ // Label 403: @20084
     /* 20084 */ GIM_Reject,
     /* 20085 */ // Label 76: @20085
     /* 20085 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(20114), // Rule ID 19 //
     /* 20090 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 20093 */   // MIs[0] dst
     /* 20093 */   // No operand predicates
     /* 20093 */   // MIs[0] src
     /* 20093 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 20101 */   // MIs[1] __idempotent_prop_match_0.x
     /* 20101 */   // No operand predicates
     /* 20101 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20108 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[1]]
     /* 20108 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20113 */   GIR_EraseRootFromParent_Done,
     /* 20114 */ // Label 404: @20114
     /* 20114 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(20135), // Rule ID 177 //
     /* 20119 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule135Enabled),
     /* 20122 */   // MIs[0] dst
     /* 20122 */   // No operand predicates
     /* 20122 */   // MIs[0] src0
     /* 20122 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 20130 */   // MIs[1] cst
     /* 20130 */   // No operand predicates
     /* 20130 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20132 */   // Combiner Rule #135: constant_fold_fabs
     /* 20132 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 20135 */ // Label 405: @20135
     /* 20135 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(20163), // Rule ID 258 //
     /* 20140 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule170Enabled),
     /* 20143 */   // MIs[0] dst
     /* 20143 */   // No operand predicates
     /* 20143 */   // MIs[0] tmp
     /* 20143 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 20151 */   // MIs[1] x
     /* 20151 */   // No operand predicates
     /* 20151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20153 */   // Combiner Rule #170: fabs_fneg_fold
     /* 20153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_FABS),
     /* 20156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 20158 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // x
     /* 20162 */   GIR_EraseRootFromParent_Done,
     /* 20163 */ // Label 406: @20163
     /* 20163 */ GIM_Reject,
     /* 20164 */ // Label 77: @20164
     /* 20164 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(20175), // Rule ID 371 //
     /* 20169 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule220Enabled),
     /* 20172 */   // Combiner Rule #220: remove_fcanonicalize; wip_match_opcode 'G_FCANONICALIZE'
     /* 20172 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner156),
     /* 20175 */ // Label 407: @20175
     /* 20175 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(20204), // Rule ID 20 //
     /* 20180 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule18Enabled),
     /* 20183 */   // MIs[0] dst
     /* 20183 */   // No operand predicates
     /* 20183 */   // MIs[0] src
     /* 20183 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 20191 */   // MIs[1] __idempotent_prop_match_0.x
     /* 20191 */   // No operand predicates
     /* 20191 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20198 */   // Combiner Rule #18: idempotent_prop @ [__idempotent_prop_match_0[2]]
     /* 20198 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20203 */   GIR_EraseRootFromParent_Done,
     /* 20204 */ // Label 408: @20204
     /* 20204 */ GIM_Reject,
     /* 20205 */ // Label 78: @20205
     /* 20205 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(20216), // Rule ID 193 //
     /* 20210 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 20213 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINNUM'
     /* 20213 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 20216 */ // Label 409: @20216
     /* 20216 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(20227), // Rule ID 297 //
     /* 20221 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20224 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMINNUM'
     /* 20224 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20227 */ // Label 410: @20227
     /* 20227 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20238), // Rule ID 332 //
     /* 20232 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20235 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM'
     /* 20235 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20238 */ // Label 411: @20238
     /* 20238 */ GIM_Reject,
     /* 20239 */ // Label 79: @20239
     /* 20239 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20250), // Rule ID 194 //
     /* 20244 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 20247 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXNUM'
     /* 20247 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 20250 */ // Label 412: @20250
     /* 20250 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20261), // Rule ID 298 //
     /* 20255 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20258 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMAXNUM'
     /* 20258 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20261 */ // Label 413: @20261
     /* 20261 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20272), // Rule ID 333 //
     /* 20266 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20269 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM'
     /* 20269 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20272 */ // Label 414: @20272
     /* 20272 */ GIM_Reject,
     /* 20273 */ // Label 80: @20273
     /* 20273 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20284), // Rule ID 334 //
     /* 20278 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20281 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINNUM_IEEE'
     /* 20281 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20284 */ // Label 415: @20284
     /* 20284 */ GIM_Reject,
     /* 20285 */ // Label 81: @20285
     /* 20285 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20296), // Rule ID 335 //
     /* 20290 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20293 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXNUM_IEEE'
     /* 20293 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20296 */ // Label 416: @20296
     /* 20296 */ GIM_Reject,
     /* 20297 */ // Label 82: @20297
     /* 20297 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20308), // Rule ID 195 //
     /* 20302 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 20305 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMINIMUM'
     /* 20305 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 20308 */ // Label 417: @20308
     /* 20308 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20319), // Rule ID 299 //
     /* 20313 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20316 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMINIMUM'
     /* 20316 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20319 */ // Label 418: @20319
     /* 20319 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20330), // Rule ID 336 //
     /* 20324 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20327 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMINIMUM'
     /* 20327 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20330 */ // Label 419: @20330
     /* 20330 */ GIM_Reject,
     /* 20331 */ // Label 83: @20331
     /* 20331 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20342), // Rule ID 196 //
     /* 20336 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule146Enabled),
     /* 20339 */   // Combiner Rule #146: combine_minmax_nan; wip_match_opcode 'G_FMAXIMUM'
     /* 20339 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner88),
     /* 20342 */ // Label 420: @20342
     /* 20342 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20353), // Rule ID 300 //
     /* 20347 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20350 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_FMAXIMUM'
     /* 20350 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20353 */ // Label 421: @20353
     /* 20353 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(20364), // Rule ID 337 //
     /* 20358 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule192Enabled),
     /* 20361 */   // Combiner Rule #192: commute_fp_constant_to_rhs; wip_match_opcode 'G_FMAXIMUM'
     /* 20361 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner128),
     /* 20364 */ // Label 422: @20364
     /* 20364 */ GIM_Reject,
     /* 20365 */ // Label 84: @20365
     /* 20365 */ GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20376), // Rule ID 148 //
     /* 20370 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule106Enabled),
     /* 20373 */   // Combiner Rule #106: reassoc_ptradd; wip_match_opcode 'G_PTR_ADD'
     /* 20373 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner57),
     /* 20376 */ // Label 423: @20376
     /* 20376 */ GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20387), // Rule ID 150 //
     /* 20381 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule108Enabled),
     /* 20384 */   // Combiner Rule #108: ptr_add_immed_chain; wip_match_opcode 'G_PTR_ADD'
     /* 20384 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner59),
     /* 20387 */ // Label 424: @20387
     /* 20387 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20398), // Rule ID 183 //
     /* 20392 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule141Enabled),
     /* 20395 */   // Combiner Rule #141: const_ptradd_to_i2p; wip_match_opcode 'G_PTR_ADD'
     /* 20395 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner83),
     /* 20398 */ // Label 425: @20398
     /* 20398 */ GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20409), // Rule ID 199 //
     /* 20403 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule149Enabled),
     /* 20406 */   // Combiner Rule #149: ptr_add_with_zero; wip_match_opcode 'G_PTR_ADD'
     /* 20406 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner91),
     /* 20409 */ // Label 426: @20409
     /* 20409 */ GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20420), // Rule ID 232 //
     /* 20414 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 20417 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_PTR_ADD'
     /* 20417 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 20420 */ // Label 427: @20420
     /* 20420 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20431), // Rule ID 277 //
     /* 20425 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20428 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_PTR_ADD'
     /* 20428 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20431 */ // Label 428: @20431
     /* 20431 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20454), // Rule ID 111 //
     /* 20436 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule84Enabled),
     /* 20439 */   // MIs[0] dst
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[0] lhs
     /* 20439 */   // No operand predicates
     /* 20439 */   // MIs[0] Operand 2
     /* 20439 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 20443 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20448 */   // Combiner Rule #84: right_identity_zero @ [__right_identity_zero_match_0[7]]
     /* 20448 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20453 */   GIR_EraseRootFromParent_Done,
     /* 20454 */ // Label 429: @20454
     /* 20454 */ GIM_Reject,
     /* 20455 */ // Label 85: @20455
     /* 20455 */ GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20466), // Rule ID 245 //
     /* 20460 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 20463 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMIN'
     /* 20463 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 20466 */ // Label 430: @20466
     /* 20466 */ GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20477), // Rule ID 288 //
     /* 20471 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20474 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SMIN'
     /* 20474 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20477 */ // Label 431: @20477
     /* 20477 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(20488), // Rule ID 314 //
     /* 20482 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 20485 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMIN'
     /* 20485 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 20488 */ // Label 432: @20488
     /* 20488 */ GIM_Reject,
     /* 20489 */ // Label 86: @20489
     /* 20489 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(20500), // Rule ID 246 //
     /* 20494 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 20497 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_SMAX'
     /* 20497 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 20500 */ // Label 433: @20500
     /* 20500 */ GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(20511), // Rule ID 289 //
     /* 20505 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20508 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_SMAX'
     /* 20508 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20511 */ // Label 434: @20511
     /* 20511 */ GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(20522), // Rule ID 315 //
     /* 20516 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 20519 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_SMAX'
     /* 20519 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 20522 */ // Label 435: @20522
     /* 20522 */ GIM_Reject,
     /* 20523 */ // Label 87: @20523
     /* 20523 */ GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(20534), // Rule ID 247 //
     /* 20528 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 20531 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMIN'
     /* 20531 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 20534 */ // Label 436: @20534
     /* 20534 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(20545), // Rule ID 290 //
     /* 20539 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20542 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UMIN'
     /* 20542 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20545 */ // Label 437: @20545
     /* 20545 */ GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(20556), // Rule ID 316 //
     /* 20550 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 20553 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMIN'
     /* 20553 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 20556 */ // Label 438: @20556
     /* 20556 */ GIM_Reject,
     /* 20557 */ // Label 88: @20557
     /* 20557 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(20568), // Rule ID 248 //
     /* 20562 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule166Enabled),
     /* 20565 */   // Combiner Rule #166: constant_fold_binop; wip_match_opcode 'G_UMAX'
     /* 20565 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner104),
     /* 20568 */ // Label 439: @20568
     /* 20568 */ GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(20579), // Rule ID 291 //
     /* 20573 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule182Enabled),
     /* 20576 */   // Combiner Rule #182: fold_binop_into_select; wip_match_opcode 'G_UMAX'
     /* 20576 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner119),
     /* 20579 */ // Label 440: @20579
     /* 20579 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(20590), // Rule ID 317 //
     /* 20584 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule191Enabled),
     /* 20587 */   // Combiner Rule #191: commute_int_constant_to_rhs; wip_match_opcode 'G_UMAX'
     /* 20587 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner127),
     /* 20590 */ // Label 441: @20590
     /* 20590 */ GIM_Reject,
     /* 20591 */ // Label 89: @20591
     /* 20591 */ GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(20602), // Rule ID 86 //
     /* 20596 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule76Enabled),
     /* 20599 */   // Combiner Rule #76: unary_undef_to_zero; wip_match_opcode 'G_ABS'
     /* 20599 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner36),
     /* 20602 */ // Label 442: @20602
     /* 20602 */ GIM_Reject,
     /* 20603 */ // Label 90: @20603
     /* 20603 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(20614), // Rule ID 175 //
     /* 20608 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule133Enabled),
     /* 20611 */   // Combiner Rule #133: opt_brcond_by_inverting_cond; wip_match_opcode 'G_BR'
     /* 20611 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner80),
     /* 20614 */ // Label 443: @20614
     /* 20614 */ GIM_Reject,
     /* 20615 */ // Label 91: @20615
     /* 20615 */ GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(20626), // Rule ID 26 //
     /* 20620 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule24Enabled),
     /* 20623 */   // Combiner Rule #24: insert_vector_elt_oob; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20623 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner10),
     /* 20626 */ // Label 444: @20626
     /* 20626 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(20637), // Rule ID 67 //
     /* 20631 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule65Enabled),
     /* 20634 */   // Combiner Rule #65: combine_insert_vec_elts_build_vector; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20634 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner27),
     /* 20637 */ // Label 445: @20637
     /* 20637 */ GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(20648), // Rule ID 101 //
     /* 20642 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 20645 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_INSERT_VECTOR_ELT'
     /* 20645 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 20648 */ // Label 446: @20648
     /* 20648 */ GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(20687), // Rule ID 38 //
     /* 20653 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule36Enabled),
     /* 20656 */   // MIs[0] root
     /* 20656 */   // No operand predicates
     /* 20656 */   // MIs[0] src
     /* 20656 */   // No operand predicates
     /* 20656 */   // MIs[0] elt
     /* 20656 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 20664 */   // MIs[1] src
     /* 20664 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /* 20669 */   // MIs[1] idx
     /* 20669 */   // No operand predicates
     /* 20669 */   // MIs[0] idx
     /* 20669 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 20674 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20679 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20681 */   // Combiner Rule #36: insert_vector_element_extract_vector_element
     /* 20681 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20686 */   GIR_EraseRootFromParent_Done,
     /* 20687 */ // Label 447: @20687
     /* 20687 */ GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(20720), // Rule ID 24 //
     /* 20692 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule22Enabled),
     /* 20695 */   // MIs[0] root
     /* 20695 */   // No operand predicates
     /* 20695 */   // MIs[0] src
     /* 20695 */   // No operand predicates
     /* 20695 */   // MIs[0] elt
     /* 20695 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 20699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20703 */   // MIs[0] idx
     /* 20703 */   // No operand predicates
     /* 20703 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner0),
     /* 20707 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20712 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20714 */   // Combiner Rule #22: insert_vector_element_elt_undef
     /* 20714 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/0, /*NewOpIdx*/1,
     /* 20719 */   GIR_EraseRootFromParent_Done,
     /* 20720 */ // Label 448: @20720
     /* 20720 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(20744), // Rule ID 23 //
     /* 20725 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule21Enabled),
     /* 20728 */   // MIs[0] root
     /* 20728 */   // No operand predicates
     /* 20728 */   // MIs[0] src
     /* 20728 */   // No operand predicates
     /* 20728 */   // MIs[0] elt
     /* 20728 */   // No operand predicates
     /* 20728 */   // MIs[0] idx
     /* 20728 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20736 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20738 */   // Combiner Rule #21: insert_vector_element_idx_undef
     /* 20738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 20741 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 20743 */   GIR_EraseRootFromParent_Done,
     /* 20744 */ // Label 449: @20744
     /* 20744 */ GIM_Reject,
     /* 20745 */ // Label 92: @20745
     /* 20745 */ GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(20756), // Rule ID 25 //
     /* 20750 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule23Enabled),
     /* 20753 */   // Combiner Rule #23: match_extract_of_element; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20753 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner9),
     /* 20756 */ // Label 450: @20756
     /* 20756 */ GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(20767), // Rule ID 68 //
     /* 20761 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule66Enabled),
     /* 20764 */   // Combiner Rule #66: extract_vec_elt_build_vec; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20764 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner28),
     /* 20767 */ // Label 451: @20767
     /* 20767 */ GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(20778), // Rule ID 74 //
     /* 20772 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule70Enabled),
     /* 20775 */   // Combiner Rule #70: combine_extracted_vector_load; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20775 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner32),
     /* 20778 */ // Label 452: @20778
     /* 20778 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(20789), // Rule ID 102 //
     /* 20783 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule82Enabled),
     /* 20786 */   // Combiner Rule #82: insert_extract_vec_elt_out_of_bounds; wip_match_opcode 'G_EXTRACT_VECTOR_ELT'
     /* 20786 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner43),
     /* 20789 */ // Label 453: @20789
     /* 20789 */ GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(20813), // Rule ID 36 //
     /* 20794 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule34Enabled),
     /* 20797 */   // MIs[0] root
     /* 20797 */   // No operand predicates
     /* 20797 */   // MIs[0] src
     /* 20797 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20801 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20805 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/9,
     /* 20808 */   // MIs[1] x
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] y
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] z
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] a
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] b
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] c
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] d
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[1] e
     /* 20808 */   // No operand predicates
     /* 20808 */   // MIs[0] idx
     /* 20808 */   // No operand predicates
     /* 20808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20810 */   // Combiner Rule #34: extract_vector_element_build_vector_trunc8
     /* 20810 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20813 */ // Label 454: @20813
     /* 20813 */ GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(20837), // Rule ID 35 //
     /* 20818 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule33Enabled),
     /* 20821 */   // MIs[0] root
     /* 20821 */   // No operand predicates
     /* 20821 */   // MIs[0] src
     /* 20821 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20829 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/8,
     /* 20832 */   // MIs[1] x
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] y
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] z
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] a
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] b
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] c
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[1] d
     /* 20832 */   // No operand predicates
     /* 20832 */   // MIs[0] idx
     /* 20832 */   // No operand predicates
     /* 20832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20834 */   // Combiner Rule #33: extract_vector_element_build_vector_trunc7
     /* 20834 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20837 */ // Label 455: @20837
     /* 20837 */ GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(20861), // Rule ID 34 //
     /* 20842 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule32Enabled),
     /* 20845 */   // MIs[0] root
     /* 20845 */   // No operand predicates
     /* 20845 */   // MIs[0] src
     /* 20845 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20849 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20853 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/7,
     /* 20856 */   // MIs[1] x
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[1] y
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[1] z
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[1] a
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[1] b
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[1] c
     /* 20856 */   // No operand predicates
     /* 20856 */   // MIs[0] idx
     /* 20856 */   // No operand predicates
     /* 20856 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20858 */   // Combiner Rule #32: extract_vector_element_build_vector_trunc6
     /* 20858 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20861 */ // Label 456: @20861
     /* 20861 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(20885), // Rule ID 33 //
     /* 20866 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule31Enabled),
     /* 20869 */   // MIs[0] root
     /* 20869 */   // No operand predicates
     /* 20869 */   // MIs[0] src
     /* 20869 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20877 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/6,
     /* 20880 */   // MIs[1] x
     /* 20880 */   // No operand predicates
     /* 20880 */   // MIs[1] y
     /* 20880 */   // No operand predicates
     /* 20880 */   // MIs[1] z
     /* 20880 */   // No operand predicates
     /* 20880 */   // MIs[1] a
     /* 20880 */   // No operand predicates
     /* 20880 */   // MIs[1] b
     /* 20880 */   // No operand predicates
     /* 20880 */   // MIs[0] idx
     /* 20880 */   // No operand predicates
     /* 20880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20882 */   // Combiner Rule #31: extract_vector_element_build_vector_trunc5
     /* 20882 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20885 */ // Label 457: @20885
     /* 20885 */ GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(20909), // Rule ID 32 //
     /* 20890 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule30Enabled),
     /* 20893 */   // MIs[0] root
     /* 20893 */   // No operand predicates
     /* 20893 */   // MIs[0] src
     /* 20893 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20901 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 20904 */   // MIs[1] x
     /* 20904 */   // No operand predicates
     /* 20904 */   // MIs[1] y
     /* 20904 */   // No operand predicates
     /* 20904 */   // MIs[1] z
     /* 20904 */   // No operand predicates
     /* 20904 */   // MIs[1] a
     /* 20904 */   // No operand predicates
     /* 20904 */   // MIs[0] idx
     /* 20904 */   // No operand predicates
     /* 20904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20906 */   // Combiner Rule #30: extract_vector_element_build_vector_trunc4
     /* 20906 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20909 */ // Label 458: @20909
     /* 20909 */ GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(20933), // Rule ID 31 //
     /* 20914 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule29Enabled),
     /* 20917 */   // MIs[0] root
     /* 20917 */   // No operand predicates
     /* 20917 */   // MIs[0] src
     /* 20917 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 20925 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 20928 */   // MIs[1] x
     /* 20928 */   // No operand predicates
     /* 20928 */   // MIs[1] y
     /* 20928 */   // No operand predicates
     /* 20928 */   // MIs[1] z
     /* 20928 */   // No operand predicates
     /* 20928 */   // MIs[0] idx
     /* 20928 */   // No operand predicates
     /* 20928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20930 */   // Combiner Rule #29: extract_vector_element_build_vector_trunc3
     /* 20930 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 20933 */ // Label 459: @20933
     /* 20933 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(20967), // Rule ID 27 //
     /* 20938 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule25Enabled),
     /* 20941 */   // MIs[0] root
     /* 20941 */   // No operand predicates
     /* 20941 */   // MIs[0] src
     /* 20941 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20949 */   // MIs[1] x
     /* 20949 */   // No operand predicates
     /* 20949 */   // MIs[1] value
     /* 20949 */   // No operand predicates
     /* 20949 */   // MIs[1] idx
     /* 20949 */   // No operand predicates
     /* 20949 */   // MIs[0] idx
     /* 20949 */   GIM_CheckIsSameOperandIgnoreCopies, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/3,
     /* 20954 */   GIM_CheckCanReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20959 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20961 */   // Combiner Rule #25: extract_vector_element_not_const
     /* 20961 */   GIR_ReplaceReg, /*OldInsnID*/0, /*OldOpIdx*/0, /*NewInsnId*/1, /*NewOpIdx*/2,
     /* 20966 */   GIR_EraseRootFromParent_Done,
     /* 20967 */ // Label 460: @20967
     /* 20967 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(20988), // Rule ID 28 //
     /* 20972 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule26Enabled),
     /* 20975 */   // MIs[0] root
     /* 20975 */   // No operand predicates
     /* 20975 */   // MIs[0] src
     /* 20975 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 20979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INSERT_VECTOR_ELT),
     /* 20983 */   // MIs[1] x
     /* 20983 */   // No operand predicates
     /* 20983 */   // MIs[1] value
     /* 20983 */   // No operand predicates
     /* 20983 */   // MIs[1] idx2
     /* 20983 */   // No operand predicates
     /* 20983 */   // MIs[0] idx1
     /* 20983 */   // No operand predicates
     /* 20983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20985 */   // Combiner Rule #26: extract_vector_element_different_indices
     /* 20985 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner11),
     /* 20988 */ // Label 461: @20988
     /* 20988 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(21017), // Rule ID 37 //
     /* 20993 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule35Enabled),
     /* 20996 */   // MIs[0] root
     /* 20996 */   // No operand predicates
     /* 20996 */   // MIs[0] src
     /* 20996 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHUFFLE_VECTOR),
     /* 21004 */   // MIs[1] src1
     /* 21004 */   // No operand predicates
     /* 21004 */   // MIs[1] src2
     /* 21004 */   // No operand predicates
     /* 21004 */   // MIs[1] mask
     /* 21004 */   // No operand predicates
     /* 21004 */   // MIs[0] idx
     /* 21004 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21008 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21012 */   // MIs[2] imm
     /* 21012 */   // No operand predicates
     /* 21012 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21014 */   // Combiner Rule #35: extract_vector_element_shuffle_vector
     /* 21014 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner14),
     /* 21017 */ // Label 462: @21017
     /* 21017 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(21041), // Rule ID 30 //
     /* 21022 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule28Enabled),
     /* 21025 */   // MIs[0] root
     /* 21025 */   // No operand predicates
     /* 21025 */   // MIs[0] src
     /* 21025 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 21033 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 21036 */   // MIs[1] x
     /* 21036 */   // No operand predicates
     /* 21036 */   // MIs[1] y
     /* 21036 */   // No operand predicates
     /* 21036 */   // MIs[0] idx
     /* 21036 */   // No operand predicates
     /* 21036 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21038 */   // Combiner Rule #28: extract_vector_element_build_vector_trunc2
     /* 21038 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner13),
     /* 21041 */ // Label 463: @21041
     /* 21041 */ GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(21073), // Rule ID 29 //
     /* 21046 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule27Enabled),
     /* 21049 */   // MIs[0] root
     /* 21049 */   // No operand predicates
     /* 21049 */   // MIs[0] src
     /* 21049 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 21057 */   GIM_CheckNumOperandsGE, /*MI*/1, /*Expected*/2,
     /* 21060 */   // MIs[1] unused
     /* 21060 */   // No operand predicates
     /* 21060 */   // MIs[0] idx
     /* 21060 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 21064 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21068 */   // MIs[2] imm
     /* 21068 */   // No operand predicates
     /* 21068 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21070 */   // Combiner Rule #27: extract_vector_element_build_vector
     /* 21070 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner12),
     /* 21073 */ // Label 464: @21073
     /* 21073 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(21097), // Rule ID 21 //
     /* 21078 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule19Enabled),
     /* 21081 */   // MIs[0] root
     /* 21081 */   // No operand predicates
     /* 21081 */   // MIs[0] vector
     /* 21081 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21085 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 21089 */   // MIs[0] idx
     /* 21089 */   // No operand predicates
     /* 21089 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21091 */   // Combiner Rule #19: match_extract_of_element_undef_vector
     /* 21091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 21094 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 21096 */   GIR_EraseRootFromParent_Done,
     /* 21097 */ // Label 465: @21097
     /* 21097 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(21121), // Rule ID 22 //
     /* 21102 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule20Enabled),
     /* 21105 */   // MIs[0] root
     /* 21105 */   // No operand predicates
     /* 21105 */   // MIs[0] vector
     /* 21105 */   // No operand predicates
     /* 21105 */   // MIs[0] idx
     /* 21105 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 21113 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21115 */   // Combiner Rule #20: match_extract_of_element_undef_index
     /* 21115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 21118 */   GIR_RootToRootCopy, /*OpIdx*/0, // root
     /* 21120 */   GIR_EraseRootFromParent_Done,
     /* 21121 */ // Label 466: @21121
     /* 21121 */ GIM_Reject,
     /* 21122 */ // Label 93: @21122
     /* 21122 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(21133), // Rule ID 97 //
     /* 21127 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule79Enabled),
     /* 21130 */   // Combiner Rule #79: propagate_undef_all_ops; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 21130 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner40),
     /* 21133 */ // Label 467: @21133
     /* 21133 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(21144), // Rule ID 99 //
     /* 21138 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule80Enabled),
     /* 21141 */   // Combiner Rule #80: propagate_undef_shuffle_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 21141 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner41),
     /* 21144 */ // Label 468: @21144
     /* 21144 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(21155), // Rule ID 345 //
     /* 21149 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule200Enabled),
     /* 21152 */   // Combiner Rule #200: combine_shuffle_concat; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 21152 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner136),
     /* 21155 */ // Label 469: @21155
     /* 21155 */ GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(21166), // Rule ID 347 //
     /* 21160 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule202Enabled),
     /* 21163 */   // Combiner Rule #202: combine_shuffle_disjoint_mask; wip_match_opcode 'G_SHUFFLE_VECTOR'
     /* 21163 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner138),
     /* 21166 */ // Label 470: @21166
     /* 21166 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(21187), // Rule ID 346 //
     /* 21171 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule201Enabled),
     /* 21174 */   // MIs[0] root
     /* 21174 */   // No operand predicates
     /* 21174 */   // MIs[0] src1
     /* 21174 */   // No operand predicates
     /* 21174 */   // MIs[0] undef
     /* 21174 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 21178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 21182 */   // MIs[0] mask
     /* 21182 */   // No operand predicates
     /* 21182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21184 */   // Combiner Rule #201: combine_shuffle_undef_rhs
     /* 21184 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner137),
     /* 21187 */ // Label 471: @21187
     /* 21187 */ GIM_Reject,
     /* 21188 */ // Label 94: @21188
     /* 21188 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(21232), // Rule ID 223 //
     /* 21193 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule160Enabled),
     /* 21196 */   // MIs[0] d
     /* 21196 */   // No operand predicates
     /* 21196 */   // MIs[0] src
     /* 21196 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 21204 */   // MIs[1] rev
     /* 21204 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 21208 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 21212 */   // MIs[2] val
     /* 21212 */   // No operand predicates
     /* 21212 */   // MIs[1] amt
     /* 21212 */   // No operand predicates
     /* 21212 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner9),
     /* 21216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21218 */   // Combiner Rule #160: bitreverse_lshr
     /* 21218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_SHL),
     /* 21221 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 21223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 21227 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 21231 */   GIR_EraseRootFromParent_Done,
     /* 21232 */ // Label 472: @21232
     /* 21232 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(21276), // Rule ID 222 //
     /* 21237 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule159Enabled),
     /* 21240 */   // MIs[0] d
     /* 21240 */   // No operand predicates
     /* 21240 */   // MIs[0] src
     /* 21240 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 21248 */   // MIs[1] rev
     /* 21248 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 21252 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITREVERSE),
     /* 21256 */   // MIs[2] val
     /* 21256 */   // No operand predicates
     /* 21256 */   // MIs[1] amt
     /* 21256 */   // No operand predicates
     /* 21256 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_GICombiner8),
     /* 21260 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 21262 */   // Combiner Rule #159: bitreverse_shl
     /* 21262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 21265 */   GIR_RootToRootCopy, /*OpIdx*/0, // d
     /* 21267 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 21271 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // amt
     /* 21275 */   GIR_EraseRootFromParent_Done,
     /* 21276 */ // Label 473: @21276
     /* 21276 */ GIM_Reject,
     /* 21277 */ // Label 95: @21277
     /* 21277 */ GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(21288), // Rule ID 374 //
     /* 21282 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule222Enabled),
     /* 21285 */   // Combiner Rule #222: rcp_sqrt_to_rsq; wip_match_opcode 'G_FSQRT'
     /* 21285 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner158),
     /* 21288 */ // Label 474: @21288
     /* 21288 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(21309), // Rule ID 178 //
     /* 21293 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule136Enabled),
     /* 21296 */   // MIs[0] dst
     /* 21296 */   // No operand predicates
     /* 21296 */   // MIs[0] src0
     /* 21296 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 21300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 21304 */   // MIs[1] cst
     /* 21304 */   // No operand predicates
     /* 21304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21306 */   // Combiner Rule #136: constant_fold_fsqrt
     /* 21306 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner81),
     /* 21309 */ // Label 475: @21309
     /* 21309 */ GIM_Reject,
     /* 21310 */ // Label 96: @21310
     /* 21310 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(21321), // Rule ID 367 //
     /* 21315 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 21318 */   // Combiner Rule #219: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE0'
     /* 21318 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 21321 */ // Label 476: @21321
     /* 21321 */ GIM_Reject,
     /* 21322 */ // Label 97: @21322
     /* 21322 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(21333), // Rule ID 368 //
     /* 21327 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 21330 */   // Combiner Rule #219: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE1'
     /* 21330 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 21333 */ // Label 477: @21333
     /* 21333 */ GIM_Reject,
     /* 21334 */ // Label 98: @21334
     /* 21334 */ GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(21345), // Rule ID 369 //
     /* 21339 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 21342 */   // Combiner Rule #219: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE2'
     /* 21342 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 21345 */ // Label 478: @21345
     /* 21345 */ GIM_Reject,
     /* 21346 */ // Label 99: @21346
     /* 21346 */ GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(21357), // Rule ID 370 //
     /* 21351 */   GIM_CheckSimplePredicate, GIMT_Encode2(GICXXPred_Simple_IsRule219Enabled),
     /* 21354 */   // Combiner Rule #219: cvt_f32_ubyteN; wip_match_opcode 'G_AMDGPU_CVT_F32_UBYTE3'
     /* 21354 */   GIR_DoneWithCustomAction, /*Fn*/GIMT_Encode2(GICXXCustomAction_GICombiner155),
     /* 21357 */ // Label 479: @21357
     /* 21357 */ GIM_Reject,
     /* 21358 */ // Label 100: @21358
     /* 21358 */ GIM_Reject,
     /* 21359 */ }; // Size: 21359 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GICOMBINER_IMPL

#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
#ifdef GET_GICOMBINER_CONSTRUCTOR_INITS
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GICOMBINER_CONSTRUCTOR_INITS

