/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the X86 target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 152;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(X86InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(X86InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static X86InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static X86InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(1),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s80,
  GILLT_s128,
  GILLT_v2s1,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s16,
  GILLT_v8s32,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
  GILLT_v16s16,
  GILLT_v16s32,
  GILLT_v32s1,
  GILLT_v32s8,
  GILLT_v32s16,
  GILLT_v64s1,
  GILLT_v64s8,
};
const static size_t NumTypeObjects = 25;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(80),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 32),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(16), 16),
  LLT::vector(ElementCount::getFixed(16), 32),
  LLT::vector(ElementCount::getFixed(32), 1),
  LLT::vector(ElementCount::getFixed(32), 8),
  LLT::vector(ElementCount::getFixed(32), 16),
  LLT::vector(ElementCount::getFixed(64), 1),
  LLT::vector(ElementCount::getFixed(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_TruePredicateBit = 63,
  Feature_HasEGPRBit = 5,
  Feature_NoEGPRBit = 4,
  Feature_HasNDDBit = 6,
  Feature_NoNDDBit = 27,
  Feature_HasZUBit = 151,
  Feature_HasCFBit = 30,
  Feature_HasCMOVBit = 29,
  Feature_NoCMOVBit = 137,
  Feature_HasMMXBit = 109,
  Feature_HasSSE1Bit = 49,
  Feature_UseSSE1Bit = 56,
  Feature_HasSSE2Bit = 48,
  Feature_UseSSE2Bit = 57,
  Feature_HasSSE3Bit = 40,
  Feature_UseSSE3Bit = 66,
  Feature_HasSSSE3Bit = 110,
  Feature_UseSSSE3Bit = 67,
  Feature_UseSSE41Bit = 64,
  Feature_UseSSE42Bit = 71,
  Feature_HasSSE4ABit = 81,
  Feature_NoAVXBit = 77,
  Feature_HasAVXBit = 58,
  Feature_HasAVX2Bit = 52,
  Feature_HasAVX1OnlyBit = 50,
  Feature_HasEVEX512Bit = 144,
  Feature_HasAVX10_2Bit = 108,
  Feature_HasAVX10_2_512Bit = 107,
  Feature_NoAVX10_2Bit = 70,
  Feature_HasAVX512Bit = 94,
  Feature_UseAVXBit = 54,
  Feature_NoAVX512Bit = 45,
  Feature_HasCDIBit = 98,
  Feature_HasVPOPCNTDQBit = 102,
  Feature_HasDQIBit = 96,
  Feature_NoDQIBit = 68,
  Feature_HasBWIBit = 97,
  Feature_NoBWIBit = 65,
  Feature_HasVLXBit = 95,
  Feature_NoVLXBit = 44,
  Feature_NoVLX_Or_NoBWIBit = 62,
  Feature_HasVNNIBit = 104,
  Feature_HasVP2INTERSECTBit = 106,
  Feature_HasFP16Bit = 100,
  Feature_HasAVXVNNIINT16Bit = 93,
  Feature_HasAVXVNNIINT8Bit = 88,
  Feature_HasAVXVNNIBit = 82,
  Feature_NoVLX_Or_NoVNNIBit = 83,
  Feature_HasBITALGBit = 105,
  Feature_HasPOPCNTBit = 69,
  Feature_HasAESBit = 74,
  Feature_HasVAESBit = 76,
  Feature_NoVLX_Or_NoVAESBit = 75,
  Feature_HasFXSRBit = 41,
  Feature_HasX87Bit = 39,
  Feature_HasXSAVEBit = 126,
  Feature_HasXSAVEOPTBit = 127,
  Feature_HasXSAVECBit = 128,
  Feature_HasXSAVESBit = 129,
  Feature_HasPCLMULBit = 78,
  Feature_NoVLX_Or_NoVPCLMULQDQBit = 79,
  Feature_HasVPCLMULQDQBit = 80,
  Feature_HasGFNIBit = 85,
  Feature_HasFMABit = 42,
  Feature_HasFMA4Bit = 46,
  Feature_NoFMA4Bit = 43,
  Feature_HasXOPBit = 47,
  Feature_HasTBMBit = 26,
  Feature_NoTBMBit = 142,
  Feature_HasLWPBit = 12,
  Feature_HasMOVBEBit = 3,
  Feature_NoNDD_Or_NoMOVBEBit = 2,
  Feature_HasRDRANDBit = 7,
  Feature_HasF16CBit = 84,
  Feature_HasFSGSBaseBit = 130,
  Feature_HasLZCNTBit = 9,
  Feature_HasBMIBit = 10,
  Feature_HasBMI2Bit = 11,
  Feature_NoBMI2Bit = 141,
  Feature_HasVBMIBit = 99,
  Feature_HasVBMI2Bit = 103,
  Feature_HasIFMABit = 101,
  Feature_HasAVXIFMABit = 86,
  Feature_NoVLX_Or_NoIFMABit = 87,
  Feature_HasRTMBit = 112,
  Feature_HasSHABit = 73,
  Feature_HasSHA512Bit = 90,
  Feature_HasSM3Bit = 91,
  Feature_HasRDSEEDBit = 8,
  Feature_HasSSEPrefetchBit = 59,
  Feature_HasPREFETCHIBit = 20,
  Feature_HasPrefetchWBit = 111,
  Feature_HasMWAITXBit = 140,
  Feature_HasCLDEMOTEBit = 24,
  Feature_HasMOVDIRIBit = 14,
  Feature_HasMOVDIR64BBit = 15,
  Feature_HasMOVRSBit = 25,
  Feature_HasPTWRITEBit = 133,
  Feature_FPStackf32Bit = 37,
  Feature_FPStackf64Bit = 38,
  Feature_HasSM4Bit = 92,
  Feature_HasCLFLUSHBit = 60,
  Feature_HasCLFLUSHOPTBit = 22,
  Feature_HasCLWBBit = 23,
  Feature_HasWBNOINVDBit = 125,
  Feature_HasRDPIDBit = 132,
  Feature_HasWAITPKGBit = 13,
  Feature_HasINVPCIDBit = 131,
  Feature_HasCX8Bit = 138,
  Feature_HasCX16Bit = 139,
  Feature_HasENQCMDBit = 16,
  Feature_HasAMXFP16Bit = 117,
  Feature_HasCMPCCXADDBit = 21,
  Feature_HasAVXNECONVERTBit = 89,
  Feature_HasKLBit = 113,
  Feature_HasRAOINTBit = 123,
  Feature_HasSERIALIZEBit = 17,
  Feature_HasTSXLDTRKBit = 18,
  Feature_HasAMXTILEBit = 114,
  Feature_HasAMXBF16Bit = 116,
  Feature_HasAMXINT8Bit = 115,
  Feature_HasAMXCOMPLEXBit = 118,
  Feature_HasAMXFP8Bit = 119,
  Feature_HasAMXTRANSPOSEBit = 120,
  Feature_HasAMXAVX512Bit = 121,
  Feature_HasAMXTF32Bit = 122,
  Feature_HasUINTRBit = 19,
  Feature_HasUSERMSRBit = 124,
  Feature_HasCRC32Bit = 72,
  Feature_Not64BitModeBit = 0,
  Feature_In64BitModeBit = 1,
  Feature_IsLP64Bit = 135,
  Feature_NotLP64Bit = 134,
  Feature_NotWin64WithoutFPBit = 136,
  Feature_IsPSBit = 146,
  Feature_NotPSBit = 145,
  Feature_KernelCodeBit = 147,
  Feature_NearDataBit = 149,
  Feature_IsNotPICBit = 148,
  Feature_OptForSizeBit = 53,
  Feature_OptForMinSizeBit = 51,
  Feature_OptForSpeedBit = 143,
  Feature_UseIncDecBit = 28,
  Feature_NoSSE41_Or_OptForSizeBit = 55,
  Feature_ImportCallOptimizationEnabledBit = 35,
  Feature_ImportCallOptimizationDisabledBit = 33,
  Feature_CallImmAddrBit = 150,
  Feature_FavorMemIndirectCallBit = 31,
  Feature_HasFastSHLDRotateBit = 36,
  Feature_HasMFenceBit = 61,
  Feature_UseIndirectThunkCallsBit = 34,
  Feature_NotUseIndirectThunkCallsBit = 32,
};

PredicateBitset X86InstructionSelector::
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (true)
    Features.set(Feature_TruePredicateBit);
  if (Subtarget->hasEGPR())
    Features.set(Feature_HasEGPRBit);
  if (!Subtarget->hasEGPR())
    Features.set(Feature_NoEGPRBit);
  if (Subtarget->hasNDD())
    Features.set(Feature_HasNDDBit);
  if (!Subtarget->hasNDD())
    Features.set(Feature_NoNDDBit);
  if (Subtarget->hasZU())
    Features.set(Feature_HasZUBit);
  if (Subtarget->hasCF())
    Features.set(Feature_HasCFBit);
  if (Subtarget->canUseCMOV())
    Features.set(Feature_HasCMOVBit);
  if (!Subtarget->canUseCMOV())
    Features.set(Feature_NoCMOVBit);
  if (Subtarget->hasMMX())
    Features.set(Feature_HasMMXBit);
  if (Subtarget->hasSSE1())
    Features.set(Feature_HasSSE1Bit);
  if (Subtarget->hasSSE1() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE1Bit);
  if (Subtarget->hasSSE2())
    Features.set(Feature_HasSSE2Bit);
  if (Subtarget->hasSSE2() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE2Bit);
  if (Subtarget->hasSSE3())
    Features.set(Feature_HasSSE3Bit);
  if (Subtarget->hasSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE3Bit);
  if (Subtarget->hasSSSE3())
    Features.set(Feature_HasSSSE3Bit);
  if (Subtarget->hasSSSE3() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSSE3Bit);
  if (Subtarget->hasSSE41() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE41Bit);
  if (Subtarget->hasSSE42() && !Subtarget->hasAVX())
    Features.set(Feature_UseSSE42Bit);
  if (Subtarget->hasSSE4A())
    Features.set(Feature_HasSSE4ABit);
  if (!Subtarget->hasAVX())
    Features.set(Feature_NoAVXBit);
  if (Subtarget->hasAVX())
    Features.set(Feature_HasAVXBit);
  if (Subtarget->hasAVX2())
    Features.set(Feature_HasAVX2Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX2())
    Features.set(Feature_HasAVX1OnlyBit);
  if (Subtarget->hasEVEX512())
    Features.set(Feature_HasEVEX512Bit);
  if (Subtarget->hasAVX10_2())
    Features.set(Feature_HasAVX10_2Bit);
  if (Subtarget->hasAVX10_2_512())
    Features.set(Feature_HasAVX10_2_512Bit);
  if (!Subtarget->hasAVX10_2())
    Features.set(Feature_NoAVX10_2Bit);
  if (Subtarget->hasAVX512())
    Features.set(Feature_HasAVX512Bit);
  if (Subtarget->hasAVX() && !Subtarget->hasAVX512())
    Features.set(Feature_UseAVXBit);
  if (!Subtarget->hasAVX512())
    Features.set(Feature_NoAVX512Bit);
  if (Subtarget->hasCDI())
    Features.set(Feature_HasCDIBit);
  if (Subtarget->hasVPOPCNTDQ())
    Features.set(Feature_HasVPOPCNTDQBit);
  if (Subtarget->hasDQI())
    Features.set(Feature_HasDQIBit);
  if (!Subtarget->hasDQI())
    Features.set(Feature_NoDQIBit);
  if (Subtarget->hasBWI())
    Features.set(Feature_HasBWIBit);
  if (!Subtarget->hasBWI())
    Features.set(Feature_NoBWIBit);
  if (Subtarget->hasVLX())
    Features.set(Feature_HasVLXBit);
  if (!Subtarget->hasVLX())
    Features.set(Feature_NoVLXBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasBWI())
    Features.set(Feature_NoVLX_Or_NoBWIBit);
  if (Subtarget->hasVNNI())
    Features.set(Feature_HasVNNIBit);
  if (Subtarget->hasVP2INTERSECT())
    Features.set(Feature_HasVP2INTERSECTBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasAVXVNNIINT16())
    Features.set(Feature_HasAVXVNNIINT16Bit);
  if (Subtarget->hasAVXVNNIINT8())
    Features.set(Feature_HasAVXVNNIINT8Bit);
  if (Subtarget->hasAVXVNNI())
    Features.set(Feature_HasAVXVNNIBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVNNI())
    Features.set(Feature_NoVLX_Or_NoVNNIBit);
  if (Subtarget->hasBITALG())
    Features.set(Feature_HasBITALGBit);
  if (Subtarget->hasPOPCNT())
    Features.set(Feature_HasPOPCNTBit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasVAES())
    Features.set(Feature_HasVAESBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVAES())
    Features.set(Feature_NoVLX_Or_NoVAESBit);
  if (Subtarget->hasFXSR())
    Features.set(Feature_HasFXSRBit);
  if (Subtarget->hasX87())
    Features.set(Feature_HasX87Bit);
  if (Subtarget->hasXSAVE())
    Features.set(Feature_HasXSAVEBit);
  if (Subtarget->hasXSAVEOPT())
    Features.set(Feature_HasXSAVEOPTBit);
  if (Subtarget->hasXSAVEC())
    Features.set(Feature_HasXSAVECBit);
  if (Subtarget->hasXSAVES())
    Features.set(Feature_HasXSAVESBit);
  if (Subtarget->hasPCLMUL())
    Features.set(Feature_HasPCLMULBit);
  if (!Subtarget->hasVLX() || !Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_NoVLX_Or_NoVPCLMULQDQBit);
  if (Subtarget->hasVPCLMULQDQ())
    Features.set(Feature_HasVPCLMULQDQBit);
  if (Subtarget->hasGFNI())
    Features.set(Feature_HasGFNIBit);
  if (Subtarget->hasFMA())
    Features.set(Feature_HasFMABit);
  if (Subtarget->hasFMA4())
    Features.set(Feature_HasFMA4Bit);
  if (!Subtarget->hasFMA4())
    Features.set(Feature_NoFMA4Bit);
  if (Subtarget->hasXOP())
    Features.set(Feature_HasXOPBit);
  if (Subtarget->hasTBM())
    Features.set(Feature_HasTBMBit);
  if (!Subtarget->hasTBM())
    Features.set(Feature_NoTBMBit);
  if (Subtarget->hasLWP())
    Features.set(Feature_HasLWPBit);
  if (Subtarget->hasMOVBE())
    Features.set(Feature_HasMOVBEBit);
  if (!Subtarget->hasNDD() || !Subtarget->hasMOVBE())
    Features.set(Feature_NoNDD_Or_NoMOVBEBit);
  if (Subtarget->hasRDRAND())
    Features.set(Feature_HasRDRANDBit);
  if (Subtarget->hasF16C())
    Features.set(Feature_HasF16CBit);
  if (Subtarget->hasFSGSBase())
    Features.set(Feature_HasFSGSBaseBit);
  if (Subtarget->hasLZCNT())
    Features.set(Feature_HasLZCNTBit);
  if (Subtarget->hasBMI())
    Features.set(Feature_HasBMIBit);
  if (Subtarget->hasBMI2())
    Features.set(Feature_HasBMI2Bit);
  if (!Subtarget->hasBMI2())
    Features.set(Feature_NoBMI2Bit);
  if (Subtarget->hasVBMI())
    Features.set(Feature_HasVBMIBit);
  if (Subtarget->hasVBMI2())
    Features.set(Feature_HasVBMI2Bit);
  if (Subtarget->hasIFMA())
    Features.set(Feature_HasIFMABit);
  if (Subtarget->hasAVXIFMA())
    Features.set(Feature_HasAVXIFMABit);
  if (!Subtarget->hasVLX() || !Subtarget->hasIFMA())
    Features.set(Feature_NoVLX_Or_NoIFMABit);
  if (Subtarget->hasRTM())
    Features.set(Feature_HasRTMBit);
  if (Subtarget->hasSHA())
    Features.set(Feature_HasSHABit);
  if (Subtarget->hasSHA512())
    Features.set(Feature_HasSHA512Bit);
  if (Subtarget->hasSM3())
    Features.set(Feature_HasSM3Bit);
  if (Subtarget->hasRDSEED())
    Features.set(Feature_HasRDSEEDBit);
  if (Subtarget->hasSSEPrefetch())
    Features.set(Feature_HasSSEPrefetchBit);
  if (Subtarget->hasPREFETCHI())
    Features.set(Feature_HasPREFETCHIBit);
  if (Subtarget->hasPrefetchW())
    Features.set(Feature_HasPrefetchWBit);
  if (Subtarget->hasMWAITX())
    Features.set(Feature_HasMWAITXBit);
  if (Subtarget->hasCLDEMOTE())
    Features.set(Feature_HasCLDEMOTEBit);
  if (Subtarget->hasMOVDIRI())
    Features.set(Feature_HasMOVDIRIBit);
  if (Subtarget->hasMOVDIR64B())
    Features.set(Feature_HasMOVDIR64BBit);
  if (Subtarget->hasMOVRS())
    Features.set(Feature_HasMOVRSBit);
  if (Subtarget->hasPTWRITE())
    Features.set(Feature_HasPTWRITEBit);
  if (!Subtarget->hasSSE1())
    Features.set(Feature_FPStackf32Bit);
  if (!Subtarget->hasSSE2())
    Features.set(Feature_FPStackf64Bit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasCLFLUSH())
    Features.set(Feature_HasCLFLUSHBit);
  if (Subtarget->hasCLFLUSHOPT())
    Features.set(Feature_HasCLFLUSHOPTBit);
  if (Subtarget->hasCLWB())
    Features.set(Feature_HasCLWBBit);
  if (Subtarget->hasWBNOINVD())
    Features.set(Feature_HasWBNOINVDBit);
  if (Subtarget->hasRDPID())
    Features.set(Feature_HasRDPIDBit);
  if (Subtarget->hasWAITPKG())
    Features.set(Feature_HasWAITPKGBit);
  if (Subtarget->hasINVPCID())
    Features.set(Feature_HasINVPCIDBit);
  if (Subtarget->hasCX8())
    Features.set(Feature_HasCX8Bit);
  if (Subtarget->hasCX16())
    Features.set(Feature_HasCX16Bit);
  if (Subtarget->hasENQCMD())
    Features.set(Feature_HasENQCMDBit);
  if (Subtarget->hasAMXFP16())
    Features.set(Feature_HasAMXFP16Bit);
  if (Subtarget->hasCMPCCXADD())
    Features.set(Feature_HasCMPCCXADDBit);
  if (Subtarget->hasAVXNECONVERT())
    Features.set(Feature_HasAVXNECONVERTBit);
  if (Subtarget->hasKL())
    Features.set(Feature_HasKLBit);
  if (Subtarget->hasRAOINT())
    Features.set(Feature_HasRAOINTBit);
  if (Subtarget->hasSERIALIZE())
    Features.set(Feature_HasSERIALIZEBit);
  if (Subtarget->hasTSXLDTRK())
    Features.set(Feature_HasTSXLDTRKBit);
  if (Subtarget->hasAMXTILE())
    Features.set(Feature_HasAMXTILEBit);
  if (Subtarget->hasAMXBF16())
    Features.set(Feature_HasAMXBF16Bit);
  if (Subtarget->hasAMXINT8())
    Features.set(Feature_HasAMXINT8Bit);
  if (Subtarget->hasAMXCOMPLEX())
    Features.set(Feature_HasAMXCOMPLEXBit);
  if (Subtarget->hasAMXFP8())
    Features.set(Feature_HasAMXFP8Bit);
  if (Subtarget->hasAMXTRANSPOSE())
    Features.set(Feature_HasAMXTRANSPOSEBit);
  if (Subtarget->hasAMXAVX512())
    Features.set(Feature_HasAMXAVX512Bit);
  if (Subtarget->hasAMXTF32())
    Features.set(Feature_HasAMXTF32Bit);
  if (Subtarget->hasUINTR())
    Features.set(Feature_HasUINTRBit);
  if (Subtarget->hasUSERMSR())
    Features.set(Feature_HasUSERMSRBit);
  if (Subtarget->hasCRC32())
    Features.set(Feature_HasCRC32Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_Not64BitModeBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->isTarget64BitLP64())
    Features.set(Feature_IsLP64Bit);
  if (!Subtarget->isTarget64BitLP64())
    Features.set(Feature_NotLP64Bit);
  if (Subtarget->isTargetPS())
    Features.set(Feature_IsPSBit);
  if (!Subtarget->isTargetPS())
    Features.set(Feature_NotPSBit);
  if (TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_KernelCodeBit);
  if (TM.getCodeModel() == CodeModel::Small ||TM.getCodeModel() == CodeModel::Kernel)
    Features.set(Feature_NearDataBit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_IsNotPICBit);
  if (Subtarget->isLegalToCallImmediateAddr())
    Features.set(Feature_CallImmAddrBit);
  if (!Subtarget->slowTwoMemOps())
    Features.set(Feature_FavorMemIndirectCallBit);
  if (Subtarget->hasFastSHLDRotate())
    Features.set(Feature_HasFastSHLDRotateBit);
  if (Subtarget->hasMFence())
    Features.set(Feature_HasMFenceBit);
  if (Subtarget->useIndirectThunkCalls())
    Features.set(Feature_UseIndirectThunkCallsBit);
  if (!Subtarget->useIndirectThunkCalls())
    Features.set(Feature_NotUseIndirectThunkCallsBit);
  return Features;
}

void X86InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const X86Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset X86InstructionSelector::
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!Subtarget->isTargetWin64() ||Subtarget->getFrameLowering()->hasFP(*MF))
    Features.set(Feature_NotWin64WithoutFPBit);
  if (shouldOptForSize(MF))
    Features.set(Feature_OptForSizeBit);
  if (MF->getFunction().hasMinSize())
    Features.set(Feature_OptForMinSizeBit);
  if (!shouldOptForSize(MF))
    Features.set(Feature_OptForSpeedBit);
  if (!Subtarget->slowIncDec() || shouldOptForSize(MF))
    Features.set(Feature_UseIncDecBit);
  if (shouldOptForSize(MF) || !Subtarget->hasSSE41())
    Features.set(Feature_NoSSE41_Or_OptForSizeBit);
  if (MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationEnabledBit);
  if (!MF->getFunction().getParent()->getModuleFlag("import-call-optimization"))
    Features.set(Feature_ImportCallOptimizationDisabledBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_FPStackf32,
  GIFBS_FPStackf64,
  GIFBS_HasAVX,
  GIFBS_HasAVX1Only,
  GIFBS_HasAVX2,
  GIFBS_HasAVX512,
  GIFBS_HasAVXNECONVERT,
  GIFBS_HasBITALG,
  GIFBS_HasBMI,
  GIFBS_HasBWI,
  GIFBS_HasCDI,
  GIFBS_HasCLDEMOTE,
  GIFBS_HasCLFLUSH,
  GIFBS_HasCLFLUSHOPT,
  GIFBS_HasCLWB,
  GIFBS_HasDQI,
  GIFBS_HasFP16,
  GIFBS_HasFXSR,
  GIFBS_HasFastSHLDRotate,
  GIFBS_HasKL,
  GIFBS_HasLWP,
  GIFBS_HasLZCNT,
  GIFBS_HasMFence,
  GIFBS_HasMMX,
  GIFBS_HasMOVBE,
  GIFBS_HasMOVRS,
  GIFBS_HasMWAITX,
  GIFBS_HasNDD,
  GIFBS_HasPOPCNT,
  GIFBS_HasPTWRITE,
  GIFBS_HasPrefetchW,
  GIFBS_HasRTM,
  GIFBS_HasSERIALIZE,
  GIFBS_HasSHA,
  GIFBS_HasSHA512,
  GIFBS_HasSM3,
  GIFBS_HasSM4,
  GIFBS_HasSSE1,
  GIFBS_HasSSE2,
  GIFBS_HasSSE3,
  GIFBS_HasSSE4A,
  GIFBS_HasSSEPrefetch,
  GIFBS_HasTBM,
  GIFBS_HasTSXLDTRK,
  GIFBS_HasVBMI2,
  GIFBS_HasVLX,
  GIFBS_HasVPOPCNTDQ,
  GIFBS_HasWAITPKG,
  GIFBS_HasWBNOINVD,
  GIFBS_HasX87,
  GIFBS_HasXOP,
  GIFBS_HasXSAVE,
  GIFBS_HasXSAVEC,
  GIFBS_HasXSAVEOPT,
  GIFBS_HasXSAVES,
  GIFBS_HasZU,
  GIFBS_In64BitMode,
  GIFBS_IsPS,
  GIFBS_NoAVX,
  GIFBS_NoDQI,
  GIFBS_NoEGPR,
  GIFBS_NoNDD,
  GIFBS_NoNDD_Or_NoMOVBE,
  GIFBS_Not64BitMode,
  GIFBS_NotPS,
  GIFBS_UseAVX,
  GIFBS_UseIncDec,
  GIFBS_UseSSE1,
  GIFBS_UseSSE2,
  GIFBS_UseSSE3,
  GIFBS_UseSSE41,
  GIFBS_UseSSSE3,
  GIFBS_HasAES_HasAVX,
  GIFBS_HasAES_NoAVX,
  GIFBS_HasAMXBF16_In64BitMode,
  GIFBS_HasAMXCOMPLEX_In64BitMode,
  GIFBS_HasAMXFP16_In64BitMode,
  GIFBS_HasAMXFP8_In64BitMode,
  GIFBS_HasAMXINT8_In64BitMode,
  GIFBS_HasAMXTF32_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode,
  GIFBS_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAVX_In64BitMode,
  GIFBS_HasAVX_NoBWI,
  GIFBS_HasAVX_NoVLX,
  GIFBS_HasAVX_NoVLX_Or_NoBWI,
  GIFBS_HasAVX10_2_HasSM4,
  GIFBS_HasAVX10_2_512_HasSM4,
  GIFBS_HasAVX2_NoVLX,
  GIFBS_HasAVX2_NoVLX_Or_NoBWI,
  GIFBS_HasAVX512_HasVAES,
  GIFBS_HasAVX512_HasVLX,
  GIFBS_HasAVX512_HasVPCLMULQDQ,
  GIFBS_HasAVX512_NoBWI,
  GIFBS_HasAVX512_NoDQI,
  GIFBS_HasAVX512_NoEGPR,
  GIFBS_HasAVX512_OptForSize,
  GIFBS_HasBITALG_HasVLX,
  GIFBS_HasBMI_HasEGPR,
  GIFBS_HasBMI_NoEGPR,
  GIFBS_HasBMI2_HasEGPR,
  GIFBS_HasBMI2_NoEGPR,
  GIFBS_HasBWI_HasVLX,
  GIFBS_HasBWI_NoEGPR,
  GIFBS_HasCDI_HasVLX,
  GIFBS_HasCRC32_NoEGPR,
  GIFBS_HasDQI_HasVLX,
  GIFBS_HasDQI_NoBWI,
  GIFBS_HasDQI_NoEGPR,
  GIFBS_HasEGPR_HasINVPCID,
  GIFBS_HasEGPR_In64BitMode,
  GIFBS_HasEVEX512_NoVLX,
  GIFBS_HasFMA4_NoAVX512,
  GIFBS_HasFMA4_NoVLX,
  GIFBS_HasFP16_HasVLX,
  GIFBS_HasFP16_In64BitMode,
  GIFBS_HasFP16_OptForSize,
  GIFBS_HasFSGSBase_In64BitMode,
  GIFBS_HasFXSR_In64BitMode,
  GIFBS_HasINVPCID_NoEGPR,
  GIFBS_HasINVPCID_Not64BitMode,
  GIFBS_HasMOVBE_NoEGPR,
  GIFBS_HasMOVDIR64B_NoEGPR,
  GIFBS_HasMOVDIRI_NoEGPR,
  GIFBS_HasNDD_In64BitMode,
  GIFBS_HasNDD_UseIncDec,
  GIFBS_HasPCLMUL_NoAVX,
  GIFBS_HasPREFETCHI_In64BitMode,
  GIFBS_HasPTWRITE_In64BitMode,
  GIFBS_HasRDPID_In64BitMode,
  GIFBS_HasRDPID_Not64BitMode,
  GIFBS_HasUINTR_In64BitMode,
  GIFBS_HasUSERMSR_NoEGPR,
  GIFBS_HasVAES_HasVLX,
  GIFBS_HasVAES_NoVLX,
  GIFBS_HasVBMI2_HasVLX,
  GIFBS_HasVLX_HasVPCLMULQDQ,
  GIFBS_HasVLX_HasVPOPCNTDQ,
  GIFBS_HasVPCLMULQDQ_NoVLX,
  GIFBS_HasWAITPKG_In64BitMode,
  GIFBS_HasWAITPKG_Not64BitMode,
  GIFBS_HasXSAVE_In64BitMode,
  GIFBS_HasXSAVEC_In64BitMode,
  GIFBS_HasXSAVEOPT_In64BitMode,
  GIFBS_HasXSAVES_In64BitMode,
  GIFBS_In64BitMode_UseIncDec,
  GIFBS_In64BitMode_UseSSE2,
  GIFBS_NoNDD_UseIncDec,
  GIFBS_Not64BitMode_OptForSize,
  GIFBS_NotWin64WithoutFP_OptForMinSize,
  GIFBS_OptForSize_UseAVX,
  GIFBS_OptForSize_UseSSE1,
  GIFBS_OptForSize_UseSSE2,
  GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES,
  GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode,
  GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode,
  GIFBS_HasAMXTILE_HasEGPR_In64BitMode,
  GIFBS_HasAMXTILE_In64BitMode_NoEGPR,
  GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ,
  GIFBS_HasAVX10_2_HasMOVRS_In64BitMode,
  GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode,
  GIFBS_HasAVX512_HasEGPR_In64BitMode,
  GIFBS_HasAVX512_HasEVEX512_NoVLX,
  GIFBS_HasBITALG_HasEVEX512_NoVLX,
  GIFBS_HasBWI_HasEGPR_In64BitMode,
  GIFBS_HasBWI_HasEVEX512_NoVLX,
  GIFBS_HasCDI_HasEVEX512_NoVLX,
  GIFBS_HasCRC32_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEGPR_In64BitMode,
  GIFBS_HasDQI_HasEVEX512_NoVLX,
  GIFBS_HasDQI_HasVLX_NoBWI,
  GIFBS_HasEGPR_HasMOVBE_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode,
  GIFBS_HasEGPR_HasMOVDIRI_In64BitMode,
  GIFBS_HasEGPR_HasMOVRS_In64BitMode,
  GIFBS_HasEGPR_HasUSERMSR_In64BitMode,
  GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX,
  GIFBS_HasFMA_NoAVX512_NoFMA4,
  GIFBS_HasFMA_NoFMA4_NoVLX,
  GIFBS_HasMOVBE_HasNDD_In64BitMode,
  GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR,
  GIFBS_HasMOVDIRI_In64BitMode_NoEGPR,
  GIFBS_HasMOVRS_In64BitMode_NoEGPR,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_FPStackf32Bit, },
  {Feature_FPStackf64Bit, },
  {Feature_HasAVXBit, },
  {Feature_HasAVX1OnlyBit, },
  {Feature_HasAVX2Bit, },
  {Feature_HasAVX512Bit, },
  {Feature_HasAVXNECONVERTBit, },
  {Feature_HasBITALGBit, },
  {Feature_HasBMIBit, },
  {Feature_HasBWIBit, },
  {Feature_HasCDIBit, },
  {Feature_HasCLDEMOTEBit, },
  {Feature_HasCLFLUSHBit, },
  {Feature_HasCLFLUSHOPTBit, },
  {Feature_HasCLWBBit, },
  {Feature_HasDQIBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFXSRBit, },
  {Feature_HasFastSHLDRotateBit, },
  {Feature_HasKLBit, },
  {Feature_HasLWPBit, },
  {Feature_HasLZCNTBit, },
  {Feature_HasMFenceBit, },
  {Feature_HasMMXBit, },
  {Feature_HasMOVBEBit, },
  {Feature_HasMOVRSBit, },
  {Feature_HasMWAITXBit, },
  {Feature_HasNDDBit, },
  {Feature_HasPOPCNTBit, },
  {Feature_HasPTWRITEBit, },
  {Feature_HasPrefetchWBit, },
  {Feature_HasRTMBit, },
  {Feature_HasSERIALIZEBit, },
  {Feature_HasSHABit, },
  {Feature_HasSHA512Bit, },
  {Feature_HasSM3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSSE1Bit, },
  {Feature_HasSSE2Bit, },
  {Feature_HasSSE3Bit, },
  {Feature_HasSSE4ABit, },
  {Feature_HasSSEPrefetchBit, },
  {Feature_HasTBMBit, },
  {Feature_HasTSXLDTRKBit, },
  {Feature_HasVBMI2Bit, },
  {Feature_HasVLXBit, },
  {Feature_HasVPOPCNTDQBit, },
  {Feature_HasWAITPKGBit, },
  {Feature_HasWBNOINVDBit, },
  {Feature_HasX87Bit, },
  {Feature_HasXOPBit, },
  {Feature_HasXSAVEBit, },
  {Feature_HasXSAVECBit, },
  {Feature_HasXSAVEOPTBit, },
  {Feature_HasXSAVESBit, },
  {Feature_HasZUBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsPSBit, },
  {Feature_NoAVXBit, },
  {Feature_NoDQIBit, },
  {Feature_NoEGPRBit, },
  {Feature_NoNDDBit, },
  {Feature_NoNDD_Or_NoMOVBEBit, },
  {Feature_Not64BitModeBit, },
  {Feature_NotPSBit, },
  {Feature_UseAVXBit, },
  {Feature_UseIncDecBit, },
  {Feature_UseSSE1Bit, },
  {Feature_UseSSE2Bit, },
  {Feature_UseSSE3Bit, },
  {Feature_UseSSE41Bit, },
  {Feature_UseSSSE3Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, },
  {Feature_HasAESBit, Feature_NoAVXBit, },
  {Feature_HasAMXBF16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXINT8Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_In64BitModeBit, },
  {Feature_HasAVXBit, Feature_NoBWIBit, },
  {Feature_HasAVXBit, Feature_NoVLXBit, },
  {Feature_HasAVXBit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX10_2Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasSM4Bit, },
  {Feature_HasAVX2Bit, Feature_NoVLXBit, },
  {Feature_HasAVX2Bit, Feature_NoVLX_Or_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_HasVAESBit, },
  {Feature_HasAVX512Bit, Feature_HasVLXBit, },
  {Feature_HasAVX512Bit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasAVX512Bit, Feature_NoBWIBit, },
  {Feature_HasAVX512Bit, Feature_NoDQIBit, },
  {Feature_HasAVX512Bit, Feature_NoEGPRBit, },
  {Feature_HasAVX512Bit, Feature_OptForSizeBit, },
  {Feature_HasBITALGBit, Feature_HasVLXBit, },
  {Feature_HasBMIBit, Feature_HasEGPRBit, },
  {Feature_HasBMIBit, Feature_NoEGPRBit, },
  {Feature_HasBMI2Bit, Feature_HasEGPRBit, },
  {Feature_HasBMI2Bit, Feature_NoEGPRBit, },
  {Feature_HasBWIBit, Feature_HasVLXBit, },
  {Feature_HasBWIBit, Feature_NoEGPRBit, },
  {Feature_HasCDIBit, Feature_HasVLXBit, },
  {Feature_HasCRC32Bit, Feature_NoEGPRBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, },
  {Feature_HasDQIBit, Feature_NoBWIBit, },
  {Feature_HasDQIBit, Feature_NoEGPRBit, },
  {Feature_HasEGPRBit, Feature_HasINVPCIDBit, },
  {Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasFMA4Bit, Feature_NoAVX512Bit, },
  {Feature_HasFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasFP16Bit, Feature_HasVLXBit, },
  {Feature_HasFP16Bit, Feature_In64BitModeBit, },
  {Feature_HasFP16Bit, Feature_OptForSizeBit, },
  {Feature_HasFSGSBaseBit, Feature_In64BitModeBit, },
  {Feature_HasFXSRBit, Feature_In64BitModeBit, },
  {Feature_HasINVPCIDBit, Feature_NoEGPRBit, },
  {Feature_HasINVPCIDBit, Feature_Not64BitModeBit, },
  {Feature_HasMOVBEBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIR64BBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_NoEGPRBit, },
  {Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasNDDBit, Feature_UseIncDecBit, },
  {Feature_HasPCLMULBit, Feature_NoAVXBit, },
  {Feature_HasPREFETCHIBit, Feature_In64BitModeBit, },
  {Feature_HasPTWRITEBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_In64BitModeBit, },
  {Feature_HasRDPIDBit, Feature_Not64BitModeBit, },
  {Feature_HasUINTRBit, Feature_In64BitModeBit, },
  {Feature_HasUSERMSRBit, Feature_NoEGPRBit, },
  {Feature_HasVAESBit, Feature_HasVLXBit, },
  {Feature_HasVAESBit, Feature_NoVLXBit, },
  {Feature_HasVBMI2Bit, Feature_HasVLXBit, },
  {Feature_HasVLXBit, Feature_HasVPCLMULQDQBit, },
  {Feature_HasVLXBit, Feature_HasVPOPCNTDQBit, },
  {Feature_HasVPCLMULQDQBit, Feature_NoVLXBit, },
  {Feature_HasWAITPKGBit, Feature_In64BitModeBit, },
  {Feature_HasWAITPKGBit, Feature_Not64BitModeBit, },
  {Feature_HasXSAVEBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVECBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVEOPTBit, Feature_In64BitModeBit, },
  {Feature_HasXSAVESBit, Feature_In64BitModeBit, },
  {Feature_In64BitModeBit, Feature_UseIncDecBit, },
  {Feature_In64BitModeBit, Feature_UseSSE2Bit, },
  {Feature_NoNDDBit, Feature_UseIncDecBit, },
  {Feature_Not64BitModeBit, Feature_OptForSizeBit, },
  {Feature_NotWin64WithoutFPBit, Feature_OptForMinSizeBit, },
  {Feature_OptForSizeBit, Feature_UseAVXBit, },
  {Feature_OptForSizeBit, Feature_UseSSE1Bit, },
  {Feature_OptForSizeBit, Feature_UseSSE2Bit, },
  {Feature_HasAESBit, Feature_HasAVXBit, Feature_NoVLX_Or_NoVAESBit, },
  {Feature_HasAMXAVX512Bit, Feature_HasAVX10_2_512Bit, Feature_In64BitModeBit, },
  {Feature_HasAMXBF16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXCOMPLEXBit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXFP16Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTF32Bit, Feature_HasAMXTRANSPOSEBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAMXTILEBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasAVXBit, Feature_HasPCLMULBit, Feature_NoVLX_Or_NoVPCLMULQDQBit, },
  {Feature_HasAVX10_2Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX10_2_512Bit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasAVX512Bit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBITALGBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasBWIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasBWIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCDIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasCRC32Bit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEGPRBit, Feature_In64BitModeBit, },
  {Feature_HasDQIBit, Feature_HasEVEX512Bit, Feature_NoVLXBit, },
  {Feature_HasDQIBit, Feature_HasVLXBit, Feature_NoBWIBit, },
  {Feature_HasEGPRBit, Feature_HasMOVBEBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVDIRIBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasMOVRSBit, Feature_In64BitModeBit, },
  {Feature_HasEGPRBit, Feature_HasUSERMSRBit, Feature_In64BitModeBit, },
  {Feature_HasEVEX512Bit, Feature_HasVPOPCNTDQBit, Feature_NoVLXBit, },
  {Feature_HasFMABit, Feature_NoAVX512Bit, Feature_NoFMA4Bit, },
  {Feature_HasFMABit, Feature_NoFMA4Bit, Feature_NoVLXBit, },
  {Feature_HasMOVBEBit, Feature_HasNDDBit, Feature_In64BitModeBit, },
  {Feature_HasMOVDIR64BBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVDIRIBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
  {Feature_HasMOVRSBit, Feature_In64BitModeBit, Feature_NoEGPRBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addr,
};
// See constructor for table contents

X86InstructionSelector::ComplexMatcherMemFn
X86InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &X86InstructionSelector::selectAddr, // gi_addr
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_alignedload = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_alignedstore,
  GICXXPred_MI_Predicate_imm_su,
  GICXXPred_MI_Predicate_loadi8,
  GICXXPred_MI_Predicate_loadi16,
  GICXXPred_MI_Predicate_loadi32,
  GICXXPred_MI_Predicate_or_disjoint,
};
bool X86InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_alignedload: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedload should have returned");
  }
  case GICXXPred_MI_Predicate_alignedstore: {
    
        auto &LdSt = cast<GLoadStore>(MI);
        return LdSt.getAlign() >= LdSt.getMemSize().getValue();
      
    llvm_unreachable("alignedstore should have returned");
  }
  case GICXXPred_MI_Predicate_imm_su: {
     return true; 
  }
  case GICXXPred_MI_Predicate_loadi8: {
     return isa<GLoad>(MI); 
  }
  case GICXXPred_MI_Predicate_loadi16: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 2 && Load.isSimple();
      
    llvm_unreachable("loadi16 should have returned");
  }
  case GICXXPred_MI_Predicate_loadi32: {
    
        auto &Load = cast<GLoad>(MI);
        LLT Ty = MRI.getType(Load.getDstReg());
        // Non extending load has MMO and destination types of the same size
        if (Load.getMemSizeInBits() == Ty.getSizeInBits())
           return true;
        return Load.getAlign() >= 4 && Load.isSimple();
      
    llvm_unreachable("loadi32 should have returned");
  }
  case GICXXPred_MI_Predicate_or_disjoint: {
    
        return MI.getFlag(MachineInstr::Disjoint);
      
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AndMask64 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BTCBTSMask64,
  GICXXPred_I64_Predicate_BTRMask64,
  GICXXPred_I64_Predicate_i16immSExt8,
  GICXXPred_I64_Predicate_i32immSExt8,
  GICXXPred_I64_Predicate_i64immSExt8,
  GICXXPred_I64_Predicate_i64immSExt32,
  GICXXPred_I64_Predicate_i64immZExt32,
  GICXXPred_I64_Predicate_i64immZExt32SExt8,
  GICXXPred_I64_Predicate_i64timmSExt32,
  GICXXPred_I64_Predicate_immff00_ffff,
};
bool X86InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AndMask64: {
    
      return isMask_64(Imm) && !isUInt<32>(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTCBTSMask64: {
    
      return !isInt<32>(Imm) && isPowerOf2_64(Imm);
    
  }
  case GICXXPred_I64_Predicate_BTRMask64: {
    
      return !isUInt<32>(Imm) && !isInt<32>(Imm) && isPowerOf2_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_i16immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt8: {
     return isInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32: {
     return isUInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_i64immZExt32SExt8: {
    
      return isUInt<32>(Imm) && isInt<8>(static_cast<int32_t>(Imm));
    
  }
  case GICXXPred_I64_Predicate_i64timmSExt32: {
     return isInt<32>(Imm); 
  }
  case GICXXPred_I64_Predicate_immff00_ffff: {
    
      return Imm >= 0xff00 && Imm <= 0xffff;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm1,
  GICXXPred_APFloat_Predicate_fpimmneg0,
  GICXXPred_APFloat_Predicate_fpimmneg1,
};
bool X86InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm1: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmneg1: {
    
      return Imm.isExactlyValue(-1.0);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool X86InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool X86InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("X86InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
X86InstructionSelector::CustomRendererFn
X86InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool X86InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool X86InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("X86InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *X86InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(346), /*)*//*default:*//*Label 80*/ GIMT_Encode4(236852),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1182),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(7415),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(10951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 3*/ GIMT_Encode4(14734),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 4*/ GIMT_Encode4(25326),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 5*/ GIMT_Encode4(33730), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 6*/ GIMT_Encode4(46431), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 7*/ GIMT_Encode4(46598), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 8*/ GIMT_Encode4(48888),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 9*/ GIMT_Encode4(52066), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 10*/ GIMT_Encode4(53286),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 11*/ GIMT_Encode4(59511),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 12*/ GIMT_Encode4(59844), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 13*/ GIMT_Encode4(60499), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 14*/ GIMT_Encode4(85962),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 15*/ GIMT_Encode4(86198), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    298 */ /*TargetOpcode::G_PREFETCH*//*Label 16*/ GIMT_Encode4(86446), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 17*/ GIMT_Encode4(86765),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 18*/ GIMT_Encode4(100591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 19*/ GIMT_Encode4(109666),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 20*/ GIMT_Encode4(110101), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    350 */ /*TargetOpcode::G_CONSTANT*//*Label 21*/ GIMT_Encode4(111190),
     /*    354 */ /*TargetOpcode::G_FCONSTANT*//*Label 22*/ GIMT_Encode4(111796), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    366 */ /*TargetOpcode::G_SEXT*//*Label 23*/ GIMT_Encode4(112249),
     /*    370 */ /*TargetOpcode::G_SEXT_INREG*//*Label 24*/ GIMT_Encode4(113921),
     /*    374 */ /*TargetOpcode::G_ZEXT*//*Label 25*/ GIMT_Encode4(114163),
     /*    378 */ /*TargetOpcode::G_SHL*//*Label 26*/ GIMT_Encode4(116147),
     /*    382 */ /*TargetOpcode::G_LSHR*//*Label 27*/ GIMT_Encode4(118431),
     /*    386 */ /*TargetOpcode::G_ASHR*//*Label 28*/ GIMT_Encode4(120475),
     /*    390 */ /*TargetOpcode::G_FSHL*//*Label 29*/ GIMT_Encode4(122519),
     /*    394 */ /*TargetOpcode::G_FSHR*//*Label 30*/ GIMT_Encode4(123247),
     /*    398 */ /*TargetOpcode::G_ROTR*//*Label 31*/ GIMT_Encode4(123935),
     /*    402 */ /*TargetOpcode::G_ROTL*//*Label 32*/ GIMT_Encode4(127433),
     /*    406 */ /*TargetOpcode::G_ICMP*//*Label 33*/ GIMT_Encode4(131153), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    422 */ /*TargetOpcode::G_SELECT*//*Label 34*/ GIMT_Encode4(132810), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    466 */ /*TargetOpcode::G_UMULH*//*Label 35*/ GIMT_Encode4(140476),
     /*    470 */ /*TargetOpcode::G_SMULH*//*Label 36*/ GIMT_Encode4(141341),
     /*    474 */ /*TargetOpcode::G_UADDSAT*//*Label 37*/ GIMT_Encode4(142206),
     /*    478 */ /*TargetOpcode::G_SADDSAT*//*Label 38*/ GIMT_Encode4(143892),
     /*    482 */ /*TargetOpcode::G_USUBSAT*//*Label 39*/ GIMT_Encode4(145578),
     /*    486 */ /*TargetOpcode::G_SSUBSAT*//*Label 40*/ GIMT_Encode4(146644), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FADD*//*Label 41*/ GIMT_Encode4(147710),
     /*    534 */ /*TargetOpcode::G_FSUB*//*Label 42*/ GIMT_Encode4(153624),
     /*    538 */ /*TargetOpcode::G_FMUL*//*Label 43*/ GIMT_Encode4(157806),
     /*    542 */ /*TargetOpcode::G_FMA*//*Label 44*/ GIMT_Encode4(163720), GIMT_Encode4(0),
     /*    550 */ /*TargetOpcode::G_FDIV*//*Label 45*/ GIMT_Encode4(169708), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    598 */ /*TargetOpcode::G_FNEG*//*Label 46*/ GIMT_Encode4(173890),
     /*    602 */ /*TargetOpcode::G_FPEXT*//*Label 47*/ GIMT_Encode4(174013),
     /*    606 */ /*TargetOpcode::G_FPTRUNC*//*Label 48*/ GIMT_Encode4(174945),
     /*    610 */ /*TargetOpcode::G_FPTOSI*//*Label 49*/ GIMT_Encode4(175331),
     /*    614 */ /*TargetOpcode::G_FPTOUI*//*Label 50*/ GIMT_Encode4(176712),
     /*    618 */ /*TargetOpcode::G_SITOFP*//*Label 51*/ GIMT_Encode4(177268),
     /*    622 */ /*TargetOpcode::G_UITOFP*//*Label 52*/ GIMT_Encode4(180644), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FABS*//*Label 53*/ GIMT_Encode4(182891), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    718 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(183014),
     /*    722 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(186335),
     /*    726 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(189656),
     /*    730 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(192977),
     /*    734 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(196298), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(198179), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 60*/ GIMT_Encode4(198195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    786 */ /*TargetOpcode::G_VECTOR_COMPRESS*//*Label 61*/ GIMT_Encode4(201124),
     /*    790 */ /*TargetOpcode::G_CTTZ*//*Label 62*/ GIMT_Encode4(203106),
     /*    794 */ /*TargetOpcode::G_CTTZ_ZERO_UNDEF*//*Label 63*/ GIMT_Encode4(203412),
     /*    798 */ /*TargetOpcode::G_CTLZ*//*Label 64*/ GIMT_Encode4(203799), GIMT_Encode4(0),
     /*    806 */ /*TargetOpcode::G_CTPOP*//*Label 65*/ GIMT_Encode4(205103),
     /*    810 */ /*TargetOpcode::G_BSWAP*//*Label 66*/ GIMT_Encode4(207365), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    866 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(207865), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    906 */ /*TargetOpcode::G_STRICT_FADD*//*Label 68*/ GIMT_Encode4(210034),
     /*    910 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 69*/ GIMT_Encode4(214964),
     /*    914 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 70*/ GIMT_Encode4(218654),
     /*    918 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 71*/ GIMT_Encode4(223584), GIMT_Encode4(0),
     /*    926 */ /*TargetOpcode::G_STRICT_FMA*//*Label 72*/ GIMT_Encode4(227274),
     /*    930 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 73*/ GIMT_Encode4(233262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    966 */ /*TargetOpcode::G_TRAP*//*Label 74*/ GIMT_Encode4(235431),
     /*    970 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 75*/ GIMT_Encode4(235444),
     /*    974 */ /*TargetOpcode::G_UBSANTRAP*//*Label 76*/ GIMT_Encode4(235480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1170 */ /*X86::G_FILD*//*Label 77*/ GIMT_Encode4(235496),
     /*   1174 */ /*X86::G_FIST*//*Label 78*/ GIMT_Encode4(235955),
     /*   1178 */ /*X86::G_FNSTCW16*//*Label 79*/ GIMT_Encode4(236819),
     /*   1182 */ // Label 0: @1182
     /*   1182 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 97*/ GIMT_Encode4(7414),
     /*   1193 */ /*GILLT_s8*//*Label 81*/ GIMT_Encode4(1289),
     /*   1197 */ /*GILLT_s16*//*Label 82*/ GIMT_Encode4(1794),
     /*   1201 */ /*GILLT_s32*//*Label 83*/ GIMT_Encode4(2444),
     /*   1205 */ /*GILLT_s64*//*Label 84*/ GIMT_Encode4(3094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1221 */ /*GILLT_v2s64*//*Label 85*/ GIMT_Encode4(3918), GIMT_Encode4(0),
     /*   1229 */ /*GILLT_v4s32*//*Label 86*/ GIMT_Encode4(4260),
     /*   1233 */ /*GILLT_v4s64*//*Label 87*/ GIMT_Encode4(4724), GIMT_Encode4(0),
     /*   1241 */ /*GILLT_v8s16*//*Label 88*/ GIMT_Encode4(5039),
     /*   1245 */ /*GILLT_v8s32*//*Label 89*/ GIMT_Encode4(5503),
     /*   1249 */ /*GILLT_v8s64*//*Label 90*/ GIMT_Encode4(5818), GIMT_Encode4(0),
     /*   1257 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(5974),
     /*   1261 */ /*GILLT_v16s16*//*Label 92*/ GIMT_Encode4(6316),
     /*   1265 */ /*GILLT_v16s32*//*Label 93*/ GIMT_Encode4(6631), GIMT_Encode4(0),
     /*   1273 */ /*GILLT_v32s8*//*Label 94*/ GIMT_Encode4(6787),
     /*   1277 */ /*GILLT_v32s16*//*Label 95*/ GIMT_Encode4(7102), GIMT_Encode4(0),
     /*   1285 */ /*GILLT_v64s8*//*Label 96*/ GIMT_Encode4(7258),
     /*   1289 */ // Label 81: @1289
     /*   1289 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1793),
     /*   1294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   1297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   1300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1304 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1365), // Rule ID 26054 //
     /*   1309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1323 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1327 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1344 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1363 */     GIR_RootConstrainSelectedInstOperands,
     /*   1364 */     // GIR_Coverage, 26054,
     /*   1364 */     GIR_EraseRootFromParent_Done,
     /*   1365 */   // Label 99: @1365
     /*   1365 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1426), // Rule ID 26073 //
     /*   1370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1381 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1388 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1405 */     // (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1410 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1424 */     GIR_RootConstrainSelectedInstOperands,
     /*   1425 */     // GIR_Coverage, 26073,
     /*   1425 */     GIR_EraseRootFromParent_Done,
     /*   1426 */   // Label 100: @1426
     /*   1426 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1487), // Rule ID 22796 //
     /*   1431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1446 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1453 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1466 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm),
     /*   1469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 22796,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 101: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1548), // Rule ID 22886 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1510 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1514 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   1518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1527 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (ADD8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rm_ND),
     /*   1530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1546 */     GIR_RootConstrainSelectedInstOperands,
     /*   1547 */     // GIR_Coverage, 22886,
     /*   1547 */     GIR_EraseRootFromParent_Done,
     /*   1548 */   // Label 102: @1548
     /*   1548 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1576), // Rule ID 22862 //
     /*   1553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1564 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r),
     /*   1567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1574 */     GIR_RootConstrainSelectedInstOperands,
     /*   1575 */     // GIR_Coverage, 22862,
     /*   1575 */     GIR_EraseRootFromParent_Done,
     /*   1576 */   // Label 103: @1576
     /*   1576 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1604), // Rule ID 22866 //
     /*   1581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   1584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1592 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r),
     /*   1595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1602 */     GIR_RootConstrainSelectedInstOperands,
     /*   1603 */     // GIR_Coverage, 22866,
     /*   1603 */     GIR_EraseRootFromParent_Done,
     /*   1604 */   // Label 104: @1604
     /*   1604 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1632), // Rule ID 22952 //
     /*   1609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   1620 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, 1:{ *:[i8] })  =>  (INC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8r_ND),
     /*   1623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1630 */     GIR_RootConstrainSelectedInstOperands,
     /*   1631 */     // GIR_Coverage, 22952,
     /*   1631 */     GIR_EraseRootFromParent_Done,
     /*   1632 */   // Label 105: @1632
     /*   1632 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1660), // Rule ID 22956 //
     /*   1637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   1640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   1648 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src, -1:{ *:[i8] })  =>  (DEC8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /*   1648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8r_ND),
     /*   1651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   1655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1658 */     GIR_RootConstrainSelectedInstOperands,
     /*   1659 */     // GIR_Coverage, 22956,
     /*   1659 */     GIR_EraseRootFromParent_Done,
     /*   1660 */   // Label 106: @1660
     /*   1660 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1697), // Rule ID 22800 //
     /*   1665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1680 */     // MIs[1] Operand 1
     /*   1680 */     // No operand predicates
     /*   1680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1682 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*   1685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1695 */     GIR_RootConstrainSelectedInstOperands,
     /*   1696 */     // GIR_Coverage, 22800,
     /*   1696 */     GIR_EraseRootFromParent_Done,
     /*   1697 */   // Label 107: @1697
     /*   1697 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1734), // Rule ID 22890 //
     /*   1702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1717 */     // MIs[1] Operand 1
     /*   1717 */     // No operand predicates
     /*   1717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1719 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ADD8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   1719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri_ND),
     /*   1722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   1726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   1729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1732 */     GIR_RootConstrainSelectedInstOperands,
     /*   1733 */     // GIR_Coverage, 22890,
     /*   1733 */     GIR_EraseRootFromParent_Done,
     /*   1734 */   // Label 108: @1734
     /*   1734 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1763), // Rule ID 22792 //
     /*   1739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1750 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1750 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /*   1755 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1761 */     GIR_RootConstrainSelectedInstOperands,
     /*   1762 */     // GIR_Coverage, 22792,
     /*   1762 */     GIR_Done,
     /*   1763 */   // Label 109: @1763
     /*   1763 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1792), // Rule ID 22882 //
     /*   1768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   1779 */     // (add:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   1779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /*   1784 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   1790 */     GIR_RootConstrainSelectedInstOperands,
     /*   1791 */     // GIR_Coverage, 22882,
     /*   1791 */     GIR_Done,
     /*   1792 */   // Label 110: @1792
     /*   1792 */   GIM_Reject,
     /*   1793 */ // Label 98: @1793
     /*   1793 */ GIM_Reject,
     /*   1794 */ // Label 82: @1794
     /*   1794 */ GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(2443),
     /*   1799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   1802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   1805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1809 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(1878), // Rule ID 22617 //
     /*   1814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1825 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1828 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1832 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1836 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   1847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1849 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1856 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] })  =>  (SUB16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i16] })
     /*   1856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi_ND),
     /*   1859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   1865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   1868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1876 */     GIR_RootConstrainSelectedInstOperands,
     /*   1877 */     // GIR_Coverage, 22617,
     /*   1877 */     GIR_EraseRootFromParent_Done,
     /*   1878 */   // Label 112: @1878
     /*   1878 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(1939), // Rule ID 26055 //
     /*   1883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   1886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1894 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1901 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1918 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   1921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1937 */     GIR_RootConstrainSelectedInstOperands,
     /*   1938 */     // GIR_Coverage, 26055,
     /*   1938 */     GIR_EraseRootFromParent_Done,
     /*   1939 */   // Label 113: @1939
     /*   1939 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2000), // Rule ID 26074 //
     /*   1944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   1947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   1955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   1958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   1962 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   1966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   1970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   1979 */     // (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   1979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   1982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   1984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   1986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   1990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   1993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   1998 */     GIR_RootConstrainSelectedInstOperands,
     /*   1999 */     // GIR_Coverage, 26074,
     /*   1999 */     GIR_EraseRootFromParent_Done,
     /*   2000 */   // Label 114: @2000
     /*   2000 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2061), // Rule ID 22797 //
     /*   2005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2027 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2040 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm),
     /*   2043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2059 */     GIR_RootConstrainSelectedInstOperands,
     /*   2060 */     // GIR_Coverage, 22797,
     /*   2060 */     GIR_EraseRootFromParent_Done,
     /*   2061 */   // Label 115: @2061
     /*   2061 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2122), // Rule ID 22887 //
     /*   2066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2081 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2088 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   2092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2094 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2101 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (ADD16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rm_ND),
     /*   2104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2106 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2108 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2120 */     GIR_RootConstrainSelectedInstOperands,
     /*   2121 */     // GIR_Coverage, 22887,
     /*   2121 */     GIR_EraseRootFromParent_Done,
     /*   2122 */   // Label 116: @2122
     /*   2122 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2160), // Rule ID 22602 //
     /*   2127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2134 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2145 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   2148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2150 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2158 */     GIR_RootConstrainSelectedInstOperands,
     /*   2159 */     // GIR_Coverage, 22602,
     /*   2159 */     GIR_EraseRootFromParent_Done,
     /*   2160 */   // Label 117: @2160
     /*   2160 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2198), // Rule ID 22608 //
     /*   2165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2172 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2183 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, 128:{ *:[i16] })  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -128:{ *:[i16] })
     /*   2183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   2186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2188 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2196 */     GIR_RootConstrainSelectedInstOperands,
     /*   2197 */     // GIR_Coverage, 22608,
     /*   2197 */     GIR_EraseRootFromParent_Done,
     /*   2198 */   // Label 118: @2198
     /*   2198 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2226), // Rule ID 22863 //
     /*   2203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2214 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r),
     /*   2217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2221 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2224 */     GIR_RootConstrainSelectedInstOperands,
     /*   2225 */     // GIR_Coverage, 22863,
     /*   2225 */     GIR_EraseRootFromParent_Done,
     /*   2226 */   // Label 119: @2226
     /*   2226 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2254), // Rule ID 22867 //
     /*   2231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2242 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r),
     /*   2245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2252 */     GIR_RootConstrainSelectedInstOperands,
     /*   2253 */     // GIR_Coverage, 22867,
     /*   2253 */     GIR_EraseRootFromParent_Done,
     /*   2254 */   // Label 120: @2254
     /*   2254 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2282), // Rule ID 22953 //
     /*   2259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2270 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, 1:{ *:[i16] })  =>  (INC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16r_ND),
     /*   2273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2275 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2280 */     GIR_RootConstrainSelectedInstOperands,
     /*   2281 */     // GIR_Coverage, 22953,
     /*   2281 */     GIR_EraseRootFromParent_Done,
     /*   2282 */   // Label 121: @2282
     /*   2282 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2310), // Rule ID 22957 //
     /*   2287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2298 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src, -1:{ *:[i16] })  =>  (DEC16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /*   2298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16r_ND),
     /*   2301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2303 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2308 */     GIR_RootConstrainSelectedInstOperands,
     /*   2309 */     // GIR_Coverage, 22957,
     /*   2309 */     GIR_EraseRootFromParent_Done,
     /*   2310 */   // Label 122: @2310
     /*   2310 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2347), // Rule ID 22801 //
     /*   2315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2330 */     // MIs[1] Operand 1
     /*   2330 */     // No operand predicates
     /*   2330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2332 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*   2335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2345 */     GIR_RootConstrainSelectedInstOperands,
     /*   2346 */     // GIR_Coverage, 22801,
     /*   2346 */     GIR_EraseRootFromParent_Done,
     /*   2347 */   // Label 123: @2347
     /*   2347 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(2384), // Rule ID 22891 //
     /*   2352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2367 */     // MIs[1] Operand 1
     /*   2367 */     // No operand predicates
     /*   2367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2369 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (ADD16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   2369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri_ND),
     /*   2372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2382 */     GIR_RootConstrainSelectedInstOperands,
     /*   2383 */     // GIR_Coverage, 22891,
     /*   2383 */     GIR_EraseRootFromParent_Done,
     /*   2384 */   // Label 124: @2384
     /*   2384 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(2413), // Rule ID 22793 //
     /*   2389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2400 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /*   2405 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2411 */     GIR_RootConstrainSelectedInstOperands,
     /*   2412 */     // GIR_Coverage, 22793,
     /*   2412 */     GIR_Done,
     /*   2413 */   // Label 125: @2413
     /*   2413 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(2442), // Rule ID 22883 //
     /*   2418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   2429 */     // (add:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   2429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /*   2434 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   2440 */     GIR_RootConstrainSelectedInstOperands,
     /*   2441 */     // GIR_Coverage, 22883,
     /*   2441 */     GIR_Done,
     /*   2442 */   // Label 126: @2442
     /*   2442 */   GIM_Reject,
     /*   2443 */ // Label 111: @2443
     /*   2443 */ GIM_Reject,
     /*   2444 */ // Label 83: @2444
     /*   2444 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(3093),
     /*   2449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2459 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(2528), // Rule ID 22618 //
     /*   2464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2482 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2486 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2506 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] })  =>  (SUB32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i32] })
     /*   2506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi_ND),
     /*   2509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   2515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2526 */     GIR_RootConstrainSelectedInstOperands,
     /*   2527 */     // GIR_Coverage, 22618,
     /*   2527 */     GIR_EraseRootFromParent_Done,
     /*   2528 */   // Label 128: @2528
     /*   2528 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2589), // Rule ID 26056 //
     /*   2533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2547 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2551 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2568 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2587 */     GIR_RootConstrainSelectedInstOperands,
     /*   2588 */     // GIR_Coverage, 26056,
     /*   2588 */     GIR_EraseRootFromParent_Done,
     /*   2589 */   // Label 129: @2589
     /*   2589 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2650), // Rule ID 26075 //
     /*   2594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2605 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2612 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2629 */     // (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2634 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   2636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2648 */     GIR_RootConstrainSelectedInstOperands,
     /*   2649 */     // GIR_Coverage, 26075,
     /*   2649 */     GIR_EraseRootFromParent_Done,
     /*   2650 */   // Label 130: @2650
     /*   2650 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2711), // Rule ID 22798 //
     /*   2655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2677 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2690 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm),
     /*   2693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2709 */     GIR_RootConstrainSelectedInstOperands,
     /*   2710 */     // GIR_Coverage, 22798,
     /*   2710 */     GIR_EraseRootFromParent_Done,
     /*   2711 */   // Label 131: @2711
     /*   2711 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2772), // Rule ID 22888 //
     /*   2716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   2731 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   2734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   2738 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   2742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   2751 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ADD32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rm_ND),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   2762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   2770 */     GIR_RootConstrainSelectedInstOperands,
     /*   2771 */     // GIR_Coverage, 22888,
     /*   2771 */     GIR_EraseRootFromParent_Done,
     /*   2772 */   // Label 132: @2772
     /*   2772 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2810), // Rule ID 22603 //
     /*   2777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2784 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2795 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   2798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2800 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2808 */     GIR_RootConstrainSelectedInstOperands,
     /*   2809 */     // GIR_Coverage, 22603,
     /*   2809 */     GIR_EraseRootFromParent_Done,
     /*   2810 */   // Label 133: @2810
     /*   2810 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2848), // Rule ID 22609 //
     /*   2815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   2818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2822 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   2833 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, 128:{ *:[i32] })  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -128:{ *:[i32] })
     /*   2833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   2836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2838 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   2843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2846 */     GIR_RootConstrainSelectedInstOperands,
     /*   2847 */     // GIR_Coverage, 22609,
     /*   2847 */     GIR_EraseRootFromParent_Done,
     /*   2848 */   // Label 134: @2848
     /*   2848 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2876), // Rule ID 22864 //
     /*   2853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2860 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2864 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2874 */     GIR_RootConstrainSelectedInstOperands,
     /*   2875 */     // GIR_Coverage, 22864,
     /*   2875 */     GIR_EraseRootFromParent_Done,
     /*   2876 */   // Label 135: @2876
     /*   2876 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2904), // Rule ID 22868 //
     /*   2881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   2884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2892 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r),
     /*   2895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2897 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2902 */     GIR_RootConstrainSelectedInstOperands,
     /*   2903 */     // GIR_Coverage, 22868,
     /*   2903 */     GIR_EraseRootFromParent_Done,
     /*   2904 */   // Label 136: @2904
     /*   2904 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2932), // Rule ID 22954 //
     /*   2909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   2920 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] })  =>  (INC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32r_ND),
     /*   2923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2930 */     GIR_RootConstrainSelectedInstOperands,
     /*   2931 */     // GIR_Coverage, 22954,
     /*   2931 */     GIR_EraseRootFromParent_Done,
     /*   2932 */   // Label 137: @2932
     /*   2932 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2960), // Rule ID 22958 //
     /*   2937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   2940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   2948 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] })  =>  (DEC32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*   2948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32r_ND),
     /*   2951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   2955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2958 */     GIR_RootConstrainSelectedInstOperands,
     /*   2959 */     // GIR_Coverage, 22958,
     /*   2959 */     GIR_EraseRootFromParent_Done,
     /*   2960 */   // Label 138: @2960
     /*   2960 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2997), // Rule ID 22802 //
     /*   2965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   2968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   2972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   2980 */     // MIs[1] Operand 1
     /*   2980 */     // No operand predicates
     /*   2980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2982 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   2982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*   2985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   2987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   2989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   2992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   2995 */     GIR_RootConstrainSelectedInstOperands,
     /*   2996 */     // GIR_Coverage, 22802,
     /*   2996 */     GIR_EraseRootFromParent_Done,
     /*   2997 */   // Label 139: @2997
     /*   2997 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(3034), // Rule ID 22892 //
     /*   3002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3017 */     // MIs[1] Operand 1
     /*   3017 */     // No operand predicates
     /*   3017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3019 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (ADD32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   3019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri_ND),
     /*   3022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3032 */     GIR_RootConstrainSelectedInstOperands,
     /*   3033 */     // GIR_Coverage, 22892,
     /*   3033 */     GIR_EraseRootFromParent_Done,
     /*   3034 */   // Label 140: @3034
     /*   3034 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(3063), // Rule ID 22794 //
     /*   3039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3050 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /*   3055 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3061 */     GIR_RootConstrainSelectedInstOperands,
     /*   3062 */     // GIR_Coverage, 22794,
     /*   3062 */     GIR_Done,
     /*   3063 */   // Label 141: @3063
     /*   3063 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(3092), // Rule ID 22884 //
     /*   3068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   3079 */     // (add:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   3079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /*   3084 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3090 */     GIR_RootConstrainSelectedInstOperands,
     /*   3091 */     // GIR_Coverage, 22884,
     /*   3091 */     GIR_Done,
     /*   3092 */   // Label 142: @3092
     /*   3092 */   GIM_Reject,
     /*   3093 */ // Label 127: @3093
     /*   3093 */ GIM_Reject,
     /*   3094 */ // Label 84: @3094
     /*   3094 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(3917),
     /*   3099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   3102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   3105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3109 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(3178), // Rule ID 22619 //
     /*   3114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3136 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3156 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -128:{ *:[i64] })
     /*   3156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3176 */     GIR_RootConstrainSelectedInstOperands,
     /*   3177 */     // GIR_Coverage, 22619,
     /*   3177 */     GIR_EraseRootFromParent_Done,
     /*   3178 */   // Label 144: @3178
     /*   3178 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(3254), // Rule ID 22625 //
     /*   3183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3205 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3218 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3225 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] })  =>  (SUB64mi32_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src, -2147483648:{ *:[i64] })
     /*   3225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32_ND),
     /*   3228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*   3234 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3247 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3252 */     GIR_RootConstrainSelectedInstOperands,
     /*   3253 */     // GIR_Coverage, 22625,
     /*   3253 */     GIR_EraseRootFromParent_Done,
     /*   3254 */   // Label 145: @3254
     /*   3254 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(3315), // Rule ID 26057 //
     /*   3259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3294 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3313 */     GIR_RootConstrainSelectedInstOperands,
     /*   3314 */     // GIR_Coverage, 26057,
     /*   3314 */     GIR_EraseRootFromParent_Done,
     /*   3315 */   // Label 146: @3315
     /*   3315 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(3376), // Rule ID 26076 //
     /*   3320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3331 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3334 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3338 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3355 */     // (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3360 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3374 */     GIR_RootConstrainSelectedInstOperands,
     /*   3375 */     // GIR_Coverage, 26076,
     /*   3375 */     GIR_EraseRootFromParent_Done,
     /*   3376 */   // Label 147: @3376
     /*   3376 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(3437), // Rule ID 22799 //
     /*   3381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3416 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm),
     /*   3419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3427 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3435 */     GIR_RootConstrainSelectedInstOperands,
     /*   3436 */     // GIR_Coverage, 22799,
     /*   3436 */     GIR_EraseRootFromParent_Done,
     /*   3437 */   // Label 148: @3437
     /*   3437 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(3498), // Rule ID 22889 //
     /*   3442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3477 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rm_ND),
     /*   3480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3496 */     GIR_RootConstrainSelectedInstOperands,
     /*   3497 */     // GIR_Coverage, 22889,
     /*   3497 */     GIR_EraseRootFromParent_Done,
     /*   3498 */   // Label 149: @3498
     /*   3498 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(3536), // Rule ID 22604 //
     /*   3503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3510 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3521 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3534 */     GIR_RootConstrainSelectedInstOperands,
     /*   3535 */     // GIR_Coverage, 22604,
     /*   3535 */     GIR_EraseRootFromParent_Done,
     /*   3536 */   // Label 150: @3536
     /*   3536 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(3574), // Rule ID 22610 //
     /*   3541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3548 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(128),
     /*   3559 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 128:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -128:{ *:[i64] })
     /*   3559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*   3569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3572 */     GIR_RootConstrainSelectedInstOperands,
     /*   3573 */     // GIR_Coverage, 22610,
     /*   3573 */     GIR_EraseRootFromParent_Done,
     /*   3574 */   // Label 151: @3574
     /*   3574 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(3619), // Rule ID 22620 //
     /*   3579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3586 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3597 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   3600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3602 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3604 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3617 */     GIR_RootConstrainSelectedInstOperands,
     /*   3618 */     // GIR_Coverage, 22620,
     /*   3618 */     GIR_EraseRootFromParent_Done,
     /*   3619 */   // Label 152: @3619
     /*   3619 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(3664), // Rule ID 22622 //
     /*   3624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3631 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2147483648),
     /*   3642 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, 2147483648:{ *:[i64] })  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, -2147483648:{ *:[i64] })
     /*   3642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   3645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3647 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3649 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*   3659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3662 */     GIR_RootConstrainSelectedInstOperands,
     /*   3663 */     // GIR_Coverage, 22622,
     /*   3663 */     GIR_EraseRootFromParent_Done,
     /*   3664 */   // Label 153: @3664
     /*   3664 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(3692), // Rule ID 22865 //
     /*   3669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3680 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r),
     /*   3683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3690 */     GIR_RootConstrainSelectedInstOperands,
     /*   3691 */     // GIR_Coverage, 22865,
     /*   3691 */     GIR_EraseRootFromParent_Done,
     /*   3692 */   // Label 154: @3692
     /*   3692 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(3720), // Rule ID 22869 //
     /*   3697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_UseIncDec),
     /*   3700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3708 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r),
     /*   3711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3713 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3718 */     GIR_RootConstrainSelectedInstOperands,
     /*   3719 */     // GIR_Coverage, 22869,
     /*   3719 */     GIR_EraseRootFromParent_Done,
     /*   3720 */   // Label 155: @3720
     /*   3720 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(3748), // Rule ID 22955 //
     /*   3725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*   3736 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] })  =>  (INC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64r_ND),
     /*   3739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3746 */     GIR_RootConstrainSelectedInstOperands,
     /*   3747 */     // GIR_Coverage, 22955,
     /*   3747 */     GIR_EraseRootFromParent_Done,
     /*   3748 */   // Label 156: @3748
     /*   3748 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(3776), // Rule ID 22959 //
     /*   3753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_UseIncDec),
     /*   3756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*   3764 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] })  =>  (DEC64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*   3764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64r_ND),
     /*   3767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*   3771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3774 */     GIR_RootConstrainSelectedInstOperands,
     /*   3775 */     // GIR_Coverage, 22959,
     /*   3775 */     GIR_EraseRootFromParent_Done,
     /*   3776 */   // Label 157: @3776
     /*   3776 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(3817), // Rule ID 22803 //
     /*   3781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3800 */     // MIs[1] Operand 1
     /*   3800 */     // No operand predicates
     /*   3800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3802 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32),
     /*   3805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3815 */     GIR_RootConstrainSelectedInstOperands,
     /*   3816 */     // GIR_Coverage, 22803,
     /*   3816 */     GIR_EraseRootFromParent_Done,
     /*   3817 */   // Label 158: @3817
     /*   3817 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3858), // Rule ID 22893 //
     /*   3822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   3837 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   3841 */     // MIs[1] Operand 1
     /*   3841 */     // No operand predicates
     /*   3841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3843 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (ADD64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   3843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64ri32_ND),
     /*   3846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3848 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   3850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   3853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   3856 */     GIR_RootConstrainSelectedInstOperands,
     /*   3857 */     // GIR_Coverage, 22893,
     /*   3857 */     GIR_EraseRootFromParent_Done,
     /*   3858 */   // Label 159: @3858
     /*   3858 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3887), // Rule ID 22795 //
     /*   3863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   3866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3874 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /*   3879 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3885 */     GIR_RootConstrainSelectedInstOperands,
     /*   3886 */     // GIR_Coverage, 22795,
     /*   3886 */     GIR_Done,
     /*   3887 */   // Label 160: @3887
     /*   3887 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3916), // Rule ID 22885 //
     /*   3892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   3895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   3903 */     // (add:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   3903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /*   3908 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   3914 */     GIR_RootConstrainSelectedInstOperands,
     /*   3915 */     // GIR_Coverage, 22885,
     /*   3915 */     GIR_Done,
     /*   3916 */   // Label 161: @3916
     /*   3916 */   GIM_Reject,
     /*   3917 */ // Label 143: @3917
     /*   3917 */ GIM_Reject,
     /*   3918 */ // Label 85: @3918
     /*   3918 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(4259),
     /*   3923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   3926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   3929 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3991), // Rule ID 23438 //
     /*   3934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   3937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   3949 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   3952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   3956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   3960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   3964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   3973 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   3973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   3976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   3980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   3984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   3989 */     GIR_RootConstrainSelectedInstOperands,
     /*   3990 */     // GIR_Coverage, 23438,
     /*   3990 */     GIR_EraseRootFromParent_Done,
     /*   3991 */   // Label 163: @3991
     /*   3991 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(4053), // Rule ID 23708 //
     /*   3996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   3999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4011 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4018 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4028 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4035 */     // (add:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4040 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4042 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4051 */     GIR_RootConstrainSelectedInstOperands,
     /*   4052 */     // GIR_Coverage, 23708,
     /*   4052 */     GIR_EraseRootFromParent_Done,
     /*   4053 */   // Label 164: @4053
     /*   4053 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(4115), // Rule ID 2541 //
     /*   4058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4097 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQrm),
     /*   4100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4102 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4104 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4113 */     GIR_RootConstrainSelectedInstOperands,
     /*   4114 */     // GIR_Coverage, 2541,
     /*   4114 */     GIR_EraseRootFromParent_Done,
     /*   4115 */   // Label 165: @4115
     /*   4115 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(4177), // Rule ID 4654 //
     /*   4120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4159 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rm),
     /*   4162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4175 */     GIR_RootConstrainSelectedInstOperands,
     /*   4176 */     // GIR_Coverage, 4654,
     /*   4176 */     GIR_EraseRootFromParent_Done,
     /*   4177 */   // Label 166: @4177
     /*   4177 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(4204), // Rule ID 2540 //
     /*   4182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4197 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQrr),
     /*   4202 */     GIR_RootConstrainSelectedInstOperands,
     /*   4203 */     // GIR_Coverage, 2540,
     /*   4203 */     GIR_Done,
     /*   4204 */   // Label 167: @4204
     /*   4204 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(4231), // Rule ID 2542 //
     /*   4209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4224 */     // (add:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PADDQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   4224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDQrr),
     /*   4229 */     GIR_RootConstrainSelectedInstOperands,
     /*   4230 */     // GIR_Coverage, 2542,
     /*   4230 */     GIR_Done,
     /*   4231 */   // Label 168: @4231
     /*   4231 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(4258), // Rule ID 4651 //
     /*   4236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4251 */     // (add:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPADDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   4251 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ128rr),
     /*   4256 */     GIR_RootConstrainSelectedInstOperands,
     /*   4257 */     // GIR_Coverage, 4651,
     /*   4257 */     GIR_Done,
     /*   4258 */   // Label 169: @4258
     /*   4258 */   GIM_Reject,
     /*   4259 */ // Label 162: @4259
     /*   4259 */ GIM_Reject,
     /*   4260 */ // Label 86: @4260
     /*   4260 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(4723),
     /*   4265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4271 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(4333), // Rule ID 23435 //
     /*   4276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4291 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4294 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4298 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4315 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4320 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4331 */     GIR_RootConstrainSelectedInstOperands,
     /*   4332 */     // GIR_Coverage, 23435,
     /*   4332 */     GIR_EraseRootFromParent_Done,
     /*   4333 */   // Label 171: @4333
     /*   4333 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(4395), // Rule ID 23726 //
     /*   4338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4353 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4377 */     // (add:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4382 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4393 */     GIR_RootConstrainSelectedInstOperands,
     /*   4394 */     // GIR_Coverage, 23726,
     /*   4394 */     GIR_EraseRootFromParent_Done,
     /*   4395 */   // Label 172: @4395
     /*   4395 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4457), // Rule ID 2535 //
     /*   4400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4419 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4422 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4426 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4432 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4439 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDrm),
     /*   4442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4455 */     GIR_RootConstrainSelectedInstOperands,
     /*   4456 */     // GIR_Coverage, 2535,
     /*   4456 */     GIR_EraseRootFromParent_Done,
     /*   4457 */   // Label 173: @4457
     /*   4457 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4519), // Rule ID 4681 //
     /*   4462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4481 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4484 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4488 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4494 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4501 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rm),
     /*   4504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4506 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4517 */     GIR_RootConstrainSelectedInstOperands,
     /*   4518 */     // GIR_Coverage, 4681,
     /*   4518 */     GIR_EraseRootFromParent_Done,
     /*   4519 */   // Label 174: @4519
     /*   4519 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4580), // Rule ID 17867 //
     /*   4524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4563 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2), VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4578 */     GIR_RootConstrainSelectedInstOperands,
     /*   4579 */     // GIR_Coverage, 17867,
     /*   4579 */     GIR_EraseRootFromParent_Done,
     /*   4580 */   // Label 175: @4580
     /*   4580 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4641), // Rule ID 25190 //
     /*   4585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   4588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4624 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src3, (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2))  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*   4624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   4637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4639 */     GIR_RootConstrainSelectedInstOperands,
     /*   4640 */     // GIR_Coverage, 25190,
     /*   4640 */     GIR_EraseRootFromParent_Done,
     /*   4641 */   // Label 176: @4641
     /*   4641 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4668), // Rule ID 2534 //
     /*   4646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   4649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4661 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDrr),
     /*   4666 */     GIR_RootConstrainSelectedInstOperands,
     /*   4667 */     // GIR_Coverage, 2534,
     /*   4667 */     GIR_Done,
     /*   4668 */   // Label 177: @4668
     /*   4668 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4695), // Rule ID 2536 //
     /*   4673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   4676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   4688 */     // (add:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PADDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   4688 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDDrr),
     /*   4693 */     GIR_RootConstrainSelectedInstOperands,
     /*   4694 */     // GIR_Coverage, 2536,
     /*   4694 */     GIR_Done,
     /*   4695 */   // Label 178: @4695
     /*   4695 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4722), // Rule ID 4678 //
     /*   4700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   4715 */     // (add:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPADDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   4715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ128rr),
     /*   4720 */     GIR_RootConstrainSelectedInstOperands,
     /*   4721 */     // GIR_Coverage, 4678,
     /*   4721 */     GIR_Done,
     /*   4722 */   // Label 179: @4722
     /*   4722 */   GIM_Reject,
     /*   4723 */ // Label 170: @4723
     /*   4723 */ GIM_Reject,
     /*   4724 */ // Label 87: @4724
     /*   4724 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(5038),
     /*   4729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   4732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   4735 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4797), // Rule ID 23440 //
     /*   4740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4758 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4762 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4779 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4795 */     GIR_RootConstrainSelectedInstOperands,
     /*   4796 */     // GIR_Coverage, 23440,
     /*   4796 */     GIR_EraseRootFromParent_Done,
     /*   4797 */   // Label 181: @4797
     /*   4797 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4859), // Rule ID 23702 //
     /*   4802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4817 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4820 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4824 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4841 */     // (add:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   4848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4857 */     GIR_RootConstrainSelectedInstOperands,
     /*   4858 */     // GIR_Coverage, 23702,
     /*   4858 */     GIR_EraseRootFromParent_Done,
     /*   4859 */   // Label 182: @4859
     /*   4859 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4921), // Rule ID 2545 //
     /*   4864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4903 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQYrm),
     /*   4906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4919 */     GIR_RootConstrainSelectedInstOperands,
     /*   4920 */     // GIR_Coverage, 2545,
     /*   4920 */     GIR_EraseRootFromParent_Done,
     /*   4921 */   // Label 183: @4921
     /*   4921 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(4983), // Rule ID 4645 //
     /*   4926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   4929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   4937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   4945 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   4948 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   4952 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   4956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   4965 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   4965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rm),
     /*   4968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   4972 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   4976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   4981 */     GIR_RootConstrainSelectedInstOperands,
     /*   4982 */     // GIR_Coverage, 4645,
     /*   4982 */     GIR_EraseRootFromParent_Done,
     /*   4983 */   // Label 184: @4983
     /*   4983 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5010), // Rule ID 2544 //
     /*   4988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   4991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   4999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5003 */     // (add:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPADDQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   5003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQYrr),
     /*   5008 */     GIR_RootConstrainSelectedInstOperands,
     /*   5009 */     // GIR_Coverage, 2544,
     /*   5009 */     GIR_Done,
     /*   5010 */   // Label 185: @5010
     /*   5010 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5037), // Rule ID 4642 //
     /*   5015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5030 */     // (add:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPADDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   5030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZ256rr),
     /*   5035 */     GIR_RootConstrainSelectedInstOperands,
     /*   5036 */     // GIR_Coverage, 4642,
     /*   5036 */     GIR_Done,
     /*   5037 */   // Label 186: @5037
     /*   5037 */   GIM_Reject,
     /*   5038 */ // Label 180: @5038
     /*   5038 */ GIM_Reject,
     /*   5039 */ // Label 88: @5039
     /*   5039 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5502),
     /*   5044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5050 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5112), // Rule ID 23432 //
     /*   5055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5094 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5110 */     GIR_RootConstrainSelectedInstOperands,
     /*   5111 */     // GIR_Coverage, 23432,
     /*   5111 */     GIR_EraseRootFromParent_Done,
     /*   5112 */   // Label 188: @5112
     /*   5112 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5174), // Rule ID 23738 //
     /*   5117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5156 */     // (add:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5172 */     GIR_RootConstrainSelectedInstOperands,
     /*   5173 */     // GIR_Coverage, 23738,
     /*   5173 */     GIR_EraseRootFromParent_Done,
     /*   5174 */   // Label 189: @5174
     /*   5174 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(5236), // Rule ID 2529 //
     /*   5179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5198 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5201 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5218 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWrm),
     /*   5221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5223 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5234 */     GIR_RootConstrainSelectedInstOperands,
     /*   5235 */     // GIR_Coverage, 2529,
     /*   5235 */     GIR_EraseRootFromParent_Done,
     /*   5236 */   // Label 190: @5236
     /*   5236 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(5298), // Rule ID 4702 //
     /*   5241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5280 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rm),
     /*   5283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5296 */     GIR_RootConstrainSelectedInstOperands,
     /*   5297 */     // GIR_Coverage, 4702,
     /*   5297 */     GIR_EraseRootFromParent_Done,
     /*   5298 */   // Label 191: @5298
     /*   5298 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(5359), // Rule ID 17866 //
     /*   5303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5342 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2), VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   5357 */     GIR_RootConstrainSelectedInstOperands,
     /*   5358 */     // GIR_Coverage, 17866,
     /*   5358 */     GIR_EraseRootFromParent_Done,
     /*   5359 */   // Label 192: @5359
     /*   5359 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(5420), // Rule ID 25189 //
     /*   5364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*   5367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   5391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5403 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src3, (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2))  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*   5403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*   5406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*   5412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*   5416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   5418 */     GIR_RootConstrainSelectedInstOperands,
     /*   5419 */     // GIR_Coverage, 25189,
     /*   5419 */     GIR_EraseRootFromParent_Done,
     /*   5420 */   // Label 193: @5420
     /*   5420 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(5447), // Rule ID 2528 //
     /*   5425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5440 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWrr),
     /*   5445 */     GIR_RootConstrainSelectedInstOperands,
     /*   5446 */     // GIR_Coverage, 2528,
     /*   5446 */     GIR_Done,
     /*   5447 */   // Label 194: @5447
     /*   5447 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(5474), // Rule ID 2530 //
     /*   5452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   5455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5467 */     // (add:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   5467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDWrr),
     /*   5472 */     GIR_RootConstrainSelectedInstOperands,
     /*   5473 */     // GIR_Coverage, 2530,
     /*   5473 */     GIR_Done,
     /*   5474 */   // Label 195: @5474
     /*   5474 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(5501), // Rule ID 4699 //
     /*   5479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   5482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   5494 */     // (add:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   5494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ128rr),
     /*   5499 */     GIR_RootConstrainSelectedInstOperands,
     /*   5500 */     // GIR_Coverage, 4699,
     /*   5500 */     GIR_Done,
     /*   5501 */   // Label 196: @5501
     /*   5501 */   GIM_Reject,
     /*   5502 */ // Label 187: @5502
     /*   5502 */ GIM_Reject,
     /*   5503 */ // Label 89: @5503
     /*   5503 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(5817),
     /*   5508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   5511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   5514 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(5576), // Rule ID 23437 //
     /*   5519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5534 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5537 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5541 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5558 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5574 */     GIR_RootConstrainSelectedInstOperands,
     /*   5575 */     // GIR_Coverage, 23437,
     /*   5575 */     GIR_EraseRootFromParent_Done,
     /*   5576 */   // Label 198: @5576
     /*   5576 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(5638), // Rule ID 23720 //
     /*   5581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5620 */     // (add:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5636 */     GIR_RootConstrainSelectedInstOperands,
     /*   5637 */     // GIR_Coverage, 23720,
     /*   5637 */     GIR_EraseRootFromParent_Done,
     /*   5638 */   // Label 199: @5638
     /*   5638 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(5700), // Rule ID 2539 //
     /*   5643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5682 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDYrm),
     /*   5685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5698 */     GIR_RootConstrainSelectedInstOperands,
     /*   5699 */     // GIR_Coverage, 2539,
     /*   5699 */     GIR_EraseRootFromParent_Done,
     /*   5700 */   // Label 200: @5700
     /*   5700 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(5762), // Rule ID 4672 //
     /*   5705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5744 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rm),
     /*   5747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5760 */     GIR_RootConstrainSelectedInstOperands,
     /*   5761 */     // GIR_Coverage, 4672,
     /*   5761 */     GIR_EraseRootFromParent_Done,
     /*   5762 */   // Label 201: @5762
     /*   5762 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(5789), // Rule ID 2538 //
     /*   5767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   5770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   5782 */     // (add:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPADDDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   5782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDYrr),
     /*   5787 */     GIR_RootConstrainSelectedInstOperands,
     /*   5788 */     // GIR_Coverage, 2538,
     /*   5788 */     GIR_Done,
     /*   5789 */   // Label 202: @5789
     /*   5789 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(5816), // Rule ID 4669 //
     /*   5794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   5797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   5809 */     // (add:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPADDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   5809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZ256rr),
     /*   5814 */     GIR_RootConstrainSelectedInstOperands,
     /*   5815 */     // GIR_Coverage, 4669,
     /*   5815 */     GIR_Done,
     /*   5816 */   // Label 203: @5816
     /*   5816 */   GIM_Reject,
     /*   5817 */ // Label 197: @5817
     /*   5817 */ GIM_Reject,
     /*   5818 */ // Label 90: @5818
     /*   5818 */ GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(5973),
     /*   5823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   5826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   5829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5833 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(5891), // Rule ID 23696 //
     /*   5838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5873 */     // (add:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   5880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5889 */     GIR_RootConstrainSelectedInstOperands,
     /*   5890 */     // GIR_Coverage, 23696,
     /*   5890 */     GIR_EraseRootFromParent_Done,
     /*   5891 */   // Label 205: @5891
     /*   5891 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(5949), // Rule ID 4636 //
     /*   5896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   5911 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   5914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   5918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   5922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   5931 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   5931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDQZrm),
     /*   5934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5936 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   5938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   5942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   5947 */     GIR_RootConstrainSelectedInstOperands,
     /*   5948 */     // GIR_Coverage, 4636,
     /*   5948 */     GIR_EraseRootFromParent_Done,
     /*   5949 */   // Label 206: @5949
     /*   5949 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(5972), // Rule ID 4633 //
     /*   5954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   5957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   5965 */     // (add:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPADDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*   5965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDQZrr),
     /*   5970 */     GIR_RootConstrainSelectedInstOperands,
     /*   5971 */     // GIR_Coverage, 4633,
     /*   5971 */     GIR_Done,
     /*   5972 */   // Label 207: @5972
     /*   5972 */   GIM_Reject,
     /*   5973 */ // Label 204: @5973
     /*   5973 */ GIM_Reject,
     /*   5974 */ // Label 91: @5974
     /*   5974 */ GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(6315),
     /*   5979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   5985 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(6047), // Rule ID 23429 //
     /*   5990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   5993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   5997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6029 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6045 */     GIR_RootConstrainSelectedInstOperands,
     /*   6046 */     // GIR_Coverage, 23429,
     /*   6046 */     GIR_EraseRootFromParent_Done,
     /*   6047 */   // Label 209: @6047
     /*   6047 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(6109), // Rule ID 23747 //
     /*   6052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6091 */     // (add:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6107 */     GIR_RootConstrainSelectedInstOperands,
     /*   6108 */     // GIR_Coverage, 23747,
     /*   6108 */     GIR_EraseRootFromParent_Done,
     /*   6109 */   // Label 210: @6109
     /*   6109 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(6171), // Rule ID 2523 //
     /*   6114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6153 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBrm),
     /*   6156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6169 */     GIR_RootConstrainSelectedInstOperands,
     /*   6170 */     // GIR_Coverage, 2523,
     /*   6170 */     GIR_EraseRootFromParent_Done,
     /*   6171 */   // Label 211: @6171
     /*   6171 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(6233), // Rule ID 4720 //
     /*   6176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6215 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rm),
     /*   6218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6231 */     GIR_RootConstrainSelectedInstOperands,
     /*   6232 */     // GIR_Coverage, 4720,
     /*   6232 */     GIR_EraseRootFromParent_Done,
     /*   6233 */   // Label 212: @6233
     /*   6233 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(6260), // Rule ID 2522 //
     /*   6238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   6241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6253 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6253 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBrr),
     /*   6258 */     GIR_RootConstrainSelectedInstOperands,
     /*   6259 */     // GIR_Coverage, 2522,
     /*   6259 */     GIR_Done,
     /*   6260 */   // Label 213: @6260
     /*   6260 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(6287), // Rule ID 2524 //
     /*   6265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   6268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   6280 */     // (add:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*   6280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDBrr),
     /*   6285 */     GIR_RootConstrainSelectedInstOperands,
     /*   6286 */     // GIR_Coverage, 2524,
     /*   6286 */     GIR_Done,
     /*   6287 */   // Label 214: @6287
     /*   6287 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(6314), // Rule ID 4717 //
     /*   6292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   6307 */     // (add:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*   6307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ128rr),
     /*   6312 */     GIR_RootConstrainSelectedInstOperands,
     /*   6313 */     // GIR_Coverage, 4717,
     /*   6313 */     GIR_Done,
     /*   6314 */   // Label 215: @6314
     /*   6314 */   GIM_Reject,
     /*   6315 */ // Label 208: @6315
     /*   6315 */ GIM_Reject,
     /*   6316 */ // Label 92: @6316
     /*   6316 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(6630),
     /*   6321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*   6324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*   6327 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(6389), // Rule ID 23434 //
     /*   6332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6347 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6350 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6354 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6371 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6387 */     GIR_RootConstrainSelectedInstOperands,
     /*   6388 */     // GIR_Coverage, 23434,
     /*   6388 */     GIR_EraseRootFromParent_Done,
     /*   6389 */   // Label 217: @6389
     /*   6389 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(6451), // Rule ID 23735 //
     /*   6394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6426 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6433 */     // (add:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6449 */     GIR_RootConstrainSelectedInstOperands,
     /*   6450 */     // GIR_Coverage, 23735,
     /*   6450 */     GIR_EraseRootFromParent_Done,
     /*   6451 */   // Label 218: @6451
     /*   6451 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(6513), // Rule ID 2533 //
     /*   6456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6475 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6478 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6482 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6495 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWYrm),
     /*   6498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6511 */     GIR_RootConstrainSelectedInstOperands,
     /*   6512 */     // GIR_Coverage, 2533,
     /*   6512 */     GIR_EraseRootFromParent_Done,
     /*   6513 */   // Label 219: @6513
     /*   6513 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(6575), // Rule ID 4696 //
     /*   6518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6540 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6544 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6550 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6557 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rm),
     /*   6560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6562 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6573 */     GIR_RootConstrainSelectedInstOperands,
     /*   6574 */     // GIR_Coverage, 4696,
     /*   6574 */     GIR_EraseRootFromParent_Done,
     /*   6575 */   // Label 220: @6575
     /*   6575 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(6602), // Rule ID 2532 //
     /*   6580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6595 */     // (add:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*   6595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWYrr),
     /*   6600 */     GIR_RootConstrainSelectedInstOperands,
     /*   6601 */     // GIR_Coverage, 2532,
     /*   6601 */     GIR_Done,
     /*   6602 */   // Label 221: @6602
     /*   6602 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(6629), // Rule ID 4693 //
     /*   6607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6622 */     // (add:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*   6622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZ256rr),
     /*   6627 */     GIR_RootConstrainSelectedInstOperands,
     /*   6628 */     // GIR_Coverage, 4693,
     /*   6628 */     GIR_Done,
     /*   6629 */   // Label 222: @6629
     /*   6629 */   GIM_Reject,
     /*   6630 */ // Label 216: @6630
     /*   6630 */ GIM_Reject,
     /*   6631 */ // Label 93: @6631
     /*   6631 */ GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(6786),
     /*   6636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*   6639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*   6642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6646 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6704), // Rule ID 23714 //
     /*   6651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6686 */     // (add:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6691 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6702 */     GIR_RootConstrainSelectedInstOperands,
     /*   6703 */     // GIR_Coverage, 23714,
     /*   6703 */     GIR_EraseRootFromParent_Done,
     /*   6704 */   // Label 224: @6704
     /*   6704 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6762), // Rule ID 4663 //
     /*   6709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6744 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDDZrm),
     /*   6747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6760 */     GIR_RootConstrainSelectedInstOperands,
     /*   6761 */     // GIR_Coverage, 4663,
     /*   6761 */     GIR_EraseRootFromParent_Done,
     /*   6762 */   // Label 225: @6762
     /*   6762 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6785), // Rule ID 4660 //
     /*   6767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*   6770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   6778 */     // (add:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPADDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*   6778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDDZrr),
     /*   6783 */     GIR_RootConstrainSelectedInstOperands,
     /*   6784 */     // GIR_Coverage, 4660,
     /*   6784 */     GIR_Done,
     /*   6785 */   // Label 226: @6785
     /*   6785 */   GIM_Reject,
     /*   6786 */ // Label 223: @6786
     /*   6786 */ GIM_Reject,
     /*   6787 */ // Label 94: @6787
     /*   6787 */ GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(7101),
     /*   6792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*   6795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*   6798 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6860), // Rule ID 23431 //
     /*   6803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6842 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6847 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6858 */     GIR_RootConstrainSelectedInstOperands,
     /*   6859 */     // GIR_Coverage, 23431,
     /*   6859 */     GIR_EraseRootFromParent_Done,
     /*   6860 */   // Label 228: @6860
     /*   6860 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6922), // Rule ID 23744 //
     /*   6865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6904 */     // (add:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   6907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6920 */     GIR_RootConstrainSelectedInstOperands,
     /*   6921 */     // GIR_Coverage, 23744,
     /*   6921 */     GIR_EraseRootFromParent_Done,
     /*   6922 */   // Label 229: @6922
     /*   6922 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6984), // Rule ID 2527 //
     /*   6927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   6930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   6938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   6946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   6949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   6953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   6957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   6966 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   6966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBYrm),
     /*   6969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   6973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   6977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   6982 */     GIR_RootConstrainSelectedInstOperands,
     /*   6983 */     // GIR_Coverage, 2527,
     /*   6983 */     GIR_EraseRootFromParent_Done,
     /*   6984 */   // Label 230: @6984
     /*   6984 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(7046), // Rule ID 4714 //
     /*   6989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   6992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   6996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7008 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7015 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7028 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rm),
     /*   7031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7033 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7044 */     GIR_RootConstrainSelectedInstOperands,
     /*   7045 */     // GIR_Coverage, 4714,
     /*   7045 */     GIR_EraseRootFromParent_Done,
     /*   7046 */   // Label 231: @7046
     /*   7046 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(7073), // Rule ID 2526 //
     /*   7051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*   7054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   7066 */     // (add:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*   7066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBYrr),
     /*   7071 */     GIR_RootConstrainSelectedInstOperands,
     /*   7072 */     // GIR_Coverage, 2526,
     /*   7072 */     GIR_Done,
     /*   7073 */   // Label 232: @7073
     /*   7073 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(7100), // Rule ID 4711 //
     /*   7078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   7081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   7093 */     // (add:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*   7093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZ256rr),
     /*   7098 */     GIR_RootConstrainSelectedInstOperands,
     /*   7099 */     // GIR_Coverage, 4711,
     /*   7099 */     GIR_Done,
     /*   7100 */   // Label 233: @7100
     /*   7100 */   GIM_Reject,
     /*   7101 */ // Label 227: @7101
     /*   7101 */ GIM_Reject,
     /*   7102 */ // Label 95: @7102
     /*   7102 */ GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(7257),
     /*   7107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*   7110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*   7113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7117 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(7175), // Rule ID 23732 //
     /*   7122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7157 */     // (add:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7173 */     GIR_RootConstrainSelectedInstOperands,
     /*   7174 */     // GIR_Coverage, 23732,
     /*   7174 */     GIR_EraseRootFromParent_Done,
     /*   7175 */   // Label 235: @7175
     /*   7175 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(7233), // Rule ID 4690 //
     /*   7180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7215 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDWZrm),
     /*   7218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7231 */     GIR_RootConstrainSelectedInstOperands,
     /*   7232 */     // GIR_Coverage, 4690,
     /*   7232 */     GIR_EraseRootFromParent_Done,
     /*   7233 */   // Label 236: @7233
     /*   7233 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7256), // Rule ID 4687 //
     /*   7238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7249 */     // (add:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*   7249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDWZrr),
     /*   7254 */     GIR_RootConstrainSelectedInstOperands,
     /*   7255 */     // GIR_Coverage, 4687,
     /*   7255 */     GIR_Done,
     /*   7256 */   // Label 237: @7256
     /*   7256 */   GIM_Reject,
     /*   7257 */ // Label 234: @7257
     /*   7257 */ GIM_Reject,
     /*   7258 */ // Label 96: @7258
     /*   7258 */ GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7413),
     /*   7263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*   7266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*   7269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7273 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7331), // Rule ID 23741 //
     /*   7278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7289 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7313 */     // (add:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7318 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7329 */     GIR_RootConstrainSelectedInstOperands,
     /*   7330 */     // GIR_Coverage, 23741,
     /*   7330 */     GIR_EraseRootFromParent_Done,
     /*   7331 */   // Label 239: @7331
     /*   7331 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7389), // Rule ID 4708 //
     /*   7336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7351 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7354 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   7358 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7364 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7371 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDBZrm),
     /*   7374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7376 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7378 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7387 */     GIR_RootConstrainSelectedInstOperands,
     /*   7388 */     // GIR_Coverage, 4708,
     /*   7388 */     GIR_EraseRootFromParent_Done,
     /*   7389 */   // Label 240: @7389
     /*   7389 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7412), // Rule ID 4705 //
     /*   7394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*   7397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   7405 */     // (add:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*   7405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDBZrr),
     /*   7410 */     GIR_RootConstrainSelectedInstOperands,
     /*   7411 */     // GIR_Coverage, 4705,
     /*   7411 */     GIR_Done,
     /*   7412 */   // Label 241: @7412
     /*   7412 */   GIM_Reject,
     /*   7413 */ // Label 238: @7413
     /*   7413 */ GIM_Reject,
     /*   7414 */ // Label 97: @7414
     /*   7414 */ GIM_Reject,
     /*   7415 */ // Label 1: @7415
     /*   7415 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 258*/ GIMT_Encode4(10950),
     /*   7426 */ /*GILLT_s8*//*Label 242*/ GIMT_Encode4(7522),
     /*   7430 */ /*GILLT_s16*//*Label 243*/ GIMT_Encode4(7874),
     /*   7434 */ /*GILLT_s32*//*Label 244*/ GIMT_Encode4(8226),
     /*   7438 */ /*GILLT_s64*//*Label 245*/ GIMT_Encode4(8578), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   7454 */ /*GILLT_v2s64*//*Label 246*/ GIMT_Encode4(8938), GIMT_Encode4(0),
     /*   7462 */ /*GILLT_v4s32*//*Label 247*/ GIMT_Encode4(9156),
     /*   7466 */ /*GILLT_v4s64*//*Label 248*/ GIMT_Encode4(9374), GIMT_Encode4(0),
     /*   7474 */ /*GILLT_v8s16*//*Label 249*/ GIMT_Encode4(9565),
     /*   7478 */ /*GILLT_v8s32*//*Label 250*/ GIMT_Encode4(9783),
     /*   7482 */ /*GILLT_v8s64*//*Label 251*/ GIMT_Encode4(9974), GIMT_Encode4(0),
     /*   7490 */ /*GILLT_v16s8*//*Label 252*/ GIMT_Encode4(10068),
     /*   7494 */ /*GILLT_v16s16*//*Label 253*/ GIMT_Encode4(10286),
     /*   7498 */ /*GILLT_v16s32*//*Label 254*/ GIMT_Encode4(10477), GIMT_Encode4(0),
     /*   7506 */ /*GILLT_v32s8*//*Label 255*/ GIMT_Encode4(10571),
     /*   7510 */ /*GILLT_v32s16*//*Label 256*/ GIMT_Encode4(10762), GIMT_Encode4(0),
     /*   7518 */ /*GILLT_v64s8*//*Label 257*/ GIMT_Encode4(10856),
     /*   7522 */ // Label 242: @7522
     /*   7522 */ GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(7873),
     /*   7527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*   7530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*   7533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7537 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(7598), // Rule ID 22808 //
     /*   7542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7557 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7564 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7577 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm),
     /*   7580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7596 */     GIR_RootConstrainSelectedInstOperands,
     /*   7597 */     // GIR_Coverage, 22808,
     /*   7597 */     GIR_EraseRootFromParent_Done,
     /*   7598 */   // Label 260: @7598
     /*   7598 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(7659), // Rule ID 22898 //
     /*   7603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7625 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*   7629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7638 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (SUB8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8rm_ND),
     /*   7641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7643 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7649 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7657 */     GIR_RootConstrainSelectedInstOperands,
     /*   7658 */     // GIR_Coverage, 22898,
     /*   7658 */     GIR_EraseRootFromParent_Done,
     /*   7659 */   // Label 261: @7659
     /*   7659 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(7687), // Rule ID 241 //
     /*   7664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7675 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r),
     /*   7678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7685 */     GIR_RootConstrainSelectedInstOperands,
     /*   7686 */     // GIR_Coverage, 241,
     /*   7686 */     GIR_EraseRootFromParent_Done,
     /*   7687 */   // Label 262: @7687
     /*   7687 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(7715), // Rule ID 249 //
     /*   7692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7703 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /*   7703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_ND),
     /*   7706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7713 */     GIR_RootConstrainSelectedInstOperands,
     /*   7714 */     // GIR_Coverage, 249,
     /*   7714 */     GIR_EraseRootFromParent_Done,
     /*   7715 */   // Label 263: @7715
     /*   7715 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(7740), // Rule ID 257 //
     /*   7720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   7723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   7727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7731 */     // (sub:{ *:[i8] } 0:{ *:[i8] }, GR8:{ *:[i8] }:$src1)  =>  (NEG8r_NF_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*   7731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8r_NF_ND),
     /*   7734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7738 */     GIR_RootConstrainSelectedInstOperands,
     /*   7739 */     // GIR_Coverage, 257,
     /*   7739 */     GIR_EraseRootFromParent_Done,
     /*   7740 */   // Label 264: @7740
     /*   7740 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(7777), // Rule ID 22812 //
     /*   7745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7760 */     // MIs[1] Operand 1
     /*   7760 */     // No operand predicates
     /*   7760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7762 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri),
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7775 */     GIR_RootConstrainSelectedInstOperands,
     /*   7776 */     // GIR_Coverage, 22812,
     /*   7776 */     GIR_EraseRootFromParent_Done,
     /*   7777 */   // Label 265: @7777
     /*   7777 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(7814), // Rule ID 22902 //
     /*   7782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7797 */     // MIs[1] Operand 1
     /*   7797 */     // No operand predicates
     /*   7797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7799 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SUB8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*   7799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8ri_ND),
     /*   7802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   7809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7812 */     GIR_RootConstrainSelectedInstOperands,
     /*   7813 */     // GIR_Coverage, 22902,
     /*   7813 */     GIR_EraseRootFromParent_Done,
     /*   7814 */   // Label 266: @7814
     /*   7814 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(7843), // Rule ID 22804 //
     /*   7819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7830 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr),
     /*   7835 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7841 */     GIR_RootConstrainSelectedInstOperands,
     /*   7842 */     // GIR_Coverage, 22804,
     /*   7842 */     GIR_Done,
     /*   7843 */   // Label 267: @7843
     /*   7843 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(7872), // Rule ID 22894 //
     /*   7848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*   7859 */     // (sub:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SUB8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*   7859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB8rr_ND),
     /*   7864 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   7870 */     GIR_RootConstrainSelectedInstOperands,
     /*   7871 */     // GIR_Coverage, 22894,
     /*   7871 */     GIR_Done,
     /*   7872 */   // Label 268: @7872
     /*   7872 */   GIM_Reject,
     /*   7873 */ // Label 259: @7873
     /*   7873 */ GIM_Reject,
     /*   7874 */ // Label 243: @7874
     /*   7874 */ GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(8225),
     /*   7879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*   7882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*   7885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7889 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(7950), // Rule ID 22809 //
     /*   7894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   7897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7912 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7916 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7922 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7929 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm),
     /*   7932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7934 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   7940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   7943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   7948 */     GIR_RootConstrainSelectedInstOperands,
     /*   7949 */     // GIR_Coverage, 22809,
     /*   7949 */     GIR_EraseRootFromParent_Done,
     /*   7950 */   // Label 270: @7950
     /*   7950 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(8011), // Rule ID 22899 //
     /*   7955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   7958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   7962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   7970 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   7973 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   7977 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*   7981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   7990 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (SUB16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   7990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16rm_ND),
     /*   7993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   7995 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8009 */     GIR_RootConstrainSelectedInstOperands,
     /*   8010 */     // GIR_Coverage, 22899,
     /*   8010 */     GIR_EraseRootFromParent_Done,
     /*   8011 */   // Label 271: @8011
     /*   8011 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(8039), // Rule ID 242 //
     /*   8016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8027 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r),
     /*   8030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8032 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8037 */     GIR_RootConstrainSelectedInstOperands,
     /*   8038 */     // GIR_Coverage, 242,
     /*   8038 */     GIR_EraseRootFromParent_Done,
     /*   8039 */   // Label 272: @8039
     /*   8039 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(8067), // Rule ID 250 //
     /*   8044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8055 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /*   8055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_ND),
     /*   8058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8065 */     GIR_RootConstrainSelectedInstOperands,
     /*   8066 */     // GIR_Coverage, 250,
     /*   8066 */     GIR_EraseRootFromParent_Done,
     /*   8067 */   // Label 273: @8067
     /*   8067 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(8092), // Rule ID 258 //
     /*   8072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8083 */     // (sub:{ *:[i16] } 0:{ *:[i16] }, GR16:{ *:[i16] }:$src1)  =>  (NEG16r_NF_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*   8083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16r_NF_ND),
     /*   8086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8090 */     GIR_RootConstrainSelectedInstOperands,
     /*   8091 */     // GIR_Coverage, 258,
     /*   8091 */     GIR_EraseRootFromParent_Done,
     /*   8092 */   // Label 274: @8092
     /*   8092 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(8129), // Rule ID 22813 //
     /*   8097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8112 */     // MIs[1] Operand 1
     /*   8112 */     // No operand predicates
     /*   8112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8114 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri),
     /*   8117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8127 */     GIR_RootConstrainSelectedInstOperands,
     /*   8128 */     // GIR_Coverage, 22813,
     /*   8128 */     GIR_EraseRootFromParent_Done,
     /*   8129 */   // Label 275: @8129
     /*   8129 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(8166), // Rule ID 22903 //
     /*   8134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8149 */     // MIs[1] Operand 1
     /*   8149 */     // No operand predicates
     /*   8149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8151 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (SUB16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*   8151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16ri_ND),
     /*   8154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8164 */     GIR_RootConstrainSelectedInstOperands,
     /*   8165 */     // GIR_Coverage, 22903,
     /*   8165 */     GIR_EraseRootFromParent_Done,
     /*   8166 */   // Label 276: @8166
     /*   8166 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(8195), // Rule ID 22805 //
     /*   8171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8182 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8182 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr),
     /*   8187 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8193 */     GIR_RootConstrainSelectedInstOperands,
     /*   8194 */     // GIR_Coverage, 22805,
     /*   8194 */     GIR_Done,
     /*   8195 */   // Label 277: @8195
     /*   8195 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(8224), // Rule ID 22895 //
     /*   8200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*   8211 */     // (sub:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (SUB16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*   8211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB16rr_ND),
     /*   8216 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8222 */     GIR_RootConstrainSelectedInstOperands,
     /*   8223 */     // GIR_Coverage, 22895,
     /*   8223 */     GIR_Done,
     /*   8224 */   // Label 278: @8224
     /*   8224 */   GIM_Reject,
     /*   8225 */ // Label 269: @8225
     /*   8225 */ GIM_Reject,
     /*   8226 */ // Label 244: @8226
     /*   8226 */ GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(8577),
     /*   8231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   8234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   8237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8241 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(8302), // Rule ID 22810 //
     /*   8246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8268 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8274 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8281 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm),
     /*   8284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8286 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8300 */     GIR_RootConstrainSelectedInstOperands,
     /*   8301 */     // GIR_Coverage, 22810,
     /*   8301 */     GIR_EraseRootFromParent_Done,
     /*   8302 */   // Label 280: @8302
     /*   8302 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8363), // Rule ID 22900 //
     /*   8307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8329 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*   8333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8342 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (SUB32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32rm_ND),
     /*   8345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8361 */     GIR_RootConstrainSelectedInstOperands,
     /*   8362 */     // GIR_Coverage, 22900,
     /*   8362 */     GIR_EraseRootFromParent_Done,
     /*   8363 */   // Label 281: @8363
     /*   8363 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8391), // Rule ID 243 //
     /*   8368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8379 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r),
     /*   8382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8389 */     GIR_RootConstrainSelectedInstOperands,
     /*   8390 */     // GIR_Coverage, 243,
     /*   8390 */     GIR_EraseRootFromParent_Done,
     /*   8391 */   // Label 282: @8391
     /*   8391 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8419), // Rule ID 251 //
     /*   8396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8407 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_ND),
     /*   8410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8417 */     GIR_RootConstrainSelectedInstOperands,
     /*   8418 */     // GIR_Coverage, 251,
     /*   8418 */     GIR_EraseRootFromParent_Done,
     /*   8419 */   // Label 283: @8419
     /*   8419 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8444), // Rule ID 259 //
     /*   8424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8427 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8435 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, GR32:{ *:[i32] }:$src1)  =>  (NEG32r_NF_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*   8435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32r_NF_ND),
     /*   8438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8442 */     GIR_RootConstrainSelectedInstOperands,
     /*   8443 */     // GIR_Coverage, 259,
     /*   8443 */     GIR_EraseRootFromParent_Done,
     /*   8444 */   // Label 284: @8444
     /*   8444 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8481), // Rule ID 22814 //
     /*   8449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8464 */     // MIs[1] Operand 1
     /*   8464 */     // No operand predicates
     /*   8464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8466 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri),
     /*   8469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8471 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8479 */     GIR_RootConstrainSelectedInstOperands,
     /*   8480 */     // GIR_Coverage, 22814,
     /*   8480 */     GIR_EraseRootFromParent_Done,
     /*   8481 */   // Label 285: @8481
     /*   8481 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8518), // Rule ID 22904 //
     /*   8486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8501 */     // MIs[1] Operand 1
     /*   8501 */     // No operand predicates
     /*   8501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8503 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (SUB32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*   8503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32ri_ND),
     /*   8506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8513 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8516 */     GIR_RootConstrainSelectedInstOperands,
     /*   8517 */     // GIR_Coverage, 22904,
     /*   8517 */     GIR_EraseRootFromParent_Done,
     /*   8518 */   // Label 286: @8518
     /*   8518 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8547), // Rule ID 22806 //
     /*   8523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8534 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr),
     /*   8539 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8545 */     GIR_RootConstrainSelectedInstOperands,
     /*   8546 */     // GIR_Coverage, 22806,
     /*   8546 */     GIR_Done,
     /*   8547 */   // Label 287: @8547
     /*   8547 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8576), // Rule ID 22896 //
     /*   8552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*   8563 */     // (sub:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (SUB32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*   8563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB32rr_ND),
     /*   8568 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8574 */     GIR_RootConstrainSelectedInstOperands,
     /*   8575 */     // GIR_Coverage, 22896,
     /*   8575 */     GIR_Done,
     /*   8576 */   // Label 288: @8576
     /*   8576 */   GIM_Reject,
     /*   8577 */ // Label 279: @8577
     /*   8577 */ GIM_Reject,
     /*   8578 */ // Label 245: @8578
     /*   8578 */ GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(8937),
     /*   8583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   8586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   8589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8593 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(8654), // Rule ID 22811 //
     /*   8598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8633 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm),
     /*   8636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8652 */     GIR_RootConstrainSelectedInstOperands,
     /*   8653 */     // GIR_Coverage, 22811,
     /*   8653 */     GIR_EraseRootFromParent_Done,
     /*   8654 */   // Label 290: @8654
     /*   8654 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(8715), // Rule ID 22901 //
     /*   8659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8694 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64rm_ND),
     /*   8697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   8705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   8713 */     GIR_RootConstrainSelectedInstOperands,
     /*   8714 */     // GIR_Coverage, 22901,
     /*   8714 */     GIR_EraseRootFromParent_Done,
     /*   8715 */   // Label 291: @8715
     /*   8715 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(8743), // Rule ID 244 //
     /*   8720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8731 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r),
     /*   8734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8736 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8741 */     GIR_RootConstrainSelectedInstOperands,
     /*   8742 */     // GIR_Coverage, 244,
     /*   8742 */     GIR_EraseRootFromParent_Done,
     /*   8743 */   // Label 292: @8743
     /*   8743 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(8771), // Rule ID 252 //
     /*   8748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8751 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8759 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /*   8759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_ND),
     /*   8762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8764 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8769 */     GIR_RootConstrainSelectedInstOperands,
     /*   8770 */     // GIR_Coverage, 252,
     /*   8770 */     GIR_EraseRootFromParent_Done,
     /*   8771 */   // Label 293: @8771
     /*   8771 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(8796), // Rule ID 260 //
     /*   8776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*   8779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   8783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8787 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, GR64:{ *:[i64] }:$src1)  =>  (NEG64r_NF_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*   8787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64r_NF_ND),
     /*   8790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8794 */     GIR_RootConstrainSelectedInstOperands,
     /*   8795 */     // GIR_Coverage, 260,
     /*   8795 */     GIR_EraseRootFromParent_Done,
     /*   8796 */   // Label 294: @8796
     /*   8796 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(8837), // Rule ID 22815 //
     /*   8801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8820 */     // MIs[1] Operand 1
     /*   8820 */     // No operand predicates
     /*   8820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8822 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32),
     /*   8825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8835 */     GIR_RootConstrainSelectedInstOperands,
     /*   8836 */     // GIR_Coverage, 22815,
     /*   8836 */     GIR_EraseRootFromParent_Done,
     /*   8837 */   // Label 295: @8837
     /*   8837 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(8878), // Rule ID 22905 //
     /*   8842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   8857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*   8861 */     // MIs[1] Operand 1
     /*   8861 */     // No operand predicates
     /*   8861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8863 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (SUB64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*   8863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64ri32_ND),
     /*   8866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*   8873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*   8876 */     GIR_RootConstrainSelectedInstOperands,
     /*   8877 */     // GIR_Coverage, 22905,
     /*   8877 */     GIR_EraseRootFromParent_Done,
     /*   8878 */   // Label 296: @8878
     /*   8878 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(8907), // Rule ID 22807 //
     /*   8883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*   8886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8894 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr),
     /*   8899 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8905 */     GIR_RootConstrainSelectedInstOperands,
     /*   8906 */     // GIR_Coverage, 22807,
     /*   8906 */     GIR_Done,
     /*   8907 */   // Label 297: @8907
     /*   8907 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(8936), // Rule ID 22897 //
     /*   8912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*   8923 */     // (sub:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (SUB64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*   8923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB64rr_ND),
     /*   8928 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*   8934 */     GIR_RootConstrainSelectedInstOperands,
     /*   8935 */     // GIR_Coverage, 22897,
     /*   8935 */     GIR_Done,
     /*   8936 */   // Label 298: @8936
     /*   8936 */   GIM_Reject,
     /*   8937 */ // Label 289: @8937
     /*   8937 */ GIM_Reject,
     /*   8938 */ // Label 246: @8938
     /*   8938 */ GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(9155),
     /*   8943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   8949 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(9011), // Rule ID 2607 //
     /*   8954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   8957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   8965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   8973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   8976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   8980 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   8984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   8993 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   8993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQrm),
     /*   8996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9009 */     GIR_RootConstrainSelectedInstOperands,
     /*   9010 */     // GIR_Coverage, 2607,
     /*   9010 */     GIR_EraseRootFromParent_Done,
     /*   9011 */   // Label 300: @9011
     /*   9011 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(9073), // Rule ID 4744 //
     /*   9016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9035 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9038 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9055 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rm),
     /*   9058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9071 */     GIR_RootConstrainSelectedInstOperands,
     /*   9072 */     // GIR_Coverage, 4744,
     /*   9072 */     GIR_EraseRootFromParent_Done,
     /*   9073 */   // Label 301: @9073
     /*   9073 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(9100), // Rule ID 2606 //
     /*   9078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9093 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQrr),
     /*   9098 */     GIR_RootConstrainSelectedInstOperands,
     /*   9099 */     // GIR_Coverage, 2606,
     /*   9099 */     GIR_Done,
     /*   9100 */   // Label 302: @9100
     /*   9100 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(9127), // Rule ID 2608 //
     /*   9105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9120 */     // (sub:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PSUBQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*   9120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBQrr),
     /*   9125 */     GIR_RootConstrainSelectedInstOperands,
     /*   9126 */     // GIR_Coverage, 2608,
     /*   9126 */     GIR_Done,
     /*   9127 */   // Label 303: @9127
     /*   9127 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(9154), // Rule ID 4741 //
     /*   9132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9147 */     // (sub:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPSUBQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*   9147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ128rr),
     /*   9152 */     GIR_RootConstrainSelectedInstOperands,
     /*   9153 */     // GIR_Coverage, 4741,
     /*   9153 */     GIR_Done,
     /*   9154 */   // Label 304: @9154
     /*   9154 */   GIM_Reject,
     /*   9155 */ // Label 299: @9155
     /*   9155 */ GIM_Reject,
     /*   9156 */ // Label 247: @9156
     /*   9156 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(9373),
     /*   9161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9167 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(9229), // Rule ID 2601 //
     /*   9172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9211 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDrm),
     /*   9214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9216 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 2601,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 306: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(9291), // Rule ID 4771 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9273 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rm),
     /*   9276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9289 */     GIR_RootConstrainSelectedInstOperands,
     /*   9290 */     // GIR_Coverage, 4771,
     /*   9290 */     GIR_EraseRootFromParent_Done,
     /*   9291 */   // Label 307: @9291
     /*   9291 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(9318), // Rule ID 2600 //
     /*   9296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*   9299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9311 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDrr),
     /*   9316 */     GIR_RootConstrainSelectedInstOperands,
     /*   9317 */     // GIR_Coverage, 2600,
     /*   9317 */     GIR_Done,
     /*   9318 */   // Label 308: @9318
     /*   9318 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(9345), // Rule ID 2602 //
     /*   9323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9338 */     // (sub:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSUBDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*   9338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBDrr),
     /*   9343 */     GIR_RootConstrainSelectedInstOperands,
     /*   9344 */     // GIR_Coverage, 2602,
     /*   9344 */     GIR_Done,
     /*   9345 */   // Label 309: @9345
     /*   9345 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(9372), // Rule ID 4768 //
     /*   9350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9365 */     // (sub:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPSUBDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*   9365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ128rr),
     /*   9370 */     GIR_RootConstrainSelectedInstOperands,
     /*   9371 */     // GIR_Coverage, 4768,
     /*   9371 */     GIR_Done,
     /*   9372 */   // Label 310: @9372
     /*   9372 */   GIM_Reject,
     /*   9373 */ // Label 305: @9373
     /*   9373 */ GIM_Reject,
     /*   9374 */ // Label 248: @9374
     /*   9374 */ GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(9564),
     /*   9379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*   9382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*   9385 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(9447), // Rule ID 2611 //
     /*   9390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9412 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9429 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrm),
     /*   9432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9445 */     GIR_RootConstrainSelectedInstOperands,
     /*   9446 */     // GIR_Coverage, 2611,
     /*   9446 */     GIR_EraseRootFromParent_Done,
     /*   9447 */   // Label 312: @9447
     /*   9447 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(9509), // Rule ID 4735 //
     /*   9452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9484 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9491 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rm),
     /*   9494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9507 */     GIR_RootConstrainSelectedInstOperands,
     /*   9508 */     // GIR_Coverage, 4735,
     /*   9508 */     GIR_EraseRootFromParent_Done,
     /*   9509 */   // Label 313: @9509
     /*   9509 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(9536), // Rule ID 2610 //
     /*   9514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9529 */     // (sub:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPSUBQYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*   9529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQYrr),
     /*   9534 */     GIR_RootConstrainSelectedInstOperands,
     /*   9535 */     // GIR_Coverage, 2610,
     /*   9535 */     GIR_Done,
     /*   9536 */   // Label 314: @9536
     /*   9536 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(9563), // Rule ID 4732 //
     /*   9541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9556 */     // (sub:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPSUBQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*   9556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZ256rr),
     /*   9561 */     GIR_RootConstrainSelectedInstOperands,
     /*   9562 */     // GIR_Coverage, 4732,
     /*   9562 */     GIR_Done,
     /*   9563 */   // Label 315: @9563
     /*   9563 */   GIM_Reject,
     /*   9564 */ // Label 311: @9564
     /*   9564 */ GIM_Reject,
     /*   9565 */ // Label 249: @9565
     /*   9565 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(9782),
     /*   9570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9576 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(9638), // Rule ID 2595 //
     /*   9581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9620 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWrm),
     /*   9623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9636 */     GIR_RootConstrainSelectedInstOperands,
     /*   9637 */     // GIR_Coverage, 2595,
     /*   9637 */     GIR_EraseRootFromParent_Done,
     /*   9638 */   // Label 317: @9638
     /*   9638 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(9700), // Rule ID 4792 //
     /*   9643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9662 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9665 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9669 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9682 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rm),
     /*   9685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9698 */     GIR_RootConstrainSelectedInstOperands,
     /*   9699 */     // GIR_Coverage, 4792,
     /*   9699 */     GIR_EraseRootFromParent_Done,
     /*   9700 */   // Label 318: @9700
     /*   9700 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(9727), // Rule ID 2594 //
     /*   9705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*   9708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9720 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWrr),
     /*   9725 */     GIR_RootConstrainSelectedInstOperands,
     /*   9726 */     // GIR_Coverage, 2594,
     /*   9726 */     GIR_Done,
     /*   9727 */   // Label 319: @9727
     /*   9727 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(9754), // Rule ID 2596 //
     /*   9732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*   9735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*   9747 */     // (sub:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*   9747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBWrr),
     /*   9752 */     GIR_RootConstrainSelectedInstOperands,
     /*   9753 */     // GIR_Coverage, 2596,
     /*   9753 */     GIR_Done,
     /*   9754 */   // Label 320: @9754
     /*   9754 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(9781), // Rule ID 4789 //
     /*   9759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*   9762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*   9774 */     // (sub:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*   9774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ128rr),
     /*   9779 */     GIR_RootConstrainSelectedInstOperands,
     /*   9780 */     // GIR_Coverage, 4789,
     /*   9780 */     GIR_Done,
     /*   9781 */   // Label 321: @9781
     /*   9781 */   GIM_Reject,
     /*   9782 */ // Label 316: @9782
     /*   9782 */ GIM_Reject,
     /*   9783 */ // Label 250: @9783
     /*   9783 */ GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(9973),
     /*   9788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*   9791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*   9794 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(9856), // Rule ID 2605 //
     /*   9799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9818 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9821 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9825 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9838 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrm),
     /*   9841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9843 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9854 */     GIR_RootConstrainSelectedInstOperands,
     /*   9855 */     // GIR_Coverage, 2605,
     /*   9855 */     GIR_EraseRootFromParent_Done,
     /*   9856 */   // Label 323: @9856
     /*   9856 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(9918), // Rule ID 4762 //
     /*   9861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*   9880 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*   9883 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*   9887 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*   9891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*   9900 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*   9900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rm),
     /*   9903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9905 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*   9911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*   9916 */     GIR_RootConstrainSelectedInstOperands,
     /*   9917 */     // GIR_Coverage, 4762,
     /*   9917 */     GIR_EraseRootFromParent_Done,
     /*   9918 */   // Label 324: @9918
     /*   9918 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(9945), // Rule ID 2604 //
     /*   9923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*   9926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*   9938 */     // (sub:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSUBDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*   9938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDYrr),
     /*   9943 */     GIR_RootConstrainSelectedInstOperands,
     /*   9944 */     // GIR_Coverage, 2604,
     /*   9944 */     GIR_Done,
     /*   9945 */   // Label 325: @9945
     /*   9945 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(9972), // Rule ID 4759 //
     /*   9950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*   9953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*   9965 */     // (sub:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPSUBDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*   9965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZ256rr),
     /*   9970 */     GIR_RootConstrainSelectedInstOperands,
     /*   9971 */     // GIR_Coverage, 4759,
     /*   9971 */     GIR_Done,
     /*   9972 */   // Label 326: @9972
     /*   9972 */   GIM_Reject,
     /*   9973 */ // Label 322: @9973
     /*   9973 */ GIM_Reject,
     /*   9974 */ // Label 251: @9974
     /*   9974 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(10067),
     /*   9979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*   9982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*   9985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*   9993 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(10047), // Rule ID 4726 //
     /*   9998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10029 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrm),
     /*  10032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10045 */     GIR_RootConstrainSelectedInstOperands,
     /*  10046 */     // GIR_Coverage, 4726,
     /*  10046 */     GIR_EraseRootFromParent_Done,
     /*  10047 */   // Label 328: @10047
     /*  10047 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(10066), // Rule ID 4723 //
     /*  10052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10059 */     // (sub:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPSUBQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  10059 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBQZrr),
     /*  10064 */     GIR_RootConstrainSelectedInstOperands,
     /*  10065 */     // GIR_Coverage, 4723,
     /*  10065 */     GIR_Done,
     /*  10066 */   // Label 329: @10066
     /*  10066 */   GIM_Reject,
     /*  10067 */ // Label 327: @10067
     /*  10067 */ GIM_Reject,
     /*  10068 */ // Label 252: @10068
     /*  10068 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(10285),
     /*  10073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10079 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(10141), // Rule ID 2589 //
     /*  10084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10106 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10123 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBrm),
     /*  10126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10128 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10139 */     GIR_RootConstrainSelectedInstOperands,
     /*  10140 */     // GIR_Coverage, 2589,
     /*  10140 */     GIR_EraseRootFromParent_Done,
     /*  10141 */   // Label 331: @10141
     /*  10141 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(10203), // Rule ID 4810 //
     /*  10146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10165 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10168 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10172 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10185 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rm),
     /*  10188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10190 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10201 */     GIR_RootConstrainSelectedInstOperands,
     /*  10202 */     // GIR_Coverage, 4810,
     /*  10202 */     GIR_EraseRootFromParent_Done,
     /*  10203 */   // Label 332: @10203
     /*  10203 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(10230), // Rule ID 2588 //
     /*  10208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  10211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10223 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBrr),
     /*  10228 */     GIR_RootConstrainSelectedInstOperands,
     /*  10229 */     // GIR_Coverage, 2588,
     /*  10229 */     GIR_Done,
     /*  10230 */   // Label 333: @10230
     /*  10230 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(10257), // Rule ID 2590 //
     /*  10235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  10238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  10250 */     // (sub:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  10250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBBrr),
     /*  10255 */     GIR_RootConstrainSelectedInstOperands,
     /*  10256 */     // GIR_Coverage, 2590,
     /*  10256 */     GIR_Done,
     /*  10257 */   // Label 334: @10257
     /*  10257 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(10284), // Rule ID 4807 //
     /*  10262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  10277 */     // (sub:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  10277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ128rr),
     /*  10282 */     GIR_RootConstrainSelectedInstOperands,
     /*  10283 */     // GIR_Coverage, 4807,
     /*  10283 */     GIR_Done,
     /*  10284 */   // Label 335: @10284
     /*  10284 */   GIM_Reject,
     /*  10285 */ // Label 330: @10285
     /*  10285 */ GIM_Reject,
     /*  10286 */ // Label 253: @10286
     /*  10286 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(10476),
     /*  10291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  10294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  10297 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(10359), // Rule ID 2599 //
     /*  10302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10334 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10341 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrm),
     /*  10344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10357 */     GIR_RootConstrainSelectedInstOperands,
     /*  10358 */     // GIR_Coverage, 2599,
     /*  10358 */     GIR_EraseRootFromParent_Done,
     /*  10359 */   // Label 337: @10359
     /*  10359 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(10421), // Rule ID 4786 //
     /*  10364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10403 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rm),
     /*  10406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10419 */     GIR_RootConstrainSelectedInstOperands,
     /*  10420 */     // GIR_Coverage, 4786,
     /*  10420 */     GIR_EraseRootFromParent_Done,
     /*  10421 */   // Label 338: @10421
     /*  10421 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(10448), // Rule ID 2598 //
     /*  10426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10441 */     // (sub:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  10441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWYrr),
     /*  10446 */     GIR_RootConstrainSelectedInstOperands,
     /*  10447 */     // GIR_Coverage, 2598,
     /*  10447 */     GIR_Done,
     /*  10448 */   // Label 339: @10448
     /*  10448 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(10475), // Rule ID 4783 //
     /*  10453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10468 */     // (sub:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  10468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZ256rr),
     /*  10473 */     GIR_RootConstrainSelectedInstOperands,
     /*  10474 */     // GIR_Coverage, 4783,
     /*  10474 */     GIR_Done,
     /*  10475 */   // Label 340: @10475
     /*  10475 */   GIM_Reject,
     /*  10476 */ // Label 336: @10476
     /*  10476 */ GIM_Reject,
     /*  10477 */ // Label 254: @10477
     /*  10477 */ GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(10570),
     /*  10482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  10485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  10488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10496 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(10550), // Rule ID 4753 //
     /*  10501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10525 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10532 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrm),
     /*  10535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10548 */     GIR_RootConstrainSelectedInstOperands,
     /*  10549 */     // GIR_Coverage, 4753,
     /*  10549 */     GIR_EraseRootFromParent_Done,
     /*  10550 */   // Label 342: @10550
     /*  10550 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(10569), // Rule ID 4750 //
     /*  10555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  10558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10562 */     // (sub:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPSUBDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  10562 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBDZrr),
     /*  10567 */     GIR_RootConstrainSelectedInstOperands,
     /*  10568 */     // GIR_Coverage, 4750,
     /*  10568 */     GIR_Done,
     /*  10569 */   // Label 343: @10569
     /*  10569 */   GIM_Reject,
     /*  10570 */ // Label 341: @10570
     /*  10570 */ GIM_Reject,
     /*  10571 */ // Label 255: @10571
     /*  10571 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(10761),
     /*  10576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  10579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  10582 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(10644), // Rule ID 2593 //
     /*  10587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10626 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrm),
     /*  10629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10642 */     GIR_RootConstrainSelectedInstOperands,
     /*  10643 */     // GIR_Coverage, 2593,
     /*  10643 */     GIR_EraseRootFromParent_Done,
     /*  10644 */   // Label 345: @10644
     /*  10644 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(10706), // Rule ID 4804 //
     /*  10649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10688 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rm),
     /*  10691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10693 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10704 */     GIR_RootConstrainSelectedInstOperands,
     /*  10705 */     // GIR_Coverage, 4804,
     /*  10705 */     GIR_EraseRootFromParent_Done,
     /*  10706 */   // Label 346: @10706
     /*  10706 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(10733), // Rule ID 2592 //
     /*  10711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  10714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  10726 */     // (sub:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  10726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBYrr),
     /*  10731 */     GIR_RootConstrainSelectedInstOperands,
     /*  10732 */     // GIR_Coverage, 2592,
     /*  10732 */     GIR_Done,
     /*  10733 */   // Label 347: @10733
     /*  10733 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(10760), // Rule ID 4801 //
     /*  10738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  10741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  10753 */     // (sub:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  10753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZ256rr),
     /*  10758 */     GIR_RootConstrainSelectedInstOperands,
     /*  10759 */     // GIR_Coverage, 4801,
     /*  10759 */     GIR_Done,
     /*  10760 */   // Label 348: @10760
     /*  10760 */   GIM_Reject,
     /*  10761 */ // Label 344: @10761
     /*  10761 */ GIM_Reject,
     /*  10762 */ // Label 256: @10762
     /*  10762 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(10855),
     /*  10767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  10770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  10773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10781 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(10835), // Rule ID 4780 //
     /*  10786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10797 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10800 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10804 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10817 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrm),
     /*  10820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10822 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10824 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10833 */     GIR_RootConstrainSelectedInstOperands,
     /*  10834 */     // GIR_Coverage, 4780,
     /*  10834 */     GIR_EraseRootFromParent_Done,
     /*  10835 */   // Label 350: @10835
     /*  10835 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(10854), // Rule ID 4777 //
     /*  10840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10847 */     // (sub:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  10847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBWZrr),
     /*  10852 */     GIR_RootConstrainSelectedInstOperands,
     /*  10853 */     // GIR_Coverage, 4777,
     /*  10853 */     GIR_Done,
     /*  10854 */   // Label 351: @10854
     /*  10854 */   GIM_Reject,
     /*  10855 */ // Label 349: @10855
     /*  10855 */ GIM_Reject,
     /*  10856 */ // Label 257: @10856
     /*  10856 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(10949),
     /*  10861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  10864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  10867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10875 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(10929), // Rule ID 4798 //
     /*  10880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  10891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  10894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  10898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  10902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  10911 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  10911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrm),
     /*  10914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  10922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  10927 */     GIR_RootConstrainSelectedInstOperands,
     /*  10928 */     // GIR_Coverage, 4798,
     /*  10928 */     GIR_EraseRootFromParent_Done,
     /*  10929 */   // Label 353: @10929
     /*  10929 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(10948), // Rule ID 4795 //
     /*  10934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  10937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  10941 */     // (sub:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  10941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBBZrr),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 4795,
     /*  10947 */     GIR_Done,
     /*  10948 */   // Label 354: @10948
     /*  10948 */   GIM_Reject,
     /*  10949 */ // Label 352: @10949
     /*  10949 */ GIM_Reject,
     /*  10950 */ // Label 258: @10950
     /*  10950 */ GIM_Reject,
     /*  10951 */ // Label 2: @10951
     /*  10951 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 367*/ GIMT_Encode4(14733),
     /*  10962 */ /*GILLT_s16*//*Label 355*/ GIMT_Encode4(11046),
     /*  10966 */ /*GILLT_s32*//*Label 356*/ GIMT_Encode4(11463),
     /*  10970 */ /*GILLT_s64*//*Label 357*/ GIMT_Encode4(11880), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10986 */ /*GILLT_v2s64*//*Label 358*/ GIMT_Encode4(12305), GIMT_Encode4(0),
     /*  10994 */ /*GILLT_v4s32*//*Label 359*/ GIMT_Encode4(12634),
     /*  10998 */ /*GILLT_v4s64*//*Label 360*/ GIMT_Encode4(12976), GIMT_Encode4(0),
     /*  11006 */ /*GILLT_v8s16*//*Label 361*/ GIMT_Encode4(13293),
     /*  11010 */ /*GILLT_v8s32*//*Label 362*/ GIMT_Encode4(13635),
     /*  11014 */ /*GILLT_v8s64*//*Label 363*/ GIMT_Encode4(13950), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11026 */ /*GILLT_v16s16*//*Label 364*/ GIMT_Encode4(14106),
     /*  11030 */ /*GILLT_v16s32*//*Label 365*/ GIMT_Encode4(14421), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  11042 */ /*GILLT_v32s16*//*Label 366*/ GIMT_Encode4(14577),
     /*  11046 */ // Label 355: @11046
     /*  11046 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(11462),
     /*  11051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  11054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  11057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11061 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(11125), // Rule ID 22979 //
     /*  11066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11081 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11093 */     // MIs[2] Operand 1
     /*  11093 */     // No operand predicates
     /*  11093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11102 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rmi),
     /*  11105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11123 */     GIR_RootConstrainSelectedInstOperands,
     /*  11124 */     // GIR_Coverage, 22979,
     /*  11124 */     GIR_EraseRootFromParent_Done,
     /*  11125 */   // Label 369: @11125
     /*  11125 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(11186), // Rule ID 26058 //
     /*  11130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11141 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11148 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11158 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11165 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11172 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11184 */     GIR_RootConstrainSelectedInstOperands,
     /*  11185 */     // GIR_Coverage, 26058,
     /*  11185 */     GIR_EraseRootFromParent_Done,
     /*  11186 */   // Label 370: @11186
     /*  11186 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(11247), // Rule ID 26077 //
     /*  11191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11205 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11209 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11226 */     // (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11231 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11245 */     GIR_RootConstrainSelectedInstOperands,
     /*  11246 */     // GIR_Coverage, 26077,
     /*  11246 */     GIR_EraseRootFromParent_Done,
     /*  11247 */   // Label 371: @11247
     /*  11247 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(11308), // Rule ID 22823 //
     /*  11252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11274 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11287 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm),
     /*  11290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11292 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11306 */     GIR_RootConstrainSelectedInstOperands,
     /*  11307 */     // GIR_Coverage, 22823,
     /*  11307 */     GIR_EraseRootFromParent_Done,
     /*  11308 */   // Label 372: @11308
     /*  11308 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(11369), // Rule ID 22913 //
     /*  11313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11335 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  11339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11348 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (IMUL16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rm_ND),
     /*  11351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11359 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11367 */     GIR_RootConstrainSelectedInstOperands,
     /*  11368 */     // GIR_Coverage, 22913,
     /*  11368 */     GIR_EraseRootFromParent_Done,
     /*  11369 */   // Label 373: @11369
     /*  11369 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(11403), // Rule ID 22976 //
     /*  11374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11386 */     // MIs[1] Operand 1
     /*  11386 */     // No operand predicates
     /*  11386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11388 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (IMUL16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  11388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL16rri),
     /*  11391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11393 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11401 */     GIR_RootConstrainSelectedInstOperands,
     /*  11402 */     // GIR_Coverage, 22976,
     /*  11402 */     GIR_EraseRootFromParent_Done,
     /*  11403 */   // Label 374: @11403
     /*  11403 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(11432), // Rule ID 22820 //
     /*  11408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11419 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr),
     /*  11424 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11430 */     GIR_RootConstrainSelectedInstOperands,
     /*  11431 */     // GIR_Coverage, 22820,
     /*  11431 */     GIR_Done,
     /*  11432 */   // Label 375: @11432
     /*  11432 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(11461), // Rule ID 22910 //
     /*  11437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  11448 */     // (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (IMUL16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  11448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL16rr_ND),
     /*  11453 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11459 */     GIR_RootConstrainSelectedInstOperands,
     /*  11460 */     // GIR_Coverage, 22910,
     /*  11460 */     GIR_Done,
     /*  11461 */   // Label 376: @11461
     /*  11461 */   GIM_Reject,
     /*  11462 */ // Label 368: @11462
     /*  11462 */ GIM_Reject,
     /*  11463 */ // Label 356: @11463
     /*  11463 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(11879),
     /*  11468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  11471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  11474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11478 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(11542), // Rule ID 22980 //
     /*  11483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11494 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11498 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11510 */     // MIs[2] Operand 1
     /*  11510 */     // No operand predicates
     /*  11510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11519 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rmi:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rmi),
     /*  11522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11524 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11540 */     GIR_RootConstrainSelectedInstOperands,
     /*  11541 */     // GIR_Coverage, 22980,
     /*  11541 */     GIR_EraseRootFromParent_Done,
     /*  11542 */   // Label 378: @11542
     /*  11542 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(11603), // Rule ID 26059 //
     /*  11547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11565 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11582 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11587 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11601 */     GIR_RootConstrainSelectedInstOperands,
     /*  11602 */     // GIR_Coverage, 26059,
     /*  11602 */     GIR_EraseRootFromParent_Done,
     /*  11603 */   // Label 379: @11603
     /*  11603 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(11664), // Rule ID 26078 //
     /*  11608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11626 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11643 */     // (mul:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  11650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11662 */     GIR_RootConstrainSelectedInstOperands,
     /*  11663 */     // GIR_Coverage, 26078,
     /*  11663 */     GIR_EraseRootFromParent_Done,
     /*  11664 */   // Label 380: @11664
     /*  11664 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(11725), // Rule ID 22824 //
     /*  11669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11684 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11687 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11691 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11697 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11704 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm),
     /*  11707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11709 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11723 */     GIR_RootConstrainSelectedInstOperands,
     /*  11724 */     // GIR_Coverage, 22824,
     /*  11724 */     GIR_EraseRootFromParent_Done,
     /*  11725 */   // Label 381: @11725
     /*  11725 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(11786), // Rule ID 22914 //
     /*  11730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11748 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11752 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  11756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11765 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (IMUL32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  11765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rm_ND),
     /*  11768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11770 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  11776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  11784 */     GIR_RootConstrainSelectedInstOperands,
     /*  11785 */     // GIR_Coverage, 22914,
     /*  11785 */     GIR_EraseRootFromParent_Done,
     /*  11786 */   // Label 382: @11786
     /*  11786 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(11820), // Rule ID 22977 //
     /*  11791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11803 */     // MIs[1] Operand 1
     /*  11803 */     // No operand predicates
     /*  11803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11805 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (IMUL32rri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  11805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL32rri),
     /*  11808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11810 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  11815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11818 */     GIR_RootConstrainSelectedInstOperands,
     /*  11819 */     // GIR_Coverage, 22977,
     /*  11819 */     GIR_EraseRootFromParent_Done,
     /*  11820 */   // Label 383: @11820
     /*  11820 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(11849), // Rule ID 22821 //
     /*  11825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11836 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr),
     /*  11841 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 22821,
     /*  11848 */     GIR_Done,
     /*  11849 */   // Label 384: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(11878), // Rule ID 22911 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  11865 */     // (mul:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (IMUL32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  11865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL32rr_ND),
     /*  11870 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  11876 */     GIR_RootConstrainSelectedInstOperands,
     /*  11877 */     // GIR_Coverage, 22911,
     /*  11877 */     GIR_Done,
     /*  11878 */   // Label 385: @11878
     /*  11878 */   GIM_Reject,
     /*  11879 */ // Label 377: @11879
     /*  11879 */ GIM_Reject,
     /*  11880 */ // Label 357: @11880
     /*  11880 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(12304),
     /*  11885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11895 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(11963), // Rule ID 22981 //
     /*  11900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11927 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  11931 */     // MIs[2] Operand 1
     /*  11931 */     // No operand predicates
     /*  11931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  11940 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rmi32:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  11940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rmi32),
     /*  11943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  11949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /*  11952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  11955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  11961 */     GIR_RootConstrainSelectedInstOperands,
     /*  11962 */     // GIR_Coverage, 22981,
     /*  11962 */     GIR_EraseRootFromParent_Done,
     /*  11963 */   // Label 387: @11963
     /*  11963 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(12024), // Rule ID 26060 //
     /*  11968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  11971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  11979 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  11982 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  11986 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  11990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  11994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12003 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  12006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12022 */     GIR_RootConstrainSelectedInstOperands,
     /*  12023 */     // GIR_Coverage, 26060,
     /*  12023 */     GIR_EraseRootFromParent_Done,
     /*  12024 */   // Label 388: @12024
     /*  12024 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(12085), // Rule ID 26079 //
     /*  12029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12064 */     // (mul:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12069 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12083 */     GIR_RootConstrainSelectedInstOperands,
     /*  12084 */     // GIR_Coverage, 26079,
     /*  12084 */     GIR_EraseRootFromParent_Done,
     /*  12085 */   // Label 389: @12085
     /*  12085 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(12146), // Rule ID 22825 //
     /*  12090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12118 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12125 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm),
     /*  12128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12130 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12144 */     GIR_RootConstrainSelectedInstOperands,
     /*  12145 */     // GIR_Coverage, 22825,
     /*  12145 */     GIR_EraseRootFromParent_Done,
     /*  12146 */   // Label 390: @12146
     /*  12146 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(12207), // Rule ID 22915 //
     /*  12151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12166 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12173 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12186 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (IMUL64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rm_ND),
     /*  12189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12205 */     GIR_RootConstrainSelectedInstOperands,
     /*  12206 */     // GIR_Coverage, 22915,
     /*  12206 */     GIR_EraseRootFromParent_Done,
     /*  12207 */   // Label 391: @12207
     /*  12207 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(12245), // Rule ID 22978 //
     /*  12212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  12224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  12228 */     // MIs[1] Operand 1
     /*  12228 */     // No operand predicates
     /*  12228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12230 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (IMUL64rri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  12230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::IMUL64rri32),
     /*  12233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  12240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  12243 */     GIR_RootConstrainSelectedInstOperands,
     /*  12244 */     // GIR_Coverage, 22978,
     /*  12244 */     GIR_EraseRootFromParent_Done,
     /*  12245 */   // Label 392: @12245
     /*  12245 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(12274), // Rule ID 22822 //
     /*  12250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  12253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12261 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr),
     /*  12266 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12272 */     GIR_RootConstrainSelectedInstOperands,
     /*  12273 */     // GIR_Coverage, 22822,
     /*  12273 */     GIR_Done,
     /*  12274 */   // Label 393: @12274
     /*  12274 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(12303), // Rule ID 22912 //
     /*  12279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  12282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  12290 */     // (mul:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (IMUL64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  12290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::IMUL64rr_ND),
     /*  12295 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  12301 */     GIR_RootConstrainSelectedInstOperands,
     /*  12302 */     // GIR_Coverage, 22912,
     /*  12302 */     GIR_Done,
     /*  12303 */   // Label 394: @12303
     /*  12303 */   GIM_Reject,
     /*  12304 */ // Label 386: @12304
     /*  12304 */ GIM_Reject,
     /*  12305 */ // Label 358: @12305
     /*  12305 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(12633),
     /*  12310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  12313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  12316 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(12378), // Rule ID 23825 //
     /*  12321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12360 */     // (mul:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12376 */     GIR_RootConstrainSelectedInstOperands,
     /*  12377 */     // GIR_Coverage, 23825,
     /*  12377 */     GIR_EraseRootFromParent_Done,
     /*  12378 */   // Label 396: @12378
     /*  12378 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(12440), // Rule ID 5023 //
     /*  12383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12422 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rm),
     /*  12425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12438 */     GIR_RootConstrainSelectedInstOperands,
     /*  12439 */     // GIR_Coverage, 5023,
     /*  12439 */     GIR_EraseRootFromParent_Done,
     /*  12440 */   // Label 397: @12440
     /*  12440 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(12467), // Rule ID 5020 //
     /*  12445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12460 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMULLQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  12460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ128rr),
     /*  12465 */     GIR_RootConstrainSelectedInstOperands,
     /*  12466 */     // GIR_Coverage, 5020,
     /*  12466 */     GIR_Done,
     /*  12467 */   // Label 398: @12467
     /*  12467 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(12632), // Rule ID 19998 //
     /*  12472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  12475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  12479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12487 */     // (mul:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /*  12487 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  12490 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12494 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  12501 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  12504 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12508 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12513 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  12516 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  12520 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  12523 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12528 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12533 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  12541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  12555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12564 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  12571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  12574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  12579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  12589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  12592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  12596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  12604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  12607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12614 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  12621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  12626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  12631 */     // GIR_Coverage, 19998,
     /*  12631 */     GIR_EraseRootFromParent_Done,
     /*  12632 */   // Label 399: @12632
     /*  12632 */   GIM_Reject,
     /*  12633 */ // Label 395: @12633
     /*  12633 */ GIM_Reject,
     /*  12634 */ // Label 359: @12634
     /*  12634 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(12975),
     /*  12639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12645 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(12707), // Rule ID 23528 //
     /*  12650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12665 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12689 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12694 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12705 */     GIR_RootConstrainSelectedInstOperands,
     /*  12706 */     // GIR_Coverage, 23528,
     /*  12706 */     GIR_EraseRootFromParent_Done,
     /*  12707 */   // Label 401: @12707
     /*  12707 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(12769), // Rule ID 23798 //
     /*  12712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12727 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12730 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12734 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12751 */     // (mul:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  12758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12767 */     GIR_RootConstrainSelectedInstOperands,
     /*  12768 */     // GIR_Coverage, 23798,
     /*  12768 */     GIR_EraseRootFromParent_Done,
     /*  12769 */   // Label 402: @12769
     /*  12769 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(12831), // Rule ID 3240 //
     /*  12774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12800 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12806 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12813 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDrm),
     /*  12816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12818 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12820 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12829 */     GIR_RootConstrainSelectedInstOperands,
     /*  12830 */     // GIR_Coverage, 3240,
     /*  12830 */     GIR_EraseRootFromParent_Done,
     /*  12831 */   // Label 403: @12831
     /*  12831 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(12893), // Rule ID 4978 //
     /*  12836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  12855 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  12858 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  12862 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  12866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  12875 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  12875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rm),
     /*  12878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12880 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  12886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  12891 */     GIR_RootConstrainSelectedInstOperands,
     /*  12892 */     // GIR_Coverage, 4978,
     /*  12892 */     GIR_EraseRootFromParent_Done,
     /*  12893 */   // Label 404: @12893
     /*  12893 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(12920), // Rule ID 3239 //
     /*  12898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  12901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12913 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDrr),
     /*  12918 */     GIR_RootConstrainSelectedInstOperands,
     /*  12919 */     // GIR_Coverage, 3239,
     /*  12919 */     GIR_Done,
     /*  12920 */   // Label 405: @12920
     /*  12920 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(12947), // Rule ID 3247 //
     /*  12925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  12928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  12940 */     // (mul:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMULLDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  12940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLDrr),
     /*  12945 */     GIR_RootConstrainSelectedInstOperands,
     /*  12946 */     // GIR_Coverage, 3247,
     /*  12946 */     GIR_Done,
     /*  12947 */   // Label 406: @12947
     /*  12947 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(12974), // Rule ID 4975 //
     /*  12952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  12955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  12967 */     // (mul:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMULLDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  12967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ128rr),
     /*  12972 */     GIR_RootConstrainSelectedInstOperands,
     /*  12973 */     // GIR_Coverage, 4975,
     /*  12973 */     GIR_Done,
     /*  12974 */   // Label 407: @12974
     /*  12974 */   GIM_Reject,
     /*  12975 */ // Label 400: @12975
     /*  12975 */ GIM_Reject,
     /*  12976 */ // Label 360: @12976
     /*  12976 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(13292),
     /*  12981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  12984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  12987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  12991 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(13049), // Rule ID 23819 //
     /*  12996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  12999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13007 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13010 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13031 */     // (mul:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13036 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13047 */     GIR_RootConstrainSelectedInstOperands,
     /*  13048 */     // GIR_Coverage, 23819,
     /*  13048 */     GIR_EraseRootFromParent_Done,
     /*  13049 */   // Label 409: @13049
     /*  13049 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(13107), // Rule ID 5014 //
     /*  13054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13069 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13076 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13082 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13089 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rm),
     /*  13092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13094 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13105 */     GIR_RootConstrainSelectedInstOperands,
     /*  13106 */     // GIR_Coverage, 5014,
     /*  13106 */     GIR_EraseRootFromParent_Done,
     /*  13107 */   // Label 410: @13107
     /*  13107 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(13130), // Rule ID 5011 //
     /*  13112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  13115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13123 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMULLQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  13123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZ256rr),
     /*  13128 */     GIR_RootConstrainSelectedInstOperands,
     /*  13129 */     // GIR_Coverage, 5011,
     /*  13129 */     GIR_Done,
     /*  13130 */   // Label 411: @13130
     /*  13130 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(13291), // Rule ID 19996 //
     /*  13135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /*  13138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13146 */     // (mul:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMULLQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /*  13146 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  13149 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13153 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  13160 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  13163 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13167 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13172 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  13175 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  13179 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  13182 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13187 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13192 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13197 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  13200 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13204 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13211 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  13214 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13218 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13223 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  13230 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  13233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  13238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  13251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  13255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  13266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  13280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  13285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  13290 */     // GIR_Coverage, 19996,
     /*  13290 */     GIR_EraseRootFromParent_Done,
     /*  13291 */   // Label 412: @13291
     /*  13291 */   GIM_Reject,
     /*  13292 */ // Label 408: @13292
     /*  13292 */ GIM_Reject,
     /*  13293 */ // Label 361: @13293
     /*  13293 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(13634),
     /*  13298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13304 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(13366), // Rule ID 23453 //
     /*  13309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13348 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13364 */     GIR_RootConstrainSelectedInstOperands,
     /*  13365 */     // GIR_Coverage, 23453,
     /*  13365 */     GIR_EraseRootFromParent_Done,
     /*  13366 */   // Label 414: @13366
     /*  13366 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(13428), // Rule ID 23810 //
     /*  13371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13410 */     // (mul:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13426 */     GIR_RootConstrainSelectedInstOperands,
     /*  13427 */     // GIR_Coverage, 23810,
     /*  13427 */     GIR_EraseRootFromParent_Done,
     /*  13428 */   // Label 415: @13428
     /*  13428 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(13490), // Rule ID 2571 //
     /*  13433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13472 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWrm),
     /*  13475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13488 */     GIR_RootConstrainSelectedInstOperands,
     /*  13489 */     // GIR_Coverage, 2571,
     /*  13489 */     GIR_EraseRootFromParent_Done,
     /*  13490 */   // Label 416: @13490
     /*  13490 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(13552), // Rule ID 4999 //
     /*  13495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13534 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rm),
     /*  13537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13550 */     GIR_RootConstrainSelectedInstOperands,
     /*  13551 */     // GIR_Coverage, 4999,
     /*  13551 */     GIR_EraseRootFromParent_Done,
     /*  13552 */   // Label 417: @13552
     /*  13552 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(13579), // Rule ID 2570 //
     /*  13557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /*  13560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13572 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWrr),
     /*  13577 */     GIR_RootConstrainSelectedInstOperands,
     /*  13578 */     // GIR_Coverage, 2570,
     /*  13578 */     GIR_Done,
     /*  13579 */   // Label 418: @13579
     /*  13579 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(13606), // Rule ID 2572 //
     /*  13584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  13587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  13599 */     // (mul:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULLWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  13599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULLWrr),
     /*  13604 */     GIR_RootConstrainSelectedInstOperands,
     /*  13605 */     // GIR_Coverage, 2572,
     /*  13605 */     GIR_Done,
     /*  13606 */   // Label 419: @13606
     /*  13606 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(13633), // Rule ID 4996 //
     /*  13611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  13614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  13626 */     // (mul:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULLWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  13626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ128rr),
     /*  13631 */     GIR_RootConstrainSelectedInstOperands,
     /*  13632 */     // GIR_Coverage, 4996,
     /*  13632 */     GIR_Done,
     /*  13633 */   // Label 420: @13633
     /*  13633 */   GIM_Reject,
     /*  13634 */ // Label 413: @13634
     /*  13634 */ GIM_Reject,
     /*  13635 */ // Label 362: @13635
     /*  13635 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(13949),
     /*  13640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  13643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  13646 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(13708), // Rule ID 23530 //
     /*  13651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13690 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13706 */     GIR_RootConstrainSelectedInstOperands,
     /*  13707 */     // GIR_Coverage, 23530,
     /*  13707 */     GIR_EraseRootFromParent_Done,
     /*  13708 */   // Label 422: @13708
     /*  13708 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(13770), // Rule ID 23792 //
     /*  13713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13752 */     // (mul:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  13759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13768 */     GIR_RootConstrainSelectedInstOperands,
     /*  13769 */     // GIR_Coverage, 23792,
     /*  13769 */     GIR_EraseRootFromParent_Done,
     /*  13770 */   // Label 423: @13770
     /*  13770 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(13832), // Rule ID 3244 //
     /*  13775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13814 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrm),
     /*  13817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13830 */     GIR_RootConstrainSelectedInstOperands,
     /*  13831 */     // GIR_Coverage, 3244,
     /*  13831 */     GIR_EraseRootFromParent_Done,
     /*  13832 */   // Label 424: @13832
     /*  13832 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(13894), // Rule ID 4969 //
     /*  13837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  13876 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  13876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rm),
     /*  13879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  13887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  13892 */     GIR_RootConstrainSelectedInstOperands,
     /*  13893 */     // GIR_Coverage, 4969,
     /*  13893 */     GIR_EraseRootFromParent_Done,
     /*  13894 */   // Label 425: @13894
     /*  13894 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(13921), // Rule ID 3243 //
     /*  13899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  13902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  13914 */     // (mul:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMULLDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  13914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDYrr),
     /*  13919 */     GIR_RootConstrainSelectedInstOperands,
     /*  13920 */     // GIR_Coverage, 3243,
     /*  13920 */     GIR_Done,
     /*  13921 */   // Label 426: @13921
     /*  13921 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(13948), // Rule ID 4966 //
     /*  13926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  13929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  13941 */     // (mul:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMULLDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  13941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZ256rr),
     /*  13946 */     GIR_RootConstrainSelectedInstOperands,
     /*  13947 */     // GIR_Coverage, 4966,
     /*  13947 */     GIR_Done,
     /*  13948 */   // Label 427: @13948
     /*  13948 */   GIM_Reject,
     /*  13949 */ // Label 421: @13949
     /*  13949 */ GIM_Reject,
     /*  13950 */ // Label 363: @13950
     /*  13950 */ GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(14105),
     /*  13955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  13958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  13961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13965 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(14023), // Rule ID 23813 //
     /*  13970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  13973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  13981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  13984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  13988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  13992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  13996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14005 */     // (mul:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  14008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14021 */     GIR_RootConstrainSelectedInstOperands,
     /*  14022 */     // GIR_Coverage, 23813,
     /*  14022 */     GIR_EraseRootFromParent_Done,
     /*  14023 */   // Label 429: @14023
     /*  14023 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(14081), // Rule ID 5005 //
     /*  14028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14063 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrm),
     /*  14066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14068 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14079 */     GIR_RootConstrainSelectedInstOperands,
     /*  14080 */     // GIR_Coverage, 5005,
     /*  14080 */     GIR_EraseRootFromParent_Done,
     /*  14081 */   // Label 430: @14081
     /*  14081 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(14104), // Rule ID 5002 //
     /*  14086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  14089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14097 */     // (mul:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMULLQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  14097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLQZrr),
     /*  14102 */     GIR_RootConstrainSelectedInstOperands,
     /*  14103 */     // GIR_Coverage, 5002,
     /*  14103 */     GIR_Done,
     /*  14104 */   // Label 431: @14104
     /*  14104 */   GIM_Reject,
     /*  14105 */ // Label 428: @14105
     /*  14105 */ GIM_Reject,
     /*  14106 */ // Label 364: @14106
     /*  14106 */ GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(14420),
     /*  14111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  14114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  14117 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(14179), // Rule ID 23455 //
     /*  14122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14161 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14177 */     GIR_RootConstrainSelectedInstOperands,
     /*  14178 */     // GIR_Coverage, 23455,
     /*  14178 */     GIR_EraseRootFromParent_Done,
     /*  14179 */   // Label 433: @14179
     /*  14179 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(14241), // Rule ID 23807 //
     /*  14184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14199 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14206 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14223 */     // (mul:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14228 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14239 */     GIR_RootConstrainSelectedInstOperands,
     /*  14240 */     // GIR_Coverage, 23807,
     /*  14240 */     GIR_EraseRootFromParent_Done,
     /*  14241 */   // Label 434: @14241
     /*  14241 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(14303), // Rule ID 2575 //
     /*  14246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14285 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrm),
     /*  14288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14301 */     GIR_RootConstrainSelectedInstOperands,
     /*  14302 */     // GIR_Coverage, 2575,
     /*  14302 */     GIR_EraseRootFromParent_Done,
     /*  14303 */   // Label 435: @14303
     /*  14303 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(14365), // Rule ID 4993 //
     /*  14308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14327 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14330 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14334 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14347 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rm),
     /*  14350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14363 */     GIR_RootConstrainSelectedInstOperands,
     /*  14364 */     // GIR_Coverage, 4993,
     /*  14364 */     GIR_EraseRootFromParent_Done,
     /*  14365 */   // Label 436: @14365
     /*  14365 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(14392), // Rule ID 2574 //
     /*  14370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /*  14373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  14385 */     // (mul:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULLWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  14385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWYrr),
     /*  14390 */     GIR_RootConstrainSelectedInstOperands,
     /*  14391 */     // GIR_Coverage, 2574,
     /*  14391 */     GIR_Done,
     /*  14392 */   // Label 437: @14392
     /*  14392 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(14419), // Rule ID 4990 //
     /*  14397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /*  14400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  14412 */     // (mul:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULLWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  14412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZ256rr),
     /*  14417 */     GIR_RootConstrainSelectedInstOperands,
     /*  14418 */     // GIR_Coverage, 4990,
     /*  14418 */     GIR_Done,
     /*  14419 */   // Label 438: @14419
     /*  14419 */   GIM_Reject,
     /*  14420 */ // Label 432: @14420
     /*  14420 */ GIM_Reject,
     /*  14421 */ // Label 365: @14421
     /*  14421 */ GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(14576),
     /*  14426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  14429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  14432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14436 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(14494), // Rule ID 23786 //
     /*  14441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14476 */     // (mul:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14481 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14492 */     GIR_RootConstrainSelectedInstOperands,
     /*  14493 */     // GIR_Coverage, 23786,
     /*  14493 */     GIR_EraseRootFromParent_Done,
     /*  14494 */   // Label 440: @14494
     /*  14494 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(14552), // Rule ID 4960 //
     /*  14499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14534 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrm),
     /*  14537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14550 */     GIR_RootConstrainSelectedInstOperands,
     /*  14551 */     // GIR_Coverage, 4960,
     /*  14551 */     GIR_EraseRootFromParent_Done,
     /*  14552 */   // Label 441: @14552
     /*  14552 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(14575), // Rule ID 4957 //
     /*  14557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  14560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14568 */     // (mul:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMULLDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  14568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLDZrr),
     /*  14573 */     GIR_RootConstrainSelectedInstOperands,
     /*  14574 */     // GIR_Coverage, 4957,
     /*  14574 */     GIR_Done,
     /*  14575 */   // Label 442: @14575
     /*  14575 */   GIM_Reject,
     /*  14576 */ // Label 439: @14576
     /*  14576 */ GIM_Reject,
     /*  14577 */ // Label 366: @14577
     /*  14577 */ GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(14732),
     /*  14582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  14585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  14588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14592 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(14650), // Rule ID 23804 //
     /*  14597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14632 */     // (mul:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14637 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  14639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14648 */     GIR_RootConstrainSelectedInstOperands,
     /*  14649 */     // GIR_Coverage, 23804,
     /*  14649 */     GIR_EraseRootFromParent_Done,
     /*  14650 */   // Label 444: @14650
     /*  14650 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(14708), // Rule ID 4987 //
     /*  14655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  14670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  14673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  14677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  14681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  14690 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULLWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  14690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrm),
     /*  14693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  14697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  14701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  14706 */     GIR_RootConstrainSelectedInstOperands,
     /*  14707 */     // GIR_Coverage, 4987,
     /*  14707 */     GIR_EraseRootFromParent_Done,
     /*  14708 */   // Label 445: @14708
     /*  14708 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(14731), // Rule ID 4984 //
     /*  14713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  14716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  14724 */     // (mul:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULLWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  14724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULLWZrr),
     /*  14729 */     GIR_RootConstrainSelectedInstOperands,
     /*  14730 */     // GIR_Coverage, 4984,
     /*  14730 */     GIR_Done,
     /*  14731 */   // Label 446: @14731
     /*  14731 */   GIM_Reject,
     /*  14732 */ // Label 443: @14732
     /*  14732 */ GIM_Reject,
     /*  14733 */ // Label 367: @14733
     /*  14733 */ GIM_Reject,
     /*  14734 */ // Label 3: @14734
     /*  14734 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 470*/ GIMT_Encode4(25325),
     /*  14745 */ /*GILLT_s1*//*Label 447*/ GIMT_Encode4(14845),
     /*  14749 */ /*GILLT_s8*//*Label 448*/ GIMT_Encode4(15191),
     /*  14753 */ /*GILLT_s16*//*Label 449*/ GIMT_Encode4(15584),
     /*  14757 */ /*GILLT_s32*//*Label 450*/ GIMT_Encode4(16269),
     /*  14761 */ /*GILLT_s64*//*Label 451*/ GIMT_Encode4(18095), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  14773 */ /*GILLT_v2s1*//*Label 452*/ GIMT_Encode4(19799),
     /*  14777 */ /*GILLT_v2s64*//*Label 453*/ GIMT_Encode4(20145),
     /*  14781 */ /*GILLT_v4s1*//*Label 454*/ GIMT_Encode4(20487),
     /*  14785 */ /*GILLT_v4s32*//*Label 455*/ GIMT_Encode4(20833),
     /*  14789 */ /*GILLT_v4s64*//*Label 456*/ GIMT_Encode4(21175),
     /*  14793 */ /*GILLT_v8s1*//*Label 457*/ GIMT_Encode4(21641),
     /*  14797 */ /*GILLT_v8s16*//*Label 458*/ GIMT_Encode4(22139),
     /*  14801 */ /*GILLT_v8s32*//*Label 459*/ GIMT_Encode4(22481),
     /*  14805 */ /*GILLT_v8s64*//*Label 460*/ GIMT_Encode4(22947),
     /*  14809 */ /*GILLT_v16s1*//*Label 461*/ GIMT_Encode4(23103),
     /*  14813 */ /*GILLT_v16s8*//*Label 462*/ GIMT_Encode4(23263),
     /*  14817 */ /*GILLT_v16s16*//*Label 463*/ GIMT_Encode4(23605),
     /*  14821 */ /*GILLT_v16s32*//*Label 464*/ GIMT_Encode4(24071),
     /*  14825 */ /*GILLT_v32s1*//*Label 465*/ GIMT_Encode4(24227),
     /*  14829 */ /*GILLT_v32s8*//*Label 466*/ GIMT_Encode4(24387),
     /*  14833 */ /*GILLT_v32s16*//*Label 467*/ GIMT_Encode4(24853),
     /*  14837 */ /*GILLT_v64s1*//*Label 468*/ GIMT_Encode4(25009),
     /*  14841 */ /*GILLT_v64s8*//*Label 469*/ GIMT_Encode4(25169),
     /*  14845 */ // Label 447: @14845
     /*  14845 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(15190),
     /*  14850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  14853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  14856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14860 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(14980), // Rule ID 19488 //
     /*  14865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  14877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  14881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14890 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  14898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14904 */     // (and:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  14904 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  14907 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14911 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14916 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  14920 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  14928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14937 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  14946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  14949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  14953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  14964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  14979 */     // GIR_Coverage, 19488,
     /*  14979 */     GIR_EraseRootFromParent_Done,
     /*  14980 */   // Label 472: @14980
     /*  14980 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(15100), // Rule ID 25367 //
     /*  14985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  14989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  15001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  15005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  15022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15024 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15024 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15027 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15031 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15036 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  15040 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15045 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15048 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15052 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15057 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  15073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15099 */     // GIR_Coverage, 25367,
     /*  15099 */     GIR_EraseRootFromParent_Done,
     /*  15100 */   // Label 473: @15100
     /*  15100 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(15189), // Rule ID 19484 //
     /*  15105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  15113 */     // (and:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  15113 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  15116 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15120 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15125 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  15129 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  15137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  15150 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  15155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  15158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  15162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  15173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  15175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  15178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  15188 */     // GIR_Coverage, 19484,
     /*  15188 */     GIR_EraseRootFromParent_Done,
     /*  15189 */   // Label 474: @15189
     /*  15189 */   GIM_Reject,
     /*  15190 */ // Label 471: @15190
     /*  15190 */ GIM_Reject,
     /*  15191 */ // Label 448: @15191
     /*  15191 */ GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(15583),
     /*  15196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  15199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  15202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15206 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(15267), // Rule ID 26069 //
     /*  15211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15225 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15229 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15246 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15265 */     GIR_RootConstrainSelectedInstOperands,
     /*  15266 */     // GIR_Coverage, 26069,
     /*  15266 */     GIR_EraseRootFromParent_Done,
     /*  15267 */   // Label 476: @15267
     /*  15267 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(15328), // Rule ID 26088 //
     /*  15272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15283 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15290 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15307 */     // (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15312 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15314 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15326 */     GIR_RootConstrainSelectedInstOperands,
     /*  15327 */     // GIR_Coverage, 26088,
     /*  15327 */     GIR_EraseRootFromParent_Done,
     /*  15328 */   // Label 477: @15328
     /*  15328 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(15389), // Rule ID 22854 //
     /*  15333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15348 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15351 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15355 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15361 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15368 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm),
     /*  15371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15373 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15387 */     GIR_RootConstrainSelectedInstOperands,
     /*  15388 */     // GIR_Coverage, 22854,
     /*  15388 */     GIR_EraseRootFromParent_Done,
     /*  15389 */   // Label 478: @15389
     /*  15389 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(15450), // Rule ID 22944 //
     /*  15394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15409 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15416 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  15420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15422 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15429 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (AND8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8rm_ND),
     /*  15432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15434 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15448 */     GIR_RootConstrainSelectedInstOperands,
     /*  15449 */     // GIR_Coverage, 22944,
     /*  15449 */     GIR_EraseRootFromParent_Done,
     /*  15450 */   // Label 479: @15450
     /*  15450 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(15487), // Rule ID 22858 //
     /*  15455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15470 */     // MIs[1] Operand 1
     /*  15470 */     // No operand predicates
     /*  15470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15472 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri),
     /*  15475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15485 */     GIR_RootConstrainSelectedInstOperands,
     /*  15486 */     // GIR_Coverage, 22858,
     /*  15486 */     GIR_EraseRootFromParent_Done,
     /*  15487 */   // Label 480: @15487
     /*  15487 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(15524), // Rule ID 22948 //
     /*  15492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15507 */     // MIs[1] Operand 1
     /*  15507 */     // No operand predicates
     /*  15507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15509 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (AND8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  15509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8ri_ND),
     /*  15512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  15519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15522 */     GIR_RootConstrainSelectedInstOperands,
     /*  15523 */     // GIR_Coverage, 22948,
     /*  15523 */     GIR_EraseRootFromParent_Done,
     /*  15524 */   // Label 481: @15524
     /*  15524 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(15553), // Rule ID 22850 //
     /*  15529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15540 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr),
     /*  15545 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15551 */     GIR_RootConstrainSelectedInstOperands,
     /*  15552 */     // GIR_Coverage, 22850,
     /*  15552 */     GIR_Done,
     /*  15553 */   // Label 482: @15553
     /*  15553 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(15582), // Rule ID 22940 //
     /*  15558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15569 */     // (and:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (AND8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  15569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND8rr_ND),
     /*  15574 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  15580 */     GIR_RootConstrainSelectedInstOperands,
     /*  15581 */     // GIR_Coverage, 22940,
     /*  15581 */     GIR_Done,
     /*  15582 */   // Label 483: @15582
     /*  15582 */   GIM_Reject,
     /*  15583 */ // Label 475: @15583
     /*  15583 */ GIM_Reject,
     /*  15584 */ // Label 449: @15584
     /*  15584 */ GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(16268),
     /*  15589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  15592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  15595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15599 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(15660), // Rule ID 26070 //
     /*  15604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15618 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15622 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15639 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15658 */     GIR_RootConstrainSelectedInstOperands,
     /*  15659 */     // GIR_Coverage, 26070,
     /*  15659 */     GIR_EraseRootFromParent_Done,
     /*  15660 */   // Label 485: @15660
     /*  15660 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(15721), // Rule ID 26089 //
     /*  15665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15683 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15700 */     // (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15707 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15719 */     GIR_RootConstrainSelectedInstOperands,
     /*  15720 */     // GIR_Coverage, 26089,
     /*  15720 */     GIR_EraseRootFromParent_Done,
     /*  15721 */   // Label 486: @15721
     /*  15721 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(15782), // Rule ID 22855 //
     /*  15726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  15729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15741 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15744 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15748 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15754 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15761 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm),
     /*  15764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15768 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15780 */     GIR_RootConstrainSelectedInstOperands,
     /*  15781 */     // GIR_Coverage, 22855,
     /*  15781 */     GIR_EraseRootFromParent_Done,
     /*  15782 */   // Label 487: @15782
     /*  15782 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(15843), // Rule ID 22945 //
     /*  15787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  15790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  15802 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  15805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  15809 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  15813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15815 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  15822 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (AND16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  15822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16rm_ND),
     /*  15825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15827 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  15829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  15833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  15841 */     GIR_RootConstrainSelectedInstOperands,
     /*  15842 */     // GIR_Coverage, 22945,
     /*  15842 */     GIR_EraseRootFromParent_Done,
     /*  15843 */   // Label 488: @15843
     /*  15843 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(15945), // Rule ID 26036 //
     /*  15848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15864 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15879 */     // (and:{ *:[i16] } (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  15900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15905 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  15908 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  15912 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  15915 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  15920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  15925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  15930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  15933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  15937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  15943 */     GIR_RootConstrainSelectedInstOperands,
     /*  15944 */     // GIR_Coverage, 26036,
     /*  15944 */     GIR_EraseRootFromParent_Done,
     /*  15945 */   // Label 489: @15945
     /*  15945 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(16047), // Rule ID 22774 //
     /*  15950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  15954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  15962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  15966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  15970 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  15974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  15979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15981 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (rotl:{ *:[i16] } -2:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  15981 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  15984 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15988 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  15995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  15998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  16002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  16010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  16014 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  16017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  16032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR16rr),
     /*  16035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  16042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16045 */     GIR_RootConstrainSelectedInstOperands,
     /*  16046 */     // GIR_Coverage, 22774,
     /*  16046 */     GIR_EraseRootFromParent_Done,
     /*  16047 */   // Label 490: @16047
     /*  16047 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(16135), // Rule ID 22634 //
     /*  16052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16056 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  16067 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, 255:{ *:[i16] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src1, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  16067 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /*  16070 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16074 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16079 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  16085 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  16090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  16095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  16098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  16102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  16107 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  16110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  16112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  16115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16117 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  16124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  16129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  16134 */     // GIR_Coverage, 22634,
     /*  16134 */     GIR_EraseRootFromParent_Done,
     /*  16135 */   // Label 491: @16135
     /*  16135 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(16172), // Rule ID 22859 //
     /*  16140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16155 */     // MIs[1] Operand 1
     /*  16155 */     // No operand predicates
     /*  16155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16157 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri),
     /*  16160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16170 */     GIR_RootConstrainSelectedInstOperands,
     /*  16171 */     // GIR_Coverage, 22859,
     /*  16171 */     GIR_EraseRootFromParent_Done,
     /*  16172 */   // Label 492: @16172
     /*  16172 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(16209), // Rule ID 22949 //
     /*  16177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16192 */     // MIs[1] Operand 1
     /*  16192 */     // No operand predicates
     /*  16192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16194 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (AND16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  16194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16ri_ND),
     /*  16197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  16204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16207 */     GIR_RootConstrainSelectedInstOperands,
     /*  16208 */     // GIR_Coverage, 22949,
     /*  16208 */     GIR_EraseRootFromParent_Done,
     /*  16209 */   // Label 493: @16209
     /*  16209 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(16238), // Rule ID 22851 //
     /*  16214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16225 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr),
     /*  16230 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16236 */     GIR_RootConstrainSelectedInstOperands,
     /*  16237 */     // GIR_Coverage, 22851,
     /*  16237 */     GIR_Done,
     /*  16238 */   // Label 494: @16238
     /*  16238 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(16267), // Rule ID 22941 //
     /*  16243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  16254 */     // (and:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (AND16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  16254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND16rr_ND),
     /*  16259 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  16265 */     GIR_RootConstrainSelectedInstOperands,
     /*  16266 */     // GIR_Coverage, 22941,
     /*  16266 */     GIR_Done,
     /*  16267 */   // Label 495: @16267
     /*  16267 */   GIM_Reject,
     /*  16268 */ // Label 484: @16268
     /*  16268 */ GIM_Reject,
     /*  16269 */ // Label 450: @16269
     /*  16269 */ GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(18094),
     /*  16274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  16277 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(16369), // Rule ID 17546 //
     /*  16282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16325 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16328 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16332 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16338 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16345 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16367 */     GIR_RootConstrainSelectedInstOperands,
     /*  16368 */     // GIR_Coverage, 17546,
     /*  16368 */     GIR_EraseRootFromParent_Done,
     /*  16369 */   // Label 497: @16369
     /*  16369 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(16461), // Rule ID 17550 //
     /*  16374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16417 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  16424 */     GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16437 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  16446 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16459 */     GIR_RootConstrainSelectedInstOperands,
     /*  16460 */     // GIR_Coverage, 17550,
     /*  16460 */     GIR_EraseRootFromParent_Done,
     /*  16461 */   // Label 498: @16461
     /*  16461 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(16553), // Rule ID 25103 //
     /*  16466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  16469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16491 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16516 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16522 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16529 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm),
     /*  16532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16551 */     GIR_RootConstrainSelectedInstOperands,
     /*  16552 */     // GIR_Coverage, 25103,
     /*  16552 */     GIR_EraseRootFromParent_Done,
     /*  16553 */   // Label 499: @16553
     /*  16553 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(16645), // Rule ID 25107 //
     /*  16558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  16561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16583 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  16599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16621 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rm_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rm_EVEX),
     /*  16624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  16630 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16634 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  16643 */     GIR_RootConstrainSelectedInstOperands,
     /*  16644 */     // GIR_Coverage, 25107,
     /*  16644 */     GIR_EraseRootFromParent_Done,
     /*  16645 */   // Label 500: @16645
     /*  16645 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(16713), // Rule ID 26071 //
     /*  16650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16675 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16692 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16711 */     GIR_RootConstrainSelectedInstOperands,
     /*  16712 */     // GIR_Coverage, 26071,
     /*  16712 */     GIR_EraseRootFromParent_Done,
     /*  16713 */   // Label 501: @16713
     /*  16713 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(16781), // Rule ID 26090 //
     /*  16718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16743 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16760 */     // (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  16767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16779 */     GIR_RootConstrainSelectedInstOperands,
     /*  16780 */     // GIR_Coverage, 26090,
     /*  16780 */     GIR_EraseRootFromParent_Done,
     /*  16781 */   // Label 502: @16781
     /*  16781 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(16849), // Rule ID 22856 //
     /*  16786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  16789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16815 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16828 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm),
     /*  16831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16847 */     GIR_RootConstrainSelectedInstOperands,
     /*  16848 */     // GIR_Coverage, 22856,
     /*  16848 */     GIR_EraseRootFromParent_Done,
     /*  16849 */   // Label 503: @16849
     /*  16849 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(16917), // Rule ID 22946 //
     /*  16854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  16857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  16876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  16879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  16883 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  16887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  16896 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (AND32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  16896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32rm_ND),
     /*  16899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  16903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  16907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  16915 */     GIR_RootConstrainSelectedInstOperands,
     /*  16916 */     // GIR_Coverage, 22946,
     /*  16916 */     GIR_EraseRootFromParent_Done,
     /*  16917 */   // Label 504: @16917
     /*  16917 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(16994), // Rule ID 24995 //
     /*  16922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  16925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  16928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  16940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  16953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  16957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  16961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  16969 */     // MIs[2] src
     /*  16969 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16974 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  16978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16980 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  16980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  16983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  16989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  16992 */     GIR_RootConstrainSelectedInstOperands,
     /*  16993 */     // GIR_Coverage, 24995,
     /*  16993 */     GIR_EraseRootFromParent_Done,
     /*  16994 */   // Label 505: @16994
     /*  16994 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(17071), // Rule ID 25007 //
     /*  16999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17030 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17046 */     // MIs[2] src
     /*  17046 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17051 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17057 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17069 */     GIR_RootConstrainSelectedInstOperands,
     /*  17070 */     // GIR_Coverage, 25007,
     /*  17070 */     GIR_EraseRootFromParent_Done,
     /*  17071 */   // Label 506: @17071
     /*  17071 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(17148), // Rule ID 17356 //
     /*  17076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17107 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17123 */     // MIs[2] src
     /*  17123 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17128 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  17132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17134 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC32rr),
     /*  17137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17146 */     GIR_RootConstrainSelectedInstOperands,
     /*  17147 */     // GIR_Coverage, 17356,
     /*  17147 */     GIR_EraseRootFromParent_Done,
     /*  17148 */   // Label 507: @17148
     /*  17148 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(17225), // Rule ID 17368 //
     /*  17153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  17200 */     // MIs[2] src
     /*  17200 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17205 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  17209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17211 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (TZMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK32rr),
     /*  17214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17223 */     GIR_RootConstrainSelectedInstOperands,
     /*  17224 */     // GIR_Coverage, 17368,
     /*  17224 */     GIR_EraseRootFromParent_Done,
     /*  17225 */   // Label 508: @17225
     /*  17225 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(17283), // Rule ID 24989 //
     /*  17230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17258 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17262 */     // MIs[0] src
     /*  17262 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17269 */     // (and:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  17278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17281 */     GIR_RootConstrainSelectedInstOperands,
     /*  17282 */     // GIR_Coverage, 24989,
     /*  17282 */     GIR_EraseRootFromParent_Done,
     /*  17283 */   // Label 509: @17283
     /*  17283 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(17392), // Rule ID 26042 //
     /*  17288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17326 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17355 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17359 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17382 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  17384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17390 */     GIR_RootConstrainSelectedInstOperands,
     /*  17391 */     // GIR_Coverage, 26042,
     /*  17391 */     GIR_EraseRootFromParent_Done,
     /*  17392 */   // Label 510: @17392
     /*  17392 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(17446), // Rule ID 17350 //
     /*  17397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  17400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  17419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17423 */     // MIs[1] src
     /*  17423 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  17428 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  17432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17434 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  17434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL32rr),
     /*  17437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17444 */     GIR_RootConstrainSelectedInstOperands,
     /*  17445 */     // GIR_Coverage, 17350,
     /*  17445 */     GIR_EraseRootFromParent_Done,
     /*  17446 */   // Label 511: @17446
     /*  17446 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(17555), // Rule ID 22780 //
     /*  17451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  17470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  17478 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  17482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  17487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17489 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  17489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  17503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  17510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  17522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  17525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  17535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  17540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR32rr),
     /*  17543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17553 */     GIR_RootConstrainSelectedInstOperands,
     /*  17554 */     // GIR_Coverage, 22780,
     /*  17554 */     GIR_EraseRootFromParent_Done,
     /*  17555 */   // Label 512: @17555
     /*  17555 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(17620), // Rule ID 22632 //
     /*  17560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17571 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17582 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 65535:{ *:[i32] })  =>  (MOVZX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src1, sub_16bit:{ *:[i32] }))
     /*  17582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  17585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src1
     /*  17600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  17605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /*  17613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17618 */     GIR_RootConstrainSelectedInstOperands,
     /*  17619 */     // GIR_Coverage, 22632,
     /*  17619 */     GIR_EraseRootFromParent_Done,
     /*  17620 */   // Label 513: @17620
     /*  17620 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(17685), // Rule ID 22633 //
     /*  17625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17636 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17647 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, 255:{ *:[i32] })  =>  (MOVZX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src1, sub_8bit:{ *:[i32] }))
     /*  17647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /*  17650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17659 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src1
     /*  17665 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  17670 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  17675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /*  17678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17683 */     GIR_RootConstrainSelectedInstOperands,
     /*  17684 */     // GIR_Coverage, 22633,
     /*  17684 */     GIR_EraseRootFromParent_Done,
     /*  17685 */   // Label 514: @17685
     /*  17685 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(17729), // Rule ID 22860 //
     /*  17690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  17693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17712 */     // MIs[1] Operand 1
     /*  17712 */     // No operand predicates
     /*  17712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17714 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri),
     /*  17717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17727 */     GIR_RootConstrainSelectedInstOperands,
     /*  17728 */     // GIR_Coverage, 22860,
     /*  17728 */     GIR_EraseRootFromParent_Done,
     /*  17729 */   // Label 515: @17729
     /*  17729 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(17773), // Rule ID 22950 //
     /*  17734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  17737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17756 */     // MIs[1] Operand 1
     /*  17756 */     // No operand predicates
     /*  17756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17758 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (AND32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  17758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32ri_ND),
     /*  17761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  17765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  17768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17771 */     GIR_RootConstrainSelectedInstOperands,
     /*  17772 */     // GIR_Coverage, 22950,
     /*  17772 */     GIR_EraseRootFromParent_Done,
     /*  17773 */   // Label 516: @17773
     /*  17773 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(17835), // Rule ID 17544 //
     /*  17778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17809 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17819 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17828 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17833 */     GIR_RootConstrainSelectedInstOperands,
     /*  17834 */     // GIR_Coverage, 17544,
     /*  17834 */     GIR_EraseRootFromParent_Done,
     /*  17835 */   // Label 517: @17835
     /*  17835 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(17897), // Rule ID 17548 //
     /*  17840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17881 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src2)  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  17884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  17892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17895 */     GIR_RootConstrainSelectedInstOperands,
     /*  17896 */     // GIR_Coverage, 17548,
     /*  17896 */     GIR_EraseRootFromParent_Done,
     /*  17897 */   // Label 518: @17897
     /*  17897 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(17959), // Rule ID 25101 //
     /*  17902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  17905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17937 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17943 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  17943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr),
     /*  17946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  17952 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  17954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  17957 */     GIR_RootConstrainSelectedInstOperands,
     /*  17958 */     // GIR_Coverage, 25101,
     /*  17958 */     GIR_EraseRootFromParent_Done,
     /*  17959 */   // Label 519: @17959
     /*  17959 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(18021), // Rule ID 25105 //
     /*  17964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  17967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  17970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  17999 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18005 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] }))  =>  (ANDN32rr_EVEX:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN32rr_EVEX),
     /*  18008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18014 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  18016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18019 */     GIR_RootConstrainSelectedInstOperands,
     /*  18020 */     // GIR_Coverage, 25105,
     /*  18020 */     GIR_EraseRootFromParent_Done,
     /*  18021 */   // Label 520: @18021
     /*  18021 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(18057), // Rule ID 22852 //
     /*  18026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18044 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr),
     /*  18049 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18055 */     GIR_RootConstrainSelectedInstOperands,
     /*  18056 */     // GIR_Coverage, 22852,
     /*  18056 */     GIR_Done,
     /*  18057 */   // Label 521: @18057
     /*  18057 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(18093), // Rule ID 22942 //
     /*  18062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  18080 */     // (and:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (AND32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  18080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND32rr_ND),
     /*  18085 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  18091 */     GIR_RootConstrainSelectedInstOperands,
     /*  18092 */     // GIR_Coverage, 22942,
     /*  18092 */     GIR_Done,
     /*  18093 */   // Label 522: @18093
     /*  18093 */   GIM_Reject,
     /*  18094 */ // Label 496: @18094
     /*  18094 */ GIM_Reject,
     /*  18095 */ // Label 451: @18095
     /*  18095 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(19798),
     /*  18100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  18103 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(18195), // Rule ID 17547 //
     /*  18108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18139 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18151 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18158 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18164 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18171 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18193 */     GIR_RootConstrainSelectedInstOperands,
     /*  18194 */     // GIR_Coverage, 17547,
     /*  18194 */     GIR_EraseRootFromParent_Done,
     /*  18195 */   // Label 524: @18195
     /*  18195 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(18287), // Rule ID 17551 //
     /*  18200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18231 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  18250 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  18254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18256 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18263 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  18272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18285 */     GIR_RootConstrainSelectedInstOperands,
     /*  18286 */     // GIR_Coverage, 17551,
     /*  18286 */     GIR_EraseRootFromParent_Done,
     /*  18287 */   // Label 525: @18287
     /*  18287 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(18379), // Rule ID 25104 //
     /*  18292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  18295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18333 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18355 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm),
     /*  18358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18377 */     GIR_RootConstrainSelectedInstOperands,
     /*  18378 */     // GIR_Coverage, 25104,
     /*  18378 */     GIR_EraseRootFromParent_Done,
     /*  18379 */   // Label 526: @18379
     /*  18379 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(18471), // Rule ID 25108 //
     /*  18384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  18387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  18425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18434 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18447 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rm_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rm_EVEX),
     /*  18450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  18456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  18469 */     GIR_RootConstrainSelectedInstOperands,
     /*  18470 */     // GIR_Coverage, 25108,
     /*  18470 */     GIR_EraseRootFromParent_Done,
     /*  18471 */   // Label 527: @18471
     /*  18471 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(18539), // Rule ID 26072 //
     /*  18476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18518 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18523 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18537 */     GIR_RootConstrainSelectedInstOperands,
     /*  18538 */     // GIR_Coverage, 26072,
     /*  18538 */     GIR_EraseRootFromParent_Done,
     /*  18539 */   // Label 528: @18539
     /*  18539 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(18607), // Rule ID 26091 //
     /*  18544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18586 */     // (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  18593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18597 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18605 */     GIR_RootConstrainSelectedInstOperands,
     /*  18606 */     // GIR_Coverage, 26091,
     /*  18606 */     GIR_EraseRootFromParent_Done,
     /*  18607 */   // Label 529: @18607
     /*  18607 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(18675), // Rule ID 22857 //
     /*  18612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  18615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18654 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm),
     /*  18657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18673 */     GIR_RootConstrainSelectedInstOperands,
     /*  18674 */     // GIR_Coverage, 22857,
     /*  18674 */     GIR_EraseRootFromParent_Done,
     /*  18675 */   // Label 530: @18675
     /*  18675 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(18743), // Rule ID 22947 //
     /*  18680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  18683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  18702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  18705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  18709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  18713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  18722 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (AND64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  18722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64rm_ND),
     /*  18725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  18729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  18733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  18741 */     GIR_RootConstrainSelectedInstOperands,
     /*  18742 */     // GIR_Coverage, 22947,
     /*  18742 */     GIR_EraseRootFromParent_Done,
     /*  18743 */   // Label 531: @18743
     /*  18743 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(18820), // Rule ID 24996 //
     /*  18748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18779 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  18783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18795 */     // MIs[2] src
     /*  18795 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18800 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18806 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18818 */     GIR_RootConstrainSelectedInstOperands,
     /*  18819 */     // GIR_Coverage, 24996,
     /*  18819 */     GIR_EraseRootFromParent_Done,
     /*  18820 */   // Label 532: @18820
     /*  18820 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(18897), // Rule ID 25008 //
     /*  18825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18872 */     // MIs[2] src
     /*  18872 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18877 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  18881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18883 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  18886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18895 */     GIR_RootConstrainSelectedInstOperands,
     /*  18896 */     // GIR_Coverage, 25008,
     /*  18896 */     GIR_EraseRootFromParent_Done,
     /*  18897 */   // Label 533: @18897
     /*  18897 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(18974), // Rule ID 17357 //
     /*  18902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  18924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  18928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  18937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  18941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  18945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18949 */     // MIs[2] src
     /*  18949 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  18958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18960 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  18960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCIC64rr),
     /*  18963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  18969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  18972 */     GIR_RootConstrainSelectedInstOperands,
     /*  18973 */     // GIR_Coverage, 17357,
     /*  18973 */     GIR_EraseRootFromParent_Done,
     /*  18974 */   // Label 534: @18974
     /*  18974 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(19051), // Rule ID 17369 //
     /*  18979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  18982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  18985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  18989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  19018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19026 */     // MIs[2] src
     /*  19026 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19031 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  19035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19037 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (TZMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZMSK64rr),
     /*  19040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19049 */     GIR_RootConstrainSelectedInstOperands,
     /*  19050 */     // GIR_Coverage, 17369,
     /*  19050 */     GIR_EraseRootFromParent_Done,
     /*  19051 */   // Label 535: @19051
     /*  19051 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(19109), // Rule ID 24990 //
     /*  19056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19084 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19088 */     // MIs[0] src
     /*  19088 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19095 */     // (and:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  19104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19107 */     GIR_RootConstrainSelectedInstOperands,
     /*  19108 */     // GIR_Coverage, 24990,
     /*  19108 */     GIR_EraseRootFromParent_Done,
     /*  19109 */   // Label 536: @19109
     /*  19109 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(19218), // Rule ID 26048 //
     /*  19114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19152 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19152 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19155 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19159 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19185 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  19210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19216 */     GIR_RootConstrainSelectedInstOperands,
     /*  19217 */     // GIR_Coverage, 26048,
     /*  19217 */     GIR_EraseRootFromParent_Done,
     /*  19218 */   // Label 537: @19218
     /*  19218 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(19272), // Rule ID 17351 //
     /*  19223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  19226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  19245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19249 */     // MIs[1] src
     /*  19249 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  19254 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  19258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19260 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  19260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCFILL64rr),
     /*  19263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  19267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19270 */     GIR_RootConstrainSelectedInstOperands,
     /*  19271 */     // GIR_Coverage, 17351,
     /*  19271 */     GIR_EraseRootFromParent_Done,
     /*  19272 */   // Label 538: @19272
     /*  19272 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(19381), // Rule ID 22786 //
     /*  19277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  19296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  19304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  19308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  19313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19315 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  19315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  19318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  19322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  19329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  19332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  19336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  19348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  19351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  19361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  19366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTR64rr),
     /*  19369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19379 */     GIR_RootConstrainSelectedInstOperands,
     /*  19380 */     // GIR_Coverage, 22786,
     /*  19380 */     GIR_EraseRootFromParent_Done,
     /*  19381 */   // Label 539: @19381
     /*  19381 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(19429), // Rule ID 22861 //
     /*  19386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19412 */     // MIs[1] Operand 1
     /*  19412 */     // No operand predicates
     /*  19412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19414 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32),
     /*  19417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19427 */     GIR_RootConstrainSelectedInstOperands,
     /*  19428 */     // GIR_Coverage, 22861,
     /*  19428 */     GIR_EraseRootFromParent_Done,
     /*  19429 */   // Label 540: @19429
     /*  19429 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(19477), // Rule ID 22951 //
     /*  19434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  19460 */     // MIs[1] Operand 1
     /*  19460 */     // No operand predicates
     /*  19460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19462 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (AND64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  19462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64ri32_ND),
     /*  19465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  19469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  19472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19475 */     GIR_RootConstrainSelectedInstOperands,
     /*  19476 */     // GIR_Coverage, 22951,
     /*  19476 */     GIR_EraseRootFromParent_Done,
     /*  19477 */   // Label 541: @19477
     /*  19477 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(19539), // Rule ID 17545 //
     /*  19482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19513 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19523 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19532 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19537 */     GIR_RootConstrainSelectedInstOperands,
     /*  19538 */     // GIR_Coverage, 17545,
     /*  19538 */     GIR_EraseRootFromParent_Done,
     /*  19539 */   // Label 542: @19539
     /*  19539 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(19601), // Rule ID 17549 //
     /*  19544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19585 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src2)  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19594 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  19596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19599 */     GIR_RootConstrainSelectedInstOperands,
     /*  19600 */     // GIR_Coverage, 17549,
     /*  19600 */     GIR_EraseRootFromParent_Done,
     /*  19601 */   // Label 543: @19601
     /*  19601 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(19663), // Rule ID 25102 //
     /*  19606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_NoEGPR),
     /*  19609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19641 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19647 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr),
     /*  19650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19656 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19661 */     GIR_RootConstrainSelectedInstOperands,
     /*  19662 */     // GIR_Coverage, 25102,
     /*  19662 */     GIR_EraseRootFromParent_Done,
     /*  19663 */   // Label 544: @19663
     /*  19663 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(19725), // Rule ID 25106 //
     /*  19668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI_HasEGPR),
     /*  19671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  19694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  19698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19703 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  19707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19709 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] }))  =>  (ANDN64rr_EVEX:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ANDN64rr_EVEX),
     /*  19712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  19720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  19723 */     GIR_RootConstrainSelectedInstOperands,
     /*  19724 */     // GIR_Coverage, 25106,
     /*  19724 */     GIR_EraseRootFromParent_Done,
     /*  19725 */   // Label 545: @19725
     /*  19725 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(19761), // Rule ID 22853 //
     /*  19730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  19733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19748 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr),
     /*  19753 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19759 */     GIR_RootConstrainSelectedInstOperands,
     /*  19760 */     // GIR_Coverage, 22853,
     /*  19760 */     GIR_Done,
     /*  19761 */   // Label 546: @19761
     /*  19761 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(19797), // Rule ID 22943 //
     /*  19766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  19769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  19772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  19784 */     // (and:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (AND64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  19784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::AND64rr_ND),
     /*  19789 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  19795 */     GIR_RootConstrainSelectedInstOperands,
     /*  19796 */     // GIR_Coverage, 22943,
     /*  19796 */     GIR_Done,
     /*  19797 */   // Label 547: @19797
     /*  19797 */   GIM_Reject,
     /*  19798 */ // Label 523: @19798
     /*  19798 */ GIM_Reject,
     /*  19799 */ // Label 452: @19799
     /*  19799 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(20144),
     /*  19804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19814 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(19934), // Rule ID 19489 //
     /*  19819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19844 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19850 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19858 */     // (and:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19870 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  19874 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  19882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  19895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  19903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  19907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19912 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  19915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  19918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  19920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  19928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  19933 */     // GIR_Coverage, 19489,
     /*  19933 */     GIR_EraseRootFromParent_Done,
     /*  19934 */   // Label 549: @19934
     /*  19934 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(20054), // Rule ID 25368 //
     /*  19939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  19955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  19959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  19964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19968 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19974 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  19976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19978 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  19978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  19981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  19985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  19990 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  19994 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  19999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20053 */     // GIR_Coverage, 25368,
     /*  20053 */     GIR_EraseRootFromParent_Done,
     /*  20054 */   // Label 550: @20054
     /*  20054 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(20143), // Rule ID 19485 //
     /*  20059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  20067 */     // (and:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  20067 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20070 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20074 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20079 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20083 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20088 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20091 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20095 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  20142 */     // GIR_Coverage, 19485,
     /*  20142 */     GIR_EraseRootFromParent_Done,
     /*  20143 */   // Label 551: @20143
     /*  20143 */   GIM_Reject,
     /*  20144 */ // Label 548: @20144
     /*  20144 */ GIM_Reject,
     /*  20145 */ // Label 453: @20145
     /*  20145 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(20486),
     /*  20150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20156 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(20218), // Rule ID 23360 //
     /*  20161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20193 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20200 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20205 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20216 */     GIR_RootConstrainSelectedInstOperands,
     /*  20217 */     // GIR_Coverage, 23360,
     /*  20217 */     GIR_EraseRootFromParent_Done,
     /*  20218 */   // Label 553: @20218
     /*  20218 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(20280), // Rule ID 24149 //
     /*  20223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20262 */     // (and:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20269 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20278 */     GIR_RootConstrainSelectedInstOperands,
     /*  20279 */     // GIR_Coverage, 24149,
     /*  20279 */     GIR_EraseRootFromParent_Done,
     /*  20280 */   // Label 554: @20280
     /*  20280 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(20342), // Rule ID 2111 //
     /*  20285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20324 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20340 */     GIR_RootConstrainSelectedInstOperands,
     /*  20341 */     // GIR_Coverage, 2111,
     /*  20341 */     GIR_EraseRootFromParent_Done,
     /*  20342 */   // Label 555: @20342
     /*  20342 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(20404), // Rule ID 5707 //
     /*  20347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20386 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  20389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20391 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  20393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20402 */     GIR_RootConstrainSelectedInstOperands,
     /*  20403 */     // GIR_Coverage, 5707,
     /*  20403 */     GIR_EraseRootFromParent_Done,
     /*  20404 */   // Label 556: @20404
     /*  20404 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(20431), // Rule ID 2110 //
     /*  20409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20424 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  20429 */     GIR_RootConstrainSelectedInstOperands,
     /*  20430 */     // GIR_Coverage, 2110,
     /*  20430 */     GIR_Done,
     /*  20431 */   // Label 557: @20431
     /*  20431 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(20458), // Rule ID 2112 //
     /*  20436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  20439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20451 */     // (and:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PANDrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  20451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  20456 */     GIR_RootConstrainSelectedInstOperands,
     /*  20457 */     // GIR_Coverage, 2112,
     /*  20457 */     GIR_Done,
     /*  20458 */   // Label 558: @20458
     /*  20458 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(20485), // Rule ID 5704 //
     /*  20463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20478 */     // (and:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPANDQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  20478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  20483 */     GIR_RootConstrainSelectedInstOperands,
     /*  20484 */     // GIR_Coverage, 5704,
     /*  20484 */     GIR_Done,
     /*  20485 */   // Label 559: @20485
     /*  20485 */   GIM_Reject,
     /*  20486 */ // Label 552: @20486
     /*  20486 */ GIM_Reject,
     /*  20487 */ // Label 454: @20487
     /*  20487 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(20832),
     /*  20492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20502 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(20622), // Rule ID 19490 //
     /*  20507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20532 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20538 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20546 */     // (and:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20546 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20549 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20553 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20558 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20562 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20579 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20600 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20621 */     // GIR_Coverage, 19490,
     /*  20621 */     GIR_EraseRootFromParent_Done,
     /*  20622 */   // Label 561: @20622
     /*  20622 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(20742), // Rule ID 25369 //
     /*  20627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  20643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  20647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20656 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  20664 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20666 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20666 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20669 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20673 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20678 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  20682 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20687 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20690 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20694 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20703 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  20715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20741 */     // GIR_Coverage, 25369,
     /*  20741 */     GIR_EraseRootFromParent_Done,
     /*  20742 */   // Label 562: @20742
     /*  20742 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(20831), // Rule ID 19486 //
     /*  20747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  20755 */     // (and:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  20755 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  20758 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20762 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20767 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  20771 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  20779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  20792 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  20797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  20800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  20804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  20809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  20812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  20815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  20817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  20820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  20825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  20830 */     // GIR_Coverage, 19486,
     /*  20830 */     GIR_EraseRootFromParent_Done,
     /*  20831 */   // Label 563: @20831
     /*  20831 */   GIM_Reject,
     /*  20832 */ // Label 560: @20832
     /*  20832 */ GIM_Reject,
     /*  20833 */ // Label 455: @20833
     /*  20833 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(21174),
     /*  20838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20844 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(20906), // Rule ID 24167 //
     /*  20849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20864 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20871 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20888 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  20891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20893 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20904 */     GIR_RootConstrainSelectedInstOperands,
     /*  20905 */     // GIR_Coverage, 24167,
     /*  20905 */     GIR_EraseRootFromParent_Done,
     /*  20906 */   // Label 565: @20906
     /*  20906 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(20968), // Rule ID 25253 //
     /*  20911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  20914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  20937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  20941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  20950 */     // (and:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  20950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  20953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20955 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  20957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  20961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 25253,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 566: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(21030), // Rule ID 5734 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  20984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  20992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  20995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  20999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21005 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21012 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rm),
     /*  21015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21017 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21019 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21028 */     GIR_RootConstrainSelectedInstOperands,
     /*  21029 */     // GIR_Coverage, 5734,
     /*  21029 */     GIR_EraseRootFromParent_Done,
     /*  21030 */   // Label 567: @21030
     /*  21030 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(21092), // Rule ID 18160 //
     /*  21035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21054 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21057 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21061 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21074 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  21077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21090 */     GIR_RootConstrainSelectedInstOperands,
     /*  21091 */     // GIR_Coverage, 18160,
     /*  21091 */     GIR_EraseRootFromParent_Done,
     /*  21092 */   // Label 568: @21092
     /*  21092 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(21119), // Rule ID 5731 //
     /*  21097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  21112 */     // (and:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPANDDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  21112 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ128rr),
     /*  21117 */     GIR_RootConstrainSelectedInstOperands,
     /*  21118 */     // GIR_Coverage, 5731,
     /*  21118 */     GIR_Done,
     /*  21119 */   // Label 569: @21119
     /*  21119 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(21146), // Rule ID 18148 //
     /*  21124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  21127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21139 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21139 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  21144 */     GIR_RootConstrainSelectedInstOperands,
     /*  21145 */     // GIR_Coverage, 18148,
     /*  21145 */     GIR_Done,
     /*  21146 */   // Label 570: @21146
     /*  21146 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(21173), // Rule ID 18172 //
     /*  21151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  21154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  21166 */     // (and:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PANDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  21166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  21171 */     GIR_RootConstrainSelectedInstOperands,
     /*  21172 */     // GIR_Coverage, 18172,
     /*  21172 */     GIR_Done,
     /*  21173 */   // Label 571: @21173
     /*  21173 */   GIM_Reject,
     /*  21174 */ // Label 564: @21174
     /*  21174 */ GIM_Reject,
     /*  21175 */ // Label 456: @21175
     /*  21175 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(21640),
     /*  21180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  21183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  21186 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(21248), // Rule ID 23362 //
     /*  21191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21230 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21235 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21246 */     GIR_RootConstrainSelectedInstOperands,
     /*  21247 */     // GIR_Coverage, 23362,
     /*  21247 */     GIR_EraseRootFromParent_Done,
     /*  21248 */   // Label 573: @21248
     /*  21248 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(21310), // Rule ID 24143 //
     /*  21253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21268 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21285 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21292 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21299 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21308 */     GIR_RootConstrainSelectedInstOperands,
     /*  21309 */     // GIR_Coverage, 24143,
     /*  21309 */     GIR_EraseRootFromParent_Done,
     /*  21310 */   // Label 574: @21310
     /*  21310 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(21372), // Rule ID 25242 //
     /*  21315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21354 */     // (and:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21359 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  21361 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21370 */     GIR_RootConstrainSelectedInstOperands,
     /*  21371 */     // GIR_Coverage, 25242,
     /*  21371 */     GIR_EraseRootFromParent_Done,
     /*  21372 */   // Label 575: @21372
     /*  21372 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(21434), // Rule ID 2115 //
     /*  21377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21416 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  21419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21432 */     GIR_RootConstrainSelectedInstOperands,
     /*  21433 */     // GIR_Coverage, 2115,
     /*  21433 */     GIR_EraseRootFromParent_Done,
     /*  21434 */   // Label 576: @21434
     /*  21434 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(21496), // Rule ID 5698 //
     /*  21439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21478 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  21481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21483 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21494 */     GIR_RootConstrainSelectedInstOperands,
     /*  21495 */     // GIR_Coverage, 5698,
     /*  21495 */     GIR_EraseRootFromParent_Done,
     /*  21496 */   // Label 577: @21496
     /*  21496 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(21558), // Rule ID 18133 //
     /*  21501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  21520 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  21523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  21527 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  21531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  21540 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  21540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  21543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  21547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  21551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  21556 */     GIR_RootConstrainSelectedInstOperands,
     /*  21557 */     // GIR_Coverage, 18133,
     /*  21557 */     GIR_EraseRootFromParent_Done,
     /*  21558 */   // Label 578: @21558
     /*  21558 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(21585), // Rule ID 2114 //
     /*  21563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  21566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21578 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPANDYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  21583 */     GIR_RootConstrainSelectedInstOperands,
     /*  21584 */     // GIR_Coverage, 2114,
     /*  21584 */     GIR_Done,
     /*  21585 */   // Label 579: @21585
     /*  21585 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(21612), // Rule ID 5695 //
     /*  21590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  21593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  21605 */     // (and:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPANDQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  21605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  21610 */     GIR_RootConstrainSelectedInstOperands,
     /*  21611 */     // GIR_Coverage, 5695,
     /*  21611 */     GIR_Done,
     /*  21612 */   // Label 580: @21612
     /*  21612 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(21639), // Rule ID 18117 //
     /*  21617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  21620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  21632 */     // (and:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VANDPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  21632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  21637 */     GIR_RootConstrainSelectedInstOperands,
     /*  21638 */     // GIR_Coverage, 18117,
     /*  21638 */     GIR_Done,
     /*  21639 */   // Label 581: @21639
     /*  21639 */   GIM_Reject,
     /*  21640 */ // Label 572: @21640
     /*  21640 */ GIM_Reject,
     /*  21641 */ // Label 457: @21641
     /*  21641 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(22138),
     /*  21646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21656 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(21716), // Rule ID 4431 //
     /*  21661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21689 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21703 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21712 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  21714 */     GIR_RootConstrainSelectedInstOperands,
     /*  21715 */     // GIR_Coverage, 4431,
     /*  21715 */     GIR_EraseRootFromParent_Done,
     /*  21716 */   // Label 583: @21716
     /*  21716 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(21839), // Rule ID 19487 //
     /*  21721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21749 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21755 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21763 */     // (and:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21775 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  21779 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  21820 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  21823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  21833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  21838 */     // GIR_Coverage, 19487,
     /*  21838 */     GIR_EraseRootFromParent_Done,
     /*  21839 */   // Label 584: @21839
     /*  21839 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(21899), // Rule ID 23692 //
     /*  21844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  21847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21876 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21886 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KANDNBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  21886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNBkk),
     /*  21889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  21897 */     GIR_RootConstrainSelectedInstOperands,
     /*  21898 */     // GIR_Coverage, 23692,
     /*  21898 */     GIR_EraseRootFromParent_Done,
     /*  21899 */   // Label 585: @21899
     /*  21899 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(22022), // Rule ID 25366 //
     /*  21904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  21907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  21923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  21927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  21932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21936 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  21944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21946 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDNWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  21946 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  21949 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21953 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21958 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  21962 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21967 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  21970 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21974 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21979 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21983 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  21988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  21991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  21995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22000 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22003 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  22006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  22016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22021 */     // GIR_Coverage, 25366,
     /*  22021 */     GIR_EraseRootFromParent_Done,
     /*  22022 */   // Label 586: @22022
     /*  22022 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(22045), // Rule ID 4415 //
     /*  22027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  22030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22038 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KANDBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  22038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDBkk),
     /*  22043 */     GIR_RootConstrainSelectedInstOperands,
     /*  22044 */     // GIR_Coverage, 4415,
     /*  22044 */     GIR_Done,
     /*  22045 */   // Label 587: @22045
     /*  22045 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(22137), // Rule ID 19483 //
     /*  22050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  22053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  22061 */     // (and:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KANDWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  22061 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  22064 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22068 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22073 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  22077 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  22085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  22098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  22103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  22106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  22110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  22121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  22131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  22136 */     // GIR_Coverage, 19483,
     /*  22136 */     GIR_EraseRootFromParent_Done,
     /*  22137 */   // Label 588: @22137
     /*  22137 */   GIM_Reject,
     /*  22138 */ // Label 582: @22138
     /*  22138 */ GIM_Reject,
     /*  22139 */ // Label 458: @22139
     /*  22139 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(22480),
     /*  22144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22150 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(22212), // Rule ID 25252 //
     /*  22155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22194 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22210 */     GIR_RootConstrainSelectedInstOperands,
     /*  22211 */     // GIR_Coverage, 25252,
     /*  22211 */     GIR_EraseRootFromParent_Done,
     /*  22212 */   // Label 590: @22212
     /*  22212 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(22274), // Rule ID 25433 //
     /*  22217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22256 */     // (and:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22272 */     GIR_RootConstrainSelectedInstOperands,
     /*  22273 */     // GIR_Coverage, 25433,
     /*  22273 */     GIR_EraseRootFromParent_Done,
     /*  22274 */   // Label 591: @22274
     /*  22274 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(22336), // Rule ID 18159 //
     /*  22279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22298 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22301 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22305 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22318 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  22321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22334 */     GIR_RootConstrainSelectedInstOperands,
     /*  22335 */     // GIR_Coverage, 18159,
     /*  22335 */     GIR_EraseRootFromParent_Done,
     /*  22336 */   // Label 592: @22336
     /*  22336 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(22398), // Rule ID 20025 //
     /*  22341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22360 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22363 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22367 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22380 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  22383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22385 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22396 */     GIR_RootConstrainSelectedInstOperands,
     /*  22397 */     // GIR_Coverage, 20025,
     /*  22397 */     GIR_EraseRootFromParent_Done,
     /*  22398 */   // Label 593: @22398
     /*  22398 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(22425), // Rule ID 18147 //
     /*  22403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  22406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22418 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  22423 */     GIR_RootConstrainSelectedInstOperands,
     /*  22424 */     // GIR_Coverage, 18147,
     /*  22424 */     GIR_Done,
     /*  22425 */   // Label 594: @22425
     /*  22425 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(22452), // Rule ID 18171 //
     /*  22430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  22433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  22445 */     // (and:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PANDrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  22445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  22450 */     GIR_RootConstrainSelectedInstOperands,
     /*  22451 */     // GIR_Coverage, 18171,
     /*  22451 */     GIR_Done,
     /*  22452 */   // Label 595: @22452
     /*  22452 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(22479), // Rule ID 20017 //
     /*  22457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  22460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  22472 */     // (and:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPANDQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  22472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  22477 */     GIR_RootConstrainSelectedInstOperands,
     /*  22478 */     // GIR_Coverage, 20017,
     /*  22478 */     GIR_Done,
     /*  22479 */   // Label 596: @22479
     /*  22479 */   GIM_Reject,
     /*  22480 */ // Label 589: @22480
     /*  22480 */ GIM_Reject,
     /*  22481 */ // Label 459: @22481
     /*  22481 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(22946),
     /*  22486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  22489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  22492 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(22554), // Rule ID 24161 //
     /*  22497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22515 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22519 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22536 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22552 */     GIR_RootConstrainSelectedInstOperands,
     /*  22553 */     // GIR_Coverage, 24161,
     /*  22553 */     GIR_EraseRootFromParent_Done,
     /*  22554 */   // Label 598: @22554
     /*  22554 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(22616), // Rule ID 25232 //
     /*  22559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22574 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22577 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22581 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22598 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22614 */     GIR_RootConstrainSelectedInstOperands,
     /*  22615 */     // GIR_Coverage, 25232,
     /*  22615 */     GIR_EraseRootFromParent_Done,
     /*  22616 */   // Label 599: @22616
     /*  22616 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(22678), // Rule ID 25241 //
     /*  22621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22660 */     // (and:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  22667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22676 */     GIR_RootConstrainSelectedInstOperands,
     /*  22677 */     // GIR_Coverage, 25241,
     /*  22677 */     GIR_EraseRootFromParent_Done,
     /*  22678 */   // Label 600: @22678
     /*  22678 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(22740), // Rule ID 5725 //
     /*  22683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22722 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rm),
     /*  22725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22738 */     GIR_RootConstrainSelectedInstOperands,
     /*  22739 */     // GIR_Coverage, 5725,
     /*  22739 */     GIR_EraseRootFromParent_Done,
     /*  22740 */   // Label 601: @22740
     /*  22740 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(22802), // Rule ID 18104 //
     /*  22745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22764 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22767 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22771 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22784 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  22787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22800 */     GIR_RootConstrainSelectedInstOperands,
     /*  22801 */     // GIR_Coverage, 18104,
     /*  22801 */     GIR_EraseRootFromParent_Done,
     /*  22802 */   // Label 602: @22802
     /*  22802 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(22864), // Rule ID 18132 //
     /*  22807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  22846 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  22846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  22849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  22853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  22857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  22862 */     GIR_RootConstrainSelectedInstOperands,
     /*  22863 */     // GIR_Coverage, 18132,
     /*  22863 */     GIR_EraseRootFromParent_Done,
     /*  22864 */   // Label 603: @22864
     /*  22864 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(22891), // Rule ID 5722 //
     /*  22869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  22872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  22884 */     // (and:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPANDDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  22884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZ256rr),
     /*  22889 */     GIR_RootConstrainSelectedInstOperands,
     /*  22890 */     // GIR_Coverage, 5722,
     /*  22890 */     GIR_Done,
     /*  22891 */   // Label 604: @22891
     /*  22891 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(22918), // Rule ID 18092 //
     /*  22896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  22899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22911 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPANDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  22916 */     GIR_RootConstrainSelectedInstOperands,
     /*  22917 */     // GIR_Coverage, 18092,
     /*  22917 */     GIR_Done,
     /*  22918 */   // Label 605: @22918
     /*  22918 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(22945), // Rule ID 18116 //
     /*  22923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  22938 */     // (and:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VANDPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  22938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  22943 */     GIR_RootConstrainSelectedInstOperands,
     /*  22944 */     // GIR_Coverage, 18116,
     /*  22944 */     GIR_Done,
     /*  22945 */   // Label 606: @22945
     /*  22945 */   GIM_Reject,
     /*  22946 */ // Label 597: @22946
     /*  22946 */ GIM_Reject,
     /*  22947 */ // Label 460: @22947
     /*  22947 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(23102),
     /*  22952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  22955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  22958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22962 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(23020), // Rule ID 24137 //
     /*  22967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  22970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  22978 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  22981 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  22985 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  22989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  22993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23002 */     // (and:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  23005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23007 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23018 */     GIR_RootConstrainSelectedInstOperands,
     /*  23019 */     // GIR_Coverage, 24137,
     /*  23019 */     GIR_EraseRootFromParent_Done,
     /*  23020 */   // Label 608: @23020
     /*  23020 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(23078), // Rule ID 5689 //
     /*  23025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23043 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23047 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23053 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23060 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  23063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23065 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23071 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23076 */     GIR_RootConstrainSelectedInstOperands,
     /*  23077 */     // GIR_Coverage, 5689,
     /*  23077 */     GIR_EraseRootFromParent_Done,
     /*  23078 */   // Label 609: @23078
     /*  23078 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(23101), // Rule ID 5686 //
     /*  23083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  23094 */     // (and:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPANDQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  23094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  23099 */     GIR_RootConstrainSelectedInstOperands,
     /*  23100 */     // GIR_Coverage, 5686,
     /*  23100 */     GIR_Done,
     /*  23101 */   // Label 610: @23101
     /*  23101 */   GIM_Reject,
     /*  23102 */ // Label 607: @23102
     /*  23102 */ GIM_Reject,
     /*  23103 */ // Label 461: @23103
     /*  23103 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(23262),
     /*  23108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23118 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(23178), // Rule ID 4432 //
     /*  23123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23151 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23163 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23165 */     // (and:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23174 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  23176 */     GIR_RootConstrainSelectedInstOperands,
     /*  23177 */     // GIR_Coverage, 4432,
     /*  23177 */     GIR_EraseRootFromParent_Done,
     /*  23178 */   // Label 612: @23178
     /*  23178 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(23238), // Rule ID 23693 //
     /*  23183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  23202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  23206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23215 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  23223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23225 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KANDNWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNWkk),
     /*  23228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  23234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  23236 */     GIR_RootConstrainSelectedInstOperands,
     /*  23237 */     // GIR_Coverage, 23693,
     /*  23237 */     GIR_EraseRootFromParent_Done,
     /*  23238 */   // Label 613: @23238
     /*  23238 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(23261), // Rule ID 4416 //
     /*  23243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  23246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  23254 */     // (and:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KANDWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  23254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDWkk),
     /*  23259 */     GIR_RootConstrainSelectedInstOperands,
     /*  23260 */     // GIR_Coverage, 4416,
     /*  23260 */     GIR_Done,
     /*  23261 */   // Label 614: @23261
     /*  23261 */   GIM_Reject,
     /*  23262 */ // Label 611: @23262
     /*  23262 */ GIM_Reject,
     /*  23263 */ // Label 462: @23263
     /*  23263 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(23604),
     /*  23268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  23271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  23274 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(23336), // Rule ID 25251 //
     /*  23279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23318 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23334 */     GIR_RootConstrainSelectedInstOperands,
     /*  23335 */     // GIR_Coverage, 25251,
     /*  23335 */     GIR_EraseRootFromParent_Done,
     /*  23336 */   // Label 616: @23336
     /*  23336 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(23398), // Rule ID 25432 //
     /*  23341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23380 */     // (and:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23396 */     GIR_RootConstrainSelectedInstOperands,
     /*  23397 */     // GIR_Coverage, 25432,
     /*  23397 */     GIR_EraseRootFromParent_Done,
     /*  23398 */   // Label 617: @23398
     /*  23398 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(23460), // Rule ID 18158 //
     /*  23403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23442 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDrm),
     /*  23445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23447 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23458 */     GIR_RootConstrainSelectedInstOperands,
     /*  23459 */     // GIR_Coverage, 18158,
     /*  23459 */     GIR_EraseRootFromParent_Done,
     /*  23460 */   // Label 618: @23460
     /*  23460 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(23522), // Rule ID 20024 //
     /*  23465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23504 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rm),
     /*  23507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23520 */     GIR_RootConstrainSelectedInstOperands,
     /*  23521 */     // GIR_Coverage, 20024,
     /*  23521 */     GIR_EraseRootFromParent_Done,
     /*  23522 */   // Label 619: @23522
     /*  23522 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(23549), // Rule ID 18146 //
     /*  23527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  23530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23542 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDrr),
     /*  23547 */     GIR_RootConstrainSelectedInstOperands,
     /*  23548 */     // GIR_Coverage, 18146,
     /*  23548 */     GIR_Done,
     /*  23549 */   // Label 620: @23549
     /*  23549 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(23576), // Rule ID 18170 //
     /*  23554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  23557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  23569 */     // (and:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PANDrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  23569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PANDrr),
     /*  23574 */     GIR_RootConstrainSelectedInstOperands,
     /*  23575 */     // GIR_Coverage, 18170,
     /*  23575 */     GIR_Done,
     /*  23576 */   // Label 621: @23576
     /*  23576 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(23603), // Rule ID 20016 //
     /*  23581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  23596 */     // (and:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPANDQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  23596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ128rr),
     /*  23601 */     GIR_RootConstrainSelectedInstOperands,
     /*  23602 */     // GIR_Coverage, 20016,
     /*  23602 */     GIR_Done,
     /*  23603 */   // Label 622: @23603
     /*  23603 */   GIM_Reject,
     /*  23604 */ // Label 615: @23604
     /*  23604 */ GIM_Reject,
     /*  23605 */ // Label 463: @23605
     /*  23605 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(24070),
     /*  23610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  23613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  23616 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(23678), // Rule ID 25231 //
     /*  23621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23660 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23671 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23676 */     GIR_RootConstrainSelectedInstOperands,
     /*  23677 */     // GIR_Coverage, 25231,
     /*  23677 */     GIR_EraseRootFromParent_Done,
     /*  23678 */   // Label 624: @23678
     /*  23678 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(23740), // Rule ID 25240 //
     /*  23683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23701 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23722 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23727 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23729 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23733 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23738 */     GIR_RootConstrainSelectedInstOperands,
     /*  23739 */     // GIR_Coverage, 25240,
     /*  23739 */     GIR_EraseRootFromParent_Done,
     /*  23740 */   // Label 625: @23740
     /*  23740 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(23802), // Rule ID 25439 //
     /*  23745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23784 */     // (and:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  23791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23800 */     GIR_RootConstrainSelectedInstOperands,
     /*  23801 */     // GIR_Coverage, 25439,
     /*  23801 */     GIR_EraseRootFromParent_Done,
     /*  23802 */   // Label 626: @23802
     /*  23802 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(23864), // Rule ID 18103 //
     /*  23807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23846 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  23849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23862 */     GIR_RootConstrainSelectedInstOperands,
     /*  23863 */     // GIR_Coverage, 18103,
     /*  23863 */     GIR_EraseRootFromParent_Done,
     /*  23864 */   // Label 627: @23864
     /*  23864 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(23926), // Rule ID 18131 //
     /*  23869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  23872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  23880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23908 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  23911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23913 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23924 */     GIR_RootConstrainSelectedInstOperands,
     /*  23925 */     // GIR_Coverage, 18131,
     /*  23925 */     GIR_EraseRootFromParent_Done,
     /*  23926 */   // Label 628: @23926
     /*  23926 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(23988), // Rule ID 20041 //
     /*  23931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  23934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  23942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  23950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  23953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  23957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  23961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23963 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  23970 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  23970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  23973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23975 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  23977 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  23981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  23986 */     GIR_RootConstrainSelectedInstOperands,
     /*  23987 */     // GIR_Coverage, 20041,
     /*  23987 */     GIR_EraseRootFromParent_Done,
     /*  23988 */   // Label 629: @23988
     /*  23988 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(24015), // Rule ID 18091 //
     /*  23993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  23996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24008 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPANDYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  24008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24013 */     GIR_RootConstrainSelectedInstOperands,
     /*  24014 */     // GIR_Coverage, 18091,
     /*  24014 */     GIR_Done,
     /*  24015 */   // Label 630: @24015
     /*  24015 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(24042), // Rule ID 18115 //
     /*  24020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24035 */     // (and:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VANDPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  24035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24040 */     GIR_RootConstrainSelectedInstOperands,
     /*  24041 */     // GIR_Coverage, 18115,
     /*  24041 */     GIR_Done,
     /*  24042 */   // Label 631: @24042
     /*  24042 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(24069), // Rule ID 20033 //
     /*  24047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24062 */     // (and:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPANDQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  24062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24067 */     GIR_RootConstrainSelectedInstOperands,
     /*  24068 */     // GIR_Coverage, 20033,
     /*  24068 */     GIR_Done,
     /*  24069 */   // Label 632: @24069
     /*  24069 */   GIM_Reject,
     /*  24070 */ // Label 623: @24070
     /*  24070 */ GIM_Reject,
     /*  24071 */ // Label 464: @24071
     /*  24071 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(24226),
     /*  24076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  24079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  24082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24086 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(24144), // Rule ID 24155 //
     /*  24091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24119 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24126 */     // (and:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24131 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24142 */     GIR_RootConstrainSelectedInstOperands,
     /*  24143 */     // GIR_Coverage, 24155,
     /*  24143 */     GIR_EraseRootFromParent_Done,
     /*  24144 */   // Label 634: @24144
     /*  24144 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(24202), // Rule ID 5716 //
     /*  24149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24184 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDDZrm),
     /*  24187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24200 */     GIR_RootConstrainSelectedInstOperands,
     /*  24201 */     // GIR_Coverage, 5716,
     /*  24201 */     GIR_EraseRootFromParent_Done,
     /*  24202 */   // Label 635: @24202
     /*  24202 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(24225), // Rule ID 5713 //
     /*  24207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24218 */     // (and:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPANDDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  24218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDDZrr),
     /*  24223 */     GIR_RootConstrainSelectedInstOperands,
     /*  24224 */     // GIR_Coverage, 5713,
     /*  24224 */     GIR_Done,
     /*  24225 */   // Label 636: @24225
     /*  24225 */   GIM_Reject,
     /*  24226 */ // Label 633: @24226
     /*  24226 */ GIM_Reject,
     /*  24227 */ // Label 465: @24227
     /*  24227 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(24386),
     /*  24232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24242 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(24302), // Rule ID 4433 //
     /*  24247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24275 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24281 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24289 */     // (and:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  24300 */     GIR_RootConstrainSelectedInstOperands,
     /*  24301 */     // GIR_Coverage, 4433,
     /*  24301 */     GIR_EraseRootFromParent_Done,
     /*  24302 */   // Label 638: @24302
     /*  24302 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(24362), // Rule ID 23694 //
     /*  24307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  24326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  24330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24339 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  24347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24349 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KANDNDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNDkk),
     /*  24352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  24358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  24360 */     GIR_RootConstrainSelectedInstOperands,
     /*  24361 */     // GIR_Coverage, 23694,
     /*  24361 */     GIR_EraseRootFromParent_Done,
     /*  24362 */   // Label 639: @24362
     /*  24362 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(24385), // Rule ID 4417 //
     /*  24367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  24370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  24378 */     // (and:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KANDDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  24378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDDkk),
     /*  24383 */     GIR_RootConstrainSelectedInstOperands,
     /*  24384 */     // GIR_Coverage, 4417,
     /*  24384 */     GIR_Done,
     /*  24385 */   // Label 640: @24385
     /*  24385 */   GIM_Reject,
     /*  24386 */ // Label 637: @24386
     /*  24386 */ GIM_Reject,
     /*  24387 */ // Label 466: @24387
     /*  24387 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(24852),
     /*  24392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  24395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  24398 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(24460), // Rule ID 25230 //
     /*  24403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24442 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24458 */     GIR_RootConstrainSelectedInstOperands,
     /*  24459 */     // GIR_Coverage, 25230,
     /*  24459 */     GIR_EraseRootFromParent_Done,
     /*  24460 */   // Label 642: @24460
     /*  24460 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(24522), // Rule ID 25239 //
     /*  24465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24504 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24509 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24520 */     GIR_RootConstrainSelectedInstOperands,
     /*  24521 */     // GIR_Coverage, 25239,
     /*  24521 */     GIR_EraseRootFromParent_Done,
     /*  24522 */   // Label 643: @24522
     /*  24522 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(24584), // Rule ID 25438 //
     /*  24527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24566 */     // (and:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24571 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24582 */     GIR_RootConstrainSelectedInstOperands,
     /*  24583 */     // GIR_Coverage, 25438,
     /*  24583 */     GIR_EraseRootFromParent_Done,
     /*  24584 */   // Label 644: @24584
     /*  24584 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(24646), // Rule ID 18102 //
     /*  24589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24628 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDYrm),
     /*  24631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24644 */     GIR_RootConstrainSelectedInstOperands,
     /*  24645 */     // GIR_Coverage, 18102,
     /*  24645 */     GIR_EraseRootFromParent_Done,
     /*  24646 */   // Label 645: @24646
     /*  24646 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(24708), // Rule ID 18130 //
     /*  24651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24670 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24673 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24677 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24690 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VANDPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VANDPSYrm),
     /*  24693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24706 */     GIR_RootConstrainSelectedInstOperands,
     /*  24707 */     // GIR_Coverage, 18130,
     /*  24707 */     GIR_EraseRootFromParent_Done,
     /*  24708 */   // Label 646: @24708
     /*  24708 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(24770), // Rule ID 20040 //
     /*  24713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24752 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rm),
     /*  24755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24768 */     GIR_RootConstrainSelectedInstOperands,
     /*  24769 */     // GIR_Coverage, 20040,
     /*  24769 */     GIR_EraseRootFromParent_Done,
     /*  24770 */   // Label 647: @24770
     /*  24770 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(24797), // Rule ID 18090 //
     /*  24775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24790 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPANDYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDYrr),
     /*  24795 */     GIR_RootConstrainSelectedInstOperands,
     /*  24796 */     // GIR_Coverage, 18090,
     /*  24796 */     GIR_Done,
     /*  24797 */   // Label 648: @24797
     /*  24797 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(24824), // Rule ID 18114 //
     /*  24802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  24805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  24817 */     // (and:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VANDPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  24817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VANDPSYrr),
     /*  24822 */     GIR_RootConstrainSelectedInstOperands,
     /*  24823 */     // GIR_Coverage, 18114,
     /*  24823 */     GIR_Done,
     /*  24824 */   // Label 649: @24824
     /*  24824 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(24851), // Rule ID 20032 //
     /*  24829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  24832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  24844 */     // (and:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPANDQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  24844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZ256rr),
     /*  24849 */     GIR_RootConstrainSelectedInstOperands,
     /*  24850 */     // GIR_Coverage, 20032,
     /*  24850 */     GIR_Done,
     /*  24851 */   // Label 650: @24851
     /*  24851 */   GIM_Reject,
     /*  24852 */ // Label 641: @24852
     /*  24852 */ GIM_Reject,
     /*  24853 */ // Label 467: @24853
     /*  24853 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(25008),
     /*  24858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  24861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  24864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24868 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(24926), // Rule ID 25445 //
     /*  24873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24901 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24908 */     // (and:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24913 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  24915 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24924 */     GIR_RootConstrainSelectedInstOperands,
     /*  24925 */     // GIR_Coverage, 25445,
     /*  24925 */     GIR_EraseRootFromParent_Done,
     /*  24926 */   // Label 652: @24926
     /*  24926 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(24984), // Rule ID 20057 //
     /*  24931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  24946 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  24949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  24953 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  24957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24959 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  24966 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  24966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  24969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  24973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  24977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  24982 */     GIR_RootConstrainSelectedInstOperands,
     /*  24983 */     // GIR_Coverage, 20057,
     /*  24983 */     GIR_EraseRootFromParent_Done,
     /*  24984 */   // Label 653: @24984
     /*  24984 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(25007), // Rule ID 20049 //
     /*  24989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  24992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  24996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25000 */     // (and:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPANDQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  25000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25005 */     GIR_RootConstrainSelectedInstOperands,
     /*  25006 */     // GIR_Coverage, 20049,
     /*  25006 */     GIR_Done,
     /*  25007 */   // Label 654: @25007
     /*  25007 */   GIM_Reject,
     /*  25008 */ // Label 651: @25008
     /*  25008 */ GIM_Reject,
     /*  25009 */ // Label 468: @25009
     /*  25009 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(25168),
     /*  25014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25024 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(25084), // Rule ID 4434 //
     /*  25029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25057 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25063 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25071 */     // (and:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  25082 */     GIR_RootConstrainSelectedInstOperands,
     /*  25083 */     // GIR_Coverage, 4434,
     /*  25083 */     GIR_EraseRootFromParent_Done,
     /*  25084 */   // Label 656: @25084
     /*  25084 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(25144), // Rule ID 23695 //
     /*  25089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  25108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  25112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25121 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25127 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  25129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25131 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KANDNQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KANDNQkk),
     /*  25134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  25140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  25142 */     GIR_RootConstrainSelectedInstOperands,
     /*  25143 */     // GIR_Coverage, 23695,
     /*  25143 */     GIR_EraseRootFromParent_Done,
     /*  25144 */   // Label 657: @25144
     /*  25144 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(25167), // Rule ID 4418 //
     /*  25149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  25152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  25160 */     // (and:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KANDQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  25160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KANDQkk),
     /*  25165 */     GIR_RootConstrainSelectedInstOperands,
     /*  25166 */     // GIR_Coverage, 4418,
     /*  25166 */     GIR_Done,
     /*  25167 */   // Label 658: @25167
     /*  25167 */   GIM_Reject,
     /*  25168 */ // Label 655: @25168
     /*  25168 */ GIM_Reject,
     /*  25169 */ // Label 469: @25169
     /*  25169 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(25324),
     /*  25174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  25177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  25180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25184 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(25242), // Rule ID 25444 //
     /*  25189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25217 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25224 */     // (and:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25229 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25240 */     GIR_RootConstrainSelectedInstOperands,
     /*  25241 */     // GIR_Coverage, 25444,
     /*  25241 */     GIR_EraseRootFromParent_Done,
     /*  25242 */   // Label 660: @25242
     /*  25242 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(25300), // Rule ID 20056 //
     /*  25247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  25269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25282 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPANDQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPANDQZrm),
     /*  25285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25298 */     GIR_RootConstrainSelectedInstOperands,
     /*  25299 */     // GIR_Coverage, 20056,
     /*  25299 */     GIR_EraseRootFromParent_Done,
     /*  25300 */   // Label 661: @25300
     /*  25300 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(25323), // Rule ID 20048 //
     /*  25305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  25308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  25316 */     // (and:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPANDQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  25316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPANDQZrr),
     /*  25321 */     GIR_RootConstrainSelectedInstOperands,
     /*  25322 */     // GIR_Coverage, 20048,
     /*  25322 */     GIR_Done,
     /*  25323 */   // Label 662: @25323
     /*  25323 */   GIM_Reject,
     /*  25324 */ // Label 659: @25324
     /*  25324 */ GIM_Reject,
     /*  25325 */ // Label 470: @25325
     /*  25325 */ GIM_Reject,
     /*  25326 */ // Label 4: @25326
     /*  25326 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 686*/ GIMT_Encode4(33729),
     /*  25337 */ /*GILLT_s1*//*Label 663*/ GIMT_Encode4(25437),
     /*  25341 */ /*GILLT_s8*//*Label 664*/ GIMT_Encode4(25537),
     /*  25345 */ /*GILLT_s16*//*Label 665*/ GIMT_Encode4(25930),
     /*  25349 */ /*GILLT_s32*//*Label 666*/ GIMT_Encode4(26527),
     /*  25353 */ /*GILLT_s64*//*Label 667*/ GIMT_Encode4(27983), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  25365 */ /*GILLT_v2s1*//*Label 668*/ GIMT_Encode4(29447),
     /*  25369 */ /*GILLT_v2s64*//*Label 669*/ GIMT_Encode4(29547),
     /*  25373 */ /*GILLT_v4s1*//*Label 670*/ GIMT_Encode4(29889),
     /*  25377 */ /*GILLT_v4s32*//*Label 671*/ GIMT_Encode4(29989),
     /*  25381 */ /*GILLT_v4s64*//*Label 672*/ GIMT_Encode4(30331),
     /*  25385 */ /*GILLT_v8s1*//*Label 673*/ GIMT_Encode4(30797),
     /*  25389 */ /*GILLT_v8s16*//*Label 674*/ GIMT_Encode4(30921),
     /*  25393 */ /*GILLT_v8s32*//*Label 675*/ GIMT_Encode4(31263),
     /*  25397 */ /*GILLT_v8s64*//*Label 676*/ GIMT_Encode4(31729),
     /*  25401 */ /*GILLT_v16s1*//*Label 677*/ GIMT_Encode4(31885),
     /*  25405 */ /*GILLT_v16s8*//*Label 678*/ GIMT_Encode4(31919),
     /*  25409 */ /*GILLT_v16s16*//*Label 679*/ GIMT_Encode4(32261),
     /*  25413 */ /*GILLT_v16s32*//*Label 680*/ GIMT_Encode4(32727),
     /*  25417 */ /*GILLT_v32s1*//*Label 681*/ GIMT_Encode4(32883),
     /*  25421 */ /*GILLT_v32s8*//*Label 682*/ GIMT_Encode4(32917),
     /*  25425 */ /*GILLT_v32s16*//*Label 683*/ GIMT_Encode4(33383),
     /*  25429 */ /*GILLT_v64s1*//*Label 684*/ GIMT_Encode4(33539),
     /*  25433 */ /*GILLT_v64s8*//*Label 685*/ GIMT_Encode4(33573),
     /*  25437 */ // Label 663: @25437
     /*  25437 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(25536), // Rule ID 19492 //
     /*  25442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  25445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  25448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  25460 */   // (or:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  25460 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  25463 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25467 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25472 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  25476 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25481 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  25484 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25488 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25493 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  25497 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  25502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  25505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  25509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25514 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25517 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  25535 */   // GIR_Coverage, 19492,
     /*  25535 */   GIR_EraseRootFromParent_Done,
     /*  25536 */ // Label 687: @25536
     /*  25536 */ GIM_Reject,
     /*  25537 */ // Label 664: @25537
     /*  25537 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(25929),
     /*  25542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  25545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  25548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25552 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(25613), // Rule ID 26061 //
     /*  25557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25575 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25592 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25611 */     GIR_RootConstrainSelectedInstOperands,
     /*  25612 */     // GIR_Coverage, 26061,
     /*  25612 */     GIR_EraseRootFromParent_Done,
     /*  25613 */   // Label 689: @25613
     /*  25613 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(25674), // Rule ID 26080 //
     /*  25618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25632 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25636 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25653 */     // (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25672 */     GIR_RootConstrainSelectedInstOperands,
     /*  25673 */     // GIR_Coverage, 26080,
     /*  25673 */     GIR_EraseRootFromParent_Done,
     /*  25674 */   // Label 690: @25674
     /*  25674 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(25735), // Rule ID 22830 //
     /*  25679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25694 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25701 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25707 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25714 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm),
     /*  25717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25733 */     GIR_RootConstrainSelectedInstOperands,
     /*  25734 */     // GIR_Coverage, 22830,
     /*  25734 */     GIR_EraseRootFromParent_Done,
     /*  25735 */   // Label 691: @25735
     /*  25735 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(25796), // Rule ID 22920 //
     /*  25740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25755 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25758 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25762 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  25766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25768 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25775 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (OR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8rm_ND),
     /*  25778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25780 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  25794 */     GIR_RootConstrainSelectedInstOperands,
     /*  25795 */     // GIR_Coverage, 22920,
     /*  25795 */     GIR_EraseRootFromParent_Done,
     /*  25796 */   // Label 692: @25796
     /*  25796 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(25833), // Rule ID 22834 //
     /*  25801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25816 */     // MIs[1] Operand 1
     /*  25816 */     // No operand predicates
     /*  25816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25818 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri),
     /*  25821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25831 */     GIR_RootConstrainSelectedInstOperands,
     /*  25832 */     // GIR_Coverage, 22834,
     /*  25832 */     GIR_EraseRootFromParent_Done,
     /*  25833 */   // Label 693: @25833
     /*  25833 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(25870), // Rule ID 22924 //
     /*  25838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25853 */     // MIs[1] Operand 1
     /*  25853 */     // No operand predicates
     /*  25853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25855 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (OR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  25855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8ri_ND),
     /*  25858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  25862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  25865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25868 */     GIR_RootConstrainSelectedInstOperands,
     /*  25869 */     // GIR_Coverage, 22924,
     /*  25869 */     GIR_EraseRootFromParent_Done,
     /*  25870 */   // Label 694: @25870
     /*  25870 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(25899), // Rule ID 22826 //
     /*  25875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25886 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr),
     /*  25891 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25897 */     GIR_RootConstrainSelectedInstOperands,
     /*  25898 */     // GIR_Coverage, 22826,
     /*  25898 */     GIR_Done,
     /*  25899 */   // Label 695: @25899
     /*  25899 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(25928), // Rule ID 22916 //
     /*  25904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  25907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  25915 */     // (or:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (OR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  25915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR8rr_ND),
     /*  25920 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  25926 */     GIR_RootConstrainSelectedInstOperands,
     /*  25927 */     // GIR_Coverage, 22916,
     /*  25927 */     GIR_Done,
     /*  25928 */   // Label 696: @25928
     /*  25928 */   GIM_Reject,
     /*  25929 */ // Label 688: @25929
     /*  25929 */ GIM_Reject,
     /*  25930 */ // Label 665: @25930
     /*  25930 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(26526),
     /*  25935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  25938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  25941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25945 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(26006), // Rule ID 26062 //
     /*  25950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  25953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  25961 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  25964 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  25968 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  25972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  25976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  25985 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  25985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  25988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25990 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  25992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  25996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  25999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26004 */     GIR_RootConstrainSelectedInstOperands,
     /*  26005 */     // GIR_Coverage, 26062,
     /*  26005 */     GIR_EraseRootFromParent_Done,
     /*  26006 */   // Label 698: @26006
     /*  26006 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(26067), // Rule ID 26081 //
     /*  26011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26029 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26046 */     // (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26053 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26065 */     GIR_RootConstrainSelectedInstOperands,
     /*  26066 */     // GIR_Coverage, 26081,
     /*  26066 */     GIR_EraseRootFromParent_Done,
     /*  26067 */   // Label 699: @26067
     /*  26067 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(26128), // Rule ID 22831 //
     /*  26072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26090 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26094 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26107 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm),
     /*  26110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26126 */     GIR_RootConstrainSelectedInstOperands,
     /*  26127 */     // GIR_Coverage, 22831,
     /*  26127 */     GIR_EraseRootFromParent_Done,
     /*  26128 */   // Label 700: @26128
     /*  26128 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(26189), // Rule ID 22921 //
     /*  26133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26151 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26155 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  26159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26168 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (OR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16rm_ND),
     /*  26171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26187 */     GIR_RootConstrainSelectedInstOperands,
     /*  26188 */     // GIR_Coverage, 22921,
     /*  26188 */     GIR_EraseRootFromParent_Done,
     /*  26189 */   // Label 701: @26189
     /*  26189 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(26291), // Rule ID 26037 //
     /*  26194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26210 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26225 */     // (or:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26251 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26281 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26289 */     GIR_RootConstrainSelectedInstOperands,
     /*  26290 */     // GIR_Coverage, 26037,
     /*  26290 */     GIR_EraseRootFromParent_Done,
     /*  26291 */   // Label 702: @26291
     /*  26291 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(26393), // Rule ID 22775 //
     /*  26296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  26308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  26312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  26316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  26320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  26325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26327 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTS16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  26327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  26330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  26341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  26344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  26348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  26360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  26363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  26368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  26373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  26378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS16rr),
     /*  26381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26391 */     GIR_RootConstrainSelectedInstOperands,
     /*  26392 */     // GIR_Coverage, 22775,
     /*  26392 */     GIR_EraseRootFromParent_Done,
     /*  26393 */   // Label 703: @26393
     /*  26393 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(26430), // Rule ID 22835 //
     /*  26398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26413 */     // MIs[1] Operand 1
     /*  26413 */     // No operand predicates
     /*  26413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26415 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri),
     /*  26418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26428 */     GIR_RootConstrainSelectedInstOperands,
     /*  26429 */     // GIR_Coverage, 22835,
     /*  26429 */     GIR_EraseRootFromParent_Done,
     /*  26430 */   // Label 704: @26430
     /*  26430 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(26467), // Rule ID 22925 //
     /*  26435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26450 */     // MIs[1] Operand 1
     /*  26450 */     // No operand predicates
     /*  26450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26452 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (OR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  26452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16ri_ND),
     /*  26455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  26462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26465 */     GIR_RootConstrainSelectedInstOperands,
     /*  26466 */     // GIR_Coverage, 22925,
     /*  26466 */     GIR_EraseRootFromParent_Done,
     /*  26467 */   // Label 705: @26467
     /*  26467 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(26496), // Rule ID 22827 //
     /*  26472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26483 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr),
     /*  26488 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26494 */     GIR_RootConstrainSelectedInstOperands,
     /*  26495 */     // GIR_Coverage, 22827,
     /*  26495 */     GIR_Done,
     /*  26496 */   // Label 706: @26496
     /*  26496 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(26525), // Rule ID 22917 //
     /*  26501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  26512 */     // (or:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (OR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  26512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR16rr_ND),
     /*  26517 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  26523 */     GIR_RootConstrainSelectedInstOperands,
     /*  26524 */     // GIR_Coverage, 22917,
     /*  26524 */     GIR_Done,
     /*  26525 */   // Label 707: @26525
     /*  26525 */   GIM_Reject,
     /*  26526 */ // Label 697: @26526
     /*  26526 */ GIM_Reject,
     /*  26527 */ // Label 666: @26527
     /*  26527 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(27982),
     /*  26532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26535 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(26603), // Rule ID 26063 //
     /*  26540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26565 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26582 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26587 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26601 */     GIR_RootConstrainSelectedInstOperands,
     /*  26602 */     // GIR_Coverage, 26063,
     /*  26602 */     GIR_EraseRootFromParent_Done,
     /*  26603 */   // Label 709: @26603
     /*  26603 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(26671), // Rule ID 26082 //
     /*  26608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26626 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26629 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26633 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26650 */     // (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26655 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  26657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26669 */     GIR_RootConstrainSelectedInstOperands,
     /*  26670 */     // GIR_Coverage, 26082,
     /*  26670 */     GIR_EraseRootFromParent_Done,
     /*  26671 */   // Label 710: @26671
     /*  26671 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(26739), // Rule ID 22832 //
     /*  26676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  26679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26698 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26701 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26705 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26718 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm),
     /*  26721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26732 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26737 */     GIR_RootConstrainSelectedInstOperands,
     /*  26738 */     // GIR_Coverage, 22832,
     /*  26738 */     GIR_EraseRootFromParent_Done,
     /*  26739 */   // Label 711: @26739
     /*  26739 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(26807), // Rule ID 22922 //
     /*  26744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  26747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  26766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  26769 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  26773 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  26777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  26779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  26786 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (OR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  26786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32rm_ND),
     /*  26789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  26793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  26797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  26805 */     GIR_RootConstrainSelectedInstOperands,
     /*  26806 */     // GIR_Coverage, 22922,
     /*  26806 */     GIR_EraseRootFromParent_Done,
     /*  26807 */   // Label 712: @26807
     /*  26807 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(26884), // Rule ID 25003 //
     /*  26812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26843 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  26847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26855 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26859 */     // MIs[2] src
     /*  26859 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26864 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26870 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  26873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26882 */     GIR_RootConstrainSelectedInstOperands,
     /*  26883 */     // GIR_Coverage, 25003,
     /*  26883 */     GIR_EraseRootFromParent_Done,
     /*  26884 */   // Label 713: @26884
     /*  26884 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(26961), // Rule ID 25005 //
     /*  26889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  26895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  26924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26932 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  26936 */     // MIs[2] src
     /*  26936 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  26941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  26945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26947 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  26947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  26950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  26956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  26959 */     GIR_RootConstrainSelectedInstOperands,
     /*  26960 */     // GIR_Coverage, 25005,
     /*  26960 */     GIR_EraseRootFromParent_Done,
     /*  26961 */   // Label 714: @26961
     /*  26961 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(27039), // Rule ID 24991 //
     /*  26966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  26969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  26973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  26985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  26989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  26997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  27001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27010 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27018 */     // MIs[0] src
     /*  27018 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  27023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27025 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  27034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27037 */     GIR_RootConstrainSelectedInstOperands,
     /*  27038 */     // GIR_Coverage, 24991,
     /*  27038 */     GIR_EraseRootFromParent_Done,
     /*  27039 */   // Label 715: @27039
     /*  27039 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(27116), // Rule ID 17364 //
     /*  27044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27075 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27087 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27091 */     // MIs[2] src
     /*  27091 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  27100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27102 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSIC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC32rr),
     /*  27105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27111 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27114 */     GIR_RootConstrainSelectedInstOperands,
     /*  27115 */     // GIR_Coverage, 17364,
     /*  27115 */     GIR_EraseRootFromParent_Done,
     /*  27116 */   // Label 716: @27116
     /*  27116 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(27193), // Rule ID 17366 //
     /*  27121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27152 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27168 */     // MIs[2] src
     /*  27168 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27173 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27177 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27179 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (T1MSKC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC32rr),
     /*  27182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27191 */     GIR_RootConstrainSelectedInstOperands,
     /*  27192 */     // GIR_Coverage, 17366,
     /*  27192 */     GIR_EraseRootFromParent_Done,
     /*  27193 */   // Label 717: @27193
     /*  27193 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(27267), // Rule ID 17352 //
     /*  27198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  27240 */     // MIs[2] src
     /*  27240 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27245 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  27249 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27255 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), -1:{ *:[i32] }))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27265 */     GIR_RootConstrainSelectedInstOperands,
     /*  27266 */     // GIR_Coverage, 17352,
     /*  27266 */     GIR_EraseRootFromParent_Done,
     /*  27267 */   // Label 718: @27267
     /*  27267 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(27325), // Rule ID 24999 //
     /*  27272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27300 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27304 */     // MIs[0] src
     /*  27304 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27311 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27323 */     GIR_RootConstrainSelectedInstOperands,
     /*  27324 */     // GIR_Coverage, 24999,
     /*  27324 */     GIR_EraseRootFromParent_Done,
     /*  27325 */   // Label 719: @27325
     /*  27325 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(27383), // Rule ID 25001 //
     /*  27330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27358 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27362 */     // MIs[0] src
     /*  27362 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  27367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27369 */     // (or:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  27378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27381 */     GIR_RootConstrainSelectedInstOperands,
     /*  27382 */     // GIR_Coverage, 25001,
     /*  27382 */     GIR_EraseRootFromParent_Done,
     /*  27383 */   // Label 720: @27383
     /*  27383 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(27492), // Rule ID 26043 //
     /*  27388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27411 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27426 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27426 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27429 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27433 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27452 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27459 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27482 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  27484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27490 */     GIR_RootConstrainSelectedInstOperands,
     /*  27491 */     // GIR_Coverage, 26043,
     /*  27491 */     GIR_EraseRootFromParent_Done,
     /*  27492 */   // Label 721: @27492
     /*  27492 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(27550), // Rule ID 24993 //
     /*  27497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27520 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27529 */     // MIs[0] src
     /*  27529 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  27534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27536 */     // (or:{ *:[i32] } (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src), GR32:{ *:[i32] }:$src)  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  27545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27548 */     GIR_RootConstrainSelectedInstOperands,
     /*  27549 */     // GIR_Coverage, 24993,
     /*  27549 */     GIR_EraseRootFromParent_Done,
     /*  27550 */   // Label 722: @27550
     /*  27550 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(27604), // Rule ID 17360 //
     /*  27555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27581 */     // MIs[1] src
     /*  27581 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27586 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  27590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27592 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS32rr),
     /*  27595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27602 */     GIR_RootConstrainSelectedInstOperands,
     /*  27603 */     // GIR_Coverage, 17360,
     /*  27603 */     GIR_EraseRootFromParent_Done,
     /*  27604 */   // Label 723: @27604
     /*  27604 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(27658), // Rule ID 17362 //
     /*  27609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  27631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  27635 */     // MIs[1] src
     /*  27635 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27640 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  27644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27646 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, -1:{ *:[i32] }))  =>  (BLSFILL32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL32rr),
     /*  27649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27651 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27656 */     GIR_RootConstrainSelectedInstOperands,
     /*  27657 */     // GIR_Coverage, 17362,
     /*  27657 */     GIR_EraseRootFromParent_Done,
     /*  27658 */   // Label 724: @27658
     /*  27658 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(27767), // Rule ID 22781 //
     /*  27663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  27682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  27690 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  27694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  27699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27701 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTS32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  27701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  27704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  27708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  27715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  27718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  27722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  27727 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  27730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  27734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  27737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  27747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  27752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS32rr),
     /*  27755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  27762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27765 */     GIR_RootConstrainSelectedInstOperands,
     /*  27766 */     // GIR_Coverage, 22781,
     /*  27766 */     GIR_EraseRootFromParent_Done,
     /*  27767 */   // Label 725: @27767
     /*  27767 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(27821), // Rule ID 17354 //
     /*  27772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  27775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  27794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  27798 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  27802 */     // MIs[1] src
     /*  27802 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  27807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27809 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (sub:{ *:[i32] } -2:{ *:[i32] }, GR32:{ *:[i32] }:$src))  =>  (BLCI32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  27809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI32rr),
     /*  27812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27819 */     GIR_RootConstrainSelectedInstOperands,
     /*  27820 */     // GIR_Coverage, 17354,
     /*  27820 */     GIR_EraseRootFromParent_Done,
     /*  27821 */   // Label 726: @27821
     /*  27821 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(27865), // Rule ID 22836 //
     /*  27826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27848 */     // MIs[1] Operand 1
     /*  27848 */     // No operand predicates
     /*  27848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27850 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri),
     /*  27853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27855 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27860 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27863 */     GIR_RootConstrainSelectedInstOperands,
     /*  27864 */     // GIR_Coverage, 22836,
     /*  27864 */     GIR_EraseRootFromParent_Done,
     /*  27865 */   // Label 727: @27865
     /*  27865 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(27909), // Rule ID 22926 //
     /*  27870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27892 */     // MIs[1] Operand 1
     /*  27892 */     // No operand predicates
     /*  27892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27894 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (OR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  27894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32ri_ND),
     /*  27897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  27901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  27904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  27907 */     GIR_RootConstrainSelectedInstOperands,
     /*  27908 */     // GIR_Coverage, 22926,
     /*  27908 */     GIR_EraseRootFromParent_Done,
     /*  27909 */   // Label 728: @27909
     /*  27909 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(27945), // Rule ID 22828 //
     /*  27914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27932 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr),
     /*  27937 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27943 */     GIR_RootConstrainSelectedInstOperands,
     /*  27944 */     // GIR_Coverage, 22828,
     /*  27944 */     GIR_Done,
     /*  27945 */   // Label 729: @27945
     /*  27945 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(27981), // Rule ID 22918 //
     /*  27950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  27953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  27956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  27968 */     // (or:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (OR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  27968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR32rr_ND),
     /*  27973 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  27979 */     GIR_RootConstrainSelectedInstOperands,
     /*  27980 */     // GIR_Coverage, 22918,
     /*  27980 */     GIR_Done,
     /*  27981 */   // Label 730: @27981
     /*  27981 */   GIM_Reject,
     /*  27982 */ // Label 708: @27982
     /*  27982 */ GIM_Reject,
     /*  27983 */ // Label 667: @27983
     /*  27983 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(29446),
     /*  27988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27991 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(28059), // Rule ID 26064 //
     /*  27996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  27999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28038 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28057 */     GIR_RootConstrainSelectedInstOperands,
     /*  28058 */     // GIR_Coverage, 26064,
     /*  28058 */     GIR_EraseRootFromParent_Done,
     /*  28059 */   // Label 732: @28059
     /*  28059 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(28127), // Rule ID 26083 //
     /*  28064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28106 */     // (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28125 */     GIR_RootConstrainSelectedInstOperands,
     /*  28126 */     // GIR_Coverage, 26083,
     /*  28126 */     GIR_EraseRootFromParent_Done,
     /*  28127 */   // Label 733: @28127
     /*  28127 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(28195), // Rule ID 22833 //
     /*  28132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  28135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28157 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28161 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28167 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28174 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm),
     /*  28177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28179 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28181 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28193 */     GIR_RootConstrainSelectedInstOperands,
     /*  28194 */     // GIR_Coverage, 22833,
     /*  28194 */     GIR_EraseRootFromParent_Done,
     /*  28195 */   // Label 734: @28195
     /*  28195 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(28263), // Rule ID 22923 //
     /*  28200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  28203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  28222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  28225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  28229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  28233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  28242 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (OR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  28242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64rm_ND),
     /*  28245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  28249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  28253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  28261 */     GIR_RootConstrainSelectedInstOperands,
     /*  28262 */     // GIR_Coverage, 22923,
     /*  28262 */     GIR_EraseRootFromParent_Done,
     /*  28263 */   // Label 735: @28263
     /*  28263 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(28340), // Rule ID 25004 //
     /*  28268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28299 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28315 */     // MIs[2] src
     /*  28315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28320 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28324 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28326 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28338 */     GIR_RootConstrainSelectedInstOperands,
     /*  28339 */     // GIR_Coverage, 25004,
     /*  28339 */     GIR_EraseRootFromParent_Done,
     /*  28340 */   // Label 736: @28340
     /*  28340 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(28417), // Rule ID 25006 //
     /*  28345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28376 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28392 */     // MIs[2] src
     /*  28392 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28397 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28403 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28415 */     GIR_RootConstrainSelectedInstOperands,
     /*  28416 */     // GIR_Coverage, 25006,
     /*  28416 */     GIR_EraseRootFromParent_Done,
     /*  28417 */   // Label 737: @28417
     /*  28417 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(28495), // Rule ID 24992 //
     /*  28422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28441 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  28457 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28474 */     // MIs[0] src
     /*  28474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  28479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28481 */     // (or:{ *:[i64] } (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src
     /*  28490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28493 */     GIR_RootConstrainSelectedInstOperands,
     /*  28494 */     // GIR_Coverage, 24992,
     /*  28494 */     GIR_EraseRootFromParent_Done,
     /*  28495 */   // Label 738: @28495
     /*  28495 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(28572), // Rule ID 17365 //
     /*  28500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28531 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28547 */     // MIs[2] src
     /*  28547 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28552 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, uint8_t(-1),
     /*  28556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28558 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSIC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSIC64rr),
     /*  28561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28570 */     GIR_RootConstrainSelectedInstOperands,
     /*  28571 */     // GIR_Coverage, 17365,
     /*  28571 */     GIR_EraseRootFromParent_Done,
     /*  28572 */   // Label 739: @28572
     /*  28572 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(28649), // Rule ID 17367 //
     /*  28577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28608 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  28616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28624 */     // MIs[2] src
     /*  28624 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28629 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28635 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (T1MSKC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::T1MSKC64rr),
     /*  28638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28647 */     GIR_RootConstrainSelectedInstOperands,
     /*  28648 */     // GIR_Coverage, 17367,
     /*  28648 */     GIR_EraseRootFromParent_Done,
     /*  28649 */   // Label 740: @28649
     /*  28649 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(28723), // Rule ID 17353 //
     /*  28654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28696 */     // MIs[2] src
     /*  28696 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  28701 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*  28705 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28711 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), -1:{ *:[i64] }))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28716 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28721 */     GIR_RootConstrainSelectedInstOperands,
     /*  28722 */     // GIR_Coverage, 17353,
     /*  28722 */     GIR_EraseRootFromParent_Done,
     /*  28723 */   // Label 741: @28723
     /*  28723 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(28781), // Rule ID 25000 //
     /*  28728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28756 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  28760 */     // MIs[0] src
     /*  28760 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28767 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  28770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28779 */     GIR_RootConstrainSelectedInstOperands,
     /*  28780 */     // GIR_Coverage, 25000,
     /*  28780 */     GIR_EraseRootFromParent_Done,
     /*  28781 */   // Label 742: @28781
     /*  28781 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(28839), // Rule ID 25002 //
     /*  28786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  28801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28814 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  28818 */     // MIs[0] src
     /*  28818 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  28823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28825 */     // (or:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  28828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  28834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28837 */     GIR_RootConstrainSelectedInstOperands,
     /*  28838 */     // GIR_Coverage, 25002,
     /*  28838 */     GIR_EraseRootFromParent_Done,
     /*  28839 */   // Label 743: @28839
     /*  28839 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(28948), // Rule ID 26049 //
     /*  28844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  28847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  28859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  28867 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  28871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  28876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28882 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  28882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  28885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  28889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  28896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  28899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  28903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  28908 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  28911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  28915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  28918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  28928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  28933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  28936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  28940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  28943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 26049,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 744: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(29006), // Rule ID 24994 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  28968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  28972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  28976 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  28980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  28985 */     // MIs[0] src
     /*  28985 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  28990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28992 */     // (or:{ *:[i64] } (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src), GR64:{ *:[i64] }:$src)  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  28992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  28995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  29001 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29004 */     GIR_RootConstrainSelectedInstOperands,
     /*  29005 */     // GIR_Coverage, 24994,
     /*  29005 */     GIR_EraseRootFromParent_Done,
     /*  29006 */   // Label 745: @29006
     /*  29006 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(29060), // Rule ID 17361 //
     /*  29011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29037 */     // MIs[1] src
     /*  29037 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29042 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  29046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29048 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCS64rr),
     /*  29051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29058 */     GIR_RootConstrainSelectedInstOperands,
     /*  29059 */     // GIR_Coverage, 17361,
     /*  29059 */     GIR_EraseRootFromParent_Done,
     /*  29060 */   // Label 746: @29060
     /*  29060 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(29114), // Rule ID 17363 //
     /*  29065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  29087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  29091 */     // MIs[1] src
     /*  29091 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  29100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29102 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, -1:{ *:[i64] }))  =>  (BLSFILL64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLSFILL64rr),
     /*  29105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29107 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29112 */     GIR_RootConstrainSelectedInstOperands,
     /*  29113 */     // GIR_Coverage, 17363,
     /*  29113 */     GIR_EraseRootFromParent_Done,
     /*  29114 */   // Label 747: @29114
     /*  29114 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(29223), // Rule ID 22787 //
     /*  29119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  29138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  29146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  29150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  29155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29157 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTS64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  29157 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  29160 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29164 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  29171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  29174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  29178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  29190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  29193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  29203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  29208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTS64rr),
     /*  29211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29221 */     GIR_RootConstrainSelectedInstOperands,
     /*  29222 */     // GIR_Coverage, 22787,
     /*  29222 */     GIR_EraseRootFromParent_Done,
     /*  29223 */   // Label 748: @29223
     /*  29223 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(29277), // Rule ID 17355 //
     /*  29228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  29231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  29250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  29254 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  29258 */     // MIs[1] src
     /*  29258 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  29263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29265 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (sub:{ *:[i64] } -2:{ *:[i64] }, GR64:{ *:[i64] }:$src))  =>  (BLCI64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  29265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCI64rr),
     /*  29268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29275 */     GIR_RootConstrainSelectedInstOperands,
     /*  29276 */     // GIR_Coverage, 17355,
     /*  29276 */     GIR_EraseRootFromParent_Done,
     /*  29277 */   // Label 749: @29277
     /*  29277 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(29325), // Rule ID 22837 //
     /*  29282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29304 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29308 */     // MIs[1] Operand 1
     /*  29308 */     // No operand predicates
     /*  29308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29310 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32),
     /*  29313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29323 */     GIR_RootConstrainSelectedInstOperands,
     /*  29324 */     // GIR_Coverage, 22837,
     /*  29324 */     GIR_EraseRootFromParent_Done,
     /*  29325 */   // Label 750: @29325
     /*  29325 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(29373), // Rule ID 22927 //
     /*  29330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  29356 */     // MIs[1] Operand 1
     /*  29356 */     // No operand predicates
     /*  29356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29358 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (OR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  29358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64ri32_ND),
     /*  29361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29363 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  29368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  29371 */     GIR_RootConstrainSelectedInstOperands,
     /*  29372 */     // GIR_Coverage, 22927,
     /*  29372 */     GIR_EraseRootFromParent_Done,
     /*  29373 */   // Label 751: @29373
     /*  29373 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(29409), // Rule ID 22829 //
     /*  29378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  29381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29396 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr),
     /*  29401 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29407 */     GIR_RootConstrainSelectedInstOperands,
     /*  29408 */     // GIR_Coverage, 22829,
     /*  29408 */     GIR_Done,
     /*  29409 */   // Label 752: @29409
     /*  29409 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(29445), // Rule ID 22919 //
     /*  29414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  29417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  29420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  29432 */     // (or:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (OR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  29432 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::OR64rr_ND),
     /*  29437 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  29443 */     GIR_RootConstrainSelectedInstOperands,
     /*  29444 */     // GIR_Coverage, 22919,
     /*  29444 */     GIR_Done,
     /*  29445 */   // Label 753: @29445
     /*  29445 */   GIM_Reject,
     /*  29446 */ // Label 731: @29446
     /*  29446 */ GIM_Reject,
     /*  29447 */ // Label 668: @29447
     /*  29447 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(29546), // Rule ID 19493 //
     /*  29452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  29455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  29458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  29470 */   // (or:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  29470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  29545 */   // GIR_Coverage, 19493,
     /*  29545 */   GIR_EraseRootFromParent_Done,
     /*  29546 */ // Label 754: @29546
     /*  29546 */ GIM_Reject,
     /*  29547 */ // Label 669: @29547
     /*  29547 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(29888),
     /*  29552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  29558 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(29620), // Rule ID 23363 //
     /*  29563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29602 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29607 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29618 */     GIR_RootConstrainSelectedInstOperands,
     /*  29619 */     // GIR_Coverage, 23363,
     /*  29619 */     GIR_EraseRootFromParent_Done,
     /*  29620 */   // Label 756: @29620
     /*  29620 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(29682), // Rule ID 24185 //
     /*  29625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29640 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29643 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29664 */     // (or:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  29671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29680 */     GIR_RootConstrainSelectedInstOperands,
     /*  29681 */     // GIR_Coverage, 24185,
     /*  29681 */     GIR_EraseRootFromParent_Done,
     /*  29682 */   // Label 757: @29682
     /*  29682 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(29744), // Rule ID 2117 //
     /*  29687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29726 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  29729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29742 */     GIR_RootConstrainSelectedInstOperands,
     /*  29743 */     // GIR_Coverage, 2117,
     /*  29743 */     GIR_EraseRootFromParent_Done,
     /*  29744 */   // Label 758: @29744
     /*  29744 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(29806), // Rule ID 5761 //
     /*  29749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  29768 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  29771 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  29775 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  29779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29781 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  29788 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  29788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  29791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29793 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  29795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  29799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  29804 */     GIR_RootConstrainSelectedInstOperands,
     /*  29805 */     // GIR_Coverage, 5761,
     /*  29805 */     GIR_EraseRootFromParent_Done,
     /*  29806 */   // Label 759: @29806
     /*  29806 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(29833), // Rule ID 2116 //
     /*  29811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  29814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29826 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  29831 */     GIR_RootConstrainSelectedInstOperands,
     /*  29832 */     // GIR_Coverage, 2116,
     /*  29832 */     GIR_Done,
     /*  29833 */   // Label 760: @29833
     /*  29833 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(29860), // Rule ID 2118 //
     /*  29838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  29841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  29853 */     // (or:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  29853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  29858 */     GIR_RootConstrainSelectedInstOperands,
     /*  29859 */     // GIR_Coverage, 2118,
     /*  29859 */     GIR_Done,
     /*  29860 */   // Label 761: @29860
     /*  29860 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(29887), // Rule ID 5758 //
     /*  29865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  29868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  29880 */     // (or:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  29880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  29885 */     GIR_RootConstrainSelectedInstOperands,
     /*  29886 */     // GIR_Coverage, 5758,
     /*  29886 */     GIR_Done,
     /*  29887 */   // Label 762: @29887
     /*  29887 */   GIM_Reject,
     /*  29888 */ // Label 755: @29888
     /*  29888 */ GIM_Reject,
     /*  29889 */ // Label 670: @29889
     /*  29889 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(29988), // Rule ID 19494 //
     /*  29894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  29897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  29900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  29912 */   // (or:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  29912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  29915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  29928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  29936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  29949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  29954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  29957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  29961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  29969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  29972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  29974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  29987 */   // GIR_Coverage, 19494,
     /*  29987 */   GIR_EraseRootFromParent_Done,
     /*  29988 */ // Label 763: @29988
     /*  29988 */ GIM_Reject,
     /*  29989 */ // Label 671: @29989
     /*  29989 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(30330),
     /*  29994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30000 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(30062), // Rule ID 24203 //
     /*  30005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30020 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30023 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30027 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30044 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30060 */     GIR_RootConstrainSelectedInstOperands,
     /*  30061 */     // GIR_Coverage, 24203,
     /*  30061 */     GIR_EraseRootFromParent_Done,
     /*  30062 */   // Label 765: @30062
     /*  30062 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(30124), // Rule ID 25256 //
     /*  30067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30082 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30085 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30089 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30106 */     // (or:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30111 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30122 */     GIR_RootConstrainSelectedInstOperands,
     /*  30123 */     // GIR_Coverage, 25256,
     /*  30123 */     GIR_EraseRootFromParent_Done,
     /*  30124 */   // Label 766: @30124
     /*  30124 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(30186), // Rule ID 5788 //
     /*  30129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30168 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rm),
     /*  30171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30173 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30184 */     GIR_RootConstrainSelectedInstOperands,
     /*  30185 */     // GIR_Coverage, 5788,
     /*  30185 */     GIR_EraseRootFromParent_Done,
     /*  30186 */   // Label 767: @30186
     /*  30186 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(30248), // Rule ID 18163 //
     /*  30191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30230 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30246 */     GIR_RootConstrainSelectedInstOperands,
     /*  30247 */     // GIR_Coverage, 18163,
     /*  30247 */     GIR_EraseRootFromParent_Done,
     /*  30248 */   // Label 768: @30248
     /*  30248 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(30275), // Rule ID 5785 //
     /*  30253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  30268 */     // (or:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  30268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ128rr),
     /*  30273 */     GIR_RootConstrainSelectedInstOperands,
     /*  30274 */     // GIR_Coverage, 5785,
     /*  30274 */     GIR_Done,
     /*  30275 */   // Label 769: @30275
     /*  30275 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(30302), // Rule ID 18151 //
     /*  30280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30295 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  30300 */     GIR_RootConstrainSelectedInstOperands,
     /*  30301 */     // GIR_Coverage, 18151,
     /*  30301 */     GIR_Done,
     /*  30302 */   // Label 770: @30302
     /*  30302 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(30329), // Rule ID 18175 //
     /*  30307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  30310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30322 */     // (or:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  30322 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  30327 */     GIR_RootConstrainSelectedInstOperands,
     /*  30328 */     // GIR_Coverage, 18175,
     /*  30328 */     GIR_Done,
     /*  30329 */   // Label 771: @30329
     /*  30329 */   GIM_Reject,
     /*  30330 */ // Label 764: @30330
     /*  30330 */ GIM_Reject,
     /*  30331 */ // Label 672: @30331
     /*  30331 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(30796),
     /*  30336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  30339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  30342 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(30404), // Rule ID 23365 //
     /*  30347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30362 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30365 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30369 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30379 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30386 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30391 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30397 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30402 */     GIR_RootConstrainSelectedInstOperands,
     /*  30403 */     // GIR_Coverage, 23365,
     /*  30403 */     GIR_EraseRootFromParent_Done,
     /*  30404 */   // Label 773: @30404
     /*  30404 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(30466), // Rule ID 24179 //
     /*  30409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30448 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30464 */     GIR_RootConstrainSelectedInstOperands,
     /*  30465 */     // GIR_Coverage, 24179,
     /*  30465 */     GIR_EraseRootFromParent_Done,
     /*  30466 */   // Label 774: @30466
     /*  30466 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(30528), // Rule ID 25246 //
     /*  30471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30510 */     // (or:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30526 */     GIR_RootConstrainSelectedInstOperands,
     /*  30527 */     // GIR_Coverage, 25246,
     /*  30527 */     GIR_EraseRootFromParent_Done,
     /*  30528 */   // Label 775: @30528
     /*  30528 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(30590), // Rule ID 2121 //
     /*  30533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30552 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30555 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30572 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  30575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30577 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30588 */     GIR_RootConstrainSelectedInstOperands,
     /*  30589 */     // GIR_Coverage, 2121,
     /*  30589 */     GIR_EraseRootFromParent_Done,
     /*  30590 */   // Label 776: @30590
     /*  30590 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(30652), // Rule ID 5752 //
     /*  30595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30614 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30621 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30634 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  30637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30639 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30650 */     GIR_RootConstrainSelectedInstOperands,
     /*  30651 */     // GIR_Coverage, 5752,
     /*  30651 */     GIR_EraseRootFromParent_Done,
     /*  30652 */   // Label 777: @30652
     /*  30652 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(30714), // Rule ID 18137 //
     /*  30657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30696 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  30699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  30703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30712 */     GIR_RootConstrainSelectedInstOperands,
     /*  30713 */     // GIR_Coverage, 18137,
     /*  30713 */     GIR_EraseRootFromParent_Done,
     /*  30714 */   // Label 778: @30714
     /*  30714 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(30741), // Rule ID 2120 //
     /*  30719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  30722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30734 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  30739 */     GIR_RootConstrainSelectedInstOperands,
     /*  30740 */     // GIR_Coverage, 2120,
     /*  30740 */     GIR_Done,
     /*  30741 */   // Label 779: @30741
     /*  30741 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(30768), // Rule ID 5749 //
     /*  30746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  30749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  30761 */     // (or:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  30761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  30766 */     GIR_RootConstrainSelectedInstOperands,
     /*  30767 */     // GIR_Coverage, 5749,
     /*  30767 */     GIR_Done,
     /*  30768 */   // Label 780: @30768
     /*  30768 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(30795), // Rule ID 18121 //
     /*  30773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  30776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  30788 */     // (or:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  30788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  30793 */     GIR_RootConstrainSelectedInstOperands,
     /*  30794 */     // GIR_Coverage, 18121,
     /*  30794 */     GIR_Done,
     /*  30795 */   // Label 781: @30795
     /*  30795 */   GIM_Reject,
     /*  30796 */ // Label 772: @30796
     /*  30796 */ GIM_Reject,
     /*  30797 */ // Label 673: @30797
     /*  30797 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(30920),
     /*  30802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  30805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  30808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  30820 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(30835), // Rule ID 4419 //
     /*  30825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  30828 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  30828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORBkk),
     /*  30833 */     GIR_RootConstrainSelectedInstOperands,
     /*  30834 */     // GIR_Coverage, 4419,
     /*  30834 */     GIR_Done,
     /*  30835 */   // Label 783: @30835
     /*  30835 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(30919), // Rule ID 19491 //
     /*  30840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  30843 */     // (or:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  30843 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  30846 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30850 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30855 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  30859 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30864 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  30867 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30871 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  30880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  30885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  30888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  30892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  30897 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  30900 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  30903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  30905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  30918 */     // GIR_Coverage, 19491,
     /*  30918 */     GIR_EraseRootFromParent_Done,
     /*  30919 */   // Label 784: @30919
     /*  30919 */   GIM_Reject,
     /*  30920 */ // Label 782: @30920
     /*  30920 */ GIM_Reject,
     /*  30921 */ // Label 674: @30921
     /*  30921 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(31262),
     /*  30926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30932 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(30994), // Rule ID 25255 //
     /*  30937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  30940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  30952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  30955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  30959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  30963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  30967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  30976 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  30976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  30979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  30983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  30987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  30992 */     GIR_RootConstrainSelectedInstOperands,
     /*  30993 */     // GIR_Coverage, 25255,
     /*  30993 */     GIR_EraseRootFromParent_Done,
     /*  30994 */   // Label 786: @30994
     /*  30994 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(31056), // Rule ID 25435 //
     /*  30999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31038 */     // (or:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31054 */     GIR_RootConstrainSelectedInstOperands,
     /*  31055 */     // GIR_Coverage, 25435,
     /*  31055 */     GIR_EraseRootFromParent_Done,
     /*  31056 */   // Label 787: @31056
     /*  31056 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(31118), // Rule ID 18162 //
     /*  31061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31100 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31116 */     GIR_RootConstrainSelectedInstOperands,
     /*  31117 */     // GIR_Coverage, 18162,
     /*  31117 */     GIR_EraseRootFromParent_Done,
     /*  31118 */   // Label 788: @31118
     /*  31118 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(31180), // Rule ID 20027 //
     /*  31123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31162 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  31165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31178 */     GIR_RootConstrainSelectedInstOperands,
     /*  31179 */     // GIR_Coverage, 20027,
     /*  31179 */     GIR_EraseRootFromParent_Done,
     /*  31180 */   // Label 789: @31180
     /*  31180 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(31207), // Rule ID 18150 //
     /*  31185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31200 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  31205 */     GIR_RootConstrainSelectedInstOperands,
     /*  31206 */     // GIR_Coverage, 18150,
     /*  31206 */     GIR_Done,
     /*  31207 */   // Label 790: @31207
     /*  31207 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(31234), // Rule ID 18174 //
     /*  31212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  31215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31227 */     // (or:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  31227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  31232 */     GIR_RootConstrainSelectedInstOperands,
     /*  31233 */     // GIR_Coverage, 18174,
     /*  31233 */     GIR_Done,
     /*  31234 */   // Label 791: @31234
     /*  31234 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(31261), // Rule ID 20019 //
     /*  31239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  31242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  31254 */     // (or:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  31254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  31259 */     GIR_RootConstrainSelectedInstOperands,
     /*  31260 */     // GIR_Coverage, 20019,
     /*  31260 */     GIR_Done,
     /*  31261 */   // Label 792: @31261
     /*  31261 */   GIM_Reject,
     /*  31262 */ // Label 785: @31262
     /*  31262 */ GIM_Reject,
     /*  31263 */ // Label 675: @31263
     /*  31263 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(31728),
     /*  31268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  31271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  31274 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(31336), // Rule ID 24197 //
     /*  31279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31318 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31334 */     GIR_RootConstrainSelectedInstOperands,
     /*  31335 */     // GIR_Coverage, 24197,
     /*  31335 */     GIR_EraseRootFromParent_Done,
     /*  31336 */   // Label 794: @31336
     /*  31336 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(31398), // Rule ID 25235 //
     /*  31341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31373 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31380 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31385 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31396 */     GIR_RootConstrainSelectedInstOperands,
     /*  31397 */     // GIR_Coverage, 25235,
     /*  31397 */     GIR_EraseRootFromParent_Done,
     /*  31398 */   // Label 795: @31398
     /*  31398 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(31460), // Rule ID 25245 //
     /*  31403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31418 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31421 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31425 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31442 */     // (or:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31447 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31458 */     GIR_RootConstrainSelectedInstOperands,
     /*  31459 */     // GIR_Coverage, 25245,
     /*  31459 */     GIR_EraseRootFromParent_Done,
     /*  31460 */   // Label 796: @31460
     /*  31460 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(31522), // Rule ID 5779 //
     /*  31465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31484 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31487 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31491 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31497 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31504 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rm),
     /*  31507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31511 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31520 */     GIR_RootConstrainSelectedInstOperands,
     /*  31521 */     // GIR_Coverage, 5779,
     /*  31521 */     GIR_EraseRootFromParent_Done,
     /*  31522 */   // Label 797: @31522
     /*  31522 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(31584), // Rule ID 18107 //
     /*  31527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31566 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  31569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31582 */     GIR_RootConstrainSelectedInstOperands,
     /*  31583 */     // GIR_Coverage, 18107,
     /*  31583 */     GIR_EraseRootFromParent_Done,
     /*  31584 */   // Label 798: @31584
     /*  31584 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(31646), // Rule ID 18136 //
     /*  31589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31628 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  31631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31633 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31644 */     GIR_RootConstrainSelectedInstOperands,
     /*  31645 */     // GIR_Coverage, 18136,
     /*  31645 */     GIR_EraseRootFromParent_Done,
     /*  31646 */   // Label 799: @31646
     /*  31646 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(31673), // Rule ID 5776 //
     /*  31651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  31654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  31666 */     // (or:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  31666 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZ256rr),
     /*  31671 */     GIR_RootConstrainSelectedInstOperands,
     /*  31672 */     // GIR_Coverage, 5776,
     /*  31672 */     GIR_Done,
     /*  31673 */   // Label 800: @31673
     /*  31673 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(31700), // Rule ID 18095 //
     /*  31678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  31681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31693 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  31698 */     GIR_RootConstrainSelectedInstOperands,
     /*  31699 */     // GIR_Coverage, 18095,
     /*  31699 */     GIR_Done,
     /*  31700 */   // Label 801: @31700
     /*  31700 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(31727), // Rule ID 18120 //
     /*  31705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  31708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  31720 */     // (or:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  31720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  31725 */     GIR_RootConstrainSelectedInstOperands,
     /*  31726 */     // GIR_Coverage, 18120,
     /*  31726 */     GIR_Done,
     /*  31727 */   // Label 802: @31727
     /*  31727 */   GIM_Reject,
     /*  31728 */ // Label 793: @31728
     /*  31728 */ GIM_Reject,
     /*  31729 */ // Label 676: @31729
     /*  31729 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(31884),
     /*  31734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  31737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  31740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31744 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(31802), // Rule ID 24173 //
     /*  31749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31760 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31763 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31777 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31784 */     // (or:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31789 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31800 */     GIR_RootConstrainSelectedInstOperands,
     /*  31801 */     // GIR_Coverage, 24173,
     /*  31801 */     GIR_EraseRootFromParent_Done,
     /*  31802 */   // Label 804: @31802
     /*  31802 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(31860), // Rule ID 5743 //
     /*  31807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31822 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31825 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31829 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31835 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31842 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  31845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31847 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  31849 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31853 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31858 */     GIR_RootConstrainSelectedInstOperands,
     /*  31859 */     // GIR_Coverage, 5743,
     /*  31859 */     GIR_EraseRootFromParent_Done,
     /*  31860 */   // Label 805: @31860
     /*  31860 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(31883), // Rule ID 5740 //
     /*  31865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  31876 */     // (or:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  31876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  31881 */     GIR_RootConstrainSelectedInstOperands,
     /*  31882 */     // GIR_Coverage, 5740,
     /*  31882 */     GIR_Done,
     /*  31883 */   // Label 806: @31883
     /*  31883 */   GIM_Reject,
     /*  31884 */ // Label 803: @31884
     /*  31884 */ GIM_Reject,
     /*  31885 */ // Label 677: @31885
     /*  31885 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(31918), // Rule ID 4420 //
     /*  31890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  31893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  31896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  31899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  31911 */   // (or:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  31911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORWkk),
     /*  31916 */   GIR_RootConstrainSelectedInstOperands,
     /*  31917 */   // GIR_Coverage, 4420,
     /*  31917 */   GIR_Done,
     /*  31918 */ // Label 807: @31918
     /*  31918 */ GIM_Reject,
     /*  31919 */ // Label 678: @31919
     /*  31919 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(32260),
     /*  31924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31930 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(31992), // Rule ID 25254 //
     /*  31935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  31938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  31950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  31953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  31957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  31961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  31965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  31974 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  31974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  31977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  31981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  31985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  31990 */     GIR_RootConstrainSelectedInstOperands,
     /*  31991 */     // GIR_Coverage, 25254,
     /*  31991 */     GIR_EraseRootFromParent_Done,
     /*  31992 */   // Label 809: @31992
     /*  31992 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(32054), // Rule ID 25434 //
     /*  31997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32036 */     // (or:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32052 */     GIR_RootConstrainSelectedInstOperands,
     /*  32053 */     // GIR_Coverage, 25434,
     /*  32053 */     GIR_EraseRootFromParent_Done,
     /*  32054 */   // Label 810: @32054
     /*  32054 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(32116), // Rule ID 18161 //
     /*  32059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32098 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORrm),
     /*  32101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32114 */     GIR_RootConstrainSelectedInstOperands,
     /*  32115 */     // GIR_Coverage, 18161,
     /*  32115 */     GIR_EraseRootFromParent_Done,
     /*  32116 */   // Label 811: @32116
     /*  32116 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(32178), // Rule ID 20026 //
     /*  32121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32160 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rm),
     /*  32163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32176 */     GIR_RootConstrainSelectedInstOperands,
     /*  32177 */     // GIR_Coverage, 20026,
     /*  32177 */     GIR_EraseRootFromParent_Done,
     /*  32178 */   // Label 812: @32178
     /*  32178 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(32205), // Rule ID 18149 //
     /*  32183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  32186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32198 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORrr),
     /*  32203 */     GIR_RootConstrainSelectedInstOperands,
     /*  32204 */     // GIR_Coverage, 18149,
     /*  32204 */     GIR_Done,
     /*  32205 */   // Label 813: @32205
     /*  32205 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(32232), // Rule ID 18173 //
     /*  32210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  32213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  32225 */     // (or:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  32225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PORrr),
     /*  32230 */     GIR_RootConstrainSelectedInstOperands,
     /*  32231 */     // GIR_Coverage, 18173,
     /*  32231 */     GIR_Done,
     /*  32232 */   // Label 814: @32232
     /*  32232 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(32259), // Rule ID 20018 //
     /*  32237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  32252 */     // (or:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  32252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ128rr),
     /*  32257 */     GIR_RootConstrainSelectedInstOperands,
     /*  32258 */     // GIR_Coverage, 20018,
     /*  32258 */     GIR_Done,
     /*  32259 */   // Label 815: @32259
     /*  32259 */   GIM_Reject,
     /*  32260 */ // Label 808: @32260
     /*  32260 */ GIM_Reject,
     /*  32261 */ // Label 679: @32261
     /*  32261 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(32726),
     /*  32266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  32269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  32272 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(32334), // Rule ID 25234 //
     /*  32277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32316 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32332 */     GIR_RootConstrainSelectedInstOperands,
     /*  32333 */     // GIR_Coverage, 25234,
     /*  32333 */     GIR_EraseRootFromParent_Done,
     /*  32334 */   // Label 817: @32334
     /*  32334 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(32396), // Rule ID 25244 //
     /*  32339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32378 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32394 */     GIR_RootConstrainSelectedInstOperands,
     /*  32395 */     // GIR_Coverage, 25244,
     /*  32395 */     GIR_EraseRootFromParent_Done,
     /*  32396 */   // Label 818: @32396
     /*  32396 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(32458), // Rule ID 25441 //
     /*  32401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32440 */     // (or:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32456 */     GIR_RootConstrainSelectedInstOperands,
     /*  32457 */     // GIR_Coverage, 25441,
     /*  32457 */     GIR_EraseRootFromParent_Done,
     /*  32458 */   // Label 819: @32458
     /*  32458 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(32520), // Rule ID 18106 //
     /*  32463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32502 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32518 */     GIR_RootConstrainSelectedInstOperands,
     /*  32519 */     // GIR_Coverage, 18106,
     /*  32519 */     GIR_EraseRootFromParent_Done,
     /*  32520 */   // Label 820: @32520
     /*  32520 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(32582), // Rule ID 18135 //
     /*  32525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32564 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  32567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32580 */     GIR_RootConstrainSelectedInstOperands,
     /*  32581 */     // GIR_Coverage, 18135,
     /*  32581 */     GIR_EraseRootFromParent_Done,
     /*  32582 */   // Label 821: @32582
     /*  32582 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(32644), // Rule ID 20043 //
     /*  32587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32626 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  32629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32642 */     GIR_RootConstrainSelectedInstOperands,
     /*  32643 */     // GIR_Coverage, 20043,
     /*  32643 */     GIR_EraseRootFromParent_Done,
     /*  32644 */   // Label 822: @32644
     /*  32644 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(32671), // Rule ID 18094 //
     /*  32649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32664 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  32669 */     GIR_RootConstrainSelectedInstOperands,
     /*  32670 */     // GIR_Coverage, 18094,
     /*  32670 */     GIR_Done,
     /*  32671 */   // Label 823: @32671
     /*  32671 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(32698), // Rule ID 18119 //
     /*  32676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32691 */     // (or:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  32691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  32696 */     GIR_RootConstrainSelectedInstOperands,
     /*  32697 */     // GIR_Coverage, 18119,
     /*  32697 */     GIR_Done,
     /*  32698 */   // Label 824: @32698
     /*  32698 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(32725), // Rule ID 20035 //
     /*  32703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  32706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  32718 */     // (or:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  32718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  32723 */     GIR_RootConstrainSelectedInstOperands,
     /*  32724 */     // GIR_Coverage, 20035,
     /*  32724 */     GIR_Done,
     /*  32725 */   // Label 825: @32725
     /*  32725 */   GIM_Reject,
     /*  32726 */ // Label 816: @32726
     /*  32726 */ GIM_Reject,
     /*  32727 */ // Label 680: @32727
     /*  32727 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(32882),
     /*  32732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  32735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  32738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32742 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(32800), // Rule ID 24191 //
     /*  32747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32782 */     // (or:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32798 */     GIR_RootConstrainSelectedInstOperands,
     /*  32799 */     // GIR_Coverage, 24191,
     /*  32799 */     GIR_EraseRootFromParent_Done,
     /*  32800 */   // Label 827: @32800
     /*  32800 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(32858), // Rule ID 5770 //
     /*  32805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32840 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORDZrm),
     /*  32843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  32847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32856 */     GIR_RootConstrainSelectedInstOperands,
     /*  32857 */     // GIR_Coverage, 5770,
     /*  32857 */     GIR_EraseRootFromParent_Done,
     /*  32858 */   // Label 828: @32858
     /*  32858 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(32881), // Rule ID 5767 //
     /*  32863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  32866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  32874 */     // (or:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  32874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORDZrr),
     /*  32879 */     GIR_RootConstrainSelectedInstOperands,
     /*  32880 */     // GIR_Coverage, 5767,
     /*  32880 */     GIR_Done,
     /*  32881 */   // Label 829: @32881
     /*  32881 */   GIM_Reject,
     /*  32882 */ // Label 826: @32882
     /*  32882 */ GIM_Reject,
     /*  32883 */ // Label 681: @32883
     /*  32883 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(32916), // Rule ID 4421 //
     /*  32888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  32891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  32894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  32897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  32909 */   // (or:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  32909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORDkk),
     /*  32914 */   GIR_RootConstrainSelectedInstOperands,
     /*  32915 */   // GIR_Coverage, 4421,
     /*  32915 */   GIR_Done,
     /*  32916 */ // Label 830: @32916
     /*  32916 */ GIM_Reject,
     /*  32917 */ // Label 682: @32917
     /*  32917 */ GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(33382),
     /*  32922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  32925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  32928 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(32990), // Rule ID 25233 //
     /*  32933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  32936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  32948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  32951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  32955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  32959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  32963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  32972 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  32972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  32975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32977 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  32979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  32983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  32988 */     GIR_RootConstrainSelectedInstOperands,
     /*  32989 */     // GIR_Coverage, 25233,
     /*  32989 */     GIR_EraseRootFromParent_Done,
     /*  32990 */   // Label 832: @32990
     /*  32990 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(33052), // Rule ID 25243 //
     /*  32995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  32998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33034 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33050 */     GIR_RootConstrainSelectedInstOperands,
     /*  33051 */     // GIR_Coverage, 25243,
     /*  33051 */     GIR_EraseRootFromParent_Done,
     /*  33052 */   // Label 833: @33052
     /*  33052 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(33114), // Rule ID 25440 //
     /*  33057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33096 */     // (or:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33101 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33112 */     GIR_RootConstrainSelectedInstOperands,
     /*  33113 */     // GIR_Coverage, 25440,
     /*  33113 */     GIR_EraseRootFromParent_Done,
     /*  33114 */   // Label 834: @33114
     /*  33114 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(33176), // Rule ID 18105 //
     /*  33119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33138 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33141 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33145 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33158 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORYrm),
     /*  33161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33174 */     GIR_RootConstrainSelectedInstOperands,
     /*  33175 */     // GIR_Coverage, 18105,
     /*  33175 */     GIR_EraseRootFromParent_Done,
     /*  33176 */   // Label 835: @33176
     /*  33176 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(33238), // Rule ID 18134 //
     /*  33181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33220 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VORPSYrm),
     /*  33223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33236 */     GIR_RootConstrainSelectedInstOperands,
     /*  33237 */     // GIR_Coverage, 18134,
     /*  33237 */     GIR_EraseRootFromParent_Done,
     /*  33238 */   // Label 836: @33238
     /*  33238 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(33300), // Rule ID 20042 //
     /*  33243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33262 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33265 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33269 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33282 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rm),
     /*  33285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33287 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33298 */     GIR_RootConstrainSelectedInstOperands,
     /*  33299 */     // GIR_Coverage, 20042,
     /*  33299 */     GIR_EraseRootFromParent_Done,
     /*  33300 */   // Label 837: @33300
     /*  33300 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(33327), // Rule ID 18093 //
     /*  33305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  33308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33320 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORYrr),
     /*  33325 */     GIR_RootConstrainSelectedInstOperands,
     /*  33326 */     // GIR_Coverage, 18093,
     /*  33326 */     GIR_Done,
     /*  33327 */   // Label 838: @33327
     /*  33327 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(33354), // Rule ID 18118 //
     /*  33332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  33335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  33347 */     // (or:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  33347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VORPSYrr),
     /*  33352 */     GIR_RootConstrainSelectedInstOperands,
     /*  33353 */     // GIR_Coverage, 18118,
     /*  33353 */     GIR_Done,
     /*  33354 */   // Label 839: @33354
     /*  33354 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(33381), // Rule ID 20034 //
     /*  33359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  33362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  33374 */     // (or:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  33374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZ256rr),
     /*  33379 */     GIR_RootConstrainSelectedInstOperands,
     /*  33380 */     // GIR_Coverage, 20034,
     /*  33380 */     GIR_Done,
     /*  33381 */   // Label 840: @33381
     /*  33381 */   GIM_Reject,
     /*  33382 */ // Label 831: @33382
     /*  33382 */ GIM_Reject,
     /*  33383 */ // Label 683: @33383
     /*  33383 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(33538),
     /*  33388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  33391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  33394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33398 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(33456), // Rule ID 25447 //
     /*  33403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33417 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33438 */     // (or:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33443 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33445 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33454 */     GIR_RootConstrainSelectedInstOperands,
     /*  33455 */     // GIR_Coverage, 25447,
     /*  33455 */     GIR_EraseRootFromParent_Done,
     /*  33456 */   // Label 842: @33456
     /*  33456 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(33514), // Rule ID 20059 //
     /*  33461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33476 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33479 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33483 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33489 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33496 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33501 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33512 */     GIR_RootConstrainSelectedInstOperands,
     /*  33513 */     // GIR_Coverage, 20059,
     /*  33513 */     GIR_EraseRootFromParent_Done,
     /*  33514 */   // Label 843: @33514
     /*  33514 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(33537), // Rule ID 20051 //
     /*  33519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33530 */     // (or:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  33530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33535 */     GIR_RootConstrainSelectedInstOperands,
     /*  33536 */     // GIR_Coverage, 20051,
     /*  33536 */     GIR_Done,
     /*  33537 */   // Label 844: @33537
     /*  33537 */   GIM_Reject,
     /*  33538 */ // Label 841: @33538
     /*  33538 */ GIM_Reject,
     /*  33539 */ // Label 684: @33539
     /*  33539 */ GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(33572), // Rule ID 4422 //
     /*  33544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  33547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  33550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  33553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33561 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  33565 */   // (or:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  33565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KORQkk),
     /*  33570 */   GIR_RootConstrainSelectedInstOperands,
     /*  33571 */   // GIR_Coverage, 4422,
     /*  33571 */   GIR_Done,
     /*  33572 */ // Label 845: @33572
     /*  33572 */ GIM_Reject,
     /*  33573 */ // Label 685: @33573
     /*  33573 */ GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(33728),
     /*  33578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  33581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  33584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33588 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(33646), // Rule ID 25446 //
     /*  33593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33604 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33607 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33611 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33628 */     // (or:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  33635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33644 */     GIR_RootConstrainSelectedInstOperands,
     /*  33645 */     // GIR_Coverage, 25446,
     /*  33645 */     GIR_EraseRootFromParent_Done,
     /*  33646 */   // Label 847: @33646
     /*  33646 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(33704), // Rule ID 20058 //
     /*  33651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  33666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  33669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  33673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  33677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33679 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  33686 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  33686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPORQZrm),
     /*  33689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33691 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  33693 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  33697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  33702 */     GIR_RootConstrainSelectedInstOperands,
     /*  33703 */     // GIR_Coverage, 20058,
     /*  33703 */     GIR_EraseRootFromParent_Done,
     /*  33704 */   // Label 848: @33704
     /*  33704 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(33727), // Rule ID 20050 //
     /*  33709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  33712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  33720 */     // (or:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  33720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPORQZrr),
     /*  33725 */     GIR_RootConstrainSelectedInstOperands,
     /*  33726 */     // GIR_Coverage, 20050,
     /*  33726 */     GIR_Done,
     /*  33727 */   // Label 849: @33727
     /*  33727 */   GIM_Reject,
     /*  33728 */ // Label 846: @33728
     /*  33728 */ GIM_Reject,
     /*  33729 */ // Label 686: @33729
     /*  33729 */ GIM_Reject,
     /*  33730 */ // Label 5: @33730
     /*  33730 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 873*/ GIMT_Encode4(46430),
     /*  33741 */ /*GILLT_s1*//*Label 850*/ GIMT_Encode4(33841),
     /*  33745 */ /*GILLT_s8*//*Label 851*/ GIMT_Encode4(34399),
     /*  33749 */ /*GILLT_s16*//*Label 852*/ GIMT_Encode4(34926),
     /*  33753 */ /*GILLT_s32*//*Label 853*/ GIMT_Encode4(35671),
     /*  33757 */ /*GILLT_s64*//*Label 854*/ GIMT_Encode4(36619), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  33769 */ /*GILLT_v2s1*//*Label 855*/ GIMT_Encode4(37526),
     /*  33773 */ /*GILLT_v2s64*//*Label 856*/ GIMT_Encode4(38068),
     /*  33777 */ /*GILLT_v4s1*//*Label 857*/ GIMT_Encode4(38688),
     /*  33781 */ /*GILLT_v4s32*//*Label 858*/ GIMT_Encode4(39230),
     /*  33785 */ /*GILLT_v4s64*//*Label 859*/ GIMT_Encode4(39850),
     /*  33789 */ /*GILLT_v8s1*//*Label 860*/ GIMT_Encode4(40594),
     /*  33793 */ /*GILLT_v8s16*//*Label 861*/ GIMT_Encode4(41392),
     /*  33797 */ /*GILLT_v8s32*//*Label 862*/ GIMT_Encode4(42012),
     /*  33801 */ /*GILLT_v8s64*//*Label 863*/ GIMT_Encode4(42756),
     /*  33805 */ /*GILLT_v16s1*//*Label 864*/ GIMT_Encode4(42954),
     /*  33809 */ /*GILLT_v16s8*//*Label 865*/ GIMT_Encode4(43212),
     /*  33813 */ /*GILLT_v16s16*//*Label 866*/ GIMT_Encode4(43832),
     /*  33817 */ /*GILLT_v16s32*//*Label 867*/ GIMT_Encode4(44576),
     /*  33821 */ /*GILLT_v32s1*//*Label 868*/ GIMT_Encode4(44774),
     /*  33825 */ /*GILLT_v32s8*//*Label 869*/ GIMT_Encode4(45032),
     /*  33829 */ /*GILLT_v32s16*//*Label 870*/ GIMT_Encode4(45776),
     /*  33833 */ /*GILLT_v64s1*//*Label 871*/ GIMT_Encode4(45974),
     /*  33837 */ /*GILLT_v64s8*//*Label 872*/ GIMT_Encode4(46232),
     /*  33841 */ // Label 850: @33841
     /*  33841 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(34398),
     /*  33846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  33849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  33852 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(33976), // Rule ID 25372 //
     /*  33857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  33877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33886 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33892 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  33894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33900 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }), VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  33900 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  33903 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33907 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33912 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  33916 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  33924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33933 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  33937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  33942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  33945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  33949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  33954 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  33957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  33960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  33962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  33970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  33975 */     // GIR_Coverage, 25372,
     /*  33975 */     GIR_EraseRootFromParent_Done,
     /*  33976 */   // Label 875: @33976
     /*  33976 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(34101), // Rule ID 19496 //
     /*  33981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  33985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  33997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  34001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34015 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34021 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34025 */     // (xor:{ *:[v1i1] } (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2), immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34037 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  34041 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34046 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34049 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34053 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34058 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34079 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34082 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34100 */     // GIR_Coverage, 19496,
     /*  34100 */     GIR_EraseRootFromParent_Done,
     /*  34101 */   // Label 876: @34101
     /*  34101 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(34225), // Rule ID 25373 //
     /*  34106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  34126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  34130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34139 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  34147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34149 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src2, (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, immAllOnesV:{ *:[v1i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34161 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  34165 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  34186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  34198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34203 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34224 */     // GIR_Coverage, 25373,
     /*  34224 */     GIR_EraseRootFromParent_Done,
     /*  34225 */   // Label 877: @34225
     /*  34225 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(34304), // Rule ID 19482 //
     /*  34230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  34234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34242 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34248 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  34250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34252 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src, immAllOnesV:{ *:[v1i1] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  34252 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34255 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34259 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34264 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  34268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  34280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  34303 */     // GIR_Coverage, 19482,
     /*  34303 */     GIR_EraseRootFromParent_Done,
     /*  34304 */   // Label 878: @34304
     /*  34304 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(34397), // Rule ID 19500 //
     /*  34309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  34321 */     // (xor:{ *:[v1i1] } VK1:{ *:[v1i1] }:$src1, VK1:{ *:[v1i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK1:{ *:[v1i1] }:$src2, VK16:{ *:[i32] })), VK1:{ *:[i32] })
     /*  34321 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  34324 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34328 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34333 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  34337 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  34345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  34358 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  34363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  34366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  34370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34375 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  34378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  34381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  34383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  34396 */     // GIR_Coverage, 19500,
     /*  34396 */     GIR_EraseRootFromParent_Done,
     /*  34397 */   // Label 879: @34397
     /*  34397 */   GIM_Reject,
     /*  34398 */ // Label 874: @34398
     /*  34398 */ GIM_Reject,
     /*  34399 */ // Label 851: @34399
     /*  34399 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(34925),
     /*  34404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  34407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  34410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34414 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(34470), // Rule ID 273 //
     /*  34419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34433 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34437 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34454 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] })  =>  (NOT8m_ND:{ *:[i8] } addr:{ *:[iPTR] }:$src1)
     /*  34454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m_ND),
     /*  34457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34468 */     GIR_RootConstrainSelectedInstOperands,
     /*  34469 */     // GIR_Coverage, 273,
     /*  34469 */     GIR_EraseRootFromParent_Done,
     /*  34470 */   // Label 881: @34470
     /*  34470 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(34531), // Rule ID 26065 //
     /*  34475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34493 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34510 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34515 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34529 */     GIR_RootConstrainSelectedInstOperands,
     /*  34530 */     // GIR_Coverage, 26065,
     /*  34530 */     GIR_EraseRootFromParent_Done,
     /*  34531 */   // Label 882: @34531
     /*  34531 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(34592), // Rule ID 26084 //
     /*  34536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34547 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34550 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34554 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34571 */     // (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, GR8:{ *:[i8] }:$src1)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  34578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34590 */     GIR_RootConstrainSelectedInstOperands,
     /*  34591 */     // GIR_Coverage, 26084,
     /*  34591 */     GIR_EraseRootFromParent_Done,
     /*  34592 */   // Label 883: @34592
     /*  34592 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(34653), // Rule ID 22842 //
     /*  34597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34619 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34632 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm),
     /*  34635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34651 */     GIR_RootConstrainSelectedInstOperands,
     /*  34652 */     // GIR_Coverage, 22842,
     /*  34652 */     GIR_EraseRootFromParent_Done,
     /*  34653 */   // Label 884: @34653
     /*  34653 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(34714), // Rule ID 22932 //
     /*  34658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34673 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34680 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  34684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34686 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34693 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>)  =>  (XOR8rm_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  34693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8rm_ND),
     /*  34696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34698 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  34704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34712 */     GIR_RootConstrainSelectedInstOperands,
     /*  34713 */     // GIR_Coverage, 22932,
     /*  34713 */     GIR_EraseRootFromParent_Done,
     /*  34714 */   // Label 885: @34714
     /*  34714 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(34742), // Rule ID 22599 //
     /*  34719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-128),
     /*  34727 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })  =>  (ADD8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, -128:{ *:[i8] })
     /*  34727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8ri),
     /*  34730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  34737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34740 */     GIR_RootConstrainSelectedInstOperands,
     /*  34741 */     // GIR_Coverage, 22599,
     /*  34741 */     GIR_EraseRootFromParent_Done,
     /*  34742 */   // Label 886: @34742
     /*  34742 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(34767), // Rule ID 245 //
     /*  34747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34758 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r),
     /*  34761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34765 */     GIR_RootConstrainSelectedInstOperands,
     /*  34766 */     // GIR_Coverage, 245,
     /*  34766 */     GIR_EraseRootFromParent_Done,
     /*  34767 */   // Label 887: @34767
     /*  34767 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(34792), // Rule ID 253 //
     /*  34772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34783 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, -1:{ *:[i8] })  =>  (NOT8r_ND:{ *:[i8] } GR8:{ *:[i8] }:$src1)
     /*  34783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8r_ND),
     /*  34786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34788 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34790 */     GIR_RootConstrainSelectedInstOperands,
     /*  34791 */     // GIR_Coverage, 253,
     /*  34791 */     GIR_EraseRootFromParent_Done,
     /*  34792 */   // Label 888: @34792
     /*  34792 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(34829), // Rule ID 22846 //
     /*  34797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34812 */     // MIs[1] Operand 1
     /*  34812 */     // No operand predicates
     /*  34812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34814 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri),
     /*  34817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34827 */     GIR_RootConstrainSelectedInstOperands,
     /*  34828 */     // GIR_Coverage, 22846,
     /*  34828 */     GIR_EraseRootFromParent_Done,
     /*  34829 */   // Label 889: @34829
     /*  34829 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(34866), // Rule ID 22936 //
     /*  34834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34849 */     // MIs[1] Operand 1
     /*  34849 */     // No operand predicates
     /*  34849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34851 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (XOR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  34851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8ri_ND),
     /*  34854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  34858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  34861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  34864 */     GIR_RootConstrainSelectedInstOperands,
     /*  34865 */     // GIR_Coverage, 22936,
     /*  34865 */     GIR_EraseRootFromParent_Done,
     /*  34866 */   // Label 890: @34866
     /*  34866 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(34895), // Rule ID 22838 //
     /*  34871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  34874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34882 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr),
     /*  34887 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34893 */     GIR_RootConstrainSelectedInstOperands,
     /*  34894 */     // GIR_Coverage, 22838,
     /*  34894 */     GIR_Done,
     /*  34895 */   // Label 891: @34895
     /*  34895 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(34924), // Rule ID 22928 //
     /*  34900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  34903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  34911 */     // (xor:{ *:[i8] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (XOR8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  34911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR8rr_ND),
     /*  34916 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  34922 */     GIR_RootConstrainSelectedInstOperands,
     /*  34923 */     // GIR_Coverage, 22928,
     /*  34923 */     GIR_Done,
     /*  34924 */   // Label 892: @34924
     /*  34924 */   GIM_Reject,
     /*  34925 */ // Label 880: @34925
     /*  34925 */ GIM_Reject,
     /*  34926 */ // Label 852: @34926
     /*  34926 */ GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(35670),
     /*  34931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  34934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  34937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  34941 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(34997), // Rule ID 274 //
     /*  34946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  34949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  34957 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  34960 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  34964 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  34968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  34972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34974 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  34981 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] })  =>  (NOT16m_ND:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /*  34981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m_ND),
     /*  34984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  34990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  34995 */     GIR_RootConstrainSelectedInstOperands,
     /*  34996 */     // GIR_Coverage, 274,
     /*  34996 */     GIR_EraseRootFromParent_Done,
     /*  34997 */   // Label 894: @34997
     /*  34997 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(35058), // Rule ID 26066 //
     /*  35002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35013 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35020 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35030 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35037 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35042 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35044 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35056 */     GIR_RootConstrainSelectedInstOperands,
     /*  35057 */     // GIR_Coverage, 26066,
     /*  35057 */     GIR_EraseRootFromParent_Done,
     /*  35058 */   // Label 895: @35058
     /*  35058 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(35119), // Rule ID 26085 //
     /*  35063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35081 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35098 */     // (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, GR16:{ *:[i16] }:$src1)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35117 */     GIR_RootConstrainSelectedInstOperands,
     /*  35118 */     // GIR_Coverage, 26085,
     /*  35118 */     GIR_EraseRootFromParent_Done,
     /*  35119 */   // Label 896: @35119
     /*  35119 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(35180), // Rule ID 22843 //
     /*  35124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35146 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35159 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm),
     /*  35162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35178 */     GIR_RootConstrainSelectedInstOperands,
     /*  35179 */     // GIR_Coverage, 22843,
     /*  35179 */     GIR_EraseRootFromParent_Done,
     /*  35180 */   // Label 897: @35180
     /*  35180 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(35241), // Rule ID 22933 //
     /*  35185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35207 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  35211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35220 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (XOR16rm_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16rm_ND),
     /*  35223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35225 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35239 */     GIR_RootConstrainSelectedInstOperands,
     /*  35240 */     // GIR_Coverage, 22933,
     /*  35240 */     GIR_EraseRootFromParent_Done,
     /*  35241 */   // Label 898: @35241
     /*  35241 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(35283), // Rule ID 22600 //
     /*  35246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35250 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-32768),
     /*  35261 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })  =>  (ADD16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, -32768:{ *:[i16] })
     /*  35261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16ri),
     /*  35264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35266 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-32768),
     /*  35278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35281 */     GIR_RootConstrainSelectedInstOperands,
     /*  35282 */     // GIR_Coverage, 22600,
     /*  35282 */     GIR_EraseRootFromParent_Done,
     /*  35283 */   // Label 899: @35283
     /*  35283 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(35385), // Rule ID 26038 //
     /*  35288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35319 */     // (xor:{ *:[i16] } (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2), GR16:{ *:[i16] }:$src1)  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35348 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35352 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35355 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35360 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35365 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35375 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35383 */     GIR_RootConstrainSelectedInstOperands,
     /*  35384 */     // GIR_Coverage, 26038,
     /*  35384 */     GIR_EraseRootFromParent_Done,
     /*  35385 */   // Label 900: @35385
     /*  35385 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(35487), // Rule ID 22776 //
     /*  35390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  35402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  35406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  35410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  35414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  35419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35421 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (shl:{ *:[i16] } 1:{ *:[i16] }, GR8:{ *:[i8] }:$src2))  =>  (BTC16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (INSERT_SUBREG:{ *:[i16] } (IMPLICIT_DEF:{ *:[i16] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  35421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /*  35424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  35435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  35438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  35442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35447 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  35450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  35454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  35457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  35462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /*  35467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  35472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC16rr),
     /*  35475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35485 */     GIR_RootConstrainSelectedInstOperands,
     /*  35486 */     // GIR_Coverage, 22776,
     /*  35486 */     GIR_EraseRootFromParent_Done,
     /*  35487 */   // Label 901: @35487
     /*  35487 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(35512), // Rule ID 246 //
     /*  35492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35503 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r),
     /*  35506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35508 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35510 */     GIR_RootConstrainSelectedInstOperands,
     /*  35511 */     // GIR_Coverage, 246,
     /*  35511 */     GIR_EraseRootFromParent_Done,
     /*  35512 */   // Label 902: @35512
     /*  35512 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(35537), // Rule ID 254 //
     /*  35517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35528 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, -1:{ *:[i16] })  =>  (NOT16r_ND:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /*  35528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16r_ND),
     /*  35531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35535 */     GIR_RootConstrainSelectedInstOperands,
     /*  35536 */     // GIR_Coverage, 254,
     /*  35536 */     GIR_EraseRootFromParent_Done,
     /*  35537 */   // Label 903: @35537
     /*  35537 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(35574), // Rule ID 22847 //
     /*  35542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35557 */     // MIs[1] Operand 1
     /*  35557 */     // No operand predicates
     /*  35557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35559 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri),
     /*  35562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35564 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35572 */     GIR_RootConstrainSelectedInstOperands,
     /*  35573 */     // GIR_Coverage, 22847,
     /*  35573 */     GIR_EraseRootFromParent_Done,
     /*  35574 */   // Label 904: @35574
     /*  35574 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(35611), // Rule ID 22937 //
     /*  35579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35594 */     // MIs[1] Operand 1
     /*  35594 */     // No operand predicates
     /*  35594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35596 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)  =>  (XOR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  35596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16ri_ND),
     /*  35599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  35606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35609 */     GIR_RootConstrainSelectedInstOperands,
     /*  35610 */     // GIR_Coverage, 22937,
     /*  35610 */     GIR_EraseRootFromParent_Done,
     /*  35611 */   // Label 905: @35611
     /*  35611 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(35640), // Rule ID 22839 //
     /*  35616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35627 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr),
     /*  35632 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35638 */     GIR_RootConstrainSelectedInstOperands,
     /*  35639 */     // GIR_Coverage, 22839,
     /*  35639 */     GIR_Done,
     /*  35640 */   // Label 906: @35640
     /*  35640 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(35669), // Rule ID 22929 //
     /*  35645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  35656 */     // (xor:{ *:[i16] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (XOR16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  35656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR16rr_ND),
     /*  35661 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  35667 */     GIR_RootConstrainSelectedInstOperands,
     /*  35668 */     // GIR_Coverage, 22929,
     /*  35668 */     GIR_Done,
     /*  35669 */   // Label 907: @35669
     /*  35669 */   GIM_Reject,
     /*  35670 */ // Label 893: @35670
     /*  35670 */ GIM_Reject,
     /*  35671 */ // Label 853: @35671
     /*  35671 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(36618),
     /*  35676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35679 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(35742), // Rule ID 275 //
     /*  35684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  35687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35705 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35709 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  35717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35726 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] })  =>  (NOT32m_ND:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  35726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m_ND),
     /*  35729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  35735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35740 */     GIR_RootConstrainSelectedInstOperands,
     /*  35741 */     // GIR_Coverage, 275,
     /*  35741 */     GIR_EraseRootFromParent_Done,
     /*  35742 */   // Label 909: @35742
     /*  35742 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(35810), // Rule ID 26067 //
     /*  35747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35772 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35789 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35794 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35808 */     GIR_RootConstrainSelectedInstOperands,
     /*  35809 */     // GIR_Coverage, 26067,
     /*  35809 */     GIR_EraseRootFromParent_Done,
     /*  35810 */   // Label 910: @35810
     /*  35810 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(35878), // Rule ID 26086 //
     /*  35815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35840 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35857 */     // (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src1)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  35864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35876 */     GIR_RootConstrainSelectedInstOperands,
     /*  35877 */     // GIR_Coverage, 26086,
     /*  35877 */     GIR_EraseRootFromParent_Done,
     /*  35878 */   // Label 911: @35878
     /*  35878 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(35946), // Rule ID 22844 //
     /*  35883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  35886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35905 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35908 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35912 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35925 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm),
     /*  35928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  35932 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  35936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  35939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  35944 */     GIR_RootConstrainSelectedInstOperands,
     /*  35945 */     // GIR_Coverage, 22844,
     /*  35945 */     GIR_EraseRootFromParent_Done,
     /*  35946 */   // Label 912: @35946
     /*  35946 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(36014), // Rule ID 22934 //
     /*  35951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  35954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  35957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  35965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  35973 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  35976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  35980 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  35984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35986 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  35993 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (XOR32rm_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  35993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32rm_ND),
     /*  35996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35998 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36000 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36012 */     GIR_RootConstrainSelectedInstOperands,
     /*  36013 */     // GIR_Coverage, 22934,
     /*  36013 */     GIR_EraseRootFromParent_Done,
     /*  36014 */   // Label 913: @36014
     /*  36014 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(36063), // Rule ID 22601 //
     /*  36019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36030 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(-2147483648),
     /*  36041 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })  =>  (ADD32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, -2147483648:{ *:[i32] })
     /*  36041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32ri),
     /*  36044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36046 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36048 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  36058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36061 */     GIR_RootConstrainSelectedInstOperands,
     /*  36062 */     // GIR_Coverage, 22601,
     /*  36062 */     GIR_EraseRootFromParent_Done,
     /*  36063 */   // Label 914: @36063
     /*  36063 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(36121), // Rule ID 24997 //
     /*  36068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36096 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36100 */     // MIs[0] src
     /*  36100 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36107 */     // (xor:{ *:[i32] } (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }), GR32:{ *:[i32] }:$src)  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  36116 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36119 */     GIR_RootConstrainSelectedInstOperands,
     /*  36120 */     // GIR_Coverage, 24997,
     /*  36120 */     GIR_EraseRootFromParent_Done,
     /*  36121 */   // Label 915: @36121
     /*  36121 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(36230), // Rule ID 26044 //
     /*  36126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36149 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36164 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2), GR32:{ *:[i32] }:$src1)  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36190 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36193 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36197 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36228 */     GIR_RootConstrainSelectedInstOperands,
     /*  36229 */     // GIR_Coverage, 26044,
     /*  36229 */     GIR_EraseRootFromParent_Done,
     /*  36230 */   // Label 916: @36230
     /*  36230 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(36284), // Rule ID 17358 //
     /*  36235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  36261 */     // MIs[1] src
     /*  36261 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  36266 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36272 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (add:{ *:[i32] } GR32:{ *:[i32] }:$src, 1:{ *:[i32] }))  =>  (BLCMSK32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /*  36272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK32rr),
     /*  36275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  36279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36282 */     GIR_RootConstrainSelectedInstOperands,
     /*  36283 */     // GIR_Coverage, 17358,
     /*  36283 */     GIR_EraseRootFromParent_Done,
     /*  36284 */   // Label 917: @36284
     /*  36284 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(36393), // Rule ID 22782 //
     /*  36289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  36308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  36312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  36316 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  36320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  36325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36327 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (shl:{ *:[i32] } 1:{ *:[i32] }, GR8:{ *:[i8] }:$src2))  =>  (BTC32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  36327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  36330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  36341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  36360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  36373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  36378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC32rr),
     /*  36381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36391 */     GIR_RootConstrainSelectedInstOperands,
     /*  36392 */     // GIR_Coverage, 22782,
     /*  36392 */     GIR_EraseRootFromParent_Done,
     /*  36393 */   // Label 918: @36393
     /*  36393 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(36425), // Rule ID 247 //
     /*  36398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36416 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r),
     /*  36419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36423 */     GIR_RootConstrainSelectedInstOperands,
     /*  36424 */     // GIR_Coverage, 247,
     /*  36424 */     GIR_EraseRootFromParent_Done,
     /*  36425 */   // Label 919: @36425
     /*  36425 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(36457), // Rule ID 255 //
     /*  36430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36448 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, -1:{ *:[i32] })  =>  (NOT32r_ND:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /*  36448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32r_ND),
     /*  36451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36455 */     GIR_RootConstrainSelectedInstOperands,
     /*  36456 */     // GIR_Coverage, 255,
     /*  36456 */     GIR_EraseRootFromParent_Done,
     /*  36457 */   // Label 920: @36457
     /*  36457 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(36501), // Rule ID 22848 //
     /*  36462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36484 */     // MIs[1] Operand 1
     /*  36484 */     // No operand predicates
     /*  36484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36486 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri),
     /*  36489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36491 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36499 */     GIR_RootConstrainSelectedInstOperands,
     /*  36500 */     // GIR_Coverage, 22848,
     /*  36500 */     GIR_EraseRootFromParent_Done,
     /*  36501 */   // Label 921: @36501
     /*  36501 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(36545), // Rule ID 22938 //
     /*  36506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36528 */     // MIs[1] Operand 1
     /*  36528 */     // No operand predicates
     /*  36528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36530 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)  =>  (XOR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  36530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32ri_ND),
     /*  36533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  36540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36543 */     GIR_RootConstrainSelectedInstOperands,
     /*  36544 */     // GIR_Coverage, 22938,
     /*  36544 */     GIR_EraseRootFromParent_Done,
     /*  36545 */   // Label 922: @36545
     /*  36545 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(36581), // Rule ID 22840 //
     /*  36550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36568 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr),
     /*  36573 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36579 */     GIR_RootConstrainSelectedInstOperands,
     /*  36580 */     // GIR_Coverage, 22840,
     /*  36580 */     GIR_Done,
     /*  36581 */   // Label 923: @36581
     /*  36581 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(36617), // Rule ID 22930 //
     /*  36586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  36604 */     // (xor:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (XOR32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  36604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR32rr_ND),
     /*  36609 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  36615 */     GIR_RootConstrainSelectedInstOperands,
     /*  36616 */     // GIR_Coverage, 22930,
     /*  36616 */     GIR_Done,
     /*  36617 */   // Label 924: @36617
     /*  36617 */   GIM_Reject,
     /*  36618 */ // Label 908: @36618
     /*  36618 */ GIM_Reject,
     /*  36619 */ // Label 854: @36619
     /*  36619 */ GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(37525),
     /*  36624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36627 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(36690), // Rule ID 276 //
     /*  36632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  36635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  36665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36674 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] })  =>  (NOT64m_ND:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /*  36674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m_ND),
     /*  36677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  36683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36688 */     GIR_RootConstrainSelectedInstOperands,
     /*  36689 */     // GIR_Coverage, 276,
     /*  36689 */     GIR_EraseRootFromParent_Done,
     /*  36690 */   // Label 926: @36690
     /*  36690 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(36758), // Rule ID 26068 //
     /*  36695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36737 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36756 */     GIR_RootConstrainSelectedInstOperands,
     /*  36757 */     // GIR_Coverage, 26068,
     /*  36757 */     GIR_EraseRootFromParent_Done,
     /*  36758 */   // Label 927: @36758
     /*  36758 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(36826), // Rule ID 26087 //
     /*  36763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36798 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36805 */     // (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src1)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36810 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  36812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36824 */     GIR_RootConstrainSelectedInstOperands,
     /*  36825 */     // GIR_Coverage, 26087,
     /*  36825 */     GIR_EraseRootFromParent_Done,
     /*  36826 */   // Label 928: @36826
     /*  36826 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(36894), // Rule ID 22845 //
     /*  36831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  36834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36853 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36856 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36860 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36873 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm),
     /*  36876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36892 */     GIR_RootConstrainSelectedInstOperands,
     /*  36893 */     // GIR_Coverage, 22845,
     /*  36893 */     GIR_EraseRootFromParent_Done,
     /*  36894 */   // Label 929: @36894
     /*  36894 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(36962), // Rule ID 22935 //
     /*  36899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  36902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  36921 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36924 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  36928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  36932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  36941 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (XOR64rm_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  36941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64rm_ND),
     /*  36944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  36948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  36952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  36955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  36960 */     GIR_RootConstrainSelectedInstOperands,
     /*  36961 */     // GIR_Coverage, 22935,
     /*  36961 */     GIR_EraseRootFromParent_Done,
     /*  36962 */   // Label 930: @36962
     /*  36962 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37020), // Rule ID 24998 //
     /*  36967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  36970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  36982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  36990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  36995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  36999 */     // MIs[0] src
     /*  36999 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  37004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37006 */     // (xor:{ *:[i64] } (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }), GR64:{ *:[i64] }:$src)  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  37006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  37009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  37015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37018 */     GIR_RootConstrainSelectedInstOperands,
     /*  37019 */     // GIR_Coverage, 24998,
     /*  37019 */     GIR_EraseRootFromParent_Done,
     /*  37020 */   // Label 931: @37020
     /*  37020 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(37129), // Rule ID 26050 //
     /*  37025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37048 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37063 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2), GR64:{ *:[i64] }:$src1)  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  37121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37127 */     GIR_RootConstrainSelectedInstOperands,
     /*  37128 */     // GIR_Coverage, 26050,
     /*  37128 */     GIR_EraseRootFromParent_Done,
     /*  37129 */   // Label 932: @37129
     /*  37129 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(37183), // Rule ID 17359 //
     /*  37134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTBM),
     /*  37137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  37156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  37160 */     // MIs[1] src
     /*  37160 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/1, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  37165 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  37169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37171 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (add:{ *:[i64] } GR64:{ *:[i64] }:$src, 1:{ *:[i64] }))  =>  (BLCMSK64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src)
     /*  37171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BLCMSK64rr),
     /*  37174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  37178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37181 */     GIR_RootConstrainSelectedInstOperands,
     /*  37182 */     // GIR_Coverage, 17359,
     /*  37182 */     GIR_EraseRootFromParent_Done,
     /*  37183 */   // Label 933: @37183
     /*  37183 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(37292), // Rule ID 22788 //
     /*  37188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  37207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  37215 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  37219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  37224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37226 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (shl:{ *:[i64] } 1:{ *:[i64] }, GR8:{ *:[i8] }:$src2))  =>  (BTC64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /*  37226 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37229 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37233 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  37240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37255 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37259 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /*  37272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  37277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BTC64rr),
     /*  37280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37290 */     GIR_RootConstrainSelectedInstOperands,
     /*  37291 */     // GIR_Coverage, 22788,
     /*  37291 */     GIR_EraseRootFromParent_Done,
     /*  37292 */   // Label 934: @37292
     /*  37292 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(37324), // Rule ID 248 //
     /*  37297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37315 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r),
     /*  37318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37322 */     GIR_RootConstrainSelectedInstOperands,
     /*  37323 */     // GIR_Coverage, 248,
     /*  37323 */     GIR_EraseRootFromParent_Done,
     /*  37324 */   // Label 935: @37324
     /*  37324 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(37356), // Rule ID 256 //
     /*  37329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /*  37332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  37347 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, -1:{ *:[i64] })  =>  (NOT64r_ND:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /*  37347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64r_ND),
     /*  37350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37354 */     GIR_RootConstrainSelectedInstOperands,
     /*  37355 */     // GIR_Coverage, 256,
     /*  37355 */     GIR_EraseRootFromParent_Done,
     /*  37356 */   // Label 936: @37356
     /*  37356 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(37404), // Rule ID 22849 //
     /*  37361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37387 */     // MIs[1] Operand 1
     /*  37387 */     // No operand predicates
     /*  37387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37389 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32),
     /*  37392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37402 */     GIR_RootConstrainSelectedInstOperands,
     /*  37403 */     // GIR_Coverage, 22849,
     /*  37403 */     GIR_EraseRootFromParent_Done,
     /*  37404 */   // Label 937: @37404
     /*  37404 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(37452), // Rule ID 22939 //
     /*  37409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  37431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  37435 */     // MIs[1] Operand 1
     /*  37435 */     // No operand predicates
     /*  37435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37437 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)  =>  (XOR64ri32_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src2)
     /*  37437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64ri32_ND),
     /*  37440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  37444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /*  37447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  37450 */     GIR_RootConstrainSelectedInstOperands,
     /*  37451 */     // GIR_Coverage, 22939,
     /*  37451 */     GIR_EraseRootFromParent_Done,
     /*  37452 */   // Label 938: @37452
     /*  37452 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(37488), // Rule ID 22841 //
     /*  37457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /*  37460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37475 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr),
     /*  37480 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37486 */     GIR_RootConstrainSelectedInstOperands,
     /*  37487 */     // GIR_Coverage, 22841,
     /*  37487 */     GIR_Done,
     /*  37488 */   // Label 939: @37488
     /*  37488 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(37524), // Rule ID 22931 //
     /*  37493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /*  37496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  37499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  37511 */     // (xor:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (XOR64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  37511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::XOR64rr_ND),
     /*  37516 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /*  37522 */     GIR_RootConstrainSelectedInstOperands,
     /*  37523 */     // GIR_Coverage, 22931,
     /*  37523 */     GIR_Done,
     /*  37524 */   // Label 940: @37524
     /*  37524 */   GIM_Reject,
     /*  37525 */ // Label 925: @37525
     /*  37525 */ GIM_Reject,
     /*  37526 */ // Label 855: @37526
     /*  37526 */ GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(38067),
     /*  37531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37541 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(37661), // Rule ID 25374 //
     /*  37546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37571 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37585 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }), VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37585 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37588 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37592 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37597 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  37601 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37660 */     // GIR_Coverage, 25374,
     /*  37660 */     GIR_EraseRootFromParent_Done,
     /*  37661 */   // Label 942: @37661
     /*  37661 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(37782), // Rule ID 19497 //
     /*  37666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  37696 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37706 */     // (xor:{ *:[v2i1] } (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2), immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37706 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37709 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37713 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37718 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  37722 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37743 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37760 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37763 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37781 */     // GIR_Coverage, 19497,
     /*  37781 */     GIR_EraseRootFromParent_Done,
     /*  37782 */   // Label 943: @37782
     /*  37782 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(37902), // Rule ID 25375 //
     /*  37787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  37803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  37807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  37816 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37822 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  37824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37826 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src2, (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, immAllOnesV:{ *:[v2i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37838 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  37842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  37863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  37875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37880 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  37886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37901 */     // GIR_Coverage, 25375,
     /*  37901 */     GIR_EraseRootFromParent_Done,
     /*  37902 */   // Label 944: @37902
     /*  37902 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(37977), // Rule ID 19481 //
     /*  37907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37915 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37921 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  37923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37925 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src, immAllOnesV:{ *:[v2i1] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  37928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37937 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  37941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  37946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  37949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  37953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  37971 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  37976 */     // GIR_Coverage, 19481,
     /*  37976 */     GIR_EraseRootFromParent_Done,
     /*  37977 */   // Label 945: @37977
     /*  37977 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(38066), // Rule ID 19501 //
     /*  37982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  37990 */     // (xor:{ *:[v2i1] } VK2:{ *:[v2i1] }:$src1, VK2:{ *:[v2i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK2:{ *:[v2i1] }:$src2, VK16:{ *:[i32] })), VK2:{ *:[i32] })
     /*  37990 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  37993 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37997 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38002 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38006 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  38027 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  38039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38044 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38047 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  38065 */     // GIR_Coverage, 19501,
     /*  38065 */     GIR_EraseRootFromParent_Done,
     /*  38066 */   // Label 946: @38066
     /*  38066 */   GIM_Reject,
     /*  38067 */ // Label 941: @38067
     /*  38067 */ GIM_Reject,
     /*  38068 */ // Label 856: @38068
     /*  38068 */ GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(38687),
     /*  38073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38079 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(38141), // Rule ID 23366 //
     /*  38084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38116 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38123 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src1)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38128 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38139 */     GIR_RootConstrainSelectedInstOperands,
     /*  38140 */     // GIR_Coverage, 23366,
     /*  38140 */     GIR_EraseRootFromParent_Done,
     /*  38141 */   // Label 948: @38141
     /*  38141 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(38203), // Rule ID 24221 //
     /*  38146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38161 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38164 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38185 */     // (xor:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38190 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  38192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38201 */     GIR_RootConstrainSelectedInstOperands,
     /*  38202 */     // GIR_Coverage, 24221,
     /*  38202 */     GIR_EraseRootFromParent_Done,
     /*  38203 */   // Label 949: @38203
     /*  38203 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(38265), // Rule ID 2123 //
     /*  38208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38247 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  38250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38252 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38254 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38263 */     GIR_RootConstrainSelectedInstOperands,
     /*  38264 */     // GIR_Coverage, 2123,
     /*  38264 */     GIR_EraseRootFromParent_Done,
     /*  38265 */   // Label 950: @38265
     /*  38265 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(38327), // Rule ID 5815 //
     /*  38270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  38289 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  38292 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  38296 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  38300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  38309 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  38309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  38312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  38316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  38320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  38325 */     GIR_RootConstrainSelectedInstOperands,
     /*  38326 */     // GIR_Coverage, 5815,
     /*  38326 */     GIR_EraseRootFromParent_Done,
     /*  38327 */   // Label 951: @38327
     /*  38327 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(38559), // Rule ID 21946 //
     /*  38332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  38335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  38339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38347 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38357 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  38357 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  38360 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38364 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  38371 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  38374 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38378 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38383 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  38386 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38390 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  38393 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38398 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38403 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38408 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  38411 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38415 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  38422 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  38425 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38429 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38434 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  38437 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38441 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  38444 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38449 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38454 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  38462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  38476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  38492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  38495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  38500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  38510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  38513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  38517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38522 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38525 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  38528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  38531 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  38534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  38548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  38553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  38558 */     // GIR_Coverage, 21946,
     /*  38558 */     GIR_EraseRootFromParent_Done,
     /*  38559 */   // Label 952: @38559
     /*  38559 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(38605), // Rule ID 21954 //
     /*  38564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  38567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38585 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  38587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  38589 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, immAllOnesV:{ *:[v2i64] })  =>  (VPTERNLOGQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, VR128X:{ *:[v2i64] }:$src, 15:{ *:[i8] })
     /*  38589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  38592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38598 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  38600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  38603 */     GIR_RootConstrainSelectedInstOperands,
     /*  38604 */     // GIR_Coverage, 21954,
     /*  38604 */     GIR_EraseRootFromParent_Done,
     /*  38605 */   // Label 953: @38605
     /*  38605 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(38632), // Rule ID 2122 //
     /*  38610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  38613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38625 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  38630 */     GIR_RootConstrainSelectedInstOperands,
     /*  38631 */     // GIR_Coverage, 2122,
     /*  38631 */     GIR_Done,
     /*  38632 */   // Label 954: @38632
     /*  38632 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(38659), // Rule ID 2124 //
     /*  38637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  38640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  38652 */     // (xor:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (PXORrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  38652 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  38657 */     GIR_RootConstrainSelectedInstOperands,
     /*  38658 */     // GIR_Coverage, 2124,
     /*  38658 */     GIR_Done,
     /*  38659 */   // Label 955: @38659
     /*  38659 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(38686), // Rule ID 5812 //
     /*  38664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  38667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  38679 */     // (xor:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPXORQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  38679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  38684 */     GIR_RootConstrainSelectedInstOperands,
     /*  38685 */     // GIR_Coverage, 5812,
     /*  38685 */     GIR_Done,
     /*  38686 */   // Label 956: @38686
     /*  38686 */   GIM_Reject,
     /*  38687 */ // Label 947: @38687
     /*  38687 */ GIM_Reject,
     /*  38688 */ // Label 857: @38688
     /*  38688 */ GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(39229),
     /*  38693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38703 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(38823), // Rule ID 25376 //
     /*  38708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38733 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38739 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38747 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }), VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38747 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38750 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38754 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38759 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  38763 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38768 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38771 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38775 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38780 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38784 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38801 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38804 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38822 */     // GIR_Coverage, 25376,
     /*  38822 */     GIR_EraseRootFromParent_Done,
     /*  38823 */   // Label 958: @38823
     /*  38823 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(38944), // Rule ID 19498 //
     /*  38828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  38858 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38868 */     // (xor:{ *:[v4i1] } (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2), immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38868 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38871 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38875 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38880 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  38884 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  38892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  38905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  38910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  38913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  38917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38922 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38925 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  38928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  38938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  38943 */     // GIR_Coverage, 19498,
     /*  38943 */     GIR_EraseRootFromParent_Done,
     /*  38944 */   // Label 959: @38944
     /*  38944 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(39064), // Rule ID 25377 //
     /*  38949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  38965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  38969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  38974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  38978 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  38986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38988 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src2, (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, immAllOnesV:{ *:[v4i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  38988 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  38991 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38995 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39000 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  39004 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39021 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  39025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  39037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39045 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39063 */     // GIR_Coverage, 25377,
     /*  39063 */     GIR_EraseRootFromParent_Done,
     /*  39064 */   // Label 960: @39064
     /*  39064 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(39139), // Rule ID 19480 //
     /*  39069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39077 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39083 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39087 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src, immAllOnesV:{ *:[v4i1] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39099 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  39115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39138 */     // GIR_Coverage, 19480,
     /*  39138 */     GIR_EraseRootFromParent_Done,
     /*  39139 */   // Label 961: @39139
     /*  39139 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(39228), // Rule ID 19502 //
     /*  39144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  39152 */     // (xor:{ *:[v4i1] } VK4:{ *:[v4i1] }:$src1, VK4:{ *:[v4i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4:{ *:[v4i1] }:$src2, VK16:{ *:[i32] })), VK4:{ *:[i32] })
     /*  39152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  39155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  39168 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  39176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  39189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  39194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  39197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  39201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39206 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39209 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  39212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  39227 */     // GIR_Coverage, 19502,
     /*  39227 */     GIR_EraseRootFromParent_Done,
     /*  39228 */   // Label 962: @39228
     /*  39228 */   GIM_Reject,
     /*  39229 */ // Label 957: @39229
     /*  39229 */ GIM_Reject,
     /*  39230 */ // Label 858: @39230
     /*  39230 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(39849),
     /*  39235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39241 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(39303), // Rule ID 24239 //
     /*  39246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39261 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39264 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39285 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39301 */     GIR_RootConstrainSelectedInstOperands,
     /*  39302 */     // GIR_Coverage, 24239,
     /*  39302 */     GIR_EraseRootFromParent_Done,
     /*  39303 */   // Label 964: @39303
     /*  39303 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(39365), // Rule ID 25259 //
     /*  39308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39323 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39326 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39330 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39340 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39347 */     // (xor:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39352 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39354 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39363 */     GIR_RootConstrainSelectedInstOperands,
     /*  39364 */     // GIR_Coverage, 25259,
     /*  39364 */     GIR_EraseRootFromParent_Done,
     /*  39365 */   // Label 965: @39365
     /*  39365 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(39427), // Rule ID 5842 //
     /*  39370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39389 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39392 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39396 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39409 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rm),
     /*  39412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39425 */     GIR_RootConstrainSelectedInstOperands,
     /*  39426 */     // GIR_Coverage, 5842,
     /*  39426 */     GIR_EraseRootFromParent_Done,
     /*  39427 */   // Label 966: @39427
     /*  39427 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(39489), // Rule ID 18166 //
     /*  39432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39471 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  39474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  39478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39487 */     GIR_RootConstrainSelectedInstOperands,
     /*  39488 */     // GIR_Coverage, 18166,
     /*  39488 */     GIR_EraseRootFromParent_Done,
     /*  39489 */   // Label 967: @39489
     /*  39489 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(39721), // Rule ID 21945 //
     /*  39494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  39497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  39501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39509 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39515 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39519 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  39519 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  39522 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39526 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  39533 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  39536 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39540 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39545 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  39548 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39552 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  39555 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39560 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39565 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39570 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  39573 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39577 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  39584 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  39587 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39591 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39596 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  39599 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39603 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  39606 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39616 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  39624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  39628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  39635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  39638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  39642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39647 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  39650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  39654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  39657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  39662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  39672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  39675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  39679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  39687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  39690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  39693 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  39696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  39710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  39715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  39720 */     // GIR_Coverage, 21945,
     /*  39720 */     GIR_EraseRootFromParent_Done,
     /*  39721 */   // Label 968: @39721
     /*  39721 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(39767), // Rule ID 21953 //
     /*  39726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  39729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39747 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  39749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39751 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, immAllOnesV:{ *:[v4i32] })  =>  (VPTERNLOGQZ128rri:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, VR128X:{ *:[v4i32] }:$src, 15:{ *:[i8] })
     /*  39751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  39754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  39762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  39765 */     GIR_RootConstrainSelectedInstOperands,
     /*  39766 */     // GIR_Coverage, 21953,
     /*  39766 */     GIR_EraseRootFromParent_Done,
     /*  39767 */   // Label 969: @39767
     /*  39767 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(39794), // Rule ID 5839 //
     /*  39772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  39787 */     // (xor:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPXORDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  39787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ128rr),
     /*  39792 */     GIR_RootConstrainSelectedInstOperands,
     /*  39793 */     // GIR_Coverage, 5839,
     /*  39793 */     GIR_Done,
     /*  39794 */   // Label 970: @39794
     /*  39794 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(39821), // Rule ID 18154 //
     /*  39799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  39802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39814 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  39819 */     GIR_RootConstrainSelectedInstOperands,
     /*  39820 */     // GIR_Coverage, 18154,
     /*  39820 */     GIR_Done,
     /*  39821 */   // Label 971: @39821
     /*  39821 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(39848), // Rule ID 18178 //
     /*  39826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  39829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  39841 */     // (xor:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PXORrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  39841 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  39846 */     GIR_RootConstrainSelectedInstOperands,
     /*  39847 */     // GIR_Coverage, 18178,
     /*  39847 */     GIR_Done,
     /*  39848 */   // Label 972: @39848
     /*  39848 */   GIM_Reject,
     /*  39849 */ // Label 963: @39849
     /*  39849 */ GIM_Reject,
     /*  39850 */ // Label 859: @39850
     /*  39850 */ GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(40593),
     /*  39855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  39858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  39861 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(39923), // Rule ID 23368 //
     /*  39866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  39869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39898 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39905 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  39908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39910 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39912 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39921 */     GIR_RootConstrainSelectedInstOperands,
     /*  39922 */     // GIR_Coverage, 23368,
     /*  39922 */     GIR_EraseRootFromParent_Done,
     /*  39923 */   // Label 974: @39923
     /*  39923 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(39985), // Rule ID 24215 //
     /*  39928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  39931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  39943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  39946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  39950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  39954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  39958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39960 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  39967 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  39967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  39970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  39974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  39978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  39983 */     GIR_RootConstrainSelectedInstOperands,
     /*  39984 */     // GIR_Coverage, 24215,
     /*  39984 */     GIR_EraseRootFromParent_Done,
     /*  39985 */   // Label 975: @39985
     /*  39985 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(40047), // Rule ID 25250 //
     /*  39990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  39993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  39997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40029 */     // (xor:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4i64] }:$src1)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  40036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40045 */     GIR_RootConstrainSelectedInstOperands,
     /*  40046 */     // GIR_Coverage, 25250,
     /*  40046 */     GIR_EraseRootFromParent_Done,
     /*  40047 */   // Label 976: @40047
     /*  40047 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(40109), // Rule ID 2127 //
     /*  40052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40078 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40091 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  40094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40096 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40107 */     GIR_RootConstrainSelectedInstOperands,
     /*  40108 */     // GIR_Coverage, 2127,
     /*  40108 */     GIR_EraseRootFromParent_Done,
     /*  40109 */   // Label 977: @40109
     /*  40109 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(40171), // Rule ID 5806 //
     /*  40114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40146 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40153 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  40156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40158 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40160 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40169 */     GIR_RootConstrainSelectedInstOperands,
     /*  40170 */     // GIR_Coverage, 5806,
     /*  40170 */     GIR_EraseRootFromParent_Done,
     /*  40171 */   // Label 978: @40171
     /*  40171 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(40233), // Rule ID 18141 //
     /*  40176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  40195 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  40198 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  40202 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  40206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40208 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  40215 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  40215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  40218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  40222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  40226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  40231 */     GIR_RootConstrainSelectedInstOperands,
     /*  40232 */     // GIR_Coverage, 18141,
     /*  40232 */     GIR_EraseRootFromParent_Done,
     /*  40233 */   // Label 979: @40233
     /*  40233 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(40465), // Rule ID 21950 //
     /*  40238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  40241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40253 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40259 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40263 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  40263 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  40266 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40270 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  40277 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  40280 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40284 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40289 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  40292 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40296 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  40299 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40304 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40309 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40314 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  40317 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40321 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  40328 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  40331 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40335 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40340 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  40343 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40347 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  40350 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40355 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40360 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  40368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  40382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40391 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  40398 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  40401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  40406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  40419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  40423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40431 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  40434 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  40437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  40440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40447 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  40454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  40459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  40464 */     // GIR_Coverage, 21950,
     /*  40464 */     GIR_EraseRootFromParent_Done,
     /*  40465 */   // Label 980: @40465
     /*  40465 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(40511), // Rule ID 21958 //
     /*  40470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  40473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40485 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  40493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40495 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, immAllOnesV:{ *:[v4i64] })  =>  (VPTERNLOGQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, VR256X:{ *:[v4i64] }:$src, 15:{ *:[i8] })
     /*  40495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  40498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  40506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  40509 */     GIR_RootConstrainSelectedInstOperands,
     /*  40510 */     // GIR_Coverage, 21958,
     /*  40510 */     GIR_EraseRootFromParent_Done,
     /*  40511 */   // Label 981: @40511
     /*  40511 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(40538), // Rule ID 2126 //
     /*  40516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  40519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40531 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPXORYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  40536 */     GIR_RootConstrainSelectedInstOperands,
     /*  40537 */     // GIR_Coverage, 2126,
     /*  40537 */     GIR_Done,
     /*  40538 */   // Label 982: @40538
     /*  40538 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(40565), // Rule ID 5803 //
     /*  40543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  40546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  40558 */     // (xor:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPXORQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  40558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  40563 */     GIR_RootConstrainSelectedInstOperands,
     /*  40564 */     // GIR_Coverage, 5803,
     /*  40564 */     GIR_Done,
     /*  40565 */   // Label 983: @40565
     /*  40565 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(40592), // Rule ID 18125 //
     /*  40570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  40573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  40585 */     // (xor:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VXORPSYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  40585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  40590 */     GIR_RootConstrainSelectedInstOperands,
     /*  40591 */     // GIR_Coverage, 18125,
     /*  40591 */     GIR_Done,
     /*  40592 */   // Label 984: @40592
     /*  40592 */   GIM_Reject,
     /*  40593 */ // Label 973: @40593
     /*  40593 */ GIM_Reject,
     /*  40594 */ // Label 860: @40594
     /*  40594 */ GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(41391),
     /*  40599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40609 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(40669), // Rule ID 23684 //
     /*  40614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40642 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40656 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  40667 */     GIR_RootConstrainSelectedInstOperands,
     /*  40668 */     // GIR_Coverage, 23684,
     /*  40668 */     GIR_EraseRootFromParent_Done,
     /*  40669 */   // Label 986: @40669
     /*  40669 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(40792), // Rule ID 25370 //
     /*  40674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40689 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40702 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40716 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }), VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40716 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40719 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40723 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40728 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  40732 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40737 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40740 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40744 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40753 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40773 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40791 */     // GIR_Coverage, 25370,
     /*  40791 */     GIR_EraseRootFromParent_Done,
     /*  40792 */   // Label 987: @40792
     /*  40792 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(40855), // Rule ID 4423 //
     /*  40797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40830 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40836 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40840 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  40840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  40843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40853 */     GIR_RootConstrainSelectedInstOperands,
     /*  40854 */     // GIR_Coverage, 4423,
     /*  40854 */     GIR_EraseRootFromParent_Done,
     /*  40855 */   // Label 988: @40855
     /*  40855 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(40979), // Rule ID 19495 //
     /*  40860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  40863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  40875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  40879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  40893 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  40901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40903 */     // (xor:{ *:[v8i1] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2), immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  40903 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  40906 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40910 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40915 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  40919 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40924 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  40927 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40931 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  40940 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  40945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  40948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  40952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40957 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  40963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  40978 */     // GIR_Coverage, 19495,
     /*  40978 */     GIR_EraseRootFromParent_Done,
     /*  40979 */   // Label 989: @40979
     /*  40979 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(41039), // Rule ID 23685 //
     /*  40984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  40987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  40991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  41003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  41007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41016 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41022 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41026 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (KXNORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORBkk),
     /*  41029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41035 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  41037 */     GIR_RootConstrainSelectedInstOperands,
     /*  41038 */     // GIR_Coverage, 23685,
     /*  41038 */     GIR_EraseRootFromParent_Done,
     /*  41039 */   // Label 990: @41039
     /*  41039 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(41162), // Rule ID 25371 //
     /*  41044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  41063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  41067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  41076 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  41084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41086 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src2, (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, immAllOnesV:{ *:[v8i1] }))  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXNORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41098 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src2
     /*  41102 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  41123 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  41135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41140 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41143 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41161 */     // GIR_Coverage, 25371,
     /*  41161 */     GIR_EraseRootFromParent_Done,
     /*  41162 */   // Label 991: @41162
     /*  41162 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(41197), // Rule ID 4411 //
     /*  41167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41184 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41188 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (KNOTBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src)
     /*  41188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTBkk),
     /*  41191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41193 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41195 */     GIR_RootConstrainSelectedInstOperands,
     /*  41196 */     // GIR_Coverage, 4411,
     /*  41196 */     GIR_EraseRootFromParent_Done,
     /*  41197 */   // Label 992: @41197
     /*  41197 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(41275), // Rule ID 19479 //
     /*  41202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoDQI),
     /*  41205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41213 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41219 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41223 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src, immAllOnesV:{ *:[v8i1] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41239 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  41251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41256 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41269 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41274 */     // GIR_Coverage, 19479,
     /*  41274 */     GIR_EraseRootFromParent_Done,
     /*  41275 */   // Label 993: @41275
     /*  41275 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(41298), // Rule ID 4427 //
     /*  41280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  41283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41291 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KXORBkk:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)
     /*  41291 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORBkk),
     /*  41296 */     GIR_RootConstrainSelectedInstOperands,
     /*  41297 */     // GIR_Coverage, 4427,
     /*  41297 */     GIR_Done,
     /*  41298 */   // Label 994: @41298
     /*  41298 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(41390), // Rule ID 19499 //
     /*  41303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoDQI),
     /*  41306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  41314 */     // (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (KXORWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK16:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK16:{ *:[i32] })), VK8:{ *:[i32] })
     /*  41314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /*  41317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41326 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /*  41330 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /*  41338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /*  41351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  41356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /*  41359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  41363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  41374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  41389 */     // GIR_Coverage, 19499,
     /*  41389 */     GIR_EraseRootFromParent_Done,
     /*  41390 */   // Label 995: @41390
     /*  41390 */   GIM_Reject,
     /*  41391 */ // Label 985: @41391
     /*  41391 */ GIM_Reject,
     /*  41392 */ // Label 861: @41392
     /*  41392 */ GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(42011),
     /*  41397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  41400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41403 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(41465), // Rule ID 25258 //
     /*  41408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41423 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41447 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41463 */     GIR_RootConstrainSelectedInstOperands,
     /*  41464 */     // GIR_Coverage, 25258,
     /*  41464 */     GIR_EraseRootFromParent_Done,
     /*  41465 */   // Label 997: @41465
     /*  41465 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(41527), // Rule ID 25437 //
     /*  41470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41509 */     // (xor:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  41516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41525 */     GIR_RootConstrainSelectedInstOperands,
     /*  41526 */     // GIR_Coverage, 25437,
     /*  41526 */     GIR_EraseRootFromParent_Done,
     /*  41527 */   // Label 998: @41527
     /*  41527 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(41589), // Rule ID 18165 //
     /*  41532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41571 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  41574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41587 */     GIR_RootConstrainSelectedInstOperands,
     /*  41588 */     // GIR_Coverage, 18165,
     /*  41588 */     GIR_EraseRootFromParent_Done,
     /*  41589 */   // Label 999: @41589
     /*  41589 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(41651), // Rule ID 20029 //
     /*  41594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  41613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  41616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  41620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  41624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  41633 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  41633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  41636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  41640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  41644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  41649 */     GIR_RootConstrainSelectedInstOperands,
     /*  41650 */     // GIR_Coverage, 20029,
     /*  41650 */     GIR_EraseRootFromParent_Done,
     /*  41651 */   // Label 1000: @41651
     /*  41651 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(41883), // Rule ID 21944 //
     /*  41656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  41659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  41663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41671 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41677 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41681 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  41681 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  41684 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41688 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  41695 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  41698 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41702 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41707 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  41710 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41714 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  41717 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41722 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41727 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41732 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  41735 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41739 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  41746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  41749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41758 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  41761 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41765 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  41768 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41773 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41778 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41783 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  41786 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41790 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  41800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41809 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41812 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  41816 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  41819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  41824 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41829 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  41834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  41837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  41841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41846 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41849 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  41852 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  41855 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  41858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41865 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  41872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  41877 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  41882 */     // GIR_Coverage, 21944,
     /*  41882 */     GIR_EraseRootFromParent_Done,
     /*  41883 */   // Label 1001: @41883
     /*  41883 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(41929), // Rule ID 21952 //
     /*  41888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  41911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41913 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, immAllOnesV:{ *:[v8i16] })  =>  (VPTERNLOGQZ128rri:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, VR128X:{ *:[v8i16] }:$src, 15:{ *:[i8] })
     /*  41913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  41916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  41924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  41927 */     GIR_RootConstrainSelectedInstOperands,
     /*  41928 */     // GIR_Coverage, 21952,
     /*  41928 */     GIR_EraseRootFromParent_Done,
     /*  41929 */   // Label 1002: @41929
     /*  41929 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(41956), // Rule ID 18153 //
     /*  41934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  41937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41949 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  41954 */     GIR_RootConstrainSelectedInstOperands,
     /*  41955 */     // GIR_Coverage, 18153,
     /*  41955 */     GIR_Done,
     /*  41956 */   // Label 1003: @41956
     /*  41956 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(41983), // Rule ID 18177 //
     /*  41961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  41964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  41976 */     // (xor:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PXORrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  41976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  41981 */     GIR_RootConstrainSelectedInstOperands,
     /*  41982 */     // GIR_Coverage, 18177,
     /*  41982 */     GIR_Done,
     /*  41983 */   // Label 1004: @41983
     /*  41983 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(42010), // Rule ID 20021 //
     /*  41988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  41991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  41999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  42003 */     // (xor:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPXORQZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /*  42003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  42008 */     GIR_RootConstrainSelectedInstOperands,
     /*  42009 */     // GIR_Coverage, 20021,
     /*  42009 */     GIR_Done,
     /*  42010 */   // Label 1005: @42010
     /*  42010 */   GIM_Reject,
     /*  42011 */ // Label 996: @42011
     /*  42011 */ GIM_Reject,
     /*  42012 */ // Label 862: @42012
     /*  42012 */ GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(42755),
     /*  42017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  42020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  42023 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(42085), // Rule ID 24233 //
     /*  42028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42067 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42083 */     GIR_RootConstrainSelectedInstOperands,
     /*  42084 */     // GIR_Coverage, 24233,
     /*  42084 */     GIR_EraseRootFromParent_Done,
     /*  42085 */   // Label 1007: @42085
     /*  42085 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(42147), // Rule ID 25238 //
     /*  42090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42105 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42112 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42129 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42134 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42145 */     GIR_RootConstrainSelectedInstOperands,
     /*  42146 */     // GIR_Coverage, 25238,
     /*  42146 */     GIR_EraseRootFromParent_Done,
     /*  42147 */   // Label 1008: @42147
     /*  42147 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(42209), // Rule ID 25249 //
     /*  42152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42174 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42191 */     // (xor:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42196 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42207 */     GIR_RootConstrainSelectedInstOperands,
     /*  42208 */     // GIR_Coverage, 25249,
     /*  42208 */     GIR_EraseRootFromParent_Done,
     /*  42209 */   // Label 1009: @42209
     /*  42209 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(42271), // Rule ID 5833 //
     /*  42214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42253 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rm),
     /*  42256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42260 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42269 */     GIR_RootConstrainSelectedInstOperands,
     /*  42270 */     // GIR_Coverage, 5833,
     /*  42270 */     GIR_EraseRootFromParent_Done,
     /*  42271 */   // Label 1010: @42271
     /*  42271 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(42333), // Rule ID 18110 //
     /*  42276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42308 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42315 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  42318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42331 */     GIR_RootConstrainSelectedInstOperands,
     /*  42332 */     // GIR_Coverage, 18110,
     /*  42332 */     GIR_EraseRootFromParent_Done,
     /*  42333 */   // Label 1011: @42333
     /*  42333 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(42395), // Rule ID 18140 //
     /*  42338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42370 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42377 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  42380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42393 */     GIR_RootConstrainSelectedInstOperands,
     /*  42394 */     // GIR_Coverage, 18140,
     /*  42394 */     GIR_EraseRootFromParent_Done,
     /*  42395 */   // Label 1012: @42395
     /*  42395 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(42627), // Rule ID 21949 //
     /*  42400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  42403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42415 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42425 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  42425 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  42428 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42432 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  42439 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  42442 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42446 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42451 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  42454 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42458 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  42461 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42466 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42471 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42476 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  42479 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42483 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  42490 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  42493 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42497 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42502 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  42505 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42509 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  42512 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42517 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42522 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42527 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  42530 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42534 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42541 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  42544 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42548 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42553 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  42560 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  42563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  42568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  42581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42593 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  42596 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  42599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  42602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  42616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  42621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  42626 */     // GIR_Coverage, 21949,
     /*  42626 */     GIR_EraseRootFromParent_Done,
     /*  42627 */   // Label 1013: @42627
     /*  42627 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(42673), // Rule ID 21957 //
     /*  42632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  42635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42647 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42657 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, immAllOnesV:{ *:[v8i32] })  =>  (VPTERNLOGQZ256rri:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, VR256X:{ *:[v8i32] }:$src, 15:{ *:[i8] })
     /*  42657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  42660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42662 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42664 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42671 */     GIR_RootConstrainSelectedInstOperands,
     /*  42672 */     // GIR_Coverage, 21957,
     /*  42672 */     GIR_EraseRootFromParent_Done,
     /*  42673 */   // Label 1014: @42673
     /*  42673 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(42700), // Rule ID 5830 //
     /*  42678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  42681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  42693 */     // (xor:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPXORDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  42693 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZ256rr),
     /*  42698 */     GIR_RootConstrainSelectedInstOperands,
     /*  42699 */     // GIR_Coverage, 5830,
     /*  42699 */     GIR_Done,
     /*  42700 */   // Label 1015: @42700
     /*  42700 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(42727), // Rule ID 18098 //
     /*  42705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  42708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42720 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPXORYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  42725 */     GIR_RootConstrainSelectedInstOperands,
     /*  42726 */     // GIR_Coverage, 18098,
     /*  42726 */     GIR_Done,
     /*  42727 */   // Label 1016: @42727
     /*  42727 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(42754), // Rule ID 18124 //
     /*  42732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  42735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  42747 */     // (xor:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VXORPSYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  42747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  42752 */     GIR_RootConstrainSelectedInstOperands,
     /*  42753 */     // GIR_Coverage, 18124,
     /*  42753 */     GIR_Done,
     /*  42754 */   // Label 1017: @42754
     /*  42754 */   GIM_Reject,
     /*  42755 */ // Label 1006: @42755
     /*  42755 */ GIM_Reject,
     /*  42756 */ // Label 863: @42756
     /*  42756 */ GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(42953),
     /*  42761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  42764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  42767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42771 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(42829), // Rule ID 24209 //
     /*  42776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42811 */     // (xor:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  42818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42827 */     GIR_RootConstrainSelectedInstOperands,
     /*  42828 */     // GIR_Coverage, 24209,
     /*  42828 */     GIR_EraseRootFromParent_Done,
     /*  42829 */   // Label 1019: @42829
     /*  42829 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(42887), // Rule ID 5797 //
     /*  42834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  42849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  42852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  42856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  42860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  42869 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  42869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  42872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  42876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  42880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  42885 */     GIR_RootConstrainSelectedInstOperands,
     /*  42886 */     // GIR_Coverage, 5797,
     /*  42886 */     GIR_EraseRootFromParent_Done,
     /*  42887 */   // Label 1020: @42887
     /*  42887 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(42929), // Rule ID 21942 //
     /*  42892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  42911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42913 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, immAllOnesV:{ *:[v8i64] })  =>  (VPTERNLOGQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, VR512:{ *:[v8i64] }:$src, 15:{ *:[i8] })
     /*  42913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  42916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42920 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42922 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  42924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  42927 */     GIR_RootConstrainSelectedInstOperands,
     /*  42928 */     // GIR_Coverage, 21942,
     /*  42928 */     GIR_EraseRootFromParent_Done,
     /*  42929 */   // Label 1021: @42929
     /*  42929 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(42952), // Rule ID 5794 //
     /*  42934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  42945 */     // (xor:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPXORQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  42945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  42950 */     GIR_RootConstrainSelectedInstOperands,
     /*  42951 */     // GIR_Coverage, 5794,
     /*  42951 */     GIR_Done,
     /*  42952 */   // Label 1022: @42952
     /*  42952 */   GIM_Reject,
     /*  42953 */ // Label 1018: @42953
     /*  42953 */ GIM_Reject,
     /*  42954 */ // Label 864: @42954
     /*  42954 */ GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(43211),
     /*  42959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42969 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(43029), // Rule ID 23686 //
     /*  42974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  42977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  42989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  42993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  42998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43002 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43008 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43016 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }), VK16:{ *:[v16i1] }:$src2)  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  43027 */     GIR_RootConstrainSelectedInstOperands,
     /*  43028 */     // GIR_Coverage, 23686,
     /*  43028 */     GIR_EraseRootFromParent_Done,
     /*  43029 */   // Label 1024: @43029
     /*  43029 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(43092), // Rule ID 4424 //
     /*  43034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43067 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43077 */     // (xor:{ *:[v16i1] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2), immAllOnesV:{ *:[v16i1] })  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  43090 */     GIR_RootConstrainSelectedInstOperands,
     /*  43091 */     // GIR_Coverage, 4424,
     /*  43091 */     GIR_EraseRootFromParent_Done,
     /*  43092 */   // Label 1025: @43092
     /*  43092 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(43152), // Rule ID 23687 //
     /*  43097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  43116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  43120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43129 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43135 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  43137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43139 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src2, (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, immAllOnesV:{ *:[v16i1] }))  =>  (KXNORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORWkk),
     /*  43142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  43148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  43150 */     GIR_RootConstrainSelectedInstOperands,
     /*  43151 */     // GIR_Coverage, 23687,
     /*  43151 */     GIR_EraseRootFromParent_Done,
     /*  43152 */   // Label 1026: @43152
     /*  43152 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(43187), // Rule ID 4412 //
     /*  43157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43168 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43174 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43178 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src, immAllOnesV:{ *:[v16i1] })  =>  (KNOTWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src)
     /*  43178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /*  43181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43185 */     GIR_RootConstrainSelectedInstOperands,
     /*  43186 */     // GIR_Coverage, 4412,
     /*  43186 */     GIR_EraseRootFromParent_Done,
     /*  43187 */   // Label 1027: @43187
     /*  43187 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(43210), // Rule ID 4428 //
     /*  43192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  43195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  43203 */     // (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KXORWkk:{ *:[v16i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)
     /*  43203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORWkk),
     /*  43208 */     GIR_RootConstrainSelectedInstOperands,
     /*  43209 */     // GIR_Coverage, 4428,
     /*  43209 */     GIR_Done,
     /*  43210 */   // Label 1028: @43210
     /*  43210 */   GIM_Reject,
     /*  43211 */ // Label 1023: @43211
     /*  43211 */ GIM_Reject,
     /*  43212 */ // Label 865: @43212
     /*  43212 */ GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(43831),
     /*  43217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  43220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  43223 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(43285), // Rule ID 25257 //
     /*  43228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43267 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43283 */     GIR_RootConstrainSelectedInstOperands,
     /*  43284 */     // GIR_Coverage, 25257,
     /*  43284 */     GIR_EraseRootFromParent_Done,
     /*  43285 */   // Label 1030: @43285
     /*  43285 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(43347), // Rule ID 25436 //
     /*  43290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43322 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43329 */     // (xor:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43334 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43345 */     GIR_RootConstrainSelectedInstOperands,
     /*  43346 */     // GIR_Coverage, 25436,
     /*  43346 */     GIR_EraseRootFromParent_Done,
     /*  43347 */   // Label 1031: @43347
     /*  43347 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(43409), // Rule ID 18164 //
     /*  43352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43371 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43374 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43378 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43384 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43391 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORrm),
     /*  43394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43398 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43407 */     GIR_RootConstrainSelectedInstOperands,
     /*  43408 */     // GIR_Coverage, 18164,
     /*  43408 */     GIR_EraseRootFromParent_Done,
     /*  43409 */   // Label 1032: @43409
     /*  43409 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(43471), // Rule ID 20028 //
     /*  43414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43453 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rm),
     /*  43456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43458 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  43460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43469 */     GIR_RootConstrainSelectedInstOperands,
     /*  43470 */     // GIR_Coverage, 20028,
     /*  43470 */     GIR_EraseRootFromParent_Done,
     /*  43471 */   // Label 1033: @43471
     /*  43471 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(43703), // Rule ID 21943 //
     /*  43476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  43479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  43483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43491 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43497 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43501 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] }), 15:{ *:[i8] }), sub_xmm:{ *:[i32] })
     /*  43501 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  43504 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43508 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  43515 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  43518 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43522 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43527 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  43530 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43534 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/11,
     /*  43537 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43542 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43547 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43552 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  43555 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43559 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  43566 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  43569 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43573 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43578 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  43581 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43585 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /*  43588 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43593 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43598 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43603 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  43606 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43610 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  43620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43629 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43632 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  43636 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /*  43639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  43644 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43649 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /*  43654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  43657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  43661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43666 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43669 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  43672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  43675 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  43678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43685 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /*  43692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  43697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  43702 */     // GIR_Coverage, 21943,
     /*  43702 */     GIR_EraseRootFromParent_Done,
     /*  43703 */   // Label 1034: @43703
     /*  43703 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(43749), // Rule ID 21951 //
     /*  43708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  43731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43733 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, immAllOnesV:{ *:[v16i8] })  =>  (VPTERNLOGQZ128rri:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, VR128X:{ *:[v16i8] }:$src, 15:{ *:[i8] })
     /*  43733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ128rri),
     /*  43736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  43744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  43747 */     GIR_RootConstrainSelectedInstOperands,
     /*  43748 */     // GIR_Coverage, 21951,
     /*  43748 */     GIR_EraseRootFromParent_Done,
     /*  43749 */   // Label 1035: @43749
     /*  43749 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(43776), // Rule ID 18152 //
     /*  43754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  43757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43769 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORrr),
     /*  43774 */     GIR_RootConstrainSelectedInstOperands,
     /*  43775 */     // GIR_Coverage, 18152,
     /*  43775 */     GIR_Done,
     /*  43776 */   // Label 1036: @43776
     /*  43776 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(43803), // Rule ID 18176 //
     /*  43781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  43784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  43796 */     // (xor:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PXORrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  43796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PXORrr),
     /*  43801 */     GIR_RootConstrainSelectedInstOperands,
     /*  43802 */     // GIR_Coverage, 18176,
     /*  43802 */     GIR_Done,
     /*  43803 */   // Label 1037: @43803
     /*  43803 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(43830), // Rule ID 20020 //
     /*  43808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  43823 */     // (xor:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPXORQZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /*  43823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ128rr),
     /*  43828 */     GIR_RootConstrainSelectedInstOperands,
     /*  43829 */     // GIR_Coverage, 20020,
     /*  43829 */     GIR_Done,
     /*  43830 */   // Label 1038: @43830
     /*  43830 */   GIM_Reject,
     /*  43831 */ // Label 1029: @43831
     /*  43831 */ GIM_Reject,
     /*  43832 */ // Label 866: @43832
     /*  43832 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(44575),
     /*  43837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  43840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  43843 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(43905), // Rule ID 25237 //
     /*  43848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  43851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43863 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43866 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43887 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  43890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43894 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43903 */     GIR_RootConstrainSelectedInstOperands,
     /*  43904 */     // GIR_Coverage, 25237,
     /*  43904 */     GIR_EraseRootFromParent_Done,
     /*  43905 */   // Label 1040: @43905
     /*  43905 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(43967), // Rule ID 25248 //
     /*  43910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  43913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  43940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  43949 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  43949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  43952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  43956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  43960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  43965 */     GIR_RootConstrainSelectedInstOperands,
     /*  43966 */     // GIR_Coverage, 25248,
     /*  43966 */     GIR_EraseRootFromParent_Done,
     /*  43967 */   // Label 1041: @43967
     /*  43967 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(44029), // Rule ID 25443 //
     /*  43972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  43975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  43979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  43987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  43990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  43994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  43998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44011 */     // (xor:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44027 */     GIR_RootConstrainSelectedInstOperands,
     /*  44028 */     // GIR_Coverage, 25443,
     /*  44028 */     GIR_EraseRootFromParent_Done,
     /*  44029 */   // Label 1042: @44029
     /*  44029 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(44091), // Rule ID 18109 //
     /*  44034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44073 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  44076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44089 */     GIR_RootConstrainSelectedInstOperands,
     /*  44090 */     // GIR_Coverage, 18109,
     /*  44090 */     GIR_EraseRootFromParent_Done,
     /*  44091 */   // Label 1043: @44091
     /*  44091 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(44153), // Rule ID 18139 //
     /*  44096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44135 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  44138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44151 */     GIR_RootConstrainSelectedInstOperands,
     /*  44152 */     // GIR_Coverage, 18139,
     /*  44152 */     GIR_EraseRootFromParent_Done,
     /*  44153 */   // Label 1044: @44153
     /*  44153 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(44215), // Rule ID 20045 //
     /*  44158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44177 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44180 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44184 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44197 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  44200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44202 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44213 */     GIR_RootConstrainSelectedInstOperands,
     /*  44214 */     // GIR_Coverage, 20045,
     /*  44214 */     GIR_EraseRootFromParent_Done,
     /*  44215 */   // Label 1045: @44215
     /*  44215 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(44447), // Rule ID 21948 //
     /*  44220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  44223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44235 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44245 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  44245 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  44248 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44252 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  44259 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  44262 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44266 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44271 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  44274 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44278 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  44281 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44286 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44291 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44296 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  44299 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44303 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  44310 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  44313 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44317 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44322 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  44325 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44329 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  44332 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44337 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44342 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44347 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  44350 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44354 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  44361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  44364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  44368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44373 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  44376 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  44380 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  44383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  44388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  44401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  44413 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  44416 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  44419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  44422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  44424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  44427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  44436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  44441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  44446 */     // GIR_Coverage, 21948,
     /*  44446 */     GIR_EraseRootFromParent_Done,
     /*  44447 */   // Label 1046: @44447
     /*  44447 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(44493), // Rule ID 21956 //
     /*  44452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44467 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44473 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44477 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, immAllOnesV:{ *:[v16i16] })  =>  (VPTERNLOGQZ256rri:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, VR256X:{ *:[v16i16] }:$src, 15:{ *:[i8] })
     /*  44477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  44480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44484 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44486 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44491 */     GIR_RootConstrainSelectedInstOperands,
     /*  44492 */     // GIR_Coverage, 21956,
     /*  44492 */     GIR_EraseRootFromParent_Done,
     /*  44493 */   // Label 1047: @44493
     /*  44493 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(44520), // Rule ID 18097 //
     /*  44498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  44501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44513 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPXORYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  44518 */     GIR_RootConstrainSelectedInstOperands,
     /*  44519 */     // GIR_Coverage, 18097,
     /*  44519 */     GIR_Done,
     /*  44520 */   // Label 1048: @44520
     /*  44520 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(44547), // Rule ID 18123 //
     /*  44525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  44528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  44540 */     // (xor:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VXORPSYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  44540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  44545 */     GIR_RootConstrainSelectedInstOperands,
     /*  44546 */     // GIR_Coverage, 18123,
     /*  44546 */     GIR_Done,
     /*  44547 */   // Label 1049: @44547
     /*  44547 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(44574), // Rule ID 20037 //
     /*  44552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  44555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  44567 */     // (xor:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPXORQZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /*  44567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  44572 */     GIR_RootConstrainSelectedInstOperands,
     /*  44573 */     // GIR_Coverage, 20037,
     /*  44573 */     GIR_Done,
     /*  44574 */   // Label 1050: @44574
     /*  44574 */   GIM_Reject,
     /*  44575 */ // Label 1039: @44575
     /*  44575 */ GIM_Reject,
     /*  44576 */ // Label 867: @44576
     /*  44576 */ GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(44773),
     /*  44581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  44584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  44587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44591 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(44649), // Rule ID 24227 //
     /*  44596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44624 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44631 */     // (xor:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  44638 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44647 */     GIR_RootConstrainSelectedInstOperands,
     /*  44648 */     // GIR_Coverage, 24227,
     /*  44648 */     GIR_EraseRootFromParent_Done,
     /*  44649 */   // Label 1052: @44649
     /*  44649 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(44707), // Rule ID 5824 //
     /*  44654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  44669 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  44672 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  44676 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  44680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  44689 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  44689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORDZrm),
     /*  44692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  44696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  44700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  44705 */     GIR_RootConstrainSelectedInstOperands,
     /*  44706 */     // GIR_Coverage, 5824,
     /*  44706 */     GIR_EraseRootFromParent_Done,
     /*  44707 */   // Label 1053: @44707
     /*  44707 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(44749), // Rule ID 21941 //
     /*  44712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44723 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44733 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, immAllOnesV:{ *:[v16i32] })  =>  (VPTERNLOGQZrri:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, VR512:{ *:[v16i32] }:$src, 15:{ *:[i8] })
     /*  44733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  44736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  44744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  44747 */     GIR_RootConstrainSelectedInstOperands,
     /*  44748 */     // GIR_Coverage, 21941,
     /*  44748 */     GIR_EraseRootFromParent_Done,
     /*  44749 */   // Label 1054: @44749
     /*  44749 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(44772), // Rule ID 5821 //
     /*  44754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  44757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  44765 */     // (xor:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPXORDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  44765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORDZrr),
     /*  44770 */     GIR_RootConstrainSelectedInstOperands,
     /*  44771 */     // GIR_Coverage, 5821,
     /*  44771 */     GIR_Done,
     /*  44772 */   // Label 1055: @44772
     /*  44772 */   GIM_Reject,
     /*  44773 */ // Label 1051: @44773
     /*  44773 */ GIM_Reject,
     /*  44774 */ // Label 868: @44774
     /*  44774 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(45031),
     /*  44779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44789 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(44849), // Rule ID 23688 //
     /*  44794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44822 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44828 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44836 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }), VK32:{ *:[v32i1] }:$src2)  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  44847 */     GIR_RootConstrainSelectedInstOperands,
     /*  44848 */     // GIR_Coverage, 23688,
     /*  44848 */     GIR_EraseRootFromParent_Done,
     /*  44849 */   // Label 1057: @44849
     /*  44849 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(44912), // Rule ID 4425 //
     /*  44854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44887 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44893 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44897 */     // (xor:{ *:[v32i1] } (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2), immAllOnesV:{ *:[v32i1] })  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  44910 */     GIR_RootConstrainSelectedInstOperands,
     /*  44911 */     // GIR_Coverage, 4425,
     /*  44911 */     GIR_EraseRootFromParent_Done,
     /*  44912 */   // Label 1058: @44912
     /*  44912 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(44972), // Rule ID 23689 //
     /*  44917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  44936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  44940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44949 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44955 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  44957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44959 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src2, (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, immAllOnesV:{ *:[v32i1] }))  =>  (KXNORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  44959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORDkk),
     /*  44962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  44968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  44970 */     GIR_RootConstrainSelectedInstOperands,
     /*  44971 */     // GIR_Coverage, 23689,
     /*  44971 */     GIR_EraseRootFromParent_Done,
     /*  44972 */   // Label 1059: @44972
     /*  44972 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(45007), // Rule ID 4413 //
     /*  44977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  44980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  44984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  44996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44998 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src, immAllOnesV:{ *:[v32i1] })  =>  (KNOTDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src)
     /*  44998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTDkk),
     /*  45001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45003 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45005 */     GIR_RootConstrainSelectedInstOperands,
     /*  45006 */     // GIR_Coverage, 4413,
     /*  45006 */     GIR_EraseRootFromParent_Done,
     /*  45007 */   // Label 1060: @45007
     /*  45007 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(45030), // Rule ID 4429 //
     /*  45012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  45019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  45023 */     // (xor:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KXORDkk:{ *:[v32i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)
     /*  45023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORDkk),
     /*  45028 */     GIR_RootConstrainSelectedInstOperands,
     /*  45029 */     // GIR_Coverage, 4429,
     /*  45029 */     GIR_Done,
     /*  45030 */   // Label 1061: @45030
     /*  45030 */   GIM_Reject,
     /*  45031 */ // Label 1056: @45031
     /*  45031 */ GIM_Reject,
     /*  45032 */ // Label 869: @45032
     /*  45032 */ GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(45775),
     /*  45037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /*  45040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  45043 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(45105), // Rule ID 25236 //
     /*  45048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45063 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45066 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45087 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45103 */     GIR_RootConstrainSelectedInstOperands,
     /*  45104 */     // GIR_Coverage, 25236,
     /*  45104 */     GIR_EraseRootFromParent_Done,
     /*  45105 */   // Label 1063: @45105
     /*  45105 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(45167), // Rule ID 25247 //
     /*  45110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45125 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45128 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45132 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45142 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45149 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45165 */     GIR_RootConstrainSelectedInstOperands,
     /*  45166 */     // GIR_Coverage, 25247,
     /*  45166 */     GIR_EraseRootFromParent_Done,
     /*  45167 */   // Label 1064: @45167
     /*  45167 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(45229), // Rule ID 25442 //
     /*  45172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45211 */     // (xor:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45216 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45218 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45227 */     GIR_RootConstrainSelectedInstOperands,
     /*  45228 */     // GIR_Coverage, 25442,
     /*  45228 */     GIR_EraseRootFromParent_Done,
     /*  45229 */   // Label 1065: @45229
     /*  45229 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(45291), // Rule ID 18108 //
     /*  45234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45253 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45256 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45266 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45273 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORYrm),
     /*  45276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45278 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45289 */     GIR_RootConstrainSelectedInstOperands,
     /*  45290 */     // GIR_Coverage, 18108,
     /*  45290 */     GIR_EraseRootFromParent_Done,
     /*  45291 */   // Label 1066: @45291
     /*  45291 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(45353), // Rule ID 18138 //
     /*  45296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45335 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VXORPSYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VXORPSYrm),
     /*  45338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45351 */     GIR_RootConstrainSelectedInstOperands,
     /*  45352 */     // GIR_Coverage, 18138,
     /*  45352 */     GIR_EraseRootFromParent_Done,
     /*  45353 */   // Label 1067: @45353
     /*  45353 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(45415), // Rule ID 20044 //
     /*  45358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45397 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rm),
     /*  45400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45413 */     GIR_RootConstrainSelectedInstOperands,
     /*  45414 */     // GIR_Coverage, 20044,
     /*  45414 */     GIR_EraseRootFromParent_Done,
     /*  45415 */   // Label 1068: @45415
     /*  45415 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(45647), // Rule ID 21947 //
     /*  45420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /*  45423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45435 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45445 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPTERNLOGQZrri:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] }), 15:{ *:[i8] }), sub_ymm:{ *:[i32] })
     /*  45445 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v8s64,
     /*  45448 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45452 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  45459 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /*  45462 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45466 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45471 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /*  45474 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45478 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/12,
     /*  45481 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45486 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45491 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45496 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /*  45499 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45503 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  45510 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /*  45513 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45517 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45522 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  45525 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45529 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /*  45532 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45537 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45542 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45547 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /*  45550 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  45554 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  45561 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /*  45564 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  45568 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45573 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  45576 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  45580 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /*  45583 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /*  45588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /*  45601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  45613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  45616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/5,
     /*  45619 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /*  45622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /*  45636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /*  45641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /*  45646 */     // GIR_Coverage, 21947,
     /*  45646 */     GIR_EraseRootFromParent_Done,
     /*  45647 */   // Label 1069: @45647
     /*  45647 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(45693), // Rule ID 21955 //
     /*  45652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45677 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, immAllOnesV:{ *:[v32i8] })  =>  (VPTERNLOGQZ256rri:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, VR256X:{ *:[v32i8] }:$src, 15:{ *:[i8] })
     /*  45677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZ256rri),
     /*  45680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45682 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45686 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45691 */     GIR_RootConstrainSelectedInstOperands,
     /*  45692 */     // GIR_Coverage, 21955,
     /*  45692 */     GIR_EraseRootFromParent_Done,
     /*  45693 */   // Label 1070: @45693
     /*  45693 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(45720), // Rule ID 18096 //
     /*  45698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /*  45701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45713 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPXORYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORYrr),
     /*  45718 */     GIR_RootConstrainSelectedInstOperands,
     /*  45719 */     // GIR_Coverage, 18096,
     /*  45719 */     GIR_Done,
     /*  45720 */   // Label 1071: @45720
     /*  45720 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(45747), // Rule ID 18122 //
     /*  45725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX1Only),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  45740 */     // (xor:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VXORPSYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  45740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VXORPSYrr),
     /*  45745 */     GIR_RootConstrainSelectedInstOperands,
     /*  45746 */     // GIR_Coverage, 18122,
     /*  45746 */     GIR_Done,
     /*  45747 */   // Label 1072: @45747
     /*  45747 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(45774), // Rule ID 20036 //
     /*  45752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  45755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  45767 */     // (xor:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPXORQZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /*  45767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZ256rr),
     /*  45772 */     GIR_RootConstrainSelectedInstOperands,
     /*  45773 */     // GIR_Coverage, 20036,
     /*  45773 */     GIR_Done,
     /*  45774 */   // Label 1073: @45774
     /*  45774 */   GIM_Reject,
     /*  45775 */ // Label 1062: @45775
     /*  45775 */ GIM_Reject,
     /*  45776 */ // Label 870: @45776
     /*  45776 */ GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(45973),
     /*  45781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  45784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /*  45787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45791 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(45849), // Rule ID 25449 //
     /*  45796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45831 */     // (xor:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  45838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45847 */     GIR_RootConstrainSelectedInstOperands,
     /*  45848 */     // GIR_Coverage, 25449,
     /*  45848 */     GIR_EraseRootFromParent_Done,
     /*  45849 */   // Label 1075: @45849
     /*  45849 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(45907), // Rule ID 20061 //
     /*  45854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  45869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  45872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  45876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  45880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  45889 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  45889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  45892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  45896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  45900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  45905 */     GIR_RootConstrainSelectedInstOperands,
     /*  45906 */     // GIR_Coverage, 20061,
     /*  45906 */     GIR_EraseRootFromParent_Done,
     /*  45907 */   // Label 1076: @45907
     /*  45907 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(45949), // Rule ID 21940 //
     /*  45912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  45931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45933 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, immAllOnesV:{ *:[v32i16] })  =>  (VPTERNLOGQZrri:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, VR512:{ *:[v32i16] }:$src, 15:{ *:[i8] })
     /*  45933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  45936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  45944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  45947 */     GIR_RootConstrainSelectedInstOperands,
     /*  45948 */     // GIR_Coverage, 21940,
     /*  45948 */     GIR_EraseRootFromParent_Done,
     /*  45949 */   // Label 1077: @45949
     /*  45949 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(45972), // Rule ID 20053 //
     /*  45954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  45957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  45965 */     // (xor:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPXORQZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /*  45965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  45970 */     GIR_RootConstrainSelectedInstOperands,
     /*  45971 */     // GIR_Coverage, 20053,
     /*  45971 */     GIR_Done,
     /*  45972 */   // Label 1078: @45972
     /*  45972 */   GIM_Reject,
     /*  45973 */ // Label 1074: @45973
     /*  45973 */ GIM_Reject,
     /*  45974 */ // Label 871: @45974
     /*  45974 */ GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(46231),
     /*  45979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  45982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  45985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  45989 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(46049), // Rule ID 23690 //
     /*  45994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  45997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46022 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46028 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46036 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }), VK64:{ *:[v64i1] }:$src2)  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46047 */     GIR_RootConstrainSelectedInstOperands,
     /*  46048 */     // GIR_Coverage, 23690,
     /*  46048 */     GIR_EraseRootFromParent_Done,
     /*  46049 */   // Label 1080: @46049
     /*  46049 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(46112), // Rule ID 4426 //
     /*  46054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46087 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46093 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46097 */     // (xor:{ *:[v64i1] } (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2), immAllOnesV:{ *:[v64i1] })  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  46110 */     GIR_RootConstrainSelectedInstOperands,
     /*  46111 */     // GIR_Coverage, 4426,
     /*  46111 */     GIR_EraseRootFromParent_Done,
     /*  46112 */   // Label 1081: @46112
     /*  46112 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(46172), // Rule ID 23691 //
     /*  46117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  46136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v64s1,
     /*  46140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46149 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46159 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src2, (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, immAllOnesV:{ *:[v64i1] }))  =>  (KXNORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KXNORQkk),
     /*  46162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  46168 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /*  46170 */     GIR_RootConstrainSelectedInstOperands,
     /*  46171 */     // GIR_Coverage, 23691,
     /*  46171 */     GIR_EraseRootFromParent_Done,
     /*  46172 */   // Label 1082: @46172
     /*  46172 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(46207), // Rule ID 4414 //
     /*  46177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46188 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46198 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src, immAllOnesV:{ *:[v64i1] })  =>  (KNOTQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src)
     /*  46198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KNOTQkk),
     /*  46201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46205 */     GIR_RootConstrainSelectedInstOperands,
     /*  46206 */     // GIR_Coverage, 4414,
     /*  46206 */     GIR_EraseRootFromParent_Done,
     /*  46207 */   // Label 1083: @46207
     /*  46207 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(46230), // Rule ID 4430 //
     /*  46212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46223 */     // (xor:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)  =>  (KXORQkk:{ *:[v64i1] } VK64:{ *:[v64i1] }:$src1, VK64:{ *:[v64i1] }:$src2)
     /*  46223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::KXORQkk),
     /*  46228 */     GIR_RootConstrainSelectedInstOperands,
     /*  46229 */     // GIR_Coverage, 4430,
     /*  46229 */     GIR_Done,
     /*  46230 */   // Label 1084: @46230
     /*  46230 */   GIM_Reject,
     /*  46231 */ // Label 1079: @46231
     /*  46231 */ GIM_Reject,
     /*  46232 */ // Label 872: @46232
     /*  46232 */ GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(46429),
     /*  46237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /*  46240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /*  46243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46247 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(46305), // Rule ID 25448 //
     /*  46252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46263 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46266 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46270 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46280 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46287 */     // (xor:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  46294 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46303 */     GIR_RootConstrainSelectedInstOperands,
     /*  46304 */     // GIR_Coverage, 25448,
     /*  46304 */     GIR_EraseRootFromParent_Done,
     /*  46305 */   // Label 1086: @46305
     /*  46305 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(46363), // Rule ID 20060 //
     /*  46310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  46325 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  46328 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  46332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  46336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  46345 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPXORQZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  46345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPXORQZrm),
     /*  46348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  46356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  46361 */     GIR_RootConstrainSelectedInstOperands,
     /*  46362 */     // GIR_Coverage, 20060,
     /*  46362 */     GIR_EraseRootFromParent_Done,
     /*  46363 */   // Label 1087: @46363
     /*  46363 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(46405), // Rule ID 21939 //
     /*  46368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  46387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46389 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, immAllOnesV:{ *:[v64i8] })  =>  (VPTERNLOGQZrri:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, VR512:{ *:[v64i8] }:$src, 15:{ *:[i8] })
     /*  46389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPTERNLOGQZrri),
     /*  46392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46394 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  46400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /*  46403 */     GIR_RootConstrainSelectedInstOperands,
     /*  46404 */     // GIR_Coverage, 21939,
     /*  46404 */     GIR_EraseRootFromParent_Done,
     /*  46405 */   // Label 1088: @46405
     /*  46405 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(46428), // Rule ID 20052 //
     /*  46410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  46421 */     // (xor:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPXORQZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /*  46421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPXORQZrr),
     /*  46426 */     GIR_RootConstrainSelectedInstOperands,
     /*  46427 */     // GIR_Coverage, 20052,
     /*  46427 */     GIR_Done,
     /*  46428 */   // Label 1089: @46428
     /*  46428 */   GIM_Reject,
     /*  46429 */ // Label 1085: @46429
     /*  46429 */ GIM_Reject,
     /*  46430 */ // Label 873: @46430
     /*  46430 */ GIM_Reject,
     /*  46431 */ // Label 6: @46431
     /*  46431 */ GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(46597),
     /*  46436 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  46439 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(16), GIMT_Encode2(24), /*)*//*default:*//*Label 1094*/ GIMT_Encode4(46596),
     /*  46450 */   /*GILLT_v16s1*//*Label 1091*/ GIMT_Encode4(46482), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46466 */   /*GILLT_v32s1*//*Label 1092*/ GIMT_Encode4(46520), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46478 */   /*GILLT_v64s1*//*Label 1093*/ GIMT_Encode4(46558),
     /*  46482 */   // Label 1091: @46482
     /*  46482 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(46519), // Rule ID 19503 //
     /*  46487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  46490 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  46496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46508 */     // (concat_vectors:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src1, VK8:{ *:[v8i1] }:$src2)  =>  (KUNPCKBWkk:{ *:[v16i1] } VK8:{ *:[v8i1] }:$src2, VK8:{ *:[v8i1] }:$src1)
     /*  46508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKBWkk),
     /*  46511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46513 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46517 */     GIR_RootConstrainSelectedInstOperands,
     /*  46518 */     // GIR_Coverage, 19503,
     /*  46518 */     GIR_EraseRootFromParent_Done,
     /*  46519 */   // Label 1095: @46519
     /*  46519 */   GIM_Reject,
     /*  46520 */   // Label 1092: @46520
     /*  46520 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(46557), // Rule ID 19504 //
     /*  46525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46528 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  46534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46546 */     // (concat_vectors:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src1, VK16:{ *:[v16i1] }:$src2)  =>  (KUNPCKWDkk:{ *:[v32i1] } VK16:{ *:[v16i1] }:$src2, VK16:{ *:[v16i1] }:$src1)
     /*  46546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKWDkk),
     /*  46549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46553 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46555 */     GIR_RootConstrainSelectedInstOperands,
     /*  46556 */     // GIR_Coverage, 19504,
     /*  46556 */     GIR_EraseRootFromParent_Done,
     /*  46557 */   // Label 1096: @46557
     /*  46557 */   GIM_Reject,
     /*  46558 */   // Label 1093: @46558
     /*  46558 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(46595), // Rule ID 19505 //
     /*  46563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  46566 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  46569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /*  46572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  46576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  46584 */     // (concat_vectors:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src1, VK32:{ *:[v32i1] }:$src2)  =>  (KUNPCKDQkk:{ *:[v64i1] } VK32:{ *:[v32i1] }:$src2, VK32:{ *:[v32i1] }:$src1)
     /*  46584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KUNPCKDQkk),
     /*  46587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /*  46591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  46593 */     GIR_RootConstrainSelectedInstOperands,
     /*  46594 */     // GIR_Coverage, 19505,
     /*  46594 */     GIR_EraseRootFromParent_Done,
     /*  46595 */   // Label 1097: @46595
     /*  46595 */   GIM_Reject,
     /*  46596 */   // Label 1094: @46596
     /*  46596 */   GIM_Reject,
     /*  46597 */ // Label 1090: @46597
     /*  46597 */ GIM_Reject,
     /*  46598 */ // Label 7: @46598
     /*  46598 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(24), /*)*//*default:*//*Label 1106*/ GIMT_Encode4(48887),
     /*  46609 */ /*GILLT_s8*//*Label 1098*/ GIMT_Encode4(46701),
     /*  46613 */ /*GILLT_s16*//*Label 1099*/ GIMT_Encode4(46762),
     /*  46617 */ /*GILLT_s32*//*Label 1100*/ GIMT_Encode4(47592),
     /*  46621 */ /*GILLT_s64*//*Label 1101*/ GIMT_Encode4(48018), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46653 */ /*GILLT_v8s1*//*Label 1102*/ GIMT_Encode4(48444), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46669 */ /*GILLT_v16s1*//*Label 1103*/ GIMT_Encode4(48605), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46685 */ /*GILLT_v32s1*//*Label 1104*/ GIMT_Encode4(48745), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  46697 */ /*GILLT_v64s1*//*Label 1105*/ GIMT_Encode4(48816),
     /*  46701 */ // Label 1098: @46701
     /*  46701 */ GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(46761), // Rule ID 19434 //
     /*  46706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  46709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  46713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  46717 */   // (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /*  46717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46729 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46733 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46743 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /*  46750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /*  46755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46760 */   // GIR_Coverage, 19434,
     /*  46760 */   GIR_EraseRootFromParent_Done,
     /*  46761 */ // Label 1107: @46761
     /*  46761 */ GIM_Reject,
     /*  46762 */ // Label 1099: @46762
     /*  46762 */ GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(46822), // Rule ID 19431 //
     /*  46767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  46770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  46778 */   // (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /*  46778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46790 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46794 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  46799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46804 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  46821 */   // GIR_Coverage, 19431,
     /*  46821 */   GIR_EraseRootFromParent_Done,
     /*  46822 */ // Label 1108: @46822
     /*  46822 */ GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(46923), // Rule ID 22140 //
     /*  46827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46841 */   // (bitconvert:{ *:[f16] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VMOVW2SHrr:{ *:[f128] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })), FR16X:{ *:[i32] })
     /*  46841 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  46844 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46848 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46853 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46855 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  46858 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46862 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46867 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46870 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46874 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/4,
     /*  46877 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46882 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  46887 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  46892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  46895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVW2SHrr),
     /*  46899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46904 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  46917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  46922 */   // GIR_Coverage, 22140,
     /*  46922 */   GIR_EraseRootFromParent_Done,
     /*  46923 */ // Label 1109: @46923
     /*  46923 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(47003), // Rule ID 22153 //
     /*  46928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  46931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  46934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  46938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  46942 */   // (bitconvert:{ *:[i16] } FR16X:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VMOVSH2Wrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f128] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /*  46942 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  46945 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46949 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46954 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  46958 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  46963 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  46966 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSH2Wrr),
     /*  46970 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46975 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46985 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  46992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  46997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47002 */   // GIR_Coverage, 22153,
     /*  47002 */   GIR_EraseRootFromParent_Done,
     /*  47003 */ // Label 1110: @47003
     /*  47003 */ GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(47082), // Rule ID 18340 //
     /*  47008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  47011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47018 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47030 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47034 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWrri),
     /*  47046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47051 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47054 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47064 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47081 */   // GIR_Coverage, 18340,
     /*  47081 */   GIR_EraseRootFromParent_Done,
     /*  47082 */ // Label 1111: @47082
     /*  47082 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(47199), // Rule ID 18341 //
     /*  47087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  47090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47097 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47097 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47100 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47104 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47111 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47114 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47118 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47123 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47126 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47130 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47133 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47138 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47143 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47148 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47151 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47155 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47160 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrri),
     /*  47169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47174 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47177 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47180 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47198 */   // GIR_Coverage, 18341,
     /*  47198 */   GIR_EraseRootFromParent_Done,
     /*  47199 */ // Label 1112: @47199
     /*  47199 */ GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(47278), // Rule ID 18337 //
     /*  47204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47214 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47214 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47217 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47221 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47226 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47230 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  47235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  47242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47247 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47250 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47253 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47260 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47267 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47272 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47277 */   // GIR_Coverage, 18337,
     /*  47277 */   GIR_EraseRootFromParent_Done,
     /*  47278 */ // Label 1113: @47278
     /*  47278 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(47395), // Rule ID 18338 //
     /*  47283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  47293 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  47293 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47296 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47300 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47307 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47310 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47314 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47319 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47322 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47326 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47329 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47334 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47339 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47344 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47347 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47351 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrri),
     /*  47365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47370 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47373 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47376 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  47394 */   // GIR_Coverage, 18338,
     /*  47394 */   GIR_EraseRootFromParent_Done,
     /*  47395 */ // Label 1114: @47395
     /*  47395 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(47474), // Rule ID 21841 //
     /*  47400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  47410 */   // (bitconvert:{ *:[i16] } f16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VPEXTRWZrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16X:{ *:[f16] }:$src, VR128X:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] })
     /*  47410 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47413 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47417 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47422 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47426 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR128XRegClassID),
     /*  47431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZrri),
     /*  47438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47443 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47446 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47454 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47456 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  47463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  47468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  47473 */   // GIR_Coverage, 21841,
     /*  47473 */   GIR_EraseRootFromParent_Done,
     /*  47474 */ // Label 1115: @47474
     /*  47474 */ GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(47591), // Rule ID 21842 //
     /*  47479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  47482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  47485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  47489 */   // (bitconvert:{ *:[f16] } i16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrri:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  47489 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  47492 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47496 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  47503 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  47506 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47510 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47515 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  47518 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  47522 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/4,
     /*  47525 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47530 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  47535 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  47540 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47543 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47547 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  47554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  47557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrri),
     /*  47561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47566 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47569 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  47572 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  47575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  47585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  47590 */   // GIR_Coverage, 21842,
     /*  47590 */   GIR_EraseRootFromParent_Done,
     /*  47591 */ // Label 1116: @47591
     /*  47591 */ GIM_Reject,
     /*  47592 */ // Label 1100: @47592
     /*  47592 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(47658), // Rule ID 22525 //
     /*  47597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  47600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47615 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47622 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47629 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47635 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47642 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  47645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47647 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47656 */   GIR_RootConstrainSelectedInstOperands,
     /*  47657 */   // GIR_Coverage, 22525,
     /*  47657 */   GIR_EraseRootFromParent_Done,
     /*  47658 */ // Label 1117: @47658
     /*  47658 */ GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(47724), // Rule ID 22526 //
     /*  47663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47681 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47688 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47695 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47701 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47708 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  47711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47713 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47717 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47722 */   GIR_RootConstrainSelectedInstOperands,
     /*  47723 */   // GIR_Coverage, 22526,
     /*  47723 */   GIR_EraseRootFromParent_Done,
     /*  47724 */ // Label 1118: @47724
     /*  47724 */ GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(47790), // Rule ID 22527 //
     /*  47729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  47747 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  47750 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  47754 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  47761 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  47765 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47767 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  47774 */   // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>)  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  47774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  47777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47779 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  47783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  47788 */   GIR_RootConstrainSelectedInstOperands,
     /*  47789 */   // GIR_Coverage, 22527,
     /*  47789 */   GIR_EraseRootFromParent_Done,
     /*  47790 */ // Label 1119: @47790
     /*  47790 */ GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(47816), // Rule ID 2915 //
     /*  47795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47809 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSrr),
     /*  47814 */   GIR_RootConstrainSelectedInstOperands,
     /*  47815 */   // GIR_Coverage, 2915,
     /*  47815 */   GIR_Done,
     /*  47816 */ // Label 1120: @47816
     /*  47816 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(47842), // Rule ID 2916 //
     /*  47821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47835 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (MOVDI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47835 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVDI2SSrr),
     /*  47840 */   GIR_RootConstrainSelectedInstOperands,
     /*  47841 */   // GIR_Coverage, 2916,
     /*  47841 */   GIR_Done,
     /*  47842 */ // Label 1121: @47842
     /*  47842 */ GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(47868), // Rule ID 2925 //
     /*  47847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  47850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47861 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VMOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIrr),
     /*  47866 */   GIR_RootConstrainSelectedInstOperands,
     /*  47867 */   // GIR_Coverage, 2925,
     /*  47867 */   GIR_Done,
     /*  47868 */ // Label 1122: @47868
     /*  47868 */ GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(47894), // Rule ID 2926 //
     /*  47873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  47876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  47887 */   // (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (MOVSS2DIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  47887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSS2DIrr),
     /*  47892 */   GIR_RootConstrainSelectedInstOperands,
     /*  47893 */   // GIR_Coverage, 2926,
     /*  47893 */   GIR_Done,
     /*  47894 */ // Label 1123: @47894
     /*  47894 */ GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(47920), // Rule ID 4598 //
     /*  47899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47913 */   // (bitconvert:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /*  47913 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  47918 */   GIR_RootConstrainSelectedInstOperands,
     /*  47919 */   // GIR_Coverage, 4598,
     /*  47919 */   GIR_Done,
     /*  47920 */ // Label 1124: @47920
     /*  47920 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(47946), // Rule ID 4603 //
     /*  47925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  47928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  47931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47939 */   // (bitconvert:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  47939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  47944 */   GIR_RootConstrainSelectedInstOperands,
     /*  47945 */   // GIR_Coverage, 4603,
     /*  47945 */   GIR_Done,
     /*  47946 */ // Label 1125: @47946
     /*  47946 */ GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(47973), // Rule ID 19442 //
     /*  47951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  47958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47962 */   // (bitconvert:{ *:[i32] } VK32:{ *:[v32i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK32:{ *:[v32i1] }:$src, GR32:{ *:[i32] })
     /*  47962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47967 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /*  47972 */   // GIR_Coverage, 19442,
     /*  47972 */   GIR_Done,
     /*  47973 */ // Label 1126: @47973
     /*  47973 */ GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(48017), // Rule ID 19876 //
     /*  47978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /*  47981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  47985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  47989 */   // (bitconvert:{ *:[f32] } VK32:{ *:[v32i1] }:$src)  =>  (VMOVDI2SSZrr:{ *:[f32] } (KMOVDrk:{ *:[i32] } VK32:{ *:[v32i1] }:$src))
     /*  47989 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  47992 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVDrk),
     /*  47996 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48001 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDI2SSZrr),
     /*  48010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48015 */   GIR_RootConstrainSelectedInstOperands,
     /*  48016 */   // GIR_Coverage, 19876,
     /*  48016 */   GIR_EraseRootFromParent_Done,
     /*  48017 */ // Label 1127: @48017
     /*  48017 */ GIM_Reject,
     /*  48018 */ // Label 1101: @48018
     /*  48018 */ GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(48084), // Rule ID 22528 //
     /*  48023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48041 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48044 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48048 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48055 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48059 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48061 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48068 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  48071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48073 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48082 */   GIR_RootConstrainSelectedInstOperands,
     /*  48083 */   // GIR_Coverage, 22528,
     /*  48083 */   GIR_EraseRootFromParent_Done,
     /*  48084 */ // Label 1128: @48084
     /*  48084 */ GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(48150), // Rule ID 22529 //
     /*  48089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48107 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48110 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48114 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48121 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48127 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48134 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  48137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48139 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48148 */   GIR_RootConstrainSelectedInstOperands,
     /*  48149 */   // GIR_Coverage, 22529,
     /*  48149 */   GIR_EraseRootFromParent_Done,
     /*  48150 */ // Label 1129: @48150
     /*  48150 */ GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(48216), // Rule ID 22530 //
     /*  48155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48173 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  48176 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48180 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  48187 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48193 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48200 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>)  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  48200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  48203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48205 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48214 */   GIR_RootConstrainSelectedInstOperands,
     /*  48215 */   // GIR_Coverage, 22530,
     /*  48215 */   GIR_EraseRootFromParent_Done,
     /*  48216 */ // Label 1130: @48216
     /*  48216 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(48242), // Rule ID 2910 //
     /*  48221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48235 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDrr),
     /*  48240 */   GIR_RootConstrainSelectedInstOperands,
     /*  48241 */   // GIR_Coverage, 2910,
     /*  48241 */   GIR_Done,
     /*  48242 */ // Label 1131: @48242
     /*  48242 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(48268), // Rule ID 2914 //
     /*  48247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48261 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (MOV64toSDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOV64toSDrr),
     /*  48266 */   GIR_RootConstrainSelectedInstOperands,
     /*  48267 */   // GIR_Coverage, 2914,
     /*  48267 */   GIR_Done,
     /*  48268 */ // Label 1132: @48268
     /*  48268 */ GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(48294), // Rule ID 2923 //
     /*  48273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  48276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48287 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VMOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64rr),
     /*  48292 */   GIR_RootConstrainSelectedInstOperands,
     /*  48293 */   // GIR_Coverage, 2923,
     /*  48293 */   GIR_Done,
     /*  48294 */ // Label 1133: @48294
     /*  48294 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(48320), // Rule ID 2924 //
     /*  48299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  48302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  48313 */   // (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (MOVSDto64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  48313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSDto64rr),
     /*  48318 */   GIR_RootConstrainSelectedInstOperands,
     /*  48319 */   // GIR_Coverage, 2924,
     /*  48319 */   GIR_Done,
     /*  48320 */ // Label 1134: @48320
     /*  48320 */ GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(48346), // Rule ID 4596 //
     /*  48325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48339 */   // (bitconvert:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /*  48339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48344 */   GIR_RootConstrainSelectedInstOperands,
     /*  48345 */   // GIR_Coverage, 4596,
     /*  48345 */   GIR_Done,
     /*  48346 */ // Label 1135: @48346
     /*  48346 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(48372), // Rule ID 4597 //
     /*  48351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48365 */   // (bitconvert:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  48365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48370 */   GIR_RootConstrainSelectedInstOperands,
     /*  48371 */   // GIR_Coverage, 4597,
     /*  48371 */   GIR_Done,
     /*  48372 */ // Label 1136: @48372
     /*  48372 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(48399), // Rule ID 19444 //
     /*  48377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48388 */   // (bitconvert:{ *:[i64] } VK64:{ *:[v64i1] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i64] } VK64:{ *:[v64i1] }:$src, GR64:{ *:[i32] })
     /*  48388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48393 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  48398 */   // GIR_Coverage, 19444,
     /*  48398 */   GIR_Done,
     /*  48399 */ // Label 1137: @48399
     /*  48399 */ GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(48443), // Rule ID 19878 //
     /*  48404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /*  48407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48415 */   // (bitconvert:{ *:[f64] } VK64:{ *:[v64i1] }:$src)  =>  (VMOV64toSDZrr:{ *:[f64] } (KMOVQrk:{ *:[i64] } VK64:{ *:[v64i1] }:$src))
     /*  48415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVQrk),
     /*  48422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48427 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOV64toSDZrr),
     /*  48436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48441 */   GIR_RootConstrainSelectedInstOperands,
     /*  48442 */   // GIR_Coverage, 19878,
     /*  48442 */   GIR_EraseRootFromParent_Done,
     /*  48443 */ // Label 1138: @48443
     /*  48443 */ GIM_Reject,
     /*  48444 */ // Label 1102: @48444
     /*  48444 */ GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(48604),
     /*  48449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /*  48452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  48456 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(48529), // Rule ID 19448 //
     /*  48461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  48479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48492 */     // (bitconvert:{ *:[v8i1] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), VK8:{ *:[i32] })
     /*  48492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  48499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48504 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  48508 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48528 */     // GIR_Coverage, 19448,
     /*  48528 */     GIR_EraseRootFromParent_Done,
     /*  48529 */   // Label 1140: @48529
     /*  48529 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(48603), // Rule ID 19433 //
     /*  48534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  48538 */     // (bitconvert:{ *:[v8i1] } GR8:{ *:[i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src, sub_8bit:{ *:[i32] }), VK8:{ *:[i32] })
     /*  48538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48564 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48567 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  48574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /*  48584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /*  48589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /*  48602 */     // GIR_Coverage, 19433,
     /*  48602 */     GIR_EraseRootFromParent_Done,
     /*  48603 */   // Label 1141: @48603
     /*  48603 */   GIM_Reject,
     /*  48604 */ // Label 1139: @48604
     /*  48604 */ GIM_Reject,
     /*  48605 */ // Label 1103: @48605
     /*  48605 */ GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(48744),
     /*  48610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  48617 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(48669), // Rule ID 19449 //
     /*  48622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  48625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  48633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  48636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  48640 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  48644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  48653 */     // (bitconvert:{ *:[v16i1] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  48653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  48656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  48662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  48667 */     GIR_RootConstrainSelectedInstOperands,
     /*  48668 */     // GIR_Coverage, 19449,
     /*  48668 */     GIR_EraseRootFromParent_Done,
     /*  48669 */   // Label 1143: @48669
     /*  48669 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(48743), // Rule ID 19430 //
     /*  48674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48678 */     // (bitconvert:{ *:[v16i1] } GR16:{ *:[i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] }), VK16:{ *:[i32] })
     /*  48678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  48681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  48685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  48692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  48699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  48707 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48711 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/4,
     /*  48714 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /*  48724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /*  48729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /*  48742 */     // GIR_Coverage, 19430,
     /*  48742 */     GIR_EraseRootFromParent_Done,
     /*  48743 */   // Label 1144: @48743
     /*  48743 */   GIM_Reject,
     /*  48744 */ // Label 1142: @48744
     /*  48744 */ GIM_Reject,
     /*  48745 */ // Label 1104: @48745
     /*  48745 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(48815),
     /*  48750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  48753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  48757 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(48777), // Rule ID 19441 //
     /*  48762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  48766 */     // (bitconvert:{ *:[v32i1] } GR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } GR32:{ *:[i32] }:$src, VK32:{ *:[i32] })
     /*  48766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /*  48776 */     // GIR_Coverage, 19441,
     /*  48776 */     GIR_Done,
     /*  48777 */   // Label 1146: @48777
     /*  48777 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(48814), // Rule ID 19875 //
     /*  48782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  48786 */     // (bitconvert:{ *:[v32i1] } FR32X:{ *:[f32] }:$src)  =>  (KMOVDkr:{ *:[v32i1] } (VMOVSS2DIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src))
     /*  48786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSS2DIZrr),
     /*  48793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkr),
     /*  48807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48812 */     GIR_RootConstrainSelectedInstOperands,
     /*  48813 */     // GIR_Coverage, 19875,
     /*  48813 */     GIR_EraseRootFromParent_Done,
     /*  48814 */   // Label 1147: @48814
     /*  48814 */   GIM_Reject,
     /*  48815 */ // Label 1145: @48815
     /*  48815 */ GIM_Reject,
     /*  48816 */ // Label 1105: @48816
     /*  48816 */ GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(48886),
     /*  48821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  48824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  48828 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(48848), // Rule ID 19443 //
     /*  48833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  48837 */     // (bitconvert:{ *:[v64i1] } GR64:{ *:[i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v64i1] } GR64:{ *:[i64] }:$src, VK64:{ *:[i32] })
     /*  48837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK64RegClassID),
     /*  48847 */     // GIR_Coverage, 19443,
     /*  48847 */     GIR_Done,
     /*  48848 */   // Label 1149: @48848
     /*  48848 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(48885), // Rule ID 19877 //
     /*  48853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  48857 */     // (bitconvert:{ *:[v64i1] } FR64X:{ *:[f64] }:$src)  =>  (KMOVQkr:{ *:[v64i1] } (VMOVSDto64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src))
     /*  48857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  48860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVSDto64Zrr),
     /*  48864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  48873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkr),
     /*  48878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  48883 */     GIR_RootConstrainSelectedInstOperands,
     /*  48884 */     // GIR_Coverage, 19877,
     /*  48884 */     GIR_EraseRootFromParent_Done,
     /*  48885 */   // Label 1150: @48885
     /*  48885 */   GIM_Reject,
     /*  48886 */ // Label 1148: @48886
     /*  48886 */ GIM_Reject,
     /*  48887 */ // Label 1106: @48887
     /*  48887 */ GIM_Reject,
     /*  48888 */ // Label 8: @48888
     /*  48888 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 1163*/ GIMT_Encode4(52065),
     /*  48899 */ /*GILLT_s16*//*Label 1151*/ GIMT_Encode4(48983),
     /*  48903 */ /*GILLT_s32*//*Label 1152*/ GIMT_Encode4(49044),
     /*  48907 */ /*GILLT_s64*//*Label 1153*/ GIMT_Encode4(49668), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48923 */ /*GILLT_v2s64*//*Label 1154*/ GIMT_Encode4(50292), GIMT_Encode4(0),
     /*  48931 */ /*GILLT_v4s32*//*Label 1155*/ GIMT_Encode4(50381),
     /*  48935 */ /*GILLT_v4s64*//*Label 1156*/ GIMT_Encode4(50827), GIMT_Encode4(0),
     /*  48943 */ /*GILLT_v8s16*//*Label 1157*/ GIMT_Encode4(51006),
     /*  48947 */ /*GILLT_v8s32*//*Label 1158*/ GIMT_Encode4(51095),
     /*  48951 */ /*GILLT_v8s64*//*Label 1159*/ GIMT_Encode4(51446), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48963 */ /*GILLT_v16s16*//*Label 1160*/ GIMT_Encode4(51714),
     /*  48967 */ /*GILLT_v16s32*//*Label 1161*/ GIMT_Encode4(51803), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48979 */ /*GILLT_v32s16*//*Label 1162*/ GIMT_Encode4(51976),
     /*  48983 */ // Label 1151: @48983
     /*  48983 */ GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(49043), // Rule ID 22169 //
     /*  48988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  48991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  48994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  48998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49002 */   // (lrint:{ *:[i16] } FR16:{ *:[f16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src), sub_16bit:{ *:[i32] })
     /*  49002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49014 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  49018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49025 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  49032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  49037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  49042 */   // GIR_Coverage, 22169,
     /*  49042 */   GIR_EraseRootFromParent_Done,
     /*  49043 */ // Label 1164: @49043
     /*  49043 */ GIM_Reject,
     /*  49044 */ // Label 1152: @49044
     /*  49044 */ GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(49103), // Rule ID 1756 //
     /*  49049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49059 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49067 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49070 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49074 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49080 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49087 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrm),
     /*  49090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49092 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49096 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49101 */   GIR_RootConstrainSelectedInstOperands,
     /*  49102 */   // GIR_Coverage, 1756,
     /*  49102 */   GIR_EraseRootFromParent_Done,
     /*  49103 */ // Label 1165: @49103
     /*  49103 */ GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(49162), // Rule ID 1760 //
     /*  49108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49118 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49122 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49126 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49129 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49133 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49137 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49139 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49146 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrm),
     /*  49149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49151 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49160 */   GIR_RootConstrainSelectedInstOperands,
     /*  49161 */   // GIR_Coverage, 1760,
     /*  49161 */   GIR_EraseRootFromParent_Done,
     /*  49162 */ // Label 1166: @49162
     /*  49162 */ GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(49221), // Rule ID 1780 //
     /*  49167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49185 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49188 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49192 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49198 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49205 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrm),
     /*  49208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49210 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49219 */   GIR_RootConstrainSelectedInstOperands,
     /*  49220 */   // GIR_Coverage, 1780,
     /*  49220 */   GIR_EraseRootFromParent_Done,
     /*  49221 */ // Label 1167: @49221
     /*  49221 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(49280), // Rule ID 1784 //
     /*  49226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49236 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49240 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49244 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49247 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49251 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49257 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49264 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrm),
     /*  49267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49269 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49278 */   GIR_RootConstrainSelectedInstOperands,
     /*  49279 */   // GIR_Coverage, 1784,
     /*  49279 */   GIR_EraseRootFromParent_Done,
     /*  49280 */ // Label 1168: @49280
     /*  49280 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(49339), // Rule ID 10353 //
     /*  49285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49303 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49306 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49310 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49314 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49316 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49323 */   // (lrint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrm),
     /*  49326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49328 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49337 */   GIR_RootConstrainSelectedInstOperands,
     /*  49338 */   // GIR_Coverage, 10353,
     /*  49338 */   GIR_EraseRootFromParent_Done,
     /*  49339 */ // Label 1169: @49339
     /*  49339 */ GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(49398), // Rule ID 10357 //
     /*  49344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49362 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49365 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49369 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49373 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49375 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49382 */   // (lrint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrm),
     /*  49385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49387 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49396 */   GIR_RootConstrainSelectedInstOperands,
     /*  49397 */   // GIR_Coverage, 10357,
     /*  49397 */   GIR_EraseRootFromParent_Done,
     /*  49398 */ // Label 1170: @49398
     /*  49398 */ GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(49457), // Rule ID 22171 //
     /*  49403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49421 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49428 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49434 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49441 */   // (lrint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  49441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /*  49444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49446 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49455 */   GIR_RootConstrainSelectedInstOperands,
     /*  49456 */   // GIR_Coverage, 22171,
     /*  49456 */   GIR_EraseRootFromParent_Done,
     /*  49457 */ // Label 1171: @49457
     /*  49457 */ GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(49487), // Rule ID 1755 //
     /*  49462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49476 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIrr),
     /*  49481 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49485 */   GIR_RootConstrainSelectedInstOperands,
     /*  49486 */   // GIR_Coverage, 1755,
     /*  49486 */   GIR_Done,
     /*  49487 */ // Label 1172: @49487
     /*  49487 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(49517), // Rule ID 1759 //
     /*  49492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49506 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIrr),
     /*  49511 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49515 */   GIR_RootConstrainSelectedInstOperands,
     /*  49516 */   // GIR_Coverage, 1759,
     /*  49516 */   GIR_Done,
     /*  49517 */ // Label 1173: @49517
     /*  49517 */ GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(49547), // Rule ID 1779 //
     /*  49522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  49536 */   // (lrint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /*  49536 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SIrr),
     /*  49541 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49545 */   GIR_RootConstrainSelectedInstOperands,
     /*  49546 */   // GIR_Coverage, 1779,
     /*  49546 */   GIR_Done,
     /*  49547 */ // Label 1174: @49547
     /*  49547 */ GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(49577), // Rule ID 1783 //
     /*  49552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  49566 */   // (lrint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /*  49566 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SIrr),
     /*  49571 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49575 */   GIR_RootConstrainSelectedInstOperands,
     /*  49576 */   // GIR_Coverage, 1783,
     /*  49576 */   GIR_Done,
     /*  49577 */ // Label 1175: @49577
     /*  49577 */ GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(49607), // Rule ID 10352 //
     /*  49582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  49596 */   // (lrint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /*  49596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SIZrr),
     /*  49601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49605 */   GIR_RootConstrainSelectedInstOperands,
     /*  49606 */   // GIR_Coverage, 10352,
     /*  49606 */   GIR_Done,
     /*  49607 */ // Label 1176: @49607
     /*  49607 */ GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(49637), // Rule ID 10356 //
     /*  49612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  49626 */   // (lrint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /*  49626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SIZrr),
     /*  49631 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49635 */   GIR_RootConstrainSelectedInstOperands,
     /*  49636 */   // GIR_Coverage, 10356,
     /*  49636 */   GIR_Done,
     /*  49637 */ // Label 1177: @49637
     /*  49637 */ GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(49667), // Rule ID 22170 //
     /*  49642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  49645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  49648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  49652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  49656 */   // (lrint:{ *:[i32] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16:{ *:[f16] }:$src)
     /*  49656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /*  49661 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  49665 */   GIR_RootConstrainSelectedInstOperands,
     /*  49666 */   // GIR_Coverage, 22170,
     /*  49666 */   GIR_Done,
     /*  49667 */ // Label 1178: @49667
     /*  49667 */ GIM_Reject,
     /*  49668 */ // Label 1153: @49668
     /*  49668 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(49727), // Rule ID 17990 //
     /*  49673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49691 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49698 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49702 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49704 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49711 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  49714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49716 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49720 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49725 */   GIR_RootConstrainSelectedInstOperands,
     /*  49726 */   // GIR_Coverage, 17990,
     /*  49726 */   GIR_EraseRootFromParent_Done,
     /*  49727 */ // Label 1179: @49727
     /*  49727 */ GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(49786), // Rule ID 17992 //
     /*  49732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  49735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49750 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49753 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49757 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49763 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49770 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  49773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49775 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49779 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49784 */   GIR_RootConstrainSelectedInstOperands,
     /*  49785 */   // GIR_Coverage, 17992,
     /*  49785 */   GIR_EraseRootFromParent_Done,
     /*  49786 */ // Label 1180: @49786
     /*  49786 */ GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(49845), // Rule ID 17994 //
     /*  49791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  49794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49809 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49816 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49822 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49829 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  49832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49834 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49838 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49843 */   GIR_RootConstrainSelectedInstOperands,
     /*  49844 */   // GIR_Coverage, 17994,
     /*  49844 */   GIR_EraseRootFromParent_Done,
     /*  49845 */ // Label 1181: @49845
     /*  49845 */ GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(49904), // Rule ID 17996 //
     /*  49850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  49853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49868 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49871 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49875 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49881 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49888 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  49891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49893 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49902 */   GIR_RootConstrainSelectedInstOperands,
     /*  49903 */   // GIR_Coverage, 17996,
     /*  49903 */   GIR_EraseRootFromParent_Done,
     /*  49904 */ // Label 1182: @49904
     /*  49904 */ GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(49963), // Rule ID 21160 //
     /*  49909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  49915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49927 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49934 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49940 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  49947 */   // (lrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  49947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  49950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49952 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  49956 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  49961 */   GIR_RootConstrainSelectedInstOperands,
     /*  49962 */   // GIR_Coverage, 21160,
     /*  49962 */   GIR_EraseRootFromParent_Done,
     /*  49963 */ // Label 1183: @49963
     /*  49963 */ GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(50022), // Rule ID 21162 //
     /*  49968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  49971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  49974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  49978 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49982 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  49986 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  49989 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  49993 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  49997 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49999 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50006 */   // (lrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  50006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  50009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50011 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50015 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50020 */   GIR_RootConstrainSelectedInstOperands,
     /*  50021 */   // GIR_Coverage, 21162,
     /*  50021 */   GIR_EraseRootFromParent_Done,
     /*  50022 */ // Label 1184: @50022
     /*  50022 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(50081), // Rule ID 22173 //
     /*  50027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50045 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50048 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50052 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50056 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50058 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50065 */   // (lrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  50065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  50068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50070 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50079 */   GIR_RootConstrainSelectedInstOperands,
     /*  50080 */   // GIR_Coverage, 22173,
     /*  50080 */   GIR_EraseRootFromParent_Done,
     /*  50081 */ // Label 1185: @50081
     /*  50081 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(50111), // Rule ID 17989 //
     /*  50086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50100 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  50105 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50109 */   GIR_RootConstrainSelectedInstOperands,
     /*  50110 */   // GIR_Coverage, 17989,
     /*  50110 */   GIR_Done,
     /*  50111 */ // Label 1186: @50111
     /*  50111 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(50141), // Rule ID 17991 //
     /*  50116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  50119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50130 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  50135 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50139 */   GIR_RootConstrainSelectedInstOperands,
     /*  50140 */   // GIR_Coverage, 17991,
     /*  50140 */   GIR_Done,
     /*  50141 */ // Label 1187: @50141
     /*  50141 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(50171), // Rule ID 17993 //
     /*  50146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  50149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50160 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50160 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  50165 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50169 */   GIR_RootConstrainSelectedInstOperands,
     /*  50170 */   // GIR_Coverage, 17993,
     /*  50170 */   GIR_Done,
     /*  50171 */ // Label 1188: @50171
     /*  50171 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(50201), // Rule ID 17995 //
     /*  50176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50190 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  50195 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50199 */   GIR_RootConstrainSelectedInstOperands,
     /*  50200 */   // GIR_Coverage, 17995,
     /*  50200 */   GIR_Done,
     /*  50201 */ // Label 1189: @50201
     /*  50201 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(50231), // Rule ID 21159 //
     /*  50206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  50220 */   // (lrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  50220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  50225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50229 */   GIR_RootConstrainSelectedInstOperands,
     /*  50230 */   // GIR_Coverage, 21159,
     /*  50230 */   GIR_Done,
     /*  50231 */ // Label 1190: @50231
     /*  50231 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(50261), // Rule ID 21161 //
     /*  50236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  50239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  50242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  50250 */   // (lrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  50250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  50255 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50259 */   GIR_RootConstrainSelectedInstOperands,
     /*  50260 */   // GIR_Coverage, 21161,
     /*  50260 */   GIR_Done,
     /*  50261 */ // Label 1191: @50261
     /*  50261 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(50291), // Rule ID 22172 //
     /*  50266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  50269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  50272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  50276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  50280 */   // (lrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  50280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  50285 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50289 */   GIR_RootConstrainSelectedInstOperands,
     /*  50290 */   // GIR_Coverage, 22172,
     /*  50290 */   GIR_Done,
     /*  50291 */ // Label 1192: @50291
     /*  50291 */ GIM_Reject,
     /*  50292 */ // Label 1154: @50292
     /*  50292 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(50380),
     /*  50297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  50300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50304 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(50356), // Rule ID 21385 //
     /*  50309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50340 */     // (lrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  50340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  50343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50354 */     GIR_RootConstrainSelectedInstOperands,
     /*  50355 */     // GIR_Coverage, 21385,
     /*  50355 */     GIR_EraseRootFromParent_Done,
     /*  50356 */   // Label 1194: @50356
     /*  50356 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(50379), // Rule ID 21384 //
     /*  50361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50368 */     // (lrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  50368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  50373 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50377 */     GIR_RootConstrainSelectedInstOperands,
     /*  50378 */     // GIR_Coverage, 21384,
     /*  50378 */     GIR_Done,
     /*  50379 */   // Label 1195: @50379
     /*  50379 */   GIM_Reject,
     /*  50380 */ // Label 1193: @50380
     /*  50380 */ GIM_Reject,
     /*  50381 */ // Label 1155: @50381
     /*  50381 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(50440), // Rule ID 18044 //
     /*  50386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50404 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50411 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50415 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50417 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50424 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrm),
     /*  50427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50429 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50438 */   GIR_RootConstrainSelectedInstOperands,
     /*  50439 */   // GIR_Coverage, 18044,
     /*  50439 */   GIR_EraseRootFromParent_Done,
     /*  50440 */ // Label 1196: @50440
     /*  50440 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(50499), // Rule ID 18048 //
     /*  50445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50463 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50466 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50470 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50474 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50476 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50483 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrm),
     /*  50486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50488 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50497 */   GIR_RootConstrainSelectedInstOperands,
     /*  50498 */   // GIR_Coverage, 18048,
     /*  50498 */   GIR_EraseRootFromParent_Done,
     /*  50499 */ // Label 1197: @50499
     /*  50499 */ GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(50558), // Rule ID 18050 //
     /*  50504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50514 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50518 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50522 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50525 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50529 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50535 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50542 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTPS2DQrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrm),
     /*  50545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50547 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50551 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50556 */   GIR_RootConstrainSelectedInstOperands,
     /*  50557 */   // GIR_Coverage, 18050,
     /*  50557 */   GIR_EraseRootFromParent_Done,
     /*  50558 */ // Label 1198: @50558
     /*  50558 */ GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(50617), // Rule ID 21357 //
     /*  50563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50581 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50588 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50594 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50601 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rm),
     /*  50604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50610 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50615 */   GIR_RootConstrainSelectedInstOperands,
     /*  50616 */   // GIR_Coverage, 21357,
     /*  50616 */   GIR_EraseRootFromParent_Done,
     /*  50617 */ // Label 1199: @50617
     /*  50617 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(50676), // Rule ID 21361 //
     /*  50622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50640 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50643 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50647 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50653 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50660 */   // (lrint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZ256rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  50660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rm),
     /*  50663 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50665 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50674 */   GIR_RootConstrainSelectedInstOperands,
     /*  50675 */   // GIR_Coverage, 21361,
     /*  50675 */   GIR_EraseRootFromParent_Done,
     /*  50676 */ // Label 1200: @50676
     /*  50676 */ GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(50706), // Rule ID 18043 //
     /*  50681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50695 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQrr),
     /*  50700 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50704 */   GIR_RootConstrainSelectedInstOperands,
     /*  50705 */   // GIR_Coverage, 18043,
     /*  50705 */   GIR_Done,
     /*  50706 */ // Label 1201: @50706
     /*  50706 */ GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(50736), // Rule ID 18047 //
     /*  50711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  50714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  50725 */   // (lrint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /*  50725 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQYrr),
     /*  50730 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50734 */   GIR_RootConstrainSelectedInstOperands,
     /*  50735 */   // GIR_Coverage, 18047,
     /*  50735 */   GIR_Done,
     /*  50736 */ // Label 1202: @50736
     /*  50736 */ GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(50766), // Rule ID 18049 //
     /*  50741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  50744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  50755 */   // (lrint:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)  =>  (CVTPS2DQrr:{ *:[v4i32] } VR128:{ *:[v4f32] }:$src)
     /*  50755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTPS2DQrr),
     /*  50760 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50764 */   GIR_RootConstrainSelectedInstOperands,
     /*  50765 */   // GIR_Coverage, 18049,
     /*  50765 */   GIR_Done,
     /*  50766 */ // Label 1203: @50766
     /*  50766 */ GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(50796), // Rule ID 21356 //
     /*  50771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50785 */   // (lrint:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2DQZ128rr:{ *:[v4i32] } VR128X:{ *:[v4f32] }:$src)
     /*  50785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ128rr),
     /*  50790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50794 */   GIR_RootConstrainSelectedInstOperands,
     /*  50795 */   // GIR_Coverage, 21356,
     /*  50795 */   GIR_Done,
     /*  50796 */ // Label 1204: @50796
     /*  50796 */ GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(50826), // Rule ID 21360 //
     /*  50801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  50804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50815 */   // (lrint:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2DQZ256rr:{ *:[v4i32] } VR256X:{ *:[v4f64] }:$src)
     /*  50815 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZ256rr),
     /*  50820 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50824 */   GIR_RootConstrainSelectedInstOperands,
     /*  50825 */   // GIR_Coverage, 21360,
     /*  50825 */   GIR_Done,
     /*  50826 */ // Label 1205: @50826
     /*  50826 */ GIM_Reject,
     /*  50827 */ // Label 1156: @50827
     /*  50827 */ GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(50886), // Rule ID 21381 //
     /*  50832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50850 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50857 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50861 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50863 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50870 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  50873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50875 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50884 */   GIR_RootConstrainSelectedInstOperands,
     /*  50885 */   // GIR_Coverage, 21381,
     /*  50885 */   GIR_EraseRootFromParent_Done,
     /*  50886 */ // Label 1206: @50886
     /*  50886 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(50945), // Rule ID 21387 //
     /*  50891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  50909 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  50912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  50916 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  50920 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50922 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  50929 */   // (lrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  50929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  50932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50934 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  50938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  50943 */   GIR_RootConstrainSelectedInstOperands,
     /*  50944 */   // GIR_Coverage, 21387,
     /*  50944 */   GIR_EraseRootFromParent_Done,
     /*  50945 */ // Label 1207: @50945
     /*  50945 */ GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(50975), // Rule ID 21380 //
     /*  50950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  50956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  50964 */   // (lrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  50964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  50969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  50973 */   GIR_RootConstrainSelectedInstOperands,
     /*  50974 */   // GIR_Coverage, 21380,
     /*  50974 */   GIR_Done,
     /*  50975 */ // Label 1208: @50975
     /*  50975 */ GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(51005), // Rule ID 21386 //
     /*  50980 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  50983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  50986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  50994 */   // (lrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  50994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  50999 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51003 */   GIR_RootConstrainSelectedInstOperands,
     /*  51004 */   // GIR_Coverage, 21386,
     /*  51004 */   GIR_Done,
     /*  51005 */ // Label 1209: @51005
     /*  51005 */ GIM_Reject,
     /*  51006 */ // Label 1157: @51006
     /*  51006 */ GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(51094),
     /*  51011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51018 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(51070), // Rule ID 22156 //
     /*  51023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51054 */     // (lrint:{ *:[v8i16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  51054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rm),
     /*  51057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51068 */     GIR_RootConstrainSelectedInstOperands,
     /*  51069 */     // GIR_Coverage, 22156,
     /*  51069 */     GIR_EraseRootFromParent_Done,
     /*  51070 */   // Label 1211: @51070
     /*  51070 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(51093), // Rule ID 22155 //
     /*  51075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51082 */     // (lrint:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2WZ128rr:{ *:[v8i16] } VR128X:{ *:[v8f16] }:$src)
     /*  51082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ128rr),
     /*  51087 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51091 */     GIR_RootConstrainSelectedInstOperands,
     /*  51092 */     // GIR_Coverage, 22155,
     /*  51092 */     GIR_Done,
     /*  51093 */   // Label 1212: @51093
     /*  51093 */   GIM_Reject,
     /*  51094 */ // Label 1210: @51094
     /*  51094 */ GIM_Reject,
     /*  51095 */ // Label 1158: @51095
     /*  51095 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(51154), // Rule ID 18046 //
     /*  51100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51118 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51121 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51125 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51131 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51138 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrm),
     /*  51141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51143 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51152 */   GIR_RootConstrainSelectedInstOperands,
     /*  51153 */   // GIR_Coverage, 18046,
     /*  51153 */   GIR_EraseRootFromParent_Done,
     /*  51154 */ // Label 1213: @51154
     /*  51154 */ GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(51213), // Rule ID 21359 //
     /*  51159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51169 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51173 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51177 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51180 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51184 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51190 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51197 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rm),
     /*  51200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51202 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51206 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51211 */   GIR_RootConstrainSelectedInstOperands,
     /*  51212 */   // GIR_Coverage, 21359,
     /*  51212 */   GIR_EraseRootFromParent_Done,
     /*  51213 */ // Label 1214: @51213
     /*  51213 */ GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(51269), // Rule ID 21365 //
     /*  51218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51233 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51240 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51246 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51253 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2DQZrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrm),
     /*  51256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51258 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51267 */   GIR_RootConstrainSelectedInstOperands,
     /*  51268 */   // GIR_Coverage, 21365,
     /*  51268 */   GIR_EraseRootFromParent_Done,
     /*  51269 */ // Label 1215: @51269
     /*  51269 */ GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(51328), // Rule ID 22160 //
     /*  51274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51292 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51299 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51305 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51312 */   // (lrint:{ *:[v8i32] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  51312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rm),
     /*  51315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51326 */   GIR_RootConstrainSelectedInstOperands,
     /*  51327 */   // GIR_Coverage, 22160,
     /*  51327 */   GIR_EraseRootFromParent_Done,
     /*  51328 */ // Label 1216: @51328
     /*  51328 */ GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(51358), // Rule ID 18045 //
     /*  51333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  51336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  51347 */   // (lrint:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQYrr:{ *:[v8i32] } VR256:{ *:[v8f32] }:$src)
     /*  51347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQYrr),
     /*  51352 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51356 */   GIR_RootConstrainSelectedInstOperands,
     /*  51357 */   // GIR_Coverage, 18045,
     /*  51357 */   GIR_Done,
     /*  51358 */ // Label 1217: @51358
     /*  51358 */ GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(51388), // Rule ID 21358 //
     /*  51363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  51366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51377 */   // (lrint:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2DQZ256rr:{ *:[v8i32] } VR256X:{ *:[v8f32] }:$src)
     /*  51377 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZ256rr),
     /*  51382 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51386 */   GIR_RootConstrainSelectedInstOperands,
     /*  51387 */   // GIR_Coverage, 21358,
     /*  51387 */   GIR_Done,
     /*  51388 */ // Label 1218: @51388
     /*  51388 */ GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(51415), // Rule ID 21364 //
     /*  51393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51404 */   // (lrint:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2DQZrr:{ *:[v8i32] } VR512:{ *:[v8f64] }:$src)
     /*  51404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2DQZrr),
     /*  51409 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51413 */   GIR_RootConstrainSelectedInstOperands,
     /*  51414 */   // GIR_Coverage, 21364,
     /*  51414 */   GIR_Done,
     /*  51415 */ // Label 1219: @51415
     /*  51415 */ GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(51445), // Rule ID 22159 //
     /*  51420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51434 */   // (lrint:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2DQZ256rr:{ *:[v8i32] } VR128X:{ *:[v8f16] }:$src)
     /*  51434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZ256rr),
     /*  51439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51443 */   GIR_RootConstrainSelectedInstOperands,
     /*  51444 */   // GIR_Coverage, 22159,
     /*  51444 */   GIR_Done,
     /*  51445 */ // Label 1220: @51445
     /*  51445 */ GIM_Reject,
     /*  51446 */ // Label 1159: @51446
     /*  51446 */ GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(51505), // Rule ID 21393 //
     /*  51451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51461 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51465 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51469 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51476 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51480 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51482 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51489 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  51492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51494 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51503 */   GIR_RootConstrainSelectedInstOperands,
     /*  51504 */   // GIR_Coverage, 21393,
     /*  51504 */   GIR_EraseRootFromParent_Done,
     /*  51505 */ // Label 1221: @51505
     /*  51505 */ GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(51564), // Rule ID 21397 //
     /*  51510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51528 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51531 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51535 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51539 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51541 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51548 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  51551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51553 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51562 */   GIR_RootConstrainSelectedInstOperands,
     /*  51563 */   // GIR_Coverage, 21397,
     /*  51563 */   GIR_EraseRootFromParent_Done,
     /*  51564 */ // Label 1222: @51564
     /*  51564 */ GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(51623), // Rule ID 22166 //
     /*  51569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51579 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51583 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51587 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51594 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51598 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51600 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51607 */   // (lrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  51607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  51610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51612 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51621 */   GIR_RootConstrainSelectedInstOperands,
     /*  51622 */   // GIR_Coverage, 22166,
     /*  51622 */   GIR_EraseRootFromParent_Done,
     /*  51623 */ // Label 1223: @51623
     /*  51623 */ GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(51653), // Rule ID 21392 //
     /*  51628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  51634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51642 */   // (lrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  51642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  51647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51651 */   GIR_RootConstrainSelectedInstOperands,
     /*  51652 */   // GIR_Coverage, 21392,
     /*  51652 */   GIR_Done,
     /*  51653 */ // Label 1224: @51653
     /*  51653 */ GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(51683), // Rule ID 21396 //
     /*  51658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  51661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  51664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51672 */   // (lrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  51672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  51677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51681 */   GIR_RootConstrainSelectedInstOperands,
     /*  51682 */   // GIR_Coverage, 21396,
     /*  51682 */   GIR_Done,
     /*  51683 */ // Label 1225: @51683
     /*  51683 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(51713), // Rule ID 22165 //
     /*  51688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  51702 */   // (lrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  51702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  51707 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51711 */   GIR_RootConstrainSelectedInstOperands,
     /*  51712 */   // GIR_Coverage, 22165,
     /*  51712 */   GIR_Done,
     /*  51713 */ // Label 1226: @51713
     /*  51713 */ GIM_Reject,
     /*  51714 */ // Label 1160: @51714
     /*  51714 */ GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(51802),
     /*  51719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51726 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(51778), // Rule ID 22158 //
     /*  51731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51762 */     // (lrint:{ *:[v16i16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  51762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rm),
     /*  51765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51776 */     GIR_RootConstrainSelectedInstOperands,
     /*  51777 */     // GIR_Coverage, 22158,
     /*  51777 */     GIR_EraseRootFromParent_Done,
     /*  51778 */   // Label 1228: @51778
     /*  51778 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(51801), // Rule ID 22157 //
     /*  51783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /*  51786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51790 */     // (lrint:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2WZ256rr:{ *:[v16i16] } VR256X:{ *:[v16f16] }:$src)
     /*  51790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZ256rr),
     /*  51795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51799 */     GIR_RootConstrainSelectedInstOperands,
     /*  51800 */     // GIR_Coverage, 22157,
     /*  51800 */     GIR_Done,
     /*  51801 */   // Label 1229: @51801
     /*  51801 */   GIM_Reject,
     /*  51802 */ // Label 1227: @51802
     /*  51802 */ GIM_Reject,
     /*  51803 */ // Label 1161: @51803
     /*  51803 */ GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(51859), // Rule ID 21363 //
     /*  51808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51823 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51830 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51836 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51843 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrm),
     /*  51846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51848 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51857 */   GIR_RootConstrainSelectedInstOperands,
     /*  51858 */   // GIR_Coverage, 21363,
     /*  51858 */   GIR_EraseRootFromParent_Done,
     /*  51859 */ // Label 1230: @51859
     /*  51859 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(51918), // Rule ID 22164 //
     /*  51864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  51882 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  51885 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  51889 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  51893 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51895 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  51902 */   // (lrint:{ *:[v16i32] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2DQZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  51902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrm),
     /*  51905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51907 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  51911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  51916 */   GIR_RootConstrainSelectedInstOperands,
     /*  51917 */   // GIR_Coverage, 22164,
     /*  51917 */   GIR_EraseRootFromParent_Done,
     /*  51918 */ // Label 1231: @51918
     /*  51918 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(51945), // Rule ID 21362 //
     /*  51923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /*  51926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51934 */   // (lrint:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)  =>  (VCVTPS2DQZrr:{ *:[v16i32] } VR512:{ *:[v16f32] }:$src)
     /*  51934 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2DQZrr),
     /*  51939 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51943 */   GIR_RootConstrainSelectedInstOperands,
     /*  51944 */   // GIR_Coverage, 21362,
     /*  51944 */   GIR_Done,
     /*  51945 */ // Label 1232: @51945
     /*  51945 */ GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(51975), // Rule ID 22163 //
     /*  51950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /*  51956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  51964 */   // (lrint:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2DQZrr:{ *:[v16i32] } VR256X:{ *:[v16f16] }:$src)
     /*  51964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2DQZrr),
     /*  51969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  51973 */   GIR_RootConstrainSelectedInstOperands,
     /*  51974 */   // GIR_Coverage, 22163,
     /*  51974 */   GIR_Done,
     /*  51975 */ // Label 1233: @51975
     /*  51975 */ GIM_Reject,
     /*  51976 */ // Label 1162: @51976
     /*  51976 */ GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(52064),
     /*  51981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /*  51984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  51988 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(52040), // Rule ID 22162 //
     /*  51993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  51996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52024 */     // (lrint:{ *:[v32i16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2WZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrm),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52038 */     GIR_RootConstrainSelectedInstOperands,
     /*  52039 */     // GIR_Coverage, 22162,
     /*  52039 */     GIR_EraseRootFromParent_Done,
     /*  52040 */   // Label 1235: @52040
     /*  52040 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(52063), // Rule ID 22161 //
     /*  52045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  52048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  52052 */     // (lrint:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)  =>  (VCVTPH2WZrr:{ *:[v32i16] } VR512:{ *:[v32f16] }:$src)
     /*  52052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2WZrr),
     /*  52057 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52061 */     GIR_RootConstrainSelectedInstOperands,
     /*  52062 */     // GIR_Coverage, 22161,
     /*  52062 */     GIR_Done,
     /*  52063 */   // Label 1236: @52063
     /*  52063 */   GIM_Reject,
     /*  52064 */ // Label 1234: @52064
     /*  52064 */ GIM_Reject,
     /*  52065 */ // Label 1163: @52065
     /*  52065 */ GIM_Reject,
     /*  52066 */ // Label 9: @52066
     /*  52066 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 1241*/ GIMT_Encode4(53285),
     /*  52077 */ /*GILLT_s64*//*Label 1237*/ GIMT_Encode4(52125), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52093 */ /*GILLT_v2s64*//*Label 1238*/ GIMT_Encode4(52749), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52105 */ /*GILLT_v4s64*//*Label 1239*/ GIMT_Encode4(52838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52121 */ /*GILLT_v8s64*//*Label 1240*/ GIMT_Encode4(53017),
     /*  52125 */ // Label 1237: @52125
     /*  52125 */ GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(52184), // Rule ID 1758 //
     /*  52130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52140 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52144 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52148 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52155 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52161 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52168 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rm),
     /*  52171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52173 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52177 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52182 */   GIR_RootConstrainSelectedInstOperands,
     /*  52183 */   // GIR_Coverage, 1758,
     /*  52183 */   GIR_EraseRootFromParent_Done,
     /*  52184 */ // Label 1242: @52184
     /*  52184 */ GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(52243), // Rule ID 1762 //
     /*  52189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52199 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52203 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52207 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52210 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52214 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52220 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52227 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rm),
     /*  52230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52232 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52241 */   GIR_RootConstrainSelectedInstOperands,
     /*  52242 */   // GIR_Coverage, 1762,
     /*  52242 */   GIR_EraseRootFromParent_Done,
     /*  52243 */ // Label 1243: @52243
     /*  52243 */ GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(52302), // Rule ID 1782 //
     /*  52248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52266 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52273 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52279 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52286 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rm),
     /*  52289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52291 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52300 */   GIR_RootConstrainSelectedInstOperands,
     /*  52301 */   // GIR_Coverage, 1782,
     /*  52301 */   GIR_EraseRootFromParent_Done,
     /*  52302 */ // Label 1244: @52302
     /*  52302 */ GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(52361), // Rule ID 1786 //
     /*  52307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52325 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52328 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52332 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52336 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52338 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52345 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rm),
     /*  52348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52350 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52359 */   GIR_RootConstrainSelectedInstOperands,
     /*  52360 */   // GIR_Coverage, 1786,
     /*  52360 */   GIR_EraseRootFromParent_Done,
     /*  52361 */ // Label 1245: @52361
     /*  52361 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(52420), // Rule ID 10355 //
     /*  52366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52384 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52387 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52391 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52397 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52404 */   // (llrint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrm),
     /*  52407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52409 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52418 */   GIR_RootConstrainSelectedInstOperands,
     /*  52419 */   // GIR_Coverage, 10355,
     /*  52419 */   GIR_EraseRootFromParent_Done,
     /*  52420 */ // Label 1246: @52420
     /*  52420 */ GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(52479), // Rule ID 10359 //
     /*  52425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52435 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52439 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52443 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52450 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52456 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52463 */   // (llrint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrm),
     /*  52466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52468 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52472 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52477 */   GIR_RootConstrainSelectedInstOperands,
     /*  52478 */   // GIR_Coverage, 10359,
     /*  52478 */   GIR_EraseRootFromParent_Done,
     /*  52479 */ // Label 1247: @52479
     /*  52479 */ GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(52538), // Rule ID 22175 //
     /*  52484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52502 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52509 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52513 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52515 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52522 */   // (llrint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  52522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /*  52525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52527 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52536 */   GIR_RootConstrainSelectedInstOperands,
     /*  52537 */   // GIR_Coverage, 22175,
     /*  52537 */   GIR_EraseRootFromParent_Done,
     /*  52538 */ // Label 1248: @52538
     /*  52538 */ GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(52568), // Rule ID 1757 //
     /*  52543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52557 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64rr),
     /*  52562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52566 */   GIR_RootConstrainSelectedInstOperands,
     /*  52567 */   // GIR_Coverage, 1757,
     /*  52567 */   GIR_Done,
     /*  52568 */ // Label 1249: @52568
     /*  52568 */ GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(52598), // Rule ID 1761 //
     /*  52573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  52576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52587 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64rr),
     /*  52592 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52596 */   GIR_RootConstrainSelectedInstOperands,
     /*  52597 */   // GIR_Coverage, 1761,
     /*  52597 */   GIR_Done,
     /*  52598 */ // Label 1250: @52598
     /*  52598 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(52628), // Rule ID 1781 //
     /*  52603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  52606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  52617 */   // (llrint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /*  52617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SI64rr),
     /*  52622 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52626 */   GIR_RootConstrainSelectedInstOperands,
     /*  52627 */   // GIR_Coverage, 1781,
     /*  52627 */   GIR_Done,
     /*  52628 */ // Label 1251: @52628
     /*  52628 */ GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(52658), // Rule ID 1785 //
     /*  52633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  52636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  52647 */   // (llrint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /*  52647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SI64rr),
     /*  52652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52656 */   GIR_RootConstrainSelectedInstOperands,
     /*  52657 */   // GIR_Coverage, 1785,
     /*  52657 */   GIR_Done,
     /*  52658 */ // Label 1252: @52658
     /*  52658 */ GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(52688), // Rule ID 10354 //
     /*  52663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  52677 */   // (llrint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /*  52677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SI64Zrr),
     /*  52682 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52686 */   GIR_RootConstrainSelectedInstOperands,
     /*  52687 */   // GIR_Coverage, 10354,
     /*  52687 */   GIR_Done,
     /*  52688 */ // Label 1253: @52688
     /*  52688 */ GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(52718), // Rule ID 10358 //
     /*  52693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  52696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  52707 */   // (llrint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /*  52707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SI64Zrr),
     /*  52712 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52716 */   GIR_RootConstrainSelectedInstOperands,
     /*  52717 */   // GIR_Coverage, 10358,
     /*  52717 */   GIR_Done,
     /*  52718 */ // Label 1254: @52718
     /*  52718 */ GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(52748), // Rule ID 22174 //
     /*  52723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_In64BitMode),
     /*  52726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  52729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  52733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  52737 */   // (llrint:{ *:[i64] } FR16:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16:{ *:[f16] }:$src)
     /*  52737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /*  52742 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52746 */   GIR_RootConstrainSelectedInstOperands,
     /*  52747 */   // GIR_Coverage, 22174,
     /*  52747 */   GIR_Done,
     /*  52748 */ // Label 1255: @52748
     /*  52748 */ GIM_Reject,
     /*  52749 */ // Label 1238: @52749
     /*  52749 */ GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(52837),
     /*  52754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  52757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52761 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(52813), // Rule ID 21389 //
     /*  52766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52797 */     // (llrint:{ *:[v2i64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  52797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rm),
     /*  52800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52802 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52811 */     GIR_RootConstrainSelectedInstOperands,
     /*  52812 */     // GIR_Coverage, 21389,
     /*  52812 */     GIR_EraseRootFromParent_Done,
     /*  52813 */   // Label 1257: @52813
     /*  52813 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(52836), // Rule ID 21388 //
     /*  52818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52825 */     // (llrint:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)  =>  (VCVTPD2QQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2f64] }:$src)
     /*  52825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ128rr),
     /*  52830 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52834 */     GIR_RootConstrainSelectedInstOperands,
     /*  52835 */     // GIR_Coverage, 21388,
     /*  52835 */     GIR_Done,
     /*  52836 */   // Label 1258: @52836
     /*  52836 */   GIM_Reject,
     /*  52837 */ // Label 1256: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 1239: @52838
     /*  52838 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(52897), // Rule ID 21383 //
     /*  52843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52853 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52857 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52861 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52864 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52868 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52874 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52881 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rm),
     /*  52884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52890 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52895 */   GIR_RootConstrainSelectedInstOperands,
     /*  52896 */   // GIR_Coverage, 21383,
     /*  52896 */   GIR_EraseRootFromParent_Done,
     /*  52897 */ // Label 1259: @52897
     /*  52897 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(52956), // Rule ID 21391 //
     /*  52902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  52920 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  52923 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  52927 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  52931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52933 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  52940 */   // (llrint:{ *:[v4i64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  52940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rm),
     /*  52943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52945 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  52949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  52954 */   GIR_RootConstrainSelectedInstOperands,
     /*  52955 */   // GIR_Coverage, 21391,
     /*  52955 */   GIR_EraseRootFromParent_Done,
     /*  52956 */ // Label 1260: @52956
     /*  52956 */ GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(52986), // Rule ID 21382 //
     /*  52961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  52971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  52975 */   // (llrint:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2QQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4f32] }:$src)
     /*  52975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZ256rr),
     /*  52980 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  52984 */   GIR_RootConstrainSelectedInstOperands,
     /*  52985 */   // GIR_Coverage, 21382,
     /*  52985 */   GIR_Done,
     /*  52986 */ // Label 1261: @52986
     /*  52986 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(53016), // Rule ID 21390 //
     /*  52991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /*  52994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /*  52997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  53001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  53005 */   // (llrint:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)  =>  (VCVTPD2QQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4f64] }:$src)
     /*  53005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZ256rr),
     /*  53010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53014 */   GIR_RootConstrainSelectedInstOperands,
     /*  53015 */   // GIR_Coverage, 21390,
     /*  53015 */   GIR_Done,
     /*  53016 */ // Label 1262: @53016
     /*  53016 */ GIM_Reject,
     /*  53017 */ // Label 1240: @53017
     /*  53017 */ GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(53076), // Rule ID 21395 //
     /*  53022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53040 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53043 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53060 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPS2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrm),
     /*  53063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53065 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53074 */   GIR_RootConstrainSelectedInstOperands,
     /*  53075 */   // GIR_Coverage, 21395,
     /*  53075 */   GIR_EraseRootFromParent_Done,
     /*  53076 */ // Label 1263: @53076
     /*  53076 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(53135), // Rule ID 21399 //
     /*  53081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53099 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53119 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPD2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrm),
     /*  53122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53124 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53133 */   GIR_RootConstrainSelectedInstOperands,
     /*  53134 */   // GIR_Coverage, 21399,
     /*  53134 */   GIR_EraseRootFromParent_Done,
     /*  53135 */ // Label 1264: @53135
     /*  53135 */ GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(53194), // Rule ID 22168 //
     /*  53140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  53158 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  53165 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  53169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53171 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53178 */   // (llrint:{ *:[v8i64] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTPH2QQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  53178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrm),
     /*  53181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53183 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53192 */   GIR_RootConstrainSelectedInstOperands,
     /*  53193 */   // GIR_Coverage, 22168,
     /*  53193 */   GIR_EraseRootFromParent_Done,
     /*  53194 */ // Label 1265: @53194
     /*  53194 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(53224), // Rule ID 21394 //
     /*  53199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /*  53205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  53213 */   // (llrint:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2QQZrr:{ *:[v8i64] } VR256X:{ *:[v8f32] }:$src)
     /*  53213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2QQZrr),
     /*  53218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53222 */   GIR_RootConstrainSelectedInstOperands,
     /*  53223 */   // GIR_Coverage, 21394,
     /*  53223 */   GIR_Done,
     /*  53224 */ // Label 1266: @53224
     /*  53224 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(53254), // Rule ID 21398 //
     /*  53229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /*  53235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53243 */   // (llrint:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)  =>  (VCVTPD2QQZrr:{ *:[v8i64] } VR512:{ *:[v8f64] }:$src)
     /*  53243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPD2QQZrr),
     /*  53248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53252 */   GIR_RootConstrainSelectedInstOperands,
     /*  53253 */   // GIR_Coverage, 21398,
     /*  53253 */   GIR_Done,
     /*  53254 */ // Label 1267: @53254
     /*  53254 */ GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(53284), // Rule ID 22167 //
     /*  53259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  53269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  53273 */   // (llrint:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2QQZrr:{ *:[v8i64] } VR128X:{ *:[v8f16] }:$src)
     /*  53273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2QQZrr),
     /*  53278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /*  53282 */   GIR_RootConstrainSelectedInstOperands,
     /*  53283 */   // GIR_Coverage, 22167,
     /*  53283 */   GIR_Done,
     /*  53284 */ // Label 1268: @53284
     /*  53284 */ GIM_Reject,
     /*  53285 */ // Label 1241: @53285
     /*  53285 */ GIM_Reject,
     /*  53286 */ // Label 10: @53286
     /*  53286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(25), /*)*//*default:*//*Label 1294*/ GIMT_Encode4(59510),
     /*  53297 */ /*GILLT_s1*//*Label 1269*/ GIMT_Encode4(53397),
     /*  53301 */ /*GILLT_s8*//*Label 1270*/ GIMT_Encode4(53464),
     /*  53305 */ /*GILLT_s16*//*Label 1271*/ GIMT_Encode4(53605),
     /*  53309 */ /*GILLT_s32*//*Label 1272*/ GIMT_Encode4(54158),
     /*  53313 */ /*GILLT_s64*//*Label 1273*/ GIMT_Encode4(54580),
     /*  53317 */ /*GILLT_s80*//*Label 1274*/ GIMT_Encode4(55153),
     /*  53321 */ /*GILLT_s128*//*Label 1275*/ GIMT_Encode4(55312),
     /*  53325 */ /*GILLT_v2s1*//*Label 1276*/ GIMT_Encode4(55440),
     /*  53329 */ /*GILLT_v2s64*//*Label 1277*/ GIMT_Encode4(55507),
     /*  53333 */ /*GILLT_v4s1*//*Label 1278*/ GIMT_Encode4(56001),
     /*  53337 */ /*GILLT_v4s32*//*Label 1279*/ GIMT_Encode4(56068),
     /*  53341 */ /*GILLT_v4s64*//*Label 1280*/ GIMT_Encode4(56562),
     /*  53345 */ /*GILLT_v8s1*//*Label 1281*/ GIMT_Encode4(56896),
     /*  53349 */ /*GILLT_v8s16*//*Label 1282*/ GIMT_Encode4(56978),
     /*  53353 */ /*GILLT_v8s32*//*Label 1283*/ GIMT_Encode4(57552),
     /*  53357 */ /*GILLT_v8s64*//*Label 1284*/ GIMT_Encode4(57886),
     /*  53361 */ /*GILLT_v16s1*//*Label 1285*/ GIMT_Encode4(58060),
     /*  53365 */ /*GILLT_v16s8*//*Label 1286*/ GIMT_Encode4(58142),
     /*  53369 */ /*GILLT_v16s16*//*Label 1287*/ GIMT_Encode4(58396),
     /*  53373 */ /*GILLT_v16s32*//*Label 1288*/ GIMT_Encode4(58730),
     /*  53377 */ /*GILLT_v32s1*//*Label 1289*/ GIMT_Encode4(58904),
     /*  53381 */ /*GILLT_v32s8*//*Label 1290*/ GIMT_Encode4(58986),
     /*  53385 */ /*GILLT_v32s16*//*Label 1291*/ GIMT_Encode4(59160),
     /*  53389 */ /*GILLT_v64s1*//*Label 1292*/ GIMT_Encode4(59334),
     /*  53393 */ /*GILLT_v64s8*//*Label 1293*/ GIMT_Encode4(59416),
     /*  53397 */ // Label 1269: @53397
     /*  53397 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(53463), // Rule ID 19445 //
     /*  53402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  53405 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /*  53416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53427 */   // (ld:{ *:[v1i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK1:{ *:[i32] })
     /*  53427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  53430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  53434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53439 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53443 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53457 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /*  53462 */   // GIR_Coverage, 19445,
     /*  53462 */   GIR_EraseRootFromParent_Done,
     /*  53463 */ // Label 1295: @53463
     /*  53463 */ GIM_Reject,
     /*  53464 */ // Label 1270: @53464
     /*  53464 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(53513), // Rule ID 22515 //
     /*  53469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53498 */   // (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53503 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53507 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53511 */   GIR_RootConstrainSelectedInstOperands,
     /*  53512 */   // GIR_Coverage, 22515,
     /*  53512 */   GIR_EraseRootFromParent_Done,
     /*  53513 */ // Label 1296: @53513
     /*  53513 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(53562), // Rule ID 22580 //
     /*  53518 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53521 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53536 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53540 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53547 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53552 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53560 */   GIR_RootConstrainSelectedInstOperands,
     /*  53561 */   // GIR_Coverage, 22580,
     /*  53561 */   GIR_EraseRootFromParent_Done,
     /*  53562 */ // Label 1297: @53562
     /*  53562 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(53604), // Rule ID 28 //
     /*  53567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  53574 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53578 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  53582 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53589 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  53589 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  53592 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53594 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53598 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53602 */   GIR_RootConstrainSelectedInstOperands,
     /*  53603 */   // GIR_Coverage, 28,
     /*  53603 */   GIR_EraseRootFromParent_Done,
     /*  53604 */ // Label 1298: @53604
     /*  53604 */ GIM_Reject,
     /*  53605 */ // Label 1271: @53605
     /*  53605 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(53650), // Rule ID 4621 //
     /*  53610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  53613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  53624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53635 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSHZrm_alt:{ *:[f16] } addr:{ *:[iPTR] }:$src)
     /*  53635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZrm_alt),
     /*  53638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53640 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53648 */   GIR_RootConstrainSelectedInstOperands,
     /*  53649 */   // GIR_Coverage, 4621,
     /*  53649 */   GIR_EraseRootFromParent_Done,
     /*  53650 */ // Label 1299: @53650
     /*  53650 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(53699), // Rule ID 22516 //
     /*  53655 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  53658 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53662 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  53669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53677 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53684 */   // (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53689 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53697 */   GIR_RootConstrainSelectedInstOperands,
     /*  53698 */   // GIR_Coverage, 22516,
     /*  53698 */   GIR_EraseRootFromParent_Done,
     /*  53699 */ // Label 1300: @53699
     /*  53699 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(53778), // Rule ID 22581 //
     /*  53704 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53707 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53711 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53726 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53733 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53745 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53749 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53760 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53777 */   // GIR_Coverage, 22581,
     /*  53777 */   GIR_EraseRootFromParent_Done,
     /*  53778 */ // Label 1301: @53778
     /*  53778 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(53857), // Rule ID 22583 //
     /*  53783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53786 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53790 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  53797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53812 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  53812 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53815 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  53819 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53824 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53828 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53832 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53834 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53837 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53839 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  53846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  53851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  53856 */   // GIR_Coverage, 22583,
     /*  53856 */   GIR_EraseRootFromParent_Done,
     /*  53857 */ // Label 1302: @53857
     /*  53857 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(53943), // Rule ID 18339 //
     /*  53862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  53865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  53872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  53876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53887 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  53887 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  53890 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  53894 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  53901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  53904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWrmi),
     /*  53908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53913 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  53916 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  53920 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  53923 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53934 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  53942 */   // GIR_Coverage, 18339,
     /*  53942 */   GIR_EraseRootFromParent_Done,
     /*  53943 */ // Label 1303: @53943
     /*  53943 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(53985), // Rule ID 29 //
     /*  53948 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  53955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  53959 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  53963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  53970 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>  =>  (MOV16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  53970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16rm),
     /*  53973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53975 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  53979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  53983 */   GIR_RootConstrainSelectedInstOperands,
     /*  53984 */   // GIR_Coverage, 29,
     /*  53984 */   GIR_EraseRootFromParent_Done,
     /*  53985 */ // Label 1304: @53985
     /*  53985 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(54071), // Rule ID 18335 //
     /*  53990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  53993 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  53996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /*  54004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54015 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (PINSRWrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16:{ *:[i32] })
     /*  54015 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  54018 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54022 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::PINSRWrmi),
     /*  54036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54041 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54044 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54048 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54051 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54055 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54062 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /*  54070 */   // GIR_Coverage, 18335,
     /*  54070 */   GIR_EraseRootFromParent_Done,
     /*  54071 */ // Label 1305: @54071
     /*  54071 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(54157), // Rule ID 21839 //
     /*  54076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  54079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  54090 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54094 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54101 */   // (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VPINSRWZrmi:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), addr:{ *:[iPTR] }:$src, 0:{ *:[i8] }), FR16X:{ *:[i32] })
     /*  54101 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  54104 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  54108 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  54115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  54118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPINSRWZrmi),
     /*  54122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54127 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54130 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54134 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  54137 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54148 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /*  54156 */   // GIR_Coverage, 21839,
     /*  54156 */   GIR_EraseRootFromParent_Done,
     /*  54157 */ // Label 1306: @54157
     /*  54157 */ GIM_Reject,
     /*  54158 */ // Label 1272: @54158
     /*  54158 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(54206), // Rule ID 1080 //
     /*  54163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  54166 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54169 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  54177 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54181 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54188 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp32m:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m),
     /*  54191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54193 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54197 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54200 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54204 */   GIR_RootConstrainSelectedInstOperands,
     /*  54205 */   // GIR_Coverage, 1080,
     /*  54205 */   GIR_EraseRootFromParent_Done,
     /*  54206 */ // Label 1307: @54206
     /*  54206 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(54251), // Rule ID 1697 //
     /*  54211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54214 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54236 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSrm_alt),
     /*  54239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54241 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54245 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54249 */   GIR_RootConstrainSelectedInstOperands,
     /*  54250 */   // GIR_Coverage, 1697,
     /*  54250 */   GIR_EraseRootFromParent_Done,
     /*  54251 */ // Label 1308: @54251
     /*  54251 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(54296), // Rule ID 1698 //
     /*  54256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  54259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  54270 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54274 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54281 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSSrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSrm_alt),
     /*  54284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54286 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54294 */   GIR_RootConstrainSelectedInstOperands,
     /*  54295 */   // GIR_Coverage, 1698,
     /*  54295 */   GIR_EraseRootFromParent_Done,
     /*  54296 */ // Label 1309: @54296
     /*  54296 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(54341), // Rule ID 4609 //
     /*  54301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54307 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  54315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54326 */   // (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSSZrm_alt:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /*  54326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZrm_alt),
     /*  54329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54331 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54339 */   GIR_RootConstrainSelectedInstOperands,
     /*  54340 */   // GIR_Coverage, 4609,
     /*  54340 */   GIR_EraseRootFromParent_Done,
     /*  54341 */ // Label 1310: @54341
     /*  54341 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(54390), // Rule ID 22517 //
     /*  54346 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54375 */   // (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54380 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54388 */   GIR_RootConstrainSelectedInstOperands,
     /*  54389 */   // GIR_Coverage, 22517,
     /*  54389 */   GIR_EraseRootFromParent_Done,
     /*  54390 */ // Label 1311: @54390
     /*  54390 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(54439), // Rule ID 22582 //
     /*  54395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54398 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54413 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54424 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54429 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54437 */   GIR_RootConstrainSelectedInstOperands,
     /*  54438 */   // GIR_Coverage, 22582,
     /*  54438 */   GIR_EraseRootFromParent_Done,
     /*  54439 */ // Label 1312: @54439
     /*  54439 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(54488), // Rule ID 22584 //
     /*  54444 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54447 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54451 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54462 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54466 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54473 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54478 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54482 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54486 */   GIR_RootConstrainSelectedInstOperands,
     /*  54487 */   // GIR_Coverage, 22584,
     /*  54487 */   GIR_EraseRootFromParent_Done,
     /*  54488 */ // Label 1313: @54488
     /*  54488 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(54537), // Rule ID 22585 //
     /*  54493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54496 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54500 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  54507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54522 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  54525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54527 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54535 */   GIR_RootConstrainSelectedInstOperands,
     /*  54536 */   // GIR_Coverage, 22585,
     /*  54536 */   GIR_EraseRootFromParent_Done,
     /*  54537 */ // Label 1314: @54537
     /*  54537 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(54579), // Rule ID 30 //
     /*  54542 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  54549 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54553 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  54557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54564 */   // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>  =>  (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  54564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  54567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54569 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54573 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54577 */   GIR_RootConstrainSelectedInstOperands,
     /*  54578 */   // GIR_Coverage, 30,
     /*  54578 */   GIR_EraseRootFromParent_Done,
     /*  54579 */ // Label 1315: @54579
     /*  54579 */ GIM_Reject,
     /*  54580 */ // Label 1273: @54580
     /*  54580 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(54622), // Rule ID 31 //
     /*  54585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54596 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54600 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54607 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54612 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54620 */   GIR_RootConstrainSelectedInstOperands,
     /*  54621 */   // GIR_Coverage, 31,
     /*  54621 */   GIR_EraseRootFromParent_Done,
     /*  54622 */ // Label 1316: @54622
     /*  54622 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(54670), // Rule ID 1081 //
     /*  54627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54641 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54645 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54652 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp64m:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m),
     /*  54655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54657 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54661 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54664 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54668 */   GIR_RootConstrainSelectedInstOperands,
     /*  54669 */   // GIR_Coverage, 1081,
     /*  54669 */   GIR_EraseRootFromParent_Done,
     /*  54670 */ // Label 1317: @54670
     /*  54670 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(54725), // Rule ID 1083 //
     /*  54675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  54678 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54681 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54685 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  54692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  54696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54700 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54707 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  54707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m64),
     /*  54710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54712 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54716 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  54719 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54723 */   GIR_RootConstrainSelectedInstOperands,
     /*  54724 */   // GIR_Coverage, 1083,
     /*  54724 */   GIR_EraseRootFromParent_Done,
     /*  54725 */ // Label 1318: @54725
     /*  54725 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(54770), // Rule ID 1701 //
     /*  54730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  54733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54744 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54755 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDrm_alt),
     /*  54758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54760 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54768 */   GIR_RootConstrainSelectedInstOperands,
     /*  54769 */   // GIR_Coverage, 1701,
     /*  54769 */   GIR_EraseRootFromParent_Done,
     /*  54770 */ // Label 1319: @54770
     /*  54770 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(54815), // Rule ID 1702 //
     /*  54775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  54778 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54781 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  54789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54793 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54800 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVSDrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDrm_alt),
     /*  54803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54805 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54813 */   GIR_RootConstrainSelectedInstOperands,
     /*  54814 */   // GIR_Coverage, 1702,
     /*  54814 */   GIR_EraseRootFromParent_Done,
     /*  54815 */ // Label 1320: @54815
     /*  54815 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(54860), // Rule ID 4615 //
     /*  54820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  54823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54826 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  54834 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54838 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54845 */   // (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVSDZrm_alt:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /*  54845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZrm_alt),
     /*  54848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54850 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54858 */   GIR_RootConstrainSelectedInstOperands,
     /*  54859 */   // GIR_Coverage, 4615,
     /*  54859 */   GIR_EraseRootFromParent_Done,
     /*  54860 */ // Label 1321: @54860
     /*  54860 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(54909), // Rule ID 22518 //
     /*  54865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  54868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  54879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54887 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54894 */   // (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>  =>  (MOV64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  54894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64rm),
     /*  54897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54899 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  54903 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54907 */   GIR_RootConstrainSelectedInstOperands,
     /*  54908 */   // GIR_Coverage, 22518,
     /*  54908 */   GIR_EraseRootFromParent_Done,
     /*  54909 */ // Label 1322: @54909
     /*  54909 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(54990), // Rule ID 22587 //
     /*  54914 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54917 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  54921 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  54928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  54932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  54936 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  54943 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  54943 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54946 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  54950 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54955 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  54959 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  54963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  54979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  54984 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  54989 */   // GIR_Coverage, 22587,
     /*  54989 */   GIR_EraseRootFromParent_Done,
     /*  54990 */ // Label 1323: @54990
     /*  54990 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(55071), // Rule ID 22588 //
     /*  54995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  54998 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  55009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  55013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55024 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  55024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  55031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55036 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55040 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  55060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55070 */   // GIR_Coverage, 22588,
     /*  55070 */   GIR_EraseRootFromParent_Done,
     /*  55071 */ // Label 1324: @55071
     /*  55071 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(55152), // Rule ID 22589 //
     /*  55076 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55079 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55083 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  55090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  55094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55098 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55105 */   // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  55105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  55112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55117 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55121 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  55141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  55146 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  55151 */   // GIR_Coverage, 22589,
     /*  55151 */   GIR_EraseRootFromParent_Done,
     /*  55152 */ // Label 1325: @55152
     /*  55152 */ GIM_Reject,
     /*  55153 */ // Label 1274: @55153
     /*  55153 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(55311),
     /*  55158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55161 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(55206), // Rule ID 1082 //
     /*  55166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55188 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD_Fp80m:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp80m),
     /*  55191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55193 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55204 */     GIR_RootConstrainSelectedInstOperands,
     /*  55205 */     // GIR_Coverage, 1082,
     /*  55205 */     GIR_EraseRootFromParent_Done,
     /*  55206 */   // Label 1327: @55206
     /*  55206 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(55258), // Rule ID 1084 //
     /*  55211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55214 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  55225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55240 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>  =>  (LD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp64m80),
     /*  55243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55249 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55256 */     GIR_RootConstrainSelectedInstOperands,
     /*  55257 */     // GIR_Coverage, 1084,
     /*  55257 */     GIR_EraseRootFromParent_Done,
     /*  55258 */   // Label 1328: @55258
     /*  55258 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(55310), // Rule ID 1085 //
     /*  55263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  55266 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  55277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  55281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55292 */     // (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>  =>  (LD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /*  55292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp32m80),
     /*  55295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55297 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  55304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55308 */     GIR_RootConstrainSelectedInstOperands,
     /*  55309 */     // GIR_Coverage, 1085,
     /*  55309 */     GIR_EraseRootFromParent_Done,
     /*  55310 */   // Label 1329: @55310
     /*  55310 */   GIM_Reject,
     /*  55311 */ // Label 1326: @55311
     /*  55311 */ GIM_Reject,
     /*  55312 */ // Label 1275: @55312
     /*  55312 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(55439),
     /*  55317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55320 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55324 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(55362), // Rule ID 23145 //
     /*  55329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  55332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55347 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55360 */     GIR_RootConstrainSelectedInstOperands,
     /*  55361 */     // GIR_Coverage, 23145,
     /*  55361 */     GIR_EraseRootFromParent_Done,
     /*  55362 */   // Label 1331: @55362
     /*  55362 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(55400), // Rule ID 23149 //
     /*  55367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55385 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  55388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55398 */     GIR_RootConstrainSelectedInstOperands,
     /*  55399 */     // GIR_Coverage, 23149,
     /*  55399 */     GIR_EraseRootFromParent_Done,
     /*  55400 */   // Label 1332: @55400
     /*  55400 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(55438), // Rule ID 23153 //
     /*  55405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  55408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55423 */     // (ld:{ *:[f128] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[f128] } addr:{ *:[iPTR] }:$src)
     /*  55423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  55426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55428 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55436 */     GIR_RootConstrainSelectedInstOperands,
     /*  55437 */     // GIR_Coverage, 23153,
     /*  55437 */     GIR_EraseRootFromParent_Done,
     /*  55438 */   // Label 1333: @55438
     /*  55438 */   GIM_Reject,
     /*  55439 */ // Label 1330: @55439
     /*  55439 */ GIM_Reject,
     /*  55440 */ // Label 1276: @55440
     /*  55440 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(55506), // Rule ID 19446 //
     /*  55445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  55448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55451 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /*  55459 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55463 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55470 */   // (ld:{ *:[v2i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK2:{ *:[i32] })
     /*  55470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  55473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  55477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55482 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  55486 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  55495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /*  55505 */   // GIR_Coverage, 19446,
     /*  55505 */   GIR_EraseRootFromParent_Done,
     /*  55506 */ // Label 1334: @55506
     /*  55506 */ GIM_Reject,
     /*  55507 */ // Label 1277: @55507
     /*  55507 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(56000),
     /*  55512 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  55515 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  55519 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(55561), // Rule ID 1704 //
     /*  55524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55535 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55546 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDrm),
     /*  55549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55559 */     GIR_RootConstrainSelectedInstOperands,
     /*  55560 */     // GIR_Coverage, 1704,
     /*  55560 */     GIR_EraseRootFromParent_Done,
     /*  55561 */   // Label 1336: @55561
     /*  55561 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(55599), // Rule ID 1706 //
     /*  55566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55584 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDrm),
     /*  55587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55597 */     GIR_RootConstrainSelectedInstOperands,
     /*  55598 */     // GIR_Coverage, 1706,
     /*  55598 */     GIR_EraseRootFromParent_Done,
     /*  55599 */   // Label 1337: @55599
     /*  55599 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(55641), // Rule ID 1713 //
     /*  55604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55615 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55626 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDrm),
     /*  55629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55639 */     GIR_RootConstrainSelectedInstOperands,
     /*  55640 */     // GIR_Coverage, 1713,
     /*  55640 */     GIR_EraseRootFromParent_Done,
     /*  55641 */   // Label 1338: @55641
     /*  55641 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(55679), // Rule ID 1714 //
     /*  55646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  55649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55664 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDrm),
     /*  55667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55677 */     GIR_RootConstrainSelectedInstOperands,
     /*  55678 */     // GIR_Coverage, 1714,
     /*  55678 */     GIR_EraseRootFromParent_Done,
     /*  55679 */   // Label 1339: @55679
     /*  55679 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(55721), // Rule ID 2518 //
     /*  55684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55695 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55706 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  55709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55719 */     GIR_RootConstrainSelectedInstOperands,
     /*  55720 */     // GIR_Coverage, 2518,
     /*  55720 */     GIR_EraseRootFromParent_Done,
     /*  55721 */   // Label 1340: @55721
     /*  55721 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(55759), // Rule ID 2519 //
     /*  55726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  55729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55733 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55744 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  55747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55757 */     GIR_RootConstrainSelectedInstOperands,
     /*  55758 */     // GIR_Coverage, 2519,
     /*  55758 */     GIR_EraseRootFromParent_Done,
     /*  55759 */   // Label 1341: @55759
     /*  55759 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(55801), // Rule ID 4490 //
     /*  55764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55775 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55786 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rm),
     /*  55789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55799 */     GIR_RootConstrainSelectedInstOperands,
     /*  55800 */     // GIR_Coverage, 4490,
     /*  55800 */     GIR_EraseRootFromParent_Done,
     /*  55801 */   // Label 1342: @55801
     /*  55801 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(55839), // Rule ID 4515 //
     /*  55806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55813 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55824 */     // (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  55824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128rm),
     /*  55827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55837 */     GIR_RootConstrainSelectedInstOperands,
     /*  55838 */     // GIR_Coverage, 4515,
     /*  55838 */     GIR_EraseRootFromParent_Done,
     /*  55839 */   // Label 1343: @55839
     /*  55839 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(55881), // Rule ID 4544 //
     /*  55844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55855 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55866 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  55869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55879 */     GIR_RootConstrainSelectedInstOperands,
     /*  55880 */     // GIR_Coverage, 4544,
     /*  55880 */     GIR_EraseRootFromParent_Done,
     /*  55881 */   // Label 1344: @55881
     /*  55881 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(55919), // Rule ID 4587 //
     /*  55886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  55889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  55893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55904 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  55907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55917 */     GIR_RootConstrainSelectedInstOperands,
     /*  55918 */     // GIR_Coverage, 4587,
     /*  55918 */     GIR_EraseRootFromParent_Done,
     /*  55919 */   // Label 1345: @55919
     /*  55919 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(55961), // Rule ID 17939 //
     /*  55924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55935 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  55939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55946 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  55949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55959 */     GIR_RootConstrainSelectedInstOperands,
     /*  55960 */     // GIR_Coverage, 17939,
     /*  55960 */     GIR_EraseRootFromParent_Done,
     /*  55961 */   // Label 1346: @55961
     /*  55961 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(55999), // Rule ID 17943 //
     /*  55966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  55969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  55973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  55977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  55984 */     // (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  55984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  55987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  55993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  55997 */     GIR_RootConstrainSelectedInstOperands,
     /*  55998 */     // GIR_Coverage, 17943,
     /*  55998 */     GIR_EraseRootFromParent_Done,
     /*  55999 */   // Label 1347: @55999
     /*  55999 */   GIM_Reject,
     /*  56000 */ // Label 1335: @56000
     /*  56000 */ GIM_Reject,
     /*  56001 */ // Label 1278: @56001
     /*  56001 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(56067), // Rule ID 19447 //
     /*  56006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /*  56009 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56012 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /*  56020 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56024 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56031 */   // (ld:{ *:[v4i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src), VK4:{ *:[i32] })
     /*  56031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /*  56034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56043 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  56047 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /*  56066 */   // GIR_Coverage, 19447,
     /*  56066 */   GIR_EraseRootFromParent_Done,
     /*  56067 */ // Label 1348: @56067
     /*  56067 */ GIM_Reject,
     /*  56068 */ // Label 1279: @56068
     /*  56068 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(56561),
     /*  56073 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56080 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(56122), // Rule ID 1703 //
     /*  56085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56092 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56096 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56107 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  56110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56112 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56120 */     GIR_RootConstrainSelectedInstOperands,
     /*  56121 */     // GIR_Coverage, 1703,
     /*  56121 */     GIR_EraseRootFromParent_Done,
     /*  56122 */   // Label 1350: @56122
     /*  56122 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(56160), // Rule ID 1705 //
     /*  56127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56145 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  56148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56158 */     GIR_RootConstrainSelectedInstOperands,
     /*  56159 */     // GIR_Coverage, 1705,
     /*  56159 */     GIR_EraseRootFromParent_Done,
     /*  56160 */   // Label 1351: @56160
     /*  56160 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(56202), // Rule ID 1711 //
     /*  56165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56176 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56187 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56192 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56200 */     GIR_RootConstrainSelectedInstOperands,
     /*  56201 */     // GIR_Coverage, 1711,
     /*  56201 */     GIR_EraseRootFromParent_Done,
     /*  56202 */   // Label 1352: @56202
     /*  56202 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(56240), // Rule ID 1712 //
     /*  56207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56214 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56225 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56238 */     GIR_RootConstrainSelectedInstOperands,
     /*  56239 */     // GIR_Coverage, 1712,
     /*  56239 */     GIR_EraseRootFromParent_Done,
     /*  56240 */   // Label 1353: @56240
     /*  56240 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(56282), // Rule ID 4472 //
     /*  56245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56256 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56267 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  56270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56276 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56280 */     GIR_RootConstrainSelectedInstOperands,
     /*  56281 */     // GIR_Coverage, 4472,
     /*  56281 */     GIR_EraseRootFromParent_Done,
     /*  56282 */   // Label 1354: @56282
     /*  56282 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(56320), // Rule ID 4503 //
     /*  56287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56305 */     // (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  56305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  56308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56310 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56318 */     GIR_RootConstrainSelectedInstOperands,
     /*  56319 */     // GIR_Coverage, 4503,
     /*  56319 */     GIR_EraseRootFromParent_Done,
     /*  56320 */   // Label 1355: @56320
     /*  56320 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(56362), // Rule ID 17940 //
     /*  56325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56332 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56336 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56347 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  56350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56360 */     GIR_RootConstrainSelectedInstOperands,
     /*  56361 */     // GIR_Coverage, 17940,
     /*  56361 */     GIR_EraseRootFromParent_Done,
     /*  56362 */   // Label 1356: @56362
     /*  56362 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(56400), // Rule ID 17944 //
     /*  56367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56385 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  56388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56390 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56398 */     GIR_RootConstrainSelectedInstOperands,
     /*  56399 */     // GIR_Coverage, 17944,
     /*  56399 */     GIR_EraseRootFromParent_Done,
     /*  56400 */   // Label 1357: @56400
     /*  56400 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(56442), // Rule ID 18319 //
     /*  56405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56416 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56427 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  56430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56440 */     GIR_RootConstrainSelectedInstOperands,
     /*  56441 */     // GIR_Coverage, 18319,
     /*  56441 */     GIR_EraseRootFromParent_Done,
     /*  56442 */   // Label 1358: @56442
     /*  56442 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(56480), // Rule ID 18323 //
     /*  56447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  56454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56465 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  56468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56478 */     GIR_RootConstrainSelectedInstOperands,
     /*  56479 */     // GIR_Coverage, 18323,
     /*  56479 */     GIR_EraseRootFromParent_Done,
     /*  56480 */   // Label 1359: @56480
     /*  56480 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(56522), // Rule ID 19812 //
     /*  56485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56496 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56507 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  56510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56520 */     GIR_RootConstrainSelectedInstOperands,
     /*  56521 */     // GIR_Coverage, 19812,
     /*  56521 */     GIR_EraseRootFromParent_Done,
     /*  56522 */   // Label 1360: @56522
     /*  56522 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(56560), // Rule ID 19816 //
     /*  56527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  56530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  56534 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56545 */     // (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  56545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  56548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56558 */     GIR_RootConstrainSelectedInstOperands,
     /*  56559 */     // GIR_Coverage, 19816,
     /*  56559 */     GIR_EraseRootFromParent_Done,
     /*  56560 */   // Label 1361: @56560
     /*  56560 */   GIM_Reject,
     /*  56561 */ // Label 1349: @56561
     /*  56561 */ GIM_Reject,
     /*  56562 */ // Label 1280: @56562
     /*  56562 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(56895),
     /*  56567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56570 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56574 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(56616), // Rule ID 1708 //
     /*  56579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56586 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56590 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56601 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYrm),
     /*  56604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56606 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56610 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56614 */     GIR_RootConstrainSelectedInstOperands,
     /*  56615 */     // GIR_Coverage, 1708,
     /*  56615 */     GIR_EraseRootFromParent_Done,
     /*  56616 */   // Label 1363: @56616
     /*  56616 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(56654), // Rule ID 1710 //
     /*  56621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56639 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYrm),
     /*  56642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56652 */     GIR_RootConstrainSelectedInstOperands,
     /*  56653 */     // GIR_Coverage, 1710,
     /*  56653 */     GIR_EraseRootFromParent_Done,
     /*  56654 */   // Label 1364: @56654
     /*  56654 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(56696), // Rule ID 4485 //
     /*  56659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56670 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56681 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rm),
     /*  56684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56694 */     GIR_RootConstrainSelectedInstOperands,
     /*  56695 */     // GIR_Coverage, 4485,
     /*  56695 */     GIR_EraseRootFromParent_Done,
     /*  56696 */   // Label 1365: @56696
     /*  56696 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(56734), // Rule ID 4512 //
     /*  56701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56719 */     // (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  56719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256rm),
     /*  56722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56724 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56732 */     GIR_RootConstrainSelectedInstOperands,
     /*  56733 */     // GIR_Coverage, 4512,
     /*  56733 */     GIR_EraseRootFromParent_Done,
     /*  56734 */   // Label 1366: @56734
     /*  56734 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(56776), // Rule ID 4539 //
     /*  56739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56750 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56761 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  56764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56766 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56774 */     GIR_RootConstrainSelectedInstOperands,
     /*  56775 */     // GIR_Coverage, 4539,
     /*  56775 */     GIR_EraseRootFromParent_Done,
     /*  56776 */   // Label 1367: @56776
     /*  56776 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(56814), // Rule ID 4584 //
     /*  56781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  56784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  56788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56799 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  56802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56812 */     GIR_RootConstrainSelectedInstOperands,
     /*  56813 */     // GIR_Coverage, 4584,
     /*  56813 */     GIR_EraseRootFromParent_Done,
     /*  56814 */   // Label 1368: @56814
     /*  56814 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(56856), // Rule ID 17915 //
     /*  56819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  56834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56841 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  56844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56854 */     GIR_RootConstrainSelectedInstOperands,
     /*  56855 */     // GIR_Coverage, 17915,
     /*  56855 */     GIR_EraseRootFromParent_Done,
     /*  56856 */   // Label 1369: @56856
     /*  56856 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56894), // Rule ID 17919 //
     /*  56861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  56868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56879 */     // (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /*  56879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  56882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56892 */     GIR_RootConstrainSelectedInstOperands,
     /*  56893 */     // GIR_Coverage, 17919,
     /*  56893 */     GIR_EraseRootFromParent_Done,
     /*  56894 */   // Label 1370: @56894
     /*  56894 */   GIM_Reject,
     /*  56895 */ // Label 1362: @56895
     /*  56895 */ GIM_Reject,
     /*  56896 */ // Label 1281: @56896
     /*  56896 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(56977),
     /*  56901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  56912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  56916 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56946), // Rule ID 4395 //
     /*  56921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  56924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56931 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm),
     /*  56934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56944 */     GIR_RootConstrainSelectedInstOperands,
     /*  56945 */     // GIR_Coverage, 4395,
     /*  56945 */     GIR_EraseRootFromParent_Done,
     /*  56946 */   // Label 1372: @56946
     /*  56946 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56976), // Rule ID 4397 //
     /*  56951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  56954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  56961 */     // (ld:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVBkm_EVEX:{ *:[v8i1] } addr:{ *:[iPTR] }:$src)
     /*  56961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBkm_EVEX),
     /*  56964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  56970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  56974 */     GIR_RootConstrainSelectedInstOperands,
     /*  56975 */     // GIR_Coverage, 4397,
     /*  56975 */     GIR_EraseRootFromParent_Done,
     /*  56976 */   // Label 1373: @56976
     /*  56976 */   GIM_Reject,
     /*  56977 */ // Label 1371: @56977
     /*  56977 */ GIM_Reject,
     /*  56978 */ // Label 1282: @56978
     /*  56978 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(57551),
     /*  56983 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  56986 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  56990 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(57032), // Rule ID 17931 //
     /*  56995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  56998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57006 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57017 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSrm),
     /*  57020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57030 */     GIR_RootConstrainSelectedInstOperands,
     /*  57031 */     // GIR_Coverage, 17931,
     /*  57031 */     GIR_EraseRootFromParent_Done,
     /*  57032 */   // Label 1375: @57032
     /*  57032 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(57070), // Rule ID 17932 //
     /*  57037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57055 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSrm),
     /*  57058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57068 */     GIR_RootConstrainSelectedInstOperands,
     /*  57069 */     // GIR_Coverage, 17932,
     /*  57069 */     GIR_EraseRootFromParent_Done,
     /*  57070 */   // Label 1376: @57070
     /*  57070 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(57112), // Rule ID 17941 //
     /*  57075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57086 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57097 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57110 */     GIR_RootConstrainSelectedInstOperands,
     /*  57111 */     // GIR_Coverage, 17941,
     /*  57111 */     GIR_EraseRootFromParent_Done,
     /*  57112 */   // Label 1377: @57112
     /*  57112 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(57150), // Rule ID 17945 //
     /*  57117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  57120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57135 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57148 */     GIR_RootConstrainSelectedInstOperands,
     /*  57149 */     // GIR_Coverage, 17945,
     /*  57149 */     GIR_EraseRootFromParent_Done,
     /*  57150 */   // Label 1378: @57150
     /*  57150 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(57192), // Rule ID 17955 //
     /*  57155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57166 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57177 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  57180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57190 */     GIR_RootConstrainSelectedInstOperands,
     /*  57191 */     // GIR_Coverage, 17955,
     /*  57191 */     GIR_EraseRootFromParent_Done,
     /*  57192 */   // Label 1379: @57192
     /*  57192 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(57230), // Rule ID 17956 //
     /*  57197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  57200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57215 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  57218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57228 */     GIR_RootConstrainSelectedInstOperands,
     /*  57229 */     // GIR_Coverage, 17956,
     /*  57229 */     GIR_EraseRootFromParent_Done,
     /*  57230 */   // Label 1380: @57230
     /*  57230 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(57272), // Rule ID 18320 //
     /*  57235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57246 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57257 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57270 */     GIR_RootConstrainSelectedInstOperands,
     /*  57271 */     // GIR_Coverage, 18320,
     /*  57271 */     GIR_EraseRootFromParent_Done,
     /*  57272 */   // Label 1381: @57272
     /*  57272 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(57314), // Rule ID 18321 //
     /*  57277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57288 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57299 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  57302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57312 */     GIR_RootConstrainSelectedInstOperands,
     /*  57313 */     // GIR_Coverage, 18321,
     /*  57313 */     GIR_EraseRootFromParent_Done,
     /*  57314 */   // Label 1382: @57314
     /*  57314 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(57352), // Rule ID 18324 //
     /*  57319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57337 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57350 */     GIR_RootConstrainSelectedInstOperands,
     /*  57351 */     // GIR_Coverage, 18324,
     /*  57351 */     GIR_EraseRootFromParent_Done,
     /*  57352 */   // Label 1383: @57352
     /*  57352 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57390), // Rule ID 18325 //
     /*  57357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  57364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57375 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  57378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57388 */     GIR_RootConstrainSelectedInstOperands,
     /*  57389 */     // GIR_Coverage, 18325,
     /*  57389 */     GIR_EraseRootFromParent_Done,
     /*  57390 */   // Label 1384: @57390
     /*  57390 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57432), // Rule ID 19813 //
     /*  57395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57406 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57417 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  57420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57430 */     GIR_RootConstrainSelectedInstOperands,
     /*  57431 */     // GIR_Coverage, 19813,
     /*  57431 */     GIR_EraseRootFromParent_Done,
     /*  57432 */   // Label 1385: @57432
     /*  57432 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57474), // Rule ID 19814 //
     /*  57437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57448 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57459 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rm),
     /*  57462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57472 */     GIR_RootConstrainSelectedInstOperands,
     /*  57473 */     // GIR_Coverage, 19814,
     /*  57473 */     GIR_EraseRootFromParent_Done,
     /*  57474 */   // Label 1386: @57474
     /*  57474 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57512), // Rule ID 19817 //
     /*  57479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57497 */     // (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  57497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  57500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57510 */     GIR_RootConstrainSelectedInstOperands,
     /*  57511 */     // GIR_Coverage, 19817,
     /*  57511 */     GIR_EraseRootFromParent_Done,
     /*  57512 */   // Label 1387: @57512
     /*  57512 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57550), // Rule ID 19818 //
     /*  57517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  57524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57535 */     // (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /*  57535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128rm),
     /*  57538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57540 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57548 */     GIR_RootConstrainSelectedInstOperands,
     /*  57549 */     // GIR_Coverage, 19818,
     /*  57549 */     GIR_EraseRootFromParent_Done,
     /*  57550 */   // Label 1388: @57550
     /*  57550 */   GIM_Reject,
     /*  57551 */ // Label 1374: @57551
     /*  57551 */ GIM_Reject,
     /*  57552 */ // Label 1283: @57552
     /*  57552 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57885),
     /*  57557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57560 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57564 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57606), // Rule ID 1707 //
     /*  57569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57591 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57604 */     GIR_RootConstrainSelectedInstOperands,
     /*  57605 */     // GIR_Coverage, 1707,
     /*  57605 */     GIR_EraseRootFromParent_Done,
     /*  57606 */   // Label 1390: @57606
     /*  57606 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57644), // Rule ID 1709 //
     /*  57611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57629 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57642 */     GIR_RootConstrainSelectedInstOperands,
     /*  57643 */     // GIR_Coverage, 1709,
     /*  57643 */     GIR_EraseRootFromParent_Done,
     /*  57644 */   // Label 1391: @57644
     /*  57644 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57686), // Rule ID 4467 //
     /*  57649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57660 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57671 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  57674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57676 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57684 */     GIR_RootConstrainSelectedInstOperands,
     /*  57685 */     // GIR_Coverage, 4467,
     /*  57685 */     GIR_EraseRootFromParent_Done,
     /*  57686 */   // Label 1392: @57686
     /*  57686 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57724), // Rule ID 4500 //
     /*  57691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  57694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57709 */     // (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  57709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  57712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57722 */     GIR_RootConstrainSelectedInstOperands,
     /*  57723 */     // GIR_Coverage, 4500,
     /*  57723 */     GIR_EraseRootFromParent_Done,
     /*  57724 */   // Label 1393: @57724
     /*  57724 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(57766), // Rule ID 17916 //
     /*  57729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57740 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57751 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  57754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57756 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57764 */     GIR_RootConstrainSelectedInstOperands,
     /*  57765 */     // GIR_Coverage, 17916,
     /*  57765 */     GIR_EraseRootFromParent_Done,
     /*  57766 */   // Label 1394: @57766
     /*  57766 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(57804), // Rule ID 17920 //
     /*  57771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  57774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  57778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57789 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  57792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57802 */     GIR_RootConstrainSelectedInstOperands,
     /*  57803 */     // GIR_Coverage, 17920,
     /*  57803 */     GIR_EraseRootFromParent_Done,
     /*  57804 */   // Label 1395: @57804
     /*  57804 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(57846), // Rule ID 19828 //
     /*  57809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57831 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57836 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57844 */     GIR_RootConstrainSelectedInstOperands,
     /*  57845 */     // GIR_Coverage, 19828,
     /*  57845 */     GIR_EraseRootFromParent_Done,
     /*  57846 */   // Label 1396: @57846
     /*  57846 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(57884), // Rule ID 19832 //
     /*  57851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  57854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  57858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57869 */     // (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /*  57869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  57872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57882 */     GIR_RootConstrainSelectedInstOperands,
     /*  57883 */     // GIR_Coverage, 19832,
     /*  57883 */     GIR_EraseRootFromParent_Done,
     /*  57884 */   // Label 1397: @57884
     /*  57884 */   GIM_Reject,
     /*  57885 */ // Label 1389: @57885
     /*  57885 */ GIM_Reject,
     /*  57886 */ // Label 1284: @57886
     /*  57886 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(58059),
     /*  57891 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  57894 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  57898 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(57940), // Rule ID 4480 //
     /*  57903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57914 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57925 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrm),
     /*  57928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57938 */     GIR_RootConstrainSelectedInstOperands,
     /*  57939 */     // GIR_Coverage, 4480,
     /*  57939 */     GIR_EraseRootFromParent_Done,
     /*  57940 */   // Label 1399: @57940
     /*  57940 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(57978), // Rule ID 4509 //
     /*  57945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  57963 */     // (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /*  57963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZrm),
     /*  57966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  57968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  57972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  57976 */     GIR_RootConstrainSelectedInstOperands,
     /*  57977 */     // GIR_Coverage, 4509,
     /*  57977 */     GIR_EraseRootFromParent_Done,
     /*  57978 */   // Label 1400: @57978
     /*  57978 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58020), // Rule ID 4534 //
     /*  57983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  57986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  57990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  57994 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  57998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58005 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  58005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58018 */     GIR_RootConstrainSelectedInstOperands,
     /*  58019 */     // GIR_Coverage, 4534,
     /*  58019 */     GIR_EraseRootFromParent_Done,
     /*  58020 */   // Label 1401: @58020
     /*  58020 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58058), // Rule ID 4581 //
     /*  58025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58043 */     // (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /*  58043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58056 */     GIR_RootConstrainSelectedInstOperands,
     /*  58057 */     // GIR_Coverage, 4581,
     /*  58057 */     GIR_EraseRootFromParent_Done,
     /*  58058 */   // Label 1402: @58058
     /*  58058 */   GIM_Reject,
     /*  58059 */ // Label 1398: @58059
     /*  58059 */ GIM_Reject,
     /*  58060 */ // Label 1285: @58060
     /*  58060 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58141),
     /*  58065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  58076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58080 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58110), // Rule ID 4399 //
     /*  58085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  58088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58095 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm),
     /*  58098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58108 */     GIR_RootConstrainSelectedInstOperands,
     /*  58109 */     // GIR_Coverage, 4399,
     /*  58109 */     GIR_EraseRootFromParent_Done,
     /*  58110 */   // Label 1404: @58110
     /*  58110 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(58140), // Rule ID 4401 //
     /*  58115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  58118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58125 */     // (ld:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVWkm_EVEX:{ *:[v16i1] } addr:{ *:[iPTR] }:$src)
     /*  58125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWkm_EVEX),
     /*  58128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58130 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58138 */     GIR_RootConstrainSelectedInstOperands,
     /*  58139 */     // GIR_Coverage, 4401,
     /*  58139 */     GIR_EraseRootFromParent_Done,
     /*  58140 */   // Label 1405: @58140
     /*  58140 */   GIM_Reject,
     /*  58141 */ // Label 1403: @58141
     /*  58141 */ GIM_Reject,
     /*  58142 */ // Label 1286: @58142
     /*  58142 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(58395),
     /*  58147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58150 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58154 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(58196), // Rule ID 17942 //
     /*  58159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58170 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58181 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (MOVAPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSrm),
     /*  58184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58194 */     GIR_RootConstrainSelectedInstOperands,
     /*  58195 */     // GIR_Coverage, 17942,
     /*  58195 */     GIR_EraseRootFromParent_Done,
     /*  58196 */   // Label 1407: @58196
     /*  58196 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(58234), // Rule ID 17946 //
     /*  58201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  58204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58219 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (MOVUPSrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSrm),
     /*  58222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58232 */     GIR_RootConstrainSelectedInstOperands,
     /*  58233 */     // GIR_Coverage, 17946,
     /*  58233 */     GIR_EraseRootFromParent_Done,
     /*  58234 */   // Label 1408: @58234
     /*  58234 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(58276), // Rule ID 18322 //
     /*  58239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58246 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58250 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58261 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQArm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQArm),
     /*  58264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58274 */     GIR_RootConstrainSelectedInstOperands,
     /*  58275 */     // GIR_Coverage, 18322,
     /*  58275 */     GIR_EraseRootFromParent_Done,
     /*  58276 */   // Label 1409: @58276
     /*  58276 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(58314), // Rule ID 18326 //
     /*  58281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  58288 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58299 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUrm),
     /*  58302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58312 */     GIR_RootConstrainSelectedInstOperands,
     /*  58313 */     // GIR_Coverage, 18326,
     /*  58313 */     GIR_EraseRootFromParent_Done,
     /*  58314 */   // Label 1410: @58314
     /*  58314 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(58356), // Rule ID 19815 //
     /*  58319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58330 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58341 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rm),
     /*  58344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58346 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58354 */     GIR_RootConstrainSelectedInstOperands,
     /*  58355 */     // GIR_Coverage, 19815,
     /*  58355 */     GIR_EraseRootFromParent_Done,
     /*  58356 */   // Label 1411: @58356
     /*  58356 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(58394), // Rule ID 19819 //
     /*  58361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  58368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58379 */     // (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /*  58379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128rm),
     /*  58382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58384 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58392 */     GIR_RootConstrainSelectedInstOperands,
     /*  58393 */     // GIR_Coverage, 19819,
     /*  58393 */     GIR_EraseRootFromParent_Done,
     /*  58394 */   // Label 1412: @58394
     /*  58394 */   GIM_Reject,
     /*  58395 */ // Label 1406: @58395
     /*  58395 */ GIM_Reject,
     /*  58396 */ // Label 1287: @58396
     /*  58396 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(58729),
     /*  58401 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58404 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58408 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(58450), // Rule ID 17917 //
     /*  58413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58424 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58435 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58448 */     GIR_RootConstrainSelectedInstOperands,
     /*  58449 */     // GIR_Coverage, 17917,
     /*  58449 */     GIR_EraseRootFromParent_Done,
     /*  58450 */   // Label 1414: @58450
     /*  58450 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(58488), // Rule ID 17921 //
     /*  58455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58462 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58473 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58486 */     GIR_RootConstrainSelectedInstOperands,
     /*  58487 */     // GIR_Coverage, 17921,
     /*  58487 */     GIR_EraseRootFromParent_Done,
     /*  58488 */   // Label 1415: @58488
     /*  58488 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(58530), // Rule ID 17935 //
     /*  58493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58515 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  58518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58520 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58528 */     GIR_RootConstrainSelectedInstOperands,
     /*  58529 */     // GIR_Coverage, 17935,
     /*  58529 */     GIR_EraseRootFromParent_Done,
     /*  58530 */   // Label 1416: @58530
     /*  58530 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(58568), // Rule ID 17936 //
     /*  58535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  58538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  58542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58553 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  58556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58566 */     GIR_RootConstrainSelectedInstOperands,
     /*  58567 */     // GIR_Coverage, 17936,
     /*  58567 */     GIR_EraseRootFromParent_Done,
     /*  58568 */   // Label 1417: @58568
     /*  58568 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(58610), // Rule ID 19829 //
     /*  58573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58584 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58595 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  58598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58608 */     GIR_RootConstrainSelectedInstOperands,
     /*  58609 */     // GIR_Coverage, 19829,
     /*  58609 */     GIR_EraseRootFromParent_Done,
     /*  58610 */   // Label 1418: @58610
     /*  58610 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(58652), // Rule ID 19830 //
     /*  58615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58626 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58637 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rm),
     /*  58640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58642 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58650 */     GIR_RootConstrainSelectedInstOperands,
     /*  58651 */     // GIR_Coverage, 19830,
     /*  58651 */     GIR_EraseRootFromParent_Done,
     /*  58652 */   // Label 1419: @58652
     /*  58652 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(58690), // Rule ID 19833 //
     /*  58657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58675 */     // (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /*  58675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  58678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58688 */     GIR_RootConstrainSelectedInstOperands,
     /*  58689 */     // GIR_Coverage, 19833,
     /*  58689 */     GIR_EraseRootFromParent_Done,
     /*  58690 */   // Label 1420: @58690
     /*  58690 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(58728), // Rule ID 19834 //
     /*  58695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  58698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  58702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58713 */     // (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /*  58713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256rm),
     /*  58716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58718 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58726 */     GIR_RootConstrainSelectedInstOperands,
     /*  58727 */     // GIR_Coverage, 19834,
     /*  58727 */     GIR_EraseRootFromParent_Done,
     /*  58728 */   // Label 1421: @58728
     /*  58728 */   GIM_Reject,
     /*  58729 */ // Label 1413: @58729
     /*  58729 */ GIM_Reject,
     /*  58730 */ // Label 1288: @58730
     /*  58730 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(58903),
     /*  58735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58742 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(58784), // Rule ID 4462 //
     /*  58747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58758 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58769 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  58772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58782 */     GIR_RootConstrainSelectedInstOperands,
     /*  58783 */     // GIR_Coverage, 4462,
     /*  58783 */     GIR_EraseRootFromParent_Done,
     /*  58784 */   // Label 1423: @58784
     /*  58784 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(58822), // Rule ID 4497 //
     /*  58789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58796 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58807 */     // (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /*  58807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  58810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58812 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58820 */     GIR_RootConstrainSelectedInstOperands,
     /*  58821 */     // GIR_Coverage, 4497,
     /*  58821 */     GIR_EraseRootFromParent_Done,
     /*  58822 */   // Label 1424: @58822
     /*  58822 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(58864), // Rule ID 19796 //
     /*  58827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58838 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  58842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58849 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  58852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58862 */     GIR_RootConstrainSelectedInstOperands,
     /*  58863 */     // GIR_Coverage, 19796,
     /*  58863 */     GIR_EraseRootFromParent_Done,
     /*  58864 */   // Label 1425: @58864
     /*  58864 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(58902), // Rule ID 19800 //
     /*  58869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  58872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  58876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58887 */     // (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /*  58887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  58890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58900 */     GIR_RootConstrainSelectedInstOperands,
     /*  58901 */     // GIR_Coverage, 19800,
     /*  58901 */     GIR_EraseRootFromParent_Done,
     /*  58902 */   // Label 1426: @58902
     /*  58902 */   GIM_Reject,
     /*  58903 */ // Label 1422: @58903
     /*  58903 */ GIM_Reject,
     /*  58904 */ // Label 1289: @58904
     /*  58904 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(58985),
     /*  58909 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58912 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  58920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  58924 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(58954), // Rule ID 4403 //
     /*  58929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  58932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58939 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm),
     /*  58942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58952 */     GIR_RootConstrainSelectedInstOperands,
     /*  58953 */     // GIR_Coverage, 4403,
     /*  58953 */     GIR_EraseRootFromParent_Done,
     /*  58954 */   // Label 1428: @58954
     /*  58954 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(58984), // Rule ID 4407 //
     /*  58959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  58962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  58969 */     // (ld:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVDkm_EVEX:{ *:[v32i1] } addr:{ *:[iPTR] }:$src)
     /*  58969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDkm_EVEX),
     /*  58972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  58978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  58982 */     GIR_RootConstrainSelectedInstOperands,
     /*  58983 */     // GIR_Coverage, 4407,
     /*  58983 */     GIR_EraseRootFromParent_Done,
     /*  58984 */   // Label 1429: @58984
     /*  58984 */   GIM_Reject,
     /*  58985 */ // Label 1427: @58985
     /*  58985 */ GIM_Reject,
     /*  58986 */ // Label 1290: @58986
     /*  58986 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(59159),
     /*  58991 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  58994 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  58998 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(59040), // Rule ID 17918 //
     /*  59003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  59006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  59010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59014 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59025 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYrm),
     /*  59028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59038 */     GIR_RootConstrainSelectedInstOperands,
     /*  59039 */     // GIR_Coverage, 17918,
     /*  59039 */     GIR_EraseRootFromParent_Done,
     /*  59040 */   // Label 1431: @59040
     /*  59040 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(59078), // Rule ID 17922 //
     /*  59045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  59048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  59052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59063 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYrm),
     /*  59066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59076 */     GIR_RootConstrainSelectedInstOperands,
     /*  59077 */     // GIR_Coverage, 17922,
     /*  59077 */     GIR_EraseRootFromParent_Done,
     /*  59078 */   // Label 1432: @59078
     /*  59078 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(59120), // Rule ID 19831 //
     /*  59083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59094 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59105 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rm),
     /*  59108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59110 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59118 */     GIR_RootConstrainSelectedInstOperands,
     /*  59119 */     // GIR_Coverage, 19831,
     /*  59119 */     GIR_EraseRootFromParent_Done,
     /*  59120 */   // Label 1433: @59120
     /*  59120 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(59158), // Rule ID 19835 //
     /*  59125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  59128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  59132 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59143 */     // (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Z256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /*  59143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256rm),
     /*  59146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59148 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59156 */     GIR_RootConstrainSelectedInstOperands,
     /*  59157 */     // GIR_Coverage, 19835,
     /*  59157 */     GIR_EraseRootFromParent_Done,
     /*  59158 */   // Label 1434: @59158
     /*  59158 */   GIM_Reject,
     /*  59159 */ // Label 1430: @59159
     /*  59159 */ GIM_Reject,
     /*  59160 */ // Label 1291: @59160
     /*  59160 */ GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(59333),
     /*  59165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59172 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(59214), // Rule ID 19797 //
     /*  59177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59199 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59204 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59212 */     GIR_RootConstrainSelectedInstOperands,
     /*  59213 */     // GIR_Coverage, 19797,
     /*  59213 */     GIR_EraseRootFromParent_Done,
     /*  59214 */   // Label 1436: @59214
     /*  59214 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(59256), // Rule ID 19798 //
     /*  59219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59230 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59241 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVAPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrm),
     /*  59244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59254 */     GIR_RootConstrainSelectedInstOperands,
     /*  59255 */     // GIR_Coverage, 19798,
     /*  59255 */     GIR_EraseRootFromParent_Done,
     /*  59256 */   // Label 1437: @59256
     /*  59256 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(59294), // Rule ID 19801 //
     /*  59261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59279 */     // (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /*  59279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59292 */     GIR_RootConstrainSelectedInstOperands,
     /*  59293 */     // GIR_Coverage, 19801,
     /*  59293 */     GIR_EraseRootFromParent_Done,
     /*  59294 */   // Label 1438: @59294
     /*  59294 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(59332), // Rule ID 19802 //
     /*  59299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59317 */     // (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVUPSZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /*  59317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZrm),
     /*  59320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59322 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59330 */     GIR_RootConstrainSelectedInstOperands,
     /*  59331 */     // GIR_Coverage, 19802,
     /*  59331 */     GIR_EraseRootFromParent_Done,
     /*  59332 */   // Label 1439: @59332
     /*  59332 */   GIM_Reject,
     /*  59333 */ // Label 1435: @59333
     /*  59333 */ GIM_Reject,
     /*  59334 */ // Label 1292: @59334
     /*  59334 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(59415),
     /*  59339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  59350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59354 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(59384), // Rule ID 4405 //
     /*  59359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  59362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59369 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm),
     /*  59372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59382 */     GIR_RootConstrainSelectedInstOperands,
     /*  59383 */     // GIR_Coverage, 4405,
     /*  59383 */     GIR_EraseRootFromParent_Done,
     /*  59384 */   // Label 1441: @59384
     /*  59384 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(59414), // Rule ID 4409 //
     /*  59389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  59392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59399 */     // (ld:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (KMOVQkm_EVEX:{ *:[v64i1] } addr:{ *:[iPTR] }:$src)
     /*  59399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQkm_EVEX),
     /*  59402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59412 */     GIR_RootConstrainSelectedInstOperands,
     /*  59413 */     // GIR_Coverage, 4409,
     /*  59413 */     GIR_EraseRootFromParent_Done,
     /*  59414 */   // Label 1442: @59414
     /*  59414 */   GIM_Reject,
     /*  59415 */ // Label 1440: @59415
     /*  59415 */ GIM_Reject,
     /*  59416 */ // Label 1293: @59416
     /*  59416 */ GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(59509),
     /*  59421 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59424 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  59428 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(59470), // Rule ID 19799 //
     /*  59433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /*  59448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59455 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>  =>  (VMOVDQA64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrm),
     /*  59458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59460 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59468 */     GIR_RootConstrainSelectedInstOperands,
     /*  59469 */     // GIR_Coverage, 19799,
     /*  59469 */     GIR_EraseRootFromParent_Done,
     /*  59470 */   // Label 1444: @59470
     /*  59470 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(59508), // Rule ID 19803 //
     /*  59475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  59478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  59482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59493 */     // (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (VMOVDQU64Zrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /*  59493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zrm),
     /*  59496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59506 */     GIR_RootConstrainSelectedInstOperands,
     /*  59507 */     // GIR_Coverage, 19803,
     /*  59507 */     GIR_EraseRootFromParent_Done,
     /*  59508 */   // Label 1445: @59508
     /*  59508 */   GIM_Reject,
     /*  59509 */ // Label 1443: @59509
     /*  59509 */ GIM_Reject,
     /*  59510 */ // Label 1294: @59510
     /*  59510 */ GIM_Reject,
     /*  59511 */ // Label 11: @59511
     /*  59511 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 1449*/ GIMT_Encode4(59843),
     /*  59522 */ /*GILLT_s16*//*Label 1446*/ GIMT_Encode4(59534),
     /*  59526 */ /*GILLT_s32*//*Label 1447*/ GIMT_Encode4(59610),
     /*  59530 */ /*GILLT_s64*//*Label 1448*/ GIMT_Encode4(59704),
     /*  59534 */ // Label 1446: @59534
     /*  59534 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(59609), // Rule ID 22648 //
     /*  59539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59542 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59553 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59557 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59564 */   // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59576 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59580 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59591 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59598 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59608 */   // GIR_Coverage, 22648,
     /*  59608 */   GIR_EraseRootFromParent_Done,
     /*  59609 */ // Label 1450: @59609
     /*  59609 */ GIM_Reject,
     /*  59610 */ // Label 1447: @59610
     /*  59610 */ GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(59703),
     /*  59615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59618 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(59660), // Rule ID 615 //
     /*  59623 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59645 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm8),
     /*  59648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59658 */     GIR_RootConstrainSelectedInstOperands,
     /*  59659 */     // GIR_Coverage, 615,
     /*  59659 */     GIR_EraseRootFromParent_Done,
     /*  59660 */   // Label 1452: @59660
     /*  59660 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(59702), // Rule ID 617 //
     /*  59665 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  59676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59687 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  59687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rm16),
     /*  59690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59700 */     GIR_RootConstrainSelectedInstOperands,
     /*  59701 */     // GIR_Coverage, 617,
     /*  59701 */     GIR_EraseRootFromParent_Done,
     /*  59702 */   // Label 1453: @59702
     /*  59702 */   GIM_Reject,
     /*  59703 */ // Label 1451: @59703
     /*  59703 */ GIM_Reject,
     /*  59704 */ // Label 1448: @59704
     /*  59704 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(59842),
     /*  59709 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59712 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(59754), // Rule ID 623 //
     /*  59717 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59728 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59739 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (MOVSX64rm8:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm8),
     /*  59742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59752 */     GIR_RootConstrainSelectedInstOperands,
     /*  59753 */     // GIR_Coverage, 623,
     /*  59753 */     GIR_EraseRootFromParent_Done,
     /*  59754 */   // Label 1455: @59754
     /*  59754 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(59796), // Rule ID 625 //
     /*  59759 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  59766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59781 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (MOVSX64rm16:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm16),
     /*  59784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59794 */     GIR_RootConstrainSelectedInstOperands,
     /*  59795 */     // GIR_Coverage, 625,
     /*  59795 */     GIR_EraseRootFromParent_Done,
     /*  59796 */   // Label 1456: @59796
     /*  59796 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(59841), // Rule ID 627 //
     /*  59801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  59804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  59811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  59815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59826 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (MOVSX64rm32:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /*  59826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX64rm32),
     /*  59829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59839 */     GIR_RootConstrainSelectedInstOperands,
     /*  59840 */     // GIR_Coverage, 627,
     /*  59840 */     GIR_EraseRootFromParent_Done,
     /*  59841 */   // Label 1457: @59841
     /*  59841 */   GIM_Reject,
     /*  59842 */ // Label 1454: @59842
     /*  59842 */ GIM_Reject,
     /*  59843 */ // Label 1449: @59843
     /*  59843 */ GIM_Reject,
     /*  59844 */ // Label 12: @59844
     /*  59844 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1462*/ GIMT_Encode4(60498),
     /*  59855 */ /*GILLT_s8*//*Label 1458*/ GIMT_Encode4(59871),
     /*  59859 */ /*GILLT_s16*//*Label 1459*/ GIMT_Encode4(59917),
     /*  59863 */ /*GILLT_s32*//*Label 1460*/ GIMT_Encode4(60056),
     /*  59867 */ /*GILLT_s64*//*Label 1461*/ GIMT_Encode4(60192),
     /*  59871 */ // Label 1458: @59871
     /*  59871 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(59916), // Rule ID 22576 //
     /*  59876 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59879 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  59890 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59894 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59901 */   // (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOV8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /*  59901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8rm),
     /*  59904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59906 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  59910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59914 */   GIR_RootConstrainSelectedInstOperands,
     /*  59915 */   // GIR_Coverage, 22576,
     /*  59915 */   GIR_EraseRootFromParent_Done,
     /*  59916 */ // Label 1463: @59916
     /*  59916 */ GIM_Reject,
     /*  59917 */ // Label 1459: @59917
     /*  59917 */ GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(60055),
     /*  59922 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  59925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  59932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  59936 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  59940 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(59997), // Rule ID 22577 //
     /*  59945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  59952 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  59952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  59955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  59959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59964 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  59968 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  59972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59979 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  59986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  59991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  59996 */     // GIR_Coverage, 22577,
     /*  59996 */     GIR_EraseRootFromParent_Done,
     /*  59997 */   // Label 1465: @59997
     /*  59997 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(60054), // Rule ID 22650 //
     /*  60002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60009 */     // (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_16bit:{ *:[i32] })
     /*  60009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60021 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60025 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60036 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  60043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  60048 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  60053 */     // GIR_Coverage, 22650,
     /*  60053 */     GIR_EraseRootFromParent_Done,
     /*  60054 */   // Label 1466: @60054
     /*  60054 */   GIM_Reject,
     /*  60055 */ // Label 1464: @60055
     /*  60055 */ GIM_Reject,
     /*  60056 */ // Label 1460: @60056
     /*  60056 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(60191),
     /*  60061 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60064 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(60106), // Rule ID 619 //
     /*  60069 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60091 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60096 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60104 */     GIR_RootConstrainSelectedInstOperands,
     /*  60105 */     // GIR_Coverage, 619,
     /*  60105 */     GIR_EraseRootFromParent_Done,
     /*  60106 */   // Label 1468: @60106
     /*  60106 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(60148), // Rule ID 621 //
     /*  60111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60133 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60146 */     GIR_RootConstrainSelectedInstOperands,
     /*  60147 */     // GIR_Coverage, 621,
     /*  60147 */     GIR_EraseRootFromParent_Done,
     /*  60148 */   // Label 1469: @60148
     /*  60148 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(60190), // Rule ID 22578 //
     /*  60153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  60164 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60175 */     // (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /*  60175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  60184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60188 */     GIR_RootConstrainSelectedInstOperands,
     /*  60189 */     // GIR_Coverage, 22578,
     /*  60189 */     GIR_EraseRootFromParent_Done,
     /*  60190 */   // Label 1470: @60190
     /*  60190 */   GIM_Reject,
     /*  60191 */ // Label 1467: @60191
     /*  60191 */ GIM_Reject,
     /*  60192 */ // Label 1461: @60192
     /*  60192 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(60497),
     /*  60197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60200 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(60274), // Rule ID 17591 //
     /*  60205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60227 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60239 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60243 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60273 */     // GIR_Coverage, 17591,
     /*  60273 */     GIR_EraseRootFromParent_Done,
     /*  60274 */   // Label 1472: @60274
     /*  60274 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(60348), // Rule ID 17593 //
     /*  60279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  60286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60301 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm16:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm16),
     /*  60308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60313 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60317 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60347 */     // GIR_Coverage, 17593,
     /*  60347 */     GIR_EraseRootFromParent_Done,
     /*  60348 */   // Label 1473: @60348
     /*  60348 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(60422), // Rule ID 17595 //
     /*  60353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  60360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60375 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rm),
     /*  60382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60387 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60391 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60421 */     // GIR_Coverage, 17595,
     /*  60421 */     GIR_EraseRootFromParent_Done,
     /*  60422 */   // Label 1474: @60422
     /*  60422 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(60496), // Rule ID 22579 //
     /*  60427 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  60438 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  60442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60449 */     // (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rm8:{ *:[i32] } addr:{ *:[iPTR] }:$src), sub_32bit:{ *:[i32] })
     /*  60449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rm8),
     /*  60456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60461 */     GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /*  60465 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  60469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  60474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  60485 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /*  60490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /*  60495 */     // GIR_Coverage, 22579,
     /*  60495 */     GIR_EraseRootFromParent_Done,
     /*  60496 */   // Label 1475: @60496
     /*  60496 */   GIM_Reject,
     /*  60497 */ // Label 1471: @60497
     /*  60497 */ GIM_Reject,
     /*  60498 */ // Label 1462: @60498
     /*  60498 */ GIM_Reject,
     /*  60499 */ // Label 13: @60499
     /*  60499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(25), /*)*//*default:*//*Label 1498*/ GIMT_Encode4(85961),
     /*  60510 */ /*GILLT_s8*//*Label 1476*/ GIMT_Encode4(60606),
     /*  60514 */ /*GILLT_s16*//*Label 1477*/ GIMT_Encode4(65276),
     /*  60518 */ /*GILLT_s32*//*Label 1478*/ GIMT_Encode4(70520),
     /*  60522 */ /*GILLT_s64*//*Label 1479*/ GIMT_Encode4(76220),
     /*  60526 */ /*GILLT_s80*//*Label 1480*/ GIMT_Encode4(81612),
     /*  60530 */ /*GILLT_s128*//*Label 1481*/ GIMT_Encode4(81771), GIMT_Encode4(0),
     /*  60538 */ /*GILLT_v2s64*//*Label 1482*/ GIMT_Encode4(82025), GIMT_Encode4(0),
     /*  60546 */ /*GILLT_v4s32*//*Label 1483*/ GIMT_Encode4(82519),
     /*  60550 */ /*GILLT_v4s64*//*Label 1484*/ GIMT_Encode4(83013),
     /*  60554 */ /*GILLT_v8s1*//*Label 1485*/ GIMT_Encode4(83347),
     /*  60558 */ /*GILLT_v8s16*//*Label 1486*/ GIMT_Encode4(83429),
     /*  60562 */ /*GILLT_v8s32*//*Label 1487*/ GIMT_Encode4(84003),
     /*  60566 */ /*GILLT_v8s64*//*Label 1488*/ GIMT_Encode4(84337),
     /*  60570 */ /*GILLT_v16s1*//*Label 1489*/ GIMT_Encode4(84511),
     /*  60574 */ /*GILLT_v16s8*//*Label 1490*/ GIMT_Encode4(84593),
     /*  60578 */ /*GILLT_v16s16*//*Label 1491*/ GIMT_Encode4(84847),
     /*  60582 */ /*GILLT_v16s32*//*Label 1492*/ GIMT_Encode4(85181),
     /*  60586 */ /*GILLT_v32s1*//*Label 1493*/ GIMT_Encode4(85355),
     /*  60590 */ /*GILLT_v32s8*//*Label 1494*/ GIMT_Encode4(85437),
     /*  60594 */ /*GILLT_v32s16*//*Label 1495*/ GIMT_Encode4(85611),
     /*  60598 */ /*GILLT_v64s1*//*Label 1496*/ GIMT_Encode4(85785),
     /*  60602 */ /*GILLT_v64s8*//*Label 1497*/ GIMT_Encode4(85867),
     /*  60606 */ // Label 1476: @60606
     /*  60606 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(60702), // Rule ID 22491 //
     /*  60611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60614 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60617 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60632 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60636 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60640 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60644 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60648 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60651 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60655 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60662 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60666 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  60670 */   // MIs[0] dst
     /*  60670 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60675 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60677 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60684 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  60687 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60691 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60694 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60700 */   GIR_RootConstrainSelectedInstOperands,
     /*  60701 */   // GIR_Coverage, 22491,
     /*  60701 */   GIR_EraseRootFromParent_Done,
     /*  60702 */ // Label 1499: @60702
     /*  60702 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(60798), // Rule ID 22495 //
     /*  60707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60710 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60713 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60720 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60724 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  60728 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60732 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60736 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60740 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60744 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60747 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60751 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60758 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60762 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60766 */   // MIs[0] dst
     /*  60766 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60771 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60773 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60780 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  60783 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60787 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60796 */   GIR_RootConstrainSelectedInstOperands,
     /*  60797 */   // GIR_Coverage, 22495,
     /*  60797 */   GIR_EraseRootFromParent_Done,
     /*  60798 */ // Label 1500: @60798
     /*  60798 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(60891), // Rule ID 22499 //
     /*  60803 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  60821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60829 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  60833 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60837 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60841 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60848 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60855 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60859 */   // MIs[0] dst
     /*  60859 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60864 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60866 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60873 */   // (atomic_store (sub:{ *:[i8] } 0:{ *:[i8] }, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  60873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  60876 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60880 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  60883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60889 */   GIR_RootConstrainSelectedInstOperands,
     /*  60890 */   // GIR_Coverage, 22499,
     /*  60890 */   GIR_EraseRootFromParent_Done,
     /*  60891 */ // Label 1501: @60891
     /*  60891 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(60981), // Rule ID 22503 //
     /*  60896 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  60910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60914 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  60918 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  60922 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60926 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  60930 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  60933 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  60937 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  60944 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  60948 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60952 */   // MIs[0] dst
     /*  60952 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  60957 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60959 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  60966 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (NOT8m addr:{ *:[iPTR] }:$dst)
     /*  60966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  60969 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  60973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  60979 */   GIR_RootConstrainSelectedInstOperands,
     /*  60980 */   // GIR_Coverage, 22503,
     /*  60980 */   GIR_EraseRootFromParent_Done,
     /*  60981 */ // Label 1502: @60981
     /*  60981 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(61067), // Rule ID 225 //
     /*  60986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  60989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  60992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  60996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61004 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61012 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61016 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61020 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61023 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61027 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61031 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  61035 */   // MIs[0] src1
     /*  61035 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61040 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61042 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61049 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC8m),
     /*  61052 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61056 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61065 */   GIR_RootConstrainSelectedInstOperands,
     /*  61066 */   // GIR_Coverage, 225,
     /*  61066 */   GIR_EraseRootFromParent_Done,
     /*  61067 */ // Label 1503: @61067
     /*  61067 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(61153), // Rule ID 228 //
     /*  61072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  61075 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61078 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61090 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61094 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61098 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61102 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61106 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61109 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61113 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61117 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61121 */   // MIs[0] src1
     /*  61121 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61126 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61128 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61135 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC8m),
     /*  61138 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61142 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61151 */   GIR_RootConstrainSelectedInstOperands,
     /*  61152 */   // GIR_Coverage, 228,
     /*  61152 */   GIR_EraseRootFromParent_Done,
     /*  61153 */ // Label 1504: @61153
     /*  61153 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(61236), // Rule ID 17612 //
     /*  61158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61165 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61169 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  61173 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61177 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61181 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61185 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61189 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61192 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61196 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61200 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61204 */   // MIs[0] dst
     /*  61204 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61209 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61211 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61218 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1),
     /*  61221 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61225 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61234 */   GIR_RootConstrainSelectedInstOperands,
     /*  61235 */   // GIR_Coverage, 17612,
     /*  61235 */   GIR_EraseRootFromParent_Done,
     /*  61236 */ // Label 1505: @61236
     /*  61236 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(61319), // Rule ID 17616 //
     /*  61241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  61256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61264 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61268 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61272 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61275 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61279 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61283 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 7,
     /*  61287 */   // MIs[0] dst
     /*  61287 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61292 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61294 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61301 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  61301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1),
     /*  61304 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  61308 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61311 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61317 */   GIR_RootConstrainSelectedInstOperands,
     /*  61318 */   // GIR_Coverage, 17616,
     /*  61318 */   GIR_EraseRootFromParent_Done,
     /*  61319 */ // Label 1506: @61319
     /*  61319 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(61402), // Rule ID 261 //
     /*  61324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61343 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61347 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  61351 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61355 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61359 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61362 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61366 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61370 */   // MIs[0] src1
     /*  61370 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61375 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61377 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61384 */   // (st (sub:{ *:[i8] } 0:{ *:[i8] }, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG8m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  61384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG8m),
     /*  61387 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61391 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61400 */   GIR_RootConstrainSelectedInstOperands,
     /*  61401 */   // GIR_Coverage, 261,
     /*  61401 */   GIR_EraseRootFromParent_Done,
     /*  61402 */ // Label 1507: @61402
     /*  61402 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(61482), // Rule ID 269 //
     /*  61407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61430 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61434 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61438 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61441 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61445 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  61449 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61453 */   // MIs[0] src1
     /*  61453 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61458 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61460 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61467 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, -1:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT8m addr:{ *:[iPTR] }:$src1)
     /*  61467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT8m),
     /*  61470 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  61480 */   GIR_RootConstrainSelectedInstOperands,
     /*  61481 */   // GIR_Coverage, 269,
     /*  61481 */   GIR_EraseRootFromParent_Done,
     /*  61482 */ // Label 1508: @61482
     /*  61482 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(61577), // Rule ID 413 //
     /*  61487 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61502 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61506 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61510 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61514 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61518 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61521 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61525 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61529 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61533 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61537 */   // MIs[3] Operand 1
     /*  61537 */   // No operand predicates
     /*  61537 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61541 */   // MIs[0] src1
     /*  61541 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61546 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61548 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61555 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  61558 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61562 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61565 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61568 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61575 */   GIR_RootConstrainSelectedInstOperands,
     /*  61576 */   // GIR_Coverage, 413,
     /*  61576 */   GIR_EraseRootFromParent_Done,
     /*  61577 */ // Label 1509: @61577
     /*  61577 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(61672), // Rule ID 305 //
     /*  61582 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61585 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61589 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61593 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61597 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61605 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61609 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61613 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61620 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61624 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61628 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61632 */   // MIs[3] Operand 1
     /*  61632 */   // No operand predicates
     /*  61632 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61636 */   // MIs[0] src1
     /*  61636 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61641 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61643 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61650 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  61653 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61657 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61660 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61670 */   GIR_RootConstrainSelectedInstOperands,
     /*  61671 */   // GIR_Coverage, 305,
     /*  61671 */   GIR_EraseRootFromParent_Done,
     /*  61672 */ // Label 1510: @61672
     /*  61672 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(61767), // Rule ID 341 //
     /*  61677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  61692 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61696 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61700 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61704 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61708 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61711 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61715 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61719 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61723 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61727 */   // MIs[3] Operand 1
     /*  61727 */   // No operand predicates
     /*  61727 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61731 */   // MIs[0] src1
     /*  61731 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61736 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61738 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61745 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  61748 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61752 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61755 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61758 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61765 */   GIR_RootConstrainSelectedInstOperands,
     /*  61766 */   // GIR_Coverage, 341,
     /*  61766 */   GIR_EraseRootFromParent_Done,
     /*  61767 */ // Label 1511: @61767
     /*  61767 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(61862), // Rule ID 453 //
     /*  61772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61775 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61779 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  61787 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61791 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61795 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61799 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61803 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61810 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61814 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61818 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61822 */   // MIs[3] Operand 1
     /*  61822 */   // No operand predicates
     /*  61822 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61826 */   // MIs[0] src1
     /*  61826 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61831 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61833 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61840 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  61843 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61847 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61850 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61860 */   GIR_RootConstrainSelectedInstOperands,
     /*  61861 */   // GIR_Coverage, 453,
     /*  61861 */   GIR_EraseRootFromParent_Done,
     /*  61862 */ // Label 1512: @61862
     /*  61862 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(61957), // Rule ID 377 //
     /*  61867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  61874 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61878 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61882 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61890 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61894 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61898 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  61901 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  61905 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  61909 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  61913 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  61917 */   // MIs[3] Operand 1
     /*  61917 */   // No operand predicates
     /*  61917 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  61921 */   // MIs[0] src1
     /*  61921 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61926 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  61928 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  61935 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  61935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  61938 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  61942 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  61945 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  61948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  61955 */   GIR_RootConstrainSelectedInstOperands,
     /*  61956 */   // GIR_Coverage, 377,
     /*  61956 */   GIR_EraseRootFromParent_Done,
     /*  61957 */ // Label 1513: @61957
     /*  61957 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(62058), // Rule ID 22427 //
     /*  61962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61965 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  61972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  61980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  61984 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  61988 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61992 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  61996 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  61999 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62003 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62010 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62014 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62018 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62022 */   // MIs[3] Operand 1
     /*  62022 */   // No operand predicates
     /*  62022 */   // MIs[0] dst
     /*  62022 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62027 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62029 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62036 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mi),
     /*  62039 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62043 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62046 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62049 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62056 */   GIR_RootConstrainSelectedInstOperands,
     /*  62057 */   // GIR_Coverage, 22427,
     /*  62057 */   GIR_EraseRootFromParent_Done,
     /*  62058 */ // Label 1514: @62058
     /*  62058 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(62159), // Rule ID 22435 //
     /*  62063 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62066 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62081 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62085 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62089 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62093 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62100 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62104 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62111 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62115 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62119 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62123 */   // MIs[3] Operand 1
     /*  62123 */   // No operand predicates
     /*  62123 */   // MIs[0] dst
     /*  62123 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62128 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62130 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62137 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mi),
     /*  62140 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62144 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62147 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62150 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62157 */   GIR_RootConstrainSelectedInstOperands,
     /*  62158 */   // GIR_Coverage, 22435,
     /*  62158 */   GIR_EraseRootFromParent_Done,
     /*  62159 */ // Label 1515: @62159
     /*  62159 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(62260), // Rule ID 22443 //
     /*  62164 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62167 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  62182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62190 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62194 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62198 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62201 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62205 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62212 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62216 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62220 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62224 */   // MIs[3] Operand 1
     /*  62224 */   // No operand predicates
     /*  62224 */   // MIs[0] dst
     /*  62224 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62229 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62231 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62238 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mi),
     /*  62241 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62245 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62248 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62258 */   GIR_RootConstrainSelectedInstOperands,
     /*  62259 */   // GIR_Coverage, 22443,
     /*  62259 */   GIR_EraseRootFromParent_Done,
     /*  62260 */ // Label 1516: @62260
     /*  62260 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(62361), // Rule ID 22459 //
     /*  62265 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62268 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  62283 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62291 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62295 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62299 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62302 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62306 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62313 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62317 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62321 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62325 */   // MIs[3] Operand 1
     /*  62325 */   // No operand predicates
     /*  62325 */   // MIs[0] dst
     /*  62325 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62330 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62332 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62339 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mi),
     /*  62342 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62346 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62349 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62352 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62359 */   GIR_RootConstrainSelectedInstOperands,
     /*  62360 */   // GIR_Coverage, 22459,
     /*  62360 */   GIR_EraseRootFromParent_Done,
     /*  62361 */ // Label 1517: @62361
     /*  62361 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(62462), // Rule ID 22451 //
     /*  62366 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62369 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62388 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62392 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62396 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62400 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62407 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62414 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62418 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62422 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62426 */   // MIs[3] Operand 1
     /*  62426 */   // No operand predicates
     /*  62426 */   // MIs[0] dst
     /*  62426 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62431 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62433 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62440 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, (imm:{ *:[i8] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  62440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mi),
     /*  62443 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  62447 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  62450 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62453 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62460 */   GIR_RootConstrainSelectedInstOperands,
     /*  62461 */   // GIR_Coverage, 22451,
     /*  62461 */   GIR_EraseRootFromParent_Done,
     /*  62462 */ // Label 1518: @62462
     /*  62462 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(62553), // Rule ID 733 //
     /*  62467 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62470 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  62482 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62490 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62494 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62498 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62501 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62505 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62509 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62513 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62517 */   // MIs[3] Operand 1
     /*  62517 */   // No operand predicates
     /*  62517 */   // MIs[0] src1
     /*  62517 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62522 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62524 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62531 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi),
     /*  62534 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62538 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62541 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62551 */   GIR_RootConstrainSelectedInstOperands,
     /*  62552 */   // GIR_Coverage, 733,
     /*  62552 */   GIR_EraseRootFromParent_Done,
     /*  62553 */ // Label 1519: @62553
     /*  62553 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(62644), // Rule ID 701 //
     /*  62558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62561 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62565 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62569 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  62573 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62577 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62581 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62585 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62589 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62592 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62596 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62600 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62604 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62608 */   // MIs[3] Operand 1
     /*  62608 */   // No operand predicates
     /*  62608 */   // MIs[0] src1
     /*  62608 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62613 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62615 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62622 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi),
     /*  62625 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62629 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62632 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62635 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62642 */   GIR_RootConstrainSelectedInstOperands,
     /*  62643 */   // GIR_Coverage, 701,
     /*  62643 */   GIR_EraseRootFromParent_Done,
     /*  62644 */ // Label 1520: @62644
     /*  62644 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(62735), // Rule ID 765 //
     /*  62649 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62652 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  62664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62668 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62672 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62676 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62680 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62683 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62687 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62691 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62695 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62699 */   // MIs[3] Operand 1
     /*  62699 */   // No operand predicates
     /*  62699 */   // MIs[0] src1
     /*  62699 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62704 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62706 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62713 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi),
     /*  62716 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62720 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62723 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62726 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62733 */   GIR_RootConstrainSelectedInstOperands,
     /*  62734 */   // GIR_Coverage, 765,
     /*  62734 */   GIR_EraseRootFromParent_Done,
     /*  62735 */ // Label 1521: @62735
     /*  62735 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(62826), // Rule ID 797 //
     /*  62740 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62743 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  62755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62771 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62774 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62778 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62782 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62786 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62790 */   // MIs[3] Operand 1
     /*  62790 */   // No operand predicates
     /*  62790 */   // MIs[0] src1
     /*  62790 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62795 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62797 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62804 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi),
     /*  62807 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62811 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62814 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62824 */   GIR_RootConstrainSelectedInstOperands,
     /*  62825 */   // GIR_Coverage, 797,
     /*  62825 */   GIR_EraseRootFromParent_Done,
     /*  62826 */ // Label 1522: @62826
     /*  62826 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(62917), // Rule ID 669 //
     /*  62831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  62838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  62846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62854 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62858 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62862 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  62865 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62869 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  62873 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  62877 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62881 */   // MIs[3] Operand 1
     /*  62881 */   // No operand predicates
     /*  62881 */   // MIs[0] src1
     /*  62881 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62886 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  62888 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62895 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  62895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi),
     /*  62898 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  62902 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  62905 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  62908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  62915 */   GIR_RootConstrainSelectedInstOperands,
     /*  62916 */   // GIR_Coverage, 669,
     /*  62916 */   GIR_EraseRootFromParent_Done,
     /*  62917 */ // Label 1523: @62917
     /*  62917 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63015), // Rule ID 22431 //
     /*  62922 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62932 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  62936 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  62940 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  62944 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  62948 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62952 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  62956 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  62959 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  62963 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  62970 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  62974 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  62979 */   // MIs[0] dst
     /*  62979 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  62984 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62986 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  62993 */   // (atomic_store (add:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  62993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  62996 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63000 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63004 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63013 */   GIR_RootConstrainSelectedInstOperands,
     /*  63014 */   // GIR_Coverage, 22431,
     /*  63014 */   GIR_EraseRootFromParent_Done,
     /*  63015 */ // Label 1524: @63015
     /*  63015 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63113), // Rule ID 26002 //
     /*  63020 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63023 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63030 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63034 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63038 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63051 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63055 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63059 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63066 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63073 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63077 */   // MIs[0] dst
     /*  63077 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63082 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63084 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63091 */   // (atomic_store (add:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63094 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63098 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63102 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63111 */   GIR_RootConstrainSelectedInstOperands,
     /*  63112 */   // GIR_Coverage, 26002,
     /*  63112 */   GIR_EraseRootFromParent_Done,
     /*  63113 */ // Label 1525: @63113
     /*  63113 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63211), // Rule ID 22439 //
     /*  63118 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63128 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63132 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63136 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63140 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63144 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63148 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63152 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63155 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63159 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63166 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63170 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63175 */   // MIs[0] dst
     /*  63175 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63180 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63182 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63189 */   // (atomic_store (and:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63192 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63196 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63200 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63209 */   GIR_RootConstrainSelectedInstOperands,
     /*  63210 */   // GIR_Coverage, 22439,
     /*  63210 */   GIR_EraseRootFromParent_Done,
     /*  63211 */ // Label 1526: @63211
     /*  63211 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63309), // Rule ID 26006 //
     /*  63216 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63219 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63226 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63230 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63234 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63238 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63247 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63251 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63255 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63262 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63269 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63273 */   // MIs[0] dst
     /*  63273 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63278 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63280 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63287 */   // (atomic_store (and:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  63290 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63294 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63298 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63307 */   GIR_RootConstrainSelectedInstOperands,
     /*  63308 */   // GIR_Coverage, 26006,
     /*  63308 */   GIR_EraseRootFromParent_Done,
     /*  63309 */ // Label 1527: @63309
     /*  63309 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63407), // Rule ID 22447 //
     /*  63314 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63317 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63340 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63344 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63348 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63351 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63355 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63362 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63366 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63371 */   // MIs[0] dst
     /*  63371 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63376 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63378 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63385 */   // (atomic_store (or:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63388 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63392 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63396 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63399 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63405 */   GIR_RootConstrainSelectedInstOperands,
     /*  63406 */   // GIR_Coverage, 22447,
     /*  63406 */   GIR_EraseRootFromParent_Done,
     /*  63407 */ // Label 1528: @63407
     /*  63407 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63505), // Rule ID 26010 //
     /*  63412 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63415 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  63430 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63434 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63438 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63443 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63447 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63458 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63465 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63469 */   // MIs[0] dst
     /*  63469 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63474 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63476 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63483 */   // (atomic_store (or:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  63486 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63490 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63494 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63503 */   GIR_RootConstrainSelectedInstOperands,
     /*  63504 */   // GIR_Coverage, 26010,
     /*  63504 */   GIR_EraseRootFromParent_Done,
     /*  63505 */ // Label 1529: @63505
     /*  63505 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63603), // Rule ID 22463 //
     /*  63510 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  63528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63536 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63540 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63544 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63551 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63558 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63562 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63567 */   // MIs[0] dst
     /*  63567 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63572 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63574 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63581 */   // (atomic_store (sub:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  63584 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63588 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63592 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63595 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63601 */   GIR_RootConstrainSelectedInstOperands,
     /*  63602 */   // GIR_Coverage, 22463,
     /*  63602 */   GIR_EraseRootFromParent_Done,
     /*  63603 */ // Label 1530: @63603
     /*  63603 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(63701), // Rule ID 22455 //
     /*  63608 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63626 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63630 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63634 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63638 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63645 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63649 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63656 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63660 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63665 */   // MIs[0] dst
     /*  63665 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63670 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63672 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63679 */   // (atomic_store (xor:{ *:[i8] } (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>, GR8:{ *:[i8] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63682 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63686 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  63690 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63699 */   GIR_RootConstrainSelectedInstOperands,
     /*  63700 */   // GIR_Coverage, 22455,
     /*  63700 */   GIR_EraseRootFromParent_Done,
     /*  63701 */ // Label 1531: @63701
     /*  63701 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(63799), // Rule ID 26014 //
     /*  63706 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63709 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63716 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63720 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63724 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63728 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63737 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63741 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  63748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63752 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  63759 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63763 */   // MIs[0] dst
     /*  63763 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63768 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63770 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63777 */   // (atomic_store (xor:{ *:[i8] } GR8:{ *:[i8] }:$src, (atomic_load:{ *:[i8] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_8>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  63777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  63780 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  63784 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  63788 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63791 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63797 */   GIR_RootConstrainSelectedInstOperands,
     /*  63798 */   // GIR_Coverage, 26014,
     /*  63798 */   GIR_EraseRootFromParent_Done,
     /*  63799 */ // Label 1532: @63799
     /*  63799 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(63887), // Rule ID 409 //
     /*  63804 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63811 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63819 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63823 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63827 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63831 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63835 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63838 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63842 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63851 */   // MIs[0] src1
     /*  63851 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63856 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63858 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63865 */   // (st (add:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63868 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63872 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  63876 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63885 */   GIR_RootConstrainSelectedInstOperands,
     /*  63886 */   // GIR_Coverage, 409,
     /*  63886 */   GIR_EraseRootFromParent_Done,
     /*  63887 */ // Label 1533: @63887
     /*  63887 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(63975), // Rule ID 23222 //
     /*  63892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63895 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  63907 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63911 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  63915 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  63920 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63924 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  63928 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63931 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  63935 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  63939 */   // MIs[0] src1
     /*  63939 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63944 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63946 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  63953 */   // (st (add:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  63953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8mr),
     /*  63956 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  63960 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  63964 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  63967 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  63973 */   GIR_RootConstrainSelectedInstOperands,
     /*  63974 */   // GIR_Coverage, 23222,
     /*  63974 */   GIR_EraseRootFromParent_Done,
     /*  63975 */ // Label 1534: @63975
     /*  63975 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(64063), // Rule ID 301 //
     /*  63980 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  63983 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  63987 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  63991 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63995 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  63999 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64003 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64007 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64011 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64018 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64027 */   // MIs[0] src1
     /*  64027 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64032 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64034 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64041 */   // (st (and:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64044 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64048 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64052 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64055 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64061 */   GIR_RootConstrainSelectedInstOperands,
     /*  64062 */   // GIR_Coverage, 301,
     /*  64062 */   GIR_EraseRootFromParent_Done,
     /*  64063 */ // Label 1535: @64063
     /*  64063 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(64151), // Rule ID 23186 //
     /*  64068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64083 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64087 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64091 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64096 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64100 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64104 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64111 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64115 */   // MIs[0] src1
     /*  64115 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64120 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64122 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64129 */   // (st (and:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND8mr),
     /*  64132 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64136 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64140 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64143 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64149 */   GIR_RootConstrainSelectedInstOperands,
     /*  64150 */   // GIR_Coverage, 23186,
     /*  64150 */   GIR_EraseRootFromParent_Done,
     /*  64151 */ // Label 1536: @64151
     /*  64151 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(64249), // Rule ID 749 //
     /*  64156 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  64171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64175 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64179 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64183 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64187 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64190 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64194 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64198 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64203 */   // MIs[0] src1
     /*  64203 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64208 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64210 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64217 */   // (st (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64221 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64227 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL),
     /*  64234 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64238 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64241 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64247 */   GIR_RootConstrainSelectedInstOperands,
     /*  64248 */   // GIR_Coverage, 749,
     /*  64248 */   GIR_EraseRootFromParent_Done,
     /*  64249 */ // Label 1537: @64249
     /*  64249 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(64347), // Rule ID 717 //
     /*  64254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64261 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64265 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  64269 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64273 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64277 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64281 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64285 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64288 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64292 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64296 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64301 */   // MIs[0] src1
     /*  64301 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64306 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64308 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64315 */   // (st (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64319 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64325 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL),
     /*  64332 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64336 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64345 */   GIR_RootConstrainSelectedInstOperands,
     /*  64346 */   // GIR_Coverage, 717,
     /*  64346 */   GIR_EraseRootFromParent_Done,
     /*  64347 */ // Label 1538: @64347
     /*  64347 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(64435), // Rule ID 337 //
     /*  64352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64367 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64371 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64375 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64379 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64383 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64386 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64390 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64394 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64399 */   // MIs[0] src1
     /*  64399 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64404 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64406 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64413 */   // (st (or:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64416 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64420 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64424 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64433 */   GIR_RootConstrainSelectedInstOperands,
     /*  64434 */   // GIR_Coverage, 337,
     /*  64434 */   GIR_EraseRootFromParent_Done,
     /*  64435 */ // Label 1539: @64435
     /*  64435 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(64523), // Rule ID 23198 //
     /*  64440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  64455 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64468 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64472 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64476 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64479 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64483 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64487 */   // MIs[0] src1
     /*  64487 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64492 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64494 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64501 */   // (st (or:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR8mr),
     /*  64504 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64508 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  64512 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64521 */   GIR_RootConstrainSelectedInstOperands,
     /*  64522 */   // GIR_Coverage, 23198,
     /*  64522 */   GIR_EraseRootFromParent_Done,
     /*  64523 */ // Label 1540: @64523
     /*  64523 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(64621), // Rule ID 781 //
     /*  64528 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64531 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  64543 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64547 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64551 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64555 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64559 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64562 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64566 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64570 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64575 */   // MIs[0] src1
     /*  64575 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64580 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64582 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64589 */   // (st (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64593 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL),
     /*  64606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64610 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64619 */   GIR_RootConstrainSelectedInstOperands,
     /*  64620 */   // GIR_Coverage, 781,
     /*  64620 */   GIR_EraseRootFromParent_Done,
     /*  64621 */ // Label 1541: @64621
     /*  64621 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(64719), // Rule ID 813 //
     /*  64626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  64641 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64645 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64649 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64653 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64657 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64660 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64664 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64673 */   // MIs[0] src1
     /*  64673 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64678 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64680 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64687 */   // (st (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64691 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64697 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL),
     /*  64704 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64708 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64717 */   GIR_RootConstrainSelectedInstOperands,
     /*  64718 */   // GIR_Coverage, 813,
     /*  64718 */   GIR_EraseRootFromParent_Done,
     /*  64719 */ // Label 1542: @64719
     /*  64719 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(64817), // Rule ID 685 //
     /*  64724 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64727 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  64739 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64743 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64747 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64751 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64755 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64758 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64762 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /*  64766 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  64771 */   // MIs[0] src1
     /*  64771 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64776 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64778 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64785 */   // (st (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL8mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  64785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  64789 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64795 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  64799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL),
     /*  64802 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64806 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64815 */   GIR_RootConstrainSelectedInstOperands,
     /*  64816 */   // GIR_Coverage, 685,
     /*  64816 */   GIR_EraseRootFromParent_Done,
     /*  64817 */ // Label 1543: @64817
     /*  64817 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(64905), // Rule ID 445 //
     /*  64822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  64837 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64841 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64853 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64860 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64864 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64869 */   // MIs[0] src1
     /*  64869 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64874 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64876 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64883 */   // (st (sub:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB8mr),
     /*  64886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64894 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64903 */   GIR_RootConstrainSelectedInstOperands,
     /*  64904 */   // GIR_Coverage, 445,
     /*  64904 */   GIR_EraseRootFromParent_Done,
     /*  64905 */ // Label 1544: @64905
     /*  64905 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64993), // Rule ID 373 //
     /*  64910 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64913 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  64917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  64921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64925 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  64929 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  64933 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64937 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  64941 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  64944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  64948 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  64952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  64957 */   // MIs[0] src1
     /*  64957 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64962 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64964 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  64971 */   // (st (xor:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  64971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  64974 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  64978 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  64982 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  64985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  64991 */   GIR_RootConstrainSelectedInstOperands,
     /*  64992 */   // GIR_Coverage, 373,
     /*  64992 */   GIR_EraseRootFromParent_Done,
     /*  64993 */ // Label 1545: @64993
     /*  64993 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(65081), // Rule ID 23210 //
     /*  64998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65013 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s8,
     /*  65017 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65021 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65026 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65030 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65034 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65037 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65041 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65045 */   // MIs[0] src1
     /*  65045 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65050 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65052 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65059 */   // (st (xor:{ *:[i8] } GR8:{ *:[i8] }:$src2, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR8mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  65059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR8mr),
     /*  65062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  65070 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65079 */   GIR_RootConstrainSelectedInstOperands,
     /*  65080 */   // GIR_Coverage, 23210,
     /*  65080 */   GIR_EraseRootFromParent_Done,
     /*  65081 */ // Label 1546: @65081
     /*  65081 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(65135), // Rule ID 24 //
     /*  65086 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65089 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65101 */   // MIs[1] Operand 1
     /*  65101 */   // No operand predicates
     /*  65101 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  65105 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65118 */   // (st (imm:{ *:[i8] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65121 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65125 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65133 */   GIR_RootConstrainSelectedInstOperands,
     /*  65134 */   // GIR_Coverage, 24,
     /*  65134 */   GIR_EraseRootFromParent_Done,
     /*  65135 */ // Label 1547: @65135
     /*  65135 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(65188), // Rule ID 22507 //
     /*  65140 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65143 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65158 */   // MIs[1] Operand 1
     /*  65158 */   // No operand predicates
     /*  65158 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65164 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65171 */   // (atomic_store (imm:{ *:[i8] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i8] }):$src)
     /*  65171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mi),
     /*  65174 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65178 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  65181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  65186 */   GIR_RootConstrainSelectedInstOperands,
     /*  65187 */   // GIR_Coverage, 22507,
     /*  65187 */   GIR_EraseRootFromParent_Done,
     /*  65188 */ // Label 1548: @65188
     /*  65188 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(65233), // Rule ID 22511 //
     /*  65193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65196 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  65203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65207 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65211 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65218 */   // (atomic_store GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_8>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65221 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65225 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65231 */   GIR_RootConstrainSelectedInstOperands,
     /*  65232 */   // GIR_Coverage, 22511,
     /*  65232 */   GIR_EraseRootFromParent_Done,
     /*  65233 */ // Label 1549: @65233
     /*  65233 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(65275), // Rule ID 32 //
     /*  65238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65241 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  65249 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  65253 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65260 */   // (st GR8:{ *:[i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV8mr addr:{ *:[iPTR] }:$dst, GR8:{ *:[i8] }:$src)
     /*  65260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8mr),
     /*  65263 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65267 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  65269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  65273 */   GIR_RootConstrainSelectedInstOperands,
     /*  65274 */   // GIR_Coverage, 32,
     /*  65274 */   GIR_EraseRootFromParent_Done,
     /*  65275 */ // Label 1550: @65275
     /*  65275 */ GIM_Reject,
     /*  65276 */ // Label 1477: @65276
     /*  65276 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(65372), // Rule ID 22492 //
     /*  65281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65284 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65302 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65306 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65310 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65314 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65318 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65321 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65325 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65332 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65336 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65340 */   // MIs[0] dst
     /*  65340 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65345 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65347 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65354 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65357 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65361 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65370 */   GIR_RootConstrainSelectedInstOperands,
     /*  65371 */   // GIR_Coverage, 22492,
     /*  65371 */   GIR_EraseRootFromParent_Done,
     /*  65372 */ // Label 1551: @65372
     /*  65372 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(65468), // Rule ID 22496 //
     /*  65377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65380 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65383 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65398 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65406 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65410 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65414 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65421 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65428 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65432 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65436 */   // MIs[0] dst
     /*  65436 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65441 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65443 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65450 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65453 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65457 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65466 */   GIR_RootConstrainSelectedInstOperands,
     /*  65467 */   // GIR_Coverage, 22496,
     /*  65467 */   GIR_EraseRootFromParent_Done,
     /*  65468 */ // Label 1552: @65468
     /*  65468 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(65561), // Rule ID 22500 //
     /*  65473 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65483 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65487 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  65491 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65495 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65499 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  65503 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65507 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65511 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65514 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65518 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65525 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65529 */   // MIs[0] dst
     /*  65529 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65534 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65536 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65543 */   // (atomic_store (sub:{ *:[i16] } 0:{ *:[i16] }, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  65546 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65550 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65559 */   GIR_RootConstrainSelectedInstOperands,
     /*  65560 */   // GIR_Coverage, 22500,
     /*  65560 */   GIR_EraseRootFromParent_Done,
     /*  65561 */ // Label 1553: @65561
     /*  65561 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(65651), // Rule ID 22504 //
     /*  65566 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65569 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65576 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65580 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65584 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65588 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65592 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65596 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65600 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  65603 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  65607 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  65614 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65618 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65622 */   // MIs[0] dst
     /*  65622 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65627 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65629 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65636 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (NOT16m addr:{ *:[iPTR] }:$dst)
     /*  65636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  65639 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65643 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65649 */   GIR_RootConstrainSelectedInstOperands,
     /*  65650 */   // GIR_Coverage, 22504,
     /*  65650 */   GIR_EraseRootFromParent_Done,
     /*  65651 */ // Label 1554: @65651
     /*  65651 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(65737), // Rule ID 226 //
     /*  65656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65662 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65674 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65682 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65686 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65690 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65693 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65697 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65701 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  65705 */   // MIs[0] src1
     /*  65705 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65710 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65712 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65719 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC16m),
     /*  65722 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65726 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65729 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65735 */   GIR_RootConstrainSelectedInstOperands,
     /*  65736 */   // GIR_Coverage, 226,
     /*  65736 */   GIR_EraseRootFromParent_Done,
     /*  65737 */ // Label 1555: @65737
     /*  65737 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(65823), // Rule ID 229 //
     /*  65742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  65745 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65748 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65752 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65756 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65760 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65768 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65772 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65776 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65779 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65783 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65787 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  65791 */   // MIs[0] src1
     /*  65791 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65796 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65798 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65805 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  65805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC16m),
     /*  65808 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  65812 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65815 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65821 */   GIR_RootConstrainSelectedInstOperands,
     /*  65822 */   // GIR_Coverage, 229,
     /*  65822 */   GIR_EraseRootFromParent_Done,
     /*  65823 */ // Label 1556: @65823
     /*  65823 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(65916), // Rule ID 22614 //
     /*  65828 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65831 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65835 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65839 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  65843 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65847 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  65851 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65855 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65859 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65862 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65866 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65870 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  65881 */   // MIs[0] dst
     /*  65881 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65886 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65888 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65895 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 128:{ *:[i16] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i16] })
     /*  65895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  65898 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  65905 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65914 */   GIR_RootConstrainSelectedInstOperands,
     /*  65915 */   // GIR_Coverage, 22614,
     /*  65915 */   GIR_EraseRootFromParent_Done,
     /*  65916 */ // Label 1557: @65916
     /*  65916 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(65999), // Rule ID 17613 //
     /*  65921 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65924 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  65928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  65932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  65936 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  65940 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  65944 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65948 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  65952 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  65955 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  65959 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  65963 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  65967 */   // MIs[0] dst
     /*  65967 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65972 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65974 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  65981 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  65981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1),
     /*  65984 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  65988 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  65991 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  65997 */   GIR_RootConstrainSelectedInstOperands,
     /*  65998 */   // GIR_Coverage, 17613,
     /*  65998 */   GIR_EraseRootFromParent_Done,
     /*  65999 */ // Label 1558: @65999
     /*  65999 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(66082), // Rule ID 17617 //
     /*  66004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66007 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  66019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66023 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  66027 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66031 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66035 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66038 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66042 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66046 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 15,
     /*  66050 */   // MIs[0] dst
     /*  66050 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66055 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66057 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66064 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  66064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1),
     /*  66067 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66071 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66074 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66080 */   GIR_RootConstrainSelectedInstOperands,
     /*  66081 */   // GIR_Coverage, 17617,
     /*  66081 */   GIR_EraseRootFromParent_Done,
     /*  66082 */ // Label 1559: @66082
     /*  66082 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(66165), // Rule ID 262 //
     /*  66087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66090 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66094 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66098 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66102 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66106 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66110 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  66114 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66118 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66122 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66125 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66129 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66133 */   // MIs[0] src1
     /*  66133 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66138 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66140 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66147 */   // (st (sub:{ *:[i16] } 0:{ *:[i16] }, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG16m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  66147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG16m),
     /*  66150 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66154 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66163 */   GIR_RootConstrainSelectedInstOperands,
     /*  66164 */   // GIR_Coverage, 262,
     /*  66164 */   GIR_EraseRootFromParent_Done,
     /*  66165 */ // Label 1560: @66165
     /*  66165 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(66245), // Rule ID 270 //
     /*  66170 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66173 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66177 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66181 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66185 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66193 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66197 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66201 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66204 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66208 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  66212 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  66216 */   // MIs[0] src1
     /*  66216 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66221 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66223 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66230 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, -1:{ *:[i16] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT16m addr:{ *:[iPTR] }:$src1)
     /*  66230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT16m),
     /*  66233 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  66243 */   GIR_RootConstrainSelectedInstOperands,
     /*  66244 */   // GIR_Coverage, 270,
     /*  66244 */   GIR_EraseRootFromParent_Done,
     /*  66245 */ // Label 1561: @66245
     /*  66245 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(66340), // Rule ID 414 //
     /*  66250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66265 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66273 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66277 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66281 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66284 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66288 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66292 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66296 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66300 */   // MIs[3] Operand 1
     /*  66300 */   // No operand predicates
     /*  66300 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66304 */   // MIs[0] src1
     /*  66304 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66309 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66311 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66318 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66321 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66325 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66328 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66331 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66338 */   GIR_RootConstrainSelectedInstOperands,
     /*  66339 */   // GIR_Coverage, 414,
     /*  66339 */   GIR_EraseRootFromParent_Done,
     /*  66340 */ // Label 1562: @66340
     /*  66340 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(66435), // Rule ID 306 //
     /*  66345 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66348 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66360 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66368 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66372 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66376 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66379 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66383 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66387 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66391 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66395 */   // MIs[3] Operand 1
     /*  66395 */   // No operand predicates
     /*  66395 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66399 */   // MIs[0] src1
     /*  66399 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66404 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66406 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66413 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66416 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66420 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66423 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66433 */   GIR_RootConstrainSelectedInstOperands,
     /*  66434 */   // GIR_Coverage, 306,
     /*  66434 */   GIR_EraseRootFromParent_Done,
     /*  66435 */ // Label 1563: @66435
     /*  66435 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(66530), // Rule ID 342 //
     /*  66440 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66447 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66455 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66471 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66478 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66482 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66486 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66490 */   // MIs[3] Operand 1
     /*  66490 */   // No operand predicates
     /*  66490 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66494 */   // MIs[0] src1
     /*  66494 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66499 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66501 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66508 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  66511 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66515 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66518 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66528 */   GIR_RootConstrainSelectedInstOperands,
     /*  66529 */   // GIR_Coverage, 342,
     /*  66529 */   GIR_EraseRootFromParent_Done,
     /*  66530 */ // Label 1564: @66530
     /*  66530 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(66625), // Rule ID 454 //
     /*  66535 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66538 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  66550 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66554 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66558 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66562 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66566 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66569 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66573 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66577 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66581 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66585 */   // MIs[3] Operand 1
     /*  66585 */   // No operand predicates
     /*  66585 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66589 */   // MIs[0] src1
     /*  66589 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66594 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66596 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66603 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  66606 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66610 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66613 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66616 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66623 */   GIR_RootConstrainSelectedInstOperands,
     /*  66624 */   // GIR_Coverage, 454,
     /*  66624 */   GIR_EraseRootFromParent_Done,
     /*  66625 */ // Label 1565: @66625
     /*  66625 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(66720), // Rule ID 378 //
     /*  66630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  66637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66645 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66653 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66657 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66661 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  66664 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66668 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66672 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66676 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66680 */   // MIs[3] Operand 1
     /*  66680 */   // No operand predicates
     /*  66680 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  66684 */   // MIs[0] src1
     /*  66684 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66689 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66691 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66698 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2)
     /*  66698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  66701 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  66705 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  66708 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66711 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66718 */   GIR_RootConstrainSelectedInstOperands,
     /*  66719 */   // GIR_Coverage, 378,
     /*  66719 */   GIR_EraseRootFromParent_Done,
     /*  66720 */ // Label 1566: @66720
     /*  66720 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(66821), // Rule ID 22428 //
     /*  66725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  66743 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66747 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66751 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66755 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66759 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66766 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66773 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66777 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66781 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66785 */   // MIs[3] Operand 1
     /*  66785 */   // No operand predicates
     /*  66785 */   // MIs[0] dst
     /*  66785 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66790 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66792 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66799 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mi),
     /*  66802 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66806 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66809 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66812 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66819 */   GIR_RootConstrainSelectedInstOperands,
     /*  66820 */   // GIR_Coverage, 22428,
     /*  66820 */   GIR_EraseRootFromParent_Done,
     /*  66821 */ // Label 1567: @66821
     /*  66821 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(66922), // Rule ID 22436 //
     /*  66826 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66836 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66840 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66844 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66848 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66852 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66856 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66860 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66863 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66867 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66874 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66878 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66882 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66886 */   // MIs[3] Operand 1
     /*  66886 */   // No operand predicates
     /*  66886 */   // MIs[0] dst
     /*  66886 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66891 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66893 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  66900 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  66900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mi),
     /*  66903 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  66907 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  66910 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  66913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  66920 */   GIR_RootConstrainSelectedInstOperands,
     /*  66921 */   // GIR_Coverage, 22436,
     /*  66921 */   GIR_EraseRootFromParent_Done,
     /*  66922 */ // Label 1568: @66922
     /*  66922 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(67023), // Rule ID 22444 //
     /*  66927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  66941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  66945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  66949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  66953 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66957 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  66961 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  66964 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  66968 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  66975 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  66979 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  66983 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66987 */   // MIs[3] Operand 1
     /*  66987 */   // No operand predicates
     /*  66987 */   // MIs[0] dst
     /*  66987 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66992 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  66994 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67001 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mi),
     /*  67004 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67008 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67011 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67021 */   GIR_RootConstrainSelectedInstOperands,
     /*  67022 */   // GIR_Coverage, 22444,
     /*  67022 */   GIR_EraseRootFromParent_Done,
     /*  67023 */ // Label 1569: @67023
     /*  67023 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(67124), // Rule ID 22460 //
     /*  67028 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  67046 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67050 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67054 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67058 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67062 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67065 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67069 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67076 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67080 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67084 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67088 */   // MIs[3] Operand 1
     /*  67088 */   // No operand predicates
     /*  67088 */   // MIs[0] dst
     /*  67088 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67093 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67095 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67102 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mi),
     /*  67105 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67109 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67112 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67115 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67122 */   GIR_RootConstrainSelectedInstOperands,
     /*  67123 */   // GIR_Coverage, 22460,
     /*  67123 */   GIR_EraseRootFromParent_Done,
     /*  67124 */ // Label 1570: @67124
     /*  67124 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(67225), // Rule ID 22452 //
     /*  67129 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67132 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67139 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67143 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67147 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67155 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67159 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67170 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67177 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67181 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67185 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67189 */   // MIs[3] Operand 1
     /*  67189 */   // No operand predicates
     /*  67189 */   // MIs[0] dst
     /*  67189 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67194 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67196 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67203 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, (imm:{ *:[i16] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  67203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mi),
     /*  67206 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67210 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  67213 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67223 */   GIR_RootConstrainSelectedInstOperands,
     /*  67224 */   // GIR_Coverage, 22452,
     /*  67224 */   GIR_EraseRootFromParent_Done,
     /*  67225 */ // Label 1571: @67225
     /*  67225 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(67316), // Rule ID 734 //
     /*  67230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  67245 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67253 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67257 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67261 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67264 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67268 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67272 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67276 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67280 */   // MIs[3] Operand 1
     /*  67280 */   // No operand predicates
     /*  67280 */   // MIs[0] src1
     /*  67280 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67285 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67287 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67294 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi),
     /*  67297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67301 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67304 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67314 */   GIR_RootConstrainSelectedInstOperands,
     /*  67315 */   // GIR_Coverage, 734,
     /*  67315 */   GIR_EraseRootFromParent_Done,
     /*  67316 */ // Label 1572: @67316
     /*  67316 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(67407), // Rule ID 702 //
     /*  67321 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67324 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  67336 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67340 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67344 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67348 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67352 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67355 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67359 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67363 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67367 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67371 */   // MIs[3] Operand 1
     /*  67371 */   // No operand predicates
     /*  67371 */   // MIs[0] src1
     /*  67371 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67376 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67378 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67385 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi),
     /*  67388 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67392 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67395 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67405 */   GIR_RootConstrainSelectedInstOperands,
     /*  67406 */   // GIR_Coverage, 702,
     /*  67406 */   GIR_EraseRootFromParent_Done,
     /*  67407 */ // Label 1573: @67407
     /*  67407 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(67498), // Rule ID 766 //
     /*  67412 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67415 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  67427 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67431 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67435 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67439 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67443 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67446 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67450 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67454 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67458 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67462 */   // MIs[3] Operand 1
     /*  67462 */   // No operand predicates
     /*  67462 */   // MIs[0] src1
     /*  67462 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67467 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67469 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67476 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi),
     /*  67479 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67483 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67496 */   GIR_RootConstrainSelectedInstOperands,
     /*  67497 */   // GIR_Coverage, 766,
     /*  67497 */   GIR_EraseRootFromParent_Done,
     /*  67498 */ // Label 1574: @67498
     /*  67498 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(67589), // Rule ID 798 //
     /*  67503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  67518 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67526 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67530 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67534 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67537 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67541 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67545 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67549 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67553 */   // MIs[3] Operand 1
     /*  67553 */   // No operand predicates
     /*  67553 */   // MIs[0] src1
     /*  67553 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67558 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67560 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67567 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi),
     /*  67570 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67574 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67577 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67587 */   GIR_RootConstrainSelectedInstOperands,
     /*  67588 */   // GIR_Coverage, 798,
     /*  67588 */   GIR_EraseRootFromParent_Done,
     /*  67589 */ // Label 1575: @67589
     /*  67589 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(67680), // Rule ID 670 //
     /*  67594 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67597 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  67601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  67609 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  67617 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67621 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67625 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  67628 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67632 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  67636 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  67640 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67644 */   // MIs[3] Operand 1
     /*  67644 */   // No operand predicates
     /*  67644 */   // MIs[0] src1
     /*  67644 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67649 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  67651 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67658 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  67658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi),
     /*  67661 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  67665 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  67668 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  67678 */   GIR_RootConstrainSelectedInstOperands,
     /*  67679 */   // GIR_Coverage, 670,
     /*  67679 */   GIR_EraseRootFromParent_Done,
     /*  67680 */ // Label 1576: @67680
     /*  67680 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(67778), // Rule ID 22432 //
     /*  67685 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67688 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67695 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67699 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67703 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67707 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67711 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67715 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67719 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67722 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67726 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67733 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67742 */   // MIs[0] dst
     /*  67742 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67747 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67749 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67756 */   // (atomic_store (add:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67759 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67763 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67767 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67776 */   GIR_RootConstrainSelectedInstOperands,
     /*  67777 */   // GIR_Coverage, 22432,
     /*  67777 */   GIR_EraseRootFromParent_Done,
     /*  67778 */ // Label 1577: @67778
     /*  67778 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(67876), // Rule ID 26003 //
     /*  67783 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  67801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67805 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67809 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67814 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67818 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67822 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67829 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67836 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67840 */   // MIs[0] dst
     /*  67840 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67845 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67847 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67854 */   // (atomic_store (add:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  67857 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67861 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  67865 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67868 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67874 */   GIR_RootConstrainSelectedInstOperands,
     /*  67875 */   // GIR_Coverage, 26003,
     /*  67875 */   GIR_EraseRootFromParent_Done,
     /*  67876 */ // Label 1578: @67876
     /*  67876 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(67974), // Rule ID 22440 //
     /*  67881 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67884 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  67903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  67907 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67911 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  67915 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67918 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  67922 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67929 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  67933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  67938 */   // MIs[0] dst
     /*  67938 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67943 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67945 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  67952 */   // (atomic_store (and:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  67952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  67955 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  67959 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  67963 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  67966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  67972 */   GIR_RootConstrainSelectedInstOperands,
     /*  67973 */   // GIR_Coverage, 22440,
     /*  67973 */   GIR_EraseRootFromParent_Done,
     /*  67974 */ // Label 1579: @67974
     /*  67974 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(68072), // Rule ID 26007 //
     /*  67979 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  67982 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  67989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  67993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67997 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68001 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68005 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68010 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68014 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68018 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68025 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68032 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68036 */   // MIs[0] dst
     /*  68036 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68041 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68043 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68050 */   // (atomic_store (and:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68053 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68057 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68061 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68064 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68070 */   GIR_RootConstrainSelectedInstOperands,
     /*  68071 */   // GIR_Coverage, 26007,
     /*  68071 */   GIR_EraseRootFromParent_Done,
     /*  68072 */ // Label 1580: @68072
     /*  68072 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(68170), // Rule ID 22448 //
     /*  68077 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68087 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68091 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68095 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68099 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68103 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68107 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68114 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68118 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68125 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68134 */   // MIs[0] dst
     /*  68134 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68139 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68141 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68148 */   // (atomic_store (or:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68151 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68155 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68159 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68162 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68168 */   GIR_RootConstrainSelectedInstOperands,
     /*  68169 */   // GIR_Coverage, 22448,
     /*  68169 */   GIR_EraseRootFromParent_Done,
     /*  68170 */ // Label 1581: @68170
     /*  68170 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(68268), // Rule ID 26011 //
     /*  68175 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68178 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  68193 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68197 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68201 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68206 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68210 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68214 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68217 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68221 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68228 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68232 */   // MIs[0] dst
     /*  68232 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68237 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68239 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68246 */   // (atomic_store (or:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  68249 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68257 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68260 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68266 */   GIR_RootConstrainSelectedInstOperands,
     /*  68267 */   // GIR_Coverage, 26011,
     /*  68267 */   GIR_EraseRootFromParent_Done,
     /*  68268 */ // Label 1582: @68268
     /*  68268 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(68366), // Rule ID 22464 //
     /*  68273 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  68291 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68295 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68299 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68303 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68307 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68310 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68314 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68321 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68330 */   // MIs[0] dst
     /*  68330 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68335 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68337 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68344 */   // (atomic_store (sub:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  68347 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68355 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68358 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68364 */   GIR_RootConstrainSelectedInstOperands,
     /*  68365 */   // GIR_Coverage, 22464,
     /*  68365 */   GIR_EraseRootFromParent_Done,
     /*  68366 */ // Label 1583: @68366
     /*  68366 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(68464), // Rule ID 22456 //
     /*  68371 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68374 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68381 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68385 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68389 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68397 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68401 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68405 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68408 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68412 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68419 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68428 */   // MIs[0] dst
     /*  68428 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68433 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68435 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68442 */   // (atomic_store (xor:{ *:[i16] } (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>, GR16:{ *:[i16] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68445 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68449 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  68453 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68462 */   GIR_RootConstrainSelectedInstOperands,
     /*  68463 */   // GIR_Coverage, 22456,
     /*  68463 */   GIR_EraseRootFromParent_Done,
     /*  68464 */ // Label 1584: @68464
     /*  68464 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(68562), // Rule ID 26015 //
     /*  68469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68472 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68487 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68491 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68500 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68504 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68508 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  68511 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68515 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  68522 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68526 */   // MIs[0] dst
     /*  68526 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68531 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68533 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68540 */   // (atomic_store (xor:{ *:[i16] } GR16:{ *:[i16] }:$src, (atomic_load:{ *:[i16] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  68540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  68543 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  68547 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  68551 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68554 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68560 */   GIR_RootConstrainSelectedInstOperands,
     /*  68561 */   // GIR_Coverage, 26015,
     /*  68561 */   GIR_EraseRootFromParent_Done,
     /*  68562 */ // Label 1585: @68562
     /*  68562 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(68650), // Rule ID 410 //
     /*  68567 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68570 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68574 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68578 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68582 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68586 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68590 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68594 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68598 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68601 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68605 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68609 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68614 */   // MIs[0] src1
     /*  68614 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68619 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68621 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68628 */   // (st (add:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68631 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68635 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68639 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68642 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68648 */   GIR_RootConstrainSelectedInstOperands,
     /*  68649 */   // GIR_Coverage, 410,
     /*  68649 */   GIR_EraseRootFromParent_Done,
     /*  68650 */ // Label 1586: @68650
     /*  68650 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(68738), // Rule ID 23223 //
     /*  68655 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68658 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68662 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68666 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  68670 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68674 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68683 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68687 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68691 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68698 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68702 */   // MIs[0] src1
     /*  68702 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68707 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68709 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68716 */   // (st (add:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16mr),
     /*  68719 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68723 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68727 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68736 */   GIR_RootConstrainSelectedInstOperands,
     /*  68737 */   // GIR_Coverage, 23223,
     /*  68737 */   GIR_EraseRootFromParent_Done,
     /*  68738 */ // Label 1587: @68738
     /*  68738 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(68826), // Rule ID 302 //
     /*  68743 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68746 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68758 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68762 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68766 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68770 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68774 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68777 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68781 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68790 */   // MIs[0] src1
     /*  68790 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68795 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68797 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68804 */   // (st (and:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68807 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68811 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  68815 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68824 */   GIR_RootConstrainSelectedInstOperands,
     /*  68825 */   // GIR_Coverage, 302,
     /*  68825 */   GIR_EraseRootFromParent_Done,
     /*  68826 */ // Label 1588: @68826
     /*  68826 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(68914), // Rule ID 23187 //
     /*  68831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  68854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  68859 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68863 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68867 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  68874 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68878 */   // MIs[0] src1
     /*  68878 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68883 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68885 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68892 */   // (st (and:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  68892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND16mr),
     /*  68895 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  68899 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  68903 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  68906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  68912 */   GIR_RootConstrainSelectedInstOperands,
     /*  68913 */   // GIR_Coverage, 23187,
     /*  68913 */   GIR_EraseRootFromParent_Done,
     /*  68914 */ // Label 1589: @68914
     /*  68914 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(69012), // Rule ID 750 //
     /*  68919 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68922 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  68926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  68930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  68934 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  68938 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  68942 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68946 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  68950 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  68953 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  68957 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  68961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  68966 */   // MIs[0] src1
     /*  68966 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68973 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  68980 */   // (st (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  68980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  68984 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68990 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  68994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL),
     /*  68997 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69001 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69010 */   GIR_RootConstrainSelectedInstOperands,
     /*  69011 */   // GIR_Coverage, 750,
     /*  69011 */   GIR_EraseRootFromParent_Done,
     /*  69012 */ // Label 1590: @69012
     /*  69012 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(69110), // Rule ID 718 //
     /*  69017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69020 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  69032 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69036 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69040 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69044 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69048 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69051 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69055 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69064 */   // MIs[0] src1
     /*  69064 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69069 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69071 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69078 */   // (st (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69078 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69082 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL),
     /*  69095 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69099 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69108 */   GIR_RootConstrainSelectedInstOperands,
     /*  69109 */   // GIR_Coverage, 718,
     /*  69109 */   GIR_EraseRootFromParent_Done,
     /*  69110 */ // Label 1591: @69110
     /*  69110 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(69198), // Rule ID 338 //
     /*  69115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69118 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69130 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69134 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69138 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69142 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69146 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69149 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69153 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69162 */   // MIs[0] src1
     /*  69162 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69167 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69169 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69176 */   // (st (or:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69179 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69183 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69187 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69196 */   GIR_RootConstrainSelectedInstOperands,
     /*  69197 */   // GIR_Coverage, 338,
     /*  69197 */   GIR_EraseRootFromParent_Done,
     /*  69198 */ // Label 1592: @69198
     /*  69198 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(69286), // Rule ID 23199 //
     /*  69203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69214 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  69218 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69222 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69226 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69231 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69235 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69239 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69242 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69246 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69250 */   // MIs[0] src1
     /*  69250 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69255 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69257 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69264 */   // (st (or:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR16mr),
     /*  69267 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69271 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69275 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69278 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69284 */   GIR_RootConstrainSelectedInstOperands,
     /*  69285 */   // GIR_Coverage, 23199,
     /*  69285 */   GIR_EraseRootFromParent_Done,
     /*  69286 */ // Label 1593: @69286
     /*  69286 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(69384), // Rule ID 782 //
     /*  69291 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  69306 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69310 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69314 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69318 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69322 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69325 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69329 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69338 */   // MIs[0] src1
     /*  69338 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69343 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69345 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69352 */   // (st (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69356 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69362 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL),
     /*  69369 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69373 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69376 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69382 */   GIR_RootConstrainSelectedInstOperands,
     /*  69383 */   // GIR_Coverage, 782,
     /*  69383 */   GIR_EraseRootFromParent_Done,
     /*  69384 */ // Label 1594: @69384
     /*  69384 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(69482), // Rule ID 814 //
     /*  69389 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69392 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69396 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69400 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  69404 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69408 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69412 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69416 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69420 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69423 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69427 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69431 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69436 */   // MIs[0] src1
     /*  69436 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69441 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69443 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69450 */   // (st (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69454 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69460 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL),
     /*  69467 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69471 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69474 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69480 */   GIR_RootConstrainSelectedInstOperands,
     /*  69481 */   // GIR_Coverage, 814,
     /*  69481 */   GIR_EraseRootFromParent_Done,
     /*  69482 */ // Label 1595: @69482
     /*  69482 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(69580), // Rule ID 686 //
     /*  69487 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69490 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  69502 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69506 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  69510 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69514 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69518 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69521 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69525 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /*  69529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  69534 */   // MIs[0] src1
     /*  69534 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69539 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69541 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69548 */   // (st (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL16mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  69548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  69552 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  69562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL),
     /*  69565 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69569 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69578 */   GIR_RootConstrainSelectedInstOperands,
     /*  69579 */   // GIR_Coverage, 686,
     /*  69579 */   GIR_EraseRootFromParent_Done,
     /*  69580 */ // Label 1596: @69580
     /*  69580 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(69668), // Rule ID 446 //
     /*  69585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  69600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69608 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69612 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69616 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69619 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69623 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69632 */   // MIs[0] src1
     /*  69632 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69637 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69639 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69646 */   // (st (sub:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB16mr),
     /*  69649 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69653 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69657 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69660 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69666 */   GIR_RootConstrainSelectedInstOperands,
     /*  69667 */   // GIR_Coverage, 446,
     /*  69667 */   GIR_EraseRootFromParent_Done,
     /*  69668 */ // Label 1597: @69668
     /*  69668 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(69756), // Rule ID 374 //
     /*  69673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69680 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69688 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69692 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69696 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69700 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69704 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69707 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69711 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69715 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69720 */   // MIs[0] src1
     /*  69720 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69725 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69727 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69734 */   // (st (xor:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR16:{ *:[i16] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69737 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  69745 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69748 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69754 */   GIR_RootConstrainSelectedInstOperands,
     /*  69755 */   // GIR_Coverage, 374,
     /*  69755 */   GIR_EraseRootFromParent_Done,
     /*  69756 */ // Label 1598: @69756
     /*  69756 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(69844), // Rule ID 23211 //
     /*  69761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69768 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69772 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69776 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69780 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /*  69784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69789 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69793 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  69797 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69800 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  69804 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  69808 */   // MIs[0] src1
     /*  69808 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69813 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69815 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69822 */   // (st (xor:{ *:[i16] } GR16:{ *:[i16] }:$src2, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR16mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  69822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR16mr),
     /*  69825 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  69829 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  69833 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  69836 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  69842 */   GIR_RootConstrainSelectedInstOperands,
     /*  69843 */   // GIR_Coverage, 23211,
     /*  69843 */   GIR_EraseRootFromParent_Done,
     /*  69844 */ // Label 1599: @69844
     /*  69844 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(69898), // Rule ID 25 //
     /*  69849 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69852 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69856 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69860 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69864 */   // MIs[1] Operand 1
     /*  69864 */   // No operand predicates
     /*  69864 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  69868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69874 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69881 */   // (st (imm:{ *:[i16] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69884 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69888 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69891 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69896 */   GIR_RootConstrainSelectedInstOperands,
     /*  69897 */   // GIR_Coverage, 25,
     /*  69897 */   GIR_EraseRootFromParent_Done,
     /*  69898 */ // Label 1600: @69898
     /*  69898 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(69951), // Rule ID 22508 //
     /*  69903 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  69906 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  69913 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69917 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69921 */   // MIs[1] Operand 1
     /*  69921 */   // No operand predicates
     /*  69921 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69925 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69934 */   // (atomic_store (imm:{ *:[i16] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i16] }):$src)
     /*  69934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mi),
     /*  69937 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  69941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  69944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  69949 */   GIR_RootConstrainSelectedInstOperands,
     /*  69950 */   // GIR_Coverage, 22508,
     /*  69950 */   GIR_EraseRootFromParent_Done,
     /*  69951 */ // Label 1601: @69951
     /*  69951 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(70014), // Rule ID 50 //
     /*  69956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  69959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  69962 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  69966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  69970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  69974 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  69978 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  69983 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  69987 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69989 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  69996 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  69996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr),
     /*  69999 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70003 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  70007 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  70012 */   GIR_RootConstrainSelectedInstOperands,
     /*  70013 */   // GIR_Coverage, 50,
     /*  70013 */   GIR_EraseRootFromParent_Done,
     /*  70014 */ // Label 1602: @70014
     /*  70014 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(70077), // Rule ID 56 //
     /*  70019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  70022 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  70037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /*  70041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  70052 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70059 */   // (st (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE16mr_EVEX addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src1)
     /*  70059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16mr_EVEX),
     /*  70062 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70066 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  70070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  70075 */   GIR_RootConstrainSelectedInstOperands,
     /*  70076 */   // GIR_Coverage, 56,
     /*  70076 */   GIR_EraseRootFromParent_Done,
     /*  70077 */ // Label 1603: @70077
     /*  70077 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(70122), // Rule ID 22512 //
     /*  70082 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70085 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  70092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70107 */   // (atomic_store GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_16>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70110 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70114 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70116 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70120 */   GIR_RootConstrainSelectedInstOperands,
     /*  70121 */   // GIR_Coverage, 22512,
     /*  70121 */   GIR_EraseRootFromParent_Done,
     /*  70122 */ // Label 1604: @70122
     /*  70122 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(70164), // Rule ID 33 //
     /*  70127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  70138 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70142 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70149 */   // (st GR16:{ *:[i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, GR16:{ *:[i16] }:$src)
     /*  70149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70152 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70156 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70162 */   GIR_RootConstrainSelectedInstOperands,
     /*  70163 */   // GIR_Coverage, 33,
     /*  70163 */   GIR_EraseRootFromParent_Done,
     /*  70164 */ // Label 1605: @70164
     /*  70164 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(70209), // Rule ID 4622 //
     /*  70169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /*  70172 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70175 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /*  70183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70194 */   // (st FR16X:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSHZmr addr:{ *:[iPTR] }:$dst, FR16X:{ *:[f16] }:$src)
     /*  70194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSHZmr),
     /*  70197 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70201 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  70203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70207 */   GIR_RootConstrainSelectedInstOperands,
     /*  70208 */   // GIR_Coverage, 4622,
     /*  70208 */   GIR_EraseRootFromParent_Done,
     /*  70209 */ // Label 1606: @70209
     /*  70209 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(70275), // Rule ID 18547 //
     /*  70214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  70217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70224 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70228 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70235 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70251 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PEXTRWmri),
     /*  70259 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70273 */   GIR_RootConstrainSelectedInstOperands,
     /*  70274 */   // GIR_Coverage, 18547,
     /*  70274 */   GIR_EraseRootFromParent_Done,
     /*  70275 */ // Label 1607: @70275
     /*  70275 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(70341), // Rule ID 18548 //
     /*  70280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoBWI),
     /*  70283 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70286 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70301 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWmri),
     /*  70325 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70339 */   GIR_RootConstrainSelectedInstOperands,
     /*  70340 */   // GIR_Coverage, 18548,
     /*  70340 */   GIR_EraseRootFromParent_Done,
     /*  70341 */ // Label 1608: @70341
     /*  70341 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(70453), // Rule ID 18336 //
     /*  70346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  70349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70367 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV16mr addr:{ *:[iPTR] }:$dst, (EXTRACT_SUBREG:{ *:[i16] } (PEXTRWrri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] }), sub_16bit:{ *:[i32] }))
     /*  70367 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  70370 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70374 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70379 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70383 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70388 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  70391 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::PEXTRWrri),
     /*  70395 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70400 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  70403 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /*  70406 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  70408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  70411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70420 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /*  70427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /*  70432 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /*  70437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16mr),
     /*  70440 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70447 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70451 */   GIR_RootConstrainSelectedInstOperands,
     /*  70452 */   // GIR_Coverage, 18336,
     /*  70452 */   GIR_EraseRootFromParent_Done,
     /*  70453 */ // Label 1609: @70453
     /*  70453 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(70519), // Rule ID 21840 //
     /*  70458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /*  70461 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70464 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  70472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70479 */   // (st f16:{ *:[f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VPEXTRWZmri addr:{ *:[iPTR] }:$dst, (COPY_TO_REGCLASS:{ *:[v8i16] } FR16:{ *:[f16] }:$src, VR128:{ *:[i32] }), 0:{ *:[i8] })
     /*  70479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  70482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  70486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  70491 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, // src
     /*  70495 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR128RegClassID),
     /*  70500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPEXTRWZmri),
     /*  70503 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  70510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  70513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  70517 */   GIR_RootConstrainSelectedInstOperands,
     /*  70518 */   // GIR_Coverage, 21840,
     /*  70518 */   GIR_EraseRootFromParent_Done,
     /*  70519 */ // Label 1610: @70519
     /*  70519 */ GIM_Reject,
     /*  70520 */ // Label 1478: @70520
     /*  70520 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(70616), // Rule ID 22493 //
     /*  70525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70528 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70538 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70546 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70554 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70558 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70562 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70565 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70569 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70576 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70580 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70584 */   // MIs[0] dst
     /*  70584 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70589 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70591 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70598 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70601 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70605 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70614 */   GIR_RootConstrainSelectedInstOperands,
     /*  70615 */   // GIR_Coverage, 22493,
     /*  70615 */   GIR_EraseRootFromParent_Done,
     /*  70616 */ // Label 1611: @70616
     /*  70616 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(70712), // Rule ID 22497 //
     /*  70621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70624 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70627 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70634 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70638 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70642 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70646 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70650 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70654 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70658 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70665 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70672 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70680 */   // MIs[0] dst
     /*  70680 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70685 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70687 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70694 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  70697 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70701 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70710 */   GIR_RootConstrainSelectedInstOperands,
     /*  70711 */   // GIR_Coverage, 22497,
     /*  70711 */   GIR_EraseRootFromParent_Done,
     /*  70712 */ // Label 1612: @70712
     /*  70712 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(70805), // Rule ID 22501 //
     /*  70717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  70735 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70743 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  70747 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70751 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70755 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70758 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70762 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70769 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70773 */   // MIs[0] dst
     /*  70773 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70778 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70780 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70787 */   // (atomic_store (sub:{ *:[i32] } 0:{ *:[i32] }, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  70787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  70790 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70794 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70803 */   GIR_RootConstrainSelectedInstOperands,
     /*  70804 */   // GIR_Coverage, 22501,
     /*  70804 */   GIR_EraseRootFromParent_Done,
     /*  70805 */ // Label 1613: @70805
     /*  70805 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(70895), // Rule ID 22505 //
     /*  70810 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70820 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70824 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70828 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70832 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70836 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70840 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70844 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  70847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  70851 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  70858 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70862 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  70866 */   // MIs[0] dst
     /*  70866 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70871 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70873 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70880 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (NOT32m addr:{ *:[iPTR] }:$dst)
     /*  70880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  70883 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  70887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70893 */   GIR_RootConstrainSelectedInstOperands,
     /*  70894 */   // GIR_Coverage, 22505,
     /*  70894 */   GIR_EraseRootFromParent_Done,
     /*  70895 */ // Label 1614: @70895
     /*  70895 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(70981), // Rule ID 227 //
     /*  70900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70903 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70910 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  70914 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  70918 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  70922 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  70926 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70930 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  70934 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70937 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  70941 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  70945 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  70949 */   // MIs[0] src1
     /*  70949 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70954 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70956 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  70963 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  70963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC32m),
     /*  70966 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  70970 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  70973 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  70979 */   GIR_RootConstrainSelectedInstOperands,
     /*  70980 */   // GIR_Coverage, 227,
     /*  70980 */   GIR_EraseRootFromParent_Done,
     /*  70981 */ // Label 1615: @70981
     /*  70981 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(71067), // Rule ID 230 //
     /*  70986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  70989 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  70992 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  70996 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71000 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71004 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71012 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71016 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71020 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71023 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71027 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71031 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71035 */   // MIs[0] src1
     /*  71035 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71040 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71042 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71049 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC32m),
     /*  71052 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71056 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71065 */   GIR_RootConstrainSelectedInstOperands,
     /*  71066 */   // GIR_Coverage, 230,
     /*  71066 */   GIR_EraseRootFromParent_Done,
     /*  71067 */ // Label 1616: @71067
     /*  71067 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(71160), // Rule ID 22615 //
     /*  71072 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71075 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71087 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71091 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71095 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71099 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71103 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71106 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71110 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71114 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  71125 */   // MIs[0] dst
     /*  71125 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71130 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71132 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71139 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 128:{ *:[i32] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i32] })
     /*  71139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71142 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  71149 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71158 */   GIR_RootConstrainSelectedInstOperands,
     /*  71159 */   // GIR_Coverage, 22615,
     /*  71159 */   GIR_EraseRootFromParent_Done,
     /*  71160 */ // Label 1617: @71160
     /*  71160 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(71243), // Rule ID 17614 //
     /*  71165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71172 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71176 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  71180 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71184 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71188 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71192 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71196 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71199 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71203 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71207 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71211 */   // MIs[0] dst
     /*  71211 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71216 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71218 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71225 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1),
     /*  71228 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71232 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71241 */   GIR_RootConstrainSelectedInstOperands,
     /*  71242 */   // GIR_Coverage, 17614,
     /*  71242 */   GIR_EraseRootFromParent_Done,
     /*  71243 */ // Label 1618: @71243
     /*  71243 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(71326), // Rule ID 17618 //
     /*  71248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  71263 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71267 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  71271 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71275 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71279 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71282 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71286 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71290 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 31,
     /*  71294 */   // MIs[0] dst
     /*  71294 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71299 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71301 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71308 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  71308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1),
     /*  71311 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  71315 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71324 */   GIR_RootConstrainSelectedInstOperands,
     /*  71325 */   // GIR_Coverage, 17618,
     /*  71325 */   GIR_EraseRootFromParent_Done,
     /*  71326 */ // Label 1619: @71326
     /*  71326 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(71409), // Rule ID 263 //
     /*  71331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71346 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71354 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  71358 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71362 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71366 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71369 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71373 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71377 */   // MIs[0] src1
     /*  71377 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71382 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71384 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71391 */   // (st (sub:{ *:[i32] } 0:{ *:[i32] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG32m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  71391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG32m),
     /*  71394 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71398 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71407 */   GIR_RootConstrainSelectedInstOperands,
     /*  71408 */   // GIR_Coverage, 263,
     /*  71408 */   GIR_EraseRootFromParent_Done,
     /*  71409 */ // Label 1620: @71409
     /*  71409 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(71489), // Rule ID 271 //
     /*  71414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71417 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71429 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71437 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71445 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71448 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71452 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  71456 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  71460 */   // MIs[0] src1
     /*  71460 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71465 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71467 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71474 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, -1:{ *:[i32] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT32m addr:{ *:[iPTR] }:$src1)
     /*  71474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT32m),
     /*  71477 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71481 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  71487 */   GIR_RootConstrainSelectedInstOperands,
     /*  71488 */   // GIR_Coverage, 271,
     /*  71488 */   GIR_EraseRootFromParent_Done,
     /*  71489 */ // Label 1621: @71489
     /*  71489 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(71584), // Rule ID 415 //
     /*  71494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71501 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71509 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71517 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71521 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71525 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71528 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71532 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71536 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71540 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71544 */   // MIs[3] Operand 1
     /*  71544 */   // No operand predicates
     /*  71544 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71548 */   // MIs[0] src1
     /*  71548 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71553 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71555 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71562 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  71565 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71569 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71572 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71582 */   GIR_RootConstrainSelectedInstOperands,
     /*  71583 */   // GIR_Coverage, 415,
     /*  71583 */   GIR_EraseRootFromParent_Done,
     /*  71584 */ // Label 1622: @71584
     /*  71584 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(71679), // Rule ID 307 //
     /*  71589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71612 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71616 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71620 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71623 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71627 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71631 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71635 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71639 */   // MIs[3] Operand 1
     /*  71639 */   // No operand predicates
     /*  71639 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71643 */   // MIs[0] src1
     /*  71643 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71648 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71650 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71657 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  71660 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71664 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71667 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71670 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71677 */   GIR_RootConstrainSelectedInstOperands,
     /*  71678 */   // GIR_Coverage, 307,
     /*  71678 */   GIR_EraseRootFromParent_Done,
     /*  71679 */ // Label 1623: @71679
     /*  71679 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(71774), // Rule ID 343 //
     /*  71684 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71687 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  71699 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71703 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71707 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71711 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71715 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71718 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71722 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71726 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71730 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71734 */   // MIs[3] Operand 1
     /*  71734 */   // No operand predicates
     /*  71734 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71738 */   // MIs[0] src1
     /*  71738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71743 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71745 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71752 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  71755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71759 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71762 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71765 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71772 */   GIR_RootConstrainSelectedInstOperands,
     /*  71773 */   // GIR_Coverage, 343,
     /*  71773 */   GIR_EraseRootFromParent_Done,
     /*  71774 */ // Label 1624: @71774
     /*  71774 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(71869), // Rule ID 455 //
     /*  71779 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  71794 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71798 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71802 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71806 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71810 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71813 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71817 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71821 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71825 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71829 */   // MIs[3] Operand 1
     /*  71829 */   // No operand predicates
     /*  71829 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71833 */   // MIs[0] src1
     /*  71833 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71838 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71840 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71847 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  71850 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71854 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71857 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71860 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71867 */   GIR_RootConstrainSelectedInstOperands,
     /*  71868 */   // GIR_Coverage, 455,
     /*  71868 */   GIR_EraseRootFromParent_Done,
     /*  71869 */ // Label 1625: @71869
     /*  71869 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(71964), // Rule ID 379 //
     /*  71874 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71877 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  71881 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71885 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71889 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71893 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71897 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71901 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  71905 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  71908 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  71912 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  71916 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  71920 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71924 */   // MIs[3] Operand 1
     /*  71924 */   // No operand predicates
     /*  71924 */   GIM_CheckCxxInsnPredicate, /*MI*/3, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  71928 */   // MIs[0] src1
     /*  71928 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71933 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  71935 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  71942 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i32] }):$src2)
     /*  71942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  71945 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  71949 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  71952 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  71955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  71962 */   GIR_RootConstrainSelectedInstOperands,
     /*  71963 */   // GIR_Coverage, 379,
     /*  71963 */   GIR_EraseRootFromParent_Done,
     /*  71964 */ // Label 1626: @71964
     /*  71964 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(72065), // Rule ID 22429 //
     /*  71969 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  71972 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  71979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  71983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  71987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  71991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  71995 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71999 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72003 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72006 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72010 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72017 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72021 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72025 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72029 */   // MIs[3] Operand 1
     /*  72029 */   // No operand predicates
     /*  72029 */   // MIs[0] dst
     /*  72029 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72034 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72036 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72043 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mi),
     /*  72046 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72050 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72053 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72056 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72063 */   GIR_RootConstrainSelectedInstOperands,
     /*  72064 */   // GIR_Coverage, 22429,
     /*  72064 */   GIR_EraseRootFromParent_Done,
     /*  72065 */ // Label 1627: @72065
     /*  72065 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(72166), // Rule ID 22437 //
     /*  72070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72096 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72100 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72104 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72107 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72111 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72118 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72122 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72126 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72130 */   // MIs[3] Operand 1
     /*  72130 */   // No operand predicates
     /*  72130 */   // MIs[0] dst
     /*  72130 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72135 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72137 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72144 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mi),
     /*  72147 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72151 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72154 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72157 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72164 */   GIR_RootConstrainSelectedInstOperands,
     /*  72165 */   // GIR_Coverage, 22437,
     /*  72165 */   GIR_EraseRootFromParent_Done,
     /*  72166 */ // Label 1628: @72166
     /*  72166 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(72267), // Rule ID 22445 //
     /*  72171 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72174 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  72189 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72193 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72197 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72201 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72205 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72208 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72212 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72219 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72223 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72227 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72231 */   // MIs[3] Operand 1
     /*  72231 */   // No operand predicates
     /*  72231 */   // MIs[0] dst
     /*  72231 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72236 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72238 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72245 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mi),
     /*  72248 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72252 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72255 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72258 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72265 */   GIR_RootConstrainSelectedInstOperands,
     /*  72266 */   // GIR_Coverage, 22445,
     /*  72266 */   GIR_EraseRootFromParent_Done,
     /*  72267 */ // Label 1629: @72267
     /*  72267 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(72368), // Rule ID 22461 //
     /*  72272 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72275 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72282 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72286 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  72290 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72294 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72298 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72302 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72306 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72313 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72320 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72324 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72328 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72332 */   // MIs[3] Operand 1
     /*  72332 */   // No operand predicates
     /*  72332 */   // MIs[0] dst
     /*  72332 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72337 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72339 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72346 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mi),
     /*  72349 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72353 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72356 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72366 */   GIR_RootConstrainSelectedInstOperands,
     /*  72367 */   // GIR_Coverage, 22461,
     /*  72367 */   GIR_EraseRootFromParent_Done,
     /*  72368 */ // Label 1630: @72368
     /*  72368 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(72469), // Rule ID 22453 //
     /*  72373 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72376 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72391 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72395 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72399 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72403 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72407 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  72410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  72414 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  72421 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72425 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72429 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72433 */   // MIs[3] Operand 1
     /*  72433 */   // No operand predicates
     /*  72433 */   // MIs[0] dst
     /*  72433 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72438 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72440 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72447 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, (imm:{ *:[i32] }):$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  72447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mi),
     /*  72450 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  72454 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  72457 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72460 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72467 */   GIR_RootConstrainSelectedInstOperands,
     /*  72468 */   // GIR_Coverage, 22453,
     /*  72468 */   GIR_EraseRootFromParent_Done,
     /*  72469 */ // Label 1631: @72469
     /*  72469 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(72573), // Rule ID 834 //
     /*  72474 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72477 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  72489 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72493 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72497 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72501 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72509 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72512 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72516 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72520 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72525 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72529 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72533 */   // MIs[3] Operand 1
     /*  72533 */   // No operand predicates
     /*  72533 */   // MIs[0] src1
     /*  72533 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72538 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72540 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72547 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8),
     /*  72550 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72554 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  72558 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72561 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72571 */   GIR_RootConstrainSelectedInstOperands,
     /*  72572 */   // GIR_Coverage, 834,
     /*  72572 */   GIR_EraseRootFromParent_Done,
     /*  72573 */ // Label 1632: @72573
     /*  72573 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(72677), // Rule ID 858 //
     /*  72578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  72593 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72597 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72601 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  72605 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  72610 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72614 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72618 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72621 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72625 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72629 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  72633 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72637 */   // MIs[3] Operand 1
     /*  72637 */   // No operand predicates
     /*  72637 */   // MIs[0] src1
     /*  72637 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72642 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72644 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72651 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  72651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8),
     /*  72654 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72658 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  72662 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  72665 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72675 */   GIR_RootConstrainSelectedInstOperands,
     /*  72676 */   // GIR_Coverage, 858,
     /*  72676 */   GIR_EraseRootFromParent_Done,
     /*  72677 */ // Label 1633: @72677
     /*  72677 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(72768), // Rule ID 735 //
     /*  72682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72685 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  72697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72701 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72705 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72709 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72713 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72716 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72720 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72724 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72728 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72732 */   // MIs[3] Operand 1
     /*  72732 */   // No operand predicates
     /*  72732 */   // MIs[0] src1
     /*  72732 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72737 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72739 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72746 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi),
     /*  72749 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72753 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72756 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72766 */   GIR_RootConstrainSelectedInstOperands,
     /*  72767 */   // GIR_Coverage, 735,
     /*  72767 */   GIR_EraseRootFromParent_Done,
     /*  72768 */ // Label 1634: @72768
     /*  72768 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(72859), // Rule ID 703 //
     /*  72773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72780 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  72788 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72792 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72796 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72800 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72804 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72807 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72811 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72815 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72819 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72823 */   // MIs[3] Operand 1
     /*  72823 */   // No operand predicates
     /*  72823 */   // MIs[0] src1
     /*  72823 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72828 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72830 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72837 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi),
     /*  72840 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72844 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72847 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72857 */   GIR_RootConstrainSelectedInstOperands,
     /*  72858 */   // GIR_Coverage, 703,
     /*  72858 */   GIR_EraseRootFromParent_Done,
     /*  72859 */ // Label 1635: @72859
     /*  72859 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(72950), // Rule ID 767 //
     /*  72864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72867 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  72879 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72883 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72887 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72891 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72895 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72898 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72902 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72906 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  72910 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72914 */   // MIs[3] Operand 1
     /*  72914 */   // No operand predicates
     /*  72914 */   // MIs[0] src1
     /*  72914 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72919 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  72921 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  72928 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  72928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi),
     /*  72931 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  72935 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  72938 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  72941 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  72948 */   GIR_RootConstrainSelectedInstOperands,
     /*  72949 */   // GIR_Coverage, 767,
     /*  72949 */   GIR_EraseRootFromParent_Done,
     /*  72950 */ // Label 1636: @72950
     /*  72950 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(73041), // Rule ID 799 //
     /*  72955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  72962 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  72966 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  72970 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  72978 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72982 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  72986 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  72989 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  72993 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  72997 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  73001 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73005 */   // MIs[3] Operand 1
     /*  73005 */   // No operand predicates
     /*  73005 */   // MIs[0] src1
     /*  73005 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73010 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73012 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73019 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  73019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi),
     /*  73022 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73026 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73029 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73032 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73039 */   GIR_RootConstrainSelectedInstOperands,
     /*  73040 */   // GIR_Coverage, 799,
     /*  73040 */   GIR_EraseRootFromParent_Done,
     /*  73041 */ // Label 1637: @73041
     /*  73041 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(73132), // Rule ID 671 //
     /*  73046 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73049 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  73053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  73061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  73069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73077 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  73080 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73084 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  73088 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  73092 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73096 */   // MIs[3] Operand 1
     /*  73096 */   // No operand predicates
     /*  73096 */   // MIs[0] src1
     /*  73096 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73101 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  73103 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73110 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  73110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi),
     /*  73113 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  73117 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  73120 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73123 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  73130 */   GIR_RootConstrainSelectedInstOperands,
     /*  73131 */   // GIR_Coverage, 671,
     /*  73131 */   GIR_EraseRootFromParent_Done,
     /*  73132 */ // Label 1638: @73132
     /*  73132 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(73230), // Rule ID 22433 //
     /*  73137 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73140 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73155 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73159 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73163 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73167 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73171 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73174 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73178 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73185 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73189 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73194 */   // MIs[0] dst
     /*  73194 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73199 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73201 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73208 */   // (atomic_store (add:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73211 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73215 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73219 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73228 */   GIR_RootConstrainSelectedInstOperands,
     /*  73229 */   // GIR_Coverage, 22433,
     /*  73229 */   GIR_EraseRootFromParent_Done,
     /*  73230 */ // Label 1639: @73230
     /*  73230 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(73328), // Rule ID 26004 //
     /*  73235 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73238 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  73253 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73257 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73266 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73270 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73274 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73281 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73288 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73292 */   // MIs[0] dst
     /*  73292 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73297 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73299 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73306 */   // (atomic_store (add:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  73309 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73313 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73317 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73326 */   GIR_RootConstrainSelectedInstOperands,
     /*  73327 */   // GIR_Coverage, 26004,
     /*  73327 */   GIR_EraseRootFromParent_Done,
     /*  73328 */ // Label 1640: @73328
     /*  73328 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(73426), // Rule ID 22441 //
     /*  73333 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73336 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73351 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73355 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73359 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73363 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73367 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73370 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73374 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73381 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73385 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73390 */   // MIs[0] dst
     /*  73390 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73395 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73397 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73404 */   // (atomic_store (and:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73407 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73411 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73415 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73418 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73424 */   GIR_RootConstrainSelectedInstOperands,
     /*  73425 */   // GIR_Coverage, 22441,
     /*  73425 */   GIR_EraseRootFromParent_Done,
     /*  73426 */ // Label 1641: @73426
     /*  73426 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(73524), // Rule ID 26008 //
     /*  73431 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73434 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73449 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73453 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73462 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73466 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73470 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73473 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73477 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73484 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73488 */   // MIs[0] dst
     /*  73488 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73493 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73495 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73502 */   // (atomic_store (and:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  73505 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73509 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73513 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73522 */   GIR_RootConstrainSelectedInstOperands,
     /*  73523 */   // GIR_Coverage, 26008,
     /*  73523 */   GIR_EraseRootFromParent_Done,
     /*  73524 */ // Label 1642: @73524
     /*  73524 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(73622), // Rule ID 22449 //
     /*  73529 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73532 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73555 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73559 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73563 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73566 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73570 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73577 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73581 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73586 */   // MIs[0] dst
     /*  73586 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73591 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73593 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73600 */   // (atomic_store (or:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73603 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73607 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73611 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73614 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73620 */   GIR_RootConstrainSelectedInstOperands,
     /*  73621 */   // GIR_Coverage, 22449,
     /*  73621 */   GIR_EraseRootFromParent_Done,
     /*  73622 */ // Label 1643: @73622
     /*  73622 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(73720), // Rule ID 26012 //
     /*  73627 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73630 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  73645 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73653 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73658 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73662 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73666 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73673 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73680 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73684 */   // MIs[0] dst
     /*  73684 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73689 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73691 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73698 */   // (atomic_store (or:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  73701 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73705 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  73709 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73718 */   GIR_RootConstrainSelectedInstOperands,
     /*  73719 */   // GIR_Coverage, 26012,
     /*  73719 */   GIR_EraseRootFromParent_Done,
     /*  73720 */ // Label 1644: @73720
     /*  73720 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(73818), // Rule ID 22465 //
     /*  73725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  73743 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73747 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73751 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73755 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73759 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73766 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73773 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73782 */   // MIs[0] dst
     /*  73782 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73787 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73789 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73796 */   // (atomic_store (sub:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  73799 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73803 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73807 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73816 */   GIR_RootConstrainSelectedInstOperands,
     /*  73817 */   // GIR_Coverage, 22465,
     /*  73817 */   GIR_EraseRootFromParent_Done,
     /*  73818 */ // Label 1645: @73818
     /*  73818 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(73916), // Rule ID 22457 //
     /*  73823 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73826 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73833 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73837 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73841 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73845 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73849 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  73853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73857 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73860 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73864 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73871 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73875 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73880 */   // MIs[0] dst
     /*  73880 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73885 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73887 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73894 */   // (atomic_store (xor:{ *:[i32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>, GR32:{ *:[i32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73901 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  73905 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  73908 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  73914 */   GIR_RootConstrainSelectedInstOperands,
     /*  73915 */   // GIR_Coverage, 22457,
     /*  73915 */   GIR_EraseRootFromParent_Done,
     /*  73916 */ // Label 1646: @73916
     /*  73916 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(74014), // Rule ID 26016 //
     /*  73921 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73924 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73931 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  73935 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73939 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  73952 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73956 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  73960 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  73963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  73967 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  73974 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  73978 */   // MIs[0] dst
     /*  73978 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73983 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73985 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  73992 */   // (atomic_store (xor:{ *:[i32] } GR32:{ *:[i32] }:$src, (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  73992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  73995 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  73999 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  74003 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74012 */   GIR_RootConstrainSelectedInstOperands,
     /*  74013 */   // GIR_Coverage, 26016,
     /*  74013 */   GIR_EraseRootFromParent_Done,
     /*  74014 */ // Label 1647: @74014
     /*  74014 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(74125), // Rule ID 837 //
     /*  74019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74022 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  74034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74038 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74042 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74046 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74050 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74054 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74057 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74061 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74065 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74070 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74075 */   // MIs[0] src1
     /*  74075 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74080 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74082 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74089 */   // (st (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74093 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74099 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL),
     /*  74106 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74110 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74114 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74117 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74123 */   GIR_RootConstrainSelectedInstOperands,
     /*  74124 */   // GIR_Coverage, 837,
     /*  74124 */   GIR_EraseRootFromParent_Done,
     /*  74125 */ // Label 1648: @74125
     /*  74125 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(74236), // Rule ID 861 //
     /*  74130 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74133 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  74145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74149 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74153 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  74157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74162 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74166 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74170 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74173 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74177 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74181 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74186 */   // MIs[0] src1
     /*  74186 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74191 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74193 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74200 */   // (st (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD32mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74204 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74210 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  74214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL),
     /*  74217 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74221 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74225 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74228 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74234 */   GIR_RootConstrainSelectedInstOperands,
     /*  74235 */   // GIR_Coverage, 861,
     /*  74235 */   GIR_EraseRootFromParent_Done,
     /*  74236 */ // Label 1649: @74236
     /*  74236 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(74324), // Rule ID 411 //
     /*  74241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74264 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74268 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74272 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74275 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74279 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74283 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74288 */   // MIs[0] src1
     /*  74288 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74293 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74295 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74302 */   // (st (add:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74305 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74313 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74322 */   GIR_RootConstrainSelectedInstOperands,
     /*  74323 */   // GIR_Coverage, 411,
     /*  74323 */   GIR_EraseRootFromParent_Done,
     /*  74324 */ // Label 1650: @74324
     /*  74324 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(74412), // Rule ID 23224 //
     /*  74329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74332 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74336 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74340 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  74344 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74348 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74352 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74357 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74361 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74365 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74368 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74372 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74376 */   // MIs[0] src1
     /*  74376 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74381 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74383 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74390 */   // (st (add:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32mr),
     /*  74393 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74397 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74401 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74410 */   GIR_RootConstrainSelectedInstOperands,
     /*  74411 */   // GIR_Coverage, 23224,
     /*  74411 */   GIR_EraseRootFromParent_Done,
     /*  74412 */ // Label 1651: @74412
     /*  74412 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(74500), // Rule ID 303 //
     /*  74417 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74420 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74424 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74428 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74432 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74436 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74440 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74444 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74448 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74451 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74455 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74459 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74464 */   // MIs[0] src1
     /*  74464 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74469 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74471 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74478 */   // (st (and:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74485 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74489 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74498 */   GIR_RootConstrainSelectedInstOperands,
     /*  74499 */   // GIR_Coverage, 303,
     /*  74499 */   GIR_EraseRootFromParent_Done,
     /*  74500 */ // Label 1652: @74500
     /*  74500 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(74588), // Rule ID 23188 //
     /*  74505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74512 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74516 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74520 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74528 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74533 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74537 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74541 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74548 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74552 */   // MIs[0] src1
     /*  74552 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74557 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74559 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74566 */   // (st (and:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND32mr),
     /*  74569 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74577 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74586 */   GIR_RootConstrainSelectedInstOperands,
     /*  74587 */   // GIR_Coverage, 23188,
     /*  74587 */   GIR_EraseRootFromParent_Done,
     /*  74588 */ // Label 1653: @74588
     /*  74588 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(74686), // Rule ID 751 //
     /*  74593 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74596 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  74608 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74612 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74616 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74620 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74624 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74627 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74631 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74635 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74640 */   // MIs[0] src1
     /*  74640 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74645 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74647 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74654 */   // (st (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74658 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74664 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL),
     /*  74671 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74675 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74678 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74684 */   GIR_RootConstrainSelectedInstOperands,
     /*  74685 */   // GIR_Coverage, 751,
     /*  74685 */   GIR_EraseRootFromParent_Done,
     /*  74686 */ // Label 1654: @74686
     /*  74686 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(74784), // Rule ID 719 //
     /*  74691 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74694 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  74706 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74710 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74714 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74718 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74722 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74725 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74729 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  74733 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  74738 */   // MIs[0] src1
     /*  74738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74743 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74745 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74752 */   // (st (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  74752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74756 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74762 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  74766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL),
     /*  74769 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74773 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74782 */   GIR_RootConstrainSelectedInstOperands,
     /*  74783 */   // GIR_Coverage, 719,
     /*  74783 */   GIR_EraseRootFromParent_Done,
     /*  74784 */ // Label 1655: @74784
     /*  74784 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(74872), // Rule ID 339 //
     /*  74789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74804 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74808 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74812 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74816 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74820 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74827 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74836 */   // MIs[0] src1
     /*  74836 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74841 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74843 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74850 */   // (st (or:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74853 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74857 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  74861 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74870 */   GIR_RootConstrainSelectedInstOperands,
     /*  74871 */   // GIR_Coverage, 339,
     /*  74871 */   GIR_EraseRootFromParent_Done,
     /*  74872 */ // Label 1656: @74872
     /*  74872 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(74960), // Rule ID 23200 //
     /*  74877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  74892 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74896 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  74900 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  74905 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74909 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74913 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  74920 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  74924 */   // MIs[0] src1
     /*  74924 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74929 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74931 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  74938 */   // (st (or:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  74938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR32mr),
     /*  74941 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  74945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  74949 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  74952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  74958 */   GIR_RootConstrainSelectedInstOperands,
     /*  74959 */   // GIR_Coverage, 23200,
     /*  74959 */   GIR_EraseRootFromParent_Done,
     /*  74960 */ // Label 1657: @74960
     /*  74960 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(75058), // Rule ID 783 //
     /*  74965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  74972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  74976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  74980 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  74984 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  74988 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74992 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  74996 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  74999 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75003 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75012 */   // MIs[0] src1
     /*  75012 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75017 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75019 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75026 */   // (st (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75030 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75036 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL),
     /*  75043 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75047 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75056 */   GIR_RootConstrainSelectedInstOperands,
     /*  75057 */   // GIR_Coverage, 783,
     /*  75057 */   GIR_EraseRootFromParent_Done,
     /*  75058 */ // Label 1658: @75058
     /*  75058 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(75156), // Rule ID 815 //
     /*  75063 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75066 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75070 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75074 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  75078 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75082 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75086 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75090 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75094 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75097 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75101 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75105 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75110 */   // MIs[0] src1
     /*  75110 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75115 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75117 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75124 */   // (st (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75124 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75128 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75134 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL),
     /*  75141 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75145 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75148 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75154 */   GIR_RootConstrainSelectedInstOperands,
     /*  75155 */   // GIR_Coverage, 815,
     /*  75155 */   GIR_EraseRootFromParent_Done,
     /*  75156 */ // Label 1659: @75156
     /*  75156 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(75254), // Rule ID 687 //
     /*  75161 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75164 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75168 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75172 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  75176 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75180 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  75184 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75188 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75192 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75195 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75199 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /*  75203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  75208 */   // MIs[0] src1
     /*  75208 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75213 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75215 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75222 */   // (st (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL32mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  75222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  75226 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  75236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL),
     /*  75239 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75243 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75252 */   GIR_RootConstrainSelectedInstOperands,
     /*  75253 */   // GIR_Coverage, 687,
     /*  75253 */   GIR_EraseRootFromParent_Done,
     /*  75254 */ // Label 1660: @75254
     /*  75254 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(75342), // Rule ID 447 //
     /*  75259 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75262 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  75274 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75278 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75282 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75286 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75290 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75293 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75297 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75301 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75306 */   // MIs[0] src1
     /*  75306 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75311 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75313 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75320 */   // (st (sub:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB32mr),
     /*  75323 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75327 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75331 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75340 */   GIR_RootConstrainSelectedInstOperands,
     /*  75341 */   // GIR_Coverage, 447,
     /*  75341 */   GIR_EraseRootFromParent_Done,
     /*  75342 */ // Label 1661: @75342
     /*  75342 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(75430), // Rule ID 375 //
     /*  75347 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75354 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75358 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75362 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75370 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75374 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75378 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75381 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75385 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75389 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75394 */   // MIs[0] src1
     /*  75394 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75399 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75401 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75408 */   // (st (xor:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR32:{ *:[i32] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75411 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  75419 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75428 */   GIR_RootConstrainSelectedInstOperands,
     /*  75429 */   // GIR_Coverage, 375,
     /*  75429 */   GIR_EraseRootFromParent_Done,
     /*  75430 */ // Label 1662: @75430
     /*  75430 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(75518), // Rule ID 23212 //
     /*  75435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75438 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75450 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75454 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  75458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  75471 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75474 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  75478 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  75482 */   // MIs[0] src1
     /*  75482 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75487 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  75489 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75496 */   // (st (xor:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR32mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  75496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR32mr),
     /*  75499 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  75503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  75507 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  75510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  75516 */   GIR_RootConstrainSelectedInstOperands,
     /*  75517 */   // GIR_Coverage, 23212,
     /*  75517 */   GIR_EraseRootFromParent_Done,
     /*  75518 */ // Label 1663: @75518
     /*  75518 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(75572), // Rule ID 26 //
     /*  75523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75530 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75534 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75538 */   // MIs[1] Operand 1
     /*  75538 */   // No operand predicates
     /*  75538 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_imm_su),
     /*  75542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75555 */   // (st (imm:{ *:[i32] })<<P:Predicate_imm_su>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75558 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75562 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75570 */   GIR_RootConstrainSelectedInstOperands,
     /*  75571 */   // GIR_Coverage, 26,
     /*  75571 */   GIR_EraseRootFromParent_Done,
     /*  75572 */ // Label 1664: @75572
     /*  75572 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(75638), // Rule ID 22519 //
     /*  75577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  75580 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75583 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75598 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75602 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75620 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  75623 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75627 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75631 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75636 */   GIR_RootConstrainSelectedInstOperands,
     /*  75637 */   // GIR_Coverage, 22519,
     /*  75637 */   GIR_EraseRootFromParent_Done,
     /*  75638 */ // Label 1665: @75638
     /*  75638 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(75704), // Rule ID 22520 //
     /*  75643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  75646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75649 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75668 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75673 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75679 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75686 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  75689 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75693 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75697 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75702 */   GIR_RootConstrainSelectedInstOperands,
     /*  75703 */   // GIR_Coverage, 22520,
     /*  75703 */   GIR_EraseRootFromParent_Done,
     /*  75704 */ // Label 1666: @75704
     /*  75704 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(75770), // Rule ID 22521 //
     /*  75709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  75712 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75715 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  75730 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75734 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  75739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75743 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75752 */   // (atomic_store (bitconvert:{ *:[i32] } FR32:{ *:[f32] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  75752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  75755 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75759 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  75763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75768 */   GIR_RootConstrainSelectedInstOperands,
     /*  75769 */   // GIR_Coverage, 22521,
     /*  75769 */   GIR_EraseRootFromParent_Done,
     /*  75770 */ // Label 1667: @75770
     /*  75770 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(75823), // Rule ID 22509 //
     /*  75775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75785 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75789 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75793 */   // MIs[1] Operand 1
     /*  75793 */   // No operand predicates
     /*  75793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75799 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75806 */   // (atomic_store (imm:{ *:[i32] }):$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mi addr:{ *:[iPTR] }:$dst, (imm:{ *:[i32] }):$src)
     /*  75806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mi),
     /*  75809 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75813 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  75816 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75821 */   GIR_RootConstrainSelectedInstOperands,
     /*  75822 */   // GIR_Coverage, 22509,
     /*  75822 */   GIR_EraseRootFromParent_Done,
     /*  75823 */ // Label 1668: @75823
     /*  75823 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(75886), // Rule ID 52 //
     /*  75828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  75831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75859 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75868 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr),
     /*  75871 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75875 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75879 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75884 */   GIR_RootConstrainSelectedInstOperands,
     /*  75885 */   // GIR_Coverage, 52,
     /*  75885 */   GIR_EraseRootFromParent_Done,
     /*  75886 */ // Label 1669: @75886
     /*  75886 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(75949), // Rule ID 58 //
     /*  75891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  75894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  75897 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  75901 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  75905 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  75909 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  75913 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75918 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75922 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75924 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75931 */   // (st (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE32mr_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src1)
     /*  75931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32mr_EVEX),
     /*  75934 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75938 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  75942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  75947 */   GIR_RootConstrainSelectedInstOperands,
     /*  75948 */   // GIR_Coverage, 58,
     /*  75948 */   GIR_EraseRootFromParent_Done,
     /*  75949 */ // Label 1670: @75949
     /*  75949 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(75994), // Rule ID 22513 //
     /*  75954 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  75957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  75964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  75968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  75972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  75979 */   // (atomic_store GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_32>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  75979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  75982 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  75986 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  75988 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  75992 */   GIR_RootConstrainSelectedInstOperands,
     /*  75993 */   // GIR_Coverage, 22513,
     /*  75993 */   GIR_EraseRootFromParent_Done,
     /*  75994 */ // Label 1671: @75994
     /*  75994 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(76036), // Rule ID 34 //
     /*  75999 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  76010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76021 */   // (st GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV32mr addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /*  76021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32mr),
     /*  76024 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76028 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76034 */   GIR_RootConstrainSelectedInstOperands,
     /*  76035 */   // GIR_Coverage, 34,
     /*  76035 */   GIR_EraseRootFromParent_Done,
     /*  76036 */ // Label 1672: @76036
     /*  76036 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(76084), // Rule ID 1095 //
     /*  76041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /*  76044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76047 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /*  76055 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76059 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76066 */   // (st RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp32m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /*  76066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp32m),
     /*  76069 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  76073 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76075 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  76078 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76082 */   GIR_RootConstrainSelectedInstOperands,
     /*  76083 */   // GIR_Coverage, 1095,
     /*  76083 */   GIR_EraseRootFromParent_Done,
     /*  76084 */ // Label 1673: @76084
     /*  76084 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(76129), // Rule ID 1688 //
     /*  76089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  76092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76103 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76107 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76114 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSmr),
     /*  76117 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76121 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76123 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76127 */   GIR_RootConstrainSelectedInstOperands,
     /*  76128 */   // GIR_Coverage, 1688,
     /*  76128 */   GIR_EraseRootFromParent_Done,
     /*  76129 */ // Label 1674: @76129
     /*  76129 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(76174), // Rule ID 1690 //
     /*  76134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  76137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /*  76148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76159 */   // (st FR32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSSmr addr:{ *:[iPTR] }:$dst, FR32:{ *:[f32] }:$src)
     /*  76159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSSmr),
     /*  76162 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76166 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76172 */   GIR_RootConstrainSelectedInstOperands,
     /*  76173 */   // GIR_Coverage, 1690,
     /*  76173 */   GIR_EraseRootFromParent_Done,
     /*  76174 */ // Label 1675: @76174
     /*  76174 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(76219), // Rule ID 4610 //
     /*  76179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  76182 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76185 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /*  76193 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  76197 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76204 */   // (st FR32X:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSSZmr addr:{ *:[iPTR] }:$dst, FR32X:{ *:[f32] }:$src)
     /*  76204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSSZmr),
     /*  76207 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76211 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  76213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  76217 */   GIR_RootConstrainSelectedInstOperands,
     /*  76218 */   // GIR_Coverage, 4610,
     /*  76218 */   GIR_EraseRootFromParent_Done,
     /*  76219 */ // Label 1676: @76219
     /*  76219 */ GIM_Reject,
     /*  76220 */ // Label 1479: @76220
     /*  76220 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(76316), // Rule ID 22494 //
     /*  76225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76228 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76231 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76246 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76250 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76254 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76258 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76262 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76265 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76269 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76276 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76280 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76284 */   // MIs[0] dst
     /*  76284 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76289 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76291 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76298 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76301 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76305 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76308 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76314 */   GIR_RootConstrainSelectedInstOperands,
     /*  76315 */   // GIR_Coverage, 22494,
     /*  76315 */   GIR_EraseRootFromParent_Done,
     /*  76316 */ // Label 1677: @76316
     /*  76316 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(76412), // Rule ID 22498 //
     /*  76321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseIncDec),
     /*  76324 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76327 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76342 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76350 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76354 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76358 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76361 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76365 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76372 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76376 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76380 */   // MIs[0] dst
     /*  76380 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76385 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76387 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76394 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76397 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76401 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76410 */   GIR_RootConstrainSelectedInstOperands,
     /*  76411 */   // GIR_Coverage, 22498,
     /*  76411 */   GIR_EraseRootFromParent_Done,
     /*  76412 */ // Label 1678: @76412
     /*  76412 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(76505), // Rule ID 22502 //
     /*  76417 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76420 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76427 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76431 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  76435 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76439 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76443 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  76447 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76451 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76455 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76462 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76469 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76473 */   // MIs[0] dst
     /*  76473 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76478 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76480 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76487 */   // (atomic_store (sub:{ *:[i64] } 0:{ *:[i64] }, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  76487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  76490 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76494 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76503 */   GIR_RootConstrainSelectedInstOperands,
     /*  76504 */   // GIR_Coverage, 22502,
     /*  76504 */   GIR_EraseRootFromParent_Done,
     /*  76505 */ // Label 1679: @76505
     /*  76505 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(76595), // Rule ID 22506 //
     /*  76510 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76536 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76540 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76544 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  76547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76551 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  76558 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76562 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76566 */   // MIs[0] dst
     /*  76566 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76571 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76573 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76580 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (NOT64m addr:{ *:[iPTR] }:$dst)
     /*  76580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  76583 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76587 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76593 */   GIR_RootConstrainSelectedInstOperands,
     /*  76594 */   // GIR_Coverage, 22506,
     /*  76594 */   GIR_EraseRootFromParent_Done,
     /*  76595 */ // Label 1680: @76595
     /*  76595 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(76681), // Rule ID 231 //
     /*  76600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76606 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76610 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76614 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76618 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76622 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76626 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76630 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76634 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76641 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76645 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*  76649 */   // MIs[0] src1
     /*  76649 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76654 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76656 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76663 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (INC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INC64m),
     /*  76666 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76670 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76673 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76679 */   GIR_RootConstrainSelectedInstOperands,
     /*  76680 */   // GIR_Coverage, 231,
     /*  76680 */   GIR_EraseRootFromParent_Done,
     /*  76681 */ // Label 1681: @76681
     /*  76681 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(76767), // Rule ID 232 //
     /*  76686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseIncDec),
     /*  76689 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76692 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76696 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76700 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76704 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76708 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76712 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76716 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76720 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76723 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76727 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76731 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  76735 */   // MIs[0] src1
     /*  76735 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76740 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76742 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76749 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (DEC64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  76749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DEC64m),
     /*  76752 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  76756 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76759 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76765 */   GIR_RootConstrainSelectedInstOperands,
     /*  76766 */   // GIR_Coverage, 232,
     /*  76766 */   GIR_EraseRootFromParent_Done,
     /*  76767 */ // Label 1682: @76767
     /*  76767 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(76860), // Rule ID 22616 //
     /*  76772 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76775 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76779 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76783 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76787 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76791 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76795 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76799 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76803 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76806 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76810 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76814 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(128),
     /*  76825 */   // MIs[0] dst
     /*  76825 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76830 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76832 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76839 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 128:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -128:{ *:[i64] })
     /*  76839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76842 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-128),
     /*  76849 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76858 */   GIR_RootConstrainSelectedInstOperands,
     /*  76859 */   // GIR_Coverage, 22616,
     /*  76859 */   GIR_EraseRootFromParent_Done,
     /*  76860 */ // Label 1683: @76860
     /*  76860 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(76960), // Rule ID 22624 //
     /*  76865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76868 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76872 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  76880 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  76888 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76892 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76896 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76899 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  76903 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  76907 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2147483648),
     /*  76918 */   // MIs[0] dst
     /*  76918 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76923 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  76925 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  76932 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 2147483648:{ *:[i64] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, -2147483648:{ *:[i64] })
     /*  76932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  76935 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  76939 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(-2147483648),
     /*  76949 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  76952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  76958 */   GIR_RootConstrainSelectedInstOperands,
     /*  76959 */   // GIR_Coverage, 22624,
     /*  76959 */   GIR_EraseRootFromParent_Done,
     /*  76960 */ // Label 1684: @76960
     /*  76960 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(77046), // Rule ID 17615 //
     /*  76965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  76968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  76971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  76975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  76979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  76983 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  76987 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  76991 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76995 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  76999 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77006 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77010 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  77014 */   // MIs[0] dst
     /*  77014 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77019 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77021 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77028 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1),
     /*  77031 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77035 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77044 */   GIR_RootConstrainSelectedInstOperands,
     /*  77045 */   // GIR_Coverage, 17615,
     /*  77045 */   GIR_EraseRootFromParent_Done,
     /*  77046 */ // Label 1685: @77046
     /*  77046 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(77132), // Rule ID 17619 //
     /*  77051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77054 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  77069 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77073 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  77077 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77081 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77085 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77092 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77096 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 63,
     /*  77100 */   // MIs[0] dst
     /*  77100 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77105 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77107 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77114 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] }), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64m1:{ *:[i32] } addr:{ *:[iPTR] }:$dst)
     /*  77114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1),
     /*  77117 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77121 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77124 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77130 */   GIR_RootConstrainSelectedInstOperands,
     /*  77131 */   // GIR_Coverage, 17619,
     /*  77131 */   GIR_EraseRootFromParent_Done,
     /*  77132 */ // Label 1686: @77132
     /*  77132 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(77218), // Rule ID 264 //
     /*  77137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77140 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77143 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77155 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77159 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77163 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  77167 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77171 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77175 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77178 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77182 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77186 */   // MIs[0] src1
     /*  77186 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77191 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77193 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77200 */   // (st (sub:{ *:[i64] } 0:{ *:[i64] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NEG64m:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  77200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NEG64m),
     /*  77203 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77207 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77216 */   GIR_RootConstrainSelectedInstOperands,
     /*  77217 */   // GIR_Coverage, 264,
     /*  77217 */   GIR_EraseRootFromParent_Done,
     /*  77218 */ // Label 1687: @77218
     /*  77218 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(77301), // Rule ID 272 //
     /*  77223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  77226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77229 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77233 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77237 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77241 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77245 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77249 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77253 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77257 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77264 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77268 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  77272 */   // MIs[0] src1
     /*  77272 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77277 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  77279 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77286 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, -1:{ *:[i64] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (NOT64m addr:{ *:[iPTR] }:$src1)
     /*  77286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::NOT64m),
     /*  77289 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  77299 */   GIR_RootConstrainSelectedInstOperands,
     /*  77300 */   // GIR_Coverage, 272,
     /*  77300 */   GIR_EraseRootFromParent_Done,
     /*  77301 */ // Label 1688: @77301
     /*  77301 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(77406), // Rule ID 22430 //
     /*  77306 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77309 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  77324 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77328 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77332 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77336 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77340 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77343 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77347 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77354 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77358 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77362 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77366 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77370 */   // MIs[3] Operand 1
     /*  77370 */   // No operand predicates
     /*  77370 */   // MIs[0] dst
     /*  77370 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77375 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77377 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77384 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mi32),
     /*  77387 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77391 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77394 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77404 */   GIR_RootConstrainSelectedInstOperands,
     /*  77405 */   // GIR_Coverage, 22430,
     /*  77405 */   GIR_EraseRootFromParent_Done,
     /*  77406 */ // Label 1689: @77406
     /*  77406 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(77511), // Rule ID 22438 //
     /*  77411 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77429 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77433 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77437 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77441 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77445 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77452 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77459 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77463 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77467 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77471 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77475 */   // MIs[3] Operand 1
     /*  77475 */   // No operand predicates
     /*  77475 */   // MIs[0] dst
     /*  77475 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77480 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77482 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77489 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mi32),
     /*  77492 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77496 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77499 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77509 */   GIR_RootConstrainSelectedInstOperands,
     /*  77510 */   // GIR_Coverage, 22438,
     /*  77510 */   GIR_EraseRootFromParent_Done,
     /*  77511 */ // Label 1690: @77511
     /*  77511 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(77616), // Rule ID 22446 //
     /*  77516 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77526 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77530 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77534 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77538 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77542 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77546 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77550 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77557 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77564 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77568 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77572 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77576 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77580 */   // MIs[3] Operand 1
     /*  77580 */   // No operand predicates
     /*  77580 */   // MIs[0] dst
     /*  77580 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77585 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77587 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77594 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mi32),
     /*  77597 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77601 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77604 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77614 */   GIR_RootConstrainSelectedInstOperands,
     /*  77615 */   // GIR_Coverage, 22446,
     /*  77615 */   GIR_EraseRootFromParent_Done,
     /*  77616 */ // Label 1691: @77616
     /*  77616 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(77721), // Rule ID 22462 //
     /*  77621 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  77639 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77643 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77647 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77651 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77655 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77658 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77662 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77669 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77673 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77677 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77681 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77685 */   // MIs[3] Operand 1
     /*  77685 */   // No operand predicates
     /*  77685 */   // MIs[0] dst
     /*  77685 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77690 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77692 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77699 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mi32),
     /*  77702 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77706 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77709 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77712 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77719 */   GIR_RootConstrainSelectedInstOperands,
     /*  77720 */   // GIR_Coverage, 22462,
     /*  77720 */   GIR_EraseRootFromParent_Done,
     /*  77721 */ // Label 1692: @77721
     /*  77721 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(77826), // Rule ID 22454 //
     /*  77726 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77736 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77744 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77748 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77752 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77756 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77760 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  77763 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77767 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  77774 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77778 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77782 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77786 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  77790 */   // MIs[3] Operand 1
     /*  77790 */   // No operand predicates
     /*  77790 */   // MIs[0] dst
     /*  77790 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77795 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77797 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77804 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mi32:{ *:[i32] } addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  77804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mi32),
     /*  77807 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  77811 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src
     /*  77814 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77817 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77824 */   GIR_RootConstrainSelectedInstOperands,
     /*  77825 */   // GIR_Coverage, 22454,
     /*  77825 */   GIR_EraseRootFromParent_Done,
     /*  77826 */ // Label 1693: @77826
     /*  77826 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(77930), // Rule ID 835 //
     /*  77831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  77846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77854 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77858 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77862 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77866 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77873 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77877 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77882 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77886 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77890 */   // MIs[3] Operand 1
     /*  77890 */   // No operand predicates
     /*  77890 */   // MIs[0] src1
     /*  77890 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77895 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77897 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  77904 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  77904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8),
     /*  77907 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  77911 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  77915 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  77918 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  77921 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  77928 */   GIR_RootConstrainSelectedInstOperands,
     /*  77929 */   // GIR_Coverage, 835,
     /*  77929 */   GIR_EraseRootFromParent_Done,
     /*  77930 */ // Label 1694: @77930
     /*  77930 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(78034), // Rule ID 859 //
     /*  77935 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  77942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  77946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  77950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  77954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  77958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  77962 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  77967 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77971 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  77975 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  77978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  77982 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  77986 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77990 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  77994 */   // MIs[3] Operand 1
     /*  77994 */   // No operand predicates
     /*  77994 */   // MIs[0] src1
     /*  77994 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77999 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78001 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78008 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mri8:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /*  78008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8),
     /*  78011 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78015 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  78019 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src3
     /*  78022 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78025 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78032 */   GIR_RootConstrainSelectedInstOperands,
     /*  78033 */   // GIR_Coverage, 859,
     /*  78033 */   GIR_EraseRootFromParent_Done,
     /*  78034 */ // Label 1695: @78034
     /*  78034 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(78128), // Rule ID 736 //
     /*  78039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78042 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78045 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78049 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78053 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  78057 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78061 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78065 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78069 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78073 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78076 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78080 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78084 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78088 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78092 */   // MIs[3] Operand 1
     /*  78092 */   // No operand predicates
     /*  78092 */   // MIs[0] src1
     /*  78092 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78097 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78099 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78106 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi),
     /*  78109 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78113 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78116 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78119 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78126 */   GIR_RootConstrainSelectedInstOperands,
     /*  78127 */   // GIR_Coverage, 736,
     /*  78127 */   GIR_EraseRootFromParent_Done,
     /*  78128 */ // Label 1696: @78128
     /*  78128 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(78222), // Rule ID 704 //
     /*  78133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78136 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78139 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  78151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78159 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78163 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78167 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78174 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78178 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78182 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78186 */   // MIs[3] Operand 1
     /*  78186 */   // No operand predicates
     /*  78186 */   // MIs[0] src1
     /*  78186 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78191 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78193 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78200 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi),
     /*  78203 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78207 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78210 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78213 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78220 */   GIR_RootConstrainSelectedInstOperands,
     /*  78221 */   // GIR_Coverage, 704,
     /*  78221 */   GIR_EraseRootFromParent_Done,
     /*  78222 */ // Label 1697: @78222
     /*  78222 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(78316), // Rule ID 768 //
     /*  78227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78230 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78233 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  78245 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78253 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78257 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78261 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78268 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78272 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78276 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78280 */   // MIs[3] Operand 1
     /*  78280 */   // No operand predicates
     /*  78280 */   // MIs[0] src1
     /*  78280 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78285 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78287 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78294 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi),
     /*  78297 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78301 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78304 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78307 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78314 */   GIR_RootConstrainSelectedInstOperands,
     /*  78315 */   // GIR_Coverage, 768,
     /*  78315 */   GIR_EraseRootFromParent_Done,
     /*  78316 */ // Label 1698: @78316
     /*  78316 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(78410), // Rule ID 800 //
     /*  78321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78324 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78327 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  78339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78343 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78347 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78351 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78355 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78358 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78362 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78366 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78370 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78374 */   // MIs[3] Operand 1
     /*  78374 */   // No operand predicates
     /*  78374 */   // MIs[0] src1
     /*  78374 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78379 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78381 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78388 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi),
     /*  78391 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78395 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78398 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78401 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78408 */   GIR_RootConstrainSelectedInstOperands,
     /*  78409 */   // GIR_Coverage, 800,
     /*  78409 */   GIR_EraseRootFromParent_Done,
     /*  78410 */ // Label 1699: @78410
     /*  78410 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(78504), // Rule ID 672 //
     /*  78415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  78418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  78425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  78433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  78441 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78445 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78449 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  78452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78456 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78460 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  78464 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  78468 */   // MIs[3] Operand 1
     /*  78468 */   // No operand predicates
     /*  78468 */   // MIs[0] src1
     /*  78468 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78473 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78475 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78482 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mi:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /*  78482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi),
     /*  78485 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  78489 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // src2
     /*  78492 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  78502 */   GIR_RootConstrainSelectedInstOperands,
     /*  78503 */   // GIR_Coverage, 672,
     /*  78503 */   GIR_EraseRootFromParent_Done,
     /*  78504 */ // Label 1700: @78504
     /*  78504 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(78602), // Rule ID 22434 //
     /*  78509 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78512 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78519 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78523 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78527 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78531 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78535 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78539 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78543 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78546 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78550 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78557 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78566 */   // MIs[0] dst
     /*  78566 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78571 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78573 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78580 */   // (atomic_store (add:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78583 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78587 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78591 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78594 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78600 */   GIR_RootConstrainSelectedInstOperands,
     /*  78601 */   // GIR_Coverage, 22434,
     /*  78601 */   GIR_EraseRootFromParent_Done,
     /*  78602 */ // Label 1701: @78602
     /*  78602 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(78700), // Rule ID 26005 //
     /*  78607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  78625 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78629 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78633 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78638 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78642 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78646 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78653 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78660 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78664 */   // MIs[0] dst
     /*  78664 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78669 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78671 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78678 */   // (atomic_store (add:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  78681 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78689 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78692 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78698 */   GIR_RootConstrainSelectedInstOperands,
     /*  78699 */   // GIR_Coverage, 26005,
     /*  78699 */   GIR_EraseRootFromParent_Done,
     /*  78700 */ // Label 1702: @78700
     /*  78700 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(78798), // Rule ID 22442 //
     /*  78705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78723 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78731 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78735 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78739 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78746 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78753 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78762 */   // MIs[0] dst
     /*  78762 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78767 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78769 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78776 */   // (atomic_store (and:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78779 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78787 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78790 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78796 */   GIR_RootConstrainSelectedInstOperands,
     /*  78797 */   // GIR_Coverage, 22442,
     /*  78797 */   GIR_EraseRootFromParent_Done,
     /*  78798 */ // Label 1703: @78798
     /*  78798 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(78896), // Rule ID 26009 //
     /*  78803 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78806 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78829 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78834 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78838 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78842 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78845 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78849 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78856 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78860 */   // MIs[0] dst
     /*  78860 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78867 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78874 */   // (atomic_store (and:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  78877 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78881 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  78885 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78894 */   GIR_RootConstrainSelectedInstOperands,
     /*  78895 */   // GIR_Coverage, 26009,
     /*  78895 */   GIR_EraseRootFromParent_Done,
     /*  78896 */ // Label 1704: @78896
     /*  78896 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(78994), // Rule ID 22450 //
     /*  78901 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78911 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  78915 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  78919 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  78923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  78927 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78931 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  78935 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  78938 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  78942 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  78949 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  78953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  78958 */   // MIs[0] dst
     /*  78958 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78963 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78965 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  78972 */   // (atomic_store (or:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  78972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  78975 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  78979 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  78983 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  78986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  78992 */   GIR_RootConstrainSelectedInstOperands,
     /*  78993 */   // GIR_Coverage, 22450,
     /*  78993 */   GIR_EraseRootFromParent_Done,
     /*  78994 */ // Label 1705: @78994
     /*  78994 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(79092), // Rule ID 26013 //
     /*  78999 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79009 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79013 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  79017 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79021 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79025 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79030 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79034 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79038 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79045 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79052 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79056 */   // MIs[0] dst
     /*  79056 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79061 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79063 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79070 */   // (atomic_store (or:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  79073 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79077 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79081 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79090 */   GIR_RootConstrainSelectedInstOperands,
     /*  79091 */   // GIR_Coverage, 26013,
     /*  79091 */   GIR_EraseRootFromParent_Done,
     /*  79092 */ // Label 1706: @79092
     /*  79092 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(79190), // Rule ID 22466 //
     /*  79097 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79100 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  79115 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79119 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79123 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79127 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79131 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79134 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79138 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79145 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79154 */   // MIs[0] dst
     /*  79154 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79159 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79161 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79168 */   // (atomic_store (sub:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  79171 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79175 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79179 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79188 */   GIR_RootConstrainSelectedInstOperands,
     /*  79189 */   // GIR_Coverage, 22466,
     /*  79189 */   GIR_EraseRootFromParent_Done,
     /*  79190 */ // Label 1707: @79190
     /*  79190 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(79288), // Rule ID 22458 //
     /*  79195 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79198 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79213 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79217 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79221 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79225 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79232 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79236 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79243 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79247 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79252 */   // MIs[0] dst
     /*  79252 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79257 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79259 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79266 */   // (atomic_store (xor:{ *:[i64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>, GR64:{ *:[i64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79269 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79273 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src
     /*  79277 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79280 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79286 */   GIR_RootConstrainSelectedInstOperands,
     /*  79287 */   // GIR_Coverage, 22458,
     /*  79287 */   GIR_EraseRootFromParent_Done,
     /*  79288 */ // Label 1708: @79288
     /*  79288 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(79386), // Rule ID 26017 //
     /*  79293 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79311 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79315 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79319 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79324 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79328 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  79335 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79339 */   GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  79346 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79350 */   // MIs[0] dst
     /*  79350 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79355 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79357 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79364 */   // (atomic_store (xor:{ *:[i64] } GR64:{ *:[i64] }:$src, (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  79364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  79367 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  79371 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  79375 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79378 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79384 */   GIR_RootConstrainSelectedInstOperands,
     /*  79385 */   // GIR_Coverage, 26017,
     /*  79385 */   GIR_EraseRootFromParent_Done,
     /*  79386 */ // Label 1709: @79386
     /*  79386 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(79497), // Rule ID 838 //
     /*  79391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79394 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79398 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79402 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHL),
     /*  79406 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79410 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79414 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79418 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79422 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79426 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79429 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79433 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79447 */   // MIs[0] src1
     /*  79447 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79452 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79454 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79461 */   // (st (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHLD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79465 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79471 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL),
     /*  79478 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79482 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79486 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79495 */   GIR_RootConstrainSelectedInstOperands,
     /*  79496 */   // GIR_Coverage, 838,
     /*  79496 */   GIR_EraseRootFromParent_Done,
     /*  79497 */ // Label 1710: @79497
     /*  79497 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(79608), // Rule ID 862 //
     /*  79502 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79505 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79509 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSHR),
     /*  79517 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79521 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79525 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s8,
     /*  79529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79534 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79538 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79542 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79545 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79549 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  79558 */   // MIs[0] src1
     /*  79558 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79563 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79565 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79572 */   // (st (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHRD64mrCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79572 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79576 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79582 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // CL
     /*  79586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL),
     /*  79589 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79593 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79597 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79606 */   GIR_RootConstrainSelectedInstOperands,
     /*  79607 */   // GIR_Coverage, 862,
     /*  79607 */   GIR_EraseRootFromParent_Done,
     /*  79608 */ // Label 1711: @79608
     /*  79608 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(79696), // Rule ID 412 //
     /*  79613 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79620 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79624 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79628 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79632 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79636 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79640 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79644 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79651 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79655 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79660 */   // MIs[0] src1
     /*  79660 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79665 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79667 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79674 */   // (st (add:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79674 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79677 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79681 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79685 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79688 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79694 */   GIR_RootConstrainSelectedInstOperands,
     /*  79695 */   // GIR_Coverage, 412,
     /*  79695 */   GIR_EraseRootFromParent_Done,
     /*  79696 */ // Label 1712: @79696
     /*  79696 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(79784), // Rule ID 23225 //
     /*  79701 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79704 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  79716 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79720 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79724 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79729 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79733 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79737 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79740 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79744 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79748 */   // MIs[0] src1
     /*  79748 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79753 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79755 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79762 */   // (st (add:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ADD64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64mr),
     /*  79765 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79769 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79773 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79782 */   GIR_RootConstrainSelectedInstOperands,
     /*  79783 */   // GIR_Coverage, 23225,
     /*  79783 */   GIR_EraseRootFromParent_Done,
     /*  79784 */ // Label 1713: @79784
     /*  79784 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(79872), // Rule ID 304 //
     /*  79789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79804 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79808 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79812 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79816 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79820 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79823 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79827 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79831 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79836 */   // MIs[0] src1
     /*  79836 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79841 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79843 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79850 */   // (st (and:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79853 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79857 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  79861 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79870 */   GIR_RootConstrainSelectedInstOperands,
     /*  79871 */   // GIR_Coverage, 304,
     /*  79871 */   GIR_EraseRootFromParent_Done,
     /*  79872 */ // Label 1714: @79872
     /*  79872 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(79960), // Rule ID 23189 //
     /*  79877 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79880 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79892 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79896 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  79900 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  79905 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79909 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79913 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  79920 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  79924 */   // MIs[0] src1
     /*  79924 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79929 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79931 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  79938 */   // (st (and:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (AND64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  79938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AND64mr),
     /*  79941 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  79945 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  79949 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  79952 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  79958 */   GIR_RootConstrainSelectedInstOperands,
     /*  79959 */   // GIR_Coverage, 23189,
     /*  79959 */   GIR_EraseRootFromParent_Done,
     /*  79960 */ // Label 1715: @79960
     /*  79960 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(80061), // Rule ID 752 //
     /*  79965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  79968 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  79971 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  79975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  79979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  79983 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  79987 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  79991 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79995 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  79999 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80006 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80010 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80015 */   // MIs[0] src1
     /*  80015 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80020 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80022 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80029 */   // (st (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SAR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80033 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL),
     /*  80046 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80050 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80053 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80059 */   GIR_RootConstrainSelectedInstOperands,
     /*  80060 */   // GIR_Coverage, 752,
     /*  80060 */   GIR_EraseRootFromParent_Done,
     /*  80061 */ // Label 1716: @80061
     /*  80061 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(80162), // Rule ID 720 //
     /*  80066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80069 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  80084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80088 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80092 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80096 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80100 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80103 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80107 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80111 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80116 */   // MIs[0] src1
     /*  80116 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80121 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80123 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80130 */   // (st (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80134 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80140 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL),
     /*  80147 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80151 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80154 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80160 */   GIR_RootConstrainSelectedInstOperands,
     /*  80161 */   // GIR_Coverage, 720,
     /*  80161 */   GIR_EraseRootFromParent_Done,
     /*  80162 */ // Label 1717: @80162
     /*  80162 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(80250), // Rule ID 340 //
     /*  80167 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80170 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80174 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80178 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80182 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80186 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80190 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80194 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80198 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80201 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80205 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80209 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80214 */   // MIs[0] src1
     /*  80214 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80219 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80221 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80228 */   // (st (or:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80231 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80235 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80239 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80242 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80248 */   GIR_RootConstrainSelectedInstOperands,
     /*  80249 */   // GIR_Coverage, 340,
     /*  80249 */   GIR_EraseRootFromParent_Done,
     /*  80250 */ // Label 1718: @80250
     /*  80250 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(80338), // Rule ID 23201 //
     /*  80255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80270 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80274 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80278 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80283 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80287 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80291 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80294 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80298 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80302 */   // MIs[0] src1
     /*  80302 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80307 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80309 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80316 */   // (st (or:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (OR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::OR64mr),
     /*  80319 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80327 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80336 */   GIR_RootConstrainSelectedInstOperands,
     /*  80337 */   // GIR_Coverage, 23201,
     /*  80337 */   GIR_EraseRootFromParent_Done,
     /*  80338 */ // Label 1719: @80338
     /*  80338 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(80439), // Rule ID 784 //
     /*  80343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80349 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80353 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80357 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  80361 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80365 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80369 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80373 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80377 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80380 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80384 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80388 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80393 */   // MIs[0] src1
     /*  80393 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80398 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80400 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80407 */   // (st (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80407 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80411 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80417 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL),
     /*  80424 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80428 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80437 */   GIR_RootConstrainSelectedInstOperands,
     /*  80438 */   // GIR_Coverage, 784,
     /*  80438 */   GIR_EraseRootFromParent_Done,
     /*  80439 */ // Label 1720: @80439
     /*  80439 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(80540), // Rule ID 816 //
     /*  80444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*  80462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80470 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80474 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80478 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80481 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80485 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80489 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80494 */   // MIs[0] src1
     /*  80494 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80499 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80501 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80508 */   // (st (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ROR64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80512 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL),
     /*  80525 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80529 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80538 */   GIR_RootConstrainSelectedInstOperands,
     /*  80539 */   // GIR_Coverage, 816,
     /*  80539 */   GIR_EraseRootFromParent_Done,
     /*  80540 */ // Label 1721: @80540
     /*  80540 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(80641), // Rule ID 688 //
     /*  80545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  80548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  80563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80567 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s8,
     /*  80571 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80575 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80579 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80586 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80590 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /*  80595 */   // MIs[0] src1
     /*  80595 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80600 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80602 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80609 */   // (st (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] }), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SHL64mCL:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /*  80609 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80613 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80619 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // CL
     /*  80623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL),
     /*  80626 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80630 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80633 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80639 */   GIR_RootConstrainSelectedInstOperands,
     /*  80640 */   // GIR_Coverage, 688,
     /*  80640 */   GIR_EraseRootFromParent_Done,
     /*  80641 */ // Label 1722: @80641
     /*  80641 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(80729), // Rule ID 448 //
     /*  80646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80653 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80657 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80661 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80665 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80669 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80673 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80677 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80680 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80684 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80688 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80693 */   // MIs[0] src1
     /*  80693 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80698 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80700 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80707 */   // (st (sub:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SUB64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB64mr),
     /*  80710 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80714 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80718 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80727 */   GIR_RootConstrainSelectedInstOperands,
     /*  80728 */   // GIR_Coverage, 448,
     /*  80728 */   GIR_EraseRootFromParent_Done,
     /*  80729 */ // Label 1723: @80729
     /*  80729 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(80817), // Rule ID 376 //
     /*  80734 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80737 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80741 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80745 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80749 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80753 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80757 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80761 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80765 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80768 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80772 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80781 */   // MIs[0] src1
     /*  80781 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80786 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80788 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80795 */   // (st (xor:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80798 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80802 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /*  80806 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80809 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80815 */   GIR_RootConstrainSelectedInstOperands,
     /*  80816 */   // GIR_Coverage, 376,
     /*  80816 */   GIR_EraseRootFromParent_Done,
     /*  80817 */ // Label 1724: @80817
     /*  80817 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(80905), // Rule ID 23213 //
     /*  80822 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80825 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  80829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80837 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80841 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  80845 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  80850 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  80854 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  80858 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  80861 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /*  80865 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /*  80869 */   // MIs[0] src1
     /*  80869 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80874 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  80876 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80883 */   // (st (xor:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>), addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (XOR64mr:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  80883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XOR64mr),
     /*  80886 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  80890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  80894 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  80897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /*  80903 */   GIR_RootConstrainSelectedInstOperands,
     /*  80904 */   // GIR_Coverage, 23213,
     /*  80904 */   GIR_EraseRootFromParent_Done,
     /*  80905 */ // Label 1725: @80905
     /*  80905 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(80962), // Rule ID 22510 //
     /*  80910 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80920 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80924 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  80928 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /*  80932 */   // MIs[1] Operand 1
     /*  80932 */   // No operand predicates
     /*  80932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  80936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  80945 */   // (atomic_store (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mi32 addr:{ *:[iPTR] }:$dst, (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src)
     /*  80945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mi32),
     /*  80948 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  80952 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src
     /*  80955 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  80960 */   GIR_RootConstrainSelectedInstOperands,
     /*  80961 */   // GIR_Coverage, 22510,
     /*  80961 */   GIR_EraseRootFromParent_Done,
     /*  80962 */ // Label 1726: @80962
     /*  80962 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(81028), // Rule ID 22522 //
     /*  80967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  80970 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  80973 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  80980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  80984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  80988 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  80992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  80997 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81001 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81010 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81013 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81017 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81026 */   GIR_RootConstrainSelectedInstOperands,
     /*  81027 */   // GIR_Coverage, 22522,
     /*  81027 */   GIR_EraseRootFromParent_Done,
     /*  81028 */ // Label 1727: @81028
     /*  81028 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(81094), // Rule ID 22523 //
     /*  81033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81036 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81039 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81054 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81058 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81069 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81076 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81079 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81083 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81092 */   GIR_RootConstrainSelectedInstOperands,
     /*  81093 */   // GIR_Coverage, 22523,
     /*  81093 */   GIR_EraseRootFromParent_Done,
     /*  81094 */ // Label 1728: @81094
     /*  81094 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(81160), // Rule ID 22524 //
     /*  81099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81112 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81116 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  81120 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81129 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81142 */   // (atomic_store (bitconvert:{ *:[i64] } FR64:{ *:[f64] }:$src), addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81145 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81149 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /*  81153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81158 */   GIR_RootConstrainSelectedInstOperands,
     /*  81159 */   // GIR_Coverage, 22524,
     /*  81159 */   GIR_EraseRootFromParent_Done,
     /*  81160 */ // Label 1729: @81160
     /*  81160 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(81223), // Rule ID 54 //
     /*  81165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /*  81168 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81171 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81175 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81179 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81183 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81187 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81198 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81205 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr),
     /*  81208 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81212 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81216 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81221 */   GIR_RootConstrainSelectedInstOperands,
     /*  81222 */   // GIR_Coverage, 54,
     /*  81222 */   GIR_EraseRootFromParent_Done,
     /*  81223 */ // Label 1730: @81223
     /*  81223 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(81286), // Rule ID 60 //
     /*  81228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /*  81231 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81234 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  81242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /*  81246 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  81250 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81255 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81268 */   // (st (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1), addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVBE64mr_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src1)
     /*  81268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64mr_EVEX),
     /*  81271 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81275 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  81279 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  81284 */   GIR_RootConstrainSelectedInstOperands,
     /*  81285 */   // GIR_Coverage, 60,
     /*  81285 */   GIR_EraseRootFromParent_Done,
     /*  81286 */ // Label 1731: @81286
     /*  81286 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(81331), // Rule ID 22514 //
     /*  81291 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  81294 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81305 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81309 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81316 */   // (atomic_store GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_atomic_store_64>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81319 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81323 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81325 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81329 */   GIR_RootConstrainSelectedInstOperands,
     /*  81330 */   // GIR_Coverage, 22514,
     /*  81330 */   GIR_EraseRootFromParent_Done,
     /*  81331 */ // Label 1732: @81331
     /*  81331 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(81373), // Rule ID 35 //
     /*  81336 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81339 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  81347 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81358 */   // (st GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOV64mr addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /*  81358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64mr),
     /*  81361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81365 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81371 */   GIR_RootConstrainSelectedInstOperands,
     /*  81372 */   // GIR_Coverage, 35,
     /*  81372 */   GIR_EraseRootFromParent_Done,
     /*  81373 */ // Label 1733: @81373
     /*  81373 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(81428), // Rule ID 1096 //
     /*  81378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81381 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81384 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81388 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81399 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81403 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81410 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m32),
     /*  81413 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81417 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81419 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81422 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81426 */   GIR_RootConstrainSelectedInstOperands,
     /*  81427 */   // GIR_Coverage, 1096,
     /*  81427 */   GIR_EraseRootFromParent_Done,
     /*  81428 */ // Label 1734: @81428
     /*  81428 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(81476), // Rule ID 1097 //
     /*  81433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /*  81436 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81439 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /*  81447 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81451 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81458 */   // (st RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_Fp64m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /*  81458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp64m),
     /*  81461 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81465 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81467 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81474 */   GIR_RootConstrainSelectedInstOperands,
     /*  81475 */   // GIR_Coverage, 1097,
     /*  81475 */   GIR_EraseRootFromParent_Done,
     /*  81476 */ // Label 1735: @81476
     /*  81476 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(81521), // Rule ID 1692 //
     /*  81481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /*  81484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81506 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDmr),
     /*  81509 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81513 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81515 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81519 */   GIR_RootConstrainSelectedInstOperands,
     /*  81520 */   // GIR_Coverage, 1692,
     /*  81520 */   GIR_EraseRootFromParent_Done,
     /*  81521 */ // Label 1736: @81521
     /*  81521 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(81566), // Rule ID 1694 //
     /*  81526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  81529 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81532 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /*  81540 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81544 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81551 */   // (st FR64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVSDmr addr:{ *:[iPTR] }:$dst, FR64:{ *:[f64] }:$src)
     /*  81551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSDmr),
     /*  81554 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81558 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81564 */   GIR_RootConstrainSelectedInstOperands,
     /*  81565 */   // GIR_Coverage, 1694,
     /*  81565 */   GIR_EraseRootFromParent_Done,
     /*  81566 */ // Label 1737: @81566
     /*  81566 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(81611), // Rule ID 4616 //
     /*  81571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  81574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /*  81585 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81589 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81596 */   // (st FR64X:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVSDZmr addr:{ *:[iPTR] }:$dst, FR64X:{ *:[f64] }:$src)
     /*  81596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVSDZmr),
     /*  81599 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81603 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81605 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81609 */   GIR_RootConstrainSelectedInstOperands,
     /*  81610 */   // GIR_Coverage, 4616,
     /*  81610 */   GIR_EraseRootFromParent_Done,
     /*  81611 */ // Label 1738: @81611
     /*  81611 */ GIM_Reject,
     /*  81612 */ // Label 1480: @81612
     /*  81612 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(81770),
     /*  81617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81620 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(81672), // Rule ID 1098 //
     /*  81625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81628 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81632 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  81639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81654 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref32>>  =>  (ST_Fp80m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m32),
     /*  81657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81661 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81670 */     GIR_RootConstrainSelectedInstOperands,
     /*  81671 */     // GIR_Coverage, 1098,
     /*  81671 */     GIR_EraseRootFromParent_Done,
     /*  81672 */   // Label 1740: @81672
     /*  81672 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(81724), // Rule ID 1099 //
     /*  81677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81680 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81684 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  81691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81706 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstoref64>>  =>  (ST_Fp80m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_Fp80m64),
     /*  81709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81713 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81722 */     GIR_RootConstrainSelectedInstOperands,
     /*  81723 */     // GIR_Coverage, 1099,
     /*  81723 */     GIR_EraseRootFromParent_Done,
     /*  81724 */   // Label 1741: @81724
     /*  81724 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(81769), // Rule ID 1100 //
     /*  81729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /*  81732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /*  81740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81751 */     // (st RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST_FpP80m:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /*  81751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ST_FpP80m),
     /*  81754 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /*  81758 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /*  81763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81767 */     GIR_RootConstrainSelectedInstOperands,
     /*  81768 */     // GIR_Coverage, 1100,
     /*  81768 */     GIR_EraseRootFromParent_Done,
     /*  81769 */   // Label 1742: @81769
     /*  81769 */   GIM_Reject,
     /*  81770 */ // Label 1739: @81770
     /*  81770 */ GIM_Reject,
     /*  81771 */ // Label 1481: @81771
     /*  81771 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(82024),
     /*  81776 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  81779 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  81783 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(81825), // Rule ID 23142 //
     /*  81788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81799 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81810 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  81813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81817 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81823 */     GIR_RootConstrainSelectedInstOperands,
     /*  81824 */     // GIR_Coverage, 23142,
     /*  81824 */     GIR_EraseRootFromParent_Done,
     /*  81825 */   // Label 1744: @81825
     /*  81825 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(81863), // Rule ID 23143 //
     /*  81830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoAVX),
     /*  81833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81848 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  81851 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81855 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81861 */     GIR_RootConstrainSelectedInstOperands,
     /*  81862 */     // GIR_Coverage, 23143,
     /*  81862 */     GIR_EraseRootFromParent_Done,
     /*  81863 */   // Label 1745: @81863
     /*  81863 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(81905), // Rule ID 23146 //
     /*  81868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81890 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  81893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81897 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81903 */     GIR_RootConstrainSelectedInstOperands,
     /*  81904 */     // GIR_Coverage, 23146,
     /*  81904 */     GIR_EraseRootFromParent_Done,
     /*  81905 */   // Label 1746: @81905
     /*  81905 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(81943), // Rule ID 23147 //
     /*  81910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  81913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  81917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81928 */     // (st VR128:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[f128] }:$src)
     /*  81928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  81931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81935 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81941 */     GIR_RootConstrainSelectedInstOperands,
     /*  81942 */     // GIR_Coverage, 23147,
     /*  81942 */     GIR_EraseRootFromParent_Done,
     /*  81943 */   // Label 1747: @81943
     /*  81943 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(81985), // Rule ID 23150 //
     /*  81948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  81959 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  81963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  81970 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  81970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  81973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  81977 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  81979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  81983 */     GIR_RootConstrainSelectedInstOperands,
     /*  81984 */     // GIR_Coverage, 23150,
     /*  81984 */     GIR_EraseRootFromParent_Done,
     /*  81985 */   // Label 1748: @81985
     /*  81985 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(82023), // Rule ID 23151 //
     /*  81990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  81993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  81997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82008 */     // (st VR128X:{ *:[f128] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[f128] }:$src)
     /*  82008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82015 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82021 */     GIR_RootConstrainSelectedInstOperands,
     /*  82022 */     // GIR_Coverage, 23151,
     /*  82022 */     GIR_EraseRootFromParent_Done,
     /*  82023 */   // Label 1749: @82023
     /*  82023 */   GIM_Reject,
     /*  82024 */ // Label 1743: @82024
     /*  82024 */ GIM_Reject,
     /*  82025 */ // Label 1482: @82025
     /*  82025 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(82518),
     /*  82030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82037 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(82079), // Rule ID 1716 //
     /*  82042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82064 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDmr),
     /*  82067 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82071 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82077 */     GIR_RootConstrainSelectedInstOperands,
     /*  82078 */     // GIR_Coverage, 1716,
     /*  82078 */     GIR_EraseRootFromParent_Done,
     /*  82079 */   // Label 1751: @82079
     /*  82079 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(82117), // Rule ID 1718 //
     /*  82084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82102 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDmr),
     /*  82105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82109 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82115 */     GIR_RootConstrainSelectedInstOperands,
     /*  82116 */     // GIR_Coverage, 1718,
     /*  82116 */     GIR_EraseRootFromParent_Done,
     /*  82117 */   // Label 1752: @82117
     /*  82117 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(82159), // Rule ID 1724 //
     /*  82122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82133 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82144 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPDmr),
     /*  82147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82151 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82157 */     GIR_RootConstrainSelectedInstOperands,
     /*  82158 */     // GIR_Coverage, 1724,
     /*  82158 */     GIR_EraseRootFromParent_Done,
     /*  82159 */   // Label 1753: @82159
     /*  82159 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(82197), // Rule ID 1726 //
     /*  82164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  82167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82182 */     // (st VR128:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2f64] }:$src)
     /*  82182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPDmr),
     /*  82185 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82189 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82195 */     GIR_RootConstrainSelectedInstOperands,
     /*  82196 */     // GIR_Coverage, 1726,
     /*  82196 */     GIR_EraseRootFromParent_Done,
     /*  82197 */   // Label 1754: @82197
     /*  82197 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(82239), // Rule ID 2520 //
     /*  82202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82209 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82224 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82231 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82237 */     GIR_RootConstrainSelectedInstOperands,
     /*  82238 */     // GIR_Coverage, 2520,
     /*  82238 */     GIR_EraseRootFromParent_Done,
     /*  82239 */   // Label 1755: @82239
     /*  82239 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(82277), // Rule ID 2521 //
     /*  82244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82262 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82269 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82275 */     GIR_RootConstrainSelectedInstOperands,
     /*  82276 */     // GIR_Coverage, 2521,
     /*  82276 */     GIR_EraseRootFromParent_Done,
     /*  82277 */   // Label 1756: @82277
     /*  82277 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(82319), // Rule ID 4496 //
     /*  82282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82293 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82304 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128mr),
     /*  82307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82311 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82317 */     GIR_RootConstrainSelectedInstOperands,
     /*  82318 */     // GIR_Coverage, 4496,
     /*  82318 */     GIR_EraseRootFromParent_Done,
     /*  82319 */   // Label 1757: @82319
     /*  82319 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(82357), // Rule ID 4520 //
     /*  82324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82331 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82342 */     // (st VR128X:{ *:[v2f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2f64] }:$src)
     /*  82342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ128mr),
     /*  82345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82349 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82355 */     GIR_RootConstrainSelectedInstOperands,
     /*  82356 */     // GIR_Coverage, 4520,
     /*  82356 */     GIR_EraseRootFromParent_Done,
     /*  82357 */   // Label 1758: @82357
     /*  82357 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(82399), // Rule ID 4550 //
     /*  82362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82373 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82384 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82387 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82391 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82397 */     GIR_RootConstrainSelectedInstOperands,
     /*  82398 */     // GIR_Coverage, 4550,
     /*  82398 */     GIR_EraseRootFromParent_Done,
     /*  82399 */   // Label 1759: @82399
     /*  82399 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(82437), // Rule ID 4592 //
     /*  82404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82422 */     // (st VR128X:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v2i64] }:$src)
     /*  82422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82429 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82435 */     GIR_RootConstrainSelectedInstOperands,
     /*  82436 */     // GIR_Coverage, 4592,
     /*  82436 */     GIR_EraseRootFromParent_Done,
     /*  82437 */   // Label 1760: @82437
     /*  82437 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(82479), // Rule ID 17947 //
     /*  82442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82453 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82464 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82471 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82477 */     GIR_RootConstrainSelectedInstOperands,
     /*  82478 */     // GIR_Coverage, 17947,
     /*  82478 */     GIR_EraseRootFromParent_Done,
     /*  82479 */   // Label 1761: @82479
     /*  82479 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(82517), // Rule ID 17951 //
     /*  82484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82502 */     // (st VR128:{ *:[v2i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src)
     /*  82502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82509 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82515 */     GIR_RootConstrainSelectedInstOperands,
     /*  82516 */     // GIR_Coverage, 17951,
     /*  82516 */     GIR_EraseRootFromParent_Done,
     /*  82517 */   // Label 1762: @82517
     /*  82517 */   GIM_Reject,
     /*  82518 */ // Label 1750: @82518
     /*  82518 */ GIM_Reject,
     /*  82519 */ // Label 1483: @82519
     /*  82519 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(83012),
     /*  82524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  82527 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  82531 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(82573), // Rule ID 1715 //
     /*  82536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82547 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82558 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  82561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82565 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82571 */     GIR_RootConstrainSelectedInstOperands,
     /*  82572 */     // GIR_Coverage, 1715,
     /*  82572 */     GIR_EraseRootFromParent_Done,
     /*  82573 */   // Label 1764: @82573
     /*  82573 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(82611), // Rule ID 1717 //
     /*  82578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82596 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  82599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82603 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82609 */     GIR_RootConstrainSelectedInstOperands,
     /*  82610 */     // GIR_Coverage, 1717,
     /*  82610 */     GIR_EraseRootFromParent_Done,
     /*  82611 */   // Label 1765: @82611
     /*  82611 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(82653), // Rule ID 1723 //
     /*  82616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82627 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82638 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82645 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82651 */     GIR_RootConstrainSelectedInstOperands,
     /*  82652 */     // GIR_Coverage, 1723,
     /*  82652 */     GIR_EraseRootFromParent_Done,
     /*  82653 */   // Label 1766: @82653
     /*  82653 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(82691), // Rule ID 1725 //
     /*  82658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82676 */     // (st VR128:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4f32] }:$src)
     /*  82676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82683 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82689 */     GIR_RootConstrainSelectedInstOperands,
     /*  82690 */     // GIR_Coverage, 1725,
     /*  82690 */     GIR_EraseRootFromParent_Done,
     /*  82691 */   // Label 1767: @82691
     /*  82691 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(82733), // Rule ID 4478 //
     /*  82696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82707 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82718 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  82721 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82725 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82731 */     GIR_RootConstrainSelectedInstOperands,
     /*  82732 */     // GIR_Coverage, 4478,
     /*  82732 */     GIR_EraseRootFromParent_Done,
     /*  82733 */   // Label 1768: @82733
     /*  82733 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(82771), // Rule ID 4508 //
     /*  82738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  82741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82756 */     // (st VR128X:{ *:[v4f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4f32] }:$src)
     /*  82756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  82759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82763 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82769 */     GIR_RootConstrainSelectedInstOperands,
     /*  82770 */     // GIR_Coverage, 4508,
     /*  82770 */     GIR_EraseRootFromParent_Done,
     /*  82771 */   // Label 1769: @82771
     /*  82771 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(82813), // Rule ID 17948 //
     /*  82776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82787 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82798 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  82801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82805 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82811 */     GIR_RootConstrainSelectedInstOperands,
     /*  82812 */     // GIR_Coverage, 17948,
     /*  82812 */     GIR_EraseRootFromParent_Done,
     /*  82813 */   // Label 1770: @82813
     /*  82813 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(82851), // Rule ID 17952 //
     /*  82818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  82821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82836 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  82839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82843 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82845 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82849 */     GIR_RootConstrainSelectedInstOperands,
     /*  82850 */     // GIR_Coverage, 17952,
     /*  82850 */     GIR_EraseRootFromParent_Done,
     /*  82851 */   // Label 1771: @82851
     /*  82851 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(82893), // Rule ID 18327 //
     /*  82856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82867 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82878 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  82881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82885 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82891 */     GIR_RootConstrainSelectedInstOperands,
     /*  82892 */     // GIR_Coverage, 18327,
     /*  82892 */     GIR_EraseRootFromParent_Done,
     /*  82893 */   // Label 1772: @82893
     /*  82893 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(82931), // Rule ID 18331 //
     /*  82898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  82901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  82905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82916 */     // (st VR128:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src)
     /*  82916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  82919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82923 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82925 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82929 */     GIR_RootConstrainSelectedInstOperands,
     /*  82930 */     // GIR_Coverage, 18331,
     /*  82930 */     GIR_EraseRootFromParent_Done,
     /*  82931 */   // Label 1773: @82931
     /*  82931 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(82973), // Rule ID 19820 //
     /*  82936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82947 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  82951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82958 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  82961 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  82965 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  82967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  82971 */     GIR_RootConstrainSelectedInstOperands,
     /*  82972 */     // GIR_Coverage, 19820,
     /*  82972 */     GIR_EraseRootFromParent_Done,
     /*  82973 */   // Label 1774: @82973
     /*  82973 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(83011), // Rule ID 19824 //
     /*  82978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  82981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  82985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  82989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  82996 */     // (st VR128X:{ *:[v4i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v4i32] }:$src)
     /*  82996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  82999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83003 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83009 */     GIR_RootConstrainSelectedInstOperands,
     /*  83010 */     // GIR_Coverage, 19824,
     /*  83010 */     GIR_EraseRootFromParent_Done,
     /*  83011 */   // Label 1775: @83011
     /*  83011 */   GIM_Reject,
     /*  83012 */ // Label 1763: @83012
     /*  83012 */ GIM_Reject,
     /*  83013 */ // Label 1484: @83013
     /*  83013 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(83346),
     /*  83018 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83021 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83025 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(83067), // Rule ID 1720 //
     /*  83030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83052 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDYmr),
     /*  83055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83059 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83065 */     GIR_RootConstrainSelectedInstOperands,
     /*  83066 */     // GIR_Coverage, 1720,
     /*  83066 */     GIR_EraseRootFromParent_Done,
     /*  83067 */   // Label 1777: @83067
     /*  83067 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(83105), // Rule ID 1722 //
     /*  83072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83090 */     // (st VR256:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4f64] }:$src)
     /*  83090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDYmr),
     /*  83093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83097 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83103 */     GIR_RootConstrainSelectedInstOperands,
     /*  83104 */     // GIR_Coverage, 1722,
     /*  83104 */     GIR_EraseRootFromParent_Done,
     /*  83105 */   // Label 1778: @83105
     /*  83105 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(83147), // Rule ID 4495 //
     /*  83110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83121 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83132 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256mr),
     /*  83135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83139 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83145 */     GIR_RootConstrainSelectedInstOperands,
     /*  83146 */     // GIR_Coverage, 4495,
     /*  83146 */     GIR_EraseRootFromParent_Done,
     /*  83147 */   // Label 1779: @83147
     /*  83147 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(83185), // Rule ID 4519 //
     /*  83152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83170 */     // (st VR256X:{ *:[v4f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4f64] }:$src)
     /*  83170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZ256mr),
     /*  83173 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83177 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83183 */     GIR_RootConstrainSelectedInstOperands,
     /*  83184 */     // GIR_Coverage, 4519,
     /*  83184 */     GIR_EraseRootFromParent_Done,
     /*  83185 */   // Label 1780: @83185
     /*  83185 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(83227), // Rule ID 4549 //
     /*  83190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83197 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83212 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  83215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83219 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83225 */     GIR_RootConstrainSelectedInstOperands,
     /*  83226 */     // GIR_Coverage, 4549,
     /*  83226 */     GIR_EraseRootFromParent_Done,
     /*  83227 */   // Label 1781: @83227
     /*  83227 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(83265), // Rule ID 4591 //
     /*  83232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  83235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  83239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83250 */     // (st VR256X:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v4i64] }:$src)
     /*  83250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  83253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83257 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83263 */     GIR_RootConstrainSelectedInstOperands,
     /*  83264 */     // GIR_Coverage, 4591,
     /*  83264 */     GIR_EraseRootFromParent_Done,
     /*  83265 */   // Label 1782: @83265
     /*  83265 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(83307), // Rule ID 17923 //
     /*  83270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83281 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83292 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  83295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83299 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83305 */     GIR_RootConstrainSelectedInstOperands,
     /*  83306 */     // GIR_Coverage, 17923,
     /*  83306 */     GIR_EraseRootFromParent_Done,
     /*  83307 */   // Label 1783: @83307
     /*  83307 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(83345), // Rule ID 17927 //
     /*  83312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  83319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83330 */     // (st VR256:{ *:[v4i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src)
     /*  83330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  83333 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83337 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83343 */     GIR_RootConstrainSelectedInstOperands,
     /*  83344 */     // GIR_Coverage, 17927,
     /*  83344 */     GIR_EraseRootFromParent_Done,
     /*  83345 */   // Label 1784: @83345
     /*  83345 */   GIM_Reject,
     /*  83346 */ // Label 1776: @83346
     /*  83346 */ GIM_Reject,
     /*  83347 */ // Label 1485: @83347
     /*  83347 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(83428),
     /*  83352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83355 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /*  83363 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83367 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(83397), // Rule ID 4396 //
     /*  83372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoEGPR),
     /*  83375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83382 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk),
     /*  83385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83389 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83395 */     GIR_RootConstrainSelectedInstOperands,
     /*  83396 */     // GIR_Coverage, 4396,
     /*  83396 */     GIR_EraseRootFromParent_Done,
     /*  83397 */   // Label 1786: @83397
     /*  83397 */   GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(83427), // Rule ID 4398 //
     /*  83402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEGPR_In64BitMode),
     /*  83405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83412 */     // (st VK8:{ *:[v8i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVBmk_EVEX addr:{ *:[iPTR] }:$dst, VK8:{ *:[v8i1] }:$src)
     /*  83412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBmk_EVEX),
     /*  83415 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83419 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83425 */     GIR_RootConstrainSelectedInstOperands,
     /*  83426 */     // GIR_Coverage, 4398,
     /*  83426 */     GIR_EraseRootFromParent_Done,
     /*  83427 */   // Label 1787: @83427
     /*  83427 */   GIM_Reject,
     /*  83428 */ // Label 1785: @83428
     /*  83428 */ GIM_Reject,
     /*  83429 */ // Label 1486: @83429
     /*  83429 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(84002),
     /*  83434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  83437 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  83441 */   GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(83483), // Rule ID 17933 //
     /*  83446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83457 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83468 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSmr),
     /*  83471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83475 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83481 */     GIR_RootConstrainSelectedInstOperands,
     /*  83482 */     // GIR_Coverage, 17933,
     /*  83482 */     GIR_EraseRootFromParent_Done,
     /*  83483 */   // Label 1789: @83483
     /*  83483 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(83521), // Rule ID 17934 //
     /*  83488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83495 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83506 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSmr),
     /*  83509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83519 */     GIR_RootConstrainSelectedInstOperands,
     /*  83520 */     // GIR_Coverage, 17934,
     /*  83520 */     GIR_EraseRootFromParent_Done,
     /*  83521 */   // Label 1790: @83521
     /*  83521 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(83563), // Rule ID 17949 //
     /*  83526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83533 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83537 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83548 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83551 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83555 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83561 */     GIR_RootConstrainSelectedInstOperands,
     /*  83562 */     // GIR_Coverage, 17949,
     /*  83562 */     GIR_EraseRootFromParent_Done,
     /*  83563 */   // Label 1791: @83563
     /*  83563 */   GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(83601), // Rule ID 17953 //
     /*  83568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  83571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83586 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83593 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83595 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83599 */     GIR_RootConstrainSelectedInstOperands,
     /*  83600 */     // GIR_Coverage, 17953,
     /*  83600 */     GIR_EraseRootFromParent_Done,
     /*  83601 */   // Label 1792: @83601
     /*  83601 */   GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(83643), // Rule ID 17957 //
     /*  83606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83617 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83628 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  83631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83635 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83641 */     GIR_RootConstrainSelectedInstOperands,
     /*  83642 */     // GIR_Coverage, 17957,
     /*  83642 */     GIR_EraseRootFromParent_Done,
     /*  83643 */   // Label 1793: @83643
     /*  83643 */   GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(83681), // Rule ID 17958 //
     /*  83648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /*  83651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83666 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  83669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83673 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83679 */     GIR_RootConstrainSelectedInstOperands,
     /*  83680 */     // GIR_Coverage, 17958,
     /*  83680 */     GIR_EraseRootFromParent_Done,
     /*  83681 */   // Label 1794: @83681
     /*  83681 */   GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(83723), // Rule ID 18328 //
     /*  83686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83708 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83711 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83715 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83721 */     GIR_RootConstrainSelectedInstOperands,
     /*  83722 */     // GIR_Coverage, 18328,
     /*  83722 */     GIR_EraseRootFromParent_Done,
     /*  83723 */   // Label 1795: @83723
     /*  83723 */   GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(83765), // Rule ID 18329 //
     /*  83728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83739 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83750 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  83753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83757 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83763 */     GIR_RootConstrainSelectedInstOperands,
     /*  83764 */     // GIR_Coverage, 18329,
     /*  83764 */     GIR_EraseRootFromParent_Done,
     /*  83765 */   // Label 1796: @83765
     /*  83765 */   GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(83803), // Rule ID 18332 //
     /*  83770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83788 */     // (st VR128:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8i16] }:$src)
     /*  83788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83791 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83795 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83801 */     GIR_RootConstrainSelectedInstOperands,
     /*  83802 */     // GIR_Coverage, 18332,
     /*  83802 */     GIR_EraseRootFromParent_Done,
     /*  83803 */   // Label 1797: @83803
     /*  83803 */   GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(83841), // Rule ID 18333 //
     /*  83808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  83811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  83815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83826 */     // (st VR128:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v8f16] }:$src)
     /*  83826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  83829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83833 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83839 */     GIR_RootConstrainSelectedInstOperands,
     /*  83840 */     // GIR_Coverage, 18333,
     /*  83840 */     GIR_EraseRootFromParent_Done,
     /*  83841 */   // Label 1798: @83841
     /*  83841 */   GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(83883), // Rule ID 19821 //
     /*  83846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83857 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83868 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  83871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83875 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83877 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83881 */     GIR_RootConstrainSelectedInstOperands,
     /*  83882 */     // GIR_Coverage, 19821,
     /*  83882 */     GIR_EraseRootFromParent_Done,
     /*  83883 */   // Label 1799: @83883
     /*  83883 */   GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(83925), // Rule ID 19822 //
     /*  83888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83895 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83899 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  83903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83910 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128mr),
     /*  83913 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83917 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83923 */     GIR_RootConstrainSelectedInstOperands,
     /*  83924 */     // GIR_Coverage, 19822,
     /*  83924 */     GIR_EraseRootFromParent_Done,
     /*  83925 */   // Label 1800: @83925
     /*  83925 */   GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(83963), // Rule ID 19825 //
     /*  83930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83948 */     // (st VR128X:{ *:[v8i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8i16] }:$src)
     /*  83948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  83951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83955 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83961 */     GIR_RootConstrainSelectedInstOperands,
     /*  83962 */     // GIR_Coverage, 19825,
     /*  83962 */     GIR_EraseRootFromParent_Done,
     /*  83963 */   // Label 1801: @83963
     /*  83963 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(84001), // Rule ID 19826 //
     /*  83968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  83971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  83975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  83979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  83986 */     // (st VR128X:{ *:[v8f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v8f16] }:$src)
     /*  83986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ128mr),
     /*  83989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  83993 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  83995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  83999 */     GIR_RootConstrainSelectedInstOperands,
     /*  84000 */     // GIR_Coverage, 19826,
     /*  84000 */     GIR_EraseRootFromParent_Done,
     /*  84001 */   // Label 1802: @84001
     /*  84001 */   GIM_Reject,
     /*  84002 */ // Label 1788: @84002
     /*  84002 */ GIM_Reject,
     /*  84003 */ // Label 1487: @84003
     /*  84003 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(84336),
     /*  84008 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84011 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84015 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(84057), // Rule ID 1719 //
     /*  84020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84042 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84049 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84055 */     GIR_RootConstrainSelectedInstOperands,
     /*  84056 */     // GIR_Coverage, 1719,
     /*  84056 */     GIR_EraseRootFromParent_Done,
     /*  84057 */   // Label 1804: @84057
     /*  84057 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(84095), // Rule ID 1721 //
     /*  84062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84080 */     // (st VR256:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8f32] }:$src)
     /*  84080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84083 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84087 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84093 */     GIR_RootConstrainSelectedInstOperands,
     /*  84094 */     // GIR_Coverage, 1721,
     /*  84094 */     GIR_EraseRootFromParent_Done,
     /*  84095 */   // Label 1805: @84095
     /*  84095 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(84137), // Rule ID 4477 //
     /*  84100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84122 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  84125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84129 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84135 */     GIR_RootConstrainSelectedInstOperands,
     /*  84136 */     // GIR_Coverage, 4477,
     /*  84136 */     GIR_EraseRootFromParent_Done,
     /*  84137 */   // Label 1806: @84137
     /*  84137 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(84175), // Rule ID 4507 //
     /*  84142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /*  84145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84160 */     // (st VR256X:{ *:[v8f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8f32] }:$src)
     /*  84160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  84163 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84167 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84173 */     GIR_RootConstrainSelectedInstOperands,
     /*  84174 */     // GIR_Coverage, 4507,
     /*  84174 */     GIR_EraseRootFromParent_Done,
     /*  84175 */   // Label 1807: @84175
     /*  84175 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(84217), // Rule ID 17924 //
     /*  84180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84202 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84209 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84215 */     GIR_RootConstrainSelectedInstOperands,
     /*  84216 */     // GIR_Coverage, 17924,
     /*  84216 */     GIR_EraseRootFromParent_Done,
     /*  84217 */   // Label 1808: @84217
     /*  84217 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(84255), // Rule ID 17928 //
     /*  84222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84240 */     // (st VR256:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src)
     /*  84240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84243 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84247 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84253 */     GIR_RootConstrainSelectedInstOperands,
     /*  84254 */     // GIR_Coverage, 17928,
     /*  84254 */     GIR_EraseRootFromParent_Done,
     /*  84255 */   // Label 1809: @84255
     /*  84255 */   GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(84297), // Rule ID 19836 //
     /*  84260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84271 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84282 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  84285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84289 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84295 */     GIR_RootConstrainSelectedInstOperands,
     /*  84296 */     // GIR_Coverage, 19836,
     /*  84296 */     GIR_EraseRootFromParent_Done,
     /*  84297 */   // Label 1810: @84297
     /*  84297 */   GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(84335), // Rule ID 19840 //
     /*  84302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  84309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84320 */     // (st VR256X:{ *:[v8i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v8i32] }:$src)
     /*  84320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  84323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84327 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84333 */     GIR_RootConstrainSelectedInstOperands,
     /*  84334 */     // GIR_Coverage, 19840,
     /*  84334 */     GIR_EraseRootFromParent_Done,
     /*  84335 */   // Label 1811: @84335
     /*  84335 */   GIM_Reject,
     /*  84336 */ // Label 1803: @84336
     /*  84336 */ GIM_Reject,
     /*  84337 */ // Label 1488: @84337
     /*  84337 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(84510),
     /*  84342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84349 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(84391), // Rule ID 4494 //
     /*  84354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84365 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84376 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZmr),
     /*  84379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84383 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84389 */     GIR_RootConstrainSelectedInstOperands,
     /*  84390 */     // GIR_Coverage, 4494,
     /*  84390 */     GIR_EraseRootFromParent_Done,
     /*  84391 */   // Label 1813: @84391
     /*  84391 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(84429), // Rule ID 4518 //
     /*  84396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84414 */     // (st VR512:{ *:[v8f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPDZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8f64] }:$src)
     /*  84414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPDZmr),
     /*  84417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84421 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84427 */     GIR_RootConstrainSelectedInstOperands,
     /*  84428 */     // GIR_Coverage, 4518,
     /*  84428 */     GIR_EraseRootFromParent_Done,
     /*  84429 */   // Label 1814: @84429
     /*  84429 */   GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(84471), // Rule ID 4548 //
     /*  84434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84441 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84445 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84456 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  84459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84463 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84469 */     GIR_RootConstrainSelectedInstOperands,
     /*  84470 */     // GIR_Coverage, 4548,
     /*  84470 */     GIR_EraseRootFromParent_Done,
     /*  84471 */   // Label 1815: @84471
     /*  84471 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(84509), // Rule ID 4590 //
     /*  84476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  84479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  84483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84494 */     // (st VR512:{ *:[v8i64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v8i64] }:$src)
     /*  84494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  84497 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84501 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84507 */     GIR_RootConstrainSelectedInstOperands,
     /*  84508 */     // GIR_Coverage, 4590,
     /*  84508 */     GIR_EraseRootFromParent_Done,
     /*  84509 */   // Label 1816: @84509
     /*  84509 */   GIM_Reject,
     /*  84510 */ // Label 1812: @84510
     /*  84510 */ GIM_Reject,
     /*  84511 */ // Label 1489: @84511
     /*  84511 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(84592),
     /*  84516 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84519 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /*  84527 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84531 */   GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(84561), // Rule ID 4400 //
     /*  84536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoEGPR),
     /*  84539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84546 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk),
     /*  84549 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84553 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84559 */     GIR_RootConstrainSelectedInstOperands,
     /*  84560 */     // GIR_Coverage, 4400,
     /*  84560 */     GIR_EraseRootFromParent_Done,
     /*  84561 */   // Label 1818: @84561
     /*  84561 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(84591), // Rule ID 4402 //
     /*  84566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEGPR_In64BitMode),
     /*  84569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84576 */     // (st VK16:{ *:[v16i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVWmk_EVEX addr:{ *:[iPTR] }:$dst, VK16:{ *:[v16i1] }:$src)
     /*  84576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWmk_EVEX),
     /*  84579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84583 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84589 */     GIR_RootConstrainSelectedInstOperands,
     /*  84590 */     // GIR_Coverage, 4402,
     /*  84590 */     GIR_EraseRootFromParent_Done,
     /*  84591 */   // Label 1819: @84591
     /*  84591 */   GIM_Reject,
     /*  84592 */ // Label 1817: @84592
     /*  84592 */ GIM_Reject,
     /*  84593 */ // Label 1490: @84593
     /*  84593 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(84846),
     /*  84598 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84601 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84605 */   GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(84647), // Rule ID 17950 //
     /*  84610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84621 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84632 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (MOVAPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVAPSmr),
     /*  84635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84639 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84645 */     GIR_RootConstrainSelectedInstOperands,
     /*  84646 */     // GIR_Coverage, 17950,
     /*  84646 */     GIR_EraseRootFromParent_Done,
     /*  84647 */   // Label 1821: @84647
     /*  84647 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(84685), // Rule ID 17954 //
     /*  84652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  84655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84670 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (MOVUPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVUPSmr),
     /*  84673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84677 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84683 */     GIR_RootConstrainSelectedInstOperands,
     /*  84684 */     // GIR_Coverage, 17954,
     /*  84684 */     GIR_EraseRootFromParent_Done,
     /*  84685 */   // Label 1822: @84685
     /*  84685 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(84727), // Rule ID 18330 //
     /*  84690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84712 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQAmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQAmr),
     /*  84715 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84719 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84725 */     GIR_RootConstrainSelectedInstOperands,
     /*  84726 */     // GIR_Coverage, 18330,
     /*  84726 */     GIR_EraseRootFromParent_Done,
     /*  84727 */   // Label 1823: @84727
     /*  84727 */   GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(84765), // Rule ID 18334 //
     /*  84732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  84739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84750 */     // (st VR128:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQUmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v16i8] }:$src)
     /*  84750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQUmr),
     /*  84753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84757 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84763 */     GIR_RootConstrainSelectedInstOperands,
     /*  84764 */     // GIR_Coverage, 18334,
     /*  84764 */     GIR_EraseRootFromParent_Done,
     /*  84765 */   // Label 1824: @84765
     /*  84765 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(84807), // Rule ID 19823 //
     /*  84770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84781 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84792 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128mr),
     /*  84795 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84799 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84805 */     GIR_RootConstrainSelectedInstOperands,
     /*  84806 */     // GIR_Coverage, 19823,
     /*  84806 */     GIR_EraseRootFromParent_Done,
     /*  84807 */   // Label 1825: @84807
     /*  84807 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(84845), // Rule ID 19827 //
     /*  84812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  84815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  84819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84830 */     // (st VR128X:{ *:[v16i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z128mr addr:{ *:[iPTR] }:$dst, VR128X:{ *:[v16i8] }:$src)
     /*  84830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z128mr),
     /*  84833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84837 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84843 */     GIR_RootConstrainSelectedInstOperands,
     /*  84844 */     // GIR_Coverage, 19827,
     /*  84844 */     GIR_EraseRootFromParent_Done,
     /*  84845 */   // Label 1826: @84845
     /*  84845 */   GIM_Reject,
     /*  84846 */ // Label 1820: @84846
     /*  84846 */ GIM_Reject,
     /*  84847 */ // Label 1491: @84847
     /*  84847 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(85180),
     /*  84852 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  84855 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  84859 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(84901), // Rule ID 17925 //
     /*  84864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84875 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84886 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84893 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84895 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84899 */     GIR_RootConstrainSelectedInstOperands,
     /*  84900 */     // GIR_Coverage, 17925,
     /*  84900 */     GIR_EraseRootFromParent_Done,
     /*  84901 */   // Label 1828: @84901
     /*  84901 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(84939), // Rule ID 17929 //
     /*  84906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84924 */     // (st VR256:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16i16] }:$src)
     /*  84924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  84927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84931 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84937 */     GIR_RootConstrainSelectedInstOperands,
     /*  84938 */     // GIR_Coverage, 17929,
     /*  84938 */     GIR_EraseRootFromParent_Done,
     /*  84939 */   // Label 1829: @84939
     /*  84939 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(84981), // Rule ID 17937 //
     /*  84944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  84959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  84966 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  84966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  84969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  84973 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  84975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  84979 */     GIR_RootConstrainSelectedInstOperands,
     /*  84980 */     // GIR_Coverage, 17937,
     /*  84980 */     GIR_EraseRootFromParent_Done,
     /*  84981 */   // Label 1830: @84981
     /*  84981 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(85019), // Rule ID 17938 //
     /*  84986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  84989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  84993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  84997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85004 */     // (st VR256:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v16f16] }:$src)
     /*  85004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85011 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85017 */     GIR_RootConstrainSelectedInstOperands,
     /*  85018 */     // GIR_Coverage, 17938,
     /*  85018 */     GIR_EraseRootFromParent_Done,
     /*  85019 */   // Label 1831: @85019
     /*  85019 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(85061), // Rule ID 19837 //
     /*  85024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85031 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85035 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85046 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85053 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85059 */     GIR_RootConstrainSelectedInstOperands,
     /*  85060 */     // GIR_Coverage, 19837,
     /*  85060 */     GIR_EraseRootFromParent_Done,
     /*  85061 */   // Label 1832: @85061
     /*  85061 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(85103), // Rule ID 19838 //
     /*  85066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85077 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85088 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256mr),
     /*  85091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85095 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85101 */     GIR_RootConstrainSelectedInstOperands,
     /*  85102 */     // GIR_Coverage, 19838,
     /*  85102 */     GIR_EraseRootFromParent_Done,
     /*  85103 */   // Label 1833: @85103
     /*  85103 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(85141), // Rule ID 19841 //
     /*  85108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85115 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85126 */     // (st VR256X:{ *:[v16i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16i16] }:$src)
     /*  85126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85133 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85139 */     GIR_RootConstrainSelectedInstOperands,
     /*  85140 */     // GIR_Coverage, 19841,
     /*  85140 */     GIR_EraseRootFromParent_Done,
     /*  85141 */   // Label 1834: @85141
     /*  85141 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(85179), // Rule ID 19842 //
     /*  85146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85164 */     // (st VR256X:{ *:[v16f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZ256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v16f16] }:$src)
     /*  85164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZ256mr),
     /*  85167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85171 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85177 */     GIR_RootConstrainSelectedInstOperands,
     /*  85178 */     // GIR_Coverage, 19842,
     /*  85178 */     GIR_EraseRootFromParent_Done,
     /*  85179 */   // Label 1835: @85179
     /*  85179 */   GIM_Reject,
     /*  85180 */ // Label 1827: @85180
     /*  85180 */ GIM_Reject,
     /*  85181 */ // Label 1492: @85181
     /*  85181 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(85354),
     /*  85186 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85189 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85193 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(85235), // Rule ID 4476 //
     /*  85198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85220 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85227 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85233 */     GIR_RootConstrainSelectedInstOperands,
     /*  85234 */     // GIR_Coverage, 4476,
     /*  85234 */     GIR_EraseRootFromParent_Done,
     /*  85235 */   // Label 1837: @85235
     /*  85235 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(85273), // Rule ID 4506 //
     /*  85240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85258 */     // (st VR512:{ *:[v16f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16f32] }:$src)
     /*  85258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85265 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85271 */     GIR_RootConstrainSelectedInstOperands,
     /*  85272 */     // GIR_Coverage, 4506,
     /*  85272 */     GIR_EraseRootFromParent_Done,
     /*  85273 */   // Label 1838: @85273
     /*  85273 */   GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(85315), // Rule ID 19804 //
     /*  85278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85300 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85307 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85313 */     GIR_RootConstrainSelectedInstOperands,
     /*  85314 */     // GIR_Coverage, 19804,
     /*  85314 */     GIR_EraseRootFromParent_Done,
     /*  85315 */   // Label 1839: @85315
     /*  85315 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(85353), // Rule ID 19808 //
     /*  85320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85338 */     // (st VR512:{ *:[v16i32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v16i32] }:$src)
     /*  85338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85345 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85351 */     GIR_RootConstrainSelectedInstOperands,
     /*  85352 */     // GIR_Coverage, 19808,
     /*  85352 */     GIR_EraseRootFromParent_Done,
     /*  85353 */   // Label 1840: @85353
     /*  85353 */   GIM_Reject,
     /*  85354 */ // Label 1836: @85354
     /*  85354 */ GIM_Reject,
     /*  85355 */ // Label 1493: @85355
     /*  85355 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(85436),
     /*  85360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /*  85371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85375 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(85405), // Rule ID 4404 //
     /*  85380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85390 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk),
     /*  85393 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85397 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85403 */     GIR_RootConstrainSelectedInstOperands,
     /*  85404 */     // GIR_Coverage, 4404,
     /*  85404 */     GIR_EraseRootFromParent_Done,
     /*  85405 */   // Label 1842: @85405
     /*  85405 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(85435), // Rule ID 4408 //
     /*  85410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85420 */     // (st VK32:{ *:[v32i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVDmk_EVEX addr:{ *:[iPTR] }:$dst, VK32:{ *:[v32i1] }:$src)
     /*  85420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVDmk_EVEX),
     /*  85423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85427 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85433 */     GIR_RootConstrainSelectedInstOperands,
     /*  85434 */     // GIR_Coverage, 4408,
     /*  85434 */     GIR_EraseRootFromParent_Done,
     /*  85435 */   // Label 1843: @85435
     /*  85435 */   GIM_Reject,
     /*  85436 */ // Label 1841: @85436
     /*  85436 */ GIM_Reject,
     /*  85437 */ // Label 1494: @85437
     /*  85437 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(85610),
     /*  85442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85445 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85449 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(85491), // Rule ID 17926 //
     /*  85454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85465 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85476 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSYmr),
     /*  85479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85483 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85489 */     GIR_RootConstrainSelectedInstOperands,
     /*  85490 */     // GIR_Coverage, 17926,
     /*  85490 */     GIR_EraseRootFromParent_Done,
     /*  85491 */   // Label 1845: @85491
     /*  85491 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(85529), // Rule ID 17930 //
     /*  85496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /*  85499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  85503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85514 */     // (st VR256:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v32i8] }:$src)
     /*  85514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSYmr),
     /*  85517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85521 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85527 */     GIR_RootConstrainSelectedInstOperands,
     /*  85528 */     // GIR_Coverage, 17930,
     /*  85528 */     GIR_EraseRootFromParent_Done,
     /*  85529 */   // Label 1846: @85529
     /*  85529 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(85571), // Rule ID 19839 //
     /*  85534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85556 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256mr),
     /*  85559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85563 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85569 */     GIR_RootConstrainSelectedInstOperands,
     /*  85570 */     // GIR_Coverage, 19839,
     /*  85570 */     GIR_EraseRootFromParent_Done,
     /*  85571 */   // Label 1847: @85571
     /*  85571 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(85609), // Rule ID 19843 //
     /*  85576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /*  85579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  85583 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85594 */     // (st VR256X:{ *:[v32i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Z256mr addr:{ *:[iPTR] }:$dst, VR256X:{ *:[v32i8] }:$src)
     /*  85594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Z256mr),
     /*  85597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85601 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85607 */     GIR_RootConstrainSelectedInstOperands,
     /*  85608 */     // GIR_Coverage, 19843,
     /*  85608 */     GIR_EraseRootFromParent_Done,
     /*  85609 */   // Label 1848: @85609
     /*  85609 */   GIM_Reject,
     /*  85610 */ // Label 1844: @85610
     /*  85610 */ GIM_Reject,
     /*  85611 */ // Label 1495: @85611
     /*  85611 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(85784),
     /*  85616 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85619 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85623 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(85665), // Rule ID 19805 //
     /*  85628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85639 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85650 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85653 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85657 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85663 */     GIR_RootConstrainSelectedInstOperands,
     /*  85664 */     // GIR_Coverage, 19805,
     /*  85664 */     GIR_EraseRootFromParent_Done,
     /*  85665 */   // Label 1850: @85665
     /*  85665 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(85707), // Rule ID 19806 //
     /*  85670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85692 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVAPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZmr),
     /*  85695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85699 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85705 */     GIR_RootConstrainSelectedInstOperands,
     /*  85706 */     // GIR_Coverage, 19806,
     /*  85706 */     GIR_EraseRootFromParent_Done,
     /*  85707 */   // Label 1851: @85707
     /*  85707 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(85745), // Rule ID 19809 //
     /*  85712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85719 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85730 */     // (st VR512:{ *:[v32i16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32i16] }:$src)
     /*  85730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85737 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85743 */     GIR_RootConstrainSelectedInstOperands,
     /*  85744 */     // GIR_Coverage, 19809,
     /*  85744 */     GIR_EraseRootFromParent_Done,
     /*  85745 */   // Label 1852: @85745
     /*  85745 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(85783), // Rule ID 19810 //
     /*  85750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85768 */     // (st VR512:{ *:[v32f16] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVUPSZmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v32f16] }:$src)
     /*  85768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVUPSZmr),
     /*  85771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85775 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85781 */     GIR_RootConstrainSelectedInstOperands,
     /*  85782 */     // GIR_Coverage, 19810,
     /*  85782 */     GIR_EraseRootFromParent_Done,
     /*  85783 */   // Label 1853: @85783
     /*  85783 */   GIM_Reject,
     /*  85784 */ // Label 1849: @85784
     /*  85784 */ GIM_Reject,
     /*  85785 */ // Label 1496: @85785
     /*  85785 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(85866),
     /*  85790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /*  85801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85805 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(85835), // Rule ID 4406 //
     /*  85810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_NoEGPR),
     /*  85813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85820 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk),
     /*  85823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85827 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85833 */     GIR_RootConstrainSelectedInstOperands,
     /*  85834 */     // GIR_Coverage, 4406,
     /*  85834 */     GIR_EraseRootFromParent_Done,
     /*  85835 */   // Label 1855: @85835
     /*  85835 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(85865), // Rule ID 4410 //
     /*  85840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEGPR_In64BitMode),
     /*  85843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85850 */     // (st VK64:{ *:[v64i1] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (KMOVQmk_EVEX addr:{ *:[iPTR] }:$dst, VK64:{ *:[v64i1] }:$src)
     /*  85850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVQmk_EVEX),
     /*  85853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85857 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85863 */     GIR_RootConstrainSelectedInstOperands,
     /*  85864 */     // GIR_Coverage, 4410,
     /*  85864 */     GIR_EraseRootFromParent_Done,
     /*  85865 */   // Label 1856: @85865
     /*  85865 */   GIM_Reject,
     /*  85866 */ // Label 1854: @85866
     /*  85866 */ GIM_Reject,
     /*  85867 */ // Label 1497: @85867
     /*  85867 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(85960),
     /*  85872 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  85875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  85879 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(85921), // Rule ID 19807 //
     /*  85884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85895 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedstore),
     /*  85899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85906 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>><<P:Predicate_alignedstore>>  =>  (VMOVDQA64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zmr),
     /*  85909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85913 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85919 */     GIR_RootConstrainSelectedInstOperands,
     /*  85920 */     // GIR_Coverage, 19807,
     /*  85920 */     GIR_EraseRootFromParent_Done,
     /*  85921 */   // Label 1858: @85921
     /*  85921 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(85959), // Rule ID 19811 //
     /*  85926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /*  85929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  85933 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  85937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  85944 */     // (st VR512:{ *:[v64i8] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (VMOVDQU64Zmr addr:{ *:[iPTR] }:$dst, VR512:{ *:[v64i8] }:$src)
     /*  85944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU64Zmr),
     /*  85947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /*  85951 */     GIR_RootToRootCopy, /*OpIdx*/0, // src
     /*  85953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  85957 */     GIR_RootConstrainSelectedInstOperands,
     /*  85958 */     // GIR_Coverage, 19811,
     /*  85958 */     GIR_EraseRootFromParent_Done,
     /*  85959 */   // Label 1859: @85959
     /*  85959 */   GIM_Reject,
     /*  85960 */ // Label 1857: @85960
     /*  85960 */ GIM_Reject,
     /*  85961 */ // Label 1498: @85961
     /*  85961 */ GIM_Reject,
     /*  85962 */ // Label 14: @85962
     /*  85962 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1864*/ GIMT_Encode4(86197),
     /*  85973 */ /*GILLT_s8*//*Label 1860*/ GIMT_Encode4(85989),
     /*  85977 */ /*GILLT_s16*//*Label 1861*/ GIMT_Encode4(86041),
     /*  85981 */ /*GILLT_s32*//*Label 1862*/ GIMT_Encode4(86093),
     /*  85985 */ /*GILLT_s64*//*Label 1863*/ GIMT_Encode4(86145),
     /*  85989 */ // Label 1860: @85989
     /*  85989 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(86040), // Rule ID 45 //
     /*  85994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  85997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86016 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86023 */   // (atomic_swap:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_swap_i8>>  =>  (XCHG8rm:{ *:[i8] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG8rm),
     /*  86026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86028 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86030 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86038 */   GIR_RootConstrainSelectedInstOperands,
     /*  86039 */   // GIR_Coverage, 45,
     /*  86039 */   GIR_EraseRootFromParent_Done,
     /*  86040 */ // Label 1865: @86040
     /*  86040 */ GIM_Reject,
     /*  86041 */ // Label 1861: @86041
     /*  86041 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(86092), // Rule ID 46 //
     /*  86046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86049 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86060 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86068 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86075 */   // (atomic_swap:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_swap_i16>>  =>  (XCHG16rm:{ *:[i16] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG16rm),
     /*  86078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86080 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86082 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86086 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86090 */   GIR_RootConstrainSelectedInstOperands,
     /*  86091 */   // GIR_Coverage, 46,
     /*  86091 */   GIR_EraseRootFromParent_Done,
     /*  86092 */ // Label 1866: @86092
     /*  86092 */ GIM_Reject,
     /*  86093 */ // Label 1862: @86093
     /*  86093 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(86144), // Rule ID 47 //
     /*  86098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86127 */   // (atomic_swap:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>>  =>  (XCHG32rm:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG32rm),
     /*  86130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86132 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86134 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86142 */   GIR_RootConstrainSelectedInstOperands,
     /*  86143 */   // GIR_Coverage, 47,
     /*  86143 */   GIR_EraseRootFromParent_Done,
     /*  86144 */ // Label 1867: @86144
     /*  86144 */ GIM_Reject,
     /*  86145 */ // Label 1863: @86145
     /*  86145 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(86196), // Rule ID 48 //
     /*  86150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86153 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86164 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86179 */   // (atomic_swap:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>>  =>  (XCHG64rm:{ *:[i64] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XCHG64rm),
     /*  86182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86184 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86186 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86190 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86194 */   GIR_RootConstrainSelectedInstOperands,
     /*  86195 */   // GIR_Coverage, 48,
     /*  86195 */   GIR_EraseRootFromParent_Done,
     /*  86196 */ // Label 1868: @86196
     /*  86196 */ GIM_Reject,
     /*  86197 */ // Label 1864: @86197
     /*  86197 */ GIM_Reject,
     /*  86198 */ // Label 15: @86198
     /*  86198 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 1873*/ GIMT_Encode4(86445),
     /*  86209 */ /*GILLT_s8*//*Label 1869*/ GIMT_Encode4(86225),
     /*  86213 */ /*GILLT_s16*//*Label 1870*/ GIMT_Encode4(86280),
     /*  86217 */ /*GILLT_s32*//*Label 1871*/ GIMT_Encode4(86335),
     /*  86221 */ /*GILLT_s64*//*Label 1872*/ GIMT_Encode4(86390),
     /*  86225 */ // Label 1869: @86225
     /*  86225 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(86279), // Rule ID 17298 //
     /*  86230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /*  86233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  86240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  86252 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86259 */   // (atomic_load_add:{ *:[i8] } addr:{ *:[iPTR] }:$ptr, GR8:{ *:[i8] }:$val)<<P:Predicate_atomic_load_add_i8>>  =>  (LXADD8:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD8),
     /*  86262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86264 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86266 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86270 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86273 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86277 */   GIR_RootConstrainSelectedInstOperands,
     /*  86278 */   // GIR_Coverage, 17298,
     /*  86278 */   GIR_EraseRootFromParent_Done,
     /*  86279 */ // Label 1874: @86279
     /*  86279 */ GIM_Reject,
     /*  86280 */ // Label 1870: @86280
     /*  86280 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(86334), // Rule ID 17299 //
     /*  86285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  86288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  86295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  86307 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86314 */   // (atomic_load_add:{ *:[i16] } addr:{ *:[iPTR] }:$ptr, GR16:{ *:[i16] }:$val)<<P:Predicate_atomic_load_add_i16>>  =>  (LXADD16:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD16),
     /*  86317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86319 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86321 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86325 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86332 */   GIR_RootConstrainSelectedInstOperands,
     /*  86333 */   // GIR_Coverage, 17299,
     /*  86333 */   GIR_EraseRootFromParent_Done,
     /*  86334 */ // Label 1875: @86334
     /*  86334 */ GIM_Reject,
     /*  86335 */ // Label 1871: @86335
     /*  86335 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(86389), // Rule ID 17300 //
     /*  86340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86343 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  86350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  86362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86369 */   // (atomic_load_add:{ *:[i32] } addr:{ *:[iPTR] }:$ptr, GR32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>>  =>  (LXADD32:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD32),
     /*  86372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86374 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86376 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86380 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86387 */   GIR_RootConstrainSelectedInstOperands,
     /*  86388 */   // GIR_Coverage, 17300,
     /*  86388 */   GIR_EraseRootFromParent_Done,
     /*  86389 */ // Label 1876: @86389
     /*  86389 */ GIM_Reject,
     /*  86390 */ // Label 1872: @86390
     /*  86390 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(86444), // Rule ID 17301 //
     /*  86395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  86398 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  86405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86409 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  86413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  86417 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86424 */   // (atomic_load_add:{ *:[i64] } addr:{ *:[iPTR] }:$ptr, GR64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>>  =>  (LXADD64:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$val, addr:{ *:[iPTR] }:$ptr)
     /*  86424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LXADD64),
     /*  86427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86429 */   GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  86431 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // ptr
     /*  86435 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /*  86438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86442 */   GIR_RootConstrainSelectedInstOperands,
     /*  86443 */   // GIR_Coverage, 17301,
     /*  86443 */   GIR_EraseRootFromParent_Done,
     /*  86444 */ // Label 1877: @86444
     /*  86444 */ GIM_Reject,
     /*  86445 */ // Label 1873: @86445
     /*  86445 */ GIM_Reject,
     /*  86446 */ // Label 16: @86446
     /*  86446 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(86601),
     /*  86451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  86454 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(86504), // Rule ID 156 //
     /*  86459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86480 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86491 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT0 addr:{ *:[iPTR] }:$src)
     /*  86491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT0),
     /*  86494 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86502 */     GIR_RootConstrainSelectedInstOperands,
     /*  86503 */     // GIR_Coverage, 156,
     /*  86503 */     GIR_EraseRootFromParent_Done,
     /*  86504 */   // Label 1879: @86504
     /*  86504 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(86554), // Rule ID 157 //
     /*  86509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPREFETCHI_In64BitMode),
     /*  86512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  86526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  86534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86541 */     // (prefetch addr:{ *:[iPTR] }:$src, 0:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (PREFETCHIT1 addr:{ *:[iPTR] }:$src)
     /*  86541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHIT1),
     /*  86544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86552 */     GIR_RootConstrainSelectedInstOperands,
     /*  86553 */     // GIR_Coverage, 157,
     /*  86553 */     GIR_EraseRootFromParent_Done,
     /*  86554 */   // Label 1880: @86554
     /*  86554 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(86600), // Rule ID 16983 //
     /*  86559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPrefetchW),
     /*  86562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /*  86573 */     // MIs[0] Operand 2
     /*  86573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  86576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86587 */     // (prefetch addr:{ *:[iPTR] }:$addr, 1:{ *:[i32] }, (timm:{ *:[i32] })<<P:Predicate_PrefetchWLevel>>, 1:{ *:[i32] })  =>  (PREFETCHW addr:{ *:[iPTR] }:$addr)
     /*  86587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHW),
     /*  86590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // addr
     /*  86594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86598 */     GIR_RootConstrainSelectedInstOperands,
     /*  86599 */     // GIR_Coverage, 16983,
     /*  86599 */     GIR_EraseRootFromParent_Done,
     /*  86600 */   // Label 1881: @86600
     /*  86600 */   GIM_Reject,
     /*  86601 */ // Label 1878: @86601
     /*  86601 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(86764),
     /*  86606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  86609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  86612 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  86616 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  86619 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(86655), // Rule ID 2505 //
     /*  86624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 3,
     /*  86631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86642 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT0 addr:{ *:[iPTR] }:$src)
     /*  86642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT0),
     /*  86645 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86653 */     GIR_RootConstrainSelectedInstOperands,
     /*  86654 */     // GIR_Coverage, 2505,
     /*  86654 */     GIR_EraseRootFromParent_Done,
     /*  86655 */   // Label 1883: @86655
     /*  86655 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(86691), // Rule ID 2506 //
     /*  86660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 2,
     /*  86667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86678 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT1 addr:{ *:[iPTR] }:$src)
     /*  86678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT1),
     /*  86681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86689 */     GIR_RootConstrainSelectedInstOperands,
     /*  86690 */     // GIR_Coverage, 2506,
     /*  86690 */     GIR_EraseRootFromParent_Done,
     /*  86691 */   // Label 1884: @86691
     /*  86691 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(86727), // Rule ID 2507 //
     /*  86696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  86703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86714 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHT2 addr:{ *:[iPTR] }:$src)
     /*  86714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHT2),
     /*  86717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86725 */     GIR_RootConstrainSelectedInstOperands,
     /*  86726 */     // GIR_Coverage, 2507,
     /*  86726 */     GIR_EraseRootFromParent_Done,
     /*  86727 */   // Label 1885: @86727
     /*  86727 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(86763), // Rule ID 2508 //
     /*  86732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSEPrefetch),
     /*  86735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  86739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  86743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86750 */     // (prefetch addr:{ *:[iPTR] }:$src, (timm:{ *:[i32] }), 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (PREFETCHNTA addr:{ *:[iPTR] }:$src)
     /*  86750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHNTA),
     /*  86753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  86761 */     GIR_RootConstrainSelectedInstOperands,
     /*  86762 */     // GIR_Coverage, 2508,
     /*  86762 */     GIR_EraseRootFromParent_Done,
     /*  86763 */   // Label 1886: @86763
     /*  86763 */   GIM_Reject,
     /*  86764 */ // Label 1882: @86764
     /*  86764 */ GIM_Reject,
     /*  86765 */ // Label 17: @86765
     /*  86765 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(89094),
     /*  86770 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  86773 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(86840), // Rule ID 1530 //
     /*  86778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  86786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15099:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  86824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrm),
     /*  86827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86829 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86838 */     GIR_RootConstrainSelectedInstOperands,
     /*  86839 */     // GIR_Coverage, 1530,
     /*  86839 */     GIR_EraseRootFromParent_Done,
     /*  86840 */   // Label 1888: @86840
     /*  86840 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(86907), // Rule ID 1532 //
     /*  86845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  86853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86884 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86891 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15098:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  86891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrm),
     /*  86894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86905 */     GIR_RootConstrainSelectedInstOperands,
     /*  86906 */     // GIR_Coverage, 1532,
     /*  86906 */     GIR_EraseRootFromParent_Done,
     /*  86907 */   // Label 1889: @86907
     /*  86907 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(86974), // Rule ID 1534 //
     /*  86912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  86920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  86938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  86941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  86945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  86949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  86958 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15097:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  86958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrm),
     /*  86961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  86967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  86972 */     GIR_RootConstrainSelectedInstOperands,
     /*  86973 */     // GIR_Coverage, 1534,
     /*  86973 */     GIR_EraseRootFromParent_Done,
     /*  86974 */   // Label 1890: @86974
     /*  86974 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(87041), // Rule ID 1536 //
     /*  86979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  86982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  86987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  86990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  86997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87025 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15096:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrm),
     /*  87028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87039 */     GIR_RootConstrainSelectedInstOperands,
     /*  87040 */     // GIR_Coverage, 1536,
     /*  87040 */     GIR_EraseRootFromParent_Done,
     /*  87041 */   // Label 1891: @87041
     /*  87041 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(87108), // Rule ID 1538 //
     /*  87046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  87054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87072 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87075 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15095:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrm),
     /*  87095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87097 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87106 */     GIR_RootConstrainSelectedInstOperands,
     /*  87107 */     // GIR_Coverage, 1538,
     /*  87107 */     GIR_EraseRootFromParent_Done,
     /*  87108 */   // Label 1892: @87108
     /*  87108 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(87175), // Rule ID 1540 //
     /*  87113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  87121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87139 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87142 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87159 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15094:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrm),
     /*  87162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87173 */     GIR_RootConstrainSelectedInstOperands,
     /*  87174 */     // GIR_Coverage, 1540,
     /*  87174 */     GIR_EraseRootFromParent_Done,
     /*  87175 */   // Label 1893: @87175
     /*  87175 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(87242), // Rule ID 1542 //
     /*  87180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  87188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87206 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87209 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87213 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87219 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87226 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15093:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUWDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrm),
     /*  87229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87231 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87240 */     GIR_RootConstrainSelectedInstOperands,
     /*  87241 */     // GIR_Coverage, 1542,
     /*  87241 */     GIR_EraseRootFromParent_Done,
     /*  87242 */   // Label 1894: @87242
     /*  87242 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(87309), // Rule ID 1544 //
     /*  87247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  87255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87273 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87280 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15092:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrm),
     /*  87296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87307 */     GIR_RootConstrainSelectedInstOperands,
     /*  87308 */     // GIR_Coverage, 1544,
     /*  87308 */     GIR_EraseRootFromParent_Done,
     /*  87309 */   // Label 1895: @87309
     /*  87309 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(87376), // Rule ID 1546 //
     /*  87314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  87322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87360 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15091:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrm),
     /*  87363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87374 */     GIR_RootConstrainSelectedInstOperands,
     /*  87375 */     // GIR_Coverage, 1546,
     /*  87375 */     GIR_EraseRootFromParent_Done,
     /*  87376 */   // Label 1896: @87376
     /*  87376 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(87443), // Rule ID 1548 //
     /*  87381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  87389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87407 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87427 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15090:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrm),
     /*  87430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87432 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87441 */     GIR_RootConstrainSelectedInstOperands,
     /*  87442 */     // GIR_Coverage, 1548,
     /*  87442 */     GIR_EraseRootFromParent_Done,
     /*  87443 */   // Label 1897: @87443
     /*  87443 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(87510), // Rule ID 1550 //
     /*  87448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  87456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87474 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87477 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87481 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87487 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87494 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15089:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDUBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrm),
     /*  87497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87508 */     GIR_RootConstrainSelectedInstOperands,
     /*  87509 */     // GIR_Coverage, 1550,
     /*  87509 */     GIR_EraseRootFromParent_Done,
     /*  87510 */   // Label 1898: @87510
     /*  87510 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(87577), // Rule ID 1552 //
     /*  87515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  87523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87541 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87544 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87548 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87561 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15088:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDDQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrm),
     /*  87564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87575 */     GIR_RootConstrainSelectedInstOperands,
     /*  87576 */     // GIR_Coverage, 1552,
     /*  87576 */     GIR_EraseRootFromParent_Done,
     /*  87577 */   // Label 1899: @87577
     /*  87577 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(87644), // Rule ID 1554 //
     /*  87582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  87590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87608 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87611 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87615 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87621 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87628 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15087:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /*  87628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrm),
     /*  87631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87642 */     GIR_RootConstrainSelectedInstOperands,
     /*  87643 */     // GIR_Coverage, 1554,
     /*  87643 */     GIR_EraseRootFromParent_Done,
     /*  87644 */   // Label 1900: @87644
     /*  87644 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(87711), // Rule ID 1556 //
     /*  87649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  87657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87675 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87678 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87682 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87688 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87695 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15086:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBQrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /*  87695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrm),
     /*  87698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87700 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87709 */     GIR_RootConstrainSelectedInstOperands,
     /*  87710 */     // GIR_Coverage, 1556,
     /*  87710 */     GIR_EraseRootFromParent_Done,
     /*  87711 */   // Label 1901: @87711
     /*  87711 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(87778), // Rule ID 1558 //
     /*  87716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  87724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15085:{ *:[iPTR] }, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDBDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /*  87762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrm),
     /*  87765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87776 */     GIR_RootConstrainSelectedInstOperands,
     /*  87777 */     // GIR_Coverage, 1558,
     /*  87777 */     GIR_EraseRootFromParent_Done,
     /*  87778 */   // Label 1902: @87778
     /*  87778 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(87845), // Rule ID 1564 //
     /*  87783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  87791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  87794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87809 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87812 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87816 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87822 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87829 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15077:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /*  87829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrm),
     /*  87832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87834 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87843 */     GIR_RootConstrainSelectedInstOperands,
     /*  87844 */     // GIR_Coverage, 1564,
     /*  87844 */     GIR_EraseRootFromParent_Done,
     /*  87845 */   // Label 1903: @87845
     /*  87845 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(87912), // Rule ID 1566 //
     /*  87850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  87858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  87861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  87864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  87868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87896 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15078:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /*  87896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrm),
     /*  87899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87901 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87910 */     GIR_RootConstrainSelectedInstOperands,
     /*  87911 */     // GIR_Coverage, 1566,
     /*  87911 */     GIR_EraseRootFromParent_Done,
     /*  87912 */   // Label 1904: @87912
     /*  87912 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(87979), // Rule ID 1572 //
     /*  87917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  87925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  87928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  87931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  87935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87943 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  87946 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  87950 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87956 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  87963 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15075:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDrm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /*  87963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrm),
     /*  87966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87968 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  87972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87977 */     GIR_RootConstrainSelectedInstOperands,
     /*  87978 */     // GIR_Coverage, 1572,
     /*  87978 */     GIR_EraseRootFromParent_Done,
     /*  87979 */   // Label 1905: @87979
     /*  87979 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(88046), // Rule ID 1574 //
     /*  87984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  87987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  87992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  87995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  87998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88010 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88013 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88017 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88030 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15076:{ *:[iPTR] }, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFRCZPDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /*  88030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrm),
     /*  88033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88035 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /*  88039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88044 */     GIR_RootConstrainSelectedInstOperands,
     /*  88045 */     // GIR_Coverage, 1574,
     /*  88045 */     GIR_EraseRootFromParent_Done,
     /*  88046 */   // Label 1906: @88046
     /*  88046 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(88113), // Rule ID 3364 //
     /*  88051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88077 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  88080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  88084 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88090 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  88097 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13450:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESIMCrm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /*  88097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrm),
     /*  88100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88102 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  88106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88111 */     GIR_RootConstrainSelectedInstOperands,
     /*  88112 */     // GIR_Coverage, 3364,
     /*  88112 */     GIR_EraseRootFromParent_Done,
     /*  88113 */   // Label 1907: @88113
     /*  88113 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(88149), // Rule ID 1529 //
     /*  88118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubwd),
     /*  88126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88140 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15099:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHSUBWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBWDrr),
     /*  88143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88147 */     GIR_RootConstrainSelectedInstOperands,
     /*  88148 */     // GIR_Coverage, 1529,
     /*  88148 */     GIR_EraseRootFromParent_Done,
     /*  88149 */   // Label 1908: @88149
     /*  88149 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(88185), // Rule ID 1531 //
     /*  88154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubdq),
     /*  88162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88176 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15098:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHSUBDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBDQrr),
     /*  88179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88183 */     GIR_RootConstrainSelectedInstOperands,
     /*  88184 */     // GIR_Coverage, 1531,
     /*  88184 */     GIR_EraseRootFromParent_Done,
     /*  88185 */   // Label 1909: @88185
     /*  88185 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(88221), // Rule ID 1533 //
     /*  88190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphsubbw),
     /*  88198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15097:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHSUBBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBBWrr),
     /*  88215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88219 */     GIR_RootConstrainSelectedInstOperands,
     /*  88220 */     // GIR_Coverage, 1533,
     /*  88220 */     GIR_EraseRootFromParent_Done,
     /*  88221 */   // Label 1910: @88221
     /*  88221 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(88257), // Rule ID 1535 //
     /*  88226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwq),
     /*  88234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88248 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15096:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWQrr),
     /*  88251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88255 */     GIR_RootConstrainSelectedInstOperands,
     /*  88256 */     // GIR_Coverage, 1535,
     /*  88256 */     GIR_EraseRootFromParent_Done,
     /*  88257 */   // Label 1911: @88257
     /*  88257 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(88293), // Rule ID 1537 //
     /*  88262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddwd),
     /*  88270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15095:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDWDrr),
     /*  88287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88291 */     GIR_RootConstrainSelectedInstOperands,
     /*  88292 */     // GIR_Coverage, 1537,
     /*  88292 */     GIR_EraseRootFromParent_Done,
     /*  88293 */   // Label 1912: @88293
     /*  88293 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(88329), // Rule ID 1539 //
     /*  88298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwq),
     /*  88306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15094:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWQrr:{ *:[v2i64] } VR128:{ *:[v8i16] }:$src)
     /*  88320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWQrr),
     /*  88323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88327 */     GIR_RootConstrainSelectedInstOperands,
     /*  88328 */     // GIR_Coverage, 1539,
     /*  88328 */     GIR_EraseRootFromParent_Done,
     /*  88329 */   // Label 1913: @88329
     /*  88329 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(88365), // Rule ID 1541 //
     /*  88334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadduwd),
     /*  88342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88356 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15093:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src)  =>  (VPHADDUWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src)
     /*  88356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUWDrr),
     /*  88359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88363 */     GIR_RootConstrainSelectedInstOperands,
     /*  88364 */     // GIR_Coverage, 1541,
     /*  88364 */     GIR_EraseRootFromParent_Done,
     /*  88365 */   // Label 1914: @88365
     /*  88365 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(88401), // Rule ID 1543 //
     /*  88370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddudq),
     /*  88378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88392 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15092:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDUDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUDQrr),
     /*  88395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88397 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88399 */     GIR_RootConstrainSelectedInstOperands,
     /*  88400 */     // GIR_Coverage, 1543,
     /*  88400 */     GIR_EraseRootFromParent_Done,
     /*  88401 */   // Label 1915: @88401
     /*  88401 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(88437), // Rule ID 1545 //
     /*  88406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubw),
     /*  88414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15091:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBWrr),
     /*  88431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88433 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88435 */     GIR_RootConstrainSelectedInstOperands,
     /*  88436 */     // GIR_Coverage, 1545,
     /*  88436 */     GIR_EraseRootFromParent_Done,
     /*  88437 */   // Label 1916: @88437
     /*  88437 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(88473), // Rule ID 1547 //
     /*  88442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubq),
     /*  88450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88464 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15090:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBQrr),
     /*  88467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88471 */     GIR_RootConstrainSelectedInstOperands,
     /*  88472 */     // GIR_Coverage, 1547,
     /*  88472 */     GIR_EraseRootFromParent_Done,
     /*  88473 */   // Label 1917: @88473
     /*  88473 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(88509), // Rule ID 1549 //
     /*  88478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddubd),
     /*  88486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88500 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15089:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDUBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDUBDrr),
     /*  88503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88507 */     GIR_RootConstrainSelectedInstOperands,
     /*  88508 */     // GIR_Coverage, 1549,
     /*  88508 */     GIR_EraseRootFromParent_Done,
     /*  88509 */   // Label 1918: @88509
     /*  88509 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(88545), // Rule ID 1551 //
     /*  88514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphadddq),
     /*  88522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88536 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15088:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src)  =>  (VPHADDDQrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src)
     /*  88536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDDQrr),
     /*  88539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88543 */     GIR_RootConstrainSelectedInstOperands,
     /*  88544 */     // GIR_Coverage, 1551,
     /*  88544 */     GIR_EraseRootFromParent_Done,
     /*  88545 */   // Label 1919: @88545
     /*  88545 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(88581), // Rule ID 1553 //
     /*  88550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbw),
     /*  88558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15087:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBWrr:{ *:[v8i16] } VR128:{ *:[v16i8] }:$src)
     /*  88572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBWrr),
     /*  88575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88579 */     GIR_RootConstrainSelectedInstOperands,
     /*  88580 */     // GIR_Coverage, 1553,
     /*  88580 */     GIR_EraseRootFromParent_Done,
     /*  88581 */   // Label 1920: @88581
     /*  88581 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(88617), // Rule ID 1555 //
     /*  88586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbq),
     /*  88594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88608 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15086:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBQrr:{ *:[v2i64] } VR128:{ *:[v16i8] }:$src)
     /*  88608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBQrr),
     /*  88611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88615 */     GIR_RootConstrainSelectedInstOperands,
     /*  88616 */     // GIR_Coverage, 1555,
     /*  88616 */     GIR_EraseRootFromParent_Done,
     /*  88617 */   // Label 1921: @88617
     /*  88617 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(88653), // Rule ID 1557 //
     /*  88622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vphaddbd),
     /*  88630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88644 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15085:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src)  =>  (VPHADDBDrr:{ *:[v4i32] } VR128:{ *:[v16i8] }:$src)
     /*  88644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDBDrr),
     /*  88647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88651 */     GIR_RootConstrainSelectedInstOperands,
     /*  88652 */     // GIR_Coverage, 1557,
     /*  88652 */     GIR_EraseRootFromParent_Done,
     /*  88653 */   // Label 1922: @88653
     /*  88653 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(88689), // Rule ID 1559 //
     /*  88658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ss),
     /*  88666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88680 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15080:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZSSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSSrr),
     /*  88683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88687 */     GIR_RootConstrainSelectedInstOperands,
     /*  88688 */     // GIR_Coverage, 1559,
     /*  88688 */     GIR_EraseRootFromParent_Done,
     /*  88689 */   // Label 1923: @88689
     /*  88689 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(88725), // Rule ID 1563 //
     /*  88694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps),
     /*  88702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 15077:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VFRCZPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /*  88716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSrr),
     /*  88719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88723 */     GIR_RootConstrainSelectedInstOperands,
     /*  88724 */     // GIR_Coverage, 1563,
     /*  88724 */     GIR_EraseRootFromParent_Done,
     /*  88725 */   // Label 1924: @88725
     /*  88725 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(88761), // Rule ID 1565 //
     /*  88730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_ps_256),
     /*  88738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  88741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  88744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88752 */     // (intrinsic_wo_chain:{ *:[v8f32] } 15078:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src)  =>  (VFRCZPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /*  88752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPSYrr),
     /*  88755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88759 */     GIR_RootConstrainSelectedInstOperands,
     /*  88760 */     // GIR_Coverage, 1565,
     /*  88760 */     GIR_EraseRootFromParent_Done,
     /*  88761 */   // Label 1925: @88761
     /*  88761 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(88797), // Rule ID 1567 //
     /*  88766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_sd),
     /*  88774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88788 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15079:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZSDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZSDrr),
     /*  88791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88793 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88795 */     GIR_RootConstrainSelectedInstOperands,
     /*  88796 */     // GIR_Coverage, 1567,
     /*  88796 */     GIR_EraseRootFromParent_Done,
     /*  88797 */   // Label 1926: @88797
     /*  88797 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(88833), // Rule ID 1571 //
     /*  88802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd),
     /*  88810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88824 */     // (intrinsic_wo_chain:{ *:[v2f64] } 15075:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src)  =>  (VFRCZPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /*  88824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDrr),
     /*  88827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88831 */     GIR_RootConstrainSelectedInstOperands,
     /*  88832 */     // GIR_Coverage, 1571,
     /*  88832 */     GIR_EraseRootFromParent_Done,
     /*  88833 */   // Label 1927: @88833
     /*  88833 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(88869), // Rule ID 1573 //
     /*  88838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  88841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vfrcz_pd_256),
     /*  88846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  88849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  88852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  88860 */     // (intrinsic_wo_chain:{ *:[v4f64] } 15076:{ *:[iPTR] }, VR256:{ *:[v4f64] }:$src)  =>  (VFRCZPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /*  88860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFRCZPDYrr),
     /*  88863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88867 */     GIR_RootConstrainSelectedInstOperands,
     /*  88868 */     // GIR_Coverage, 1573,
     /*  88868 */     GIR_EraseRootFromParent_Done,
     /*  88869 */   // Label 1928: @88869
     /*  88869 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(88905), // Rule ID 3363 //
     /*  88874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  88877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88896 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13450:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (VAESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESIMCrr),
     /*  88899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88903 */     GIR_RootConstrainSelectedInstOperands,
     /*  88904 */     // GIR_Coverage, 3363,
     /*  88904 */     GIR_EraseRootFromParent_Done,
     /*  88905 */   // Label 1929: @88905
     /*  88905 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(88941), // Rule ID 3365 //
     /*  88910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  88913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesimc),
     /*  88918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  88921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  88924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88932 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13450:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1)  =>  (AESIMCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1)
     /*  88932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESIMCrr),
     /*  88935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  88939 */     GIR_RootConstrainSelectedInstOperands,
     /*  88940 */     // GIR_Coverage, 3365,
     /*  88940 */     GIR_EraseRootFromParent_Done,
     /*  88941 */   // Label 1930: @88941
     /*  88941 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(88979), // Rule ID 18266 //
     /*  88946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  88949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  88968 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14785:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  88968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSQRTSSr_Int),
     /*  88971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88975 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  88977 */     GIR_RootConstrainSelectedInstOperands,
     /*  88978 */     // GIR_Coverage, 18266,
     /*  88978 */     GIR_EraseRootFromParent_Done,
     /*  88979 */   // Label 1931: @88979
     /*  88979 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(89017), // Rule ID 18270 //
     /*  88984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  88987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rsqrt_ss),
     /*  88992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  88995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  88998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89006 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14785:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRSQRTSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRSQRTSSr_Int),
     /*  89009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89013 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89015 */     GIR_RootConstrainSelectedInstOperands,
     /*  89016 */     // GIR_Coverage, 18270,
     /*  89016 */     GIR_EraseRootFromParent_Done,
     /*  89017 */   // Label 1932: @89017
     /*  89017 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(89055), // Rule ID 18286 //
     /*  89022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /*  89025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89044 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14783:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (RCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RCPSSr_Int),
     /*  89047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89051 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89053 */     GIR_RootConstrainSelectedInstOperands,
     /*  89054 */     // GIR_Coverage, 18286,
     /*  89054 */     GIR_EraseRootFromParent_Done,
     /*  89055 */   // Label 1933: @89055
     /*  89055 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(89093), // Rule ID 18290 //
     /*  89060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse_rcp_ss),
     /*  89068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89082 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14783:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src)  =>  (VRCPSSr_Int:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src, VR128:{ *:[v4f32] }:$src)
     /*  89082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VRCPSSr_Int),
     /*  89085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89087 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  89091 */     GIR_RootConstrainSelectedInstOperands,
     /*  89092 */     // GIR_Coverage, 18290,
     /*  89092 */     GIR_EraseRootFromParent_Done,
     /*  89093 */   // Label 1934: @89093
     /*  89093 */   GIM_Reject,
     /*  89094 */ // Label 1887: @89094
     /*  89094 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(95875),
     /*  89099 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  89102 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(89174), // Rule ID 3368 //
     /*  89107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  89110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  89115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  89118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89133 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89136 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89140 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89144 */     // MIs[0] src2
     /*  89144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  89147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89149 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89156 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13451:{ *:[iPTR] }, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  89156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rm),
     /*  89159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /*  89165 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  89167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89172 */     GIR_RootConstrainSelectedInstOperands,
     /*  89173 */     // GIR_Coverage, 3368,
     /*  89173 */     GIR_EraseRootFromParent_Done,
     /*  89174 */   // Label 1936: @89174
     /*  89174 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(89250), // Rule ID 16790 //
     /*  89179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  89187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89212 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89215 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89219 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89232 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15054:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rm),
     /*  89235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89248 */     GIR_RootConstrainSelectedInstOperands,
     /*  89249 */     // GIR_Coverage, 16790,
     /*  89249 */     GIR_EraseRootFromParent_Done,
     /*  89250 */   // Label 1937: @89250
     /*  89250 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(89326), // Rule ID 16792 //
     /*  89255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  89263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89308 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15055:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rm),
     /*  89311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89313 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89324 */     GIR_RootConstrainSelectedInstOperands,
     /*  89325 */     // GIR_Coverage, 16792,
     /*  89325 */     GIR_EraseRootFromParent_Done,
     /*  89326 */   // Label 1938: @89326
     /*  89326 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(89402), // Rule ID 16796 //
     /*  89331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  89339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  89356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89364 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89371 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89377 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rm),
     /*  89387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89389 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89391 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89400 */     GIR_RootConstrainSelectedInstOperands,
     /*  89401 */     // GIR_Coverage, 16796,
     /*  89401 */     GIR_EraseRootFromParent_Done,
     /*  89402 */   // Label 1939: @89402
     /*  89402 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(89478), // Rule ID 16798 //
     /*  89407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  89410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  89415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  89418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  89421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  89424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  89432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89460 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15058:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Z256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rm),
     /*  89463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89467 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89476 */     GIR_RootConstrainSelectedInstOperands,
     /*  89477 */     // GIR_Coverage, 16798,
     /*  89477 */     GIR_EraseRootFromParent_Done,
     /*  89478 */   // Label 1940: @89478
     /*  89478 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(89554), // Rule ID 3023 //
     /*  89483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  89491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89536 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14923:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrm),
     /*  89539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89541 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89552 */     GIR_RootConstrainSelectedInstOperands,
     /*  89553 */     // GIR_Coverage, 3023,
     /*  89553 */     GIR_EraseRootFromParent_Done,
     /*  89554 */   // Label 1941: @89554
     /*  89554 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(89630), // Rule ID 3025 //
     /*  89559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  89567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89612 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14927:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrm),
     /*  89615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89628 */     GIR_RootConstrainSelectedInstOperands,
     /*  89629 */     // GIR_Coverage, 3025,
     /*  89629 */     GIR_EraseRootFromParent_Done,
     /*  89630 */   // Label 1942: @89630
     /*  89630 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(89706), // Rule ID 3027 //
     /*  89635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  89643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  89646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  89649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89668 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89675 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89681 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89688 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14925:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrm),
     /*  89691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89693 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89695 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89704 */     GIR_RootConstrainSelectedInstOperands,
     /*  89705 */     // GIR_Coverage, 3027,
     /*  89705 */     GIR_EraseRootFromParent_Done,
     /*  89706 */   // Label 1943: @89706
     /*  89706 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(89782), // Rule ID 3029 //
     /*  89711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  89719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89744 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89747 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89751 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89757 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89764 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14907:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrm),
     /*  89767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89780 */     GIR_RootConstrainSelectedInstOperands,
     /*  89781 */     // GIR_Coverage, 3029,
     /*  89781 */     GIR_EraseRootFromParent_Done,
     /*  89782 */   // Label 1944: @89782
     /*  89782 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(89858), // Rule ID 3031 //
     /*  89787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  89790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  89795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  89812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89840 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14913:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrm),
     /*  89843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89856 */     GIR_RootConstrainSelectedInstOperands,
     /*  89857 */     // GIR_Coverage, 3031,
     /*  89857 */     GIR_EraseRootFromParent_Done,
     /*  89858 */   // Label 1945: @89858
     /*  89858 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(89934), // Rule ID 3047 //
     /*  89863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  89871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  89874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  89877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  89880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89916 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13814:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrm),
     /*  89919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89921 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  89927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  89932 */     GIR_RootConstrainSelectedInstOperands,
     /*  89933 */     // GIR_Coverage, 3047,
     /*  89933 */     GIR_EraseRootFromParent_Done,
     /*  89934 */   // Label 1946: @89934
     /*  89934 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(90010), // Rule ID 3049 //
     /*  89939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  89942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  89947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  89950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  89953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  89956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  89964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  89968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  89972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  89975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  89979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  89983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  89992 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13816:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  89992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrm),
     /*  89995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  89997 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  89999 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90008 */     GIR_RootConstrainSelectedInstOperands,
     /*  90009 */     // GIR_Coverage, 3049,
     /*  90009 */     GIR_EraseRootFromParent_Done,
     /*  90010 */   // Label 1947: @90010
     /*  90010 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(90086), // Rule ID 3051 //
     /*  90015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  90023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  90026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  90029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  90032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90048 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90051 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90055 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90068 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13815:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSIGNDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrm),
     /*  90071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90073 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90084 */     GIR_RootConstrainSelectedInstOperands,
     /*  90085 */     // GIR_Coverage, 3051,
     /*  90085 */     GIR_EraseRootFromParent_Done,
     /*  90086 */   // Label 1948: @90086
     /*  90086 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(90162), // Rule ID 3053 //
     /*  90091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  90099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90144 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13801:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrm),
     /*  90147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90149 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90160 */     GIR_RootConstrainSelectedInstOperands,
     /*  90161 */     // GIR_Coverage, 3053,
     /*  90161 */     GIR_EraseRootFromParent_Done,
     /*  90162 */   // Label 1949: @90162
     /*  90162 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(90238), // Rule ID 3055 //
     /*  90167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  90170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  90175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  90178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  90181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  90184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  90192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90220 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13804:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPHSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrm),
     /*  90223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90236 */     GIR_RootConstrainSelectedInstOperands,
     /*  90237 */     // GIR_Coverage, 3055,
     /*  90237 */     GIR_EraseRootFromParent_Done,
     /*  90238 */   // Label 1950: @90238
     /*  90238 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(90314), // Rule ID 3310 //
     /*  90243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90296 */     // (intrinsic_wo_chain:{ *:[i32] } 14881:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8),
     /*  90299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90301 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90303 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90312 */     GIR_RootConstrainSelectedInstOperands,
     /*  90313 */     // GIR_Coverage, 3310,
     /*  90313 */     GIR_EraseRootFromParent_Done,
     /*  90314 */   // Label 1951: @90314
     /*  90314 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(90390), // Rule ID 3312 //
     /*  90319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90352 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90355 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90359 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90372 */     // (intrinsic_wo_chain:{ *:[i32] } 14879:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16),
     /*  90375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90377 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90379 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90388 */     GIR_RootConstrainSelectedInstOperands,
     /*  90389 */     // GIR_Coverage, 3312,
     /*  90389 */     GIR_EraseRootFromParent_Done,
     /*  90390 */   // Label 1952: @90390
     /*  90390 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(90466), // Rule ID 3314 //
     /*  90395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90428 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90431 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90435 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90448 */     // (intrinsic_wo_chain:{ *:[i32] } 14880:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32),
     /*  90451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90453 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90464 */     GIR_RootConstrainSelectedInstOperands,
     /*  90465 */     // GIR_Coverage, 3314,
     /*  90465 */     GIR_EraseRootFromParent_Done,
     /*  90466 */   // Label 1953: @90466
     /*  90466 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(90542), // Rule ID 3316 //
     /*  90471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  90474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90504 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90507 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90524 */     // (intrinsic_wo_chain:{ *:[i64] } 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64),
     /*  90527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90540 */     GIR_RootConstrainSelectedInstOperands,
     /*  90541 */     // GIR_Coverage, 3316,
     /*  90541 */     GIR_EraseRootFromParent_Done,
     /*  90542 */   // Label 1954: @90542
     /*  90542 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(90618), // Rule ID 3318 //
     /*  90547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  90555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  90564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90583 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90587 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90600 */     // (intrinsic_wo_chain:{ *:[i32] } 14881:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m8_EVEX),
     /*  90603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90616 */     GIR_RootConstrainSelectedInstOperands,
     /*  90617 */     // GIR_Coverage, 3318,
     /*  90617 */     GIR_EraseRootFromParent_Done,
     /*  90618 */   // Label 1955: @90618
     /*  90618 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(90694), // Rule ID 3320 //
     /*  90623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  90631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  90640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90656 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90663 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90676 */     // (intrinsic_wo_chain:{ *:[i32] } 14879:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m16_EVEX),
     /*  90679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90692 */     GIR_RootConstrainSelectedInstOperands,
     /*  90693 */     // GIR_Coverage, 3320,
     /*  90693 */     GIR_EraseRootFromParent_Done,
     /*  90694 */   // Label 1956: @90694
     /*  90694 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(90770), // Rule ID 3322 //
     /*  90699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  90707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  90710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  90713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  90716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  90724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90752 */     // (intrinsic_wo_chain:{ *:[i32] } 14880:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r32m32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32m32_EVEX),
     /*  90755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90768 */     GIR_RootConstrainSelectedInstOperands,
     /*  90769 */     // GIR_Coverage, 3322,
     /*  90769 */     GIR_EraseRootFromParent_Done,
     /*  90770 */   // Label 1957: @90770
     /*  90770 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(90846), // Rule ID 3324 //
     /*  90775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  90778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  90783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  90786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  90789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  90792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  90800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90808 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90811 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90828 */     // (intrinsic_wo_chain:{ *:[i64] } 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CRC32r64m64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64m64_EVEX),
     /*  90831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90835 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90839 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90844 */     GIR_RootConstrainSelectedInstOperands,
     /*  90845 */     // GIR_Coverage, 3324,
     /*  90845 */     GIR_EraseRootFromParent_Done,
     /*  90846 */   // Label 1958: @90846
     /*  90846 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(90922), // Rule ID 3340 //
     /*  90851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  90859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90884 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90887 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90904 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13444:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrm),
     /*  90907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90909 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90920 */     GIR_RootConstrainSelectedInstOperands,
     /*  90921 */     // GIR_Coverage, 3340,
     /*  90921 */     GIR_EraseRootFromParent_Done,
     /*  90922 */   // Label 1959: @90922
     /*  90922 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(90998), // Rule ID 3342 //
     /*  90927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  90930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  90935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  90938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  90944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  90952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  90956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  90960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  90963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  90967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  90971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  90980 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13447:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  90980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrm),
     /*  90983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  90985 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  90987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  90991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  90996 */     GIR_RootConstrainSelectedInstOperands,
     /*  90997 */     // GIR_Coverage, 3342,
     /*  90997 */     GIR_EraseRootFromParent_Done,
     /*  90998 */   // Label 1960: @90998
     /*  90998 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(91074), // Rule ID 3344 //
     /*  91003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  91006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  91011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91056 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13438:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrm),
     /*  91059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91061 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91072 */     GIR_RootConstrainSelectedInstOperands,
     /*  91073 */     // GIR_Coverage, 3344,
     /*  91073 */     GIR_EraseRootFromParent_Done,
     /*  91074 */   // Label 1961: @91074
     /*  91074 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(91150), // Rule ID 3346 //
     /*  91079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  91082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  91087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91132 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13441:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrm),
     /*  91135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91137 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91148 */     GIR_RootConstrainSelectedInstOperands,
     /*  91149 */     // GIR_Coverage, 3346,
     /*  91149 */     GIR_EraseRootFromParent_Done,
     /*  91150 */   // Label 1962: @91150
     /*  91150 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(91226), // Rule ID 3348 //
     /*  91155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91188 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91191 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91201 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91208 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13445:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrm),
     /*  91211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91224 */     GIR_RootConstrainSelectedInstOperands,
     /*  91225 */     // GIR_Coverage, 3348,
     /*  91225 */     GIR_EraseRootFromParent_Done,
     /*  91226 */   // Label 1963: @91226
     /*  91226 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(91302), // Rule ID 3350 //
     /*  91231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  91239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91284 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13448:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrm),
     /*  91287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91300 */     GIR_RootConstrainSelectedInstOperands,
     /*  91301 */     // GIR_Coverage, 3350,
     /*  91301 */     GIR_EraseRootFromParent_Done,
     /*  91302 */   // Label 1964: @91302
     /*  91302 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(91378), // Rule ID 3352 //
     /*  91307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  91315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91360 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13439:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrm),
     /*  91363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91365 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91376 */     GIR_RootConstrainSelectedInstOperands,
     /*  91377 */     // GIR_Coverage, 3352,
     /*  91377 */     GIR_EraseRootFromParent_Done,
     /*  91378 */   // Label 1965: @91378
     /*  91378 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(91454), // Rule ID 3354 //
     /*  91383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  91386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  91391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91436 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13442:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrm),
     /*  91439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91452 */     GIR_RootConstrainSelectedInstOperands,
     /*  91453 */     // GIR_Coverage, 3354,
     /*  91453 */     GIR_EraseRootFromParent_Done,
     /*  91454 */   // Label 1966: @91454
     /*  91454 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(91530), // Rule ID 3565 //
     /*  91459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  91467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91512 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15054:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rm),
     /*  91515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91528 */     GIR_RootConstrainSelectedInstOperands,
     /*  91529 */     // GIR_Coverage, 3565,
     /*  91529 */     GIR_EraseRootFromParent_Done,
     /*  91530 */   // Label 1967: @91530
     /*  91530 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(91606), // Rule ID 3567 //
     /*  91535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  91543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91588 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15055:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrm),
     /*  91591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91604 */     GIR_RootConstrainSelectedInstOperands,
     /*  91605 */     // GIR_Coverage, 3567,
     /*  91605 */     GIR_EraseRootFromParent_Done,
     /*  91606 */   // Label 1968: @91606
     /*  91606 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(91682), // Rule ID 3569 //
     /*  91611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  91619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  91622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  91636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91664 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rm),
     /*  91667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91680 */     GIR_RootConstrainSelectedInstOperands,
     /*  91681 */     // GIR_Coverage, 3569,
     /*  91681 */     GIR_EraseRootFromParent_Done,
     /*  91682 */   // Label 1969: @91682
     /*  91682 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(91758), // Rule ID 3571 //
     /*  91687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  91690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  91695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  91698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  91701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  91704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  91712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91720 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91723 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91727 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91733 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91740 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15058:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Yrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrm),
     /*  91743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91745 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91747 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91756 */     GIR_RootConstrainSelectedInstOperands,
     /*  91757 */     // GIR_Coverage, 3571,
     /*  91757 */     GIR_EraseRootFromParent_Done,
     /*  91758 */   // Label 1970: @91758
     /*  91758 */   GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(91834), // Rule ID 14061 //
     /*  91763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  91771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  91774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  91777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  91780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  91788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91796 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91799 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91803 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91816 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13444:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rm),
     /*  91819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91823 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91832 */     GIR_RootConstrainSelectedInstOperands,
     /*  91833 */     // GIR_Coverage, 14061,
     /*  91833 */     GIR_EraseRootFromParent_Done,
     /*  91834 */   // Label 1971: @91834
     /*  91834 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(91910), // Rule ID 14063 //
     /*  91839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  91847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  91850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  91853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  91856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  91864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91885 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91892 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13445:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rm),
     /*  91895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91897 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91899 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91908 */     GIR_RootConstrainSelectedInstOperands,
     /*  91909 */     // GIR_Coverage, 14063,
     /*  91909 */     GIR_EraseRootFromParent_Done,
     /*  91910 */   // Label 1972: @91910
     /*  91910 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(91986), // Rule ID 14065 //
     /*  91915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  91918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  91923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  91926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  91929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  91932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  91944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  91948 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  91951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  91955 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  91959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91961 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  91968 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13446:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  91968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrm),
     /*  91971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  91975 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  91979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91984 */     GIR_RootConstrainSelectedInstOperands,
     /*  91985 */     // GIR_Coverage, 14065,
     /*  91985 */     GIR_EraseRootFromParent_Done,
     /*  91986 */   // Label 1973: @91986
     /*  91986 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(92062), // Rule ID 14067 //
     /*  91991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  91994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  91999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13447:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rm),
     /*  92047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92049 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92060 */     GIR_RootConstrainSelectedInstOperands,
     /*  92061 */     // GIR_Coverage, 14067,
     /*  92061 */     GIR_EraseRootFromParent_Done,
     /*  92062 */   // Label 1974: @92062
     /*  92062 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(92138), // Rule ID 14069 //
     /*  92067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  92075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92120 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13448:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rm),
     /*  92123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92136 */     GIR_RootConstrainSelectedInstOperands,
     /*  92137 */     // GIR_Coverage, 14069,
     /*  92137 */     GIR_EraseRootFromParent_Done,
     /*  92138 */   // Label 1975: @92138
     /*  92138 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(92214), // Rule ID 14071 //
     /*  92143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  92151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92179 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92183 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92196 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13449:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESENCLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrm),
     /*  92199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92212 */     GIR_RootConstrainSelectedInstOperands,
     /*  92213 */     // GIR_Coverage, 14071,
     /*  92213 */     GIR_EraseRootFromParent_Done,
     /*  92214 */   // Label 1976: @92214
     /*  92214 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(92290), // Rule ID 14073 //
     /*  92219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  92227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92272 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13438:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rm),
     /*  92275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92288 */     GIR_RootConstrainSelectedInstOperands,
     /*  92289 */     // GIR_Coverage, 14073,
     /*  92289 */     GIR_EraseRootFromParent_Done,
     /*  92290 */   // Label 1977: @92290
     /*  92290 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(92366), // Rule ID 14075 //
     /*  92295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  92303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92335 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92348 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13439:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rm),
     /*  92351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92364 */     GIR_RootConstrainSelectedInstOperands,
     /*  92365 */     // GIR_Coverage, 14075,
     /*  92365 */     GIR_EraseRootFromParent_Done,
     /*  92366 */   // Label 1978: @92366
     /*  92366 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(92442), // Rule ID 14077 //
     /*  92371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  92379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92404 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92407 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92411 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92424 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13440:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrm),
     /*  92427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92429 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92431 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92440 */     GIR_RootConstrainSelectedInstOperands,
     /*  92441 */     // GIR_Coverage, 14077,
     /*  92441 */     GIR_EraseRootFromParent_Done,
     /*  92442 */   // Label 1979: @92442
     /*  92442 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(92518), // Rule ID 14079 //
     /*  92447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  92455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13441:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rm),
     /*  92503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92505 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92507 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92516 */     GIR_RootConstrainSelectedInstOperands,
     /*  92517 */     // GIR_Coverage, 14079,
     /*  92517 */     GIR_EraseRootFromParent_Done,
     /*  92518 */   // Label 1980: @92518
     /*  92518 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(92594), // Rule ID 14081 //
     /*  92523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  92526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  92531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  92534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  92537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  92540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92576 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13442:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rm),
     /*  92579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92581 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92592 */     GIR_RootConstrainSelectedInstOperands,
     /*  92593 */     // GIR_Coverage, 14081,
     /*  92593 */     GIR_EraseRootFromParent_Done,
     /*  92594 */   // Label 1981: @92594
     /*  92594 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(92670), // Rule ID 14083 //
     /*  92599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  92602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  92607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  92610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  92613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  92616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92652 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13443:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VAESDECLASTZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrm),
     /*  92655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92668 */     GIR_RootConstrainSelectedInstOperands,
     /*  92669 */     // GIR_Coverage, 14083,
     /*  92669 */     GIR_EraseRootFromParent_Done,
     /*  92670 */   // Label 1982: @92670
     /*  92670 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(92746), // Rule ID 16794 //
     /*  92675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  92683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92721 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92728 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15056:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4KEY4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrm),
     /*  92731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92744 */     GIR_RootConstrainSelectedInstOperands,
     /*  92745 */     // GIR_Coverage, 16794,
     /*  92745 */     GIR_EraseRootFromParent_Done,
     /*  92746 */   // Label 1983: @92746
     /*  92746 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(92822), // Rule ID 16800 //
     /*  92751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  92754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  92759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  92762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  92765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  92768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  92776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  92784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  92787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  92791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  92795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  92804 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15059:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM4RNDS4Zrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /*  92804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrm),
     /*  92807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  92815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92820 */     GIR_RootConstrainSelectedInstOperands,
     /*  92821 */     // GIR_Coverage, 16800,
     /*  92821 */     GIR_EraseRootFromParent_Done,
     /*  92822 */   // Label 1984: @92822
     /*  92822 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(92863), // Rule ID 3367 //
     /*  92827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX),
     /*  92830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92849 */     // MIs[0] src2
     /*  92849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92852 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13451:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (VAESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESKEYGENASSIST128rr),
     /*  92855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92857 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92859 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92861 */     GIR_RootConstrainSelectedInstOperands,
     /*  92862 */     // GIR_Coverage, 3367,
     /*  92862 */     GIR_EraseRootFromParent_Done,
     /*  92863 */   // Label 1985: @92863
     /*  92863 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(92904), // Rule ID 3369 //
     /*  92868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  92871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aeskeygenassist),
     /*  92876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  92890 */     // MIs[0] src2
     /*  92890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  92893 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13451:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)  =>  (AESKEYGENASSIST128rr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (timm:{ *:[i8] }):$src2)
     /*  92893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESKEYGENASSIST128rr),
     /*  92896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92898 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92900 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92902 */     GIR_RootConstrainSelectedInstOperands,
     /*  92903 */     // GIR_Coverage, 3369,
     /*  92903 */     GIR_EraseRootFromParent_Done,
     /*  92904 */   // Label 1986: @92904
     /*  92904 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(92949), // Rule ID 16789 //
     /*  92909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  92917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  92938 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15054:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  92938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z128rr),
     /*  92941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92943 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92945 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92947 */     GIR_RootConstrainSelectedInstOperands,
     /*  92948 */     // GIR_Coverage, 16789,
     /*  92948 */     GIR_EraseRootFromParent_Done,
     /*  92949 */   // Label 1987: @92949
     /*  92949 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(92994), // Rule ID 16791 //
     /*  92954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  92957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  92962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  92965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  92968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  92971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  92983 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15055:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  92983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Z256rr),
     /*  92986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  92988 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  92990 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  92992 */     GIR_RootConstrainSelectedInstOperands,
     /*  92993 */     // GIR_Coverage, 16791,
     /*  92993 */     GIR_EraseRootFromParent_Done,
     /*  92994 */   // Label 1988: @92994
     /*  92994 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(93039), // Rule ID 16795 //
     /*  92999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  93002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  93007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  93028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4Z128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /*  93028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z128rr),
     /*  93031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93033 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93035 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93037 */     GIR_RootConstrainSelectedInstOperands,
     /*  93038 */     // GIR_Coverage, 16795,
     /*  93038 */     GIR_EraseRootFromParent_Done,
     /*  93039 */   // Label 1989: @93039
     /*  93039 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(93084), // Rule ID 16797 //
     /*  93044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasSM4),
     /*  93047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  93052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  93073 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15058:{ *:[iPTR] }, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Z256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /*  93073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Z256rr),
     /*  93076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93080 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93082 */     GIR_RootConstrainSelectedInstOperands,
     /*  93083 */     // GIR_Coverage, 16797,
     /*  93083 */     GIR_EraseRootFromParent_Done,
     /*  93084 */   // Label 1990: @93084
     /*  93084 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(93129), // Rule ID 3022 //
     /*  93089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93118 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14923:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBrr),
     /*  93121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93125 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93127 */     GIR_RootConstrainSelectedInstOperands,
     /*  93128 */     // GIR_Coverage, 3022,
     /*  93128 */     GIR_EraseRootFromParent_Done,
     /*  93129 */   // Label 1991: @93129
     /*  93129 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(93174), // Rule ID 3024 //
     /*  93134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93163 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14927:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWrr),
     /*  93166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93168 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93170 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93172 */     GIR_RootConstrainSelectedInstOperands,
     /*  93173 */     // GIR_Coverage, 3024,
     /*  93173 */     GIR_EraseRootFromParent_Done,
     /*  93174 */   // Label 1992: @93174
     /*  93174 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(93219), // Rule ID 3026 //
     /*  93179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93208 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14925:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDrr),
     /*  93211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93213 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93215 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93217 */     GIR_RootConstrainSelectedInstOperands,
     /*  93218 */     // GIR_Coverage, 3026,
     /*  93218 */     GIR_EraseRootFromParent_Done,
     /*  93219 */   // Label 1993: @93219
     /*  93219 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(93264), // Rule ID 3028 //
     /*  93224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93253 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14907:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWrr),
     /*  93256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93258 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93260 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93262 */     GIR_RootConstrainSelectedInstOperands,
     /*  93263 */     // GIR_Coverage, 3028,
     /*  93263 */     GIR_EraseRootFromParent_Done,
     /*  93264 */   // Label 1994: @93264
     /*  93264 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(93309), // Rule ID 3030 //
     /*  93269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  93272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93298 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14913:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWrr),
     /*  93301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93305 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93307 */     GIR_RootConstrainSelectedInstOperands,
     /*  93308 */     // GIR_Coverage, 3030,
     /*  93308 */     GIR_EraseRootFromParent_Done,
     /*  93309 */   // Label 1995: @93309
     /*  93309 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(93354), // Rule ID 3046 //
     /*  93314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_b),
     /*  93322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /*  93325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /*  93328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /*  93331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93343 */     // (intrinsic_wo_chain:{ *:[v32i8] } 13814:{ *:[iPTR] }, VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSIGNBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /*  93343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNBYrr),
     /*  93346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93352 */     GIR_RootConstrainSelectedInstOperands,
     /*  93353 */     // GIR_Coverage, 3046,
     /*  93353 */     GIR_EraseRootFromParent_Done,
     /*  93354 */   // Label 1996: @93354
     /*  93354 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(93399), // Rule ID 3048 //
     /*  93359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_w),
     /*  93367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93388 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13816:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSIGNWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNWYrr),
     /*  93391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93393 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93395 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93397 */     GIR_RootConstrainSelectedInstOperands,
     /*  93398 */     // GIR_Coverage, 3048,
     /*  93398 */     GIR_EraseRootFromParent_Done,
     /*  93399 */   // Label 1997: @93399
     /*  93399 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(93444), // Rule ID 3050 //
     /*  93404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_psign_d),
     /*  93412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  93415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  93418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  93421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93433 */     // (intrinsic_wo_chain:{ *:[v8i32] } 13815:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPSIGNDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  93433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSIGNDYrr),
     /*  93436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93440 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93442 */     GIR_RootConstrainSelectedInstOperands,
     /*  93443 */     // GIR_Coverage, 3050,
     /*  93443 */     GIR_EraseRootFromParent_Done,
     /*  93444 */   // Label 1998: @93444
     /*  93444 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(93489), // Rule ID 3052 //
     /*  93449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phadd_sw),
     /*  93457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93478 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13801:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHADDSWYrr),
     /*  93481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93485 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93487 */     GIR_RootConstrainSelectedInstOperands,
     /*  93488 */     // GIR_Coverage, 3052,
     /*  93488 */     GIR_EraseRootFromParent_Done,
     /*  93489 */   // Label 1999: @93489
     /*  93489 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(93534), // Rule ID 3054 //
     /*  93494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /*  93497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_phsub_sw),
     /*  93502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /*  93505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /*  93508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /*  93511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  93523 */     // (intrinsic_wo_chain:{ *:[v16i16] } 13804:{ *:[iPTR] }, VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPHSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /*  93523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPHSUBSWYrr),
     /*  93526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93530 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93532 */     GIR_RootConstrainSelectedInstOperands,
     /*  93533 */     // GIR_Coverage, 3054,
     /*  93533 */     GIR_EraseRootFromParent_Done,
     /*  93534 */   // Label 2000: @93534
     /*  93534 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(93579), // Rule ID 3064 //
     /*  93539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_b_128),
     /*  93547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  93556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 14923:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSIGNBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /*  93568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNBrr),
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93573 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93575 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93577 */     GIR_RootConstrainSelectedInstOperands,
     /*  93578 */     // GIR_Coverage, 3064,
     /*  93578 */     GIR_EraseRootFromParent_Done,
     /*  93579 */   // Label 2001: @93579
     /*  93579 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(93624), // Rule ID 3066 //
     /*  93584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_w_128),
     /*  93592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93613 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14927:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSIGNWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNWrr),
     /*  93616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93620 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93622 */     GIR_RootConstrainSelectedInstOperands,
     /*  93623 */     // GIR_Coverage, 3066,
     /*  93623 */     GIR_EraseRootFromParent_Done,
     /*  93624 */   // Label 2002: @93624
     /*  93624 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(93669), // Rule ID 3068 //
     /*  93629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_psign_d_128),
     /*  93637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93658 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14925:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PSIGNDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  93658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PSIGNDrr),
     /*  93661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93665 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93667 */     GIR_RootConstrainSelectedInstOperands,
     /*  93668 */     // GIR_Coverage, 3068,
     /*  93668 */     GIR_EraseRootFromParent_Done,
     /*  93669 */   // Label 2003: @93669
     /*  93669 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(93714), // Rule ID 3072 //
     /*  93674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phadd_sw_128),
     /*  93682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93703 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14907:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHADDSWrr),
     /*  93706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93708 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93710 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93712 */     GIR_RootConstrainSelectedInstOperands,
     /*  93713 */     // GIR_Coverage, 3072,
     /*  93713 */     GIR_EraseRootFromParent_Done,
     /*  93714 */   // Label 2004: @93714
     /*  93714 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(93759), // Rule ID 3074 //
     /*  93719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /*  93722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_ssse3_phsub_sw_128),
     /*  93727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  93748 */     // (intrinsic_wo_chain:{ *:[v8i16] } 14913:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PHSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /*  93748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PHSUBSWrr),
     /*  93751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93753 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93755 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93757 */     GIR_RootConstrainSelectedInstOperands,
     /*  93758 */     // GIR_Coverage, 3074,
     /*  93758 */     GIR_EraseRootFromParent_Done,
     /*  93759 */   // Label 2005: @93759
     /*  93759 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(93804), // Rule ID 3309 //
     /*  93764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93793 */     // (intrinsic_wo_chain:{ *:[i32] } 14881:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8),
     /*  93796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93800 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93802 */     GIR_RootConstrainSelectedInstOperands,
     /*  93803 */     // GIR_Coverage, 3309,
     /*  93803 */     GIR_EraseRootFromParent_Done,
     /*  93804 */   // Label 2006: @93804
     /*  93804 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(93849), // Rule ID 3311 //
     /*  93809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  93826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  93838 */     // (intrinsic_wo_chain:{ *:[i32] } 14879:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  93838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16),
     /*  93841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93845 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93847 */     GIR_RootConstrainSelectedInstOperands,
     /*  93848 */     // GIR_Coverage, 3311,
     /*  93848 */     GIR_EraseRootFromParent_Done,
     /*  93849 */   // Label 2007: @93849
     /*  93849 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(93894), // Rule ID 3313 //
     /*  93854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  93862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93883 */     // (intrinsic_wo_chain:{ *:[i32] } 14880:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  93883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32),
     /*  93886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93888 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93890 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93892 */     GIR_RootConstrainSelectedInstOperands,
     /*  93893 */     // GIR_Coverage, 3313,
     /*  93893 */     GIR_EraseRootFromParent_Done,
     /*  93894 */   // Label 2008: @93894
     /*  93894 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(93939), // Rule ID 3315 //
     /*  93899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_NoEGPR),
     /*  93902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  93907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  93928 */     // (intrinsic_wo_chain:{ *:[i64] } 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  93928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64),
     /*  93931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93933 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93935 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93937 */     GIR_RootConstrainSelectedInstOperands,
     /*  93938 */     // GIR_Coverage, 3315,
     /*  93938 */     GIR_EraseRootFromParent_Done,
     /*  93939 */   // Label 2009: @93939
     /*  93939 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(93984), // Rule ID 3317 //
     /*  93944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_8),
     /*  93952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /*  93961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  93969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /*  93973 */     // (intrinsic_wo_chain:{ *:[i32] } 14881:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (CRC32r32r8_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)
     /*  93973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r8_EVEX),
     /*  93976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93978 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  93980 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  93982 */     GIR_RootConstrainSelectedInstOperands,
     /*  93983 */     // GIR_Coverage, 3317,
     /*  93983 */     GIR_EraseRootFromParent_Done,
     /*  93984 */   // Label 2010: @93984
     /*  93984 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(94029), // Rule ID 3319 //
     /*  93989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  93992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_16),
     /*  93997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  94006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /*  94018 */     // (intrinsic_wo_chain:{ *:[i32] } 14879:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)  =>  (CRC32r32r16_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR16:{ *:[i16] }:$src2)
     /*  94018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r16_EVEX),
     /*  94021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94025 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94027 */     GIR_RootConstrainSelectedInstOperands,
     /*  94028 */     // GIR_Coverage, 3319,
     /*  94028 */     GIR_EraseRootFromParent_Done,
     /*  94029 */   // Label 2011: @94029
     /*  94029 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(94074), // Rule ID 3321 //
     /*  94034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_32_32),
     /*  94042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /*  94063 */     // (intrinsic_wo_chain:{ *:[i32] } 14880:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)  =>  (CRC32r32r32_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /*  94063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r32r32_EVEX),
     /*  94066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94068 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94070 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94072 */     GIR_RootConstrainSelectedInstOperands,
     /*  94073 */     // GIR_Coverage, 3321,
     /*  94073 */     GIR_EraseRootFromParent_Done,
     /*  94074 */   // Label 2012: @94074
     /*  94074 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(94119), // Rule ID 3323 //
     /*  94079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC32_HasEGPR_In64BitMode),
     /*  94082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse42_crc32_64_64),
     /*  94087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  94090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  94093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  94096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /*  94108 */     // (intrinsic_wo_chain:{ *:[i64] } 14882:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (CRC32r64r64_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /*  94108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CRC32r64r64_EVEX),
     /*  94111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94115 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94117 */     GIR_RootConstrainSelectedInstOperands,
     /*  94118 */     // GIR_Coverage, 3323,
     /*  94118 */     GIR_EraseRootFromParent_Done,
     /*  94119 */   // Label 2013: @94119
     /*  94119 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(94164), // Rule ID 3327 //
     /*  94124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1nexte),
     /*  94132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94153 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14751:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1NEXTErr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1NEXTErr),
     /*  94156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94158 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94160 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94162 */     GIR_RootConstrainSelectedInstOperands,
     /*  94163 */     // GIR_Coverage, 3327,
     /*  94163 */     GIR_EraseRootFromParent_Done,
     /*  94164 */   // Label 2014: @94164
     /*  94164 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(94209), // Rule ID 3329 //
     /*  94169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg1),
     /*  94177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94198 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14749:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG1rr),
     /*  94201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94205 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94207 */     GIR_RootConstrainSelectedInstOperands,
     /*  94208 */     // GIR_Coverage, 3329,
     /*  94208 */     GIR_EraseRootFromParent_Done,
     /*  94209 */   // Label 2015: @94209
     /*  94209 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(94254), // Rule ID 3331 //
     /*  94214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1msg2),
     /*  94222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94243 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14750:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA1MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1MSG2rr),
     /*  94246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94250 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94252 */     GIR_RootConstrainSelectedInstOperands,
     /*  94253 */     // GIR_Coverage, 3331,
     /*  94253 */     GIR_EraseRootFromParent_Done,
     /*  94254 */   // Label 2016: @94254
     /*  94254 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(94299), // Rule ID 3335 //
     /*  94259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg1),
     /*  94267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94288 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14753:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG1rr),
     /*  94291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94293 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94295 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94297 */     GIR_RootConstrainSelectedInstOperands,
     /*  94298 */     // GIR_Coverage, 3335,
     /*  94298 */     GIR_EraseRootFromParent_Done,
     /*  94299 */   // Label 2017: @94299
     /*  94299 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(94344), // Rule ID 3337 //
     /*  94304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  94307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256msg2),
     /*  94312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94333 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14754:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (SHA256MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  94333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256MSG2rr),
     /*  94336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94340 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94342 */     GIR_RootConstrainSelectedInstOperands,
     /*  94343 */     // GIR_Coverage, 3337,
     /*  94343 */     GIR_EraseRootFromParent_Done,
     /*  94344 */   // Label 2018: @94344
     /*  94344 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(94389), // Rule ID 3339 //
     /*  94349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94378 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13444:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCrr),
     /*  94381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94385 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94387 */     GIR_RootConstrainSelectedInstOperands,
     /*  94388 */     // GIR_Coverage, 3339,
     /*  94388 */     GIR_EraseRootFromParent_Done,
     /*  94389 */   // Label 2019: @94389
     /*  94389 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(94434), // Rule ID 3341 //
     /*  94394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94423 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13447:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTrr),
     /*  94426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94428 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94432 */     GIR_RootConstrainSelectedInstOperands,
     /*  94433 */     // GIR_Coverage, 3341,
     /*  94433 */     GIR_EraseRootFromParent_Done,
     /*  94434 */   // Label 2020: @94434
     /*  94434 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(94479), // Rule ID 3343 //
     /*  94439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94468 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13438:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECrr),
     /*  94471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94475 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94477 */     GIR_RootConstrainSelectedInstOperands,
     /*  94478 */     // GIR_Coverage, 3343,
     /*  94478 */     GIR_EraseRootFromParent_Done,
     /*  94479 */   // Label 2021: @94479
     /*  94479 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(94524), // Rule ID 3345 //
     /*  94484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasAVX_NoVLX_Or_NoVAES),
     /*  94487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94513 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13441:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTrr),
     /*  94516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94518 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94522 */     GIR_RootConstrainSelectedInstOperands,
     /*  94523 */     // GIR_Coverage, 3345,
     /*  94523 */     GIR_EraseRootFromParent_Done,
     /*  94524 */   // Label 2022: @94524
     /*  94524 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(94569), // Rule ID 3347 //
     /*  94529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  94537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94558 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13445:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCYrr),
     /*  94561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94565 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94567 */     GIR_RootConstrainSelectedInstOperands,
     /*  94568 */     // GIR_Coverage, 3347,
     /*  94568 */     GIR_EraseRootFromParent_Done,
     /*  94569 */   // Label 2023: @94569
     /*  94569 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(94614), // Rule ID 3349 //
     /*  94574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  94582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94603 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13448:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTYrr),
     /*  94606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94608 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94610 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94612 */     GIR_RootConstrainSelectedInstOperands,
     /*  94613 */     // GIR_Coverage, 3349,
     /*  94613 */     GIR_EraseRootFromParent_Done,
     /*  94614 */   // Label 2024: @94614
     /*  94614 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(94659), // Rule ID 3351 //
     /*  94619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  94627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94648 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13439:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECYrr),
     /*  94651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94653 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94655 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94657 */     GIR_RootConstrainSelectedInstOperands,
     /*  94658 */     // GIR_Coverage, 3351,
     /*  94658 */     GIR_EraseRootFromParent_Done,
     /*  94659 */   // Label 2025: @94659
     /*  94659 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(94704), // Rule ID 3353 //
     /*  94664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_NoVLX),
     /*  94667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  94672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  94681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  94693 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13442:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTYrr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  94693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTYrr),
     /*  94696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94698 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94700 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94702 */     GIR_RootConstrainSelectedInstOperands,
     /*  94703 */     // GIR_Coverage, 3353,
     /*  94703 */     GIR_EraseRootFromParent_Done,
     /*  94704 */   // Label 2026: @94704
     /*  94704 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(94749), // Rule ID 3355 //
     /*  94709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  94717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94738 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13444:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCrr),
     /*  94741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94747 */     GIR_RootConstrainSelectedInstOperands,
     /*  94748 */     // GIR_Coverage, 3355,
     /*  94748 */     GIR_EraseRootFromParent_Done,
     /*  94749 */   // Label 2027: @94749
     /*  94749 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(94794), // Rule ID 3357 //
     /*  94754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  94762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94783 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13447:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESENCLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESENCLASTrr),
     /*  94786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94788 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94790 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94792 */     GIR_RootConstrainSelectedInstOperands,
     /*  94793 */     // GIR_Coverage, 3357,
     /*  94793 */     GIR_EraseRootFromParent_Done,
     /*  94794 */   // Label 2028: @94794
     /*  94794 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(94839), // Rule ID 3359 //
     /*  94799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  94807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94828 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13438:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECrr),
     /*  94831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94833 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94835 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94837 */     GIR_RootConstrainSelectedInstOperands,
     /*  94838 */     // GIR_Coverage, 3359,
     /*  94838 */     GIR_EraseRootFromParent_Done,
     /*  94839 */   // Label 2029: @94839
     /*  94839 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(94884), // Rule ID 3361 //
     /*  94844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_NoAVX),
     /*  94847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  94852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94873 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13441:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (AESDECLASTrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  94873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AESDECLASTrr),
     /*  94876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  94880 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  94882 */     GIR_RootConstrainSelectedInstOperands,
     /*  94883 */     // GIR_Coverage, 3361,
     /*  94883 */     GIR_EraseRootFromParent_Done,
     /*  94884 */   // Label 2030: @94884
     /*  94884 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(94929), // Rule ID 3378 //
     /*  94889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_extrq),
     /*  94897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94918 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14897:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)  =>  (EXTRQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v16i8] }:$mask)
     /*  94918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::EXTRQ),
     /*  94921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94925 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94927 */     GIR_RootConstrainSelectedInstOperands,
     /*  94928 */     // GIR_Coverage, 3378,
     /*  94928 */     GIR_EraseRootFromParent_Done,
     /*  94929 */   // Label 2031: @94929
     /*  94929 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(94974), // Rule ID 3380 //
     /*  94934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE4A),
     /*  94937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse4a_insertq),
     /*  94942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  94963 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14899:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)  =>  (INSERTQ:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src, VR128:{ *:[v2i64] }:$mask)
     /*  94963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INSERTQ),
     /*  94966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  94970 */     GIR_RootToRootCopy, /*OpIdx*/3, // mask
     /*  94972 */     GIR_RootConstrainSelectedInstOperands,
     /*  94973 */     // GIR_Coverage, 3380,
     /*  94973 */     GIR_EraseRootFromParent_Done,
     /*  94974 */   // Label 2032: @94974
     /*  94974 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(95019), // Rule ID 3555 //
     /*  94979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  94982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg1),
     /*  94987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  94990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  94993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  94996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95008 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15048:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VSHA512MSG1rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /*  95008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG1rr),
     /*  95011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95013 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95015 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95017 */     GIR_RootConstrainSelectedInstOperands,
     /*  95018 */     // GIR_Coverage, 3555,
     /*  95018 */     GIR_EraseRootFromParent_Done,
     /*  95019 */   // Label 2033: @95019
     /*  95019 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(95064), // Rule ID 3556 //
     /*  95024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /*  95027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512msg2),
     /*  95032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95053 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15049:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VSHA512MSG2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /*  95053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512MSG2rr),
     /*  95056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95058 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95060 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95062 */     GIR_RootConstrainSelectedInstOperands,
     /*  95063 */     // GIR_Coverage, 3556,
     /*  95063 */     GIR_EraseRootFromParent_Done,
     /*  95064 */   // Label 2034: @95064
     /*  95064 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(95109), // Rule ID 3564 //
     /*  95069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4128),
     /*  95077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95098 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15054:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4KEY4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4rr),
     /*  95101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95103 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95105 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95107 */     GIR_RootConstrainSelectedInstOperands,
     /*  95108 */     // GIR_Coverage, 3564,
     /*  95108 */     GIR_EraseRootFromParent_Done,
     /*  95109 */   // Label 2035: @95109
     /*  95109 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(95154), // Rule ID 3566 //
     /*  95114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4256),
     /*  95122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95143 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15055:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4KEY4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Yrr),
     /*  95146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95150 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95152 */     GIR_RootConstrainSelectedInstOperands,
     /*  95153 */     // GIR_Coverage, 3566,
     /*  95153 */     GIR_EraseRootFromParent_Done,
     /*  95154 */   // Label 2036: @95154
     /*  95154 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(95199), // Rule ID 3568 //
     /*  95159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4128),
     /*  95167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95188 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15057:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VSM4RNDS4rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /*  95188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4rr),
     /*  95191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95195 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95197 */     GIR_RootConstrainSelectedInstOperands,
     /*  95198 */     // GIR_Coverage, 3568,
     /*  95198 */     GIR_EraseRootFromParent_Done,
     /*  95199 */   // Label 2037: @95199
     /*  95199 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(95244), // Rule ID 3570 //
     /*  95204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /*  95207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4256),
     /*  95212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  95215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  95218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  95221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  95233 */     // (intrinsic_wo_chain:{ *:[v8i32] } 15058:{ *:[iPTR] }, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VSM4RNDS4Yrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /*  95233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Yrr),
     /*  95236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95242 */     GIR_RootConstrainSelectedInstOperands,
     /*  95243 */     // GIR_Coverage, 3570,
     /*  95243 */     GIR_EraseRootFromParent_Done,
     /*  95244 */   // Label 2038: @95244
     /*  95244 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(95289), // Rule ID 14060 //
     /*  95249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc),
     /*  95257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95278 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13444:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ128rr),
     /*  95281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95283 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95285 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95287 */     GIR_RootConstrainSelectedInstOperands,
     /*  95288 */     // GIR_Coverage, 14060,
     /*  95288 */     GIR_EraseRootFromParent_Done,
     /*  95289 */   // Label 2039: @95289
     /*  95289 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(95334), // Rule ID 14062 //
     /*  95294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_256),
     /*  95302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95323 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13445:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZ256rr),
     /*  95326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95328 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95330 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95332 */     GIR_RootConstrainSelectedInstOperands,
     /*  95333 */     // GIR_Coverage, 14062,
     /*  95333 */     GIR_EraseRootFromParent_Done,
     /*  95334 */   // Label 2040: @95334
     /*  95334 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(95379), // Rule ID 14064 //
     /*  95339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenc_512),
     /*  95347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95368 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13446:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCZrr),
     /*  95371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95373 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95375 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95377 */     GIR_RootConstrainSelectedInstOperands,
     /*  95378 */     // GIR_Coverage, 14064,
     /*  95378 */     GIR_EraseRootFromParent_Done,
     /*  95379 */   // Label 2041: @95379
     /*  95379 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(95424), // Rule ID 14066 //
     /*  95384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast),
     /*  95392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95413 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13447:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESENCLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ128rr),
     /*  95416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95422 */     GIR_RootConstrainSelectedInstOperands,
     /*  95423 */     // GIR_Coverage, 14066,
     /*  95423 */     GIR_EraseRootFromParent_Done,
     /*  95424 */   // Label 2042: @95424
     /*  95424 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(95469), // Rule ID 14068 //
     /*  95429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_256),
     /*  95437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95458 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13448:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESENCLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZ256rr),
     /*  95461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95465 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95467 */     GIR_RootConstrainSelectedInstOperands,
     /*  95468 */     // GIR_Coverage, 14068,
     /*  95468 */     GIR_EraseRootFromParent_Done,
     /*  95469 */   // Label 2043: @95469
     /*  95469 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(95514), // Rule ID 14070 //
     /*  95474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesenclast_512),
     /*  95482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95503 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13449:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESENCLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESENCLASTZrr),
     /*  95506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95510 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95512 */     GIR_RootConstrainSelectedInstOperands,
     /*  95513 */     // GIR_Coverage, 14070,
     /*  95513 */     GIR_EraseRootFromParent_Done,
     /*  95514 */   // Label 2044: @95514
     /*  95514 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(95559), // Rule ID 14072 //
     /*  95519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec),
     /*  95527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95548 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13438:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ128rr),
     /*  95551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95555 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95557 */     GIR_RootConstrainSelectedInstOperands,
     /*  95558 */     // GIR_Coverage, 14072,
     /*  95558 */     GIR_EraseRootFromParent_Done,
     /*  95559 */   // Label 2045: @95559
     /*  95559 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(95604), // Rule ID 14074 //
     /*  95564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_256),
     /*  95572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95593 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13439:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZ256rr),
     /*  95596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95600 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95602 */     GIR_RootConstrainSelectedInstOperands,
     /*  95603 */     // GIR_Coverage, 14074,
     /*  95603 */     GIR_EraseRootFromParent_Done,
     /*  95604 */   // Label 2046: @95604
     /*  95604 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(95649), // Rule ID 14076 //
     /*  95609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdec_512),
     /*  95617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95638 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13440:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECZrr),
     /*  95641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95645 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95647 */     GIR_RootConstrainSelectedInstOperands,
     /*  95648 */     // GIR_Coverage, 14076,
     /*  95648 */     GIR_EraseRootFromParent_Done,
     /*  95649 */   // Label 2047: @95649
     /*  95649 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(95694), // Rule ID 14078 //
     /*  95654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast),
     /*  95662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  95683 */     // (intrinsic_wo_chain:{ *:[v2i64] } 13441:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VAESDECLASTZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /*  95683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ128rr),
     /*  95686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95688 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95690 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95692 */     GIR_RootConstrainSelectedInstOperands,
     /*  95693 */     // GIR_Coverage, 14078,
     /*  95693 */     GIR_EraseRootFromParent_Done,
     /*  95694 */   // Label 2048: @95694
     /*  95694 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(95739), // Rule ID 14080 //
     /*  95699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVAES_HasVLX),
     /*  95702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_256),
     /*  95707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  95710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  95713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  95716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  95728 */     // (intrinsic_wo_chain:{ *:[v4i64] } 13442:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VAESDECLASTZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /*  95728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZ256rr),
     /*  95731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95733 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95735 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95737 */     GIR_RootConstrainSelectedInstOperands,
     /*  95738 */     // GIR_Coverage, 14080,
     /*  95738 */     GIR_EraseRootFromParent_Done,
     /*  95739 */   // Label 2049: @95739
     /*  95739 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(95784), // Rule ID 14082 //
     /*  95744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVAES),
     /*  95747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_aesni_aesdeclast_512),
     /*  95752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  95755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  95758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  95761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95773 */     // (intrinsic_wo_chain:{ *:[v8i64] } 13443:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VAESDECLASTZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /*  95773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VAESDECLASTZrr),
     /*  95776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95778 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95782 */     GIR_RootConstrainSelectedInstOperands,
     /*  95783 */     // GIR_Coverage, 14082,
     /*  95783 */     GIR_EraseRootFromParent_Done,
     /*  95784 */   // Label 2050: @95784
     /*  95784 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(95829), // Rule ID 16793 //
     /*  95789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4key4512),
     /*  95797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95818 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15056:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4KEY4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4KEY4Zrr),
     /*  95821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95823 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95825 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95827 */     GIR_RootConstrainSelectedInstOperands,
     /*  95828 */     // GIR_Coverage, 16793,
     /*  95828 */     GIR_EraseRootFromParent_Done,
     /*  95829 */   // Label 2051: @95829
     /*  95829 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(95874), // Rule ID 16799 //
     /*  95834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasSM4),
     /*  95837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm4rnds4512),
     /*  95842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /*  95845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /*  95848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /*  95851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  95863 */     // (intrinsic_wo_chain:{ *:[v16i32] } 15059:{ *:[iPTR] }, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VSM4RNDS4Zrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /*  95863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM4RNDS4Zrr),
     /*  95866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  95870 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  95872 */     GIR_RootConstrainSelectedInstOperands,
     /*  95873 */     // GIR_Coverage, 16799,
     /*  95873 */     GIR_EraseRootFromParent_Done,
     /*  95874 */   // Label 2052: @95874
     /*  95874 */   GIM_Reject,
     /*  95875 */ // Label 1935: @95875
     /*  95875 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(100461),
     /*  95880 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  95883 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(95964), // Rule ID 23534 //
     /*  95888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  95896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  95899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  95920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  95924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  95928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95932 */     // MIs[0] src3
     /*  95932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  95944 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14866:{ *:[iPTR] }, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  95944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  95947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95949 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  95951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  95955 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  95957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  95962 */     GIR_RootConstrainSelectedInstOperands,
     /*  95963 */     // GIR_Coverage, 23534,
     /*  95963 */     GIR_EraseRootFromParent_Done,
     /*  95964 */   // Label 2054: @95964
     /*  95964 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(96045), // Rule ID 23535 //
     /*  95969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  95972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  95977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  95980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  95990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  95998 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96001 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96013 */     // MIs[0] src3
     /*  96013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96018 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96025 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14865:{ *:[iPTR] }, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96030 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96036 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96043 */     GIR_RootConstrainSelectedInstOperands,
     /*  96044 */     // GIR_Coverage, 23535,
     /*  96044 */     GIR_EraseRootFromParent_Done,
     /*  96045 */   // Label 2055: @96045
     /*  96045 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(96126), // Rule ID 23536 //
     /*  96050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96079 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96082 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96086 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96094 */     // MIs[0] src3
     /*  96094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96099 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96106 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13476:{ *:[iPTR] }, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96111 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96113 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96117 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96124 */     GIR_RootConstrainSelectedInstOperands,
     /*  96125 */     // GIR_Coverage, 23536,
     /*  96125 */     GIR_EraseRootFromParent_Done,
     /*  96126 */   // Label 2056: @96126
     /*  96126 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(96207), // Rule ID 3254 //
     /*  96131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  96139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  96145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96175 */     // MIs[0] src3
     /*  96175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96180 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96187 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14866:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrmi:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrmi),
     /*  96190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96192 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96194 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96198 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96205 */     GIR_RootConstrainSelectedInstOperands,
     /*  96206 */     // GIR_Coverage, 3254,
     /*  96206 */     GIR_EraseRootFromParent_Done,
     /*  96207 */   // Label 2057: @96207
     /*  96207 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(96288), // Rule ID 3256 //
     /*  96212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  96220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96245 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96248 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96256 */     // MIs[0] src3
     /*  96256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96268 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14865:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrmi:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrmi),
     /*  96271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96275 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96279 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96286 */     GIR_RootConstrainSelectedInstOperands,
     /*  96287 */     // GIR_Coverage, 3256,
     /*  96287 */     GIR_EraseRootFromParent_Done,
     /*  96288 */   // Label 2058: @96288
     /*  96288 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(96369), // Rule ID 3258 //
     /*  96293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  96296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  96301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  96304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  96307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  96310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96337 */     // MIs[0] src3
     /*  96337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96349 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13476:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrmi:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrmi),
     /*  96352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96367 */     GIR_RootConstrainSelectedInstOperands,
     /*  96368 */     // GIR_Coverage, 3258,
     /*  96368 */     GIR_EraseRootFromParent_Done,
     /*  96369 */   // Label 2059: @96369
     /*  96369 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(96450), // Rule ID 3374 //
     /*  96374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  96377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96407 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96410 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96418 */     // MIs[0] src3
     /*  96418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96423 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96430 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14717:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrmi:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrmi),
     /*  96433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96435 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96437 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96441 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96443 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96448 */     GIR_RootConstrainSelectedInstOperands,
     /*  96449 */     // GIR_Coverage, 3374,
     /*  96449 */     GIR_EraseRootFromParent_Done,
     /*  96450 */   // Label 2060: @96450
     /*  96450 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(96531), // Rule ID 3376 //
     /*  96455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  96458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  96480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96499 */     // MIs[0] src3
     /*  96499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96504 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96511 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14718:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrmi:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrmi),
     /*  96514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96522 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96529 */     GIR_RootConstrainSelectedInstOperands,
     /*  96530 */     // GIR_Coverage, 3376,
     /*  96530 */     GIR_EraseRootFromParent_Done,
     /*  96531 */   // Label 2061: @96531
     /*  96531 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(96612), // Rule ID 14085 //
     /*  96536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  96539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  96544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  96547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  96550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  96553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  96561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96580 */     // MIs[0] src3
     /*  96580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96592 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14719:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrmi:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrmi),
     /*  96595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96597 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96603 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96610 */     GIR_RootConstrainSelectedInstOperands,
     /*  96611 */     // GIR_Coverage, 14085,
     /*  96611 */     GIR_EraseRootFromParent_Done,
     /*  96612 */   // Label 2062: @96612
     /*  96612 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(96693), // Rule ID 14087 //
     /*  96617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  96625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  96628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  96631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  96634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  96642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96661 */     // MIs[0] src3
     /*  96661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96673 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14717:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rmi:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rmi),
     /*  96676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96684 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96691 */     GIR_RootConstrainSelectedInstOperands,
     /*  96692 */     // GIR_Coverage, 14087,
     /*  96692 */     GIR_EraseRootFromParent_Done,
     /*  96693 */   // Label 2063: @96693
     /*  96693 */   GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(96774), // Rule ID 14089 //
     /*  96698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  96701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  96706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  96709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  96712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  96715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  96723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  96727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96731 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96734 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96742 */     // MIs[0] src3
     /*  96742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96754 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14718:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rmi:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  96754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rmi),
     /*  96757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96759 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  96761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96765 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96772 */     GIR_RootConstrainSelectedInstOperands,
     /*  96773 */     // GIR_Coverage, 14089,
     /*  96773 */     GIR_EraseRootFromParent_Done,
     /*  96774 */   // Label 2064: @96774
     /*  96774 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(96859), // Rule ID 23336 //
     /*  96779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  96787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96811 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96814 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96818 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15111:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  96842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96844 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96850 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96857 */     GIR_RootConstrainSelectedInstOperands,
     /*  96858 */     // GIR_Coverage, 23336,
     /*  96858 */     GIR_EraseRootFromParent_Done,
     /*  96859 */   // Label 2065: @96859
     /*  96859 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(96944), // Rule ID 23337 //
     /*  96864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  96872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  96884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  96924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15110:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  96924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  96927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96929 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  96931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  96935 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  96937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  96942 */     GIR_RootConstrainSelectedInstOperands,
     /*  96943 */     // GIR_Coverage, 23337,
     /*  96943 */     GIR_EraseRootFromParent_Done,
     /*  96944 */   // Label 2066: @96944
     /*  96944 */   GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(97029), // Rule ID 23338 //
     /*  96949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  96952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  96957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  96963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  96969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  96981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  96984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  96988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  96992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  96996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97009 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15109:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  97012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97014 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97020 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97027 */     GIR_RootConstrainSelectedInstOperands,
     /*  97028 */     // GIR_Coverage, 23338,
     /*  97028 */     GIR_EraseRootFromParent_Done,
     /*  97029 */   // Label 2067: @97029
     /*  97029 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(97114), // Rule ID 23339 //
     /*  97034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  97042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97066 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97069 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97073 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15108:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  97097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97099 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97105 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97112 */     GIR_RootConstrainSelectedInstOperands,
     /*  97113 */     // GIR_Coverage, 23339,
     /*  97113 */     GIR_EraseRootFromParent_Done,
     /*  97114 */   // Label 2068: @97114
     /*  97114 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(97199), // Rule ID 23340 //
     /*  97119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  97127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97179 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15107:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  97179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  97182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97184 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97190 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97197 */     GIR_RootConstrainSelectedInstOperands,
     /*  97198 */     // GIR_Coverage, 23340,
     /*  97198 */     GIR_EraseRootFromParent_Done,
     /*  97199 */   // Label 2069: @97199
     /*  97199 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(97284), // Rule ID 23341 //
     /*  97204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  97212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97257 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15106:{ *:[iPTR] }, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  97267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97269 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97271 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97275 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97282 */     GIR_RootConstrainSelectedInstOperands,
     /*  97283 */     // GIR_Coverage, 23341,
     /*  97283 */     GIR_EraseRootFromParent_Done,
     /*  97284 */   // Label 2070: @97284
     /*  97284 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(97369), // Rule ID 23342 //
     /*  97289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  97297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97321 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97324 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97328 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97349 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15105:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  97352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97354 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97360 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97367 */     GIR_RootConstrainSelectedInstOperands,
     /*  97368 */     // GIR_Coverage, 23342,
     /*  97368 */     GIR_EraseRootFromParent_Done,
     /*  97369 */   // Label 2071: @97369
     /*  97369 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(97454), // Rule ID 23343 //
     /*  97374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  97382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97406 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97409 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97413 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97434 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15104:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  97437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97439 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97445 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97452 */     GIR_RootConstrainSelectedInstOperands,
     /*  97453 */     // GIR_Coverage, 23343,
     /*  97453 */     GIR_EraseRootFromParent_Done,
     /*  97454 */   // Label 2072: @97454
     /*  97454 */   GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(97539), // Rule ID 23344 //
     /*  97459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  97467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97519 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15103:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  97522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97530 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97537 */     GIR_RootConstrainSelectedInstOperands,
     /*  97538 */     // GIR_Coverage, 23344,
     /*  97538 */     GIR_EraseRootFromParent_Done,
     /*  97539 */   // Label 2073: @97539
     /*  97539 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(97624), // Rule ID 23345 //
     /*  97544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  97552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15102:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  97607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97609 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97615 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97622 */     GIR_RootConstrainSelectedInstOperands,
     /*  97623 */     // GIR_Coverage, 23345,
     /*  97623 */     GIR_EraseRootFromParent_Done,
     /*  97624 */   // Label 2074: @97624
     /*  97624 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(97709), // Rule ID 23346 //
     /*  97629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  97637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  97640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  97649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97682 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97689 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15101:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  97689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  97692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97694 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97700 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97707 */     GIR_RootConstrainSelectedInstOperands,
     /*  97708 */     // GIR_Coverage, 23346,
     /*  97708 */     GIR_EraseRootFromParent_Done,
     /*  97709 */   // Label 2075: @97709
     /*  97709 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(97794), // Rule ID 23347 //
     /*  97714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  97722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  97728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97774 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15100:{ *:[iPTR] }, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  97777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97779 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /*  97781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97785 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97792 */     GIR_RootConstrainSelectedInstOperands,
     /*  97793 */     // GIR_Coverage, 23347,
     /*  97793 */     GIR_EraseRootFromParent_Done,
     /*  97794 */   // Label 2076: @97794
     /*  97794 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(97879), // Rule ID 1620 //
     /*  97799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  97807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97859 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15111:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrm),
     /*  97862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97866 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97870 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97877 */     GIR_RootConstrainSelectedInstOperands,
     /*  97878 */     // GIR_Coverage, 1620,
     /*  97878 */     GIR_EraseRootFromParent_Done,
     /*  97879 */   // Label 2077: @97879
     /*  97879 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(97964), // Rule ID 1622 //
     /*  97884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  97892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  97904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  97916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  97920 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  97923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  97927 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  97931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  97944 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15110:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  97944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrm),
     /*  97947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97949 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  97951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  97955 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  97957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  97962 */     GIR_RootConstrainSelectedInstOperands,
     /*  97963 */     // GIR_Coverage, 1622,
     /*  97963 */     GIR_EraseRootFromParent_Done,
     /*  97964 */   // Label 2078: @97964
     /*  97964 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(98049), // Rule ID 1624 //
     /*  97969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  97972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  97977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  97983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  97989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  97997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98005 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98029 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15109:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrm),
     /*  98032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98040 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98047 */     GIR_RootConstrainSelectedInstOperands,
     /*  98048 */     // GIR_Coverage, 1624,
     /*  98048 */     GIR_EraseRootFromParent_Done,
     /*  98049 */   // Label 2079: @98049
     /*  98049 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(98134), // Rule ID 1626 //
     /*  98054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  98062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98114 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15108:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrm),
     /*  98117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98125 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98132 */     GIR_RootConstrainSelectedInstOperands,
     /*  98133 */     // GIR_Coverage, 1626,
     /*  98133 */     GIR_EraseRootFromParent_Done,
     /*  98134 */   // Label 2080: @98134
     /*  98134 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(98219), // Rule ID 1628 //
     /*  98139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  98147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  98150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  98159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98199 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15107:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  98199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrm),
     /*  98202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98204 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98206 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98210 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98217 */     GIR_RootConstrainSelectedInstOperands,
     /*  98218 */     // GIR_Coverage, 1628,
     /*  98218 */     GIR_EraseRootFromParent_Done,
     /*  98219 */   // Label 2081: @98219
     /*  98219 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(98304), // Rule ID 1630 //
     /*  98224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  98232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  98238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  98241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98260 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98263 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98267 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15106:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrm:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrm),
     /*  98287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98295 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98302 */     GIR_RootConstrainSelectedInstOperands,
     /*  98303 */     // GIR_Coverage, 1630,
     /*  98303 */     GIR_EraseRootFromParent_Done,
     /*  98304 */   // Label 2082: @98304
     /*  98304 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(98389), // Rule ID 1632 //
     /*  98309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  98317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98369 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15105:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrm),
     /*  98372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98380 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98387 */     GIR_RootConstrainSelectedInstOperands,
     /*  98388 */     // GIR_Coverage, 1632,
     /*  98388 */     GIR_EraseRootFromParent_Done,
     /*  98389 */   // Label 2083: @98389
     /*  98389 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(98474), // Rule ID 1634 //
     /*  98394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  98402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98454 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15104:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrm),
     /*  98457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98465 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98472 */     GIR_RootConstrainSelectedInstOperands,
     /*  98473 */     // GIR_Coverage, 1634,
     /*  98473 */     GIR_EraseRootFromParent_Done,
     /*  98474 */   // Label 2084: @98474
     /*  98474 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(98559), // Rule ID 1636 //
     /*  98479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /*  98487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98515 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98518 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98522 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98539 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15103:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrm),
     /*  98542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98550 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98557 */     GIR_RootConstrainSelectedInstOperands,
     /*  98558 */     // GIR_Coverage, 1636,
     /*  98558 */     GIR_EraseRootFromParent_Done,
     /*  98559 */   // Label 2085: @98559
     /*  98559 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(98644), // Rule ID 1638 //
     /*  98564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /*  98572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98603 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98607 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98624 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15102:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrm),
     /*  98627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98631 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98635 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98642 */     GIR_RootConstrainSelectedInstOperands,
     /*  98643 */     // GIR_Coverage, 1638,
     /*  98643 */     GIR_EraseRootFromParent_Done,
     /*  98644 */   // Label 2086: @98644
     /*  98644 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(98729), // Rule ID 1640 //
     /*  98649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /*  98657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  98669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98685 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98688 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98692 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98709 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15101:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrm:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  98709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrm),
     /*  98712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98714 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98720 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98727 */     GIR_RootConstrainSelectedInstOperands,
     /*  98728 */     // GIR_Coverage, 1640,
     /*  98728 */     GIR_EraseRootFromParent_Done,
     /*  98729 */   // Label 2087: @98729
     /*  98729 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(98814), // Rule ID 1642 //
     /*  98734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  98737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /*  98742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  98766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98770 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98773 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98794 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15100:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  98794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrm),
     /*  98797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /*  98805 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  98807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98812 */     GIR_RootConstrainSelectedInstOperands,
     /*  98813 */     // GIR_Coverage, 1642,
     /*  98813 */     GIR_EraseRootFromParent_Done,
     /*  98814 */   // Label 2088: @98814
     /*  98814 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(98899), // Rule ID 3559 //
     /*  98819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /*  98827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15051:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG1rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rm),
     /*  98882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98884 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98886 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98888 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98897 */     GIR_RootConstrainSelectedInstOperands,
     /*  98898 */     // GIR_Coverage, 3559,
     /*  98898 */     GIR_EraseRootFromParent_Done,
     /*  98899 */   // Label 2089: @98899
     /*  98899 */   GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(98984), // Rule ID 3561 //
     /*  98904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /*  98907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /*  98912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  98918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  98924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  98936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  98940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  98944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  98947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /*  98951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  98955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /*  98964 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15052:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSM3MSG2rm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /*  98964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rm),
     /*  98967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  98971 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  98973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /*  98977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  98982 */     GIR_RootConstrainSelectedInstOperands,
     /*  98983 */     // GIR_Coverage, 3561,
     /*  98983 */     GIR_EraseRootFromParent_Done,
     /*  98984 */   // Label 2090: @98984
     /*  98984 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(99034), // Rule ID 3253 //
     /*  98989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  98992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  98997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99018 */     // MIs[0] src3
     /*  99018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99021 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14866:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSrri),
     /*  99024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99026 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99028 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99030 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99032 */     GIR_RootConstrainSelectedInstOperands,
     /*  99033 */     // GIR_Coverage, 3253,
     /*  99033 */     GIR_EraseRootFromParent_Done,
     /*  99034 */   // Label 2091: @99034
     /*  99034 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(99084), // Rule ID 3255 //
     /*  99039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99068 */     // MIs[0] src3
     /*  99068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99071 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14865:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPDrri),
     /*  99074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99078 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99080 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99082 */     GIR_RootConstrainSelectedInstOperands,
     /*  99083 */     // GIR_Coverage, 3255,
     /*  99083 */     GIR_EraseRootFromParent_Done,
     /*  99084 */   // Label 2092: @99084
     /*  99084 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(99134), // Rule ID 3257 //
     /*  99089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /*  99092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_dp_ps_256),
     /*  99097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /*  99100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /*  99103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /*  99106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99118 */     // MIs[0] src3
     /*  99118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99121 */     // (intrinsic_wo_chain:{ *:[v8f32] } 13476:{ *:[iPTR] }, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VDPPSYrri:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDPPSYrri),
     /*  99124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99128 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99130 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99132 */     GIR_RootConstrainSelectedInstOperands,
     /*  99133 */     // GIR_Coverage, 3257,
     /*  99133 */     GIR_EraseRootFromParent_Done,
     /*  99134 */   // Label 2093: @99134
     /*  99134 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(99184), // Rule ID 3263 //
     /*  99139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dpps),
     /*  99147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99168 */     // MIs[0] src3
     /*  99168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99171 */     // (intrinsic_wo_chain:{ *:[v4f32] } 14866:{ *:[iPTR] }, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPSrri:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPSrri),
     /*  99174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99176 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99178 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99180 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99182 */     GIR_RootConstrainSelectedInstOperands,
     /*  99183 */     // GIR_Coverage, 3263,
     /*  99183 */     GIR_EraseRootFromParent_Done,
     /*  99184 */   // Label 2094: @99184
     /*  99184 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(99234), // Rule ID 3265 //
     /*  99189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /*  99192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse41_dppd),
     /*  99197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99218 */     // MIs[0] src3
     /*  99218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99221 */     // (intrinsic_wo_chain:{ *:[v2f64] } 14865:{ *:[iPTR] }, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (DPPDrri:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DPPDrri),
     /*  99224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99228 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99230 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99232 */     GIR_RootConstrainSelectedInstOperands,
     /*  99233 */     // GIR_Coverage, 3265,
     /*  99233 */     GIR_EraseRootFromParent_Done,
     /*  99234 */   // Label 2095: @99234
     /*  99234 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(99284), // Rule ID 3325 //
     /*  99239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /*  99242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha1rnds4),
     /*  99247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99268 */     // MIs[0] src3
     /*  99268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99271 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14752:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (SHA1RNDS4rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA1RNDS4rri),
     /*  99274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99276 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99278 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99280 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99282 */     GIR_RootConstrainSelectedInstOperands,
     /*  99283 */     // GIR_Coverage, 3325,
     /*  99283 */     GIR_EraseRootFromParent_Done,
     /*  99284 */   // Label 2096: @99284
     /*  99284 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(99334), // Rule ID 3371 //
     /*  99289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPCLMUL_NoAVX),
     /*  99292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99318 */     // MIs[0] src3
     /*  99318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99321 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14717:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (PCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PCLMULQDQrri),
     /*  99324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99326 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99328 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99330 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99332 */     GIR_RootConstrainSelectedInstOperands,
     /*  99333 */     // GIR_Coverage, 3371,
     /*  99333 */     GIR_EraseRootFromParent_Done,
     /*  99334 */   // Label 2097: @99334
     /*  99334 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(99384), // Rule ID 3373 //
     /*  99339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_HasPCLMUL_NoVLX_Or_NoVPCLMULQDQ),
     /*  99342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99368 */     // MIs[0] src3
     /*  99368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99371 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14717:{ *:[iPTR] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQrri:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQrri),
     /*  99374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99376 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99378 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99380 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99382 */     GIR_RootConstrainSelectedInstOperands,
     /*  99383 */     // GIR_Coverage, 3373,
     /*  99383 */     GIR_EraseRootFromParent_Done,
     /*  99384 */   // Label 2098: @99384
     /*  99384 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(99434), // Rule ID 3375 //
     /*  99389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPCLMULQDQ_NoVLX),
     /*  99392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /*  99418 */     // MIs[0] src3
     /*  99418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99421 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14718:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQYrri:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQYrri),
     /*  99424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99426 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99428 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99430 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99432 */     GIR_RootConstrainSelectedInstOperands,
     /*  99433 */     // GIR_Coverage, 3375,
     /*  99433 */     GIR_EraseRootFromParent_Done,
     /*  99434 */   // Label 2099: @99434
     /*  99434 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(99484), // Rule ID 14084 //
     /*  99439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVPCLMULQDQ),
     /*  99442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_512),
     /*  99447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /*  99450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /*  99453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /*  99456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /*  99468 */     // MIs[0] src3
     /*  99468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99471 */     // (intrinsic_wo_chain:{ *:[v8i64] } 14719:{ *:[iPTR] }, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZrri:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZrri),
     /*  99474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99478 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99480 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99482 */     GIR_RootConstrainSelectedInstOperands,
     /*  99483 */     // GIR_Coverage, 14084,
     /*  99483 */     GIR_EraseRootFromParent_Done,
     /*  99484 */   // Label 2100: @99484
     /*  99484 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(99534), // Rule ID 14086 //
     /*  99489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq),
     /*  99497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  99506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /*  99518 */     // MIs[0] src3
     /*  99518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99521 */     // (intrinsic_wo_chain:{ *:[v2i64] } 14717:{ *:[iPTR] }, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ128rri:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ128rri),
     /*  99524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99526 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99528 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99530 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99532 */     GIR_RootConstrainSelectedInstOperands,
     /*  99533 */     // GIR_Coverage, 14086,
     /*  99533 */     GIR_EraseRootFromParent_Done,
     /*  99534 */   // Label 2101: @99534
     /*  99534 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(99584), // Rule ID 14088 //
     /*  99539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPCLMULQDQ),
     /*  99542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_pclmulqdq_256),
     /*  99547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /*  99550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /*  99553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /*  99556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /*  99568 */     // MIs[0] src3
     /*  99568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99571 */     // (intrinsic_wo_chain:{ *:[v4i64] } 14718:{ *:[iPTR] }, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)  =>  (VPCLMULQDQZ256rri:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2, (timm:{ *:[i8] }):$src3)
     /*  99571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCLMULQDQZ256rri),
     /*  99574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99578 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99580 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99582 */     GIR_RootConstrainSelectedInstOperands,
     /*  99583 */     // GIR_Coverage, 14088,
     /*  99583 */     GIR_EraseRootFromParent_Done,
     /*  99584 */   // Label 2102: @99584
     /*  99584 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(99638), // Rule ID 1619 //
     /*  99589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcswd),
     /*  99597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99625 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15111:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSWDrr),
     /*  99628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99630 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99632 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99634 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99636 */     GIR_RootConstrainSelectedInstOperands,
     /*  99637 */     // GIR_Coverage, 1619,
     /*  99637 */     GIR_EraseRootFromParent_Done,
     /*  99638 */   // Label 2103: @99638
     /*  99638 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(99692), // Rule ID 1621 //
     /*  99643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmadcsswd),
     /*  99651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15110:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMADCSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMADCSSWDrr),
     /*  99682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99684 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99686 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99688 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99690 */     GIR_RootConstrainSelectedInstOperands,
     /*  99691 */     // GIR_Coverage, 1621,
     /*  99691 */     GIR_EraseRootFromParent_Done,
     /*  99692 */   // Label 2104: @99692
     /*  99692 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(99746), // Rule ID 1623 //
     /*  99697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsww),
     /*  99705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99733 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15109:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWWrr),
     /*  99736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99738 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99740 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99742 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99744 */     GIR_RootConstrainSelectedInstOperands,
     /*  99745 */     // GIR_Coverage, 1623,
     /*  99745 */     GIR_EraseRootFromParent_Done,
     /*  99746 */   // Label 2105: @99746
     /*  99746 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(99800), // Rule ID 1625 //
     /*  99751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacswd),
     /*  99759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15108:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSWDrr),
     /*  99790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99794 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99796 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99798 */     GIR_RootConstrainSelectedInstOperands,
     /*  99799 */     // GIR_Coverage, 1625,
     /*  99799 */     GIR_EraseRootFromParent_Done,
     /*  99800 */   // Label 2106: @99800
     /*  99800 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(99854), // Rule ID 1627 //
     /*  99805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssww),
     /*  99813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  99816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  99825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99841 */     // (intrinsic_wo_chain:{ *:[v8i16] } 15107:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)  =>  (VPMACSSWWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v8i16] }:$src3)
     /*  99841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWWrr),
     /*  99844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99846 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99848 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99850 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99852 */     GIR_RootConstrainSelectedInstOperands,
     /*  99853 */     // GIR_Coverage, 1627,
     /*  99853 */     GIR_EraseRootFromParent_Done,
     /*  99854 */   // Label 2107: @99854
     /*  99854 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(99908), // Rule ID 1629 //
     /*  99859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsswd),
     /*  99867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  99870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  99873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  99876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  99879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15106:{ *:[iPTR] }, VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSWDrr:{ *:[v4i32] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /*  99895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSWDrr),
     /*  99898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99902 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99904 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99906 */     GIR_RootConstrainSelectedInstOperands,
     /*  99907 */     // GIR_Coverage, 1629,
     /*  99907 */     GIR_EraseRootFromParent_Done,
     /*  99908 */   // Label 2108: @99908
     /*  99908 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(99962), // Rule ID 1631 //
     /*  99913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdql),
     /*  99921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99949 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15105:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /*  99949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQLrr),
     /*  99952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  99956 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /*  99958 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /*  99960 */     GIR_RootConstrainSelectedInstOperands,
     /*  99961 */     // GIR_Coverage, 1631,
     /*  99961 */     GIR_EraseRootFromParent_Done,
     /*  99962 */   // Label 2109: @99962
     /*  99962 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(100016), // Rule ID 1633 //
     /*  99967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /*  99970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdqh),
     /*  99975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  99978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  99981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  99984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  99987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /*  99999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100003 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15104:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDQHrr),
     /* 100006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100008 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100012 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100014 */     GIR_RootConstrainSelectedInstOperands,
     /* 100015 */     // GIR_Coverage, 1633,
     /* 100015 */     GIR_EraseRootFromParent_Done,
     /* 100016 */   // Label 2110: @100016
     /* 100016 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(100070), // Rule ID 1635 //
     /* 100021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacssdd),
     /* 100029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100057 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15103:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSSDDrr),
     /* 100060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100062 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100064 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100066 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100068 */     GIR_RootConstrainSelectedInstOperands,
     /* 100069 */     // GIR_Coverage, 1635,
     /* 100069 */     GIR_EraseRootFromParent_Done,
     /* 100070 */   // Label 2111: @100070
     /* 100070 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(100124), // Rule ID 1637 //
     /* 100075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdql),
     /* 100083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100111 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15102:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQLrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQLrr),
     /* 100114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100118 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100120 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100122 */     GIR_RootConstrainSelectedInstOperands,
     /* 100123 */     // GIR_Coverage, 1637,
     /* 100123 */     GIR_EraseRootFromParent_Done,
     /* 100124 */   // Label 2112: @100124
     /* 100124 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(100178), // Rule ID 1639 //
     /* 100129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdqh),
     /* 100137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 100140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100165 */     // (intrinsic_wo_chain:{ *:[v2i64] } 15101:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VPMACSDQHrr:{ *:[v2i64] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDQHrr),
     /* 100168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100170 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100172 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100174 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100176 */     GIR_RootConstrainSelectedInstOperands,
     /* 100177 */     // GIR_Coverage, 1639,
     /* 100177 */     GIR_EraseRootFromParent_Done,
     /* 100178 */   // Label 2113: @100178
     /* 100178 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(100232), // Rule ID 1641 //
     /* 100183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 100186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xop_vpmacsdd),
     /* 100191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100219 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15100:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VPMACSDDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMACSDDrr),
     /* 100222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100226 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100228 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100230 */     GIR_RootConstrainSelectedInstOperands,
     /* 100231 */     // GIR_Coverage, 1641,
     /* 100231 */     GIR_EraseRootFromParent_Done,
     /* 100232 */   // Label 2114: @100232
     /* 100232 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(100298), // Rule ID 3333 //
     /* 100237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA),
     /* 100240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sha256rnds2),
     /* 100245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100273 */     // (intrinsic_wo_chain:{ *:[v4i32] } 14755:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, XMM0:{ *:[v4i32] })  =>  (SHA256RNDS2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 100273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100277 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XMM0
     /* 100287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHA256RNDS2rr),
     /* 100290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100294 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100296 */     GIR_RootConstrainSelectedInstOperands,
     /* 100297 */     // GIR_Coverage, 3333,
     /* 100297 */     GIR_EraseRootFromParent_Done,
     /* 100298 */   // Label 2115: @100298
     /* 100298 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(100352), // Rule ID 3557 //
     /* 100303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA512),
     /* 100306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsha512rnds2),
     /* 100311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 100314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 100317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 100320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 100323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 100335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100339 */     // (intrinsic_wo_chain:{ *:[v4i64] } 15050:{ *:[iPTR] }, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)  =>  (VSHA512RNDS2rr:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2, VR128:{ *:[v2i64] }:$src3)
     /* 100339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSHA512RNDS2rr),
     /* 100342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100344 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100346 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100348 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100350 */     GIR_RootConstrainSelectedInstOperands,
     /* 100351 */     // GIR_Coverage, 3557,
     /* 100351 */     GIR_EraseRootFromParent_Done,
     /* 100352 */   // Label 2116: @100352
     /* 100352 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(100406), // Rule ID 3558 //
     /* 100357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg1),
     /* 100365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100393 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15051:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG1rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG1rr),
     /* 100396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100398 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100400 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100402 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100404 */     GIR_RootConstrainSelectedInstOperands,
     /* 100405 */     // GIR_Coverage, 3558,
     /* 100405 */     GIR_EraseRootFromParent_Done,
     /* 100406 */   // Label 2117: @100406
     /* 100406 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(100460), // Rule ID 3560 //
     /* 100411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3msg2),
     /* 100419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100447 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15052:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)  =>  (VSM3MSG2rr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3)
     /* 100447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3MSG2rr),
     /* 100450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100454 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100456 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100458 */     GIR_RootConstrainSelectedInstOperands,
     /* 100459 */     // GIR_Coverage, 3560,
     /* 100459 */     GIR_EraseRootFromParent_Done,
     /* 100460 */   // Label 2118: @100460
     /* 100460 */   GIM_Reject,
     /* 100461 */ // Label 2053: @100461
     /* 100461 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(100590),
     /* 100466 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 100469 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vsm3rnds2),
     /* 100474 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 100477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 100480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 100483 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 100486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100494 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100498 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(100559), // Rule ID 3563 //
     /* 100503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 100510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 100514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 100521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 100525 */     // MIs[0] src4
     /* 100525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 100537 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15053:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rmi:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, addr:{ *:[iPTR] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rmi),
     /* 100540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100542 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100544 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 100550 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 100557 */     GIR_RootConstrainSelectedInstOperands,
     /* 100558 */     // GIR_Coverage, 3563,
     /* 100558 */     GIR_EraseRootFromParent_Done,
     /* 100559 */   // Label 2120: @100559
     /* 100559 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(100589), // Rule ID 3562 //
     /* 100564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM3),
     /* 100567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 100571 */     // MIs[0] src4
     /* 100571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 100574 */     // (intrinsic_wo_chain:{ *:[v4i32] } 15053:{ *:[iPTR] }, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)  =>  (VSM3RNDS2rri:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2, VR128:{ *:[v4i32] }:$src3, (timm:{ *:[i32] }):$src4)
     /* 100574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSM3RNDS2rri),
     /* 100577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100579 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 100581 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 100583 */     GIR_RootToRootCopy, /*OpIdx*/4, // src3
     /* 100585 */     GIR_RootToRootCopy, /*OpIdx*/5, // src4
     /* 100587 */     GIR_RootConstrainSelectedInstOperands,
     /* 100588 */     // GIR_Coverage, 3562,
     /* 100588 */     GIR_EraseRootFromParent_Done,
     /* 100589 */   // Label 2121: @100589
     /* 100589 */   GIM_Reject,
     /* 100590 */ // Label 2119: @100590
     /* 100590 */ GIM_Reject,
     /* 100591 */ // Label 18: @100591
     /* 100591 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(101150),
     /* 100596 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 100599 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(100621), // Rule ID 149 //
     /* 100604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSERIALIZE),
     /* 100607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_serialize),
     /* 100612 */     // (intrinsic_void 14747:{ *:[iPTR] })  =>  (SERIALIZE)
     /* 100612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SERIALIZE),
     /* 100615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100619 */     GIR_RootConstrainSelectedInstOperands,
     /* 100620 */     // GIR_Coverage, 149,
     /* 100620 */     GIR_EraseRootFromParent_Done,
     /* 100621 */   // Label 2123: @100621
     /* 100621 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(100643), // Rule ID 150 //
     /* 100626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsusldtrk),
     /* 100634 */     // (intrinsic_void 15135:{ *:[iPTR] })  =>  (XSUSLDTRK)
     /* 100634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSUSLDTRK),
     /* 100637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100641 */     GIR_RootConstrainSelectedInstOperands,
     /* 100642 */     // GIR_Coverage, 150,
     /* 100642 */     GIR_EraseRootFromParent_Done,
     /* 100643 */   // Label 2124: @100643
     /* 100643 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(100665), // Rule ID 151 //
     /* 100648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTSXLDTRK),
     /* 100651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xresldtrk),
     /* 100656 */     // (intrinsic_void 15121:{ *:[iPTR] })  =>  (XRESLDTRK)
     /* 100656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRESLDTRK),
     /* 100659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100663 */     GIR_RootConstrainSelectedInstOperands,
     /* 100664 */     // GIR_Coverage, 151,
     /* 100664 */     GIR_EraseRootFromParent_Done,
     /* 100665 */   // Label 2125: @100665
     /* 100665 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(100687), // Rule ID 152 //
     /* 100670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clui),
     /* 100678 */     // (intrinsic_void 14605:{ *:[iPTR] })  =>  (CLUI)
     /* 100678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLUI),
     /* 100681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100685 */     GIR_RootConstrainSelectedInstOperands,
     /* 100686 */     // GIR_Coverage, 152,
     /* 100686 */     GIR_EraseRootFromParent_Done,
     /* 100687 */   // Label 2126: @100687
     /* 100687 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(100709), // Rule ID 153 //
     /* 100692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 100695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_stui),
     /* 100700 */     // (intrinsic_void 14929:{ *:[iPTR] })  =>  (STUI)
     /* 100700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STUI),
     /* 100703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100707 */     GIR_RootConstrainSelectedInstOperands,
     /* 100708 */     // GIR_Coverage, 153,
     /* 100708 */     GIR_EraseRootFromParent_Done,
     /* 100709 */   // Label 2127: @100709
     /* 100709 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(100728), // Rule ID 2510 //
     /* 100714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_pause),
     /* 100719 */     // (intrinsic_void 14824:{ *:[iPTR] })  =>  (PAUSE)
     /* 100719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PAUSE),
     /* 100722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100726 */     GIR_RootConstrainSelectedInstOperands,
     /* 100727 */     // GIR_Coverage, 2510,
     /* 100727 */     GIR_EraseRootFromParent_Done,
     /* 100728 */   // Label 2128: @100728
     /* 100728 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(100750), // Rule ID 2511 //
     /* 100733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE1),
     /* 100736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_sfence),
     /* 100741 */     // (intrinsic_void 14786:{ *:[iPTR] })  =>  (SFENCE)
     /* 100741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SFENCE),
     /* 100744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100748 */     GIR_RootConstrainSelectedInstOperands,
     /* 100749 */     // GIR_Coverage, 2511,
     /* 100749 */     GIR_EraseRootFromParent_Done,
     /* 100750 */   // Label 2129: @100750
     /* 100750 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(100772), // Rule ID 2512 //
     /* 100755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE2),
     /* 100758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_lfence),
     /* 100763 */     // (intrinsic_void 14813:{ *:[iPTR] })  =>  (LFENCE)
     /* 100763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LFENCE),
     /* 100766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100770 */     GIR_RootConstrainSelectedInstOperands,
     /* 100771 */     // GIR_Coverage, 2512,
     /* 100771 */     GIR_EraseRootFromParent_Done,
     /* 100772 */   // Label 2130: @100772
     /* 100772 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(100794), // Rule ID 2513 //
     /* 100777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMFence),
     /* 100780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_mfence),
     /* 100785 */     // (intrinsic_void 14817:{ *:[iPTR] })  =>  (MFENCE)
     /* 100785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MFENCE),
     /* 100788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100792 */     GIR_RootConstrainSelectedInstOperands,
     /* 100793 */     // GIR_Coverage, 2513,
     /* 100793 */     GIR_EraseRootFromParent_Done,
     /* 100794 */   // Label 2131: @100794
     /* 100794 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(100860), // Rule ID 3427 //
     /* 100799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroall),
     /* 100807 */     // (intrinsic_void 13519:{ *:[iPTR] })  =>  (VZEROALL)
     /* 100807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROALL),
     /* 100810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100855 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100858 */     GIR_RootConstrainSelectedInstOperands,
     /* 100859 */     // GIR_Coverage, 3427,
     /* 100859 */     GIR_EraseRootFromParent_Done,
     /* 100860 */   // Label 2132: @100860
     /* 100860 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(100926), // Rule ID 3428 //
     /* 100865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 100868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_vzeroupper),
     /* 100873 */     // (intrinsic_void 13520:{ *:[iPTR] })  =>  (VZEROUPPER)
     /* 100873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VZEROUPPER),
     /* 100876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM0*/0,
     /* 100879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM1*/1,
     /* 100882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM2*/2,
     /* 100885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM3*/3,
     /* 100888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM4*/4,
     /* 100891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM5*/5,
     /* 100894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM6*/6,
     /* 100897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM7*/7,
     /* 100900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM8*/8,
     /* 100903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM9*/9,
     /* 100906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM10*/10,
     /* 100909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM11*/11,
     /* 100912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM12*/12,
     /* 100915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM13*/13,
     /* 100918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM14*/14,
     /* 100921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::YMM15*/15,
     /* 100924 */     GIR_RootConstrainSelectedInstOperands,
     /* 100925 */     // GIR_Coverage, 3428,
     /* 100925 */     GIR_EraseRootFromParent_Done,
     /* 100926 */   // Label 2133: @100926
     /* 100926 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(100996), // Rule ID 16802 //
     /* 100931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMMX),
     /* 100934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mmx_emms),
     /* 100939 */     // (intrinsic_void 14640:{ *:[iPTR] })  =>  (MMX_EMMS:{ *:[x86mmx] })
     /* 100939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MMX_EMMS),
     /* 100942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM0*/0,
     /* 100945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM1*/1,
     /* 100948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM2*/2,
     /* 100951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM3*/3,
     /* 100954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM4*/4,
     /* 100957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM5*/5,
     /* 100960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM6*/6,
     /* 100963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MM7*/7,
     /* 100966 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST0*/8,
     /* 100969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST1*/9,
     /* 100972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST2*/10,
     /* 100975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST3*/11,
     /* 100978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST4*/12,
     /* 100981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST5*/13,
     /* 100984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST6*/14,
     /* 100987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ST7*/15,
     /* 100990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100994 */     GIR_RootConstrainSelectedInstOperands,
     /* 100995 */     // GIR_Coverage, 16802,
     /* 100995 */     GIR_EraseRootFromParent_Done,
     /* 100996 */   // Label 2134: @100996
     /* 100996 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(101018), // Rule ID 16985 //
     /* 101001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 101004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xend),
     /* 101009 */     // (intrinsic_void 15073:{ *:[iPTR] })  =>  (XEND)
     /* 101009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XEND),
     /* 101012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101016 */     GIR_RootConstrainSelectedInstOperands,
     /* 101017 */     // GIR_Coverage, 16985,
     /* 101017 */     GIR_EraseRootFromParent_Done,
     /* 101018 */   // Label 2135: @101018
     /* 101018 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(101064), // Rule ID 16997 //
     /* 101023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 101026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilerelease),
     /* 101031 */     // (intrinsic_void 14999:{ *:[iPTR] })  =>  (TILERELEASE:{ *:[x86amx] })
     /* 101031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TILERELEASE),
     /* 101034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101055 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101062 */     GIR_RootConstrainSelectedInstOperands,
     /* 101063 */     // GIR_Coverage, 16997,
     /* 101063 */     GIR_EraseRootFromParent_Done,
     /* 101064 */   // Label 2136: @101064
     /* 101064 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(101083), // Rule ID 17086 //
     /* 101069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbinvd),
     /* 101074 */     // (intrinsic_void 15060:{ *:[iPTR] })  =>  (WBINVD)
     /* 101074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBINVD),
     /* 101077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101081 */     GIR_RootConstrainSelectedInstOperands,
     /* 101082 */     // GIR_Coverage, 17086,
     /* 101082 */     GIR_EraseRootFromParent_Done,
     /* 101083 */   // Label 2137: @101083
     /* 101083 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(101105), // Rule ID 17087 //
     /* 101088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWBNOINVD),
     /* 101091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wbnoinvd),
     /* 101096 */     // (intrinsic_void 15061:{ *:[iPTR] })  =>  (WBNOINVD)
     /* 101096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WBNOINVD),
     /* 101099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101103 */     GIR_RootConstrainSelectedInstOperands,
     /* 101104 */     // GIR_Coverage, 17087,
     /* 101104 */     GIR_EraseRootFromParent_Done,
     /* 101105 */   // Label 2138: @101105
     /* 101105 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(101127), // Rule ID 17092 //
     /* 101110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_saveprevssp),
     /* 101115 */     // (intrinsic_void 14742:{ *:[iPTR] })  =>  (SAVEPREVSSP)
     /* 101115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAVEPREVSSP),
     /* 101118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101125 */     GIR_RootConstrainSelectedInstOperands,
     /* 101126 */     // GIR_Coverage, 17092,
     /* 101126 */     GIR_EraseRootFromParent_Done,
     /* 101127 */   // Label 2139: @101127
     /* 101127 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(101149), // Rule ID 17102 //
     /* 101132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_setssbsy),
     /* 101137 */     // (intrinsic_void 14748:{ *:[iPTR] })  =>  (SETSSBSY)
     /* 101137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SETSSBSY),
     /* 101140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101147 */     GIR_RootConstrainSelectedInstOperands,
     /* 101148 */     // GIR_Coverage, 17102,
     /* 101148 */     GIR_EraseRootFromParent_Done,
     /* 101149 */   // Label 2140: @101149
     /* 101149 */   GIM_Reject,
     /* 101150 */ // Label 2122: @101150
     /* 101150 */ GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(103038),
     /* 101155 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 101158 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(101216), // Rule ID 17130 //
     /* 101163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 101166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 101171 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 101174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 101189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101202 */     // (intrinsic_void 14722:{ *:[iPTR] }, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (PTWRITE64m addr:{ *:[iPTR] }:$dst)
     /* 101202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64m),
     /* 101205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101214 */     GIR_RootConstrainSelectedInstOperands,
     /* 101215 */     // GIR_Coverage, 17130,
     /* 101215 */     GIR_EraseRootFromParent_Done,
     /* 101216 */   // Label 2142: @101216
     /* 101216 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(101274), // Rule ID 17129 //
     /* 101221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 101224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 101229 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 101240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 101247 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 101251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101260 */     // (intrinsic_void 14721:{ *:[iPTR] }, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$dst)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (PTWRITEm addr:{ *:[iPTR] }:$dst)
     /* 101260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEm),
     /* 101263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 101272 */     GIR_RootConstrainSelectedInstOperands,
     /* 101273 */     // GIR_Coverage, 17129,
     /* 101273 */     GIR_EraseRootFromParent_Done,
     /* 101274 */   // Label 2143: @101274
     /* 101274 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(101311), // Rule ID 162 //
     /* 101279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSHOPT),
     /* 101282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clflushopt),
     /* 101287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101298 */     // (intrinsic_void 14603:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSHOPT addr:{ *:[iPTR] }:$src)
     /* 101298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSHOPT),
     /* 101301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101309 */     GIR_RootConstrainSelectedInstOperands,
     /* 101310 */     // GIR_Coverage, 162,
     /* 101310 */     GIR_EraseRootFromParent_Done,
     /* 101311 */   // Label 2144: @101311
     /* 101311 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(101348), // Rule ID 163 //
     /* 101316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLWB),
     /* 101319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clwb),
     /* 101324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101335 */     // (intrinsic_void 14606:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLWB addr:{ *:[iPTR] }:$src)
     /* 101335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLWB),
     /* 101338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101346 */     GIR_RootConstrainSelectedInstOperands,
     /* 101347 */     // GIR_Coverage, 163,
     /* 101347 */     GIR_EraseRootFromParent_Done,
     /* 101348 */   // Label 2145: @101348
     /* 101348 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(101385), // Rule ID 164 //
     /* 101353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLDEMOTE),
     /* 101356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_cldemote),
     /* 101361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101372 */     // (intrinsic_void 14602:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLDEMOTE addr:{ *:[iPTR] }:$src)
     /* 101372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLDEMOTE),
     /* 101375 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101383 */     GIR_RootConstrainSelectedInstOperands,
     /* 101384 */     // GIR_Coverage, 164,
     /* 101384 */     GIR_EraseRootFromParent_Done,
     /* 101385 */   // Label 2146: @101385
     /* 101385 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(101422), // Rule ID 169 //
     /* 101390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS),
     /* 101393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_prefetchrs),
     /* 101398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101409 */     // (intrinsic_void 14720:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (PREFETCHRST2 addr:{ *:[iPTR] }:$src)
     /* 101409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PREFETCHRST2),
     /* 101412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101420 */     GIR_RootConstrainSelectedInstOperands,
     /* 101421 */     // GIR_Coverage, 169,
     /* 101421 */     GIR_EraseRootFromParent_Done,
     /* 101422 */   // Label 2147: @101422
     /* 101422 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(101459), // Rule ID 1133 //
     /* 101427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave),
     /* 101435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101446 */     // (intrinsic_void 14626:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE addr:{ *:[iPTR] }:$dst)
     /* 101446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE),
     /* 101449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101457 */     GIR_RootConstrainSelectedInstOperands,
     /* 101458 */     // GIR_Coverage, 1133,
     /* 101458 */     GIR_EraseRootFromParent_Done,
     /* 101459 */   // Label 2148: @101459
     /* 101459 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(101496), // Rule ID 1134 //
     /* 101464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxsave64),
     /* 101472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101483 */     // (intrinsic_void 14627:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (FXSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 101483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXSAVE64),
     /* 101486 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101494 */     GIR_RootConstrainSelectedInstOperands,
     /* 101495 */     // GIR_Coverage, 1134,
     /* 101495 */     GIR_EraseRootFromParent_Done,
     /* 101496 */   // Label 2149: @101496
     /* 101496 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(101539), // Rule ID 1135 //
     /* 101501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR),
     /* 101504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor),
     /* 101509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101520 */     // (intrinsic_void 14624:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR),
     /* 101523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101537 */     GIR_RootConstrainSelectedInstOperands,
     /* 101538 */     // GIR_Coverage, 1135,
     /* 101538 */     GIR_EraseRootFromParent_Done,
     /* 101539 */   // Label 2150: @101539
     /* 101539 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(101582), // Rule ID 1136 //
     /* 101544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFXSR_In64BitMode),
     /* 101547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_fxrstor64),
     /* 101552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101563 */     // (intrinsic_void 14625:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (FXRSTOR64:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 101563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FXRSTOR64),
     /* 101566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 101573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPCW*/1,
     /* 101576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101580 */     GIR_RootConstrainSelectedInstOperands,
     /* 101581 */     // GIR_Coverage, 1136,
     /* 101581 */     GIR_EraseRootFromParent_Done,
     /* 101582 */   // Label 2151: @101582
     /* 101582 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(101619), // Rule ID 2509 //
     /* 101587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCLFLUSH),
     /* 101590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_clflush),
     /* 101595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101606 */     // (intrinsic_void 14794:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLFLUSH addr:{ *:[iPTR] }:$src)
     /* 101606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLFLUSH),
     /* 101609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101617 */     GIR_RootConstrainSelectedInstOperands,
     /* 101618 */     // GIR_Coverage, 2509,
     /* 101618 */     GIR_EraseRootFromParent_Done,
     /* 101619 */   // Label 2152: @101619
     /* 101619 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(101659), // Rule ID 2514 //
     /* 101624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101643 */     // (intrinsic_void 14775:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDMXCSR),
     /* 101646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101657 */     GIR_RootConstrainSelectedInstOperands,
     /* 101658 */     // GIR_Coverage, 2514,
     /* 101658 */     GIR_EraseRootFromParent_Done,
     /* 101659 */   // Label 2153: @101659
     /* 101659 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(101696), // Rule ID 2515 //
     /* 101664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 101667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101683 */     // (intrinsic_void 14787:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (VSTMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSTMXCSR),
     /* 101686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101694 */     GIR_RootConstrainSelectedInstOperands,
     /* 101695 */     // GIR_Coverage, 2515,
     /* 101695 */     GIR_EraseRootFromParent_Done,
     /* 101696 */   // Label 2154: @101696
     /* 101696 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(101733), // Rule ID 2516 //
     /* 101701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_ldmxcsr),
     /* 101706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101717 */     // (intrinsic_void 14775:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDMXCSR addr:{ *:[iPTR] }:$src)
     /* 101717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDMXCSR),
     /* 101720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::MXCSR*/0,
     /* 101727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101731 */     GIR_RootConstrainSelectedInstOperands,
     /* 101732 */     // GIR_Coverage, 2516,
     /* 101732 */     GIR_EraseRootFromParent_Done,
     /* 101733 */   // Label 2155: @101733
     /* 101733 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(101767), // Rule ID 2517 //
     /* 101738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse_stmxcsr),
     /* 101743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101754 */     // (intrinsic_void 14787:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst)  =>  (STMXCSR addr:{ *:[iPTR] }:$dst)
     /* 101754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STMXCSR),
     /* 101757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 101761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101765 */     GIR_RootConstrainSelectedInstOperands,
     /* 101766 */     // GIR_Coverage, 2517,
     /* 101766 */     GIR_EraseRootFromParent_Done,
     /* 101767 */   // Label 2156: @101767
     /* 101767 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(101828), // Rule ID 16993 //
     /* 101772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101791 */     // (intrinsic_void 14632:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG),
     /* 101794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101826 */     GIR_RootConstrainSelectedInstOperands,
     /* 101827 */     // GIR_Coverage, 16993,
     /* 101827 */     GIR_EraseRootFromParent_Done,
     /* 101828 */   // Label 2157: @101828
     /* 101828 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(101865), // Rule ID 16994 //
     /* 101833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode_NoEGPR),
     /* 101836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101852 */     // (intrinsic_void 14928:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG addr:{ *:[iPTR] }:$src)
     /* 101852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG),
     /* 101855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101863 */     GIR_RootConstrainSelectedInstOperands,
     /* 101864 */     // GIR_Coverage, 16994,
     /* 101864 */     GIR_EraseRootFromParent_Done,
     /* 101865 */   // Label 2158: @101865
     /* 101865 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(101926), // Rule ID 16995 //
     /* 101870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ldtilecfg),
     /* 101878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101889 */     // (intrinsic_void 14632:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDTILECFG_EVEX:{ *:[x86amx] } addr:{ *:[iPTR] }:$src)
     /* 101889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDTILECFG_EVEX),
     /* 101892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM0*/0,
     /* 101899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM1*/1,
     /* 101902 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM2*/2,
     /* 101905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM3*/3,
     /* 101908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM4*/4,
     /* 101911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM5*/5,
     /* 101914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM6*/6,
     /* 101917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::TMM7*/7,
     /* 101920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101924 */     GIR_RootConstrainSelectedInstOperands,
     /* 101925 */     // GIR_Coverage, 16995,
     /* 101925 */     GIR_EraseRootFromParent_Done,
     /* 101926 */   // Label 2159: @101926
     /* 101926 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(101963), // Rule ID 16996 //
     /* 101931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_HasEGPR_In64BitMode),
     /* 101934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sttilecfg),
     /* 101939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101950 */     // (intrinsic_void 14928:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (STTILECFG_EVEX addr:{ *:[iPTR] }:$src)
     /* 101950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::STTILECFG_EVEX),
     /* 101953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101961 */     GIR_RootConstrainSelectedInstOperands,
     /* 101962 */     // GIR_Coverage, 16996,
     /* 101962 */     GIR_EraseRootFromParent_Done,
     /* 101963 */   // Label 2160: @101963
     /* 101963 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(102000), // Rule ID 17093 //
     /* 101968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_rstorssp),
     /* 101973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 101984 */     // (intrinsic_void 14741:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (RSTORSSP addr:{ *:[iPTR] }:$src)
     /* 101984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RSTORSSP),
     /* 101987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 101991 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 101994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101998 */     GIR_RootConstrainSelectedInstOperands,
     /* 101999 */     // GIR_Coverage, 17093,
     /* 101999 */     GIR_EraseRootFromParent_Done,
     /* 102000 */   // Label 2161: @102000
     /* 102000 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(102037), // Rule ID 17103 //
     /* 102005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_clrssbsy),
     /* 102010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 102021 */     // (intrinsic_void 14604:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (CLRSSBSY addr:{ *:[iPTR] }:$src)
     /* 102021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CLRSSBSY),
     /* 102024 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 102028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102035 */     GIR_RootConstrainSelectedInstOperands,
     /* 102036 */     // GIR_Coverage, 17103,
     /* 102036 */     GIR_EraseRootFromParent_Done,
     /* 102037 */   // Label 2162: @102037
     /* 102037 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(102067), // Rule ID 17075 //
     /* 102042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102047 */     // MIs[0] Operand 1
     /* 102047 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(3),
     /* 102058 */     // (intrinsic_void 14630:{ *:[iPTR] }, 3:{ *:[i8] })  =>  (INT3)
     /* 102058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 102061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102065 */     GIR_RootConstrainSelectedInstOperands,
     /* 102066 */     // GIR_Coverage, 17075,
     /* 102066 */     GIR_EraseRootFromParent_Done,
     /* 102067 */   // Label 2163: @102067
     /* 102067 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(102094), // Rule ID 16987 //
     /* 102072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xabort),
     /* 102080 */     // MIs[0] imm
     /* 102080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102083 */     // (intrinsic_void 15071:{ *:[iPTR] }, (timm:{ *:[i8] }):$imm)  =>  (XABORT (timm:{ *:[i8] }):$imm)
     /* 102083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XABORT),
     /* 102086 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 102088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102092 */     GIR_RootConstrainSelectedInstOperands,
     /* 102093 */     // GIR_Coverage, 16987,
     /* 102093 */     GIR_EraseRootFromParent_Done,
     /* 102094 */   // Label 2164: @102094
     /* 102094 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(102121), // Rule ID 16999 //
     /* 102099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTILE_In64BitMode),
     /* 102102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tilezero),
     /* 102107 */     // MIs[0] src
     /* 102107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102110 */     // (intrinsic_void 15002:{ *:[iPTR] }, (timm:{ *:[i8] }):$src)  =>  (PTILEZERO (timm:{ *:[i8] }):$src)
     /* 102110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEZERO),
     /* 102113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102119 */     GIR_RootConstrainSelectedInstOperands,
     /* 102120 */     // GIR_Coverage, 16999,
     /* 102120 */     GIR_EraseRootFromParent_Done,
     /* 102121 */   // Label 2165: @102121
     /* 102121 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(102145), // Rule ID 17077 //
     /* 102126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_int),
     /* 102131 */     // MIs[0] trap
     /* 102131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 102134 */     // (intrinsic_void 14630:{ *:[iPTR] }, (timm:{ *:[i8] }):$trap)  =>  (INT (timm:{ *:[i8] }):$trap)
     /* 102134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 102137 */     GIR_RootToRootCopy, /*OpIdx*/1, // trap
     /* 102139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102143 */     GIR_RootConstrainSelectedInstOperands,
     /* 102144 */     // GIR_Coverage, 17077,
     /* 102144 */     GIR_EraseRootFromParent_Done,
     /* 102145 */   // Label 2166: @102145
     /* 102145 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(102179), // Rule ID 1 //
     /* 102150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u32),
     /* 102158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102165 */     // (intrinsic_w_chain:{ *:[i32] } 14616:{ *:[iPTR] })  =>  (RDFLAGS32:{ *:[i32] }:{ *:[i32] })
     /* 102165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS32),
     /* 102168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102177 */     GIR_RootConstrainSelectedInstOperands,
     /* 102178 */     // GIR_Coverage, 1,
     /* 102178 */     GIR_EraseRootFromParent_Done,
     /* 102179 */   // Label 2167: @102179
     /* 102179 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(102213), // Rule ID 2 //
     /* 102184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_flags_read_u64),
     /* 102192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102199 */     // (intrinsic_w_chain:{ *:[i64] } 14617:{ *:[iPTR] })  =>  (RDFLAGS64:{ *:[i64] }:{ *:[i32] })
     /* 102199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFLAGS64),
     /* 102202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102211 */     GIR_RootConstrainSelectedInstOperands,
     /* 102212 */     // GIR_Coverage, 2,
     /* 102212 */     GIR_EraseRootFromParent_Done,
     /* 102213 */   // Label 2168: @102213
     /* 102213 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(102244), // Rule ID 115 //
     /* 102218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102233 */     // (intrinsic_w_chain:{ *:[i32] } 14756:{ *:[iPTR] })  =>  (SLWPCB:{ *:[i32] })
     /* 102233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB),
     /* 102236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102242 */     GIR_RootConstrainSelectedInstOperands,
     /* 102243 */     // GIR_Coverage, 115,
     /* 102243 */     GIR_EraseRootFromParent_Done,
     /* 102244 */   // Label 2169: @102244
     /* 102244 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(102275), // Rule ID 117 //
     /* 102249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_slwpcb),
     /* 102257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102264 */     // (intrinsic_w_chain:{ *:[i64] } 14756:{ *:[iPTR] })  =>  (SLWPCB64:{ *:[i64] })
     /* 102264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SLWPCB64),
     /* 102267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102273 */     GIR_RootConstrainSelectedInstOperands,
     /* 102274 */     // GIR_Coverage, 117,
     /* 102274 */     GIR_EraseRootFromParent_Done,
     /* 102275 */   // Label 2170: @102275
     /* 102275 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(102306), // Rule ID 16984 //
     /* 102280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRTM),
     /* 102283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_xbegin),
     /* 102288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102295 */     // (intrinsic_w_chain:{ *:[i32] } 15072:{ *:[iPTR] })  =>  (XBEGIN:{ *:[i32] })
     /* 102295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XBEGIN),
     /* 102298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102304 */     GIR_RootConstrainSelectedInstOperands,
     /* 102305 */     // GIR_Coverage, 16984,
     /* 102305 */     GIR_EraseRootFromParent_Done,
     /* 102306 */   // Label 2171: @102306
     /* 102306 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(102337), // Rule ID 17119 //
     /* 102311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_32),
     /* 102319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102326 */     // (intrinsic_w_chain:{ *:[i32] } 14723:{ *:[iPTR] })  =>  (RDFSBASE:{ *:[i32] })
     /* 102326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE),
     /* 102329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102335 */     GIR_RootConstrainSelectedInstOperands,
     /* 102336 */     // GIR_Coverage, 17119,
     /* 102336 */     GIR_EraseRootFromParent_Done,
     /* 102337 */   // Label 2172: @102337
     /* 102337 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(102368), // Rule ID 17120 //
     /* 102342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdfsbase_64),
     /* 102350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102357 */     // (intrinsic_w_chain:{ *:[i64] } 14724:{ *:[iPTR] })  =>  (RDFSBASE64:{ *:[i64] })
     /* 102357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDFSBASE64),
     /* 102360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102366 */     GIR_RootConstrainSelectedInstOperands,
     /* 102367 */     // GIR_Coverage, 17120,
     /* 102367 */     GIR_EraseRootFromParent_Done,
     /* 102368 */   // Label 2173: @102368
     /* 102368 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(102399), // Rule ID 17121 //
     /* 102373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_32),
     /* 102381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102388 */     // (intrinsic_w_chain:{ *:[i32] } 14725:{ *:[iPTR] })  =>  (RDGSBASE:{ *:[i32] })
     /* 102388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE),
     /* 102391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102397 */     GIR_RootConstrainSelectedInstOperands,
     /* 102398 */     // GIR_Coverage, 17121,
     /* 102398 */     GIR_EraseRootFromParent_Done,
     /* 102399 */   // Label 2174: @102399
     /* 102399 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(102430), // Rule ID 17122 //
     /* 102404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdgsbase_64),
     /* 102412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 102415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102419 */     // (intrinsic_w_chain:{ *:[i64] } 14726:{ *:[iPTR] })  =>  (RDGSBASE64:{ *:[i64] })
     /* 102419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDGSBASE64),
     /* 102422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102428 */     GIR_RootConstrainSelectedInstOperands,
     /* 102429 */     // GIR_Coverage, 17122,
     /* 102429 */     GIR_EraseRootFromParent_Done,
     /* 102430 */   // Label 2175: @102430
     /* 102430 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(102461), // Rule ID 17128 //
     /* 102435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_Not64BitMode),
     /* 102438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102450 */     // (intrinsic_w_chain:{ *:[i32] } 14727:{ *:[iPTR] })  =>  (RDPID32:{ *:[i32] })
     /* 102450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDPID32),
     /* 102453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102459 */     GIR_RootConstrainSelectedInstOperands,
     /* 102460 */     // GIR_Coverage, 17128,
     /* 102460 */     GIR_EraseRootFromParent_Done,
     /* 102461 */   // Label 2176: @102461
     /* 102461 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(102518), // Rule ID 22381 //
     /* 102466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDPID_In64BitMode),
     /* 102469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdpid),
     /* 102474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 102477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102481 */     // (intrinsic_w_chain:{ *:[i32] } 14727:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (RDPID64:{ *:[i64] }), sub_32bit:{ *:[i32] })
     /* 102481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 102484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::RDPID64),
     /* 102488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102500 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_32bit),
     /* 102507 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 102512 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 102517 */     // GIR_Coverage, 22381,
     /* 102517 */     GIR_EraseRootFromParent_Done,
     /* 102518 */   // Label 2177: @102518
     /* 102518 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(102558), // Rule ID 3 //
     /* 102523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 102526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u32),
     /* 102531 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102538 */     // (intrinsic_void 14618:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFLAGS32:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 102538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS32),
     /* 102541 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::ESP*/0,
     /* 102546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102556 */     GIR_RootConstrainSelectedInstOperands,
     /* 102557 */     // GIR_Coverage, 3,
     /* 102557 */     GIR_EraseRootFromParent_Done,
     /* 102558 */   // Label 2178: @102558
     /* 102558 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(102598), // Rule ID 4 //
     /* 102563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 102566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_flags_write_u64),
     /* 102571 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102578 */     // (intrinsic_void 14619:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFLAGS64:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 102578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFLAGS64),
     /* 102581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::RSP*/0,
     /* 102586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/1,
     /* 102589 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::DF*/2,
     /* 102592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102596 */     GIR_RootConstrainSelectedInstOperands,
     /* 102597 */     // GIR_Coverage, 4,
     /* 102597 */     GIR_EraseRootFromParent_Done,
     /* 102598 */   // Label 2179: @102598
     /* 102598 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(102629), // Rule ID 154 //
     /* 102603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUINTR_In64BitMode),
     /* 102606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_senduipi),
     /* 102611 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102618 */     // (intrinsic_void 14746:{ *:[iPTR] }, GR64:{ *:[i64] }:$arg)  =>  (SENDUIPI GR64:{ *:[i64] }:$arg)
     /* 102618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SENDUIPI),
     /* 102621 */     GIR_RootToRootCopy, /*OpIdx*/1, // arg
     /* 102623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102627 */     GIR_RootConstrainSelectedInstOperands,
     /* 102628 */     // GIR_Coverage, 154,
     /* 102628 */     GIR_EraseRootFromParent_Done,
     /* 102629 */   // Label 2180: @102629
     /* 102629 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(102660), // Rule ID 17088 //
     /* 102634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspd),
     /* 102639 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102646 */     // (intrinsic_void 14628:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (INCSSPD GR32:{ *:[i32] }:$src)
     /* 102646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPD),
     /* 102649 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102658 */     GIR_RootConstrainSelectedInstOperands,
     /* 102659 */     // GIR_Coverage, 17088,
     /* 102659 */     GIR_EraseRootFromParent_Done,
     /* 102660 */   // Label 2181: @102660
     /* 102660 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(102691), // Rule ID 17089 //
     /* 102665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_incsspq),
     /* 102670 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102677 */     // (intrinsic_void 14629:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (INCSSPQ GR64:{ *:[i64] }:$src)
     /* 102677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INCSSPQ),
     /* 102680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::SSP*/0,
     /* 102685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102689 */     GIR_RootConstrainSelectedInstOperands,
     /* 102690 */     // GIR_Coverage, 17089,
     /* 102690 */     GIR_EraseRootFromParent_Done,
     /* 102691 */   // Label 2182: @102691
     /* 102691 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(102722), // Rule ID 17123 //
     /* 102696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_32),
     /* 102704 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102711 */     // (intrinsic_void 15062:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRFSBASE GR32:{ *:[i32] }:$src)
     /* 102711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE),
     /* 102714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102720 */     GIR_RootConstrainSelectedInstOperands,
     /* 102721 */     // GIR_Coverage, 17123,
     /* 102721 */     GIR_EraseRootFromParent_Done,
     /* 102722 */   // Label 2183: @102722
     /* 102722 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(102753), // Rule ID 17124 //
     /* 102727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrfsbase_64),
     /* 102735 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102742 */     // (intrinsic_void 15063:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRFSBASE64 GR64:{ *:[i64] }:$src)
     /* 102742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRFSBASE64),
     /* 102745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102751 */     GIR_RootConstrainSelectedInstOperands,
     /* 102752 */     // GIR_Coverage, 17124,
     /* 102752 */     GIR_EraseRootFromParent_Done,
     /* 102753 */   // Label 2184: @102753
     /* 102753 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(102784), // Rule ID 17125 //
     /* 102758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_32),
     /* 102766 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102773 */     // (intrinsic_void 15064:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (WRGSBASE GR32:{ *:[i32] }:$src)
     /* 102773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE),
     /* 102776 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102782 */     GIR_RootConstrainSelectedInstOperands,
     /* 102783 */     // GIR_Coverage, 17125,
     /* 102783 */     GIR_EraseRootFromParent_Done,
     /* 102784 */   // Label 2185: @102784
     /* 102784 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(102815), // Rule ID 17126 //
     /* 102789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFSGSBase_In64BitMode),
     /* 102792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrgsbase_64),
     /* 102797 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102804 */     // (intrinsic_void 15065:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (WRGSBASE64 GR64:{ *:[i64] }:$src)
     /* 102804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRGSBASE64),
     /* 102807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102813 */     GIR_RootConstrainSelectedInstOperands,
     /* 102814 */     // GIR_Coverage, 17126,
     /* 102814 */     GIR_EraseRootFromParent_Done,
     /* 102815 */   // Label 2186: @102815
     /* 102815 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(102846), // Rule ID 17131 //
     /* 102820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE),
     /* 102823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite32),
     /* 102828 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102835 */     // (intrinsic_void 14721:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst)  =>  (PTWRITEr GR32:{ *:[i32] }:$dst)
     /* 102835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITEr),
     /* 102838 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102844 */     GIR_RootConstrainSelectedInstOperands,
     /* 102845 */     // GIR_Coverage, 17131,
     /* 102845 */     GIR_EraseRootFromParent_Done,
     /* 102846 */   // Label 2187: @102846
     /* 102846 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(102877), // Rule ID 17132 //
     /* 102851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPTWRITE_In64BitMode),
     /* 102854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ptwrite64),
     /* 102859 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102866 */     // (intrinsic_void 14722:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst)  =>  (PTWRITE64r GR64:{ *:[i64] }:$dst)
     /* 102866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTWRITE64r),
     /* 102869 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 102871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102875 */     GIR_RootConstrainSelectedInstOperands,
     /* 102876 */     // GIR_Coverage, 17132,
     /* 102876 */     GIR_EraseRootFromParent_Done,
     /* 102877 */   // Label 2188: @102877
     /* 102877 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(102909), // Rule ID 114 //
     /* 102882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102890 */     // MIs[0] src
     /* 102890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102898 */     // (intrinsic_void 14634:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (LLWPCB GR32:{ *:[i32] }:$src)
     /* 102898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB),
     /* 102901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102907 */     GIR_RootConstrainSelectedInstOperands,
     /* 102908 */     // GIR_Coverage, 114,
     /* 102908 */     GIR_EraseRootFromParent_Done,
     /* 102909 */   // Label 2189: @102909
     /* 102909 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(102941), // Rule ID 116 //
     /* 102914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 102917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_llwpcb),
     /* 102922 */     // MIs[0] src
     /* 102922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 102926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 102930 */     // (intrinsic_void 14634:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (LLWPCB64 GR64:{ *:[i64] }:$src)
     /* 102930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LLWPCB64),
     /* 102933 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102939 */     GIR_RootConstrainSelectedInstOperands,
     /* 102940 */     // GIR_Coverage, 116,
     /* 102940 */     GIR_EraseRootFromParent_Done,
     /* 102941 */   // Label 2190: @102941
     /* 102941 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(102973), // Rule ID 126 //
     /* 102946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_Not64BitMode),
     /* 102949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102954 */     // MIs[0] src
     /* 102954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/16,
     /* 102958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 102962 */     // (intrinsic_void 15019:{ *:[iPTR] }, GR16:{ *:[i16] }:$src)  =>  (UMONITOR16 GR16:{ *:[i16] }:$src)
     /* 102962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR16),
     /* 102965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102971 */     GIR_RootConstrainSelectedInstOperands,
     /* 102972 */     // GIR_Coverage, 126,
     /* 102972 */     GIR_EraseRootFromParent_Done,
     /* 102973 */   // Label 2191: @102973
     /* 102973 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(103005), // Rule ID 127 //
     /* 102978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG),
     /* 102981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 102986 */     // MIs[0] src
     /* 102986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 102990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 102994 */     // (intrinsic_void 15019:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (UMONITOR32 GR32:{ *:[i32] }:$src)
     /* 102994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR32),
     /* 102997 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 102999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103003 */     GIR_RootConstrainSelectedInstOperands,
     /* 103004 */     // GIR_Coverage, 127,
     /* 103004 */     GIR_EraseRootFromParent_Done,
     /* 103005 */   // Label 2192: @103005
     /* 103005 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(103037), // Rule ID 128 //
     /* 103010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasWAITPKG_In64BitMode),
     /* 103013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_umonitor),
     /* 103018 */     // MIs[0] src
     /* 103018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 103022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103026 */     // (intrinsic_void 15019:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (UMONITOR64 GR64:{ *:[i64] }:$src)
     /* 103026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UMONITOR64),
     /* 103029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 103031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103035 */     GIR_RootConstrainSelectedInstOperands,
     /* 103036 */     // GIR_Coverage, 128,
     /* 103036 */     GIR_EraseRootFromParent_Done,
     /* 103037 */   // Label 2193: @103037
     /* 103037 */   GIM_Reject,
     /* 103038 */ // Label 2141: @103038
     /* 103038 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(106032),
     /* 103043 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 103046 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(103092), // Rule ID 165 //
     /* 103051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103077 */     // (intrinsic_w_chain:{ *:[i8] } 14714:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm),
     /* 103080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103090 */     GIR_RootConstrainSelectedInstOperands,
     /* 103091 */     // GIR_Coverage, 165,
     /* 103091 */     GIR_EraseRootFromParent_Done,
     /* 103092 */   // Label 2195: @103092
     /* 103092 */   GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(103138), // Rule ID 166 //
     /* 103097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103123 */     // (intrinsic_w_chain:{ *:[i16] } 14713:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm),
     /* 103126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103136 */     GIR_RootConstrainSelectedInstOperands,
     /* 103137 */     // GIR_Coverage, 166,
     /* 103137 */     GIR_EraseRootFromParent_Done,
     /* 103138 */   // Label 2196: @103138
     /* 103138 */   GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(103184), // Rule ID 167 //
     /* 103143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103169 */     // (intrinsic_w_chain:{ *:[i32] } 14715:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm),
     /* 103172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103182 */     GIR_RootConstrainSelectedInstOperands,
     /* 103183 */     // GIR_Coverage, 167,
     /* 103183 */     GIR_EraseRootFromParent_Done,
     /* 103184 */   // Label 2197: @103184
     /* 103184 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(103230), // Rule ID 168 //
     /* 103189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVRS_In64BitMode_NoEGPR),
     /* 103192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103215 */     // (intrinsic_w_chain:{ *:[i64] } 14712:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm),
     /* 103218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103228 */     GIR_RootConstrainSelectedInstOperands,
     /* 103229 */     // GIR_Coverage, 168,
     /* 103229 */     GIR_EraseRootFromParent_Done,
     /* 103230 */   // Label 2198: @103230
     /* 103230 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(103276), // Rule ID 170 //
     /* 103235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsqi),
     /* 103243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 103246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 103250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103261 */     // (intrinsic_w_chain:{ *:[i8] } 14714:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS8rm_EVEX:{ *:[i8] } addr:{ *:[iPTR] }:$src)
     /* 103261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS8rm_EVEX),
     /* 103264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103266 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103274 */     GIR_RootConstrainSelectedInstOperands,
     /* 103275 */     // GIR_Coverage, 170,
     /* 103275 */     GIR_EraseRootFromParent_Done,
     /* 103276 */   // Label 2199: @103276
     /* 103276 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(103322), // Rule ID 171 //
     /* 103281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrshi),
     /* 103289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 103292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 103296 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103307 */     // (intrinsic_w_chain:{ *:[i16] } 14713:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 103307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS16rm_EVEX),
     /* 103310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103320 */     GIR_RootConstrainSelectedInstOperands,
     /* 103321 */     // GIR_Coverage, 171,
     /* 103321 */     GIR_EraseRootFromParent_Done,
     /* 103322 */   // Label 2200: @103322
     /* 103322 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(103368), // Rule ID 172 //
     /* 103327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrssi),
     /* 103335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 103338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 103342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103353 */     // (intrinsic_w_chain:{ *:[i32] } 14715:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 103353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS32rm_EVEX),
     /* 103356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103358 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103366 */     GIR_RootConstrainSelectedInstOperands,
     /* 103367 */     // GIR_Coverage, 172,
     /* 103367 */     GIR_EraseRootFromParent_Done,
     /* 103368 */   // Label 2201: @103368
     /* 103368 */   GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(103414), // Rule ID 173 //
     /* 103373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVRS_In64BitMode),
     /* 103376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_movrsdi),
     /* 103381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 103384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 103388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103399 */     // (intrinsic_w_chain:{ *:[i64] } 14712:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (MOVRS64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 103399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVRS64rm_EVEX),
     /* 103402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103412 */     GIR_RootConstrainSelectedInstOperands,
     /* 103413 */     // GIR_Coverage, 173,
     /* 103413 */     GIR_EraseRootFromParent_Done,
     /* 103414 */   // Label 2202: @103414
     /* 103414 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(103460), // Rule ID 2951 //
     /* 103419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103445 */     // (intrinsic_w_chain:{ *:[v16i8] } 14860:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUrm),
     /* 103448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103458 */     GIR_RootConstrainSelectedInstOperands,
     /* 103459 */     // GIR_Coverage, 2951,
     /* 103459 */     GIR_EraseRootFromParent_Done,
     /* 103460 */   // Label 2203: @103460
     /* 103460 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(103506), // Rule ID 2952 //
     /* 103465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 103468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_ldu_dq_256),
     /* 103473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 103476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103491 */     // (intrinsic_w_chain:{ *:[v32i8] } 13481:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VLDDQUYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 103491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VLDDQUYrm),
     /* 103494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103496 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103504 */     GIR_RootConstrainSelectedInstOperands,
     /* 103505 */     // GIR_Coverage, 2952,
     /* 103505 */     GIR_EraseRootFromParent_Done,
     /* 103506 */   // Label 2204: @103506
     /* 103506 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(103552), // Rule ID 2953 //
     /* 103511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE3),
     /* 103514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_sse3_ldu_dq),
     /* 103519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 103522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103537 */     // (intrinsic_w_chain:{ *:[v16i8] } 14860:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (LDDQUrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 103537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LDDQUrm),
     /* 103540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103542 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103546 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103550 */     GIR_RootConstrainSelectedInstOperands,
     /* 103551 */     // GIR_Coverage, 2953,
     /* 103551 */     GIR_EraseRootFromParent_Done,
     /* 103552 */   // Label 2205: @103552
     /* 103552 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(103598), // Rule ID 3543 //
     /* 103557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps128),
     /* 103565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103572 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103583 */     // (intrinsic_w_chain:{ *:[v4f32] } 15023:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSrm),
     /* 103586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103596 */     GIR_RootConstrainSelectedInstOperands,
     /* 103597 */     // GIR_Coverage, 3543,
     /* 103597 */     GIR_EraseRootFromParent_Done,
     /* 103598 */   // Label 2206: @103598
     /* 103598 */   GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(103644), // Rule ID 3544 //
     /* 103603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnebf162ps256),
     /* 103611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103618 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103629 */     // (intrinsic_w_chain:{ *:[v8f32] } 15024:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNEBF162PSYrm),
     /* 103632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103642 */     GIR_RootConstrainSelectedInstOperands,
     /* 103643 */     // GIR_Coverage, 3544,
     /* 103643 */     GIR_EraseRootFromParent_Done,
     /* 103644 */   // Label 2207: @103644
     /* 103644 */   GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(103690), // Rule ID 3545 //
     /* 103649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps128),
     /* 103657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103675 */     // (intrinsic_w_chain:{ *:[v4f32] } 15025:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSrm),
     /* 103678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103688 */     GIR_RootConstrainSelectedInstOperands,
     /* 103689 */     // GIR_Coverage, 3545,
     /* 103689 */     GIR_EraseRootFromParent_Done,
     /* 103690 */   // Label 2208: @103690
     /* 103690 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(103736), // Rule ID 3546 //
     /* 103695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vbcstnesh2ps256),
     /* 103703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103721 */     // (intrinsic_w_chain:{ *:[v8f32] } 15026:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VBCSTNESH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VBCSTNESH2PSYrm),
     /* 103724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103726 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103734 */     GIR_RootConstrainSelectedInstOperands,
     /* 103735 */     // GIR_Coverage, 3546,
     /* 103735 */     GIR_EraseRootFromParent_Done,
     /* 103736 */   // Label 2209: @103736
     /* 103736 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(103782), // Rule ID 3547 //
     /* 103741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps128),
     /* 103749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103767 */     // (intrinsic_w_chain:{ *:[v4f32] } 15027:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSrm),
     /* 103770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103772 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103776 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103780 */     GIR_RootConstrainSelectedInstOperands,
     /* 103781 */     // GIR_Coverage, 3547,
     /* 103781 */     GIR_EraseRootFromParent_Done,
     /* 103782 */   // Label 2210: @103782
     /* 103782 */   GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(103828), // Rule ID 3548 //
     /* 103787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneebf162ps256),
     /* 103795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103813 */     // (intrinsic_w_chain:{ *:[v8f32] } 15028:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEBF162PSYrm),
     /* 103816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103826 */     GIR_RootConstrainSelectedInstOperands,
     /* 103827 */     // GIR_Coverage, 3548,
     /* 103827 */     GIR_EraseRootFromParent_Done,
     /* 103828 */   // Label 2211: @103828
     /* 103828 */   GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(103874), // Rule ID 3549 //
     /* 103833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps128),
     /* 103841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103859 */     // (intrinsic_w_chain:{ *:[v4f32] } 15029:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSrm),
     /* 103862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103864 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103872 */     GIR_RootConstrainSelectedInstOperands,
     /* 103873 */     // GIR_Coverage, 3549,
     /* 103873 */     GIR_EraseRootFromParent_Done,
     /* 103874 */   // Label 2212: @103874
     /* 103874 */   GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(103920), // Rule ID 3550 //
     /* 103879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneeph2ps256),
     /* 103887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103905 */     // (intrinsic_w_chain:{ *:[v8f32] } 15030:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEEPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEEPH2PSYrm),
     /* 103908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103910 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103918 */     GIR_RootConstrainSelectedInstOperands,
     /* 103919 */     // GIR_Coverage, 3550,
     /* 103919 */     GIR_EraseRootFromParent_Done,
     /* 103920 */   // Label 2213: @103920
     /* 103920 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(103966), // Rule ID 3551 //
     /* 103925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps128),
     /* 103933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 103936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 103940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103951 */     // (intrinsic_w_chain:{ *:[v4f32] } 15031:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 103951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSrm),
     /* 103954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 103960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103964 */     GIR_RootConstrainSelectedInstOperands,
     /* 103965 */     // GIR_Coverage, 3551,
     /* 103965 */     GIR_EraseRootFromParent_Done,
     /* 103966 */   // Label 2214: @103966
     /* 103966 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(104012), // Rule ID 3552 //
     /* 103971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 103974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneobf162ps256),
     /* 103979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 103982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 103986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 103990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 103997 */     // (intrinsic_w_chain:{ *:[v8f32] } 15032:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOBF162PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 103997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOBF162PSYrm),
     /* 104000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104010 */     GIR_RootConstrainSelectedInstOperands,
     /* 104011 */     // GIR_Coverage, 3552,
     /* 104011 */     GIR_EraseRootFromParent_Done,
     /* 104012 */   // Label 2215: @104012
     /* 104012 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(104058), // Rule ID 3553 //
     /* 104017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps128),
     /* 104025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 104032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104043 */     // (intrinsic_w_chain:{ *:[v4f32] } 15033:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 104043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSrm),
     /* 104046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104048 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104056 */     GIR_RootConstrainSelectedInstOperands,
     /* 104057 */     // GIR_Coverage, 3553,
     /* 104057 */     GIR_EraseRootFromParent_Done,
     /* 104058 */   // Label 2216: @104058
     /* 104058 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(104104), // Rule ID 3554 //
     /* 104063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVXNECONVERT),
     /* 104066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_vcvtneoph2ps256),
     /* 104071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 104078 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104089 */     // (intrinsic_w_chain:{ *:[v8f32] } 15034:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VCVTNEOPH2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 104089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTNEOPH2PSYrm),
     /* 104092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104102 */     GIR_RootConstrainSelectedInstOperands,
     /* 104103 */     // GIR_Coverage, 3554,
     /* 104103 */     GIR_EraseRootFromParent_Done,
     /* 104104 */   // Label 2217: @104104
     /* 104104 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(104150), // Rule ID 16753 //
     /* 104109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb512),
     /* 104117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v64s8,
     /* 104120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104135 */     // (intrinsic_w_chain:{ *:[v64i8] } 13737:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src)
     /* 104135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZm),
     /* 104138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104148 */     GIR_RootConstrainSelectedInstOperands,
     /* 104149 */     // GIR_Coverage, 16753,
     /* 104149 */     GIR_EraseRootFromParent_Done,
     /* 104150 */   // Label 2218: @104150
     /* 104150 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(104196), // Rule ID 16756 //
     /* 104155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb128),
     /* 104163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 104166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104181 */     // (intrinsic_w_chain:{ *:[v16i8] } 13735:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ128m:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 104181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ128m),
     /* 104184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104194 */     GIR_RootConstrainSelectedInstOperands,
     /* 104195 */     // GIR_Coverage, 16756,
     /* 104195 */     GIR_EraseRootFromParent_Done,
     /* 104196 */   // Label 2219: @104196
     /* 104196 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(104242), // Rule ID 16759 //
     /* 104201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsb256),
     /* 104209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s8,
     /* 104212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104227 */     // (intrinsic_w_chain:{ *:[v32i8] } 13736:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSBZ256m:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 104227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSBZ256m),
     /* 104230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104232 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104240 */     GIR_RootConstrainSelectedInstOperands,
     /* 104241 */     // GIR_Coverage, 16759,
     /* 104241 */     GIR_EraseRootFromParent_Done,
     /* 104242 */   // Label 2220: @104242
     /* 104242 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(104288), // Rule ID 16762 //
     /* 104247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw512),
     /* 104255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 104258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104273 */     // (intrinsic_w_chain:{ *:[v32i16] } 13746:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 104273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZm),
     /* 104276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104278 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104286 */     GIR_RootConstrainSelectedInstOperands,
     /* 104287 */     // GIR_Coverage, 16762,
     /* 104287 */     GIR_EraseRootFromParent_Done,
     /* 104288 */   // Label 2221: @104288
     /* 104288 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(104334), // Rule ID 16765 //
     /* 104293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw128),
     /* 104301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 104304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104319 */     // (intrinsic_w_chain:{ *:[v8i16] } 13744:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ128m:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 104319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ128m),
     /* 104322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104332 */     GIR_RootConstrainSelectedInstOperands,
     /* 104333 */     // GIR_Coverage, 16765,
     /* 104333 */     GIR_EraseRootFromParent_Done,
     /* 104334 */   // Label 2222: @104334
     /* 104334 */   GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(104380), // Rule ID 16768 //
     /* 104339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsw256),
     /* 104347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s16,
     /* 104350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104365 */     // (intrinsic_w_chain:{ *:[v16i16] } 13745:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSWZ256m:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 104365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSWZ256m),
     /* 104368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104378 */     GIR_RootConstrainSelectedInstOperands,
     /* 104379 */     // GIR_Coverage, 16768,
     /* 104379 */     GIR_EraseRootFromParent_Done,
     /* 104380 */   // Label 2223: @104380
     /* 104380 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(104426), // Rule ID 16771 //
     /* 104385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd512),
     /* 104393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 104396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104411 */     // (intrinsic_w_chain:{ *:[v16i32] } 13740:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 104411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZm),
     /* 104414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104424 */     GIR_RootConstrainSelectedInstOperands,
     /* 104425 */     // GIR_Coverage, 16771,
     /* 104425 */     GIR_EraseRootFromParent_Done,
     /* 104426 */   // Label 2224: @104426
     /* 104426 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(104472), // Rule ID 16774 //
     /* 104431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd128),
     /* 104439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 104442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104457 */     // (intrinsic_w_chain:{ *:[v4i32] } 13738:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ128m:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 104457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ128m),
     /* 104460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104470 */     GIR_RootConstrainSelectedInstOperands,
     /* 104471 */     // GIR_Coverage, 16774,
     /* 104471 */     GIR_EraseRootFromParent_Done,
     /* 104472 */   // Label 2225: @104472
     /* 104472 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(104518), // Rule ID 16777 //
     /* 104477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsd256),
     /* 104485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 104488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104503 */     // (intrinsic_w_chain:{ *:[v8i32] } 13739:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSDZ256m:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 104503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSDZ256m),
     /* 104506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104508 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104516 */     GIR_RootConstrainSelectedInstOperands,
     /* 104517 */     // GIR_Coverage, 16777,
     /* 104517 */     GIR_EraseRootFromParent_Done,
     /* 104518 */   // Label 2226: @104518
     /* 104518 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(104564), // Rule ID 16780 //
     /* 104523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_512_HasMOVRS_In64BitMode),
     /* 104526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq512),
     /* 104531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s64,
     /* 104534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 104538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104549 */     // (intrinsic_w_chain:{ *:[v8i64] } 13743:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 104549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZm),
     /* 104552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104562 */     GIR_RootConstrainSelectedInstOperands,
     /* 104563 */     // GIR_Coverage, 16780,
     /* 104563 */     GIR_EraseRootFromParent_Done,
     /* 104564 */   // Label 2227: @104564
     /* 104564 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(104610), // Rule ID 16783 //
     /* 104569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq128),
     /* 104577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 104580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 104584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104595 */     // (intrinsic_w_chain:{ *:[v2i64] } 13741:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ128m:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)
     /* 104595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ128m),
     /* 104598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104600 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104608 */     GIR_RootConstrainSelectedInstOperands,
     /* 104609 */     // GIR_Coverage, 16783,
     /* 104609 */     GIR_EraseRootFromParent_Done,
     /* 104610 */   // Label 2228: @104610
     /* 104610 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(104656), // Rule ID 16786 //
     /* 104615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX10_2_HasMOVRS_In64BitMode),
     /* 104618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx10_vmovrsq256),
     /* 104623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 104626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 104630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104641 */     // (intrinsic_w_chain:{ *:[v4i64] } 13742:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src)  =>  (VMOVRSQZ256m:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 104641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVRSQZ256m),
     /* 104644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 104650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104654 */     GIR_RootConstrainSelectedInstOperands,
     /* 104655 */     // GIR_Coverage, 16786,
     /* 104655 */     GIR_EraseRootFromParent_Done,
     /* 104656 */   // Label 2229: @104656
     /* 104656 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(104702), // Rule ID 17094 //
     /* 104661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104669 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104687 */     // (intrinsic_void 15067:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD),
     /* 104690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104694 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104700 */     GIR_RootConstrainSelectedInstOperands,
     /* 104701 */     // GIR_Coverage, 17094,
     /* 104701 */     GIR_EraseRootFromParent_Done,
     /* 104702 */   // Label 2230: @104702
     /* 104702 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(104748), // Rule ID 17095 //
     /* 104707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104715 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104722 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104733 */     // (intrinsic_void 15068:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ),
     /* 104736 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104746 */     GIR_RootConstrainSelectedInstOperands,
     /* 104747 */     // GIR_Coverage, 17095,
     /* 104747 */     GIR_EraseRootFromParent_Done,
     /* 104748 */   // Label 2231: @104748
     /* 104748 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(104794), // Rule ID 17096 //
     /* 104753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104761 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104779 */     // (intrinsic_void 15069:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD),
     /* 104782 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104792 */     GIR_RootConstrainSelectedInstOperands,
     /* 104793 */     // GIR_Coverage, 17096,
     /* 104793 */     GIR_EraseRootFromParent_Done,
     /* 104794 */   // Label 2232: @104794
     /* 104794 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(104840), // Rule ID 17097 //
     /* 104799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoEGPR),
     /* 104802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104807 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104825 */     // (intrinsic_void 15070:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ),
     /* 104828 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104832 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104838 */     GIR_RootConstrainSelectedInstOperands,
     /* 104839 */     // GIR_Coverage, 17097,
     /* 104839 */     GIR_EraseRootFromParent_Done,
     /* 104840 */   // Label 2233: @104840
     /* 104840 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(104886), // Rule ID 17098 //
     /* 104845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssd),
     /* 104853 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104871 */     // (intrinsic_void 15067:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSD_EVEX),
     /* 104874 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104884 */     GIR_RootConstrainSelectedInstOperands,
     /* 104885 */     // GIR_Coverage, 17098,
     /* 104885 */     GIR_EraseRootFromParent_Done,
     /* 104886 */   // Label 2234: @104886
     /* 104886 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(104932), // Rule ID 17099 //
     /* 104891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrssq),
     /* 104899 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104917 */     // (intrinsic_void 15068:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 104917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRSSQ_EVEX),
     /* 104920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104930 */     GIR_RootConstrainSelectedInstOperands,
     /* 104931 */     // GIR_Coverage, 17099,
     /* 104931 */     GIR_EraseRootFromParent_Done,
     /* 104932 */   // Label 2235: @104932
     /* 104932 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(104978), // Rule ID 17100 //
     /* 104937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussd),
     /* 104945 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 104948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 104952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 104956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 104963 */     // (intrinsic_void 15069:{ *:[iPTR] }, GR32:{ *:[i32] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSD_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 104963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSD_EVEX),
     /* 104966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 104970 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 104972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104976 */     GIR_RootConstrainSelectedInstOperands,
     /* 104977 */     // GIR_Coverage, 17100,
     /* 104977 */     GIR_EraseRootFromParent_Done,
     /* 104978 */   // Label 2236: @104978
     /* 104978 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(105024), // Rule ID 17101 //
     /* 104983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_In64BitMode),
     /* 104986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_wrussq),
     /* 104991 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 104998 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105009 */     // (intrinsic_void 15070:{ *:[iPTR] }, GR64:{ *:[i64] }:$src, addr:{ *:[iPTR] }:$dst)  =>  (WRUSSQ_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::WRUSSQ_EVEX),
     /* 105012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105016 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 105018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105022 */     GIR_RootConstrainSelectedInstOperands,
     /* 105023 */     // GIR_Coverage, 17101,
     /* 105023 */     GIR_EraseRootFromParent_Done,
     /* 105024 */   // Label 2237: @105024
     /* 105024 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(105070), // Rule ID 17127 //
     /* 105029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_Not64BitMode),
     /* 105032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105037 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105055 */     // (intrinsic_void 14631:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID32 GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 105055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID32),
     /* 105058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105060 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105068 */     GIR_RootConstrainSelectedInstOperands,
     /* 105069 */     // GIR_Coverage, 17127,
     /* 105069 */     GIR_EraseRootFromParent_Done,
     /* 105070 */   // Label 2238: @105070
     /* 105070 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(105162), // Rule ID 22379 //
     /* 105075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasINVPCID_NoEGPR),
     /* 105078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105083 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105101 */     // (intrinsic_void 14631:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64 (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64),
     /* 105153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105156 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105160 */     GIR_RootConstrainSelectedInstOperands,
     /* 105161 */     // GIR_Coverage, 22379,
     /* 105161 */     GIR_EraseRootFromParent_Done,
     /* 105162 */   // Label 2239: @105162
     /* 105162 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(105254), // Rule ID 22380 //
     /* 105167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasINVPCID),
     /* 105170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_invpcid),
     /* 105175 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105182 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105193 */     // (intrinsic_void 14631:{ *:[iPTR] }, GR32:{ *:[i32] }:$src1, addr:{ *:[iPTR] }:$src2)  =>  (INVPCID64_EVEX (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1), sub_32bit:{ *:[i32] }), addr:{ *:[iPTR] }:$src2)
     /* 105193 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105196 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 105200 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105205 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 105209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105223 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 105226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/6,
     /* 105232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 105237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 105242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INVPCID64_EVEX),
     /* 105245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 105252 */     GIR_RootConstrainSelectedInstOperands,
     /* 105253 */     // GIR_Coverage, 22380,
     /* 105253 */     GIR_EraseRootFromParent_Done,
     /* 105254 */   // Label 2240: @105254
     /* 105254 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(105300), // Rule ID 131 //
     /* 105259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_NoEGPR),
     /* 105262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105285 */     // (intrinsic_void 14610:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32 addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32),
     /* 105288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105292 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105298 */     GIR_RootConstrainSelectedInstOperands,
     /* 105299 */     // GIR_Coverage, 131,
     /* 105299 */     GIR_EraseRootFromParent_Done,
     /* 105300 */   // Label 2241: @105300
     /* 105300 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(105346), // Rule ID 132 //
     /* 105305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIRI_In64BitMode_NoEGPR),
     /* 105308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105331 */     // (intrinsic_void 14611:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64 addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64),
     /* 105334 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105344 */     GIR_RootConstrainSelectedInstOperands,
     /* 105345 */     // GIR_Coverage, 132,
     /* 105345 */     GIR_EraseRootFromParent_Done,
     /* 105346 */   // Label 2242: @105346
     /* 105346 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(105392), // Rule ID 133 //
     /* 105351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore32),
     /* 105359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105377 */     // (intrinsic_void 14610:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)  =>  (MOVDIRI32_EVEX addr:{ *:[iPTR] }:$dst, GR32:{ *:[i32] }:$src)
     /* 105377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI32_EVEX),
     /* 105380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105390 */     GIR_RootConstrainSelectedInstOperands,
     /* 105391 */     // GIR_Coverage, 133,
     /* 105391 */     GIR_EraseRootFromParent_Done,
     /* 105392 */   // Label 2243: @105392
     /* 105392 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(105438), // Rule ID 134 //
     /* 105397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIRI_In64BitMode),
     /* 105400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_directstore64),
     /* 105405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105423 */     // (intrinsic_void 14611:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)  =>  (MOVDIRI64_EVEX addr:{ *:[iPTR] }:$dst, GR64:{ *:[i64] }:$src)
     /* 105423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIRI64_EVEX),
     /* 105426 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 105430 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105436 */     GIR_RootConstrainSelectedInstOperands,
     /* 105437 */     // GIR_Coverage, 134,
     /* 105437 */     GIR_EraseRootFromParent_Done,
     /* 105438 */   // Label 2244: @105438
     /* 105438 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(105485), // Rule ID 135 //
     /* 105443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_NoEGPR),
     /* 105446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105451 */     // MIs[0] dst
     /* 105451 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105470 */     // (intrinsic_void 14711:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32 GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32),
     /* 105473 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105483 */     GIR_RootConstrainSelectedInstOperands,
     /* 105484 */     // GIR_Coverage, 135,
     /* 105484 */     GIR_EraseRootFromParent_Done,
     /* 105485 */   // Label 2245: @105485
     /* 105485 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(105532), // Rule ID 136 //
     /* 105490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVDIR64B_In64BitMode_NoEGPR),
     /* 105493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105498 */     // MIs[0] dst
     /* 105498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105506 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105517 */     // (intrinsic_void 14711:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64 GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64),
     /* 105520 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105530 */     GIR_RootConstrainSelectedInstOperands,
     /* 105531 */     // GIR_Coverage, 136,
     /* 105531 */     GIR_EraseRootFromParent_Done,
     /* 105532 */   // Label 2246: @105532
     /* 105532 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(105579), // Rule ID 137 //
     /* 105537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105545 */     // MIs[0] dst
     /* 105545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 105549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105564 */     // (intrinsic_void 14711:{ *:[iPTR] }, GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B32_EVEX GR32:{ *:[i32] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B32_EVEX),
     /* 105567 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105569 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105577 */     GIR_RootConstrainSelectedInstOperands,
     /* 105578 */     // GIR_Coverage, 137,
     /* 105578 */     GIR_EraseRootFromParent_Done,
     /* 105579 */   // Label 2247: @105579
     /* 105579 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(105626), // Rule ID 138 //
     /* 105584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVDIR64B_In64BitMode),
     /* 105587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_movdir64b),
     /* 105592 */     // MIs[0] dst
     /* 105592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 105604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 105611 */     // (intrinsic_void 14711:{ *:[iPTR] }, GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)  =>  (MOVDIR64B64_EVEX GR64:{ *:[i64] }:$dst, addr:{ *:[iPTR] }:$src)
     /* 105611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVDIR64B64_EVEX),
     /* 105614 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105616 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 105620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105624 */     GIR_RootConstrainSelectedInstOperands,
     /* 105625 */     // GIR_Coverage, 138,
     /* 105625 */     GIR_EraseRootFromParent_Done,
     /* 105626 */   // Label 2248: @105626
     /* 105626 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(105658), // Rule ID 17025 //
     /* 105631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTRANSPOSE_In64BitMode),
     /* 105634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttransposed),
     /* 105639 */     // MIs[0] dst
     /* 105639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105642 */     // MIs[0] src
     /* 105642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105645 */     // (intrinsic_void 15017:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTTRANSPOSED (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTRANSPOSED),
     /* 105648 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105650 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105656 */     GIR_RootConstrainSelectedInstOperands,
     /* 105657 */     // GIR_Coverage, 17025,
     /* 105657 */     GIR_EraseRootFromParent_Done,
     /* 105658 */   // Label 2249: @105658
     /* 105658 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(105690), // Rule ID 17037 //
     /* 105663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 105666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtfp16),
     /* 105671 */     // MIs[0] dst
     /* 105671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 105674 */     // MIs[0] src
     /* 105674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105677 */     // (intrinsic_void 14956:{ *:[iPTR] }, (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)  =>  (PTCONJTFP16 (timm:{ *:[i8] }):$dst, (timm:{ *:[i8] }):$src)
     /* 105677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTFP16),
     /* 105680 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 105682 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105688 */     GIR_RootConstrainSelectedInstOperands,
     /* 105689 */     // GIR_Coverage, 17037,
     /* 105689 */     GIR_EraseRootFromParent_Done,
     /* 105690 */   // Label 2250: @105690
     /* 105690 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(105733), // Rule ID 17152 //
     /* 105695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::asan_check_memaccess),
     /* 105700 */     // MIs[0] addr
     /* 105700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64PLTSafeRegClassID),
     /* 105708 */     // MIs[0] accessinfo
     /* 105708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 105711 */     // (intrinsic_void 9:{ *:[iPTR] }, GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)  =>  (ASAN_CHECK_MEMACCESS:{ *:[i64] } GR64PLTSafe:{ *:[i64] }:$addr, (timm:{ *:[i32] }):$accessinfo)
     /* 105711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ASAN_CHECK_MEMACCESS),
     /* 105714 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 105716 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 105718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R10*/0,
     /* 105721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::R11*/1,
     /* 105724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/2,
     /* 105727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105731 */     GIR_RootConstrainSelectedInstOperands,
     /* 105732 */     // GIR_Coverage, 17152,
     /* 105732 */     GIR_EraseRootFromParent_Done,
     /* 105733 */   // Label 2251: @105733
     /* 105733 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(105773), // Rule ID 17078 //
     /* 105738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105760 */     // (intrinsic_w_chain:{ *:[i64] } 15021:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr),
     /* 105763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105771 */     GIR_RootConstrainSelectedInstOperands,
     /* 105772 */     // GIR_Coverage, 17078,
     /* 105772 */     GIR_EraseRootFromParent_Done,
     /* 105773 */   // Label 2252: @105773
     /* 105773 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(105813), // Rule ID 17082 //
     /* 105778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_urdmsr),
     /* 105786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105800 */     // (intrinsic_w_chain:{ *:[i64] } 15021:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (URDMSRrr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::URDMSRrr_EVEX),
     /* 105803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105805 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105811 */     GIR_RootConstrainSelectedInstOperands,
     /* 105812 */     // GIR_Coverage, 17082,
     /* 105812 */     GIR_EraseRootFromParent_Done,
     /* 105813 */   // Label 2253: @105813
     /* 105813 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(105850), // Rule ID 17090 //
     /* 105818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspd),
     /* 105823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 105826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 105837 */     // (intrinsic_w_chain:{ *:[i32] } 14737:{ *:[iPTR] }, GR32:{ *:[i32] }:$src)  =>  (RDSSPD:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 105837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPD),
     /* 105840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105842 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105848 */     GIR_RootConstrainSelectedInstOperands,
     /* 105849 */     // GIR_Coverage, 17090,
     /* 105849 */     GIR_EraseRootFromParent_Done,
     /* 105850 */   // Label 2254: @105850
     /* 105850 */   GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(105887), // Rule ID 17091 //
     /* 105855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_rdsspq),
     /* 105860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 105863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105874 */     // (intrinsic_w_chain:{ *:[i64] } 14738:{ *:[iPTR] }, GR64:{ *:[i64] }:$src)  =>  (RDSSPQ:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 105874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RDSSPQ),
     /* 105877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 105881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105885 */     GIR_RootConstrainSelectedInstOperands,
     /* 105886 */     // GIR_Coverage, 17091,
     /* 105886 */     GIR_EraseRootFromParent_Done,
     /* 105887 */   // Label 2255: @105887
     /* 105887 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(105951), // Rule ID 3086 //
     /* 105892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 105895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse3_mwait),
     /* 105900 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 105910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 105914 */     // (intrinsic_void 14862:{ *:[iPTR] }, ECX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (MWAITrr)
     /* 105914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105918 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105924 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EAX
     /* 105928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 105932 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 105942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITrr),
     /* 105945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105949 */     GIR_RootConstrainSelectedInstOperands,
     /* 105950 */     // GIR_Coverage, 3086,
     /* 105950 */     GIR_EraseRootFromParent_Done,
     /* 105951 */   // Label 2256: @105951
     /* 105951 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(105991), // Rule ID 17080 //
     /* 105956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasUSERMSR_NoEGPR),
     /* 105959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 105964 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 105978 */     // (intrinsic_void 15022:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 105978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr),
     /* 105981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105983 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 105985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105989 */     GIR_RootConstrainSelectedInstOperands,
     /* 105990 */     // GIR_Coverage, 17080,
     /* 105990 */     GIR_EraseRootFromParent_Done,
     /* 105991 */   // Label 2257: @105991
     /* 105991 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(106031), // Rule ID 17084 //
     /* 105996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasUSERMSR_In64BitMode),
     /* 105999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_uwrmsr),
     /* 106004 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 106010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106018 */     // (intrinsic_void 15022:{ *:[iPTR] }, GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)  =>  (UWRMSRrr_EVEX GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 106018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::UWRMSRrr_EVEX),
     /* 106021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 106023 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 106025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106029 */     GIR_RootConstrainSelectedInstOperands,
     /* 106030 */     // GIR_Coverage, 17084,
     /* 106030 */     GIR_EraseRootFromParent_Done,
     /* 106031 */   // Label 2258: @106031
     /* 106031 */   GIM_Reject,
     /* 106032 */ // Label 2194: @106032
     /* 106032 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(109577),
     /* 106037 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 106040 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(106112), // Rule ID 123 //
     /* 106045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 106053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 106063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106071 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106078 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106082 */     // MIs[0] cntl
     /* 106082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106094 */     // (intrinsic_void 14638:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rmi GR32:{ *:[i32] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rmi),
     /* 106097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106103 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106110 */     GIR_RootConstrainSelectedInstOperands,
     /* 106111 */     // GIR_Coverage, 123,
     /* 106111 */     GIR_EraseRootFromParent_Done,
     /* 106112 */   // Label 2260: @106112
     /* 106112 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(106184), // Rule ID 125 //
     /* 106117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 106120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 106125 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 106135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106143 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106146 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106150 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 106154 */     // MIs[0] cntl
     /* 106154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 106157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106159 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106166 */     // (intrinsic_void 14639:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rmi GR64:{ *:[i64] }:$src0, addr:{ *:[iPTR] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 106166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rmi),
     /* 106169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 106171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 106175 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 106177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106182 */     GIR_RootConstrainSelectedInstOperands,
     /* 106183 */     // GIR_Coverage, 125,
     /* 106183 */     GIR_EraseRootFromParent_Done,
     /* 106184 */   // Label 2261: @106184
     /* 106184 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(106239), // Rule ID 3387 //
     /* 106189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps),
     /* 106197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106222 */     // (intrinsic_w_chain:{ *:[v4f32] } 13484:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VMASKMOVPSrm:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSrm),
     /* 106225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106227 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106237 */     GIR_RootConstrainSelectedInstOperands,
     /* 106238 */     // GIR_Coverage, 3387,
     /* 106238 */     GIR_EraseRootFromParent_Done,
     /* 106239 */   // Label 2262: @106239
     /* 106239 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(106294), // Rule ID 3388 //
     /* 106244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_ps_256),
     /* 106252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106277 */     // (intrinsic_w_chain:{ *:[v8f32] } 13485:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VMASKMOVPSYrm:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYrm),
     /* 106280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106282 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106292 */     GIR_RootConstrainSelectedInstOperands,
     /* 106293 */     // GIR_Coverage, 3388,
     /* 106293 */     GIR_EraseRootFromParent_Done,
     /* 106294 */   // Label 2263: @106294
     /* 106294 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(106349), // Rule ID 3391 //
     /* 106299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd),
     /* 106307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106332 */     // (intrinsic_w_chain:{ *:[v2f64] } 13482:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VMASKMOVPDrm:{ *:[v2f64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDrm),
     /* 106335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106347 */     GIR_RootConstrainSelectedInstOperands,
     /* 106348 */     // GIR_Coverage, 3391,
     /* 106348 */     GIR_EraseRootFromParent_Done,
     /* 106349 */   // Label 2264: @106349
     /* 106349 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(106404), // Rule ID 3392 //
     /* 106354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx_maskload_pd_256),
     /* 106362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106372 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106387 */     // (intrinsic_w_chain:{ *:[v4f64] } 13483:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VMASKMOVPDYrm:{ *:[v4f64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYrm),
     /* 106390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106392 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106402 */     GIR_RootConstrainSelectedInstOperands,
     /* 106403 */     // GIR_Coverage, 3392,
     /* 106403 */     GIR_EraseRootFromParent_Done,
     /* 106404 */   // Label 2265: @106404
     /* 106404 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(106459), // Rule ID 3465 //
     /* 106409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d),
     /* 106417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 106420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106442 */     // (intrinsic_w_chain:{ *:[v4i32] } 13782:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4i32] }:$src1)  =>  (VPMASKMOVDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDrm),
     /* 106445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106447 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106457 */     GIR_RootConstrainSelectedInstOperands,
     /* 106458 */     // GIR_Coverage, 3465,
     /* 106458 */     GIR_EraseRootFromParent_Done,
     /* 106459 */   // Label 2266: @106459
     /* 106459 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(106514), // Rule ID 3466 //
     /* 106464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_d_256),
     /* 106472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s32,
     /* 106475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106497 */     // (intrinsic_w_chain:{ *:[v8i32] } 13783:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8i32] }:$src1)  =>  (VPMASKMOVDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYrm),
     /* 106500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106502 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106512 */     GIR_RootConstrainSelectedInstOperands,
     /* 106513 */     // GIR_Coverage, 3466,
     /* 106513 */     GIR_EraseRootFromParent_Done,
     /* 106514 */   // Label 2267: @106514
     /* 106514 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(106569), // Rule ID 3469 //
     /* 106519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q),
     /* 106527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 106530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106537 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106552 */     // (intrinsic_w_chain:{ *:[v2i64] } 13784:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2i64] }:$src1)  =>  (VPMASKMOVQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQrm),
     /* 106555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106567 */     GIR_RootConstrainSelectedInstOperands,
     /* 106568 */     // GIR_Coverage, 3469,
     /* 106568 */     GIR_EraseRootFromParent_Done,
     /* 106569 */   // Label 2268: @106569
     /* 106569 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(106624), // Rule ID 3470 //
     /* 106574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_avx2_maskload_q_256),
     /* 106582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s64,
     /* 106585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 106596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106607 */     // (intrinsic_w_chain:{ *:[v4i64] } 13785:{ *:[iPTR] }, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4i64] }:$src1)  =>  (VPMASKMOVQYrm:{ *:[v4i64] } VR256:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 106607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYrm),
     /* 106610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106612 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 106614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 106618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106622 */     GIR_RootConstrainSelectedInstOperands,
     /* 106623 */     // GIR_Coverage, 3470,
     /* 106623 */     GIR_EraseRootFromParent_Done,
     /* 106624 */   // Label 2269: @106624
     /* 106624 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(106679), // Rule ID 3389 //
     /* 106629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps),
     /* 106637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106662 */     // (intrinsic_void 13488:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMASKMOVPSmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSmr),
     /* 106665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106671 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106677 */     GIR_RootConstrainSelectedInstOperands,
     /* 106678 */     // GIR_Coverage, 3389,
     /* 106678 */     GIR_EraseRootFromParent_Done,
     /* 106679 */   // Label 2270: @106679
     /* 106679 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(106734), // Rule ID 3390 //
     /* 106684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_ps_256),
     /* 106692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106717 */     // (intrinsic_void 13489:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMASKMOVPSYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 106717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPSYmr),
     /* 106720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106726 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106732 */     GIR_RootConstrainSelectedInstOperands,
     /* 106733 */     // GIR_Coverage, 3390,
     /* 106733 */     GIR_EraseRootFromParent_Done,
     /* 106734 */   // Label 2271: @106734
     /* 106734 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(106789), // Rule ID 3393 //
     /* 106739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd),
     /* 106747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106772 */     // (intrinsic_void 13486:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMASKMOVPDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 106772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDmr),
     /* 106775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106779 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106781 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106787 */     GIR_RootConstrainSelectedInstOperands,
     /* 106788 */     // GIR_Coverage, 3393,
     /* 106788 */     GIR_EraseRootFromParent_Done,
     /* 106789 */   // Label 2272: @106789
     /* 106789 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(106844), // Rule ID 3394 //
     /* 106794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 106797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx_maskstore_pd_256),
     /* 106802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 106805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 106808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106827 */     // (intrinsic_void 13487:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMASKMOVPDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 106827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVPDYmr),
     /* 106830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106834 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106836 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106842 */     GIR_RootConstrainSelectedInstOperands,
     /* 106843 */     // GIR_Coverage, 3394,
     /* 106843 */     GIR_EraseRootFromParent_Done,
     /* 106844 */   // Label 2273: @106844
     /* 106844 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(106899), // Rule ID 3467 //
     /* 106849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d),
     /* 106857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 106860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 106863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106882 */     // (intrinsic_void 13786:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMASKMOVDmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 106882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDmr),
     /* 106885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106889 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106891 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106897 */     GIR_RootConstrainSelectedInstOperands,
     /* 106898 */     // GIR_Coverage, 3467,
     /* 106898 */     GIR_EraseRootFromParent_Done,
     /* 106899 */   // Label 2274: @106899
     /* 106899 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(106954), // Rule ID 3468 //
     /* 106904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_d_256),
     /* 106912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 106915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 106918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 106930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106937 */     // (intrinsic_void 13787:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMASKMOVDYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 106937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVDYmr),
     /* 106940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106944 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 106946 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 106948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106952 */     GIR_RootConstrainSelectedInstOperands,
     /* 106953 */     // GIR_Coverage, 3468,
     /* 106953 */     GIR_EraseRootFromParent_Done,
     /* 106954 */   // Label 2275: @106954
     /* 106954 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(107009), // Rule ID 3471 //
     /* 106959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 106962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q),
     /* 106967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 106970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 106973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 106985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 106992 */     // (intrinsic_void 13788:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPMASKMOVQmr addr:{ *:[iPTR] }:$dst, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 106992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQmr),
     /* 106995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 106999 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107001 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 107003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107007 */     GIR_RootConstrainSelectedInstOperands,
     /* 107008 */     // GIR_Coverage, 3471,
     /* 107008 */     GIR_EraseRootFromParent_Done,
     /* 107009 */   // Label 2276: @107009
     /* 107009 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(107064), // Rule ID 3472 //
     /* 107014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2),
     /* 107017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_avx2_maskstore_q_256),
     /* 107022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 107025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 107028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 107040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107047 */     // (intrinsic_void 13789:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)  =>  (VPMASKMOVQYmr addr:{ *:[iPTR] }:$dst, VR256:{ *:[v4i64] }:$src1, VR256:{ *:[v4i64] }:$src2)
     /* 107047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMASKMOVQYmr),
     /* 107050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107054 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107056 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 107058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107062 */     GIR_RootConstrainSelectedInstOperands,
     /* 107063 */     // GIR_Coverage, 3472,
     /* 107063 */     GIR_EraseRootFromParent_Done,
     /* 107064 */   // Label 2277: @107064
     /* 107064 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(107143), // Rule ID 17105 //
     /* 107069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave),
     /* 107077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107102 */     // (intrinsic_void 15126:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE addr:{ *:[iPTR] }:$dst)
     /* 107102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107106 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107112 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107120 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE),
     /* 107133 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107141 */     GIR_RootConstrainSelectedInstOperands,
     /* 107142 */     // GIR_Coverage, 17105,
     /* 107142 */     GIR_EraseRootFromParent_Done,
     /* 107143 */   // Label 2278: @107143
     /* 107143 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(107222), // Rule ID 17106 //
     /* 107148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsave64),
     /* 107156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107181 */     // (intrinsic_void 15127:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVE64 addr:{ *:[iPTR] }:$dst)
     /* 107181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107185 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107199 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVE64),
     /* 107212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107220 */     GIR_RootConstrainSelectedInstOperands,
     /* 107221 */     // GIR_Coverage, 17106,
     /* 107221 */     GIR_EraseRootFromParent_Done,
     /* 107222 */   // Label 2279: @107222
     /* 107222 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(107301), // Rule ID 17107 //
     /* 107227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE),
     /* 107230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor),
     /* 107235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107260 */     // (intrinsic_void 15122:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR addr:{ *:[iPTR] }:$dst)
     /* 107260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107264 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107278 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107284 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR),
     /* 107291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107299 */     GIR_RootConstrainSelectedInstOperands,
     /* 107300 */     // GIR_Coverage, 17107,
     /* 107300 */     GIR_EraseRootFromParent_Done,
     /* 107301 */   // Label 2280: @107301
     /* 107301 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(107380), // Rule ID 17108 //
     /* 107306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstor64),
     /* 107314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107339 */     // (intrinsic_void 15123:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTOR64 addr:{ *:[iPTR] }:$dst)
     /* 107339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107343 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107349 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107357 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTOR64),
     /* 107370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107378 */     GIR_RootConstrainSelectedInstOperands,
     /* 107379 */     // GIR_Coverage, 17108,
     /* 107379 */     GIR_EraseRootFromParent_Done,
     /* 107380 */   // Label 2281: @107380
     /* 107380 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(107459), // Rule ID 17109 //
     /* 107385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT),
     /* 107388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt),
     /* 107393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107418 */     // (intrinsic_void 15130:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT addr:{ *:[iPTR] }:$dst)
     /* 107418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107422 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107428 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107436 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT),
     /* 107449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107457 */     GIR_RootConstrainSelectedInstOperands,
     /* 107458 */     // GIR_Coverage, 17109,
     /* 107458 */     GIR_EraseRootFromParent_Done,
     /* 107459 */   // Label 2282: @107459
     /* 107459 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(107538), // Rule ID 17110 //
     /* 107464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEOPT_In64BitMode),
     /* 107467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaveopt64),
     /* 107472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107497 */     // (intrinsic_void 15131:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEOPT64 addr:{ *:[iPTR] }:$dst)
     /* 107497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107501 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107515 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107521 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEOPT64),
     /* 107528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107536 */     GIR_RootConstrainSelectedInstOperands,
     /* 107537 */     // GIR_Coverage, 17110,
     /* 107537 */     GIR_EraseRootFromParent_Done,
     /* 107538 */   // Label 2283: @107538
     /* 107538 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(107617), // Rule ID 17111 //
     /* 107543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC),
     /* 107546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec),
     /* 107551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107576 */     // (intrinsic_void 15128:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC addr:{ *:[iPTR] }:$dst)
     /* 107576 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107580 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107586 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107594 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107600 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC),
     /* 107607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107615 */     GIR_RootConstrainSelectedInstOperands,
     /* 107616 */     // GIR_Coverage, 17111,
     /* 107616 */     GIR_EraseRootFromParent_Done,
     /* 107617 */   // Label 2284: @107617
     /* 107617 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(107696), // Rule ID 17112 //
     /* 107622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVEC_In64BitMode),
     /* 107625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsavec64),
     /* 107630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107655 */     // (intrinsic_void 15129:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVEC64 addr:{ *:[iPTR] }:$dst)
     /* 107655 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107659 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107673 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVEC64),
     /* 107686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107694 */     GIR_RootConstrainSelectedInstOperands,
     /* 107695 */     // GIR_Coverage, 17112,
     /* 107695 */     GIR_EraseRootFromParent_Done,
     /* 107696 */   // Label 2285: @107696
     /* 107696 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(107775), // Rule ID 17113 //
     /* 107701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves),
     /* 107709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107734 */     // (intrinsic_void 15132:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES addr:{ *:[iPTR] }:$dst)
     /* 107734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107738 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107744 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107752 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES),
     /* 107765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107773 */     GIR_RootConstrainSelectedInstOperands,
     /* 107774 */     // GIR_Coverage, 17113,
     /* 107774 */     GIR_EraseRootFromParent_Done,
     /* 107775 */   // Label 2286: @107775
     /* 107775 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(107854), // Rule ID 17114 //
     /* 107780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVE_In64BitMode),
     /* 107783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsaves64),
     /* 107788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107813 */     // (intrinsic_void 15133:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSAVES64 addr:{ *:[iPTR] }:$dst)
     /* 107813 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107817 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107831 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSAVES64),
     /* 107844 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107852 */     GIR_RootConstrainSelectedInstOperands,
     /* 107853 */     // GIR_Coverage, 17114,
     /* 107853 */     GIR_EraseRootFromParent_Done,
     /* 107854 */   // Label 2287: @107854
     /* 107854 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(107933), // Rule ID 17115 //
     /* 107859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES),
     /* 107862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors),
     /* 107867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107873 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107892 */     // (intrinsic_void 15124:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS addr:{ *:[iPTR] }:$dst)
     /* 107892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107896 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107902 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107910 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS),
     /* 107923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 107927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107931 */     GIR_RootConstrainSelectedInstOperands,
     /* 107932 */     // GIR_Coverage, 17115,
     /* 107932 */     GIR_EraseRootFromParent_Done,
     /* 107933 */   // Label 2288: @107933
     /* 107933 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(108012), // Rule ID 17116 //
     /* 107938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXSAVES_In64BitMode),
     /* 107941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xrstors64),
     /* 107946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 107949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 107952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 107960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 107964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 107971 */     // (intrinsic_void 15125:{ *:[iPTR] }, addr:{ *:[iPTR] }:$dst, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XRSTORS64 addr:{ *:[iPTR] }:$dst)
     /* 107971 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107975 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107981 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 107985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107989 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107995 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 107999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XRSTORS64),
     /* 108002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 108006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108010 */     GIR_RootConstrainSelectedInstOperands,
     /* 108011 */     // GIR_Coverage, 17116,
     /* 108011 */     GIR_EraseRootFromParent_Done,
     /* 108012 */   // Label 2289: @108012
     /* 108012 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(108049), // Rule ID 17004 //
     /* 108017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbssd),
     /* 108025 */     // MIs[0] src1
     /* 108025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108028 */     // MIs[0] src2
     /* 108028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108031 */     // MIs[0] src3
     /* 108031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108034 */     // (intrinsic_void 14974:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSSD),
     /* 108037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108047 */     GIR_RootConstrainSelectedInstOperands,
     /* 108048 */     // GIR_Coverage, 17004,
     /* 108048 */     GIR_EraseRootFromParent_Done,
     /* 108049 */   // Label 2290: @108049
     /* 108049 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(108086), // Rule ID 17005 //
     /* 108054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbsud),
     /* 108062 */     // MIs[0] src1
     /* 108062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108065 */     // MIs[0] src2
     /* 108065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108068 */     // MIs[0] src3
     /* 108068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108071 */     // (intrinsic_void 14976:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBSUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBSUD),
     /* 108074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108078 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108084 */     GIR_RootConstrainSelectedInstOperands,
     /* 108085 */     // GIR_Coverage, 17005,
     /* 108085 */     GIR_EraseRootFromParent_Done,
     /* 108086 */   // Label 2291: @108086
     /* 108086 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(108123), // Rule ID 17006 //
     /* 108091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbusd),
     /* 108099 */     // MIs[0] src1
     /* 108099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108102 */     // MIs[0] src2
     /* 108102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108105 */     // MIs[0] src3
     /* 108105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108108 */     // (intrinsic_void 14978:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUSD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUSD),
     /* 108111 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108113 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108115 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108121 */     GIR_RootConstrainSelectedInstOperands,
     /* 108122 */     // GIR_Coverage, 17006,
     /* 108122 */     GIR_EraseRootFromParent_Done,
     /* 108123 */   // Label 2292: @108123
     /* 108123 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(108160), // Rule ID 17007 //
     /* 108128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXINT8_In64BitMode),
     /* 108131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbuud),
     /* 108136 */     // MIs[0] src1
     /* 108136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108139 */     // MIs[0] src2
     /* 108139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108142 */     // MIs[0] src3
     /* 108142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108145 */     // (intrinsic_void 14980:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBUUD (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBUUD),
     /* 108148 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108152 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108158 */     GIR_RootConstrainSelectedInstOperands,
     /* 108159 */     // GIR_Coverage, 17007,
     /* 108159 */     GIR_EraseRootFromParent_Done,
     /* 108160 */   // Label 2293: @108160
     /* 108160 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(108197), // Rule ID 17009 //
     /* 108165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_In64BitMode),
     /* 108168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf16ps),
     /* 108173 */     // MIs[0] src1
     /* 108173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108176 */     // MIs[0] src2
     /* 108176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108179 */     // MIs[0] src3
     /* 108179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108182 */     // (intrinsic_void 14968:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF16PS),
     /* 108185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108189 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108195 */     GIR_RootConstrainSelectedInstOperands,
     /* 108196 */     // GIR_Coverage, 17009,
     /* 108196 */     GIR_EraseRootFromParent_Done,
     /* 108197 */   // Label 2294: @108197
     /* 108197 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(108234), // Rule ID 17011 //
     /* 108202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_In64BitMode),
     /* 108205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpfp16ps),
     /* 108210 */     // MIs[0] src1
     /* 108210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108213 */     // MIs[0] src2
     /* 108213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108216 */     // MIs[0] src3
     /* 108216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108219 */     // (intrinsic_void 14982:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPFP16PS),
     /* 108222 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108226 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108232 */     GIR_RootConstrainSelectedInstOperands,
     /* 108233 */     // GIR_Coverage, 17011,
     /* 108233 */     GIR_EraseRootFromParent_Done,
     /* 108234 */   // Label 2295: @108234
     /* 108234 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(108271), // Rule ID 17014 //
     /* 108239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmimfp16ps),
     /* 108247 */     // MIs[0] src1
     /* 108247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108250 */     // MIs[0] src2
     /* 108250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108253 */     // MIs[0] src3
     /* 108253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108256 */     // (intrinsic_void 14950:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMIMFP16PS),
     /* 108259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108263 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108269 */     GIR_RootConstrainSelectedInstOperands,
     /* 108270 */     // GIR_Coverage, 17014,
     /* 108270 */     GIR_EraseRootFromParent_Done,
     /* 108271 */   // Label 2296: @108271
     /* 108271 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(108308), // Rule ID 17015 //
     /* 108276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_In64BitMode),
     /* 108279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tcmmrlfp16ps),
     /* 108284 */     // MIs[0] src1
     /* 108284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108287 */     // MIs[0] src2
     /* 108287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108290 */     // MIs[0] src3
     /* 108290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108293 */     // (intrinsic_void 14952:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCMMRLFP16PS),
     /* 108296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108298 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108300 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108306 */     GIR_RootConstrainSelectedInstOperands,
     /* 108307 */     // GIR_Coverage, 17015,
     /* 108307 */     GIR_EraseRootFromParent_Done,
     /* 108308 */   // Label 2297: @108308
     /* 108308 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(108345), // Rule ID 17016 //
     /* 108313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbf8ps),
     /* 108321 */     // MIs[0] src1
     /* 108321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108324 */     // MIs[0] src2
     /* 108324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108327 */     // MIs[0] src3
     /* 108327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108330 */     // (intrinsic_void 14970:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBF8PS),
     /* 108333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108335 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108337 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108343 */     GIR_RootConstrainSelectedInstOperands,
     /* 108344 */     // GIR_Coverage, 17016,
     /* 108344 */     GIR_EraseRootFromParent_Done,
     /* 108345 */   // Label 2298: @108345
     /* 108345 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(108382), // Rule ID 17017 //
     /* 108350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdpbhf8ps),
     /* 108358 */     // MIs[0] src1
     /* 108358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108361 */     // MIs[0] src2
     /* 108361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108364 */     // MIs[0] src3
     /* 108364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108367 */     // (intrinsic_void 14972:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPBHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPBHF8PS),
     /* 108370 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108372 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108374 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108380 */     GIR_RootConstrainSelectedInstOperands,
     /* 108381 */     // GIR_Coverage, 17017,
     /* 108381 */     GIR_EraseRootFromParent_Done,
     /* 108382 */   // Label 2299: @108382
     /* 108382 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(108419), // Rule ID 17018 //
     /* 108387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphbf8ps),
     /* 108395 */     // MIs[0] src1
     /* 108395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108398 */     // MIs[0] src2
     /* 108398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108401 */     // MIs[0] src3
     /* 108401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108404 */     // (intrinsic_void 14984:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHBF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHBF8PS),
     /* 108407 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108411 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108413 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108417 */     GIR_RootConstrainSelectedInstOperands,
     /* 108418 */     // GIR_Coverage, 17018,
     /* 108418 */     GIR_EraseRootFromParent_Done,
     /* 108419 */   // Label 2300: @108419
     /* 108419 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(108456), // Rule ID 17019 //
     /* 108424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP8_In64BitMode),
     /* 108427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tdphf8ps),
     /* 108432 */     // MIs[0] src1
     /* 108432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108435 */     // MIs[0] src2
     /* 108435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108438 */     // MIs[0] src3
     /* 108438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108441 */     // (intrinsic_void 14986:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTDPHF8PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTDPHF8PS),
     /* 108444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108448 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108454 */     GIR_RootConstrainSelectedInstOperands,
     /* 108455 */     // GIR_Coverage, 17019,
     /* 108455 */     GIR_EraseRootFromParent_Done,
     /* 108456 */   // Label 2301: @108456
     /* 108456 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(108493), // Rule ID 17027 //
     /* 108461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXBF16_HasAMXTRANSPOSE_In64BitMode),
     /* 108464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpbf16ps),
     /* 108469 */     // MIs[0] src1
     /* 108469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108472 */     // MIs[0] src2
     /* 108472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108475 */     // MIs[0] src3
     /* 108475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108478 */     // (intrinsic_void 15011:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPBF16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPBF16PS),
     /* 108481 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108485 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108491 */     GIR_RootConstrainSelectedInstOperands,
     /* 108492 */     // GIR_Coverage, 17027,
     /* 108492 */     GIR_EraseRootFromParent_Done,
     /* 108493 */   // Label 2302: @108493
     /* 108493 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(108530), // Rule ID 17029 //
     /* 108498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXFP16_HasAMXTRANSPOSE_In64BitMode),
     /* 108501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttdpfp16ps),
     /* 108506 */     // MIs[0] src1
     /* 108506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108509 */     // MIs[0] src2
     /* 108509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108512 */     // MIs[0] src3
     /* 108512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108515 */     // (intrinsic_void 15013:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTDPFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTDPFP16PS),
     /* 108518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108522 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108528 */     GIR_RootConstrainSelectedInstOperands,
     /* 108529 */     // GIR_Coverage, 17029,
     /* 108529 */     GIR_EraseRootFromParent_Done,
     /* 108530 */   // Label 2303: @108530
     /* 108530 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(108567), // Rule ID 17034 //
     /* 108535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmimfp16ps),
     /* 108543 */     // MIs[0] src1
     /* 108543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108546 */     // MIs[0] src2
     /* 108546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108549 */     // MIs[0] src3
     /* 108549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108552 */     // (intrinsic_void 15007:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMIMFP16PS),
     /* 108555 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108557 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108559 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108565 */     GIR_RootConstrainSelectedInstOperands,
     /* 108566 */     // GIR_Coverage, 17034,
     /* 108566 */     GIR_EraseRootFromParent_Done,
     /* 108567 */   // Label 2304: @108567
     /* 108567 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(108604), // Rule ID 17035 //
     /* 108572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttcmmrlfp16ps),
     /* 108580 */     // MIs[0] src1
     /* 108580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108583 */     // MIs[0] src2
     /* 108583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108586 */     // MIs[0] src3
     /* 108586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108589 */     // (intrinsic_void 15009:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTCMMRLFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTCMMRLFP16PS),
     /* 108592 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108594 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108596 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108602 */     GIR_RootConstrainSelectedInstOperands,
     /* 108603 */     // GIR_Coverage, 17035,
     /* 108603 */     GIR_EraseRootFromParent_Done,
     /* 108604 */   // Label 2305: @108604
     /* 108604 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(108641), // Rule ID 17036 //
     /* 108609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXCOMPLEX_HasAMXTRANSPOSE_In64BitMode),
     /* 108612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tconjtcmmimfp16ps),
     /* 108617 */     // MIs[0] src1
     /* 108617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108620 */     // MIs[0] src2
     /* 108620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108623 */     // MIs[0] src3
     /* 108623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108626 */     // (intrinsic_void 14954:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTCONJTCMMIMFP16PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCONJTCMMIMFP16PS),
     /* 108629 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108631 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108633 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108639 */     GIR_RootConstrainSelectedInstOperands,
     /* 108640 */     // GIR_Coverage, 17036,
     /* 108640 */     GIR_EraseRootFromParent_Done,
     /* 108641 */   // Label 2306: @108641
     /* 108641 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(108678), // Rule ID 17055 //
     /* 108646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_In64BitMode),
     /* 108649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_tmmultf32ps),
     /* 108654 */     // MIs[0] src1
     /* 108654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108657 */     // MIs[0] src2
     /* 108657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108660 */     // MIs[0] src3
     /* 108660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108663 */     // (intrinsic_void 15004:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTMMULTF32PS),
     /* 108666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108670 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108676 */     GIR_RootConstrainSelectedInstOperands,
     /* 108677 */     // GIR_Coverage, 17055,
     /* 108677 */     GIR_EraseRootFromParent_Done,
     /* 108678 */   // Label 2307: @108678
     /* 108678 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(108715), // Rule ID 17057 //
     /* 108683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXTF32_HasAMXTRANSPOSE_In64BitMode),
     /* 108686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_ttmmultf32ps),
     /* 108691 */     // MIs[0] src1
     /* 108691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 108694 */     // MIs[0] src2
     /* 108694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108697 */     // MIs[0] src3
     /* 108697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 108700 */     // (intrinsic_void 15015:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)  =>  (PTTMMULTF32PS (timm:{ *:[i8] }):$src1, (timm:{ *:[i8] }):$src2, (timm:{ *:[i8] }):$src3)
     /* 108700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTTMMULTF32PS),
     /* 108703 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 108707 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 108709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108713 */     GIR_RootConstrainSelectedInstOperands,
     /* 108714 */     // GIR_Coverage, 17057,
     /* 108714 */     GIR_EraseRootFromParent_Done,
     /* 108715 */   // Label 2308: @108715
     /* 108715 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(108768), // Rule ID 17038 //
     /* 108720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108738 */     // MIs[0] src1
     /* 108738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108749 */     // MIs[1] Operand 1
     /* 108749 */     // No operand predicates
     /* 108749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108751 */     // (intrinsic_w_chain:{ *:[v16f32] } 14958:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWD2PSrri:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrri),
     /* 108754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108756 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108766 */     GIR_RootConstrainSelectedInstOperands,
     /* 108767 */     // GIR_Coverage, 17038,
     /* 108767 */     GIR_EraseRootFromParent_Done,
     /* 108768 */   // Label 2309: @108768
     /* 108768 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(108821), // Rule ID 17047 //
     /* 108773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108791 */     // MIs[0] src1
     /* 108791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108802 */     // MIs[1] Operand 1
     /* 108802 */     // No operand predicates
     /* 108802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108804 */     // (intrinsic_w_chain:{ *:[v32f16] } 14964:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHHrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrri),
     /* 108807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108819 */     GIR_RootConstrainSelectedInstOperands,
     /* 108820 */     // GIR_Coverage, 17047,
     /* 108820 */     GIR_EraseRootFromParent_Done,
     /* 108821 */   // Label 2310: @108821
     /* 108821 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(108874), // Rule ID 17049 //
     /* 108826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 108834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108844 */     // MIs[0] src1
     /* 108844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108855 */     // MIs[1] Operand 1
     /* 108855 */     // No operand predicates
     /* 108855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108857 */     // (intrinsic_w_chain:{ *:[v32f16] } 14966:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTCVTROWPS2PHLrri:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrri),
     /* 108860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108872 */     GIR_RootConstrainSelectedInstOperands,
     /* 108873 */     // GIR_Coverage, 17049,
     /* 108873 */     GIR_EraseRootFromParent_Done,
     /* 108874 */   // Label 2311: @108874
     /* 108874 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(108927), // Rule ID 17050 //
     /* 108879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 108887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108897 */     // MIs[0] src1
     /* 108897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 108904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108908 */     // MIs[1] Operand 1
     /* 108908 */     // No operand predicates
     /* 108908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108910 */     // (intrinsic_w_chain:{ *:[v16i32] } 14997:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)  =>  (PTILEMOVROWrri:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, (imm:{ *:[i32] }):$src2)
     /* 108910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrri),
     /* 108913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108915 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 108920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 108925 */     GIR_RootConstrainSelectedInstOperands,
     /* 108926 */     // GIR_Coverage, 17050,
     /* 108926 */     GIR_EraseRootFromParent_Done,
     /* 108927 */   // Label 2312: @108927
     /* 108927 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(108972), // Rule ID 17039 //
     /* 108932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowd2ps),
     /* 108940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 108943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108950 */     // MIs[0] src1
     /* 108950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 108957 */     // (intrinsic_w_chain:{ *:[v16f32] } 14958:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWD2PSrre:{ *:[v16f32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 108957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWD2PSrre),
     /* 108960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108964 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 108966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108970 */     GIR_RootConstrainSelectedInstOperands,
     /* 108971 */     // GIR_Coverage, 17039,
     /* 108971 */     GIR_EraseRootFromParent_Done,
     /* 108972 */   // Label 2313: @108972
     /* 108972 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(109017), // Rule ID 17046 //
     /* 108977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 108980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phh),
     /* 108985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 108988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 108991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 108995 */     // MIs[0] src1
     /* 108995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 108998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109002 */     // (intrinsic_w_chain:{ *:[v32f16] } 14964:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHHrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHHrre),
     /* 109005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109007 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109009 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109015 */     GIR_RootConstrainSelectedInstOperands,
     /* 109016 */     // GIR_Coverage, 17046,
     /* 109016 */     GIR_EraseRootFromParent_Done,
     /* 109017 */   // Label 2314: @109017
     /* 109017 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(109062), // Rule ID 17048 //
     /* 109022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tcvtrowps2phl),
     /* 109030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v32s16,
     /* 109033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109040 */     // MIs[0] src1
     /* 109040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109047 */     // (intrinsic_w_chain:{ *:[v32f16] } 14966:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTCVTROWPS2PHLrre:{ *:[v32f16] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTCVTROWPS2PHLrre),
     /* 109050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109054 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109060 */     GIR_RootConstrainSelectedInstOperands,
     /* 109061 */     // GIR_Coverage, 17048,
     /* 109061 */     GIR_EraseRootFromParent_Done,
     /* 109062 */   // Label 2315: @109062
     /* 109062 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(109107), // Rule ID 17051 //
     /* 109067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAMXAVX512_HasAVX10_2_512_In64BitMode),
     /* 109070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::x86_tilemovrow),
     /* 109075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s32,
     /* 109078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 109085 */     // MIs[0] src1
     /* 109085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 109088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109092 */     // (intrinsic_w_chain:{ *:[v16i32] } 14997:{ *:[iPTR] }, (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)  =>  (PTILEMOVROWrre:{ *:[v16i32] } (timm:{ *:[i8] }):$src1, GR32:{ *:[i32] }:$src2)
     /* 109092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::PTILEMOVROWrre),
     /* 109095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109099 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109105 */     GIR_RootConstrainSelectedInstOperands,
     /* 109106 */     // GIR_Coverage, 17051,
     /* 109106 */     GIR_EraseRootFromParent_Done,
     /* 109107 */   // Label 2316: @109107
     /* 109107 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(109152), // Rule ID 122 //
     /* 109112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval32),
     /* 109120 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109134 */     // MIs[0] cntl
     /* 109134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109137 */     // (intrinsic_void 14638:{ *:[iPTR] }, GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL32rri GR32:{ *:[i32] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL32rri),
     /* 109140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109142 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109144 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109150 */     GIR_RootConstrainSelectedInstOperands,
     /* 109151 */     // GIR_Coverage, 122,
     /* 109151 */     GIR_EraseRootFromParent_Done,
     /* 109152 */   // Label 2317: @109152
     /* 109152 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(109197), // Rule ID 124 //
     /* 109157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLWP),
     /* 109160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_lwpval64),
     /* 109165 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109179 */     // MIs[0] cntl
     /* 109179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 109182 */     // (intrinsic_void 14639:{ *:[iPTR] }, GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)  =>  (LWPVAL64rri GR64:{ *:[i64] }:$src0, GR32:{ *:[i32] }:$src1, (timm:{ *:[i32] }):$cntl)
     /* 109182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LWPVAL64rri),
     /* 109185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src0
     /* 109187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109189 */     GIR_RootToRootCopy, /*OpIdx*/3, // cntl
     /* 109191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109195 */     GIR_RootConstrainSelectedInstOperands,
     /* 109196 */     // GIR_Coverage, 124,
     /* 109196 */     GIR_EraseRootFromParent_Done,
     /* 109197 */   // Label 2318: @109197
     /* 109197 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(109279), // Rule ID 17104 //
     /* 109202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_xsetbv),
     /* 109207 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32_ArgRef_and_GR32_CBRegClassID),
     /* 109220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32_AD_and_GR32_ArgRefRegClassID),
     /* 109224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109228 */     // (intrinsic_void 15134:{ *:[iPTR] }, ECX:{ *:[i32] }, EDX:{ *:[i32] }, EAX:{ *:[i32] })  =>  (XSETBV)
     /* 109228 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109232 */     GIR_AddRegister, /*InsnID*/3, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109238 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // EAX
     /* 109242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109246 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EDX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109252 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // EDX
     /* 109256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::ECX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // ECX
     /* 109270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::XSETBV),
     /* 109273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109277 */     GIR_RootConstrainSelectedInstOperands,
     /* 109278 */     // GIR_Coverage, 17104,
     /* 109278 */     GIR_EraseRootFromParent_Done,
     /* 109279 */   // Label 2319: @109279
     /* 109279 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(109328), // Rule ID 17293 //
     /* 109284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMWAITX),
     /* 109287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_mwaitx),
     /* 109292 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 109295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 109298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 109301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109313 */     // (intrinsic_void 14716:{ *:[iPTR] }, GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)  =>  (MWAITX GR32:{ *:[i32] }:$ecx, GR32:{ *:[i32] }:$eax, GR32:{ *:[i32] }:$ebx)
     /* 109313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MWAITX),
     /* 109316 */     GIR_RootToRootCopy, /*OpIdx*/1, // ecx
     /* 109318 */     GIR_RootToRootCopy, /*OpIdx*/2, // eax
     /* 109320 */     GIR_RootToRootCopy, /*OpIdx*/3, // ebx
     /* 109322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109326 */     GIR_RootConstrainSelectedInstOperands,
     /* 109327 */     // GIR_Coverage, 17293,
     /* 109327 */     GIR_EraseRootFromParent_Done,
     /* 109328 */   // Label 2320: @109328
     /* 109328 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(109390), // Rule ID 2903 //
     /* 109333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_In64BitMode),
     /* 109336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109341 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109355 */     // MIs[0] Operand 3
     /* 109355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109363 */     // (intrinsic_void 14814:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (VMASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109367 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU64),
     /* 109380 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109382 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109388 */     GIR_RootConstrainSelectedInstOperands,
     /* 109389 */     // GIR_Coverage, 2903,
     /* 109389 */     GIR_EraseRootFromParent_Done,
     /* 109390 */   // Label 2321: @109390
     /* 109390 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(109452), // Rule ID 2904 //
     /* 109395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX),
     /* 109398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109403 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109417 */     // MIs[0] Operand 3
     /* 109417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109425 */     // (intrinsic_void 14814:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (VMASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109429 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109435 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMASKMOVDQU),
     /* 109442 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109444 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109450 */     GIR_RootConstrainSelectedInstOperands,
     /* 109451 */     // GIR_Coverage, 2904,
     /* 109451 */     GIR_EraseRootFromParent_Done,
     /* 109452 */   // Label 2322: @109452
     /* 109452 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(109514), // Rule ID 2905 //
     /* 109457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_UseSSE2),
     /* 109460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109465 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109479 */     // MIs[0] Operand 3
     /* 109479 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 109483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR64_with_sub_32bit_in_GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109487 */     // (intrinsic_void 14814:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, RDI:{ *:[i64] })  =>  (MASKMOVDQU64 VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109491 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::RDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // RDI
     /* 109501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU64),
     /* 109504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109506 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109512 */     GIR_RootConstrainSelectedInstOperands,
     /* 109513 */     // GIR_Coverage, 2905,
     /* 109513 */     GIR_EraseRootFromParent_Done,
     /* 109514 */   // Label 2323: @109514
     /* 109514 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(109576), // Rule ID 2906 //
     /* 109519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 109522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_sse2_maskmov_dqu),
     /* 109527 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 109533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109541 */     // MIs[0] Operand 3
     /* 109541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/32,
     /* 109545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR32_DIBP_and_GR32_SIDIRegClassID),
     /* 109549 */     // (intrinsic_void 14814:{ *:[iPTR] }, VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask, EDI:{ *:[i32] })  =>  (MASKMOVDQU VR128:{ *:[v16i8] }:$src, VR128:{ *:[v16i8] }:$mask)
     /* 109549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109553 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::EDI), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // EDI
     /* 109563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MASKMOVDQU),
     /* 109566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109568 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 109570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109574 */     GIR_RootConstrainSelectedInstOperands,
     /* 109575 */     // GIR_Coverage, 2906,
     /* 109575 */     GIR_EraseRootFromParent_Done,
     /* 109576 */   // Label 2324: @109576
     /* 109576 */   GIM_Reject,
     /* 109577 */ // Label 2259: @109577
     /* 109577 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(109665), // Rule ID 16988 //
     /* 109582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasKL),
     /* 109585 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 109588 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::x86_loadiwkey),
     /* 109593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 109599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 109602 */   GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 109605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109613 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 109617 */   GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(X86::GR32_ADRegClassID),
     /* 109621 */   // (intrinsic_void 14635:{ *:[iPTR] }, XMM0:{ *:[v2i64] }, VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2, EAX:{ *:[i32] })  =>  (LOADIWKEY:{ *:[i32] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 109621 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109625 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(X86::EAX), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109631 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // EAX
     /* 109635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109639 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::XMM0), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // XMM0
     /* 109649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LOADIWKEY),
     /* 109652 */   GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 109654 */   GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 109656 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 109659 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109663 */   GIR_RootConstrainSelectedInstOperands,
     /* 109664 */   // GIR_Coverage, 16988,
     /* 109664 */   GIR_EraseRootFromParent_Done,
     /* 109665 */ // Label 2325: @109665
     /* 109665 */ GIM_Reject,
     /* 109666 */ // Label 19: @109666
     /* 109666 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2329*/ GIMT_Encode4(110100),
     /* 109677 */ /*GILLT_s16*//*Label 2326*/ GIMT_Encode4(109689),
     /* 109681 */ /*GILLT_s32*//*Label 2327*/ GIMT_Encode4(109747),
     /* 109685 */ /*GILLT_s64*//*Label 2328*/ GIMT_Encode4(109922),
     /* 109689 */ // Label 2326: @109689
     /* 109689 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(109746), // Rule ID 22590 //
     /* 109694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109705 */   // (anyext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 109705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109728 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 109735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 109740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 109745 */   // GIR_Coverage, 22590,
     /* 109745 */   GIR_EraseRootFromParent_Done,
     /* 109746 */ // Label 2330: @109746
     /* 109746 */ GIM_Reject,
     /* 109747 */ // Label 2327: @109747
     /* 109747 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(109793), // Rule ID 19437 //
     /* 109752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 109771 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 109776 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109778 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] })
     /* 109778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109792 */   // GIR_Coverage, 19437,
     /* 109792 */   GIR_EraseRootFromParent_Done,
     /* 109793 */ // Label 2331: @109793
     /* 109793 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(109839), // Rule ID 19440 //
     /* 109798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 109813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 109817 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 109822 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109824 */   // (anyext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (COPY_TO_REGCLASS:{ *:[i32] } VK8:{ *:[v8i1] }:$src, GR32:{ *:[i32] })
     /* 109824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109829 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 109833 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 109838 */   // GIR_Coverage, 19440,
     /* 109838 */   GIR_EraseRootFromParent_Done,
     /* 109839 */ // Label 2332: @109839
     /* 109839 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(109862), // Rule ID 22591 //
     /* 109844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 109851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109855 */   // (anyext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 109855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109860 */   GIR_RootConstrainSelectedInstOperands,
     /* 109861 */   // GIR_Coverage, 22591,
     /* 109861 */   GIR_Done,
     /* 109862 */ // Label 2333: @109862
     /* 109862 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(109921), // Rule ID 22592 //
     /* 109867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109878 */   // (anyext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR16:{ *:[i16] }:$src, sub_16bit:{ *:[i32] })
     /* 109878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109897 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109900 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 109905 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 109915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 109920 */   // GIR_Coverage, 22592,
     /* 109920 */   GIR_EraseRootFromParent_Done,
     /* 109921 */ // Label 2334: @109921
     /* 109921 */ GIM_Reject,
     /* 109922 */ // Label 2328: @109922
     /* 109922 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(109981), // Rule ID 22593 //
     /* 109927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 109930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 109938 */   // (anyext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 109938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 109941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 109945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109950 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 109959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 109970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 109975 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 109980 */   // GIR_Coverage, 22593,
     /* 109980 */   GIR_EraseRootFromParent_Done,
     /* 109981 */ // Label 2335: @109981
     /* 109981 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(110040), // Rule ID 22594 //
     /* 109986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 109989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 109993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 109997 */   // (anyext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 109997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 110004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110009 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110039 */   // GIR_Coverage, 22594,
     /* 110039 */   GIR_EraseRootFromParent_Done,
     /* 110040 */ // Label 2336: @110040
     /* 110040 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(110099), // Rule ID 22595 //
     /* 110045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 110052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110056 */   // (anyext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR32:{ *:[i32] }:$src, sub_32bit:{ *:[i32] })
     /* 110056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 110059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110078 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 110083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 110088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR64RegClassID),
     /* 110093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 110098 */   // GIR_Coverage, 22595,
     /* 110098 */   GIR_EraseRootFromParent_Done,
     /* 110099 */ // Label 2337: @110099
     /* 110099 */ GIM_Reject,
     /* 110100 */ // Label 2329: @110100
     /* 110100 */ GIM_Reject,
     /* 110101 */ // Label 20: @110101
     /* 110101 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(111189),
     /* 110112 */ /*GILLT_s8*//*Label 2338*/ GIMT_Encode4(110196),
     /* 110116 */ /*GILLT_s16*//*Label 2339*/ GIMT_Encode4(110480), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110148 */ /*GILLT_v4s32*//*Label 2340*/ GIMT_Encode4(110519), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110160 */ /*GILLT_v8s16*//*Label 2341*/ GIMT_Encode4(110659),
     /* 110164 */ /*GILLT_v8s32*//*Label 2342*/ GIMT_Encode4(110822), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110176 */ /*GILLT_v16s8*//*Label 2343*/ GIMT_Encode4(110849),
     /* 110180 */ /*GILLT_v16s16*//*Label 2344*/ GIMT_Encode4(111135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110192 */ /*GILLT_v32s8*//*Label 2345*/ GIMT_Encode4(111162),
     /* 110196 */ // Label 2338: @110196
     /* 110196 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(110271), // Rule ID 19432 //
     /* 110201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110208 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 110216 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 110220 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 110225 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110227 */   // (trunc:{ *:[i8] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } VK16:{ *:[v16i1] }:$src, GR32:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110239 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 110243 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32RegClassID),
     /* 110248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110253 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110265 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110270 */   // GIR_Coverage, 19432,
     /* 110270 */   GIR_EraseRootFromParent_Done,
     /* 110271 */ // Label 2347: @110271
     /* 110271 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(110334), // Rule ID 22652 //
     /* 110276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110290 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i32] } GR32:{ *:[i32] }:$src, GR32_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110302 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110306 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110316 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32_ABCDRegClassID),
     /* 110333 */   // GIR_Coverage, 22652,
     /* 110333 */   GIR_EraseRootFromParent_Done,
     /* 110334 */ // Label 2348: @110334
     /* 110334 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(110397), // Rule ID 22653 //
     /* 110339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode),
     /* 110342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110353 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } (COPY_TO_REGCLASS:{ *:[i16] } GR16:{ *:[i16] }:$src, GR16_ABCD:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 110353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 110356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110365 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110369 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110379 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 110386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 110391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16_ABCDRegClassID),
     /* 110396 */   // GIR_Coverage, 22653,
     /* 110396 */   GIR_EraseRootFromParent_Done,
     /* 110397 */ // Label 2349: @110397
     /* 110397 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(110438), // Rule ID 22657 //
     /* 110402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110416 */   // (trunc:{ *:[i8] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] })
     /* 110416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110421 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110437 */   // GIR_Coverage, 22657,
     /* 110437 */   GIR_EraseRootFromParent_Done,
     /* 110438 */ // Label 2350: @110438
     /* 110438 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(110479), // Rule ID 22658 //
     /* 110443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 110446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 110453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110457 */   // (trunc:{ *:[i8] } GR16:{ *:[i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })
     /* 110457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110460 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110462 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 110468 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 110473 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 110478 */   // GIR_Coverage, 22658,
     /* 110478 */   GIR_EraseRootFromParent_Done,
     /* 110479 */ // Label 2351: @110479
     /* 110479 */ GIM_Reject,
     /* 110480 */ // Label 2339: @110480
     /* 110480 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(110518), // Rule ID 22651 //
     /* 110485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 110492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 110496 */   // (trunc:{ *:[i16] } GR32:{ *:[i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] })
     /* 110496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110501 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 110507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 110512 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 110517 */   // GIR_Coverage, 22651,
     /* 110517 */   GIR_EraseRootFromParent_Done,
     /* 110518 */ // Label 2352: @110518
     /* 110518 */ GIM_Reject,
     /* 110519 */ // Label 2340: @110519
     /* 110519 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(110658),
     /* 110524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 110527 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(110550), // Rule ID 12262 //
     /* 110532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110543 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (VPMOVQDZ256rr:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)
     /* 110543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZ256rr),
     /* 110548 */     GIR_RootConstrainSelectedInstOperands,
     /* 110549 */     // GIR_Coverage, 12262,
     /* 110549 */     GIR_Done,
     /* 110550 */   // Label 2354: @110550
     /* 110550 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(110657), // Rule ID 21557 //
     /* 110555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110566 */     // (trunc:{ *:[v4i32] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPMOVQDZrr:{ *:[v8i32] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110566 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 110569 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110573 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 110583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110592 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110599 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 110620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110656 */     // GIR_Coverage, 21557,
     /* 110656 */     GIR_EraseRootFromParent_Done,
     /* 110657 */   // Label 2355: @110657
     /* 110657 */   GIM_Reject,
     /* 110658 */ // Label 2353: @110658
     /* 110658 */ GIM_Reject,
     /* 110659 */ // Label 2341: @110659
     /* 110659 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(110685), // Rule ID 12238 //
     /* 110664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110678 */   // (trunc:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQWZrr:{ *:[v8i16] } VR512:{ *:[v8i64] }:$src)
     /* 110678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQWZrr),
     /* 110683 */   GIR_RootConstrainSelectedInstOperands,
     /* 110684 */   // GIR_Coverage, 12238,
     /* 110684 */   GIR_Done,
     /* 110685 */ // Label 2356: @110685
     /* 110685 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(110711), // Rule ID 12316 //
     /* 110690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 110693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110704 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)
     /* 110704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 110709 */   GIR_RootConstrainSelectedInstOperands,
     /* 110710 */   // GIR_Coverage, 12316,
     /* 110710 */   GIR_Done,
     /* 110711 */ // Label 2357: @110711
     /* 110711 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(110821), // Rule ID 21556 //
     /* 110716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 110719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 110722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110730 */   // (trunc:{ *:[v8i16] } VR256X:{ *:[v8i32] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPMOVDWZrr:{ *:[v16i16] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110730 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 110733 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110737 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110742 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110744 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 110747 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110751 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110756 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110759 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 110763 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 110766 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 110771 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 110776 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110781 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 110784 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 110788 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110793 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110803 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 110810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 110815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 110820 */   // GIR_Coverage, 21556,
     /* 110820 */   GIR_EraseRootFromParent_Done,
     /* 110821 */ // Label 2358: @110821
     /* 110821 */ GIM_Reject,
     /* 110822 */ // Label 2342: @110822
     /* 110822 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(110848), // Rule ID 12265 //
     /* 110827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 110833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110841 */   // (trunc:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)  =>  (VPMOVQDZrr:{ *:[v8i32] } VR512:{ *:[v8i64] }:$src)
     /* 110841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVQDZrr),
     /* 110846 */   GIR_RootConstrainSelectedInstOperands,
     /* 110847 */   // GIR_Coverage, 12265,
     /* 110847 */   GIR_Done,
     /* 110848 */ // Label 2359: @110848
     /* 110848 */ GIM_Reject,
     /* 110849 */ // Label 2343: @110849
     /* 110849 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(110925), // Rule ID 21650 //
     /* 110854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 110872 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 110879 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 110883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110885 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 110892 */   // (trunc:{ *:[v16i8] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src))
     /* 110892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 110895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 110899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110904 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src
     /* 110908 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 110913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110923 */   GIR_RootConstrainSelectedInstOperands,
     /* 110924 */   // GIR_Coverage, 21650,
     /* 110924 */   GIR_EraseRootFromParent_Done,
     /* 110925 */ // Label 2360: @110925
     /* 110925 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(110951), // Rule ID 12292 //
     /* 110930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 110933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 110936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 110944 */   // (trunc:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } VR512:{ *:[v16i32] }:$src)
     /* 110944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 110949 */   GIR_RootConstrainSelectedInstOperands,
     /* 110950 */   // GIR_Coverage, 12292,
     /* 110950 */   GIR_Done,
     /* 110951 */ // Label 2361: @110951
     /* 110951 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(110977), // Rule ID 12343 //
     /* 110956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 110959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 110966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110970 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVWBZ256rr:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)
     /* 110970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZ256rr),
     /* 110975 */   GIR_RootConstrainSelectedInstOperands,
     /* 110976 */   // GIR_Coverage, 12343,
     /* 110976 */   GIR_Done,
     /* 110977 */ // Label 2362: @110977
     /* 110977 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(111087), // Rule ID 21558 //
     /* 110982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 110985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 110988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 110992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 110996 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPMOVWBZrr:{ *:[v32i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 110996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 110999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 111003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 111013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 111017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111022 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 111025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111029 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 111032 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 111037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 111042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 111050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 111062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111069 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 111076 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 111081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256XRegClassID),
     /* 111086 */   // GIR_Coverage, 21558,
     /* 111086 */   GIR_EraseRootFromParent_Done,
     /* 111087 */ // Label 2363: @111087
     /* 111087 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(111134), // Rule ID 21649 //
     /* 111092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_NoBWI),
     /* 111095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 111098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 111102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111106 */   // (trunc:{ *:[v16i8] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src))
     /* 111106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 111109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 111113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111118 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 111122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 111127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111132 */   GIR_RootConstrainSelectedInstOperands,
     /* 111133 */   // GIR_Coverage, 21649,
     /* 111133 */   GIR_EraseRootFromParent_Done,
     /* 111134 */ // Label 2364: @111134
     /* 111134 */ GIM_Reject,
     /* 111135 */ // Label 2344: @111135
     /* 111135 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(111161), // Rule ID 12319 //
     /* 111140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 111143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 111146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111154 */   // (trunc:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } VR512:{ *:[v16i32] }:$src)
     /* 111154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 111159 */   GIR_RootConstrainSelectedInstOperands,
     /* 111160 */   // GIR_Coverage, 12319,
     /* 111160 */   GIR_Done,
     /* 111161 */ // Label 2365: @111161
     /* 111161 */ GIM_Reject,
     /* 111162 */ // Label 2345: @111162
     /* 111162 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(111188), // Rule ID 12346 //
     /* 111167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 111170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 111173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 111177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 111181 */   // (trunc:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)  =>  (VPMOVWBZrr:{ *:[v32i8] } VR512:{ *:[v32i16] }:$src)
     /* 111181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVWBZrr),
     /* 111186 */   GIR_RootConstrainSelectedInstOperands,
     /* 111187 */   // GIR_Coverage, 12346,
     /* 111187 */   GIR_Done,
     /* 111188 */ // Label 2366: @111188
     /* 111188 */ GIM_Reject,
     /* 111189 */ // Label 2346: @111189
     /* 111189 */ GIM_Reject,
     /* 111190 */ // Label 21: @111190
     /* 111190 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2371*/ GIMT_Encode4(111795),
     /* 111201 */ /*GILLT_s8*//*Label 2367*/ GIMT_Encode4(111217),
     /* 111205 */ /*GILLT_s16*//*Label 2368*/ GIMT_Encode4(111299),
     /* 111209 */ /*GILLT_s32*//*Label 2369*/ GIMT_Encode4(111499),
     /* 111213 */ /*GILLT_s64*//*Label 2370*/ GIMT_Encode4(111641),
     /* 111217 */ // Label 2367: @111217
     /* 111217 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(111298),
     /* 111222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 111226 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(111282), // Rule ID 22384 //
     /* 111231 */     // MIs[0] Operand 1
     /* 111231 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111242 */     // 0:{ *:[i8] }  =>  (EXTRACT_SUBREG:{ *:[i8] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_8bit:{ *:[i32] })
     /* 111242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111254 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_8bit),
     /* 111271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 111276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111281 */     // GIR_Coverage, 22384,
     /* 111281 */     GIR_EraseRootFromParent_Done,
     /* 111282 */   // Label 2373: @111282
     /* 111282 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(111297), // Rule ID 19 //
     /* 111287 */     // MIs[0] Operand 1
     /* 111287 */     // No operand predicates
     /* 111287 */     // (imm:{ *:[i8] }):$src  =>  (MOV8ri:{ *:[i8] } (imm:{ *:[i8] }):$src)
     /* 111287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV8ri),
     /* 111290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111295 */     GIR_RootConstrainSelectedInstOperands,
     /* 111296 */     // GIR_Coverage, 19,
     /* 111296 */     GIR_EraseRootFromParent_Done,
     /* 111297 */   // Label 2374: @111297
     /* 111297 */   GIM_Reject,
     /* 111298 */ // Label 2372: @111298
     /* 111298 */ GIM_Reject,
     /* 111299 */ // Label 2368: @111299
     /* 111299 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(111498),
     /* 111304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 111308 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(111364), // Rule ID 22385 //
     /* 111313 */     // MIs[0] Operand 1
     /* 111313 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111324 */     // 0:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111336 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111346 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111363 */     // GIR_Coverage, 22385,
     /* 111363 */     GIR_EraseRootFromParent_Done,
     /* 111364 */   // Label 2376: @111364
     /* 111364 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(111423), // Rule ID 22387 //
     /* 111369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111372 */     // MIs[0] Operand 1
     /* 111372 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111383 */     // 1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111395 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111405 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111422 */     // GIR_Coverage, 22387,
     /* 111422 */     GIR_EraseRootFromParent_Done,
     /* 111423 */   // Label 2377: @111423
     /* 111423 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(111482), // Rule ID 22388 //
     /* 111428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111431 */     // MIs[0] Operand 1
     /* 111431 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111442 */     // -1:{ *:[i16] }  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOV32r_1:{ *:[i32] }:{ *:[i32] }), sub_16bit:{ *:[i32] })
     /* 111442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111454 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111457 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111464 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 111471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 111476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 111481 */     // GIR_Coverage, 22388,
     /* 111481 */     GIR_EraseRootFromParent_Done,
     /* 111482 */   // Label 2378: @111482
     /* 111482 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(111497), // Rule ID 20 //
     /* 111487 */     // MIs[0] Operand 1
     /* 111487 */     // No operand predicates
     /* 111487 */     // (imm:{ *:[i16] }):$src  =>  (MOV16ri:{ *:[i16] } (imm:{ *:[i16] }):$src)
     /* 111487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV16ri),
     /* 111490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111495 */     GIR_RootConstrainSelectedInstOperands,
     /* 111496 */     // GIR_Coverage, 20,
     /* 111496 */     GIR_EraseRootFromParent_Done,
     /* 111497 */   // Label 2379: @111497
     /* 111497 */   GIM_Reject,
     /* 111498 */ // Label 2375: @111498
     /* 111498 */ GIM_Reject,
     /* 111499 */ // Label 2369: @111499
     /* 111499 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(111529), // Rule ID 17153 //
     /* 111504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111508 */   // MIs[0] Operand 1
     /* 111508 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111519 */   // 0:{ *:[i32] }  =>  (MOV32r0:{ *:[i32] }:{ *:[i32] })
     /* 111519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111524 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111527 */   GIR_RootConstrainSelectedInstOperands,
     /* 111528 */   // GIR_Coverage, 17153,
     /* 111528 */   GIR_EraseRootFromParent_Done,
     /* 111529 */ // Label 2380: @111529
     /* 111529 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(111562), // Rule ID 17154 //
     /* 111534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111541 */   // MIs[0] Operand 1
     /* 111541 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 111552 */   // 1:{ *:[i32] }  =>  (MOV32r1:{ *:[i32] }:{ *:[i32] })
     /* 111552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r1),
     /* 111555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111557 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111560 */   GIR_RootConstrainSelectedInstOperands,
     /* 111561 */   // GIR_Coverage, 17154,
     /* 111561 */   GIR_EraseRootFromParent_Done,
     /* 111562 */ // Label 2381: @111562
     /* 111562 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(111595), // Rule ID 17155 //
     /* 111567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_Not64BitMode_OptForSize),
     /* 111570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111574 */   // MIs[0] Operand 1
     /* 111574 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 111585 */   // -1:{ *:[i32] }  =>  (MOV32r_1:{ *:[i32] }:{ *:[i32] })
     /* 111585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32r_1),
     /* 111588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111590 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 111593 */   GIR_RootConstrainSelectedInstOperands,
     /* 111594 */   // GIR_Coverage, 17155,
     /* 111594 */   GIR_EraseRootFromParent_Done,
     /* 111595 */ // Label 2382: @111595
     /* 111595 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(111621), // Rule ID 17156 //
     /* 111600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111603 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immSExt8),
     /* 111607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111611 */   // MIs[0] Operand 1
     /* 111611 */   // No operand predicates
     /* 111611 */   // (imm:{ *:[i32] })<<P:Predicate_i32immSExt8>>:$src  =>  (MOV32ImmSExti8:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ImmSExti8),
     /* 111614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111616 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111619 */   GIR_RootConstrainSelectedInstOperands,
     /* 111620 */   // GIR_Coverage, 17156,
     /* 111620 */   GIR_EraseRootFromParent_Done,
     /* 111621 */ // Label 2383: @111621
     /* 111621 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(111640), // Rule ID 21 //
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 111630 */   // MIs[0] Operand 1
     /* 111630 */   // No operand predicates
     /* 111630 */   // (imm:{ *:[i32] }):$src  =>  (MOV32ri:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 111630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri),
     /* 111633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111635 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111638 */   GIR_RootConstrainSelectedInstOperands,
     /* 111639 */   // GIR_Coverage, 21,
     /* 111639 */   GIR_EraseRootFromParent_Done,
     /* 111640 */ // Label 2384: @111640
     /* 111640 */ GIM_Reject,
     /* 111641 */ // Label 2370: @111641
     /* 111641 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(111703), // Rule ID 22386 //
     /* 111646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111650 */   // MIs[0] Operand 1
     /* 111650 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 111661 */   // 0:{ *:[i64] }  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32r0:{ *:[i32] }:{ *:[i32] }), sub_32bit:{ *:[i32] })
     /* 111661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32r0),
     /* 111668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111673 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 111676 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111686 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 111692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 111697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 111702 */   // GIR_Coverage, 22386,
     /* 111702 */   GIR_EraseRootFromParent_Done,
     /* 111703 */ // Label 2385: @111703
     /* 111703 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(111729), // Rule ID 17157 //
     /* 111708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotWin64WithoutFP_OptForMinSize),
     /* 111711 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt8),
     /* 111715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111719 */   // MIs[0] Operand 1
     /* 111719 */   // No operand predicates
     /* 111719 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt8>>:$src  =>  (MOV64ImmSExti8:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ImmSExti8),
     /* 111722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111724 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111727 */   GIR_RootConstrainSelectedInstOperands,
     /* 111728 */   // GIR_Coverage, 17157,
     /* 111728 */   GIR_EraseRootFromParent_Done,
     /* 111729 */ // Label 2386: @111729
     /* 111729 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(111752), // Rule ID 17158 //
     /* 111734 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immZExt32),
     /* 111738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111742 */   // MIs[0] Operand 1
     /* 111742 */   // No operand predicates
     /* 111742 */   // (imm:{ *:[i64] })<<P:Predicate_i64immZExt32>>:$src  =>  (MOV32ri64:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV32ri64),
     /* 111745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111747 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111750 */   GIR_RootConstrainSelectedInstOperands,
     /* 111751 */   // GIR_Coverage, 17158,
     /* 111751 */   GIR_EraseRootFromParent_Done,
     /* 111752 */ // Label 2387: @111752
     /* 111752 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(111775), // Rule ID 22 //
     /* 111757 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64immSExt32),
     /* 111761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111765 */   // MIs[0] Operand 1
     /* 111765 */   // No operand predicates
     /* 111765 */   // (imm:{ *:[i64] })<<P:Predicate_i64immSExt32>>:$src  =>  (MOV64ri32:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri32),
     /* 111768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111770 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111773 */   GIR_RootConstrainSelectedInstOperands,
     /* 111774 */   // GIR_Coverage, 22,
     /* 111774 */   GIR_EraseRootFromParent_Done,
     /* 111775 */ // Label 2388: @111775
     /* 111775 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(111794), // Rule ID 23 //
     /* 111780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 111784 */   // MIs[0] Operand 1
     /* 111784 */   // No operand predicates
     /* 111784 */   // (imm:{ *:[i64] }):$src  =>  (MOV64ri:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 111784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOV64ri),
     /* 111787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111789 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 111792 */   GIR_RootConstrainSelectedInstOperands,
     /* 111793 */   // GIR_Coverage, 23,
     /* 111793 */   GIR_EraseRootFromParent_Done,
     /* 111794 */ // Label 2389: @111794
     /* 111794 */ GIM_Reject,
     /* 111795 */ // Label 2371: @111795
     /* 111795 */ GIM_Reject,
     /* 111796 */ // Label 22: @111796
     /* 111796 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 2393*/ GIMT_Encode4(112248),
     /* 111807 */ /*GILLT_s32*//*Label 2390*/ GIMT_Encode4(111819),
     /* 111811 */ /*GILLT_s64*//*Label 2391*/ GIMT_Encode4(111964),
     /* 111815 */ /*GILLT_s80*//*Label 2392*/ GIMT_Encode4(112109),
     /* 111819 */ // Label 2390: @111819
     /* 111819 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(111845), // Rule ID 1116 //
     /* 111824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111827 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111835 */   // MIs[0] Operand 1
     /* 111835 */   // No operand predicates
     /* 111835 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (LD_Fp032:{ *:[f32] }:{ *:[i16] })
     /* 111835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111840 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111843 */   GIR_RootConstrainSelectedInstOperands,
     /* 111844 */   // GIR_Coverage, 1116,
     /* 111844 */   GIR_EraseRootFromParent_Done,
     /* 111845 */ // Label 2394: @111845
     /* 111845 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(111871), // Rule ID 1117 //
     /* 111850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111853 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 111857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111861 */   // MIs[0] Operand 1
     /* 111861 */   // No operand predicates
     /* 111861 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm1>>  =>  (LD_Fp132:{ *:[f32] }:{ *:[i16] })
     /* 111861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111866 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111869 */   GIR_RootConstrainSelectedInstOperands,
     /* 111870 */   // GIR_Coverage, 1117,
     /* 111870 */   GIR_EraseRootFromParent_Done,
     /* 111871 */ // Label 2395: @111871
     /* 111871 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(111917), // Rule ID 17720 //
     /* 111876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111879 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 111883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111887 */   // MIs[0] Operand 1
     /* 111887 */   // No operand predicates
     /* 111887 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp032:{ *:[f32] }:{ *:[i16] }))
     /* 111887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp032),
     /* 111894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111899 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111912 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111915 */   GIR_RootConstrainSelectedInstOperands,
     /* 111916 */   // GIR_Coverage, 17720,
     /* 111916 */   GIR_EraseRootFromParent_Done,
     /* 111917 */ // Label 2396: @111917
     /* 111917 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(111963), // Rule ID 17721 //
     /* 111922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 111925 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 111929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 111933 */   // MIs[0] Operand 1
     /* 111933 */   // No operand predicates
     /* 111933 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } (LD_Fp132:{ *:[f32] }:{ *:[i16] }))
     /* 111933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp132),
     /* 111940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111945 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 111948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 111953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111958 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111961 */   GIR_RootConstrainSelectedInstOperands,
     /* 111962 */   // GIR_Coverage, 17721,
     /* 111962 */   GIR_EraseRootFromParent_Done,
     /* 111963 */ // Label 2397: @111963
     /* 111963 */ GIM_Reject,
     /* 111964 */ // Label 2391: @111964
     /* 111964 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(111990), // Rule ID 1118 //
     /* 111969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111972 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 111976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 111980 */   // MIs[0] Operand 1
     /* 111980 */   // No operand predicates
     /* 111980 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (LD_Fp064:{ *:[f64] }:{ *:[i16] })
     /* 111980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 111983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111985 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 111988 */   GIR_RootConstrainSelectedInstOperands,
     /* 111989 */   // GIR_Coverage, 1118,
     /* 111989 */   GIR_EraseRootFromParent_Done,
     /* 111990 */ // Label 2398: @111990
     /* 111990 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(112016), // Rule ID 1119 //
     /* 111995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 111998 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 112002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112006 */   // MIs[0] Operand 1
     /* 112006 */   // No operand predicates
     /* 112006 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm1>>  =>  (LD_Fp164:{ *:[f64] }:{ *:[i16] })
     /* 112006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 112009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112011 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112014 */   GIR_RootConstrainSelectedInstOperands,
     /* 112015 */   // GIR_Coverage, 1119,
     /* 112015 */   GIR_EraseRootFromParent_Done,
     /* 112016 */ // Label 2399: @112016
     /* 112016 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(112062), // Rule ID 17722 //
     /* 112021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112024 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112032 */   // MIs[0] Operand 1
     /* 112032 */   // No operand predicates
     /* 112032 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp064:{ *:[f64] }:{ *:[i16] }))
     /* 112032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp064),
     /* 112039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112044 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112057 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112060 */   GIR_RootConstrainSelectedInstOperands,
     /* 112061 */   // GIR_Coverage, 17722,
     /* 112061 */   GIR_EraseRootFromParent_Done,
     /* 112062 */ // Label 2400: @112062
     /* 112062 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(112108), // Rule ID 17723 //
     /* 112067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 112070 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 112078 */   // MIs[0] Operand 1
     /* 112078 */   // No operand predicates
     /* 112078 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } (LD_Fp164:{ *:[f64] }:{ *:[i16] }))
     /* 112078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp164),
     /* 112085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112090 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 112098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112103 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112106 */   GIR_RootConstrainSelectedInstOperands,
     /* 112107 */   // GIR_Coverage, 17723,
     /* 112107 */   GIR_EraseRootFromParent_Done,
     /* 112108 */ // Label 2401: @112108
     /* 112108 */ GIM_Reject,
     /* 112109 */ // Label 2392: @112109
     /* 112109 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(112135), // Rule ID 1120 //
     /* 112114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112117 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 112121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112125 */   // MIs[0] Operand 1
     /* 112125 */   // No operand predicates
     /* 112125 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm0>>  =>  (LD_Fp080:{ *:[f80] }:{ *:[i16] })
     /* 112125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112130 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112133 */   GIR_RootConstrainSelectedInstOperands,
     /* 112134 */   // GIR_Coverage, 1120,
     /* 112134 */   GIR_EraseRootFromParent_Done,
     /* 112135 */ // Label 2402: @112135
     /* 112135 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(112161), // Rule ID 1121 //
     /* 112140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 112143 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm1),
     /* 112147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112151 */   // MIs[0] Operand 1
     /* 112151 */   // No operand predicates
     /* 112151 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimm1>>  =>  (LD_Fp180:{ *:[f80] }:{ *:[i16] })
     /* 112151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112156 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112159 */   GIR_RootConstrainSelectedInstOperands,
     /* 112160 */   // GIR_Coverage, 1121,
     /* 112160 */   GIR_EraseRootFromParent_Done,
     /* 112161 */ // Label 2403: @112161
     /* 112161 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(112204), // Rule ID 17724 //
     /* 112166 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg0),
     /* 112170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112174 */   // MIs[0] Operand 1
     /* 112174 */   // No operand predicates
     /* 112174 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg0>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp080:{ *:[f80] }:{ *:[i16] }))
     /* 112174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp080),
     /* 112181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112186 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112199 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112202 */   GIR_RootConstrainSelectedInstOperands,
     /* 112203 */   // GIR_Coverage, 17724,
     /* 112203 */   GIR_EraseRootFromParent_Done,
     /* 112204 */ // Label 2404: @112204
     /* 112204 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(112247), // Rule ID 17725 //
     /* 112209 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimmneg1),
     /* 112213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 112217 */   // MIs[0] Operand 1
     /* 112217 */   // No operand predicates
     /* 112217 */   // (fpimm:{ *:[f80] })<<P:Predicate_fpimmneg1>>  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } (LD_Fp180:{ *:[f80] }:{ *:[i16] }))
     /* 112217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s80,
     /* 112220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::LD_Fp180),
     /* 112224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112229 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::FPSW*/0,
     /* 112232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 112237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112242 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 112245 */   GIR_RootConstrainSelectedInstOperands,
     /* 112246 */   // GIR_Coverage, 17725,
     /* 112246 */   GIR_EraseRootFromParent_Done,
     /* 112247 */ // Label 2405: @112247
     /* 112247 */ GIM_Reject,
     /* 112248 */ // Label 2393: @112248
     /* 112248 */ GIM_Reject,
     /* 112249 */ // Label 23: @112249
     /* 112249 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 2421*/ GIMT_Encode4(113920),
     /* 112260 */ /*GILLT_s16*//*Label 2406*/ GIMT_Encode4(112352),
     /* 112264 */ /*GILLT_s32*//*Label 2407*/ GIMT_Encode4(112410),
     /* 112268 */ /*GILLT_s64*//*Label 2408*/ GIMT_Encode4(112457), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112284 */ /*GILLT_v2s64*//*Label 2409*/ GIMT_Encode4(112530), GIMT_Encode4(0),
     /* 112292 */ /*GILLT_v4s32*//*Label 2410*/ GIMT_Encode4(112557),
     /* 112296 */ /*GILLT_v4s64*//*Label 2411*/ GIMT_Encode4(112584), GIMT_Encode4(0),
     /* 112304 */ /*GILLT_v8s16*//*Label 2412*/ GIMT_Encode4(112781),
     /* 112308 */ /*GILLT_v8s32*//*Label 2413*/ GIMT_Encode4(112850),
     /* 112312 */ /*GILLT_v8s64*//*Label 2414*/ GIMT_Encode4(113047), GIMT_Encode4(0),
     /* 112320 */ /*GILLT_v16s8*//*Label 2415*/ GIMT_Encode4(113244),
     /* 112324 */ /*GILLT_v16s16*//*Label 2416*/ GIMT_Encode4(113313),
     /* 112328 */ /*GILLT_v16s32*//*Label 2417*/ GIMT_Encode4(113557), GIMT_Encode4(0),
     /* 112336 */ /*GILLT_v32s8*//*Label 2418*/ GIMT_Encode4(113754),
     /* 112340 */ /*GILLT_v32s16*//*Label 2419*/ GIMT_Encode4(113781), GIMT_Encode4(0),
     /* 112348 */ /*GILLT_v64s8*//*Label 2420*/ GIMT_Encode4(113893),
     /* 112352 */ // Label 2406: @112352
     /* 112352 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(112409), // Rule ID 22647 //
     /* 112357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112368 */   // (sext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 112368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112380 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112386 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112389 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112391 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 112398 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 112403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 112408 */   // GIR_Coverage, 22647,
     /* 112408 */   GIR_EraseRootFromParent_Done,
     /* 112409 */ // Label 2422: @112409
     /* 112409 */ GIM_Reject,
     /* 112410 */ // Label 2407: @112410
     /* 112410 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(112433), // Rule ID 614 //
     /* 112415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112426 */   // (sext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVSX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 112426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 112431 */   GIR_RootConstrainSelectedInstOperands,
     /* 112432 */   // GIR_Coverage, 614,
     /* 112432 */   GIR_Done,
     /* 112433 */ // Label 2423: @112433
     /* 112433 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(112456), // Rule ID 616 //
     /* 112438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112449 */   // (sext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVSX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 112449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 112454 */   GIR_RootConstrainSelectedInstOperands,
     /* 112455 */   // GIR_Coverage, 616,
     /* 112455 */   GIR_Done,
     /* 112456 */ // Label 2424: @112456
     /* 112456 */ GIM_Reject,
     /* 112457 */ // Label 2408: @112457
     /* 112457 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(112480), // Rule ID 622 //
     /* 112462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 112465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 112473 */   // (sext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (MOVSX64rr8:{ *:[i64] } GR8:{ *:[i8] }:$src)
     /* 112473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr8),
     /* 112478 */   GIR_RootConstrainSelectedInstOperands,
     /* 112479 */   // GIR_Coverage, 622,
     /* 112479 */   GIR_Done,
     /* 112480 */ // Label 2425: @112480
     /* 112480 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(112503), // Rule ID 624 //
     /* 112485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 112488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 112496 */   // (sext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (MOVSX64rr16:{ *:[i64] } GR16:{ *:[i16] }:$src)
     /* 112496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr16),
     /* 112501 */   GIR_RootConstrainSelectedInstOperands,
     /* 112502 */   // GIR_Coverage, 624,
     /* 112502 */   GIR_Done,
     /* 112503 */ // Label 2426: @112503
     /* 112503 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(112529), // Rule ID 626 //
     /* 112508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 112511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 112514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 112518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 112522 */   // (sext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (MOVSX64rr32:{ *:[i64] } GR32:{ *:[i32] }:$src)
     /* 112522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVSX64rr32),
     /* 112527 */   GIR_RootConstrainSelectedInstOperands,
     /* 112528 */   // GIR_Coverage, 626,
     /* 112528 */   GIR_Done,
     /* 112529 */ // Label 2427: @112529
     /* 112529 */ GIM_Reject,
     /* 112530 */ // Label 2409: @112530
     /* 112530 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(112556), // Rule ID 12594 //
     /* 112535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 112541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 112549 */   // (sext:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)  =>  (VPMOVM2QZ128rk:{ *:[v2i64] } VK2:{ *:[v2i1] }:$src)
     /* 112549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ128rk),
     /* 112554 */   GIR_RootConstrainSelectedInstOperands,
     /* 112555 */   // GIR_Coverage, 12594,
     /* 112555 */   GIR_Done,
     /* 112556 */ // Label 2428: @112556
     /* 112556 */ GIM_Reject,
     /* 112557 */ // Label 2410: @112557
     /* 112557 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(112583), // Rule ID 12591 //
     /* 112562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112576 */   // (sext:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2DZ128rk:{ *:[v4i32] } VK4:{ *:[v4i1] }:$src)
     /* 112576 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ128rk),
     /* 112581 */   GIR_RootConstrainSelectedInstOperands,
     /* 112582 */   // GIR_Coverage, 12591,
     /* 112582 */   GIR_Done,
     /* 112583 */ // Label 2429: @112583
     /* 112583 */ GIM_Reject,
     /* 112584 */ // Label 2411: @112584
     /* 112584 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(112643), // Rule ID 18390 //
     /* 112589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112599 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112603 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112607 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112614 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112620 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112627 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrm),
     /* 112630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112632 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112636 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112641 */   GIR_RootConstrainSelectedInstOperands,
     /* 112642 */   // GIR_Coverage, 18390,
     /* 112642 */   GIR_EraseRootFromParent_Done,
     /* 112643 */ // Label 2430: @112643
     /* 112643 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(112702), // Rule ID 21585 //
     /* 112648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112666 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112673 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112677 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112679 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112686 */   // (sext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 112686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rm),
     /* 112689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112691 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112700 */   GIR_RootConstrainSelectedInstOperands,
     /* 112701 */   // GIR_Coverage, 21585,
     /* 112701 */   GIR_EraseRootFromParent_Done,
     /* 112702 */ // Label 2431: @112702
     /* 112702 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(112728), // Rule ID 12571 //
     /* 112707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112721 */   // (sext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 112721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZ256rr),
     /* 112726 */   GIR_RootConstrainSelectedInstOperands,
     /* 112727 */   // GIR_Coverage, 12571,
     /* 112727 */   GIR_Done,
     /* 112728 */ // Label 2432: @112728
     /* 112728 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(112754), // Rule ID 12593 //
     /* 112733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 112736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 112739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 112747 */   // (sext:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)  =>  (VPMOVM2QZ256rk:{ *:[v4i64] } VK4:{ *:[v4i1] }:$src)
     /* 112747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZ256rk),
     /* 112752 */   GIR_RootConstrainSelectedInstOperands,
     /* 112753 */   // GIR_Coverage, 12593,
     /* 112753 */   GIR_Done,
     /* 112754 */ // Label 2433: @112754
     /* 112754 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(112780), // Rule ID 18378 //
     /* 112759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 112773 */   // (sext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVSXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 112773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQYrr),
     /* 112778 */   GIR_RootConstrainSelectedInstOperands,
     /* 112779 */   // GIR_Coverage, 18378,
     /* 112779 */   GIR_Done,
     /* 112780 */ // Label 2434: @112780
     /* 112780 */ GIM_Reject,
     /* 112781 */ // Label 2412: @112781
     /* 112781 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(112849),
     /* 112786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 112789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 112797 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(112812), // Rule ID 12588 //
     /* 112802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 112805 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2WZ128rk:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)
     /* 112805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ128rk),
     /* 112810 */     GIR_RootConstrainSelectedInstOperands,
     /* 112811 */     // GIR_Coverage, 12588,
     /* 112811 */     GIR_Done,
     /* 112812 */   // Label 2436: @112812
     /* 112812 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(112848), // Rule ID 21661 //
     /* 112817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX_NoBWI),
     /* 112820 */     // (sext:{ *:[v8i16] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVDWZ256rr:{ *:[v8i16] } (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src))
     /* 112820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 112823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 112827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112832 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZ256rr),
     /* 112841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112846 */     GIR_RootConstrainSelectedInstOperands,
     /* 112847 */     // GIR_Coverage, 21661,
     /* 112847 */     GIR_EraseRootFromParent_Done,
     /* 112848 */   // Label 2437: @112848
     /* 112848 */   GIM_Reject,
     /* 112849 */ // Label 2435: @112849
     /* 112849 */ GIM_Reject,
     /* 112850 */ // Label 2413: @112850
     /* 112850 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(112909), // Rule ID 18386 //
     /* 112855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 112858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 112865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112880 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112886 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112893 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrm),
     /* 112896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112898 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112902 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112907 */   GIR_RootConstrainSelectedInstOperands,
     /* 112908 */   // GIR_Coverage, 18386,
     /* 112908 */   GIR_EraseRootFromParent_Done,
     /* 112909 */ // Label 2438: @112909
     /* 112909 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(112968), // Rule ID 21584 //
     /* 112914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 112917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112924 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112928 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 112932 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 112939 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 112943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112945 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 112952 */   // (sext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 112952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rm),
     /* 112955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112957 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 112961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112966 */   GIR_RootConstrainSelectedInstOperands,
     /* 112967 */   // GIR_Coverage, 21584,
     /* 112967 */   GIR_EraseRootFromParent_Done,
     /* 112968 */ // Label 2439: @112968
     /* 112968 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(112994), // Rule ID 12535 //
     /* 112973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 112976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 112983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 112987 */   // (sext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 112987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZ256rr),
     /* 112992 */   GIR_RootConstrainSelectedInstOperands,
     /* 112993 */   // GIR_Coverage, 12535,
     /* 112993 */   GIR_Done,
     /* 112994 */ // Label 2440: @112994
     /* 112994 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(113020), // Rule ID 12590 //
     /* 112999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 113002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113013 */   // (sext:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2DZ256rk:{ *:[v8i32] } VK8:{ *:[v8i1] }:$src)
     /* 113013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZ256rk),
     /* 113018 */   GIR_RootConstrainSelectedInstOperands,
     /* 113019 */   // GIR_Coverage, 12590,
     /* 113019 */   GIR_Done,
     /* 113020 */ // Label 2441: @113020
     /* 113020 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(113046), // Rule ID 18376 //
     /* 113025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 113028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113039 */   // (sext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVSXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 113039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDYrr),
     /* 113044 */   GIR_RootConstrainSelectedInstOperands,
     /* 113045 */   // GIR_Coverage, 18376,
     /* 113045 */   GIR_Done,
     /* 113046 */ // Label 2442: @113046
     /* 113046 */ GIM_Reject,
     /* 113047 */ // Label 2414: @113047
     /* 113047 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(113106), // Rule ID 21589 //
     /* 113052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113062 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113066 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113070 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113073 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113077 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113081 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113083 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113090 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrm),
     /* 113093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113095 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113104 */   GIR_RootConstrainSelectedInstOperands,
     /* 113105 */   // GIR_Coverage, 21589,
     /* 113105 */   GIR_EraseRootFromParent_Done,
     /* 113106 */ // Label 2443: @113106
     /* 113106 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(113165), // Rule ID 21590 //
     /* 113111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113129 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113136 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113140 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113142 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113149 */   // (sext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 113149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrm),
     /* 113152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113154 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113158 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113163 */   GIR_RootConstrainSelectedInstOperands,
     /* 113164 */   // GIR_Coverage, 21590,
     /* 113164 */   GIR_EraseRootFromParent_Done,
     /* 113165 */ // Label 2444: @113165
     /* 113165 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(113191), // Rule ID 12559 //
     /* 113170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113184 */   // (sext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVSXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 113184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWQZrr),
     /* 113189 */   GIR_RootConstrainSelectedInstOperands,
     /* 113190 */   // GIR_Coverage, 12559,
     /* 113190 */   GIR_Done,
     /* 113191 */ // Label 2445: @113191
     /* 113191 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(113217), // Rule ID 12577 //
     /* 113196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 113202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113210 */   // (sext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVSXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 113210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXDQZrr),
     /* 113215 */   GIR_RootConstrainSelectedInstOperands,
     /* 113216 */   // GIR_Coverage, 12577,
     /* 113216 */   GIR_Done,
     /* 113217 */ // Label 2446: @113217
     /* 113217 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(113243), // Rule ID 12592 //
     /* 113222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 113228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 113236 */   // (sext:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)  =>  (VPMOVM2QZrk:{ *:[v8i64] } VK8:{ *:[v8i1] }:$src)
     /* 113236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2QZrk),
     /* 113241 */   GIR_RootConstrainSelectedInstOperands,
     /* 113242 */   // GIR_Coverage, 12592,
     /* 113242 */   GIR_Done,
     /* 113243 */ // Label 2447: @113243
     /* 113243 */ GIM_Reject,
     /* 113244 */ // Label 2415: @113244
     /* 113244 */ GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(113312),
     /* 113249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113260 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(113275), // Rule ID 12585 //
     /* 113265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113268 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2BZ128rk:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)
     /* 113268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ128rk),
     /* 113273 */     GIR_RootConstrainSelectedInstOperands,
     /* 113274 */     // GIR_Coverage, 12585,
     /* 113274 */     GIR_Done,
     /* 113275 */   // Label 2449: @113275
     /* 113275 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(113311), // Rule ID 21659 //
     /* 113280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113283 */     // (sext:{ *:[v16i8] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDBZrr:{ *:[v16i8] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113295 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDBZrr),
     /* 113304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113309 */     GIR_RootConstrainSelectedInstOperands,
     /* 113310 */     // GIR_Coverage, 21659,
     /* 113310 */     GIR_EraseRootFromParent_Done,
     /* 113311 */   // Label 2450: @113311
     /* 113311 */   GIM_Reject,
     /* 113312 */ // Label 2448: @113312
     /* 113312 */ GIM_Reject,
     /* 113313 */ // Label 2416: @113313
     /* 113313 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(113372), // Rule ID 18380 //
     /* 113318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113328 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113332 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113336 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113339 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113343 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113349 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113356 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrm),
     /* 113359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113361 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113370 */   GIR_RootConstrainSelectedInstOperands,
     /* 113371 */   // GIR_Coverage, 18380,
     /* 113371 */   GIR_EraseRootFromParent_Done,
     /* 113372 */ // Label 2451: @113372
     /* 113372 */ GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(113431), // Rule ID 21583 //
     /* 113377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113387 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113391 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113395 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113402 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113408 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113415 */   // (sext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 113415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rm),
     /* 113418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113420 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113429 */   GIR_RootConstrainSelectedInstOperands,
     /* 113430 */   // GIR_Coverage, 21583,
     /* 113430 */   GIR_EraseRootFromParent_Done,
     /* 113431 */ // Label 2452: @113431
     /* 113431 */ GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(113457), // Rule ID 12481 //
     /* 113436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113450 */   // (sext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 113450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZ256rr),
     /* 113455 */   GIR_RootConstrainSelectedInstOperands,
     /* 113456 */   // GIR_Coverage, 12481,
     /* 113456 */   GIR_Done,
     /* 113457 */ // Label 2453: @113457
     /* 113457 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(113483), // Rule ID 12587 //
     /* 113462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113476 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2WZ256rk:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)
     /* 113476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZ256rk),
     /* 113481 */   GIR_RootConstrainSelectedInstOperands,
     /* 113482 */   // GIR_Coverage, 12587,
     /* 113482 */   GIR_Done,
     /* 113483 */ // Label 2454: @113483
     /* 113483 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(113509), // Rule ID 18373 //
     /* 113488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 113491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 113498 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 113502 */   // (sext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVSXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 113502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWYrr),
     /* 113507 */   GIR_RootConstrainSelectedInstOperands,
     /* 113508 */   // GIR_Coverage, 18373,
     /* 113508 */   GIR_Done,
     /* 113509 */ // Label 2455: @113509
     /* 113509 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(113556), // Rule ID 21660 //
     /* 113514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_NoBWI),
     /* 113517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113528 */   // (sext:{ *:[v16i16] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVDWZrr:{ *:[v16i16] } (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src))
     /* 113528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 113531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113540 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVDWZrr),
     /* 113549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113554 */   GIR_RootConstrainSelectedInstOperands,
     /* 113555 */   // GIR_Coverage, 21660,
     /* 113555 */   GIR_EraseRootFromParent_Done,
     /* 113556 */ // Label 2456: @113556
     /* 113556 */ GIM_Reject,
     /* 113557 */ // Label 2417: @113557
     /* 113557 */ GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(113616), // Rule ID 21587 //
     /* 113562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113580 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113587 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113593 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113600 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrm),
     /* 113603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113605 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113614 */   GIR_RootConstrainSelectedInstOperands,
     /* 113615 */   // GIR_Coverage, 21587,
     /* 113615 */   GIR_EraseRootFromParent_Done,
     /* 113616 */ // Label 2457: @113616
     /* 113616 */ GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(113675), // Rule ID 21588 //
     /* 113621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113639 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113646 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113650 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113652 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113659 */   // (sext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 113659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrm),
     /* 113662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113664 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113673 */   GIR_RootConstrainSelectedInstOperands,
     /* 113674 */   // GIR_Coverage, 21588,
     /* 113674 */   GIR_EraseRootFromParent_Done,
     /* 113675 */ // Label 2458: @113675
     /* 113675 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(113701), // Rule ID 12505 //
     /* 113680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 113694 */   // (sext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVSXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 113694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBDZrr),
     /* 113699 */   GIR_RootConstrainSelectedInstOperands,
     /* 113700 */   // GIR_Coverage, 12505,
     /* 113700 */   GIR_Done,
     /* 113701 */ // Label 2459: @113701
     /* 113701 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(113727), // Rule ID 12541 //
     /* 113706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 113709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 113712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113720 */   // (sext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVSXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 113720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXWDZrr),
     /* 113725 */   GIR_RootConstrainSelectedInstOperands,
     /* 113726 */   // GIR_Coverage, 12541,
     /* 113726 */   GIR_Done,
     /* 113727 */ // Label 2460: @113727
     /* 113727 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(113753), // Rule ID 12589 //
     /* 113732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 113735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 113738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 113746 */   // (sext:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)  =>  (VPMOVM2DZrk:{ *:[v16i32] } VK16:{ *:[v16i1] }:$src)
     /* 113746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2DZrk),
     /* 113751 */   GIR_RootConstrainSelectedInstOperands,
     /* 113752 */   // GIR_Coverage, 12589,
     /* 113752 */   GIR_Done,
     /* 113753 */ // Label 2461: @113753
     /* 113753 */ GIM_Reject,
     /* 113754 */ // Label 2418: @113754
     /* 113754 */ GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(113780), // Rule ID 12584 //
     /* 113759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 113762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113769 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113773 */   // (sext:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2BZ256rk:{ *:[v32i8] } VK32:{ *:[v32i1] }:$src)
     /* 113773 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZ256rk),
     /* 113778 */   GIR_RootConstrainSelectedInstOperands,
     /* 113779 */   // GIR_Coverage, 12584,
     /* 113779 */   GIR_Done,
     /* 113780 */ // Label 2462: @113780
     /* 113780 */ GIM_Reject,
     /* 113781 */ // Label 2419: @113781
     /* 113781 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(113840), // Rule ID 21586 //
     /* 113786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 113804 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113807 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 113811 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 113815 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113817 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 113824 */   // (sext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVSXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 113824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrm),
     /* 113827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113829 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 113833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113838 */   GIR_RootConstrainSelectedInstOperands,
     /* 113839 */   // GIR_Coverage, 21586,
     /* 113839 */   GIR_EraseRootFromParent_Done,
     /* 113840 */ // Label 2463: @113840
     /* 113840 */ GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(113866), // Rule ID 12487 //
     /* 113845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 113851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 113859 */   // (sext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVSXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 113859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVSXBWZrr),
     /* 113864 */   GIR_RootConstrainSelectedInstOperands,
     /* 113865 */   // GIR_Coverage, 12487,
     /* 113865 */   GIR_Done,
     /* 113866 */ // Label 2464: @113866
     /* 113866 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(113892), // Rule ID 12586 //
     /* 113871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 113877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 113885 */   // (sext:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)  =>  (VPMOVM2WZrk:{ *:[v32i16] } VK32:{ *:[v32i1] }:$src)
     /* 113885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2WZrk),
     /* 113890 */   GIR_RootConstrainSelectedInstOperands,
     /* 113891 */   // GIR_Coverage, 12586,
     /* 113891 */   GIR_Done,
     /* 113892 */ // Label 2465: @113892
     /* 113892 */ GIM_Reject,
     /* 113893 */ // Label 2420: @113893
     /* 113893 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(113919), // Rule ID 12583 //
     /* 113898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 113901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 113904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 113908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 113912 */   // (sext:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)  =>  (VPMOVM2BZrk:{ *:[v64i8] } VK64:{ *:[v64i1] }:$src)
     /* 113912 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVM2BZrk),
     /* 113917 */   GIR_RootConstrainSelectedInstOperands,
     /* 113918 */   // GIR_Coverage, 12583,
     /* 113918 */   GIR_Done,
     /* 113919 */ // Label 2466: @113919
     /* 113919 */ GIM_Reject,
     /* 113920 */ // Label 2421: @113920
     /* 113920 */ GIM_Reject,
     /* 113921 */ // Label 24: @113921
     /* 113921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2469*/ GIMT_Encode4(114162),
     /* 113932 */ /*GILLT_s16*//*Label 2467*/ GIMT_Encode4(113940),
     /* 113936 */ /*GILLT_s32*//*Label 2468*/ GIMT_Encode4(114036),
     /* 113940 */ // Label 2467: @113940
     /* 113940 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(114035), // Rule ID 22643 //
     /* 113945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 113956 */   // MIs[0] Operand 2
     /* 113956 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 113967 */   // (sext_inreg:{ *:[i16] } GR16:{ *:[i16] }:$src, i8:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR16:{ *:[i16] }:$src, sub_8bit:{ *:[i32] })), sub_16bit:{ *:[i32] })
     /* 113967 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 113970 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113974 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113979 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 113985 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 113990 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::GR16RegClassID),
     /* 113995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 114002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114007 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114017 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114034 */   // GIR_Coverage, 22643,
     /* 114034 */   GIR_EraseRootFromParent_Done,
     /* 114035 */ // Label 2470: @114035
     /* 114035 */ GIM_Reject,
     /* 114036 */ // Label 2468: @114036
     /* 114036 */ GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(114161),
     /* 114041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114052 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(114106), // Rule ID 22641 //
     /* 114057 */     // MIs[0] Operand 2
     /* 114057 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 114068 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX32rr16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i16] } GR32:{ *:[i32] }:$src, sub_16bit:{ *:[i32] }))
     /* 114068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114080 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(4), // src
     /* 114086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr16),
     /* 114099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114104 */     GIR_RootConstrainSelectedInstOperands,
     /* 114105 */     // GIR_Coverage, 22641,
     /* 114105 */     GIR_EraseRootFromParent_Done,
     /* 114106 */   // Label 2472: @114106
     /* 114106 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(114160), // Rule ID 22642 //
     /* 114111 */     // MIs[0] Operand 2
     /* 114111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 114122 */     // (sext_inreg:{ *:[i32] } GR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX32rr8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i8] } GR32:{ *:[i32] }:$src, sub_8bit:{ *:[i32] }))
     /* 114122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 114125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114134 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 114140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR8RegClassID),
     /* 114145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVSX32rr8),
     /* 114153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114158 */     GIR_RootConstrainSelectedInstOperands,
     /* 114159 */     // GIR_Coverage, 22642,
     /* 114159 */     GIR_EraseRootFromParent_Done,
     /* 114160 */   // Label 2473: @114160
     /* 114160 */   GIM_Reject,
     /* 114161 */ // Label 2471: @114161
     /* 114161 */ GIM_Reject,
     /* 114162 */ // Label 2469: @114162
     /* 114162 */ GIM_Reject,
     /* 114163 */ // Label 25: @114163
     /* 114163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 2483*/ GIMT_Encode4(116146),
     /* 114174 */ /*GILLT_s16*//*Label 2474*/ GIMT_Encode4(114258),
     /* 114178 */ /*GILLT_s32*//*Label 2475*/ GIMT_Encode4(114316),
     /* 114182 */ /*GILLT_s64*//*Label 2476*/ GIMT_Encode4(114668), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114210 */ /*GILLT_v4s64*//*Label 2477*/ GIMT_Encode4(115215), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114222 */ /*GILLT_v8s32*//*Label 2478*/ GIMT_Encode4(115383),
     /* 114226 */ /*GILLT_v8s64*//*Label 2479*/ GIMT_Encode4(115551), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114238 */ /*GILLT_v16s16*//*Label 2480*/ GIMT_Encode4(115722),
     /* 114242 */ /*GILLT_v16s32*//*Label 2481*/ GIMT_Encode4(115890), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114254 */ /*GILLT_v32s16*//*Label 2482*/ GIMT_Encode4(116061),
     /* 114258 */ // Label 2474: @114258
     /* 114258 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(114315), // Rule ID 22649 //
     /* 114263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114274 */   // (zext:{ *:[i16] } GR8:{ *:[i8] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i16] } (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_16bit:{ *:[i32] })
     /* 114274 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114277 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114281 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114286 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114297 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_16bit),
     /* 114304 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR16RegClassID),
     /* 114309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::GR32RegClassID),
     /* 114314 */   // GIR_Coverage, 22649,
     /* 114314 */   GIR_EraseRootFromParent_Done,
     /* 114315 */ // Label 2484: @114315
     /* 114315 */ GIM_Reject,
     /* 114316 */ // Label 2475: @114316
     /* 114316 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(114439), // Rule ID 22973 //
     /* 114321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114339 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114343 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114347 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114351 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114355 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114358 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114362 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114366 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114370 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114374 */   // MIs[3] Operand 1
     /* 114374 */   // No operand predicates
     /* 114374 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114376 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114383 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114383 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114386 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114390 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114395 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114399 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114402 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114405 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114422 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114438 */   // GIR_Coverage, 22973,
     /* 114438 */   GIR_EraseRootFromParent_Done,
     /* 114439 */ // Label 2485: @114439
     /* 114439 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(114534), // Rule ID 22972 //
     /* 114444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114462 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114470 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114475 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114479 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114483 */   // MIs[2] Operand 1
     /* 114483 */   // No operand predicates
     /* 114483 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114485 */   // (zext:{ *:[i32] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i32] } 0:{ *:[i32] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114497 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114504 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114517 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114523 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBPRegClassID),
     /* 114528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114533 */   // GIR_Coverage, 22972,
     /* 114533 */   GIR_EraseRootFromParent_Done,
     /* 114534 */ // Label 2486: @114534
     /* 114534 */ GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(114576), // Rule ID 19435 //
     /* 114539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114546 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114554 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114558 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114565 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src)
     /* 114565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114570 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114574 */   GIR_RootConstrainSelectedInstOperands,
     /* 114575 */   // GIR_Coverage, 19435,
     /* 114575 */   GIR_EraseRootFromParent_Done,
     /* 114576 */ // Label 2487: @114576
     /* 114576 */ GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(114621), // Rule ID 19438 //
     /* 114581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114591 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114595 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114599 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114603 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114608 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114610 */   // (zext:{ *:[i32] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src)
     /* 114610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 114613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114615 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114619 */   GIR_RootConstrainSelectedInstOperands,
     /* 114620 */   // GIR_Coverage, 19438,
     /* 114620 */   GIR_EraseRootFromParent_Done,
     /* 114621 */ // Label 2488: @114621
     /* 114621 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(114644), // Rule ID 618 //
     /* 114626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 114637 */   // (zext:{ *:[i32] } GR8:{ *:[i8] }:$src)  =>  (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src)
     /* 114637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 114642 */   GIR_RootConstrainSelectedInstOperands,
     /* 114643 */   // GIR_Coverage, 618,
     /* 114643 */   GIR_Done,
     /* 114644 */ // Label 2489: @114644
     /* 114644 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(114667), // Rule ID 620 //
     /* 114649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 114656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114660 */   // (zext:{ *:[i32] } GR16:{ *:[i16] }:$src)  =>  (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src)
     /* 114660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 114665 */   GIR_RootConstrainSelectedInstOperands,
     /* 114666 */   // GIR_Coverage, 620,
     /* 114666 */   GIR_Done,
     /* 114667 */ // Label 2490: @114667
     /* 114667 */ GIM_Reject,
     /* 114668 */ // Label 2476: @114668
     /* 114668 */ GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(114791), // Rule ID 22975 //
     /* 114673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114683 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114687 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114691 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114695 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114699 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114703 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 114707 */   GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114710 */   GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 114714 */   GIM_CheckCxxInsnPredicate, /*MI*/2, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 114718 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 114722 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114726 */   // MIs[3] Operand 1
     /* 114726 */   // No operand predicates
     /* 114726 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 114728 */   GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 114735 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rmi:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rmi),
     /* 114742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114747 */   GIR_ComplexRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), // src1
     /* 114751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // src2
     /* 114754 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114757 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 114764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114774 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114790 */   // GIR_Coverage, 22975,
     /* 114790 */   GIR_EraseRootFromParent_Done,
     /* 114791 */ // Label 2491: @114791
     /* 114791 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(114886), // Rule ID 22974 //
     /* 114796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasZU),
     /* 114799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114806 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114810 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 114814 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 114818 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 114822 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 114827 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114831 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 114835 */   // MIs[2] Operand 1
     /* 114835 */   // No operand predicates
     /* 114835 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114837 */   // (zext:{ *:[i64] } (mul:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (IMULZU16rri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i16] }):$src2), sub_16bit:{ *:[i32] })
     /* 114837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::IMULZU16rri),
     /* 114844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114849 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 114853 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // src2
     /* 114856 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for X86::EFLAGS*/0,
     /* 114859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 114875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR16RegClassID),
     /* 114885 */   // GIR_Coverage, 22974,
     /* 114885 */   GIR_EraseRootFromParent_Done,
     /* 114886 */ // Label 2492: @114886
     /* 114886 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(114960), // Rule ID 19436 //
     /* 114891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114898 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114902 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114906 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 114910 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 114915 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114917 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i16] } VK16:{ *:[v16i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVWrk:{ *:[i32] } VK16:{ *:[v16i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114917 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114920 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVWrk),
     /* 114924 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114929 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 114933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 114938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114943 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 114949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 114954 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 114959 */   // GIR_Coverage, 19436,
     /* 114959 */   GIR_EraseRootFromParent_Done,
     /* 114960 */ // Label 2493: @114960
     /* 114960 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(115037), // Rule ID 19439 //
     /* 114965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 114968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 114971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 114975 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114979 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 114983 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 114987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 114992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114994 */   // (zext:{ *:[i64] } (bitconvert:{ *:[i8] } VK8:{ *:[v8i1] }:$src))  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (KMOVBrk:{ *:[i32] } VK8:{ *:[v8i1] }:$src), sub_32bit:{ *:[i32] })
     /* 114994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KMOVBrk),
     /* 115001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115006 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 115010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115031 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115036 */   // GIR_Coverage, 19439,
     /* 115036 */   GIR_EraseRootFromParent_Done,
     /* 115037 */ // Label 2494: @115037
     /* 115037 */ GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(115096), // Rule ID 17590 //
     /* 115042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 115045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 115053 */   // (zext:{ *:[i64] } GR8:{ *:[i8] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr8:{ *:[i32] } GR8:{ *:[i8] }:$src), sub_32bit:{ *:[i32] })
     /* 115053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr8),
     /* 115060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115095 */   // GIR_Coverage, 17590,
     /* 115095 */   GIR_EraseRootFromParent_Done,
     /* 115096 */ // Label 2495: @115096
     /* 115096 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(115155), // Rule ID 17592 //
     /* 115101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 115112 */   // (zext:{ *:[i64] } GR16:{ *:[i16] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVZX32rr16:{ *:[i32] } GR16:{ *:[i16] }:$src), sub_32bit:{ *:[i32] })
     /* 115112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOVZX32rr16),
     /* 115119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115124 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115144 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115154 */   // GIR_Coverage, 17592,
     /* 115154 */   GIR_EraseRootFromParent_Done,
     /* 115155 */ // Label 2496: @115155
     /* 115155 */ GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(115214), // Rule ID 17594 //
     /* 115160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 115167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 115171 */   // (zext:{ *:[i64] } GR32:{ *:[i32] }:$src)  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOV32rr:{ *:[i32] } GR32:{ *:[i32] }:$src), sub_32bit:{ *:[i32] })
     /* 115171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::MOV32rr),
     /* 115178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115183 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 115187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 115197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 115203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::GR64RegClassID),
     /* 115208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(X86::GR32RegClassID),
     /* 115213 */   // GIR_Coverage, 17594,
     /* 115213 */   GIR_EraseRootFromParent_Done,
     /* 115214 */ // Label 2497: @115214
     /* 115214 */ GIM_Reject,
     /* 115215 */ // Label 2477: @115215
     /* 115215 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(115382),
     /* 115220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115223 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(115279), // Rule ID 18413 //
     /* 115228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115263 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQYrm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrm),
     /* 115266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115268 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115277 */     GIR_RootConstrainSelectedInstOperands,
     /* 115278 */     // GIR_Coverage, 18413,
     /* 115278 */     GIR_EraseRootFromParent_Done,
     /* 115279 */   // Label 2499: @115279
     /* 115279 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(115335), // Rule ID 21618 //
     /* 115284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115319 */     // (zext:{ *:[v4i64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)
     /* 115319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rm),
     /* 115322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115324 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115333 */     GIR_RootConstrainSelectedInstOperands,
     /* 115334 */     // GIR_Coverage, 21618,
     /* 115334 */     GIR_EraseRootFromParent_Done,
     /* 115335 */   // Label 2500: @115335
     /* 115335 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(115358), // Rule ID 12463 //
     /* 115340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115351 */     // (zext:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQZ256rr:{ *:[v4i64] } VR128X:{ *:[v4i32] }:$src)
     /* 115351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZ256rr),
     /* 115356 */     GIR_RootConstrainSelectedInstOperands,
     /* 115357 */     // GIR_Coverage, 12463,
     /* 115357 */     GIR_Done,
     /* 115358 */   // Label 2501: @115358
     /* 115358 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(115381), // Rule ID 18401 //
     /* 115363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115374 */     // (zext:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)  =>  (VPMOVZXDQYrr:{ *:[v4i64] } VR128:{ *:[v4i32] }:$src)
     /* 115374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQYrr),
     /* 115379 */     GIR_RootConstrainSelectedInstOperands,
     /* 115380 */     // GIR_Coverage, 18401,
     /* 115380 */     GIR_Done,
     /* 115381 */   // Label 2502: @115381
     /* 115381 */   GIM_Reject,
     /* 115382 */ // Label 2498: @115382
     /* 115382 */ GIM_Reject,
     /* 115383 */ // Label 2478: @115383
     /* 115383 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(115550),
     /* 115388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115391 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(115447), // Rule ID 18409 //
     /* 115396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115431 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrm),
     /* 115434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115436 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115445 */     GIR_RootConstrainSelectedInstOperands,
     /* 115446 */     // GIR_Coverage, 18409,
     /* 115446 */     GIR_EraseRootFromParent_Done,
     /* 115447 */   // Label 2504: @115447
     /* 115447 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(115503), // Rule ID 21617 //
     /* 115452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 115455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115467 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115470 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115474 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115480 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115487 */     // (zext:{ *:[v8i32] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 115487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rm),
     /* 115490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115501 */     GIR_RootConstrainSelectedInstOperands,
     /* 115502 */     // GIR_Coverage, 21617,
     /* 115502 */     GIR_EraseRootFromParent_Done,
     /* 115503 */   // Label 2505: @115503
     /* 115503 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(115526), // Rule ID 12427 //
     /* 115508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 115511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115519 */     // (zext:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDZ256rr:{ *:[v8i32] } VR128X:{ *:[v8i16] }:$src)
     /* 115519 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZ256rr),
     /* 115524 */     GIR_RootConstrainSelectedInstOperands,
     /* 115525 */     // GIR_Coverage, 12427,
     /* 115525 */     GIR_Done,
     /* 115526 */   // Label 2506: @115526
     /* 115526 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(115549), // Rule ID 18399 //
     /* 115531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 115534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115542 */     // (zext:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)  =>  (VPMOVZXWDYrr:{ *:[v8i32] } VR128:{ *:[v8i16] }:$src)
     /* 115542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDYrr),
     /* 115547 */     GIR_RootConstrainSelectedInstOperands,
     /* 115548 */     // GIR_Coverage, 18399,
     /* 115548 */     GIR_Done,
     /* 115549 */   // Label 2507: @115549
     /* 115549 */   GIM_Reject,
     /* 115550 */ // Label 2503: @115550
     /* 115550 */ GIM_Reject,
     /* 115551 */ // Label 2479: @115551
     /* 115551 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(115610), // Rule ID 21622 //
     /* 115556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115574 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115581 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115587 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115594 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrm),
     /* 115597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115599 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115608 */   GIR_RootConstrainSelectedInstOperands,
     /* 115609 */   // GIR_Coverage, 21622,
     /* 115609 */   GIR_EraseRootFromParent_Done,
     /* 115610 */ // Label 2508: @115610
     /* 115610 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(115669), // Rule ID 21623 //
     /* 115615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115633 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115640 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115646 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115653 */   // (zext:{ *:[v8i64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXDQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)
     /* 115653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrm),
     /* 115656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115667 */   GIR_RootConstrainSelectedInstOperands,
     /* 115668 */   // GIR_Coverage, 21623,
     /* 115668 */   GIR_EraseRootFromParent_Done,
     /* 115669 */ // Label 2509: @115669
     /* 115669 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(115695), // Rule ID 12451 //
     /* 115674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115688 */   // (zext:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)  =>  (VPMOVZXWQZrr:{ *:[v8i64] } VR128X:{ *:[v8i16] }:$src)
     /* 115688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWQZrr),
     /* 115693 */   GIR_RootConstrainSelectedInstOperands,
     /* 115694 */   // GIR_Coverage, 12451,
     /* 115694 */   GIR_Done,
     /* 115695 */ // Label 2510: @115695
     /* 115695 */ GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(115721), // Rule ID 12469 //
     /* 115700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 115706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115714 */   // (zext:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)  =>  (VPMOVZXDQZrr:{ *:[v8i64] } VR256X:{ *:[v8i32] }:$src)
     /* 115714 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXDQZrr),
     /* 115719 */   GIR_RootConstrainSelectedInstOperands,
     /* 115720 */   // GIR_Coverage, 12469,
     /* 115720 */   GIR_Done,
     /* 115721 */ // Label 2511: @115721
     /* 115721 */ GIM_Reject,
     /* 115722 */ // Label 2480: @115722
     /* 115722 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(115889),
     /* 115727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115730 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(115786), // Rule ID 18403 //
     /* 115735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115750 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115753 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115757 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115770 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrm),
     /* 115773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115784 */     GIR_RootConstrainSelectedInstOperands,
     /* 115785 */     // GIR_Coverage, 18403,
     /* 115785 */     GIR_EraseRootFromParent_Done,
     /* 115786 */   // Label 2513: @115786
     /* 115786 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(115842), // Rule ID 21616 //
     /* 115791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115826 */     // (zext:{ *:[v16i16] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 115826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rm),
     /* 115829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115840 */     GIR_RootConstrainSelectedInstOperands,
     /* 115841 */     // GIR_Coverage, 21616,
     /* 115841 */     GIR_EraseRootFromParent_Done,
     /* 115842 */   // Label 2514: @115842
     /* 115842 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(115865), // Rule ID 12373 //
     /* 115847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 115850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 115854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 115858 */     // (zext:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWZ256rr:{ *:[v16i16] } VR128X:{ *:[v16i8] }:$src)
     /* 115858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZ256rr),
     /* 115863 */     GIR_RootConstrainSelectedInstOperands,
     /* 115864 */     // GIR_Coverage, 12373,
     /* 115864 */     GIR_Done,
     /* 115865 */   // Label 2515: @115865
     /* 115865 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(115888), // Rule ID 18396 //
     /* 115870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 115873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 115877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 115881 */     // (zext:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)  =>  (VPMOVZXBWYrr:{ *:[v16i16] } VR128:{ *:[v16i8] }:$src)
     /* 115881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWYrr),
     /* 115886 */     GIR_RootConstrainSelectedInstOperands,
     /* 115887 */     // GIR_Coverage, 18396,
     /* 115887 */     GIR_Done,
     /* 115888 */   // Label 2516: @115888
     /* 115888 */   GIM_Reject,
     /* 115889 */ // Label 2512: @115889
     /* 115889 */ GIM_Reject,
     /* 115890 */ // Label 2481: @115890
     /* 115890 */ GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(115949), // Rule ID 21620 //
     /* 115895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115913 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115916 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115920 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115926 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115933 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrm),
     /* 115936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115938 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 115942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115947 */   GIR_RootConstrainSelectedInstOperands,
     /* 115948 */   // GIR_Coverage, 21620,
     /* 115948 */   GIR_EraseRootFromParent_Done,
     /* 115949 */ // Label 2517: @115949
     /* 115949 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(116008), // Rule ID 21621 //
     /* 115954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 115957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 115960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 115964 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115968 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 115972 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115975 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 115979 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 115983 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115985 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 115992 */   // (zext:{ *:[v16i32] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXWDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)
     /* 115992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrm),
     /* 115995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115997 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 116001 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116006 */   GIR_RootConstrainSelectedInstOperands,
     /* 116007 */   // GIR_Coverage, 21621,
     /* 116007 */   GIR_EraseRootFromParent_Done,
     /* 116008 */ // Label 2518: @116008
     /* 116008 */ GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(116034), // Rule ID 12397 //
     /* 116013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 116016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 116019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 116027 */   // (zext:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)  =>  (VPMOVZXBDZrr:{ *:[v16i32] } VR128X:{ *:[v16i8] }:$src)
     /* 116027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBDZrr),
     /* 116032 */   GIR_RootConstrainSelectedInstOperands,
     /* 116033 */   // GIR_Coverage, 12397,
     /* 116033 */   GIR_Done,
     /* 116034 */ // Label 2519: @116034
     /* 116034 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(116060), // Rule ID 12433 //
     /* 116039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 116042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 116045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116053 */   // (zext:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)  =>  (VPMOVZXWDZrr:{ *:[v16i32] } VR256X:{ *:[v16i16] }:$src)
     /* 116053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXWDZrr),
     /* 116058 */   GIR_RootConstrainSelectedInstOperands,
     /* 116059 */   // GIR_Coverage, 12433,
     /* 116059 */   GIR_Done,
     /* 116060 */ // Label 2520: @116060
     /* 116060 */ GIM_Reject,
     /* 116061 */ // Label 2482: @116061
     /* 116061 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(116145),
     /* 116066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 116069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 116073 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(116125), // Rule ID 21619 //
     /* 116078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116089 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116092 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 116096 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116102 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116109 */     // (zext:{ *:[v32i16] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMOVZXBWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)
     /* 116109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrm),
     /* 116112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116114 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 116118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116123 */     GIR_RootConstrainSelectedInstOperands,
     /* 116124 */     // GIR_Coverage, 21619,
     /* 116124 */     GIR_EraseRootFromParent_Done,
     /* 116125 */   // Label 2522: @116125
     /* 116125 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(116144), // Rule ID 12379 //
     /* 116130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 116133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 116137 */     // (zext:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)  =>  (VPMOVZXBWZrr:{ *:[v32i16] } VR256X:{ *:[v32i8] }:$src)
     /* 116137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMOVZXBWZrr),
     /* 116142 */     GIR_RootConstrainSelectedInstOperands,
     /* 116143 */     // GIR_Coverage, 12379,
     /* 116143 */     GIR_Done,
     /* 116144 */   // Label 2523: @116144
     /* 116144 */   GIM_Reject,
     /* 116145 */ // Label 2521: @116145
     /* 116145 */ GIM_Reject,
     /* 116146 */ // Label 2483: @116146
     /* 116146 */ GIM_Reject,
     /* 116147 */ // Label 26: @116147
     /* 116147 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2528*/ GIMT_Encode4(118430),
     /* 116158 */ /*GILLT_s8*//*Label 2524*/ GIMT_Encode4(116174),
     /* 116162 */ /*GILLT_s16*//*Label 2525*/ GIMT_Encode4(116549),
     /* 116166 */ /*GILLT_s32*//*Label 2526*/ GIMT_Encode4(116924),
     /* 116170 */ /*GILLT_s64*//*Label 2527*/ GIMT_Encode4(117677),
     /* 116174 */ // Label 2524: @116174
     /* 116174 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(116548),
     /* 116179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 116182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116189 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(116256), // Rule ID 673 //
     /* 116194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116212 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116224 */     // MIs[2] Operand 1
     /* 116224 */     // No operand predicates
     /* 116224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116233 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mi_ND),
     /* 116236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116238 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116254 */     GIR_RootConstrainSelectedInstOperands,
     /* 116255 */     // GIR_Coverage, 673,
     /* 116255 */     GIR_EraseRootFromParent_Done,
     /* 116256 */   // Label 2530: @116256
     /* 116256 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(116329), // Rule ID 689 //
     /* 116261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116272 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116279 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 116283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116289 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116296 */     // (shl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116300 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116306 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8mCL_ND),
     /* 116313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116327 */     GIR_RootConstrainSelectedInstOperands,
     /* 116328 */     // GIR_Coverage, 689,
     /* 116328 */     GIR_EraseRootFromParent_Done,
     /* 116329 */   // Label 2531: @116329
     /* 116329 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(116359), // Rule ID 22674 //
     /* 116334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116345 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr),
     /* 116348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116357 */     GIR_RootConstrainSelectedInstOperands,
     /* 116358 */     // GIR_Coverage, 22674,
     /* 116358 */     GIR_EraseRootFromParent_Done,
     /* 116359 */   // Label 2532: @116359
     /* 116359 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(116389), // Rule ID 22678 //
     /* 116364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116371 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116375 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 1:{ *:[i8] })  =>  (ADD8rr_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, GR8:{ *:[i8] }:$src1)
     /* 116375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD8rr_ND),
     /* 116378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116380 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116382 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116387 */     GIR_RootConstrainSelectedInstOperands,
     /* 116388 */     // GIR_Coverage, 22678,
     /* 116388 */     GIR_EraseRootFromParent_Done,
     /* 116389 */   // Label 2533: @116389
     /* 116389 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(116426), // Rule ID 661 //
     /* 116394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116409 */     // MIs[1] Operand 1
     /* 116409 */     // No operand predicates
     /* 116409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116411 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri),
     /* 116414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116416 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116424 */     GIR_RootConstrainSelectedInstOperands,
     /* 116425 */     // GIR_Coverage, 661,
     /* 116425 */     GIR_EraseRootFromParent_Done,
     /* 116426 */   // Label 2534: @116426
     /* 116426 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(116463), // Rule ID 665 //
     /* 116431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116446 */     // MIs[1] Operand 1
     /* 116446 */     // No operand predicates
     /* 116446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116448 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8ri_ND),
     /* 116451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116453 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116461 */     GIR_RootConstrainSelectedInstOperands,
     /* 116462 */     // GIR_Coverage, 665,
     /* 116462 */     GIR_EraseRootFromParent_Done,
     /* 116463 */   // Label 2535: @116463
     /* 116463 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(116505), // Rule ID 677 //
     /* 116468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116479 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116483 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116489 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL),
     /* 116496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116503 */     GIR_RootConstrainSelectedInstOperands,
     /* 116504 */     // GIR_Coverage, 677,
     /* 116504 */     GIR_EraseRootFromParent_Done,
     /* 116505 */   // Label 2536: @116505
     /* 116505 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(116547), // Rule ID 681 //
     /* 116510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 116517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116521 */     // (shl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 116521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116525 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116531 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL8rCL_ND),
     /* 116538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116545 */     GIR_RootConstrainSelectedInstOperands,
     /* 116546 */     // GIR_Coverage, 681,
     /* 116546 */     GIR_EraseRootFromParent_Done,
     /* 116547 */   // Label 2537: @116547
     /* 116547 */   GIM_Reject,
     /* 116548 */ // Label 2529: @116548
     /* 116548 */ GIM_Reject,
     /* 116549 */ // Label 2525: @116549
     /* 116549 */ GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(116923),
     /* 116554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116564 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(116631), // Rule ID 674 //
     /* 116569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116587 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116599 */     // MIs[2] Operand 1
     /* 116599 */     // No operand predicates
     /* 116599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116608 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mi_ND),
     /* 116611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116629 */     GIR_RootConstrainSelectedInstOperands,
     /* 116630 */     // GIR_Coverage, 674,
     /* 116630 */     GIR_EraseRootFromParent_Done,
     /* 116631 */   // Label 2539: @116631
     /* 116631 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(116704), // Rule ID 690 //
     /* 116636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116647 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116654 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 116658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116664 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116671 */     // (shl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 116671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116675 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16mCL_ND),
     /* 116688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116690 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116702 */     GIR_RootConstrainSelectedInstOperands,
     /* 116703 */     // GIR_Coverage, 690,
     /* 116703 */     GIR_EraseRootFromParent_Done,
     /* 116704 */   // Label 2540: @116704
     /* 116704 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(116734), // Rule ID 22675 //
     /* 116709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116720 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr),
     /* 116723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116725 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116727 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116732 */     GIR_RootConstrainSelectedInstOperands,
     /* 116733 */     // GIR_Coverage, 22675,
     /* 116733 */     GIR_EraseRootFromParent_Done,
     /* 116734 */   // Label 2541: @116734
     /* 116734 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(116764), // Rule ID 22679 //
     /* 116739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 116742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 116750 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 1:{ *:[i8] })  =>  (ADD16rr_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, GR16:{ *:[i16] }:$src1)
     /* 116750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD16rr_ND),
     /* 116753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116757 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116762 */     GIR_RootConstrainSelectedInstOperands,
     /* 116763 */     // GIR_Coverage, 22679,
     /* 116763 */     GIR_EraseRootFromParent_Done,
     /* 116764 */   // Label 2542: @116764
     /* 116764 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(116801), // Rule ID 662 //
     /* 116769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116784 */     // MIs[1] Operand 1
     /* 116784 */     // No operand predicates
     /* 116784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116786 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri),
     /* 116789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116796 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116799 */     GIR_RootConstrainSelectedInstOperands,
     /* 116800 */     // GIR_Coverage, 662,
     /* 116800 */     GIR_EraseRootFromParent_Done,
     /* 116801 */   // Label 2543: @116801
     /* 116801 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(116838), // Rule ID 666 //
     /* 116806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 116817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116821 */     // MIs[1] Operand 1
     /* 116821 */     // No operand predicates
     /* 116821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116823 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16ri_ND),
     /* 116826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 116833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116836 */     GIR_RootConstrainSelectedInstOperands,
     /* 116837 */     // GIR_Coverage, 666,
     /* 116837 */     GIR_EraseRootFromParent_Done,
     /* 116838 */   // Label 2544: @116838
     /* 116838 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(116880), // Rule ID 678 //
     /* 116843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 116846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116854 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL),
     /* 116871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116878 */     GIR_RootConstrainSelectedInstOperands,
     /* 116879 */     // GIR_Coverage, 678,
     /* 116879 */     GIR_EraseRootFromParent_Done,
     /* 116880 */   // Label 2545: @116880
     /* 116880 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(116922), // Rule ID 682 //
     /* 116885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 116892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 116896 */     // (shl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 116896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116900 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 116910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL16rCL_ND),
     /* 116913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 116917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116920 */     GIR_RootConstrainSelectedInstOperands,
     /* 116921 */     // GIR_Coverage, 682,
     /* 116921 */     GIR_EraseRootFromParent_Done,
     /* 116922 */   // Label 2546: @116922
     /* 116922 */   GIM_Reject,
     /* 116923 */ // Label 2538: @116923
     /* 116923 */ GIM_Reject,
     /* 116924 */ // Label 2526: @116924
     /* 116924 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(117676),
     /* 116929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 116935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 116939 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(117006), // Rule ID 675 //
     /* 116944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 116947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 116955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116958 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 116962 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 116966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 116970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116974 */     // MIs[2] Operand 1
     /* 116974 */     // No operand predicates
     /* 116974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 116983 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 116983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mi_ND),
     /* 116986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116988 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 116992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 116995 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 116998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117004 */     GIR_RootConstrainSelectedInstOperands,
     /* 117005 */     // GIR_Coverage, 675,
     /* 117005 */     GIR_EraseRootFromParent_Done,
     /* 117006 */   // Label 2548: @117006
     /* 117006 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(117079), // Rule ID 691 //
     /* 117011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117029 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117046 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117050 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117056 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32mCL_ND),
     /* 117063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117065 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117069 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117077 */     GIR_RootConstrainSelectedInstOperands,
     /* 117078 */     // GIR_Coverage, 691,
     /* 117078 */     GIR_EraseRootFromParent_Done,
     /* 117079 */   // Label 2549: @117079
     /* 117079 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(117189), // Rule ID 17672 //
     /* 117084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117102 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117119 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117119 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117122 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117126 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm),
     /* 117173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117187 */     GIR_RootConstrainSelectedInstOperands,
     /* 117188 */     // GIR_Coverage, 17672,
     /* 117188 */     GIR_EraseRootFromParent_Done,
     /* 117189 */   // Label 2550: @117189
     /* 117189 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(117299), // Rule ID 17704 //
     /* 117194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117205 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117208 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117212 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 117216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117222 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117229 */     // (shl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rm_EVEX),
     /* 117283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117285 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117297 */     GIR_RootConstrainSelectedInstOperands,
     /* 117298 */     // GIR_Coverage, 17704,
     /* 117298 */     GIR_EraseRootFromParent_Done,
     /* 117299 */   // Label 2551: @117299
     /* 117299 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(117329), // Rule ID 22676 //
     /* 117304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117315 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr),
     /* 117318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117327 */     GIR_RootConstrainSelectedInstOperands,
     /* 117328 */     // GIR_Coverage, 22676,
     /* 117328 */     GIR_EraseRootFromParent_Done,
     /* 117329 */   // Label 2552: @117329
     /* 117329 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(117359), // Rule ID 22680 //
     /* 117334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 117337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 117345 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 1:{ *:[i8] })  =>  (ADD32rr_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src1)
     /* 117345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD32rr_ND),
     /* 117348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117352 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117357 */     GIR_RootConstrainSelectedInstOperands,
     /* 117358 */     // GIR_Coverage, 22680,
     /* 117358 */     GIR_EraseRootFromParent_Done,
     /* 117359 */   // Label 2553: @117359
     /* 117359 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(117396), // Rule ID 663 //
     /* 117364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117379 */     // MIs[1] Operand 1
     /* 117379 */     // No operand predicates
     /* 117379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117381 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri),
     /* 117384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117394 */     GIR_RootConstrainSelectedInstOperands,
     /* 117395 */     // GIR_Coverage, 663,
     /* 117395 */     GIR_EraseRootFromParent_Done,
     /* 117396 */   // Label 2554: @117396
     /* 117396 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(117433), // Rule ID 667 //
     /* 117401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 117412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117416 */     // MIs[1] Operand 1
     /* 117416 */     // No operand predicates
     /* 117416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117418 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32ri_ND),
     /* 117421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 117428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117431 */     GIR_RootConstrainSelectedInstOperands,
     /* 117432 */     // GIR_Coverage, 667,
     /* 117432 */     GIR_EraseRootFromParent_Done,
     /* 117433 */   // Label 2555: @117433
     /* 117433 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(117512), // Rule ID 17668 //
     /* 117438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117449 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117449 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117452 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117456 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117475 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117478 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr),
     /* 117503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117505 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117510 */     GIR_RootConstrainSelectedInstOperands,
     /* 117511 */     // GIR_Coverage, 17668,
     /* 117511 */     GIR_EraseRootFromParent_Done,
     /* 117512 */   // Label 2556: @117512
     /* 117512 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(117591), // Rule ID 17700 //
     /* 117517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117528 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117528 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117531 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117535 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117554 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117557 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117561 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 117574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX32rr_EVEX),
     /* 117582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117584 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117589 */     GIR_RootConstrainSelectedInstOperands,
     /* 117590 */     // GIR_Coverage, 17700,
     /* 117590 */     GIR_EraseRootFromParent_Done,
     /* 117591 */   // Label 2557: @117591
     /* 117591 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(117633), // Rule ID 679 //
     /* 117596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 117599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117607 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117611 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL),
     /* 117624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117626 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117631 */     GIR_RootConstrainSelectedInstOperands,
     /* 117632 */     // GIR_Coverage, 679,
     /* 117632 */     GIR_EraseRootFromParent_Done,
     /* 117633 */   // Label 2558: @117633
     /* 117633 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(117675), // Rule ID 683 //
     /* 117638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 117645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117649 */     // (shl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 117649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117653 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117659 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL32rCL_ND),
     /* 117666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 117670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117673 */     GIR_RootConstrainSelectedInstOperands,
     /* 117674 */     // GIR_Coverage, 683,
     /* 117674 */     GIR_EraseRootFromParent_Done,
     /* 117675 */   // Label 2559: @117675
     /* 117675 */   GIM_Reject,
     /* 117676 */ // Label 2547: @117676
     /* 117676 */ GIM_Reject,
     /* 117677 */ // Label 2527: @117677
     /* 117677 */ GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(118429),
     /* 117682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 117688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 117692 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(117759), // Rule ID 676 //
     /* 117697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117708 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117711 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117715 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 117723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 117727 */     // MIs[2] Operand 1
     /* 117727 */     // No operand predicates
     /* 117727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 117729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117736 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 117736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mi_ND),
     /* 117739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 117748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 117757 */     GIR_RootConstrainSelectedInstOperands,
     /* 117758 */     // GIR_Coverage, 676,
     /* 117758 */     GIR_EraseRootFromParent_Done,
     /* 117759 */   // Label 2561: @117759
     /* 117759 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(117832), // Rule ID 692 //
     /* 117764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 117767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 117790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117799 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 117799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117803 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 117813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64mCL_ND),
     /* 117816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 117825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117830 */     GIR_RootConstrainSelectedInstOperands,
     /* 117831 */     // GIR_Coverage, 692,
     /* 117831 */     GIR_EraseRootFromParent_Done,
     /* 117832 */   // Label 2562: @117832
     /* 117832 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(117942), // Rule ID 17673 //
     /* 117837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 117840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117851 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117855 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117865 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117872 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117898 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117901 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 117905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 117908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117913 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 117918 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 117923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm),
     /* 117926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 117932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117940 */     GIR_RootConstrainSelectedInstOperands,
     /* 117941 */     // GIR_Coverage, 17673,
     /* 117941 */     GIR_EraseRootFromParent_Done,
     /* 117942 */   // Label 2563: @117942
     /* 117942 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(118052), // Rule ID 17705 //
     /* 117947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 117950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 117958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117961 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 117965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 117969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 117973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 117982 */     // (shl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 117982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 117985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118008 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118011 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118015 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118018 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118023 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rm_EVEX),
     /* 118036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118050 */     GIR_RootConstrainSelectedInstOperands,
     /* 118051 */     // GIR_Coverage, 17705,
     /* 118051 */     GIR_EraseRootFromParent_Done,
     /* 118052 */   // Label 2564: @118052
     /* 118052 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(118082), // Rule ID 22677 //
     /* 118057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118068 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr),
     /* 118071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118073 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118080 */     GIR_RootConstrainSelectedInstOperands,
     /* 118081 */     // GIR_Coverage, 22677,
     /* 118081 */     GIR_EraseRootFromParent_Done,
     /* 118082 */   // Label 2565: @118082
     /* 118082 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(118112), // Rule ID 22681 //
     /* 118087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 118090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /* 118098 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 1:{ *:[i8] })  =>  (ADD64rr_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src1)
     /* 118098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD64rr_ND),
     /* 118101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118107 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118110 */     GIR_RootConstrainSelectedInstOperands,
     /* 118111 */     // GIR_Coverage, 22681,
     /* 118111 */     GIR_EraseRootFromParent_Done,
     /* 118112 */   // Label 2566: @118112
     /* 118112 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(118149), // Rule ID 664 //
     /* 118117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118132 */     // MIs[1] Operand 1
     /* 118132 */     // No operand predicates
     /* 118132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118134 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri),
     /* 118137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118139 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118147 */     GIR_RootConstrainSelectedInstOperands,
     /* 118148 */     // GIR_Coverage, 664,
     /* 118148 */     GIR_EraseRootFromParent_Done,
     /* 118149 */   // Label 2567: @118149
     /* 118149 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(118186), // Rule ID 668 //
     /* 118154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118169 */     // MIs[1] Operand 1
     /* 118169 */     // No operand predicates
     /* 118169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118171 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64ri_ND),
     /* 118174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118184 */     GIR_RootConstrainSelectedInstOperands,
     /* 118185 */     // GIR_Coverage, 668,
     /* 118185 */     GIR_EraseRootFromParent_Done,
     /* 118186 */   // Label 2568: @118186
     /* 118186 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(118265), // Rule ID 17669 //
     /* 118191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 118194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118202 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118202 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118205 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118209 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118228 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118235 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118238 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr),
     /* 118256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118263 */     GIR_RootConstrainSelectedInstOperands,
     /* 118264 */     // GIR_Coverage, 17669,
     /* 118264 */     GIR_EraseRootFromParent_Done,
     /* 118265 */   // Label 2569: @118265
     /* 118265 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(118344), // Rule ID 17701 //
     /* 118270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 118273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118281 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHLX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 118281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 118284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 118314 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 118317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 118327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 118332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLX64rr_EVEX),
     /* 118335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118337 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118342 */     GIR_RootConstrainSelectedInstOperands,
     /* 118343 */     // GIR_Coverage, 17701,
     /* 118343 */     GIR_EraseRootFromParent_Done,
     /* 118344 */   // Label 2570: @118344
     /* 118344 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(118386), // Rule ID 680 //
     /* 118349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118360 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118364 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL),
     /* 118377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118379 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118384 */     GIR_RootConstrainSelectedInstOperands,
     /* 118385 */     // GIR_Coverage, 680,
     /* 118385 */     GIR_EraseRootFromParent_Done,
     /* 118386 */   // Label 2571: @118386
     /* 118386 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(118428), // Rule ID 684 //
     /* 118391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 118398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118402 */     // (shl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 118402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118406 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHL64rCL_ND),
     /* 118419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118426 */     GIR_RootConstrainSelectedInstOperands,
     /* 118427 */     // GIR_Coverage, 684,
     /* 118427 */     GIR_EraseRootFromParent_Done,
     /* 118428 */   // Label 2572: @118428
     /* 118428 */   GIM_Reject,
     /* 118429 */ // Label 2560: @118429
     /* 118429 */ GIM_Reject,
     /* 118430 */ // Label 2528: @118430
     /* 118430 */ GIM_Reject,
     /* 118431 */ // Label 27: @118431
     /* 118431 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2577*/ GIMT_Encode4(120474),
     /* 118442 */ /*GILLT_s8*//*Label 2573*/ GIMT_Encode4(118458),
     /* 118446 */ /*GILLT_s16*//*Label 2574*/ GIMT_Encode4(118773),
     /* 118450 */ /*GILLT_s32*//*Label 2575*/ GIMT_Encode4(119088),
     /* 118454 */ /*GILLT_s64*//*Label 2576*/ GIMT_Encode4(119781),
     /* 118458 */ // Label 2573: @118458
     /* 118458 */ GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(118772),
     /* 118463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 118466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118473 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(118540), // Rule ID 705 //
     /* 118478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118489 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118496 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118508 */     // MIs[2] Operand 1
     /* 118508 */     // No operand predicates
     /* 118508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118517 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SHR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mi_ND),
     /* 118520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118538 */     GIR_RootConstrainSelectedInstOperands,
     /* 118539 */     // GIR_Coverage, 705,
     /* 118539 */     GIR_EraseRootFromParent_Done,
     /* 118540 */   // Label 2579: @118540
     /* 118540 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(118613), // Rule ID 721 //
     /* 118545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118559 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118563 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 118567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118580 */     // (srl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SHR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118584 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8mCL_ND),
     /* 118597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118611 */     GIR_RootConstrainSelectedInstOperands,
     /* 118612 */     // GIR_Coverage, 721,
     /* 118612 */     GIR_EraseRootFromParent_Done,
     /* 118613 */   // Label 2580: @118613
     /* 118613 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(118650), // Rule ID 693 //
     /* 118618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118633 */     // MIs[1] Operand 1
     /* 118633 */     // No operand predicates
     /* 118633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118635 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri),
     /* 118638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118640 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118645 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118648 */     GIR_RootConstrainSelectedInstOperands,
     /* 118649 */     // GIR_Coverage, 693,
     /* 118649 */     GIR_EraseRootFromParent_Done,
     /* 118650 */   // Label 2581: @118650
     /* 118650 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(118687), // Rule ID 697 //
     /* 118655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118670 */     // MIs[1] Operand 1
     /* 118670 */     // No operand predicates
     /* 118670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118672 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8ri_ND),
     /* 118675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118685 */     GIR_RootConstrainSelectedInstOperands,
     /* 118686 */     // GIR_Coverage, 697,
     /* 118686 */     GIR_EraseRootFromParent_Done,
     /* 118687 */   // Label 2582: @118687
     /* 118687 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(118729), // Rule ID 709 //
     /* 118692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118703 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118707 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL),
     /* 118720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118722 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118727 */     GIR_RootConstrainSelectedInstOperands,
     /* 118728 */     // GIR_Coverage, 709,
     /* 118728 */     GIR_EraseRootFromParent_Done,
     /* 118729 */   // Label 2583: @118729
     /* 118729 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(118771), // Rule ID 713 //
     /* 118734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 118741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118745 */     // (srl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SHR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 118745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118749 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118755 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR8rCL_ND),
     /* 118762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118769 */     GIR_RootConstrainSelectedInstOperands,
     /* 118770 */     // GIR_Coverage, 713,
     /* 118770 */     GIR_EraseRootFromParent_Done,
     /* 118771 */   // Label 2584: @118771
     /* 118771 */   GIM_Reject,
     /* 118772 */ // Label 2578: @118772
     /* 118772 */ GIM_Reject,
     /* 118773 */ // Label 2574: @118773
     /* 118773 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(119087),
     /* 118778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 118781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 118784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118788 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(118855), // Rule ID 706 //
     /* 118793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118811 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 118819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118823 */     // MIs[2] Operand 1
     /* 118823 */     // No operand predicates
     /* 118823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 118825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118832 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SHR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mi_ND),
     /* 118835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 118844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 118853 */     GIR_RootConstrainSelectedInstOperands,
     /* 118854 */     // GIR_Coverage, 706,
     /* 118854 */     GIR_EraseRootFromParent_Done,
     /* 118855 */   // Label 2586: @118855
     /* 118855 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(118928), // Rule ID 722 //
     /* 118860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 118871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118874 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 118878 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 118882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 118886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 118895 */     // (srl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SHR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 118895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118899 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 118909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16mCL_ND),
     /* 118912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118914 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 118918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118926 */     GIR_RootConstrainSelectedInstOperands,
     /* 118927 */     // GIR_Coverage, 722,
     /* 118927 */     GIR_EraseRootFromParent_Done,
     /* 118928 */   // Label 2587: @118928
     /* 118928 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(118965), // Rule ID 694 //
     /* 118933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 118936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118948 */     // MIs[1] Operand 1
     /* 118948 */     // No operand predicates
     /* 118948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118950 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri),
     /* 118953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118955 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 118963 */     GIR_RootConstrainSelectedInstOperands,
     /* 118964 */     // GIR_Coverage, 694,
     /* 118964 */     GIR_EraseRootFromParent_Done,
     /* 118965 */   // Label 2588: @118965
     /* 118965 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(119002), // Rule ID 698 //
     /* 118970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 118973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 118977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 118981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 118985 */     // MIs[1] Operand 1
     /* 118985 */     // No operand predicates
     /* 118985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118987 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 118987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16ri_ND),
     /* 118990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118992 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 118994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 118997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119000 */     GIR_RootConstrainSelectedInstOperands,
     /* 119001 */     // GIR_Coverage, 698,
     /* 119001 */     GIR_EraseRootFromParent_Done,
     /* 119002 */   // Label 2589: @119002
     /* 119002 */   GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(119044), // Rule ID 710 //
     /* 119007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 119014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119018 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 119018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119022 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL),
     /* 119035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119042 */     GIR_RootConstrainSelectedInstOperands,
     /* 119043 */     // GIR_Coverage, 710,
     /* 119043 */     GIR_EraseRootFromParent_Done,
     /* 119044 */   // Label 2590: @119044
     /* 119044 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(119086), // Rule ID 714 //
     /* 119049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 119056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119060 */     // (srl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SHR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 119060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR16rCL_ND),
     /* 119077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119084 */     GIR_RootConstrainSelectedInstOperands,
     /* 119085 */     // GIR_Coverage, 714,
     /* 119085 */     GIR_EraseRootFromParent_Done,
     /* 119086 */   // Label 2591: @119086
     /* 119086 */   GIM_Reject,
     /* 119087 */ // Label 2585: @119087
     /* 119087 */ GIM_Reject,
     /* 119088 */ // Label 2575: @119088
     /* 119088 */ GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(119780),
     /* 119093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119103 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(119170), // Rule ID 707 //
     /* 119108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119119 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119126 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119138 */     // MIs[2] Operand 1
     /* 119138 */     // No operand predicates
     /* 119138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119147 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SHR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mi_ND),
     /* 119150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119168 */     GIR_RootConstrainSelectedInstOperands,
     /* 119169 */     // GIR_Coverage, 707,
     /* 119169 */     GIR_EraseRootFromParent_Done,
     /* 119170 */   // Label 2593: @119170
     /* 119170 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(119243), // Rule ID 723 //
     /* 119175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119193 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119210 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119214 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119220 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32mCL_ND),
     /* 119227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119241 */     GIR_RootConstrainSelectedInstOperands,
     /* 119242 */     // GIR_Coverage, 723,
     /* 119242 */     GIR_EraseRootFromParent_Done,
     /* 119243 */   // Label 2594: @119243
     /* 119243 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(119353), // Rule ID 17664 //
     /* 119248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119266 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119283 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119309 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119316 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119324 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119329 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm),
     /* 119337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119351 */     GIR_RootConstrainSelectedInstOperands,
     /* 119352 */     // GIR_Coverage, 17664,
     /* 119352 */     GIR_EraseRootFromParent_Done,
     /* 119353 */   // Label 2595: @119353
     /* 119353 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(119463), // Rule ID 17696 //
     /* 119358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119376 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 119380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119393 */     // (srl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rm_EVEX),
     /* 119447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119461 */     GIR_RootConstrainSelectedInstOperands,
     /* 119462 */     // GIR_Coverage, 17696,
     /* 119462 */     GIR_EraseRootFromParent_Done,
     /* 119463 */   // Label 2596: @119463
     /* 119463 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(119500), // Rule ID 695 //
     /* 119468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119483 */     // MIs[1] Operand 1
     /* 119483 */     // No operand predicates
     /* 119483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119485 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri),
     /* 119488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119498 */     GIR_RootConstrainSelectedInstOperands,
     /* 119499 */     // GIR_Coverage, 695,
     /* 119499 */     GIR_EraseRootFromParent_Done,
     /* 119500 */   // Label 2597: @119500
     /* 119500 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(119537), // Rule ID 699 //
     /* 119505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 119516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119520 */     // MIs[1] Operand 1
     /* 119520 */     // No operand predicates
     /* 119520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119522 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32ri_ND),
     /* 119525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 119532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119535 */     GIR_RootConstrainSelectedInstOperands,
     /* 119536 */     // GIR_Coverage, 699,
     /* 119536 */     GIR_EraseRootFromParent_Done,
     /* 119537 */   // Label 2598: @119537
     /* 119537 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(119616), // Rule ID 17660 //
     /* 119542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119553 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119553 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119556 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119560 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119579 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119586 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr),
     /* 119607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119614 */     GIR_RootConstrainSelectedInstOperands,
     /* 119615 */     // GIR_Coverage, 17660,
     /* 119615 */     GIR_EraseRootFromParent_Done,
     /* 119616 */   // Label 2599: @119616
     /* 119616 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(119695), // Rule ID 17692 //
     /* 119621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 119624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119632 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119632 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119635 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119639 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 119665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 119668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 119678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 119683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX32rr_EVEX),
     /* 119686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119688 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119693 */     GIR_RootConstrainSelectedInstOperands,
     /* 119694 */     // GIR_Coverage, 17692,
     /* 119694 */     GIR_EraseRootFromParent_Done,
     /* 119695 */   // Label 2600: @119695
     /* 119695 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(119737), // Rule ID 711 //
     /* 119700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 119703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119711 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119715 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119721 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL),
     /* 119728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119735 */     GIR_RootConstrainSelectedInstOperands,
     /* 119736 */     // GIR_Coverage, 711,
     /* 119736 */     GIR_EraseRootFromParent_Done,
     /* 119737 */   // Label 2601: @119737
     /* 119737 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(119779), // Rule ID 715 //
     /* 119742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 119749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119753 */     // (srl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 119753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119757 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119763 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR32rCL_ND),
     /* 119770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 119774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119777 */     GIR_RootConstrainSelectedInstOperands,
     /* 119778 */     // GIR_Coverage, 715,
     /* 119778 */     GIR_EraseRootFromParent_Done,
     /* 119779 */   // Label 2602: @119779
     /* 119779 */   GIM_Reject,
     /* 119780 */ // Label 2592: @119780
     /* 119780 */ GIM_Reject,
     /* 119781 */ // Label 2576: @119781
     /* 119781 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(120473),
     /* 119786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 119792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 119796 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(119863), // Rule ID 708 //
     /* 119801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 119827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119831 */     // MIs[2] Operand 1
     /* 119831 */     // No operand predicates
     /* 119831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119840 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SHR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 119840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mi_ND),
     /* 119843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 119852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119861 */     GIR_RootConstrainSelectedInstOperands,
     /* 119862 */     // GIR_Coverage, 708,
     /* 119862 */     GIR_EraseRootFromParent_Done,
     /* 119863 */   // Label 2604: @119863
     /* 119863 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(119936), // Rule ID 724 //
     /* 119868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 119871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119879 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119882 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119886 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 119894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119903 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 119903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119907 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 119917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64mCL_ND),
     /* 119920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119922 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 119926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 119929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119934 */     GIR_RootConstrainSelectedInstOperands,
     /* 119935 */     // GIR_Coverage, 724,
     /* 119935 */     GIR_EraseRootFromParent_Done,
     /* 119936 */   // Label 2605: @119936
     /* 119936 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(120046), // Rule ID 17665 //
     /* 119941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 119944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 119952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 119959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 119963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 119967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 119976 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 119976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120012 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm),
     /* 120030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120032 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120044 */     GIR_RootConstrainSelectedInstOperands,
     /* 120045 */     // GIR_Coverage, 17665,
     /* 120045 */     GIR_EraseRootFromParent_Done,
     /* 120046 */   // Label 2606: @120046
     /* 120046 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(120156), // Rule ID 17697 //
     /* 120051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 120069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120079 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120086 */     // (srl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120112 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120119 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rm_EVEX),
     /* 120140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120154 */     GIR_RootConstrainSelectedInstOperands,
     /* 120155 */     // GIR_Coverage, 17697,
     /* 120155 */     GIR_EraseRootFromParent_Done,
     /* 120156 */   // Label 2607: @120156
     /* 120156 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(120193), // Rule ID 696 //
     /* 120161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120176 */     // MIs[1] Operand 1
     /* 120176 */     // No operand predicates
     /* 120176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120178 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri),
     /* 120181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120183 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120191 */     GIR_RootConstrainSelectedInstOperands,
     /* 120192 */     // GIR_Coverage, 696,
     /* 120192 */     GIR_EraseRootFromParent_Done,
     /* 120193 */   // Label 2608: @120193
     /* 120193 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(120230), // Rule ID 700 //
     /* 120198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120213 */     // MIs[1] Operand 1
     /* 120213 */     // No operand predicates
     /* 120213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120215 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SHR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64ri_ND),
     /* 120218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120228 */     GIR_RootConstrainSelectedInstOperands,
     /* 120229 */     // GIR_Coverage, 700,
     /* 120229 */     GIR_EraseRootFromParent_Done,
     /* 120230 */   // Label 2609: @120230
     /* 120230 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(120309), // Rule ID 17661 //
     /* 120235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 120238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120246 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120272 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120275 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120279 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120287 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr),
     /* 120300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120307 */     GIR_RootConstrainSelectedInstOperands,
     /* 120308 */     // GIR_Coverage, 17661,
     /* 120308 */     GIR_EraseRootFromParent_Done,
     /* 120309 */   // Label 2610: @120309
     /* 120309 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(120388), // Rule ID 17693 //
     /* 120314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 120317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120325 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SHRX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 120325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 120328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 120342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 120346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120351 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 120354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 120358 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 120361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 120371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 120376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRX64rr_EVEX),
     /* 120379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120386 */     GIR_RootConstrainSelectedInstOperands,
     /* 120387 */     // GIR_Coverage, 17693,
     /* 120387 */     GIR_EraseRootFromParent_Done,
     /* 120388 */   // Label 2611: @120388
     /* 120388 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(120430), // Rule ID 712 //
     /* 120393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120404 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120408 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL),
     /* 120421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120428 */     GIR_RootConstrainSelectedInstOperands,
     /* 120429 */     // GIR_Coverage, 712,
     /* 120429 */     GIR_EraseRootFromParent_Done,
     /* 120430 */   // Label 2612: @120430
     /* 120430 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(120472), // Rule ID 716 //
     /* 120435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 120442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120446 */     // (srl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 120446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120450 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHR64rCL_ND),
     /* 120463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120465 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120470 */     GIR_RootConstrainSelectedInstOperands,
     /* 120471 */     // GIR_Coverage, 716,
     /* 120471 */     GIR_EraseRootFromParent_Done,
     /* 120472 */   // Label 2613: @120472
     /* 120472 */   GIM_Reject,
     /* 120473 */ // Label 2603: @120473
     /* 120473 */ GIM_Reject,
     /* 120474 */ // Label 2577: @120474
     /* 120474 */ GIM_Reject,
     /* 120475 */ // Label 28: @120475
     /* 120475 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(5), /*)*//*default:*//*Label 2618*/ GIMT_Encode4(122518),
     /* 120486 */ /*GILLT_s8*//*Label 2614*/ GIMT_Encode4(120502),
     /* 120490 */ /*GILLT_s16*//*Label 2615*/ GIMT_Encode4(120817),
     /* 120494 */ /*GILLT_s32*//*Label 2616*/ GIMT_Encode4(121132),
     /* 120498 */ /*GILLT_s64*//*Label 2617*/ GIMT_Encode4(121825),
     /* 120502 */ // Label 2614: @120502
     /* 120502 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(120816),
     /* 120507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 120510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120517 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(120584), // Rule ID 737 //
     /* 120522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120533 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120540 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120552 */     // MIs[2] Operand 1
     /* 120552 */     // No operand predicates
     /* 120552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120561 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (SAR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mi_ND),
     /* 120564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120566 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120582 */     GIR_RootConstrainSelectedInstOperands,
     /* 120583 */     // GIR_Coverage, 737,
     /* 120583 */     GIR_EraseRootFromParent_Done,
     /* 120584 */   // Label 2620: @120584
     /* 120584 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(120657), // Rule ID 753 //
     /* 120589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120600 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120607 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 120611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120624 */     // (sra:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (SAR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120628 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8mCL_ND),
     /* 120641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120655 */     GIR_RootConstrainSelectedInstOperands,
     /* 120656 */     // GIR_Coverage, 753,
     /* 120656 */     GIR_EraseRootFromParent_Done,
     /* 120657 */   // Label 2621: @120657
     /* 120657 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(120694), // Rule ID 725 //
     /* 120662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120677 */     // MIs[1] Operand 1
     /* 120677 */     // No operand predicates
     /* 120677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120679 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri),
     /* 120682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120692 */     GIR_RootConstrainSelectedInstOperands,
     /* 120693 */     // GIR_Coverage, 725,
     /* 120693 */     GIR_EraseRootFromParent_Done,
     /* 120694 */   // Label 2622: @120694
     /* 120694 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(120731), // Rule ID 729 //
     /* 120699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120714 */     // MIs[1] Operand 1
     /* 120714 */     // No operand predicates
     /* 120714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120716 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8ri_ND),
     /* 120719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 120726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120729 */     GIR_RootConstrainSelectedInstOperands,
     /* 120730 */     // GIR_Coverage, 729,
     /* 120730 */     GIR_EraseRootFromParent_Done,
     /* 120731 */   // Label 2623: @120731
     /* 120731 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(120773), // Rule ID 741 //
     /* 120736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120747 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120751 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL),
     /* 120764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120766 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120771 */     GIR_RootConstrainSelectedInstOperands,
     /* 120772 */     // GIR_Coverage, 741,
     /* 120772 */     GIR_EraseRootFromParent_Done,
     /* 120773 */   // Label 2624: @120773
     /* 120773 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(120815), // Rule ID 745 //
     /* 120778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 120785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120789 */     // (sra:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (SAR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 120789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120793 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120799 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR8rCL_ND),
     /* 120806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 120810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120813 */     GIR_RootConstrainSelectedInstOperands,
     /* 120814 */     // GIR_Coverage, 745,
     /* 120814 */     GIR_EraseRootFromParent_Done,
     /* 120815 */   // Label 2625: @120815
     /* 120815 */   GIM_Reject,
     /* 120816 */ // Label 2619: @120816
     /* 120816 */ GIM_Reject,
     /* 120817 */ // Label 2615: @120817
     /* 120817 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(121131),
     /* 120822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 120828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120832 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(120899), // Rule ID 738 //
     /* 120837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120848 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120855 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120867 */     // MIs[2] Operand 1
     /* 120867 */     // No operand predicates
     /* 120867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120876 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (SAR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mi_ND),
     /* 120879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120881 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 120888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 120897 */     GIR_RootConstrainSelectedInstOperands,
     /* 120898 */     // GIR_Coverage, 738,
     /* 120898 */     GIR_EraseRootFromParent_Done,
     /* 120899 */   // Label 2627: @120899
     /* 120899 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(120972), // Rule ID 754 //
     /* 120904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 120907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 120915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120918 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 120922 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 120926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 120930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120932 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 120939 */     // (sra:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (SAR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 120939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120943 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 120953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16mCL_ND),
     /* 120956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120958 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 120962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 120965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120970 */     GIR_RootConstrainSelectedInstOperands,
     /* 120971 */     // GIR_Coverage, 754,
     /* 120971 */     GIR_EraseRootFromParent_Done,
     /* 120972 */   // Label 2628: @120972
     /* 120972 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(121009), // Rule ID 726 //
     /* 120977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 120980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 120984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 120988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 120992 */     // MIs[1] Operand 1
     /* 120992 */     // No operand predicates
     /* 120992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120994 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 120994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri),
     /* 120997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120999 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121007 */     GIR_RootConstrainSelectedInstOperands,
     /* 121008 */     // GIR_Coverage, 726,
     /* 121008 */     GIR_EraseRootFromParent_Done,
     /* 121009 */   // Label 2629: @121009
     /* 121009 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(121046), // Rule ID 730 //
     /* 121014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121029 */     // MIs[1] Operand 1
     /* 121029 */     // No operand predicates
     /* 121029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121031 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16ri_ND),
     /* 121034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121044 */     GIR_RootConstrainSelectedInstOperands,
     /* 121045 */     // GIR_Coverage, 730,
     /* 121045 */     GIR_EraseRootFromParent_Done,
     /* 121046 */   // Label 2630: @121046
     /* 121046 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(121088), // Rule ID 742 //
     /* 121051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121062 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121066 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121072 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL),
     /* 121079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121081 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121086 */     GIR_RootConstrainSelectedInstOperands,
     /* 121087 */     // GIR_Coverage, 742,
     /* 121087 */     GIR_EraseRootFromParent_Done,
     /* 121088 */   // Label 2631: @121088
     /* 121088 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(121130), // Rule ID 746 //
     /* 121093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 121100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121104 */     // (sra:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (SAR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 121104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121108 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121114 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR16rCL_ND),
     /* 121121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121123 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121128 */     GIR_RootConstrainSelectedInstOperands,
     /* 121129 */     // GIR_Coverage, 746,
     /* 121129 */     GIR_EraseRootFromParent_Done,
     /* 121130 */   // Label 2632: @121130
     /* 121130 */   GIM_Reject,
     /* 121131 */ // Label 2626: @121131
     /* 121131 */ GIM_Reject,
     /* 121132 */ // Label 2616: @121132
     /* 121132 */ GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(121824),
     /* 121137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121147 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(121214), // Rule ID 739 //
     /* 121152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121163 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121170 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121182 */     // MIs[2] Operand 1
     /* 121182 */     // No operand predicates
     /* 121182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121191 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (SAR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mi_ND),
     /* 121194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121206 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121212 */     GIR_RootConstrainSelectedInstOperands,
     /* 121213 */     // GIR_Coverage, 739,
     /* 121213 */     GIR_EraseRootFromParent_Done,
     /* 121214 */   // Label 2634: @121214
     /* 121214 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(121287), // Rule ID 755 //
     /* 121219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121237 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121254 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SAR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121258 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32mCL_ND),
     /* 121271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121273 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121285 */     GIR_RootConstrainSelectedInstOperands,
     /* 121286 */     // GIR_Coverage, 755,
     /* 121286 */     GIR_EraseRootFromParent_Done,
     /* 121287 */   // Label 2635: @121287
     /* 121287 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(121397), // Rule ID 17656 //
     /* 121292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121303 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121310 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121327 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121353 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121360 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm),
     /* 121381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121390 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121395 */     GIR_RootConstrainSelectedInstOperands,
     /* 121396 */     // GIR_Coverage, 17656,
     /* 121396 */     GIR_EraseRootFromParent_Done,
     /* 121397 */   // Label 2636: @121397
     /* 121397 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(121507), // Rule ID 17688 //
     /* 121402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121416 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121420 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 121424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121430 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121437 */     // (sra:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR8:{ *:[i8] }:$src2)  =>  (SARX32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121437 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121440 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121444 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121483 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rm_EVEX),
     /* 121491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121505 */     GIR_RootConstrainSelectedInstOperands,
     /* 121506 */     // GIR_Coverage, 17688,
     /* 121506 */     GIR_EraseRootFromParent_Done,
     /* 121507 */   // Label 2637: @121507
     /* 121507 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(121544), // Rule ID 727 //
     /* 121512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121527 */     // MIs[1] Operand 1
     /* 121527 */     // No operand predicates
     /* 121527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121529 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri),
     /* 121532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121534 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121539 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121542 */     GIR_RootConstrainSelectedInstOperands,
     /* 121543 */     // GIR_Coverage, 727,
     /* 121543 */     GIR_EraseRootFromParent_Done,
     /* 121544 */   // Label 2638: @121544
     /* 121544 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(121581), // Rule ID 731 //
     /* 121549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 121560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121564 */     // MIs[1] Operand 1
     /* 121564 */     // No operand predicates
     /* 121564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121566 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32ri_ND),
     /* 121569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 121576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121579 */     GIR_RootConstrainSelectedInstOperands,
     /* 121580 */     // GIR_Coverage, 731,
     /* 121580 */     GIR_EraseRootFromParent_Done,
     /* 121581 */   // Label 2639: @121581
     /* 121581 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(121660), // Rule ID 17652 //
     /* 121586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121597 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121597 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121600 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121604 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121623 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr),
     /* 121651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121658 */     GIR_RootConstrainSelectedInstOperands,
     /* 121659 */     // GIR_Coverage, 17652,
     /* 121659 */     GIR_EraseRootFromParent_Done,
     /* 121660 */   // Label 2640: @121660
     /* 121660 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(121739), // Rule ID 17684 //
     /* 121665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 121668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 121676 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX32rr_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src1, (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 121676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 121709 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 121712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::LOW32_ADDR_ACCESS_RBP_with_sub_8bitRegClassID),
     /* 121722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 121727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX32rr_EVEX),
     /* 121730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121737 */     GIR_RootConstrainSelectedInstOperands,
     /* 121738 */     // GIR_Coverage, 17684,
     /* 121738 */     GIR_EraseRootFromParent_Done,
     /* 121739 */   // Label 2641: @121739
     /* 121739 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(121781), // Rule ID 743 //
     /* 121744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 121747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121755 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121759 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121765 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL),
     /* 121772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121774 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121779 */     GIR_RootConstrainSelectedInstOperands,
     /* 121780 */     // GIR_Coverage, 743,
     /* 121780 */     GIR_EraseRootFromParent_Done,
     /* 121781 */   // Label 2642: @121781
     /* 121781 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(121823), // Rule ID 747 //
     /* 121786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 121793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121797 */     // (sra:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SAR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 121797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121801 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR32rCL_ND),
     /* 121814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 121818 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121821 */     GIR_RootConstrainSelectedInstOperands,
     /* 121822 */     // GIR_Coverage, 747,
     /* 121822 */     GIR_EraseRootFromParent_Done,
     /* 121823 */   // Label 2643: @121823
     /* 121823 */   GIM_Reject,
     /* 121824 */ // Label 2633: @121824
     /* 121824 */ GIM_Reject,
     /* 121825 */ // Label 2617: @121825
     /* 121825 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(122517),
     /* 121830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 121833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 121836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 121840 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(121907), // Rule ID 740 //
     /* 121845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121875 */     // MIs[2] Operand 1
     /* 121875 */     // No operand predicates
     /* 121875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121877 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121884 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (SAR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 121884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mi_ND),
     /* 121887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 121896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121905 */     GIR_RootConstrainSelectedInstOperands,
     /* 121906 */     // GIR_Coverage, 740,
     /* 121906 */     GIR_EraseRootFromParent_Done,
     /* 121907 */   // Label 2645: @121907
     /* 121907 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(121980), // Rule ID 756 //
     /* 121912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 121915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121923 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121926 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 121930 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 121934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 121938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121940 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 121947 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SAR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 121947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121951 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121957 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 121961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64mCL_ND),
     /* 121964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 121970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 121973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121978 */     GIR_RootConstrainSelectedInstOperands,
     /* 121979 */     // GIR_Coverage, 756,
     /* 121979 */     GIR_EraseRootFromParent_Done,
     /* 121980 */   // Label 2646: @121980
     /* 121980 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(122090), // Rule ID 17657 //
     /* 121985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 121988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 121996 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121999 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122003 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122020 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122049 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122053 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm),
     /* 122074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122076 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122088 */     GIR_RootConstrainSelectedInstOperands,
     /* 122089 */     // GIR_Coverage, 17657,
     /* 122089 */     GIR_EraseRootFromParent_Done,
     /* 122090 */   // Label 2647: @122090
     /* 122090 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(122200), // Rule ID 17689 //
     /* 122095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122106 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122113 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122130 */     // (sra:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR8:{ *:[i8] }:$src2)  =>  (SARX64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122156 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122176 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rm_EVEX),
     /* 122184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122198 */     GIR_RootConstrainSelectedInstOperands,
     /* 122199 */     // GIR_Coverage, 17689,
     /* 122199 */     GIR_EraseRootFromParent_Done,
     /* 122200 */   // Label 2648: @122200
     /* 122200 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(122237), // Rule ID 728 //
     /* 122205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122220 */     // MIs[1] Operand 1
     /* 122220 */     // No operand predicates
     /* 122220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122222 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri),
     /* 122225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122235 */     GIR_RootConstrainSelectedInstOperands,
     /* 122236 */     // GIR_Coverage, 728,
     /* 122236 */     GIR_EraseRootFromParent_Done,
     /* 122237 */   // Label 2649: @122237
     /* 122237 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(122274), // Rule ID 732 //
     /* 122242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 122253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122257 */     // MIs[1] Operand 1
     /* 122257 */     // No operand predicates
     /* 122257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122259 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (SAR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 122259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64ri_ND),
     /* 122262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122264 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 122269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122272 */     GIR_RootConstrainSelectedInstOperands,
     /* 122273 */     // GIR_Coverage, 732,
     /* 122273 */     GIR_EraseRootFromParent_Done,
     /* 122274 */   // Label 2650: @122274
     /* 122274 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(122353), // Rule ID 17653 //
     /* 122279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 122282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122290 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122323 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr),
     /* 122344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122346 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122351 */     GIR_RootConstrainSelectedInstOperands,
     /* 122352 */     // GIR_Coverage, 17653,
     /* 122352 */     GIR_EraseRootFromParent_Done,
     /* 122353 */   // Label 2651: @122353
     /* 122353 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(122432), // Rule ID 17685 //
     /* 122358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 122361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 122369 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR8:{ *:[i8] }:$src2)  =>  (SARX64rr_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src1, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GR8:{ *:[i8] }:$src2, sub_8bit:{ *:[i32] }))
     /* 122369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 122386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122395 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 122402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 122405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::GR64_with_sub_8bitRegClassID),
     /* 122415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(X86::GR8RegClassID),
     /* 122420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SARX64rr_EVEX),
     /* 122423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122425 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122430 */     GIR_RootConstrainSelectedInstOperands,
     /* 122431 */     // GIR_Coverage, 17685,
     /* 122431 */     GIR_EraseRootFromParent_Done,
     /* 122432 */   // Label 2652: @122432
     /* 122432 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(122474), // Rule ID 744 //
     /* 122437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122448 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122452 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL),
     /* 122465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122472 */     GIR_RootConstrainSelectedInstOperands,
     /* 122473 */     // GIR_Coverage, 744,
     /* 122473 */     GIR_EraseRootFromParent_Done,
     /* 122474 */   // Label 2653: @122474
     /* 122474 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(122516), // Rule ID 748 //
     /* 122479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122490 */     // (sra:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SAR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 122490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122494 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 122504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SAR64rCL_ND),
     /* 122507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122509 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122514 */     GIR_RootConstrainSelectedInstOperands,
     /* 122515 */     // GIR_Coverage, 748,
     /* 122515 */     GIR_EraseRootFromParent_Done,
     /* 122516 */   // Label 2654: @122516
     /* 122516 */   GIM_Reject,
     /* 122517 */ // Label 2644: @122517
     /* 122517 */ GIM_Reject,
     /* 122518 */ // Label 2618: @122518
     /* 122518 */ GIM_Reject,
     /* 122519 */ // Label 29: @122519
     /* 122519 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2657*/ GIMT_Encode4(123246),
     /* 122530 */ /*GILLT_s32*//*Label 2655*/ GIMT_Encode4(122538),
     /* 122534 */ /*GILLT_s64*//*Label 2656*/ GIMT_Encode4(122892),
     /* 122538 */ // Label 2655: @122538
     /* 122538 */ GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(122891),
     /* 122543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122549 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122556 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(122629), // Rule ID 840 //
     /* 122561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122579 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122595 */     // MIs[2] Operand 1
     /* 122595 */     // No operand predicates
     /* 122595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122604 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mri8_ND),
     /* 122607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122618 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122627 */     GIR_RootConstrainSelectedInstOperands,
     /* 122628 */     // GIR_Coverage, 840,
     /* 122628 */     GIR_EraseRootFromParent_Done,
     /* 122629 */   // Label 2659: @122629
     /* 122629 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(122708), // Rule ID 843 //
     /* 122634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122645 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122648 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122652 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 122656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122673 */     // (fshl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122677 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32mrCL_ND),
     /* 122690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122696 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 122706 */     GIR_RootConstrainSelectedInstOperands,
     /* 122707 */     // GIR_Coverage, 843,
     /* 122707 */     GIR_EraseRootFromParent_Done,
     /* 122708 */   // Label 2660: @122708
     /* 122708 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(122751), // Rule ID 822 //
     /* 122713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122732 */     // MIs[1] Operand 1
     /* 122732 */     // No operand predicates
     /* 122732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122734 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8),
     /* 122737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122741 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122746 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122749 */     GIR_RootConstrainSelectedInstOperands,
     /* 122750 */     // GIR_Coverage, 822,
     /* 122750 */     GIR_EraseRootFromParent_Done,
     /* 122751 */   // Label 2661: @122751
     /* 122751 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(122794), // Rule ID 828 //
     /* 122756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 122771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122775 */     // MIs[1] Operand 1
     /* 122775 */     // No operand predicates
     /* 122775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122777 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rri8_ND),
     /* 122780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 122789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122792 */     GIR_RootConstrainSelectedInstOperands,
     /* 122793 */     // GIR_Coverage, 828,
     /* 122793 */     GIR_EraseRootFromParent_Done,
     /* 122794 */   // Label 2662: @122794
     /* 122794 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(122842), // Rule ID 825 //
     /* 122799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 122802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122814 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122818 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL),
     /* 122831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122833 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122835 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122840 */     GIR_RootConstrainSelectedInstOperands,
     /* 122841 */     // GIR_Coverage, 825,
     /* 122841 */     GIR_EraseRootFromParent_Done,
     /* 122842 */   // Label 2663: @122842
     /* 122842 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(122890), // Rule ID 831 //
     /* 122847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 122858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 122862 */     // (fshl:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, CL:{ *:[i8] })  =>  (SHLD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 122862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122866 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 122876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD32rrCL_ND),
     /* 122879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 122883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122888 */     GIR_RootConstrainSelectedInstOperands,
     /* 122889 */     // GIR_Coverage, 831,
     /* 122889 */     GIR_EraseRootFromParent_Done,
     /* 122890 */   // Label 2664: @122890
     /* 122890 */   GIM_Reject,
     /* 122891 */ // Label 2658: @122891
     /* 122891 */ GIM_Reject,
     /* 122892 */ // Label 2656: @122892
     /* 122892 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(123245),
     /* 122897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 122900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 122903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 122906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122910 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(122983), // Rule ID 841 //
     /* 122915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 122933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 122937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 122941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 122945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122949 */     // MIs[2] Operand 1
     /* 122949 */     // No operand predicates
     /* 122949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 122958 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 122958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mri8_ND),
     /* 122961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 122967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 122969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 122972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 122975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 122981 */     GIR_RootConstrainSelectedInstOperands,
     /* 122982 */     // GIR_Coverage, 841,
     /* 122982 */     GIR_EraseRootFromParent_Done,
     /* 122983 */   // Label 2666: @122983
     /* 122983 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(123062), // Rule ID 844 //
     /* 122988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 122991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 122999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123027 */     // (fshl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123031 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64mrCL_ND),
     /* 123044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123060 */     GIR_RootConstrainSelectedInstOperands,
     /* 123061 */     // GIR_Coverage, 844,
     /* 123061 */     GIR_EraseRootFromParent_Done,
     /* 123062 */   // Label 2667: @123062
     /* 123062 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(123105), // Rule ID 823 //
     /* 123067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123086 */     // MIs[1] Operand 1
     /* 123086 */     // No operand predicates
     /* 123086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123088 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8),
     /* 123091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123095 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123103 */     GIR_RootConstrainSelectedInstOperands,
     /* 123104 */     // GIR_Coverage, 823,
     /* 123104 */     GIR_EraseRootFromParent_Done,
     /* 123105 */   // Label 2668: @123105
     /* 123105 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(123148), // Rule ID 829 //
     /* 123110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123129 */     // MIs[1] Operand 1
     /* 123129 */     // No operand predicates
     /* 123129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123131 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)  =>  (SHLD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rri8_ND),
     /* 123134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123146 */     GIR_RootConstrainSelectedInstOperands,
     /* 123147 */     // GIR_Coverage, 829,
     /* 123147 */     GIR_EraseRootFromParent_Done,
     /* 123148 */   // Label 2669: @123148
     /* 123148 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(123196), // Rule ID 826 //
     /* 123153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123168 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123172 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL),
     /* 123185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123194 */     GIR_RootConstrainSelectedInstOperands,
     /* 123195 */     // GIR_Coverage, 826,
     /* 123195 */     GIR_EraseRootFromParent_Done,
     /* 123196 */   // Label 2670: @123196
     /* 123196 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(123244), // Rule ID 832 //
     /* 123201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123216 */     // (fshl:{ *:[i64] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, CL:{ *:[i8] })  =>  (SHLD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123220 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123226 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLD64rrCL_ND),
     /* 123233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 123237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 123239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123242 */     GIR_RootConstrainSelectedInstOperands,
     /* 123243 */     // GIR_Coverage, 832,
     /* 123243 */     GIR_EraseRootFromParent_Done,
     /* 123244 */   // Label 2671: @123244
     /* 123244 */   GIM_Reject,
     /* 123245 */ // Label 2665: @123245
     /* 123245 */ GIM_Reject,
     /* 123246 */ // Label 2657: @123246
     /* 123246 */ GIM_Reject,
     /* 123247 */ // Label 30: @123247
     /* 123247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2674*/ GIMT_Encode4(123934),
     /* 123258 */ /*GILLT_s32*//*Label 2672*/ GIMT_Encode4(123266),
     /* 123262 */ /*GILLT_s64*//*Label 2673*/ GIMT_Encode4(123600),
     /* 123266 */ // Label 2672: @123266
     /* 123266 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(123599),
     /* 123271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 123274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 123277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123288 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(123357), // Rule ID 864 //
     /* 123293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123311 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123323 */     // MIs[2] Operand 1
     /* 123323 */     // No operand predicates
     /* 123323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123332 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD32mri8_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mri8_ND),
     /* 123335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123337 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123341 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123355 */     GIR_RootConstrainSelectedInstOperands,
     /* 123356 */     // GIR_Coverage, 864,
     /* 123356 */     GIR_EraseRootFromParent_Done,
     /* 123357 */   // Label 2676: @123357
     /* 123357 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(123432), // Rule ID 867 //
     /* 123362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123380 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 123384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123397 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (SHRD32mrCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123401 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123407 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32mrCL_ND),
     /* 123414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123430 */     GIR_RootConstrainSelectedInstOperands,
     /* 123431 */     // GIR_Coverage, 867,
     /* 123431 */     GIR_EraseRootFromParent_Done,
     /* 123432 */   // Label 2677: @123432
     /* 123432 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(123471), // Rule ID 846 //
     /* 123437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123452 */     // MIs[1] Operand 1
     /* 123452 */     // No operand predicates
     /* 123452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123454 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8),
     /* 123457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123469 */     GIR_RootConstrainSelectedInstOperands,
     /* 123470 */     // GIR_Coverage, 846,
     /* 123470 */     GIR_EraseRootFromParent_Done,
     /* 123471 */   // Label 2678: @123471
     /* 123471 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(123510), // Rule ID 852 //
     /* 123476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123491 */     // MIs[1] Operand 1
     /* 123491 */     // No operand predicates
     /* 123491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123493 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD32rri8_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rri8_ND),
     /* 123496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123498 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123500 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123508 */     GIR_RootConstrainSelectedInstOperands,
     /* 123509 */     // GIR_Coverage, 852,
     /* 123509 */     GIR_EraseRootFromParent_Done,
     /* 123510 */   // Label 2679: @123510
     /* 123510 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(123554), // Rule ID 849 //
     /* 123515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123526 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123530 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL),
     /* 123543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123552 */     GIR_RootConstrainSelectedInstOperands,
     /* 123553 */     // GIR_Coverage, 849,
     /* 123553 */     GIR_EraseRootFromParent_Done,
     /* 123554 */   // Label 2680: @123554
     /* 123554 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(123598), // Rule ID 855 //
     /* 123559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 123566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123570 */     // (fshr:{ *:[i32] } GR32:{ *:[i32] }:$src2, GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (SHRD32rrCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, GR32:{ *:[i32] }:$src2)
     /* 123570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123574 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD32rrCL_ND),
     /* 123587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123589 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123591 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123596 */     GIR_RootConstrainSelectedInstOperands,
     /* 123597 */     // GIR_Coverage, 855,
     /* 123597 */     GIR_EraseRootFromParent_Done,
     /* 123598 */   // Label 2681: @123598
     /* 123598 */   GIM_Reject,
     /* 123599 */ // Label 2675: @123599
     /* 123599 */ GIM_Reject,
     /* 123600 */ // Label 2673: @123600
     /* 123600 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(123933),
     /* 123605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 123608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 123611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s8,
     /* 123614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123622 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(123691), // Rule ID 865 //
     /* 123627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 123653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123657 */     // MIs[2] Operand 1
     /* 123657 */     // No operand predicates
     /* 123657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123666 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src3)  =>  (SHRD64mri8_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mri8_ND),
     /* 123669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src3
     /* 123680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 123689 */     GIR_RootConstrainSelectedInstOperands,
     /* 123690 */     // GIR_Coverage, 865,
     /* 123690 */     GIR_EraseRootFromParent_Done,
     /* 123691 */   // Label 2683: @123691
     /* 123691 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(123766), // Rule ID 868 //
     /* 123696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 123703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 123707 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 123714 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 123718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123724 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 123731 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (SHRD64mrCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123735 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64mrCL_ND),
     /* 123748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 123754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 123764 */     GIR_RootConstrainSelectedInstOperands,
     /* 123765 */     // GIR_Coverage, 868,
     /* 123765 */     GIR_EraseRootFromParent_Done,
     /* 123766 */   // Label 2684: @123766
     /* 123766 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(123805), // Rule ID 847 //
     /* 123771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123786 */     // MIs[1] Operand 1
     /* 123786 */     // No operand predicates
     /* 123786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123788 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8),
     /* 123791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123793 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123803 */     GIR_RootConstrainSelectedInstOperands,
     /* 123804 */     // GIR_Coverage, 847,
     /* 123804 */     GIR_EraseRootFromParent_Done,
     /* 123805 */   // Label 2685: @123805
     /* 123805 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(123844), // Rule ID 853 //
     /* 123810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 123821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123825 */     // MIs[1] Operand 1
     /* 123825 */     // No operand predicates
     /* 123825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 123827 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src3)  =>  (SHRD64rri8_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2, (imm:{ *:[i8] }):$src3)
     /* 123827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rri8_ND),
     /* 123830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123832 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123834 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src3
     /* 123839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123842 */     GIR_RootConstrainSelectedInstOperands,
     /* 123843 */     // GIR_Coverage, 853,
     /* 123843 */     GIR_EraseRootFromParent_Done,
     /* 123844 */   // Label 2686: @123844
     /* 123844 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(123888), // Rule ID 850 //
     /* 123849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 123852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123860 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123864 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL),
     /* 123877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123879 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123886 */     GIR_RootConstrainSelectedInstOperands,
     /* 123887 */     // GIR_Coverage, 850,
     /* 123887 */     GIR_EraseRootFromParent_Done,
     /* 123888 */   // Label 2687: @123888
     /* 123888 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(123932), // Rule ID 856 //
     /* 123893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 123896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 123900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 123904 */     // (fshr:{ *:[i64] } GR64:{ *:[i64] }:$src2, GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (SHRD64rrCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, GR64:{ *:[i64] }:$src2)
     /* 123904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123908 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // CL
     /* 123918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRD64rrCL_ND),
     /* 123921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 123925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 123927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 123930 */     GIR_RootConstrainSelectedInstOperands,
     /* 123931 */     // GIR_Coverage, 856,
     /* 123931 */     GIR_EraseRootFromParent_Done,
     /* 123932 */   // Label 2688: @123932
     /* 123932 */   GIM_Reject,
     /* 123933 */ // Label 2682: @123933
     /* 123933 */ GIM_Reject,
     /* 123934 */ // Label 2674: @123934
     /* 123934 */ GIM_Reject,
     /* 123935 */ // Label 31: @123935
     /* 123935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2699*/ GIMT_Encode4(127432),
     /* 123946 */ /*GILLT_s8*//*Label 2689*/ GIMT_Encode4(124022),
     /* 123950 */ /*GILLT_s16*//*Label 2690*/ GIMT_Encode4(124452),
     /* 123954 */ /*GILLT_s32*//*Label 2691*/ GIMT_Encode4(124882),
     /* 123958 */ /*GILLT_s64*//*Label 2692*/ GIMT_Encode4(125545), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123974 */ /*GILLT_v2s64*//*Label 2693*/ GIMT_Encode4(126208), GIMT_Encode4(0),
     /* 123982 */ /*GILLT_v4s32*//*Label 2694*/ GIMT_Encode4(126475),
     /* 123986 */ /*GILLT_v4s64*//*Label 2695*/ GIMT_Encode4(126742), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123998 */ /*GILLT_v8s32*//*Label 2696*/ GIMT_Encode4(126993),
     /* 124002 */ /*GILLT_v8s64*//*Label 2697*/ GIMT_Encode4(127244), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124018 */ /*GILLT_v16s32*//*Label 2698*/ GIMT_Encode4(127338),
     /* 124022 */ // Label 2689: @124022
     /* 124022 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(124451),
     /* 124027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 124030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124037 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(124096), // Rule ID 17624 //
     /* 124042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124056 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124060 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124077 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROL8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8m1_ND),
     /* 124080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124094 */     GIR_RootConstrainSelectedInstOperands,
     /* 124095 */     // GIR_Coverage, 17624,
     /* 124095 */     GIR_EraseRootFromParent_Done,
     /* 124096 */   // Label 2701: @124096
     /* 124096 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(124163), // Rule ID 801 //
     /* 124101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124119 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124131 */     // MIs[2] Operand 1
     /* 124131 */     // No operand predicates
     /* 124131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124140 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROR8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mi_ND),
     /* 124143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124145 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124161 */     GIR_RootConstrainSelectedInstOperands,
     /* 124162 */     // GIR_Coverage, 801,
     /* 124162 */     GIR_EraseRootFromParent_Done,
     /* 124163 */   // Label 2702: @124163
     /* 124163 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(124236), // Rule ID 817 //
     /* 124168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124179 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124186 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 124190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124196 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124203 */     // (rotr:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROR8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124207 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124213 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8mCL_ND),
     /* 124220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124222 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124234 */     GIR_RootConstrainSelectedInstOperands,
     /* 124235 */     // GIR_Coverage, 817,
     /* 124235 */     GIR_EraseRootFromParent_Done,
     /* 124236 */   // Label 2703: @124236
     /* 124236 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(124264), // Rule ID 17600 //
     /* 124241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124252 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124257 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124262 */     GIR_RootConstrainSelectedInstOperands,
     /* 124263 */     // GIR_Coverage, 17600,
     /* 124263 */     GIR_EraseRootFromParent_Done,
     /* 124264 */   // Label 2704: @124264
     /* 124264 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(124292), // Rule ID 17608 //
     /* 124269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 124280 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROL8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8r1_ND),
     /* 124283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124290 */     GIR_RootConstrainSelectedInstOperands,
     /* 124291 */     // GIR_Coverage, 17608,
     /* 124291 */     GIR_EraseRootFromParent_Done,
     /* 124292 */   // Label 2705: @124292
     /* 124292 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(124329), // Rule ID 789 //
     /* 124297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124312 */     // MIs[1] Operand 1
     /* 124312 */     // No operand predicates
     /* 124312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124314 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri),
     /* 124317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124327 */     GIR_RootConstrainSelectedInstOperands,
     /* 124328 */     // GIR_Coverage, 789,
     /* 124328 */     GIR_EraseRootFromParent_Done,
     /* 124329 */   // Label 2706: @124329
     /* 124329 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(124366), // Rule ID 793 //
     /* 124334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124349 */     // MIs[1] Operand 1
     /* 124349 */     // No operand predicates
     /* 124349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124351 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8ri_ND),
     /* 124354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124356 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124364 */     GIR_RootConstrainSelectedInstOperands,
     /* 124365 */     // GIR_Coverage, 793,
     /* 124365 */     GIR_EraseRootFromParent_Done,
     /* 124366 */   // Label 2707: @124366
     /* 124366 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(124408), // Rule ID 805 //
     /* 124371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124382 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124386 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL),
     /* 124399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124401 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124403 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124406 */     GIR_RootConstrainSelectedInstOperands,
     /* 124407 */     // GIR_Coverage, 805,
     /* 124407 */     GIR_EraseRootFromParent_Done,
     /* 124408 */   // Label 2708: @124408
     /* 124408 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(124450), // Rule ID 809 //
     /* 124413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 124420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124424 */     // (rotr:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROR8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 124424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124428 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8rCL_ND),
     /* 124441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124448 */     GIR_RootConstrainSelectedInstOperands,
     /* 124449 */     // GIR_Coverage, 809,
     /* 124449 */     GIR_EraseRootFromParent_Done,
     /* 124450 */   // Label 2709: @124450
     /* 124450 */   GIM_Reject,
     /* 124451 */ // Label 2700: @124451
     /* 124451 */ GIM_Reject,
     /* 124452 */ // Label 2690: @124452
     /* 124452 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(124881),
     /* 124457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 124460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124467 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(124526), // Rule ID 17625 //
     /* 124472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124483 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124490 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124507 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROL16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16m1_ND),
     /* 124510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124524 */     GIR_RootConstrainSelectedInstOperands,
     /* 124525 */     // GIR_Coverage, 17625,
     /* 124525 */     GIR_EraseRootFromParent_Done,
     /* 124526 */   // Label 2711: @124526
     /* 124526 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(124593), // Rule ID 802 //
     /* 124531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124549 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124561 */     // MIs[2] Operand 1
     /* 124561 */     // No operand predicates
     /* 124561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124570 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROR16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mi_ND),
     /* 124573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124575 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 124582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 124591 */     GIR_RootConstrainSelectedInstOperands,
     /* 124592 */     // GIR_Coverage, 802,
     /* 124592 */     GIR_EraseRootFromParent_Done,
     /* 124593 */   // Label 2712: @124593
     /* 124593 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(124666), // Rule ID 818 //
     /* 124598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124612 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124616 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 124620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124633 */     // (rotr:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROR16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 124633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124637 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124643 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16mCL_ND),
     /* 124650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124652 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 124656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 124665 */     // GIR_Coverage, 818,
     /* 124665 */     GIR_EraseRootFromParent_Done,
     /* 124666 */   // Label 2713: @124666
     /* 124666 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(124694), // Rule ID 17601 //
     /* 124671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124678 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124682 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1),
     /* 124685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124692 */     GIR_RootConstrainSelectedInstOperands,
     /* 124693 */     // GIR_Coverage, 17601,
     /* 124693 */     GIR_EraseRootFromParent_Done,
     /* 124694 */   // Label 2714: @124694
     /* 124694 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(124722), // Rule ID 17609 //
     /* 124699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 124710 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROL16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16r1_ND),
     /* 124713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124720 */     GIR_RootConstrainSelectedInstOperands,
     /* 124721 */     // GIR_Coverage, 17609,
     /* 124721 */     GIR_EraseRootFromParent_Done,
     /* 124722 */   // Label 2715: @124722
     /* 124722 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(124759), // Rule ID 790 //
     /* 124727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124742 */     // MIs[1] Operand 1
     /* 124742 */     // No operand predicates
     /* 124742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124744 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri),
     /* 124747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124757 */     GIR_RootConstrainSelectedInstOperands,
     /* 124758 */     // GIR_Coverage, 790,
     /* 124758 */     GIR_EraseRootFromParent_Done,
     /* 124759 */   // Label 2716: @124759
     /* 124759 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(124796), // Rule ID 794 //
     /* 124764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124779 */     // MIs[1] Operand 1
     /* 124779 */     // No operand predicates
     /* 124779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124781 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 124781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16ri_ND),
     /* 124784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 124791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124794 */     GIR_RootConstrainSelectedInstOperands,
     /* 124795 */     // GIR_Coverage, 794,
     /* 124795 */     GIR_EraseRootFromParent_Done,
     /* 124796 */   // Label 2717: @124796
     /* 124796 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(124838), // Rule ID 806 //
     /* 124801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 124804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124812 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124816 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL),
     /* 124829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124833 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124836 */     GIR_RootConstrainSelectedInstOperands,
     /* 124837 */     // GIR_Coverage, 806,
     /* 124837 */     GIR_EraseRootFromParent_Done,
     /* 124838 */   // Label 2718: @124838
     /* 124838 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(124880), // Rule ID 810 //
     /* 124843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 124850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 124854 */     // (rotr:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROR16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 124854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 124868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16rCL_ND),
     /* 124871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 124875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124878 */     GIR_RootConstrainSelectedInstOperands,
     /* 124879 */     // GIR_Coverage, 810,
     /* 124879 */     GIR_EraseRootFromParent_Done,
     /* 124880 */   // Label 2719: @124880
     /* 124880 */   GIM_Reject,
     /* 124881 */ // Label 2710: @124881
     /* 124881 */ GIM_Reject,
     /* 124882 */ // Label 2691: @124882
     /* 124882 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(125544),
     /* 124887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 124890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 124893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 124897 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(124956), // Rule ID 17626 //
     /* 124902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 124905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124920 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 124928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124930 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 124937 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROL32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 124937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32m1_ND),
     /* 124940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 124946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 124949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 124954 */     GIR_RootConstrainSelectedInstOperands,
     /* 124955 */     // GIR_Coverage, 17626,
     /* 124955 */     GIR_EraseRootFromParent_Done,
     /* 124956 */   // Label 2721: @124956
     /* 124956 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(125023), // Rule ID 803 //
     /* 124961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 124964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 124972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 124979 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 124983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 124987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 124991 */     // MIs[2] Operand 1
     /* 124991 */     // No operand predicates
     /* 124991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 124993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125000 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROR32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mi_ND),
     /* 125003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125021 */     GIR_RootConstrainSelectedInstOperands,
     /* 125022 */     // GIR_Coverage, 803,
     /* 125022 */     GIR_EraseRootFromParent_Done,
     /* 125023 */   // Label 2722: @125023
     /* 125023 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(125087), // Rule ID 17648 //
     /* 125028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125042 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125046 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125058 */     // MIs[2] Operand 1
     /* 125058 */     // No operand predicates
     /* 125058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125067 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi),
     /* 125070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125085 */     GIR_RootConstrainSelectedInstOperands,
     /* 125086 */     // GIR_Coverage, 17648,
     /* 125086 */     GIR_EraseRootFromParent_Done,
     /* 125087 */   // Label 2723: @125087
     /* 125087 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(125151), // Rule ID 17680 //
     /* 125092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125103 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125110 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125122 */     // MIs[2] Operand 1
     /* 125122 */     // No operand predicates
     /* 125122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125131 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX32mi_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32mi_EVEX),
     /* 125134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125149 */     GIR_RootConstrainSelectedInstOperands,
     /* 125150 */     // GIR_Coverage, 17680,
     /* 125150 */     GIR_EraseRootFromParent_Done,
     /* 125151 */   // Label 2724: @125151
     /* 125151 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(125224), // Rule ID 819 //
     /* 125156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125167 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125170 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125174 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 125178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125191 */     // (rotr:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROR32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125195 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32mCL_ND),
     /* 125208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125217 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125222 */     GIR_RootConstrainSelectedInstOperands,
     /* 125223 */     // GIR_Coverage, 819,
     /* 125223 */     GIR_EraseRootFromParent_Done,
     /* 125224 */   // Label 2725: @125224
     /* 125224 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(125258), // Rule ID 17644 //
     /* 125229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125244 */     // MIs[1] Operand 1
     /* 125244 */     // No operand predicates
     /* 125244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125246 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri),
     /* 125249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125256 */     GIR_RootConstrainSelectedInstOperands,
     /* 125257 */     // GIR_Coverage, 17644,
     /* 125257 */     GIR_EraseRootFromParent_Done,
     /* 125258 */   // Label 2726: @125258
     /* 125258 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(125292), // Rule ID 17676 //
     /* 125263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125278 */     // MIs[1] Operand 1
     /* 125278 */     // No operand predicates
     /* 125278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125280 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX32ri_EVEX:{ *:[i32] } GR32:{ *:[i32] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX32ri_EVEX),
     /* 125283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125285 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125290 */     GIR_RootConstrainSelectedInstOperands,
     /* 125291 */     // GIR_Coverage, 17676,
     /* 125291 */     GIR_EraseRootFromParent_Done,
     /* 125292 */   // Label 2727: @125292
     /* 125292 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(125329), // Rule ID 871 //
     /* 125297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125312 */     // MIs[1] Operand 1
     /* 125312 */     // No operand predicates
     /* 125312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125314 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT32ri),
     /* 125317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125319 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125327 */     GIR_RootConstrainSelectedInstOperands,
     /* 125328 */     // GIR_Coverage, 871,
     /* 125328 */     GIR_EraseRootFromParent_Done,
     /* 125329 */   // Label 2728: @125329
     /* 125329 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(125357), // Rule ID 17602 //
     /* 125334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125345 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1),
     /* 125348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125355 */     GIR_RootConstrainSelectedInstOperands,
     /* 125356 */     // GIR_Coverage, 17602,
     /* 125356 */     GIR_EraseRootFromParent_Done,
     /* 125357 */   // Label 2729: @125357
     /* 125357 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(125385), // Rule ID 17610 //
     /* 125362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 125373 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROL32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32r1_ND),
     /* 125376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125383 */     GIR_RootConstrainSelectedInstOperands,
     /* 125384 */     // GIR_Coverage, 17610,
     /* 125384 */     GIR_EraseRootFromParent_Done,
     /* 125385 */   // Label 2730: @125385
     /* 125385 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(125422), // Rule ID 791 //
     /* 125390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125405 */     // MIs[1] Operand 1
     /* 125405 */     // No operand predicates
     /* 125405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125407 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri),
     /* 125410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125420 */     GIR_RootConstrainSelectedInstOperands,
     /* 125421 */     // GIR_Coverage, 791,
     /* 125421 */     GIR_EraseRootFromParent_Done,
     /* 125422 */   // Label 2731: @125422
     /* 125422 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(125459), // Rule ID 795 //
     /* 125427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125442 */     // MIs[1] Operand 1
     /* 125442 */     // No operand predicates
     /* 125442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125444 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32ri_ND),
     /* 125447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 125454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125457 */     GIR_RootConstrainSelectedInstOperands,
     /* 125458 */     // GIR_Coverage, 795,
     /* 125458 */     GIR_EraseRootFromParent_Done,
     /* 125459 */   // Label 2732: @125459
     /* 125459 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(125501), // Rule ID 807 //
     /* 125464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 125467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125475 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125479 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL),
     /* 125492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125494 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125499 */     GIR_RootConstrainSelectedInstOperands,
     /* 125500 */     // GIR_Coverage, 807,
     /* 125500 */     GIR_EraseRootFromParent_Done,
     /* 125501 */   // Label 2733: @125501
     /* 125501 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(125543), // Rule ID 811 //
     /* 125506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 125513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125517 */     // (rotr:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROR32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 125517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125521 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125527 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32rCL_ND),
     /* 125534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125541 */     GIR_RootConstrainSelectedInstOperands,
     /* 125542 */     // GIR_Coverage, 811,
     /* 125542 */     GIR_EraseRootFromParent_Done,
     /* 125543 */   // Label 2734: @125543
     /* 125543 */   GIM_Reject,
     /* 125544 */ // Label 2720: @125544
     /* 125544 */ GIM_Reject,
     /* 125545 */ // Label 2692: @125545
     /* 125545 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(126207),
     /* 125550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 125553 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 125556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125560 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(125619), // Rule ID 17627 //
     /* 125565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 125568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 125591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125600 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROL64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 125600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64m1_ND),
     /* 125603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125617 */     GIR_RootConstrainSelectedInstOperands,
     /* 125618 */     // GIR_Coverage, 17627,
     /* 125618 */     GIR_EraseRootFromParent_Done,
     /* 125619 */   // Label 2736: @125619
     /* 125619 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(125686), // Rule ID 804 //
     /* 125624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125654 */     // MIs[2] Operand 1
     /* 125654 */     // No operand predicates
     /* 125654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125663 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROR64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 125663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mi_ND),
     /* 125666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125668 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125672 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 125675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125684 */     GIR_RootConstrainSelectedInstOperands,
     /* 125685 */     // GIR_Coverage, 804,
     /* 125685 */     GIR_EraseRootFromParent_Done,
     /* 125686 */   // Label 2737: @125686
     /* 125686 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(125750), // Rule ID 17649 //
     /* 125691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125721 */     // MIs[2] Operand 1
     /* 125721 */     // No operand predicates
     /* 125721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125723 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125730 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi),
     /* 125733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125735 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125748 */     GIR_RootConstrainSelectedInstOperands,
     /* 125749 */     // GIR_Coverage, 17649,
     /* 125749 */     GIR_EraseRootFromParent_Done,
     /* 125750 */   // Label 2738: @125750
     /* 125750 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(125814), // Rule ID 17681 //
     /* 125755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 125781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125785 */     // MIs[2] Operand 1
     /* 125785 */     // No operand predicates
     /* 125785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 125787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125794 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$shamt)  =>  (RORX64mi_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64mi_EVEX),
     /* 125797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125799 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 125803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 125806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 125812 */     GIR_RootConstrainSelectedInstOperands,
     /* 125813 */     // GIR_Coverage, 17681,
     /* 125813 */     GIR_EraseRootFromParent_Done,
     /* 125814 */   // Label 2739: @125814
     /* 125814 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(125887), // Rule ID 820 //
     /* 125819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 125822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 125830 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125833 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 125837 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 125841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 125845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125847 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 125854 */     // (rotr:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROR64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 125854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 125868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64mCL_ND),
     /* 125871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125873 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 125877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 125885 */     GIR_RootConstrainSelectedInstOperands,
     /* 125886 */     // GIR_Coverage, 820,
     /* 125886 */     GIR_EraseRootFromParent_Done,
     /* 125887 */   // Label 2740: @125887
     /* 125887 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(125921), // Rule ID 17645 //
     /* 125892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_NoEGPR),
     /* 125895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125907 */     // MIs[1] Operand 1
     /* 125907 */     // No operand predicates
     /* 125907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125909 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri),
     /* 125912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125914 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125919 */     GIR_RootConstrainSelectedInstOperands,
     /* 125920 */     // GIR_Coverage, 17645,
     /* 125920 */     GIR_EraseRootFromParent_Done,
     /* 125921 */   // Label 2741: @125921
     /* 125921 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(125955), // Rule ID 17677 //
     /* 125926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI2_HasEGPR),
     /* 125929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125941 */     // MIs[1] Operand 1
     /* 125941 */     // No operand predicates
     /* 125941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125943 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)  =>  (RORX64ri_EVEX:{ *:[i64] } GR64:{ *:[i64] }:$src, (imm:{ *:[i8] }):$shamt)
     /* 125943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::RORX64ri_EVEX),
     /* 125946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 125950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125953 */     GIR_RootConstrainSelectedInstOperands,
     /* 125954 */     // GIR_Coverage, 17677,
     /* 125954 */     GIR_EraseRootFromParent_Done,
     /* 125955 */   // Label 2742: @125955
     /* 125955 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(125992), // Rule ID 872 //
     /* 125960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 125963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 125967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 125975 */     // MIs[1] Operand 1
     /* 125975 */     // No operand predicates
     /* 125975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125977 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHRDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 125977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHRDROT64ri),
     /* 125980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 125984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 125987 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 125990 */     GIR_RootConstrainSelectedInstOperands,
     /* 125991 */     // GIR_Coverage, 872,
     /* 125991 */     GIR_EraseRootFromParent_Done,
     /* 125992 */   // Label 2743: @125992
     /* 125992 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(126020), // Rule ID 17603 //
     /* 125997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 126008 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1),
     /* 126011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126013 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126018 */     GIR_RootConstrainSelectedInstOperands,
     /* 126019 */     // GIR_Coverage, 17603,
     /* 126019 */     GIR_EraseRootFromParent_Done,
     /* 126020 */   // Label 2744: @126020
     /* 126020 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(126048), // Rule ID 17611 //
     /* 126025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 126028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 126036 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROL64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64r1_ND),
     /* 126039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126043 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126046 */     GIR_RootConstrainSelectedInstOperands,
     /* 126047 */     // GIR_Coverage, 17611,
     /* 126047 */     GIR_EraseRootFromParent_Done,
     /* 126048 */   // Label 2745: @126048
     /* 126048 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(126085), // Rule ID 792 //
     /* 126053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126068 */     // MIs[1] Operand 1
     /* 126068 */     // No operand predicates
     /* 126068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126070 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri),
     /* 126073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126083 */     GIR_RootConstrainSelectedInstOperands,
     /* 126084 */     // GIR_Coverage, 792,
     /* 126084 */     GIR_EraseRootFromParent_Done,
     /* 126085 */   // Label 2746: @126085
     /* 126085 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(126122), // Rule ID 796 //
     /* 126090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126105 */     // MIs[1] Operand 1
     /* 126105 */     // No operand predicates
     /* 126105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126107 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROR64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 126107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64ri_ND),
     /* 126110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126112 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 126117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126120 */     GIR_RootConstrainSelectedInstOperands,
     /* 126121 */     // GIR_Coverage, 796,
     /* 126121 */     GIR_EraseRootFromParent_Done,
     /* 126122 */   // Label 2747: @126122
     /* 126122 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(126164), // Rule ID 808 //
     /* 126127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 126130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126138 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126142 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL),
     /* 126155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126162 */     GIR_RootConstrainSelectedInstOperands,
     /* 126163 */     // GIR_Coverage, 808,
     /* 126163 */     GIR_EraseRootFromParent_Done,
     /* 126164 */   // Label 2748: @126164
     /* 126164 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(126206), // Rule ID 812 //
     /* 126169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 126172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 126176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 126180 */     // (rotr:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROR64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 126180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126184 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126190 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 126194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64rCL_ND),
     /* 126197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 126204 */     GIR_RootConstrainSelectedInstOperands,
     /* 126205 */     // GIR_Coverage, 812,
     /* 126205 */     GIR_EraseRootFromParent_Done,
     /* 126206 */   // Label 2749: @126206
     /* 126206 */   GIM_Reject,
     /* 126207 */ // Label 2735: @126207
     /* 126207 */ GIM_Reject,
     /* 126208 */ // Label 2693: @126208
     /* 126208 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(126474),
     /* 126213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 126216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 126219 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(126281), // Rule ID 8005 //
     /* 126224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126243 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126246 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126263 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rm),
     /* 126266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126279 */     GIR_RootConstrainSelectedInstOperands,
     /* 126280 */     // GIR_Coverage, 8005,
     /* 126280 */     GIR_EraseRootFromParent_Done,
     /* 126281 */   // Label 2751: @126281
     /* 126281 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(126308), // Rule ID 8002 //
     /* 126286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126301 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPRORVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 126301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ128rr),
     /* 126306 */     GIR_RootConstrainSelectedInstOperands,
     /* 126307 */     // GIR_Coverage, 8002,
     /* 126307 */     GIR_Done,
     /* 126308 */   // Label 2752: @126308
     /* 126308 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(126473), // Rule ID 20804 //
     /* 126313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126328 */     // (rotr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126328 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126331 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126335 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126342 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126345 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126349 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126354 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126357 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126361 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126364 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126369 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126374 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126379 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126382 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126386 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126405 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126408 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126412 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126425 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126442 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126455 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126472 */     // GIR_Coverage, 20804,
     /* 126472 */     GIR_EraseRootFromParent_Done,
     /* 126473 */   // Label 2753: @126473
     /* 126473 */   GIM_Reject,
     /* 126474 */ // Label 2750: @126474
     /* 126474 */ GIM_Reject,
     /* 126475 */ // Label 2694: @126475
     /* 126475 */ GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(126741),
     /* 126480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126483 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 126486 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(126548), // Rule ID 7978 //
     /* 126491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126530 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rm),
     /* 126533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126535 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126546 */     GIR_RootConstrainSelectedInstOperands,
     /* 126547 */     // GIR_Coverage, 7978,
     /* 126547 */     GIR_EraseRootFromParent_Done,
     /* 126548 */   // Label 2755: @126548
     /* 126548 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(126575), // Rule ID 7975 //
     /* 126553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126568 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPRORVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 126568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ128rr),
     /* 126573 */     GIR_RootConstrainSelectedInstOperands,
     /* 126574 */     // GIR_Coverage, 7975,
     /* 126574 */     GIR_Done,
     /* 126575 */   // Label 2756: @126575
     /* 126575 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(126740), // Rule ID 20806 //
     /* 126580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 126587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 126595 */     // (rotr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 126595 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 126598 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126602 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126609 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 126612 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126616 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126621 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126624 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126628 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 126631 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126636 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126641 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126646 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 126649 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126653 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 126663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126672 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 126682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 126697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 126700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 126704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 126729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 126734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126739 */     // GIR_Coverage, 20806,
     /* 126739 */     GIR_EraseRootFromParent_Done,
     /* 126740 */   // Label 2757: @126740
     /* 126740 */   GIM_Reject,
     /* 126741 */ // Label 2754: @126741
     /* 126741 */ GIM_Reject,
     /* 126742 */ // Label 2695: @126742
     /* 126742 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(126992),
     /* 126747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 126750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 126753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126761 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(126815), // Rule ID 7996 //
     /* 126766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 126777 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 126784 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 126788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 126797 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 126797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rm),
     /* 126800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126804 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 126808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 126813 */     GIR_RootConstrainSelectedInstOperands,
     /* 126814 */     // GIR_Coverage, 7996,
     /* 126814 */     GIR_EraseRootFromParent_Done,
     /* 126815 */   // Label 2759: @126815
     /* 126815 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(126834), // Rule ID 7993 //
     /* 126820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 126823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126827 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPRORVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 126827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZ256rr),
     /* 126832 */     GIR_RootConstrainSelectedInstOperands,
     /* 126833 */     // GIR_Coverage, 7993,
     /* 126833 */     GIR_Done,
     /* 126834 */   // Label 2760: @126834
     /* 126834 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(126991), // Rule ID 20805 //
     /* 126839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 126842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 126846 */     // (rotr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPRORVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 126846 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 126849 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126853 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 126860 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 126863 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126867 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126872 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 126875 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 126879 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 126882 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126887 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126892 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126897 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 126900 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126904 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126911 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 126914 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 126918 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126923 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 126926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 126930 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 126933 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 126938 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 126951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 126955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126960 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 126963 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 126966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126973 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 126980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 126985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 126990 */     // GIR_Coverage, 20805,
     /* 126990 */     GIR_EraseRootFromParent_Done,
     /* 126991 */   // Label 2761: @126991
     /* 126991 */   GIM_Reject,
     /* 126992 */ // Label 2758: @126992
     /* 126992 */ GIM_Reject,
     /* 126993 */ // Label 2696: @126993
     /* 126993 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(127243),
     /* 126998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 127001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 127004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127012 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(127066), // Rule ID 7969 //
     /* 127017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127048 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rm),
     /* 127051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127064 */     GIR_RootConstrainSelectedInstOperands,
     /* 127065 */     // GIR_Coverage, 7969,
     /* 127065 */     GIR_EraseRootFromParent_Done,
     /* 127066 */   // Label 2763: @127066
     /* 127066 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(127085), // Rule ID 7966 //
     /* 127071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 127074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127078 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPRORVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 127078 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZ256rr),
     /* 127083 */     GIR_RootConstrainSelectedInstOperands,
     /* 127084 */     // GIR_Coverage, 7966,
     /* 127084 */     GIR_Done,
     /* 127085 */   // Label 2764: @127085
     /* 127085 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(127242), // Rule ID 20807 //
     /* 127090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 127093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 127097 */     // (rotr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPRORVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 127097 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 127100 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127104 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 127111 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 127114 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127118 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127123 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 127126 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 127130 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 127133 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127138 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127143 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127148 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 127151 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127155 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127162 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 127165 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 127169 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127174 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 127177 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 127181 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 127184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 127189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 127202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 127214 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 127217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127224 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 127231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 127236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 127241 */     // GIR_Coverage, 20807,
     /* 127241 */     GIR_EraseRootFromParent_Done,
     /* 127242 */   // Label 2765: @127242
     /* 127242 */   GIM_Reject,
     /* 127243 */ // Label 2762: @127243
     /* 127243 */ GIM_Reject,
     /* 127244 */ // Label 2697: @127244
     /* 127244 */ GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(127337),
     /* 127249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 127252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 127255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127263 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(127317), // Rule ID 7987 //
     /* 127268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127279 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127282 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127286 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127299 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrm),
     /* 127302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127304 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127315 */     GIR_RootConstrainSelectedInstOperands,
     /* 127316 */     // GIR_Coverage, 7987,
     /* 127316 */     GIR_EraseRootFromParent_Done,
     /* 127317 */   // Label 2767: @127317
     /* 127317 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(127336), // Rule ID 7984 //
     /* 127322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127329 */     // (rotr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPRORVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 127329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVQZrr),
     /* 127334 */     GIR_RootConstrainSelectedInstOperands,
     /* 127335 */     // GIR_Coverage, 7984,
     /* 127335 */     GIR_Done,
     /* 127336 */   // Label 2768: @127336
     /* 127336 */   GIM_Reject,
     /* 127337 */ // Label 2766: @127337
     /* 127337 */ GIM_Reject,
     /* 127338 */ // Label 2698: @127338
     /* 127338 */ GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(127431),
     /* 127343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 127346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 127349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127357 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(127411), // Rule ID 7960 //
     /* 127362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 127380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127386 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127393 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPRORVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 127393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrm),
     /* 127396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127398 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127400 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 127404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127409 */     GIR_RootConstrainSelectedInstOperands,
     /* 127410 */     // GIR_Coverage, 7960,
     /* 127410 */     GIR_EraseRootFromParent_Done,
     /* 127411 */   // Label 2770: @127411
     /* 127411 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(127430), // Rule ID 7957 //
     /* 127416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 127419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 127423 */     // (rotr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPRORVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 127423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPRORVDZrr),
     /* 127428 */     GIR_RootConstrainSelectedInstOperands,
     /* 127429 */     // GIR_Coverage, 7957,
     /* 127429 */     GIR_Done,
     /* 127430 */   // Label 2771: @127430
     /* 127430 */   GIM_Reject,
     /* 127431 */ // Label 2769: @127431
     /* 127431 */ GIM_Reject,
     /* 127432 */ // Label 2699: @127432
     /* 127432 */ GIM_Reject,
     /* 127433 */ // Label 32: @127433
     /* 127433 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(20), /*)*//*default:*//*Label 2784*/ GIMT_Encode4(131152),
     /* 127444 */ /*GILLT_s8*//*Label 2772*/ GIMT_Encode4(127520),
     /* 127448 */ /*GILLT_s16*//*Label 2773*/ GIMT_Encode4(127950),
     /* 127452 */ /*GILLT_s32*//*Label 2774*/ GIMT_Encode4(128380),
     /* 127456 */ /*GILLT_s64*//*Label 2775*/ GIMT_Encode4(128847), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127472 */ /*GILLT_v2s64*//*Label 2776*/ GIMT_Encode4(129314), GIMT_Encode4(0),
     /* 127480 */ /*GILLT_v4s32*//*Label 2777*/ GIMT_Encode4(129732),
     /* 127484 */ /*GILLT_v4s64*//*Label 2778*/ GIMT_Encode4(130150), GIMT_Encode4(0),
     /* 127492 */ /*GILLT_v8s16*//*Label 2779*/ GIMT_Encode4(130401),
     /* 127496 */ /*GILLT_v8s32*//*Label 2780*/ GIMT_Encode4(130557),
     /* 127500 */ /*GILLT_v8s64*//*Label 2781*/ GIMT_Encode4(130808), GIMT_Encode4(0),
     /* 127508 */ /*GILLT_v16s8*//*Label 2782*/ GIMT_Encode4(130902), GIMT_Encode4(0),
     /* 127516 */ /*GILLT_v16s32*//*Label 2783*/ GIMT_Encode4(131058),
     /* 127520 */ // Label 2772: @127520
     /* 127520 */ GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(127949),
     /* 127525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 127528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127535 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(127594), // Rule ID 17620 //
     /* 127540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127558 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127568 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127575 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, 7:{ *:[i8] })  =>  (ROR8m1_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 127575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8m1_ND),
     /* 127578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 127584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127592 */     GIR_RootConstrainSelectedInstOperands,
     /* 127593 */     // GIR_Coverage, 17620,
     /* 127593 */     GIR_EraseRootFromParent_Done,
     /* 127594 */   // Label 2786: @127594
     /* 127594 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(127661), // Rule ID 769 //
     /* 127599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127617 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 127625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127629 */     // MIs[2] Operand 1
     /* 127629 */     // No operand predicates
     /* 127629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 127631 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127638 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, (imm:{ *:[i8] }):$src2)  =>  (ROL8mi_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mi_ND),
     /* 127641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 127650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127653 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 127659 */     GIR_RootConstrainSelectedInstOperands,
     /* 127660 */     // GIR_Coverage, 769,
     /* 127660 */     GIR_EraseRootFromParent_Done,
     /* 127661 */   // Label 2787: @127661
     /* 127661 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(127734), // Rule ID 785 //
     /* 127666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127677 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127680 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127684 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi8),
     /* 127688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 127701 */     // (rotl:{ *:[i8] } (ld:{ *:[i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi8>>, CL:{ *:[i8] })  =>  (ROL8mCL_ND:{ *:[i8] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 127701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127705 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8mCL_ND),
     /* 127718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 127724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 127732 */     GIR_RootConstrainSelectedInstOperands,
     /* 127733 */     // GIR_Coverage, 785,
     /* 127733 */     GIR_EraseRootFromParent_Done,
     /* 127734 */   // Label 2788: @127734
     /* 127734 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(127762), // Rule ID 17596 //
     /* 127739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127750 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1),
     /* 127753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127755 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127760 */     GIR_RootConstrainSelectedInstOperands,
     /* 127761 */     // GIR_Coverage, 17596,
     /* 127761 */     GIR_EraseRootFromParent_Done,
     /* 127762 */   // Label 2789: @127762
     /* 127762 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(127790), // Rule ID 17604 //
     /* 127767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 7,
     /* 127778 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, 7:{ *:[i8] })  =>  (ROR8r1_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR8r1_ND),
     /* 127781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127788 */     GIR_RootConstrainSelectedInstOperands,
     /* 127789 */     // GIR_Coverage, 17604,
     /* 127789 */     GIR_EraseRootFromParent_Done,
     /* 127790 */   // Label 2790: @127790
     /* 127790 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(127827), // Rule ID 757 //
     /* 127795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127810 */     // MIs[1] Operand 1
     /* 127810 */     // No operand predicates
     /* 127810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127812 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri),
     /* 127815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127825 */     GIR_RootConstrainSelectedInstOperands,
     /* 127826 */     // GIR_Coverage, 757,
     /* 127826 */     GIR_EraseRootFromParent_Done,
     /* 127827 */   // Label 2791: @127827
     /* 127827 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(127864), // Rule ID 761 //
     /* 127832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 127843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 127847 */     // MIs[1] Operand 1
     /* 127847 */     // No operand predicates
     /* 127847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127849 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL8ri_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 127849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8ri_ND),
     /* 127852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 127859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127862 */     GIR_RootConstrainSelectedInstOperands,
     /* 127863 */     // GIR_Coverage, 761,
     /* 127863 */     GIR_EraseRootFromParent_Done,
     /* 127864 */   // Label 2792: @127864
     /* 127864 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(127906), // Rule ID 773 //
     /* 127869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 127872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127880 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127884 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL),
     /* 127897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127899 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127901 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127904 */     GIR_RootConstrainSelectedInstOperands,
     /* 127905 */     // GIR_Coverage, 773,
     /* 127905 */     GIR_EraseRootFromParent_Done,
     /* 127906 */   // Label 2793: @127906
     /* 127906 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(127948), // Rule ID 777 //
     /* 127911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 127914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR8RegClassID),
     /* 127918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 127922 */     // (rotl:{ *:[i8] } GR8:{ *:[i8] }:$src1, CL:{ *:[i8] })  =>  (ROL8rCL_ND:{ *:[i8] }:{ *:[i32] } GR8:{ *:[i8] }:$src1)
     /* 127922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127926 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 127936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL8rCL_ND),
     /* 127939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 127943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 127946 */     GIR_RootConstrainSelectedInstOperands,
     /* 127947 */     // GIR_Coverage, 777,
     /* 127947 */     GIR_EraseRootFromParent_Done,
     /* 127948 */   // Label 2794: @127948
     /* 127948 */   GIM_Reject,
     /* 127949 */ // Label 2785: @127949
     /* 127949 */ GIM_Reject,
     /* 127950 */ // Label 2773: @127950
     /* 127950 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(128379),
     /* 127955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 127958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 127961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 127965 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(128024), // Rule ID 17621 //
     /* 127970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 127973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 127981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 127988 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 127992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 127996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128005 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, 15:{ *:[i8] })  =>  (ROR16m1_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16m1_ND),
     /* 128008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128010 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128022 */     GIR_RootConstrainSelectedInstOperands,
     /* 128023 */     // GIR_Coverage, 17621,
     /* 128023 */     GIR_EraseRootFromParent_Done,
     /* 128024 */   // Label 2796: @128024
     /* 128024 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(128091), // Rule ID 770 //
     /* 128029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128047 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128059 */     // MIs[2] Operand 1
     /* 128059 */     // No operand predicates
     /* 128059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128068 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, (imm:{ *:[i8] }):$src2)  =>  (ROL16mi_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mi_ND),
     /* 128071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128080 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128089 */     GIR_RootConstrainSelectedInstOperands,
     /* 128090 */     // GIR_Coverage, 770,
     /* 128090 */     GIR_EraseRootFromParent_Done,
     /* 128091 */   // Label 2797: @128091
     /* 128091 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(128164), // Rule ID 786 //
     /* 128096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128110 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128114 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 128118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128131 */     // (rotl:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>, CL:{ *:[i8] })  =>  (ROL16mCL_ND:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128135 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16mCL_ND),
     /* 128148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128162 */     GIR_RootConstrainSelectedInstOperands,
     /* 128163 */     // GIR_Coverage, 786,
     /* 128163 */     GIR_EraseRootFromParent_Done,
     /* 128164 */   // Label 2798: @128164
     /* 128164 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(128192), // Rule ID 17597 //
     /* 128169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128180 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1),
     /* 128183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128185 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128190 */     GIR_RootConstrainSelectedInstOperands,
     /* 128191 */     // GIR_Coverage, 17597,
     /* 128191 */     GIR_EraseRootFromParent_Done,
     /* 128192 */   // Label 2799: @128192
     /* 128192 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(128220), // Rule ID 17605 //
     /* 128197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 15,
     /* 128208 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, 15:{ *:[i8] })  =>  (ROR16r1_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR16r1_ND),
     /* 128211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128218 */     GIR_RootConstrainSelectedInstOperands,
     /* 128219 */     // GIR_Coverage, 17605,
     /* 128219 */     GIR_EraseRootFromParent_Done,
     /* 128220 */   // Label 2800: @128220
     /* 128220 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(128257), // Rule ID 758 //
     /* 128225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128240 */     // MIs[1] Operand 1
     /* 128240 */     // No operand predicates
     /* 128240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128242 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 128245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128255 */     GIR_RootConstrainSelectedInstOperands,
     /* 128256 */     // GIR_Coverage, 758,
     /* 128256 */     GIR_EraseRootFromParent_Done,
     /* 128257 */   // Label 2801: @128257
     /* 128257 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(128294), // Rule ID 762 //
     /* 128262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128277 */     // MIs[1] Operand 1
     /* 128277 */     // No operand predicates
     /* 128277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128279 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL16ri_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri_ND),
     /* 128282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128284 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128292 */     GIR_RootConstrainSelectedInstOperands,
     /* 128293 */     // GIR_Coverage, 762,
     /* 128293 */     GIR_EraseRootFromParent_Done,
     /* 128294 */   // Label 2802: @128294
     /* 128294 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(128336), // Rule ID 774 //
     /* 128299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128310 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128314 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL),
     /* 128327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128334 */     GIR_RootConstrainSelectedInstOperands,
     /* 128335 */     // GIR_Coverage, 774,
     /* 128335 */     GIR_EraseRootFromParent_Done,
     /* 128336 */   // Label 2803: @128336
     /* 128336 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(128378), // Rule ID 778 //
     /* 128341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 128348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128352 */     // (rotl:{ *:[i16] } GR16:{ *:[i16] }:$src1, CL:{ *:[i8] })  =>  (ROL16rCL_ND:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 128352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128356 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128362 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16rCL_ND),
     /* 128369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128371 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128376 */     GIR_RootConstrainSelectedInstOperands,
     /* 128377 */     // GIR_Coverage, 778,
     /* 128377 */     GIR_EraseRootFromParent_Done,
     /* 128378 */   // Label 2804: @128378
     /* 128378 */   GIM_Reject,
     /* 128379 */ // Label 2795: @128379
     /* 128379 */ GIM_Reject,
     /* 128380 */ // Label 2774: @128380
     /* 128380 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(128846),
     /* 128385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128395 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(128454), // Rule ID 17622 //
     /* 128400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128418 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128435 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, 31:{ *:[i8] })  =>  (ROR32m1_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32m1_ND),
     /* 128438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128452 */     GIR_RootConstrainSelectedInstOperands,
     /* 128453 */     // GIR_Coverage, 17622,
     /* 128453 */     GIR_EraseRootFromParent_Done,
     /* 128454 */   // Label 2806: @128454
     /* 128454 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(128521), // Rule ID 771 //
     /* 128459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128470 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128477 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128489 */     // MIs[2] Operand 1
     /* 128489 */     // No operand predicates
     /* 128489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128491 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128498 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, (imm:{ *:[i8] }):$src2)  =>  (ROL32mi_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mi_ND),
     /* 128501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128503 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128519 */     GIR_RootConstrainSelectedInstOperands,
     /* 128520 */     // GIR_Coverage, 771,
     /* 128520 */     GIR_EraseRootFromParent_Done,
     /* 128521 */   // Label 2807: @128521
     /* 128521 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(128594), // Rule ID 787 //
     /* 128526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128540 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128544 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 128548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128554 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128561 */     // (rotl:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>, CL:{ *:[i8] })  =>  (ROL32mCL_ND:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 128561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128565 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32mCL_ND),
     /* 128578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128584 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128592 */     GIR_RootConstrainSelectedInstOperands,
     /* 128593 */     // GIR_Coverage, 787,
     /* 128593 */     GIR_EraseRootFromParent_Done,
     /* 128594 */   // Label 2808: @128594
     /* 128594 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(128631), // Rule ID 869 //
     /* 128599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 128602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128614 */     // MIs[1] Operand 1
     /* 128614 */     // No operand predicates
     /* 128614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128616 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 128616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT32ri),
     /* 128619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 128626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128629 */     GIR_RootConstrainSelectedInstOperands,
     /* 128630 */     // GIR_Coverage, 869,
     /* 128630 */     GIR_EraseRootFromParent_Done,
     /* 128631 */   // Label 2809: @128631
     /* 128631 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(128659), // Rule ID 17598 //
     /* 128636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128643 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128647 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1),
     /* 128650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128652 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128657 */     GIR_RootConstrainSelectedInstOperands,
     /* 128658 */     // GIR_Coverage, 17598,
     /* 128658 */     GIR_EraseRootFromParent_Done,
     /* 128659 */   // Label 2810: @128659
     /* 128659 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(128687), // Rule ID 17606 //
     /* 128664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 31,
     /* 128675 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, 31:{ *:[i8] })  =>  (ROR32r1_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR32r1_ND),
     /* 128678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128685 */     GIR_RootConstrainSelectedInstOperands,
     /* 128686 */     // GIR_Coverage, 17606,
     /* 128686 */     GIR_EraseRootFromParent_Done,
     /* 128687 */   // Label 2811: @128687
     /* 128687 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(128724), // Rule ID 759 //
     /* 128692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128707 */     // MIs[1] Operand 1
     /* 128707 */     // No operand predicates
     /* 128707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128709 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri),
     /* 128712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128719 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128722 */     GIR_RootConstrainSelectedInstOperands,
     /* 128723 */     // GIR_Coverage, 759,
     /* 128723 */     GIR_EraseRootFromParent_Done,
     /* 128724 */   // Label 2812: @128724
     /* 128724 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(128761), // Rule ID 763 //
     /* 128729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 128740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128744 */     // MIs[1] Operand 1
     /* 128744 */     // No operand predicates
     /* 128744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128746 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL32ri_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32ri_ND),
     /* 128749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128751 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 128756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128759 */     GIR_RootConstrainSelectedInstOperands,
     /* 128760 */     // GIR_Coverage, 763,
     /* 128760 */     GIR_EraseRootFromParent_Done,
     /* 128761 */   // Label 2813: @128761
     /* 128761 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(128803), // Rule ID 775 //
     /* 128766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 128769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128777 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128781 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128787 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL),
     /* 128794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128796 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128801 */     GIR_RootConstrainSelectedInstOperands,
     /* 128802 */     // GIR_Coverage, 775,
     /* 128802 */     GIR_EraseRootFromParent_Done,
     /* 128803 */   // Label 2814: @128803
     /* 128803 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(128845), // Rule ID 779 //
     /* 128808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 128815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 128819 */     // (rotl:{ *:[i32] } GR32:{ *:[i32] }:$src1, CL:{ *:[i8] })  =>  (ROL32rCL_ND:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 128819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128823 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 128833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL32rCL_ND),
     /* 128836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128838 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 128840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128843 */     GIR_RootConstrainSelectedInstOperands,
     /* 128844 */     // GIR_Coverage, 779,
     /* 128844 */     GIR_EraseRootFromParent_Done,
     /* 128845 */   // Label 2815: @128845
     /* 128845 */   GIM_Reject,
     /* 128846 */ // Label 2805: @128846
     /* 128846 */ GIM_Reject,
     /* 128847 */ // Label 2775: @128847
     /* 128847 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(129313),
     /* 128852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 128858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 128862 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(128921), // Rule ID 17623 //
     /* 128867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 128870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128878 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128881 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128885 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 128893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128902 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 63:{ *:[i8] })  =>  (ROR64m1_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 128902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64m1_ND),
     /* 128905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 128911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 128919 */     GIR_RootConstrainSelectedInstOperands,
     /* 128920 */     // GIR_Coverage, 17623,
     /* 128920 */     GIR_EraseRootFromParent_Done,
     /* 128921 */   // Label 2817: @128921
     /* 128921 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(128988), // Rule ID 772 //
     /* 128926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 128937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 128944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 128948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 128952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 128956 */     // MIs[2] Operand 1
     /* 128956 */     // No operand predicates
     /* 128956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 128958 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 128965 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i8] }):$src2)  =>  (ROL64mi_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 128965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mi_ND),
     /* 128968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 128974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // src2
     /* 128977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 128980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 128986 */     GIR_RootConstrainSelectedInstOperands,
     /* 128987 */     // GIR_Coverage, 772,
     /* 128987 */     GIR_EraseRootFromParent_Done,
     /* 128988 */   // Label 2818: @128988
     /* 128988 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(129061), // Rule ID 788 //
     /* 128993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 128996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129021 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129028 */     // (rotl:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, CL:{ *:[i8] })  =>  (ROL64mCL_ND:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 129028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129032 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64mCL_ND),
     /* 129045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129059 */     GIR_RootConstrainSelectedInstOperands,
     /* 129060 */     // GIR_Coverage, 788,
     /* 129060 */     GIR_EraseRootFromParent_Done,
     /* 129061 */   // Label 2819: @129061
     /* 129061 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(129098), // Rule ID 870 //
     /* 129066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFastSHLDRotate),
     /* 129069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129081 */     // MIs[1] Operand 1
     /* 129081 */     // No operand predicates
     /* 129081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129083 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)  =>  (SHLDROT64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$shamt)
     /* 129083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SHLDROT64ri),
     /* 129086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129088 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 129093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129096 */     GIR_RootConstrainSelectedInstOperands,
     /* 129097 */     // GIR_Coverage, 870,
     /* 129097 */     GIR_EraseRootFromParent_Done,
     /* 129098 */   // Label 2820: @129098
     /* 129098 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(129126), // Rule ID 17599 //
     /* 129103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129110 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129114 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1),
     /* 129117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129124 */     GIR_RootConstrainSelectedInstOperands,
     /* 129125 */     // GIR_Coverage, 17599,
     /* 129125 */     GIR_EraseRootFromParent_Done,
     /* 129126 */   // Label 2821: @129126
     /* 129126 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(129154), // Rule ID 17607 //
     /* 129131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD),
     /* 129134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 63,
     /* 129142 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, 63:{ *:[i8] })  =>  (ROR64r1_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROR64r1_ND),
     /* 129145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129152 */     GIR_RootConstrainSelectedInstOperands,
     /* 129153 */     // GIR_Coverage, 17607,
     /* 129153 */     GIR_EraseRootFromParent_Done,
     /* 129154 */   // Label 2822: @129154
     /* 129154 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(129191), // Rule ID 760 //
     /* 129159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129174 */     // MIs[1] Operand 1
     /* 129174 */     // No operand predicates
     /* 129174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129176 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri),
     /* 129179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129189 */     GIR_RootConstrainSelectedInstOperands,
     /* 129190 */     // GIR_Coverage, 760,
     /* 129190 */     GIR_EraseRootFromParent_Done,
     /* 129191 */   // Label 2823: @129191
     /* 129191 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(129228), // Rule ID 764 //
     /* 129196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 129211 */     // MIs[1] Operand 1
     /* 129211 */     // No operand predicates
     /* 129211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129213 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)  =>  (ROL64ri_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1, (imm:{ *:[i8] }):$src2)
     /* 129213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64ri_ND),
     /* 129216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129218 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // src2
     /* 129223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129226 */     GIR_RootConstrainSelectedInstOperands,
     /* 129227 */     // GIR_Coverage, 764,
     /* 129227 */     GIR_EraseRootFromParent_Done,
     /* 129228 */   // Label 2824: @129228
     /* 129228 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(129270), // Rule ID 776 //
     /* 129233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD),
     /* 129236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129244 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129248 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL),
     /* 129261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129268 */     GIR_RootConstrainSelectedInstOperands,
     /* 129269 */     // GIR_Coverage, 776,
     /* 129269 */     GIR_EraseRootFromParent_Done,
     /* 129270 */   // Label 2825: @129270
     /* 129270 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(129312), // Rule ID 780 //
     /* 129275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNDD_In64BitMode),
     /* 129278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 129282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::GR8_ABCD_LRegClassID),
     /* 129286 */     // (rotl:{ *:[i64] } GR64:{ *:[i64] }:$src1, CL:{ *:[i8] })  =>  (ROL64rCL_ND:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 129286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129290 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(X86::CL), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129296 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // CL
     /* 129300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL64rCL_ND),
     /* 129303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129305 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 129310 */     GIR_RootConstrainSelectedInstOperands,
     /* 129311 */     // GIR_Coverage, 780,
     /* 129311 */     GIR_EraseRootFromParent_Done,
     /* 129312 */   // Label 2826: @129312
     /* 129312 */   GIM_Reject,
     /* 129313 */ // Label 2816: @129313
     /* 129313 */ GIM_Reject,
     /* 129314 */ // Label 2776: @129314
     /* 129314 */ GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(129731),
     /* 129319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 129322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 129325 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(129387), // Rule ID 1583 //
     /* 129330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129369 */     // (rotl:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQmr:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQmr),
     /* 129372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129378 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129385 */     GIR_RootConstrainSelectedInstOperands,
     /* 129386 */     // GIR_Coverage, 1583,
     /* 129386 */     GIR_EraseRootFromParent_Done,
     /* 129387 */   // Label 2828: @129387
     /* 129387 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(129449), // Rule ID 1582 //
     /* 129392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129431 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTQrm:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTQrm),
     /* 129434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129436 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129438 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129447 */     GIR_RootConstrainSelectedInstOperands,
     /* 129448 */     // GIR_Coverage, 1582,
     /* 129448 */     GIR_EraseRootFromParent_Done,
     /* 129449 */   // Label 2829: @129449
     /* 129449 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(129511), // Rule ID 8059 //
     /* 129454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129493 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rm),
     /* 129496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129509 */     GIR_RootConstrainSelectedInstOperands,
     /* 129510 */     // GIR_Coverage, 8059,
     /* 129510 */     GIR_EraseRootFromParent_Done,
     /* 129511 */   // Label 2830: @129511
     /* 129511 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(129538), // Rule ID 1581 //
     /* 129516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129531 */     // (rotl:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)  =>  (VPROTQrr:{ *:[v2i64] } VR128:{ *:[v2i64] }:$src1, VR128:{ *:[v2i64] }:$src2)
     /* 129531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTQrr),
     /* 129536 */     GIR_RootConstrainSelectedInstOperands,
     /* 129537 */     // GIR_Coverage, 1581,
     /* 129537 */     GIR_Done,
     /* 129538 */   // Label 2831: @129538
     /* 129538 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(129565), // Rule ID 8056 //
     /* 129543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129558 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPROLVQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 129558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ128rr),
     /* 129563 */     GIR_RootConstrainSelectedInstOperands,
     /* 129564 */     // GIR_Coverage, 8056,
     /* 129564 */     GIR_Done,
     /* 129565 */   // Label 2832: @129565
     /* 129565 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(129730), // Rule ID 20796 //
     /* 129570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129585 */     // (rotl:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 129585 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 129588 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129592 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 129599 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 129602 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129606 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129611 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 129614 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 129618 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 129621 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129626 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129631 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129636 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 129639 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129643 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129650 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 129653 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 129657 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129662 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 129665 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 129669 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 129672 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 129677 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 129687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 129690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 129694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129699 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 129702 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 129705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129712 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 129719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 129724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 129729 */     // GIR_Coverage, 20796,
     /* 129729 */     GIR_EraseRootFromParent_Done,
     /* 129730 */   // Label 2833: @129730
     /* 129730 */   GIM_Reject,
     /* 129731 */ // Label 2827: @129731
     /* 129731 */ GIM_Reject,
     /* 129732 */ // Label 2777: @129732
     /* 129732 */ GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(130149),
     /* 129737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129743 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(129805), // Rule ID 1580 //
     /* 129748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129763 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129770 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129787 */     // (rotl:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDmr:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDmr),
     /* 129790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129792 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 129796 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 129798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129803 */     GIR_RootConstrainSelectedInstOperands,
     /* 129804 */     // GIR_Coverage, 1580,
     /* 129804 */     GIR_EraseRootFromParent_Done,
     /* 129805 */   // Label 2835: @129805
     /* 129805 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(129867), // Rule ID 1579 //
     /* 129810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129849 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTDrm),
     /* 129852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129865 */     GIR_RootConstrainSelectedInstOperands,
     /* 129866 */     // GIR_Coverage, 1579,
     /* 129866 */     GIR_EraseRootFromParent_Done,
     /* 129867 */   // Label 2836: @129867
     /* 129867 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(129929), // Rule ID 8032 //
     /* 129872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 129887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 129891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 129898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 129902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 129911 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 129911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rm),
     /* 129914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 129918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 129922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 129927 */     GIR_RootConstrainSelectedInstOperands,
     /* 129928 */     // GIR_Coverage, 8032,
     /* 129928 */     GIR_EraseRootFromParent_Done,
     /* 129929 */   // Label 2837: @129929
     /* 129929 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(129956), // Rule ID 1578 //
     /* 129934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 129937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 129949 */     // (rotl:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPROTDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 129949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTDrr),
     /* 129954 */     GIR_RootConstrainSelectedInstOperands,
     /* 129955 */     // GIR_Coverage, 1578,
     /* 129955 */     GIR_Done,
     /* 129956 */   // Label 2838: @129956
     /* 129956 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(129983), // Rule ID 8029 //
     /* 129961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 129964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129976 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPROLVDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 129976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ128rr),
     /* 129981 */     GIR_RootConstrainSelectedInstOperands,
     /* 129982 */     // GIR_Coverage, 8029,
     /* 129982 */     GIR_Done,
     /* 129983 */   // Label 2839: @129983
     /* 129983 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(130148), // Rule ID 20798 //
     /* 129988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 129991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 129995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 129999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 130003 */     // (rotl:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 130003 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130006 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130010 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130029 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130032 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130036 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 130039 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130044 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130049 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130068 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130071 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130075 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130080 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 130090 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130095 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130100 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 130105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130117 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130130 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 130137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 130142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130147 */     // GIR_Coverage, 20798,
     /* 130147 */     GIR_EraseRootFromParent_Done,
     /* 130148 */   // Label 2840: @130148
     /* 130148 */   GIM_Reject,
     /* 130149 */ // Label 2834: @130149
     /* 130149 */ GIM_Reject,
     /* 130150 */ // Label 2778: @130150
     /* 130150 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(130400),
     /* 130155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 130158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 130161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130169 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(130223), // Rule ID 8050 //
     /* 130174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130185 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130188 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130192 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130198 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130205 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rm),
     /* 130208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130210 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130221 */     GIR_RootConstrainSelectedInstOperands,
     /* 130222 */     // GIR_Coverage, 8050,
     /* 130222 */     GIR_EraseRootFromParent_Done,
     /* 130223 */   // Label 2842: @130223
     /* 130223 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(130242), // Rule ID 8047 //
     /* 130228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130235 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPROLVQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 130235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZ256rr),
     /* 130240 */     GIR_RootConstrainSelectedInstOperands,
     /* 130241 */     // GIR_Coverage, 8047,
     /* 130241 */     GIR_Done,
     /* 130242 */   // Label 2843: @130242
     /* 130242 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(130399), // Rule ID 20797 //
     /* 130247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130254 */     // (rotl:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPROLVQZrr:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130254 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 130257 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130261 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130268 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 130271 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130275 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130280 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130283 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130287 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130290 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130295 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130300 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 130308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 130322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130331 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130338 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130341 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130351 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 130359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130398 */     // GIR_Coverage, 20797,
     /* 130398 */     GIR_EraseRootFromParent_Done,
     /* 130399 */   // Label 2844: @130399
     /* 130399 */   GIM_Reject,
     /* 130400 */ // Label 2841: @130400
     /* 130400 */ GIM_Reject,
     /* 130401 */ // Label 2779: @130401
     /* 130401 */ GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(130556),
     /* 130406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 130409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 130412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130416 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(130474), // Rule ID 1586 //
     /* 130421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130456 */     // (rotl:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWmr:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWmr),
     /* 130459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130472 */     GIR_RootConstrainSelectedInstOperands,
     /* 130473 */     // GIR_Coverage, 1586,
     /* 130473 */     GIR_EraseRootFromParent_Done,
     /* 130474 */   // Label 2846: @130474
     /* 130474 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(130532), // Rule ID 1585 //
     /* 130479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130514 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTWrm),
     /* 130517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130530 */     GIR_RootConstrainSelectedInstOperands,
     /* 130531 */     // GIR_Coverage, 1585,
     /* 130531 */     GIR_EraseRootFromParent_Done,
     /* 130532 */   // Label 2847: @130532
     /* 130532 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(130555), // Rule ID 1584 //
     /* 130537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130548 */     // (rotl:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPROTWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 130548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTWrr),
     /* 130553 */     GIR_RootConstrainSelectedInstOperands,
     /* 130554 */     // GIR_Coverage, 1584,
     /* 130554 */     GIR_Done,
     /* 130555 */   // Label 2848: @130555
     /* 130555 */   GIM_Reject,
     /* 130556 */ // Label 2845: @130556
     /* 130556 */ GIM_Reject,
     /* 130557 */ // Label 2780: @130557
     /* 130557 */ GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(130807),
     /* 130562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 130565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 130568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130576 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(130630), // Rule ID 8023 //
     /* 130581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130612 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rm),
     /* 130615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130628 */     GIR_RootConstrainSelectedInstOperands,
     /* 130629 */     // GIR_Coverage, 8023,
     /* 130629 */     GIR_EraseRootFromParent_Done,
     /* 130630 */   // Label 2850: @130630
     /* 130630 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(130649), // Rule ID 8020 //
     /* 130635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 130638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130642 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPROLVDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 130642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZ256rr),
     /* 130647 */     GIR_RootConstrainSelectedInstOperands,
     /* 130648 */     // GIR_Coverage, 8020,
     /* 130648 */     GIR_Done,
     /* 130649 */   // Label 2851: @130649
     /* 130649 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(130806), // Rule ID 20799 //
     /* 130654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 130657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 130661 */     // (rotl:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPROLVDZrr:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 130661 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 130664 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130668 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 130675 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 130678 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130682 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130687 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 130690 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 130694 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 130697 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130702 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130707 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130712 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 130715 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 130719 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 130729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 130733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130738 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 130741 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 130745 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 130748 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 130753 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130758 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 130766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 130770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130778 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 130781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130788 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 130795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 130800 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 130805 */     // GIR_Coverage, 20799,
     /* 130805 */     GIR_EraseRootFromParent_Done,
     /* 130806 */   // Label 2852: @130806
     /* 130806 */   GIM_Reject,
     /* 130807 */ // Label 2849: @130807
     /* 130807 */ GIM_Reject,
     /* 130808 */ // Label 2781: @130808
     /* 130808 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(130901),
     /* 130813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 130816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 130819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130827 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(130881), // Rule ID 8041 //
     /* 130832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130843 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130850 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130856 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130863 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 130863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrm),
     /* 130866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130868 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 130870 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 130874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130879 */     GIR_RootConstrainSelectedInstOperands,
     /* 130880 */     // GIR_Coverage, 8041,
     /* 130880 */     GIR_EraseRootFromParent_Done,
     /* 130881 */   // Label 2854: @130881
     /* 130881 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(130900), // Rule ID 8038 //
     /* 130886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 130889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 130893 */     // (rotl:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPROLVQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 130893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVQZrr),
     /* 130898 */     GIR_RootConstrainSelectedInstOperands,
     /* 130899 */     // GIR_Coverage, 8038,
     /* 130899 */     GIR_Done,
     /* 130900 */   // Label 2855: @130900
     /* 130900 */   GIM_Reject,
     /* 130901 */ // Label 2853: @130901
     /* 130901 */ GIM_Reject,
     /* 130902 */ // Label 2782: @130902
     /* 130902 */ GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(131057),
     /* 130907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 130910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 130913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130917 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(130975), // Rule ID 1577 //
     /* 130922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 130940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 130944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 130957 */     // (rotl:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBmr:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 130957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBmr),
     /* 130960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130962 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 130966 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 130968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 130973 */     GIR_RootConstrainSelectedInstOperands,
     /* 130974 */     // GIR_Coverage, 1577,
     /* 130974 */     GIR_EraseRootFromParent_Done,
     /* 130975 */   // Label 2857: @130975
     /* 130975 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(131033), // Rule ID 1576 //
     /* 130980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 130983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 130987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 130991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 130995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 130998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 131002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 131006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131008 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 131015 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROTBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 131015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROTBrm),
     /* 131018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131020 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131026 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131031 */     GIR_RootConstrainSelectedInstOperands,
     /* 131032 */     // GIR_Coverage, 1576,
     /* 131032 */     GIR_EraseRootFromParent_Done,
     /* 131033 */   // Label 2858: @131033
     /* 131033 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(131056), // Rule ID 1575 //
     /* 131038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasXOP),
     /* 131041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 131049 */     // (rotl:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPROTBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 131049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROTBrr),
     /* 131054 */     GIR_RootConstrainSelectedInstOperands,
     /* 131055 */     // GIR_Coverage, 1575,
     /* 131055 */     GIR_Done,
     /* 131056 */   // Label 2859: @131056
     /* 131056 */   GIM_Reject,
     /* 131057 */ // Label 2856: @131057
     /* 131057 */ GIM_Reject,
     /* 131058 */ // Label 2783: @131058
     /* 131058 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(131151),
     /* 131063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 131066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 131069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131077 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(131131), // Rule ID 8014 //
     /* 131082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 131093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 131100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 131104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 131113 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPROLVDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 131113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrm),
     /* 131116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 131120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 131124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131129 */     GIR_RootConstrainSelectedInstOperands,
     /* 131130 */     // GIR_Coverage, 8014,
     /* 131130 */     GIR_EraseRootFromParent_Done,
     /* 131131 */   // Label 2861: @131131
     /* 131131 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(131150), // Rule ID 8011 //
     /* 131136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 131139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131143 */     // (rotl:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPROLVDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 131143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPROLVDZrr),
     /* 131148 */     GIR_RootConstrainSelectedInstOperands,
     /* 131149 */     // GIR_Coverage, 8011,
     /* 131149 */     GIR_Done,
     /* 131150 */   // Label 2862: @131150
     /* 131150 */   GIM_Reject,
     /* 131151 */ // Label 2860: @131151
     /* 131151 */ GIM_Reject,
     /* 131152 */ // Label 2784: @131152
     /* 131152 */ GIM_Reject,
     /* 131153 */ // Label 33: @131153
     /* 131153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(24), /*)*//*default:*//*Label 2869*/ GIMT_Encode4(132809),
     /* 131164 */ /*GILLT_v2s1*//*Label 2863*/ GIMT_Encode4(131232), GIMT_Encode4(0),
     /* 131172 */ /*GILLT_v4s1*//*Label 2864*/ GIMT_Encode4(131393), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131184 */ /*GILLT_v8s1*//*Label 2865*/ GIMT_Encode4(131740), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131200 */ /*GILLT_v16s1*//*Label 2866*/ GIMT_Encode4(132137), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131216 */ /*GILLT_v32s1*//*Label 2867*/ GIMT_Encode4(132534), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131228 */ /*GILLT_v64s1*//*Label 2868*/ GIMT_Encode4(132758),
     /* 131232 */ // Label 2863: @131232
     /* 131232 */ GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(131392),
     /* 131237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 131240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 131243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 131247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131256 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(131287), // Rule ID 12606 //
     /* 131261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131268 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131274 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131278 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ128kr:{ *:[v2i1] } VR128X:{ *:[v2i64] }:$src)
     /* 131278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ128kr),
     /* 131281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131283 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131285 */     GIR_RootConstrainSelectedInstOperands,
     /* 131286 */     // GIR_Coverage, 12606,
     /* 131286 */     GIR_EraseRootFromParent_Done,
     /* 131287 */   // Label 2871: @131287
     /* 131287 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(131391), // Rule ID 21658 //
     /* 131292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131299 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131305 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131309 */     // (setcc:{ *:[v2i1] } immAllZerosV:{ *:[v2i64] }, VR128X:{ *:[v2i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), VK2:{ *:[i32] })
     /* 131309 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131312 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131316 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131323 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131326 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131330 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131335 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131342 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131345 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131372 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 131390 */     // GIR_Coverage, 21658,
     /* 131390 */     GIR_EraseRootFromParent_Done,
     /* 131391 */   // Label 2872: @131391
     /* 131391 */   GIM_Reject,
     /* 131392 */ // Label 2870: @131392
     /* 131392 */ GIM_Reject,
     /* 131393 */ // Label 2864: @131393
     /* 131393 */ GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(131443), // Rule ID 12603 //
     /* 131398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131411 */   // MIs[0] Operand 1
     /* 131411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131416 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131420 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131426 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131428 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131434 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ128kr:{ *:[v4i1] } VR128X:{ *:[v4i32] }:$src)
     /* 131434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ128kr),
     /* 131437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131439 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131441 */   GIR_RootConstrainSelectedInstOperands,
     /* 131442 */   // GIR_Coverage, 12603,
     /* 131442 */   GIR_EraseRootFromParent_Done,
     /* 131443 */ // Label 2873: @131443
     /* 131443 */ GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(131493), // Rule ID 12605 //
     /* 131448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131461 */   // MIs[0] Operand 1
     /* 131461 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131470 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131476 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131478 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131484 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZ256kr:{ *:[v4i1] } VR256X:{ *:[v4i64] }:$src)
     /* 131484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZ256kr),
     /* 131487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131489 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131491 */   GIR_RootConstrainSelectedInstOperands,
     /* 131492 */   // GIR_Coverage, 12605,
     /* 131492 */   GIR_EraseRootFromParent_Done,
     /* 131493 */ // Label 2874: @131493
     /* 131493 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(131616), // Rule ID 21656 //
     /* 131498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 131504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 131507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131511 */   // MIs[0] Operand 1
     /* 131511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131516 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131520 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131526 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131532 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131534 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i32] }, VR128X:{ *:[v4i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src, sub_xmm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131534 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 131537 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131541 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131548 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 131551 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131555 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131560 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131563 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131567 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131570 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131575 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131580 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 131588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 131592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131597 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131615 */   // GIR_Coverage, 21656,
     /* 131615 */   GIR_EraseRootFromParent_Done,
     /* 131616 */ // Label 2875: @131616
     /* 131616 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(131739), // Rule ID 21657 //
     /* 131621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 131624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 131627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 131630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 131634 */   // MIs[0] Operand 1
     /* 131634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131643 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131649 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131651 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131657 */   // (setcc:{ *:[v4i1] } immAllZerosV:{ *:[v4i64] }, VR256X:{ *:[v4i64] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (VPMOVQ2MZkr:{ *:[v8i1] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), VK4:{ *:[i32] })
     /* 131657 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 131660 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131664 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 131674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131683 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131686 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131690 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 131693 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131698 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131703 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 131708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 131711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131720 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 131738 */   // GIR_Coverage, 21657,
     /* 131738 */   GIR_EraseRootFromParent_Done,
     /* 131739 */ // Label 2876: @131739
     /* 131739 */ GIM_Reject,
     /* 131740 */ // Label 2865: @131740
     /* 131740 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(131790), // Rule ID 12600 //
     /* 131745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 131748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131758 */   // MIs[0] Operand 1
     /* 131758 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131767 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131773 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131775 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131779 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131781 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ128kr:{ *:[v8i1] } VR128X:{ *:[v8i16] }:$src)
     /* 131781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ128kr),
     /* 131784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131786 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131788 */   GIR_RootConstrainSelectedInstOperands,
     /* 131789 */   // GIR_Coverage, 12600,
     /* 131789 */   GIR_EraseRootFromParent_Done,
     /* 131790 */ // Label 2877: @131790
     /* 131790 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(131840), // Rule ID 12602 //
     /* 131795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 131798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 131801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 131804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131808 */   // MIs[0] Operand 1
     /* 131808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131817 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131823 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131825 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 131829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131831 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZ256kr:{ *:[v8i1] } VR256X:{ *:[v8i32] }:$src)
     /* 131831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZ256kr),
     /* 131834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131836 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131838 */   GIR_RootConstrainSelectedInstOperands,
     /* 131839 */   // GIR_Coverage, 12602,
     /* 131839 */   GIR_EraseRootFromParent_Done,
     /* 131840 */ // Label 2878: @131840
     /* 131840 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(131890), // Rule ID 12604 //
     /* 131845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 131848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 131851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 131854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131858 */   // MIs[0] Operand 1
     /* 131858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131863 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131867 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131873 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 131879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131881 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVQ2MZkr:{ *:[v8i1] } VR512:{ *:[v8i64] }:$src)
     /* 131881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVQ2MZkr),
     /* 131884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131886 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 131888 */   GIR_RootConstrainSelectedInstOperands,
     /* 131889 */   // GIR_Coverage, 12604,
     /* 131889 */   GIR_EraseRootFromParent_Done,
     /* 131890 */ // Label 2879: @131890
     /* 131890 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(132013), // Rule ID 21654 //
     /* 131895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 131898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 131901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 131904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 131908 */   // MIs[0] Operand 1
     /* 131908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 131913 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 131917 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 131923 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 131925 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 131929 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131931 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i16] }, VR128X:{ *:[v8i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src, sub_xmm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 131931 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 131934 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 131938 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131945 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 131948 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 131952 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131957 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 131960 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 131964 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 131967 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 131972 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 131977 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 131982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 131985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 131989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131994 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132007 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 132012 */   // GIR_Coverage, 21654,
     /* 132012 */   GIR_EraseRootFromParent_Done,
     /* 132013 */ // Label 2880: @132013
     /* 132013 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(132136), // Rule ID 21655 //
     /* 132018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasEVEX512_NoVLX),
     /* 132021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 132024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 132027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 132031 */   // MIs[0] Operand 1
     /* 132031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132036 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132040 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132046 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132054 */   // (setcc:{ *:[v8i1] } immAllZerosV:{ *:[v8i32] }, VR256X:{ *:[v8i32] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (VPMOVD2MZkr:{ *:[v16i1] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src, sub_ymm:{ *:[i32] })), VK8:{ *:[i32] })
     /* 132054 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 132057 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132061 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 132071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132080 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132087 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132090 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132095 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132100 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 132108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132117 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132130 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 132135 */   // GIR_Coverage, 21655,
     /* 132135 */   GIR_EraseRootFromParent_Done,
     /* 132136 */ // Label 2881: @132136
     /* 132136 */ GIM_Reject,
     /* 132137 */ // Label 2866: @132137
     /* 132137 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(132187), // Rule ID 12597 //
     /* 132142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132148 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132155 */   // MIs[0] Operand 1
     /* 132155 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132160 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132164 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132170 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132172 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132178 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ128kr:{ *:[v16i1] } VR128X:{ *:[v16i8] }:$src)
     /* 132178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ128kr),
     /* 132181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132183 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132185 */   GIR_RootConstrainSelectedInstOperands,
     /* 132186 */   // GIR_Coverage, 12597,
     /* 132186 */   GIR_EraseRootFromParent_Done,
     /* 132187 */ // Label 2882: @132187
     /* 132187 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(132237), // Rule ID 12599 //
     /* 132192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132198 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132205 */   // MIs[0] Operand 1
     /* 132205 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132210 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132214 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132220 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132222 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132228 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZ256kr:{ *:[v16i1] } VR256X:{ *:[v16i16] }:$src)
     /* 132228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZ256kr),
     /* 132231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132233 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132235 */   GIR_RootConstrainSelectedInstOperands,
     /* 132236 */   // GIR_Coverage, 12599,
     /* 132236 */   GIR_EraseRootFromParent_Done,
     /* 132237 */ // Label 2883: @132237
     /* 132237 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(132287), // Rule ID 12601 //
     /* 132242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 132245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 132248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 132251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132255 */   // MIs[0] Operand 1
     /* 132255 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132264 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132270 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132278 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVD2MZkr:{ *:[v16i1] } VR512:{ *:[v16i32] }:$src)
     /* 132278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVD2MZkr),
     /* 132281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132283 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132285 */   GIR_RootConstrainSelectedInstOperands,
     /* 132286 */   // GIR_Coverage, 12601,
     /* 132286 */   GIR_EraseRootFromParent_Done,
     /* 132287 */ // Label 2884: @132287
     /* 132287 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(132410), // Rule ID 21652 //
     /* 132292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 132298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 132301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132305 */   // MIs[0] Operand 1
     /* 132305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132310 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132314 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132320 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132322 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132326 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132328 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i8] }, VR128X:{ *:[v16i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src, sub_xmm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132328 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132331 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132335 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132342 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132345 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132349 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132354 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132357 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132361 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 132364 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132369 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132374 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 132379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132391 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132404 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132409 */   // GIR_Coverage, 21652,
     /* 132409 */   GIR_EraseRootFromParent_Done,
     /* 132410 */ // Label 2885: @132410
     /* 132410 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(132533), // Rule ID 21653 //
     /* 132415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 132421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 132424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 132428 */   // MIs[0] Operand 1
     /* 132428 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132437 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132443 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132449 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132451 */   // (setcc:{ *:[v16i1] } immAllZerosV:{ *:[v16i16] }, VR256X:{ *:[v16i16] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (VPMOVW2MZkr:{ *:[v32i1] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src, sub_ymm:{ *:[i32] })), VK16:{ *:[i32] })
     /* 132451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 132454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132465 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 132468 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132472 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132477 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132484 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132487 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132492 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132497 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s1,
     /* 132505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132514 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 132532 */   // GIR_Coverage, 21653,
     /* 132532 */   GIR_EraseRootFromParent_Done,
     /* 132533 */ // Label 2886: @132533
     /* 132533 */ GIM_Reject,
     /* 132534 */ // Label 2867: @132534
     /* 132534 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(132584), // Rule ID 12596 //
     /* 132539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 132542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132552 */   // MIs[0] Operand 1
     /* 132552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132561 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132567 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132575 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZ256kr:{ *:[v32i1] } VR256X:{ *:[v32i8] }:$src)
     /* 132575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZ256kr),
     /* 132578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132580 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132582 */   GIR_RootConstrainSelectedInstOperands,
     /* 132583 */   // GIR_Coverage, 12596,
     /* 132583 */   GIR_EraseRootFromParent_Done,
     /* 132584 */ // Label 2887: @132584
     /* 132584 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(132634), // Rule ID 12598 //
     /* 132589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 132595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 132598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132602 */   // MIs[0] Operand 1
     /* 132602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132611 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132617 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132623 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132625 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i16] }, VR512:{ *:[v32i16] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVW2MZkr:{ *:[v32i1] } VR512:{ *:[v32i16] }:$src)
     /* 132625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVW2MZkr),
     /* 132628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132630 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132632 */   GIR_RootConstrainSelectedInstOperands,
     /* 132633 */   // GIR_Coverage, 12598,
     /* 132633 */   GIR_EraseRootFromParent_Done,
     /* 132634 */ // Label 2888: @132634
     /* 132634 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(132757), // Rule ID 21651 //
     /* 132639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 132642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 132645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 132648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 132652 */   // MIs[0] Operand 1
     /* 132652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132657 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132661 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132667 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 132673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132675 */   // (setcc:{ *:[v32i1] } immAllZerosV:{ *:[v32i8] }, VR256X:{ *:[v32i8] }:$src, SETGT:{ *:[Other] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } (VPMOVB2MZkr:{ *:[v64i1] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src, sub_ymm:{ *:[i32] })), VK32:{ *:[i32] })
     /* 132675 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 132678 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 132682 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132689 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 132692 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 132696 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132701 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132704 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src
     /* 132708 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 132711 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 132716 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 132721 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 132726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s1,
     /* 132729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132738 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132748 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 132756 */   // GIR_Coverage, 21651,
     /* 132756 */   GIR_EraseRootFromParent_Done,
     /* 132757 */ // Label 2889: @132757
     /* 132757 */ GIM_Reject,
     /* 132758 */ // Label 2868: @132758
     /* 132758 */ GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(132808), // Rule ID 12595 //
     /* 132763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 132766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 132769 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 132772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 132776 */   // MIs[0] Operand 1
     /* 132776 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 132785 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132791 */   GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 132797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132799 */   // (setcc:{ *:[v64i1] } immAllZerosV:{ *:[v64i8] }, VR512:{ *:[v64i8] }:$src, SETGT:{ *:[Other] })  =>  (VPMOVB2MZkr:{ *:[v64i1] } VR512:{ *:[v64i8] }:$src)
     /* 132799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMOVB2MZkr),
     /* 132802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132804 */   GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 132806 */   GIR_RootConstrainSelectedInstOperands,
     /* 132807 */   // GIR_Coverage, 12595,
     /* 132807 */   GIR_EraseRootFromParent_Done,
     /* 132808 */ // Label 2890: @132808
     /* 132808 */ GIM_Reject,
     /* 132809 */ // Label 2869: @132809
     /* 132809 */ GIM_Reject,
     /* 132810 */ // Label 34: @132810
     /* 132810 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 2903*/ GIMT_Encode4(140475),
     /* 132821 */ /*GILLT_v2s64*//*Label 2891*/ GIMT_Encode4(132889), GIMT_Encode4(0),
     /* 132829 */ /*GILLT_v4s32*//*Label 2892*/ GIMT_Encode4(133753),
     /* 132833 */ /*GILLT_v4s64*//*Label 2893*/ GIMT_Encode4(134617), GIMT_Encode4(0),
     /* 132841 */ /*GILLT_v8s16*//*Label 2894*/ GIMT_Encode4(135397),
     /* 132845 */ /*GILLT_v8s32*//*Label 2895*/ GIMT_Encode4(136555),
     /* 132849 */ /*GILLT_v8s64*//*Label 2896*/ GIMT_Encode4(137335), GIMT_Encode4(0),
     /* 132857 */ /*GILLT_v16s8*//*Label 2897*/ GIMT_Encode4(137716),
     /* 132861 */ /*GILLT_v16s16*//*Label 2898*/ GIMT_Encode4(138156),
     /* 132865 */ /*GILLT_v16s32*//*Label 2899*/ GIMT_Encode4(139226), GIMT_Encode4(0),
     /* 132873 */ /*GILLT_v32s8*//*Label 2900*/ GIMT_Encode4(139567),
     /* 132877 */ /*GILLT_v32s16*//*Label 2901*/ GIMT_Encode4(139971), GIMT_Encode4(0),
     /* 132885 */ /*GILLT_v64s8*//*Label 2902*/ GIMT_Encode4(140389),
     /* 132889 */ // Label 2891: @132889
     /* 132889 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(133752),
     /* 132894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 132897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 132900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 132903 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(132948), // Rule ID 4489 //
     /* 132908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132927 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132933 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132937 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src, immAllZerosV:{ *:[v2f64] })  =>  (VMOVAPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 132937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrkz),
     /* 132940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132942 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132944 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132946 */     GIR_RootConstrainSelectedInstOperands,
     /* 132947 */     // GIR_Coverage, 4489,
     /* 132947 */     GIR_EraseRootFromParent_Done,
     /* 132948 */   // Label 2905: @132948
     /* 132948 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(132993), // Rule ID 4543 //
     /* 132953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 132956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 132964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 132968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 132972 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 132978 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 132980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132982 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src, immAllZerosV:{ *:[v2i64] })  =>  (VMOVDQA64Z128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 132982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrkz),
     /* 132985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132987 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 132989 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 132991 */     GIR_RootConstrainSelectedInstOperands,
     /* 132992 */     // GIR_Coverage, 4543,
     /* 132992 */     GIR_EraseRootFromParent_Done,
     /* 132993 */   // Label 2906: @132993
     /* 132993 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(133142), // Rule ID 19777 //
     /* 132998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133017 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133023 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133027 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, immAllZerosV:{ *:[v2f64] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133027 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133030 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133034 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133053 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133056 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133060 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133063 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133068 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133073 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133094 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 133106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133124 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133141 */     // GIR_Coverage, 19777,
     /* 133141 */     GIR_EraseRootFromParent_Done,
     /* 133142 */   // Label 2907: @133142
     /* 133142 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(133291), // Rule ID 19779 //
     /* 133147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133176 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, immAllZerosV:{ *:[v2i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133176 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 133179 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133183 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133202 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133205 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133209 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133212 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133217 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133222 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 133230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 133255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133260 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133263 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133290 */     // GIR_Coverage, 19779,
     /* 133290 */     GIR_EraseRootFromParent_Done,
     /* 133291 */   // Label 2908: @133291
     /* 133291 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(133328), // Rule ID 4491 //
     /* 133296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133315 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (VMOVAPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1)
     /* 133315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ128rrk),
     /* 133318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133320 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133322 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133326 */     GIR_RootConstrainSelectedInstOperands,
     /* 133327 */     // GIR_Coverage, 4491,
     /* 133327 */     GIR_EraseRootFromParent_Done,
     /* 133328 */   // Label 2909: @133328
     /* 133328 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(133365), // Rule ID 4545 //
     /* 133333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133352 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (VMOVDQA64Z128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src0, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1)
     /* 133352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z128rrk),
     /* 133355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133357 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 133359 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133361 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 133363 */     GIR_RootConstrainSelectedInstOperands,
     /* 133364 */     // GIR_Coverage, 4545,
     /* 133364 */     GIR_EraseRootFromParent_Done,
     /* 133365 */   // Label 2910: @133365
     /* 133365 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(133558), // Rule ID 19776 //
     /* 133370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133389 */     // (vselect:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR128X:{ *:[v2f64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133389 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133392 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133396 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133403 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133406 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133410 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133415 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133418 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133422 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133425 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133430 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133435 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133440 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133443 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133447 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133452 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133456 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133461 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133464 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133468 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133475 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133478 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133482 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133487 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133494 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 133519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133530 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133557 */     // GIR_Coverage, 19776,
     /* 133557 */     GIR_EraseRootFromParent_Done,
     /* 133558 */   // Label 2911: @133558
     /* 133558 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(133751), // Rule ID 19778 //
     /* 133563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 133574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133582 */     // (vselect:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK2WM:{ *:[v2i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133582 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 133585 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133589 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 133596 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 133599 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133603 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133608 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 133611 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133615 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 133618 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133623 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133628 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133633 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 133636 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133640 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133645 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133649 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 133654 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 133657 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133661 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133668 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 133671 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133675 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133680 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 133687 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 133690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 133708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 133712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133717 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133720 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 133723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 133726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 133745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133750 */     // GIR_Coverage, 19778,
     /* 133750 */     GIR_EraseRootFromParent_Done,
     /* 133751 */   // Label 2912: @133751
     /* 133751 */   GIM_Reject,
     /* 133752 */ // Label 2904: @133752
     /* 133752 */ GIM_Reject,
     /* 133753 */ // Label 2892: @133753
     /* 133753 */ GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(134616),
     /* 133758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 133761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 133764 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 133767 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(133812), // Rule ID 4471 //
     /* 133772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133791 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133797 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133801 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src, immAllZerosV:{ *:[v4f32] })  =>  (VMOVAPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 133801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrkz),
     /* 133804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133806 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133810 */     GIR_RootConstrainSelectedInstOperands,
     /* 133811 */     // GIR_Coverage, 4471,
     /* 133811 */     GIR_EraseRootFromParent_Done,
     /* 133812 */   // Label 2914: @133812
     /* 133812 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(133857), // Rule ID 4529 //
     /* 133817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 133820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133836 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133842 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133846 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src, immAllZerosV:{ *:[v4i32] })  =>  (VMOVDQA32Z128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 133846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrkz),
     /* 133849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133851 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 133853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 133855 */     GIR_RootConstrainSelectedInstOperands,
     /* 133856 */     // GIR_Coverage, 4529,
     /* 133856 */     GIR_EraseRootFromParent_Done,
     /* 133857 */   // Label 2915: @133857
     /* 133857 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(134006), // Rule ID 19769 //
     /* 133862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 133865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 133869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 133873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 133877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 133881 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 133887 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 133889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133891 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, immAllZerosV:{ *:[v4f32] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 133891 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 133894 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 133898 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 133905 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 133908 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 133912 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133917 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 133920 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 133924 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 133927 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 133932 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 133937 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 133942 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 133945 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133949 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133954 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 133958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 133963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 133966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 133970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133975 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133978 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 133981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133988 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 133995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134005 */     // GIR_Coverage, 19769,
     /* 134005 */     GIR_EraseRootFromParent_Done,
     /* 134006 */   // Label 2916: @134006
     /* 134006 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(134155), // Rule ID 19771 //
     /* 134011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134030 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134036 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134040 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, immAllZerosV:{ *:[v4i32] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134040 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 134043 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134047 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134066 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134069 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134073 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 134076 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134081 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134086 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 134094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134103 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134107 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 134119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134127 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134154 */     // GIR_Coverage, 19771,
     /* 134154 */     GIR_EraseRootFromParent_Done,
     /* 134155 */   // Label 2917: @134155
     /* 134155 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(134192), // Rule ID 4473 //
     /* 134160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134179 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (VMOVAPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1)
     /* 134179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ128rrk),
     /* 134182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134184 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134186 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134190 */     GIR_RootConstrainSelectedInstOperands,
     /* 134191 */     // GIR_Coverage, 4473,
     /* 134191 */     GIR_EraseRootFromParent_Done,
     /* 134192 */   // Label 2918: @134192
     /* 134192 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(134229), // Rule ID 4530 //
     /* 134197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134216 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (VMOVDQA32Z128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1)
     /* 134216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z128rrk),
     /* 134219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134221 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 134223 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 134227 */     GIR_RootConstrainSelectedInstOperands,
     /* 134228 */     // GIR_Coverage, 4530,
     /* 134228 */     GIR_EraseRootFromParent_Done,
     /* 134229 */   // Label 2919: @134229
     /* 134229 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(134422), // Rule ID 19768 //
     /* 134234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134253 */     // (vselect:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR128X:{ *:[v4f32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134253 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134256 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134260 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134267 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134270 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134274 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134279 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134282 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134286 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134289 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134294 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134299 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134304 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134307 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134311 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134316 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134320 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134351 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 134383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134391 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134404 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134421 */     // GIR_Coverage, 19768,
     /* 134421 */     GIR_EraseRootFromParent_Done,
     /* 134422 */   // Label 2920: @134422
     /* 134422 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(134615), // Rule ID 19770 //
     /* 134427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 134434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 134446 */     // (vselect:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK4WM:{ *:[v4i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 134446 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 134449 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134453 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 134460 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 134463 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134467 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134472 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 134475 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134479 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 134482 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134487 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134492 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134497 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 134500 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134504 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134509 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134513 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 134518 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 134521 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134525 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134532 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 134535 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134539 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134544 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 134547 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 134551 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 134554 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134559 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 134569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 134572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 134576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134581 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 134587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 134590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134597 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 134604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 134609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134614 */     // GIR_Coverage, 19770,
     /* 134614 */     GIR_EraseRootFromParent_Done,
     /* 134615 */   // Label 2921: @134615
     /* 134615 */   GIM_Reject,
     /* 134616 */ // Label 2913: @134616
     /* 134616 */ GIM_Reject,
     /* 134617 */ // Label 2893: @134617
     /* 134617 */ GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(135396),
     /* 134622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 134625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 134628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 134631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 134639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134643 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(134676), // Rule ID 4484 //
     /* 134648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134655 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134661 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134665 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src, immAllZerosV:{ *:[v4f64] })  =>  (VMOVAPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 134665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrkz),
     /* 134668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134670 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134672 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134674 */     GIR_RootConstrainSelectedInstOperands,
     /* 134675 */     // GIR_Coverage, 4484,
     /* 134675 */     GIR_EraseRootFromParent_Done,
     /* 134676 */   // Label 2923: @134676
     /* 134676 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(134709), // Rule ID 4538 //
     /* 134681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134688 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134694 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134698 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src, immAllZerosV:{ *:[v4i64] })  =>  (VMOVDQA64Z256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 134698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrkz),
     /* 134701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134703 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 134705 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 134707 */     GIR_RootConstrainSelectedInstOperands,
     /* 134708 */     // GIR_Coverage, 4538,
     /* 134708 */     GIR_EraseRootFromParent_Done,
     /* 134709 */   // Label 2924: @134709
     /* 134709 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(134846), // Rule ID 19781 //
     /* 134714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134731 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, immAllZerosV:{ *:[v4f64] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrkz:{ *:[v8f64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134731 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134734 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134738 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134745 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134748 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134752 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134757 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134760 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134764 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134767 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134772 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134777 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134782 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134785 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134789 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134794 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 134810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134818 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134828 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134845 */     // GIR_Coverage, 19781,
     /* 134845 */     GIR_EraseRootFromParent_Done,
     /* 134846 */   // Label 2925: @134846
     /* 134846 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(134983), // Rule ID 19783 //
     /* 134851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 134854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 134858 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 134864 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 134866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134868 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, immAllZerosV:{ *:[v4i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 134868 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 134871 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 134875 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134882 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 134885 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 134889 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134894 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 134897 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 134901 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 134904 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 134909 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134914 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s1,
     /* 134922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 134935 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 134940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 134943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 134947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134952 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 134955 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 134958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 134960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134965 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 134972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 134977 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 134982 */     // GIR_Coverage, 19783,
     /* 134982 */     GIR_EraseRootFromParent_Done,
     /* 134983 */   // Label 2926: @134983
     /* 134983 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(135008), // Rule ID 4486 //
     /* 134988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 134991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 134995 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (VMOVAPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1)
     /* 134995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZ256rrk),
     /* 134998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135000 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135002 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135006 */     GIR_RootConstrainSelectedInstOperands,
     /* 135007 */     // GIR_Coverage, 4486,
     /* 135007 */     GIR_EraseRootFromParent_Done,
     /* 135008 */   // Label 2927: @135008
     /* 135008 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(135033), // Rule ID 4540 //
     /* 135013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 135016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135020 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (VMOVDQA64Z256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src0, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1)
     /* 135020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Z256rrk),
     /* 135023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135025 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135027 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135029 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 135031 */     GIR_RootConstrainSelectedInstOperands,
     /* 135032 */     // GIR_Coverage, 4540,
     /* 135032 */     GIR_EraseRootFromParent_Done,
     /* 135033 */   // Label 2928: @135033
     /* 135033 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(135214), // Rule ID 19780 //
     /* 135038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135045 */     // (vselect:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4f64] } (VMOVAPDZrrk:{ *:[v8f64] } (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8f64] } (IMPLICIT_DEF:{ *:[v8f64] }), VR256X:{ *:[v4f64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135045 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135048 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135052 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135059 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135062 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135066 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135071 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135074 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135078 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135081 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135086 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135091 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135096 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135099 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135103 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135108 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135112 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135143 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 135175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135183 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135196 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135203 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135213 */     // GIR_Coverage, 19780,
     /* 135213 */     GIR_EraseRootFromParent_Done,
     /* 135214 */   // Label 2929: @135214
     /* 135214 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(135395), // Rule ID 19782 //
     /* 135219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 135222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 135226 */     // (vselect:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VMOVDQA64Zrrk:{ *:[v8i64] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v8i1] } VK4WM:{ *:[v4i1] }:$mask, VK8WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 135226 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v8s64,
     /* 135229 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135233 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 135240 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 135243 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135247 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135252 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 135255 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135259 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 135262 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135267 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135272 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135277 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s1,
     /* 135280 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135284 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135289 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135293 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 135301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 135312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 135315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 135327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 135331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 135334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s64,
     /* 135352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 135356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 135367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 135370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135377 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 135384 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 135389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135394 */     // GIR_Coverage, 19782,
     /* 135394 */     GIR_EraseRootFromParent_Done,
     /* 135395 */   // Label 2930: @135395
     /* 135395 */   GIM_Reject,
     /* 135396 */ // Label 2922: @135396
     /* 135396 */ GIM_Reject,
     /* 135397 */ // Label 2894: @135397
     /* 135397 */ GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(136554),
     /* 135402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 135405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 135408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 135411 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(135490), // Rule ID 19867 //
     /* 135416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135435 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135438 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135442 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135446 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135454 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135460 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135471 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135476 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135478 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135488 */     GIR_RootConstrainSelectedInstOperands,
     /* 135489 */     // GIR_Coverage, 19867,
     /* 135489 */     GIR_EraseRootFromParent_Done,
     /* 135490 */   // Label 2932: @135490
     /* 135490 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(135565), // Rule ID 19869 //
     /* 135495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 135529 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135535 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 135537 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135546 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rmkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmkz),
     /* 135549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135551 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135563 */     GIR_RootConstrainSelectedInstOperands,
     /* 135564 */     // GIR_Coverage, 19869,
     /* 135564 */     GIR_EraseRootFromParent_Done,
     /* 135565 */   // Label 2933: @135565
     /* 135565 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(135637), // Rule ID 19866 //
     /* 135570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135589 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135596 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135600 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 135604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135617 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135624 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135635 */     GIR_RootConstrainSelectedInstOperands,
     /* 135636 */     // GIR_Coverage, 19866,
     /* 135636 */     GIR_EraseRootFromParent_Done,
     /* 135637 */   // Label 2934: @135637
     /* 135637 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(135705), // Rule ID 19868 //
     /* 135642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 135657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 135661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 135668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 135672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 135685 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rmk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 135685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rmk),
     /* 135688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135690 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 135692 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135694 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 135698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135703 */     GIR_RootConstrainSelectedInstOperands,
     /* 135704 */     // GIR_Coverage, 19868,
     /* 135704 */     GIR_EraseRootFromParent_Done,
     /* 135705 */   // Label 2935: @135705
     /* 135705 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(135750), // Rule ID 4571 //
     /* 135710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 135713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135729 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135735 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135739 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src, immAllZerosV:{ *:[v8i16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 135739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 135742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135744 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 135746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 135748 */     GIR_RootConstrainSelectedInstOperands,
     /* 135749 */     // GIR_Coverage, 4571,
     /* 135749 */     GIR_EraseRootFromParent_Done,
     /* 135750 */   // Label 2936: @135750
     /* 135750 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(135899), // Rule ID 19789 //
     /* 135755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135774 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135780 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135784 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, immAllZerosV:{ *:[v8i16] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135784 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135787 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135791 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135798 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135801 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135805 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135810 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135813 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135817 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135820 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135825 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135830 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135847 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 135851 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 135856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 135859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 135863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135868 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 135871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 135874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 135876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135881 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 135888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 135893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135898 */     // GIR_Coverage, 19789,
     /* 135898 */     GIR_EraseRootFromParent_Done,
     /* 135899 */   // Label 2937: @135899
     /* 135899 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(136048), // Rule ID 19793 //
     /* 135904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 135907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 135911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 135915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 135919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 135923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 135929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 135931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135933 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 135933 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 135936 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 135940 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 135947 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 135950 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 135954 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135959 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 135962 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 135966 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 135969 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 135974 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 135979 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 135984 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 135987 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135991 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135996 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 136012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136017 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136030 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136047 */     // GIR_Coverage, 19793,
     /* 136047 */     GIR_EraseRootFromParent_Done,
     /* 136048 */   // Label 2938: @136048
     /* 136048 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(136093), // Rule ID 19865 //
     /* 136053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136072 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136078 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136082 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, immAllZerosV:{ *:[v8f16] })  =>  (VMOVDQU16Z128rrkz:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrkz),
     /* 136085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136087 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136091 */     GIR_RootConstrainSelectedInstOperands,
     /* 136092 */     // GIR_Coverage, 19865,
     /* 136092 */     GIR_EraseRootFromParent_Done,
     /* 136093 */   // Label 2939: @136093
     /* 136093 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(136130), // Rule ID 4572 //
     /* 136098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136117 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1)
     /* 136117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136122 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136124 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136128 */     GIR_RootConstrainSelectedInstOperands,
     /* 136129 */     // GIR_Coverage, 4572,
     /* 136129 */     GIR_EraseRootFromParent_Done,
     /* 136130 */   // Label 2940: @136130
     /* 136130 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(136323), // Rule ID 19788 //
     /* 136135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136154 */     // (vselect:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136154 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136157 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136161 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136168 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136171 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136175 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136180 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136183 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136187 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136190 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136195 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136200 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136205 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136208 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136212 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136217 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136221 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136226 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136229 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136233 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136252 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136259 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136292 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136305 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136312 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136322 */     // GIR_Coverage, 19788,
     /* 136322 */     GIR_EraseRootFromParent_Done,
     /* 136323 */   // Label 2941: @136323
     /* 136323 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(136516), // Rule ID 19792 //
     /* 136328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 136331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 136335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136347 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK8WM:{ *:[v8i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR128X:{ *:[v8f16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 136347 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 136350 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136354 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136361 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 136364 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136368 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136373 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 136376 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136380 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 136383 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136388 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136393 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136398 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 136401 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136405 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136410 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136414 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 136419 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 136422 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136426 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 136436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136445 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 136448 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 136452 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 136455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136460 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 136470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 136473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 136477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136482 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136485 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 136488 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 136491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136498 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 136505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 136510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136515 */     // GIR_Coverage, 19792,
     /* 136515 */     GIR_EraseRootFromParent_Done,
     /* 136516 */   // Label 2942: @136516
     /* 136516 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(136553), // Rule ID 19864 //
     /* 136521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 136524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 136540 */     // (vselect:{ *:[v8f16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src0)  =>  (VMOVDQU16Z128rrk:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8f16] }:$src1)
     /* 136540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z128rrk),
     /* 136543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136545 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136547 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136549 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136551 */     GIR_RootConstrainSelectedInstOperands,
     /* 136552 */     // GIR_Coverage, 19864,
     /* 136552 */     GIR_EraseRootFromParent_Done,
     /* 136553 */   // Label 2943: @136553
     /* 136553 */   GIM_Reject,
     /* 136554 */ // Label 2931: @136554
     /* 136554 */ GIM_Reject,
     /* 136555 */ // Label 2895: @136555
     /* 136555 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(137334),
     /* 136560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 136563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 136566 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 136569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 136577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136581 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(136614), // Rule ID 4466 //
     /* 136586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136593 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136599 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136603 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src, immAllZerosV:{ *:[v8f32] })  =>  (VMOVAPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 136603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrkz),
     /* 136606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136608 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136610 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136612 */     GIR_RootConstrainSelectedInstOperands,
     /* 136613 */     // GIR_Coverage, 4466,
     /* 136613 */     GIR_EraseRootFromParent_Done,
     /* 136614 */   // Label 2945: @136614
     /* 136614 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(136647), // Rule ID 4525 //
     /* 136619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136626 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136632 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136636 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src, immAllZerosV:{ *:[v8i32] })  =>  (VMOVDQA32Z256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 136636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrkz),
     /* 136639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136641 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136643 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 136645 */     GIR_RootConstrainSelectedInstOperands,
     /* 136646 */     // GIR_Coverage, 4525,
     /* 136646 */     GIR_EraseRootFromParent_Done,
     /* 136647 */   // Label 2946: @136647
     /* 136647 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(136784), // Rule ID 19773 //
     /* 136652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136669 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, immAllZerosV:{ *:[v8f32] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrkz:{ *:[v16f32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136669 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136672 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136676 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136683 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136686 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136690 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136695 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136698 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136702 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136705 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136710 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136715 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136720 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136723 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136727 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136736 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 136748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136753 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136756 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136766 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136783 */     // GIR_Coverage, 19773,
     /* 136783 */     GIR_EraseRootFromParent_Done,
     /* 136784 */   // Label 2947: @136784
     /* 136784 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(136921), // Rule ID 19775 //
     /* 136789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 136796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 136802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 136804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136806 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, immAllZerosV:{ *:[v8i32] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrkz:{ *:[v16i32] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136806 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s32,
     /* 136809 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136813 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136820 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 136823 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 136827 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136832 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 136835 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 136839 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 136842 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 136847 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136852 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 136860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 136873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 136878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 136881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 136885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136890 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 136893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 136896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 136898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 136910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 136915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 136920 */     // GIR_Coverage, 19775,
     /* 136920 */     GIR_EraseRootFromParent_Done,
     /* 136921 */   // Label 2948: @136921
     /* 136921 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(136946), // Rule ID 4468 //
     /* 136926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136933 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (VMOVAPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1)
     /* 136933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZ256rrk),
     /* 136936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136938 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136940 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136942 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136944 */     GIR_RootConstrainSelectedInstOperands,
     /* 136945 */     // GIR_Coverage, 4468,
     /* 136945 */     GIR_EraseRootFromParent_Done,
     /* 136946 */   // Label 2949: @136946
     /* 136946 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(136971), // Rule ID 4526 //
     /* 136951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 136954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136958 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (VMOVDQA32Z256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1)
     /* 136958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Z256rrk),
     /* 136961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136963 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 136965 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 136967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 136969 */     GIR_RootConstrainSelectedInstOperands,
     /* 136970 */     // GIR_Coverage, 4526,
     /* 136970 */     GIR_EraseRootFromParent_Done,
     /* 136971 */   // Label 2950: @136971
     /* 136971 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(137152), // Rule ID 19772 //
     /* 136976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 136979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 136983 */     // (vselect:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8f32] } (VMOVAPSZrrk:{ *:[v16f32] } (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16f32] } (IMPLICIT_DEF:{ *:[v16f32] }), VR256X:{ *:[v8f32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 136983 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 136986 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 136990 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 136997 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 137000 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137004 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137009 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137012 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137016 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 137019 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137024 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137029 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137034 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137037 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137041 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137046 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137050 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137055 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137058 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137062 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137081 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137084 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137088 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137096 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137101 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 137113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137118 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137121 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137124 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137134 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137151 */     // GIR_Coverage, 19772,
     /* 137151 */     GIR_EraseRootFromParent_Done,
     /* 137152 */   // Label 2951: @137152
     /* 137152 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(137333), // Rule ID 19774 //
     /* 137157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 137160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 137164 */     // (vselect:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VMOVDQA32Zrrk:{ *:[v16i32] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v16i1] } VK8WM:{ *:[v8i1] }:$mask, VK16WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 137164 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v16s32,
     /* 137167 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137171 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137178 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s32,
     /* 137181 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137185 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137190 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 137193 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137197 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 137200 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137205 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137210 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137215 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s1,
     /* 137218 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137222 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137227 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137231 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137236 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 137239 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137243 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137250 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 137253 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137257 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137262 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137265 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 137269 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 137272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s32,
     /* 137290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 137294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137299 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 137305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 137308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137315 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 137322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 137327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137332 */     // GIR_Coverage, 19774,
     /* 137332 */     GIR_EraseRootFromParent_Done,
     /* 137333 */   // Label 2952: @137333
     /* 137333 */   GIM_Reject,
     /* 137334 */ // Label 2944: @137334
     /* 137334 */ GIM_Reject,
     /* 137335 */ // Label 2896: @137335
     /* 137335 */ GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(137715),
     /* 137340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 137346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 137349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137353 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(137422), // Rule ID 19766 //
     /* 137358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 137366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 137370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 137374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 137379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 137383 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 137391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 137395 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 137403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 137409 */     // (vselect:{ *:[v8i64] } (xor:{ *:[v8i1] } VK8:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i1] }), immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 137418 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137420 */     GIR_RootConstrainSelectedInstOperands,
     /* 137421 */     // GIR_Coverage, 19766,
     /* 137421 */     GIR_EraseRootFromParent_Done,
     /* 137422 */   // Label 2954: @137422
     /* 137422 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(137469), // Rule ID 3599 //
     /* 137427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137444 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 137446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 137450 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137456 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 137458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 137460 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllOnesV:{ *:[v8i64] }, immAllZerosV:{ *:[v8i64] })  =>  (AVX512_512_SEXT_MASK_64:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask)
     /* 137460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_64),
     /* 137463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137465 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137467 */     GIR_RootConstrainSelectedInstOperands,
     /* 137468 */     // GIR_Coverage, 3599,
     /* 137468 */     GIR_EraseRootFromParent_Done,
     /* 137469 */   // Label 2955: @137469
     /* 137469 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(137566), // Rule ID 19764 //
     /* 137474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 137482 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137488 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137496 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] }, VR512:{ *:[v8i64] }:$src)  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } (COPY_TO_REGCLASS:{ *:[v8i1] } (KNOTWkk:{ *:[v16i1] } (COPY_TO_REGCLASS:{ *:[v16i1] } VK8:{ *:[v8i1] }:$mask, VK16:{ *:[i32] })), VK8:{ *:[i32] }), VR512:{ *:[v8i64] }:$src)
     /* 137496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s1,
     /* 137499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137508 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137512 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 137517 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s1,
     /* 137520 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 137524 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137529 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 137532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s1,
     /* 137537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137546 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 137554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137562 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 137564 */     GIR_RootConstrainSelectedInstOperands,
     /* 137565 */     // GIR_Coverage, 19764,
     /* 137565 */     GIR_EraseRootFromParent_Done,
     /* 137566 */   // Label 2956: @137566
     /* 137566 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(137607), // Rule ID 4479 //
     /* 137571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137596 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src, immAllZerosV:{ *:[v8f64] })  =>  (VMOVAPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 137596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrkz),
     /* 137599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137601 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137603 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137605 */     GIR_RootConstrainSelectedInstOperands,
     /* 137606 */     // GIR_Coverage, 4479,
     /* 137606 */     GIR_EraseRootFromParent_Done,
     /* 137607 */   // Label 2957: @137607
     /* 137607 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(137648), // Rule ID 4533 //
     /* 137612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137637 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src, immAllZerosV:{ *:[v8i64] })  =>  (VMOVDQA64Zrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 137637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrkz),
     /* 137640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137642 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137646 */     GIR_RootConstrainSelectedInstOperands,
     /* 137647 */     // GIR_Coverage, 4533,
     /* 137647 */     GIR_EraseRootFromParent_Done,
     /* 137648 */   // Label 2958: @137648
     /* 137648 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(137681), // Rule ID 4481 //
     /* 137653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137668 */     // (vselect:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src0)  =>  (VMOVAPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src1)
     /* 137668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPDZrrk),
     /* 137671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137673 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137675 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137679 */     GIR_RootConstrainSelectedInstOperands,
     /* 137680 */     // GIR_Coverage, 4481,
     /* 137680 */     GIR_EraseRootFromParent_Done,
     /* 137681 */   // Label 2959: @137681
     /* 137681 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(137714), // Rule ID 4535 //
     /* 137686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 137689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 137693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 137701 */     // (vselect:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src0)  =>  (VMOVDQA64Zrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src0, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src1)
     /* 137701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA64Zrrk),
     /* 137704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137706 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137708 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137710 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137712 */     GIR_RootConstrainSelectedInstOperands,
     /* 137713 */     // GIR_Coverage, 4535,
     /* 137713 */     GIR_EraseRootFromParent_Done,
     /* 137714 */   // Label 2960: @137714
     /* 137714 */   GIM_Reject,
     /* 137715 */ // Label 2953: @137715
     /* 137715 */ GIM_Reject,
     /* 137716 */ // Label 2897: @137716
     /* 137716 */ GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(138155),
     /* 137721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 137724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 137727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 137730 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(137775), // Rule ID 4559 //
     /* 137735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137754 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137760 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137764 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src, immAllZerosV:{ *:[v16i8] })  =>  (VMOVDQU8Z128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 137764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrkz),
     /* 137767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137769 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137771 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 137773 */     GIR_RootConstrainSelectedInstOperands,
     /* 137774 */     // GIR_Coverage, 4559,
     /* 137774 */     GIR_EraseRootFromParent_Done,
     /* 137775 */   // Label 2962: @137775
     /* 137775 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(137924), // Rule ID 19785 //
     /* 137780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 137799 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 137805 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 137807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137809 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, immAllZerosV:{ *:[v16i8] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 137812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137823 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 137826 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 137830 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137835 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 137838 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 137842 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/11,
     /* 137845 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 137850 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 137860 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 137863 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137867 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137872 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 137876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 137881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 137884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 137888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 137896 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 137899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 137901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137906 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 137913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 137918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 137923 */     // GIR_Coverage, 19785,
     /* 137923 */     GIR_EraseRootFromParent_Done,
     /* 137924 */   // Label 2963: @137924
     /* 137924 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(137961), // Rule ID 4560 //
     /* 137929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137948 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (VMOVDQU8Z128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1)
     /* 137948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z128rrk),
     /* 137951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137953 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 137955 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 137957 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 137959 */     GIR_RootConstrainSelectedInstOperands,
     /* 137960 */     // GIR_Coverage, 4560,
     /* 137960 */     GIR_EraseRootFromParent_Done,
     /* 137961 */   // Label 2964: @137961
     /* 137961 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(138154), // Rule ID 19784 //
     /* 137966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 137969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 137973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 137977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 137985 */     // (vselect:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src0, sub_xmm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK16WM:{ *:[v16i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 137985 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 137988 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 137992 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 137999 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 138002 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138006 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138011 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138014 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138018 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/11,
     /* 138021 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138026 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138031 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138036 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 138039 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138043 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138048 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138052 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 138057 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 138060 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138064 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 138074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138083 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138086 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138090 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 138093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138103 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 138108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 138111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 138115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138120 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138136 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 138143 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 138148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138153 */     // GIR_Coverage, 19784,
     /* 138153 */     GIR_EraseRootFromParent_Done,
     /* 138154 */   // Label 2965: @138154
     /* 138154 */   GIM_Reject,
     /* 138155 */ // Label 2961: @138155
     /* 138155 */ GIM_Reject,
     /* 138156 */ // Label 2898: @138156
     /* 138156 */ GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(139225),
     /* 138161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 138164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 138167 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 138170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 138178 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(138249), // Rule ID 19857 //
     /* 138183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138205 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138213 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138219 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138230 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138235 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138247 */     GIR_RootConstrainSelectedInstOperands,
     /* 138248 */     // GIR_Coverage, 19857,
     /* 138248 */     GIR_EraseRootFromParent_Done,
     /* 138249 */   // Label 2967: @138249
     /* 138249 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(138316), // Rule ID 19859 //
     /* 138254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 138280 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138286 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 138288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138297 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rmkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmkz),
     /* 138300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138302 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138314 */     GIR_RootConstrainSelectedInstOperands,
     /* 138315 */     // GIR_Coverage, 19859,
     /* 138315 */     GIR_EraseRootFromParent_Done,
     /* 138316 */   // Label 2968: @138316
     /* 138316 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(138380), // Rule ID 19856 //
     /* 138321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138343 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 138347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138360 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138365 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138367 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138378 */     GIR_RootConstrainSelectedInstOperands,
     /* 138379 */     // GIR_Coverage, 19856,
     /* 138379 */     GIR_EraseRootFromParent_Done,
     /* 138380 */   // Label 2969: @138380
     /* 138380 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(138440), // Rule ID 19858 //
     /* 138385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 138392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 138396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 138403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 138407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 138420 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rmk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 138420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rmk),
     /* 138423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138425 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138427 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 138433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138438 */     GIR_RootConstrainSelectedInstOperands,
     /* 138439 */     // GIR_Coverage, 19858,
     /* 138439 */     GIR_EraseRootFromParent_Done,
     /* 138440 */   // Label 2970: @138440
     /* 138440 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(138477), // Rule ID 4567 //
     /* 138445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138456 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138462 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138466 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src, immAllZerosV:{ *:[v16i16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 138466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138471 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138473 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 138475 */     GIR_RootConstrainSelectedInstOperands,
     /* 138476 */     // GIR_Coverage, 4567,
     /* 138476 */     GIR_EraseRootFromParent_Done,
     /* 138477 */   // Label 2971: @138477
     /* 138477 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(138618), // Rule ID 19791 //
     /* 138482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138493 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138499 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138503 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, immAllZerosV:{ *:[v16i16] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrkz:{ *:[v32i16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138503 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138506 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138510 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138517 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138520 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138524 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138529 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138532 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138536 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138539 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138544 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138590 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138600 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138617 */     // GIR_Coverage, 19791,
     /* 138617 */     GIR_EraseRootFromParent_Done,
     /* 138618 */   // Label 2972: @138618
     /* 138618 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(138759), // Rule ID 19795 //
     /* 138623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138644 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrkz:{ *:[v32f16] } (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138644 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s16,
     /* 138647 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138651 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138658 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138661 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138665 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138670 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 138673 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138677 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 138680 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138685 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138690 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s1,
     /* 138698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 138723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 138734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138758 */     // GIR_Coverage, 19795,
     /* 138758 */     GIR_EraseRootFromParent_Done,
     /* 138759 */   // Label 2973: @138759
     /* 138759 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(138796), // Rule ID 19855 //
     /* 138764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 138775 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 138781 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 138783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138785 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, immAllZerosV:{ *:[v16f16] })  =>  (VMOVDQU16Z256rrkz:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 138785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrkz),
     /* 138788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138790 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138794 */     GIR_RootConstrainSelectedInstOperands,
     /* 138795 */     // GIR_Coverage, 19855,
     /* 138795 */     GIR_EraseRootFromParent_Done,
     /* 138796 */   // Label 2974: @138796
     /* 138796 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(138825), // Rule ID 4568 //
     /* 138801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 138804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138812 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1)
     /* 138812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 138815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138817 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 138819 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 138821 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 138823 */     GIR_RootConstrainSelectedInstOperands,
     /* 138824 */     // GIR_Coverage, 4568,
     /* 138824 */     GIR_EraseRootFromParent_Done,
     /* 138825 */   // Label 2975: @138825
     /* 138825 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(139010), // Rule ID 19790 //
     /* 138830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 138833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 138841 */     // (vselect:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VMOVDQU16Zrrk:{ *:[v32i16] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 138841 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 138844 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138848 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 138855 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 138858 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138862 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138867 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 138870 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 138874 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 138877 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138882 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138887 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138892 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 138895 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138899 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138904 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 138908 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 138913 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 138916 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 138920 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138927 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 138930 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 138934 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138939 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 138942 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 138946 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 138949 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 138954 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 138959 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 138964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 138967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 138971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138976 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 138979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 138982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 138985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 138987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138992 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 138999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139009 */     // GIR_Coverage, 19790,
     /* 139009 */     GIR_EraseRootFromParent_Done,
     /* 139010 */   // Label 2976: @139010
     /* 139010 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(139195), // Rule ID 19794 //
     /* 139015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139026 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v16f16] } (VMOVDQU16Zrrk:{ *:[v32f16] } (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v32i1] } VK16WM:{ *:[v16i1] }:$mask, VK32WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v32f16] } (IMPLICIT_DEF:{ *:[v32f16] }), VR256X:{ *:[v16f16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139026 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v32s16,
     /* 139029 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139033 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139040 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v32s16,
     /* 139043 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139047 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139052 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139055 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139059 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139062 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139067 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139072 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139077 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v32s1,
     /* 139080 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139084 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139089 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139093 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139098 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 139101 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139105 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 139115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139124 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139127 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139131 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139134 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139139 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139144 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s16,
     /* 139152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 139156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139161 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139167 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139177 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139194 */     // GIR_Coverage, 19794,
     /* 139194 */     GIR_EraseRootFromParent_Done,
     /* 139195 */   // Label 2977: @139195
     /* 139195 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(139224), // Rule ID 19854 //
     /* 139200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139211 */     // (vselect:{ *:[v16f16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src0)  =>  (VMOVDQU16Z256rrk:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16f16] }:$src1)
     /* 139211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Z256rrk),
     /* 139214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139216 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139218 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139220 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139222 */     GIR_RootConstrainSelectedInstOperands,
     /* 139223 */     // GIR_Coverage, 19854,
     /* 139223 */     GIR_EraseRootFromParent_Done,
     /* 139224 */   // Label 2978: @139224
     /* 139224 */   GIM_Reject,
     /* 139225 */ // Label 2966: @139225
     /* 139225 */ GIM_Reject,
     /* 139226 */ // Label 2899: @139226
     /* 139226 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(139566),
     /* 139231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 139237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 139240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139244 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(139313), // Rule ID 19767 //
     /* 139249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 139257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 139261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 139265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 139270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 139274 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 139282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 139286 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139292 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /* 139294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 139300 */     // (vselect:{ *:[v16i32] } (xor:{ *:[v16i1] } VK16:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i1] }), immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // mask
     /* 139309 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139311 */     GIR_RootConstrainSelectedInstOperands,
     /* 139312 */     // GIR_Coverage, 19767,
     /* 139312 */     GIR_EraseRootFromParent_Done,
     /* 139313 */   // Label 2980: @139313
     /* 139313 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(139360), // Rule ID 3598 //
     /* 139318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139329 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 139337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 139341 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139347 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 139349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 139351 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllOnesV:{ *:[v16i32] }, immAllZerosV:{ *:[v16i32] })  =>  (AVX512_512_SEXT_MASK_32:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask)
     /* 139351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::AVX512_512_SEXT_MASK_32),
     /* 139354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139356 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139358 */     GIR_RootConstrainSelectedInstOperands,
     /* 139359 */     // GIR_Coverage, 3598,
     /* 139359 */     GIR_EraseRootFromParent_Done,
     /* 139360 */   // Label 2981: @139360
     /* 139360 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(139417), // Rule ID 19765 //
     /* 139365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 139373 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139379 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139387 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] }, VR512:{ *:[v16i32] }:$src)  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } (KNOTWkk:{ *:[v16i1] } VK16WM:{ *:[v16i1] }:$mask), VR512:{ *:[v16i32] }:$src)
     /* 139387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s1,
     /* 139390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::KNOTWkk),
     /* 139394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139413 */     GIR_RootToRootCopy, /*OpIdx*/3, // src
     /* 139415 */     GIR_RootConstrainSelectedInstOperands,
     /* 139416 */     // GIR_Coverage, 19765,
     /* 139416 */     GIR_EraseRootFromParent_Done,
     /* 139417 */   // Label 2982: @139417
     /* 139417 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(139458), // Rule ID 4461 //
     /* 139422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139437 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139443 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139447 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src, immAllZerosV:{ *:[v16f32] })  =>  (VMOVAPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 139447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrkz),
     /* 139450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139452 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139454 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139456 */     GIR_RootConstrainSelectedInstOperands,
     /* 139457 */     // GIR_Coverage, 4461,
     /* 139457 */     GIR_EraseRootFromParent_Done,
     /* 139458 */   // Label 2983: @139458
     /* 139458 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(139499), // Rule ID 4521 //
     /* 139463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139478 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139484 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139488 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src, immAllZerosV:{ *:[v16i32] })  =>  (VMOVDQA32Zrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 139488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrkz),
     /* 139491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139493 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139495 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139497 */     GIR_RootConstrainSelectedInstOperands,
     /* 139498 */     // GIR_Coverage, 4521,
     /* 139498 */     GIR_EraseRootFromParent_Done,
     /* 139499 */   // Label 2984: @139499
     /* 139499 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(139532), // Rule ID 4463 //
     /* 139504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139519 */     // (vselect:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src0)  =>  (VMOVAPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src1)
     /* 139519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVAPSZrrk),
     /* 139522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139524 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139526 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139528 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139530 */     GIR_RootConstrainSelectedInstOperands,
     /* 139531 */     // GIR_Coverage, 4463,
     /* 139531 */     GIR_EraseRootFromParent_Done,
     /* 139532 */   // Label 2985: @139532
     /* 139532 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(139565), // Rule ID 4522 //
     /* 139537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 139540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 139544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139552 */     // (vselect:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src0)  =>  (VMOVDQA32Zrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src0, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src1)
     /* 139552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQA32Zrrk),
     /* 139555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139557 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139559 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139561 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139563 */     GIR_RootConstrainSelectedInstOperands,
     /* 139564 */     // GIR_Coverage, 4522,
     /* 139564 */     GIR_EraseRootFromParent_Done,
     /* 139565 */   // Label 2986: @139565
     /* 139565 */   GIM_Reject,
     /* 139566 */ // Label 2979: @139566
     /* 139566 */ GIM_Reject,
     /* 139567 */ // Label 2900: @139567
     /* 139567 */ GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(139970),
     /* 139572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 139578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 139581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139593 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(139626), // Rule ID 4555 //
     /* 139598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139605 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139611 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139615 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src, immAllZerosV:{ *:[v32i8] })  =>  (VMOVDQU8Z256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 139615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrkz),
     /* 139618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139620 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139622 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 139624 */     GIR_RootConstrainSelectedInstOperands,
     /* 139625 */     // GIR_Coverage, 4555,
     /* 139625 */     GIR_EraseRootFromParent_Done,
     /* 139626 */   // Label 2988: @139626
     /* 139626 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(139763), // Rule ID 19787 //
     /* 139631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 139638 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 139644 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 139646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139648 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, immAllZerosV:{ *:[v32i8] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrkz:{ *:[v64i8] } (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139648 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s8,
     /* 139651 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139655 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139662 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139665 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139669 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139674 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 139677 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139681 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/12,
     /* 139684 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139689 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139694 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139699 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s1,
     /* 139702 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139706 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 139727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139732 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139735 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 139738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139745 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139752 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139762 */     // GIR_Coverage, 19787,
     /* 139762 */     GIR_EraseRootFromParent_Done,
     /* 139763 */   // Label 2989: @139763
     /* 139763 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(139788), // Rule ID 4556 //
     /* 139768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 139771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139775 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (VMOVDQU8Z256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1)
     /* 139775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Z256rrk),
     /* 139778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139780 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 139782 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 139784 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 139786 */     GIR_RootConstrainSelectedInstOperands,
     /* 139787 */     // GIR_Coverage, 4556,
     /* 139787 */     GIR_EraseRootFromParent_Done,
     /* 139788 */   // Label 2990: @139788
     /* 139788 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(139969), // Rule ID 19786 //
     /* 139793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasEVEX512_NoVLX),
     /* 139796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 139800 */     // (vselect:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src0)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VMOVDQU8Zrrk:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src0, sub_ymm:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v64i1] } VK32WM:{ *:[v32i1] }:$mask, VK64WM:{ *:[i32] }), (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 139800 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v64s8,
     /* 139803 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139807 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 139814 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v64s8,
     /* 139817 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139821 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139826 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 139829 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/2, // src1
     /* 139833 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/12,
     /* 139836 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139841 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139846 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139851 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v64s1,
     /* 139854 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139858 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139863 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // mask
     /* 139867 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VK64WMRegClassID),
     /* 139872 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 139875 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 139879 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139886 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 139889 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 139893 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139898 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 139901 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // src0
     /* 139905 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 139908 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 139913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 139926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 139930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139935 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 139938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 139941 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/4,
     /* 139944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 139946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139951 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 139958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 139963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 139968 */     // GIR_Coverage, 19786,
     /* 139968 */     GIR_EraseRootFromParent_Done,
     /* 139969 */   // Label 2991: @139969
     /* 139969 */   GIM_Reject,
     /* 139970 */ // Label 2987: @139970
     /* 139970 */ GIM_Reject,
     /* 139971 */ // Label 2901: @139971
     /* 139971 */ GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(140388),
     /* 139976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 139979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 139982 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 139985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 139989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 139993 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(140064), // Rule ID 19847 //
     /* 139998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140009 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140012 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140016 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140020 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140028 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140045 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140050 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140062 */     GIR_RootConstrainSelectedInstOperands,
     /* 140063 */     // GIR_Coverage, 19847,
     /* 140063 */     GIR_EraseRootFromParent_Done,
     /* 140064 */   // Label 2993: @140064
     /* 140064 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(140131), // Rule ID 19849 //
     /* 140069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 140095 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140101 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /* 140103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140112 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrmkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmkz),
     /* 140115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140117 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140119 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 140129 */     GIR_RootConstrainSelectedInstOperands,
     /* 140130 */     // GIR_Coverage, 19849,
     /* 140130 */     GIR_EraseRootFromParent_Done,
     /* 140131 */   // Label 2994: @140131
     /* 140131 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(140195), // Rule ID 19846 //
     /* 140136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140158 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_alignedload),
     /* 140162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140168 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140175 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>><<P:Predicate_alignedload>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140180 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140182 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140193 */     GIR_RootConstrainSelectedInstOperands,
     /* 140194 */     // GIR_Coverage, 19846,
     /* 140194 */     GIR_EraseRootFromParent_Done,
     /* 140195 */   // Label 2995: @140195
     /* 140195 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(140255), // Rule ID 19848 //
     /* 140200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140211 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140218 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140228 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140235 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrmk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, addr:{ *:[iPTR] }:$src)
     /* 140235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrmk),
     /* 140238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140240 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140242 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 140248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140253 */     GIR_RootConstrainSelectedInstOperands,
     /* 140254 */     // GIR_Coverage, 19848,
     /* 140254 */     GIR_EraseRootFromParent_Done,
     /* 140255 */   // Label 2996: @140255
     /* 140255 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(140292), // Rule ID 4563 //
     /* 140260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140281 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src, immAllZerosV:{ *:[v32i16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 140281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140286 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140288 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140290 */     GIR_RootConstrainSelectedInstOperands,
     /* 140291 */     // GIR_Coverage, 4563,
     /* 140291 */     GIR_EraseRootFromParent_Done,
     /* 140292 */   // Label 2997: @140292
     /* 140292 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(140329), // Rule ID 19845 //
     /* 140297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140308 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140314 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140318 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, immAllZerosV:{ *:[v32f16] })  =>  (VMOVDQU16Zrrkz:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrkz),
     /* 140321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140323 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140327 */     GIR_RootConstrainSelectedInstOperands,
     /* 140328 */     // GIR_Coverage, 19845,
     /* 140328 */     GIR_EraseRootFromParent_Done,
     /* 140329 */   // Label 2998: @140329
     /* 140329 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(140358), // Rule ID 4564 //
     /* 140334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140345 */     // (vselect:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src1)
     /* 140345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140352 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140354 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140356 */     GIR_RootConstrainSelectedInstOperands,
     /* 140357 */     // GIR_Coverage, 4564,
     /* 140357 */     GIR_EraseRootFromParent_Done,
     /* 140358 */   // Label 2999: @140358
     /* 140358 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(140387), // Rule ID 19844 //
     /* 140363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140374 */     // (vselect:{ *:[v32f16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src0)  =>  (VMOVDQU16Zrrk:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src0, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32f16] }:$src1)
     /* 140374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU16Zrrk),
     /* 140377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140379 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140381 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140385 */     GIR_RootConstrainSelectedInstOperands,
     /* 140386 */     // GIR_Coverage, 19844,
     /* 140386 */     GIR_EraseRootFromParent_Done,
     /* 140387 */   // Label 3000: @140387
     /* 140387 */   GIM_Reject,
     /* 140388 */ // Label 2992: @140388
     /* 140388 */ GIM_Reject,
     /* 140389 */ // Label 2902: @140389
     /* 140389 */ GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(140474),
     /* 140394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 140397 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 140400 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 140403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 140411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140415 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(140448), // Rule ID 4551 //
     /* 140420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 140427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 140433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 140435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140437 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src, immAllZerosV:{ *:[v64i8] })  =>  (VMOVDQU8Zrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 140437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrkz),
     /* 140440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140442 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140444 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 140446 */     GIR_RootConstrainSelectedInstOperands,
     /* 140447 */     // GIR_Coverage, 4551,
     /* 140447 */     GIR_EraseRootFromParent_Done,
     /* 140448 */   // Label 3002: @140448
     /* 140448 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(140473), // Rule ID 4552 //
     /* 140453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 140456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 140460 */     // (vselect:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src0)  =>  (VMOVDQU8Zrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src0, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src1)
     /* 140460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMOVDQU8Zrrk),
     /* 140463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140465 */     GIR_RootToRootCopy, /*OpIdx*/3, // src0
     /* 140467 */     GIR_RootToRootCopy, /*OpIdx*/1, // mask
     /* 140469 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140471 */     GIR_RootConstrainSelectedInstOperands,
     /* 140472 */     // GIR_Coverage, 4552,
     /* 140472 */     GIR_EraseRootFromParent_Done,
     /* 140473 */   // Label 3003: @140473
     /* 140473 */   GIM_Reject,
     /* 140474 */ // Label 3001: @140474
     /* 140474 */ GIM_Reject,
     /* 140475 */ // Label 2903: @140475
     /* 140475 */ GIM_Reject,
     /* 140476 */ // Label 35: @140476
     /* 140476 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3007*/ GIMT_Encode4(141340),
     /* 140487 */ /*GILLT_v8s16*//*Label 3004*/ GIMT_Encode4(140527), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140507 */ /*GILLT_v16s16*//*Label 3005*/ GIMT_Encode4(140869), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 140523 */ /*GILLT_v32s16*//*Label 3006*/ GIMT_Encode4(141184),
     /* 140527 */ // Label 3004: @140527
     /* 140527 */ GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(140868),
     /* 140532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 140538 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(140600), // Rule ID 23456 //
     /* 140543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140558 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140561 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140565 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140582 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140587 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140589 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140598 */     GIR_RootConstrainSelectedInstOperands,
     /* 140599 */     // GIR_Coverage, 23456,
     /* 140599 */     GIR_EraseRootFromParent_Done,
     /* 140600 */   // Label 3009: @140600
     /* 140600 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(140662), // Rule ID 23846 //
     /* 140605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140620 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140623 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140627 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140644 */     // (mulhu:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140649 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140651 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140655 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140660 */     GIR_RootConstrainSelectedInstOperands,
     /* 140661 */     // GIR_Coverage, 23846,
     /* 140661 */     GIR_EraseRootFromParent_Done,
     /* 140662 */   // Label 3010: @140662
     /* 140662 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(140724), // Rule ID 2577 //
     /* 140667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140686 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140689 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140693 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140699 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140706 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrm),
     /* 140709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140711 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140713 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140722 */     GIR_RootConstrainSelectedInstOperands,
     /* 140723 */     // GIR_Coverage, 2577,
     /* 140723 */     GIR_EraseRootFromParent_Done,
     /* 140724 */   // Label 3011: @140724
     /* 140724 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(140786), // Rule ID 5062 //
     /* 140729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140748 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140751 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140755 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140761 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140768 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rm),
     /* 140771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 140775 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140784 */     GIR_RootConstrainSelectedInstOperands,
     /* 140785 */     // GIR_Coverage, 5062,
     /* 140785 */     GIR_EraseRootFromParent_Done,
     /* 140786 */   // Label 3012: @140786
     /* 140786 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(140813), // Rule ID 2576 //
     /* 140791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 140794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140806 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWrr),
     /* 140811 */     GIR_RootConstrainSelectedInstOperands,
     /* 140812 */     // GIR_Coverage, 2576,
     /* 140812 */     GIR_Done,
     /* 140813 */   // Label 3013: @140813
     /* 140813 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(140840), // Rule ID 2578 //
     /* 140818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 140821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 140833 */     // (mulhu:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 140833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHUWrr),
     /* 140838 */     GIR_RootConstrainSelectedInstOperands,
     /* 140839 */     // GIR_Coverage, 2578,
     /* 140839 */     GIR_Done,
     /* 140840 */   // Label 3014: @140840
     /* 140840 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(140867), // Rule ID 5059 //
     /* 140845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 140860 */     // (mulhu:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 140860 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ128rr),
     /* 140865 */     GIR_RootConstrainSelectedInstOperands,
     /* 140866 */     // GIR_Coverage, 5059,
     /* 140866 */     GIR_Done,
     /* 140867 */   // Label 3015: @140867
     /* 140867 */   GIM_Reject,
     /* 140868 */ // Label 3008: @140868
     /* 140868 */ GIM_Reject,
     /* 140869 */ // Label 3005: @140869
     /* 140869 */ GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(141183),
     /* 140874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 140877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 140880 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(140942), // Rule ID 23458 //
     /* 140885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 140888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 140915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140917 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140924 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 140927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140940 */     GIR_RootConstrainSelectedInstOperands,
     /* 140941 */     // GIR_Coverage, 23458,
     /* 140941 */     GIR_EraseRootFromParent_Done,
     /* 140942 */   // Label 3017: @140942
     /* 140942 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(141004), // Rule ID 23843 //
     /* 140947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 140950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 140962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 140969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 140973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 140977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 140986 */     // (mulhu:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 140986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 140989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140991 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 140993 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 140997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141002 */     GIR_RootConstrainSelectedInstOperands,
     /* 141003 */     // GIR_Coverage, 23843,
     /* 141003 */     GIR_EraseRootFromParent_Done,
     /* 141004 */   // Label 3018: @141004
     /* 141004 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(141066), // Rule ID 2581 //
     /* 141009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141028 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141035 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141041 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141048 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrm),
     /* 141051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141053 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141055 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141064 */     GIR_RootConstrainSelectedInstOperands,
     /* 141065 */     // GIR_Coverage, 2581,
     /* 141065 */     GIR_EraseRootFromParent_Done,
     /* 141066 */   // Label 3019: @141066
     /* 141066 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(141128), // Rule ID 5056 //
     /* 141071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141103 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141110 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rm),
     /* 141113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141115 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141117 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141126 */     GIR_RootConstrainSelectedInstOperands,
     /* 141127 */     // GIR_Coverage, 5056,
     /* 141127 */     GIR_EraseRootFromParent_Done,
     /* 141128 */   // Label 3020: @141128
     /* 141128 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(141155), // Rule ID 2580 //
     /* 141133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141148 */     // (mulhu:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 141148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWYrr),
     /* 141153 */     GIR_RootConstrainSelectedInstOperands,
     /* 141154 */     // GIR_Coverage, 2580,
     /* 141154 */     GIR_Done,
     /* 141155 */   // Label 3021: @141155
     /* 141155 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(141182), // Rule ID 5053 //
     /* 141160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141175 */     // (mulhu:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 141175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZ256rr),
     /* 141180 */     GIR_RootConstrainSelectedInstOperands,
     /* 141181 */     // GIR_Coverage, 5053,
     /* 141181 */     GIR_Done,
     /* 141182 */   // Label 3022: @141182
     /* 141182 */   GIM_Reject,
     /* 141183 */ // Label 3016: @141183
     /* 141183 */ GIM_Reject,
     /* 141184 */ // Label 3006: @141184
     /* 141184 */ GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(141339),
     /* 141189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 141192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 141195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141199 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(141257), // Rule ID 23840 //
     /* 141204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141215 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141218 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141222 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141232 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141239 */     // (mulhu:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141244 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141246 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141255 */     GIR_RootConstrainSelectedInstOperands,
     /* 141256 */     // GIR_Coverage, 23840,
     /* 141256 */     GIR_EraseRootFromParent_Done,
     /* 141257 */   // Label 3024: @141257
     /* 141257 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(141315), // Rule ID 5050 //
     /* 141262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141277 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141280 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141284 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141297 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrm),
     /* 141300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141313 */     GIR_RootConstrainSelectedInstOperands,
     /* 141314 */     // GIR_Coverage, 5050,
     /* 141314 */     GIR_EraseRootFromParent_Done,
     /* 141315 */   // Label 3025: @141315
     /* 141315 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(141338), // Rule ID 5047 //
     /* 141320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 141323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 141331 */     // (mulhu:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 141331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHUWZrr),
     /* 141336 */     GIR_RootConstrainSelectedInstOperands,
     /* 141337 */     // GIR_Coverage, 5047,
     /* 141337 */     GIR_Done,
     /* 141338 */   // Label 3026: @141338
     /* 141338 */   GIM_Reject,
     /* 141339 */ // Label 3023: @141339
     /* 141339 */ GIM_Reject,
     /* 141340 */ // Label 3007: @141340
     /* 141340 */ GIM_Reject,
     /* 141341 */ // Label 36: @141341
     /* 141341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(23), /*)*//*default:*//*Label 3030*/ GIMT_Encode4(142205),
     /* 141352 */ /*GILLT_v8s16*//*Label 3027*/ GIMT_Encode4(141392), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141372 */ /*GILLT_v16s16*//*Label 3028*/ GIMT_Encode4(141734), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 141388 */ /*GILLT_v32s16*//*Label 3029*/ GIMT_Encode4(142049),
     /* 141392 */ // Label 3027: @141392
     /* 141392 */ GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(141733),
     /* 141397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 141400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 141403 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(141465), // Rule ID 23459 //
     /* 141408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141423 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141447 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141463 */     GIR_RootConstrainSelectedInstOperands,
     /* 141464 */     // GIR_Coverage, 23459,
     /* 141464 */     GIR_EraseRootFromParent_Done,
     /* 141465 */   // Label 3032: @141465
     /* 141465 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(141527), // Rule ID 23837 //
     /* 141470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141509 */     // (mulhs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141514 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141525 */     GIR_RootConstrainSelectedInstOperands,
     /* 141526 */     // GIR_Coverage, 23837,
     /* 141526 */     GIR_EraseRootFromParent_Done,
     /* 141527 */   // Label 3033: @141527
     /* 141527 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(141589), // Rule ID 2583 //
     /* 141532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141551 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141554 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141558 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141564 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141571 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWrm),
     /* 141574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141578 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141587 */     GIR_RootConstrainSelectedInstOperands,
     /* 141588 */     // GIR_Coverage, 2583,
     /* 141588 */     GIR_EraseRootFromParent_Done,
     /* 141589 */   // Label 3034: @141589
     /* 141589 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(141651), // Rule ID 5044 //
     /* 141594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141613 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141616 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141620 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141626 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141633 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rm),
     /* 141636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141649 */     GIR_RootConstrainSelectedInstOperands,
     /* 141650 */     // GIR_Coverage, 5044,
     /* 141650 */     GIR_EraseRootFromParent_Done,
     /* 141651 */   // Label 3035: @141651
     /* 141651 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(141678), // Rule ID 2582 //
     /* 141656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 141659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141671 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWrr),
     /* 141676 */     GIR_RootConstrainSelectedInstOperands,
     /* 141677 */     // GIR_Coverage, 2582,
     /* 141677 */     GIR_Done,
     /* 141678 */   // Label 3036: @141678
     /* 141678 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(141705), // Rule ID 2584 //
     /* 141683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 141686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 141698 */     // (mulhs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMULHWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 141698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMULHWrr),
     /* 141703 */     GIR_RootConstrainSelectedInstOperands,
     /* 141704 */     // GIR_Coverage, 2584,
     /* 141704 */     GIR_Done,
     /* 141705 */   // Label 3037: @141705
     /* 141705 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(141732), // Rule ID 5041 //
     /* 141710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 141725 */     // (mulhs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMULHWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 141725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ128rr),
     /* 141730 */     GIR_RootConstrainSelectedInstOperands,
     /* 141731 */     // GIR_Coverage, 5041,
     /* 141731 */     GIR_Done,
     /* 141732 */   // Label 3038: @141732
     /* 141732 */   GIM_Reject,
     /* 141733 */ // Label 3031: @141733
     /* 141733 */ GIM_Reject,
     /* 141734 */ // Label 3028: @141734
     /* 141734 */ GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(142048),
     /* 141739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 141742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 141745 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(141807), // Rule ID 23461 //
     /* 141750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141765 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141768 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141772 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141789 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141794 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141796 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141805 */     GIR_RootConstrainSelectedInstOperands,
     /* 141806 */     // GIR_Coverage, 23461,
     /* 141806 */     GIR_EraseRootFromParent_Done,
     /* 141807 */   // Label 3040: @141807
     /* 141807 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(141869), // Rule ID 23834 //
     /* 141812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141827 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141830 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141834 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141851 */     // (mulhs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141856 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 141858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141867 */     GIR_RootConstrainSelectedInstOperands,
     /* 141868 */     // GIR_Coverage, 23834,
     /* 141868 */     GIR_EraseRootFromParent_Done,
     /* 141869 */   // Label 3041: @141869
     /* 141869 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(141931), // Rule ID 2587 //
     /* 141874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 141877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 141885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141893 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141896 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141900 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141906 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141913 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrm),
     /* 141916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141920 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141929 */     GIR_RootConstrainSelectedInstOperands,
     /* 141930 */     // GIR_Coverage, 2587,
     /* 141930 */     GIR_EraseRootFromParent_Done,
     /* 141931 */   // Label 3042: @141931
     /* 141931 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(141993), // Rule ID 5038 //
     /* 141936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 141939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 141947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 141951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 141955 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141958 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 141962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 141966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141968 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 141975 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 141975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rm),
     /* 141978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 141982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 141986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141991 */     GIR_RootConstrainSelectedInstOperands,
     /* 141992 */     // GIR_Coverage, 5038,
     /* 141992 */     GIR_EraseRootFromParent_Done,
     /* 141993 */   // Label 3043: @141993
     /* 141993 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(142020), // Rule ID 2586 //
     /* 141998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142013 */     // (mulhs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMULHWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 142013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWYrr),
     /* 142018 */     GIR_RootConstrainSelectedInstOperands,
     /* 142019 */     // GIR_Coverage, 2586,
     /* 142019 */     GIR_Done,
     /* 142020 */   // Label 3044: @142020
     /* 142020 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(142047), // Rule ID 5035 //
     /* 142025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 142040 */     // (mulhs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMULHWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 142040 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZ256rr),
     /* 142045 */     GIR_RootConstrainSelectedInstOperands,
     /* 142046 */     // GIR_Coverage, 5035,
     /* 142046 */     GIR_Done,
     /* 142047 */   // Label 3045: @142047
     /* 142047 */   GIM_Reject,
     /* 142048 */ // Label 3039: @142048
     /* 142048 */ GIM_Reject,
     /* 142049 */ // Label 3029: @142049
     /* 142049 */ GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(142204),
     /* 142054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 142057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 142060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142064 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(142122), // Rule ID 23831 //
     /* 142069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142097 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142104 */     // (mulhs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142109 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142120 */     GIR_RootConstrainSelectedInstOperands,
     /* 142121 */     // GIR_Coverage, 23831,
     /* 142121 */     GIR_EraseRootFromParent_Done,
     /* 142122 */   // Label 3047: @142122
     /* 142122 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(142180), // Rule ID 5032 //
     /* 142127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142162 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMULHWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrm),
     /* 142165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142167 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142178 */     GIR_RootConstrainSelectedInstOperands,
     /* 142179 */     // GIR_Coverage, 5032,
     /* 142179 */     GIR_EraseRootFromParent_Done,
     /* 142180 */   // Label 3048: @142180
     /* 142180 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(142203), // Rule ID 5029 //
     /* 142185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 142188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 142196 */     // (mulhs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMULHWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 142196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMULHWZrr),
     /* 142201 */     GIR_RootConstrainSelectedInstOperands,
     /* 142202 */     // GIR_Coverage, 5029,
     /* 142202 */     GIR_Done,
     /* 142203 */   // Label 3049: @142203
     /* 142203 */   GIM_Reject,
     /* 142204 */ // Label 3046: @142204
     /* 142204 */ GIM_Reject,
     /* 142205 */ // Label 3030: @142205
     /* 142205 */ GIM_Reject,
     /* 142206 */ // Label 37: @142206
     /* 142206 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3056*/ GIMT_Encode4(143891),
     /* 142217 */ /*GILLT_v8s16*//*Label 3050*/ GIMT_Encode4(142265), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142233 */ /*GILLT_v16s8*//*Label 3051*/ GIMT_Encode4(142607),
     /* 142237 */ /*GILLT_v16s16*//*Label 3052*/ GIMT_Encode4(142949), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 142249 */ /*GILLT_v32s8*//*Label 3053*/ GIMT_Encode4(143264),
     /* 142253 */ /*GILLT_v32s16*//*Label 3054*/ GIMT_Encode4(143579), GIMT_Encode4(0),
     /* 142261 */ /*GILLT_v64s8*//*Label 3055*/ GIMT_Encode4(143735),
     /* 142265 */ // Label 3050: @142265
     /* 142265 */ GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(142606),
     /* 142270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 142273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142276 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(142338), // Rule ID 23450 //
     /* 142281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142320 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142336 */     GIR_RootConstrainSelectedInstOperands,
     /* 142337 */     // GIR_Coverage, 23450,
     /* 142337 */     GIR_EraseRootFromParent_Done,
     /* 142338 */   // Label 3058: @142338
     /* 142338 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(142400), // Rule ID 23774 //
     /* 142343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142382 */     // (uaddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142389 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142398 */     GIR_RootConstrainSelectedInstOperands,
     /* 142399 */     // GIR_Coverage, 23774,
     /* 142399 */     GIR_EraseRootFromParent_Done,
     /* 142400 */   // Label 3059: @142400
     /* 142400 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(142462), // Rule ID 2565 //
     /* 142405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142444 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrm),
     /* 142447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142449 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142451 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142460 */     GIR_RootConstrainSelectedInstOperands,
     /* 142461 */     // GIR_Coverage, 2565,
     /* 142461 */     GIR_EraseRootFromParent_Done,
     /* 142462 */   // Label 3060: @142462
     /* 142462 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(142524), // Rule ID 4900 //
     /* 142467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142486 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142489 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142493 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142499 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142506 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rm),
     /* 142509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142522 */     GIR_RootConstrainSelectedInstOperands,
     /* 142523 */     // GIR_Coverage, 4900,
     /* 142523 */     GIR_EraseRootFromParent_Done,
     /* 142524 */   // Label 3061: @142524
     /* 142524 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(142551), // Rule ID 2564 //
     /* 142529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142544 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWrr),
     /* 142549 */     GIR_RootConstrainSelectedInstOperands,
     /* 142550 */     // GIR_Coverage, 2564,
     /* 142550 */     GIR_Done,
     /* 142551 */   // Label 3062: @142551
     /* 142551 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(142578), // Rule ID 2566 //
     /* 142556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142571 */     // (uaddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 142571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSWrr),
     /* 142576 */     GIR_RootConstrainSelectedInstOperands,
     /* 142577 */     // GIR_Coverage, 2566,
     /* 142577 */     GIR_Done,
     /* 142578 */   // Label 3063: @142578
     /* 142578 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(142605), // Rule ID 4897 //
     /* 142583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142598 */     // (uaddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 142598 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ128rr),
     /* 142603 */     GIR_RootConstrainSelectedInstOperands,
     /* 142604 */     // GIR_Coverage, 4897,
     /* 142604 */     GIR_Done,
     /* 142605 */   // Label 3064: @142605
     /* 142605 */   GIM_Reject,
     /* 142606 */ // Label 3057: @142606
     /* 142606 */ GIM_Reject,
     /* 142607 */ // Label 3051: @142607
     /* 142607 */ GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(142948),
     /* 142612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 142615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142618 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(142680), // Rule ID 23447 //
     /* 142623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142662 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142667 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142669 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142678 */     GIR_RootConstrainSelectedInstOperands,
     /* 142679 */     // GIR_Coverage, 23447,
     /* 142679 */     GIR_EraseRootFromParent_Done,
     /* 142680 */   // Label 3066: @142680
     /* 142680 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(142742), // Rule ID 23783 //
     /* 142685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142700 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142703 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142707 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142717 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142724 */     // (uaddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142729 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 142731 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142740 */     GIR_RootConstrainSelectedInstOperands,
     /* 142741 */     // GIR_Coverage, 23783,
     /* 142741 */     GIR_EraseRootFromParent_Done,
     /* 142742 */   // Label 3067: @142742
     /* 142742 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(142804), // Rule ID 2559 //
     /* 142747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142779 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142786 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrm),
     /* 142789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142791 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142802 */     GIR_RootConstrainSelectedInstOperands,
     /* 142803 */     // GIR_Coverage, 2559,
     /* 142803 */     GIR_EraseRootFromParent_Done,
     /* 142804 */   // Label 3068: @142804
     /* 142804 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(142866), // Rule ID 4918 //
     /* 142809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 142824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 142848 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 142848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rm),
     /* 142851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 142855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 142859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 142864 */     GIR_RootConstrainSelectedInstOperands,
     /* 142865 */     // GIR_Coverage, 4918,
     /* 142865 */     GIR_EraseRootFromParent_Done,
     /* 142866 */   // Label 3069: @142866
     /* 142866 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(142893), // Rule ID 2558 //
     /* 142871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 142874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142886 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBrr),
     /* 142891 */     GIR_RootConstrainSelectedInstOperands,
     /* 142892 */     // GIR_Coverage, 2558,
     /* 142892 */     GIR_Done,
     /* 142893 */   // Label 3070: @142893
     /* 142893 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(142920), // Rule ID 2560 //
     /* 142898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 142901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 142913 */     // (uaddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 142913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDUSBrr),
     /* 142918 */     GIR_RootConstrainSelectedInstOperands,
     /* 142919 */     // GIR_Coverage, 2560,
     /* 142919 */     GIR_Done,
     /* 142920 */   // Label 3071: @142920
     /* 142920 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(142947), // Rule ID 4915 //
     /* 142925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 142928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 142940 */     // (uaddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 142940 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ128rr),
     /* 142945 */     GIR_RootConstrainSelectedInstOperands,
     /* 142946 */     // GIR_Coverage, 4915,
     /* 142946 */     GIR_Done,
     /* 142947 */   // Label 3072: @142947
     /* 142947 */   GIM_Reject,
     /* 142948 */ // Label 3065: @142948
     /* 142948 */ GIM_Reject,
     /* 142949 */ // Label 3052: @142949
     /* 142949 */ GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(143263),
     /* 142954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 142957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 142960 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(143022), // Rule ID 23452 //
     /* 142965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 142968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 142980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 142987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 142991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 142995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143004 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 143007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143011 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143020 */     GIR_RootConstrainSelectedInstOperands,
     /* 143021 */     // GIR_Coverage, 23452,
     /* 143021 */     GIR_EraseRootFromParent_Done,
     /* 143022 */   // Label 3074: @143022
     /* 143022 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(143084), // Rule ID 23771 //
     /* 143027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143059 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143066 */     // (uaddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143071 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143082 */     GIR_RootConstrainSelectedInstOperands,
     /* 143083 */     // GIR_Coverage, 23771,
     /* 143083 */     GIR_EraseRootFromParent_Done,
     /* 143084 */   // Label 3075: @143084
     /* 143084 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(143146), // Rule ID 2569 //
     /* 143089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143128 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrm),
     /* 143131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143144 */     GIR_RootConstrainSelectedInstOperands,
     /* 143145 */     // GIR_Coverage, 2569,
     /* 143145 */     GIR_EraseRootFromParent_Done,
     /* 143146 */   // Label 3076: @143146
     /* 143146 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(143208), // Rule ID 4894 //
     /* 143151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143190 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rm),
     /* 143193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143206 */     GIR_RootConstrainSelectedInstOperands,
     /* 143207 */     // GIR_Coverage, 4894,
     /* 143207 */     GIR_EraseRootFromParent_Done,
     /* 143208 */   // Label 3077: @143208
     /* 143208 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(143235), // Rule ID 2568 //
     /* 143213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143228 */     // (uaddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 143228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWYrr),
     /* 143233 */     GIR_RootConstrainSelectedInstOperands,
     /* 143234 */     // GIR_Coverage, 2568,
     /* 143234 */     GIR_Done,
     /* 143235 */   // Label 3078: @143235
     /* 143235 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(143262), // Rule ID 4891 //
     /* 143240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143255 */     // (uaddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 143255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZ256rr),
     /* 143260 */     GIR_RootConstrainSelectedInstOperands,
     /* 143261 */     // GIR_Coverage, 4891,
     /* 143261 */     GIR_Done,
     /* 143262 */   // Label 3079: @143262
     /* 143262 */   GIM_Reject,
     /* 143263 */ // Label 3073: @143263
     /* 143263 */ GIM_Reject,
     /* 143264 */ // Label 3053: @143264
     /* 143264 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(143578),
     /* 143269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 143272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 143275 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(143337), // Rule ID 23449 //
     /* 143280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143295 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143298 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143319 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143324 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143335 */     GIR_RootConstrainSelectedInstOperands,
     /* 143336 */     // GIR_Coverage, 23449,
     /* 143336 */     GIR_EraseRootFromParent_Done,
     /* 143337 */   // Label 3081: @143337
     /* 143337 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(143399), // Rule ID 23780 //
     /* 143342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143357 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143360 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143364 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143381 */     // (uaddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143386 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143397 */     GIR_RootConstrainSelectedInstOperands,
     /* 143398 */     // GIR_Coverage, 23780,
     /* 143398 */     GIR_EraseRootFromParent_Done,
     /* 143399 */   // Label 3082: @143399
     /* 143399 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(143461), // Rule ID 2563 //
     /* 143404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143423 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143443 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrm),
     /* 143446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143459 */     GIR_RootConstrainSelectedInstOperands,
     /* 143460 */     // GIR_Coverage, 2563,
     /* 143460 */     GIR_EraseRootFromParent_Done,
     /* 143461 */   // Label 3083: @143461
     /* 143461 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(143523), // Rule ID 4912 //
     /* 143466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143485 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143488 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143492 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143498 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143505 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rm),
     /* 143508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143510 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143512 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143516 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143521 */     GIR_RootConstrainSelectedInstOperands,
     /* 143522 */     // GIR_Coverage, 4912,
     /* 143522 */     GIR_EraseRootFromParent_Done,
     /* 143523 */   // Label 3084: @143523
     /* 143523 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(143550), // Rule ID 2562 //
     /* 143528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 143531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 143543 */     // (uaddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 143543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBYrr),
     /* 143548 */     GIR_RootConstrainSelectedInstOperands,
     /* 143549 */     // GIR_Coverage, 2562,
     /* 143549 */     GIR_Done,
     /* 143550 */   // Label 3085: @143550
     /* 143550 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(143577), // Rule ID 4909 //
     /* 143555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 143558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 143570 */     // (uaddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 143570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZ256rr),
     /* 143575 */     GIR_RootConstrainSelectedInstOperands,
     /* 143576 */     // GIR_Coverage, 4909,
     /* 143576 */     GIR_Done,
     /* 143577 */   // Label 3086: @143577
     /* 143577 */   GIM_Reject,
     /* 143578 */ // Label 3080: @143578
     /* 143578 */ GIM_Reject,
     /* 143579 */ // Label 3054: @143579
     /* 143579 */ GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(143734),
     /* 143584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 143587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 143590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143594 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(143652), // Rule ID 23768 //
     /* 143599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143634 */     // (uaddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143650 */     GIR_RootConstrainSelectedInstOperands,
     /* 143651 */     // GIR_Coverage, 23768,
     /* 143651 */     GIR_EraseRootFromParent_Done,
     /* 143652 */   // Label 3088: @143652
     /* 143652 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(143710), // Rule ID 4888 //
     /* 143657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143692 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrm),
     /* 143695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143708 */     GIR_RootConstrainSelectedInstOperands,
     /* 143709 */     // GIR_Coverage, 4888,
     /* 143709 */     GIR_EraseRootFromParent_Done,
     /* 143710 */   // Label 3089: @143710
     /* 143710 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(143733), // Rule ID 4885 //
     /* 143715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143726 */     // (uaddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 143726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSWZrr),
     /* 143731 */     GIR_RootConstrainSelectedInstOperands,
     /* 143732 */     // GIR_Coverage, 4885,
     /* 143732 */     GIR_Done,
     /* 143733 */   // Label 3090: @143733
     /* 143733 */   GIM_Reject,
     /* 143734 */ // Label 3087: @143734
     /* 143734 */ GIM_Reject,
     /* 143735 */ // Label 3055: @143735
     /* 143735 */ GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(143890),
     /* 143740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 143743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 143746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143750 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(143808), // Rule ID 23777 //
     /* 143755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143790 */     // (uaddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 143797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143806 */     GIR_RootConstrainSelectedInstOperands,
     /* 143807 */     // GIR_Coverage, 23777,
     /* 143807 */     GIR_EraseRootFromParent_Done,
     /* 143808 */   // Label 3092: @143808
     /* 143808 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(143866), // Rule ID 4906 //
     /* 143813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 143824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143841 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 143848 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrm),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143853 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 143855 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 143859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 143864 */     GIR_RootConstrainSelectedInstOperands,
     /* 143865 */     // GIR_Coverage, 4906,
     /* 143865 */     GIR_EraseRootFromParent_Done,
     /* 143866 */   // Label 3093: @143866
     /* 143866 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(143889), // Rule ID 4903 //
     /* 143871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 143874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 143882 */     // (uaddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 143882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDUSBZrr),
     /* 143887 */     GIR_RootConstrainSelectedInstOperands,
     /* 143888 */     // GIR_Coverage, 4903,
     /* 143888 */     GIR_Done,
     /* 143889 */   // Label 3094: @143889
     /* 143889 */   GIM_Reject,
     /* 143890 */ // Label 3091: @143890
     /* 143890 */ GIM_Reject,
     /* 143891 */ // Label 3056: @143891
     /* 143891 */ GIM_Reject,
     /* 143892 */ // Label 38: @143892
     /* 143892 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3101*/ GIMT_Encode4(145577),
     /* 143903 */ /*GILLT_v8s16*//*Label 3095*/ GIMT_Encode4(143951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143919 */ /*GILLT_v16s8*//*Label 3096*/ GIMT_Encode4(144293),
     /* 143923 */ /*GILLT_v16s16*//*Label 3097*/ GIMT_Encode4(144635), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 143935 */ /*GILLT_v32s8*//*Label 3098*/ GIMT_Encode4(144950),
     /* 143939 */ /*GILLT_v32s16*//*Label 3099*/ GIMT_Encode4(145265), GIMT_Encode4(0),
     /* 143947 */ /*GILLT_v64s8*//*Label 3100*/ GIMT_Encode4(145421),
     /* 143951 */ // Label 3095: @143951
     /* 143951 */ GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(144292),
     /* 143956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 143959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143962 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(144024), // Rule ID 23444 //
     /* 143967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 143970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 143982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 143989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 143993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 143997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143999 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144006 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 144009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144011 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144022 */     GIR_RootConstrainSelectedInstOperands,
     /* 144023 */     // GIR_Coverage, 23444,
     /* 144023 */     GIR_EraseRootFromParent_Done,
     /* 144024 */   // Label 3103: @144024
     /* 144024 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(144086), // Rule ID 23756 //
     /* 144029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144061 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144068 */     // (saddsat:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144073 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144075 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144079 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144084 */     GIR_RootConstrainSelectedInstOperands,
     /* 144085 */     // GIR_Coverage, 23756,
     /* 144085 */     GIR_EraseRootFromParent_Done,
     /* 144086 */   // Label 3104: @144086
     /* 144086 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(144148), // Rule ID 2553 //
     /* 144091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144123 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144130 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWrm),
     /* 144133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144135 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144137 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144146 */     GIR_RootConstrainSelectedInstOperands,
     /* 144147 */     // GIR_Coverage, 2553,
     /* 144147 */     GIR_EraseRootFromParent_Done,
     /* 144148 */   // Label 3105: @144148
     /* 144148 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(144210), // Rule ID 4828 //
     /* 144153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144192 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rm),
     /* 144195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144208 */     GIR_RootConstrainSelectedInstOperands,
     /* 144209 */     // GIR_Coverage, 4828,
     /* 144209 */     GIR_EraseRootFromParent_Done,
     /* 144210 */   // Label 3106: @144210
     /* 144210 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(144237), // Rule ID 2552 //
     /* 144215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144230 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWrr),
     /* 144235 */     GIR_RootConstrainSelectedInstOperands,
     /* 144236 */     // GIR_Coverage, 2552,
     /* 144236 */     GIR_Done,
     /* 144237 */   // Label 3107: @144237
     /* 144237 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(144264), // Rule ID 2554 //
     /* 144242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144257 */     // (saddsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PADDSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 144257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSWrr),
     /* 144262 */     GIR_RootConstrainSelectedInstOperands,
     /* 144263 */     // GIR_Coverage, 2554,
     /* 144263 */     GIR_Done,
     /* 144264 */   // Label 3108: @144264
     /* 144264 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(144291), // Rule ID 4825 //
     /* 144269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144284 */     // (saddsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPADDSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 144284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ128rr),
     /* 144289 */     GIR_RootConstrainSelectedInstOperands,
     /* 144290 */     // GIR_Coverage, 4825,
     /* 144290 */     GIR_Done,
     /* 144291 */   // Label 3109: @144291
     /* 144291 */   GIM_Reject,
     /* 144292 */ // Label 3102: @144292
     /* 144292 */ GIM_Reject,
     /* 144293 */ // Label 3096: @144293
     /* 144293 */ GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(144634),
     /* 144298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 144301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 144304 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(144366), // Rule ID 23441 //
     /* 144309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144324 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144327 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144348 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144353 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144355 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144364 */     GIR_RootConstrainSelectedInstOperands,
     /* 144365 */     // GIR_Coverage, 23441,
     /* 144365 */     GIR_EraseRootFromParent_Done,
     /* 144366 */   // Label 3111: @144366
     /* 144366 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(144428), // Rule ID 23765 //
     /* 144371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144410 */     // (saddsat:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144415 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144426 */     GIR_RootConstrainSelectedInstOperands,
     /* 144427 */     // GIR_Coverage, 23765,
     /* 144427 */     GIR_EraseRootFromParent_Done,
     /* 144428 */   // Label 3112: @144428
     /* 144428 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(144490), // Rule ID 2547 //
     /* 144433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144472 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBrm),
     /* 144475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144488 */     GIR_RootConstrainSelectedInstOperands,
     /* 144489 */     // GIR_Coverage, 2547,
     /* 144489 */     GIR_EraseRootFromParent_Done,
     /* 144490 */   // Label 3113: @144490
     /* 144490 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(144552), // Rule ID 4846 //
     /* 144495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144534 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rm),
     /* 144537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144550 */     GIR_RootConstrainSelectedInstOperands,
     /* 144551 */     // GIR_Coverage, 4846,
     /* 144551 */     GIR_EraseRootFromParent_Done,
     /* 144552 */   // Label 3114: @144552
     /* 144552 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(144579), // Rule ID 2546 //
     /* 144557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 144560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144572 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBrr),
     /* 144577 */     GIR_RootConstrainSelectedInstOperands,
     /* 144578 */     // GIR_Coverage, 2546,
     /* 144578 */     GIR_Done,
     /* 144579 */   // Label 3115: @144579
     /* 144579 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(144606), // Rule ID 2548 //
     /* 144584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 144587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 144599 */     // (saddsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PADDSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 144599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PADDSBrr),
     /* 144604 */     GIR_RootConstrainSelectedInstOperands,
     /* 144605 */     // GIR_Coverage, 2548,
     /* 144605 */     GIR_Done,
     /* 144606 */   // Label 3116: @144606
     /* 144606 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(144633), // Rule ID 4843 //
     /* 144611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 144626 */     // (saddsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPADDSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 144626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ128rr),
     /* 144631 */     GIR_RootConstrainSelectedInstOperands,
     /* 144632 */     // GIR_Coverage, 4843,
     /* 144632 */     GIR_Done,
     /* 144633 */   // Label 3117: @144633
     /* 144633 */   GIM_Reject,
     /* 144634 */ // Label 3110: @144634
     /* 144634 */ GIM_Reject,
     /* 144635 */ // Label 3097: @144635
     /* 144635 */ GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(144949),
     /* 144640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 144643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 144646 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(144708), // Rule ID 23446 //
     /* 144651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144666 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144669 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144673 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144683 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144690 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144695 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144697 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144706 */     GIR_RootConstrainSelectedInstOperands,
     /* 144707 */     // GIR_Coverage, 23446,
     /* 144707 */     GIR_EraseRootFromParent_Done,
     /* 144708 */   // Label 3119: @144708
     /* 144708 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(144770), // Rule ID 23753 //
     /* 144713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144745 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144752 */     // (saddsat:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 144759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144768 */     GIR_RootConstrainSelectedInstOperands,
     /* 144769 */     // GIR_Coverage, 23753,
     /* 144769 */     GIR_EraseRootFromParent_Done,
     /* 144770 */   // Label 3120: @144770
     /* 144770 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(144832), // Rule ID 2557 //
     /* 144775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144814 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrm),
     /* 144817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144830 */     GIR_RootConstrainSelectedInstOperands,
     /* 144831 */     // GIR_Coverage, 2557,
     /* 144831 */     GIR_EraseRootFromParent_Done,
     /* 144832 */   // Label 3121: @144832
     /* 144832 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(144894), // Rule ID 4822 //
     /* 144837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 144852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144869 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 144876 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 144876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rm),
     /* 144879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144881 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 144883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 144887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 144892 */     GIR_RootConstrainSelectedInstOperands,
     /* 144893 */     // GIR_Coverage, 4822,
     /* 144893 */     GIR_EraseRootFromParent_Done,
     /* 144894 */   // Label 3122: @144894
     /* 144894 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(144921), // Rule ID 2556 //
     /* 144899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144914 */     // (saddsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPADDSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 144914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWYrr),
     /* 144919 */     GIR_RootConstrainSelectedInstOperands,
     /* 144920 */     // GIR_Coverage, 2556,
     /* 144920 */     GIR_Done,
     /* 144921 */   // Label 3123: @144921
     /* 144921 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(144948), // Rule ID 4819 //
     /* 144926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 144929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 144941 */     // (saddsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPADDSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 144941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZ256rr),
     /* 144946 */     GIR_RootConstrainSelectedInstOperands,
     /* 144947 */     // GIR_Coverage, 4819,
     /* 144947 */     GIR_Done,
     /* 144948 */   // Label 3124: @144948
     /* 144948 */   GIM_Reject,
     /* 144949 */ // Label 3118: @144949
     /* 144949 */ GIM_Reject,
     /* 144950 */ // Label 3098: @144950
     /* 144950 */ GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(145264),
     /* 144955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 144958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 144961 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(145023), // Rule ID 23443 //
     /* 144966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 144969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 144981 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 144988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 144992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 144996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145005 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 145008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145021 */     GIR_RootConstrainSelectedInstOperands,
     /* 145022 */     // GIR_Coverage, 23443,
     /* 145022 */     GIR_EraseRootFromParent_Done,
     /* 145023 */   // Label 3126: @145023
     /* 145023 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(145085), // Rule ID 23762 //
     /* 145028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145043 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145046 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145060 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145067 */     // (saddsat:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145072 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145074 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145083 */     GIR_RootConstrainSelectedInstOperands,
     /* 145084 */     // GIR_Coverage, 23762,
     /* 145084 */     GIR_EraseRootFromParent_Done,
     /* 145085 */   // Label 3127: @145085
     /* 145085 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(145147), // Rule ID 2551 //
     /* 145090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145129 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrm),
     /* 145132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145134 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145136 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145145 */     GIR_RootConstrainSelectedInstOperands,
     /* 145146 */     // GIR_Coverage, 2551,
     /* 145146 */     GIR_EraseRootFromParent_Done,
     /* 145147 */   // Label 3128: @145147
     /* 145147 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(145209), // Rule ID 4840 //
     /* 145152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145191 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rm),
     /* 145194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145196 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145198 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145207 */     GIR_RootConstrainSelectedInstOperands,
     /* 145208 */     // GIR_Coverage, 4840,
     /* 145208 */     GIR_EraseRootFromParent_Done,
     /* 145209 */   // Label 3129: @145209
     /* 145209 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(145236), // Rule ID 2550 //
     /* 145214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 145217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 145229 */     // (saddsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPADDSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 145229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBYrr),
     /* 145234 */     GIR_RootConstrainSelectedInstOperands,
     /* 145235 */     // GIR_Coverage, 2550,
     /* 145235 */     GIR_Done,
     /* 145236 */   // Label 3130: @145236
     /* 145236 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(145263), // Rule ID 4837 //
     /* 145241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 145256 */     // (saddsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPADDSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 145256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZ256rr),
     /* 145261 */     GIR_RootConstrainSelectedInstOperands,
     /* 145262 */     // GIR_Coverage, 4837,
     /* 145262 */     GIR_Done,
     /* 145263 */   // Label 3131: @145263
     /* 145263 */   GIM_Reject,
     /* 145264 */ // Label 3125: @145264
     /* 145264 */ GIM_Reject,
     /* 145265 */ // Label 3099: @145265
     /* 145265 */ GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(145420),
     /* 145270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 145273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 145276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145280 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(145338), // Rule ID 23750 //
     /* 145285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145320 */     // (saddsat:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145325 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145327 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145336 */     GIR_RootConstrainSelectedInstOperands,
     /* 145337 */     // GIR_Coverage, 23750,
     /* 145337 */     GIR_EraseRootFromParent_Done,
     /* 145338 */   // Label 3133: @145338
     /* 145338 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(145396), // Rule ID 4816 //
     /* 145343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145378 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrm),
     /* 145381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145394 */     GIR_RootConstrainSelectedInstOperands,
     /* 145395 */     // GIR_Coverage, 4816,
     /* 145395 */     GIR_EraseRootFromParent_Done,
     /* 145396 */   // Label 3134: @145396
     /* 145396 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(145419), // Rule ID 4813 //
     /* 145401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145412 */     // (saddsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPADDSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 145412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSWZrr),
     /* 145417 */     GIR_RootConstrainSelectedInstOperands,
     /* 145418 */     // GIR_Coverage, 4813,
     /* 145418 */     GIR_Done,
     /* 145419 */   // Label 3135: @145419
     /* 145419 */   GIM_Reject,
     /* 145420 */ // Label 3132: @145420
     /* 145420 */ GIM_Reject,
     /* 145421 */ // Label 3100: @145421
     /* 145421 */ GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(145576),
     /* 145426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 145429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 145432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145436 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(145494), // Rule ID 23759 //
     /* 145441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145452 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145455 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145469 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145476 */     // (saddsat:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145481 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 145483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145492 */     GIR_RootConstrainSelectedInstOperands,
     /* 145493 */     // GIR_Coverage, 23759,
     /* 145493 */     GIR_EraseRootFromParent_Done,
     /* 145494 */   // Label 3137: @145494
     /* 145494 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(145552), // Rule ID 4834 //
     /* 145499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145534 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPADDSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrm),
     /* 145537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145550 */     GIR_RootConstrainSelectedInstOperands,
     /* 145551 */     // GIR_Coverage, 4834,
     /* 145551 */     GIR_EraseRootFromParent_Done,
     /* 145552 */   // Label 3138: @145552
     /* 145552 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(145575), // Rule ID 4831 //
     /* 145557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 145560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 145568 */     // (saddsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPADDSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 145568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPADDSBZrr),
     /* 145573 */     GIR_RootConstrainSelectedInstOperands,
     /* 145574 */     // GIR_Coverage, 4831,
     /* 145574 */     GIR_Done,
     /* 145575 */   // Label 3139: @145575
     /* 145575 */   GIM_Reject,
     /* 145576 */ // Label 3136: @145576
     /* 145576 */ GIM_Reject,
     /* 145577 */ // Label 3101: @145577
     /* 145577 */ GIM_Reject,
     /* 145578 */ // Label 39: @145578
     /* 145578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3146*/ GIMT_Encode4(146643),
     /* 145589 */ /*GILLT_v8s16*//*Label 3140*/ GIMT_Encode4(145637), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145605 */ /*GILLT_v16s8*//*Label 3141*/ GIMT_Encode4(145855),
     /* 145609 */ /*GILLT_v16s16*//*Label 3142*/ GIMT_Encode4(146073), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 145621 */ /*GILLT_v32s8*//*Label 3143*/ GIMT_Encode4(146264),
     /* 145625 */ /*GILLT_v32s16*//*Label 3144*/ GIMT_Encode4(146455), GIMT_Encode4(0),
     /* 145633 */ /*GILLT_v64s8*//*Label 3145*/ GIMT_Encode4(146549),
     /* 145637 */ // Label 3140: @145637
     /* 145637 */ GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(145854),
     /* 145642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 145645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145648 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(145710), // Rule ID 2631 //
     /* 145653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145672 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145679 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145692 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrm),
     /* 145695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145697 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145699 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145708 */     GIR_RootConstrainSelectedInstOperands,
     /* 145709 */     // GIR_Coverage, 2631,
     /* 145709 */     GIR_EraseRootFromParent_Done,
     /* 145710 */   // Label 3148: @145710
     /* 145710 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(145772), // Rule ID 4936 //
     /* 145715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145734 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145737 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145741 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145747 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145754 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rm),
     /* 145757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145759 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145770 */     GIR_RootConstrainSelectedInstOperands,
     /* 145771 */     // GIR_Coverage, 4936,
     /* 145771 */     GIR_EraseRootFromParent_Done,
     /* 145772 */   // Label 3149: @145772
     /* 145772 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(145799), // Rule ID 2630 //
     /* 145777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145792 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWrr),
     /* 145797 */     GIR_RootConstrainSelectedInstOperands,
     /* 145798 */     // GIR_Coverage, 2630,
     /* 145798 */     GIR_Done,
     /* 145799 */   // Label 3150: @145799
     /* 145799 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(145826), // Rule ID 2632 //
     /* 145804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 145807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145819 */     // (usubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBUSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 145819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSWrr),
     /* 145824 */     GIR_RootConstrainSelectedInstOperands,
     /* 145825 */     // GIR_Coverage, 2632,
     /* 145825 */     GIR_Done,
     /* 145826 */   // Label 3151: @145826
     /* 145826 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(145853), // Rule ID 4933 //
     /* 145831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145846 */     // (usubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBUSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 145846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ128rr),
     /* 145851 */     GIR_RootConstrainSelectedInstOperands,
     /* 145852 */     // GIR_Coverage, 4933,
     /* 145852 */     GIR_Done,
     /* 145853 */   // Label 3152: @145853
     /* 145853 */   GIM_Reject,
     /* 145854 */ // Label 3147: @145854
     /* 145854 */ GIM_Reject,
     /* 145855 */ // Label 3141: @145855
     /* 145855 */ GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(146072),
     /* 145860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 145863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145866 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(145928), // Rule ID 2625 //
     /* 145871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 145882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145890 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145893 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145897 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145903 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145910 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrm),
     /* 145913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145915 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145917 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145926 */     GIR_RootConstrainSelectedInstOperands,
     /* 145927 */     // GIR_Coverage, 2625,
     /* 145927 */     GIR_EraseRootFromParent_Done,
     /* 145928 */   // Label 3154: @145928
     /* 145928 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(145990), // Rule ID 4954 //
     /* 145933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 145936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 145944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 145948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 145952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 145955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 145959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 145963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 145972 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 145972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rm),
     /* 145975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 145979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 145983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 145988 */     GIR_RootConstrainSelectedInstOperands,
     /* 145989 */     // GIR_Coverage, 4954,
     /* 145989 */     GIR_EraseRootFromParent_Done,
     /* 145990 */   // Label 3155: @145990
     /* 145990 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(146017), // Rule ID 2624 //
     /* 145995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 145998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146010 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146010 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBrr),
     /* 146015 */     GIR_RootConstrainSelectedInstOperands,
     /* 146016 */     // GIR_Coverage, 2624,
     /* 146016 */     GIR_Done,
     /* 146017 */   // Label 3156: @146017
     /* 146017 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(146044), // Rule ID 2626 //
     /* 146022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146037 */     // (usubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBUSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 146037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBUSBrr),
     /* 146042 */     GIR_RootConstrainSelectedInstOperands,
     /* 146043 */     // GIR_Coverage, 2626,
     /* 146043 */     GIR_Done,
     /* 146044 */   // Label 3157: @146044
     /* 146044 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(146071), // Rule ID 4951 //
     /* 146049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146064 */     // (usubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBUSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 146064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ128rr),
     /* 146069 */     GIR_RootConstrainSelectedInstOperands,
     /* 146070 */     // GIR_Coverage, 4951,
     /* 146070 */     GIR_Done,
     /* 146071 */   // Label 3158: @146071
     /* 146071 */   GIM_Reject,
     /* 146072 */ // Label 3153: @146072
     /* 146072 */ GIM_Reject,
     /* 146073 */ // Label 3142: @146073
     /* 146073 */ GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(146263),
     /* 146078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 146081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 146084 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(146146), // Rule ID 2635 //
     /* 146089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146108 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146111 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146115 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146121 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146128 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrm),
     /* 146131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146133 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146135 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146144 */     GIR_RootConstrainSelectedInstOperands,
     /* 146145 */     // GIR_Coverage, 2635,
     /* 146145 */     GIR_EraseRootFromParent_Done,
     /* 146146 */   // Label 3160: @146146
     /* 146146 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(146208), // Rule ID 4930 //
     /* 146151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146170 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146173 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146177 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146190 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rm),
     /* 146193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146197 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146206 */     GIR_RootConstrainSelectedInstOperands,
     /* 146207 */     // GIR_Coverage, 4930,
     /* 146207 */     GIR_EraseRootFromParent_Done,
     /* 146208 */   // Label 3161: @146208
     /* 146208 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(146235), // Rule ID 2634 //
     /* 146213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146228 */     // (usubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 146228 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWYrr),
     /* 146233 */     GIR_RootConstrainSelectedInstOperands,
     /* 146234 */     // GIR_Coverage, 2634,
     /* 146234 */     GIR_Done,
     /* 146235 */   // Label 3162: @146235
     /* 146235 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(146262), // Rule ID 4927 //
     /* 146240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146255 */     // (usubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBUSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 146255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZ256rr),
     /* 146260 */     GIR_RootConstrainSelectedInstOperands,
     /* 146261 */     // GIR_Coverage, 4927,
     /* 146261 */     GIR_Done,
     /* 146262 */   // Label 3163: @146262
     /* 146262 */   GIM_Reject,
     /* 146263 */ // Label 3159: @146263
     /* 146263 */ GIM_Reject,
     /* 146264 */ // Label 3143: @146264
     /* 146264 */ GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(146454),
     /* 146269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 146272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 146275 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(146337), // Rule ID 2629 //
     /* 146280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146299 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146302 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146306 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146312 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146319 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrm),
     /* 146322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146324 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146326 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146335 */     GIR_RootConstrainSelectedInstOperands,
     /* 146336 */     // GIR_Coverage, 2629,
     /* 146336 */     GIR_EraseRootFromParent_Done,
     /* 146337 */   // Label 3165: @146337
     /* 146337 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(146399), // Rule ID 4948 //
     /* 146342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146361 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146364 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146368 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146374 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146381 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rm),
     /* 146384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146397 */     GIR_RootConstrainSelectedInstOperands,
     /* 146398 */     // GIR_Coverage, 4948,
     /* 146398 */     GIR_EraseRootFromParent_Done,
     /* 146399 */   // Label 3166: @146399
     /* 146399 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(146426), // Rule ID 2628 //
     /* 146404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 146407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 146419 */     // (usubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 146419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBYrr),
     /* 146424 */     GIR_RootConstrainSelectedInstOperands,
     /* 146425 */     // GIR_Coverage, 2628,
     /* 146425 */     GIR_Done,
     /* 146426 */   // Label 3167: @146426
     /* 146426 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(146453), // Rule ID 4945 //
     /* 146431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 146446 */     // (usubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBUSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 146446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZ256rr),
     /* 146451 */     GIR_RootConstrainSelectedInstOperands,
     /* 146452 */     // GIR_Coverage, 4945,
     /* 146452 */     GIR_Done,
     /* 146453 */   // Label 3168: @146453
     /* 146453 */   GIM_Reject,
     /* 146454 */ // Label 3164: @146454
     /* 146454 */ GIM_Reject,
     /* 146455 */ // Label 3144: @146455
     /* 146455 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(146548),
     /* 146460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 146463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 146466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146474 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(146528), // Rule ID 4924 //
     /* 146479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146490 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146493 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146497 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146503 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146510 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrm),
     /* 146513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146515 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146517 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146526 */     GIR_RootConstrainSelectedInstOperands,
     /* 146527 */     // GIR_Coverage, 4924,
     /* 146527 */     GIR_EraseRootFromParent_Done,
     /* 146528 */   // Label 3170: @146528
     /* 146528 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(146547), // Rule ID 4921 //
     /* 146533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146540 */     // (usubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBUSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 146540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSWZrr),
     /* 146545 */     GIR_RootConstrainSelectedInstOperands,
     /* 146546 */     // GIR_Coverage, 4921,
     /* 146546 */     GIR_Done,
     /* 146547 */   // Label 3171: @146547
     /* 146547 */   GIM_Reject,
     /* 146548 */ // Label 3169: @146548
     /* 146548 */ GIM_Reject,
     /* 146549 */ // Label 3145: @146549
     /* 146549 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(146642),
     /* 146554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 146557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 146560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146568 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(146622), // Rule ID 4942 //
     /* 146573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146604 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBUSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrm),
     /* 146607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146609 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146611 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146620 */     GIR_RootConstrainSelectedInstOperands,
     /* 146621 */     // GIR_Coverage, 4942,
     /* 146621 */     GIR_EraseRootFromParent_Done,
     /* 146622 */   // Label 3173: @146622
     /* 146622 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(146641), // Rule ID 4939 //
     /* 146627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 146630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 146634 */     // (usubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBUSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 146634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBUSBZrr),
     /* 146639 */     GIR_RootConstrainSelectedInstOperands,
     /* 146640 */     // GIR_Coverage, 4939,
     /* 146640 */     GIR_Done,
     /* 146641 */   // Label 3174: @146641
     /* 146641 */   GIM_Reject,
     /* 146642 */ // Label 3172: @146642
     /* 146642 */ GIM_Reject,
     /* 146643 */ // Label 3146: @146643
     /* 146643 */ GIM_Reject,
     /* 146644 */ // Label 40: @146644
     /* 146644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(13), GIMT_Encode2(25), /*)*//*default:*//*Label 3181*/ GIMT_Encode4(147709),
     /* 146655 */ /*GILLT_v8s16*//*Label 3175*/ GIMT_Encode4(146703), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146671 */ /*GILLT_v16s8*//*Label 3176*/ GIMT_Encode4(146921),
     /* 146675 */ /*GILLT_v16s16*//*Label 3177*/ GIMT_Encode4(147139), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 146687 */ /*GILLT_v32s8*//*Label 3178*/ GIMT_Encode4(147330),
     /* 146691 */ /*GILLT_v32s16*//*Label 3179*/ GIMT_Encode4(147521), GIMT_Encode4(0),
     /* 146699 */ /*GILLT_v64s8*//*Label 3180*/ GIMT_Encode4(147615),
     /* 146703 */ // Label 3175: @146703
     /* 146703 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(146920),
     /* 146708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 146711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146714 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(146776), // Rule ID 2619 //
     /* 146719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146758 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrm),
     /* 146761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146774 */     GIR_RootConstrainSelectedInstOperands,
     /* 146775 */     // GIR_Coverage, 2619,
     /* 146775 */     GIR_EraseRootFromParent_Done,
     /* 146776 */   // Label 3183: @146776
     /* 146776 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(146838), // Rule ID 4864 //
     /* 146781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146820 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rm),
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146836 */     GIR_RootConstrainSelectedInstOperands,
     /* 146837 */     // GIR_Coverage, 4864,
     /* 146837 */     GIR_EraseRootFromParent_Done,
     /* 146838 */   // Label 3184: @146838
     /* 146838 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(146865), // Rule ID 2618 //
     /* 146843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146858 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWrr),
     /* 146863 */     GIR_RootConstrainSelectedInstOperands,
     /* 146864 */     // GIR_Coverage, 2618,
     /* 146864 */     GIR_Done,
     /* 146865 */   // Label 3185: @146865
     /* 146865 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(146892), // Rule ID 2620 //
     /* 146870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146885 */     // (ssubsat:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PSUBSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 146885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSWrr),
     /* 146890 */     GIR_RootConstrainSelectedInstOperands,
     /* 146891 */     // GIR_Coverage, 2620,
     /* 146891 */     GIR_Done,
     /* 146892 */   // Label 3186: @146892
     /* 146892 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(146919), // Rule ID 4861 //
     /* 146897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 146900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 146912 */     // (ssubsat:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPSUBSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 146912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ128rr),
     /* 146917 */     GIR_RootConstrainSelectedInstOperands,
     /* 146918 */     // GIR_Coverage, 4861,
     /* 146918 */     GIR_Done,
     /* 146919 */   // Label 3187: @146919
     /* 146919 */   GIM_Reject,
     /* 146920 */ // Label 3182: @146920
     /* 146920 */ GIM_Reject,
     /* 146921 */ // Label 3176: @146921
     /* 146921 */ GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(147138),
     /* 146926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 146929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146932 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(146994), // Rule ID 2613 //
     /* 146937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 146940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 146948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 146952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 146956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 146959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 146963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 146967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 146976 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 146976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrm),
     /* 146979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 146981 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 146983 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 146987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 146992 */     GIR_RootConstrainSelectedInstOperands,
     /* 146993 */     // GIR_Coverage, 2613,
     /* 146993 */     GIR_EraseRootFromParent_Done,
     /* 146994 */   // Label 3189: @146994
     /* 146994 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(147056), // Rule ID 4882 //
     /* 146999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147018 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147021 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147025 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147038 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rm),
     /* 147041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147043 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147054 */     GIR_RootConstrainSelectedInstOperands,
     /* 147055 */     // GIR_Coverage, 4882,
     /* 147055 */     GIR_EraseRootFromParent_Done,
     /* 147056 */   // Label 3190: @147056
     /* 147056 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(147083), // Rule ID 2612 //
     /* 147061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 147064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147076 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBrr),
     /* 147081 */     GIR_RootConstrainSelectedInstOperands,
     /* 147082 */     // GIR_Coverage, 2612,
     /* 147082 */     GIR_Done,
     /* 147083 */   // Label 3191: @147083
     /* 147083 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(147110), // Rule ID 2614 //
     /* 147088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 147091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 147103 */     // (ssubsat:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PSUBSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 147103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PSUBSBrr),
     /* 147108 */     GIR_RootConstrainSelectedInstOperands,
     /* 147109 */     // GIR_Coverage, 2614,
     /* 147109 */     GIR_Done,
     /* 147110 */   // Label 3192: @147110
     /* 147110 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(147137), // Rule ID 4879 //
     /* 147115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 147130 */     // (ssubsat:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPSUBSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 147130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ128rr),
     /* 147135 */     GIR_RootConstrainSelectedInstOperands,
     /* 147136 */     // GIR_Coverage, 4879,
     /* 147136 */     GIR_Done,
     /* 147137 */   // Label 3193: @147137
     /* 147137 */   GIM_Reject,
     /* 147138 */ // Label 3188: @147138
     /* 147138 */ GIM_Reject,
     /* 147139 */ // Label 3177: @147139
     /* 147139 */ GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(147329),
     /* 147144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 147147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 147150 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(147212), // Rule ID 2623 //
     /* 147155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147187 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147194 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrm),
     /* 147197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147199 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147201 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147210 */     GIR_RootConstrainSelectedInstOperands,
     /* 147211 */     // GIR_Coverage, 2623,
     /* 147211 */     GIR_EraseRootFromParent_Done,
     /* 147212 */   // Label 3195: @147212
     /* 147212 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(147274), // Rule ID 4858 //
     /* 147217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147256 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rm),
     /* 147259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147272 */     GIR_RootConstrainSelectedInstOperands,
     /* 147273 */     // GIR_Coverage, 4858,
     /* 147273 */     GIR_EraseRootFromParent_Done,
     /* 147274 */   // Label 3196: @147274
     /* 147274 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(147301), // Rule ID 2622 //
     /* 147279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147294 */     // (ssubsat:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPSUBSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 147294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWYrr),
     /* 147299 */     GIR_RootConstrainSelectedInstOperands,
     /* 147300 */     // GIR_Coverage, 2622,
     /* 147300 */     GIR_Done,
     /* 147301 */   // Label 3197: @147301
     /* 147301 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(147328), // Rule ID 4855 //
     /* 147306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147321 */     // (ssubsat:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPSUBSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 147321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZ256rr),
     /* 147326 */     GIR_RootConstrainSelectedInstOperands,
     /* 147327 */     // GIR_Coverage, 4855,
     /* 147327 */     GIR_Done,
     /* 147328 */   // Label 3198: @147328
     /* 147328 */   GIM_Reject,
     /* 147329 */ // Label 3194: @147329
     /* 147329 */ GIM_Reject,
     /* 147330 */ // Label 3178: @147330
     /* 147330 */ GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(147520),
     /* 147335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 147338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 147341 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(147403), // Rule ID 2617 //
     /* 147346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147365 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147368 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147372 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147385 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrm),
     /* 147388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147390 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147392 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147401 */     GIR_RootConstrainSelectedInstOperands,
     /* 147402 */     // GIR_Coverage, 2617,
     /* 147402 */     GIR_EraseRootFromParent_Done,
     /* 147403 */   // Label 3200: @147403
     /* 147403 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(147465), // Rule ID 4876 //
     /* 147408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147440 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147447 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rm),
     /* 147450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147454 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147463 */     GIR_RootConstrainSelectedInstOperands,
     /* 147464 */     // GIR_Coverage, 4876,
     /* 147464 */     GIR_EraseRootFromParent_Done,
     /* 147465 */   // Label 3201: @147465
     /* 147465 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(147492), // Rule ID 2616 //
     /* 147470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 147473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 147485 */     // (ssubsat:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPSUBSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 147485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBYrr),
     /* 147490 */     GIR_RootConstrainSelectedInstOperands,
     /* 147491 */     // GIR_Coverage, 2616,
     /* 147491 */     GIR_Done,
     /* 147492 */   // Label 3202: @147492
     /* 147492 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(147519), // Rule ID 4873 //
     /* 147497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 147512 */     // (ssubsat:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPSUBSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 147512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZ256rr),
     /* 147517 */     GIR_RootConstrainSelectedInstOperands,
     /* 147518 */     // GIR_Coverage, 4873,
     /* 147518 */     GIR_Done,
     /* 147519 */   // Label 3203: @147519
     /* 147519 */   GIM_Reject,
     /* 147520 */ // Label 3199: @147520
     /* 147520 */ GIM_Reject,
     /* 147521 */ // Label 3179: @147521
     /* 147521 */ GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(147614),
     /* 147526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 147529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 147532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147540 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(147594), // Rule ID 4852 //
     /* 147545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147576 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrm),
     /* 147579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147592 */     GIR_RootConstrainSelectedInstOperands,
     /* 147593 */     // GIR_Coverage, 4852,
     /* 147593 */     GIR_EraseRootFromParent_Done,
     /* 147594 */   // Label 3205: @147594
     /* 147594 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(147613), // Rule ID 4849 //
     /* 147599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147606 */     // (ssubsat:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPSUBSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 147606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSWZrr),
     /* 147611 */     GIR_RootConstrainSelectedInstOperands,
     /* 147612 */     // GIR_Coverage, 4849,
     /* 147612 */     GIR_Done,
     /* 147613 */   // Label 3206: @147613
     /* 147613 */   GIM_Reject,
     /* 147614 */ // Label 3204: @147614
     /* 147614 */ GIM_Reject,
     /* 147615 */ // Label 3180: @147615
     /* 147615 */ GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(147708),
     /* 147620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 147623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 147626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147634 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(147688), // Rule ID 4870 //
     /* 147639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147670 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPSUBSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrm),
     /* 147673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147686 */     GIR_RootConstrainSelectedInstOperands,
     /* 147687 */     // GIR_Coverage, 4870,
     /* 147687 */     GIR_EraseRootFromParent_Done,
     /* 147688 */   // Label 3208: @147688
     /* 147688 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(147707), // Rule ID 4867 //
     /* 147693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 147696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 147700 */     // (ssubsat:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPSUBSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 147700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPSUBSBZrr),
     /* 147705 */     GIR_RootConstrainSelectedInstOperands,
     /* 147706 */     // GIR_Coverage, 4867,
     /* 147706 */     GIR_Done,
     /* 147707 */   // Label 3209: @147707
     /* 147707 */   GIM_Reject,
     /* 147708 */ // Label 3207: @147708
     /* 147708 */ GIM_Reject,
     /* 147709 */ // Label 3181: @147709
     /* 147709 */ GIM_Reject,
     /* 147710 */ // Label 41: @147710
     /* 147710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3223*/ GIMT_Encode4(153623),
     /* 147721 */ /*GILLT_s16*//*Label 3210*/ GIMT_Encode4(147805),
     /* 147725 */ /*GILLT_s32*//*Label 3211*/ GIMT_Encode4(147965),
     /* 147729 */ /*GILLT_s64*//*Label 3212*/ GIMT_Encode4(149362),
     /* 147733 */ /*GILLT_s80*//*Label 3213*/ GIMT_Encode4(150903), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147745 */ /*GILLT_v2s64*//*Label 3214*/ GIMT_Encode4(151469), GIMT_Encode4(0),
     /* 147753 */ /*GILLT_v4s32*//*Label 3215*/ GIMT_Encode4(151823),
     /* 147757 */ /*GILLT_v4s64*//*Label 3216*/ GIMT_Encode4(152177), GIMT_Encode4(0),
     /* 147765 */ /*GILLT_v8s16*//*Label 3217*/ GIMT_Encode4(152500),
     /* 147769 */ /*GILLT_v8s32*//*Label 3218*/ GIMT_Encode4(152660),
     /* 147773 */ /*GILLT_v8s64*//*Label 3219*/ GIMT_Encode4(152983), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147785 */ /*GILLT_v16s16*//*Label 3220*/ GIMT_Encode4(153143),
     /* 147789 */ /*GILLT_v16s32*//*Label 3221*/ GIMT_Encode4(153303), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 147801 */ /*GILLT_v32s16*//*Label 3222*/ GIMT_Encode4(153463),
     /* 147805 */ // Label 3210: @147805
     /* 147805 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(147964),
     /* 147810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 147813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147820 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(147878), // Rule ID 24250 //
     /* 147825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147860 */     // (fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 147867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147876 */     GIR_RootConstrainSelectedInstOperands,
     /* 147877 */     // GIR_Coverage, 24250,
     /* 147877 */     GIR_EraseRootFromParent_Done,
     /* 147878 */   // Label 3225: @147878
     /* 147878 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(147936), // Rule ID 5955 //
     /* 147883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 147894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 147898 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 147901 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 147905 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 147909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 147918 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 147918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 147921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147923 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 147925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 147929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 147934 */     GIR_RootConstrainSelectedInstOperands,
     /* 147935 */     // GIR_Coverage, 5955,
     /* 147935 */     GIR_EraseRootFromParent_Done,
     /* 147936 */   // Label 3226: @147936
     /* 147936 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(147963), // Rule ID 5953 //
     /* 147941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 147944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 147952 */     // (fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 147952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 147957 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 147961 */     GIR_RootConstrainSelectedInstOperands,
     /* 147962 */     // GIR_Coverage, 5953,
     /* 147962 */     GIR_Done,
     /* 147963 */   // Label 3227: @147963
     /* 147963 */   GIM_Reject,
     /* 147964 */ // Label 3224: @147964
     /* 147964 */ GIM_Reject,
     /* 147965 */ // Label 3211: @147965
     /* 147965 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(149361),
     /* 147970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 147973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147976 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(148058), // Rule ID 26018 //
     /* 147981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 147984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 147988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 147996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148008 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148011 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148015 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148022 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148032 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148039 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148044 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148056 */     GIR_RootConstrainSelectedInstOperands,
     /* 148057 */     // GIR_Coverage, 26018,
     /* 148057 */     GIR_EraseRootFromParent_Done,
     /* 148058 */   // Label 3229: @148058
     /* 148058 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(148140), // Rule ID 26019 //
     /* 148063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148090 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148097 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148104 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148114 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148121 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148126 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148128 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148138 */     GIR_RootConstrainSelectedInstOperands,
     /* 148139 */     // GIR_Coverage, 26019,
     /* 148139 */     GIR_EraseRootFromParent_Done,
     /* 148140 */   // Label 3230: @148140
     /* 148140 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(148222), // Rule ID 26020 //
     /* 148145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148172 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148179 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148186 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148196 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148203 */     // (fadd:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148208 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148210 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148220 */     GIR_RootConstrainSelectedInstOperands,
     /* 148221 */     // GIR_Coverage, 26020,
     /* 148221 */     GIR_EraseRootFromParent_Done,
     /* 148222 */   // Label 3231: @148222
     /* 148222 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(148304), // Rule ID 22467 //
     /* 148227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148258 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148265 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148272 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148278 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148285 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148302 */     GIR_RootConstrainSelectedInstOperands,
     /* 148303 */     // GIR_Coverage, 22467,
     /* 148303 */     GIR_EraseRootFromParent_Done,
     /* 148304 */   // Label 3232: @148304
     /* 148304 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(148386), // Rule ID 22468 //
     /* 148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148340 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148347 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148354 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148360 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148367 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148372 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148374 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148384 */     GIR_RootConstrainSelectedInstOperands,
     /* 148385 */     // GIR_Coverage, 22468,
     /* 148385 */     GIR_EraseRootFromParent_Done,
     /* 148386 */   // Label 3233: @148386
     /* 148386 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(148468), // Rule ID 22469 //
     /* 148391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 148410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 148414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 148418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148422 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 148425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 148429 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148436 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 148440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 148442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148449 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148456 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 148466 */     GIR_RootConstrainSelectedInstOperands,
     /* 148467 */     // GIR_Coverage, 22469,
     /* 148467 */     GIR_EraseRootFromParent_Done,
     /* 148468 */   // Label 3234: @148468
     /* 148468 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(148533), // Rule ID 23247 //
     /* 148473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148488 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148512 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148517 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148531 */     GIR_RootConstrainSelectedInstOperands,
     /* 148532 */     // GIR_Coverage, 23247,
     /* 148532 */     GIR_EraseRootFromParent_Done,
     /* 148533 */   // Label 3235: @148533
     /* 148533 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(148598), // Rule ID 23249 //
     /* 148538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148553 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148577 */     // (fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148582 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148584 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148596 */     GIR_RootConstrainSelectedInstOperands,
     /* 148597 */     // GIR_Coverage, 23249,
     /* 148597 */     GIR_EraseRootFromParent_Done,
     /* 148598 */   // Label 3236: @148598
     /* 148598 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(148663), // Rule ID 23237 //
     /* 148603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148618 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148621 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148625 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148635 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148642 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 148645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148647 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148649 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148656 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148661 */     GIR_RootConstrainSelectedInstOperands,
     /* 148662 */     // GIR_Coverage, 23237,
     /* 148662 */     GIR_EraseRootFromParent_Done,
     /* 148663 */   // Label 3237: @148663
     /* 148663 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(148725), // Rule ID 23382 //
     /* 148668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 148671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148683 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148686 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148690 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148707 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 148710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148712 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148714 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148723 */     GIR_RootConstrainSelectedInstOperands,
     /* 148724 */     // GIR_Coverage, 23382,
     /* 148724 */     GIR_EraseRootFromParent_Done,
     /* 148725 */   // Label 3238: @148725
     /* 148725 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(148787), // Rule ID 23386 //
     /* 148730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 148733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148745 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148748 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148752 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 148760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148769 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 148772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148774 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148776 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148785 */     GIR_RootConstrainSelectedInstOperands,
     /* 148786 */     // GIR_Coverage, 23386,
     /* 148786 */     GIR_EraseRootFromParent_Done,
     /* 148787 */   // Label 3239: @148787
     /* 148787 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(148849), // Rule ID 24246 //
     /* 148792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 148795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 148807 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 148810 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 148814 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 148822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148824 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148831 */     // (fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 148834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148836 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 148838 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148847 */     GIR_RootConstrainSelectedInstOperands,
     /* 148848 */     // GIR_Coverage, 24246,
     /* 148848 */     GIR_EraseRootFromParent_Done,
     /* 148849 */   // Label 3240: @148849
     /* 148849 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(148914), // Rule ID 921 //
     /* 148854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148873 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148886 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148893 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 148896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148898 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148900 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148912 */     GIR_RootConstrainSelectedInstOperands,
     /* 148913 */     // GIR_Coverage, 921,
     /* 148913 */     GIR_EraseRootFromParent_Done,
     /* 148914 */   // Label 3241: @148914
     /* 148914 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(148979), // Rule ID 923 //
     /* 148919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 148938 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 148949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 148958 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 148958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 148961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148963 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 148965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 148969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 148972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 148977 */     GIR_RootConstrainSelectedInstOperands,
     /* 148978 */     // GIR_Coverage, 923,
     /* 148978 */     GIR_EraseRootFromParent_Done,
     /* 148979 */   // Label 3242: @148979
     /* 148979 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(149044), // Rule ID 911 //
     /* 148984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 148987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 148995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 148999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149003 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149006 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149010 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149023 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 149026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149028 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149042 */     GIR_RootConstrainSelectedInstOperands,
     /* 149043 */     // GIR_Coverage, 911,
     /* 149043 */     GIR_EraseRootFromParent_Done,
     /* 149044 */   // Label 3243: @149044
     /* 149044 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(149106), // Rule ID 2161 //
     /* 149049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149068 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149075 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149081 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149088 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 149091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149093 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149095 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149104 */     GIR_RootConstrainSelectedInstOperands,
     /* 149105 */     // GIR_Coverage, 2161,
     /* 149105 */     GIR_EraseRootFromParent_Done,
     /* 149106 */   // Label 3244: @149106
     /* 149106 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(149168), // Rule ID 2169 //
     /* 149111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149150 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 149153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149155 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149166 */     GIR_RootConstrainSelectedInstOperands,
     /* 149167 */     // GIR_Coverage, 2169,
     /* 149167 */     GIR_EraseRootFromParent_Done,
     /* 149168 */   // Label 3245: @149168
     /* 149168 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(149230), // Rule ID 5917 //
     /* 149173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 149195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 149199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149212 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 149215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149217 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149228 */     GIR_RootConstrainSelectedInstOperands,
     /* 149229 */     // GIR_Coverage, 5917,
     /* 149229 */     GIR_EraseRootFromParent_Done,
     /* 149230 */   // Label 3246: @149230
     /* 149230 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(149267), // Rule ID 887 //
     /* 149235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 149238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 149250 */     // (fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 149250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 149255 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 149261 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 149265 */     GIR_RootConstrainSelectedInstOperands,
     /* 149266 */     // GIR_Coverage, 887,
     /* 149266 */     GIR_Done,
     /* 149267 */   // Label 3247: @149267
     /* 149267 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(149298), // Rule ID 2159 //
     /* 149272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149287 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 149292 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149296 */     GIR_RootConstrainSelectedInstOperands,
     /* 149297 */     // GIR_Coverage, 2159,
     /* 149297 */     GIR_Done,
     /* 149298 */   // Label 3248: @149298
     /* 149298 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(149329), // Rule ID 2167 //
     /* 149303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 149318 */     // (fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 149318 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 149323 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149327 */     GIR_RootConstrainSelectedInstOperands,
     /* 149328 */     // GIR_Coverage, 2167,
     /* 149328 */     GIR_Done,
     /* 149329 */   // Label 3249: @149329
     /* 149329 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(149360), // Rule ID 5915 //
     /* 149334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 149349 */     // (fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 149349 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 149354 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 149358 */     GIR_RootConstrainSelectedInstOperands,
     /* 149359 */     // GIR_Coverage, 5915,
     /* 149359 */     GIR_Done,
     /* 149360 */   // Label 3250: @149360
     /* 149360 */   GIM_Reject,
     /* 149361 */ // Label 3228: @149361
     /* 149361 */ GIM_Reject,
     /* 149362 */ // Label 3212: @149362
     /* 149362 */ GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(150902),
     /* 149367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 149370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149373 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(149455), // Rule ID 26021 //
     /* 149378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149405 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149412 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149419 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149429 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149436 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149441 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149453 */     GIR_RootConstrainSelectedInstOperands,
     /* 149454 */     // GIR_Coverage, 26021,
     /* 149454 */     GIR_EraseRootFromParent_Done,
     /* 149455 */   // Label 3252: @149455
     /* 149455 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(149537), // Rule ID 26022 //
     /* 149460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149487 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149490 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149494 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149501 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149509 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149511 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149518 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149523 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149535 */     GIR_RootConstrainSelectedInstOperands,
     /* 149536 */     // GIR_Coverage, 26022,
     /* 149536 */     GIR_EraseRootFromParent_Done,
     /* 149537 */   // Label 3253: @149537
     /* 149537 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(149619), // Rule ID 26023 //
     /* 149542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149569 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149576 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149600 */     // (fadd:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149617 */     GIR_RootConstrainSelectedInstOperands,
     /* 149618 */     // GIR_Coverage, 26023,
     /* 149618 */     GIR_EraseRootFromParent_Done,
     /* 149619 */   // Label 3254: @149619
     /* 149619 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(149701), // Rule ID 22470 //
     /* 149624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 149627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149655 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149658 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149662 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149669 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149675 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149682 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 149685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149687 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149699 */     GIR_RootConstrainSelectedInstOperands,
     /* 149700 */     // GIR_Coverage, 22470,
     /* 149700 */     GIR_EraseRootFromParent_Done,
     /* 149701 */   // Label 3255: @149701
     /* 149701 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(149783), // Rule ID 22471 //
     /* 149706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 149709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 149717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149737 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149744 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149751 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149757 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149764 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 149767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149769 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149771 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149781 */     GIR_RootConstrainSelectedInstOperands,
     /* 149782 */     // GIR_Coverage, 22471,
     /* 149782 */     GIR_EraseRootFromParent_Done,
     /* 149783 */   // Label 3256: @149783
     /* 149783 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(149865), // Rule ID 22472 //
     /* 149788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 149791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 149799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 149803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 149807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 149811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 149815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 149819 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 149822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 149826 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149833 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 149837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 149839 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149846 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 149849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 149853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 149863 */     GIR_RootConstrainSelectedInstOperands,
     /* 149864 */     // GIR_Coverage, 22472,
     /* 149864 */     GIR_EraseRootFromParent_Done,
     /* 149865 */   // Label 3257: @149865
     /* 149865 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(149930), // Rule ID 23251 //
     /* 149870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149885 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149892 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149902 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149909 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 149912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149916 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149928 */     GIR_RootConstrainSelectedInstOperands,
     /* 149929 */     // GIR_Coverage, 23251,
     /* 149929 */     GIR_EraseRootFromParent_Done,
     /* 149930 */   // Label 3258: @149930
     /* 149930 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(149995), // Rule ID 23253 //
     /* 149935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 149938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 149950 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 149961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 149965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 149974 */     // (fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 149974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 149977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 149981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 149985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 149988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 149993 */     GIR_RootConstrainSelectedInstOperands,
     /* 149994 */     // GIR_Coverage, 23253,
     /* 149994 */     GIR_EraseRootFromParent_Done,
     /* 149995 */   // Label 3259: @149995
     /* 149995 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(150060), // Rule ID 23239 //
     /* 150000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150015 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150018 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150022 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150032 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150039 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150044 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150046 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150058 */     GIR_RootConstrainSelectedInstOperands,
     /* 150059 */     // GIR_Coverage, 23239,
     /* 150059 */     GIR_EraseRootFromParent_Done,
     /* 150060 */   // Label 3260: @150060
     /* 150060 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(150132), // Rule ID 23241 //
     /* 150065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150083 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150087 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150111 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150130 */     GIR_RootConstrainSelectedInstOperands,
     /* 150131 */     // GIR_Coverage, 23241,
     /* 150131 */     GIR_EraseRootFromParent_Done,
     /* 150132 */   // Label 3261: @150132
     /* 150132 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(150194), // Rule ID 23384 //
     /* 150137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150176 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150192 */     GIR_RootConstrainSelectedInstOperands,
     /* 150193 */     // GIR_Coverage, 23384,
     /* 150193 */     GIR_EraseRootFromParent_Done,
     /* 150194 */   // Label 3262: @150194
     /* 150194 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(150256), // Rule ID 23388 //
     /* 150199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150214 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150217 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150221 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150231 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150238 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150243 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150245 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150254 */     GIR_RootConstrainSelectedInstOperands,
     /* 150255 */     // GIR_Coverage, 23388,
     /* 150255 */     GIR_EraseRootFromParent_Done,
     /* 150256 */   // Label 3263: @150256
     /* 150256 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(150318), // Rule ID 24248 //
     /* 150261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150276 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150279 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150283 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150300 */     // (fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150316 */     GIR_RootConstrainSelectedInstOperands,
     /* 150317 */     // GIR_Coverage, 24248,
     /* 150317 */     GIR_EraseRootFromParent_Done,
     /* 150318 */   // Label 3264: @150318
     /* 150318 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(150383), // Rule ID 925 //
     /* 150323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150342 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150349 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150355 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150362 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 150365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150367 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150369 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150381 */     GIR_RootConstrainSelectedInstOperands,
     /* 150382 */     // GIR_Coverage, 925,
     /* 150382 */     GIR_EraseRootFromParent_Done,
     /* 150383 */   // Label 3265: @150383
     /* 150383 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(150448), // Rule ID 927 //
     /* 150388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150407 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150414 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150427 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 150430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150446 */     GIR_RootConstrainSelectedInstOperands,
     /* 150447 */     // GIR_Coverage, 927,
     /* 150447 */     GIR_EraseRootFromParent_Done,
     /* 150448 */   // Label 3266: @150448
     /* 150448 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(150513), // Rule ID 913 //
     /* 150453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150472 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150475 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150479 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150485 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150492 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 150495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150503 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150511 */     GIR_RootConstrainSelectedInstOperands,
     /* 150512 */     // GIR_Coverage, 913,
     /* 150512 */     GIR_EraseRootFromParent_Done,
     /* 150513 */   // Label 3267: @150513
     /* 150513 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(150585), // Rule ID 915 //
     /* 150518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150537 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150540 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150544 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 150551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150564 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 150567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150583 */     GIR_RootConstrainSelectedInstOperands,
     /* 150584 */     // GIR_Coverage, 915,
     /* 150584 */     GIR_EraseRootFromParent_Done,
     /* 150585 */   // Label 3268: @150585
     /* 150585 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(150647), // Rule ID 2165 //
     /* 150590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150612 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150616 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150629 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 150632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150634 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150645 */     GIR_RootConstrainSelectedInstOperands,
     /* 150646 */     // GIR_Coverage, 2165,
     /* 150646 */     GIR_EraseRootFromParent_Done,
     /* 150647 */   // Label 3269: @150647
     /* 150647 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(150709), // Rule ID 2173 //
     /* 150652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150691 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 150694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150696 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150698 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150707 */     GIR_RootConstrainSelectedInstOperands,
     /* 150708 */     // GIR_Coverage, 2173,
     /* 150708 */     GIR_EraseRootFromParent_Done,
     /* 150709 */   // Label 3270: @150709
     /* 150709 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(150771), // Rule ID 5936 //
     /* 150714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 150729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 150733 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 150736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 150740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150753 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 150756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 150760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150769 */     GIR_RootConstrainSelectedInstOperands,
     /* 150770 */     // GIR_Coverage, 5936,
     /* 150770 */     GIR_EraseRootFromParent_Done,
     /* 150771 */   // Label 3271: @150771
     /* 150771 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(150808), // Rule ID 889 //
     /* 150776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 150791 */     // (fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 150791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 150796 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 150802 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 150806 */     GIR_RootConstrainSelectedInstOperands,
     /* 150807 */     // GIR_Coverage, 889,
     /* 150807 */     GIR_Done,
     /* 150808 */   // Label 3272: @150808
     /* 150808 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(150839), // Rule ID 2163 //
     /* 150813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 150816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150828 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 150833 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150837 */     GIR_RootConstrainSelectedInstOperands,
     /* 150838 */     // GIR_Coverage, 2163,
     /* 150838 */     GIR_Done,
     /* 150839 */   // Label 3273: @150839
     /* 150839 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(150870), // Rule ID 2171 //
     /* 150844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 150847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 150859 */     // (fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 150859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 150864 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150868 */     GIR_RootConstrainSelectedInstOperands,
     /* 150869 */     // GIR_Coverage, 2171,
     /* 150869 */     GIR_Done,
     /* 150870 */   // Label 3274: @150870
     /* 150870 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(150901), // Rule ID 5934 //
     /* 150875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 150878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 150890 */     // (fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 150890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 150895 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 150899 */     GIR_RootConstrainSelectedInstOperands,
     /* 150900 */     // GIR_Coverage, 5934,
     /* 150900 */     GIR_Done,
     /* 150901 */   // Label 3275: @150901
     /* 150901 */   GIM_Reject,
     /* 150902 */ // Label 3251: @150902
     /* 150902 */ GIM_Reject,
     /* 150903 */ // Label 3213: @150903
     /* 150903 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(151468),
     /* 150908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 150911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 150914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150918 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(150979), // Rule ID 23255 //
     /* 150923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150934 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150941 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 150945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 150949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150951 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 150958 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 150958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 150961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 150965 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 150969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 150972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 150977 */     GIR_RootConstrainSelectedInstOperands,
     /* 150978 */     // GIR_Coverage, 23255,
     /* 150978 */     GIR_EraseRootFromParent_Done,
     /* 150979 */   // Label 3277: @150979
     /* 150979 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(151040), // Rule ID 23257 //
     /* 150984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 150987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 150995 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151019 */     // (fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151024 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151038 */     GIR_RootConstrainSelectedInstOperands,
     /* 151039 */     // GIR_Coverage, 23257,
     /* 151039 */     GIR_EraseRootFromParent_Done,
     /* 151040 */   // Label 3278: @151040
     /* 151040 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(151108), // Rule ID 23243 //
     /* 151045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151056 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151059 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151063 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151070 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151080 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151087 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151092 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151094 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151106 */     GIR_RootConstrainSelectedInstOperands,
     /* 151107 */     // GIR_Coverage, 23243,
     /* 151107 */     GIR_EraseRootFromParent_Done,
     /* 151108 */   // Label 3279: @151108
     /* 151108 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(151176), // Rule ID 23245 //
     /* 151113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151127 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151131 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151138 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151148 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151155 */     // (fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151160 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151174 */     GIR_RootConstrainSelectedInstOperands,
     /* 151175 */     // GIR_Coverage, 23245,
     /* 151175 */     GIR_EraseRootFromParent_Done,
     /* 151176 */   // Label 3280: @151176
     /* 151176 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(151237), // Rule ID 929 //
     /* 151181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151196 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151216 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 151219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151230 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151235 */     GIR_RootConstrainSelectedInstOperands,
     /* 151236 */     // GIR_Coverage, 929,
     /* 151236 */     GIR_EraseRootFromParent_Done,
     /* 151237 */   // Label 3281: @151237
     /* 151237 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(151298), // Rule ID 931 //
     /* 151242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 151257 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151264 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151277 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 151280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151282 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151296 */     GIR_RootConstrainSelectedInstOperands,
     /* 151297 */     // GIR_Coverage, 931,
     /* 151297 */     GIR_EraseRootFromParent_Done,
     /* 151298 */   // Label 3282: @151298
     /* 151298 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(151366), // Rule ID 917 //
     /* 151303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151321 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151325 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151345 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 151348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151364 */     GIR_RootConstrainSelectedInstOperands,
     /* 151365 */     // GIR_Coverage, 917,
     /* 151365 */     GIR_EraseRootFromParent_Done,
     /* 151366 */   // Label 3283: @151366
     /* 151366 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(151434), // Rule ID 919 //
     /* 151371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151389 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151393 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151400 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151413 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 151416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151418 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151420 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 151427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151432 */     GIR_RootConstrainSelectedInstOperands,
     /* 151433 */     // GIR_Coverage, 919,
     /* 151433 */     GIR_EraseRootFromParent_Done,
     /* 151434 */   // Label 3284: @151434
     /* 151434 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(151467), // Rule ID 891 //
     /* 151439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 151442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 151450 */     // (fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 151450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 151455 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 151461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 151465 */     GIR_RootConstrainSelectedInstOperands,
     /* 151466 */     // GIR_Coverage, 891,
     /* 151466 */     GIR_Done,
     /* 151467 */   // Label 3285: @151467
     /* 151467 */   GIM_Reject,
     /* 151468 */ // Label 3276: @151468
     /* 151468 */ GIM_Reject,
     /* 151469 */ // Label 3214: @151469
     /* 151469 */ GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(151822),
     /* 151474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 151477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 151480 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(151542), // Rule ID 23372 //
     /* 151485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151500 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151503 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151507 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151524 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151540 */     GIR_RootConstrainSelectedInstOperands,
     /* 151541 */     // GIR_Coverage, 23372,
     /* 151541 */     GIR_EraseRootFromParent_Done,
     /* 151542 */   // Label 3287: @151542
     /* 151542 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(151604), // Rule ID 24296 //
     /* 151547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151586 */     // (fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151591 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151593 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151602 */     GIR_RootConstrainSelectedInstOperands,
     /* 151603 */     // GIR_Coverage, 24296,
     /* 151603 */     GIR_EraseRootFromParent_Done,
     /* 151604 */   // Label 3288: @151604
     /* 151604 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(151666), // Rule ID 2141 //
     /* 151609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151648 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 151651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151653 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151655 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151664 */     GIR_RootConstrainSelectedInstOperands,
     /* 151665 */     // GIR_Coverage, 2141,
     /* 151665 */     GIR_EraseRootFromParent_Done,
     /* 151666 */   // Label 3289: @151666
     /* 151666 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(151728), // Rule ID 6309 //
     /* 151671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151690 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151693 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151697 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151703 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151710 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 151713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 151717 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151726 */     GIR_RootConstrainSelectedInstOperands,
     /* 151727 */     // GIR_Coverage, 6309,
     /* 151727 */     GIR_EraseRootFromParent_Done,
     /* 151728 */   // Label 3290: @151728
     /* 151728 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(151759), // Rule ID 2139 //
     /* 151733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151748 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 151753 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151757 */     GIR_RootConstrainSelectedInstOperands,
     /* 151758 */     // GIR_Coverage, 2139,
     /* 151758 */     GIR_Done,
     /* 151759 */   // Label 3291: @151759
     /* 151759 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(151790), // Rule ID 2155 //
     /* 151764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 151767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151779 */     // (fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 151779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 151784 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151788 */     GIR_RootConstrainSelectedInstOperands,
     /* 151789 */     // GIR_Coverage, 2155,
     /* 151789 */     GIR_Done,
     /* 151790 */   // Label 3292: @151790
     /* 151790 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(151821), // Rule ID 6305 //
     /* 151795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151810 */     // (fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 151810 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 151815 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 151819 */     GIR_RootConstrainSelectedInstOperands,
     /* 151820 */     // GIR_Coverage, 6305,
     /* 151820 */     GIR_Done,
     /* 151821 */   // Label 3293: @151821
     /* 151821 */   GIM_Reject,
     /* 151822 */ // Label 3286: @151822
     /* 151822 */ GIM_Reject,
     /* 151823 */ // Label 3215: @151823
     /* 151823 */ GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(152176),
     /* 151828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 151831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 151834 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(151896), // Rule ID 23370 //
     /* 151839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151878 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 151881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151883 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151894 */     GIR_RootConstrainSelectedInstOperands,
     /* 151895 */     // GIR_Coverage, 23370,
     /* 151895 */     GIR_EraseRootFromParent_Done,
     /* 151896 */   // Label 3295: @151896
     /* 151896 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(151958), // Rule ID 24280 //
     /* 151901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 151904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 151931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151933 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 151940 */     // (fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 151940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 151943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 151947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 151951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 151956 */     GIR_RootConstrainSelectedInstOperands,
     /* 151957 */     // GIR_Coverage, 24280,
     /* 151957 */     GIR_EraseRootFromParent_Done,
     /* 151958 */   // Label 3296: @151958
     /* 151958 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(152020), // Rule ID 2137 //
     /* 151963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 151966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 151974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 151978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 151982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 151985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 151989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 151993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152002 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 152005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152007 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152009 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152018 */     GIR_RootConstrainSelectedInstOperands,
     /* 152019 */     // GIR_Coverage, 2137,
     /* 152019 */     GIR_EraseRootFromParent_Done,
     /* 152020 */   // Label 3297: @152020
     /* 152020 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(152082), // Rule ID 6285 //
     /* 152025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152047 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152051 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152057 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152064 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 152067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152069 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152071 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152080 */     GIR_RootConstrainSelectedInstOperands,
     /* 152081 */     // GIR_Coverage, 6285,
     /* 152081 */     GIR_EraseRootFromParent_Done,
     /* 152082 */   // Label 3298: @152082
     /* 152082 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(152113), // Rule ID 2135 //
     /* 152087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152102 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 152107 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152111 */     GIR_RootConstrainSelectedInstOperands,
     /* 152112 */     // GIR_Coverage, 2135,
     /* 152112 */     GIR_Done,
     /* 152113 */   // Label 3299: @152113
     /* 152113 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(152144), // Rule ID 2151 //
     /* 152118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 152121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 152133 */     // (fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 152133 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 152138 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152142 */     GIR_RootConstrainSelectedInstOperands,
     /* 152143 */     // GIR_Coverage, 2151,
     /* 152143 */     GIR_Done,
     /* 152144 */   // Label 3300: @152144
     /* 152144 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(152175), // Rule ID 6281 //
     /* 152149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152164 */     // (fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 152164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 152169 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152173 */     GIR_RootConstrainSelectedInstOperands,
     /* 152174 */     // GIR_Coverage, 6281,
     /* 152174 */     GIR_Done,
     /* 152175 */   // Label 3301: @152175
     /* 152175 */   GIM_Reject,
     /* 152176 */ // Label 3294: @152176
     /* 152176 */ GIM_Reject,
     /* 152177 */ // Label 3216: @152177
     /* 152177 */ GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(152499),
     /* 152182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 152185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 152188 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(152250), // Rule ID 23376 //
     /* 152193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152208 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152211 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152232 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152243 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152248 */     GIR_RootConstrainSelectedInstOperands,
     /* 152249 */     // GIR_Coverage, 23376,
     /* 152249 */     GIR_EraseRootFromParent_Done,
     /* 152250 */   // Label 3303: @152250
     /* 152250 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(152312), // Rule ID 24304 //
     /* 152255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152294 */     // (fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152310 */     GIR_RootConstrainSelectedInstOperands,
     /* 152311 */     // GIR_Coverage, 24304,
     /* 152311 */     GIR_EraseRootFromParent_Done,
     /* 152312 */   // Label 3304: @152312
     /* 152312 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(152374), // Rule ID 2149 //
     /* 152317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152336 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152339 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152343 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152349 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152356 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 152359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152372 */     GIR_RootConstrainSelectedInstOperands,
     /* 152373 */     // GIR_Coverage, 2149,
     /* 152373 */     GIR_EraseRootFromParent_Done,
     /* 152374 */   // Label 3305: @152374
     /* 152374 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(152436), // Rule ID 6321 //
     /* 152379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152418 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 152421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152425 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152434 */     GIR_RootConstrainSelectedInstOperands,
     /* 152435 */     // GIR_Coverage, 6321,
     /* 152435 */     GIR_EraseRootFromParent_Done,
     /* 152436 */   // Label 3306: @152436
     /* 152436 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(152467), // Rule ID 2147 //
     /* 152441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152456 */     // (fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 152456 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 152461 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152465 */     GIR_RootConstrainSelectedInstOperands,
     /* 152466 */     // GIR_Coverage, 2147,
     /* 152466 */     GIR_Done,
     /* 152467 */   // Label 3307: @152467
     /* 152467 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(152498), // Rule ID 6317 //
     /* 152472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152487 */     // (fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 152487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 152492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152496 */     GIR_RootConstrainSelectedInstOperands,
     /* 152497 */     // GIR_Coverage, 6317,
     /* 152497 */     GIR_Done,
     /* 152498 */   // Label 3308: @152498
     /* 152498 */   GIM_Reject,
     /* 152499 */ // Label 3302: @152499
     /* 152499 */ GIM_Reject,
     /* 152500 */ // Label 3217: @152500
     /* 152500 */ GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(152659),
     /* 152505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152515 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(152573), // Rule ID 24320 //
     /* 152520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152531 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152534 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152538 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152548 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152555 */     // (fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152560 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152571 */     GIR_RootConstrainSelectedInstOperands,
     /* 152572 */     // GIR_Coverage, 24320,
     /* 152572 */     GIR_EraseRootFromParent_Done,
     /* 152573 */   // Label 3310: @152573
     /* 152573 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(152631), // Rule ID 6345 //
     /* 152578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152613 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 152616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152618 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152620 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152629 */     GIR_RootConstrainSelectedInstOperands,
     /* 152630 */     // GIR_Coverage, 6345,
     /* 152630 */     GIR_EraseRootFromParent_Done,
     /* 152631 */   // Label 3311: @152631
     /* 152631 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(152658), // Rule ID 6341 //
     /* 152636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 152639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 152647 */     // (fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 152647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 152652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152656 */     GIR_RootConstrainSelectedInstOperands,
     /* 152657 */     // GIR_Coverage, 6341,
     /* 152657 */     GIR_Done,
     /* 152658 */   // Label 3312: @152658
     /* 152658 */   GIM_Reject,
     /* 152659 */ // Label 3309: @152659
     /* 152659 */ GIM_Reject,
     /* 152660 */ // Label 3218: @152660
     /* 152660 */ GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(152982),
     /* 152665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 152668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 152671 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(152733), // Rule ID 23374 //
     /* 152676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152691 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152694 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152698 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152715 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152720 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152731 */     GIR_RootConstrainSelectedInstOperands,
     /* 152732 */     // GIR_Coverage, 23374,
     /* 152732 */     GIR_EraseRootFromParent_Done,
     /* 152733 */   // Label 3314: @152733
     /* 152733 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(152795), // Rule ID 24288 //
     /* 152738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152753 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152756 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152760 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152777 */     // (fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152782 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 152784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152793 */     GIR_RootConstrainSelectedInstOperands,
     /* 152794 */     // GIR_Coverage, 24288,
     /* 152794 */     GIR_EraseRootFromParent_Done,
     /* 152795 */   // Label 3315: @152795
     /* 152795 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(152857), // Rule ID 2145 //
     /* 152800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152819 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152822 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152826 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152832 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152839 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 152842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152846 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152855 */     GIR_RootConstrainSelectedInstOperands,
     /* 152856 */     // GIR_Coverage, 2145,
     /* 152856 */     GIR_EraseRootFromParent_Done,
     /* 152857 */   // Label 3316: @152857
     /* 152857 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(152919), // Rule ID 6297 //
     /* 152862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 152881 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 152884 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 152888 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 152892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152894 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 152901 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 152901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 152904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152906 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 152908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 152912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 152917 */     GIR_RootConstrainSelectedInstOperands,
     /* 152918 */     // GIR_Coverage, 6297,
     /* 152918 */     GIR_EraseRootFromParent_Done,
     /* 152919 */   // Label 3317: @152919
     /* 152919 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(152950), // Rule ID 2143 //
     /* 152924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 152927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 152939 */     // (fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 152939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 152944 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152948 */     GIR_RootConstrainSelectedInstOperands,
     /* 152949 */     // GIR_Coverage, 2143,
     /* 152949 */     GIR_Done,
     /* 152950 */   // Label 3318: @152950
     /* 152950 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(152981), // Rule ID 6293 //
     /* 152955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 152958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 152970 */     // (fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 152970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 152975 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 152979 */     GIR_RootConstrainSelectedInstOperands,
     /* 152980 */     // GIR_Coverage, 6293,
     /* 152980 */     GIR_Done,
     /* 152981 */   // Label 3319: @152981
     /* 152981 */   GIM_Reject,
     /* 152982 */ // Label 3313: @152982
     /* 152982 */ GIM_Reject,
     /* 152983 */ // Label 3219: @152983
     /* 152983 */ GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(153142),
     /* 152988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 152991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 152994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 152998 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(153056), // Rule ID 24272 //
     /* 153003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153031 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153038 */     // (fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153045 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153054 */     GIR_RootConstrainSelectedInstOperands,
     /* 153055 */     // GIR_Coverage, 24272,
     /* 153055 */     GIR_EraseRootFromParent_Done,
     /* 153056 */   // Label 3321: @153056
     /* 153056 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(153114), // Rule ID 6273 //
     /* 153061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153076 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153079 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153083 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153089 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153096 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 153099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153101 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153103 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153112 */     GIR_RootConstrainSelectedInstOperands,
     /* 153113 */     // GIR_Coverage, 6273,
     /* 153113 */     GIR_EraseRootFromParent_Done,
     /* 153114 */   // Label 3322: @153114
     /* 153114 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(153141), // Rule ID 6269 //
     /* 153119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153130 */     // (fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 153130 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 153135 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153139 */     GIR_RootConstrainSelectedInstOperands,
     /* 153140 */     // GIR_Coverage, 6269,
     /* 153140 */     GIR_Done,
     /* 153141 */   // Label 3323: @153141
     /* 153141 */   GIM_Reject,
     /* 153142 */ // Label 3320: @153142
     /* 153142 */ GIM_Reject,
     /* 153143 */ // Label 3220: @153143
     /* 153143 */ GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(153302),
     /* 153148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 153151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 153154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153158 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(153216), // Rule ID 24328 //
     /* 153163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153198 */     // (fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153214 */     GIR_RootConstrainSelectedInstOperands,
     /* 153215 */     // GIR_Coverage, 24328,
     /* 153215 */     GIR_EraseRootFromParent_Done,
     /* 153216 */   // Label 3325: @153216
     /* 153216 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(153274), // Rule ID 6357 //
     /* 153221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153256 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 153259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153263 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153272 */     GIR_RootConstrainSelectedInstOperands,
     /* 153273 */     // GIR_Coverage, 6357,
     /* 153273 */     GIR_EraseRootFromParent_Done,
     /* 153274 */   // Label 3326: @153274
     /* 153274 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(153301), // Rule ID 6353 //
     /* 153279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 153282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 153290 */     // (fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 153290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 153295 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153299 */     GIR_RootConstrainSelectedInstOperands,
     /* 153300 */     // GIR_Coverage, 6353,
     /* 153300 */     GIR_Done,
     /* 153301 */   // Label 3327: @153301
     /* 153301 */   GIM_Reject,
     /* 153302 */ // Label 3324: @153302
     /* 153302 */ GIM_Reject,
     /* 153303 */ // Label 3221: @153303
     /* 153303 */ GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(153462),
     /* 153308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 153311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 153314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153318 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(153376), // Rule ID 24264 //
     /* 153323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153334 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153337 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153341 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153351 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153358 */     // (fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153365 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153374 */     GIR_RootConstrainSelectedInstOperands,
     /* 153375 */     // GIR_Coverage, 24264,
     /* 153375 */     GIR_EraseRootFromParent_Done,
     /* 153376 */   // Label 3329: @153376
     /* 153376 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(153434), // Rule ID 6261 //
     /* 153381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153399 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153403 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153416 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 153419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153421 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153423 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153432 */     GIR_RootConstrainSelectedInstOperands,
     /* 153433 */     // GIR_Coverage, 6261,
     /* 153433 */     GIR_EraseRootFromParent_Done,
     /* 153434 */   // Label 3330: @153434
     /* 153434 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(153461), // Rule ID 6257 //
     /* 153439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 153442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153450 */     // (fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 153450 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 153455 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153459 */     GIR_RootConstrainSelectedInstOperands,
     /* 153460 */     // GIR_Coverage, 6257,
     /* 153460 */     GIR_Done,
     /* 153461 */   // Label 3331: @153461
     /* 153461 */   GIM_Reject,
     /* 153462 */ // Label 3328: @153462
     /* 153462 */ GIM_Reject,
     /* 153463 */ // Label 3222: @153463
     /* 153463 */ GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(153622),
     /* 153468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 153471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 153474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153478 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(153536), // Rule ID 24312 //
     /* 153483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 153490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153511 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153518 */     // (fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153523 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 153525 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153529 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153534 */     GIR_RootConstrainSelectedInstOperands,
     /* 153535 */     // GIR_Coverage, 24312,
     /* 153535 */     GIR_EraseRootFromParent_Done,
     /* 153536 */   // Label 3333: @153536
     /* 153536 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(153594), // Rule ID 6333 //
     /* 153541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153556 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153559 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153563 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153569 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153576 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 153579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153581 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153583 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153592 */     GIR_RootConstrainSelectedInstOperands,
     /* 153593 */     // GIR_Coverage, 6333,
     /* 153593 */     GIR_EraseRootFromParent_Done,
     /* 153594 */   // Label 3334: @153594
     /* 153594 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(153621), // Rule ID 6329 //
     /* 153599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 153610 */     // (fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 153610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 153615 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153619 */     GIR_RootConstrainSelectedInstOperands,
     /* 153620 */     // GIR_Coverage, 6329,
     /* 153620 */     GIR_Done,
     /* 153621 */   // Label 3335: @153621
     /* 153621 */   GIM_Reject,
     /* 153622 */ // Label 3332: @153622
     /* 153622 */ GIM_Reject,
     /* 153623 */ // Label 3223: @153623
     /* 153623 */ GIM_Reject,
     /* 153624 */ // Label 42: @153624
     /* 153624 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3349*/ GIMT_Encode4(157805),
     /* 153635 */ /*GILLT_s16*//*Label 3336*/ GIMT_Encode4(153719),
     /* 153639 */ /*GILLT_s32*//*Label 3337*/ GIMT_Encode4(153817),
     /* 153643 */ /*GILLT_s64*//*Label 3338*/ GIMT_Encode4(154782),
     /* 153647 */ /*GILLT_s80*//*Label 3339*/ GIMT_Encode4(155891), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153659 */ /*GILLT_v2s64*//*Label 3340*/ GIMT_Encode4(156457), GIMT_Encode4(0),
     /* 153667 */ /*GILLT_v4s32*//*Label 3341*/ GIMT_Encode4(156687),
     /* 153671 */ /*GILLT_v4s64*//*Label 3342*/ GIMT_Encode4(156917), GIMT_Encode4(0),
     /* 153679 */ /*GILLT_v8s16*//*Label 3343*/ GIMT_Encode4(157116),
     /* 153683 */ /*GILLT_v8s32*//*Label 3344*/ GIMT_Encode4(157214),
     /* 153687 */ /*GILLT_v8s64*//*Label 3345*/ GIMT_Encode4(157413), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153699 */ /*GILLT_v16s16*//*Label 3346*/ GIMT_Encode4(157511),
     /* 153703 */ /*GILLT_v16s32*//*Label 3347*/ GIMT_Encode4(157609), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 153715 */ /*GILLT_v32s16*//*Label 3348*/ GIMT_Encode4(157707),
     /* 153719 */ // Label 3336: @153719
     /* 153719 */ GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(153816),
     /* 153724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 153727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 153730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153738 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(153792), // Rule ID 6069 //
     /* 153743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 153757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 153761 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 153765 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153767 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153774 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 153777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153779 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153781 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 153790 */     GIR_RootConstrainSelectedInstOperands,
     /* 153791 */     // GIR_Coverage, 6069,
     /* 153791 */     GIR_EraseRootFromParent_Done,
     /* 153792 */   // Label 3351: @153792
     /* 153792 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(153815), // Rule ID 6067 //
     /* 153797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 153800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 153804 */     // (fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 153804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 153809 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 153813 */     GIR_RootConstrainSelectedInstOperands,
     /* 153814 */     // GIR_Coverage, 6067,
     /* 153814 */     GIR_Done,
     /* 153815 */   // Label 3352: @153815
     /* 153815 */   GIM_Reject,
     /* 153816 */ // Label 3350: @153816
     /* 153816 */ GIM_Reject,
     /* 153817 */ // Label 3337: @153817
     /* 153817 */ GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(154781),
     /* 153822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 153825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153828 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(153910), // Rule ID 22473 //
     /* 153833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 153836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153864 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153867 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153871 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153878 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153884 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153891 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 153894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153896 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153908 */     GIR_RootConstrainSelectedInstOperands,
     /* 153909 */     // GIR_Coverage, 22473,
     /* 153909 */     GIR_EraseRootFromParent_Done,
     /* 153910 */   // Label 3354: @153910
     /* 153910 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(153992), // Rule ID 22474 //
     /* 153915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 153918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 153926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 153934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 153938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 153942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 153946 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 153949 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 153953 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153960 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 153964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 153966 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 153973 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 153973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 153976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153978 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 153980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 153984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 153990 */     GIR_RootConstrainSelectedInstOperands,
     /* 153991 */     // GIR_Coverage, 22474,
     /* 153991 */     GIR_EraseRootFromParent_Done,
     /* 153992 */   // Label 3355: @153992
     /* 153992 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(154074), // Rule ID 22475 //
     /* 153997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 154020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154028 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154031 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154035 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154042 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154048 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154055 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154060 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154072 */     GIR_RootConstrainSelectedInstOperands,
     /* 154073 */     // GIR_Coverage, 22475,
     /* 154073 */     GIR_EraseRootFromParent_Done,
     /* 154074 */   // Label 3356: @154074
     /* 154074 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(154139), // Rule ID 965 //
     /* 154079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154094 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154118 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 154121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154123 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154137 */     GIR_RootConstrainSelectedInstOperands,
     /* 154138 */     // GIR_Coverage, 965,
     /* 154138 */     GIR_EraseRootFromParent_Done,
     /* 154139 */   // Label 3357: @154139
     /* 154139 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(154204), // Rule ID 967 //
     /* 154144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154159 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154183 */     // (fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 154186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154202 */     GIR_RootConstrainSelectedInstOperands,
     /* 154203 */     // GIR_Coverage, 967,
     /* 154203 */     GIR_EraseRootFromParent_Done,
     /* 154204 */   // Label 3358: @154204
     /* 154204 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(154269), // Rule ID 955 //
     /* 154209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 154220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154248 */     // (fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 154251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 154255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154267 */     GIR_RootConstrainSelectedInstOperands,
     /* 154268 */     // GIR_Coverage, 955,
     /* 154268 */     GIR_EraseRootFromParent_Done,
     /* 154269 */   // Label 3359: @154269
     /* 154269 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(154334), // Rule ID 943 //
     /* 154274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154293 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154300 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154313 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 154316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154318 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154320 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154332 */     GIR_RootConstrainSelectedInstOperands,
     /* 154333 */     // GIR_Coverage, 943,
     /* 154333 */     GIR_EraseRootFromParent_Done,
     /* 154334 */   // Label 3360: @154334
     /* 154334 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(154399), // Rule ID 945 //
     /* 154339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 154358 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154378 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 154381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154389 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154397 */     GIR_RootConstrainSelectedInstOperands,
     /* 154398 */     // GIR_Coverage, 945,
     /* 154398 */     GIR_EraseRootFromParent_Done,
     /* 154399 */   // Label 3361: @154399
     /* 154399 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(154464), // Rule ID 933 //
     /* 154404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154423 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154430 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154436 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154443 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 154446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154448 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154450 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 154457 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154462 */     GIR_RootConstrainSelectedInstOperands,
     /* 154463 */     // GIR_Coverage, 933,
     /* 154463 */     GIR_EraseRootFromParent_Done,
     /* 154464 */   // Label 3362: @154464
     /* 154464 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(154526), // Rule ID 2241 //
     /* 154469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154488 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154491 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154495 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154501 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154508 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 154511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154513 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154515 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154524 */     GIR_RootConstrainSelectedInstOperands,
     /* 154525 */     // GIR_Coverage, 2241,
     /* 154525 */     GIR_EraseRootFromParent_Done,
     /* 154526 */   // Label 3363: @154526
     /* 154526 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(154588), // Rule ID 2249 //
     /* 154531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154550 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154553 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154557 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154563 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154570 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 154573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154575 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154577 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154586 */     GIR_RootConstrainSelectedInstOperands,
     /* 154587 */     // GIR_Coverage, 2249,
     /* 154587 */     GIR_EraseRootFromParent_Done,
     /* 154588 */   // Label 3364: @154588
     /* 154588 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(154650), // Rule ID 6031 //
     /* 154593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154612 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 154615 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 154619 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 154623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154625 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154632 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 154635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154637 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154639 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 154648 */     GIR_RootConstrainSelectedInstOperands,
     /* 154649 */     // GIR_Coverage, 6031,
     /* 154649 */     GIR_EraseRootFromParent_Done,
     /* 154650 */   // Label 3365: @154650
     /* 154650 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(154687), // Rule ID 893 //
     /* 154655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 154658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 154670 */     // (fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 154670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 154675 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 154681 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 154685 */     GIR_RootConstrainSelectedInstOperands,
     /* 154686 */     // GIR_Coverage, 893,
     /* 154686 */     GIR_Done,
     /* 154687 */   // Label 3366: @154687
     /* 154687 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(154718), // Rule ID 2239 //
     /* 154692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154707 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154707 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 154712 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154716 */     GIR_RootConstrainSelectedInstOperands,
     /* 154717 */     // GIR_Coverage, 2239,
     /* 154717 */     GIR_Done,
     /* 154718 */   // Label 3367: @154718
     /* 154718 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(154749), // Rule ID 2247 //
     /* 154723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 154738 */     // (fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 154738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 154743 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154747 */     GIR_RootConstrainSelectedInstOperands,
     /* 154748 */     // GIR_Coverage, 2247,
     /* 154748 */     GIR_Done,
     /* 154749 */   // Label 3368: @154749
     /* 154749 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(154780), // Rule ID 6029 //
     /* 154754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 154769 */     // (fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 154769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 154774 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 154778 */     GIR_RootConstrainSelectedInstOperands,
     /* 154779 */     // GIR_Coverage, 6029,
     /* 154779 */     GIR_Done,
     /* 154780 */   // Label 3369: @154780
     /* 154780 */   GIM_Reject,
     /* 154781 */ // Label 3353: @154781
     /* 154781 */ GIM_Reject,
     /* 154782 */ // Label 3338: @154782
     /* 154782 */ GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(155890),
     /* 154787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 154790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154793 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(154875), // Rule ID 22476 //
     /* 154798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 154801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154829 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154836 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154843 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154849 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154856 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 154859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154861 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154863 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154873 */     GIR_RootConstrainSelectedInstOperands,
     /* 154874 */     // GIR_Coverage, 22476,
     /* 154874 */     GIR_EraseRootFromParent_Done,
     /* 154875 */   // Label 3371: @154875
     /* 154875 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(154957), // Rule ID 22477 //
     /* 154880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 154883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 154891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154911 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154914 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 154918 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154925 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 154929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154931 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 154938 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 154938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 154941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 154945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 154949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 154955 */     GIR_RootConstrainSelectedInstOperands,
     /* 154956 */     // GIR_Coverage, 22477,
     /* 154956 */     GIR_EraseRootFromParent_Done,
     /* 154957 */   // Label 3372: @154957
     /* 154957 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(155039), // Rule ID 22478 //
     /* 154962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 154965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 154973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 154981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 154985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 154993 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 154996 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 155000 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155007 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 155011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155013 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155020 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 155037 */     GIR_RootConstrainSelectedInstOperands,
     /* 155038 */     // GIR_Coverage, 22478,
     /* 155038 */     GIR_EraseRootFromParent_Done,
     /* 155039 */   // Label 3373: @155039
     /* 155039 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(155104), // Rule ID 969 //
     /* 155044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155059 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155083 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 155086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155094 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155102 */     GIR_RootConstrainSelectedInstOperands,
     /* 155103 */     // GIR_Coverage, 969,
     /* 155103 */     GIR_EraseRootFromParent_Done,
     /* 155104 */   // Label 3374: @155104
     /* 155104 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(155169), // Rule ID 971 //
     /* 155109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155124 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155148 */     // (fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155167 */     GIR_RootConstrainSelectedInstOperands,
     /* 155168 */     // GIR_Coverage, 971,
     /* 155168 */     GIR_EraseRootFromParent_Done,
     /* 155169 */   // Label 3375: @155169
     /* 155169 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(155234), // Rule ID 957 //
     /* 155174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155206 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155213 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 155216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155218 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155220 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155232 */     GIR_RootConstrainSelectedInstOperands,
     /* 155233 */     // GIR_Coverage, 957,
     /* 155233 */     GIR_EraseRootFromParent_Done,
     /* 155234 */   // Label 3376: @155234
     /* 155234 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(155306), // Rule ID 959 //
     /* 155239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155254 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155257 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155261 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155268 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155285 */     // (fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 155288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155290 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155304 */     GIR_RootConstrainSelectedInstOperands,
     /* 155305 */     // GIR_Coverage, 959,
     /* 155305 */     GIR_EraseRootFromParent_Done,
     /* 155306 */   // Label 3377: @155306
     /* 155306 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(155371), // Rule ID 947 //
     /* 155311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155330 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155350 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 155353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155355 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155357 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155369 */     GIR_RootConstrainSelectedInstOperands,
     /* 155370 */     // GIR_Coverage, 947,
     /* 155370 */     GIR_EraseRootFromParent_Done,
     /* 155371 */   // Label 3378: @155371
     /* 155371 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(155436), // Rule ID 949 //
     /* 155376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155395 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155415 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 155418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155434 */     GIR_RootConstrainSelectedInstOperands,
     /* 155435 */     // GIR_Coverage, 949,
     /* 155435 */     GIR_EraseRootFromParent_Done,
     /* 155436 */   // Label 3379: @155436
     /* 155436 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(155501), // Rule ID 935 //
     /* 155441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155480 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 155483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155499 */     GIR_RootConstrainSelectedInstOperands,
     /* 155500 */     // GIR_Coverage, 935,
     /* 155500 */     GIR_EraseRootFromParent_Done,
     /* 155501 */   // Label 3380: @155501
     /* 155501 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(155573), // Rule ID 937 //
     /* 155506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155525 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155528 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155532 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155552 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 155555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155563 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155571 */     GIR_RootConstrainSelectedInstOperands,
     /* 155572 */     // GIR_Coverage, 937,
     /* 155572 */     GIR_EraseRootFromParent_Done,
     /* 155573 */   // Label 3381: @155573
     /* 155573 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(155635), // Rule ID 2245 //
     /* 155578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155597 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155600 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155617 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 155620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155622 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155633 */     GIR_RootConstrainSelectedInstOperands,
     /* 155634 */     // GIR_Coverage, 2245,
     /* 155634 */     GIR_EraseRootFromParent_Done,
     /* 155635 */   // Label 3382: @155635
     /* 155635 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(155697), // Rule ID 2253 //
     /* 155640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155659 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155662 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155666 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155672 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155679 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 155682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155684 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155695 */     GIR_RootConstrainSelectedInstOperands,
     /* 155696 */     // GIR_Coverage, 2253,
     /* 155696 */     GIR_EraseRootFromParent_Done,
     /* 155697 */   // Label 3383: @155697
     /* 155697 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(155759), // Rule ID 6050 //
     /* 155702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 155721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 155724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 155728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155741 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 155744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155746 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 155748 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155757 */     GIR_RootConstrainSelectedInstOperands,
     /* 155758 */     // GIR_Coverage, 6050,
     /* 155758 */     GIR_EraseRootFromParent_Done,
     /* 155759 */   // Label 3384: @155759
     /* 155759 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(155796), // Rule ID 895 //
     /* 155764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 155767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 155779 */     // (fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 155779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 155784 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 155790 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 155794 */     GIR_RootConstrainSelectedInstOperands,
     /* 155795 */     // GIR_Coverage, 895,
     /* 155795 */     GIR_Done,
     /* 155796 */   // Label 3385: @155796
     /* 155796 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(155827), // Rule ID 2243 //
     /* 155801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 155804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155816 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155816 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 155821 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155825 */     GIR_RootConstrainSelectedInstOperands,
     /* 155826 */     // GIR_Coverage, 2243,
     /* 155826 */     GIR_Done,
     /* 155827 */   // Label 3386: @155827
     /* 155827 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(155858), // Rule ID 2251 //
     /* 155832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 155835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 155847 */     // (fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 155847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 155852 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155856 */     GIR_RootConstrainSelectedInstOperands,
     /* 155857 */     // GIR_Coverage, 2251,
     /* 155857 */     GIR_Done,
     /* 155858 */   // Label 3387: @155858
     /* 155858 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(155889), // Rule ID 6048 //
     /* 155863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 155866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 155878 */     // (fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 155878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 155883 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 155887 */     GIR_RootConstrainSelectedInstOperands,
     /* 155888 */     // GIR_Coverage, 6048,
     /* 155888 */     GIR_Done,
     /* 155889 */   // Label 3388: @155889
     /* 155889 */   GIM_Reject,
     /* 155890 */ // Label 3370: @155890
     /* 155890 */ GIM_Reject,
     /* 155891 */ // Label 3339: @155891
     /* 155891 */ GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(156456),
     /* 155896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 155899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 155902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155906 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(155967), // Rule ID 973 //
     /* 155911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155922 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 155946 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 155946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 155949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155951 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 155953 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 155957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 155960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 155965 */     GIR_RootConstrainSelectedInstOperands,
     /* 155966 */     // GIR_Coverage, 973,
     /* 155966 */     GIR_EraseRootFromParent_Done,
     /* 155967 */   // Label 3390: @155967
     /* 155967 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(156028), // Rule ID 975 //
     /* 155972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 155975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 155979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 155983 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155990 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 155994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 155998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156000 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156007 */     // (fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 156010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156012 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156026 */     GIR_RootConstrainSelectedInstOperands,
     /* 156027 */     // GIR_Coverage, 975,
     /* 156027 */     GIR_EraseRootFromParent_Done,
     /* 156028 */   // Label 3391: @156028
     /* 156028 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(156096), // Rule ID 961 //
     /* 156033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156044 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156047 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156051 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156058 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156075 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 156078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156080 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156082 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156094 */     GIR_RootConstrainSelectedInstOperands,
     /* 156095 */     // GIR_Coverage, 961,
     /* 156095 */     GIR_EraseRootFromParent_Done,
     /* 156096 */   // Label 3392: @156096
     /* 156096 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(156164), // Rule ID 963 //
     /* 156101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 156108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156115 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156119 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156126 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156143 */     // (fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 156146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156148 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 156150 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156162 */     GIR_RootConstrainSelectedInstOperands,
     /* 156163 */     // GIR_Coverage, 963,
     /* 156163 */     GIR_EraseRootFromParent_Done,
     /* 156164 */   // Label 3393: @156164
     /* 156164 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(156225), // Rule ID 951 //
     /* 156169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156184 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156191 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156197 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156204 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 156207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156215 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156223 */     GIR_RootConstrainSelectedInstOperands,
     /* 156224 */     // GIR_Coverage, 951,
     /* 156224 */     GIR_EraseRootFromParent_Done,
     /* 156225 */   // Label 3394: @156225
     /* 156225 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(156286), // Rule ID 953 //
     /* 156230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 156245 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156252 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156258 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156265 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 156268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156270 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156272 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156284 */     GIR_RootConstrainSelectedInstOperands,
     /* 156285 */     // GIR_Coverage, 953,
     /* 156285 */     GIR_EraseRootFromParent_Done,
     /* 156286 */   // Label 3395: @156286
     /* 156286 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(156354), // Rule ID 939 //
     /* 156291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156306 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156309 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156313 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156320 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156333 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 156336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156338 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156340 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156352 */     GIR_RootConstrainSelectedInstOperands,
     /* 156353 */     // GIR_Coverage, 939,
     /* 156353 */     GIR_EraseRootFromParent_Done,
     /* 156354 */   // Label 3396: @156354
     /* 156354 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(156422), // Rule ID 941 //
     /* 156359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156377 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156381 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156388 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156401 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 156404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156408 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 156415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 156421 */     // GIR_Coverage, 941,
     /* 156421 */     GIR_EraseRootFromParent_Done,
     /* 156422 */   // Label 3397: @156422
     /* 156422 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(156455), // Rule ID 897 //
     /* 156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 156430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 156438 */     // (fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 156438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 156443 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 156449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 156453 */     GIR_RootConstrainSelectedInstOperands,
     /* 156454 */     // GIR_Coverage, 897,
     /* 156454 */     GIR_Done,
     /* 156455 */   // Label 3398: @156455
     /* 156455 */   GIM_Reject,
     /* 156456 */ // Label 3389: @156456
     /* 156456 */ GIM_Reject,
     /* 156457 */ // Label 3340: @156457
     /* 156457 */ GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(156686),
     /* 156462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 156468 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(156530), // Rule ID 2221 //
     /* 156473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156512 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 156515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156528 */     GIR_RootConstrainSelectedInstOperands,
     /* 156529 */     // GIR_Coverage, 2221,
     /* 156529 */     GIR_EraseRootFromParent_Done,
     /* 156530 */   // Label 3400: @156530
     /* 156530 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(156592), // Rule ID 6543 //
     /* 156535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156567 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156574 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 156577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156579 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156581 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156585 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156590 */     GIR_RootConstrainSelectedInstOperands,
     /* 156591 */     // GIR_Coverage, 6543,
     /* 156591 */     GIR_EraseRootFromParent_Done,
     /* 156592 */   // Label 3401: @156592
     /* 156592 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(156623), // Rule ID 2219 //
     /* 156597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156612 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 156617 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156621 */     GIR_RootConstrainSelectedInstOperands,
     /* 156622 */     // GIR_Coverage, 2219,
     /* 156622 */     GIR_Done,
     /* 156623 */   // Label 3402: @156623
     /* 156623 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(156654), // Rule ID 2235 //
     /* 156628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 156631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156643 */     // (fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 156643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 156648 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156652 */     GIR_RootConstrainSelectedInstOperands,
     /* 156653 */     // GIR_Coverage, 2235,
     /* 156653 */     GIR_Done,
     /* 156654 */   // Label 3403: @156654
     /* 156654 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(156685), // Rule ID 6539 //
     /* 156659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156674 */     // (fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 156674 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 156679 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156683 */     GIR_RootConstrainSelectedInstOperands,
     /* 156684 */     // GIR_Coverage, 6539,
     /* 156684 */     GIR_Done,
     /* 156685 */   // Label 3404: @156685
     /* 156685 */   GIM_Reject,
     /* 156686 */ // Label 3399: @156686
     /* 156686 */ GIM_Reject,
     /* 156687 */ // Label 3341: @156687
     /* 156687 */ GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(156916),
     /* 156692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156698 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(156760), // Rule ID 2217 //
     /* 156703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156725 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156729 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156742 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 156745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156747 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156758 */     GIR_RootConstrainSelectedInstOperands,
     /* 156759 */     // GIR_Coverage, 2217,
     /* 156759 */     GIR_EraseRootFromParent_Done,
     /* 156760 */   // Label 3406: @156760
     /* 156760 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(156822), // Rule ID 6519 //
     /* 156765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156804 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 156807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156820 */     GIR_RootConstrainSelectedInstOperands,
     /* 156821 */     // GIR_Coverage, 6519,
     /* 156821 */     GIR_EraseRootFromParent_Done,
     /* 156822 */   // Label 3407: @156822
     /* 156822 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(156853), // Rule ID 2215 //
     /* 156827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156842 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 156847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156851 */     GIR_RootConstrainSelectedInstOperands,
     /* 156852 */     // GIR_Coverage, 2215,
     /* 156852 */     GIR_Done,
     /* 156853 */   // Label 3408: @156853
     /* 156853 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(156884), // Rule ID 2231 //
     /* 156858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 156861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 156873 */     // (fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 156873 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 156878 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156882 */     GIR_RootConstrainSelectedInstOperands,
     /* 156883 */     // GIR_Coverage, 2231,
     /* 156883 */     GIR_Done,
     /* 156884 */   // Label 3409: @156884
     /* 156884 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(156915), // Rule ID 6515 //
     /* 156889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 156904 */     // (fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 156904 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 156909 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 156913 */     GIR_RootConstrainSelectedInstOperands,
     /* 156914 */     // GIR_Coverage, 6515,
     /* 156914 */     GIR_Done,
     /* 156915 */   // Label 3410: @156915
     /* 156915 */   GIM_Reject,
     /* 156916 */ // Label 3405: @156916
     /* 156916 */ GIM_Reject,
     /* 156917 */ // Label 3342: @156917
     /* 156917 */ GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(157115),
     /* 156922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 156925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 156928 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(156990), // Rule ID 2229 //
     /* 156933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 156936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 156944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 156952 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 156955 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 156959 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 156963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 156965 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 156972 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 156972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 156975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156977 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 156979 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 156983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 156988 */     GIR_RootConstrainSelectedInstOperands,
     /* 156989 */     // GIR_Coverage, 2229,
     /* 156989 */     GIR_EraseRootFromParent_Done,
     /* 156990 */   // Label 3412: @156990
     /* 156990 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(157052), // Rule ID 6555 //
     /* 156995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 156998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157034 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 157037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157050 */     GIR_RootConstrainSelectedInstOperands,
     /* 157051 */     // GIR_Coverage, 6555,
     /* 157051 */     GIR_EraseRootFromParent_Done,
     /* 157052 */   // Label 3413: @157052
     /* 157052 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(157083), // Rule ID 2227 //
     /* 157057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157072 */     // (fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 157072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 157077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157081 */     GIR_RootConstrainSelectedInstOperands,
     /* 157082 */     // GIR_Coverage, 2227,
     /* 157082 */     GIR_Done,
     /* 157083 */   // Label 3414: @157083
     /* 157083 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(157114), // Rule ID 6551 //
     /* 157088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157103 */     // (fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 157103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 157108 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157112 */     GIR_RootConstrainSelectedInstOperands,
     /* 157113 */     // GIR_Coverage, 6551,
     /* 157113 */     GIR_Done,
     /* 157114 */   // Label 3415: @157114
     /* 157114 */   GIM_Reject,
     /* 157115 */ // Label 3411: @157115
     /* 157115 */ GIM_Reject,
     /* 157116 */ // Label 3343: @157116
     /* 157116 */ GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(157213),
     /* 157121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 157127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157135 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(157189), // Rule ID 6579 //
     /* 157140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157151 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157154 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157158 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157164 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157171 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 157174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157176 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157178 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157187 */     GIR_RootConstrainSelectedInstOperands,
     /* 157188 */     // GIR_Coverage, 6579,
     /* 157188 */     GIR_EraseRootFromParent_Done,
     /* 157189 */   // Label 3417: @157189
     /* 157189 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(157212), // Rule ID 6575 //
     /* 157194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 157201 */     // (fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 157201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 157206 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157210 */     GIR_RootConstrainSelectedInstOperands,
     /* 157211 */     // GIR_Coverage, 6575,
     /* 157211 */     GIR_Done,
     /* 157212 */   // Label 3418: @157212
     /* 157212 */   GIM_Reject,
     /* 157213 */ // Label 3416: @157213
     /* 157213 */ GIM_Reject,
     /* 157214 */ // Label 3344: @157214
     /* 157214 */ GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(157412),
     /* 157219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 157222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 157225 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(157287), // Rule ID 2225 //
     /* 157230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157269 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 157272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157285 */     GIR_RootConstrainSelectedInstOperands,
     /* 157286 */     // GIR_Coverage, 2225,
     /* 157286 */     GIR_EraseRootFromParent_Done,
     /* 157287 */   // Label 3420: @157287
     /* 157287 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(157349), // Rule ID 6531 //
     /* 157292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157331 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 157334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157336 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157338 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157347 */     GIR_RootConstrainSelectedInstOperands,
     /* 157348 */     // GIR_Coverage, 6531,
     /* 157348 */     GIR_EraseRootFromParent_Done,
     /* 157349 */   // Label 3421: @157349
     /* 157349 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(157380), // Rule ID 2223 //
     /* 157354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 157357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 157369 */     // (fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 157369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 157374 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157378 */     GIR_RootConstrainSelectedInstOperands,
     /* 157379 */     // GIR_Coverage, 2223,
     /* 157379 */     GIR_Done,
     /* 157380 */   // Label 3422: @157380
     /* 157380 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(157411), // Rule ID 6527 //
     /* 157385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 157388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157400 */     // (fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 157400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 157405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157409 */     GIR_RootConstrainSelectedInstOperands,
     /* 157410 */     // GIR_Coverage, 6527,
     /* 157410 */     GIR_Done,
     /* 157411 */   // Label 3423: @157411
     /* 157411 */   GIM_Reject,
     /* 157412 */ // Label 3419: @157412
     /* 157412 */ GIM_Reject,
     /* 157413 */ // Label 3345: @157413
     /* 157413 */ GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(157510),
     /* 157418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 157421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 157424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157432 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(157486), // Rule ID 6507 //
     /* 157437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157461 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157468 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 157471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157473 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157475 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157484 */     GIR_RootConstrainSelectedInstOperands,
     /* 157485 */     // GIR_Coverage, 6507,
     /* 157485 */     GIR_EraseRootFromParent_Done,
     /* 157486 */   // Label 3425: @157486
     /* 157486 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(157509), // Rule ID 6503 //
     /* 157491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157498 */     // (fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 157498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 157503 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157507 */     GIR_RootConstrainSelectedInstOperands,
     /* 157508 */     // GIR_Coverage, 6503,
     /* 157508 */     GIR_Done,
     /* 157509 */   // Label 3426: @157509
     /* 157509 */   GIM_Reject,
     /* 157510 */ // Label 3424: @157510
     /* 157510 */ GIM_Reject,
     /* 157511 */ // Label 3346: @157511
     /* 157511 */ GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(157608),
     /* 157516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 157519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 157522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157530 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(157584), // Rule ID 6591 //
     /* 157535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157546 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157549 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157553 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157559 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157566 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 157569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157571 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157573 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157582 */     GIR_RootConstrainSelectedInstOperands,
     /* 157583 */     // GIR_Coverage, 6591,
     /* 157583 */     GIR_EraseRootFromParent_Done,
     /* 157584 */   // Label 3428: @157584
     /* 157584 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(157607), // Rule ID 6587 //
     /* 157589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 157596 */     // (fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 157596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 157601 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157605 */     GIR_RootConstrainSelectedInstOperands,
     /* 157606 */     // GIR_Coverage, 6587,
     /* 157606 */     GIR_Done,
     /* 157607 */   // Label 3429: @157607
     /* 157607 */   GIM_Reject,
     /* 157608 */ // Label 3427: @157608
     /* 157608 */ GIM_Reject,
     /* 157609 */ // Label 3347: @157609
     /* 157609 */ GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(157706),
     /* 157614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 157617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 157620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157628 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(157682), // Rule ID 6495 //
     /* 157633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157664 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 157667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157680 */     GIR_RootConstrainSelectedInstOperands,
     /* 157681 */     // GIR_Coverage, 6495,
     /* 157681 */     GIR_EraseRootFromParent_Done,
     /* 157682 */   // Label 3431: @157682
     /* 157682 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(157705), // Rule ID 6491 //
     /* 157687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 157690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157694 */     // (fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 157694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 157699 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157703 */     GIR_RootConstrainSelectedInstOperands,
     /* 157704 */     // GIR_Coverage, 6491,
     /* 157704 */     GIR_Done,
     /* 157705 */   // Label 3432: @157705
     /* 157705 */   GIM_Reject,
     /* 157706 */ // Label 3430: @157706
     /* 157706 */ GIM_Reject,
     /* 157707 */ // Label 3348: @157707
     /* 157707 */ GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(157804),
     /* 157712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 157715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 157718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157726 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(157780), // Rule ID 6567 //
     /* 157731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157742 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157749 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157762 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 157765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157767 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 157769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157778 */     GIR_RootConstrainSelectedInstOperands,
     /* 157779 */     // GIR_Coverage, 6567,
     /* 157779 */     GIR_EraseRootFromParent_Done,
     /* 157780 */   // Label 3434: @157780
     /* 157780 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(157803), // Rule ID 6563 //
     /* 157785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 157792 */     // (fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 157792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 157797 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 157801 */     GIR_RootConstrainSelectedInstOperands,
     /* 157802 */     // GIR_Coverage, 6563,
     /* 157802 */     GIR_Done,
     /* 157803 */   // Label 3435: @157803
     /* 157803 */   GIM_Reject,
     /* 157804 */ // Label 3433: @157804
     /* 157804 */ GIM_Reject,
     /* 157805 */ // Label 3349: @157805
     /* 157805 */ GIM_Reject,
     /* 157806 */ // Label 43: @157806
     /* 157806 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3449*/ GIMT_Encode4(163719),
     /* 157817 */ /*GILLT_s16*//*Label 3436*/ GIMT_Encode4(157901),
     /* 157821 */ /*GILLT_s32*//*Label 3437*/ GIMT_Encode4(158061),
     /* 157825 */ /*GILLT_s64*//*Label 3438*/ GIMT_Encode4(159458),
     /* 157829 */ /*GILLT_s80*//*Label 3439*/ GIMT_Encode4(160999), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157841 */ /*GILLT_v2s64*//*Label 3440*/ GIMT_Encode4(161565), GIMT_Encode4(0),
     /* 157849 */ /*GILLT_v4s32*//*Label 3441*/ GIMT_Encode4(161919),
     /* 157853 */ /*GILLT_v4s64*//*Label 3442*/ GIMT_Encode4(162273), GIMT_Encode4(0),
     /* 157861 */ /*GILLT_v8s16*//*Label 3443*/ GIMT_Encode4(162596),
     /* 157865 */ /*GILLT_v8s32*//*Label 3444*/ GIMT_Encode4(162756),
     /* 157869 */ /*GILLT_v8s64*//*Label 3445*/ GIMT_Encode4(163079), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157881 */ /*GILLT_v16s16*//*Label 3446*/ GIMT_Encode4(163239),
     /* 157885 */ /*GILLT_v16s32*//*Label 3447*/ GIMT_Encode4(163399), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 157897 */ /*GILLT_v32s16*//*Label 3448*/ GIMT_Encode4(163559),
     /* 157901 */ // Label 3436: @157901
     /* 157901 */ GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(158060),
     /* 157906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 157909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157916 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(157974), // Rule ID 24256 //
     /* 157921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 157928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157932 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157935 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 157939 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 157943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 157949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 157956 */     // (fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 157956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 157959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157961 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 157963 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 157967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 157972 */     GIR_RootConstrainSelectedInstOperands,
     /* 157973 */     // GIR_Coverage, 24256,
     /* 157973 */     GIR_EraseRootFromParent_Done,
     /* 157974 */   // Label 3451: @157974
     /* 157974 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(158032), // Rule ID 6012 //
     /* 157979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 157982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 157986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 157990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 157994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 157997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158014 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 158017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158019 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158021 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158030 */     GIR_RootConstrainSelectedInstOperands,
     /* 158031 */     // GIR_Coverage, 6012,
     /* 158031 */     GIR_EraseRootFromParent_Done,
     /* 158032 */   // Label 3452: @158032
     /* 158032 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(158059), // Rule ID 6010 //
     /* 158037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 158040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 158048 */     // (fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 158048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 158053 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 158057 */     GIR_RootConstrainSelectedInstOperands,
     /* 158058 */     // GIR_Coverage, 6010,
     /* 158058 */     GIR_Done,
     /* 158059 */   // Label 3453: @158059
     /* 158059 */   GIM_Reject,
     /* 158060 */ // Label 3450: @158060
     /* 158060 */ GIM_Reject,
     /* 158061 */ // Label 3437: @158061
     /* 158061 */ GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(159457),
     /* 158066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 158069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158072 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(158154), // Rule ID 26024 //
     /* 158077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158104 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158107 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158111 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158118 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158135 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158152 */     GIR_RootConstrainSelectedInstOperands,
     /* 158153 */     // GIR_Coverage, 26024,
     /* 158153 */     GIR_EraseRootFromParent_Done,
     /* 158154 */   // Label 3455: @158154
     /* 158154 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(158236), // Rule ID 26025 //
     /* 158159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158186 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158193 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158200 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158210 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158217 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158222 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158224 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158234 */     GIR_RootConstrainSelectedInstOperands,
     /* 158235 */     // GIR_Coverage, 26025,
     /* 158235 */     GIR_EraseRootFromParent_Done,
     /* 158236 */   // Label 3456: @158236
     /* 158236 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(158318), // Rule ID 26026 //
     /* 158241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158268 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158275 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158282 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158299 */     // (fmul:{ *:[f32] } (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>), FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158304 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158306 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158316 */     GIR_RootConstrainSelectedInstOperands,
     /* 158317 */     // GIR_Coverage, 26026,
     /* 158317 */     GIR_EraseRootFromParent_Done,
     /* 158318 */   // Label 3457: @158318
     /* 158318 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(158400), // Rule ID 22479 //
     /* 158323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158354 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158361 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158368 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158374 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158381 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158386 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158388 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158398 */     GIR_RootConstrainSelectedInstOperands,
     /* 158399 */     // GIR_Coverage, 22479,
     /* 158399 */     GIR_EraseRootFromParent_Done,
     /* 158400 */   // Label 3458: @158400
     /* 158400 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(158482), // Rule ID 22480 //
     /* 158405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158436 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158443 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158456 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158463 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158470 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158480 */     GIR_RootConstrainSelectedInstOperands,
     /* 158481 */     // GIR_Coverage, 22480,
     /* 158481 */     GIR_EraseRootFromParent_Done,
     /* 158482 */   // Label 3459: @158482
     /* 158482 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(158564), // Rule ID 22481 //
     /* 158487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 158506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158518 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 158521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 158525 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158532 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 158536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158538 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158545 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158550 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158552 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 158562 */     GIR_RootConstrainSelectedInstOperands,
     /* 158563 */     // GIR_Coverage, 22481,
     /* 158563 */     GIR_EraseRootFromParent_Done,
     /* 158564 */   // Label 3460: @158564
     /* 158564 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(158629), // Rule ID 23269 //
     /* 158569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158584 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158608 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158613 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158627 */     GIR_RootConstrainSelectedInstOperands,
     /* 158628 */     // GIR_Coverage, 23269,
     /* 158628 */     GIR_EraseRootFromParent_Done,
     /* 158629 */   // Label 3461: @158629
     /* 158629 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(158694), // Rule ID 23271 //
     /* 158634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158649 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158673 */     // (fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 158676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158678 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158680 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158692 */     GIR_RootConstrainSelectedInstOperands,
     /* 158693 */     // GIR_Coverage, 23271,
     /* 158693 */     GIR_EraseRootFromParent_Done,
     /* 158694 */   // Label 3462: @158694
     /* 158694 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(158759), // Rule ID 23259 //
     /* 158699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158731 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158738 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 158741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158745 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 158752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158757 */     GIR_RootConstrainSelectedInstOperands,
     /* 158758 */     // GIR_Coverage, 23259,
     /* 158758 */     GIR_EraseRootFromParent_Done,
     /* 158759 */   // Label 3463: @158759
     /* 158759 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(158821), // Rule ID 23402 //
     /* 158764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 158767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158803 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 158806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158808 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158819 */     GIR_RootConstrainSelectedInstOperands,
     /* 158820 */     // GIR_Coverage, 23402,
     /* 158820 */     GIR_EraseRootFromParent_Done,
     /* 158821 */   // Label 3464: @158821
     /* 158821 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(158883), // Rule ID 23406 //
     /* 158826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 158829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 158856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158865 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 158868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158870 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158881 */     GIR_RootConstrainSelectedInstOperands,
     /* 158882 */     // GIR_Coverage, 23406,
     /* 158882 */     GIR_EraseRootFromParent_Done,
     /* 158883 */   // Label 3465: @158883
     /* 158883 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(158945), // Rule ID 24252 //
     /* 158888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 158891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 158899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 158903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 158906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 158910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 158918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158927 */     // (fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 158930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 158934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 158938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 158943 */     GIR_RootConstrainSelectedInstOperands,
     /* 158944 */     // GIR_Coverage, 24252,
     /* 158944 */     GIR_EraseRootFromParent_Done,
     /* 158945 */   // Label 3466: @158945
     /* 158945 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(159010), // Rule ID 987 //
     /* 158950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 158953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 158961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 158969 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158976 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 158980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158982 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 158989 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 158989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 158992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158994 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 158996 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159008 */     GIR_RootConstrainSelectedInstOperands,
     /* 159009 */     // GIR_Coverage, 987,
     /* 159009 */     GIR_EraseRootFromParent_Done,
     /* 159010 */   // Label 3467: @159010
     /* 159010 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(159075), // Rule ID 989 //
     /* 159015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159034 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159054 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 159057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159059 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159073 */     GIR_RootConstrainSelectedInstOperands,
     /* 159074 */     // GIR_Coverage, 989,
     /* 159074 */     GIR_EraseRootFromParent_Done,
     /* 159075 */   // Label 3468: @159075
     /* 159075 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(159140), // Rule ID 977 //
     /* 159080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159119 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 159122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 159133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159138 */     GIR_RootConstrainSelectedInstOperands,
     /* 159139 */     // GIR_Coverage, 977,
     /* 159139 */     GIR_EraseRootFromParent_Done,
     /* 159140 */   // Label 3469: @159140
     /* 159140 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(159202), // Rule ID 2201 //
     /* 159145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159164 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159171 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159184 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 159187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159189 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159200 */     GIR_RootConstrainSelectedInstOperands,
     /* 159201 */     // GIR_Coverage, 2201,
     /* 159201 */     GIR_EraseRootFromParent_Done,
     /* 159202 */   // Label 3470: @159202
     /* 159202 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(159264), // Rule ID 2209 //
     /* 159207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159226 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159229 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159233 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159246 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 159249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159251 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159253 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159262 */     GIR_RootConstrainSelectedInstOperands,
     /* 159263 */     // GIR_Coverage, 2209,
     /* 159263 */     GIR_EraseRootFromParent_Done,
     /* 159264 */   // Label 3471: @159264
     /* 159264 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(159326), // Rule ID 5974 //
     /* 159269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159288 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 159291 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 159295 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159301 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159308 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 159311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159313 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 159324 */     GIR_RootConstrainSelectedInstOperands,
     /* 159325 */     // GIR_Coverage, 5974,
     /* 159325 */     GIR_EraseRootFromParent_Done,
     /* 159326 */   // Label 3472: @159326
     /* 159326 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(159363), // Rule ID 899 //
     /* 159331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 159334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 159346 */     // (fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 159346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 159351 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 159357 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 159361 */     GIR_RootConstrainSelectedInstOperands,
     /* 159362 */     // GIR_Coverage, 899,
     /* 159362 */     GIR_Done,
     /* 159363 */   // Label 3473: @159363
     /* 159363 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(159394), // Rule ID 2199 //
     /* 159368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159383 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 159388 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159392 */     GIR_RootConstrainSelectedInstOperands,
     /* 159393 */     // GIR_Coverage, 2199,
     /* 159393 */     GIR_Done,
     /* 159394 */   // Label 3474: @159394
     /* 159394 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(159425), // Rule ID 2207 //
     /* 159399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 159414 */     // (fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 159414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 159419 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159423 */     GIR_RootConstrainSelectedInstOperands,
     /* 159424 */     // GIR_Coverage, 2207,
     /* 159424 */     GIR_Done,
     /* 159425 */   // Label 3475: @159425
     /* 159425 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(159456), // Rule ID 5972 //
     /* 159430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 159445 */     // (fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 159445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 159450 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 159454 */     GIR_RootConstrainSelectedInstOperands,
     /* 159455 */     // GIR_Coverage, 5972,
     /* 159455 */     GIR_Done,
     /* 159456 */   // Label 3476: @159456
     /* 159456 */   GIM_Reject,
     /* 159457 */ // Label 3454: @159457
     /* 159457 */ GIM_Reject,
     /* 159458 */ // Label 3438: @159458
     /* 159458 */ GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(160998),
     /* 159463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 159466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159469 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(159551), // Rule ID 26027 //
     /* 159474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159501 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159504 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159508 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159515 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159532 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159537 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159549 */     GIR_RootConstrainSelectedInstOperands,
     /* 159550 */     // GIR_Coverage, 26027,
     /* 159550 */     GIR_EraseRootFromParent_Done,
     /* 159551 */   // Label 3478: @159551
     /* 159551 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(159633), // Rule ID 26028 //
     /* 159556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159583 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159586 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159590 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159597 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159607 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159614 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159631 */     GIR_RootConstrainSelectedInstOperands,
     /* 159632 */     // GIR_Coverage, 26028,
     /* 159632 */     GIR_EraseRootFromParent_Done,
     /* 159633 */   // Label 3479: @159633
     /* 159633 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(159715), // Rule ID 26029 //
     /* 159638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159665 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159668 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159672 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159696 */     // (fmul:{ *:[f64] } (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>), FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 159703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159713 */     GIR_RootConstrainSelectedInstOperands,
     /* 159714 */     // GIR_Coverage, 26029,
     /* 159714 */     GIR_EraseRootFromParent_Done,
     /* 159715 */   // Label 3480: @159715
     /* 159715 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(159797), // Rule ID 22482 //
     /* 159720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 159723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159751 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159754 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159758 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159765 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159778 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 159781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159783 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159795 */     GIR_RootConstrainSelectedInstOperands,
     /* 159796 */     // GIR_Coverage, 22482,
     /* 159796 */     GIR_EraseRootFromParent_Done,
     /* 159797 */   // Label 3481: @159797
     /* 159797 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(159879), // Rule ID 22483 //
     /* 159802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 159805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 159813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159833 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159840 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159847 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159853 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159860 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 159863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159865 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159877 */     GIR_RootConstrainSelectedInstOperands,
     /* 159878 */     // GIR_Coverage, 22483,
     /* 159878 */     GIR_EraseRootFromParent_Done,
     /* 159879 */   // Label 3482: @159879
     /* 159879 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(159961), // Rule ID 22484 //
     /* 159884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 159887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 159895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 159903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 159907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 159911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 159915 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 159918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 159922 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159929 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 159933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159935 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 159942 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 159942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 159945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159947 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 159949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 159953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 159959 */     GIR_RootConstrainSelectedInstOperands,
     /* 159960 */     // GIR_Coverage, 22484,
     /* 159960 */     GIR_EraseRootFromParent_Done,
     /* 159961 */   // Label 3483: @159961
     /* 159961 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(160026), // Rule ID 23273 //
     /* 159966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 159969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 159977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 159981 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159988 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 159992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 159996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160005 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 160008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160016 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160024 */     GIR_RootConstrainSelectedInstOperands,
     /* 160025 */     // GIR_Coverage, 23273,
     /* 160025 */     GIR_EraseRootFromParent_Done,
     /* 160026 */   // Label 3484: @160026
     /* 160026 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(160091), // Rule ID 23275 //
     /* 160031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160046 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160053 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160070 */     // (fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160089 */     GIR_RootConstrainSelectedInstOperands,
     /* 160090 */     // GIR_Coverage, 23275,
     /* 160090 */     GIR_EraseRootFromParent_Done,
     /* 160091 */   // Label 3485: @160091
     /* 160091 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(160156), // Rule ID 23261 //
     /* 160096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160111 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160118 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160135 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160140 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160154 */     GIR_RootConstrainSelectedInstOperands,
     /* 160155 */     // GIR_Coverage, 23261,
     /* 160155 */     GIR_EraseRootFromParent_Done,
     /* 160156 */   // Label 3486: @160156
     /* 160156 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(160228), // Rule ID 23263 //
     /* 160161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160176 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160179 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160183 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160190 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160207 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160212 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160226 */     GIR_RootConstrainSelectedInstOperands,
     /* 160227 */     // GIR_Coverage, 23263,
     /* 160227 */     GIR_EraseRootFromParent_Done,
     /* 160228 */   // Label 3487: @160228
     /* 160228 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(160290), // Rule ID 23404 //
     /* 160233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160248 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160251 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160255 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160272 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160277 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160288 */     GIR_RootConstrainSelectedInstOperands,
     /* 160289 */     // GIR_Coverage, 23404,
     /* 160289 */     GIR_EraseRootFromParent_Done,
     /* 160290 */   // Label 3488: @160290
     /* 160290 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(160352), // Rule ID 23408 //
     /* 160295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160310 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160313 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160317 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160327 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160334 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160339 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160345 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160350 */     GIR_RootConstrainSelectedInstOperands,
     /* 160351 */     // GIR_Coverage, 23408,
     /* 160351 */     GIR_EraseRootFromParent_Done,
     /* 160352 */   // Label 3489: @160352
     /* 160352 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(160414), // Rule ID 24254 //
     /* 160357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 160368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160372 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160375 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160379 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160396 */     // (fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160401 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 160403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160412 */     GIR_RootConstrainSelectedInstOperands,
     /* 160413 */     // GIR_Coverage, 24254,
     /* 160413 */     GIR_EraseRootFromParent_Done,
     /* 160414 */   // Label 3490: @160414
     /* 160414 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(160479), // Rule ID 991 //
     /* 160419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160438 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 160445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160458 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 160461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160463 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160477 */     GIR_RootConstrainSelectedInstOperands,
     /* 160478 */     // GIR_Coverage, 991,
     /* 160478 */     GIR_EraseRootFromParent_Done,
     /* 160479 */   // Label 3491: @160479
     /* 160479 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(160544), // Rule ID 993 //
     /* 160484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 160503 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160510 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160523 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 160526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160530 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160534 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160542 */     GIR_RootConstrainSelectedInstOperands,
     /* 160543 */     // GIR_Coverage, 993,
     /* 160543 */     GIR_EraseRootFromParent_Done,
     /* 160544 */   // Label 3492: @160544
     /* 160544 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(160609), // Rule ID 979 //
     /* 160549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160588 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 160591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160595 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160607 */     GIR_RootConstrainSelectedInstOperands,
     /* 160608 */     // GIR_Coverage, 979,
     /* 160608 */     GIR_EraseRootFromParent_Done,
     /* 160609 */   // Label 3493: @160609
     /* 160609 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(160681), // Rule ID 981 //
     /* 160614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160633 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160636 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160640 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160647 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160653 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160660 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 160663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160667 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 160674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160679 */     GIR_RootConstrainSelectedInstOperands,
     /* 160680 */     // GIR_Coverage, 981,
     /* 160680 */     GIR_EraseRootFromParent_Done,
     /* 160681 */   // Label 3494: @160681
     /* 160681 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(160743), // Rule ID 2205 //
     /* 160686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160725 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 160728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160741 */     GIR_RootConstrainSelectedInstOperands,
     /* 160742 */     // GIR_Coverage, 2205,
     /* 160742 */     GIR_EraseRootFromParent_Done,
     /* 160743 */   // Label 3495: @160743
     /* 160743 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(160805), // Rule ID 2213 //
     /* 160748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160767 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160770 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160774 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160787 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 160790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160792 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160803 */     GIR_RootConstrainSelectedInstOperands,
     /* 160804 */     // GIR_Coverage, 2213,
     /* 160804 */     GIR_EraseRootFromParent_Done,
     /* 160805 */   // Label 3496: @160805
     /* 160805 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(160867), // Rule ID 5993 //
     /* 160810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 160829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 160832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 160836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 160840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 160849 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 160849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 160852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 160856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 160860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 160865 */     GIR_RootConstrainSelectedInstOperands,
     /* 160866 */     // GIR_Coverage, 5993,
     /* 160866 */     GIR_EraseRootFromParent_Done,
     /* 160867 */   // Label 3497: @160867
     /* 160867 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(160904), // Rule ID 901 //
     /* 160872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 160875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 160887 */     // (fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 160887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 160892 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 160898 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 160902 */     GIR_RootConstrainSelectedInstOperands,
     /* 160903 */     // GIR_Coverage, 901,
     /* 160903 */     GIR_Done,
     /* 160904 */   // Label 3498: @160904
     /* 160904 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(160935), // Rule ID 2203 //
     /* 160909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 160912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160924 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 160929 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160933 */     GIR_RootConstrainSelectedInstOperands,
     /* 160934 */     // GIR_Coverage, 2203,
     /* 160934 */     GIR_Done,
     /* 160935 */   // Label 3499: @160935
     /* 160935 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(160966), // Rule ID 2211 //
     /* 160940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 160943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 160955 */     // (fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 160955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 160960 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160964 */     GIR_RootConstrainSelectedInstOperands,
     /* 160965 */     // GIR_Coverage, 2211,
     /* 160965 */     GIR_Done,
     /* 160966 */   // Label 3500: @160966
     /* 160966 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(160997), // Rule ID 5991 //
     /* 160971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 160974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 160986 */     // (fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 160986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 160991 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 160995 */     GIR_RootConstrainSelectedInstOperands,
     /* 160996 */     // GIR_Coverage, 5991,
     /* 160996 */     GIR_Done,
     /* 160997 */   // Label 3501: @160997
     /* 160997 */   GIM_Reject,
     /* 160998 */ // Label 3477: @160998
     /* 160998 */ GIM_Reject,
     /* 160999 */ // Label 3439: @160999
     /* 160999 */ GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(161564),
     /* 161004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 161007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 161010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161014 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(161075), // Rule ID 23277 //
     /* 161019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161030 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161054 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161059 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161073 */     GIR_RootConstrainSelectedInstOperands,
     /* 161074 */     // GIR_Coverage, 23277,
     /* 161074 */     GIR_EraseRootFromParent_Done,
     /* 161075 */   // Label 3503: @161075
     /* 161075 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(161136), // Rule ID 23279 //
     /* 161080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161091 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161115 */     // (fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161134 */     GIR_RootConstrainSelectedInstOperands,
     /* 161135 */     // GIR_Coverage, 23279,
     /* 161135 */     GIR_EraseRootFromParent_Done,
     /* 161136 */   // Label 3504: @161136
     /* 161136 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(161204), // Rule ID 23265 //
     /* 161141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161155 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161159 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161176 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161183 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161188 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161190 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161194 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161202 */     GIR_RootConstrainSelectedInstOperands,
     /* 161203 */     // GIR_Coverage, 23265,
     /* 161203 */     GIR_EraseRootFromParent_Done,
     /* 161204 */   // Label 3505: @161204
     /* 161204 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(161272), // Rule ID 23267 //
     /* 161209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161220 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161223 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161227 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161251 */     // (fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161256 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161258 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161270 */     GIR_RootConstrainSelectedInstOperands,
     /* 161271 */     // GIR_Coverage, 23267,
     /* 161271 */     GIR_EraseRootFromParent_Done,
     /* 161272 */   // Label 3506: @161272
     /* 161272 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(161333), // Rule ID 995 //
     /* 161277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161292 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 161299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161312 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 161315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161317 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161319 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161331 */     GIR_RootConstrainSelectedInstOperands,
     /* 161332 */     // GIR_Coverage, 995,
     /* 161332 */     GIR_EraseRootFromParent_Done,
     /* 161333 */   // Label 3507: @161333
     /* 161333 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(161394), // Rule ID 997 //
     /* 161338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 161353 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161373 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 161376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161392 */     GIR_RootConstrainSelectedInstOperands,
     /* 161393 */     // GIR_Coverage, 997,
     /* 161393 */     GIR_EraseRootFromParent_Done,
     /* 161394 */   // Label 3508: @161394
     /* 161394 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(161462), // Rule ID 983 //
     /* 161399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161414 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161417 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161421 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 161428 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161441 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 161444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161446 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161460 */     GIR_RootConstrainSelectedInstOperands,
     /* 161461 */     // GIR_Coverage, 983,
     /* 161461 */     GIR_EraseRootFromParent_Done,
     /* 161462 */   // Label 3509: @161462
     /* 161462 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(161530), // Rule ID 985 //
     /* 161467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161485 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161489 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 161496 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161509 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 161512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161514 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161516 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161520 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 161523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161528 */     GIR_RootConstrainSelectedInstOperands,
     /* 161529 */     // GIR_Coverage, 985,
     /* 161529 */     GIR_EraseRootFromParent_Done,
     /* 161530 */   // Label 3510: @161530
     /* 161530 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(161563), // Rule ID 903 //
     /* 161535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 161538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 161546 */     // (fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 161546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 161551 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 161557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 161561 */     GIR_RootConstrainSelectedInstOperands,
     /* 161562 */     // GIR_Coverage, 903,
     /* 161562 */     GIR_Done,
     /* 161563 */   // Label 3511: @161563
     /* 161563 */   GIM_Reject,
     /* 161564 */ // Label 3502: @161564
     /* 161564 */ GIM_Reject,
     /* 161565 */ // Label 3440: @161565
     /* 161565 */ GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(161918),
     /* 161570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161576 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(161638), // Rule ID 23392 //
     /* 161581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161613 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161620 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161625 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161627 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161636 */     GIR_RootConstrainSelectedInstOperands,
     /* 161637 */     // GIR_Coverage, 23392,
     /* 161637 */     GIR_EraseRootFromParent_Done,
     /* 161638 */   // Label 3513: @161638
     /* 161638 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(161700), // Rule ID 24368 //
     /* 161643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161661 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161665 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161675 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161682 */     // (fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161687 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161689 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161698 */     GIR_RootConstrainSelectedInstOperands,
     /* 161699 */     // GIR_Coverage, 24368,
     /* 161699 */     GIR_EraseRootFromParent_Done,
     /* 161700 */   // Label 3514: @161700
     /* 161700 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(161762), // Rule ID 2181 //
     /* 161705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161724 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161731 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161744 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 161747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161749 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161751 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161760 */     GIR_RootConstrainSelectedInstOperands,
     /* 161761 */     // GIR_Coverage, 2181,
     /* 161761 */     GIR_EraseRootFromParent_Done,
     /* 161762 */   // Label 3515: @161762
     /* 161762 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(161824), // Rule ID 6426 //
     /* 161767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 161782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161806 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 161809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161811 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 161813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161822 */     GIR_RootConstrainSelectedInstOperands,
     /* 161823 */     // GIR_Coverage, 6426,
     /* 161823 */     GIR_EraseRootFromParent_Done,
     /* 161824 */   // Label 3516: @161824
     /* 161824 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(161855), // Rule ID 2179 //
     /* 161829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161844 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161844 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 161849 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161853 */     GIR_RootConstrainSelectedInstOperands,
     /* 161854 */     // GIR_Coverage, 2179,
     /* 161854 */     GIR_Done,
     /* 161855 */   // Label 3517: @161855
     /* 161855 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(161886), // Rule ID 2195 //
     /* 161860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 161863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161875 */     // (fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 161875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 161880 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161884 */     GIR_RootConstrainSelectedInstOperands,
     /* 161885 */     // GIR_Coverage, 2195,
     /* 161885 */     GIR_Done,
     /* 161886 */   // Label 3518: @161886
     /* 161886 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(161917), // Rule ID 6422 //
     /* 161891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 161894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 161906 */     // (fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 161906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 161911 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 161915 */     GIR_RootConstrainSelectedInstOperands,
     /* 161916 */     // GIR_Coverage, 6422,
     /* 161916 */     GIR_Done,
     /* 161917 */   // Label 3519: @161917
     /* 161917 */   GIM_Reject,
     /* 161918 */ // Label 3512: @161918
     /* 161918 */ GIM_Reject,
     /* 161919 */ // Label 3441: @161919
     /* 161919 */ GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(162272),
     /* 161924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161930 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(161992), // Rule ID 23390 //
     /* 161935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 161938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 161946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 161950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 161953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 161957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 161961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 161965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 161967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 161974 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 161974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 161977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 161981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 161985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 161990 */     GIR_RootConstrainSelectedInstOperands,
     /* 161991 */     // GIR_Coverage, 23390,
     /* 161991 */     GIR_EraseRootFromParent_Done,
     /* 161992 */   // Label 3521: @161992
     /* 161992 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(162054), // Rule ID 24352 //
     /* 161997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162036 */     // (fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162041 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162052 */     GIR_RootConstrainSelectedInstOperands,
     /* 162053 */     // GIR_Coverage, 24352,
     /* 162053 */     GIR_EraseRootFromParent_Done,
     /* 162054 */   // Label 3522: @162054
     /* 162054 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(162116), // Rule ID 2177 //
     /* 162059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162098 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 162101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162114 */     GIR_RootConstrainSelectedInstOperands,
     /* 162115 */     // GIR_Coverage, 2177,
     /* 162115 */     GIR_EraseRootFromParent_Done,
     /* 162116 */   // Label 3523: @162116
     /* 162116 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(162178), // Rule ID 6402 //
     /* 162121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162140 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162143 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162147 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162153 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162160 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 162163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162165 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162176 */     GIR_RootConstrainSelectedInstOperands,
     /* 162177 */     // GIR_Coverage, 6402,
     /* 162177 */     GIR_EraseRootFromParent_Done,
     /* 162178 */   // Label 3524: @162178
     /* 162178 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(162209), // Rule ID 2175 //
     /* 162183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162198 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 162203 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162207 */     GIR_RootConstrainSelectedInstOperands,
     /* 162208 */     // GIR_Coverage, 2175,
     /* 162208 */     GIR_Done,
     /* 162209 */   // Label 3525: @162209
     /* 162209 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(162240), // Rule ID 2191 //
     /* 162214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 162217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 162229 */     // (fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 162229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 162234 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162238 */     GIR_RootConstrainSelectedInstOperands,
     /* 162239 */     // GIR_Coverage, 2191,
     /* 162239 */     GIR_Done,
     /* 162240 */   // Label 3526: @162240
     /* 162240 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(162271), // Rule ID 6398 //
     /* 162245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162260 */     // (fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 162260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 162265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162269 */     GIR_RootConstrainSelectedInstOperands,
     /* 162270 */     // GIR_Coverage, 6398,
     /* 162270 */     GIR_Done,
     /* 162271 */   // Label 3527: @162271
     /* 162271 */   GIM_Reject,
     /* 162272 */ // Label 3520: @162272
     /* 162272 */ GIM_Reject,
     /* 162273 */ // Label 3442: @162273
     /* 162273 */ GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(162595),
     /* 162278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 162281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 162284 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(162346), // Rule ID 23396 //
     /* 162289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162304 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162307 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162311 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162328 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162333 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162344 */     GIR_RootConstrainSelectedInstOperands,
     /* 162345 */     // GIR_Coverage, 23396,
     /* 162345 */     GIR_EraseRootFromParent_Done,
     /* 162346 */   // Label 3529: @162346
     /* 162346 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(162408), // Rule ID 24376 //
     /* 162351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162366 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162369 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162373 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162383 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162390 */     // (fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162397 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162406 */     GIR_RootConstrainSelectedInstOperands,
     /* 162407 */     // GIR_Coverage, 24376,
     /* 162407 */     GIR_EraseRootFromParent_Done,
     /* 162408 */   // Label 3530: @162408
     /* 162408 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(162470), // Rule ID 2189 //
     /* 162413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162452 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 162455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162468 */     GIR_RootConstrainSelectedInstOperands,
     /* 162469 */     // GIR_Coverage, 2189,
     /* 162469 */     GIR_EraseRootFromParent_Done,
     /* 162470 */   // Label 3531: @162470
     /* 162470 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(162532), // Rule ID 6438 //
     /* 162475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162494 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162497 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162501 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162507 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162514 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 162517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162519 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162530 */     GIR_RootConstrainSelectedInstOperands,
     /* 162531 */     // GIR_Coverage, 6438,
     /* 162531 */     GIR_EraseRootFromParent_Done,
     /* 162532 */   // Label 3532: @162532
     /* 162532 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(162563), // Rule ID 2187 //
     /* 162537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162552 */     // (fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 162552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 162557 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162561 */     GIR_RootConstrainSelectedInstOperands,
     /* 162562 */     // GIR_Coverage, 2187,
     /* 162562 */     GIR_Done,
     /* 162563 */   // Label 3533: @162563
     /* 162563 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(162594), // Rule ID 6434 //
     /* 162568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162583 */     // (fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 162583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 162588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162592 */     GIR_RootConstrainSelectedInstOperands,
     /* 162593 */     // GIR_Coverage, 6434,
     /* 162593 */     GIR_Done,
     /* 162594 */   // Label 3534: @162594
     /* 162594 */   GIM_Reject,
     /* 162595 */ // Label 3528: @162595
     /* 162595 */ GIM_Reject,
     /* 162596 */ // Label 3443: @162596
     /* 162596 */ GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(162755),
     /* 162601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162611 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(162669), // Rule ID 24392 //
     /* 162616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162627 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162634 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162651 */     // (fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162656 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162667 */     GIR_RootConstrainSelectedInstOperands,
     /* 162668 */     // GIR_Coverage, 24392,
     /* 162668 */     GIR_EraseRootFromParent_Done,
     /* 162669 */   // Label 3536: @162669
     /* 162669 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(162727), // Rule ID 6462 //
     /* 162674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162689 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162692 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162696 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162702 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162709 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 162712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162714 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162716 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162725 */     GIR_RootConstrainSelectedInstOperands,
     /* 162726 */     // GIR_Coverage, 6462,
     /* 162726 */     GIR_EraseRootFromParent_Done,
     /* 162727 */   // Label 3537: @162727
     /* 162727 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(162754), // Rule ID 6458 //
     /* 162732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 162735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 162743 */     // (fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 162743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 162748 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 162752 */     GIR_RootConstrainSelectedInstOperands,
     /* 162753 */     // GIR_Coverage, 6458,
     /* 162753 */     GIR_Done,
     /* 162754 */   // Label 3538: @162754
     /* 162754 */   GIM_Reject,
     /* 162755 */ // Label 3535: @162755
     /* 162755 */ GIM_Reject,
     /* 162756 */ // Label 3444: @162756
     /* 162756 */ GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(163078),
     /* 162761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 162764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 162767 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(162829), // Rule ID 23394 //
     /* 162772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162787 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162794 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162804 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162811 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162827 */     GIR_RootConstrainSelectedInstOperands,
     /* 162828 */     // GIR_Coverage, 23394,
     /* 162828 */     GIR_EraseRootFromParent_Done,
     /* 162829 */   // Label 3540: @162829
     /* 162829 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(162891), // Rule ID 24360 //
     /* 162834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 162845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162866 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162873 */     // (fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 162876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162878 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 162880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162889 */     GIR_RootConstrainSelectedInstOperands,
     /* 162890 */     // GIR_Coverage, 24360,
     /* 162890 */     GIR_EraseRootFromParent_Done,
     /* 162891 */   // Label 3541: @162891
     /* 162891 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(162953), // Rule ID 2185 //
     /* 162896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 162899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 162907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162935 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 162938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162940 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 162942 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 162946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 162951 */     GIR_RootConstrainSelectedInstOperands,
     /* 162952 */     // GIR_Coverage, 2185,
     /* 162952 */     GIR_EraseRootFromParent_Done,
     /* 162953 */   // Label 3542: @162953
     /* 162953 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(163015), // Rule ID 6414 //
     /* 162958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 162961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 162969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 162973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 162977 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 162980 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 162984 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 162988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162990 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 162997 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 162997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 163000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163002 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163004 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163013 */     GIR_RootConstrainSelectedInstOperands,
     /* 163014 */     // GIR_Coverage, 6414,
     /* 163014 */     GIR_EraseRootFromParent_Done,
     /* 163015 */   // Label 3543: @163015
     /* 163015 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(163046), // Rule ID 2183 //
     /* 163020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 163023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 163035 */     // (fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 163035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 163040 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163044 */     GIR_RootConstrainSelectedInstOperands,
     /* 163045 */     // GIR_Coverage, 2183,
     /* 163045 */     GIR_Done,
     /* 163046 */   // Label 3544: @163046
     /* 163046 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(163077), // Rule ID 6410 //
     /* 163051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 163054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163066 */     // (fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 163066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 163071 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163075 */     GIR_RootConstrainSelectedInstOperands,
     /* 163076 */     // GIR_Coverage, 6410,
     /* 163076 */     GIR_Done,
     /* 163077 */   // Label 3545: @163077
     /* 163077 */   GIM_Reject,
     /* 163078 */ // Label 3539: @163078
     /* 163078 */ GIM_Reject,
     /* 163079 */ // Label 3445: @163079
     /* 163079 */ GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(163238),
     /* 163084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 163087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 163090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163094 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(163152), // Rule ID 24344 //
     /* 163099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163134 */     // (fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163139 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163141 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163150 */     GIR_RootConstrainSelectedInstOperands,
     /* 163151 */     // GIR_Coverage, 24344,
     /* 163151 */     GIR_EraseRootFromParent_Done,
     /* 163152 */   // Label 3547: @163152
     /* 163152 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(163210), // Rule ID 6390 //
     /* 163157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163192 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 163195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163197 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163208 */     GIR_RootConstrainSelectedInstOperands,
     /* 163209 */     // GIR_Coverage, 6390,
     /* 163209 */     GIR_EraseRootFromParent_Done,
     /* 163210 */   // Label 3548: @163210
     /* 163210 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(163237), // Rule ID 6386 //
     /* 163215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163226 */     // (fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 163226 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 163231 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163235 */     GIR_RootConstrainSelectedInstOperands,
     /* 163236 */     // GIR_Coverage, 6386,
     /* 163236 */     GIR_Done,
     /* 163237 */   // Label 3549: @163237
     /* 163237 */   GIM_Reject,
     /* 163238 */ // Label 3546: @163238
     /* 163238 */ GIM_Reject,
     /* 163239 */ // Label 3446: @163239
     /* 163239 */ GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(163398),
     /* 163244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 163247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 163250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163254 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(163312), // Rule ID 24400 //
     /* 163259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163287 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163294 */     // (fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163299 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163301 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163310 */     GIR_RootConstrainSelectedInstOperands,
     /* 163311 */     // GIR_Coverage, 24400,
     /* 163311 */     GIR_EraseRootFromParent_Done,
     /* 163312 */   // Label 3551: @163312
     /* 163312 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(163370), // Rule ID 6474 //
     /* 163317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163332 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163335 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163339 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163345 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163352 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 163355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163357 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163359 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163368 */     GIR_RootConstrainSelectedInstOperands,
     /* 163369 */     // GIR_Coverage, 6474,
     /* 163369 */     GIR_EraseRootFromParent_Done,
     /* 163370 */   // Label 3552: @163370
     /* 163370 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(163397), // Rule ID 6470 //
     /* 163375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 163378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 163386 */     // (fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 163386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 163391 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163395 */     GIR_RootConstrainSelectedInstOperands,
     /* 163396 */     // GIR_Coverage, 6470,
     /* 163396 */     GIR_Done,
     /* 163397 */   // Label 3553: @163397
     /* 163397 */   GIM_Reject,
     /* 163398 */ // Label 3550: @163398
     /* 163398 */ GIM_Reject,
     /* 163399 */ // Label 3447: @163399
     /* 163399 */ GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(163558),
     /* 163404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 163407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 163410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163414 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(163472), // Rule ID 24336 //
     /* 163419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163430 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163433 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163437 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163447 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163454 */     // (fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163461 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163470 */     GIR_RootConstrainSelectedInstOperands,
     /* 163471 */     // GIR_Coverage, 24336,
     /* 163471 */     GIR_EraseRootFromParent_Done,
     /* 163472 */   // Label 3555: @163472
     /* 163472 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(163530), // Rule ID 6378 //
     /* 163477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163512 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 163515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163528 */     GIR_RootConstrainSelectedInstOperands,
     /* 163529 */     // GIR_Coverage, 6378,
     /* 163529 */     GIR_EraseRootFromParent_Done,
     /* 163530 */   // Label 3556: @163530
     /* 163530 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(163557), // Rule ID 6374 //
     /* 163535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 163538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163546 */     // (fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 163546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 163551 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163555 */     GIR_RootConstrainSelectedInstOperands,
     /* 163556 */     // GIR_Coverage, 6374,
     /* 163556 */     GIR_Done,
     /* 163557 */   // Label 3557: @163557
     /* 163557 */   GIM_Reject,
     /* 163558 */ // Label 3554: @163558
     /* 163558 */ GIM_Reject,
     /* 163559 */ // Label 3448: @163559
     /* 163559 */ GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(163718),
     /* 163564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 163567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 163570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163574 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(163632), // Rule ID 24384 //
     /* 163579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163614 */     // (fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163621 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163630 */     GIR_RootConstrainSelectedInstOperands,
     /* 163631 */     // GIR_Coverage, 24384,
     /* 163631 */     GIR_EraseRootFromParent_Done,
     /* 163632 */   // Label 3559: @163632
     /* 163632 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(163690), // Rule ID 6450 //
     /* 163637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163652 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163655 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163672 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 163672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 163679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 163683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163688 */     GIR_RootConstrainSelectedInstOperands,
     /* 163689 */     // GIR_Coverage, 6450,
     /* 163689 */     GIR_EraseRootFromParent_Done,
     /* 163690 */   // Label 3560: @163690
     /* 163690 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(163717), // Rule ID 6446 //
     /* 163695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 163706 */     // (fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 163706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 163711 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 163715 */     GIR_RootConstrainSelectedInstOperands,
     /* 163716 */     // GIR_Coverage, 6446,
     /* 163716 */     GIR_Done,
     /* 163717 */   // Label 3561: @163717
     /* 163717 */   GIM_Reject,
     /* 163718 */ // Label 3558: @163718
     /* 163718 */ GIM_Reject,
     /* 163719 */ // Label 3449: @163719
     /* 163719 */ GIM_Reject,
     /* 163720 */ // Label 44: @163720
     /* 163720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3574*/ GIMT_Encode4(169707),
     /* 163731 */ /*GILLT_s16*//*Label 3562*/ GIMT_Encode4(163815),
     /* 163735 */ /*GILLT_s32*//*Label 3563*/ GIMT_Encode4(164060),
     /* 163739 */ /*GILLT_s64*//*Label 3564*/ GIMT_Encode4(164797), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163755 */ /*GILLT_v2s64*//*Label 3565*/ GIMT_Encode4(165534), GIMT_Encode4(0),
     /* 163763 */ /*GILLT_v4s32*//*Label 3566*/ GIMT_Encode4(166271),
     /* 163767 */ /*GILLT_v4s64*//*Label 3567*/ GIMT_Encode4(167008), GIMT_Encode4(0),
     /* 163775 */ /*GILLT_v8s16*//*Label 3568*/ GIMT_Encode4(167745),
     /* 163779 */ /*GILLT_v8s32*//*Label 3569*/ GIMT_Encode4(167990),
     /* 163783 */ /*GILLT_v8s64*//*Label 3570*/ GIMT_Encode4(168727), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163795 */ /*GILLT_v16s16*//*Label 3571*/ GIMT_Encode4(168972),
     /* 163799 */ /*GILLT_v16s32*//*Label 3572*/ GIMT_Encode4(169217), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 163811 */ /*GILLT_v32s16*//*Label 3573*/ GIMT_Encode4(169462),
     /* 163815 */ // Label 3562: @163815
     /* 163815 */ GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(164059),
     /* 163820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 163823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 163826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 163829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163833 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(163897), // Rule ID 10158 //
     /* 163838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 163845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163849 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163852 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163877 */     // (fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 163880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 163884 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 163886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163895 */     GIR_RootConstrainSelectedInstOperands,
     /* 163896 */     // GIR_Coverage, 10158,
     /* 163896 */     GIR_EraseRootFromParent_Done,
     /* 163897 */   // Label 3576: @163897
     /* 163897 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(163961), // Rule ID 10156 //
     /* 163902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 163913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163917 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163924 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163934 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 163941 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 163941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 163944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 163946 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 163948 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 163950 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 163954 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 163959 */     GIR_RootConstrainSelectedInstOperands,
     /* 163960 */     // GIR_Coverage, 10156,
     /* 163960 */     GIR_EraseRootFromParent_Done,
     /* 163961 */   // Label 3577: @163961
     /* 163961 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(164025), // Rule ID 10153 //
     /* 163966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 163969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 163977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 163985 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 163988 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 163992 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 163996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164005 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 164008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164010 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164012 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164014 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164023 */     GIR_RootConstrainSelectedInstOperands,
     /* 164024 */     // GIR_Coverage, 10153,
     /* 164024 */     GIR_EraseRootFromParent_Done,
     /* 164025 */   // Label 3578: @164025
     /* 164025 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(164058), // Rule ID 10151 //
     /* 164030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 164033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 164045 */     // (fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 164045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 164048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164050 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164052 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164054 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164056 */     GIR_RootConstrainSelectedInstOperands,
     /* 164057 */     // GIR_Coverage, 10151,
     /* 164057 */     GIR_EraseRootFromParent_Done,
     /* 164058 */   // Label 3579: @164058
     /* 164058 */   GIM_Reject,
     /* 164059 */ // Label 3575: @164059
     /* 164059 */ GIM_Reject,
     /* 164060 */ // Label 3563: @164060
     /* 164060 */ GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(164796),
     /* 164065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164071 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164074 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(164142), // Rule ID 1304 //
     /* 164079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164122 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 164125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164127 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164129 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164135 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164140 */     GIR_RootConstrainSelectedInstOperands,
     /* 164141 */     // GIR_Coverage, 1304,
     /* 164141 */     GIR_EraseRootFromParent_Done,
     /* 164142 */   // Label 3581: @164142
     /* 164142 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(164210), // Rule ID 10140 //
     /* 164147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164162 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164165 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164169 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164183 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164190 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 164193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164195 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164197 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164208 */     GIR_RootConstrainSelectedInstOperands,
     /* 164209 */     // GIR_Coverage, 10140,
     /* 164209 */     GIR_EraseRootFromParent_Done,
     /* 164210 */   // Label 3582: @164210
     /* 164210 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(164278), // Rule ID 23281 //
     /* 164215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164258 */     // (fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164263 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164269 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164276 */     GIR_RootConstrainSelectedInstOperands,
     /* 164277 */     // GIR_Coverage, 23281,
     /* 164277 */     GIR_EraseRootFromParent_Done,
     /* 164278 */   // Label 3583: @164278
     /* 164278 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(164346), // Rule ID 1302 //
     /* 164283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164319 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164326 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 164329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164331 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164344 */     GIR_RootConstrainSelectedInstOperands,
     /* 164345 */     // GIR_Coverage, 1302,
     /* 164345 */     GIR_EraseRootFromParent_Done,
     /* 164346 */   // Label 3584: @164346
     /* 164346 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(164414), // Rule ID 1366 //
     /* 164351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164370 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164373 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164377 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164394 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 164397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 164405 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164412 */     GIR_RootConstrainSelectedInstOperands,
     /* 164413 */     // GIR_Coverage, 1366,
     /* 164413 */     GIR_EraseRootFromParent_Done,
     /* 164414 */   // Label 3585: @164414
     /* 164414 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(164482), // Rule ID 10138 //
     /* 164419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 164434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164438 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164441 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164445 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164462 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 164465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164467 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 164469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164471 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164480 */     GIR_RootConstrainSelectedInstOperands,
     /* 164481 */     // GIR_Coverage, 10138,
     /* 164481 */     GIR_EraseRootFromParent_Done,
     /* 164482 */   // Label 3586: @164482
     /* 164482 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(164550), // Rule ID 1300 //
     /* 164487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164510 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164513 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164517 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164523 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164530 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 164533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164537 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164548 */     GIR_RootConstrainSelectedInstOperands,
     /* 164549 */     // GIR_Coverage, 1300,
     /* 164549 */     GIR_EraseRootFromParent_Done,
     /* 164550 */   // Label 3587: @164550
     /* 164550 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(164618), // Rule ID 1364 //
     /* 164555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164591 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164598 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 164601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164603 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 164605 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 164607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164616 */     GIR_RootConstrainSelectedInstOperands,
     /* 164617 */     // GIR_Coverage, 1364,
     /* 164617 */     GIR_EraseRootFromParent_Done,
     /* 164618 */   // Label 3588: @164618
     /* 164618 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(164686), // Rule ID 10135 //
     /* 164623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164666 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 164669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164671 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164673 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164684 */     GIR_RootConstrainSelectedInstOperands,
     /* 164685 */     // GIR_Coverage, 10135,
     /* 164685 */     GIR_EraseRootFromParent_Done,
     /* 164686 */   // Label 3589: @164686
     /* 164686 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(164723), // Rule ID 1298 //
     /* 164691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164710 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 164713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164715 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164717 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164721 */     GIR_RootConstrainSelectedInstOperands,
     /* 164722 */     // GIR_Coverage, 1298,
     /* 164722 */     GIR_EraseRootFromParent_Done,
     /* 164723 */   // Label 3590: @164723
     /* 164723 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(164758), // Rule ID 1362 //
     /* 164728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 164747 */     // (fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 164747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 164752 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 164756 */     GIR_RootConstrainSelectedInstOperands,
     /* 164757 */     // GIR_Coverage, 1362,
     /* 164757 */     GIR_Done,
     /* 164758 */   // Label 3591: @164758
     /* 164758 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(164795), // Rule ID 10133 //
     /* 164763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 164782 */     // (fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 164782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 164785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 164793 */     GIR_RootConstrainSelectedInstOperands,
     /* 164794 */     // GIR_Coverage, 10133,
     /* 164794 */     GIR_EraseRootFromParent_Done,
     /* 164795 */   // Label 3592: @164795
     /* 164795 */   GIM_Reject,
     /* 164796 */ // Label 3580: @164796
     /* 164796 */ GIM_Reject,
     /* 164797 */ // Label 3564: @164797
     /* 164797 */ GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(165533),
     /* 164802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164811 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(164879), // Rule ID 1312 //
     /* 164816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 164819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164852 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164859 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 164862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164864 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164866 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164877 */     GIR_RootConstrainSelectedInstOperands,
     /* 164878 */     // GIR_Coverage, 1312,
     /* 164878 */     GIR_EraseRootFromParent_Done,
     /* 164879 */   // Label 3594: @164879
     /* 164879 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(164947), // Rule ID 10149 //
     /* 164884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 164887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164899 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164902 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 164918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164927 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 164927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 164930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 164934 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 164936 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 164940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 164945 */     GIR_RootConstrainSelectedInstOperands,
     /* 164946 */     // GIR_Coverage, 10149,
     /* 164946 */     GIR_EraseRootFromParent_Done,
     /* 164947 */   // Label 3595: @164947
     /* 164947 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(165015), // Rule ID 23309 //
     /* 164952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 164955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 164967 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 164970 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 164974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 164978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 164986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 164995 */     // (fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 164995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 164998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165006 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165013 */     GIR_RootConstrainSelectedInstOperands,
     /* 165014 */     // GIR_Coverage, 23309,
     /* 165014 */     GIR_EraseRootFromParent_Done,
     /* 165015 */   // Label 3596: @165015
     /* 165015 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(165083), // Rule ID 1310 //
     /* 165020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165039 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165042 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165046 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165056 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165063 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 165066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165068 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165072 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165081 */     GIR_RootConstrainSelectedInstOperands,
     /* 165082 */     // GIR_Coverage, 1310,
     /* 165082 */     GIR_EraseRootFromParent_Done,
     /* 165083 */   // Label 3597: @165083
     /* 165083 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(165151), // Rule ID 1450 //
     /* 165088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165107 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165114 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165124 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165131 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 165134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165136 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165138 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165142 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165149 */     GIR_RootConstrainSelectedInstOperands,
     /* 165150 */     // GIR_Coverage, 1450,
     /* 165150 */     GIR_EraseRootFromParent_Done,
     /* 165151 */   // Label 3598: @165151
     /* 165151 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(165219), // Rule ID 10147 //
     /* 165156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165175 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165178 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165182 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165199 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 165202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165204 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165206 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165208 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165217 */     GIR_RootConstrainSelectedInstOperands,
     /* 165218 */     // GIR_Coverage, 10147,
     /* 165218 */     GIR_EraseRootFromParent_Done,
     /* 165219 */   // Label 3599: @165219
     /* 165219 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(165287), // Rule ID 1308 //
     /* 165224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165247 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165250 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165267 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 165270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165285 */     GIR_RootConstrainSelectedInstOperands,
     /* 165286 */     // GIR_Coverage, 1308,
     /* 165286 */     GIR_EraseRootFromParent_Done,
     /* 165287 */   // Label 3600: @165287
     /* 165287 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(165355), // Rule ID 1448 //
     /* 165292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165335 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 165338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165340 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 165344 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165353 */     GIR_RootConstrainSelectedInstOperands,
     /* 165354 */     // GIR_Coverage, 1448,
     /* 165354 */     GIR_EraseRootFromParent_Done,
     /* 165355 */   // Label 3601: @165355
     /* 165355 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(165423), // Rule ID 10144 //
     /* 165360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165396 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165403 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 165406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165408 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165410 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165421 */     GIR_RootConstrainSelectedInstOperands,
     /* 165422 */     // GIR_Coverage, 10144,
     /* 165422 */     GIR_EraseRootFromParent_Done,
     /* 165423 */   // Label 3602: @165423
     /* 165423 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(165460), // Rule ID 1306 //
     /* 165428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 165431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165447 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 165450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165458 */     GIR_RootConstrainSelectedInstOperands,
     /* 165459 */     // GIR_Coverage, 1306,
     /* 165459 */     GIR_EraseRootFromParent_Done,
     /* 165460 */   // Label 3603: @165460
     /* 165460 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(165495), // Rule ID 1446 //
     /* 165465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 165484 */     // (fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 165484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 165489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 165493 */     GIR_RootConstrainSelectedInstOperands,
     /* 165494 */     // GIR_Coverage, 1446,
     /* 165494 */     GIR_Done,
     /* 165495 */   // Label 3604: @165495
     /* 165495 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(165532), // Rule ID 10142 //
     /* 165500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 165503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 165519 */     // (fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 165519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 165522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165526 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165528 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165530 */     GIR_RootConstrainSelectedInstOperands,
     /* 165531 */     // GIR_Coverage, 10142,
     /* 165531 */     GIR_EraseRootFromParent_Done,
     /* 165532 */   // Label 3605: @165532
     /* 165532 */   GIM_Reject,
     /* 165533 */ // Label 3593: @165533
     /* 165533 */ GIM_Reject,
     /* 165534 */ // Label 3565: @165534
     /* 165534 */ GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(166270),
     /* 165539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 165542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 165548 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(165616), // Rule ID 1192 //
     /* 165553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165568 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165575 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165596 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 165599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165603 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165614 */     GIR_RootConstrainSelectedInstOperands,
     /* 165615 */     // GIR_Coverage, 1192,
     /* 165615 */     GIR_EraseRootFromParent_Done,
     /* 165616 */   // Label 3607: @165616
     /* 165616 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(165684), // Rule ID 9681 //
     /* 165621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165636 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165639 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165643 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165664 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 165667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165669 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165671 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 165673 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165682 */     GIR_RootConstrainSelectedInstOperands,
     /* 165683 */     // GIR_Coverage, 9681,
     /* 165683 */     GIR_EraseRootFromParent_Done,
     /* 165684 */   // Label 3608: @165684
     /* 165684 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(165752), // Rule ID 23317 //
     /* 165689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165704 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165707 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165711 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165732 */     // (fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165737 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 165739 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165743 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165750 */     GIR_RootConstrainSelectedInstOperands,
     /* 165751 */     // GIR_Coverage, 23317,
     /* 165751 */     GIR_EraseRootFromParent_Done,
     /* 165752 */   // Label 3609: @165752
     /* 165752 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(165820), // Rule ID 1190 //
     /* 165757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165776 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165779 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165783 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165793 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165800 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 165803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165805 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165809 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165818 */     GIR_RootConstrainSelectedInstOperands,
     /* 165819 */     // GIR_Coverage, 1190,
     /* 165819 */     GIR_EraseRootFromParent_Done,
     /* 165820 */   // Label 3610: @165820
     /* 165820 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(165888), // Rule ID 1474 //
     /* 165825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 165828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165844 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165847 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165851 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165861 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165868 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 165875 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 165879 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 165881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165886 */     GIR_RootConstrainSelectedInstOperands,
     /* 165887 */     // GIR_Coverage, 1474,
     /* 165887 */     GIR_EraseRootFromParent_Done,
     /* 165888 */   // Label 3611: @165888
     /* 165888 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(165956), // Rule ID 9141 //
     /* 165893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 165908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165912 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165915 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165919 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 165927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 165936 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 165936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 165939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 165941 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 165943 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 165945 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 165949 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 165954 */     GIR_RootConstrainSelectedInstOperands,
     /* 165955 */     // GIR_Coverage, 9141,
     /* 165955 */     GIR_EraseRootFromParent_Done,
     /* 165956 */   // Label 3612: @165956
     /* 165956 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(166024), // Rule ID 1188 //
     /* 165961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 165964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 165976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 165980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 165984 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 165987 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 165991 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 165995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165997 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166004 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 166007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166009 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166013 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166022 */     GIR_RootConstrainSelectedInstOperands,
     /* 166023 */     // GIR_Coverage, 1188,
     /* 166023 */     GIR_EraseRootFromParent_Done,
     /* 166024 */   // Label 3613: @166024
     /* 166024 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(166092), // Rule ID 1472 //
     /* 166029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166052 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166055 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166059 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166065 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166072 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 166075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166077 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166079 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166081 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166090 */     GIR_RootConstrainSelectedInstOperands,
     /* 166091 */     // GIR_Coverage, 1472,
     /* 166091 */     GIR_EraseRootFromParent_Done,
     /* 166092 */   // Label 3614: @166092
     /* 166092 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(166160), // Rule ID 8514 //
     /* 166097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166140 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 166143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166147 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166149 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166153 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166158 */     GIR_RootConstrainSelectedInstOperands,
     /* 166159 */     // GIR_Coverage, 8514,
     /* 166159 */     GIR_EraseRootFromParent_Done,
     /* 166160 */   // Label 3615: @166160
     /* 166160 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(166197), // Rule ID 1186 //
     /* 166165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166184 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 166187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166193 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166195 */     GIR_RootConstrainSelectedInstOperands,
     /* 166196 */     // GIR_Coverage, 1186,
     /* 166196 */     GIR_EraseRootFromParent_Done,
     /* 166197 */   // Label 3616: @166197
     /* 166197 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(166232), // Rule ID 1470 //
     /* 166202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166221 */     // (fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 166221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 166226 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166230 */     GIR_RootConstrainSelectedInstOperands,
     /* 166231 */     // GIR_Coverage, 1470,
     /* 166231 */     GIR_Done,
     /* 166232 */   // Label 3617: @166232
     /* 166232 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(166269), // Rule ID 8510 //
     /* 166237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166256 */     // (fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 166256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 166259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166261 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166265 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166267 */     GIR_RootConstrainSelectedInstOperands,
     /* 166268 */     // GIR_Coverage, 8510,
     /* 166268 */     GIR_EraseRootFromParent_Done,
     /* 166269 */   // Label 3618: @166269
     /* 166269 */   GIM_Reject,
     /* 166270 */ // Label 3606: @166270
     /* 166270 */ GIM_Reject,
     /* 166271 */ // Label 3566: @166271
     /* 166271 */ GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(167007),
     /* 166276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166285 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(166353), // Rule ID 1144 //
     /* 166290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166305 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166308 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166312 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166326 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166333 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 166336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166338 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166340 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166342 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166351 */     GIR_RootConstrainSelectedInstOperands,
     /* 166352 */     // GIR_Coverage, 1144,
     /* 166352 */     GIR_EraseRootFromParent_Done,
     /* 166353 */   // Label 3620: @166353
     /* 166353 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(166421), // Rule ID 9649 //
     /* 166358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166376 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166380 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166401 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 166404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166406 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166408 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 166410 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166419 */     GIR_RootConstrainSelectedInstOperands,
     /* 166420 */     // GIR_Coverage, 9649,
     /* 166420 */     GIR_EraseRootFromParent_Done,
     /* 166421 */   // Label 3621: @166421
     /* 166421 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(166489), // Rule ID 23289 //
     /* 166426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166441 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166444 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166448 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166469 */     // (fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166480 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166487 */     GIR_RootConstrainSelectedInstOperands,
     /* 166488 */     // GIR_Coverage, 23289,
     /* 166488 */     GIR_EraseRootFromParent_Done,
     /* 166489 */   // Label 3622: @166489
     /* 166489 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(166557), // Rule ID 1142 //
     /* 166494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166513 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166516 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166520 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166537 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 166540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166542 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166544 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166555 */     GIR_RootConstrainSelectedInstOperands,
     /* 166556 */     // GIR_Coverage, 1142,
     /* 166556 */     GIR_EraseRootFromParent_Done,
     /* 166557 */   // Label 3623: @166557
     /* 166557 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(166625), // Rule ID 1390 //
     /* 166562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166605 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 166608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166610 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166612 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 166616 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166623 */     GIR_RootConstrainSelectedInstOperands,
     /* 166624 */     // GIR_Coverage, 1390,
     /* 166624 */     GIR_EraseRootFromParent_Done,
     /* 166625 */   // Label 3624: @166625
     /* 166625 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(166693), // Rule ID 9109 //
     /* 166630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 166645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166673 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 166676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166678 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 166680 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166691 */     GIR_RootConstrainSelectedInstOperands,
     /* 166692 */     // GIR_Coverage, 9109,
     /* 166692 */     GIR_EraseRootFromParent_Done,
     /* 166693 */   // Label 3625: @166693
     /* 166693 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(166761), // Rule ID 1140 //
     /* 166698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166721 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166724 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166728 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166734 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166741 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 166744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166746 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166748 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166750 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166759 */     GIR_RootConstrainSelectedInstOperands,
     /* 166760 */     // GIR_Coverage, 1140,
     /* 166760 */     GIR_EraseRootFromParent_Done,
     /* 166761 */   // Label 3626: @166761
     /* 166761 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(166829), // Rule ID 1388 //
     /* 166766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166789 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166792 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166796 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166802 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166809 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 166812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166814 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 166816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 166818 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166827 */     GIR_RootConstrainSelectedInstOperands,
     /* 166828 */     // GIR_Coverage, 1388,
     /* 166828 */     GIR_EraseRootFromParent_Done,
     /* 166829 */   // Label 3627: @166829
     /* 166829 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(166897), // Rule ID 8475 //
     /* 166834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 166857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 166860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 166864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 166868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 166877 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 166877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 166880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166886 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 166890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 166895 */     GIR_RootConstrainSelectedInstOperands,
     /* 166896 */     // GIR_Coverage, 8475,
     /* 166896 */     GIR_EraseRootFromParent_Done,
     /* 166897 */   // Label 3628: @166897
     /* 166897 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(166934), // Rule ID 1138 //
     /* 166902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 166905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166921 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 166924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166926 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 166928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 166930 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 166932 */     GIR_RootConstrainSelectedInstOperands,
     /* 166933 */     // GIR_Coverage, 1138,
     /* 166933 */     GIR_EraseRootFromParent_Done,
     /* 166934 */   // Label 3629: @166934
     /* 166934 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(166969), // Rule ID 1386 //
     /* 166939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 166942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 166958 */     // (fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 166958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 166963 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 166967 */     GIR_RootConstrainSelectedInstOperands,
     /* 166968 */     // GIR_Coverage, 1386,
     /* 166968 */     GIR_Done,
     /* 166969 */   // Label 3630: @166969
     /* 166969 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(167006), // Rule ID 8471 //
     /* 166974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 166977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 166993 */     // (fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 166993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 166996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 166998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167000 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167002 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167004 */     GIR_RootConstrainSelectedInstOperands,
     /* 167005 */     // GIR_Coverage, 8471,
     /* 167005 */     GIR_EraseRootFromParent_Done,
     /* 167006 */   // Label 3631: @167006
     /* 167006 */   GIM_Reject,
     /* 167007 */ // Label 3619: @167007
     /* 167007 */ GIM_Reject,
     /* 167008 */ // Label 3567: @167008
     /* 167008 */ GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(167744),
     /* 167013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 167016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 167019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 167022 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(167090), // Rule ID 1200 //
     /* 167027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167042 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167045 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167049 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167070 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 167073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167075 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167077 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167079 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167088 */     GIR_RootConstrainSelectedInstOperands,
     /* 167089 */     // GIR_Coverage, 1200,
     /* 167089 */     GIR_EraseRootFromParent_Done,
     /* 167090 */   // Label 3633: @167090
     /* 167090 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(167158), // Rule ID 9671 //
     /* 167095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167110 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167113 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167117 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167131 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167138 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 167141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167143 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167145 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167156 */     GIR_RootConstrainSelectedInstOperands,
     /* 167157 */     // GIR_Coverage, 9671,
     /* 167157 */     GIR_EraseRootFromParent_Done,
     /* 167158 */   // Label 3634: @167158
     /* 167158 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(167226), // Rule ID 23319 //
     /* 167163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167206 */     // (fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167213 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167217 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167224 */     GIR_RootConstrainSelectedInstOperands,
     /* 167225 */     // GIR_Coverage, 23319,
     /* 167225 */     GIR_EraseRootFromParent_Done,
     /* 167226 */   // Label 3635: @167226
     /* 167226 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(167294), // Rule ID 1198 //
     /* 167231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167250 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167253 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167257 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167267 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167274 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 167277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167279 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167281 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167283 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167292 */     GIR_RootConstrainSelectedInstOperands,
     /* 167293 */     // GIR_Coverage, 1198,
     /* 167293 */     GIR_EraseRootFromParent_Done,
     /* 167294 */   // Label 3636: @167294
     /* 167294 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(167362), // Rule ID 1480 //
     /* 167299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167342 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 167345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 167353 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167355 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167360 */     GIR_RootConstrainSelectedInstOperands,
     /* 167361 */     // GIR_Coverage, 1480,
     /* 167361 */     GIR_EraseRootFromParent_Done,
     /* 167362 */   // Label 3637: @167362
     /* 167362 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(167430), // Rule ID 9131 //
     /* 167367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167386 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167389 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167393 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167410 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 167413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167415 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167417 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167419 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167428 */     GIR_RootConstrainSelectedInstOperands,
     /* 167429 */     // GIR_Coverage, 9131,
     /* 167429 */     GIR_EraseRootFromParent_Done,
     /* 167430 */   // Label 3638: @167430
     /* 167430 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(167498), // Rule ID 1196 //
     /* 167435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167478 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 167481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167485 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167487 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167496 */     GIR_RootConstrainSelectedInstOperands,
     /* 167497 */     // GIR_Coverage, 1196,
     /* 167497 */     GIR_EraseRootFromParent_Done,
     /* 167498 */   // Label 3639: @167498
     /* 167498 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(167566), // Rule ID 1478 //
     /* 167503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167526 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167529 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167533 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167546 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 167549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 167553 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 167555 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167564 */     GIR_RootConstrainSelectedInstOperands,
     /* 167565 */     // GIR_Coverage, 1478,
     /* 167565 */     GIR_EraseRootFromParent_Done,
     /* 167566 */   // Label 3640: @167566
     /* 167566 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(167634), // Rule ID 8502 //
     /* 167571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167614 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 167617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167619 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167621 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167632 */     GIR_RootConstrainSelectedInstOperands,
     /* 167633 */     // GIR_Coverage, 8502,
     /* 167633 */     GIR_EraseRootFromParent_Done,
     /* 167634 */   // Label 3641: @167634
     /* 167634 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(167671), // Rule ID 1194 //
     /* 167639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 167642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167658 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167663 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167667 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167669 */     GIR_RootConstrainSelectedInstOperands,
     /* 167670 */     // GIR_Coverage, 1194,
     /* 167670 */     GIR_EraseRootFromParent_Done,
     /* 167671 */   // Label 3642: @167671
     /* 167671 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(167706), // Rule ID 1476 //
     /* 167676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 167679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 167695 */     // (fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 167695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 167700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 167704 */     GIR_RootConstrainSelectedInstOperands,
     /* 167705 */     // GIR_Coverage, 1476,
     /* 167705 */     GIR_Done,
     /* 167706 */   // Label 3643: @167706
     /* 167706 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(167743), // Rule ID 8498 //
     /* 167711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 167714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 167730 */     // (fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 167730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 167733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167735 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167737 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167739 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167741 */     GIR_RootConstrainSelectedInstOperands,
     /* 167742 */     // GIR_Coverage, 8498,
     /* 167742 */     GIR_EraseRootFromParent_Done,
     /* 167743 */   // Label 3644: @167743
     /* 167743 */   GIM_Reject,
     /* 167744 */ // Label 3632: @167744
     /* 167744 */ GIM_Reject,
     /* 167745 */ // Label 3568: @167745
     /* 167745 */ GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(167989),
     /* 167750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 167753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 167759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167763 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(167827), // Rule ID 9617 //
     /* 167768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 167775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167800 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167807 */     // (fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 167810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167812 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167814 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 167816 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167825 */     GIR_RootConstrainSelectedInstOperands,
     /* 167826 */     // GIR_Coverage, 9617,
     /* 167826 */     GIR_EraseRootFromParent_Done,
     /* 167827 */   // Label 3646: @167827
     /* 167827 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(167891), // Rule ID 9077 //
     /* 167832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 167843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167847 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167854 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167871 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 167874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167876 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 167878 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167880 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167889 */     GIR_RootConstrainSelectedInstOperands,
     /* 167890 */     // GIR_Coverage, 9077,
     /* 167890 */     GIR_EraseRootFromParent_Done,
     /* 167891 */   // Label 3647: @167891
     /* 167891 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(167955), // Rule ID 8436 //
     /* 167896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 167915 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 167918 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 167922 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 167926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167928 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 167935 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 167935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 167938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167940 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167942 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167944 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 167948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 167953 */     GIR_RootConstrainSelectedInstOperands,
     /* 167954 */     // GIR_Coverage, 8436,
     /* 167954 */     GIR_EraseRootFromParent_Done,
     /* 167955 */   // Label 3648: @167955
     /* 167955 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(167988), // Rule ID 8432 //
     /* 167960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 167963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 167975 */     // (fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 167975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 167978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 167982 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 167984 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 167986 */     GIR_RootConstrainSelectedInstOperands,
     /* 167987 */     // GIR_Coverage, 8432,
     /* 167987 */     GIR_EraseRootFromParent_Done,
     /* 167988 */   // Label 3649: @167988
     /* 167988 */   GIM_Reject,
     /* 167989 */ // Label 3645: @167989
     /* 167989 */ GIM_Reject,
     /* 167990 */ // Label 3569: @167990
     /* 167990 */ GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(168726),
     /* 167995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 167998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 168001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 168004 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(168072), // Rule ID 1152 //
     /* 168009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168052 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 168055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168057 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168059 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168070 */     GIR_RootConstrainSelectedInstOperands,
     /* 168071 */     // GIR_Coverage, 1152,
     /* 168071 */     GIR_EraseRootFromParent_Done,
     /* 168072 */   // Label 3651: @168072
     /* 168072 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(168140), // Rule ID 9639 //
     /* 168077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168092 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168095 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168099 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168120 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 168123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168127 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168129 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168138 */     GIR_RootConstrainSelectedInstOperands,
     /* 168139 */     // GIR_Coverage, 9639,
     /* 168139 */     GIR_EraseRootFromParent_Done,
     /* 168140 */   // Label 3652: @168140
     /* 168140 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(168208), // Rule ID 23291 //
     /* 168145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168181 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168188 */     // (fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168193 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168195 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168199 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168206 */     GIR_RootConstrainSelectedInstOperands,
     /* 168207 */     // GIR_Coverage, 23291,
     /* 168207 */     GIR_EraseRootFromParent_Done,
     /* 168208 */   // Label 3653: @168208
     /* 168208 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(168276), // Rule ID 1150 //
     /* 168213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168232 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168235 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168239 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168249 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168256 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 168259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168261 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168263 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168269 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168274 */     GIR_RootConstrainSelectedInstOperands,
     /* 168275 */     // GIR_Coverage, 1150,
     /* 168275 */     GIR_EraseRootFromParent_Done,
     /* 168276 */   // Label 3654: @168276
     /* 168276 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(168344), // Rule ID 1396 //
     /* 168281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168300 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168303 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168307 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168317 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168324 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 168327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168329 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168331 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 168335 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168342 */     GIR_RootConstrainSelectedInstOperands,
     /* 168343 */     // GIR_Coverage, 1396,
     /* 168343 */     GIR_EraseRootFromParent_Done,
     /* 168344 */   // Label 3655: @168344
     /* 168344 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(168412), // Rule ID 9099 //
     /* 168349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168368 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168375 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168392 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 168395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168397 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168410 */     GIR_RootConstrainSelectedInstOperands,
     /* 168411 */     // GIR_Coverage, 9099,
     /* 168411 */     GIR_EraseRootFromParent_Done,
     /* 168412 */   // Label 3656: @168412
     /* 168412 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(168480), // Rule ID 1148 //
     /* 168417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168460 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 168463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168465 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168478 */     GIR_RootConstrainSelectedInstOperands,
     /* 168479 */     // GIR_Coverage, 1148,
     /* 168479 */     GIR_EraseRootFromParent_Done,
     /* 168480 */   // Label 3657: @168480
     /* 168480 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(168548), // Rule ID 1394 //
     /* 168485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168528 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 168531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 168535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 168537 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168546 */     GIR_RootConstrainSelectedInstOperands,
     /* 168547 */     // GIR_Coverage, 1394,
     /* 168547 */     GIR_EraseRootFromParent_Done,
     /* 168548 */   // Label 3658: @168548
     /* 168548 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(168616), // Rule ID 8463 //
     /* 168553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168596 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 168599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168601 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168603 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168614 */     GIR_RootConstrainSelectedInstOperands,
     /* 168615 */     // GIR_Coverage, 8463,
     /* 168615 */     GIR_EraseRootFromParent_Done,
     /* 168616 */   // Label 3659: @168616
     /* 168616 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(168653), // Rule ID 1146 //
     /* 168621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 168624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168640 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 168643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168647 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168649 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168651 */     GIR_RootConstrainSelectedInstOperands,
     /* 168652 */     // GIR_Coverage, 1146,
     /* 168652 */     GIR_EraseRootFromParent_Done,
     /* 168653 */   // Label 3660: @168653
     /* 168653 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(168688), // Rule ID 1392 //
     /* 168658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 168661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 168677 */     // (fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 168677 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 168682 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 168686 */     GIR_RootConstrainSelectedInstOperands,
     /* 168687 */     // GIR_Coverage, 1392,
     /* 168687 */     GIR_Done,
     /* 168688 */   // Label 3661: @168688
     /* 168688 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(168725), // Rule ID 8459 //
     /* 168693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 168696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168712 */     // (fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 168712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 168715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168717 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168719 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168721 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168723 */     GIR_RootConstrainSelectedInstOperands,
     /* 168724 */     // GIR_Coverage, 8459,
     /* 168724 */     GIR_EraseRootFromParent_Done,
     /* 168725 */   // Label 3662: @168725
     /* 168725 */   GIM_Reject,
     /* 168726 */ // Label 3650: @168726
     /* 168726 */ GIM_Reject,
     /* 168727 */ // Label 3570: @168727
     /* 168727 */ GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(168971),
     /* 168732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 168735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 168738 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 168741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168745 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(168809), // Rule ID 9659 //
     /* 168750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 168757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168782 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168789 */     // (fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 168792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168794 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 168798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168807 */     GIR_RootConstrainSelectedInstOperands,
     /* 168808 */     // GIR_Coverage, 9659,
     /* 168808 */     GIR_EraseRootFromParent_Done,
     /* 168809 */   // Label 3664: @168809
     /* 168809 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(168873), // Rule ID 9119 //
     /* 168814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 168825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168846 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168853 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 168856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168858 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 168860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168871 */     GIR_RootConstrainSelectedInstOperands,
     /* 168872 */     // GIR_Coverage, 9119,
     /* 168872 */     GIR_EraseRootFromParent_Done,
     /* 168873 */   // Label 3665: @168873
     /* 168873 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(168937), // Rule ID 8487 //
     /* 168878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 168893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 168897 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 168900 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 168904 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 168908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 168910 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 168917 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 168917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 168920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168924 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168926 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 168930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 168935 */     GIR_RootConstrainSelectedInstOperands,
     /* 168936 */     // GIR_Coverage, 8487,
     /* 168936 */     GIR_EraseRootFromParent_Done,
     /* 168937 */   // Label 3666: @168937
     /* 168937 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(168970), // Rule ID 8483 //
     /* 168942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 168945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 168957 */     // (fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 168957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 168960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 168964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 168966 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 168968 */     GIR_RootConstrainSelectedInstOperands,
     /* 168969 */     // GIR_Coverage, 8483,
     /* 168969 */     GIR_EraseRootFromParent_Done,
     /* 168970 */   // Label 3667: @168970
     /* 168970 */   GIM_Reject,
     /* 168971 */ // Label 3663: @168971
     /* 168971 */ GIM_Reject,
     /* 168972 */ // Label 3571: @168972
     /* 168972 */ GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(169216),
     /* 168977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 168980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 168983 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 168986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 168990 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(169054), // Rule ID 9607 //
     /* 168995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 168998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169006 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169009 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169034 */     // (fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 169037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169039 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169041 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169052 */     GIR_RootConstrainSelectedInstOperands,
     /* 169053 */     // GIR_Coverage, 9607,
     /* 169053 */     GIR_EraseRootFromParent_Done,
     /* 169054 */   // Label 3669: @169054
     /* 169054 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(169118), // Rule ID 9067 //
     /* 169059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169074 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169077 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169081 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169098 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 169101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169103 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169107 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169116 */     GIR_RootConstrainSelectedInstOperands,
     /* 169117 */     // GIR_Coverage, 9067,
     /* 169117 */     GIR_EraseRootFromParent_Done,
     /* 169118 */   // Label 3670: @169118
     /* 169118 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(169182), // Rule ID 8424 //
     /* 169123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169142 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169149 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169155 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169162 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 169165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169167 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169169 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169171 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169180 */     GIR_RootConstrainSelectedInstOperands,
     /* 169181 */     // GIR_Coverage, 8424,
     /* 169181 */     GIR_EraseRootFromParent_Done,
     /* 169182 */   // Label 3671: @169182
     /* 169182 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(169215), // Rule ID 8420 //
     /* 169187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 169190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 169202 */     // (fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 169202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 169205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169213 */     GIR_RootConstrainSelectedInstOperands,
     /* 169214 */     // GIR_Coverage, 8420,
     /* 169214 */     GIR_EraseRootFromParent_Done,
     /* 169215 */   // Label 3672: @169215
     /* 169215 */   GIM_Reject,
     /* 169216 */ // Label 3668: @169216
     /* 169216 */ GIM_Reject,
     /* 169217 */ // Label 3572: @169217
     /* 169217 */ GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(169461),
     /* 169222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 169225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 169228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 169231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169235 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(169299), // Rule ID 9627 //
     /* 169240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169254 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169258 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169279 */     // (fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 169282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169284 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169286 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169288 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169297 */     GIR_RootConstrainSelectedInstOperands,
     /* 169298 */     // GIR_Coverage, 9627,
     /* 169298 */     GIR_EraseRootFromParent_Done,
     /* 169299 */   // Label 3674: @169299
     /* 169299 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(169363), // Rule ID 9087 //
     /* 169304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169319 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169322 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169326 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169343 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 169346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169348 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169361 */     GIR_RootConstrainSelectedInstOperands,
     /* 169362 */     // GIR_Coverage, 9087,
     /* 169362 */     GIR_EraseRootFromParent_Done,
     /* 169363 */   // Label 3675: @169363
     /* 169363 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(169427), // Rule ID 8448 //
     /* 169368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169387 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169407 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 169410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169425 */     GIR_RootConstrainSelectedInstOperands,
     /* 169426 */     // GIR_Coverage, 8448,
     /* 169426 */     GIR_EraseRootFromParent_Done,
     /* 169427 */   // Label 3676: @169427
     /* 169427 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(169460), // Rule ID 8444 //
     /* 169432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 169435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169447 */     // (fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 169447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 169450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169452 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169454 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169456 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169458 */     GIR_RootConstrainSelectedInstOperands,
     /* 169459 */     // GIR_Coverage, 8444,
     /* 169459 */     GIR_EraseRootFromParent_Done,
     /* 169460 */   // Label 3677: @169460
     /* 169460 */   GIM_Reject,
     /* 169461 */ // Label 3673: @169461
     /* 169461 */ GIM_Reject,
     /* 169462 */ // Label 3573: @169462
     /* 169462 */ GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(169706),
     /* 169467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 169470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 169473 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 169476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169480 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(169544), // Rule ID 9595 //
     /* 169485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169524 */     // (fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 169527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169529 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169531 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 169533 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169542 */     GIR_RootConstrainSelectedInstOperands,
     /* 169543 */     // GIR_Coverage, 9595,
     /* 169543 */     GIR_EraseRootFromParent_Done,
     /* 169544 */   // Label 3679: @169544
     /* 169544 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(169608), // Rule ID 9055 //
     /* 169549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169564 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169567 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169571 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169588 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 169591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169593 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 169595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169606 */     GIR_RootConstrainSelectedInstOperands,
     /* 169607 */     // GIR_Coverage, 9055,
     /* 169607 */     GIR_EraseRootFromParent_Done,
     /* 169608 */   // Label 3680: @169608
     /* 169608 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(169672), // Rule ID 8409 //
     /* 169613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 169628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169652 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 169652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 169655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 169665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169670 */     GIR_RootConstrainSelectedInstOperands,
     /* 169671 */     // GIR_Coverage, 8409,
     /* 169671 */     GIR_EraseRootFromParent_Done,
     /* 169672 */   // Label 3681: @169672
     /* 169672 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(169705), // Rule ID 8405 //
     /* 169677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 169692 */     // (fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 169692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 169695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 169699 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 169701 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 169703 */     GIR_RootConstrainSelectedInstOperands,
     /* 169704 */     // GIR_Coverage, 8405,
     /* 169704 */     GIR_EraseRootFromParent_Done,
     /* 169705 */   // Label 3682: @169705
     /* 169705 */   GIM_Reject,
     /* 169706 */ // Label 3678: @169706
     /* 169706 */ GIM_Reject,
     /* 169707 */ // Label 3574: @169707
     /* 169707 */ GIM_Reject,
     /* 169708 */ // Label 45: @169708
     /* 169708 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3696*/ GIMT_Encode4(173889),
     /* 169719 */ /*GILLT_s16*//*Label 3683*/ GIMT_Encode4(169803),
     /* 169723 */ /*GILLT_s32*//*Label 3684*/ GIMT_Encode4(169901),
     /* 169727 */ /*GILLT_s64*//*Label 3685*/ GIMT_Encode4(170866),
     /* 169731 */ /*GILLT_s80*//*Label 3686*/ GIMT_Encode4(171975), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169743 */ /*GILLT_v2s64*//*Label 3687*/ GIMT_Encode4(172541), GIMT_Encode4(0),
     /* 169751 */ /*GILLT_v4s32*//*Label 3688*/ GIMT_Encode4(172771),
     /* 169755 */ /*GILLT_v4s64*//*Label 3689*/ GIMT_Encode4(173001), GIMT_Encode4(0),
     /* 169763 */ /*GILLT_v8s16*//*Label 3690*/ GIMT_Encode4(173200),
     /* 169767 */ /*GILLT_v8s32*//*Label 3691*/ GIMT_Encode4(173298),
     /* 169771 */ /*GILLT_v8s64*//*Label 3692*/ GIMT_Encode4(173497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169783 */ /*GILLT_v16s16*//*Label 3693*/ GIMT_Encode4(173595),
     /* 169787 */ /*GILLT_v16s32*//*Label 3694*/ GIMT_Encode4(173693), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 169799 */ /*GILLT_v32s16*//*Label 3695*/ GIMT_Encode4(173791),
     /* 169803 */ // Label 3683: @169803
     /* 169803 */ GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(169900),
     /* 169808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 169811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 169814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169822 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(169876), // Rule ID 6126 //
     /* 169827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169838 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 169841 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 169845 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 169849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169858 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 169861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169863 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 169874 */     GIR_RootConstrainSelectedInstOperands,
     /* 169875 */     // GIR_Coverage, 6126,
     /* 169875 */     GIR_EraseRootFromParent_Done,
     /* 169876 */   // Label 3698: @169876
     /* 169876 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(169899), // Rule ID 6124 //
     /* 169881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 169884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 169888 */     // (fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 169888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 169893 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 169897 */     GIR_RootConstrainSelectedInstOperands,
     /* 169898 */     // GIR_Coverage, 6124,
     /* 169898 */     GIR_Done,
     /* 169899 */   // Label 3699: @169899
     /* 169899 */   GIM_Reject,
     /* 169900 */ // Label 3697: @169900
     /* 169900 */ GIM_Reject,
     /* 169901 */ // Label 3684: @169901
     /* 169901 */ GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(170865),
     /* 169906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169912 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(169994), // Rule ID 22485 //
     /* 169917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 169920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 169928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 169936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 169944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 169948 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 169951 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 169955 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 169962 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 169966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169968 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 169975 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 169975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 169978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169980 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 169982 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 169986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 169992 */     GIR_RootConstrainSelectedInstOperands,
     /* 169993 */     // GIR_Coverage, 22485,
     /* 169993 */     GIR_EraseRootFromParent_Done,
     /* 169994 */   // Label 3701: @169994
     /* 169994 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(170076), // Rule ID 22486 //
     /* 169999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170030 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170037 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170050 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170057 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170074 */     GIR_RootConstrainSelectedInstOperands,
     /* 170075 */     // GIR_Coverage, 22486,
     /* 170075 */     GIR_EraseRootFromParent_Done,
     /* 170076 */   // Label 3702: @170076
     /* 170076 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(170158), // Rule ID 22487 //
     /* 170081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 170104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170112 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170119 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170126 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170139 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>))  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170144 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170156 */     GIR_RootConstrainSelectedInstOperands,
     /* 170157 */     // GIR_Coverage, 22487,
     /* 170157 */     GIR_EraseRootFromParent_Done,
     /* 170158 */   // Label 3703: @170158
     /* 170158 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(170223), // Rule ID 1031 //
     /* 170163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170178 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170195 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170202 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 170205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170209 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170221 */     GIR_RootConstrainSelectedInstOperands,
     /* 170222 */     // GIR_Coverage, 1031,
     /* 170222 */     GIR_EraseRootFromParent_Done,
     /* 170223 */   // Label 3704: @170223
     /* 170223 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(170288), // Rule ID 1033 //
     /* 170228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170243 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170260 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170267 */     // (fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 170270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170272 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170274 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170286 */     GIR_RootConstrainSelectedInstOperands,
     /* 170287 */     // GIR_Coverage, 1033,
     /* 170287 */     GIR_EraseRootFromParent_Done,
     /* 170288 */   // Label 3705: @170288
     /* 170288 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(170353), // Rule ID 1021 //
     /* 170293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170332 */     // (fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 170335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 170339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170343 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170351 */     GIR_RootConstrainSelectedInstOperands,
     /* 170352 */     // GIR_Coverage, 1021,
     /* 170352 */     GIR_EraseRootFromParent_Done,
     /* 170353 */   // Label 3706: @170353
     /* 170353 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(170418), // Rule ID 1009 //
     /* 170358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170377 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 170384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170390 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170397 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 170400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170402 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170404 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170416 */     GIR_RootConstrainSelectedInstOperands,
     /* 170417 */     // GIR_Coverage, 1009,
     /* 170417 */     GIR_EraseRootFromParent_Done,
     /* 170418 */   // Label 3707: @170418
     /* 170418 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(170483), // Rule ID 1011 //
     /* 170423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 170442 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 170449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170462 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 170465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170469 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170481 */     GIR_RootConstrainSelectedInstOperands,
     /* 170482 */     // GIR_Coverage, 1011,
     /* 170482 */     GIR_EraseRootFromParent_Done,
     /* 170483 */   // Label 3708: @170483
     /* 170483 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(170548), // Rule ID 999 //
     /* 170488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170527 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 170530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 170541 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170546 */     GIR_RootConstrainSelectedInstOperands,
     /* 170547 */     // GIR_Coverage, 999,
     /* 170547 */     GIR_EraseRootFromParent_Done,
     /* 170548 */   // Label 3709: @170548
     /* 170548 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(170610), // Rule ID 2281 //
     /* 170553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170572 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170575 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170579 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170585 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170592 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 170595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170597 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170599 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170608 */     GIR_RootConstrainSelectedInstOperands,
     /* 170609 */     // GIR_Coverage, 2281,
     /* 170609 */     GIR_EraseRootFromParent_Done,
     /* 170610 */   // Label 3710: @170610
     /* 170610 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(170672), // Rule ID 2289 //
     /* 170615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170634 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170637 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170641 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170647 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170654 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 170657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170670 */     GIR_RootConstrainSelectedInstOperands,
     /* 170671 */     // GIR_Coverage, 2289,
     /* 170671 */     GIR_EraseRootFromParent_Done,
     /* 170672 */   // Label 3711: @170672
     /* 170672 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(170734), // Rule ID 6088 //
     /* 170677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 170699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 170703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 170707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170716 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 170719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170721 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170723 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 170732 */     GIR_RootConstrainSelectedInstOperands,
     /* 170733 */     // GIR_Coverage, 6088,
     /* 170733 */     GIR_EraseRootFromParent_Done,
     /* 170734 */   // Label 3712: @170734
     /* 170734 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(170771), // Rule ID 905 //
     /* 170739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 170742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 170754 */     // (fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 170754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 170759 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 170765 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 170769 */     GIR_RootConstrainSelectedInstOperands,
     /* 170770 */     // GIR_Coverage, 905,
     /* 170770 */     GIR_Done,
     /* 170771 */   // Label 3713: @170771
     /* 170771 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(170802), // Rule ID 2279 //
     /* 170776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170791 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170791 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 170796 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170800 */     GIR_RootConstrainSelectedInstOperands,
     /* 170801 */     // GIR_Coverage, 2279,
     /* 170801 */     GIR_Done,
     /* 170802 */   // Label 3714: @170802
     /* 170802 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(170833), // Rule ID 2287 //
     /* 170807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 170822 */     // (fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 170822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 170827 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170831 */     GIR_RootConstrainSelectedInstOperands,
     /* 170832 */     // GIR_Coverage, 2287,
     /* 170832 */     GIR_Done,
     /* 170833 */   // Label 3715: @170833
     /* 170833 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(170864), // Rule ID 6086 //
     /* 170838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 170841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 170853 */     // (fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 170853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 170858 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 170862 */     GIR_RootConstrainSelectedInstOperands,
     /* 170863 */     // GIR_Coverage, 6086,
     /* 170863 */     GIR_Done,
     /* 170864 */   // Label 3716: @170864
     /* 170864 */   GIM_Reject,
     /* 170865 */ // Label 3700: @170865
     /* 170865 */ GIM_Reject,
     /* 170866 */ // Label 3685: @170866
     /* 170866 */ GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(171974),
     /* 170871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170877 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(170959), // Rule ID 22488 //
     /* 170882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 170885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170913 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 170920 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 170927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 170931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170933 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 170940 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 170940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 170943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170945 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 170947 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 170951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 170957 */     GIR_RootConstrainSelectedInstOperands,
     /* 170958 */     // GIR_Coverage, 22488,
     /* 170958 */     GIR_EraseRootFromParent_Done,
     /* 170959 */   // Label 3718: @170959
     /* 170959 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(171041), // Rule ID 22489 //
     /* 170964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 170967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 170975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 170983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 170991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 170995 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 170998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 171002 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 171009 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 171013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 171015 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171022 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171027 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171039 */     GIR_RootConstrainSelectedInstOperands,
     /* 171040 */     // GIR_Coverage, 22489,
     /* 171040 */     GIR_EraseRootFromParent_Done,
     /* 171041 */   // Label 3719: @171041
     /* 171041 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(171123), // Rule ID 22490 //
     /* 171046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 171065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 171069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 171073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171077 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 171080 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 171084 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 171091 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 171095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 171097 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171104 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>>))  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171109 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171111 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 171121 */     GIR_RootConstrainSelectedInstOperands,
     /* 171122 */     // GIR_Coverage, 22490,
     /* 171122 */     GIR_EraseRootFromParent_Done,
     /* 171123 */   // Label 3720: @171123
     /* 171123 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(171188), // Rule ID 1035 //
     /* 171128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171143 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171150 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171160 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171167 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 171170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171172 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171174 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171186 */     GIR_RootConstrainSelectedInstOperands,
     /* 171187 */     // GIR_Coverage, 1035,
     /* 171187 */     GIR_EraseRootFromParent_Done,
     /* 171188 */   // Label 3721: @171188
     /* 171188 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(171253), // Rule ID 1037 //
     /* 171193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171208 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171215 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171225 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171232 */     // (fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 171235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171237 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171239 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171251 */     GIR_RootConstrainSelectedInstOperands,
     /* 171252 */     // GIR_Coverage, 1037,
     /* 171252 */     GIR_EraseRootFromParent_Done,
     /* 171253 */   // Label 3722: @171253
     /* 171253 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(171318), // Rule ID 1023 //
     /* 171258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171273 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171280 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171290 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171297 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 171300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171302 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171316 */     GIR_RootConstrainSelectedInstOperands,
     /* 171317 */     // GIR_Coverage, 1023,
     /* 171317 */     GIR_EraseRootFromParent_Done,
     /* 171318 */   // Label 3723: @171318
     /* 171318 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(171390), // Rule ID 1025 //
     /* 171323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 171334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171341 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171345 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171369 */     // (fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 171372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171374 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 171376 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171388 */     GIR_RootConstrainSelectedInstOperands,
     /* 171389 */     // GIR_Coverage, 1025,
     /* 171389 */     GIR_EraseRootFromParent_Done,
     /* 171390 */   // Label 3724: @171390
     /* 171390 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(171455), // Rule ID 1013 //
     /* 171395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171414 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 171421 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171434 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 171437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171439 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171448 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171453 */     GIR_RootConstrainSelectedInstOperands,
     /* 171454 */     // GIR_Coverage, 1013,
     /* 171454 */     GIR_EraseRootFromParent_Done,
     /* 171455 */   // Label 3725: @171455
     /* 171455 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(171520), // Rule ID 1015 //
     /* 171460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 171479 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171499 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 171502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171504 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171506 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171518 */     GIR_RootConstrainSelectedInstOperands,
     /* 171519 */     // GIR_Coverage, 1015,
     /* 171519 */     GIR_EraseRootFromParent_Done,
     /* 171520 */   // Label 3726: @171520
     /* 171520 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(171585), // Rule ID 1001 //
     /* 171525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171564 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 171567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171583 */     GIR_RootConstrainSelectedInstOperands,
     /* 171584 */     // GIR_Coverage, 1001,
     /* 171584 */     GIR_EraseRootFromParent_Done,
     /* 171585 */   // Label 3727: @171585
     /* 171585 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(171657), // Rule ID 1003 //
     /* 171590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171609 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171612 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171616 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 171623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171629 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171636 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 171639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 171650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171655 */     GIR_RootConstrainSelectedInstOperands,
     /* 171656 */     // GIR_Coverage, 1003,
     /* 171656 */     GIR_EraseRootFromParent_Done,
     /* 171657 */   // Label 3728: @171657
     /* 171657 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(171719), // Rule ID 2285 //
     /* 171662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171681 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171688 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171694 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171701 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 171704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171706 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171708 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171712 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171717 */     GIR_RootConstrainSelectedInstOperands,
     /* 171718 */     // GIR_Coverage, 2285,
     /* 171718 */     GIR_EraseRootFromParent_Done,
     /* 171719 */   // Label 3729: @171719
     /* 171719 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(171781), // Rule ID 2293 //
     /* 171724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171743 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171750 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171756 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171763 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 171766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171768 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171770 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171774 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171779 */     GIR_RootConstrainSelectedInstOperands,
     /* 171780 */     // GIR_Coverage, 2293,
     /* 171780 */     GIR_EraseRootFromParent_Done,
     /* 171781 */   // Label 3730: @171781
     /* 171781 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(171843), // Rule ID 6107 //
     /* 171786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 171801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 171805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 171808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 171812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 171816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 171818 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 171825 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 171825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 171828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171830 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 171832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 171836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 171841 */     GIR_RootConstrainSelectedInstOperands,
     /* 171842 */     // GIR_Coverage, 6107,
     /* 171842 */     GIR_EraseRootFromParent_Done,
     /* 171843 */   // Label 3731: @171843
     /* 171843 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(171880), // Rule ID 907 //
     /* 171848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 171851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 171863 */     // (fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 171863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 171868 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 171874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 171878 */     GIR_RootConstrainSelectedInstOperands,
     /* 171879 */     // GIR_Coverage, 907,
     /* 171879 */     GIR_Done,
     /* 171880 */   // Label 3732: @171880
     /* 171880 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(171911), // Rule ID 2283 //
     /* 171885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 171888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171900 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 171905 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171909 */     GIR_RootConstrainSelectedInstOperands,
     /* 171910 */     // GIR_Coverage, 2283,
     /* 171910 */     GIR_Done,
     /* 171911 */   // Label 3733: @171911
     /* 171911 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(171942), // Rule ID 2291 //
     /* 171916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 171919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 171931 */     // (fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 171931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 171936 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171940 */     GIR_RootConstrainSelectedInstOperands,
     /* 171941 */     // GIR_Coverage, 2291,
     /* 171941 */     GIR_Done,
     /* 171942 */   // Label 3734: @171942
     /* 171942 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(171973), // Rule ID 6105 //
     /* 171947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 171962 */     // (fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 171962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 171967 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 171971 */     GIR_RootConstrainSelectedInstOperands,
     /* 171972 */     // GIR_Coverage, 6105,
     /* 171972 */     GIR_Done,
     /* 171973 */   // Label 3735: @171973
     /* 171973 */   GIM_Reject,
     /* 171974 */ // Label 3717: @171974
     /* 171974 */ GIM_Reject,
     /* 171975 */ // Label 3686: @171975
     /* 171975 */ GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(172540),
     /* 171980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 171983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 171986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 171990 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(172051), // Rule ID 1039 //
     /* 171995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 171998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172006 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172013 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172030 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 172033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172037 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172044 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172049 */     GIR_RootConstrainSelectedInstOperands,
     /* 172050 */     // GIR_Coverage, 1039,
     /* 172050 */     GIR_EraseRootFromParent_Done,
     /* 172051 */   // Label 3737: @172051
     /* 172051 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(172112), // Rule ID 1041 //
     /* 172056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172067 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172091 */     // (fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 172094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172096 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172102 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172110 */     GIR_RootConstrainSelectedInstOperands,
     /* 172111 */     // GIR_Coverage, 1041,
     /* 172111 */     GIR_EraseRootFromParent_Done,
     /* 172112 */   // Label 3738: @172112
     /* 172112 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(172180), // Rule ID 1027 //
     /* 172117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172128 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172131 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172135 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172159 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 172162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172178 */     GIR_RootConstrainSelectedInstOperands,
     /* 172179 */     // GIR_Coverage, 1027,
     /* 172179 */     GIR_EraseRootFromParent_Done,
     /* 172180 */   // Label 3739: @172180
     /* 172180 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(172248), // Rule ID 1029 //
     /* 172185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 172192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172199 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172203 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172227 */     // (fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 172230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 172234 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172246 */     GIR_RootConstrainSelectedInstOperands,
     /* 172247 */     // GIR_Coverage, 1029,
     /* 172247 */     GIR_EraseRootFromParent_Done,
     /* 172248 */   // Label 3740: @172248
     /* 172248 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(172309), // Rule ID 1017 //
     /* 172253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172268 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 172275 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172281 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172288 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 172291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172293 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172295 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172307 */     GIR_RootConstrainSelectedInstOperands,
     /* 172308 */     // GIR_Coverage, 1017,
     /* 172308 */     GIR_EraseRootFromParent_Done,
     /* 172309 */   // Label 3741: @172309
     /* 172309 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(172370), // Rule ID 1019 //
     /* 172314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 172329 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172342 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172349 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 172352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172354 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172356 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172368 */     GIR_RootConstrainSelectedInstOperands,
     /* 172369 */     // GIR_Coverage, 1019,
     /* 172369 */     GIR_EraseRootFromParent_Done,
     /* 172370 */   // Label 3742: @172370
     /* 172370 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(172438), // Rule ID 1005 //
     /* 172375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172390 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172393 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172397 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 172404 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172410 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172417 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 172420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172424 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172436 */     GIR_RootConstrainSelectedInstOperands,
     /* 172437 */     // GIR_Coverage, 1005,
     /* 172437 */     GIR_EraseRootFromParent_Done,
     /* 172438 */   // Label 3743: @172438
     /* 172438 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(172506), // Rule ID 1007 //
     /* 172443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172461 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172465 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 172472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172485 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 172488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172490 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172492 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 172499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172504 */     GIR_RootConstrainSelectedInstOperands,
     /* 172505 */     // GIR_Coverage, 1007,
     /* 172505 */     GIR_EraseRootFromParent_Done,
     /* 172506 */   // Label 3744: @172506
     /* 172506 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(172539), // Rule ID 909 //
     /* 172511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 172514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 172522 */     // (fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 172522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 172527 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 172533 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 172537 */     GIR_RootConstrainSelectedInstOperands,
     /* 172538 */     // GIR_Coverage, 909,
     /* 172538 */     GIR_Done,
     /* 172539 */   // Label 3745: @172539
     /* 172539 */   GIM_Reject,
     /* 172540 */ // Label 3736: @172540
     /* 172540 */ GIM_Reject,
     /* 172541 */ // Label 3687: @172541
     /* 172541 */ GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(172770),
     /* 172546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172552 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(172614), // Rule ID 2261 //
     /* 172557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172596 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 172599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172612 */     GIR_RootConstrainSelectedInstOperands,
     /* 172613 */     // GIR_Coverage, 2261,
     /* 172613 */     GIR_EraseRootFromParent_Done,
     /* 172614 */   // Label 3747: @172614
     /* 172614 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(172676), // Rule ID 6660 //
     /* 172619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172638 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172641 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172645 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172651 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172658 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 172661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172663 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172665 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172674 */     GIR_RootConstrainSelectedInstOperands,
     /* 172675 */     // GIR_Coverage, 6660,
     /* 172675 */     GIR_EraseRootFromParent_Done,
     /* 172676 */   // Label 3748: @172676
     /* 172676 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(172707), // Rule ID 2259 //
     /* 172681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172696 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 172701 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172705 */     GIR_RootConstrainSelectedInstOperands,
     /* 172706 */     // GIR_Coverage, 2259,
     /* 172706 */     GIR_Done,
     /* 172707 */   // Label 3749: @172707
     /* 172707 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(172738), // Rule ID 2275 //
     /* 172712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 172715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172727 */     // (fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 172727 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 172732 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172736 */     GIR_RootConstrainSelectedInstOperands,
     /* 172737 */     // GIR_Coverage, 2275,
     /* 172737 */     GIR_Done,
     /* 172738 */   // Label 3750: @172738
     /* 172738 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(172769), // Rule ID 6656 //
     /* 172743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172758 */     // (fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 172758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 172763 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172767 */     GIR_RootConstrainSelectedInstOperands,
     /* 172768 */     // GIR_Coverage, 6656,
     /* 172768 */     GIR_Done,
     /* 172769 */   // Label 3751: @172769
     /* 172769 */   GIM_Reject,
     /* 172770 */ // Label 3746: @172770
     /* 172770 */ GIM_Reject,
     /* 172771 */ // Label 3688: @172771
     /* 172771 */ GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(173000),
     /* 172776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172782 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(172844), // Rule ID 2257 //
     /* 172787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172806 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172809 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172813 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172819 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172826 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 172829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172833 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172842 */     GIR_RootConstrainSelectedInstOperands,
     /* 172843 */     // GIR_Coverage, 2257,
     /* 172843 */     GIR_EraseRootFromParent_Done,
     /* 172844 */   // Label 3753: @172844
     /* 172844 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(172906), // Rule ID 6636 //
     /* 172849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 172864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 172868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 172871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 172875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 172879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 172881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 172888 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 172888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 172891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 172895 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 172899 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 172904 */     GIR_RootConstrainSelectedInstOperands,
     /* 172905 */     // GIR_Coverage, 6636,
     /* 172905 */     GIR_EraseRootFromParent_Done,
     /* 172906 */   // Label 3754: @172906
     /* 172906 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(172937), // Rule ID 2255 //
     /* 172911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 172914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172926 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 172931 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172935 */     GIR_RootConstrainSelectedInstOperands,
     /* 172936 */     // GIR_Coverage, 2255,
     /* 172936 */     GIR_Done,
     /* 172937 */   // Label 3755: @172937
     /* 172937 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(172968), // Rule ID 2271 //
     /* 172942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 172945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 172957 */     // (fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 172957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 172962 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172966 */     GIR_RootConstrainSelectedInstOperands,
     /* 172967 */     // GIR_Coverage, 2271,
     /* 172967 */     GIR_Done,
     /* 172968 */   // Label 3756: @172968
     /* 172968 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(172999), // Rule ID 6632 //
     /* 172973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 172976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 172988 */     // (fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 172988 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 172993 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 172997 */     GIR_RootConstrainSelectedInstOperands,
     /* 172998 */     // GIR_Coverage, 6632,
     /* 172998 */     GIR_Done,
     /* 172999 */   // Label 3757: @172999
     /* 172999 */   GIM_Reject,
     /* 173000 */ // Label 3752: @173000
     /* 173000 */ GIM_Reject,
     /* 173001 */ // Label 3689: @173001
     /* 173001 */ GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(173199),
     /* 173006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 173009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 173012 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(173074), // Rule ID 2269 //
     /* 173017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173056 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 173059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173072 */     GIR_RootConstrainSelectedInstOperands,
     /* 173073 */     // GIR_Coverage, 2269,
     /* 173073 */     GIR_EraseRootFromParent_Done,
     /* 173074 */   // Label 3759: @173074
     /* 173074 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(173136), // Rule ID 6672 //
     /* 173079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173118 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 173121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173123 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173125 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173134 */     GIR_RootConstrainSelectedInstOperands,
     /* 173135 */     // GIR_Coverage, 6672,
     /* 173135 */     GIR_EraseRootFromParent_Done,
     /* 173136 */   // Label 3760: @173136
     /* 173136 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(173167), // Rule ID 2267 //
     /* 173141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173156 */     // (fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 173156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 173161 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173165 */     GIR_RootConstrainSelectedInstOperands,
     /* 173166 */     // GIR_Coverage, 2267,
     /* 173166 */     GIR_Done,
     /* 173167 */   // Label 3761: @173167
     /* 173167 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(173198), // Rule ID 6668 //
     /* 173172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173187 */     // (fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 173187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 173192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173196 */     GIR_RootConstrainSelectedInstOperands,
     /* 173197 */     // GIR_Coverage, 6668,
     /* 173197 */     GIR_Done,
     /* 173198 */   // Label 3762: @173198
     /* 173198 */   GIM_Reject,
     /* 173199 */ // Label 3758: @173199
     /* 173199 */ GIM_Reject,
     /* 173200 */ // Label 3690: @173200
     /* 173200 */ GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(173297),
     /* 173205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173219 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(173273), // Rule ID 6696 //
     /* 173224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173235 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173242 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173255 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 173258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173260 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173262 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173271 */     GIR_RootConstrainSelectedInstOperands,
     /* 173272 */     // GIR_Coverage, 6696,
     /* 173272 */     GIR_EraseRootFromParent_Done,
     /* 173273 */   // Label 3764: @173273
     /* 173273 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(173296), // Rule ID 6692 //
     /* 173278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 173285 */     // (fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 173285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 173290 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173294 */     GIR_RootConstrainSelectedInstOperands,
     /* 173295 */     // GIR_Coverage, 6692,
     /* 173295 */     GIR_Done,
     /* 173296 */   // Label 3765: @173296
     /* 173296 */   GIM_Reject,
     /* 173297 */ // Label 3763: @173297
     /* 173297 */ GIM_Reject,
     /* 173298 */ // Label 3691: @173298
     /* 173298 */ GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(173496),
     /* 173303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 173306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 173309 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(173371), // Rule ID 2265 //
     /* 173314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173353 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 173356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173358 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173369 */     GIR_RootConstrainSelectedInstOperands,
     /* 173370 */     // GIR_Coverage, 2265,
     /* 173370 */     GIR_EraseRootFromParent_Done,
     /* 173371 */   // Label 3767: @173371
     /* 173371 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(173433), // Rule ID 6648 //
     /* 173376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173415 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 173418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173431 */     GIR_RootConstrainSelectedInstOperands,
     /* 173432 */     // GIR_Coverage, 6648,
     /* 173432 */     GIR_EraseRootFromParent_Done,
     /* 173433 */   // Label 3768: @173433
     /* 173433 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(173464), // Rule ID 2263 //
     /* 173438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 173441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 173453 */     // (fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 173453 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 173458 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173462 */     GIR_RootConstrainSelectedInstOperands,
     /* 173463 */     // GIR_Coverage, 2263,
     /* 173463 */     GIR_Done,
     /* 173464 */   // Label 3769: @173464
     /* 173464 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(173495), // Rule ID 6644 //
     /* 173469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 173472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173484 */     // (fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 173484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 173489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173493 */     GIR_RootConstrainSelectedInstOperands,
     /* 173494 */     // GIR_Coverage, 6644,
     /* 173494 */     GIR_Done,
     /* 173495 */   // Label 3770: @173495
     /* 173495 */   GIM_Reject,
     /* 173496 */ // Label 3766: @173496
     /* 173496 */ GIM_Reject,
     /* 173497 */ // Label 3692: @173497
     /* 173497 */ GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(173594),
     /* 173502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 173505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 173508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173516 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(173570), // Rule ID 6624 //
     /* 173521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173532 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173539 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173545 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173552 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 173555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173557 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173559 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173568 */     GIR_RootConstrainSelectedInstOperands,
     /* 173569 */     // GIR_Coverage, 6624,
     /* 173569 */     GIR_EraseRootFromParent_Done,
     /* 173570 */   // Label 3772: @173570
     /* 173570 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(173593), // Rule ID 6620 //
     /* 173575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173582 */     // (fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 173582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 173587 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173591 */     GIR_RootConstrainSelectedInstOperands,
     /* 173592 */     // GIR_Coverage, 6620,
     /* 173592 */     GIR_Done,
     /* 173593 */   // Label 3773: @173593
     /* 173593 */   GIM_Reject,
     /* 173594 */ // Label 3771: @173594
     /* 173594 */ GIM_Reject,
     /* 173595 */ // Label 3693: @173595
     /* 173595 */ GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(173692),
     /* 173600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 173603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 173606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173614 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(173668), // Rule ID 6708 //
     /* 173619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173643 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173650 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 173653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173655 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173666 */     GIR_RootConstrainSelectedInstOperands,
     /* 173667 */     // GIR_Coverage, 6708,
     /* 173667 */     GIR_EraseRootFromParent_Done,
     /* 173668 */   // Label 3775: @173668
     /* 173668 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(173691), // Rule ID 6704 //
     /* 173673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 173676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 173680 */     // (fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 173680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 173685 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173689 */     GIR_RootConstrainSelectedInstOperands,
     /* 173690 */     // GIR_Coverage, 6704,
     /* 173690 */     GIR_Done,
     /* 173691 */   // Label 3776: @173691
     /* 173691 */   GIM_Reject,
     /* 173692 */ // Label 3774: @173692
     /* 173692 */ GIM_Reject,
     /* 173693 */ // Label 3694: @173693
     /* 173693 */ GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(173790),
     /* 173698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 173701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 173704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173712 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(173766), // Rule ID 6612 //
     /* 173717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173728 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173735 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173741 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173748 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 173751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173755 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173764 */     GIR_RootConstrainSelectedInstOperands,
     /* 173765 */     // GIR_Coverage, 6612,
     /* 173765 */     GIR_EraseRootFromParent_Done,
     /* 173766 */   // Label 3778: @173766
     /* 173766 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(173789), // Rule ID 6608 //
     /* 173771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 173774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173778 */     // (fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 173778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 173783 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173787 */     GIR_RootConstrainSelectedInstOperands,
     /* 173788 */     // GIR_Coverage, 6608,
     /* 173788 */     GIR_Done,
     /* 173789 */   // Label 3779: @173789
     /* 173789 */   GIM_Reject,
     /* 173790 */ // Label 3777: @173790
     /* 173790 */ GIM_Reject,
     /* 173791 */ // Label 3695: @173791
     /* 173791 */ GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(173888),
     /* 173796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 173799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 173802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173810 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(173864), // Rule ID 6684 //
     /* 173815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 173822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 173826 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 173829 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 173833 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 173837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 173839 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 173846 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 173846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 173849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 173853 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 173857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 173862 */     GIR_RootConstrainSelectedInstOperands,
     /* 173863 */     // GIR_Coverage, 6684,
     /* 173863 */     GIR_EraseRootFromParent_Done,
     /* 173864 */   // Label 3781: @173864
     /* 173864 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(173887), // Rule ID 6680 //
     /* 173869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 173872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 173876 */     // (fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 173876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 173881 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 173885 */     GIR_RootConstrainSelectedInstOperands,
     /* 173886 */     // GIR_Coverage, 6680,
     /* 173886 */     GIR_Done,
     /* 173887 */   // Label 3782: @173887
     /* 173887 */   GIM_Reject,
     /* 173888 */ // Label 3780: @173888
     /* 173888 */ GIM_Reject,
     /* 173889 */ // Label 3696: @173889
     /* 173889 */ GIM_Reject,
     /* 173890 */ // Label 46: @173890
     /* 173890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 3786*/ GIMT_Encode4(174012),
     /* 173901 */ /*GILLT_s32*//*Label 3783*/ GIMT_Encode4(173913),
     /* 173905 */ /*GILLT_s64*//*Label 3784*/ GIMT_Encode4(173946),
     /* 173909 */ /*GILLT_s80*//*Label 3785*/ GIMT_Encode4(173979),
     /* 173913 */ // Label 3783: @173913
     /* 173913 */ GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(173945), // Rule ID 1042 //
     /* 173918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 173921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 173924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 173932 */   // (fneg:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (CHS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 173932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp32),
     /* 173937 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173943 */   GIR_RootConstrainSelectedInstOperands,
     /* 173944 */   // GIR_Coverage, 1042,
     /* 173944 */   GIR_Done,
     /* 173945 */ // Label 3787: @173945
     /* 173945 */ GIM_Reject,
     /* 173946 */ // Label 3784: @173946
     /* 173946 */ GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(173978), // Rule ID 1043 //
     /* 173951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 173954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 173957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 173965 */   // (fneg:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (CHS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 173965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp64),
     /* 173970 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 173976 */   GIR_RootConstrainSelectedInstOperands,
     /* 173977 */   // GIR_Coverage, 1043,
     /* 173977 */   GIR_Done,
     /* 173978 */ // Label 3788: @173978
     /* 173978 */ GIM_Reject,
     /* 173979 */ // Label 3785: @173979
     /* 173979 */ GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(174011), // Rule ID 1044 //
     /* 173984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 173987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 173990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 173998 */   // (fneg:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (CHS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 173998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CHS_Fp80),
     /* 174003 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 174009 */   GIR_RootConstrainSelectedInstOperands,
     /* 174010 */   // GIR_Coverage, 1044,
     /* 174010 */   GIR_Done,
     /* 174011 */ // Label 3789: @174011
     /* 174011 */ GIM_Reject,
     /* 174012 */ // Label 3786: @174012
     /* 174012 */ GIM_Reject,
     /* 174013 */ // Label 47: @174013
     /* 174013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(20), /*)*//*default:*//*Label 3797*/ GIMT_Encode4(174944),
     /* 174024 */ /*GILLT_s32*//*Label 3790*/ GIMT_Encode4(174092),
     /* 174028 */ /*GILLT_s64*//*Label 3791*/ GIMT_Encode4(174213),
     /* 174032 */ /*GILLT_s80*//*Label 3792*/ GIMT_Encode4(174696), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174056 */ /*GILLT_v4s64*//*Label 3793*/ GIMT_Encode4(174757), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174068 */ /*GILLT_v8s32*//*Label 3794*/ GIMT_Encode4(174821),
     /* 174072 */ /*GILLT_v8s64*//*Label 3795*/ GIMT_Encode4(174852), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 174088 */ /*GILLT_v16s32*//*Label 3796*/ GIMT_Encode4(174913),
     /* 174092 */ // Label 3790: @174092
     /* 174092 */ GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(174212),
     /* 174097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174104 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(174173), // Rule ID 21204 //
     /* 174109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174120 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174123 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174127 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174140 */     // (fpextend:{ *:[f32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 174140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrm),
     /* 174157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174162 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174171 */     GIR_RootConstrainSelectedInstOperands,
     /* 174172 */     // GIR_Coverage, 21204,
     /* 174172 */     GIR_EraseRootFromParent_Done,
     /* 174173 */   // Label 3799: @174173
     /* 174173 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(174211), // Rule ID 21202 //
     /* 174178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174185 */     // (fpextend:{ *:[f32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR16X:{ *:[f16] }:$src)
     /* 174185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 174188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SSZrr),
     /* 174202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174207 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174209 */     GIR_RootConstrainSelectedInstOperands,
     /* 174210 */     // GIR_Coverage, 21202,
     /* 174210 */     GIR_EraseRootFromParent_Done,
     /* 174211 */   // Label 3800: @174211
     /* 174211 */   GIM_Reject,
     /* 174212 */ // Label 3798: @174212
     /* 174212 */ GIM_Reject,
     /* 174213 */ // Label 3791: @174213
     /* 174213 */ GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(174272), // Rule ID 1894 //
     /* 174218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 174221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174228 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174232 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174236 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174239 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174243 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174249 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174256 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSS2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 174256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrm),
     /* 174259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174261 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174265 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174270 */   GIR_RootConstrainSelectedInstOperands,
     /* 174271 */   // GIR_Coverage, 1894,
     /* 174271 */   GIR_EraseRootFromParent_Done,
     /* 174272 */ // Label 3801: @174272
     /* 174272 */ GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(174348), // Rule ID 18002 //
     /* 174277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 174280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174287 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174295 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174298 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174302 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174306 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174308 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174315 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrm),
     /* 174332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174334 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174337 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174346 */   GIR_RootConstrainSelectedInstOperands,
     /* 174347 */   // GIR_Coverage, 18002,
     /* 174347 */   GIR_EraseRootFromParent_Done,
     /* 174348 */ // Label 3802: @174348
     /* 174348 */ GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(174424), // Rule ID 21198 //
     /* 174353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 174356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174371 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174378 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174382 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174384 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174391 */   // (fpextend:{ *:[f64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSS2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrm),
     /* 174408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174413 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174422 */   GIR_RootConstrainSelectedInstOperands,
     /* 174423 */   // GIR_Coverage, 21198,
     /* 174423 */   GIR_EraseRootFromParent_Done,
     /* 174424 */ // Label 3803: @174424
     /* 174424 */ GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(174500), // Rule ID 21208 //
     /* 174429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 174432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174439 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 174443 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 174447 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 174450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 174454 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 174458 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 174460 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 174467 */   // (fpextend:{ *:[f64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSH2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 174467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrm),
     /* 174484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174489 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 174493 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 174498 */   GIR_RootConstrainSelectedInstOperands,
     /* 174499 */   // GIR_Coverage, 21208,
     /* 174499 */   GIR_EraseRootFromParent_Done,
     /* 174500 */ // Label 3804: @174500
     /* 174500 */ GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(174530), // Rule ID 1892 //
     /* 174505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 174508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174519 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (CVTSS2SDrr:{ *:[f64] } FR32:{ *:[f32] }:$src)
     /* 174519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSS2SDrr),
     /* 174524 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174528 */   GIR_RootConstrainSelectedInstOperands,
     /* 174529 */   // GIR_Coverage, 1892,
     /* 174529 */   GIR_Done,
     /* 174530 */ // Label 3805: @174530
     /* 174530 */ GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(174560), // Rule ID 17727 //
     /* 174535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174549 */   // (fpextend:{ *:[f64] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP32:{ *:[f32] }:$src, RFP64:{ *:[i32] })
     /* 174549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 174559 */   // GIR_Coverage, 17727,
     /* 174559 */   GIR_Done,
     /* 174560 */ // Label 3806: @174560
     /* 174560 */ GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(174605), // Rule ID 18000 //
     /* 174565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 174568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 174575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 174579 */   // (fpextend:{ *:[f64] } FR32:{ *:[f32] }:$src)  =>  (VCVTSS2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32:{ *:[f32] }:$src)
     /* 174579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDrr),
     /* 174596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174603 */   GIR_RootConstrainSelectedInstOperands,
     /* 174604 */   // GIR_Coverage, 18000,
     /* 174604 */   GIR_EraseRootFromParent_Done,
     /* 174605 */ // Label 3807: @174605
     /* 174605 */ GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(174650), // Rule ID 21196 //
     /* 174610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174624 */   // (fpextend:{ *:[f64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR32X:{ *:[f32] }:$src)
     /* 174624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SDZrr),
     /* 174641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174648 */   GIR_RootConstrainSelectedInstOperands,
     /* 174649 */   // GIR_Coverage, 21196,
     /* 174649 */   GIR_EraseRootFromParent_Done,
     /* 174650 */ // Label 3808: @174650
     /* 174650 */ GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(174695), // Rule ID 21206 //
     /* 174655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 174661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 174665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174669 */   // (fpextend:{ *:[f64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTSH2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR16X:{ *:[f16] }:$src)
     /* 174669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 174672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSH2SDZrr),
     /* 174686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174691 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 174693 */   GIR_RootConstrainSelectedInstOperands,
     /* 174694 */   // GIR_Coverage, 21206,
     /* 174694 */   GIR_EraseRootFromParent_Done,
     /* 174695 */ // Label 3809: @174695
     /* 174695 */ GIM_Reject,
     /* 174696 */ // Label 3792: @174696
     /* 174696 */ GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(174726), // Rule ID 17729 //
     /* 174701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 174704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 174715 */   // (fpextend:{ *:[f80] } RFP32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP32:{ *:[f32] }:$src, RFP80:{ *:[i32] })
     /* 174715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174725 */   // GIR_Coverage, 17729,
     /* 174725 */   GIR_Done,
     /* 174726 */ // Label 3810: @174726
     /* 174726 */ GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(174756), // Rule ID 17731 //
     /* 174731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 174734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 174737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 174741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 174745 */   // (fpextend:{ *:[f80] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f80] } RFP64:{ *:[f64] }:$src, RFP80:{ *:[i32] })
     /* 174745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP80RegClassID),
     /* 174755 */   // GIR_Coverage, 17731,
     /* 174755 */   GIR_Done,
     /* 174756 */ // Label 3811: @174756
     /* 174756 */ GIM_Reject,
     /* 174757 */ // Label 3793: @174757
     /* 174757 */ GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(174820),
     /* 174762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174765 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(174792), // Rule ID 1935 //
     /* 174770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 174773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 174777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 174781 */     // (fpextend:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDYrr:{ *:[v4f64] } VR128:{ *:[v4f32] }:$src)
     /* 174781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDYrr),
     /* 174786 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174790 */     GIR_RootConstrainSelectedInstOperands,
     /* 174791 */     // GIR_Coverage, 1935,
     /* 174791 */     GIR_Done,
     /* 174792 */   // Label 3813: @174792
     /* 174792 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(174819), // Rule ID 10575 //
     /* 174797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 174800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174808 */     // (fpextend:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)  =>  (VCVTPS2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4f32] }:$src)
     /* 174808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZ256rr),
     /* 174813 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174817 */     GIR_RootConstrainSelectedInstOperands,
     /* 174818 */     // GIR_Coverage, 10575,
     /* 174818 */     GIR_Done,
     /* 174819 */   // Label 3814: @174819
     /* 174819 */   GIM_Reject,
     /* 174820 */ // Label 3812: @174820
     /* 174820 */ GIM_Reject,
     /* 174821 */ // Label 3794: @174821
     /* 174821 */ GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(174851), // Rule ID 10638 //
     /* 174826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 174829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174840 */   // (fpextend:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PSXZ256rr:{ *:[v8f32] } VR128X:{ *:[v8f16] }:$src)
     /* 174840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZ256rr),
     /* 174845 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174849 */   GIR_RootConstrainSelectedInstOperands,
     /* 174850 */   // GIR_Coverage, 10638,
     /* 174850 */   GIR_Done,
     /* 174851 */ // Label 3815: @174851
     /* 174851 */ GIM_Reject,
     /* 174852 */ // Label 3795: @174852
     /* 174852 */ GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(174882), // Rule ID 10550 //
     /* 174857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 174860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 174863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174871 */   // (fpextend:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)  =>  (VCVTPS2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8f32] }:$src)
     /* 174871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPS2PDZrr),
     /* 174876 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174880 */   GIR_RootConstrainSelectedInstOperands,
     /* 174881 */   // GIR_Coverage, 10550,
     /* 174881 */   GIR_Done,
     /* 174882 */ // Label 3816: @174882
     /* 174882 */ GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(174912), // Rule ID 10664 //
     /* 174887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 174901 */   // (fpextend:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)  =>  (VCVTPH2PDZrr:{ *:[v8f64] } VR128X:{ *:[v8f16] }:$src)
     /* 174901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PDZrr),
     /* 174906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174910 */   GIR_RootConstrainSelectedInstOperands,
     /* 174911 */   // GIR_Coverage, 10664,
     /* 174911 */   GIR_Done,
     /* 174912 */ // Label 3817: @174912
     /* 174912 */ GIM_Reject,
     /* 174913 */ // Label 3796: @174913
     /* 174913 */ GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(174943), // Rule ID 10613 //
     /* 174918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 174924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 174928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 174932 */   // (fpextend:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)  =>  (VCVTPH2PSXZrr:{ *:[v16f32] } VR256X:{ *:[v16f16] }:$src)
     /* 174932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTPH2PSXZrr),
     /* 174937 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 174941 */   GIR_RootConstrainSelectedInstOperands,
     /* 174942 */   // GIR_Coverage, 10613,
     /* 174942 */   GIR_Done,
     /* 174943 */ // Label 3818: @174943
     /* 174943 */ GIM_Reject,
     /* 174944 */ // Label 3797: @174944
     /* 174944 */ GIM_Reject,
     /* 174945 */ // Label 48: @174945
     /* 174945 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 3822*/ GIMT_Encode4(175330),
     /* 174956 */ /*GILLT_s16*//*Label 3819*/ GIMT_Encode4(174968),
     /* 174960 */ /*GILLT_s32*//*Label 3820*/ GIMT_Encode4(175059),
     /* 174964 */ /*GILLT_s64*//*Label 3821*/ GIMT_Encode4(175299),
     /* 174968 */ // Label 3819: @174968
     /* 174968 */ GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(175013), // Rule ID 21210 //
     /* 174973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 174976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 174979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 174983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 174987 */   // (fpround:{ *:[f16] } FR32X:{ *:[f32] }:$src)  =>  (VCVTSS2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR32X:{ *:[f32] }:$src)
     /* 174987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSS2SHZrr),
     /* 175004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175011 */   GIR_RootConstrainSelectedInstOperands,
     /* 175012 */   // GIR_Coverage, 21210,
     /* 175012 */   GIR_EraseRootFromParent_Done,
     /* 175013 */ // Label 3823: @175013
     /* 175013 */ GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(175058), // Rule ID 21212 //
     /* 175018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175032 */   // (fpround:{ *:[f16] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR64X:{ *:[f64] }:$src)
     /* 175032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SHZrr),
     /* 175049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175056 */   GIR_RootConstrainSelectedInstOperands,
     /* 175057 */   // GIR_Coverage, 21212,
     /* 175057 */   GIR_EraseRootFromParent_Done,
     /* 175058 */ // Label 3824: @175058
     /* 175058 */ GIM_Reject,
     /* 175059 */ // Label 3820: @175059
     /* 175059 */ GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(175118), // Rule ID 1882 //
     /* 175064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 175067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175074 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175078 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175082 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175085 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175089 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175093 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175095 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175102 */   // (fpround:{ *:[f32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSD2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 175102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrm),
     /* 175105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175107 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175111 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175116 */   GIR_RootConstrainSelectedInstOperands,
     /* 175117 */   // GIR_Coverage, 1882,
     /* 175117 */   GIR_EraseRootFromParent_Done,
     /* 175118 */ // Label 3825: @175118
     /* 175118 */ GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(175148), // Rule ID 1880 //
     /* 175123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175137 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (CVTSD2SSrr:{ *:[f32] } FR64:{ *:[f64] }:$src)
     /* 175137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSD2SSrr),
     /* 175142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175146 */   GIR_RootConstrainSelectedInstOperands,
     /* 175147 */   // GIR_Coverage, 1880,
     /* 175147 */   GIR_Done,
     /* 175148 */ // Label 3826: @175148
     /* 175148 */ GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(175178), // Rule ID 17733 //
     /* 175153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175167 */   // (fpround:{ *:[f32] } RFP64:{ *:[f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP64:{ *:[f64] }:$src, RFP32:{ *:[i32] })
     /* 175167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175177 */   // GIR_Coverage, 17733,
     /* 175177 */   GIR_Done,
     /* 175178 */ // Label 3827: @175178
     /* 175178 */ GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(175208), // Rule ID 17735 //
     /* 175183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 175186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 175193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175197 */   // (fpround:{ *:[f32] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } RFP80:{ *:[f80] }:$src, RFP32:{ *:[i32] })
     /* 175197 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP32RegClassID),
     /* 175207 */   // GIR_Coverage, 17735,
     /* 175207 */   GIR_Done,
     /* 175208 */ // Label 3828: @175208
     /* 175208 */ GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(175253), // Rule ID 17998 //
     /* 175213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175227 */   // (fpround:{ *:[f32] } FR64:{ *:[f64] }:$src)  =>  (VCVTSD2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64:{ *:[f64] }:$src)
     /* 175227 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175230 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175234 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSrr),
     /* 175244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175251 */   GIR_RootConstrainSelectedInstOperands,
     /* 175252 */   // GIR_Coverage, 17998,
     /* 175252 */   GIR_EraseRootFromParent_Done,
     /* 175253 */ // Label 3829: @175253
     /* 175253 */ GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(175298), // Rule ID 21200 //
     /* 175258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175272 */   // (fpround:{ *:[f32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTSD2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR64X:{ *:[f64] }:$src)
     /* 175272 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175275 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 175279 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 175286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSD2SSZrr),
     /* 175289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175294 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 175296 */   GIR_RootConstrainSelectedInstOperands,
     /* 175297 */   // GIR_Coverage, 21200,
     /* 175297 */   GIR_EraseRootFromParent_Done,
     /* 175298 */ // Label 3830: @175298
     /* 175298 */ GIM_Reject,
     /* 175299 */ // Label 3821: @175299
     /* 175299 */ GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(175329), // Rule ID 17737 //
     /* 175304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 175307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 175310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 175314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 175318 */   // (fpround:{ *:[f64] } RFP80:{ *:[f80] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } RFP80:{ *:[f80] }:$src, RFP64:{ *:[i32] })
     /* 175318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::RFP64RegClassID),
     /* 175328 */   // GIR_Coverage, 17737,
     /* 175328 */   GIR_Done,
     /* 175329 */ // Label 3831: @175329
     /* 175329 */ GIM_Reject,
     /* 175330 */ // Label 3822: @175330
     /* 175330 */ GIM_Reject,
     /* 175331 */ // Label 49: @175331
     /* 175331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 3835*/ GIMT_Encode4(176711),
     /* 175342 */ /*GILLT_s32*//*Label 3832*/ GIMT_Encode4(175374),
     /* 175346 */ /*GILLT_s64*//*Label 3833*/ GIMT_Encode4(175998), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 175370 */ /*GILLT_v4s32*//*Label 3834*/ GIMT_Encode4(176622),
     /* 175374 */ // Label 3832: @175374
     /* 175374 */ GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(175433), // Rule ID 1742 //
     /* 175379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175397 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175404 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175410 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175417 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrm),
     /* 175420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175422 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175431 */   GIR_RootConstrainSelectedInstOperands,
     /* 175432 */   // GIR_Coverage, 1742,
     /* 175432 */   GIR_EraseRootFromParent_Done,
     /* 175433 */ // Label 3836: @175433
     /* 175433 */ GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(175492), // Rule ID 1750 //
     /* 175438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175456 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175463 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175469 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175476 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrm),
     /* 175479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175490 */   GIR_RootConstrainSelectedInstOperands,
     /* 175491 */   // GIR_Coverage, 1750,
     /* 175491 */   GIR_EraseRootFromParent_Done,
     /* 175492 */ // Label 3837: @175492
     /* 175492 */ GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(175551), // Rule ID 1766 //
     /* 175497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175515 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175518 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175522 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175528 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175535 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrm),
     /* 175538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175540 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175544 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175549 */   GIR_RootConstrainSelectedInstOperands,
     /* 175550 */   // GIR_Coverage, 1766,
     /* 175550 */   GIR_EraseRootFromParent_Done,
     /* 175551 */ // Label 3838: @175551
     /* 175551 */ GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(175610), // Rule ID 1774 //
     /* 175556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175566 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175570 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175574 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175577 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175581 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175585 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175587 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175594 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SIrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrm),
     /* 175597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175599 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175603 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175608 */   GIR_RootConstrainSelectedInstOperands,
     /* 175609 */   // GIR_Coverage, 1774,
     /* 175609 */   GIR_EraseRootFromParent_Done,
     /* 175610 */ // Label 3839: @175610
     /* 175610 */ GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(175669), // Rule ID 10363 //
     /* 175615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175625 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175629 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175633 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175636 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175640 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175644 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175646 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175653 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrm),
     /* 175656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175667 */   GIR_RootConstrainSelectedInstOperands,
     /* 175668 */   // GIR_Coverage, 10363,
     /* 175668 */   GIR_EraseRootFromParent_Done,
     /* 175669 */ // Label 3840: @175669
     /* 175669 */ GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(175728), // Rule ID 10381 //
     /* 175674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175692 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175695 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175699 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175705 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175712 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrm),
     /* 175715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175717 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175726 */   GIR_RootConstrainSelectedInstOperands,
     /* 175727 */   // GIR_Coverage, 10381,
     /* 175727 */   GIR_EraseRootFromParent_Done,
     /* 175728 */ // Label 3841: @175728
     /* 175728 */ GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(175787), // Rule ID 15171 //
     /* 175733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 175747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 175751 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 175754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 175758 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 175762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 175764 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 175771 */   // (fp_to_sint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 175771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrm),
     /* 175774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 175776 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 175780 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 175785 */   GIR_RootConstrainSelectedInstOperands,
     /* 175786 */   // GIR_Coverage, 15171,
     /* 175786 */   GIR_EraseRootFromParent_Done,
     /* 175787 */ // Label 3842: @175787
     /* 175787 */ GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(175817), // Rule ID 1740 //
     /* 175792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175806 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIrr),
     /* 175811 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175815 */   GIR_RootConstrainSelectedInstOperands,
     /* 175816 */   // GIR_Coverage, 1740,
     /* 175816 */   GIR_Done,
     /* 175817 */ // Label 3843: @175817
     /* 175817 */ GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(175847), // Rule ID 1748 //
     /* 175822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 175825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175836 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIrr),
     /* 175841 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175845 */   GIR_RootConstrainSelectedInstOperands,
     /* 175846 */   // GIR_Coverage, 1748,
     /* 175846 */   GIR_Done,
     /* 175847 */ // Label 3844: @175847
     /* 175847 */ GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(175877), // Rule ID 1764 //
     /* 175852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 175855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 175866 */   // (fp_to_sint:{ *:[i32] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SIrr:{ *:[i32] } FR32:{ *:[f32] }:$src)
     /* 175866 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SIrr),
     /* 175871 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175875 */   GIR_RootConstrainSelectedInstOperands,
     /* 175876 */   // GIR_Coverage, 1764,
     /* 175876 */   GIR_Done,
     /* 175877 */ // Label 3845: @175877
     /* 175877 */ GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(175907), // Rule ID 1772 //
     /* 175882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 175885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 175896 */   // (fp_to_sint:{ *:[i32] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SIrr:{ *:[i32] } FR64:{ *:[f64] }:$src)
     /* 175896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SIrr),
     /* 175901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175905 */   GIR_RootConstrainSelectedInstOperands,
     /* 175906 */   // GIR_Coverage, 1772,
     /* 175906 */   GIR_Done,
     /* 175907 */ // Label 3846: @175907
     /* 175907 */ GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(175937), // Rule ID 10361 //
     /* 175912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 175918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 175926 */   // (fp_to_sint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 175926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SIZrr),
     /* 175931 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175935 */   GIR_RootConstrainSelectedInstOperands,
     /* 175936 */   // GIR_Coverage, 10361,
     /* 175936 */   GIR_Done,
     /* 175937 */ // Label 3847: @175937
     /* 175937 */ GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(175967), // Rule ID 10379 //
     /* 175942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 175945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 175948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 175956 */   // (fp_to_sint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 175956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SIZrr),
     /* 175961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175965 */   GIR_RootConstrainSelectedInstOperands,
     /* 175966 */   // GIR_Coverage, 10379,
     /* 175966 */   GIR_Done,
     /* 175967 */ // Label 3848: @175967
     /* 175967 */ GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(175997), // Rule ID 15169 //
     /* 175972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 175975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 175978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 175982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 175986 */   // (fp_to_sint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 175986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SIZrr),
     /* 175991 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 175995 */   GIR_RootConstrainSelectedInstOperands,
     /* 175996 */   // GIR_Coverage, 15169,
     /* 175996 */   GIR_Done,
     /* 175997 */ // Label 3849: @175997
     /* 175997 */ GIM_Reject,
     /* 175998 */ // Label 3833: @175998
     /* 175998 */ GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(176057), // Rule ID 1746 //
     /* 176003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176013 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176017 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176021 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176024 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176028 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176034 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176041 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rm),
     /* 176044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176046 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176050 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176055 */   GIR_RootConstrainSelectedInstOperands,
     /* 176056 */   // GIR_Coverage, 1746,
     /* 176056 */   GIR_EraseRootFromParent_Done,
     /* 176057 */ // Label 3850: @176057
     /* 176057 */ GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(176116), // Rule ID 1754 //
     /* 176062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176072 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176076 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176080 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176087 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176093 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176100 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rm),
     /* 176103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176105 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176114 */   GIR_RootConstrainSelectedInstOperands,
     /* 176115 */   // GIR_Coverage, 1754,
     /* 176115 */   GIR_EraseRootFromParent_Done,
     /* 176116 */ // Label 3851: @176116
     /* 176116 */ GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(176175), // Rule ID 1770 //
     /* 176121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176131 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176135 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176139 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176142 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176146 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176150 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176152 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176159 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSS2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rm),
     /* 176162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176164 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176173 */   GIR_RootConstrainSelectedInstOperands,
     /* 176174 */   // GIR_Coverage, 1770,
     /* 176174 */   GIR_EraseRootFromParent_Done,
     /* 176175 */ // Label 3852: @176175
     /* 176175 */ GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(176234), // Rule ID 1778 //
     /* 176180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176190 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176194 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176198 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176201 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176205 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176209 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176211 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176218 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTTSD2SI64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rm),
     /* 176221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176223 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176232 */   GIR_RootConstrainSelectedInstOperands,
     /* 176233 */   // GIR_Coverage, 1778,
     /* 176233 */   GIR_EraseRootFromParent_Done,
     /* 176234 */ // Label 3853: @176234
     /* 176234 */ GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(176293), // Rule ID 10372 //
     /* 176239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176249 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176253 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176257 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176264 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176270 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176277 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrm),
     /* 176280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176282 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176286 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176291 */   GIR_RootConstrainSelectedInstOperands,
     /* 176292 */   // GIR_Coverage, 10372,
     /* 176292 */   GIR_EraseRootFromParent_Done,
     /* 176293 */ // Label 3854: @176293
     /* 176293 */ GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(176352), // Rule ID 10390 //
     /* 176298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176316 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176319 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176323 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176327 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176329 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176336 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrm),
     /* 176339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176341 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176350 */   GIR_RootConstrainSelectedInstOperands,
     /* 176351 */   // GIR_Coverage, 10390,
     /* 176351 */   GIR_EraseRootFromParent_Done,
     /* 176352 */ // Label 3855: @176352
     /* 176352 */ GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(176411), // Rule ID 15180 //
     /* 176357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176367 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176371 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176375 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176378 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176382 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176386 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176388 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176395 */   // (fp_to_sint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2SI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 176395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrm),
     /* 176398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176400 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176409 */   GIR_RootConstrainSelectedInstOperands,
     /* 176410 */   // GIR_Coverage, 15180,
     /* 176410 */   GIR_EraseRootFromParent_Done,
     /* 176411 */ // Label 3856: @176411
     /* 176411 */ GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(176441), // Rule ID 1744 //
     /* 176416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176430 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64rr),
     /* 176435 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176439 */   GIR_RootConstrainSelectedInstOperands,
     /* 176440 */   // GIR_Coverage, 1744,
     /* 176440 */   GIR_Done,
     /* 176441 */ // Label 3857: @176441
     /* 176441 */ GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(176471), // Rule ID 1752 //
     /* 176446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 176449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176460 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176460 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64rr),
     /* 176465 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176469 */   GIR_RootConstrainSelectedInstOperands,
     /* 176470 */   // GIR_Coverage, 1752,
     /* 176470 */   GIR_Done,
     /* 176471 */ // Label 3858: @176471
     /* 176471 */ GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(176501), // Rule ID 1768 //
     /* 176476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 176479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 176490 */   // (fp_to_sint:{ *:[i64] } FR32:{ *:[f32] }:$src)  =>  (CVTTSS2SI64rr:{ *:[i64] } FR32:{ *:[f32] }:$src)
     /* 176490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSS2SI64rr),
     /* 176495 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176499 */   GIR_RootConstrainSelectedInstOperands,
     /* 176500 */   // GIR_Coverage, 1768,
     /* 176500 */   GIR_Done,
     /* 176501 */ // Label 3859: @176501
     /* 176501 */ GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(176531), // Rule ID 1776 //
     /* 176506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 176509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 176520 */   // (fp_to_sint:{ *:[i64] } FR64:{ *:[f64] }:$src)  =>  (CVTTSD2SI64rr:{ *:[i64] } FR64:{ *:[f64] }:$src)
     /* 176520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTTSD2SI64rr),
     /* 176525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176529 */   GIR_RootConstrainSelectedInstOperands,
     /* 176530 */   // GIR_Coverage, 1776,
     /* 176530 */   GIR_Done,
     /* 176531 */ // Label 3860: @176531
     /* 176531 */ GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(176561), // Rule ID 10370 //
     /* 176536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176550 */   // (fp_to_sint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2SI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 176550 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2SI64Zrr),
     /* 176555 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176559 */   GIR_RootConstrainSelectedInstOperands,
     /* 176560 */   // GIR_Coverage, 10370,
     /* 176560 */   GIR_Done,
     /* 176561 */ // Label 3861: @176561
     /* 176561 */ GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(176591), // Rule ID 10388 //
     /* 176566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176580 */   // (fp_to_sint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2SI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 176580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2SI64Zrr),
     /* 176585 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176589 */   GIR_RootConstrainSelectedInstOperands,
     /* 176590 */   // GIR_Coverage, 10388,
     /* 176590 */   GIR_Done,
     /* 176591 */ // Label 3862: @176591
     /* 176591 */ GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(176621), // Rule ID 15178 //
     /* 176596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 176606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176610 */   // (fp_to_sint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2SI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 176610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2SI64Zrr),
     /* 176615 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176619 */   GIR_RootConstrainSelectedInstOperands,
     /* 176620 */   // GIR_Coverage, 15178,
     /* 176620 */   GIR_Done,
     /* 176621 */ // Label 3863: @176621
     /* 176621 */ GIM_Reject,
     /* 176622 */ // Label 3834: @176622
     /* 176622 */ GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(176710),
     /* 176627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 176630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 176634 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(176686), // Rule ID 18054 //
     /* 176639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176670 */     // (fp_to_sint:{ *:[v4i32] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTPD2DQYrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 176670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrm),
     /* 176673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176675 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176684 */     GIR_RootConstrainSelectedInstOperands,
     /* 176685 */     // GIR_Coverage, 18054,
     /* 176685 */     GIR_EraseRootFromParent_Done,
     /* 176686 */   // Label 3865: @176686
     /* 176686 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(176709), // Rule ID 18052 //
     /* 176691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 176694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 176698 */     // (fp_to_sint:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)  =>  (VCVTTPD2DQYrr:{ *:[v4i32] } VR256:{ *:[v4f64] }:$src)
     /* 176698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTPD2DQYrr),
     /* 176703 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176707 */     GIR_RootConstrainSelectedInstOperands,
     /* 176708 */     // GIR_Coverage, 18052,
     /* 176708 */     GIR_Done,
     /* 176709 */   // Label 3866: @176709
     /* 176709 */   GIM_Reject,
     /* 176710 */ // Label 3864: @176710
     /* 176710 */ GIM_Reject,
     /* 176711 */ // Label 3835: @176711
     /* 176711 */ GIM_Reject,
     /* 176712 */ // Label 50: @176712
     /* 176712 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3869*/ GIMT_Encode4(177267),
     /* 176723 */ /*GILLT_s32*//*Label 3867*/ GIMT_Encode4(176731),
     /* 176727 */ /*GILLT_s64*//*Label 3868*/ GIMT_Encode4(176999),
     /* 176731 */ // Label 3867: @176731
     /* 176731 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(176790), // Rule ID 10399 //
     /* 176736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176754 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176757 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176761 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176765 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176767 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176774 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrm),
     /* 176777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176779 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176783 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176788 */   GIR_RootConstrainSelectedInstOperands,
     /* 176789 */   // GIR_Coverage, 10399,
     /* 176789 */   GIR_EraseRootFromParent_Done,
     /* 176790 */ // Label 3870: @176790
     /* 176790 */ GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(176849), // Rule ID 10417 //
     /* 176795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176813 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176816 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176820 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176824 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176826 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176833 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrm),
     /* 176836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176838 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176847 */   GIR_RootConstrainSelectedInstOperands,
     /* 176848 */   // GIR_Coverage, 10417,
     /* 176848 */   GIR_EraseRootFromParent_Done,
     /* 176849 */ // Label 3871: @176849
     /* 176849 */ GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(176908), // Rule ID 15189 //
     /* 176854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 176868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 176872 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 176875 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 176879 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 176883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 176885 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 176892 */   // (fp_to_uint:{ *:[i32] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USIZrm:{ *:[i32] } addr:{ *:[iPTR] }:$src)
     /* 176892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrm),
     /* 176895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176897 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 176901 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 176906 */   GIR_RootConstrainSelectedInstOperands,
     /* 176907 */   // GIR_Coverage, 15189,
     /* 176907 */   GIR_EraseRootFromParent_Done,
     /* 176908 */ // Label 3872: @176908
     /* 176908 */ GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(176938), // Rule ID 10397 //
     /* 176913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 176919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 176927 */   // (fp_to_uint:{ *:[i32] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USIZrr:{ *:[i32] } FR32X:{ *:[f32] }:$src)
     /* 176927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USIZrr),
     /* 176932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176936 */   GIR_RootConstrainSelectedInstOperands,
     /* 176937 */   // GIR_Coverage, 10397,
     /* 176937 */   GIR_Done,
     /* 176938 */ // Label 3873: @176938
     /* 176938 */ GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(176968), // Rule ID 10415 //
     /* 176943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 176946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 176949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 176957 */   // (fp_to_uint:{ *:[i32] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USIZrr:{ *:[i32] } FR64X:{ *:[f64] }:$src)
     /* 176957 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USIZrr),
     /* 176962 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176966 */   GIR_RootConstrainSelectedInstOperands,
     /* 176967 */   // GIR_Coverage, 10415,
     /* 176967 */   GIR_Done,
     /* 176968 */ // Label 3874: @176968
     /* 176968 */ GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(176998), // Rule ID 15187 //
     /* 176973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 176976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 176979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 176983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 176987 */   // (fp_to_uint:{ *:[i32] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USIZrr:{ *:[i32] } FR16X:{ *:[f16] }:$src)
     /* 176987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USIZrr),
     /* 176992 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 176996 */   GIR_RootConstrainSelectedInstOperands,
     /* 176997 */   // GIR_Coverage, 15187,
     /* 176997 */   GIR_Done,
     /* 176998 */ // Label 3875: @176998
     /* 176998 */ GIM_Reject,
     /* 176999 */ // Label 3868: @176999
     /* 176999 */ GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(177058), // Rule ID 10408 //
     /* 177004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177014 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177018 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177022 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177025 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177029 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177035 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177042 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSS2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrm),
     /* 177045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177047 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177056 */   GIR_RootConstrainSelectedInstOperands,
     /* 177057 */   // GIR_Coverage, 10408,
     /* 177057 */   GIR_EraseRootFromParent_Done,
     /* 177058 */ // Label 3876: @177058
     /* 177058 */ GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(177117), // Rule ID 10426 //
     /* 177063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177081 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177084 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177088 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177094 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177101 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSD2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrm),
     /* 177104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177106 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177115 */   GIR_RootConstrainSelectedInstOperands,
     /* 177116 */   // GIR_Coverage, 10426,
     /* 177116 */   GIR_EraseRootFromParent_Done,
     /* 177117 */ // Label 3877: @177117
     /* 177117 */ GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(177176), // Rule ID 15198 //
     /* 177122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177132 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177136 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177140 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177143 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177147 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177151 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177153 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177160 */   // (fp_to_uint:{ *:[i64] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTTSH2USI64Zrm:{ *:[i64] } addr:{ *:[iPTR] }:$src)
     /* 177160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrm),
     /* 177163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177165 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177169 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177174 */   GIR_RootConstrainSelectedInstOperands,
     /* 177175 */   // GIR_Coverage, 15198,
     /* 177175 */   GIR_EraseRootFromParent_Done,
     /* 177176 */ // Label 3878: @177176
     /* 177176 */ GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(177206), // Rule ID 10406 //
     /* 177181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177195 */   // (fp_to_uint:{ *:[i64] } FR32X:{ *:[f32] }:$src)  =>  (VCVTTSS2USI64Zrr:{ *:[i64] } FR32X:{ *:[f32] }:$src)
     /* 177195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSS2USI64Zrr),
     /* 177200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177204 */   GIR_RootConstrainSelectedInstOperands,
     /* 177205 */   // GIR_Coverage, 10406,
     /* 177205 */   GIR_Done,
     /* 177206 */ // Label 3879: @177206
     /* 177206 */ GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(177236), // Rule ID 10424 //
     /* 177211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 177225 */   // (fp_to_uint:{ *:[i64] } FR64X:{ *:[f64] }:$src)  =>  (VCVTTSD2USI64Zrr:{ *:[i64] } FR64X:{ *:[f64] }:$src)
     /* 177225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSD2USI64Zrr),
     /* 177230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177234 */   GIR_RootConstrainSelectedInstOperands,
     /* 177235 */   // GIR_Coverage, 10424,
     /* 177235 */   GIR_Done,
     /* 177236 */ // Label 3880: @177236
     /* 177236 */ GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(177266), // Rule ID 15196 //
     /* 177241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 177247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177255 */   // (fp_to_uint:{ *:[i64] } FR16X:{ *:[f16] }:$src)  =>  (VCVTTSH2USI64Zrr:{ *:[i64] } FR16X:{ *:[f16] }:$src)
     /* 177255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTTSH2USI64Zrr),
     /* 177260 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 177264 */   GIR_RootConstrainSelectedInstOperands,
     /* 177265 */   // GIR_Coverage, 15196,
     /* 177265 */   GIR_Done,
     /* 177266 */ // Label 3881: @177266
     /* 177266 */ GIM_Reject,
     /* 177267 */ // Label 3869: @177267
     /* 177267 */ GIM_Reject,
     /* 177268 */ // Label 51: @177268
     /* 177268 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3894*/ GIMT_Encode4(180643),
     /* 177279 */ /*GILLT_s16*//*Label 3882*/ GIMT_Encode4(177363),
     /* 177283 */ /*GILLT_s32*//*Label 3883*/ GIMT_Encode4(177606),
     /* 177287 */ /*GILLT_s64*//*Label 3884*/ GIMT_Encode4(178269), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177303 */ /*GILLT_v2s64*//*Label 3885*/ GIMT_Encode4(178928), GIMT_Encode4(0),
     /* 177311 */ /*GILLT_v4s32*//*Label 3886*/ GIMT_Encode4(179017),
     /* 177315 */ /*GILLT_v4s64*//*Label 3887*/ GIMT_Encode4(179315), GIMT_Encode4(0),
     /* 177323 */ /*GILLT_v8s16*//*Label 3888*/ GIMT_Encode4(179575),
     /* 177327 */ /*GILLT_v8s32*//*Label 3889*/ GIMT_Encode4(179843),
     /* 177331 */ /*GILLT_v8s64*//*Label 3890*/ GIMT_Encode4(180111), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177343 */ /*GILLT_v16s16*//*Label 3891*/ GIMT_Encode4(180286),
     /* 177347 */ /*GILLT_v16s32*//*Label 3892*/ GIMT_Encode4(180465), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 177359 */ /*GILLT_v32s16*//*Label 3893*/ GIMT_Encode4(180554),
     /* 177363 */ // Label 3882: @177363
     /* 177363 */ GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(177439), // Rule ID 22179 //
     /* 177368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177386 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177389 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177393 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177399 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177406 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrm),
     /* 177423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177428 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177432 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177437 */   GIR_RootConstrainSelectedInstOperands,
     /* 177438 */   // GIR_Coverage, 22179,
     /* 177438 */   GIR_EraseRootFromParent_Done,
     /* 177439 */ // Label 3895: @177439
     /* 177439 */ GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(177515), // Rule ID 22177 //
     /* 177444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177462 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177465 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177469 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177473 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177475 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177482 */   // (sint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 177482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrm),
     /* 177499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177504 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177508 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177513 */   GIR_RootConstrainSelectedInstOperands,
     /* 177514 */   // GIR_Coverage, 22177,
     /* 177514 */   GIR_EraseRootFromParent_Done,
     /* 177515 */ // Label 3896: @177515
     /* 177515 */ GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(177560), // Rule ID 22181 //
     /* 177520 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 177534 */   // (sint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 177534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SHZrr),
     /* 177551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177558 */   GIR_RootConstrainSelectedInstOperands,
     /* 177559 */   // GIR_Coverage, 22181,
     /* 177559 */   GIR_EraseRootFromParent_Done,
     /* 177560 */ // Label 3897: @177560
     /* 177560 */ GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(177605), // Rule ID 22183 //
     /* 177565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 177568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 177575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 177579 */   // (sint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 177579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SHZrr),
     /* 177596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 177603 */   GIR_RootConstrainSelectedInstOperands,
     /* 177604 */   // GIR_Coverage, 22183,
     /* 177604 */   GIR_EraseRootFromParent_Done,
     /* 177605 */ // Label 3898: @177605
     /* 177605 */ GIM_Reject,
     /* 177606 */ // Label 3883: @177606
     /* 177606 */ GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(177665), // Rule ID 1794 //
     /* 177611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177629 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177636 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177640 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177642 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177649 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrm),
     /* 177652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177654 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177658 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177663 */   GIR_RootConstrainSelectedInstOperands,
     /* 177664 */   // GIR_Coverage, 1794,
     /* 177664 */   GIR_EraseRootFromParent_Done,
     /* 177665 */ // Label 3899: @177665
     /* 177665 */ GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(177741), // Rule ID 17976 //
     /* 177670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177680 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177684 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177688 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177691 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177695 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177699 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177701 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177708 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrm),
     /* 177725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177730 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177739 */   GIR_RootConstrainSelectedInstOperands,
     /* 177740 */   // GIR_Coverage, 17976,
     /* 177740 */   GIR_EraseRootFromParent_Done,
     /* 177741 */ // Label 3900: @177741
     /* 177741 */ GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(177817), // Rule ID 21130 //
     /* 177746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 177752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177764 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177767 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 177771 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177775 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177777 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177784 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177784 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177787 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177791 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrm),
     /* 177801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177806 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177815 */   GIR_RootConstrainSelectedInstOperands,
     /* 177816 */   // GIR_Coverage, 21130,
     /* 177816 */   GIR_EraseRootFromParent_Done,
     /* 177817 */ // Label 3901: @177817
     /* 177817 */ GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(177876), // Rule ID 1790 //
     /* 177822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 177825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177832 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177836 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177840 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177843 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177847 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177853 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177860 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SSrm:{ *:[f32] } addr:{ *:[iPTR] }:$src)
     /* 177860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrm),
     /* 177863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177865 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177869 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177874 */   GIR_RootConstrainSelectedInstOperands,
     /* 177875 */   // GIR_Coverage, 1790,
     /* 177875 */   GIR_EraseRootFromParent_Done,
     /* 177876 */ // Label 3902: @177876
     /* 177876 */ GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(177952), // Rule ID 17974 //
     /* 177881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 177884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 177891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177899 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177902 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177906 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177910 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177912 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177919 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 177926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrm),
     /* 177936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177941 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 177945 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 177950 */   GIR_RootConstrainSelectedInstOperands,
     /* 177951 */   // GIR_Coverage, 17974,
     /* 177951 */   GIR_EraseRootFromParent_Done,
     /* 177952 */ // Label 3903: @177952
     /* 177952 */ GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(178028), // Rule ID 21128 //
     /* 177957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 177960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 177963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 177967 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 177971 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 177975 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 177978 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 177982 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 177986 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177988 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 177995 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 177995 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177998 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178002 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrm),
     /* 178012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178017 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178026 */   GIR_RootConstrainSelectedInstOperands,
     /* 178027 */   // GIR_Coverage, 21128,
     /* 178027 */   GIR_EraseRootFromParent_Done,
     /* 178028 */ // Label 3904: @178028
     /* 178028 */ GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(178058), // Rule ID 1788 //
     /* 178033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178047 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SSrr:{ *:[f32] } GR32:{ *:[i32] }:$src)
     /* 178047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SSrr),
     /* 178052 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178056 */   GIR_RootConstrainSelectedInstOperands,
     /* 178057 */   // GIR_Coverage, 1788,
     /* 178057 */   GIR_Done,
     /* 178058 */ // Label 3905: @178058
     /* 178058 */ GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(178088), // Rule ID 1792 //
     /* 178063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 178066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178077 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SSrr:{ *:[f32] } GR64:{ *:[i64] }:$src)
     /* 178077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SSrr),
     /* 178082 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178086 */   GIR_RootConstrainSelectedInstOperands,
     /* 178087 */   // GIR_Coverage, 1792,
     /* 178087 */   GIR_Done,
     /* 178088 */ // Label 3906: @178088
     /* 178088 */ GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(178133), // Rule ID 17982 //
     /* 178093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178107 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSrr),
     /* 178124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178131 */   GIR_RootConstrainSelectedInstOperands,
     /* 178132 */   // GIR_Coverage, 17982,
     /* 178132 */   GIR_EraseRootFromParent_Done,
     /* 178133 */ // Label 3907: @178133
     /* 178133 */ GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(178178), // Rule ID 17984 //
     /* 178138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 178148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178152 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSrr),
     /* 178169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178174 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178176 */   GIR_RootConstrainSelectedInstOperands,
     /* 178177 */   // GIR_Coverage, 17984,
     /* 178177 */   GIR_EraseRootFromParent_Done,
     /* 178178 */ // Label 3908: @178178
     /* 178178 */ GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(178223), // Rule ID 21136 //
     /* 178183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178197 */   // (sint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 178197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178209 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SSZrr),
     /* 178214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178216 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178219 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178221 */   GIR_RootConstrainSelectedInstOperands,
     /* 178222 */   // GIR_Coverage, 21136,
     /* 178222 */   GIR_EraseRootFromParent_Done,
     /* 178223 */ // Label 3909: @178223
     /* 178223 */ GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(178268), // Rule ID 21138 //
     /* 178228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 178238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178242 */   // (sint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 178242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 178245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SSZrr),
     /* 178259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178266 */   GIR_RootConstrainSelectedInstOperands,
     /* 178267 */   // GIR_Coverage, 21138,
     /* 178267 */   GIR_EraseRootFromParent_Done,
     /* 178268 */ // Label 3910: @178268
     /* 178268 */ GIM_Reject,
     /* 178269 */ // Label 3884: @178269
     /* 178269 */ GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(178328), // Rule ID 1802 //
     /* 178274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178292 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178295 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178299 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178303 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178305 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178312 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (CVTSI642SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrm),
     /* 178315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178317 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178321 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178326 */   GIR_RootConstrainSelectedInstOperands,
     /* 178327 */   // GIR_Coverage, 1802,
     /* 178327 */   GIR_EraseRootFromParent_Done,
     /* 178328 */ // Label 3911: @178328
     /* 178328 */ GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(178404), // Rule ID 17980 //
     /* 178333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178351 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178354 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178358 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178362 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178364 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178371 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178371 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178374 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178378 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrm),
     /* 178388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178393 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178402 */   GIR_RootConstrainSelectedInstOperands,
     /* 178403 */   // GIR_Coverage, 17980,
     /* 178403 */   GIR_EraseRootFromParent_Done,
     /* 178404 */ // Label 3912: @178404
     /* 178404 */ GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(178480), // Rule ID 21134 //
     /* 178409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178419 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178423 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178427 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178430 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178434 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178438 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178440 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178447 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178447 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178450 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178454 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrm),
     /* 178464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178469 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178478 */   GIR_RootConstrainSelectedInstOperands,
     /* 178479 */   // GIR_Coverage, 21134,
     /* 178479 */   GIR_EraseRootFromParent_Done,
     /* 178480 */ // Label 3913: @178480
     /* 178480 */ GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(178539), // Rule ID 1798 //
     /* 178485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178503 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178506 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178510 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178516 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178523 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (CVTSI2SDrm:{ *:[f64] } addr:{ *:[iPTR] }:$src)
     /* 178523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrm),
     /* 178526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178528 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178532 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178537 */   GIR_RootConstrainSelectedInstOperands,
     /* 178538 */   // GIR_Coverage, 1798,
     /* 178538 */   GIR_EraseRootFromParent_Done,
     /* 178539 */ // Label 3914: @178539
     /* 178539 */ GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(178615), // Rule ID 17978 //
     /* 178544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178562 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178565 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178569 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178575 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178582 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrm),
     /* 178599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178604 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178608 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178613 */   GIR_RootConstrainSelectedInstOperands,
     /* 178614 */   // GIR_Coverage, 17978,
     /* 178614 */   GIR_EraseRootFromParent_Done,
     /* 178615 */ // Label 3915: @178615
     /* 178615 */ GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(178691), // Rule ID 21132 //
     /* 178620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178638 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178641 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178645 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 178649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178651 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178658 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 178658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178670 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrm),
     /* 178675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178680 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178689 */   GIR_RootConstrainSelectedInstOperands,
     /* 178690 */   // GIR_Coverage, 21132,
     /* 178690 */   GIR_EraseRootFromParent_Done,
     /* 178691 */ // Label 3916: @178691
     /* 178691 */ GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(178717), // Rule ID 1796 //
     /* 178696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178710 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (CVTSI2SDrr:{ *:[f64] } GR32:{ *:[i32] }:$src)
     /* 178710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI2SDrr),
     /* 178715 */   GIR_RootConstrainSelectedInstOperands,
     /* 178716 */   // GIR_Coverage, 1796,
     /* 178716 */   GIR_Done,
     /* 178717 */ // Label 3917: @178717
     /* 178717 */ GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(178747), // Rule ID 1800 //
     /* 178722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 178725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178736 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (CVTSI642SDrr:{ *:[f64] } GR64:{ *:[i64] }:$src)
     /* 178736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTSI642SDrr),
     /* 178741 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 178745 */   GIR_RootConstrainSelectedInstOperands,
     /* 178746 */   // GIR_Coverage, 1800,
     /* 178746 */   GIR_Done,
     /* 178747 */ // Label 3918: @178747
     /* 178747 */ GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(178792), // Rule ID 17986 //
     /* 178752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178766 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDrr),
     /* 178783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178788 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178790 */   GIR_RootConstrainSelectedInstOperands,
     /* 178791 */   // GIR_Coverage, 17986,
     /* 178791 */   GIR_EraseRootFromParent_Done,
     /* 178792 */ // Label 3919: @178792
     /* 178792 */ GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(178837), // Rule ID 17988 //
     /* 178797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 178800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 178807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178811 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDrr),
     /* 178828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178833 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178835 */   GIR_RootConstrainSelectedInstOperands,
     /* 178836 */   // GIR_Coverage, 17988,
     /* 178836 */   GIR_EraseRootFromParent_Done,
     /* 178837 */ // Label 3920: @178837
     /* 178837 */ GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(178882), // Rule ID 21140 //
     /* 178842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 178848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 178856 */   // (sint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 178856 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178859 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178863 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178868 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI2SDZrr),
     /* 178873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178880 */   GIR_RootConstrainSelectedInstOperands,
     /* 178881 */   // GIR_Coverage, 21140,
     /* 178881 */   GIR_EraseRootFromParent_Done,
     /* 178882 */ // Label 3921: @178882
     /* 178882 */ GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(178927), // Rule ID 21142 //
     /* 178887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 178890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 178893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 178897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 178901 */   // (sint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 178901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 178904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 178908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 178915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTSI642SDZrr),
     /* 178918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 178925 */   GIR_RootConstrainSelectedInstOperands,
     /* 178926 */   // GIR_Coverage, 21142,
     /* 178926 */   GIR_EraseRootFromParent_Done,
     /* 178927 */ // Label 3922: @178927
     /* 178927 */ GIM_Reject,
     /* 178928 */ // Label 3885: @178928
     /* 178928 */ GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(179016),
     /* 178933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 178940 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(178992), // Rule ID 11379 //
     /* 178945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 178948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 178952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 178956 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 178959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 178963 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 178967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 178969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 178976 */     // (sint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 178976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rm),
     /* 178979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 178981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 178985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 178990 */     GIR_RootConstrainSelectedInstOperands,
     /* 178991 */     // GIR_Coverage, 11379,
     /* 178991 */     GIR_EraseRootFromParent_Done,
     /* 178992 */   // Label 3924: @178992
     /* 178992 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(179015), // Rule ID 11375 //
     /* 178997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179004 */     // (sint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 179004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ128rr),
     /* 179009 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179013 */     GIR_RootConstrainSelectedInstOperands,
     /* 179014 */     // GIR_Coverage, 11375,
     /* 179014 */     GIR_Done,
     /* 179015 */   // Label 3925: @179015
     /* 179015 */   GIM_Reject,
     /* 179016 */ // Label 3923: @179016
     /* 179016 */ GIM_Reject,
     /* 179017 */ // Label 3886: @179017
     /* 179017 */ GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(179076), // Rule ID 1870 //
     /* 179022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179032 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179036 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179040 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179043 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179047 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179053 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179060 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSrm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrm),
     /* 179063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179065 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179074 */   GIR_RootConstrainSelectedInstOperands,
     /* 179075 */   // GIR_Coverage, 1870,
     /* 179075 */   GIR_EraseRootFromParent_Done,
     /* 179076 */ // Label 3926: @179076
     /* 179076 */ GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(179135), // Rule ID 10755 //
     /* 179081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179091 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179095 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179099 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179102 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179106 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179112 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179119 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rm),
     /* 179122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179124 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179133 */   GIR_RootConstrainSelectedInstOperands,
     /* 179134 */   // GIR_Coverage, 10755,
     /* 179134 */   GIR_EraseRootFromParent_Done,
     /* 179135 */ // Label 3927: @179135
     /* 179135 */ GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(179194), // Rule ID 11511 //
     /* 179140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179158 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179161 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179165 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179171 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179178 */   // (sint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 179178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rm),
     /* 179181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179183 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179187 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179192 */   GIR_RootConstrainSelectedInstOperands,
     /* 179193 */   // GIR_Coverage, 11511,
     /* 179193 */   GIR_EraseRootFromParent_Done,
     /* 179194 */ // Label 3928: @179194
     /* 179194 */ GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(179224), // Rule ID 1868 //
     /* 179199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179213 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSrr),
     /* 179218 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179222 */   GIR_RootConstrainSelectedInstOperands,
     /* 179223 */   // GIR_Coverage, 1868,
     /* 179223 */   GIR_Done,
     /* 179224 */ // Label 3929: @179224
     /* 179224 */ GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(179254), // Rule ID 1876 //
     /* 179229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 179232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179243 */   // (sint_to_fp:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)  =>  (CVTDQ2PSrr:{ *:[v4f32] } VR128:{ *:[v4i32] }:$src)
     /* 179243 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::CVTDQ2PSrr),
     /* 179248 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179252 */   GIR_RootConstrainSelectedInstOperands,
     /* 179253 */   // GIR_Coverage, 1876,
     /* 179253 */   GIR_Done,
     /* 179254 */ // Label 3930: @179254
     /* 179254 */ GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(179284), // Rule ID 10751 //
     /* 179259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179273 */   // (sint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 179273 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ128rr),
     /* 179278 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179282 */   GIR_RootConstrainSelectedInstOperands,
     /* 179283 */   // GIR_Coverage, 10751,
     /* 179283 */   GIR_Done,
     /* 179284 */ // Label 3931: @179284
     /* 179284 */ GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(179314), // Rule ID 11507 //
     /* 179289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179303 */   // (sint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 179303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZ256rr),
     /* 179308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179312 */   GIR_RootConstrainSelectedInstOperands,
     /* 179313 */   // GIR_Coverage, 11507,
     /* 179313 */   GIR_Done,
     /* 179314 */ // Label 3932: @179314
     /* 179314 */ GIM_Reject,
     /* 179315 */ // Label 3887: @179315
     /* 179315 */ GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(179374), // Rule ID 1945 //
     /* 179320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179330 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179334 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179338 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179345 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179349 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179351 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179358 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDYrm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrm),
     /* 179361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179363 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179367 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179372 */   GIR_RootConstrainSelectedInstOperands,
     /* 179373 */   // GIR_Coverage, 1945,
     /* 179373 */   GIR_EraseRootFromParent_Done,
     /* 179374 */ // Label 3933: @179374
     /* 179374 */ GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(179433), // Rule ID 10728 //
     /* 179379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179397 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179400 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179404 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179408 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179410 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179417 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179417 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rm),
     /* 179420 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179422 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179426 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179431 */   GIR_RootConstrainSelectedInstOperands,
     /* 179432 */   // GIR_Coverage, 10728,
     /* 179432 */   GIR_EraseRootFromParent_Done,
     /* 179433 */ // Label 3934: @179433
     /* 179433 */ GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(179492), // Rule ID 11391 //
     /* 179438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179456 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179459 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179463 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179469 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179476 */   // (sint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 179476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rm),
     /* 179479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179481 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179485 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179490 */   GIR_RootConstrainSelectedInstOperands,
     /* 179491 */   // GIR_Coverage, 11391,
     /* 179491 */   GIR_EraseRootFromParent_Done,
     /* 179492 */ // Label 3935: @179492
     /* 179492 */ GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(179518), // Rule ID 1947 //
     /* 179497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 179511 */   // (sint_to_fp:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDYrr:{ *:[v4f64] } VR128:{ *:[v4i32] }:$src)
     /* 179511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDYrr),
     /* 179516 */   GIR_RootConstrainSelectedInstOperands,
     /* 179517 */   // GIR_Coverage, 1947,
     /* 179517 */   GIR_Done,
     /* 179518 */ // Label 3936: @179518
     /* 179518 */ GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(179544), // Rule ID 10724 //
     /* 179523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179537 */   // (sint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 179537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZ256rr),
     /* 179542 */   GIR_RootConstrainSelectedInstOperands,
     /* 179543 */   // GIR_Coverage, 10724,
     /* 179543 */   GIR_Done,
     /* 179544 */ // Label 3937: @179544
     /* 179544 */ GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(179574), // Rule ID 11387 //
     /* 179549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 179552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 179555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179563 */   // (sint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 179563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZ256rr),
     /* 179568 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179572 */   GIR_RootConstrainSelectedInstOperands,
     /* 179573 */   // GIR_Coverage, 11387,
     /* 179573 */   GIR_Done,
     /* 179574 */ // Label 3938: @179574
     /* 179574 */ GIM_Reject,
     /* 179575 */ // Label 3888: @179575
     /* 179575 */ GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(179634), // Rule ID 11457 //
     /* 179580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179598 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179601 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179605 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179609 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179611 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179618 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rm),
     /* 179621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179623 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179627 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179632 */   GIR_RootConstrainSelectedInstOperands,
     /* 179633 */   // GIR_Coverage, 11457,
     /* 179633 */   GIR_EraseRootFromParent_Done,
     /* 179634 */ // Label 3939: @179634
     /* 179634 */ GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(179693), // Rule ID 14823 //
     /* 179639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179649 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179653 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179657 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179664 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179670 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179677 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rm),
     /* 179680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179682 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179686 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179691 */   GIR_RootConstrainSelectedInstOperands,
     /* 179692 */   // GIR_Coverage, 14823,
     /* 179692 */   GIR_EraseRootFromParent_Done,
     /* 179693 */ // Label 3940: @179693
     /* 179693 */ GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(179752), // Rule ID 15123 //
     /* 179698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179716 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179719 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179723 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179727 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179729 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179736 */   // (sint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 179736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrm),
     /* 179739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179741 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179745 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179750 */   GIR_RootConstrainSelectedInstOperands,
     /* 179751 */   // GIR_Coverage, 15123,
     /* 179751 */   GIR_EraseRootFromParent_Done,
     /* 179752 */ // Label 3941: @179752
     /* 179752 */ GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(179782), // Rule ID 11453 //
     /* 179757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179771 */   // (sint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 179771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZ256rr),
     /* 179776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179780 */   GIR_RootConstrainSelectedInstOperands,
     /* 179781 */   // GIR_Coverage, 11453,
     /* 179781 */   GIR_Done,
     /* 179782 */ // Label 3942: @179782
     /* 179782 */ GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(179812), // Rule ID 14819 //
     /* 179787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 179790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179801 */   // (sint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 179801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ128rr),
     /* 179806 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179810 */   GIR_RootConstrainSelectedInstOperands,
     /* 179811 */   // GIR_Coverage, 14819,
     /* 179811 */   GIR_Done,
     /* 179812 */ // Label 3943: @179812
     /* 179812 */ GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(179842), // Rule ID 15119 //
     /* 179817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 179820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 179827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 179831 */   // (sint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 179831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PHZrr),
     /* 179836 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 179840 */   GIR_RootConstrainSelectedInstOperands,
     /* 179841 */   // GIR_Coverage, 15119,
     /* 179841 */   GIR_Done,
     /* 179842 */ // Label 3944: @179842
     /* 179842 */ GIM_Reject,
     /* 179843 */ // Label 3889: @179843
     /* 179843 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(179902), // Rule ID 1874 //
     /* 179848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 179851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 179858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179866 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179873 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179879 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179886 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSYrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrm),
     /* 179889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179891 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179895 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179900 */   GIR_RootConstrainSelectedInstOperands,
     /* 179901 */   // GIR_Coverage, 1874,
     /* 179901 */   GIR_EraseRootFromParent_Done,
     /* 179902 */ // Label 3945: @179902
     /* 179902 */ GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(179961), // Rule ID 10767 //
     /* 179907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 179910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 179913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179917 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179921 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179925 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179928 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179932 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179936 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179938 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 179945 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 179945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rm),
     /* 179948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179950 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 179954 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 179959 */   GIR_RootConstrainSelectedInstOperands,
     /* 179960 */   // GIR_Coverage, 10767,
     /* 179960 */   GIR_EraseRootFromParent_Done,
     /* 179961 */ // Label 3946: @179961
     /* 179961 */ GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(180020), // Rule ID 11496 //
     /* 179966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 179969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 179972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 179976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 179980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 179984 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 179987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 179991 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 179995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 179997 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180004 */   // (sint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 180004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrm),
     /* 180007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180009 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180013 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180018 */   GIR_RootConstrainSelectedInstOperands,
     /* 180019 */   // GIR_Coverage, 11496,
     /* 180019 */   GIR_EraseRootFromParent_Done,
     /* 180020 */ // Label 3947: @180020
     /* 180020 */ GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(180050), // Rule ID 1872 //
     /* 180025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 180028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 180039 */   // (sint_to_fp:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSYrr:{ *:[v8f32] } VR256:{ *:[v8i32] }:$src)
     /* 180039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSYrr),
     /* 180044 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180048 */   GIR_RootConstrainSelectedInstOperands,
     /* 180049 */   // GIR_Coverage, 1872,
     /* 180049 */   GIR_Done,
     /* 180050 */ // Label 3948: @180050
     /* 180050 */ GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(180080), // Rule ID 10763 //
     /* 180055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 180058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180069 */   // (sint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 180069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZ256rr),
     /* 180074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180078 */   GIR_RootConstrainSelectedInstOperands,
     /* 180079 */   // GIR_Coverage, 10763,
     /* 180079 */   GIR_Done,
     /* 180080 */ // Label 3949: @180080
     /* 180080 */ GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(180110), // Rule ID 11492 //
     /* 180085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180099 */   // (sint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 180099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PSZrr),
     /* 180104 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180108 */   GIR_RootConstrainSelectedInstOperands,
     /* 180109 */   // GIR_Coverage, 11492,
     /* 180109 */   GIR_Done,
     /* 180110 */ // Label 3950: @180110
     /* 180110 */ GIM_Reject,
     /* 180111 */ // Label 3890: @180111
     /* 180111 */ GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(180170), // Rule ID 10704 //
     /* 180116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180126 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180130 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180134 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180141 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180145 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180147 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180154 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrm),
     /* 180157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180159 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180163 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180168 */   GIR_RootConstrainSelectedInstOperands,
     /* 180169 */   // GIR_Coverage, 10704,
     /* 180169 */   GIR_EraseRootFromParent_Done,
     /* 180170 */ // Label 3951: @180170
     /* 180170 */ GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(180229), // Rule ID 11364 //
     /* 180175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180193 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180200 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180204 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180206 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180213 */   // (sint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 180213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrm),
     /* 180216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180218 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180227 */   GIR_RootConstrainSelectedInstOperands,
     /* 180228 */   // GIR_Coverage, 11364,
     /* 180228 */   GIR_EraseRootFromParent_Done,
     /* 180229 */ // Label 3952: @180229
     /* 180229 */ GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(180255), // Rule ID 10700 //
     /* 180234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 180240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180248 */   // (sint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 180248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PDZrr),
     /* 180253 */   GIR_RootConstrainSelectedInstOperands,
     /* 180254 */   // GIR_Coverage, 10700,
     /* 180254 */   GIR_Done,
     /* 180255 */ // Label 3953: @180255
     /* 180255 */ GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(180285), // Rule ID 11360 //
     /* 180260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 180263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 180266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180274 */   // (sint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 180274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTQQ2PDZrr),
     /* 180279 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180283 */   GIR_RootConstrainSelectedInstOperands,
     /* 180284 */   // GIR_Coverage, 11360,
     /* 180284 */   GIR_Done,
     /* 180285 */ // Label 3954: @180285
     /* 180285 */ GIM_Reject,
     /* 180286 */ // Label 3891: @180286
     /* 180286 */ GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(180345), // Rule ID 11442 //
     /* 180291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180309 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180316 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180320 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180322 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180329 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrm),
     /* 180332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180334 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180343 */   GIR_RootConstrainSelectedInstOperands,
     /* 180344 */   // GIR_Coverage, 11442,
     /* 180344 */   GIR_EraseRootFromParent_Done,
     /* 180345 */ // Label 3955: @180345
     /* 180345 */ GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(180404), // Rule ID 14835 //
     /* 180350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180368 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180375 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180381 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180388 */   // (sint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 180388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rm),
     /* 180391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180393 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180402 */   GIR_RootConstrainSelectedInstOperands,
     /* 180403 */   // GIR_Coverage, 14835,
     /* 180403 */   GIR_EraseRootFromParent_Done,
     /* 180404 */ // Label 3956: @180404
     /* 180404 */ GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(180434), // Rule ID 11438 //
     /* 180409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180423 */   // (sint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 180423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PHZrr),
     /* 180428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180432 */   GIR_RootConstrainSelectedInstOperands,
     /* 180433 */   // GIR_Coverage, 11438,
     /* 180433 */   GIR_Done,
     /* 180434 */ // Label 3957: @180434
     /* 180434 */ GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(180464), // Rule ID 14831 //
     /* 180439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 180442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 180445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 180453 */   // (sint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 180453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZ256rr),
     /* 180458 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180462 */   GIR_RootConstrainSelectedInstOperands,
     /* 180463 */   // GIR_Coverage, 14831,
     /* 180463 */   GIR_Done,
     /* 180464 */ // Label 3958: @180464
     /* 180464 */ GIM_Reject,
     /* 180465 */ // Label 3892: @180465
     /* 180465 */ GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(180553),
     /* 180470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 180473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180477 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(180529), // Rule ID 10740 //
     /* 180482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180493 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180500 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180513 */     // (sint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 180513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrm),
     /* 180516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180518 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180527 */     GIR_RootConstrainSelectedInstOperands,
     /* 180528 */     // GIR_Coverage, 10740,
     /* 180528 */     GIR_EraseRootFromParent_Done,
     /* 180529 */   // Label 3960: @180529
     /* 180529 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(180552), // Rule ID 10736 //
     /* 180534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180537 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180541 */     // (sint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 180541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTDQ2PSZrr),
     /* 180546 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180550 */     GIR_RootConstrainSelectedInstOperands,
     /* 180551 */     // GIR_Coverage, 10736,
     /* 180551 */     GIR_Done,
     /* 180552 */   // Label 3961: @180552
     /* 180552 */   GIM_Reject,
     /* 180553 */ // Label 3959: @180553
     /* 180553 */ GIM_Reject,
     /* 180554 */ // Label 3893: @180554
     /* 180554 */ GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(180642),
     /* 180559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 180562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180566 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(180618), // Rule ID 14808 //
     /* 180571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180602 */     // (sint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 180602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrm),
     /* 180605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180607 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180616 */     GIR_RootConstrainSelectedInstOperands,
     /* 180617 */     // GIR_Coverage, 14808,
     /* 180617 */     GIR_EraseRootFromParent_Done,
     /* 180618 */   // Label 3963: @180618
     /* 180618 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(180641), // Rule ID 14804 //
     /* 180623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 180630 */     // (sint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 180630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTW2PHZrr),
     /* 180635 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 180639 */     GIR_RootConstrainSelectedInstOperands,
     /* 180640 */     // GIR_Coverage, 14804,
     /* 180640 */     GIR_Done,
     /* 180641 */   // Label 3964: @180641
     /* 180641 */   GIM_Reject,
     /* 180642 */ // Label 3962: @180642
     /* 180642 */ GIM_Reject,
     /* 180643 */ // Label 3894: @180643
     /* 180643 */ GIM_Reject,
     /* 180644 */ // Label 52: @180644
     /* 180644 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 3977*/ GIMT_Encode4(182890),
     /* 180655 */ /*GILLT_s16*//*Label 3965*/ GIMT_Encode4(180739),
     /* 180659 */ /*GILLT_s32*//*Label 3966*/ GIMT_Encode4(180982),
     /* 180663 */ /*GILLT_s64*//*Label 3967*/ GIMT_Encode4(181225), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180679 */ /*GILLT_v2s64*//*Label 3968*/ GIMT_Encode4(181468), GIMT_Encode4(0),
     /* 180687 */ /*GILLT_v4s32*//*Label 3969*/ GIMT_Encode4(181557),
     /* 180691 */ /*GILLT_v4s64*//*Label 3970*/ GIMT_Encode4(181736), GIMT_Encode4(0),
     /* 180699 */ /*GILLT_v8s16*//*Label 3971*/ GIMT_Encode4(181911),
     /* 180703 */ /*GILLT_v8s32*//*Label 3972*/ GIMT_Encode4(182179),
     /* 180707 */ /*GILLT_v8s64*//*Label 3973*/ GIMT_Encode4(182358), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180719 */ /*GILLT_v16s16*//*Label 3974*/ GIMT_Encode4(182533),
     /* 180723 */ /*GILLT_v16s32*//*Label 3975*/ GIMT_Encode4(182712), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 180735 */ /*GILLT_v32s16*//*Label 3976*/ GIMT_Encode4(182801),
     /* 180739 */ // Label 3965: @180739
     /* 180739 */ GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(180815), // Rule ID 22187 //
     /* 180744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180754 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180758 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180762 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180765 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 180769 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180775 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180782 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrm),
     /* 180799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180804 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180808 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180813 */   GIR_RootConstrainSelectedInstOperands,
     /* 180814 */   // GIR_Coverage, 22187,
     /* 180814 */   GIR_EraseRootFromParent_Done,
     /* 180815 */ // Label 3978: @180815
     /* 180815 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(180891), // Rule ID 22185 //
     /* 180820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 180834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 180838 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 180841 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 180845 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 180849 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 180851 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 180858 */   // (uint_to_fp:{ *:[f16] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SHZrm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 180858 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180861 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180865 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrm),
     /* 180875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180880 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 180884 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 180889 */   GIR_RootConstrainSelectedInstOperands,
     /* 180890 */   // GIR_Coverage, 22185,
     /* 180890 */   GIR_EraseRootFromParent_Done,
     /* 180891 */ // Label 3979: @180891
     /* 180891 */ GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(180936), // Rule ID 22189 //
     /* 180896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 180902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 180910 */   // (uint_to_fp:{ *:[f16] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR32:{ *:[i32] }:$src)
     /* 180910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SHZrr),
     /* 180927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180932 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180934 */   GIR_RootConstrainSelectedInstOperands,
     /* 180935 */   // GIR_Coverage, 22189,
     /* 180935 */   GIR_EraseRootFromParent_Done,
     /* 180936 */ // Label 3980: @180936
     /* 180936 */ GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(180981), // Rule ID 22191 //
     /* 180941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 180944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 180951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 180955 */   // (uint_to_fp:{ *:[f16] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SHZrr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), GR64:{ *:[i64] }:$src)
     /* 180955 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 180958 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 180962 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180967 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SHZrr),
     /* 180972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 180979 */   GIR_RootConstrainSelectedInstOperands,
     /* 180980 */   // GIR_Coverage, 22191,
     /* 180980 */   GIR_EraseRootFromParent_Done,
     /* 180981 */ // Label 3981: @180981
     /* 180981 */ GIM_Reject,
     /* 180982 */ // Label 3966: @180982
     /* 180982 */ GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(181058), // Rule ID 21146 //
     /* 180987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 180990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 180993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 180997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181005 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181008 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181012 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181016 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181018 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181025 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrm),
     /* 181042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181047 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181051 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181056 */   GIR_RootConstrainSelectedInstOperands,
     /* 181057 */   // GIR_Coverage, 21146,
     /* 181057 */   GIR_EraseRootFromParent_Done,
     /* 181058 */ // Label 3982: @181058
     /* 181058 */ GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(181134), // Rule ID 21144 //
     /* 181063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181073 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181077 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181081 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181084 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181088 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181092 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181094 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181101 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SSZrm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 181101 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181104 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181108 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrm),
     /* 181118 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181120 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181123 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181127 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181132 */   GIR_RootConstrainSelectedInstOperands,
     /* 181133 */   // GIR_Coverage, 21144,
     /* 181133 */   GIR_EraseRootFromParent_Done,
     /* 181134 */ // Label 3983: @181134
     /* 181134 */ GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(181179), // Rule ID 21152 //
     /* 181139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181153 */   // (uint_to_fp:{ *:[f32] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR32:{ *:[i32] }:$src)
     /* 181153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SSZrr),
     /* 181170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181175 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181177 */   GIR_RootConstrainSelectedInstOperands,
     /* 181178 */   // GIR_Coverage, 21152,
     /* 181178 */   GIR_EraseRootFromParent_Done,
     /* 181179 */ // Label 3984: @181179
     /* 181179 */ GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(181224), // Rule ID 21154 //
     /* 181184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 181194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181198 */   // (uint_to_fp:{ *:[f32] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SSZrr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), GR64:{ *:[i64] }:$src)
     /* 181198 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 181201 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181205 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SSZrr),
     /* 181215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181220 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181222 */   GIR_RootConstrainSelectedInstOperands,
     /* 181223 */   // GIR_Coverage, 21154,
     /* 181223 */   GIR_EraseRootFromParent_Done,
     /* 181224 */ // Label 3985: @181224
     /* 181224 */ GIM_Reject,
     /* 181225 */ // Label 3967: @181225
     /* 181225 */ GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(181301), // Rule ID 21150 //
     /* 181230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181248 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181255 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181261 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181268 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUSI642SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrm),
     /* 181285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181290 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181299 */   GIR_RootConstrainSelectedInstOperands,
     /* 181300 */   // GIR_Coverage, 21150,
     /* 181300 */   GIR_EraseRootFromParent_Done,
     /* 181301 */ // Label 3986: @181301
     /* 181301 */ GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(181377), // Rule ID 21148 //
     /* 181306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181316 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181320 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181324 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181327 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181331 */   GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 181335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181337 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181344 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (VCVTUSI2SDZrm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 181344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrm),
     /* 181361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181366 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181375 */   GIR_RootConstrainSelectedInstOperands,
     /* 181376 */   // GIR_Coverage, 21148,
     /* 181376 */   GIR_EraseRootFromParent_Done,
     /* 181377 */ // Label 3987: @181377
     /* 181377 */ GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(181422), // Rule ID 21156 //
     /* 181382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 181388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 181396 */   // (uint_to_fp:{ *:[f64] } GR32:{ *:[i32] }:$src)  =>  (VCVTUSI2SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR32:{ *:[i32] }:$src)
     /* 181396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI2SDZrr),
     /* 181413 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181415 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181420 */   GIR_RootConstrainSelectedInstOperands,
     /* 181421 */   // GIR_Coverage, 21156,
     /* 181421 */   GIR_EraseRootFromParent_Done,
     /* 181422 */ // Label 3988: @181422
     /* 181422 */ GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(181467), // Rule ID 21158 //
     /* 181427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 181430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 181433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 181437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 181441 */   // (uint_to_fp:{ *:[f64] } GR64:{ *:[i64] }:$src)  =>  (VCVTUSI642SDZrr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), GR64:{ *:[i64] }:$src)
     /* 181441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 181444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 181448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 181455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUSI642SDZrr),
     /* 181458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 181463 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 181465 */   GIR_RootConstrainSelectedInstOperands,
     /* 181466 */   // GIR_Coverage, 21158,
     /* 181466 */   GIR_EraseRootFromParent_Done,
     /* 181467 */ // Label 3989: @181467
     /* 181467 */ GIM_Reject,
     /* 181468 */ // Label 3968: @181468
     /* 181468 */ GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(181556),
     /* 181473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 181476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181480 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(181532), // Rule ID 11418 //
     /* 181485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181496 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181499 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181503 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181516 */     // (uint_to_fp:{ *:[v2f64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ128rm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 181516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rm),
     /* 181519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181530 */     GIR_RootConstrainSelectedInstOperands,
     /* 181531 */     // GIR_Coverage, 11418,
     /* 181531 */     GIR_EraseRootFromParent_Done,
     /* 181532 */   // Label 3991: @181532
     /* 181532 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(181555), // Rule ID 11414 //
     /* 181537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181544 */     // (uint_to_fp:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)  =>  (VCVTUQQ2PDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2i64] }:$src)
     /* 181544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ128rr),
     /* 181549 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181553 */     GIR_RootConstrainSelectedInstOperands,
     /* 181554 */     // GIR_Coverage, 11414,
     /* 181554 */     GIR_Done,
     /* 181555 */   // Label 3992: @181555
     /* 181555 */   GIM_Reject,
     /* 181556 */ // Label 3990: @181556
     /* 181556 */ GIM_Reject,
     /* 181557 */ // Label 3969: @181557
     /* 181557 */ GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(181616), // Rule ID 10962 //
     /* 181562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181580 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181587 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181591 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181593 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181600 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ128rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rm),
     /* 181603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181605 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181614 */   GIR_RootConstrainSelectedInstOperands,
     /* 181615 */   // GIR_Coverage, 10962,
     /* 181615 */   GIR_EraseRootFromParent_Done,
     /* 181616 */ // Label 3993: @181616
     /* 181616 */ GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(181675), // Rule ID 11538 //
     /* 181621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181631 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181635 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181639 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181642 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181646 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181650 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181652 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181659 */   // (uint_to_fp:{ *:[v4f32] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZ256rm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 181659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rm),
     /* 181662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181664 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181673 */   GIR_RootConstrainSelectedInstOperands,
     /* 181674 */   // GIR_Coverage, 11538,
     /* 181674 */   GIR_EraseRootFromParent_Done,
     /* 181675 */ // Label 3994: @181675
     /* 181675 */ GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(181705), // Rule ID 10958 //
     /* 181680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181694 */   // (uint_to_fp:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4i32] }:$src)
     /* 181694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ128rr),
     /* 181699 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181703 */   GIR_RootConstrainSelectedInstOperands,
     /* 181704 */   // GIR_Coverage, 10958,
     /* 181704 */   GIR_Done,
     /* 181705 */ // Label 3995: @181705
     /* 181705 */ GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(181735), // Rule ID 11534 //
     /* 181710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181724 */   // (uint_to_fp:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PSZ256rr:{ *:[v4f32] } VR256X:{ *:[v4i64] }:$src)
     /* 181724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZ256rr),
     /* 181729 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181733 */   GIR_RootConstrainSelectedInstOperands,
     /* 181734 */   // GIR_Coverage, 11534,
     /* 181734 */   GIR_Done,
     /* 181735 */ // Label 3996: @181735
     /* 181735 */ GIM_Reject,
     /* 181736 */ // Label 3970: @181736
     /* 181736 */ GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(181795), // Rule ID 10935 //
     /* 181741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181759 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181762 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181766 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181772 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181779 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181779 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rm),
     /* 181782 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181784 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181788 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181793 */   GIR_RootConstrainSelectedInstOperands,
     /* 181794 */   // GIR_Coverage, 10935,
     /* 181794 */   GIR_EraseRootFromParent_Done,
     /* 181795 */ // Label 3997: @181795
     /* 181795 */ GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(181854), // Rule ID 11430 //
     /* 181800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181810 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181814 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181818 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181821 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181825 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181831 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181838 */   // (uint_to_fp:{ *:[v4f64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZ256rm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 181838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rm),
     /* 181841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181843 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181847 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181852 */   GIR_RootConstrainSelectedInstOperands,
     /* 181853 */   // GIR_Coverage, 11430,
     /* 181853 */   GIR_EraseRootFromParent_Done,
     /* 181854 */ // Label 3998: @181854
     /* 181854 */ GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(181880), // Rule ID 10931 //
     /* 181859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 181862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 181865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181873 */   // (uint_to_fp:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)  =>  (VCVTUDQ2PDZ256rr:{ *:[v4f64] } VR128X:{ *:[v4i32] }:$src)
     /* 181873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZ256rr),
     /* 181878 */   GIR_RootConstrainSelectedInstOperands,
     /* 181879 */   // GIR_Coverage, 10931,
     /* 181879 */   GIR_Done,
     /* 181880 */ // Label 3999: @181880
     /* 181880 */ GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(181910), // Rule ID 11426 //
     /* 181885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI_HasVLX),
     /* 181888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 181891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 181899 */   // (uint_to_fp:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)  =>  (VCVTUQQ2PDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4i64] }:$src)
     /* 181899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZ256rr),
     /* 181904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 181908 */   GIR_RootConstrainSelectedInstOperands,
     /* 181909 */   // GIR_Coverage, 11426,
     /* 181909 */   GIR_Done,
     /* 181910 */ // Label 4000: @181910
     /* 181910 */ GIM_Reject,
     /* 181911 */ // Label 3971: @181911
     /* 181911 */ GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(181970), // Rule ID 11484 //
     /* 181916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 181922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181934 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181937 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 181941 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 181945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181947 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 181954 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZ256rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 181954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rm),
     /* 181957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 181959 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 181963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 181968 */   GIR_RootConstrainSelectedInstOperands,
     /* 181969 */   // GIR_Coverage, 11484,
     /* 181969 */   GIR_EraseRootFromParent_Done,
     /* 181970 */ // Label 4001: @181970
     /* 181970 */ GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(182029), // Rule ID 14676 //
     /* 181975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 181978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 181981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 181985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 181989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 181993 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 181996 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182000 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182006 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182013 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ128rm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 182013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rm),
     /* 182016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182018 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182022 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182027 */   GIR_RootConstrainSelectedInstOperands,
     /* 182028 */   // GIR_Coverage, 14676,
     /* 182028 */   GIR_EraseRootFromParent_Done,
     /* 182029 */ // Label 4002: @182029
     /* 182029 */ GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(182088), // Rule ID 15138 //
     /* 182034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182052 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182055 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182059 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182065 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182072 */   // (uint_to_fp:{ *:[v8f16] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PHZrm:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 182072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrm),
     /* 182075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182077 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182081 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182086 */   GIR_RootConstrainSelectedInstOperands,
     /* 182087 */   // GIR_Coverage, 15138,
     /* 182087 */   GIR_EraseRootFromParent_Done,
     /* 182088 */ // Label 4003: @182088
     /* 182088 */ GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(182118), // Rule ID 11480 //
     /* 182093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182107 */   // (uint_to_fp:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PHZ256rr:{ *:[v8f16] } VR256X:{ *:[v8i32] }:$src)
     /* 182107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZ256rr),
     /* 182112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182116 */   GIR_RootConstrainSelectedInstOperands,
     /* 182117 */   // GIR_Coverage, 11480,
     /* 182117 */   GIR_Done,
     /* 182118 */ // Label 4004: @182118
     /* 182118 */ GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(182148), // Rule ID 14672 //
     /* 182123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 182129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182137 */   // (uint_to_fp:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)  =>  (VCVTUW2PHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8i16] }:$src)
     /* 182137 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ128rr),
     /* 182142 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182146 */   GIR_RootConstrainSelectedInstOperands,
     /* 182147 */   // GIR_Coverage, 14672,
     /* 182147 */   GIR_Done,
     /* 182148 */ // Label 4005: @182148
     /* 182148 */ GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(182178), // Rule ID 15134 //
     /* 182153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 182163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182167 */   // (uint_to_fp:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PHZrr:{ *:[v8f16] } VR512:{ *:[v8i64] }:$src)
     /* 182167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PHZrr),
     /* 182172 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182176 */   GIR_RootConstrainSelectedInstOperands,
     /* 182177 */   // GIR_Coverage, 15134,
     /* 182177 */   GIR_Done,
     /* 182178 */ // Label 4006: @182178
     /* 182178 */ GIM_Reject,
     /* 182179 */ // Label 3972: @182179
     /* 182179 */ GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(182238), // Rule ID 10974 //
     /* 182184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182202 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182205 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182209 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182215 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182222 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZ256rm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rm),
     /* 182225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182227 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182236 */   GIR_RootConstrainSelectedInstOperands,
     /* 182237 */   // GIR_Coverage, 10974,
     /* 182237 */   GIR_EraseRootFromParent_Done,
     /* 182238 */ // Label 4007: @182238
     /* 182238 */ GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(182297), // Rule ID 11523 //
     /* 182243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182261 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182264 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182268 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182272 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182274 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182281 */   // (uint_to_fp:{ *:[v8f32] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PSZrm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 182281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrm),
     /* 182284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182286 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182295 */   GIR_RootConstrainSelectedInstOperands,
     /* 182296 */   // GIR_Coverage, 11523,
     /* 182296 */   GIR_EraseRootFromParent_Done,
     /* 182297 */ // Label 4008: @182297
     /* 182297 */ GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(182327), // Rule ID 10970 //
     /* 182302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 182305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182316 */   // (uint_to_fp:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8i32] }:$src)
     /* 182316 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZ256rr),
     /* 182321 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182325 */   GIR_RootConstrainSelectedInstOperands,
     /* 182326 */   // GIR_Coverage, 10970,
     /* 182326 */   GIR_Done,
     /* 182327 */ // Label 4009: @182327
     /* 182327 */ GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(182357), // Rule ID 11519 //
     /* 182332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182346 */   // (uint_to_fp:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PSZrr:{ *:[v8f32] } VR512:{ *:[v8i64] }:$src)
     /* 182346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PSZrr),
     /* 182351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182355 */   GIR_RootConstrainSelectedInstOperands,
     /* 182356 */   // GIR_Coverage, 11519,
     /* 182356 */   GIR_Done,
     /* 182357 */ // Label 4010: @182357
     /* 182357 */ GIM_Reject,
     /* 182358 */ // Label 3973: @182358
     /* 182358 */ GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(182417), // Rule ID 10911 //
     /* 182363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182381 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182384 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182388 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182394 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182401 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrm),
     /* 182404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182406 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182415 */   GIR_RootConstrainSelectedInstOperands,
     /* 182416 */   // GIR_Coverage, 10911,
     /* 182416 */   GIR_EraseRootFromParent_Done,
     /* 182417 */ // Label 4011: @182417
     /* 182417 */ GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(182476), // Rule ID 11403 //
     /* 182422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182432 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182436 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182440 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182443 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182447 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182453 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182460 */   // (uint_to_fp:{ *:[v8f64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUQQ2PDZrm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 182460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrm),
     /* 182463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182465 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182469 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182474 */   GIR_RootConstrainSelectedInstOperands,
     /* 182475 */   // GIR_Coverage, 11403,
     /* 182475 */   GIR_EraseRootFromParent_Done,
     /* 182476 */ // Label 4012: @182476
     /* 182476 */ GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(182502), // Rule ID 10907 //
     /* 182481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 182487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182495 */   // (uint_to_fp:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)  =>  (VCVTUDQ2PDZrr:{ *:[v8f64] } VR256X:{ *:[v8i32] }:$src)
     /* 182495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PDZrr),
     /* 182500 */   GIR_RootConstrainSelectedInstOperands,
     /* 182501 */   // GIR_Coverage, 10907,
     /* 182501 */   GIR_Done,
     /* 182502 */ // Label 4013: @182502
     /* 182502 */ GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(182532), // Rule ID 11399 //
     /* 182507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDQI),
     /* 182510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 182513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182521 */   // (uint_to_fp:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)  =>  (VCVTUQQ2PDZrr:{ *:[v8f64] } VR512:{ *:[v8i64] }:$src)
     /* 182521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUQQ2PDZrr),
     /* 182526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182530 */   GIR_RootConstrainSelectedInstOperands,
     /* 182531 */   // GIR_Coverage, 11399,
     /* 182531 */   GIR_Done,
     /* 182532 */ // Label 4014: @182532
     /* 182532 */ GIM_Reject,
     /* 182533 */ // Label 3974: @182533
     /* 182533 */ GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(182592), // Rule ID 11469 //
     /* 182538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182556 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182563 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182569 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182576 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PHZrm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrm),
     /* 182579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182581 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182590 */   GIR_RootConstrainSelectedInstOperands,
     /* 182591 */   // GIR_Coverage, 11469,
     /* 182591 */   GIR_EraseRootFromParent_Done,
     /* 182592 */ // Label 4015: @182592
     /* 182592 */ GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(182651), // Rule ID 14688 //
     /* 182597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182607 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182611 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182615 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182622 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182628 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182635 */   // (uint_to_fp:{ *:[v16f16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZ256rm:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 182635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rm),
     /* 182638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182640 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182649 */   GIR_RootConstrainSelectedInstOperands,
     /* 182650 */   // GIR_Coverage, 14688,
     /* 182650 */   GIR_EraseRootFromParent_Done,
     /* 182651 */ // Label 4016: @182651
     /* 182651 */ GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(182681), // Rule ID 11465 //
     /* 182656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182670 */   // (uint_to_fp:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PHZrr:{ *:[v16f16] } VR512:{ *:[v16i32] }:$src)
     /* 182670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PHZrr),
     /* 182675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182679 */   GIR_RootConstrainSelectedInstOperands,
     /* 182680 */   // GIR_Coverage, 11465,
     /* 182680 */   GIR_Done,
     /* 182681 */ // Label 4017: @182681
     /* 182681 */ GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(182711), // Rule ID 14684 //
     /* 182686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 182689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 182692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 182700 */   // (uint_to_fp:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)  =>  (VCVTUW2PHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16i16] }:$src)
     /* 182700 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZ256rr),
     /* 182705 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182709 */   GIR_RootConstrainSelectedInstOperands,
     /* 182710 */   // GIR_Coverage, 14684,
     /* 182710 */   GIR_Done,
     /* 182711 */ // Label 4018: @182711
     /* 182711 */ GIM_Reject,
     /* 182712 */ // Label 3975: @182712
     /* 182712 */ GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(182800),
     /* 182717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 182720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182724 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(182776), // Rule ID 10947 //
     /* 182729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182740 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182743 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182747 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182760 */     // (uint_to_fp:{ *:[v16f32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUDQ2PSZrm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 182760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrm),
     /* 182763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182774 */     GIR_RootConstrainSelectedInstOperands,
     /* 182775 */     // GIR_Coverage, 10947,
     /* 182775 */     GIR_EraseRootFromParent_Done,
     /* 182776 */   // Label 4020: @182776
     /* 182776 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(182799), // Rule ID 10943 //
     /* 182781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 182784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182788 */     // (uint_to_fp:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)  =>  (VCVTUDQ2PSZrr:{ *:[v16f32] } VR512:{ *:[v16i32] }:$src)
     /* 182788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUDQ2PSZrr),
     /* 182793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182797 */     GIR_RootConstrainSelectedInstOperands,
     /* 182798 */     // GIR_Coverage, 10943,
     /* 182798 */     GIR_Done,
     /* 182799 */   // Label 4021: @182799
     /* 182799 */   GIM_Reject,
     /* 182800 */ // Label 4019: @182800
     /* 182800 */ GIM_Reject,
     /* 182801 */ // Label 3976: @182801
     /* 182801 */ GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(182889),
     /* 182806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 182809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182813 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(182865), // Rule ID 14661 //
     /* 182818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 182825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 182829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 182832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 182836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 182840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 182849 */     // (uint_to_fp:{ *:[v32f16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VCVTUW2PHZrm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 182849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrm),
     /* 182852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182854 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 182858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 182863 */     GIR_RootConstrainSelectedInstOperands,
     /* 182864 */     // GIR_Coverage, 14661,
     /* 182864 */     GIR_EraseRootFromParent_Done,
     /* 182865 */   // Label 4023: @182865
     /* 182865 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(182888), // Rule ID 14657 //
     /* 182870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 182873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 182877 */     // (uint_to_fp:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)  =>  (VCVTUW2PHZrr:{ *:[v32f16] } VR512:{ *:[v32i16] }:$src)
     /* 182877 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VCVTUW2PHZrr),
     /* 182882 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 182886 */     GIR_RootConstrainSelectedInstOperands,
     /* 182887 */     // GIR_Coverage, 14657,
     /* 182887 */     GIR_Done,
     /* 182888 */   // Label 4024: @182888
     /* 182888 */   GIM_Reject,
     /* 182889 */ // Label 4022: @182889
     /* 182889 */ GIM_Reject,
     /* 182890 */ // Label 3977: @182890
     /* 182890 */ GIM_Reject,
     /* 182891 */ // Label 53: @182891
     /* 182891 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 4028*/ GIMT_Encode4(183013),
     /* 182902 */ /*GILLT_s32*//*Label 4025*/ GIMT_Encode4(182914),
     /* 182906 */ /*GILLT_s64*//*Label 4026*/ GIMT_Encode4(182947),
     /* 182910 */ /*GILLT_s80*//*Label 4027*/ GIMT_Encode4(182980),
     /* 182914 */ // Label 4025: @182914
     /* 182914 */ GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(182946), // Rule ID 1045 //
     /* 182919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 182922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 182925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 182933 */   // (fabs:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (ABS_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 182933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp32),
     /* 182938 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182944 */   GIR_RootConstrainSelectedInstOperands,
     /* 182945 */   // GIR_Coverage, 1045,
     /* 182945 */   GIR_Done,
     /* 182946 */ // Label 4029: @182946
     /* 182946 */ GIM_Reject,
     /* 182947 */ // Label 4026: @182947
     /* 182947 */ GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(182979), // Rule ID 1046 //
     /* 182952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 182955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 182966 */   // (fabs:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (ABS_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 182966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp64),
     /* 182971 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 182977 */   GIR_RootConstrainSelectedInstOperands,
     /* 182978 */   // GIR_Coverage, 1046,
     /* 182978 */   GIR_Done,
     /* 182979 */ // Label 4030: @182979
     /* 182979 */ GIM_Reject,
     /* 182980 */ // Label 4027: @182980
     /* 182980 */ GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(183012), // Rule ID 1047 //
     /* 182985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 182988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 182991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 182999 */   // (fabs:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (ABS_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 182999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ABS_Fp80),
     /* 183004 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 183010 */   GIR_RootConstrainSelectedInstOperands,
     /* 183011 */   // GIR_Coverage, 1047,
     /* 183011 */   GIR_Done,
     /* 183012 */ // Label 4031: @183012
     /* 183012 */ GIM_Reject,
     /* 183013 */ // Label 4028: @183013
     /* 183013 */ GIM_Reject,
     /* 183014 */ // Label 54: @183014
     /* 183014 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4044*/ GIMT_Encode4(186334),
     /* 183025 */ /*GILLT_v2s64*//*Label 4032*/ GIMT_Encode4(183093), GIMT_Encode4(0),
     /* 183033 */ /*GILLT_v4s32*//*Label 4033*/ GIMT_Encode4(183422),
     /* 183037 */ /*GILLT_v4s64*//*Label 4034*/ GIMT_Encode4(183764), GIMT_Encode4(0),
     /* 183045 */ /*GILLT_v8s16*//*Label 4035*/ GIMT_Encode4(184081),
     /* 183049 */ /*GILLT_v8s32*//*Label 4036*/ GIMT_Encode4(184423),
     /* 183053 */ /*GILLT_v8s64*//*Label 4037*/ GIMT_Encode4(184738), GIMT_Encode4(0),
     /* 183061 */ /*GILLT_v16s8*//*Label 4038*/ GIMT_Encode4(184894),
     /* 183065 */ /*GILLT_v16s16*//*Label 4039*/ GIMT_Encode4(185236),
     /* 183069 */ /*GILLT_v16s32*//*Label 4040*/ GIMT_Encode4(185551), GIMT_Encode4(0),
     /* 183077 */ /*GILLT_v32s8*//*Label 4041*/ GIMT_Encode4(185707),
     /* 183081 */ /*GILLT_v32s16*//*Label 4042*/ GIMT_Encode4(186022), GIMT_Encode4(0),
     /* 183089 */ /*GILLT_v64s8*//*Label 4043*/ GIMT_Encode4(186178),
     /* 183093 */ // Label 4032: @183093
     /* 183093 */ GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(183421),
     /* 183098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 183101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 183104 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(183166), // Rule ID 24077 //
     /* 183109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183124 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183127 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183131 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183141 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183148 */     // (smin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183153 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183155 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183164 */     GIR_RootConstrainSelectedInstOperands,
     /* 183165 */     // GIR_Coverage, 24077,
     /* 183165 */     GIR_EraseRootFromParent_Done,
     /* 183166 */   // Label 4046: @183166
     /* 183166 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(183228), // Rule ID 5590 //
     /* 183171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183210 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rm),
     /* 183213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183226 */     GIR_RootConstrainSelectedInstOperands,
     /* 183227 */     // GIR_Coverage, 5590,
     /* 183227 */     GIR_EraseRootFromParent_Done,
     /* 183228 */   // Label 4047: @183228
     /* 183228 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(183255), // Rule ID 5587 //
     /* 183233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183248 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 183248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ128rr),
     /* 183253 */     GIR_RootConstrainSelectedInstOperands,
     /* 183254 */     // GIR_Coverage, 5587,
     /* 183254 */     GIR_Done,
     /* 183255 */   // Label 4048: @183255
     /* 183255 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(183420), // Rule ID 20014 //
     /* 183260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 183267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183275 */     // (smin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 183275 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183278 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183282 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183289 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183292 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183296 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183301 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183304 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183308 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 183311 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183316 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183321 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183326 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183329 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183333 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 183343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183352 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 183355 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 183359 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 183362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183367 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183372 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 183377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 183380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 183384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 183392 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 183395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 183400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183402 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 183409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 183414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183419 */     // GIR_Coverage, 20014,
     /* 183419 */     GIR_EraseRootFromParent_Done,
     /* 183420 */   // Label 4049: @183420
     /* 183420 */   GIM_Reject,
     /* 183421 */ // Label 4045: @183421
     /* 183421 */ GIM_Reject,
     /* 183422 */ // Label 4033: @183422
     /* 183422 */ GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(183763),
     /* 183427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 183430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 183433 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(183495), // Rule ID 23501 //
     /* 183438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183477 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183482 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183493 */     GIR_RootConstrainSelectedInstOperands,
     /* 183494 */     // GIR_Coverage, 23501,
     /* 183494 */     GIR_EraseRootFromParent_Done,
     /* 183495 */   // Label 4051: @183495
     /* 183495 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(183557), // Rule ID 24059 //
     /* 183500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183515 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183518 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183522 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183539 */     // (smin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183555 */     GIR_RootConstrainSelectedInstOperands,
     /* 183556 */     // GIR_Coverage, 24059,
     /* 183556 */     GIR_EraseRootFromParent_Done,
     /* 183557 */   // Label 4052: @183557
     /* 183557 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(183619), // Rule ID 3186 //
     /* 183562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183584 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183588 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183601 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDrm),
     /* 183604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183617 */     GIR_RootConstrainSelectedInstOperands,
     /* 183618 */     // GIR_Coverage, 3186,
     /* 183618 */     GIR_EraseRootFromParent_Done,
     /* 183619 */   // Label 4053: @183619
     /* 183619 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(183681), // Rule ID 5563 //
     /* 183624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183643 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183650 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183663 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rm),
     /* 183666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183670 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183679 */     GIR_RootConstrainSelectedInstOperands,
     /* 183680 */     // GIR_Coverage, 5563,
     /* 183680 */     GIR_EraseRootFromParent_Done,
     /* 183681 */   // Label 4054: @183681
     /* 183681 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(183708), // Rule ID 3185 //
     /* 183686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 183689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183701 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDrr),
     /* 183706 */     GIR_RootConstrainSelectedInstOperands,
     /* 183707 */     // GIR_Coverage, 3185,
     /* 183707 */     GIR_Done,
     /* 183708 */   // Label 4055: @183708
     /* 183708 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(183735), // Rule ID 3223 //
     /* 183713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 183716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 183728 */     // (smin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 183728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSDrr),
     /* 183733 */     GIR_RootConstrainSelectedInstOperands,
     /* 183734 */     // GIR_Coverage, 3223,
     /* 183734 */     GIR_Done,
     /* 183735 */   // Label 4056: @183735
     /* 183735 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(183762), // Rule ID 5560 //
     /* 183740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 183755 */     // (smin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 183755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ128rr),
     /* 183760 */     GIR_RootConstrainSelectedInstOperands,
     /* 183761 */     // GIR_Coverage, 5560,
     /* 183761 */     GIR_Done,
     /* 183762 */   // Label 4057: @183762
     /* 183762 */   GIM_Reject,
     /* 183763 */ // Label 4050: @183763
     /* 183763 */ GIM_Reject,
     /* 183764 */ // Label 4034: @183764
     /* 183764 */ GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(184080),
     /* 183769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 183772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 183775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183779 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(183837), // Rule ID 24071 //
     /* 183784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 183791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183795 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183802 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183812 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183819 */     // (smin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 183826 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183835 */     GIR_RootConstrainSelectedInstOperands,
     /* 183836 */     // GIR_Coverage, 24071,
     /* 183836 */     GIR_EraseRootFromParent_Done,
     /* 183837 */   // Label 4059: @183837
     /* 183837 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(183895), // Rule ID 5581 //
     /* 183842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 183853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 183857 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 183860 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 183864 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 183868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 183870 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 183877 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 183877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rm),
     /* 183880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 183884 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 183888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 183893 */     GIR_RootConstrainSelectedInstOperands,
     /* 183894 */     // GIR_Coverage, 5581,
     /* 183894 */     GIR_EraseRootFromParent_Done,
     /* 183895 */   // Label 4060: @183895
     /* 183895 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(183918), // Rule ID 5578 //
     /* 183900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 183903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183911 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 183911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZ256rr),
     /* 183916 */     GIR_RootConstrainSelectedInstOperands,
     /* 183917 */     // GIR_Coverage, 5578,
     /* 183917 */     GIR_Done,
     /* 183918 */   // Label 4061: @183918
     /* 183918 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(184079), // Rule ID 20012 //
     /* 183923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 183926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 183934 */     // (smin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 183934 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 183937 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183941 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 183948 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 183951 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183955 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183960 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 183963 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 183967 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 183970 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 183975 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 183980 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 183985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 183988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 183999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 184002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184011 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 184014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 184018 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 184021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 184026 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 184039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184048 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 184051 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 184054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 184056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 184059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 184068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 184073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 184078 */     // GIR_Coverage, 20012,
     /* 184078 */     GIR_EraseRootFromParent_Done,
     /* 184079 */   // Label 4062: @184079
     /* 184079 */   GIM_Reject,
     /* 184080 */ // Label 4058: @184080
     /* 184080 */ GIM_Reject,
     /* 184081 */ // Label 4035: @184081
     /* 184081 */ GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(184422),
     /* 184086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 184089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184092 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(184154), // Rule ID 23465 //
     /* 184097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184136 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184152 */     GIR_RootConstrainSelectedInstOperands,
     /* 184153 */     // GIR_Coverage, 23465,
     /* 184153 */     GIR_EraseRootFromParent_Done,
     /* 184154 */   // Label 4064: @184154
     /* 184154 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(184216), // Rule ID 24044 //
     /* 184159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184198 */     // (smin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184214 */     GIR_RootConstrainSelectedInstOperands,
     /* 184215 */     // GIR_Coverage, 24044,
     /* 184215 */     GIR_EraseRootFromParent_Done,
     /* 184216 */   // Label 4065: @184216
     /* 184216 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(184278), // Rule ID 2643 //
     /* 184221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184240 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184243 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184247 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184260 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWrm),
     /* 184263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184265 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184276 */     GIR_RootConstrainSelectedInstOperands,
     /* 184277 */     // GIR_Coverage, 2643,
     /* 184277 */     GIR_EraseRootFromParent_Done,
     /* 184278 */   // Label 4066: @184278
     /* 184278 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(184340), // Rule ID 5539 //
     /* 184283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184302 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184305 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184322 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rm),
     /* 184325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184338 */     GIR_RootConstrainSelectedInstOperands,
     /* 184339 */     // GIR_Coverage, 5539,
     /* 184339 */     GIR_EraseRootFromParent_Done,
     /* 184340 */   // Label 4067: @184340
     /* 184340 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(184367), // Rule ID 2642 //
     /* 184345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184360 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWrr),
     /* 184365 */     GIR_RootConstrainSelectedInstOperands,
     /* 184366 */     // GIR_Coverage, 2642,
     /* 184366 */     GIR_Done,
     /* 184367 */   // Label 4068: @184367
     /* 184367 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(184394), // Rule ID 2644 //
     /* 184372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 184375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184387 */     // (smin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 184387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSWrr),
     /* 184392 */     GIR_RootConstrainSelectedInstOperands,
     /* 184393 */     // GIR_Coverage, 2644,
     /* 184393 */     GIR_Done,
     /* 184394 */   // Label 4069: @184394
     /* 184394 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(184421), // Rule ID 5536 //
     /* 184399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184414 */     // (smin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 184414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ128rr),
     /* 184419 */     GIR_RootConstrainSelectedInstOperands,
     /* 184420 */     // GIR_Coverage, 5536,
     /* 184420 */     GIR_Done,
     /* 184421 */   // Label 4070: @184421
     /* 184421 */   GIM_Reject,
     /* 184422 */ // Label 4063: @184422
     /* 184422 */ GIM_Reject,
     /* 184423 */ // Label 4036: @184423
     /* 184423 */ GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(184737),
     /* 184428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 184431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 184434 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(184496), // Rule ID 23510 //
     /* 184439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184478 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184494 */     GIR_RootConstrainSelectedInstOperands,
     /* 184495 */     // GIR_Coverage, 23510,
     /* 184495 */     GIR_EraseRootFromParent_Done,
     /* 184496 */   // Label 4072: @184496
     /* 184496 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(184558), // Rule ID 24053 //
     /* 184501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184540 */     // (smin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184545 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184556 */     GIR_RootConstrainSelectedInstOperands,
     /* 184557 */     // GIR_Coverage, 24053,
     /* 184557 */     GIR_EraseRootFromParent_Done,
     /* 184558 */   // Label 4073: @184558
     /* 184558 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(184620), // Rule ID 3204 //
     /* 184563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184602 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrm),
     /* 184605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184618 */     GIR_RootConstrainSelectedInstOperands,
     /* 184619 */     // GIR_Coverage, 3204,
     /* 184619 */     GIR_EraseRootFromParent_Done,
     /* 184620 */   // Label 4074: @184620
     /* 184620 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(184682), // Rule ID 5554 //
     /* 184625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184664 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rm),
     /* 184667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184680 */     GIR_RootConstrainSelectedInstOperands,
     /* 184681 */     // GIR_Coverage, 5554,
     /* 184681 */     GIR_EraseRootFromParent_Done,
     /* 184682 */   // Label 4075: @184682
     /* 184682 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(184709), // Rule ID 3203 //
     /* 184687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 184690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 184702 */     // (smin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 184702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDYrr),
     /* 184707 */     GIR_RootConstrainSelectedInstOperands,
     /* 184708 */     // GIR_Coverage, 3203,
     /* 184708 */     GIR_Done,
     /* 184709 */   // Label 4076: @184709
     /* 184709 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(184736), // Rule ID 5551 //
     /* 184714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 184717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 184729 */     // (smin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 184729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZ256rr),
     /* 184734 */     GIR_RootConstrainSelectedInstOperands,
     /* 184735 */     // GIR_Coverage, 5551,
     /* 184735 */     GIR_Done,
     /* 184736 */   // Label 4077: @184736
     /* 184736 */   GIM_Reject,
     /* 184737 */ // Label 4071: @184737
     /* 184737 */ GIM_Reject,
     /* 184738 */ // Label 4037: @184738
     /* 184738 */ GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(184893),
     /* 184743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 184746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 184749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184753 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(184811), // Rule ID 24065 //
     /* 184758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184769 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184772 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184776 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184793 */     // (smin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184798 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184809 */     GIR_RootConstrainSelectedInstOperands,
     /* 184810 */     // GIR_Coverage, 24065,
     /* 184810 */     GIR_EraseRootFromParent_Done,
     /* 184811 */   // Label 4079: @184811
     /* 184811 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(184869), // Rule ID 5572 //
     /* 184816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 184827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184831 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184834 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184851 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrm),
     /* 184854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184856 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 184858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184867 */     GIR_RootConstrainSelectedInstOperands,
     /* 184868 */     // GIR_Coverage, 5572,
     /* 184868 */     GIR_EraseRootFromParent_Done,
     /* 184869 */   // Label 4080: @184869
     /* 184869 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(184892), // Rule ID 5569 //
     /* 184874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 184877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 184885 */     // (smin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 184885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSQZrr),
     /* 184890 */     GIR_RootConstrainSelectedInstOperands,
     /* 184891 */     // GIR_Coverage, 5569,
     /* 184891 */     GIR_Done,
     /* 184892 */   // Label 4081: @184892
     /* 184892 */   GIM_Reject,
     /* 184893 */ // Label 4078: @184893
     /* 184893 */ GIM_Reject,
     /* 184894 */ // Label 4038: @184894
     /* 184894 */ GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(185235),
     /* 184899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 184902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 184905 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(184967), // Rule ID 23506 //
     /* 184910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 184913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184925 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184928 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184932 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 184940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184942 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 184949 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 184949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 184952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 184954 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 184956 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 184960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 184965 */     GIR_RootConstrainSelectedInstOperands,
     /* 184966 */     // GIR_Coverage, 23506,
     /* 184966 */     GIR_EraseRootFromParent_Done,
     /* 184967 */   // Label 4083: @184967
     /* 184967 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(185029), // Rule ID 24035 //
     /* 184972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 184975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 184979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 184983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 184987 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 184990 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 184994 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 184998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185011 */     // (smin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 185014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185016 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185018 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185027 */     GIR_RootConstrainSelectedInstOperands,
     /* 185028 */     // GIR_Coverage, 24035,
     /* 185028 */     GIR_EraseRootFromParent_Done,
     /* 185029 */   // Label 4084: @185029
     /* 185029 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(185091), // Rule ID 3196 //
     /* 185034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185066 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185073 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBrm),
     /* 185076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185078 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185080 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185089 */     GIR_RootConstrainSelectedInstOperands,
     /* 185090 */     // GIR_Coverage, 3196,
     /* 185090 */     GIR_EraseRootFromParent_Done,
     /* 185091 */   // Label 4085: @185091
     /* 185091 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(185153), // Rule ID 5521 //
     /* 185096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185135 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rm),
     /* 185138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185151 */     GIR_RootConstrainSelectedInstOperands,
     /* 185152 */     // GIR_Coverage, 5521,
     /* 185152 */     GIR_EraseRootFromParent_Done,
     /* 185153 */   // Label 4086: @185153
     /* 185153 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(185180), // Rule ID 3195 //
     /* 185158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 185161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185173 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBrr),
     /* 185178 */     GIR_RootConstrainSelectedInstOperands,
     /* 185179 */     // GIR_Coverage, 3195,
     /* 185179 */     GIR_Done,
     /* 185180 */   // Label 4087: @185180
     /* 185180 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(185207), // Rule ID 3221 //
     /* 185185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 185188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 185200 */     // (smin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 185200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINSBrr),
     /* 185205 */     GIR_RootConstrainSelectedInstOperands,
     /* 185206 */     // GIR_Coverage, 3221,
     /* 185206 */     GIR_Done,
     /* 185207 */   // Label 4088: @185207
     /* 185207 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(185234), // Rule ID 5518 //
     /* 185212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 185227 */     // (smin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 185227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ128rr),
     /* 185232 */     GIR_RootConstrainSelectedInstOperands,
     /* 185233 */     // GIR_Coverage, 5518,
     /* 185233 */     GIR_Done,
     /* 185234 */   // Label 4089: @185234
     /* 185234 */   GIM_Reject,
     /* 185235 */ // Label 4082: @185235
     /* 185235 */ GIM_Reject,
     /* 185236 */ // Label 4039: @185236
     /* 185236 */ GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(185550),
     /* 185241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 185244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 185247 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(185309), // Rule ID 23467 //
     /* 185252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185267 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185270 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185274 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185291 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185296 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185307 */     GIR_RootConstrainSelectedInstOperands,
     /* 185308 */     // GIR_Coverage, 23467,
     /* 185308 */     GIR_EraseRootFromParent_Done,
     /* 185309 */   // Label 4091: @185309
     /* 185309 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(185371), // Rule ID 24041 //
     /* 185314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185329 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185336 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185346 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185353 */     // (smin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185360 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185369 */     GIR_RootConstrainSelectedInstOperands,
     /* 185370 */     // GIR_Coverage, 24041,
     /* 185370 */     GIR_EraseRootFromParent_Done,
     /* 185371 */   // Label 4092: @185371
     /* 185371 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(185433), // Rule ID 2647 //
     /* 185376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185395 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185398 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185402 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185408 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185415 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrm),
     /* 185418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185420 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185431 */     GIR_RootConstrainSelectedInstOperands,
     /* 185432 */     // GIR_Coverage, 2647,
     /* 185432 */     GIR_EraseRootFromParent_Done,
     /* 185433 */   // Label 4093: @185433
     /* 185433 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(185495), // Rule ID 5533 //
     /* 185438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185457 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185460 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185464 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185470 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185477 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rm),
     /* 185480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185484 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185493 */     GIR_RootConstrainSelectedInstOperands,
     /* 185494 */     // GIR_Coverage, 5533,
     /* 185494 */     GIR_EraseRootFromParent_Done,
     /* 185495 */   // Label 4094: @185495
     /* 185495 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(185522), // Rule ID 2646 //
     /* 185500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185515 */     // (smin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 185515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWYrr),
     /* 185520 */     GIR_RootConstrainSelectedInstOperands,
     /* 185521 */     // GIR_Coverage, 2646,
     /* 185521 */     GIR_Done,
     /* 185522 */   // Label 4095: @185522
     /* 185522 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(185549), // Rule ID 5530 //
     /* 185527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185542 */     // (smin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 185542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZ256rr),
     /* 185547 */     GIR_RootConstrainSelectedInstOperands,
     /* 185548 */     // GIR_Coverage, 5530,
     /* 185548 */     GIR_Done,
     /* 185549 */   // Label 4096: @185549
     /* 185549 */   GIM_Reject,
     /* 185550 */ // Label 4090: @185550
     /* 185550 */ GIM_Reject,
     /* 185551 */ // Label 4040: @185551
     /* 185551 */ GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(185706),
     /* 185556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 185559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 185562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185566 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(185624), // Rule ID 24047 //
     /* 185571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185606 */     // (smin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185617 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185622 */     GIR_RootConstrainSelectedInstOperands,
     /* 185623 */     // GIR_Coverage, 24047,
     /* 185623 */     GIR_EraseRootFromParent_Done,
     /* 185624 */   // Label 4098: @185624
     /* 185624 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(185682), // Rule ID 5545 //
     /* 185629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185664 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrm),
     /* 185667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185680 */     GIR_RootConstrainSelectedInstOperands,
     /* 185681 */     // GIR_Coverage, 5545,
     /* 185681 */     GIR_EraseRootFromParent_Done,
     /* 185682 */   // Label 4099: @185682
     /* 185682 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(185705), // Rule ID 5542 //
     /* 185687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 185690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 185698 */     // (smin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 185698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSDZrr),
     /* 185703 */     GIR_RootConstrainSelectedInstOperands,
     /* 185704 */     // GIR_Coverage, 5542,
     /* 185704 */     GIR_Done,
     /* 185705 */   // Label 4100: @185705
     /* 185705 */   GIM_Reject,
     /* 185706 */ // Label 4097: @185706
     /* 185706 */ GIM_Reject,
     /* 185707 */ // Label 4041: @185707
     /* 185707 */ GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(186021),
     /* 185712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 185715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 185718 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(185780), // Rule ID 23515 //
     /* 185723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185755 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185762 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185767 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185769 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185778 */     GIR_RootConstrainSelectedInstOperands,
     /* 185779 */     // GIR_Coverage, 23515,
     /* 185779 */     GIR_EraseRootFromParent_Done,
     /* 185780 */   // Label 4102: @185780
     /* 185780 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(185842), // Rule ID 24032 //
     /* 185785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 185796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185817 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185824 */     // (smin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185829 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 185831 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185840 */     GIR_RootConstrainSelectedInstOperands,
     /* 185841 */     // GIR_Coverage, 24032,
     /* 185841 */     GIR_EraseRootFromParent_Done,
     /* 185842 */   // Label 4103: @185842
     /* 185842 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(185904), // Rule ID 3214 //
     /* 185847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185866 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185869 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185873 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185879 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185886 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrm),
     /* 185889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185891 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185902 */     GIR_RootConstrainSelectedInstOperands,
     /* 185903 */     // GIR_Coverage, 3214,
     /* 185903 */     GIR_EraseRootFromParent_Done,
     /* 185904 */   // Label 4104: @185904
     /* 185904 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(185966), // Rule ID 5515 //
     /* 185909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 185912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 185920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 185924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 185928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 185931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 185935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 185939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 185948 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 185948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rm),
     /* 185951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 185953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 185955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 185959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 185964 */     GIR_RootConstrainSelectedInstOperands,
     /* 185965 */     // GIR_Coverage, 5515,
     /* 185965 */     GIR_EraseRootFromParent_Done,
     /* 185966 */   // Label 4105: @185966
     /* 185966 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(185993), // Rule ID 3213 //
     /* 185971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 185974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 185986 */     // (smin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 185986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBYrr),
     /* 185991 */     GIR_RootConstrainSelectedInstOperands,
     /* 185992 */     // GIR_Coverage, 3213,
     /* 185992 */     GIR_Done,
     /* 185993 */   // Label 4106: @185993
     /* 185993 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(186020), // Rule ID 5512 //
     /* 185998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 186001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 186013 */     // (smin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 186013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZ256rr),
     /* 186018 */     GIR_RootConstrainSelectedInstOperands,
     /* 186019 */     // GIR_Coverage, 5512,
     /* 186019 */     GIR_Done,
     /* 186020 */   // Label 4107: @186020
     /* 186020 */   GIM_Reject,
     /* 186021 */ // Label 4101: @186021
     /* 186021 */ GIM_Reject,
     /* 186022 */ // Label 4042: @186022
     /* 186022 */ GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(186177),
     /* 186027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 186030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 186033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186037 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(186095), // Rule ID 24038 //
     /* 186042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186053 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186056 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186060 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186070 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186077 */     // (smin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186084 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186093 */     GIR_RootConstrainSelectedInstOperands,
     /* 186094 */     // GIR_Coverage, 24038,
     /* 186094 */     GIR_EraseRootFromParent_Done,
     /* 186095 */   // Label 4109: @186095
     /* 186095 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(186153), // Rule ID 5527 //
     /* 186100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186115 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186122 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186128 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186135 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrm),
     /* 186138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186140 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186151 */     GIR_RootConstrainSelectedInstOperands,
     /* 186152 */     // GIR_Coverage, 5527,
     /* 186152 */     GIR_EraseRootFromParent_Done,
     /* 186153 */   // Label 4110: @186153
     /* 186153 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(186176), // Rule ID 5524 //
     /* 186158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186169 */     // (smin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 186169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSWZrr),
     /* 186174 */     GIR_RootConstrainSelectedInstOperands,
     /* 186175 */     // GIR_Coverage, 5524,
     /* 186175 */     GIR_Done,
     /* 186176 */   // Label 4111: @186176
     /* 186176 */   GIM_Reject,
     /* 186177 */ // Label 4108: @186177
     /* 186177 */ GIM_Reject,
     /* 186178 */ // Label 4043: @186178
     /* 186178 */ GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(186333),
     /* 186183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 186186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 186189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186193 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(186251), // Rule ID 24029 //
     /* 186198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186209 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186216 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186226 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186233 */     // (smin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186238 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186240 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186244 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186249 */     GIR_RootConstrainSelectedInstOperands,
     /* 186250 */     // GIR_Coverage, 24029,
     /* 186250 */     GIR_EraseRootFromParent_Done,
     /* 186251 */   // Label 4113: @186251
     /* 186251 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(186309), // Rule ID 5509 //
     /* 186256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186271 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186274 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186284 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186291 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrm),
     /* 186294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186298 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186307 */     GIR_RootConstrainSelectedInstOperands,
     /* 186308 */     // GIR_Coverage, 5509,
     /* 186308 */     GIR_EraseRootFromParent_Done,
     /* 186309 */   // Label 4114: @186309
     /* 186309 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(186332), // Rule ID 5506 //
     /* 186314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 186317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 186325 */     // (smin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 186325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINSBZrr),
     /* 186330 */     GIR_RootConstrainSelectedInstOperands,
     /* 186331 */     // GIR_Coverage, 5506,
     /* 186331 */     GIR_Done,
     /* 186332 */   // Label 4115: @186332
     /* 186332 */   GIM_Reject,
     /* 186333 */ // Label 4112: @186333
     /* 186333 */ GIM_Reject,
     /* 186334 */ // Label 4044: @186334
     /* 186334 */ GIM_Reject,
     /* 186335 */ // Label 55: @186335
     /* 186335 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4128*/ GIMT_Encode4(189655),
     /* 186346 */ /*GILLT_v2s64*//*Label 4116*/ GIMT_Encode4(186414), GIMT_Encode4(0),
     /* 186354 */ /*GILLT_v4s32*//*Label 4117*/ GIMT_Encode4(186743),
     /* 186358 */ /*GILLT_v4s64*//*Label 4118*/ GIMT_Encode4(187085), GIMT_Encode4(0),
     /* 186366 */ /*GILLT_v8s16*//*Label 4119*/ GIMT_Encode4(187402),
     /* 186370 */ /*GILLT_v8s32*//*Label 4120*/ GIMT_Encode4(187744),
     /* 186374 */ /*GILLT_v8s64*//*Label 4121*/ GIMT_Encode4(188059), GIMT_Encode4(0),
     /* 186382 */ /*GILLT_v16s8*//*Label 4122*/ GIMT_Encode4(188215),
     /* 186386 */ /*GILLT_v16s16*//*Label 4123*/ GIMT_Encode4(188557),
     /* 186390 */ /*GILLT_v16s32*//*Label 4124*/ GIMT_Encode4(188872), GIMT_Encode4(0),
     /* 186398 */ /*GILLT_v32s8*//*Label 4125*/ GIMT_Encode4(189028),
     /* 186402 */ /*GILLT_v32s16*//*Label 4126*/ GIMT_Encode4(189343), GIMT_Encode4(0),
     /* 186410 */ /*GILLT_v64s8*//*Label 4127*/ GIMT_Encode4(189499),
     /* 186414 */ // Label 4116: @186414
     /* 186414 */ GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(186742),
     /* 186419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 186422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186425 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(186487), // Rule ID 23969 //
     /* 186430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186462 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186469 */     // (smax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186474 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186476 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186485 */     GIR_RootConstrainSelectedInstOperands,
     /* 186486 */     // GIR_Coverage, 23969,
     /* 186486 */     GIR_EraseRootFromParent_Done,
     /* 186487 */   // Label 4130: @186487
     /* 186487 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(186549), // Rule ID 5410 //
     /* 186492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186511 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186514 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186518 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186524 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186531 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rm),
     /* 186534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186538 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186547 */     GIR_RootConstrainSelectedInstOperands,
     /* 186548 */     // GIR_Coverage, 5410,
     /* 186548 */     GIR_EraseRootFromParent_Done,
     /* 186549 */   // Label 4131: @186549
     /* 186549 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(186576), // Rule ID 5407 //
     /* 186554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186569 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 186569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ128rr),
     /* 186574 */     GIR_RootConstrainSelectedInstOperands,
     /* 186575 */     // GIR_Coverage, 5407,
     /* 186575 */     GIR_Done,
     /* 186576 */   // Label 4132: @186576
     /* 186576 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(186741), // Rule ID 20010 //
     /* 186581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 186584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 186588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186596 */     // (smax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 186596 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 186599 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186603 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 186610 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 186613 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186617 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186622 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 186625 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 186629 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 186632 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186637 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186642 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186647 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 186650 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186654 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 186661 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 186664 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186668 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186673 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 186676 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 186680 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 186683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 186688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 186698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 186701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 186705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 186713 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 186716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 186718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 186721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186723 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 186730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 186735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 186740 */     // GIR_Coverage, 20010,
     /* 186740 */     GIR_EraseRootFromParent_Done,
     /* 186741 */   // Label 4133: @186741
     /* 186741 */   GIM_Reject,
     /* 186742 */ // Label 4129: @186742
     /* 186742 */ GIM_Reject,
     /* 186743 */ // Label 4117: @186743
     /* 186743 */ GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(187084),
     /* 186748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 186751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186754 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(186816), // Rule ID 23503 //
     /* 186759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186777 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186781 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186798 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186803 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186814 */     GIR_RootConstrainSelectedInstOperands,
     /* 186815 */     // GIR_Coverage, 23503,
     /* 186815 */     GIR_EraseRootFromParent_Done,
     /* 186816 */   // Label 4135: @186816
     /* 186816 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(186878), // Rule ID 23951 //
     /* 186821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 186832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186836 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186839 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186843 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186853 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186860 */     // (smax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 186867 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186876 */     GIR_RootConstrainSelectedInstOperands,
     /* 186877 */     // GIR_Coverage, 23951,
     /* 186877 */     GIR_EraseRootFromParent_Done,
     /* 186878 */   // Label 4136: @186878
     /* 186878 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(186940), // Rule ID 3190 //
     /* 186883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 186886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 186894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186922 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrm),
     /* 186925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186927 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186929 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 186938 */     GIR_RootConstrainSelectedInstOperands,
     /* 186939 */     // GIR_Coverage, 3190,
     /* 186939 */     GIR_EraseRootFromParent_Done,
     /* 186940 */   // Label 4137: @186940
     /* 186940 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(187002), // Rule ID 5383 //
     /* 186945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 186948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 186956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 186960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 186964 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 186967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 186971 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 186975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 186977 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 186984 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 186984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rm),
     /* 186987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186989 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 186991 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 186995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187000 */     GIR_RootConstrainSelectedInstOperands,
     /* 187001 */     // GIR_Coverage, 5383,
     /* 187001 */     GIR_EraseRootFromParent_Done,
     /* 187002 */   // Label 4138: @187002
     /* 187002 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(187029), // Rule ID 3189 //
     /* 187007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 187010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187022 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDrr),
     /* 187027 */     GIR_RootConstrainSelectedInstOperands,
     /* 187028 */     // GIR_Coverage, 3189,
     /* 187028 */     GIR_Done,
     /* 187029 */   // Label 4139: @187029
     /* 187029 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(187056), // Rule ID 3231 //
     /* 187034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 187037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187049 */     // (smax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 187049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSDrr),
     /* 187054 */     GIR_RootConstrainSelectedInstOperands,
     /* 187055 */     // GIR_Coverage, 3231,
     /* 187055 */     GIR_Done,
     /* 187056 */   // Label 4140: @187056
     /* 187056 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(187083), // Rule ID 5380 //
     /* 187061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187076 */     // (smax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 187076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ128rr),
     /* 187081 */     GIR_RootConstrainSelectedInstOperands,
     /* 187082 */     // GIR_Coverage, 5380,
     /* 187082 */     GIR_Done,
     /* 187083 */   // Label 4141: @187083
     /* 187083 */   GIM_Reject,
     /* 187084 */ // Label 4134: @187084
     /* 187084 */ GIM_Reject,
     /* 187085 */ // Label 4118: @187085
     /* 187085 */ GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(187401),
     /* 187090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 187093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 187096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187100 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(187158), // Rule ID 23963 //
     /* 187105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187116 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187119 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187123 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187133 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187140 */     // (smax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187145 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187147 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187156 */     GIR_RootConstrainSelectedInstOperands,
     /* 187157 */     // GIR_Coverage, 23963,
     /* 187157 */     GIR_EraseRootFromParent_Done,
     /* 187158 */   // Label 4143: @187158
     /* 187158 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(187216), // Rule ID 5401 //
     /* 187163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187178 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187198 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rm),
     /* 187201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187214 */     GIR_RootConstrainSelectedInstOperands,
     /* 187215 */     // GIR_Coverage, 5401,
     /* 187215 */     GIR_EraseRootFromParent_Done,
     /* 187216 */   // Label 4144: @187216
     /* 187216 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(187239), // Rule ID 5398 //
     /* 187221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187232 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 187232 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZ256rr),
     /* 187237 */     GIR_RootConstrainSelectedInstOperands,
     /* 187238 */     // GIR_Coverage, 5398,
     /* 187238 */     GIR_Done,
     /* 187239 */   // Label 4145: @187239
     /* 187239 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(187400), // Rule ID 20008 //
     /* 187244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 187247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187255 */     // (smax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 187255 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 187258 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187262 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 187269 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 187272 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187276 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187281 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 187284 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 187288 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 187291 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187296 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187301 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187306 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 187309 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187313 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 187320 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 187323 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187327 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187332 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 187335 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 187339 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 187342 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 187347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 187360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 187364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187369 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 187372 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 187375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 187377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 187380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187382 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 187389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 187394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 187399 */     // GIR_Coverage, 20008,
     /* 187399 */     GIR_EraseRootFromParent_Done,
     /* 187400 */   // Label 4146: @187400
     /* 187400 */   GIM_Reject,
     /* 187401 */ // Label 4142: @187401
     /* 187401 */ GIM_Reject,
     /* 187402 */ // Label 4119: @187402
     /* 187402 */ GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(187743),
     /* 187407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 187410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187413 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(187475), // Rule ID 23471 //
     /* 187418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187433 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187450 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187457 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187462 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187464 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187473 */     GIR_RootConstrainSelectedInstOperands,
     /* 187474 */     // GIR_Coverage, 23471,
     /* 187474 */     GIR_EraseRootFromParent_Done,
     /* 187475 */   // Label 4148: @187475
     /* 187475 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(187537), // Rule ID 23936 //
     /* 187480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187495 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187502 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187519 */     // (smax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187524 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187535 */     GIR_RootConstrainSelectedInstOperands,
     /* 187536 */     // GIR_Coverage, 23936,
     /* 187536 */     GIR_EraseRootFromParent_Done,
     /* 187537 */   // Label 4149: @187537
     /* 187537 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(187599), // Rule ID 2655 //
     /* 187542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187561 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187564 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187568 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187574 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187581 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrm),
     /* 187584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187588 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187597 */     GIR_RootConstrainSelectedInstOperands,
     /* 187598 */     // GIR_Coverage, 2655,
     /* 187598 */     GIR_EraseRootFromParent_Done,
     /* 187599 */   // Label 4150: @187599
     /* 187599 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(187661), // Rule ID 5359 //
     /* 187604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187623 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187630 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187643 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rm),
     /* 187646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187659 */     GIR_RootConstrainSelectedInstOperands,
     /* 187660 */     // GIR_Coverage, 5359,
     /* 187660 */     GIR_EraseRootFromParent_Done,
     /* 187661 */   // Label 4151: @187661
     /* 187661 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(187688), // Rule ID 2654 //
     /* 187666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 187669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187681 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWrr),
     /* 187686 */     GIR_RootConstrainSelectedInstOperands,
     /* 187687 */     // GIR_Coverage, 2654,
     /* 187687 */     GIR_Done,
     /* 187688 */   // Label 4152: @187688
     /* 187688 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(187715), // Rule ID 2656 //
     /* 187693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 187696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 187708 */     // (smax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 187708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSWrr),
     /* 187713 */     GIR_RootConstrainSelectedInstOperands,
     /* 187714 */     // GIR_Coverage, 2656,
     /* 187714 */     GIR_Done,
     /* 187715 */   // Label 4153: @187715
     /* 187715 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(187742), // Rule ID 5356 //
     /* 187720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 187723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 187735 */     // (smax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 187735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ128rr),
     /* 187740 */     GIR_RootConstrainSelectedInstOperands,
     /* 187741 */     // GIR_Coverage, 5356,
     /* 187741 */     GIR_Done,
     /* 187742 */   // Label 4154: @187742
     /* 187742 */   GIM_Reject,
     /* 187743 */ // Label 4147: @187743
     /* 187743 */ GIM_Reject,
     /* 187744 */ // Label 4120: @187744
     /* 187744 */ GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(188058),
     /* 187749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 187752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 187755 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(187817), // Rule ID 23512 //
     /* 187760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187775 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187782 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187799 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187804 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187815 */     GIR_RootConstrainSelectedInstOperands,
     /* 187816 */     // GIR_Coverage, 23512,
     /* 187816 */     GIR_EraseRootFromParent_Done,
     /* 187817 */   // Label 4156: @187817
     /* 187817 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(187879), // Rule ID 23945 //
     /* 187822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 187833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187861 */     // (smax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187866 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 187868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187877 */     GIR_RootConstrainSelectedInstOperands,
     /* 187878 */     // GIR_Coverage, 23945,
     /* 187878 */     GIR_EraseRootFromParent_Done,
     /* 187879 */   // Label 4157: @187879
     /* 187879 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(187941), // Rule ID 3208 //
     /* 187884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 187887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 187895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187923 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrm),
     /* 187926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187928 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 187939 */     GIR_RootConstrainSelectedInstOperands,
     /* 187940 */     // GIR_Coverage, 3208,
     /* 187940 */     GIR_EraseRootFromParent_Done,
     /* 187941 */   // Label 4158: @187941
     /* 187941 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(188003), // Rule ID 5374 //
     /* 187946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 187949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 187957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 187961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 187965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 187968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 187972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 187976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 187978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 187985 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 187985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rm),
     /* 187988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 187990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 187992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 187996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188001 */     GIR_RootConstrainSelectedInstOperands,
     /* 188002 */     // GIR_Coverage, 5374,
     /* 188002 */     GIR_EraseRootFromParent_Done,
     /* 188003 */   // Label 4159: @188003
     /* 188003 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(188030), // Rule ID 3207 //
     /* 188008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 188011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188023 */     // (smax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 188023 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDYrr),
     /* 188028 */     GIR_RootConstrainSelectedInstOperands,
     /* 188029 */     // GIR_Coverage, 3207,
     /* 188029 */     GIR_Done,
     /* 188030 */   // Label 4160: @188030
     /* 188030 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(188057), // Rule ID 5371 //
     /* 188035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 188038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188050 */     // (smax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 188050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZ256rr),
     /* 188055 */     GIR_RootConstrainSelectedInstOperands,
     /* 188056 */     // GIR_Coverage, 5371,
     /* 188056 */     GIR_Done,
     /* 188057 */   // Label 4161: @188057
     /* 188057 */   GIM_Reject,
     /* 188058 */ // Label 4155: @188058
     /* 188058 */ GIM_Reject,
     /* 188059 */ // Label 4121: @188059
     /* 188059 */ GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(188214),
     /* 188064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 188067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 188070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188074 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(188132), // Rule ID 23957 //
     /* 188079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188090 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188097 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188114 */     // (smax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188119 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188130 */     GIR_RootConstrainSelectedInstOperands,
     /* 188131 */     // GIR_Coverage, 23957,
     /* 188131 */     GIR_EraseRootFromParent_Done,
     /* 188132 */   // Label 4163: @188132
     /* 188132 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(188190), // Rule ID 5392 //
     /* 188137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188152 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188155 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188159 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188165 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188172 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrm),
     /* 188175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188177 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188188 */     GIR_RootConstrainSelectedInstOperands,
     /* 188189 */     // GIR_Coverage, 5392,
     /* 188189 */     GIR_EraseRootFromParent_Done,
     /* 188190 */   // Label 4164: @188190
     /* 188190 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(188213), // Rule ID 5389 //
     /* 188195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188206 */     // (smax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 188206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSQZrr),
     /* 188211 */     GIR_RootConstrainSelectedInstOperands,
     /* 188212 */     // GIR_Coverage, 5389,
     /* 188212 */     GIR_Done,
     /* 188213 */   // Label 4165: @188213
     /* 188213 */   GIM_Reject,
     /* 188214 */ // Label 4162: @188214
     /* 188214 */ GIM_Reject,
     /* 188215 */ // Label 4122: @188215
     /* 188215 */ GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(188556),
     /* 188220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 188223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 188226 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(188288), // Rule ID 23508 //
     /* 188231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188246 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188249 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188253 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188263 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188270 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188277 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188286 */     GIR_RootConstrainSelectedInstOperands,
     /* 188287 */     // GIR_Coverage, 23508,
     /* 188287 */     GIR_EraseRootFromParent_Done,
     /* 188288 */   // Label 4167: @188288
     /* 188288 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(188350), // Rule ID 23927 //
     /* 188293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188325 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188332 */     // (smax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188337 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188339 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188348 */     GIR_RootConstrainSelectedInstOperands,
     /* 188349 */     // GIR_Coverage, 23927,
     /* 188349 */     GIR_EraseRootFromParent_Done,
     /* 188350 */   // Label 4168: @188350
     /* 188350 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(188412), // Rule ID 3200 //
     /* 188355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188387 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188394 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrm),
     /* 188397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188401 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188410 */     GIR_RootConstrainSelectedInstOperands,
     /* 188411 */     // GIR_Coverage, 3200,
     /* 188411 */     GIR_EraseRootFromParent_Done,
     /* 188412 */   // Label 4169: @188412
     /* 188412 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(188474), // Rule ID 5341 //
     /* 188417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188456 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rm),
     /* 188459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188472 */     GIR_RootConstrainSelectedInstOperands,
     /* 188473 */     // GIR_Coverage, 5341,
     /* 188473 */     GIR_EraseRootFromParent_Done,
     /* 188474 */   // Label 4170: @188474
     /* 188474 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(188501), // Rule ID 3199 //
     /* 188479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 188482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188494 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBrr),
     /* 188499 */     GIR_RootConstrainSelectedInstOperands,
     /* 188500 */     // GIR_Coverage, 3199,
     /* 188500 */     GIR_Done,
     /* 188501 */   // Label 4171: @188501
     /* 188501 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(188528), // Rule ID 3229 //
     /* 188506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 188509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 188521 */     // (smax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 188521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXSBrr),
     /* 188526 */     GIR_RootConstrainSelectedInstOperands,
     /* 188527 */     // GIR_Coverage, 3229,
     /* 188527 */     GIR_Done,
     /* 188528 */   // Label 4172: @188528
     /* 188528 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(188555), // Rule ID 5338 //
     /* 188533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 188548 */     // (smax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 188548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ128rr),
     /* 188553 */     GIR_RootConstrainSelectedInstOperands,
     /* 188554 */     // GIR_Coverage, 5338,
     /* 188554 */     GIR_Done,
     /* 188555 */   // Label 4173: @188555
     /* 188555 */   GIM_Reject,
     /* 188556 */ // Label 4166: @188556
     /* 188556 */ GIM_Reject,
     /* 188557 */ // Label 4123: @188557
     /* 188557 */ GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(188871),
     /* 188562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 188565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 188568 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(188630), // Rule ID 23473 //
     /* 188573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188612 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188617 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188628 */     GIR_RootConstrainSelectedInstOperands,
     /* 188629 */     // GIR_Coverage, 23473,
     /* 188629 */     GIR_EraseRootFromParent_Done,
     /* 188630 */   // Label 4175: @188630
     /* 188630 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(188692), // Rule ID 23933 //
     /* 188635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188674 */     // (smax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188681 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188690 */     GIR_RootConstrainSelectedInstOperands,
     /* 188691 */     // GIR_Coverage, 23933,
     /* 188691 */     GIR_EraseRootFromParent_Done,
     /* 188692 */   // Label 4176: @188692
     /* 188692 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(188754), // Rule ID 2659 //
     /* 188697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188736 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrm),
     /* 188739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188741 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188752 */     GIR_RootConstrainSelectedInstOperands,
     /* 188753 */     // GIR_Coverage, 2659,
     /* 188753 */     GIR_EraseRootFromParent_Done,
     /* 188754 */   // Label 4177: @188754
     /* 188754 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(188816), // Rule ID 5353 //
     /* 188759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188778 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188781 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188785 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188791 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188798 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rm),
     /* 188801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188805 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188814 */     GIR_RootConstrainSelectedInstOperands,
     /* 188815 */     // GIR_Coverage, 5353,
     /* 188815 */     GIR_EraseRootFromParent_Done,
     /* 188816 */   // Label 4178: @188816
     /* 188816 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(188843), // Rule ID 2658 //
     /* 188821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 188824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 188836 */     // (smax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 188836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWYrr),
     /* 188841 */     GIR_RootConstrainSelectedInstOperands,
     /* 188842 */     // GIR_Coverage, 2658,
     /* 188842 */     GIR_Done,
     /* 188843 */   // Label 4179: @188843
     /* 188843 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(188870), // Rule ID 5350 //
     /* 188848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 188851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 188863 */     // (smax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 188863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZ256rr),
     /* 188868 */     GIR_RootConstrainSelectedInstOperands,
     /* 188869 */     // GIR_Coverage, 5350,
     /* 188869 */     GIR_Done,
     /* 188870 */   // Label 4180: @188870
     /* 188870 */   GIM_Reject,
     /* 188871 */ // Label 4174: @188871
     /* 188871 */ GIM_Reject,
     /* 188872 */ // Label 4124: @188872
     /* 188872 */ GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(189027),
     /* 188877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 188880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 188883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188887 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(188945), // Rule ID 23939 //
     /* 188892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 188899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188903 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188906 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188910 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188920 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188927 */     // (smax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188932 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 188934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 188943 */     GIR_RootConstrainSelectedInstOperands,
     /* 188944 */     // GIR_Coverage, 23939,
     /* 188944 */     GIR_EraseRootFromParent_Done,
     /* 188945 */   // Label 4182: @188945
     /* 188945 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(189003), // Rule ID 5365 //
     /* 188950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 188953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 188957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 188961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 188965 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 188968 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 188972 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 188976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 188978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 188985 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 188985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrm),
     /* 188988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 188990 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 188992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 188996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189001 */     GIR_RootConstrainSelectedInstOperands,
     /* 189002 */     // GIR_Coverage, 5365,
     /* 189002 */     GIR_EraseRootFromParent_Done,
     /* 189003 */   // Label 4183: @189003
     /* 189003 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(189026), // Rule ID 5362 //
     /* 189008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 189011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189019 */     // (smax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 189019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSDZrr),
     /* 189024 */     GIR_RootConstrainSelectedInstOperands,
     /* 189025 */     // GIR_Coverage, 5362,
     /* 189025 */     GIR_Done,
     /* 189026 */   // Label 4184: @189026
     /* 189026 */   GIM_Reject,
     /* 189027 */ // Label 4181: @189027
     /* 189027 */ GIM_Reject,
     /* 189028 */ // Label 4125: @189028
     /* 189028 */ GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(189342),
     /* 189033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 189036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 189039 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(189101), // Rule ID 23517 //
     /* 189044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189059 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189062 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189066 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189083 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189088 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189090 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189094 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189099 */     GIR_RootConstrainSelectedInstOperands,
     /* 189100 */     // GIR_Coverage, 23517,
     /* 189100 */     GIR_EraseRootFromParent_Done,
     /* 189101 */   // Label 4186: @189101
     /* 189101 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(189163), // Rule ID 23924 //
     /* 189106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189138 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189145 */     // (smax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189150 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189152 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189161 */     GIR_RootConstrainSelectedInstOperands,
     /* 189162 */     // GIR_Coverage, 23924,
     /* 189162 */     GIR_EraseRootFromParent_Done,
     /* 189163 */   // Label 4187: @189163
     /* 189163 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(189225), // Rule ID 3218 //
     /* 189168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189187 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189190 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189194 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189200 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189207 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrm),
     /* 189210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189214 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189223 */     GIR_RootConstrainSelectedInstOperands,
     /* 189224 */     // GIR_Coverage, 3218,
     /* 189224 */     GIR_EraseRootFromParent_Done,
     /* 189225 */   // Label 4188: @189225
     /* 189225 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(189287), // Rule ID 5335 //
     /* 189230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189249 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189256 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189269 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rm),
     /* 189272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189274 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189285 */     GIR_RootConstrainSelectedInstOperands,
     /* 189286 */     // GIR_Coverage, 5335,
     /* 189286 */     GIR_EraseRootFromParent_Done,
     /* 189287 */   // Label 4189: @189287
     /* 189287 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(189314), // Rule ID 3217 //
     /* 189292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 189295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 189307 */     // (smax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 189307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBYrr),
     /* 189312 */     GIR_RootConstrainSelectedInstOperands,
     /* 189313 */     // GIR_Coverage, 3217,
     /* 189313 */     GIR_Done,
     /* 189314 */   // Label 4190: @189314
     /* 189314 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(189341), // Rule ID 5332 //
     /* 189319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 189322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 189334 */     // (smax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 189334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZ256rr),
     /* 189339 */     GIR_RootConstrainSelectedInstOperands,
     /* 189340 */     // GIR_Coverage, 5332,
     /* 189340 */     GIR_Done,
     /* 189341 */   // Label 4191: @189341
     /* 189341 */   GIM_Reject,
     /* 189342 */ // Label 4185: @189342
     /* 189342 */ GIM_Reject,
     /* 189343 */ // Label 4126: @189343
     /* 189343 */ GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(189498),
     /* 189348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 189351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 189354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189358 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(189416), // Rule ID 23930 //
     /* 189363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189374 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189381 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189391 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189398 */     // (smax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189403 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189405 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189414 */     GIR_RootConstrainSelectedInstOperands,
     /* 189415 */     // GIR_Coverage, 23930,
     /* 189415 */     GIR_EraseRootFromParent_Done,
     /* 189416 */   // Label 4193: @189416
     /* 189416 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(189474), // Rule ID 5347 //
     /* 189421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189436 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189439 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189443 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189449 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189456 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrm),
     /* 189459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189463 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189472 */     GIR_RootConstrainSelectedInstOperands,
     /* 189473 */     // GIR_Coverage, 5347,
     /* 189473 */     GIR_EraseRootFromParent_Done,
     /* 189474 */   // Label 4194: @189474
     /* 189474 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(189497), // Rule ID 5344 //
     /* 189479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189490 */     // (smax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 189490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSWZrr),
     /* 189495 */     GIR_RootConstrainSelectedInstOperands,
     /* 189496 */     // GIR_Coverage, 5344,
     /* 189496 */     GIR_Done,
     /* 189497 */   // Label 4195: @189497
     /* 189497 */   GIM_Reject,
     /* 189498 */ // Label 4192: @189498
     /* 189498 */ GIM_Reject,
     /* 189499 */ // Label 4127: @189499
     /* 189499 */ GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(189654),
     /* 189504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 189507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 189510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189514 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(189572), // Rule ID 23921 //
     /* 189519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189530 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189533 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189537 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189547 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189554 */     // (smax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189559 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189561 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189570 */     GIR_RootConstrainSelectedInstOperands,
     /* 189571 */     // GIR_Coverage, 23921,
     /* 189571 */     GIR_EraseRootFromParent_Done,
     /* 189572 */   // Label 4197: @189572
     /* 189572 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(189630), // Rule ID 5329 //
     /* 189577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189592 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189605 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189612 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXSBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrm),
     /* 189615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189617 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189628 */     GIR_RootConstrainSelectedInstOperands,
     /* 189629 */     // GIR_Coverage, 5329,
     /* 189629 */     GIR_EraseRootFromParent_Done,
     /* 189630 */   // Label 4198: @189630
     /* 189630 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(189653), // Rule ID 5326 //
     /* 189635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 189638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 189646 */     // (smax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 189646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXSBZrr),
     /* 189651 */     GIR_RootConstrainSelectedInstOperands,
     /* 189652 */     // GIR_Coverage, 5326,
     /* 189652 */     GIR_Done,
     /* 189653 */   // Label 4199: @189653
     /* 189653 */   GIM_Reject,
     /* 189654 */ // Label 4196: @189654
     /* 189654 */ GIM_Reject,
     /* 189655 */ // Label 4128: @189655
     /* 189655 */ GIM_Reject,
     /* 189656 */ // Label 56: @189656
     /* 189656 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4212*/ GIMT_Encode4(192976),
     /* 189667 */ /*GILLT_v2s64*//*Label 4200*/ GIMT_Encode4(189735), GIMT_Encode4(0),
     /* 189675 */ /*GILLT_v4s32*//*Label 4201*/ GIMT_Encode4(190064),
     /* 189679 */ /*GILLT_v4s64*//*Label 4202*/ GIMT_Encode4(190406), GIMT_Encode4(0),
     /* 189687 */ /*GILLT_v8s16*//*Label 4203*/ GIMT_Encode4(190723),
     /* 189691 */ /*GILLT_v8s32*//*Label 4204*/ GIMT_Encode4(191065),
     /* 189695 */ /*GILLT_v8s64*//*Label 4205*/ GIMT_Encode4(191380), GIMT_Encode4(0),
     /* 189703 */ /*GILLT_v16s8*//*Label 4206*/ GIMT_Encode4(191536),
     /* 189707 */ /*GILLT_v16s16*//*Label 4207*/ GIMT_Encode4(191878),
     /* 189711 */ /*GILLT_v16s32*//*Label 4208*/ GIMT_Encode4(192193), GIMT_Encode4(0),
     /* 189719 */ /*GILLT_v32s8*//*Label 4209*/ GIMT_Encode4(192349),
     /* 189723 */ /*GILLT_v32s16*//*Label 4210*/ GIMT_Encode4(192664), GIMT_Encode4(0),
     /* 189731 */ /*GILLT_v64s8*//*Label 4211*/ GIMT_Encode4(192820),
     /* 189735 */ // Label 4200: @189735
     /* 189735 */ GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(190063),
     /* 189740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 189743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189746 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(189808), // Rule ID 24131 //
     /* 189751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 189762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189766 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189769 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189773 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189790 */     // (umin:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189795 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 189797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189806 */     GIR_RootConstrainSelectedInstOperands,
     /* 189807 */     // GIR_Coverage, 24131,
     /* 189807 */     GIR_EraseRootFromParent_Done,
     /* 189808 */   // Label 4214: @189808
     /* 189808 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(189870), // Rule ID 5680 //
     /* 189813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 189828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 189832 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 189835 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 189839 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 189843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 189845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 189852 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 189852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rm),
     /* 189855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 189857 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 189859 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 189863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 189868 */     GIR_RootConstrainSelectedInstOperands,
     /* 189869 */     // GIR_Coverage, 5680,
     /* 189869 */     GIR_EraseRootFromParent_Done,
     /* 189870 */   // Label 4215: @189870
     /* 189870 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(189897), // Rule ID 5677 //
     /* 189875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 189878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189890 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMINUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 189890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ128rr),
     /* 189895 */     GIR_RootConstrainSelectedInstOperands,
     /* 189896 */     // GIR_Coverage, 5677,
     /* 189896 */     GIR_Done,
     /* 189897 */   // Label 4216: @189897
     /* 189897 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(190062), // Rule ID 20006 //
     /* 189902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 189905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 189909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 189917 */     // (umin:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 189917 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 189920 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189924 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 189931 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 189934 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189938 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189943 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 189946 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 189950 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 189953 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 189958 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 189963 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 189968 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 189971 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189975 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 189982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 189985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189994 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 189997 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190001 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 190004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190014 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 190019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190031 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190034 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190037 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190044 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 190051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 190056 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190061 */     // GIR_Coverage, 20006,
     /* 190061 */     GIR_EraseRootFromParent_Done,
     /* 190062 */   // Label 4217: @190062
     /* 190062 */   GIM_Reject,
     /* 190063 */ // Label 4213: @190063
     /* 190063 */ GIM_Reject,
     /* 190064 */ // Label 4201: @190064
     /* 190064 */ GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(190405),
     /* 190069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 190072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190075 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(190137), // Rule ID 23502 //
     /* 190080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190095 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190102 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190119 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190124 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190135 */     GIR_RootConstrainSelectedInstOperands,
     /* 190136 */     // GIR_Coverage, 23502,
     /* 190136 */     GIR_EraseRootFromParent_Done,
     /* 190137 */   // Label 4219: @190137
     /* 190137 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(190199), // Rule ID 24113 //
     /* 190142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190160 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190164 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190181 */     // (umin:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190186 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190192 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190197 */     GIR_RootConstrainSelectedInstOperands,
     /* 190198 */     // GIR_Coverage, 24113,
     /* 190198 */     GIR_EraseRootFromParent_Done,
     /* 190199 */   // Label 4220: @190199
     /* 190199 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(190261), // Rule ID 3188 //
     /* 190204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190236 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190243 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDrm),
     /* 190246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190248 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190250 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190259 */     GIR_RootConstrainSelectedInstOperands,
     /* 190260 */     // GIR_Coverage, 3188,
     /* 190260 */     GIR_EraseRootFromParent_Done,
     /* 190261 */   // Label 4221: @190261
     /* 190261 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(190323), // Rule ID 5653 //
     /* 190266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190285 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190288 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190305 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rm),
     /* 190308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190316 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190321 */     GIR_RootConstrainSelectedInstOperands,
     /* 190322 */     // GIR_Coverage, 5653,
     /* 190322 */     GIR_EraseRootFromParent_Done,
     /* 190323 */   // Label 4222: @190323
     /* 190323 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(190350), // Rule ID 3187 //
     /* 190328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 190331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190343 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDrr),
     /* 190348 */     GIR_RootConstrainSelectedInstOperands,
     /* 190349 */     // GIR_Coverage, 3187,
     /* 190349 */     GIR_Done,
     /* 190350 */   // Label 4223: @190350
     /* 190350 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(190377), // Rule ID 3225 //
     /* 190355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 190358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190370 */     // (umin:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMINUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 190370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUDrr),
     /* 190375 */     GIR_RootConstrainSelectedInstOperands,
     /* 190376 */     // GIR_Coverage, 3225,
     /* 190376 */     GIR_Done,
     /* 190377 */   // Label 4224: @190377
     /* 190377 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(190404), // Rule ID 5650 //
     /* 190382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190397 */     // (umin:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMINUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 190397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ128rr),
     /* 190402 */     GIR_RootConstrainSelectedInstOperands,
     /* 190403 */     // GIR_Coverage, 5650,
     /* 190403 */     GIR_Done,
     /* 190404 */   // Label 4225: @190404
     /* 190404 */   GIM_Reject,
     /* 190405 */ // Label 4218: @190405
     /* 190405 */ GIM_Reject,
     /* 190406 */ // Label 4202: @190406
     /* 190406 */ GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(190722),
     /* 190411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 190414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 190417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190421 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(190479), // Rule ID 24125 //
     /* 190426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190437 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190440 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190444 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190454 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190461 */     // (umin:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190466 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190468 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190477 */     GIR_RootConstrainSelectedInstOperands,
     /* 190478 */     // GIR_Coverage, 24125,
     /* 190478 */     GIR_EraseRootFromParent_Done,
     /* 190479 */   // Label 4227: @190479
     /* 190479 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(190537), // Rule ID 5671 //
     /* 190484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190499 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190502 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190506 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190519 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rm),
     /* 190522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190524 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190526 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190535 */     GIR_RootConstrainSelectedInstOperands,
     /* 190536 */     // GIR_Coverage, 5671,
     /* 190536 */     GIR_EraseRootFromParent_Done,
     /* 190537 */   // Label 4228: @190537
     /* 190537 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(190560), // Rule ID 5668 //
     /* 190542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 190545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190553 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMINUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 190553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZ256rr),
     /* 190558 */     GIR_RootConstrainSelectedInstOperands,
     /* 190559 */     // GIR_Coverage, 5668,
     /* 190559 */     GIR_Done,
     /* 190560 */   // Label 4229: @190560
     /* 190560 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(190721), // Rule ID 20004 //
     /* 190565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 190568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 190576 */     // (umin:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMINUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 190576 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 190579 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190583 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 190590 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 190593 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190597 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190602 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 190605 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 190609 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 190612 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190617 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190622 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 190630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 190641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 190644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 190656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 190660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 190663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 190668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 190681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 190685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 190693 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 190696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 190698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 190701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190703 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 190710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 190715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 190720 */     // GIR_Coverage, 20004,
     /* 190720 */     GIR_EraseRootFromParent_Done,
     /* 190721 */   // Label 4230: @190721
     /* 190721 */   GIM_Reject,
     /* 190722 */ // Label 4226: @190722
     /* 190722 */ GIM_Reject,
     /* 190723 */ // Label 4203: @190723
     /* 190723 */ GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(191064),
     /* 190728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 190731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190734 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(190796), // Rule ID 23507 //
     /* 190739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190754 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190761 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190778 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190783 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190794 */     GIR_RootConstrainSelectedInstOperands,
     /* 190795 */     // GIR_Coverage, 23507,
     /* 190795 */     GIR_EraseRootFromParent_Done,
     /* 190796 */   // Label 4232: @190796
     /* 190796 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(190858), // Rule ID 24098 //
     /* 190801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 190812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190816 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190819 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190823 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190840 */     // (umin:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 190847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190856 */     GIR_RootConstrainSelectedInstOperands,
     /* 190857 */     // GIR_Coverage, 24098,
     /* 190857 */     GIR_EraseRootFromParent_Done,
     /* 190858 */   // Label 4233: @190858
     /* 190858 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(190920), // Rule ID 3198 //
     /* 190863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190882 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190889 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190895 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190902 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWrm),
     /* 190905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190907 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190909 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190918 */     GIR_RootConstrainSelectedInstOperands,
     /* 190919 */     // GIR_Coverage, 3198,
     /* 190919 */     GIR_EraseRootFromParent_Done,
     /* 190920 */   // Label 4234: @190920
     /* 190920 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(190982), // Rule ID 5629 //
     /* 190925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 190928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 190936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 190940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 190944 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 190947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 190951 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 190955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 190957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 190964 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 190964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rm),
     /* 190967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 190969 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 190971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 190975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 190980 */     GIR_RootConstrainSelectedInstOperands,
     /* 190981 */     // GIR_Coverage, 5629,
     /* 190981 */     GIR_EraseRootFromParent_Done,
     /* 190982 */   // Label 4235: @190982
     /* 190982 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(191009), // Rule ID 3197 //
     /* 190987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 190990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 190998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191002 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191002 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWrr),
     /* 191007 */     GIR_RootConstrainSelectedInstOperands,
     /* 191008 */     // GIR_Coverage, 3197,
     /* 191008 */     GIR_Done,
     /* 191009 */   // Label 4236: @191009
     /* 191009 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(191036), // Rule ID 3227 //
     /* 191014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 191017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191029 */     // (umin:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMINUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 191029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUWrr),
     /* 191034 */     GIR_RootConstrainSelectedInstOperands,
     /* 191035 */     // GIR_Coverage, 3227,
     /* 191035 */     GIR_Done,
     /* 191036 */   // Label 4237: @191036
     /* 191036 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(191063), // Rule ID 5626 //
     /* 191041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191056 */     // (umin:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMINUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 191056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ128rr),
     /* 191061 */     GIR_RootConstrainSelectedInstOperands,
     /* 191062 */     // GIR_Coverage, 5626,
     /* 191062 */     GIR_Done,
     /* 191063 */   // Label 4238: @191063
     /* 191063 */   GIM_Reject,
     /* 191064 */ // Label 4231: @191064
     /* 191064 */ GIM_Reject,
     /* 191065 */ // Label 4204: @191065
     /* 191065 */ GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(191379),
     /* 191070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 191073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 191076 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(191138), // Rule ID 23511 //
     /* 191081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191113 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191120 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191136 */     GIR_RootConstrainSelectedInstOperands,
     /* 191137 */     // GIR_Coverage, 23511,
     /* 191137 */     GIR_EraseRootFromParent_Done,
     /* 191138 */   // Label 4240: @191138
     /* 191138 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(191200), // Rule ID 24107 //
     /* 191143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191158 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191161 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191165 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191182 */     // (umin:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191187 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191189 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191198 */     GIR_RootConstrainSelectedInstOperands,
     /* 191199 */     // GIR_Coverage, 24107,
     /* 191199 */     GIR_EraseRootFromParent_Done,
     /* 191200 */   // Label 4241: @191200
     /* 191200 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(191262), // Rule ID 3206 //
     /* 191205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191244 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrm),
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191249 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191251 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191260 */     GIR_RootConstrainSelectedInstOperands,
     /* 191261 */     // GIR_Coverage, 3206,
     /* 191261 */     GIR_EraseRootFromParent_Done,
     /* 191262 */   // Label 4242: @191262
     /* 191262 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(191324), // Rule ID 5644 //
     /* 191267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191306 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rm),
     /* 191309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191322 */     GIR_RootConstrainSelectedInstOperands,
     /* 191323 */     // GIR_Coverage, 5644,
     /* 191323 */     GIR_EraseRootFromParent_Done,
     /* 191324 */   // Label 4243: @191324
     /* 191324 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(191351), // Rule ID 3205 //
     /* 191329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 191332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191344 */     // (umin:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMINUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 191344 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDYrr),
     /* 191349 */     GIR_RootConstrainSelectedInstOperands,
     /* 191350 */     // GIR_Coverage, 3205,
     /* 191350 */     GIR_Done,
     /* 191351 */   // Label 4244: @191351
     /* 191351 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(191378), // Rule ID 5641 //
     /* 191356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 191359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191371 */     // (umin:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMINUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 191371 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZ256rr),
     /* 191376 */     GIR_RootConstrainSelectedInstOperands,
     /* 191377 */     // GIR_Coverage, 5641,
     /* 191377 */     GIR_Done,
     /* 191378 */   // Label 4245: @191378
     /* 191378 */   GIM_Reject,
     /* 191379 */ // Label 4239: @191379
     /* 191379 */ GIM_Reject,
     /* 191380 */ // Label 4205: @191380
     /* 191380 */ GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(191535),
     /* 191385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 191388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 191391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191395 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(191453), // Rule ID 24119 //
     /* 191400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191428 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191435 */     // (umin:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191440 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191451 */     GIR_RootConstrainSelectedInstOperands,
     /* 191452 */     // GIR_Coverage, 24119,
     /* 191452 */     GIR_EraseRootFromParent_Done,
     /* 191453 */   // Label 4247: @191453
     /* 191453 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(191511), // Rule ID 5662 //
     /* 191458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191473 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191476 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191480 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191486 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191493 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrm),
     /* 191496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191500 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191509 */     GIR_RootConstrainSelectedInstOperands,
     /* 191510 */     // GIR_Coverage, 5662,
     /* 191510 */     GIR_EraseRootFromParent_Done,
     /* 191511 */   // Label 4248: @191511
     /* 191511 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(191534), // Rule ID 5659 //
     /* 191516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 191519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 191527 */     // (umin:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMINUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 191527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUQZrr),
     /* 191532 */     GIR_RootConstrainSelectedInstOperands,
     /* 191533 */     // GIR_Coverage, 5659,
     /* 191533 */     GIR_Done,
     /* 191534 */   // Label 4249: @191534
     /* 191534 */   GIM_Reject,
     /* 191535 */ // Label 4246: @191535
     /* 191535 */ GIM_Reject,
     /* 191536 */ // Label 4206: @191536
     /* 191536 */ GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(191877),
     /* 191541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 191544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191547 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(191609), // Rule ID 23462 //
     /* 191552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191567 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191574 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191584 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191591 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191596 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191598 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191602 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191607 */     GIR_RootConstrainSelectedInstOperands,
     /* 191608 */     // GIR_Coverage, 23462,
     /* 191608 */     GIR_EraseRootFromParent_Done,
     /* 191609 */   // Label 4251: @191609
     /* 191609 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(191671), // Rule ID 24089 //
     /* 191614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191629 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191632 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191636 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191653 */     // (umin:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191658 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191660 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191669 */     GIR_RootConstrainSelectedInstOperands,
     /* 191670 */     // GIR_Coverage, 24089,
     /* 191670 */     GIR_EraseRootFromParent_Done,
     /* 191671 */   // Label 4252: @191671
     /* 191671 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(191733), // Rule ID 2637 //
     /* 191676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191708 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191715 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBrm),
     /* 191718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191720 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191722 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191731 */     GIR_RootConstrainSelectedInstOperands,
     /* 191732 */     // GIR_Coverage, 2637,
     /* 191732 */     GIR_EraseRootFromParent_Done,
     /* 191733 */   // Label 4253: @191733
     /* 191733 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(191795), // Rule ID 5611 //
     /* 191738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 191753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191777 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rm),
     /* 191780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 191784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191793 */     GIR_RootConstrainSelectedInstOperands,
     /* 191794 */     // GIR_Coverage, 5611,
     /* 191794 */     GIR_EraseRootFromParent_Done,
     /* 191795 */   // Label 4254: @191795
     /* 191795 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(191822), // Rule ID 2636 //
     /* 191800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 191803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191815 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBrr),
     /* 191820 */     GIR_RootConstrainSelectedInstOperands,
     /* 191821 */     // GIR_Coverage, 2636,
     /* 191821 */     GIR_Done,
     /* 191822 */   // Label 4255: @191822
     /* 191822 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(191849), // Rule ID 2638 //
     /* 191827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 191830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 191842 */     // (umin:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMINUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 191842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMINUBrr),
     /* 191847 */     GIR_RootConstrainSelectedInstOperands,
     /* 191848 */     // GIR_Coverage, 2638,
     /* 191848 */     GIR_Done,
     /* 191849 */   // Label 4256: @191849
     /* 191849 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(191876), // Rule ID 5608 //
     /* 191854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 191869 */     // (umin:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMINUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 191869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ128rr),
     /* 191874 */     GIR_RootConstrainSelectedInstOperands,
     /* 191875 */     // GIR_Coverage, 5608,
     /* 191875 */     GIR_Done,
     /* 191876 */   // Label 4257: @191876
     /* 191876 */   GIM_Reject,
     /* 191877 */ // Label 4250: @191877
     /* 191877 */ GIM_Reject,
     /* 191878 */ // Label 4207: @191878
     /* 191878 */ GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(192192),
     /* 191883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 191886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 191889 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(191951), // Rule ID 23516 //
     /* 191894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 191897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191909 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191912 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191916 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 191924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191933 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 191936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 191938 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 191940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 191944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 191949 */     GIR_RootConstrainSelectedInstOperands,
     /* 191950 */     // GIR_Coverage, 23516,
     /* 191950 */     GIR_EraseRootFromParent_Done,
     /* 191951 */   // Label 4259: @191951
     /* 191951 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(192013), // Rule ID 24095 //
     /* 191956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 191959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 191967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 191971 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 191974 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 191978 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 191982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 191986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 191988 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 191995 */     // (umin:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 191995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 191998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192000 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192002 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192011 */     GIR_RootConstrainSelectedInstOperands,
     /* 192012 */     // GIR_Coverage, 24095,
     /* 192012 */     GIR_EraseRootFromParent_Done,
     /* 192013 */   // Label 4260: @192013
     /* 192013 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(192075), // Rule ID 3216 //
     /* 192018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192050 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192057 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrm),
     /* 192060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192062 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192064 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192073 */     GIR_RootConstrainSelectedInstOperands,
     /* 192074 */     // GIR_Coverage, 3216,
     /* 192074 */     GIR_EraseRootFromParent_Done,
     /* 192075 */   // Label 4261: @192075
     /* 192075 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(192137), // Rule ID 5623 //
     /* 192080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192099 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192102 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192106 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192119 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rm),
     /* 192122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192124 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192126 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192135 */     GIR_RootConstrainSelectedInstOperands,
     /* 192136 */     // GIR_Coverage, 5623,
     /* 192136 */     GIR_EraseRootFromParent_Done,
     /* 192137 */   // Label 4262: @192137
     /* 192137 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(192164), // Rule ID 3215 //
     /* 192142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192157 */     // (umin:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMINUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 192157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWYrr),
     /* 192162 */     GIR_RootConstrainSelectedInstOperands,
     /* 192163 */     // GIR_Coverage, 3215,
     /* 192163 */     GIR_Done,
     /* 192164 */   // Label 4263: @192164
     /* 192164 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(192191), // Rule ID 5620 //
     /* 192169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192184 */     // (umin:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMINUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 192184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZ256rr),
     /* 192189 */     GIR_RootConstrainSelectedInstOperands,
     /* 192190 */     // GIR_Coverage, 5620,
     /* 192190 */     GIR_Done,
     /* 192191 */   // Label 4264: @192191
     /* 192191 */   GIM_Reject,
     /* 192192 */ // Label 4258: @192192
     /* 192192 */ GIM_Reject,
     /* 192193 */ // Label 4208: @192193
     /* 192193 */ GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(192348),
     /* 192198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 192201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 192204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192208 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(192266), // Rule ID 24101 //
     /* 192213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192224 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192227 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192231 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192248 */     // (umin:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192253 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192255 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192259 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192264 */     GIR_RootConstrainSelectedInstOperands,
     /* 192265 */     // GIR_Coverage, 24101,
     /* 192265 */     GIR_EraseRootFromParent_Done,
     /* 192266 */   // Label 4266: @192266
     /* 192266 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(192324), // Rule ID 5635 //
     /* 192271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192286 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192289 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192293 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192299 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192306 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrm),
     /* 192309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192311 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192313 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192322 */     GIR_RootConstrainSelectedInstOperands,
     /* 192323 */     // GIR_Coverage, 5635,
     /* 192323 */     GIR_EraseRootFromParent_Done,
     /* 192324 */   // Label 4267: @192324
     /* 192324 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(192347), // Rule ID 5632 //
     /* 192329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 192332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192340 */     // (umin:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMINUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 192340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUDZrr),
     /* 192345 */     GIR_RootConstrainSelectedInstOperands,
     /* 192346 */     // GIR_Coverage, 5632,
     /* 192346 */     GIR_Done,
     /* 192347 */   // Label 4268: @192347
     /* 192347 */   GIM_Reject,
     /* 192348 */ // Label 4265: @192348
     /* 192348 */ GIM_Reject,
     /* 192349 */ // Label 4209: @192349
     /* 192349 */ GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(192663),
     /* 192354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 192357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 192360 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(192422), // Rule ID 23464 //
     /* 192365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192380 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192383 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192404 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192409 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192420 */     GIR_RootConstrainSelectedInstOperands,
     /* 192421 */     // GIR_Coverage, 23464,
     /* 192421 */     GIR_EraseRootFromParent_Done,
     /* 192422 */   // Label 4270: @192422
     /* 192422 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(192484), // Rule ID 24086 //
     /* 192427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192442 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192445 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192449 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192459 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192466 */     // (umin:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192471 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192482 */     GIR_RootConstrainSelectedInstOperands,
     /* 192483 */     // GIR_Coverage, 24086,
     /* 192483 */     GIR_EraseRootFromParent_Done,
     /* 192484 */   // Label 4271: @192484
     /* 192484 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(192546), // Rule ID 2641 //
     /* 192489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192508 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192515 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192521 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192528 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrm),
     /* 192531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192533 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192535 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192544 */     GIR_RootConstrainSelectedInstOperands,
     /* 192545 */     // GIR_Coverage, 2641,
     /* 192545 */     GIR_EraseRootFromParent_Done,
     /* 192546 */   // Label 4272: @192546
     /* 192546 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(192608), // Rule ID 5605 //
     /* 192551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192590 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rm),
     /* 192593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192606 */     GIR_RootConstrainSelectedInstOperands,
     /* 192607 */     // GIR_Coverage, 5605,
     /* 192607 */     GIR_EraseRootFromParent_Done,
     /* 192608 */   // Label 4273: @192608
     /* 192608 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(192635), // Rule ID 2640 //
     /* 192613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 192616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 192628 */     // (umin:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMINUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 192628 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBYrr),
     /* 192633 */     GIR_RootConstrainSelectedInstOperands,
     /* 192634 */     // GIR_Coverage, 2640,
     /* 192634 */     GIR_Done,
     /* 192635 */   // Label 4274: @192635
     /* 192635 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(192662), // Rule ID 5602 //
     /* 192640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 192643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 192655 */     // (umin:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMINUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 192655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZ256rr),
     /* 192660 */     GIR_RootConstrainSelectedInstOperands,
     /* 192661 */     // GIR_Coverage, 5602,
     /* 192661 */     GIR_Done,
     /* 192662 */   // Label 4275: @192662
     /* 192662 */   GIM_Reject,
     /* 192663 */ // Label 4269: @192663
     /* 192663 */ GIM_Reject,
     /* 192664 */ // Label 4210: @192664
     /* 192664 */ GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(192819),
     /* 192669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 192672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 192675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192679 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(192737), // Rule ID 24092 //
     /* 192684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192702 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192719 */     // (umin:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192724 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192726 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192735 */     GIR_RootConstrainSelectedInstOperands,
     /* 192736 */     // GIR_Coverage, 24092,
     /* 192736 */     GIR_EraseRootFromParent_Done,
     /* 192737 */   // Label 4277: @192737
     /* 192737 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(192795), // Rule ID 5617 //
     /* 192742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192757 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192760 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192764 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192770 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192777 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrm),
     /* 192780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192782 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192784 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192793 */     GIR_RootConstrainSelectedInstOperands,
     /* 192794 */     // GIR_Coverage, 5617,
     /* 192794 */     GIR_EraseRootFromParent_Done,
     /* 192795 */   // Label 4278: @192795
     /* 192795 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(192818), // Rule ID 5614 //
     /* 192800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192811 */     // (umin:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMINUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 192811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUWZrr),
     /* 192816 */     GIR_RootConstrainSelectedInstOperands,
     /* 192817 */     // GIR_Coverage, 5614,
     /* 192817 */     GIR_Done,
     /* 192818 */   // Label 4279: @192818
     /* 192818 */   GIM_Reject,
     /* 192819 */ // Label 4276: @192819
     /* 192819 */ GIM_Reject,
     /* 192820 */ // Label 4211: @192820
     /* 192820 */ GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(192975),
     /* 192825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 192828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 192831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192835 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(192893), // Rule ID 24083 //
     /* 192840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 192847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192851 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192858 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192875 */     // (umin:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 192882 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192891 */     GIR_RootConstrainSelectedInstOperands,
     /* 192892 */     // GIR_Coverage, 24083,
     /* 192892 */     GIR_EraseRootFromParent_Done,
     /* 192893 */   // Label 4281: @192893
     /* 192893 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(192951), // Rule ID 5599 //
     /* 192898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 192909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 192913 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 192916 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 192920 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 192924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 192926 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 192933 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMINUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 192933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrm),
     /* 192936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 192938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 192940 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 192944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 192949 */     GIR_RootConstrainSelectedInstOperands,
     /* 192950 */     // GIR_Coverage, 5599,
     /* 192950 */     GIR_EraseRootFromParent_Done,
     /* 192951 */   // Label 4282: @192951
     /* 192951 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(192974), // Rule ID 5596 //
     /* 192956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 192959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 192967 */     // (umin:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMINUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 192967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMINUBZrr),
     /* 192972 */     GIR_RootConstrainSelectedInstOperands,
     /* 192973 */     // GIR_Coverage, 5596,
     /* 192973 */     GIR_Done,
     /* 192974 */   // Label 4283: @192974
     /* 192974 */   GIM_Reject,
     /* 192975 */ // Label 4280: @192975
     /* 192975 */ GIM_Reject,
     /* 192976 */ // Label 4212: @192976
     /* 192976 */ GIM_Reject,
     /* 192977 */ // Label 57: @192977
     /* 192977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4296*/ GIMT_Encode4(196297),
     /* 192988 */ /*GILLT_v2s64*//*Label 4284*/ GIMT_Encode4(193056), GIMT_Encode4(0),
     /* 192996 */ /*GILLT_v4s32*//*Label 4285*/ GIMT_Encode4(193385),
     /* 193000 */ /*GILLT_v4s64*//*Label 4286*/ GIMT_Encode4(193727), GIMT_Encode4(0),
     /* 193008 */ /*GILLT_v8s16*//*Label 4287*/ GIMT_Encode4(194044),
     /* 193012 */ /*GILLT_v8s32*//*Label 4288*/ GIMT_Encode4(194386),
     /* 193016 */ /*GILLT_v8s64*//*Label 4289*/ GIMT_Encode4(194701), GIMT_Encode4(0),
     /* 193024 */ /*GILLT_v16s8*//*Label 4290*/ GIMT_Encode4(194857),
     /* 193028 */ /*GILLT_v16s16*//*Label 4291*/ GIMT_Encode4(195199),
     /* 193032 */ /*GILLT_v16s32*//*Label 4292*/ GIMT_Encode4(195514), GIMT_Encode4(0),
     /* 193040 */ /*GILLT_v32s8*//*Label 4293*/ GIMT_Encode4(195670),
     /* 193044 */ /*GILLT_v32s16*//*Label 4294*/ GIMT_Encode4(195985), GIMT_Encode4(0),
     /* 193052 */ /*GILLT_v64s8*//*Label 4295*/ GIMT_Encode4(196141),
     /* 193056 */ // Label 4284: @193056
     /* 193056 */ GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(193384),
     /* 193061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 193064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193067 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(193129), // Rule ID 24023 //
     /* 193072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193087 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193090 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193094 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193104 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193111 */     // (umax:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2i64] }:$src1)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193116 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193127 */     GIR_RootConstrainSelectedInstOperands,
     /* 193128 */     // GIR_Coverage, 24023,
     /* 193128 */     GIR_EraseRootFromParent_Done,
     /* 193129 */   // Label 4298: @193129
     /* 193129 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(193191), // Rule ID 5500 //
     /* 193134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193166 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193173 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ128rm:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rm),
     /* 193176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193178 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193180 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193189 */     GIR_RootConstrainSelectedInstOperands,
     /* 193190 */     // GIR_Coverage, 5500,
     /* 193190 */     GIR_EraseRootFromParent_Done,
     /* 193191 */   // Label 4299: @193191
     /* 193191 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(193218), // Rule ID 5497 //
     /* 193196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193211 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (VPMAXUQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)
     /* 193211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ128rr),
     /* 193216 */     GIR_RootConstrainSelectedInstOperands,
     /* 193217 */     // GIR_Coverage, 5497,
     /* 193217 */     GIR_Done,
     /* 193218 */   // Label 4300: @193218
     /* 193218 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(193383), // Rule ID 20002 //
     /* 193223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 193230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193238 */     // (umax:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1, VR128X:{ *:[v2i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src2, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 193238 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193241 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193245 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193252 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193255 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193259 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193264 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193267 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193271 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/11,
     /* 193274 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193279 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193284 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193289 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193292 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193296 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193303 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193306 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193310 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193315 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193322 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 193325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193335 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 193340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 193343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 193347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193352 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 193355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 193358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 193360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 193363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193365 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 193372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 193377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193382 */     // GIR_Coverage, 20002,
     /* 193382 */     GIR_EraseRootFromParent_Done,
     /* 193383 */   // Label 4301: @193383
     /* 193383 */   GIM_Reject,
     /* 193384 */ // Label 4297: @193384
     /* 193384 */ GIM_Reject,
     /* 193385 */ // Label 4285: @193385
     /* 193385 */ GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(193726),
     /* 193390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 193393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193396 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(193458), // Rule ID 23504 //
     /* 193401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193440 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4i32] }:$src1)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193445 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193456 */     GIR_RootConstrainSelectedInstOperands,
     /* 193457 */     // GIR_Coverage, 23504,
     /* 193457 */     GIR_EraseRootFromParent_Done,
     /* 193458 */   // Label 4303: @193458
     /* 193458 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(193520), // Rule ID 24005 //
     /* 193463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193478 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193481 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193485 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193502 */     // (umax:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4i32] }:$src1)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193507 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193518 */     GIR_RootConstrainSelectedInstOperands,
     /* 193519 */     // GIR_Coverage, 24005,
     /* 193519 */     GIR_EraseRootFromParent_Done,
     /* 193520 */   // Label 4304: @193520
     /* 193520 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(193582), // Rule ID 3192 //
     /* 193525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193544 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193547 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193551 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193564 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDrm:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrm),
     /* 193567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193569 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193571 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193580 */     GIR_RootConstrainSelectedInstOperands,
     /* 193581 */     // GIR_Coverage, 3192,
     /* 193581 */     GIR_EraseRootFromParent_Done,
     /* 193582 */   // Label 4305: @193582
     /* 193582 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(193644), // Rule ID 5473 //
     /* 193587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193626 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ128rm:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rm),
     /* 193629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193642 */     GIR_RootConstrainSelectedInstOperands,
     /* 193643 */     // GIR_Coverage, 5473,
     /* 193643 */     GIR_EraseRootFromParent_Done,
     /* 193644 */   // Label 4306: @193644
     /* 193644 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(193671), // Rule ID 3191 //
     /* 193649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 193652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193664 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (VPMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDrr),
     /* 193669 */     GIR_RootConstrainSelectedInstOperands,
     /* 193670 */     // GIR_Coverage, 3191,
     /* 193670 */     GIR_Done,
     /* 193671 */   // Label 4307: @193671
     /* 193671 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(193698), // Rule ID 3233 //
     /* 193676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 193679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 193691 */     // (umax:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)  =>  (PMAXUDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src1, VR128:{ *:[v4i32] }:$src2)
     /* 193691 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUDrr),
     /* 193696 */     GIR_RootConstrainSelectedInstOperands,
     /* 193697 */     // GIR_Coverage, 3233,
     /* 193697 */     GIR_Done,
     /* 193698 */   // Label 4308: @193698
     /* 193698 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(193725), // Rule ID 5470 //
     /* 193703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 193718 */     // (umax:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)  =>  (VPMAXUDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1, VR128X:{ *:[v4i32] }:$src2)
     /* 193718 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ128rr),
     /* 193723 */     GIR_RootConstrainSelectedInstOperands,
     /* 193724 */     // GIR_Coverage, 5470,
     /* 193724 */     GIR_Done,
     /* 193725 */   // Label 4309: @193725
     /* 193725 */   GIM_Reject,
     /* 193726 */ // Label 4302: @193726
     /* 193726 */ GIM_Reject,
     /* 193727 */ // Label 4286: @193727
     /* 193727 */ GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(194043),
     /* 193732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 193735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 193738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193742 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(193800), // Rule ID 24017 //
     /* 193747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 193754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193758 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193761 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193765 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193782 */     // (umax:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4i64] }:$src1)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193787 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 193789 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193798 */     GIR_RootConstrainSelectedInstOperands,
     /* 193799 */     // GIR_Coverage, 24017,
     /* 193799 */     GIR_EraseRootFromParent_Done,
     /* 193800 */   // Label 4311: @193800
     /* 193800 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(193858), // Rule ID 5491 //
     /* 193805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 193816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 193820 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 193823 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 193827 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 193831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 193833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 193840 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZ256rm:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 193840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rm),
     /* 193843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 193845 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 193847 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 193851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 193856 */     GIR_RootConstrainSelectedInstOperands,
     /* 193857 */     // GIR_Coverage, 5491,
     /* 193857 */     GIR_EraseRootFromParent_Done,
     /* 193858 */   // Label 4312: @193858
     /* 193858 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(193881), // Rule ID 5488 //
     /* 193863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 193866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193874 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (VPMAXUQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)
     /* 193874 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZ256rr),
     /* 193879 */     GIR_RootConstrainSelectedInstOperands,
     /* 193880 */     // GIR_Coverage, 5488,
     /* 193880 */     GIR_Done,
     /* 193881 */   // Label 4313: @193881
     /* 193881 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(194042), // Rule ID 20000 //
     /* 193886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 193889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 193897 */     // (umax:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1, VR256X:{ *:[v4i64] }:$src2)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPMAXUQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] }), (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src2, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 193897 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s64,
     /* 193900 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193904 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 193911 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s64,
     /* 193914 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193918 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193923 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 193926 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 193930 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/12,
     /* 193933 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193938 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193943 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193948 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 193951 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193955 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 193962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 193965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193974 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 193977 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 193981 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 193984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 193989 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 193994 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 193999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 194002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 194006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194011 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 194014 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 194017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 194019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 194022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194024 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 194031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 194036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 194041 */     // GIR_Coverage, 20000,
     /* 194041 */     GIR_EraseRootFromParent_Done,
     /* 194042 */   // Label 4314: @194042
     /* 194042 */   GIM_Reject,
     /* 194043 */ // Label 4310: @194043
     /* 194043 */ GIM_Reject,
     /* 194044 */ // Label 4287: @194044
     /* 194044 */ GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(194385),
     /* 194049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 194052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194055 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(194117), // Rule ID 23509 //
     /* 194060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194075 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194078 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194082 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194092 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194099 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v8i16] }:$src1)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194104 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194106 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194115 */     GIR_RootConstrainSelectedInstOperands,
     /* 194116 */     // GIR_Coverage, 23509,
     /* 194116 */     GIR_EraseRootFromParent_Done,
     /* 194117 */   // Label 4316: @194117
     /* 194117 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(194179), // Rule ID 23990 //
     /* 194122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194154 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194161 */     // (umax:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8i16] }:$src1)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194166 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194168 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194177 */     GIR_RootConstrainSelectedInstOperands,
     /* 194178 */     // GIR_Coverage, 23990,
     /* 194178 */     GIR_EraseRootFromParent_Done,
     /* 194179 */   // Label 4317: @194179
     /* 194179 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(194241), // Rule ID 3202 //
     /* 194184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194223 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWrm:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrm),
     /* 194226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194228 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194230 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194239 */     GIR_RootConstrainSelectedInstOperands,
     /* 194240 */     // GIR_Coverage, 3202,
     /* 194240 */     GIR_EraseRootFromParent_Done,
     /* 194241 */   // Label 4318: @194241
     /* 194241 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(194303), // Rule ID 5449 //
     /* 194246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194265 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194272 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194278 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194285 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ128rm:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rm),
     /* 194288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194292 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194301 */     GIR_RootConstrainSelectedInstOperands,
     /* 194302 */     // GIR_Coverage, 5449,
     /* 194302 */     GIR_EraseRootFromParent_Done,
     /* 194303 */   // Label 4319: @194303
     /* 194303 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(194330), // Rule ID 3201 //
     /* 194308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194323 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (VPMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWrr),
     /* 194328 */     GIR_RootConstrainSelectedInstOperands,
     /* 194329 */     // GIR_Coverage, 3201,
     /* 194329 */     GIR_Done,
     /* 194330 */   // Label 4320: @194330
     /* 194330 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(194357), // Rule ID 3235 //
     /* 194335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE41),
     /* 194338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194350 */     // (umax:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)  =>  (PMAXUWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src1, VR128:{ *:[v8i16] }:$src2)
     /* 194350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUWrr),
     /* 194355 */     GIR_RootConstrainSelectedInstOperands,
     /* 194356 */     // GIR_Coverage, 3235,
     /* 194356 */     GIR_Done,
     /* 194357 */   // Label 4321: @194357
     /* 194357 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(194384), // Rule ID 5446 //
     /* 194362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194377 */     // (umax:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)  =>  (VPMAXUWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1, VR128X:{ *:[v8i16] }:$src2)
     /* 194377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ128rr),
     /* 194382 */     GIR_RootConstrainSelectedInstOperands,
     /* 194383 */     // GIR_Coverage, 5446,
     /* 194383 */     GIR_Done,
     /* 194384 */   // Label 4322: @194384
     /* 194384 */   GIM_Reject,
     /* 194385 */ // Label 4315: @194385
     /* 194385 */ GIM_Reject,
     /* 194386 */ // Label 4288: @194386
     /* 194386 */ GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(194700),
     /* 194391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 194394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 194397 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(194459), // Rule ID 23513 //
     /* 194402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194417 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194420 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194424 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194434 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194441 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8i32] }:$src1)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194446 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194448 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194457 */     GIR_RootConstrainSelectedInstOperands,
     /* 194458 */     // GIR_Coverage, 23513,
     /* 194458 */     GIR_EraseRootFromParent_Done,
     /* 194459 */   // Label 4324: @194459
     /* 194459 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(194521), // Rule ID 23999 //
     /* 194464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194479 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194486 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194503 */     // (umax:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8i32] }:$src1)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194508 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194519 */     GIR_RootConstrainSelectedInstOperands,
     /* 194520 */     // GIR_Coverage, 23999,
     /* 194520 */     GIR_EraseRootFromParent_Done,
     /* 194521 */   // Label 4325: @194521
     /* 194521 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(194583), // Rule ID 3210 //
     /* 194526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194558 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194565 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDYrm:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrm),
     /* 194568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194570 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194572 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194581 */     GIR_RootConstrainSelectedInstOperands,
     /* 194582 */     // GIR_Coverage, 3210,
     /* 194582 */     GIR_EraseRootFromParent_Done,
     /* 194583 */   // Label 4326: @194583
     /* 194583 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(194645), // Rule ID 5464 //
     /* 194588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194627 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZ256rm:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rm),
     /* 194630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194643 */     GIR_RootConstrainSelectedInstOperands,
     /* 194644 */     // GIR_Coverage, 5464,
     /* 194644 */     GIR_EraseRootFromParent_Done,
     /* 194645 */   // Label 4327: @194645
     /* 194645 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(194672), // Rule ID 3209 //
     /* 194650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 194653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 194665 */     // (umax:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)  =>  (VPMAXUDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src1, VR256:{ *:[v8i32] }:$src2)
     /* 194665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDYrr),
     /* 194670 */     GIR_RootConstrainSelectedInstOperands,
     /* 194671 */     // GIR_Coverage, 3209,
     /* 194671 */     GIR_Done,
     /* 194672 */   // Label 4328: @194672
     /* 194672 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(194699), // Rule ID 5461 //
     /* 194677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 194680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 194692 */     // (umax:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)  =>  (VPMAXUDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1, VR256X:{ *:[v8i32] }:$src2)
     /* 194692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZ256rr),
     /* 194697 */     GIR_RootConstrainSelectedInstOperands,
     /* 194698 */     // GIR_Coverage, 5461,
     /* 194698 */     GIR_Done,
     /* 194699 */   // Label 4329: @194699
     /* 194699 */   GIM_Reject,
     /* 194700 */ // Label 4323: @194700
     /* 194700 */ GIM_Reject,
     /* 194701 */ // Label 4289: @194701
     /* 194701 */ GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(194856),
     /* 194706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 194709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 194712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194716 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(194774), // Rule ID 24011 //
     /* 194721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194756 */     // (umax:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8i64] }:$src1)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194772 */     GIR_RootConstrainSelectedInstOperands,
     /* 194773 */     // GIR_Coverage, 24011,
     /* 194773 */     GIR_EraseRootFromParent_Done,
     /* 194774 */   // Label 4331: @194774
     /* 194774 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(194832), // Rule ID 5482 //
     /* 194779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 194790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194814 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUQZrm:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrm),
     /* 194817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 194821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194830 */     GIR_RootConstrainSelectedInstOperands,
     /* 194831 */     // GIR_Coverage, 5482,
     /* 194831 */     GIR_EraseRootFromParent_Done,
     /* 194832 */   // Label 4332: @194832
     /* 194832 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(194855), // Rule ID 5479 //
     /* 194837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 194840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 194848 */     // (umax:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)  =>  (VPMAXUQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1, VR512:{ *:[v8i64] }:$src2)
     /* 194848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUQZrr),
     /* 194853 */     GIR_RootConstrainSelectedInstOperands,
     /* 194854 */     // GIR_Coverage, 5479,
     /* 194854 */     GIR_Done,
     /* 194855 */   // Label 4333: @194855
     /* 194855 */   GIM_Reject,
     /* 194856 */ // Label 4330: @194856
     /* 194856 */ GIM_Reject,
     /* 194857 */ // Label 4290: @194857
     /* 194857 */ GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(195198),
     /* 194862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 194865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194868 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(194930), // Rule ID 23468 //
     /* 194873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 194876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194888 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194891 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194895 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 194903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194912 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v16i8] }:$src1)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 194915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194919 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194928 */     GIR_RootConstrainSelectedInstOperands,
     /* 194929 */     // GIR_Coverage, 23468,
     /* 194929 */     GIR_EraseRootFromParent_Done,
     /* 194930 */   // Label 4335: @194930
     /* 194930 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(194992), // Rule ID 23981 //
     /* 194935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 194938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 194946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 194950 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 194953 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 194957 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 194961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 194965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 194967 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 194974 */     // (umax:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v16i8] }:$src1)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 194974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 194977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 194979 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 194981 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 194985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 194990 */     GIR_RootConstrainSelectedInstOperands,
     /* 194991 */     // GIR_Coverage, 23981,
     /* 194991 */     GIR_EraseRootFromParent_Done,
     /* 194992 */   // Label 4336: @194992
     /* 194992 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(195054), // Rule ID 2649 //
     /* 194997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 195000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195029 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195036 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBrm:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrm),
     /* 195039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195043 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195052 */     GIR_RootConstrainSelectedInstOperands,
     /* 195053 */     // GIR_Coverage, 2649,
     /* 195053 */     GIR_EraseRootFromParent_Done,
     /* 195054 */   // Label 4337: @195054
     /* 195054 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(195116), // Rule ID 5431 //
     /* 195059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195098 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ128rm:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rm),
     /* 195101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195114 */     GIR_RootConstrainSelectedInstOperands,
     /* 195115 */     // GIR_Coverage, 5431,
     /* 195115 */     GIR_EraseRootFromParent_Done,
     /* 195116 */   // Label 4338: @195116
     /* 195116 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(195143), // Rule ID 2648 //
     /* 195121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 195124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195136 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (VPMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195136 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBrr),
     /* 195141 */     GIR_RootConstrainSelectedInstOperands,
     /* 195142 */     // GIR_Coverage, 2648,
     /* 195142 */     GIR_Done,
     /* 195143 */   // Label 4339: @195143
     /* 195143 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(195170), // Rule ID 2650 //
     /* 195148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 195151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 195163 */     // (umax:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)  =>  (PMAXUBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src1, VR128:{ *:[v16i8] }:$src2)
     /* 195163 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PMAXUBrr),
     /* 195168 */     GIR_RootConstrainSelectedInstOperands,
     /* 195169 */     // GIR_Coverage, 2650,
     /* 195169 */     GIR_Done,
     /* 195170 */   // Label 4340: @195170
     /* 195170 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(195197), // Rule ID 5428 //
     /* 195175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 195190 */     // (umax:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)  =>  (VPMAXUBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1, VR128X:{ *:[v16i8] }:$src2)
     /* 195190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ128rr),
     /* 195195 */     GIR_RootConstrainSelectedInstOperands,
     /* 195196 */     // GIR_Coverage, 5428,
     /* 195196 */     GIR_Done,
     /* 195197 */   // Label 4341: @195197
     /* 195197 */   GIM_Reject,
     /* 195198 */ // Label 4334: @195198
     /* 195198 */ GIM_Reject,
     /* 195199 */ // Label 4291: @195199
     /* 195199 */ GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(195513),
     /* 195204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 195207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 195210 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(195272), // Rule ID 23518 //
     /* 195215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195254 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v16i16] }:$src1)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195270 */     GIR_RootConstrainSelectedInstOperands,
     /* 195271 */     // GIR_Coverage, 23518,
     /* 195271 */     GIR_EraseRootFromParent_Done,
     /* 195272 */   // Label 4343: @195272
     /* 195272 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(195334), // Rule ID 23987 //
     /* 195277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195316 */     // (umax:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16i16] }:$src1)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195321 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195332 */     GIR_RootConstrainSelectedInstOperands,
     /* 195333 */     // GIR_Coverage, 23987,
     /* 195333 */     GIR_EraseRootFromParent_Done,
     /* 195334 */   // Label 4344: @195334
     /* 195334 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(195396), // Rule ID 3220 //
     /* 195339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195378 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWYrm:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrm),
     /* 195381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195394 */     GIR_RootConstrainSelectedInstOperands,
     /* 195395 */     // GIR_Coverage, 3220,
     /* 195395 */     GIR_EraseRootFromParent_Done,
     /* 195396 */   // Label 4345: @195396
     /* 195396 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(195458), // Rule ID 5443 //
     /* 195401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195440 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZ256rm:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rm),
     /* 195443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195456 */     GIR_RootConstrainSelectedInstOperands,
     /* 195457 */     // GIR_Coverage, 5443,
     /* 195457 */     GIR_EraseRootFromParent_Done,
     /* 195458 */   // Label 4346: @195458
     /* 195458 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(195485), // Rule ID 3219 //
     /* 195463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195478 */     // (umax:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)  =>  (VPMAXUWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src1, VR256:{ *:[v16i16] }:$src2)
     /* 195478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWYrr),
     /* 195483 */     GIR_RootConstrainSelectedInstOperands,
     /* 195484 */     // GIR_Coverage, 3219,
     /* 195484 */     GIR_Done,
     /* 195485 */   // Label 4347: @195485
     /* 195485 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(195512), // Rule ID 5440 //
     /* 195490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195505 */     // (umax:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)  =>  (VPMAXUWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1, VR256X:{ *:[v16i16] }:$src2)
     /* 195505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZ256rr),
     /* 195510 */     GIR_RootConstrainSelectedInstOperands,
     /* 195511 */     // GIR_Coverage, 5440,
     /* 195511 */     GIR_Done,
     /* 195512 */   // Label 4348: @195512
     /* 195512 */   GIM_Reject,
     /* 195513 */ // Label 4342: @195513
     /* 195513 */ GIM_Reject,
     /* 195514 */ // Label 4292: @195514
     /* 195514 */ GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(195669),
     /* 195519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 195522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 195525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195529 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(195587), // Rule ID 23993 //
     /* 195534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195545 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195548 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195552 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195562 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195569 */     // (umax:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16i32] }:$src1)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195574 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195576 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195585 */     GIR_RootConstrainSelectedInstOperands,
     /* 195586 */     // GIR_Coverage, 23993,
     /* 195586 */     GIR_EraseRootFromParent_Done,
     /* 195587 */   // Label 4350: @195587
     /* 195587 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(195645), // Rule ID 5455 //
     /* 195592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195607 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195610 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195614 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195627 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUDZrm:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrm),
     /* 195630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195632 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195634 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195643 */     GIR_RootConstrainSelectedInstOperands,
     /* 195644 */     // GIR_Coverage, 5455,
     /* 195644 */     GIR_EraseRootFromParent_Done,
     /* 195645 */   // Label 4351: @195645
     /* 195645 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(195668), // Rule ID 5452 //
     /* 195650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 195653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 195661 */     // (umax:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)  =>  (VPMAXUDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1, VR512:{ *:[v16i32] }:$src2)
     /* 195661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUDZrr),
     /* 195666 */     GIR_RootConstrainSelectedInstOperands,
     /* 195667 */     // GIR_Coverage, 5452,
     /* 195667 */     GIR_Done,
     /* 195668 */   // Label 4352: @195668
     /* 195668 */   GIM_Reject,
     /* 195669 */ // Label 4349: @195669
     /* 195669 */ GIM_Reject,
     /* 195670 */ // Label 4293: @195670
     /* 195670 */ GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(195984),
     /* 195675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 195678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s8,
     /* 195681 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(195743), // Rule ID 23470 //
     /* 195686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195701 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195704 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195708 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195725 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v32i8] }:$src1)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195730 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195741 */     GIR_RootConstrainSelectedInstOperands,
     /* 195742 */     // GIR_Coverage, 23470,
     /* 195742 */     GIR_EraseRootFromParent_Done,
     /* 195743 */   // Label 4354: @195743
     /* 195743 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(195805), // Rule ID 23978 //
     /* 195748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 195759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195763 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195766 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195770 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195780 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195787 */     // (umax:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v32i8] }:$src1)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195792 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 195794 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195803 */     GIR_RootConstrainSelectedInstOperands,
     /* 195804 */     // GIR_Coverage, 23978,
     /* 195804 */     GIR_EraseRootFromParent_Done,
     /* 195805 */   // Label 4355: @195805
     /* 195805 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(195867), // Rule ID 2653 //
     /* 195810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195829 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195832 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195836 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195842 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195849 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBYrm:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrm),
     /* 195852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195854 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195856 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195865 */     GIR_RootConstrainSelectedInstOperands,
     /* 195866 */     // GIR_Coverage, 2653,
     /* 195866 */     GIR_EraseRootFromParent_Done,
     /* 195867 */   // Label 4356: @195867
     /* 195867 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(195929), // Rule ID 5425 //
     /* 195872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 195887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 195891 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 195894 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 195898 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 195902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 195904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 195911 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZ256rm:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 195911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rm),
     /* 195914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 195916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 195918 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 195922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 195927 */     GIR_RootConstrainSelectedInstOperands,
     /* 195928 */     // GIR_Coverage, 5425,
     /* 195928 */     GIR_EraseRootFromParent_Done,
     /* 195929 */   // Label 4357: @195929
     /* 195929 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(195956), // Rule ID 2652 //
     /* 195934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 195937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 195949 */     // (umax:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)  =>  (VPMAXUBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src1, VR256:{ *:[v32i8] }:$src2)
     /* 195949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBYrr),
     /* 195954 */     GIR_RootConstrainSelectedInstOperands,
     /* 195955 */     // GIR_Coverage, 2652,
     /* 195955 */     GIR_Done,
     /* 195956 */   // Label 4358: @195956
     /* 195956 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(195983), // Rule ID 5422 //
     /* 195961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 195964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 195976 */     // (umax:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)  =>  (VPMAXUBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1, VR256X:{ *:[v32i8] }:$src2)
     /* 195976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZ256rr),
     /* 195981 */     GIR_RootConstrainSelectedInstOperands,
     /* 195982 */     // GIR_Coverage, 5422,
     /* 195982 */     GIR_Done,
     /* 195983 */   // Label 4359: @195983
     /* 195983 */   GIM_Reject,
     /* 195984 */ // Label 4353: @195984
     /* 195984 */ GIM_Reject,
     /* 195985 */ // Label 4294: @195985
     /* 195985 */ GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(196140),
     /* 195990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 195993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 195996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196000 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(196058), // Rule ID 23984 //
     /* 196005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196019 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196023 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196033 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196040 */     // (umax:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32i16] }:$src1)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196045 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196047 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196056 */     GIR_RootConstrainSelectedInstOperands,
     /* 196057 */     // GIR_Coverage, 23984,
     /* 196057 */     GIR_EraseRootFromParent_Done,
     /* 196058 */   // Label 4361: @196058
     /* 196058 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(196116), // Rule ID 5437 //
     /* 196063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196078 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196081 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196085 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196098 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUWZrm:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrm),
     /* 196101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196103 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196114 */     GIR_RootConstrainSelectedInstOperands,
     /* 196115 */     // GIR_Coverage, 5437,
     /* 196115 */     GIR_EraseRootFromParent_Done,
     /* 196116 */   // Label 4362: @196116
     /* 196116 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(196139), // Rule ID 5434 //
     /* 196121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196132 */     // (umax:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)  =>  (VPMAXUWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1, VR512:{ *:[v32i16] }:$src2)
     /* 196132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUWZrr),
     /* 196137 */     GIR_RootConstrainSelectedInstOperands,
     /* 196138 */     // GIR_Coverage, 5434,
     /* 196138 */     GIR_Done,
     /* 196139 */   // Label 4363: @196139
     /* 196139 */   GIM_Reject,
     /* 196140 */ // Label 4360: @196140
     /* 196140 */ GIM_Reject,
     /* 196141 */ // Label 4295: @196141
     /* 196141 */ GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(196296),
     /* 196146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 196149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s8,
     /* 196152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196156 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(196214), // Rule ID 23975 //
     /* 196161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196172 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196175 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196179 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196189 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196196 */     // (umax:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v64i8] }:$src1)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196201 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 196203 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196212 */     GIR_RootConstrainSelectedInstOperands,
     /* 196213 */     // GIR_Coverage, 23975,
     /* 196213 */     GIR_EraseRootFromParent_Done,
     /* 196214 */   // Label 4365: @196214
     /* 196214 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(196272), // Rule ID 5419 //
     /* 196219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 196230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196237 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196241 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196254 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPMAXUBZrm:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 196254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrm),
     /* 196257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196259 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 196261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 196265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196270 */     GIR_RootConstrainSelectedInstOperands,
     /* 196271 */     // GIR_Coverage, 5419,
     /* 196271 */     GIR_EraseRootFromParent_Done,
     /* 196272 */   // Label 4366: @196272
     /* 196272 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(196295), // Rule ID 5416 //
     /* 196277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 196280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 196288 */     // (umax:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)  =>  (VPMAXUBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1, VR512:{ *:[v64i8] }:$src2)
     /* 196288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPMAXUBZrr),
     /* 196293 */     GIR_RootConstrainSelectedInstOperands,
     /* 196294 */     // GIR_Coverage, 5416,
     /* 196294 */     GIR_Done,
     /* 196295 */   // Label 4367: @196295
     /* 196295 */   GIM_Reject,
     /* 196296 */ // Label 4364: @196296
     /* 196296 */ GIM_Reject,
     /* 196297 */ // Label 4296: @196297
     /* 196297 */ GIM_Reject,
     /* 196298 */ // Label 58: @196298
     /* 196298 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4380*/ GIMT_Encode4(198178),
     /* 196309 */ /*GILLT_v2s64*//*Label 4368*/ GIMT_Encode4(196377), GIMT_Encode4(0),
     /* 196317 */ /*GILLT_v4s32*//*Label 4369*/ GIMT_Encode4(196573),
     /* 196321 */ /*GILLT_v4s64*//*Label 4370*/ GIMT_Encode4(196764), GIMT_Encode4(0),
     /* 196329 */ /*GILLT_v8s16*//*Label 4371*/ GIMT_Encode4(196952),
     /* 196333 */ /*GILLT_v8s32*//*Label 4372*/ GIMT_Encode4(197143),
     /* 196337 */ /*GILLT_v8s64*//*Label 4373*/ GIMT_Encode4(197311), GIMT_Encode4(0),
     /* 196345 */ /*GILLT_v16s8*//*Label 4374*/ GIMT_Encode4(197396),
     /* 196349 */ /*GILLT_v16s16*//*Label 4375*/ GIMT_Encode4(197587),
     /* 196353 */ /*GILLT_v16s32*//*Label 4376*/ GIMT_Encode4(197755), GIMT_Encode4(0),
     /* 196361 */ /*GILLT_v32s8*//*Label 4377*/ GIMT_Encode4(197840),
     /* 196365 */ /*GILLT_v32s16*//*Label 4378*/ GIMT_Encode4(198008), GIMT_Encode4(0),
     /* 196373 */ /*GILLT_v64s8*//*Label 4379*/ GIMT_Encode4(198093),
     /* 196377 */ // Label 4368: @196377
     /* 196377 */ GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(196572),
     /* 196382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 196385 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(196441), // Rule ID 13267 //
     /* 196390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196405 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196408 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196412 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196425 */     // (abs:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 196425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rm),
     /* 196428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196430 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196439 */     GIR_RootConstrainSelectedInstOperands,
     /* 196440 */     // GIR_Coverage, 13267,
     /* 196440 */     GIR_EraseRootFromParent_Done,
     /* 196441 */   // Label 4382: @196441
     /* 196441 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(196464), // Rule ID 13264 //
     /* 196446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196457 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPABSQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 196457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ128rr),
     /* 196462 */     GIR_RootConstrainSelectedInstOperands,
     /* 196463 */     // GIR_Coverage, 13264,
     /* 196463 */     GIR_Done,
     /* 196464 */   // Label 4383: @196464
     /* 196464 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(196571), // Rule ID 21824 //
     /* 196469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 196476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196480 */     // (abs:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 196480 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196483 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196487 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196494 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196497 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196501 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196506 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196509 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 196516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 196531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196543 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 196560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 196565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196570 */     // GIR_Coverage, 21824,
     /* 196570 */     GIR_EraseRootFromParent_Done,
     /* 196571 */   // Label 4384: @196571
     /* 196571 */   GIM_Reject,
     /* 196572 */ // Label 4381: @196572
     /* 196572 */ GIM_Reject,
     /* 196573 */ // Label 4369: @196573
     /* 196573 */ GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(196763),
     /* 196578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 196581 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(196637), // Rule ID 2995 //
     /* 196586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196601 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196604 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196608 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196614 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196621 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDrm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src)
     /* 196621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDrm),
     /* 196624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 196630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196635 */     GIR_RootConstrainSelectedInstOperands,
     /* 196636 */     // GIR_Coverage, 2995,
     /* 196636 */     GIR_EraseRootFromParent_Done,
     /* 196637 */   // Label 4386: @196637
     /* 196637 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(196693), // Rule ID 13294 //
     /* 196642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196657 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196664 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196670 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196677 */     // (abs:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 196677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rm),
     /* 196680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196691 */     GIR_RootConstrainSelectedInstOperands,
     /* 196692 */     // GIR_Coverage, 13294,
     /* 196692 */     GIR_EraseRootFromParent_Done,
     /* 196693 */   // Label 4387: @196693
     /* 196693 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(196716), // Rule ID 2994 //
     /* 196698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 196701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196709 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (VPABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDrr),
     /* 196714 */     GIR_RootConstrainSelectedInstOperands,
     /* 196715 */     // GIR_Coverage, 2994,
     /* 196715 */     GIR_Done,
     /* 196716 */   // Label 4388: @196716
     /* 196716 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(196739), // Rule ID 3006 //
     /* 196721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 196724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196732 */     // (abs:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)  =>  (PABSDrr:{ *:[v4i32] } VR128:{ *:[v4i32] }:$src)
     /* 196732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSDrr),
     /* 196737 */     GIR_RootConstrainSelectedInstOperands,
     /* 196738 */     // GIR_Coverage, 3006,
     /* 196738 */     GIR_Done,
     /* 196739 */   // Label 4389: @196739
     /* 196739 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(196762), // Rule ID 13291 //
     /* 196744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 196755 */     // (abs:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPABSDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 196755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ128rr),
     /* 196760 */     GIR_RootConstrainSelectedInstOperands,
     /* 196761 */     // GIR_Coverage, 13291,
     /* 196761 */     GIR_Done,
     /* 196762 */   // Label 4390: @196762
     /* 196762 */   GIM_Reject,
     /* 196763 */ // Label 4385: @196763
     /* 196763 */ GIM_Reject,
     /* 196764 */ // Label 4370: @196764
     /* 196764 */ GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(196951),
     /* 196769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 196772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196776 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(196828), // Rule ID 13258 //
     /* 196781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196792 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196795 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196799 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 196812 */     // (abs:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 196812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rm),
     /* 196815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196817 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 196821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 196826 */     GIR_RootConstrainSelectedInstOperands,
     /* 196827 */     // GIR_Coverage, 13258,
     /* 196827 */     GIR_EraseRootFromParent_Done,
     /* 196828 */   // Label 4392: @196828
     /* 196828 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(196847), // Rule ID 13255 //
     /* 196833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 196836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196840 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPABSQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 196840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZ256rr),
     /* 196845 */     GIR_RootConstrainSelectedInstOperands,
     /* 196846 */     // GIR_Coverage, 13255,
     /* 196846 */     GIR_Done,
     /* 196847 */   // Label 4393: @196847
     /* 196847 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(196950), // Rule ID 21823 //
     /* 196852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasEVEX512_NoVLX),
     /* 196855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 196859 */     // (abs:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPABSQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 196859 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 196862 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196866 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 196873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 196876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 196888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 196892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 196895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 196900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 196913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 196917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196922 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 196925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 196927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 196930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196932 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 196939 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 196944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 196949 */     // GIR_Coverage, 21823,
     /* 196949 */     GIR_EraseRootFromParent_Done,
     /* 196950 */   // Label 4394: @196950
     /* 196950 */   GIM_Reject,
     /* 196951 */ // Label 4391: @196951
     /* 196951 */ GIM_Reject,
     /* 196952 */ // Label 4371: @196952
     /* 196952 */ GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(197142),
     /* 196957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 196960 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(197016), // Rule ID 2993 //
     /* 196965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 196968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 196972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 196976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 196980 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 196983 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 196987 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 196991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 196993 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197000 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWrm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src)
     /* 197000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWrm),
     /* 197003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197014 */     GIR_RootConstrainSelectedInstOperands,
     /* 197015 */     // GIR_Coverage, 2993,
     /* 197015 */     GIR_EraseRootFromParent_Done,
     /* 197016 */   // Label 4396: @197016
     /* 197016 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(197072), // Rule ID 13315 //
     /* 197021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197056 */     // (abs:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 197056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rm),
     /* 197059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197070 */     GIR_RootConstrainSelectedInstOperands,
     /* 197071 */     // GIR_Coverage, 13315,
     /* 197071 */     GIR_EraseRootFromParent_Done,
     /* 197072 */   // Label 4397: @197072
     /* 197072 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(197095), // Rule ID 2992 //
     /* 197077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197088 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (VPABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWrr),
     /* 197093 */     GIR_RootConstrainSelectedInstOperands,
     /* 197094 */     // GIR_Coverage, 2992,
     /* 197094 */     GIR_Done,
     /* 197095 */   // Label 4398: @197095
     /* 197095 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(197118), // Rule ID 3004 //
     /* 197100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197111 */     // (abs:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)  =>  (PABSWrr:{ *:[v8i16] } VR128:{ *:[v8i16] }:$src)
     /* 197111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSWrr),
     /* 197116 */     GIR_RootConstrainSelectedInstOperands,
     /* 197117 */     // GIR_Coverage, 3004,
     /* 197117 */     GIR_Done,
     /* 197118 */   // Label 4399: @197118
     /* 197118 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(197141), // Rule ID 13312 //
     /* 197123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197134 */     // (abs:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPABSWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 197134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ128rr),
     /* 197139 */     GIR_RootConstrainSelectedInstOperands,
     /* 197140 */     // GIR_Coverage, 13312,
     /* 197140 */     GIR_Done,
     /* 197141 */   // Label 4400: @197141
     /* 197141 */   GIM_Reject,
     /* 197142 */ // Label 4395: @197142
     /* 197142 */ GIM_Reject,
     /* 197143 */ // Label 4372: @197143
     /* 197143 */ GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(197310),
     /* 197148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 197151 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(197207), // Rule ID 3001 //
     /* 197156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197171 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197174 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197178 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197184 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197191 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDYrm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src)
     /* 197191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDYrm),
     /* 197194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197196 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197205 */     GIR_RootConstrainSelectedInstOperands,
     /* 197206 */     // GIR_Coverage, 3001,
     /* 197206 */     GIR_EraseRootFromParent_Done,
     /* 197207 */   // Label 4402: @197207
     /* 197207 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(197263), // Rule ID 13285 //
     /* 197212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197227 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197230 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197234 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197247 */     // (abs:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 197247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rm),
     /* 197250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197252 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197261 */     GIR_RootConstrainSelectedInstOperands,
     /* 197262 */     // GIR_Coverage, 13285,
     /* 197262 */     GIR_EraseRootFromParent_Done,
     /* 197263 */   // Label 4403: @197263
     /* 197263 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(197286), // Rule ID 3000 //
     /* 197268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX),
     /* 197271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197279 */     // (abs:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)  =>  (VPABSDYrr:{ *:[v8i32] } VR256:{ *:[v8i32] }:$src)
     /* 197279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDYrr),
     /* 197284 */     GIR_RootConstrainSelectedInstOperands,
     /* 197285 */     // GIR_Coverage, 3000,
     /* 197285 */     GIR_Done,
     /* 197286 */   // Label 4404: @197286
     /* 197286 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(197309), // Rule ID 13282 //
     /* 197291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 197294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197302 */     // (abs:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPABSDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 197302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZ256rr),
     /* 197307 */     GIR_RootConstrainSelectedInstOperands,
     /* 197308 */     // GIR_Coverage, 13282,
     /* 197308 */     GIR_Done,
     /* 197309 */   // Label 4405: @197309
     /* 197309 */   GIM_Reject,
     /* 197310 */ // Label 4401: @197310
     /* 197310 */ GIM_Reject,
     /* 197311 */ // Label 4373: @197311
     /* 197311 */ GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(197395),
     /* 197316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 197319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197323 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(197375), // Rule ID 13249 //
     /* 197328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197339 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197346 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197359 */     // (abs:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 197359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSQZrm),
     /* 197362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197373 */     GIR_RootConstrainSelectedInstOperands,
     /* 197374 */     // GIR_Coverage, 13249,
     /* 197374 */     GIR_EraseRootFromParent_Done,
     /* 197375 */   // Label 4407: @197375
     /* 197375 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(197394), // Rule ID 13246 //
     /* 197380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197387 */     // (abs:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPABSQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 197387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSQZrr),
     /* 197392 */     GIR_RootConstrainSelectedInstOperands,
     /* 197393 */     // GIR_Coverage, 13246,
     /* 197393 */     GIR_Done,
     /* 197394 */   // Label 4408: @197394
     /* 197394 */   GIM_Reject,
     /* 197395 */ // Label 4406: @197395
     /* 197395 */ GIM_Reject,
     /* 197396 */ // Label 4374: @197396
     /* 197396 */ GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(197586),
     /* 197401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 197404 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(197460), // Rule ID 2991 //
     /* 197409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197437 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197444 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBrm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src)
     /* 197444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBrm),
     /* 197447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197449 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197458 */     GIR_RootConstrainSelectedInstOperands,
     /* 197459 */     // GIR_Coverage, 2991,
     /* 197459 */     GIR_EraseRootFromParent_Done,
     /* 197460 */   // Label 4410: @197460
     /* 197460 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(197516), // Rule ID 13333 //
     /* 197465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197500 */     // (abs:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 197500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rm),
     /* 197503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197514 */     GIR_RootConstrainSelectedInstOperands,
     /* 197515 */     // GIR_Coverage, 13333,
     /* 197515 */     GIR_EraseRootFromParent_Done,
     /* 197516 */   // Label 4411: @197516
     /* 197516 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(197539), // Rule ID 2990 //
     /* 197521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX_Or_NoBWI),
     /* 197524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197532 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (VPABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBrr),
     /* 197537 */     GIR_RootConstrainSelectedInstOperands,
     /* 197538 */     // GIR_Coverage, 2990,
     /* 197538 */     GIR_Done,
     /* 197539 */   // Label 4412: @197539
     /* 197539 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(197562), // Rule ID 3002 //
     /* 197544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSSE3),
     /* 197547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 197555 */     // (abs:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)  =>  (PABSBrr:{ *:[v16i8] } VR128:{ *:[v16i8] }:$src)
     /* 197555 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::PABSBrr),
     /* 197560 */     GIR_RootConstrainSelectedInstOperands,
     /* 197561 */     // GIR_Coverage, 3002,
     /* 197561 */     GIR_Done,
     /* 197562 */   // Label 4413: @197562
     /* 197562 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(197585), // Rule ID 13330 //
     /* 197567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 197578 */     // (abs:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPABSBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 197578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ128rr),
     /* 197583 */     GIR_RootConstrainSelectedInstOperands,
     /* 197584 */     // GIR_Coverage, 13330,
     /* 197584 */     GIR_Done,
     /* 197585 */   // Label 4414: @197585
     /* 197585 */   GIM_Reject,
     /* 197586 */ // Label 4409: @197586
     /* 197586 */ GIM_Reject,
     /* 197587 */ // Label 4375: @197587
     /* 197587 */ GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(197754),
     /* 197592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 197595 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(197651), // Rule ID 2999 //
     /* 197600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197615 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197618 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197622 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197635 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWYrm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src)
     /* 197635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWYrm),
     /* 197638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197640 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197649 */     GIR_RootConstrainSelectedInstOperands,
     /* 197650 */     // GIR_Coverage, 2999,
     /* 197650 */     GIR_EraseRootFromParent_Done,
     /* 197651 */   // Label 4416: @197651
     /* 197651 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(197707), // Rule ID 13309 //
     /* 197656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197684 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197691 */     // (abs:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 197691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rm),
     /* 197694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197696 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197705 */     GIR_RootConstrainSelectedInstOperands,
     /* 197706 */     // GIR_Coverage, 13309,
     /* 197706 */     GIR_EraseRootFromParent_Done,
     /* 197707 */   // Label 4417: @197707
     /* 197707 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(197730), // Rule ID 2998 //
     /* 197712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197723 */     // (abs:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)  =>  (VPABSWYrr:{ *:[v16i16] } VR256:{ *:[v16i16] }:$src)
     /* 197723 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWYrr),
     /* 197728 */     GIR_RootConstrainSelectedInstOperands,
     /* 197729 */     // GIR_Coverage, 2998,
     /* 197729 */     GIR_Done,
     /* 197730 */   // Label 4418: @197730
     /* 197730 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(197753), // Rule ID 13306 //
     /* 197735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197746 */     // (abs:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPABSWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 197746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZ256rr),
     /* 197751 */     GIR_RootConstrainSelectedInstOperands,
     /* 197752 */     // GIR_Coverage, 13306,
     /* 197752 */     GIR_Done,
     /* 197753 */   // Label 4419: @197753
     /* 197753 */   GIM_Reject,
     /* 197754 */ // Label 4415: @197754
     /* 197754 */ GIM_Reject,
     /* 197755 */ // Label 4376: @197755
     /* 197755 */ GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(197839),
     /* 197760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 197763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197767 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(197819), // Rule ID 13276 //
     /* 197772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197783 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197786 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197790 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197796 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197803 */     // (abs:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 197803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSDZrm),
     /* 197806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197817 */     GIR_RootConstrainSelectedInstOperands,
     /* 197818 */     // GIR_Coverage, 13276,
     /* 197818 */     GIR_EraseRootFromParent_Done,
     /* 197819 */   // Label 4421: @197819
     /* 197819 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(197838), // Rule ID 13273 //
     /* 197824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 197827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 197831 */     // (abs:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPABSDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 197831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSDZrr),
     /* 197836 */     GIR_RootConstrainSelectedInstOperands,
     /* 197837 */     // GIR_Coverage, 13273,
     /* 197837 */     GIR_Done,
     /* 197838 */   // Label 4422: @197838
     /* 197838 */   GIM_Reject,
     /* 197839 */ // Label 4420: @197839
     /* 197839 */ GIM_Reject,
     /* 197840 */ // Label 4377: @197840
     /* 197840 */ GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(198007),
     /* 197845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 197848 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(197904), // Rule ID 2997 //
     /* 197853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197868 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197871 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197875 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197881 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197888 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBYrm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src)
     /* 197888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBYrm),
     /* 197891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197893 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 197897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197902 */     GIR_RootConstrainSelectedInstOperands,
     /* 197903 */     // GIR_Coverage, 2997,
     /* 197903 */     GIR_EraseRootFromParent_Done,
     /* 197904 */   // Label 4424: @197904
     /* 197904 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(197960), // Rule ID 13327 //
     /* 197909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 197920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 197924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 197927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 197931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 197935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 197937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 197944 */     // (abs:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 197944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rm),
     /* 197947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197949 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 197953 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 197958 */     GIR_RootConstrainSelectedInstOperands,
     /* 197959 */     // GIR_Coverage, 13327,
     /* 197959 */     GIR_EraseRootFromParent_Done,
     /* 197960 */   // Label 4425: @197960
     /* 197960 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(197983), // Rule ID 2996 //
     /* 197965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX2_NoVLX_Or_NoBWI),
     /* 197968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 197976 */     // (abs:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)  =>  (VPABSBYrr:{ *:[v32i8] } VR256:{ *:[v32i8] }:$src)
     /* 197976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBYrr),
     /* 197981 */     GIR_RootConstrainSelectedInstOperands,
     /* 197982 */     // GIR_Coverage, 2996,
     /* 197982 */     GIR_Done,
     /* 197983 */   // Label 4426: @197983
     /* 197983 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(198006), // Rule ID 13324 //
     /* 197988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI_HasVLX),
     /* 197991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 197999 */     // (abs:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPABSBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 197999 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZ256rr),
     /* 198004 */     GIR_RootConstrainSelectedInstOperands,
     /* 198005 */     // GIR_Coverage, 13324,
     /* 198005 */     GIR_Done,
     /* 198006 */   // Label 4427: @198006
     /* 198006 */   GIM_Reject,
     /* 198007 */ // Label 4423: @198007
     /* 198007 */ GIM_Reject,
     /* 198008 */ // Label 4378: @198008
     /* 198008 */ GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(198092),
     /* 198013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 198016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198020 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(198072), // Rule ID 13303 //
     /* 198025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198056 */     // (abs:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 198056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSWZrm),
     /* 198059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198061 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198070 */     GIR_RootConstrainSelectedInstOperands,
     /* 198071 */     // GIR_Coverage, 13303,
     /* 198071 */     GIR_EraseRootFromParent_Done,
     /* 198072 */   // Label 4429: @198072
     /* 198072 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(198091), // Rule ID 13300 //
     /* 198077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198084 */     // (abs:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPABSWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 198084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSWZrr),
     /* 198089 */     GIR_RootConstrainSelectedInstOperands,
     /* 198090 */     // GIR_Coverage, 13300,
     /* 198090 */     GIR_Done,
     /* 198091 */   // Label 4430: @198091
     /* 198091 */   GIM_Reject,
     /* 198092 */ // Label 4428: @198092
     /* 198092 */ GIM_Reject,
     /* 198093 */ // Label 4379: @198093
     /* 198093 */ GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(198177),
     /* 198098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 198101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198105 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(198157), // Rule ID 13321 //
     /* 198110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 198117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 198121 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 198124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 198128 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 198132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 198134 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 198141 */     // (abs:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPABSBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 198141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPABSBZrm),
     /* 198144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198146 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 198150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 198155 */     GIR_RootConstrainSelectedInstOperands,
     /* 198156 */     // GIR_Coverage, 13321,
     /* 198156 */     GIR_EraseRootFromParent_Done,
     /* 198157 */   // Label 4432: @198157
     /* 198157 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(198176), // Rule ID 13318 //
     /* 198162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBWI),
     /* 198165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198169 */     // (abs:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPABSBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 198169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPABSBZrr),
     /* 198174 */     GIR_RootConstrainSelectedInstOperands,
     /* 198175 */     // GIR_Coverage, 13318,
     /* 198175 */     GIR_Done,
     /* 198176 */   // Label 4433: @198176
     /* 198176 */   GIM_Reject,
     /* 198177 */ // Label 4431: @198177
     /* 198177 */ GIM_Reject,
     /* 198178 */ // Label 4380: @198178
     /* 198178 */ GIM_Reject,
     /* 198179 */ // Label 59: @198179
     /* 198179 */ GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(198194), // Rule ID 630 //
     /* 198184 */   // MIs[0] dst
     /* 198184 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 198187 */   // (br (bb:{ *:[Other] }):$dst)  =>  (JMP_1 (bb:{ *:[Other] }):$dst)
     /* 198187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::JMP_1),
     /* 198192 */   GIR_RootConstrainSelectedInstOperands,
     /* 198193 */   // GIR_Coverage, 630,
     /* 198193 */   GIR_Done,
     /* 198194 */ // Label 4434: @198194
     /* 198194 */ GIM_Reject,
     /* 198195 */ // Label 60: @198195
     /* 198195 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(22), /*)*//*default:*//*Label 4449*/ GIMT_Encode4(201123),
     /* 198206 */ /*GILLT_s1*//*Label 4435*/ GIMT_Encode4(198294), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 198234 */ /*GILLT_v2s1*//*Label 4436*/ GIMT_Encode4(198535),
     /* 198238 */ /*GILLT_v2s64*//*Label 4437*/ GIMT_Encode4(198736),
     /* 198242 */ /*GILLT_v4s1*//*Label 4438*/ GIMT_Encode4(199217),
     /* 198246 */ /*GILLT_v4s32*//*Label 4439*/ GIMT_Encode4(199378),
     /* 198250 */ /*GILLT_v4s64*//*Label 4440*/ GIMT_Encode4(199859),
     /* 198254 */ /*GILLT_v8s1*//*Label 4441*/ GIMT_Encode4(199942),
     /* 198258 */ /*GILLT_v8s16*//*Label 4442*/ GIMT_Encode4(200063),
     /* 198262 */ /*GILLT_v8s32*//*Label 4443*/ GIMT_Encode4(200544), GIMT_Encode4(0),
     /* 198270 */ /*GILLT_v16s1*//*Label 4444*/ GIMT_Encode4(200627),
     /* 198274 */ /*GILLT_v16s8*//*Label 4445*/ GIMT_Encode4(200708),
     /* 198278 */ /*GILLT_v16s16*//*Label 4446*/ GIMT_Encode4(200949), GIMT_Encode4(0),
     /* 198286 */ /*GILLT_v32s1*//*Label 4447*/ GIMT_Encode4(201032),
     /* 198290 */ /*GILLT_v32s8*//*Label 4448*/ GIMT_Encode4(201073),
     /* 198294 */ // Label 4435: @198294
     /* 198294 */ GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(198334), // Rule ID 19602 //
     /* 198299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /* 198302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198310 */   // MIs[0] Operand 2
     /* 198310 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198321 */   // (extract_subvector:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK2:{ *:[v2i1] }:$src, VK1:{ *:[i32] })
     /* 198321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198326 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198328 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198333 */   // GIR_Coverage, 19602,
     /* 198333 */   GIR_EraseRootFromParent_Done,
     /* 198334 */ // Label 4450: @198334
     /* 198334 */ GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(198374), // Rule ID 19604 //
     /* 198339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198350 */   // MIs[0] Operand 2
     /* 198350 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198361 */   // (extract_subvector:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK4:{ *:[v4i1] }:$src, VK1:{ *:[i32] })
     /* 198361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198366 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198368 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198373 */   // GIR_Coverage, 19604,
     /* 198373 */   GIR_EraseRootFromParent_Done,
     /* 198374 */ // Label 4451: @198374
     /* 198374 */ GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(198414), // Rule ID 19606 //
     /* 198379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198390 */   // MIs[0] Operand 2
     /* 198390 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198401 */   // (extract_subvector:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK8:{ *:[v8i1] }:$src, VK1:{ *:[i32] })
     /* 198401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198406 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198413 */   // GIR_Coverage, 19606,
     /* 198413 */   GIR_EraseRootFromParent_Done,
     /* 198414 */ // Label 4452: @198414
     /* 198414 */ GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(198454), // Rule ID 19608 //
     /* 198419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198430 */   // MIs[0] Operand 2
     /* 198430 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198441 */   // (extract_subvector:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK16:{ *:[v16i1] }:$src, VK1:{ *:[i32] })
     /* 198441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198453 */   // GIR_Coverage, 19608,
     /* 198453 */   GIR_EraseRootFromParent_Done,
     /* 198454 */ // Label 4453: @198454
     /* 198454 */ GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(198494), // Rule ID 19610 //
     /* 198459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198470 */   // MIs[0] Operand 2
     /* 198470 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198481 */   // (extract_subvector:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK32:{ *:[v32i1] }:$src, VK1:{ *:[i32] })
     /* 198481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198486 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198493 */   // GIR_Coverage, 19610,
     /* 198493 */   GIR_EraseRootFromParent_Done,
     /* 198494 */ // Label 4454: @198494
     /* 198494 */ GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(198534), // Rule ID 19612 //
     /* 198499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK1RegClassID),
     /* 198506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198510 */   // MIs[0] Operand 2
     /* 198510 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198521 */   // (extract_subvector:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v1i1] } VK64:{ *:[v64i1] }:$src, VK1:{ *:[i32] })
     /* 198521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198526 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198528 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK1RegClassID),
     /* 198533 */   // GIR_Coverage, 19612,
     /* 198533 */   GIR_EraseRootFromParent_Done,
     /* 198534 */ // Label 4455: @198534
     /* 198534 */ GIM_Reject,
     /* 198535 */ // Label 4436: @198535
     /* 198535 */ GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(198575), // Rule ID 19614 //
     /* 198540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /* 198543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 198551 */   // MIs[0] Operand 2
     /* 198551 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198562 */   // (extract_subvector:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK4:{ *:[v4i1] }:$src, VK2:{ *:[i32] })
     /* 198562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198567 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198569 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198574 */   // GIR_Coverage, 19614,
     /* 198574 */   GIR_EraseRootFromParent_Done,
     /* 198575 */ // Label 4456: @198575
     /* 198575 */ GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(198615), // Rule ID 19616 //
     /* 198580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 198583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 198591 */   // MIs[0] Operand 2
     /* 198591 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198602 */   // (extract_subvector:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK8:{ *:[v8i1] }:$src, VK2:{ *:[i32] })
     /* 198602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198607 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198614 */   // GIR_Coverage, 19616,
     /* 198614 */   GIR_EraseRootFromParent_Done,
     /* 198615 */ // Label 4457: @198615
     /* 198615 */ GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(198655), // Rule ID 19618 //
     /* 198620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 198623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 198631 */   // MIs[0] Operand 2
     /* 198631 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198642 */   // (extract_subvector:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK16:{ *:[v16i1] }:$src, VK2:{ *:[i32] })
     /* 198642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198647 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198654 */   // GIR_Coverage, 19618,
     /* 198654 */   GIR_EraseRootFromParent_Done,
     /* 198655 */ // Label 4458: @198655
     /* 198655 */ GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(198695), // Rule ID 19620 //
     /* 198660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 198663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 198671 */   // MIs[0] Operand 2
     /* 198671 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198682 */   // (extract_subvector:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK32:{ *:[v32i1] }:$src, VK2:{ *:[i32] })
     /* 198682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198687 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198689 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198694 */   // GIR_Coverage, 19620,
     /* 198694 */   GIR_EraseRootFromParent_Done,
     /* 198695 */ // Label 4459: @198695
     /* 198695 */ GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(198735), // Rule ID 19622 //
     /* 198700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 198703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK2RegClassID),
     /* 198707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 198711 */   // MIs[0] Operand 2
     /* 198711 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 198722 */   // (extract_subvector:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } VK64:{ *:[v64i1] }:$src, VK2:{ *:[i32] })
     /* 198722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198727 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 198729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK2RegClassID),
     /* 198734 */   // GIR_Coverage, 19622,
     /* 198734 */   GIR_EraseRootFromParent_Done,
     /* 198735 */ // Label 4460: @198735
     /* 198735 */ GIM_Reject,
     /* 198736 */ // Label 4437: @198736
     /* 198736 */ GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(198807), // Rule ID 19053 //
     /* 198741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198755 */   // MIs[0] Operand 2
     /* 198755 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198766 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198778 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198784 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198789 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 198797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198799 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198805 */   GIR_RootConstrainSelectedInstOperands,
     /* 198806 */   // GIR_Coverage, 19053,
     /* 198806 */   GIR_EraseRootFromParent_Done,
     /* 198807 */ // Label 4461: @198807
     /* 198807 */ GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(198878), // Rule ID 19054 //
     /* 198812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 198815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 198822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198826 */   // MIs[0] Operand 2
     /* 198826 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198837 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198849 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 198868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198876 */   GIR_RootConstrainSelectedInstOperands,
     /* 198877 */   // GIR_Coverage, 19054,
     /* 198877 */   GIR_EraseRootFromParent_Done,
     /* 198878 */ // Label 4462: @198878
     /* 198878 */ GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(198949), // Rule ID 19060 //
     /* 198883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198897 */   // MIs[0] Operand 2
     /* 198897 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198908 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v2i64] } (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198920 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 198931 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 198936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 198939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 198944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198947 */   GIR_RootConstrainSelectedInstOperands,
     /* 198948 */   // GIR_Coverage, 19060,
     /* 198948 */   GIR_EraseRootFromParent_Done,
     /* 198949 */ // Label 4463: @198949
     /* 198949 */ GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(199020), // Rule ID 19061 //
     /* 198954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 198957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 198960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 198964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 198968 */   // MIs[0] Operand 2
     /* 198968 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 198979 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 2:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v2f64] } (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 198979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /* 198982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 198986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198991 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 198997 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 199010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199018 */   GIR_RootConstrainSelectedInstOperands,
     /* 199019 */   // GIR_Coverage, 19061,
     /* 199019 */   GIR_EraseRootFromParent_Done,
     /* 199020 */ // Label 4464: @199020
     /* 199020 */ GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(199069), // Rule ID 23007 //
     /* 199025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199036 */   // MIs[0] Operand 2
     /* 199036 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199047 */   // (extract_subvector:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR256:{ *:[v4i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199052 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199063 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199068 */   // GIR_Coverage, 23007,
     /* 199068 */   GIR_EraseRootFromParent_Done,
     /* 199069 */ // Label 4465: @199069
     /* 199069 */ GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(199118), // Rule ID 23010 //
     /* 199074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 199077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199085 */   // MIs[0] Operand 2
     /* 199085 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199096 */   // (extract_subvector:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR256:{ *:[v4f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199101 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199112 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199117 */   // GIR_Coverage, 23010,
     /* 199117 */   GIR_EraseRootFromParent_Done,
     /* 199118 */ // Label 4466: @199118
     /* 199118 */ GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(199167), // Rule ID 23028 //
     /* 199123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199134 */   // MIs[0] Operand 2
     /* 199134 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199145 */   // (extract_subvector:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2i64] } VR512:{ *:[v8i64] }:$src, sub_xmm:{ *:[i32] })
     /* 199145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199150 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199166 */   // GIR_Coverage, 23028,
     /* 199166 */   GIR_EraseRootFromParent_Done,
     /* 199167 */ // Label 4467: @199167
     /* 199167 */ GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(199216), // Rule ID 23031 //
     /* 199172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199183 */   // MIs[0] Operand 2
     /* 199183 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199194 */   // (extract_subvector:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v2f64] } VR512:{ *:[v8f64] }:$src, sub_xmm:{ *:[i32] })
     /* 199194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199199 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199210 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199215 */   // GIR_Coverage, 23031,
     /* 199215 */   GIR_EraseRootFromParent_Done,
     /* 199216 */ // Label 4468: @199216
     /* 199216 */ GIM_Reject,
     /* 199217 */ // Label 4438: @199217
     /* 199217 */ GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(199257), // Rule ID 19624 //
     /* 199222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /* 199225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199233 */   // MIs[0] Operand 2
     /* 199233 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199244 */   // (extract_subvector:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK8:{ *:[v8i1] }:$src, VK4:{ *:[i32] })
     /* 199244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199256 */   // GIR_Coverage, 19624,
     /* 199256 */   GIR_EraseRootFromParent_Done,
     /* 199257 */ // Label 4469: @199257
     /* 199257 */ GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(199297), // Rule ID 19626 //
     /* 199262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199273 */   // MIs[0] Operand 2
     /* 199273 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199284 */   // (extract_subvector:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK16:{ *:[v16i1] }:$src, VK4:{ *:[i32] })
     /* 199284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199289 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199296 */   // GIR_Coverage, 19626,
     /* 199296 */   GIR_EraseRootFromParent_Done,
     /* 199297 */ // Label 4470: @199297
     /* 199297 */ GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(199337), // Rule ID 19628 //
     /* 199302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199313 */   // MIs[0] Operand 2
     /* 199313 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199324 */   // (extract_subvector:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK32:{ *:[v32i1] }:$src, VK4:{ *:[i32] })
     /* 199324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199336 */   // GIR_Coverage, 19628,
     /* 199336 */   GIR_EraseRootFromParent_Done,
     /* 199337 */ // Label 4471: @199337
     /* 199337 */ GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(199377), // Rule ID 19630 //
     /* 199342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 199345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK4RegClassID),
     /* 199349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 199353 */   // MIs[0] Operand 2
     /* 199353 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199364 */   // (extract_subvector:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } VK64:{ *:[v64i1] }:$src, VK4:{ *:[i32] })
     /* 199364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199371 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK4RegClassID),
     /* 199376 */   // GIR_Coverage, 19630,
     /* 199376 */   GIR_EraseRootFromParent_Done,
     /* 199377 */ // Label 4472: @199377
     /* 199377 */ GIM_Reject,
     /* 199378 */ // Label 4439: @199378
     /* 199378 */ GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(199449), // Rule ID 19055 //
     /* 199383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199397 */   // MIs[0] Operand 2
     /* 199397 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199408 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199420 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 199439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199441 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199447 */   GIR_RootConstrainSelectedInstOperands,
     /* 199448 */   // GIR_Coverage, 19055,
     /* 199448 */   GIR_EraseRootFromParent_Done,
     /* 199449 */ // Label 4473: @199449
     /* 199449 */ GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(199520), // Rule ID 19056 //
     /* 199454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 199457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 199464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199468 */   // MIs[0] Operand 2
     /* 199468 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199479 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199491 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199502 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 199510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199518 */   GIR_RootConstrainSelectedInstOperands,
     /* 199519 */   // GIR_Coverage, 19056,
     /* 199519 */   GIR_EraseRootFromParent_Done,
     /* 199520 */ // Label 4474: @199520
     /* 199520 */ GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(199591), // Rule ID 19062 //
     /* 199525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199539 */   // MIs[0] Operand 2
     /* 199539 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199550 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v4i32] } (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199562 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 199581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199589 */   GIR_RootConstrainSelectedInstOperands,
     /* 199590 */   // GIR_Coverage, 19062,
     /* 199590 */   GIR_EraseRootFromParent_Done,
     /* 199591 */ // Label 4475: @199591
     /* 199591 */ GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(199662), // Rule ID 19063 //
     /* 199596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 199599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 199606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199610 */   // MIs[0] Operand 2
     /* 199610 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 199621 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 4:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 199621 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s32,
     /* 199624 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199628 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199633 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199639 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199644 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 199652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 199657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199660 */   GIR_RootConstrainSelectedInstOperands,
     /* 199661 */   // GIR_Coverage, 19063,
     /* 199661 */   GIR_EraseRootFromParent_Done,
     /* 199662 */ // Label 4476: @199662
     /* 199662 */ GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(199711), // Rule ID 23001 //
     /* 199667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199678 */   // MIs[0] Operand 2
     /* 199678 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199689 */   // (extract_subvector:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR256:{ *:[v8i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199694 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199700 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199710 */   // GIR_Coverage, 23001,
     /* 199710 */   GIR_EraseRootFromParent_Done,
     /* 199711 */ // Label 4477: @199711
     /* 199711 */ GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(199760), // Rule ID 23004 //
     /* 199716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 199719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 199723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 199727 */   // MIs[0] Operand 2
     /* 199727 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199738 */   // (extract_subvector:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR256:{ *:[v8f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199743 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 199754 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 199759 */   // GIR_Coverage, 23004,
     /* 199759 */   GIR_EraseRootFromParent_Done,
     /* 199760 */ // Label 4478: @199760
     /* 199760 */ GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(199809), // Rule ID 23022 //
     /* 199765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199776 */   // MIs[0] Operand 2
     /* 199776 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199787 */   // (extract_subvector:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i32] } VR512:{ *:[v16i32] }:$src, sub_xmm:{ *:[i32] })
     /* 199787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199792 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199803 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199808 */   // GIR_Coverage, 23022,
     /* 199808 */   GIR_EraseRootFromParent_Done,
     /* 199809 */ // Label 4479: @199809
     /* 199809 */ GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(199858), // Rule ID 23025 //
     /* 199814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 199817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 199821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199825 */   // MIs[0] Operand 2
     /* 199825 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199836 */   // (extract_subvector:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f32] } VR512:{ *:[v16f32] }:$src, sub_xmm:{ *:[i32] })
     /* 199836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199841 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 199847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 199852 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199857 */   // GIR_Coverage, 23025,
     /* 199857 */   GIR_EraseRootFromParent_Done,
     /* 199858 */ // Label 4480: @199858
     /* 199858 */ GIM_Reject,
     /* 199859 */ // Label 4440: @199859
     /* 199859 */ GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(199941),
     /* 199864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 199867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 199871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 199875 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199886 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(199913), // Rule ID 23049 //
     /* 199891 */     // (extract_subvector:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4i64] } VR512:{ *:[v8i64] }:$src, sub_ymm:{ *:[i32] })
     /* 199891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199896 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199912 */     // GIR_Coverage, 23049,
     /* 199912 */     GIR_EraseRootFromParent_Done,
     /* 199913 */   // Label 4482: @199913
     /* 199913 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(199940), // Rule ID 23052 //
     /* 199918 */     // (extract_subvector:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v4f64] } VR512:{ *:[v8f64] }:$src, sub_ymm:{ *:[i32] })
     /* 199918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199923 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 199929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 199934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 199939 */     // GIR_Coverage, 23052,
     /* 199939 */     GIR_EraseRootFromParent_Done,
     /* 199940 */   // Label 4483: @199940
     /* 199940 */   GIM_Reject,
     /* 199941 */ // Label 4481: @199941
     /* 199941 */ GIM_Reject,
     /* 199942 */ // Label 4441: @199942
     /* 199942 */ GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(199982), // Rule ID 19632 //
     /* 199947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /* 199950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 199958 */   // MIs[0] Operand 2
     /* 199958 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 199969 */   // (extract_subvector:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK16:{ *:[v16i1] }:$src, VK8:{ *:[i32] })
     /* 199969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 199972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199974 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 199976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 199981 */   // GIR_Coverage, 19632,
     /* 199981 */   GIR_EraseRootFromParent_Done,
     /* 199982 */ // Label 4484: @199982
     /* 199982 */ GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(200022), // Rule ID 19634 //
     /* 199987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 199990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 199994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 199998 */   // MIs[0] Operand 2
     /* 199998 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200009 */   // (extract_subvector:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK32:{ *:[v32i1] }:$src, VK8:{ *:[i32] })
     /* 200009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200014 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200016 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200021 */   // GIR_Coverage, 19634,
     /* 200021 */   GIR_EraseRootFromParent_Done,
     /* 200022 */ // Label 4485: @200022
     /* 200022 */ GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(200062), // Rule ID 19636 //
     /* 200027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK8RegClassID),
     /* 200034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200038 */   // MIs[0] Operand 2
     /* 200038 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200049 */   // (extract_subvector:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } VK64:{ *:[v64i1] }:$src, VK8:{ *:[i32] })
     /* 200049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK8RegClassID),
     /* 200061 */   // GIR_Coverage, 19636,
     /* 200061 */   GIR_EraseRootFromParent_Done,
     /* 200062 */ // Label 4486: @200062
     /* 200062 */ GIM_Reject,
     /* 200063 */ // Label 4442: @200063
     /* 200063 */ GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(200134), // Rule ID 19057 //
     /* 200068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200082 */   // MIs[0] Operand 2
     /* 200082 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200093 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200105 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200132 */   GIR_RootConstrainSelectedInstOperands,
     /* 200133 */   // GIR_Coverage, 19057,
     /* 200133 */   GIR_EraseRootFromParent_Done,
     /* 200134 */ // Label 4487: @200134
     /* 200134 */ GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(200205), // Rule ID 19058 //
     /* 200139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200153 */   // MIs[0] Operand 2
     /* 200153 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200164 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF128rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200176 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200182 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200187 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF128rri),
     /* 200195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200203 */   GIR_RootConstrainSelectedInstOperands,
     /* 200204 */   // GIR_Coverage, 19058,
     /* 200204 */   GIR_EraseRootFromParent_Done,
     /* 200205 */ // Label 4488: @200205
     /* 200205 */ GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(200276), // Rule ID 19064 //
     /* 200210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200224 */   // MIs[0] Operand 2
     /* 200224 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200235 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v8i16] } (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200247 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200274 */   GIR_RootConstrainSelectedInstOperands,
     /* 200275 */   // GIR_Coverage, 19064,
     /* 200275 */   GIR_EraseRootFromParent_Done,
     /* 200276 */ // Label 4489: @200276
     /* 200276 */ GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(200347), // Rule ID 19065 //
     /* 200281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200295 */   // MIs[0] Operand 2
     /* 200295 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 200306 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 8:{ *:[iPTR] })  =>  (VEXTRACTF32X4Z256rri:{ *:[v8f16] } (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s16,
     /* 200309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200318 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTF32X4Z256rri),
     /* 200337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200345 */   GIR_RootConstrainSelectedInstOperands,
     /* 200346 */   // GIR_Coverage, 19065,
     /* 200346 */   GIR_EraseRootFromParent_Done,
     /* 200347 */ // Label 4490: @200347
     /* 200347 */ GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(200396), // Rule ID 23013 //
     /* 200352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200363 */   // MIs[0] Operand 2
     /* 200363 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200374 */   // (extract_subvector:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR256:{ *:[v16i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200379 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200390 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200395 */   // GIR_Coverage, 23013,
     /* 200395 */   GIR_EraseRootFromParent_Done,
     /* 200396 */ // Label 4491: @200396
     /* 200396 */ GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(200445), // Rule ID 23019 //
     /* 200401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 200404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200412 */   // MIs[0] Operand 2
     /* 200412 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200423 */   // (extract_subvector:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR256:{ *:[v16f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200428 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200444 */   // GIR_Coverage, 23019,
     /* 200444 */   GIR_EraseRootFromParent_Done,
     /* 200445 */ // Label 4492: @200445
     /* 200445 */ GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(200494), // Rule ID 23034 //
     /* 200450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200461 */   // MIs[0] Operand 2
     /* 200461 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200472 */   // (extract_subvector:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i16] } VR512:{ *:[v32i16] }:$src, sub_xmm:{ *:[i32] })
     /* 200472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200477 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200493 */   // GIR_Coverage, 23034,
     /* 200493 */   GIR_EraseRootFromParent_Done,
     /* 200494 */ // Label 4493: @200494
     /* 200494 */ GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(200543), // Rule ID 23040 //
     /* 200499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200510 */   // MIs[0] Operand 2
     /* 200510 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200521 */   // (extract_subvector:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f16] } VR512:{ *:[v32f16] }:$src, sub_xmm:{ *:[i32] })
     /* 200521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200526 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200532 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200537 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200542 */   // GIR_Coverage, 23040,
     /* 200542 */   GIR_EraseRootFromParent_Done,
     /* 200543 */ // Label 4494: @200543
     /* 200543 */ GIM_Reject,
     /* 200544 */ // Label 4443: @200544
     /* 200544 */ GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(200626),
     /* 200549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 200552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200560 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200571 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(200598), // Rule ID 23043 //
     /* 200576 */     // (extract_subvector:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8i32] } VR512:{ *:[v16i32] }:$src, sub_ymm:{ *:[i32] })
     /* 200576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200581 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200597 */     // GIR_Coverage, 23043,
     /* 200597 */     GIR_EraseRootFromParent_Done,
     /* 200598 */   // Label 4496: @200598
     /* 200598 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(200625), // Rule ID 23046 //
     /* 200603 */     // (extract_subvector:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v8f32] } VR512:{ *:[v16f32] }:$src, sub_ymm:{ *:[i32] })
     /* 200603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200608 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200619 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200624 */     // GIR_Coverage, 23046,
     /* 200624 */     GIR_EraseRootFromParent_Done,
     /* 200625 */   // Label 4497: @200625
     /* 200625 */   GIM_Reject,
     /* 200626 */ // Label 4495: @200626
     /* 200626 */ GIM_Reject,
     /* 200627 */ // Label 4444: @200627
     /* 200627 */ GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(200667), // Rule ID 19638 //
     /* 200632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s1,
     /* 200635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 200643 */   // MIs[0] Operand 2
     /* 200643 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200654 */   // (extract_subvector:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK32:{ *:[v32i1] }:$src, VK16:{ *:[i32] })
     /* 200654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200659 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200661 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200666 */   // GIR_Coverage, 19638,
     /* 200666 */   GIR_EraseRootFromParent_Done,
     /* 200667 */ // Label 4498: @200667
     /* 200667 */ GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(200707), // Rule ID 19640 //
     /* 200672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 200675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK16RegClassID),
     /* 200679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 200683 */   // MIs[0] Operand 2
     /* 200683 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200694 */   // (extract_subvector:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } VK64:{ *:[v64i1] }:$src, VK16:{ *:[i32] })
     /* 200694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 200701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK16RegClassID),
     /* 200706 */   // GIR_Coverage, 19640,
     /* 200706 */   GIR_EraseRootFromParent_Done,
     /* 200707 */ // Label 4499: @200707
     /* 200707 */ GIM_Reject,
     /* 200708 */ // Label 4445: @200708
     /* 200708 */ GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(200779), // Rule ID 19059 //
     /* 200713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_NoVLX),
     /* 200716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 200723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200727 */   // MIs[0] Operand 2
     /* 200727 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200738 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI128rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200750 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI128rri),
     /* 200769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200777 */   GIR_RootConstrainSelectedInstOperands,
     /* 200778 */   // GIR_Coverage, 19059,
     /* 200778 */   GIR_EraseRootFromParent_Done,
     /* 200779 */ // Label 4500: @200779
     /* 200779 */ GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(200850), // Rule ID 19066 //
     /* 200784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 200787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 200794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200798 */   // MIs[0] Operand 2
     /* 200798 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 200809 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 16:{ *:[iPTR] })  =>  (VEXTRACTI32X4Z256rri:{ *:[v16i8] } (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] }), 1:{ *:[i8] })
     /* 200809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v32s8,
     /* 200812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200821 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200832 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VEXTRACTI32X4Z256rri),
     /* 200840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200842 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200848 */   GIR_RootConstrainSelectedInstOperands,
     /* 200849 */   // GIR_Coverage, 19066,
     /* 200849 */   GIR_EraseRootFromParent_Done,
     /* 200850 */ // Label 4501: @200850
     /* 200850 */ GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(200899), // Rule ID 23016 //
     /* 200855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 200858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16RegClassID),
     /* 200862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 200866 */   // MIs[0] Operand 2
     /* 200866 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200877 */   // (extract_subvector:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR256:{ *:[v32i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200882 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16RegClassID),
     /* 200893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR256RegClassID),
     /* 200898 */   // GIR_Coverage, 23016,
     /* 200898 */   GIR_EraseRootFromParent_Done,
     /* 200899 */ // Label 4502: @200899
     /* 200899 */ GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(200948), // Rule ID 23037 //
     /* 200904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 200907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 200911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200915 */   // MIs[0] Operand 2
     /* 200915 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200926 */   // (extract_subvector:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i8] } VR512:{ *:[v64i8] }:$src, sub_xmm:{ *:[i32] })
     /* 200926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200931 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(11), // src
     /* 200937 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 200942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 200947 */   // GIR_Coverage, 23037,
     /* 200947 */   GIR_EraseRootFromParent_Done,
     /* 200948 */ // Label 4503: @200948
     /* 200948 */ GIM_Reject,
     /* 200949 */ // Label 4446: @200949
     /* 200949 */ GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(201031),
     /* 200954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 200957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 200961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 200965 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 200976 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(201003), // Rule ID 23055 //
     /* 200981 */     // (extract_subvector:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16i16] } VR512:{ *:[v32i16] }:$src, sub_ymm:{ *:[i32] })
     /* 200981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 200984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200986 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 200992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 200997 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201002 */     // GIR_Coverage, 23055,
     /* 201002 */     GIR_EraseRootFromParent_Done,
     /* 201003 */   // Label 4505: @201003
     /* 201003 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(201030), // Rule ID 23061 //
     /* 201008 */     // (extract_subvector:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v16f16] } VR512:{ *:[v32f16] }:$src, sub_ymm:{ *:[i32] })
     /* 201008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201013 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 201019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201029 */     // GIR_Coverage, 23061,
     /* 201029 */     GIR_EraseRootFromParent_Done,
     /* 201030 */   // Label 4506: @201030
     /* 201030 */   GIM_Reject,
     /* 201031 */ // Label 4504: @201031
     /* 201031 */ GIM_Reject,
     /* 201032 */ // Label 4447: @201032
     /* 201032 */ GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(201072), // Rule ID 19642 //
     /* 201037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s1,
     /* 201040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VK32RegClassID),
     /* 201044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VK64RegClassID),
     /* 201048 */   // MIs[0] Operand 2
     /* 201048 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201059 */   // (extract_subvector:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, 0:{ *:[iPTR] })  =>  (COPY_TO_REGCLASS:{ *:[v32i1] } VK64:{ *:[v64i1] }:$src, VK32:{ *:[i32] })
     /* 201059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201064 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VK32RegClassID),
     /* 201071 */   // GIR_Coverage, 19642,
     /* 201071 */   GIR_EraseRootFromParent_Done,
     /* 201072 */ // Label 4507: @201072
     /* 201072 */ GIM_Reject,
     /* 201073 */ // Label 4448: @201073
     /* 201073 */ GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(201122), // Rule ID 23058 //
     /* 201078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 201081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 201089 */   // MIs[0] Operand 2
     /* 201089 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 201100 */   // (extract_subvector:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, 0:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[v32i8] } VR512:{ *:[v64i8] }:$src, sub_ymm:{ *:[i32] })
     /* 201100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 201103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201105 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(12), // src
     /* 201111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 201116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 201121 */   // GIR_Coverage, 23058,
     /* 201121 */   GIR_EraseRootFromParent_Done,
     /* 201122 */ // Label 4508: @201122
     /* 201122 */ GIM_Reject,
     /* 201123 */ // Label 4449: @201123
     /* 201123 */ GIM_Reject,
     /* 201124 */ // Label 61: @201124
     /* 201124 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(25), /*)*//*default:*//*Label 4521*/ GIMT_Encode4(203105),
     /* 201135 */ /*GILLT_v2s64*//*Label 4509*/ GIMT_Encode4(201203), GIMT_Encode4(0),
     /* 201143 */ /*GILLT_v4s32*//*Label 4510*/ GIMT_Encode4(201405),
     /* 201147 */ /*GILLT_v4s64*//*Label 4511*/ GIMT_Encode4(201607), GIMT_Encode4(0),
     /* 201155 */ /*GILLT_v8s16*//*Label 4512*/ GIMT_Encode4(201809),
     /* 201159 */ /*GILLT_v8s32*//*Label 4513*/ GIMT_Encode4(201924),
     /* 201163 */ /*GILLT_v8s64*//*Label 4514*/ GIMT_Encode4(202126), GIMT_Encode4(0),
     /* 201171 */ /*GILLT_v16s8*//*Label 4515*/ GIMT_Encode4(202328),
     /* 201175 */ /*GILLT_v16s16*//*Label 4516*/ GIMT_Encode4(202443),
     /* 201179 */ /*GILLT_v16s32*//*Label 4517*/ GIMT_Encode4(202558), GIMT_Encode4(0),
     /* 201187 */ /*GILLT_v32s8*//*Label 4518*/ GIMT_Encode4(202760),
     /* 201191 */ /*GILLT_v32s16*//*Label 4519*/ GIMT_Encode4(202875), GIMT_Encode4(0),
     /* 201199 */ /*GILLT_v64s8*//*Label 4520*/ GIMT_Encode4(202990),
     /* 201203 */ // Label 4509: @201203
     /* 201203 */ GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(201404),
     /* 201208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 201211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /* 201214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 201217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201225 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK2WMRegClassID),
     /* 201229 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(201262), // Rule ID 21696 //
     /* 201234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201241 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201247 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201251 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2i64] })  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201256 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201258 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201260 */     GIR_RootConstrainSelectedInstOperands,
     /* 201261 */     // GIR_Coverage, 21696,
     /* 201261 */     GIR_EraseRootFromParent_Done,
     /* 201262 */   // Label 4523: @201262
     /* 201262 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(201295), // Rule ID 21732 //
     /* 201267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201284 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, immAllZerosV:{ *:[v2f64] })  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201289 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201293 */     GIR_RootConstrainSelectedInstOperands,
     /* 201294 */     // GIR_Coverage, 21732,
     /* 201294 */     GIR_EraseRootFromParent_Done,
     /* 201295 */   // Label 4524: @201295
     /* 201295 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(201324), // Rule ID 21695 //
     /* 201300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201313 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2i64] }))  =>  (VPCOMPRESSQZ128rrkz:{ *:[v2i64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrkz),
     /* 201316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201318 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201320 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201322 */     GIR_RootConstrainSelectedInstOperands,
     /* 201323 */     // GIR_Coverage, 21695,
     /* 201323 */     GIR_EraseRootFromParent_Done,
     /* 201324 */   // Label 4525: @201324
     /* 201324 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(201353), // Rule ID 21731 //
     /* 201329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201342 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, (undef:{ *:[v2f64] }))  =>  (VCOMPRESSPDZ128rrkz:{ *:[v2f64] } VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrkz),
     /* 201345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201347 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201349 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201351 */     GIR_RootConstrainSelectedInstOperands,
     /* 201352 */     // GIR_Coverage, 21731,
     /* 201352 */     GIR_EraseRootFromParent_Done,
     /* 201353 */   // Label 4526: @201353
     /* 201353 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(201378), // Rule ID 21697 //
     /* 201358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201365 */     // (vector_compress:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$passthru)  =>  (VPCOMPRESSQZ128rrk:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2i64] }:$src)
     /* 201365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ128rrk),
     /* 201368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201370 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201372 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201374 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201376 */     GIR_RootConstrainSelectedInstOperands,
     /* 201377 */     // GIR_Coverage, 21697,
     /* 201377 */     GIR_EraseRootFromParent_Done,
     /* 201378 */   // Label 4527: @201378
     /* 201378 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(201403), // Rule ID 21733 //
     /* 201383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201390 */     // (vector_compress:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$passthru)  =>  (VCOMPRESSPDZ128rrk:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$passthru, VK2WM:{ *:[v2i1] }:$mask, VR128X:{ *:[v2f64] }:$src)
     /* 201390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ128rrk),
     /* 201393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201395 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201397 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201399 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201401 */     GIR_RootConstrainSelectedInstOperands,
     /* 201402 */     // GIR_Coverage, 21733,
     /* 201402 */     GIR_EraseRootFromParent_Done,
     /* 201403 */   // Label 4528: @201403
     /* 201403 */   GIM_Reject,
     /* 201404 */ // Label 4522: @201404
     /* 201404 */ GIM_Reject,
     /* 201405 */ // Label 4510: @201405
     /* 201405 */ GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(201606),
     /* 201410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 201413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 201419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201431 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(201464), // Rule ID 21678 //
     /* 201436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201443 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201449 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201453 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i32] })  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201458 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201460 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201462 */     GIR_RootConstrainSelectedInstOperands,
     /* 201463 */     // GIR_Coverage, 21678,
     /* 201463 */     GIR_EraseRootFromParent_Done,
     /* 201464 */   // Label 4530: @201464
     /* 201464 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(201497), // Rule ID 21714 //
     /* 201469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201476 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201482 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201486 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f32] })  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201491 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201493 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201495 */     GIR_RootConstrainSelectedInstOperands,
     /* 201496 */     // GIR_Coverage, 21714,
     /* 201496 */     GIR_EraseRootFromParent_Done,
     /* 201497 */   // Label 4531: @201497
     /* 201497 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(201526), // Rule ID 21677 //
     /* 201502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201515 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i32] }))  =>  (VPCOMPRESSDZ128rrkz:{ *:[v4i32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrkz),
     /* 201518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201520 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201522 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201524 */     GIR_RootConstrainSelectedInstOperands,
     /* 201525 */     // GIR_Coverage, 21677,
     /* 201525 */     GIR_EraseRootFromParent_Done,
     /* 201526 */   // Label 4532: @201526
     /* 201526 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(201555), // Rule ID 21713 //
     /* 201531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201544 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f32] }))  =>  (VCOMPRESSPSZ128rrkz:{ *:[v4f32] } VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrkz),
     /* 201547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201549 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201551 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201553 */     GIR_RootConstrainSelectedInstOperands,
     /* 201554 */     // GIR_Coverage, 21713,
     /* 201554 */     GIR_EraseRootFromParent_Done,
     /* 201555 */   // Label 4533: @201555
     /* 201555 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(201580), // Rule ID 21679 //
     /* 201560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201567 */     // (vector_compress:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$passthru)  =>  (VPCOMPRESSDZ128rrk:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4i32] }:$src)
     /* 201567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ128rrk),
     /* 201570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 21679,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 4534: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(201605), // Rule ID 21715 //
     /* 201585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201592 */     // (vector_compress:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$passthru)  =>  (VCOMPRESSPSZ128rrk:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR128X:{ *:[v4f32] }:$src)
     /* 201592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ128rrk),
     /* 201595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201597 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201599 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201603 */     GIR_RootConstrainSelectedInstOperands,
     /* 201604 */     // GIR_Coverage, 21715,
     /* 201604 */     GIR_EraseRootFromParent_Done,
     /* 201605 */   // Label 4535: @201605
     /* 201605 */   GIM_Reject,
     /* 201606 */ // Label 4529: @201606
     /* 201606 */ GIM_Reject,
     /* 201607 */ // Label 4511: @201607
     /* 201607 */ GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(201808),
     /* 201612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 201615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /* 201618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 201621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK4WMRegClassID),
     /* 201633 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(201666), // Rule ID 21690 //
     /* 201638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201655 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4i64] })  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201660 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201662 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201664 */     GIR_RootConstrainSelectedInstOperands,
     /* 201665 */     // GIR_Coverage, 21690,
     /* 201665 */     GIR_EraseRootFromParent_Done,
     /* 201666 */   // Label 4537: @201666
     /* 201666 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(201699), // Rule ID 21726 //
     /* 201671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201678 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201684 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201688 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, immAllZerosV:{ *:[v4f64] })  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201693 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201695 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201697 */     GIR_RootConstrainSelectedInstOperands,
     /* 201698 */     // GIR_Coverage, 21726,
     /* 201698 */     GIR_EraseRootFromParent_Done,
     /* 201699 */   // Label 4538: @201699
     /* 201699 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(201728), // Rule ID 21689 //
     /* 201704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201717 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4i64] }))  =>  (VPCOMPRESSQZ256rrkz:{ *:[v4i64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrkz),
     /* 201720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201726 */     GIR_RootConstrainSelectedInstOperands,
     /* 201727 */     // GIR_Coverage, 21689,
     /* 201727 */     GIR_EraseRootFromParent_Done,
     /* 201728 */   // Label 4539: @201728
     /* 201728 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(201757), // Rule ID 21725 //
     /* 201733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201746 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, (undef:{ *:[v4f64] }))  =>  (VCOMPRESSPDZ256rrkz:{ *:[v4f64] } VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrkz),
     /* 201749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201751 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201753 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201755 */     GIR_RootConstrainSelectedInstOperands,
     /* 201756 */     // GIR_Coverage, 21725,
     /* 201756 */     GIR_EraseRootFromParent_Done,
     /* 201757 */   // Label 4540: @201757
     /* 201757 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(201782), // Rule ID 21691 //
     /* 201762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201769 */     // (vector_compress:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$passthru)  =>  (VPCOMPRESSQZ256rrk:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4i64] }:$src)
     /* 201769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZ256rrk),
     /* 201772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201774 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201776 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201778 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201780 */     GIR_RootConstrainSelectedInstOperands,
     /* 201781 */     // GIR_Coverage, 21691,
     /* 201781 */     GIR_EraseRootFromParent_Done,
     /* 201782 */   // Label 4541: @201782
     /* 201782 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(201807), // Rule ID 21727 //
     /* 201787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201794 */     // (vector_compress:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$passthru)  =>  (VCOMPRESSPDZ256rrk:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$passthru, VK4WM:{ *:[v4i1] }:$mask, VR256X:{ *:[v4f64] }:$src)
     /* 201794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZ256rrk),
     /* 201797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201799 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201801 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201803 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201805 */     GIR_RootConstrainSelectedInstOperands,
     /* 201806 */     // GIR_Coverage, 21727,
     /* 201806 */     GIR_EraseRootFromParent_Done,
     /* 201807 */   // Label 4542: @201807
     /* 201807 */   GIM_Reject,
     /* 201808 */ // Label 4536: @201808
     /* 201808 */ GIM_Reject,
     /* 201809 */ // Label 4512: @201809
     /* 201809 */ GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(201923),
     /* 201814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 201817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 201823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201835 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(201868), // Rule ID 22098 //
     /* 201840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201847 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201853 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201857 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i16] })  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201862 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201866 */     GIR_RootConstrainSelectedInstOperands,
     /* 201867 */     // GIR_Coverage, 22098,
     /* 201867 */     GIR_EraseRootFromParent_Done,
     /* 201868 */   // Label 4544: @201868
     /* 201868 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(201897), // Rule ID 22097 //
     /* 201873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 201884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201886 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i16] }))  =>  (VPCOMPRESSWZ128rrkz:{ *:[v8i16] } VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrkz),
     /* 201889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201893 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201895 */     GIR_RootConstrainSelectedInstOperands,
     /* 201896 */     // GIR_Coverage, 22097,
     /* 201896 */     GIR_EraseRootFromParent_Done,
     /* 201897 */   // Label 4545: @201897
     /* 201897 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(201922), // Rule ID 22099 //
     /* 201902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 201905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 201909 */     // (vector_compress:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$passthru)  =>  (VPCOMPRESSWZ128rrk:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR128X:{ *:[v8i16] }:$src)
     /* 201909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ128rrk),
     /* 201912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201914 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 201916 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201918 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201920 */     GIR_RootConstrainSelectedInstOperands,
     /* 201921 */     // GIR_Coverage, 22099,
     /* 201921 */     GIR_EraseRootFromParent_Done,
     /* 201922 */   // Label 4546: @201922
     /* 201922 */   GIM_Reject,
     /* 201923 */ // Label 4543: @201923
     /* 201923 */ GIM_Reject,
     /* 201924 */ // Label 4513: @201924
     /* 201924 */ GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(202125),
     /* 201929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 201932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 201935 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 201938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 201946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 201950 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(201983), // Rule ID 21672 //
     /* 201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201962 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 201968 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 201970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 201972 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i32] })  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 201972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 201975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 201977 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 201981 */     GIR_RootConstrainSelectedInstOperands,
     /* 201982 */     // GIR_Coverage, 21672,
     /* 201982 */     GIR_EraseRootFromParent_Done,
     /* 201983 */   // Label 4548: @201983
     /* 201983 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(202016), // Rule ID 21708 //
     /* 201988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 201991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 201995 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202001 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202005 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f32] })  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 202008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202010 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202012 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202014 */     GIR_RootConstrainSelectedInstOperands,
     /* 202015 */     // GIR_Coverage, 21708,
     /* 202015 */     GIR_EraseRootFromParent_Done,
     /* 202016 */   // Label 4549: @202016
     /* 202016 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(202045), // Rule ID 21671 //
     /* 202021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202034 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i32] }))  =>  (VPCOMPRESSDZ256rrkz:{ *:[v8i32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrkz),
     /* 202037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202039 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202041 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202043 */     GIR_RootConstrainSelectedInstOperands,
     /* 202044 */     // GIR_Coverage, 21671,
     /* 202044 */     GIR_EraseRootFromParent_Done,
     /* 202045 */   // Label 4550: @202045
     /* 202045 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(202074), // Rule ID 21707 //
     /* 202050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202063 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f32] }))  =>  (VCOMPRESSPSZ256rrkz:{ *:[v8f32] } VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrkz),
     /* 202066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202068 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202070 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202072 */     GIR_RootConstrainSelectedInstOperands,
     /* 202073 */     // GIR_Coverage, 21707,
     /* 202073 */     GIR_EraseRootFromParent_Done,
     /* 202074 */   // Label 4551: @202074
     /* 202074 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(202099), // Rule ID 21673 //
     /* 202079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202086 */     // (vector_compress:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$passthru)  =>  (VPCOMPRESSDZ256rrk:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8i32] }:$src)
     /* 202086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZ256rrk),
     /* 202089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202091 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202093 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202095 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202097 */     GIR_RootConstrainSelectedInstOperands,
     /* 202098 */     // GIR_Coverage, 21673,
     /* 202098 */     GIR_EraseRootFromParent_Done,
     /* 202099 */   // Label 4552: @202099
     /* 202099 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(202124), // Rule ID 21709 //
     /* 202104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 202107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202111 */     // (vector_compress:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$passthru)  =>  (VCOMPRESSPSZ256rrk:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR256X:{ *:[v8f32] }:$src)
     /* 202111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZ256rrk),
     /* 202114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202116 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202118 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202120 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202122 */     GIR_RootConstrainSelectedInstOperands,
     /* 202123 */     // GIR_Coverage, 21709,
     /* 202123 */     GIR_EraseRootFromParent_Done,
     /* 202124 */   // Label 4553: @202124
     /* 202124 */   GIM_Reject,
     /* 202125 */ // Label 4547: @202125
     /* 202125 */ GIM_Reject,
     /* 202126 */ // Label 4514: @202126
     /* 202126 */ GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(202327),
     /* 202131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 202134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /* 202137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 202140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK8WMRegClassID),
     /* 202152 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(202185), // Rule ID 21684 //
     /* 202157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202164 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202170 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202174 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8i64] })  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202179 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202183 */     GIR_RootConstrainSelectedInstOperands,
     /* 202184 */     // GIR_Coverage, 21684,
     /* 202184 */     GIR_EraseRootFromParent_Done,
     /* 202185 */   // Label 4555: @202185
     /* 202185 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(202218), // Rule ID 21720 //
     /* 202190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202197 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202207 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, immAllZerosV:{ *:[v8f64] })  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202212 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202216 */     GIR_RootConstrainSelectedInstOperands,
     /* 202217 */     // GIR_Coverage, 21720,
     /* 202217 */     GIR_EraseRootFromParent_Done,
     /* 202218 */   // Label 4556: @202218
     /* 202218 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(202247), // Rule ID 21683 //
     /* 202223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202236 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8i64] }))  =>  (VPCOMPRESSQZrrkz:{ *:[v8i64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrkz),
     /* 202239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202241 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202243 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202245 */     GIR_RootConstrainSelectedInstOperands,
     /* 202246 */     // GIR_Coverage, 21683,
     /* 202246 */     GIR_EraseRootFromParent_Done,
     /* 202247 */   // Label 4557: @202247
     /* 202247 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(202276), // Rule ID 21719 //
     /* 202252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202265 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, (undef:{ *:[v8f64] }))  =>  (VCOMPRESSPDZrrkz:{ *:[v8f64] } VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrkz),
     /* 202268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202270 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202272 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202274 */     GIR_RootConstrainSelectedInstOperands,
     /* 202275 */     // GIR_Coverage, 21719,
     /* 202275 */     GIR_EraseRootFromParent_Done,
     /* 202276 */   // Label 4558: @202276
     /* 202276 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(202301), // Rule ID 21685 //
     /* 202281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202288 */     // (vector_compress:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$passthru)  =>  (VPCOMPRESSQZrrk:{ *:[v8i64] } VR512:{ *:[v8i64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8i64] }:$src)
     /* 202288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSQZrrk),
     /* 202291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202293 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202295 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202297 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202299 */     GIR_RootConstrainSelectedInstOperands,
     /* 202300 */     // GIR_Coverage, 21685,
     /* 202300 */     GIR_EraseRootFromParent_Done,
     /* 202301 */   // Label 4559: @202301
     /* 202301 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(202326), // Rule ID 21721 //
     /* 202306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202313 */     // (vector_compress:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$passthru)  =>  (VCOMPRESSPDZrrk:{ *:[v8f64] } VR512:{ *:[v8f64] }:$passthru, VK8WM:{ *:[v8i1] }:$mask, VR512:{ *:[v8f64] }:$src)
     /* 202313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPDZrrk),
     /* 202316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202318 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202320 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202322 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202324 */     GIR_RootConstrainSelectedInstOperands,
     /* 202325 */     // GIR_Coverage, 21721,
     /* 202325 */     GIR_EraseRootFromParent_Done,
     /* 202326 */   // Label 4560: @202326
     /* 202326 */   GIM_Reject,
     /* 202327 */ // Label 4554: @202327
     /* 202327 */ GIM_Reject,
     /* 202328 */ // Label 4515: @202328
     /* 202328 */ GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(202442),
     /* 202333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 202336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 202342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202354 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(202387), // Rule ID 22080 //
     /* 202359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202366 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202372 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202376 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i8] })  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202381 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202385 */     GIR_RootConstrainSelectedInstOperands,
     /* 202386 */     // GIR_Coverage, 22080,
     /* 202386 */     GIR_EraseRootFromParent_Done,
     /* 202387 */   // Label 4562: @202387
     /* 202387 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(202416), // Rule ID 22079 //
     /* 202392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202405 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i8] }))  =>  (VPCOMPRESSBZ128rrkz:{ *:[v16i8] } VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrkz),
     /* 202408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202410 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202414 */     GIR_RootConstrainSelectedInstOperands,
     /* 202415 */     // GIR_Coverage, 22079,
     /* 202415 */     GIR_EraseRootFromParent_Done,
     /* 202416 */   // Label 4563: @202416
     /* 202416 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(202441), // Rule ID 22081 //
     /* 202421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 202428 */     // (vector_compress:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$passthru)  =>  (VPCOMPRESSBZ128rrk:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR128X:{ *:[v16i8] }:$src)
     /* 202428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ128rrk),
     /* 202431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202433 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202435 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202437 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202439 */     GIR_RootConstrainSelectedInstOperands,
     /* 202440 */     // GIR_Coverage, 22081,
     /* 202440 */     GIR_EraseRootFromParent_Done,
     /* 202441 */   // Label 4564: @202441
     /* 202441 */   GIM_Reject,
     /* 202442 */ // Label 4561: @202442
     /* 202442 */ GIM_Reject,
     /* 202443 */ // Label 4516: @202443
     /* 202443 */ GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(202557),
     /* 202448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 202451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 202457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202469 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(202502), // Rule ID 22092 //
     /* 202474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202481 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202487 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202491 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i16] })  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202496 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202498 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202500 */     GIR_RootConstrainSelectedInstOperands,
     /* 202501 */     // GIR_Coverage, 22092,
     /* 202501 */     GIR_EraseRootFromParent_Done,
     /* 202502 */   // Label 4566: @202502
     /* 202502 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(202531), // Rule ID 22091 //
     /* 202507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202520 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i16] }))  =>  (VPCOMPRESSWZ256rrkz:{ *:[v16i16] } VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrkz),
     /* 202523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202525 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202527 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202529 */     GIR_RootConstrainSelectedInstOperands,
     /* 202530 */     // GIR_Coverage, 22091,
     /* 202530 */     GIR_EraseRootFromParent_Done,
     /* 202531 */   // Label 4567: @202531
     /* 202531 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(202556), // Rule ID 22093 //
     /* 202536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202543 */     // (vector_compress:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$passthru)  =>  (VPCOMPRESSWZ256rrk:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR256X:{ *:[v16i16] }:$src)
     /* 202543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZ256rrk),
     /* 202546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202548 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202550 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202552 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202554 */     GIR_RootConstrainSelectedInstOperands,
     /* 202555 */     // GIR_Coverage, 22093,
     /* 202555 */     GIR_EraseRootFromParent_Done,
     /* 202556 */   // Label 4568: @202556
     /* 202556 */   GIM_Reject,
     /* 202557 */ // Label 4565: @202557
     /* 202557 */ GIM_Reject,
     /* 202558 */ // Label 4517: @202558
     /* 202558 */ GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(202759),
     /* 202563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 202566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /* 202569 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 202572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK16WMRegClassID),
     /* 202584 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(202617), // Rule ID 21666 //
     /* 202589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202596 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202602 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202606 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16i32] })  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202611 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202615 */     GIR_RootConstrainSelectedInstOperands,
     /* 202616 */     // GIR_Coverage, 21666,
     /* 202616 */     GIR_EraseRootFromParent_Done,
     /* 202617 */   // Label 4570: @202617
     /* 202617 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(202650), // Rule ID 21702 //
     /* 202622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202639 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, immAllZerosV:{ *:[v16f32] })  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202644 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202648 */     GIR_RootConstrainSelectedInstOperands,
     /* 202649 */     // GIR_Coverage, 21702,
     /* 202649 */     GIR_EraseRootFromParent_Done,
     /* 202650 */   // Label 4571: @202650
     /* 202650 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(202679), // Rule ID 21665 //
     /* 202655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202668 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16i32] }))  =>  (VPCOMPRESSDZrrkz:{ *:[v16i32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrkz),
     /* 202671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202673 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202677 */     GIR_RootConstrainSelectedInstOperands,
     /* 202678 */     // GIR_Coverage, 21665,
     /* 202678 */     GIR_EraseRootFromParent_Done,
     /* 202679 */   // Label 4572: @202679
     /* 202679 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(202708), // Rule ID 21701 //
     /* 202684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202697 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, (undef:{ *:[v16f32] }))  =>  (VCOMPRESSPSZrrkz:{ *:[v16f32] } VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrkz),
     /* 202700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202702 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202704 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202706 */     GIR_RootConstrainSelectedInstOperands,
     /* 202707 */     // GIR_Coverage, 21701,
     /* 202707 */     GIR_EraseRootFromParent_Done,
     /* 202708 */   // Label 4573: @202708
     /* 202708 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(202733), // Rule ID 21667 //
     /* 202713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202720 */     // (vector_compress:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$passthru)  =>  (VPCOMPRESSDZrrk:{ *:[v16i32] } VR512:{ *:[v16i32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16i32] }:$src)
     /* 202720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSDZrrk),
     /* 202723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202725 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202727 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202729 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202731 */     GIR_RootConstrainSelectedInstOperands,
     /* 202732 */     // GIR_Coverage, 21667,
     /* 202732 */     GIR_EraseRootFromParent_Done,
     /* 202733 */   // Label 4574: @202733
     /* 202733 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(202758), // Rule ID 21703 //
     /* 202738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 202741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202745 */     // (vector_compress:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$passthru)  =>  (VCOMPRESSPSZrrk:{ *:[v16f32] } VR512:{ *:[v16f32] }:$passthru, VK16WM:{ *:[v16i1] }:$mask, VR512:{ *:[v16f32] }:$src)
     /* 202745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VCOMPRESSPSZrrk),
     /* 202748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202750 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202752 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202754 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202756 */     GIR_RootConstrainSelectedInstOperands,
     /* 202757 */     // GIR_Coverage, 21703,
     /* 202757 */     GIR_EraseRootFromParent_Done,
     /* 202758 */   // Label 4575: @202758
     /* 202758 */   GIM_Reject,
     /* 202759 */ // Label 4569: @202759
     /* 202759 */ GIM_Reject,
     /* 202760 */ // Label 4518: @202760
     /* 202760 */ GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(202874),
     /* 202765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 202768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s8,
     /* 202774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202786 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(202819), // Rule ID 22074 //
     /* 202791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202798 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202804 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202808 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i8] })  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202813 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202815 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202817 */     GIR_RootConstrainSelectedInstOperands,
     /* 202818 */     // GIR_Coverage, 22074,
     /* 202818 */     GIR_EraseRootFromParent_Done,
     /* 202819 */   // Label 4577: @202819
     /* 202819 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(202848), // Rule ID 22073 //
     /* 202824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202837 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i8] }))  =>  (VPCOMPRESSBZ256rrkz:{ *:[v32i8] } VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrkz),
     /* 202840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202842 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202844 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202846 */     GIR_RootConstrainSelectedInstOperands,
     /* 202847 */     // GIR_Coverage, 22073,
     /* 202847 */     GIR_EraseRootFromParent_Done,
     /* 202848 */   // Label 4578: @202848
     /* 202848 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(202873), // Rule ID 22075 //
     /* 202853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2_HasVLX),
     /* 202856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 202860 */     // (vector_compress:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$passthru)  =>  (VPCOMPRESSBZ256rrk:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR256X:{ *:[v32i8] }:$src)
     /* 202860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZ256rrk),
     /* 202863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202865 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202867 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202869 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202871 */     GIR_RootConstrainSelectedInstOperands,
     /* 202872 */     // GIR_Coverage, 22075,
     /* 202872 */     GIR_EraseRootFromParent_Done,
     /* 202873 */   // Label 4579: @202873
     /* 202873 */   GIM_Reject,
     /* 202874 */ // Label 4576: @202874
     /* 202874 */ GIM_Reject,
     /* 202875 */ // Label 4519: @202875
     /* 202875 */ GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(202989),
     /* 202880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 202883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s1,
     /* 202886 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 202889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK32WMRegClassID),
     /* 202901 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(202934), // Rule ID 22086 //
     /* 202906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 202919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 202921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202923 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, immAllZerosV:{ *:[v32i16] })  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202928 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202930 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202932 */     GIR_RootConstrainSelectedInstOperands,
     /* 202933 */     // GIR_Coverage, 22086,
     /* 202933 */     GIR_EraseRootFromParent_Done,
     /* 202934 */   // Label 4581: @202934
     /* 202934 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(202963), // Rule ID 22085 //
     /* 202939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 202946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 202950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 202952 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, (undef:{ *:[v32i16] }))  =>  (VPCOMPRESSWZrrkz:{ *:[v32i16] } VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrkz),
     /* 202955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202957 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202959 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202961 */     GIR_RootConstrainSelectedInstOperands,
     /* 202962 */     // GIR_Coverage, 22085,
     /* 202962 */     GIR_EraseRootFromParent_Done,
     /* 202963 */   // Label 4582: @202963
     /* 202963 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(202988), // Rule ID 22087 //
     /* 202968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 202971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 202975 */     // (vector_compress:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$passthru)  =>  (VPCOMPRESSWZrrk:{ *:[v32i16] } VR512:{ *:[v32i16] }:$passthru, VK32WM:{ *:[v32i1] }:$mask, VR512:{ *:[v32i16] }:$src)
     /* 202975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSWZrrk),
     /* 202978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202980 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 202982 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 202984 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 202986 */     GIR_RootConstrainSelectedInstOperands,
     /* 202987 */     // GIR_Coverage, 22087,
     /* 202987 */     GIR_EraseRootFromParent_Done,
     /* 202988 */   // Label 4583: @202988
     /* 202988 */   GIM_Reject,
     /* 202989 */ // Label 4580: @202989
     /* 202989 */ GIM_Reject,
     /* 202990 */ // Label 4520: @202990
     /* 202990 */ GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(203104),
     /* 202995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 202998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v64s1,
     /* 203001 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v64s8,
     /* 203004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VK64WMRegClassID),
     /* 203016 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(203049), // Rule ID 22068 //
     /* 203021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203028 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 203034 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 203036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203038 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, immAllZerosV:{ *:[v64i8] })  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203043 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203045 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203047 */     GIR_RootConstrainSelectedInstOperands,
     /* 203048 */     // GIR_Coverage, 22068,
     /* 203048 */     GIR_EraseRootFromParent_Done,
     /* 203049 */   // Label 4585: @203049
     /* 203049 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(203078), // Rule ID 22067 //
     /* 203054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 203061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 203065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203067 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, (undef:{ *:[v64i8] }))  =>  (VPCOMPRESSBZrrkz:{ *:[v64i8] } VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrkz),
     /* 203070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203072 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203074 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203076 */     GIR_RootConstrainSelectedInstOperands,
     /* 203077 */     // GIR_Coverage, 22067,
     /* 203077 */     GIR_EraseRootFromParent_Done,
     /* 203078 */   // Label 4586: @203078
     /* 203078 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(203103), // Rule ID 22069 //
     /* 203083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVBMI2),
     /* 203086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 203090 */     // (vector_compress:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$passthru)  =>  (VPCOMPRESSBZrrk:{ *:[v64i8] } VR512:{ *:[v64i8] }:$passthru, VK64WM:{ *:[v64i1] }:$mask, VR512:{ *:[v64i8] }:$src)
     /* 203090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPCOMPRESSBZrrk),
     /* 203093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203095 */     GIR_RootToRootCopy, /*OpIdx*/3, // passthru
     /* 203097 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 203099 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203101 */     GIR_RootConstrainSelectedInstOperands,
     /* 203102 */     // GIR_Coverage, 22069,
     /* 203102 */     GIR_EraseRootFromParent_Done,
     /* 203103 */   // Label 4587: @203103
     /* 203103 */   GIM_Reject,
     /* 203104 */ // Label 4584: @203104
     /* 203104 */ GIM_Reject,
     /* 203105 */ // Label 4521: @203105
     /* 203105 */ GIM_Reject,
     /* 203106 */ // Label 62: @203106
     /* 203106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4591*/ GIMT_Encode4(203411),
     /* 203117 */ /*GILLT_s16*//*Label 4588*/ GIMT_Encode4(203129),
     /* 203121 */ /*GILLT_s32*//*Label 4589*/ GIMT_Encode4(203223),
     /* 203125 */ /*GILLT_s64*//*Label 4590*/ GIMT_Encode4(203317),
     /* 203129 */ // Label 4588: @203129
     /* 203129 */ GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(203222),
     /* 203134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203141 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(203196), // Rule ID 77 //
     /* 203146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203157 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203164 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203170 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203177 */     // (cttz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (TZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT16rm),
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203182 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203186 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203189 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203194 */     GIR_RootConstrainSelectedInstOperands,
     /* 203195 */     // GIR_Coverage, 77,
     /* 203195 */     GIR_EraseRootFromParent_Done,
     /* 203196 */   // Label 4593: @203196
     /* 203196 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(203221), // Rule ID 76 //
     /* 203201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203208 */     // (cttz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (TZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT16rr),
     /* 203213 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203219 */     GIR_RootConstrainSelectedInstOperands,
     /* 203220 */     // GIR_Coverage, 76,
     /* 203220 */     GIR_Done,
     /* 203221 */   // Label 4594: @203221
     /* 203221 */   GIM_Reject,
     /* 203222 */ // Label 4592: @203222
     /* 203222 */ GIM_Reject,
     /* 203223 */ // Label 4589: @203223
     /* 203223 */ GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(203316),
     /* 203228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203235 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(203290), // Rule ID 79 //
     /* 203240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203251 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203254 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203258 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203271 */     // (cttz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (TZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT32rm),
     /* 203274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203276 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203288 */     GIR_RootConstrainSelectedInstOperands,
     /* 203289 */     // GIR_Coverage, 79,
     /* 203289 */     GIR_EraseRootFromParent_Done,
     /* 203290 */   // Label 4596: @203290
     /* 203290 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(203315), // Rule ID 78 //
     /* 203295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203302 */     // (cttz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (TZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 203302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT32rr),
     /* 203307 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203313 */     GIR_RootConstrainSelectedInstOperands,
     /* 203314 */     // GIR_Coverage, 78,
     /* 203314 */     GIR_Done,
     /* 203315 */   // Label 4597: @203315
     /* 203315 */   GIM_Reject,
     /* 203316 */ // Label 4595: @203316
     /* 203316 */ GIM_Reject,
     /* 203317 */ // Label 4590: @203317
     /* 203317 */ GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(203410),
     /* 203322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203329 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(203384), // Rule ID 81 //
     /* 203334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203345 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203348 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203358 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203365 */     // (cttz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (TZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::TZCNT64rm),
     /* 203368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203382 */     GIR_RootConstrainSelectedInstOperands,
     /* 203383 */     // GIR_Coverage, 81,
     /* 203383 */     GIR_EraseRootFromParent_Done,
     /* 203384 */   // Label 4599: @203384
     /* 203384 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(203409), // Rule ID 80 //
     /* 203389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBMI),
     /* 203392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203396 */     // (cttz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (TZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 203396 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TZCNT64rr),
     /* 203401 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203407 */     GIR_RootConstrainSelectedInstOperands,
     /* 203408 */     // GIR_Coverage, 80,
     /* 203408 */     GIR_Done,
     /* 203409 */   // Label 4600: @203409
     /* 203409 */   GIM_Reject,
     /* 203410 */ // Label 4598: @203410
     /* 203410 */ GIM_Reject,
     /* 203411 */ // Label 4591: @203411
     /* 203411 */ GIM_Reject,
     /* 203412 */ // Label 63: @203412
     /* 203412 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4604*/ GIMT_Encode4(203798),
     /* 203423 */ /*GILLT_s16*//*Label 4601*/ GIMT_Encode4(203435),
     /* 203427 */ /*GILLT_s32*//*Label 4602*/ GIMT_Encode4(203556),
     /* 203431 */ /*GILLT_s64*//*Label 4603*/ GIMT_Encode4(203677),
     /* 203435 */ // Label 4601: @203435
     /* 203435 */ GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(203555),
     /* 203440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203447 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(203516), // Rule ID 22985 //
     /* 203452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203463 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203467 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203473 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203480 */     // (cttz_zero_undef:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (BSF16rm:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), addr:{ *:[iPTR] }:$src)
     /* 203480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rm),
     /* 203497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203514 */     GIR_RootConstrainSelectedInstOperands,
     /* 203515 */     // GIR_Coverage, 22985,
     /* 203515 */     GIR_EraseRootFromParent_Done,
     /* 203516 */   // Label 4606: @203516
     /* 203516 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(203554), // Rule ID 22982 //
     /* 203521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203525 */     // (cttz_zero_undef:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (BSF16rr:{ *:[i16] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i16] }), GR16:{ *:[i16] }:$src)
     /* 203525 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 203528 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203532 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF16rr),
     /* 203542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203547 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203552 */     GIR_RootConstrainSelectedInstOperands,
     /* 203553 */     // GIR_Coverage, 22982,
     /* 203553 */     GIR_EraseRootFromParent_Done,
     /* 203554 */   // Label 4607: @203554
     /* 203554 */   GIM_Reject,
     /* 203555 */ // Label 4605: @203555
     /* 203555 */ GIM_Reject,
     /* 203556 */ // Label 4602: @203556
     /* 203556 */ GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(203676),
     /* 203561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203568 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(203637), // Rule ID 22986 //
     /* 203573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203581 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203588 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 203592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203601 */     // (cttz_zero_undef:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (BSF32rm:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), addr:{ *:[iPTR] }:$src)
     /* 203601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rm),
     /* 203618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203635 */     GIR_RootConstrainSelectedInstOperands,
     /* 203636 */     // GIR_Coverage, 22986,
     /* 203636 */     GIR_EraseRootFromParent_Done,
     /* 203637 */   // Label 4609: @203637
     /* 203637 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(203675), // Rule ID 22983 //
     /* 203642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203646 */     // (cttz_zero_undef:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSF32rr:{ *:[i32] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), GR32:{ *:[i32] }:$src)
     /* 203646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 203649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF32rr),
     /* 203663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203668 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203673 */     GIR_RootConstrainSelectedInstOperands,
     /* 203674 */     // GIR_Coverage, 22983,
     /* 203674 */     GIR_EraseRootFromParent_Done,
     /* 203675 */   // Label 4610: @203675
     /* 203675 */   GIM_Reject,
     /* 203676 */ // Label 4608: @203676
     /* 203676 */ GIM_Reject,
     /* 203677 */ // Label 4603: @203677
     /* 203677 */ GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(203797),
     /* 203682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 203685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203689 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(203758), // Rule ID 22987 //
     /* 203694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203702 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203705 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 203709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203722 */     // (cttz_zero_undef:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (BSF64rm:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), addr:{ *:[iPTR] }:$src)
     /* 203722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rm),
     /* 203739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 203748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203751 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203756 */     GIR_RootConstrainSelectedInstOperands,
     /* 203757 */     // GIR_Coverage, 22987,
     /* 203757 */     GIR_EraseRootFromParent_Done,
     /* 203758 */   // Label 4612: @203758
     /* 203758 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(203796), // Rule ID 22984 //
     /* 203763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 203767 */     // (cttz_zero_undef:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSF64rr:{ *:[i64] }:{ *:[i32] } (IMPLICIT_DEF:{ *:[i64] }), GR64:{ *:[i64] }:$src)
     /* 203767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 203770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 203781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::BSF64rr),
     /* 203784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 203789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 203791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203794 */     GIR_RootConstrainSelectedInstOperands,
     /* 203795 */     // GIR_Coverage, 22984,
     /* 203795 */     GIR_EraseRootFromParent_Done,
     /* 203796 */   // Label 4613: @203796
     /* 203796 */   GIM_Reject,
     /* 203797 */ // Label 4611: @203797
     /* 203797 */ GIM_Reject,
     /* 203798 */ // Label 4604: @203798
     /* 203798 */ GIM_Reject,
     /* 203799 */ // Label 64: @203799
     /* 203799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(20), /*)*//*default:*//*Label 4623*/ GIMT_Encode4(205102),
     /* 203810 */ /*GILLT_s16*//*Label 4614*/ GIMT_Encode4(203882),
     /* 203814 */ /*GILLT_s32*//*Label 4615*/ GIMT_Encode4(203976),
     /* 203818 */ /*GILLT_s64*//*Label 4616*/ GIMT_Encode4(204070), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203834 */ /*GILLT_v2s64*//*Label 4617*/ GIMT_Encode4(204164), GIMT_Encode4(0),
     /* 203842 */ /*GILLT_v4s32*//*Label 4618*/ GIMT_Encode4(204360),
     /* 203846 */ /*GILLT_v4s64*//*Label 4619*/ GIMT_Encode4(204556), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203858 */ /*GILLT_v8s32*//*Label 4620*/ GIMT_Encode4(204744),
     /* 203862 */ /*GILLT_v8s64*//*Label 4621*/ GIMT_Encode4(204932), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 203878 */ /*GILLT_v16s32*//*Label 4622*/ GIMT_Encode4(205017),
     /* 203882 */ // Label 4614: @203882
     /* 203882 */ GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(203975),
     /* 203887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 203890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203894 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(203949), // Rule ID 71 //
     /* 203899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 203906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 203910 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 203913 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 203917 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 203921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 203923 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 203930 */     // (ctlz:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (LZCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 203930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT16rm),
     /* 203933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203935 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 203939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 203942 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 203947 */     GIR_RootConstrainSelectedInstOperands,
     /* 203948 */     // GIR_Coverage, 71,
     /* 203948 */     GIR_EraseRootFromParent_Done,
     /* 203949 */   // Label 4625: @203949
     /* 203949 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(203974), // Rule ID 70 //
     /* 203954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 203961 */     // (ctlz:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (LZCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 203961 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT16rr),
     /* 203966 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 203972 */     GIR_RootConstrainSelectedInstOperands,
     /* 203973 */     // GIR_Coverage, 70,
     /* 203973 */     GIR_Done,
     /* 203974 */   // Label 4626: @203974
     /* 203974 */   GIM_Reject,
     /* 203975 */ // Label 4624: @203975
     /* 203975 */ GIM_Reject,
     /* 203976 */ // Label 4615: @203976
     /* 203976 */ GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(204069),
     /* 203981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 203984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 203988 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(204043), // Rule ID 73 //
     /* 203993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 203996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204007 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204011 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 204015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204024 */     // (ctlz:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (LZCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT32rm),
     /* 204027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204033 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204041 */     GIR_RootConstrainSelectedInstOperands,
     /* 204042 */     // GIR_Coverage, 73,
     /* 204042 */     GIR_EraseRootFromParent_Done,
     /* 204043 */   // Label 4628: @204043
     /* 204043 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(204068), // Rule ID 72 //
     /* 204048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 204055 */     // (ctlz:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (LZCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 204055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT32rr),
     /* 204060 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204066 */     GIR_RootConstrainSelectedInstOperands,
     /* 204067 */     // GIR_Coverage, 72,
     /* 204067 */     GIR_Done,
     /* 204068 */   // Label 4629: @204068
     /* 204068 */   GIM_Reject,
     /* 204069 */ // Label 4627: @204069
     /* 204069 */ GIM_Reject,
     /* 204070 */ // Label 4616: @204070
     /* 204070 */ GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(204163),
     /* 204075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 204078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204082 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(204137), // Rule ID 75 //
     /* 204087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204098 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204101 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204105 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204111 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204118 */     // (ctlz:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LZCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 204118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::LZCNT64rm),
     /* 204121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204123 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 204130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204135 */     GIR_RootConstrainSelectedInstOperands,
     /* 204136 */     // GIR_Coverage, 75,
     /* 204136 */     GIR_EraseRootFromParent_Done,
     /* 204137 */   // Label 4631: @204137
     /* 204137 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(204162), // Rule ID 74 //
     /* 204142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLZCNT),
     /* 204145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 204149 */     // (ctlz:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (LZCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 204149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::LZCNT64rr),
     /* 204154 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 204160 */     GIR_RootConstrainSelectedInstOperands,
     /* 204161 */     // GIR_Coverage, 74,
     /* 204161 */     GIR_Done,
     /* 204162 */   // Label 4632: @204162
     /* 204162 */   GIM_Reject,
     /* 204163 */ // Label 4630: @204163
     /* 204163 */ GIM_Reject,
     /* 204164 */ // Label 4617: @204164
     /* 204164 */ GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(204359),
     /* 204169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 204172 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(204228), // Rule ID 13357 //
     /* 204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204192 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204195 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204199 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204212 */     // (ctlz:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 204212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rm),
     /* 204215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204226 */     GIR_RootConstrainSelectedInstOperands,
     /* 204227 */     // GIR_Coverage, 13357,
     /* 204227 */     GIR_EraseRootFromParent_Done,
     /* 204228 */   // Label 4634: @204228
     /* 204228 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(204251), // Rule ID 13354 //
     /* 204233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204244 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPLZCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 204244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ128rr),
     /* 204249 */     GIR_RootConstrainSelectedInstOperands,
     /* 204250 */     // GIR_Coverage, 13354,
     /* 204250 */     GIR_Done,
     /* 204251 */   // Label 4635: @204251
     /* 204251 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(204358), // Rule ID 21826 //
     /* 204256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204267 */     // (ctlz:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204267 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204270 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204274 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204281 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204284 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204288 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204293 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204296 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204300 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204303 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204308 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204313 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204330 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204340 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204352 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204357 */     // GIR_Coverage, 21826,
     /* 204357 */     GIR_EraseRootFromParent_Done,
     /* 204358 */   // Label 4636: @204358
     /* 204358 */   GIM_Reject,
     /* 204359 */ // Label 4633: @204359
     /* 204359 */ GIM_Reject,
     /* 204360 */ // Label 4618: @204360
     /* 204360 */ GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(204555),
     /* 204365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204368 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(204424), // Rule ID 13384 //
     /* 204373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204388 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204391 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204395 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204401 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204408 */     // (ctlz:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 204408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rm),
     /* 204411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204413 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204422 */     GIR_RootConstrainSelectedInstOperands,
     /* 204423 */     // GIR_Coverage, 13384,
     /* 204423 */     GIR_EraseRootFromParent_Done,
     /* 204424 */   // Label 4638: @204424
     /* 204424 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(204447), // Rule ID 13381 //
     /* 204429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204440 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPLZCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 204440 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ128rr),
     /* 204445 */     GIR_RootConstrainSelectedInstOperands,
     /* 204446 */     // GIR_Coverage, 13381,
     /* 204446 */     GIR_Done,
     /* 204447 */   // Label 4639: @204447
     /* 204447 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(204554), // Rule ID 21828 //
     /* 204452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 204459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 204463 */     // (ctlz:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 204463 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204466 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204470 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204489 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204492 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204496 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 204499 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204504 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 204514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 204543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 204548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204553 */     // GIR_Coverage, 21828,
     /* 204553 */     GIR_EraseRootFromParent_Done,
     /* 204554 */   // Label 4640: @204554
     /* 204554 */   GIM_Reject,
     /* 204555 */ // Label 4637: @204555
     /* 204555 */ GIM_Reject,
     /* 204556 */ // Label 4619: @204556
     /* 204556 */ GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(204743),
     /* 204561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 204564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204568 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(204620), // Rule ID 13348 //
     /* 204573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204584 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204587 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204591 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204597 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204604 */     // (ctlz:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 204604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rm),
     /* 204607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204618 */     GIR_RootConstrainSelectedInstOperands,
     /* 204619 */     // GIR_Coverage, 13348,
     /* 204619 */     GIR_EraseRootFromParent_Done,
     /* 204620 */   // Label 4642: @204620
     /* 204620 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(204639), // Rule ID 13345 //
     /* 204625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204632 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPLZCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 204632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZ256rr),
     /* 204637 */     GIR_RootConstrainSelectedInstOperands,
     /* 204638 */     // GIR_Coverage, 13345,
     /* 204638 */     GIR_Done,
     /* 204639 */   // Label 4643: @204639
     /* 204639 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(204742), // Rule ID 21825 //
     /* 204644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204651 */     // (ctlz:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPLZCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204651 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 204654 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204658 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 204668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204677 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204680 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204684 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204697 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 204709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204714 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204724 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204741 */     // GIR_Coverage, 21825,
     /* 204741 */     GIR_EraseRootFromParent_Done,
     /* 204742 */   // Label 4644: @204742
     /* 204742 */   GIM_Reject,
     /* 204743 */ // Label 4641: @204743
     /* 204743 */ GIM_Reject,
     /* 204744 */ // Label 4620: @204744
     /* 204744 */ GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(204931),
     /* 204749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 204752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204756 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(204808), // Rule ID 13375 //
     /* 204761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204775 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204779 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204785 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204792 */     // (ctlz:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 204792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rm),
     /* 204795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204806 */     GIR_RootConstrainSelectedInstOperands,
     /* 204807 */     // GIR_Coverage, 13375,
     /* 204807 */     GIR_EraseRootFromParent_Done,
     /* 204808 */   // Label 4646: @204808
     /* 204808 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(204827), // Rule ID 13372 //
     /* 204813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasVLX),
     /* 204816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204820 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPLZCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 204820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZ256rr),
     /* 204825 */     GIR_RootConstrainSelectedInstOperands,
     /* 204826 */     // GIR_Coverage, 13372,
     /* 204826 */     GIR_Done,
     /* 204827 */   // Label 4647: @204827
     /* 204827 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(204930), // Rule ID 21827 //
     /* 204832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI_HasEVEX512_NoVLX),
     /* 204835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 204839 */     // (ctlz:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPLZCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 204839 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 204842 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204846 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 204853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 204856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204865 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 204868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 204872 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 204875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 204880 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204885 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 204893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 204897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 204905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 204907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 204910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 204919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 204924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 204929 */     // GIR_Coverage, 21827,
     /* 204929 */     GIR_EraseRootFromParent_Done,
     /* 204930 */   // Label 4648: @204930
     /* 204930 */   GIM_Reject,
     /* 204931 */ // Label 4645: @204931
     /* 204931 */ GIM_Reject,
     /* 204932 */ // Label 4621: @204932
     /* 204932 */ GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(205016),
     /* 204937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 204940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 204944 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(204996), // Rule ID 13339 //
     /* 204949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 204952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 204956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 204960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 204963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 204967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 204971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 204973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 204980 */     // (ctlz:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 204980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrm),
     /* 204983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204985 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 204989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 204994 */     GIR_RootConstrainSelectedInstOperands,
     /* 204995 */     // GIR_Coverage, 13339,
     /* 204995 */     GIR_EraseRootFromParent_Done,
     /* 204996 */   // Label 4650: @204996
     /* 204996 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(205015), // Rule ID 13336 //
     /* 205001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205008 */     // (ctlz:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPLZCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 205008 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTQZrr),
     /* 205013 */     GIR_RootConstrainSelectedInstOperands,
     /* 205014 */     // GIR_Coverage, 13336,
     /* 205014 */     GIR_Done,
     /* 205015 */   // Label 4651: @205015
     /* 205015 */   GIM_Reject,
     /* 205016 */ // Label 4649: @205016
     /* 205016 */ GIM_Reject,
     /* 205017 */ // Label 4622: @205017
     /* 205017 */ GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(205101),
     /* 205022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 205025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205029 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(205081), // Rule ID 13366 //
     /* 205034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205045 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205052 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205058 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205065 */     // (ctlz:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPLZCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 205065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrm),
     /* 205068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205070 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205079 */     GIR_RootConstrainSelectedInstOperands,
     /* 205080 */     // GIR_Coverage, 13366,
     /* 205080 */     GIR_EraseRootFromParent_Done,
     /* 205081 */   // Label 4653: @205081
     /* 205081 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(205100), // Rule ID 13363 //
     /* 205086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCDI),
     /* 205089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 205093 */     // (ctlz:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPLZCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 205093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPLZCNTDZrr),
     /* 205098 */     GIR_RootConstrainSelectedInstOperands,
     /* 205099 */     // GIR_Coverage, 13363,
     /* 205099 */     GIR_Done,
     /* 205100 */   // Label 4654: @205100
     /* 205100 */   GIM_Reject,
     /* 205101 */ // Label 4652: @205101
     /* 205101 */ GIM_Reject,
     /* 205102 */ // Label 4623: @205102
     /* 205102 */ GIM_Reject,
     /* 205103 */ // Label 65: @205103
     /* 205103 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(25), /*)*//*default:*//*Label 4670*/ GIMT_Encode4(207364),
     /* 205114 */ /*GILLT_s16*//*Label 4655*/ GIMT_Encode4(205206),
     /* 205118 */ /*GILLT_s32*//*Label 4656*/ GIMT_Encode4(205300),
     /* 205122 */ /*GILLT_s64*//*Label 4657*/ GIMT_Encode4(205394), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 205138 */ /*GILLT_v2s64*//*Label 4658*/ GIMT_Encode4(205488), GIMT_Encode4(0),
     /* 205146 */ /*GILLT_v4s32*//*Label 4659*/ GIMT_Encode4(205684),
     /* 205150 */ /*GILLT_v4s64*//*Label 4660*/ GIMT_Encode4(205880), GIMT_Encode4(0),
     /* 205158 */ /*GILLT_v8s16*//*Label 4661*/ GIMT_Encode4(206068),
     /* 205162 */ /*GILLT_v8s32*//*Label 4662*/ GIMT_Encode4(206264),
     /* 205166 */ /*GILLT_v8s64*//*Label 4663*/ GIMT_Encode4(206452), GIMT_Encode4(0),
     /* 205174 */ /*GILLT_v16s8*//*Label 4664*/ GIMT_Encode4(206537),
     /* 205178 */ /*GILLT_v16s16*//*Label 4665*/ GIMT_Encode4(206733),
     /* 205182 */ /*GILLT_v16s32*//*Label 4666*/ GIMT_Encode4(206921), GIMT_Encode4(0),
     /* 205190 */ /*GILLT_v32s8*//*Label 4667*/ GIMT_Encode4(207006),
     /* 205194 */ /*GILLT_v32s16*//*Label 4668*/ GIMT_Encode4(207194), GIMT_Encode4(0),
     /* 205202 */ /*GILLT_v64s8*//*Label 4669*/ GIMT_Encode4(207279),
     /* 205206 */ // Label 4655: @205206
     /* 205206 */ GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(205299),
     /* 205211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 205214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205218 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(205273), // Rule ID 3176 //
     /* 205223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205234 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205241 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 205245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205254 */     // (ctpop:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (POPCNT16rm:{ *:[i16] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT16rm),
     /* 205257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205259 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205271 */     GIR_RootConstrainSelectedInstOperands,
     /* 205272 */     // GIR_Coverage, 3176,
     /* 205272 */     GIR_EraseRootFromParent_Done,
     /* 205273 */   // Label 4672: @205273
     /* 205273 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(205298), // Rule ID 3175 //
     /* 205278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 205285 */     // (ctpop:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (POPCNT16rr:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src1)
     /* 205285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT16rr),
     /* 205290 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205296 */     GIR_RootConstrainSelectedInstOperands,
     /* 205297 */     // GIR_Coverage, 3175,
     /* 205297 */     GIR_Done,
     /* 205298 */   // Label 4673: @205298
     /* 205298 */   GIM_Reject,
     /* 205299 */ // Label 4671: @205299
     /* 205299 */ GIM_Reject,
     /* 205300 */ // Label 4656: @205300
     /* 205300 */ GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(205393),
     /* 205305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 205308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205312 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(205367), // Rule ID 3178 //
     /* 205317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205328 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205331 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205335 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 205339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205341 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205348 */     // (ctpop:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (POPCNT32rm:{ *:[i32] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT32rm),
     /* 205351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205365 */     GIR_RootConstrainSelectedInstOperands,
     /* 205366 */     // GIR_Coverage, 3178,
     /* 205366 */     GIR_EraseRootFromParent_Done,
     /* 205367 */   // Label 4675: @205367
     /* 205367 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(205392), // Rule ID 3177 //
     /* 205372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 205379 */     // (ctpop:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (POPCNT32rr:{ *:[i32] }:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 205379 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT32rr),
     /* 205384 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205390 */     GIR_RootConstrainSelectedInstOperands,
     /* 205391 */     // GIR_Coverage, 3177,
     /* 205391 */     GIR_Done,
     /* 205392 */   // Label 4676: @205392
     /* 205392 */   GIM_Reject,
     /* 205393 */ // Label 4674: @205393
     /* 205393 */ GIM_Reject,
     /* 205394 */ // Label 4657: @205394
     /* 205394 */ GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(205487),
     /* 205399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 205402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205406 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(205461), // Rule ID 3180 //
     /* 205411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205422 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205425 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205429 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205435 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205442 */     // (ctpop:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (POPCNT64rm:{ *:[i64] }:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 205442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::POPCNT64rm),
     /* 205445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 205454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205459 */     GIR_RootConstrainSelectedInstOperands,
     /* 205460 */     // GIR_Coverage, 3180,
     /* 205460 */     GIR_EraseRootFromParent_Done,
     /* 205461 */   // Label 4678: @205461
     /* 205461 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(205486), // Rule ID 3179 //
     /* 205466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPOPCNT),
     /* 205469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 205473 */     // (ctpop:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (POPCNT64rr:{ *:[i64] }:{ *:[i32] } GR64:{ *:[i64] }:$src1)
     /* 205473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::POPCNT64rr),
     /* 205478 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::EFLAGS), GIMT_Encode2(RegState::Dead),
     /* 205484 */     GIR_RootConstrainSelectedInstOperands,
     /* 205485 */     // GIR_Coverage, 3179,
     /* 205485 */     GIR_Done,
     /* 205486 */   // Label 4679: @205486
     /* 205486 */   GIM_Reject,
     /* 205487 */ // Label 4677: @205487
     /* 205487 */ GIM_Reject,
     /* 205488 */ // Label 4658: @205488
     /* 205488 */ GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(205683),
     /* 205493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 205496 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(205552), // Rule ID 13465 //
     /* 205501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205536 */     // (ctpop:{ *:[v2i64] } (ld:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ128rm:{ *:[v2i64] } addr:{ *:[iPTR] }:$src1)
     /* 205536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rm),
     /* 205539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205541 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205550 */     GIR_RootConstrainSelectedInstOperands,
     /* 205551 */     // GIR_Coverage, 13465,
     /* 205551 */     GIR_EraseRootFromParent_Done,
     /* 205552 */   // Label 4681: @205552
     /* 205552 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(205575), // Rule ID 13462 //
     /* 205557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205568 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (VPOPCNTQZ128rr:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)
     /* 205568 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ128rr),
     /* 205573 */     GIR_RootConstrainSelectedInstOperands,
     /* 205574 */     // GIR_Coverage, 13462,
     /* 205574 */     GIR_Done,
     /* 205575 */   // Label 4682: @205575
     /* 205575 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(205682), // Rule ID 21830 //
     /* 205580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205591 */     // (ctpop:{ *:[v2i64] } VR128X:{ *:[v2i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v2i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR128X:{ *:[v2i64] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205591 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205594 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205598 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205605 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205608 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205612 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205617 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205620 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205624 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205627 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205632 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205637 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 205649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205654 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205664 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205681 */     // GIR_Coverage, 21830,
     /* 205681 */     GIR_EraseRootFromParent_Done,
     /* 205682 */   // Label 4683: @205682
     /* 205682 */   GIM_Reject,
     /* 205683 */ // Label 4680: @205683
     /* 205683 */ GIM_Reject,
     /* 205684 */ // Label 4659: @205684
     /* 205684 */ GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(205879),
     /* 205689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 205692 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(205748), // Rule ID 13492 //
     /* 205697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205712 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205719 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205732 */     // (ctpop:{ *:[v4i32] } (ld:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ128rm:{ *:[v4i32] } addr:{ *:[iPTR] }:$src1)
     /* 205732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rm),
     /* 205735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205737 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205746 */     GIR_RootConstrainSelectedInstOperands,
     /* 205747 */     // GIR_Coverage, 13492,
     /* 205747 */     GIR_EraseRootFromParent_Done,
     /* 205748 */   // Label 4685: @205748
     /* 205748 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(205771), // Rule ID 13489 //
     /* 205753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205764 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (VPOPCNTDZ128rr:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)
     /* 205764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ128rr),
     /* 205769 */     GIR_RootConstrainSelectedInstOperands,
     /* 205770 */     // GIR_Coverage, 13489,
     /* 205770 */     GIR_Done,
     /* 205771 */   // Label 4686: @205771
     /* 205771 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(205878), // Rule ID 21832 //
     /* 205776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 205783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 205787 */     // (ctpop:{ *:[v4i32] } VR128X:{ *:[v4i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR128X:{ *:[v4i32] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 205787 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 205790 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205794 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205801 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 205804 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205808 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205813 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 205816 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 205820 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 205823 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 205828 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205833 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 205838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 205841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 205845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 205853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 205855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 205858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205860 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 205867 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 205872 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 205877 */     // GIR_Coverage, 21832,
     /* 205877 */     GIR_EraseRootFromParent_Done,
     /* 205878 */   // Label 4687: @205878
     /* 205878 */   GIM_Reject,
     /* 205879 */ // Label 4684: @205879
     /* 205879 */ GIM_Reject,
     /* 205880 */ // Label 4660: @205880
     /* 205880 */ GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(206067),
     /* 205885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 205888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205892 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(205944), // Rule ID 13456 //
     /* 205897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 205904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 205908 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 205911 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 205915 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 205919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 205921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 205928 */     // (ctpop:{ *:[v4i64] } (ld:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZ256rm:{ *:[v4i64] } addr:{ *:[iPTR] }:$src1)
     /* 205928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rm),
     /* 205931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 205933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 205937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 205942 */     GIR_RootConstrainSelectedInstOperands,
     /* 205943 */     // GIR_Coverage, 13456,
     /* 205943 */     GIR_EraseRootFromParent_Done,
     /* 205944 */   // Label 4689: @205944
     /* 205944 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(205963), // Rule ID 13453 //
     /* 205949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 205952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205956 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (VPOPCNTQZ256rr:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)
     /* 205956 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZ256rr),
     /* 205961 */     GIR_RootConstrainSelectedInstOperands,
     /* 205962 */     // GIR_Coverage, 13453,
     /* 205962 */     GIR_Done,
     /* 205963 */   // Label 4690: @205963
     /* 205963 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(206066), // Rule ID 21829 //
     /* 205968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 205971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 205975 */     // (ctpop:{ *:[v4i64] } VR256X:{ *:[v4i64] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v4i64] } (VPOPCNTQZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v8i64] } (IMPLICIT_DEF:{ *:[v8i64] }), VR256X:{ *:[v4i64] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 205975 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s64,
     /* 205978 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205982 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 205989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s64,
     /* 205992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206001 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206004 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206008 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206016 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206021 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206048 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206065 */     // GIR_Coverage, 21829,
     /* 206065 */     GIR_EraseRootFromParent_Done,
     /* 206066 */   // Label 4691: @206066
     /* 206066 */   GIM_Reject,
     /* 206067 */ // Label 4688: @206067
     /* 206067 */ GIM_Reject,
     /* 206068 */ // Label 4661: @206068
     /* 206068 */ GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(206263),
     /* 206073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 206076 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(206132), // Rule ID 14519 //
     /* 206081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206096 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206099 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206103 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206109 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206116 */     // (ctpop:{ *:[v8i16] } (ld:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ128rm:{ *:[v8i16] } addr:{ *:[iPTR] }:$src1)
     /* 206116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rm),
     /* 206119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206130 */     GIR_RootConstrainSelectedInstOperands,
     /* 206131 */     // GIR_Coverage, 14519,
     /* 206131 */     GIR_EraseRootFromParent_Done,
     /* 206132 */   // Label 4693: @206132
     /* 206132 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(206155), // Rule ID 14516 //
     /* 206137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206148 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (VPOPCNTWZ128rr:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)
     /* 206148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ128rr),
     /* 206153 */     GIR_RootConstrainSelectedInstOperands,
     /* 206154 */     // GIR_Coverage, 14516,
     /* 206154 */     GIR_Done,
     /* 206155 */   // Label 4694: @206155
     /* 206155 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(206262), // Rule ID 22139 //
     /* 206160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206171 */     // (ctpop:{ *:[v8i16] } VR128X:{ *:[v8i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR128X:{ *:[v8i16] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206171 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206174 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206178 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206197 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206200 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206204 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206244 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206261 */     // GIR_Coverage, 22139,
     /* 206261 */     GIR_EraseRootFromParent_Done,
     /* 206262 */   // Label 4695: @206262
     /* 206262 */   GIM_Reject,
     /* 206263 */ // Label 4692: @206263
     /* 206263 */ GIM_Reject,
     /* 206264 */ // Label 4662: @206264
     /* 206264 */ GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(206451),
     /* 206269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 206272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206276 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(206328), // Rule ID 13483 //
     /* 206281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206292 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206295 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206299 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206305 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206312 */     // (ctpop:{ *:[v8i32] } (ld:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZ256rm:{ *:[v8i32] } addr:{ *:[iPTR] }:$src1)
     /* 206312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rm),
     /* 206315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206317 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206326 */     GIR_RootConstrainSelectedInstOperands,
     /* 206327 */     // GIR_Coverage, 13483,
     /* 206327 */     GIR_EraseRootFromParent_Done,
     /* 206328 */   // Label 4697: @206328
     /* 206328 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(206347), // Rule ID 13480 //
     /* 206333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX_HasVPOPCNTDQ),
     /* 206336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206340 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (VPOPCNTDZ256rr:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)
     /* 206340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZ256rr),
     /* 206345 */     GIR_RootConstrainSelectedInstOperands,
     /* 206346 */     // GIR_Coverage, 13480,
     /* 206346 */     GIR_Done,
     /* 206347 */   // Label 4698: @206347
     /* 206347 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(206450), // Rule ID 21831 //
     /* 206352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEVEX512_HasVPOPCNTDQ_NoVLX),
     /* 206355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206359 */     // (ctpop:{ *:[v8i32] } VR256X:{ *:[v8i32] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v8i32] } (VPOPCNTDZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v16i32] } (IMPLICIT_DEF:{ *:[v16i32] }), VR256X:{ *:[v8i32] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s32,
     /* 206362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s32,
     /* 206376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 206417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206432 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206439 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206449 */     // GIR_Coverage, 21831,
     /* 206449 */     GIR_EraseRootFromParent_Done,
     /* 206450 */   // Label 4699: @206450
     /* 206450 */   GIM_Reject,
     /* 206451 */ // Label 4696: @206451
     /* 206451 */ GIM_Reject,
     /* 206452 */ // Label 4663: @206452
     /* 206452 */ GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(206536),
     /* 206457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 206460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206464 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(206516), // Rule ID 13447 //
     /* 206469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206480 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206483 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206487 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206493 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206500 */     // (ctpop:{ *:[v8i64] } (ld:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTQZrm:{ *:[v8i64] } addr:{ *:[iPTR] }:$src1)
     /* 206500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrm),
     /* 206503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206505 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206514 */     GIR_RootConstrainSelectedInstOperands,
     /* 206515 */     // GIR_Coverage, 13447,
     /* 206515 */     GIR_EraseRootFromParent_Done,
     /* 206516 */   // Label 4701: @206516
     /* 206516 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(206535), // Rule ID 13444 //
     /* 206521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206528 */     // (ctpop:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)  =>  (VPOPCNTQZrr:{ *:[v8i64] } VR512:{ *:[v8i64] }:$src1)
     /* 206528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTQZrr),
     /* 206533 */     GIR_RootConstrainSelectedInstOperands,
     /* 206534 */     // GIR_Coverage, 13444,
     /* 206534 */     GIR_Done,
     /* 206535 */   // Label 4702: @206535
     /* 206535 */   GIM_Reject,
     /* 206536 */ // Label 4700: @206536
     /* 206536 */ GIM_Reject,
     /* 206537 */ // Label 4664: @206537
     /* 206537 */ GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(206732),
     /* 206542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 206545 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(206601), // Rule ID 14501 //
     /* 206550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206565 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206572 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206578 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206585 */     // (ctpop:{ *:[v16i8] } (ld:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ128rm:{ *:[v16i8] } addr:{ *:[iPTR] }:$src1)
     /* 206585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rm),
     /* 206588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206590 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206599 */     GIR_RootConstrainSelectedInstOperands,
     /* 206600 */     // GIR_Coverage, 14501,
     /* 206600 */     GIR_EraseRootFromParent_Done,
     /* 206601 */   // Label 4704: @206601
     /* 206601 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(206624), // Rule ID 14498 //
     /* 206606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206617 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (VPOPCNTBZ128rr:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)
     /* 206617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ128rr),
     /* 206622 */     GIR_RootConstrainSelectedInstOperands,
     /* 206623 */     // GIR_Coverage, 14498,
     /* 206623 */     GIR_Done,
     /* 206624 */   // Label 4705: @206624
     /* 206624 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(206731), // Rule ID 22137 //
     /* 206629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 206636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 206640 */     // (ctpop:{ *:[v16i8] } VR128X:{ *:[v16i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR128X:{ *:[v16i8] }:$src1, sub_xmm:{ *:[i32] })), sub_xmm:{ *:[i32] })
     /* 206640 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 206643 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206647 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206654 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 206657 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206661 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206666 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206669 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206673 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/11,
     /* 206676 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR128XRegClassID),
     /* 206691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 206698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206703 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206713 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_xmm),
     /* 206720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::FR16XRegClassID),
     /* 206725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206730 */     // GIR_Coverage, 22137,
     /* 206730 */     GIR_EraseRootFromParent_Done,
     /* 206731 */   // Label 4706: @206731
     /* 206731 */   GIM_Reject,
     /* 206732 */ // Label 4703: @206732
     /* 206732 */ GIM_Reject,
     /* 206733 */ // Label 4665: @206733
     /* 206733 */ GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(206920),
     /* 206738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 206741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206745 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(206797), // Rule ID 14513 //
     /* 206750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206761 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206764 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206768 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206774 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206781 */     // (ctpop:{ *:[v16i16] } (ld:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZ256rm:{ *:[v16i16] } addr:{ *:[iPTR] }:$src1)
     /* 206781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rm),
     /* 206784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206786 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206795 */     GIR_RootConstrainSelectedInstOperands,
     /* 206796 */     // GIR_Coverage, 14513,
     /* 206796 */     GIR_EraseRootFromParent_Done,
     /* 206797 */   // Label 4708: @206797
     /* 206797 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(206816), // Rule ID 14510 //
     /* 206802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 206805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206809 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (VPOPCNTWZ256rr:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)
     /* 206809 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZ256rr),
     /* 206814 */     GIR_RootConstrainSelectedInstOperands,
     /* 206815 */     // GIR_Coverage, 14510,
     /* 206815 */     GIR_Done,
     /* 206816 */   // Label 4709: @206816
     /* 206816 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(206919), // Rule ID 22138 //
     /* 206821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 206824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 206828 */     // (ctpop:{ *:[v16i16] } VR256X:{ *:[v16i16] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v16i16] } (VPOPCNTWZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v32i16] } (IMPLICIT_DEF:{ *:[v32i16] }), VR256X:{ *:[v16i16] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 206828 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v32s16,
     /* 206831 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206835 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 206842 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v32s16,
     /* 206845 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206849 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206854 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 206857 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 206861 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 206864 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 206869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 206882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 206886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206891 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 206894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 206896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 206899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206901 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 206908 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 206913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 206918 */     // GIR_Coverage, 22138,
     /* 206918 */     GIR_EraseRootFromParent_Done,
     /* 206919 */   // Label 4710: @206919
     /* 206919 */   GIM_Reject,
     /* 206920 */ // Label 4707: @206920
     /* 206920 */ GIM_Reject,
     /* 206921 */ // Label 4666: @206921
     /* 206921 */ GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(207005),
     /* 206926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 206929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206933 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(206985), // Rule ID 13474 //
     /* 206938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 206945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 206949 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 206952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 206956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 206960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 206962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 206969 */     // (ctpop:{ *:[v16i32] } (ld:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTDZrm:{ *:[v16i32] } addr:{ *:[iPTR] }:$src1)
     /* 206969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrm),
     /* 206972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 206974 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 206978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 206983 */     GIR_RootConstrainSelectedInstOperands,
     /* 206984 */     // GIR_Coverage, 13474,
     /* 206984 */     GIR_EraseRootFromParent_Done,
     /* 206985 */   // Label 4712: @206985
     /* 206985 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(207004), // Rule ID 13471 //
     /* 206990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVPOPCNTDQ),
     /* 206993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 206997 */     // (ctpop:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)  =>  (VPOPCNTDZrr:{ *:[v16i32] } VR512:{ *:[v16i32] }:$src1)
     /* 206997 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTDZrr),
     /* 207002 */     GIR_RootConstrainSelectedInstOperands,
     /* 207003 */     // GIR_Coverage, 13471,
     /* 207003 */     GIR_Done,
     /* 207004 */   // Label 4713: @207004
     /* 207004 */   GIM_Reject,
     /* 207005 */ // Label 4711: @207005
     /* 207005 */ GIM_Reject,
     /* 207006 */ // Label 4667: @207006
     /* 207006 */ GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(207193),
     /* 207011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s8,
     /* 207014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207018 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(207070), // Rule ID 14495 //
     /* 207023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207034 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207037 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207041 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207054 */     // (ctpop:{ *:[v32i8] } (ld:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZ256rm:{ *:[v32i8] } addr:{ *:[iPTR] }:$src1)
     /* 207054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rm),
     /* 207057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207068 */     GIR_RootConstrainSelectedInstOperands,
     /* 207069 */     // GIR_Coverage, 14495,
     /* 207069 */     GIR_EraseRootFromParent_Done,
     /* 207070 */   // Label 4715: @207070
     /* 207070 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(207089), // Rule ID 14492 //
     /* 207075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasVLX),
     /* 207078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207082 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (VPOPCNTBZ256rr:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)
     /* 207082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZ256rr),
     /* 207087 */     GIR_RootConstrainSelectedInstOperands,
     /* 207088 */     // GIR_Coverage, 14492,
     /* 207088 */     GIR_Done,
     /* 207089 */   // Label 4716: @207089
     /* 207089 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(207192), // Rule ID 22136 //
     /* 207094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG_HasEVEX512_NoVLX),
     /* 207097 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 207101 */     // (ctpop:{ *:[v32i8] } VR256X:{ *:[v32i8] }:$src1)  =>  (EXTRACT_SUBREG:{ *:[v32i8] } (VPOPCNTBZrr:{ *:[v64i8] } (INSERT_SUBREG:{ *:[v64i8] } (IMPLICIT_DEF:{ *:[v64i8] }), VR256X:{ *:[v32i8] }:$src1, sub_ymm:{ *:[i32] })), sub_ymm:{ *:[i32] })
     /* 207101 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v64s8,
     /* 207104 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207108 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 207115 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v64s8,
     /* 207118 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207122 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207127 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 207130 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 207134 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/12,
     /* 207137 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(X86::VR512RegClassID),
     /* 207142 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v64s8,
     /* 207155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207164 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 207167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 207169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207174 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(X86::sub_ymm),
     /* 207181 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(X86::VR256XRegClassID),
     /* 207186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(X86::VR512RegClassID),
     /* 207191 */     // GIR_Coverage, 22136,
     /* 207191 */     GIR_EraseRootFromParent_Done,
     /* 207192 */   // Label 4717: @207192
     /* 207192 */   GIM_Reject,
     /* 207193 */ // Label 4714: @207193
     /* 207193 */ GIM_Reject,
     /* 207194 */ // Label 4668: @207194
     /* 207194 */ GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(207278),
     /* 207199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 207202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207206 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(207258), // Rule ID 14507 //
     /* 207211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207242 */     // (ctpop:{ *:[v32i16] } (ld:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTWZrm:{ *:[v32i16] } addr:{ *:[iPTR] }:$src1)
     /* 207242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrm),
     /* 207245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207247 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207256 */     GIR_RootConstrainSelectedInstOperands,
     /* 207257 */     // GIR_Coverage, 14507,
     /* 207257 */     GIR_EraseRootFromParent_Done,
     /* 207258 */   // Label 4719: @207258
     /* 207258 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(207277), // Rule ID 14504 //
     /* 207263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207270 */     // (ctpop:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)  =>  (VPOPCNTWZrr:{ *:[v32i16] } VR512:{ *:[v32i16] }:$src1)
     /* 207270 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTWZrr),
     /* 207275 */     GIR_RootConstrainSelectedInstOperands,
     /* 207276 */     // GIR_Coverage, 14504,
     /* 207276 */     GIR_Done,
     /* 207277 */   // Label 4720: @207277
     /* 207277 */   GIM_Reject,
     /* 207278 */ // Label 4718: @207278
     /* 207278 */ GIM_Reject,
     /* 207279 */ // Label 4669: @207279
     /* 207279 */ GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(207363),
     /* 207284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v64s8,
     /* 207287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207291 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(207343), // Rule ID 14489 //
     /* 207296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207307 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207310 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207314 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207327 */     // (ctpop:{ *:[v64i8] } (ld:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VPOPCNTBZrm:{ *:[v64i8] } addr:{ *:[iPTR] }:$src1)
     /* 207327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrm),
     /* 207330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207332 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207341 */     GIR_RootConstrainSelectedInstOperands,
     /* 207342 */     // GIR_Coverage, 14489,
     /* 207342 */     GIR_EraseRootFromParent_Done,
     /* 207343 */   // Label 4722: @207343
     /* 207343 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(207362), // Rule ID 14486 //
     /* 207348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBITALG),
     /* 207351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 207355 */     // (ctpop:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)  =>  (VPOPCNTBZrr:{ *:[v64i8] } VR512:{ *:[v64i8] }:$src1)
     /* 207355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VPOPCNTBZrr),
     /* 207360 */     GIR_RootConstrainSelectedInstOperands,
     /* 207361 */     // GIR_Coverage, 14486,
     /* 207361 */     GIR_Done,
     /* 207362 */   // Label 4723: @207362
     /* 207362 */   GIM_Reject,
     /* 207363 */ // Label 4721: @207363
     /* 207363 */ GIM_Reject,
     /* 207364 */ // Label 4670: @207364
     /* 207364 */ GIM_Reject,
     /* 207365 */ // Label 66: @207365
     /* 207365 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 4727*/ GIMT_Encode4(207864),
     /* 207376 */ /*GILLT_s16*//*Label 4724*/ GIMT_Encode4(207388),
     /* 207380 */ /*GILLT_s32*//*Label 4725*/ GIMT_Encode4(207552),
     /* 207384 */ /*GILLT_s64*//*Label 4726*/ GIMT_Encode4(207708),
     /* 207388 */ // Label 4724: @207388
     /* 207388 */ GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(207551),
     /* 207393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207400 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(207452), // Rule ID 49 //
     /* 207405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207419 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207423 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207436 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm),
     /* 207439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207441 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207450 */     GIR_RootConstrainSelectedInstOperands,
     /* 207451 */     // GIR_Coverage, 49,
     /* 207451 */     GIR_EraseRootFromParent_Done,
     /* 207452 */   // Label 4729: @207452
     /* 207452 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(207504), // Rule ID 55 //
     /* 207457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207468 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207471 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207475 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi16),
     /* 207479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207488 */     // (bswap:{ *:[i16] } (ld:{ *:[i16] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi16>>)  =>  (MOVBE16rm_EVEX:{ *:[i16] } addr:{ *:[iPTR] }:$src1)
     /* 207488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE16rm_EVEX),
     /* 207491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207493 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207497 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207502 */     GIR_RootConstrainSelectedInstOperands,
     /* 207503 */     // GIR_Coverage, 55,
     /* 207503 */     GIR_EraseRootFromParent_Done,
     /* 207504 */   // Label 4730: @207504
     /* 207504 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(207523), // Rule ID 61 //
     /* 207509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207516 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src1)  =>  (MOVBE16rr:{ *:[i16] } GR16:{ *:[i16] }:$src1)
     /* 207516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE16rr),
     /* 207521 */     GIR_RootConstrainSelectedInstOperands,
     /* 207522 */     // GIR_Coverage, 61,
     /* 207522 */     GIR_Done,
     /* 207523 */   // Label 4731: @207523
     /* 207523 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(207550), // Rule ID 22988 //
     /* 207528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE),
     /* 207531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR16RegClassID),
     /* 207535 */     // (bswap:{ *:[i16] } GR16:{ *:[i16] }:$src)  =>  (ROL16ri:{ *:[i16] }:{ *:[i32] } GR16:{ *:[i16] }:$src, 8:{ *:[i8] })
     /* 207535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ROL16ri),
     /* 207538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207540 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 207542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 207545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 207548 */     GIR_RootConstrainSelectedInstOperands,
     /* 207549 */     // GIR_Coverage, 22988,
     /* 207549 */     GIR_EraseRootFromParent_Done,
     /* 207550 */   // Label 4732: @207550
     /* 207550 */   GIM_Reject,
     /* 207551 */ // Label 4728: @207551
     /* 207551 */ GIM_Reject,
     /* 207552 */ // Label 4725: @207552
     /* 207552 */ GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(207707),
     /* 207557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 207560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207564 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(207616), // Rule ID 51 //
     /* 207569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207587 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207593 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207600 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm),
     /* 207603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207605 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207614 */     GIR_RootConstrainSelectedInstOperands,
     /* 207615 */     // GIR_Coverage, 51,
     /* 207615 */     GIR_EraseRootFromParent_Done,
     /* 207616 */   // Label 4734: @207616
     /* 207616 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(207668), // Rule ID 57 //
     /* 207621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207639 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_loadi32),
     /* 207643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207652 */     // (bswap:{ *:[i32] } (ld:{ *:[i32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_loadi32>>)  =>  (MOVBE32rm_EVEX:{ *:[i32] } addr:{ *:[iPTR] }:$src1)
     /* 207652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE32rm_EVEX),
     /* 207655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207657 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207661 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207666 */     GIR_RootConstrainSelectedInstOperands,
     /* 207667 */     // GIR_Coverage, 57,
     /* 207667 */     GIR_EraseRootFromParent_Done,
     /* 207668 */   // Label 4735: @207668
     /* 207668 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(207687), // Rule ID 5 //
     /* 207673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207680 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src)  =>  (BSWAP32r:{ *:[i32] } GR32:{ *:[i32] }:$src)
     /* 207680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP32r),
     /* 207685 */     GIR_RootConstrainSelectedInstOperands,
     /* 207686 */     // GIR_Coverage, 5,
     /* 207686 */     GIR_Done,
     /* 207687 */   // Label 4736: @207687
     /* 207687 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(207706), // Rule ID 62 //
     /* 207692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR32RegClassID),
     /* 207699 */     // (bswap:{ *:[i32] } GR32:{ *:[i32] }:$src1)  =>  (MOVBE32rr:{ *:[i32] } GR32:{ *:[i32] }:$src1)
     /* 207699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE32rr),
     /* 207704 */     GIR_RootConstrainSelectedInstOperands,
     /* 207705 */     // GIR_Coverage, 62,
     /* 207705 */     GIR_Done,
     /* 207706 */   // Label 4737: @207706
     /* 207706 */   GIM_Reject,
     /* 207707 */ // Label 4733: @207707
     /* 207707 */ GIM_Reject,
     /* 207708 */ // Label 4726: @207708
     /* 207708 */ GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(207863),
     /* 207713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 207716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207720 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(207772), // Rule ID 53 //
     /* 207725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_NoEGPR),
     /* 207728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207743 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207756 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm),
     /* 207759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207761 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207765 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207770 */     GIR_RootConstrainSelectedInstOperands,
     /* 207771 */     // GIR_Coverage, 53,
     /* 207771 */     GIR_EraseRootFromParent_Done,
     /* 207772 */   // Label 4739: @207772
     /* 207772 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(207824), // Rule ID 59 //
     /* 207777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasEGPR_HasMOVBE_In64BitMode),
     /* 207780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207788 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207791 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207795 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 207801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 207808 */     // (bswap:{ *:[i64] } (ld:{ *:[i64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MOVBE64rm_EVEX:{ *:[i64] } addr:{ *:[iPTR] }:$src1)
     /* 207808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MOVBE64rm_EVEX),
     /* 207811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 207813 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 207817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 207822 */     GIR_RootConstrainSelectedInstOperands,
     /* 207823 */     // GIR_Coverage, 59,
     /* 207823 */     GIR_EraseRootFromParent_Done,
     /* 207824 */   // Label 4740: @207824
     /* 207824 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(207843), // Rule ID 6 //
     /* 207829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoNDD_Or_NoMOVBE),
     /* 207832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207836 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src)  =>  (BSWAP64r:{ *:[i64] } GR64:{ *:[i64] }:$src)
     /* 207836 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::BSWAP64r),
     /* 207841 */     GIR_RootConstrainSelectedInstOperands,
     /* 207842 */     // GIR_Coverage, 6,
     /* 207842 */     GIR_Done,
     /* 207843 */   // Label 4741: @207843
     /* 207843 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(207862), // Rule ID 63 //
     /* 207848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMOVBE_HasNDD_In64BitMode),
     /* 207851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::GR64RegClassID),
     /* 207855 */     // (bswap:{ *:[i64] } GR64:{ *:[i64] }:$src1)  =>  (MOVBE64rr:{ *:[i64] } GR64:{ *:[i64] }:$src1)
     /* 207855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MOVBE64rr),
     /* 207860 */     GIR_RootConstrainSelectedInstOperands,
     /* 207861 */     // GIR_Coverage, 63,
     /* 207861 */     GIR_Done,
     /* 207862 */   // Label 4742: @207862
     /* 207862 */   GIM_Reject,
     /* 207863 */ // Label 4738: @207863
     /* 207863 */ GIM_Reject,
     /* 207864 */ // Label 4727: @207864
     /* 207864 */ GIM_Reject,
     /* 207865 */ // Label 67: @207865
     /* 207865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4756*/ GIMT_Encode4(210033),
     /* 207876 */ /*GILLT_s16*//*Label 4743*/ GIMT_Encode4(207960),
     /* 207880 */ /*GILLT_s32*//*Label 4744*/ GIMT_Encode4(208081),
     /* 207884 */ /*GILLT_s64*//*Label 4745*/ GIMT_Encode4(208437),
     /* 207888 */ /*GILLT_s80*//*Label 4746*/ GIMT_Encode4(208793), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207900 */ /*GILLT_v2s64*//*Label 4747*/ GIMT_Encode4(208830), GIMT_Encode4(0),
     /* 207908 */ /*GILLT_v4s32*//*Label 4748*/ GIMT_Encode4(209033),
     /* 207912 */ /*GILLT_v4s64*//*Label 4749*/ GIMT_Encode4(209236), GIMT_Encode4(0),
     /* 207920 */ /*GILLT_v8s16*//*Label 4750*/ GIMT_Encode4(209412),
     /* 207924 */ /*GILLT_v8s32*//*Label 4751*/ GIMT_Encode4(209501),
     /* 207928 */ /*GILLT_v8s64*//*Label 4752*/ GIMT_Encode4(209677), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207940 */ /*GILLT_v16s16*//*Label 4753*/ GIMT_Encode4(209766),
     /* 207944 */ /*GILLT_v16s32*//*Label 4754*/ GIMT_Encode4(209855), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 207956 */ /*GILLT_v32s16*//*Label 4755*/ GIMT_Encode4(209944),
     /* 207960 */ // Label 4743: @207960
     /* 207960 */ GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(208080),
     /* 207965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 207968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 207972 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(208041), // Rule ID 21421 //
     /* 207977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 207980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 207984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 207988 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 207991 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 207995 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 207999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208001 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208008 */     // (fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 208008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 208011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208039 */     GIR_RootConstrainSelectedInstOperands,
     /* 208040 */     // GIR_Coverage, 21421,
     /* 208040 */     GIR_EraseRootFromParent_Done,
     /* 208041 */   // Label 4758: @208041
     /* 208041 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(208079), // Rule ID 21419 //
     /* 208046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 208049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 208053 */     // (fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 208053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 208056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 208070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208075 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208077 */     GIR_RootConstrainSelectedInstOperands,
     /* 208078 */     // GIR_Coverage, 21419,
     /* 208078 */     GIR_EraseRootFromParent_Done,
     /* 208079 */   // Label 4759: @208079
     /* 208079 */   GIM_Reject,
     /* 208080 */ // Label 4757: @208080
     /* 208080 */ GIM_Reject,
     /* 208081 */ // Label 4744: @208081
     /* 208081 */ GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(208436),
     /* 208086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208089 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(208145), // Rule ID 2449 //
     /* 208094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 208097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208109 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208112 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208122 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208129 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 208129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 208132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208134 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208143 */     GIR_RootConstrainSelectedInstOperands,
     /* 208144 */     // GIR_Coverage, 2449,
     /* 208144 */     GIR_EraseRootFromParent_Done,
     /* 208145 */   // Label 4761: @208145
     /* 208145 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(208218), // Rule ID 18277 //
     /* 208150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208165 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208168 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208172 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208178 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208185 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 208202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208207 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208216 */     GIR_RootConstrainSelectedInstOperands,
     /* 208217 */     // GIR_Coverage, 18277,
     /* 208217 */     GIR_EraseRootFromParent_Done,
     /* 208218 */   // Label 4762: @208218
     /* 208218 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(208291), // Rule ID 21425 //
     /* 208223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208238 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208241 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208245 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208258 */     // (fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 208258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 208275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208289 */     GIR_RootConstrainSelectedInstOperands,
     /* 208290 */     // GIR_Coverage, 21425,
     /* 208290 */     GIR_EraseRootFromParent_Done,
     /* 208291 */   // Label 4763: @208291
     /* 208291 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(208324), // Rule ID 1049 //
     /* 208296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 208299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 208307 */     // (fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 208307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 208312 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208318 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208322 */     GIR_RootConstrainSelectedInstOperands,
     /* 208323 */     // GIR_Coverage, 1049,
     /* 208323 */     GIR_Done,
     /* 208324 */   // Label 4764: @208324
     /* 208324 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(208351), // Rule ID 2447 //
     /* 208329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 208332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208340 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 208340 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 208345 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208349 */     GIR_RootConstrainSelectedInstOperands,
     /* 208350 */     // GIR_Coverage, 2447,
     /* 208350 */     GIR_Done,
     /* 208351 */   // Label 4765: @208351
     /* 208351 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(208393), // Rule ID 18275 //
     /* 208356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 208367 */     // (fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 208367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 208384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208391 */     GIR_RootConstrainSelectedInstOperands,
     /* 208392 */     // GIR_Coverage, 18275,
     /* 208392 */     GIR_EraseRootFromParent_Done,
     /* 208393 */   // Label 4766: @208393
     /* 208393 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(208435), // Rule ID 21423 //
     /* 208398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 208409 */     // (fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 208409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 208412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 208426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208431 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208433 */     GIR_RootConstrainSelectedInstOperands,
     /* 208434 */     // GIR_Coverage, 21423,
     /* 208434 */     GIR_EraseRootFromParent_Done,
     /* 208435 */   // Label 4767: @208435
     /* 208435 */   GIM_Reject,
     /* 208436 */ // Label 4760: @208436
     /* 208436 */ GIM_Reject,
     /* 208437 */ // Label 4745: @208437
     /* 208437 */ GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(208792),
     /* 208442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208445 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(208501), // Rule ID 2465 //
     /* 208450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 208453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208465 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208468 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208472 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208485 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 208485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 208488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 208494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208499 */     GIR_RootConstrainSelectedInstOperands,
     /* 208500 */     // GIR_Coverage, 2465,
     /* 208500 */     GIR_EraseRootFromParent_Done,
     /* 208501 */   // Label 4769: @208501
     /* 208501 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(208574), // Rule ID 18281 //
     /* 208506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 208509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208534 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208541 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 208558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208572 */     GIR_RootConstrainSelectedInstOperands,
     /* 208573 */     // GIR_Coverage, 18281,
     /* 208573 */     GIR_EraseRootFromParent_Done,
     /* 208574 */   // Label 4770: @208574
     /* 208574 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(208647), // Rule ID 21429 //
     /* 208579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 208582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208594 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208597 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208601 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208607 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208614 */     // (fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 208614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 208631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208636 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208645 */     GIR_RootConstrainSelectedInstOperands,
     /* 208646 */     // GIR_Coverage, 21429,
     /* 208646 */     GIR_EraseRootFromParent_Done,
     /* 208647 */   // Label 4771: @208647
     /* 208647 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(208680), // Rule ID 1051 //
     /* 208652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 208655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 208663 */     // (fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 208663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 208668 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208678 */     GIR_RootConstrainSelectedInstOperands,
     /* 208679 */     // GIR_Coverage, 1051,
     /* 208679 */     GIR_Done,
     /* 208680 */   // Label 4772: @208680
     /* 208680 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(208707), // Rule ID 2463 //
     /* 208685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208696 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 208696 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 208701 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208705 */     GIR_RootConstrainSelectedInstOperands,
     /* 208706 */     // GIR_Coverage, 2463,
     /* 208706 */     GIR_Done,
     /* 208707 */   // Label 4773: @208707
     /* 208707 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(208749), // Rule ID 18279 //
     /* 208712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 208715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 208723 */     // (fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 208723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 208740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208747 */     GIR_RootConstrainSelectedInstOperands,
     /* 208748 */     // GIR_Coverage, 18279,
     /* 208748 */     GIR_EraseRootFromParent_Done,
     /* 208749 */   // Label 4774: @208749
     /* 208749 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(208791), // Rule ID 21427 //
     /* 208754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 208757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 208765 */     // (fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 208765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 208782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208787 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 208789 */     GIR_RootConstrainSelectedInstOperands,
     /* 208790 */     // GIR_Coverage, 21427,
     /* 208790 */     GIR_EraseRootFromParent_Done,
     /* 208791 */   // Label 4775: @208791
     /* 208791 */   GIM_Reject,
     /* 208792 */ // Label 4768: @208792
     /* 208792 */ GIM_Reject,
     /* 208793 */ // Label 4746: @208793
     /* 208793 */ GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(208829), // Rule ID 1053 //
     /* 208798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 208801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 208804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 208812 */   // (fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 208812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 208817 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 208823 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 208827 */   GIR_RootConstrainSelectedInstOperands,
     /* 208828 */   // GIR_Coverage, 1053,
     /* 208828 */   GIR_Done,
     /* 208829 */ // Label 4776: @208829
     /* 208829 */ GIM_Reject,
     /* 208830 */ // Label 4747: @208830
     /* 208830 */ GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(209032),
     /* 208835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208838 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(208894), // Rule ID 2469 //
     /* 208843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208858 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208861 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208865 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208878 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 208881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208883 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208892 */     GIR_RootConstrainSelectedInstOperands,
     /* 208893 */     // GIR_Coverage, 2469,
     /* 208893 */     GIR_EraseRootFromParent_Done,
     /* 208894 */   // Label 4778: @208894
     /* 208894 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(208950), // Rule ID 12087 //
     /* 208899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 208902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 208906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 208910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 208914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 208917 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 208921 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 208925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 208927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 208934 */     // (fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 208934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 208937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208939 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 208943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 208948 */     GIR_RootConstrainSelectedInstOperands,
     /* 208949 */     // GIR_Coverage, 12087,
     /* 208949 */     GIR_EraseRootFromParent_Done,
     /* 208950 */   // Label 4779: @208950
     /* 208950 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(208977), // Rule ID 2467 //
     /* 208955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 208958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208966 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 208971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 208975 */     GIR_RootConstrainSelectedInstOperands,
     /* 208976 */     // GIR_Coverage, 2467,
     /* 208976 */     GIR_Done,
     /* 208977 */   // Label 4780: @208977
     /* 208977 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(209004), // Rule ID 2475 //
     /* 208982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 208985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 208993 */     // (fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 208993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 208998 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209002 */     GIR_RootConstrainSelectedInstOperands,
     /* 209003 */     // GIR_Coverage, 2475,
     /* 209003 */     GIR_Done,
     /* 209004 */   // Label 4781: @209004
     /* 209004 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(209031), // Rule ID 12083 //
     /* 209009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209020 */     // (fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 209020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 209025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209029 */     GIR_RootConstrainSelectedInstOperands,
     /* 209030 */     // GIR_Coverage, 12083,
     /* 209030 */     GIR_Done,
     /* 209031 */   // Label 4782: @209031
     /* 209031 */   GIM_Reject,
     /* 209032 */ // Label 4777: @209032
     /* 209032 */ GIM_Reject,
     /* 209033 */ // Label 4748: @209033
     /* 209033 */ GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(209235),
     /* 209038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209041 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(209097), // Rule ID 2453 //
     /* 209046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209061 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209064 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209068 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209081 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 209084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209095 */     GIR_RootConstrainSelectedInstOperands,
     /* 209096 */     // GIR_Coverage, 2453,
     /* 209096 */     GIR_EraseRootFromParent_Done,
     /* 209097 */   // Label 4784: @209097
     /* 209097 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(209153), // Rule ID 12063 //
     /* 209102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209117 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209120 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209124 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209130 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209137 */     // (fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 209137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 209140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209146 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209151 */     GIR_RootConstrainSelectedInstOperands,
     /* 209152 */     // GIR_Coverage, 12063,
     /* 209152 */     GIR_EraseRootFromParent_Done,
     /* 209153 */   // Label 4785: @209153
     /* 209153 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(209180), // Rule ID 2451 //
     /* 209158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209169 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209169 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 209174 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209178 */     GIR_RootConstrainSelectedInstOperands,
     /* 209179 */     // GIR_Coverage, 2451,
     /* 209179 */     GIR_Done,
     /* 209180 */   // Label 4786: @209180
     /* 209180 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(209207), // Rule ID 2459 //
     /* 209185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 209188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 209196 */     // (fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 209196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 209201 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209205 */     GIR_RootConstrainSelectedInstOperands,
     /* 209206 */     // GIR_Coverage, 2459,
     /* 209206 */     GIR_Done,
     /* 209207 */   // Label 4787: @209207
     /* 209207 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(209234), // Rule ID 12059 //
     /* 209212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209223 */     // (fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 209223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 209228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209232 */     GIR_RootConstrainSelectedInstOperands,
     /* 209233 */     // GIR_Coverage, 12059,
     /* 209233 */     GIR_Done,
     /* 209234 */   // Label 4788: @209234
     /* 209234 */   GIM_Reject,
     /* 209235 */ // Label 4783: @209235
     /* 209235 */ GIM_Reject,
     /* 209236 */ // Label 4749: @209236
     /* 209236 */ GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(209411),
     /* 209241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 209244 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(209300), // Rule ID 2473 //
     /* 209249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209284 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 209287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209289 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209298 */     GIR_RootConstrainSelectedInstOperands,
     /* 209299 */     // GIR_Coverage, 2473,
     /* 209299 */     GIR_EraseRootFromParent_Done,
     /* 209300 */   // Label 4790: @209300
     /* 209300 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(209356), // Rule ID 12099 //
     /* 209305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209320 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209323 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209340 */     // (fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 209340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 209343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209345 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209354 */     GIR_RootConstrainSelectedInstOperands,
     /* 209355 */     // GIR_Coverage, 12099,
     /* 209355 */     GIR_EraseRootFromParent_Done,
     /* 209356 */   // Label 4791: @209356
     /* 209356 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(209383), // Rule ID 2471 //
     /* 209361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209372 */     // (fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 209372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 209377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209381 */     GIR_RootConstrainSelectedInstOperands,
     /* 209382 */     // GIR_Coverage, 2471,
     /* 209382 */     GIR_Done,
     /* 209383 */   // Label 4792: @209383
     /* 209383 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(209410), // Rule ID 12095 //
     /* 209388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209399 */     // (fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 209399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 209404 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209408 */     GIR_RootConstrainSelectedInstOperands,
     /* 209409 */     // GIR_Coverage, 12095,
     /* 209409 */     GIR_Done,
     /* 209410 */   // Label 4793: @209410
     /* 209410 */   GIM_Reject,
     /* 209411 */ // Label 4789: @209411
     /* 209411 */ GIM_Reject,
     /* 209412 */ // Label 4750: @209412
     /* 209412 */ GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(209500),
     /* 209417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 209420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209424 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(209476), // Rule ID 12015 //
     /* 209429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209440 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209443 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209447 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209453 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209460 */     // (fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 209460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 209463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209465 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209474 */     GIR_RootConstrainSelectedInstOperands,
     /* 209475 */     // GIR_Coverage, 12015,
     /* 209475 */     GIR_EraseRootFromParent_Done,
     /* 209476 */   // Label 4795: @209476
     /* 209476 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(209499), // Rule ID 12011 //
     /* 209481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 209488 */     // (fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 209488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 209493 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209497 */     GIR_RootConstrainSelectedInstOperands,
     /* 209498 */     // GIR_Coverage, 12011,
     /* 209498 */     GIR_Done,
     /* 209499 */   // Label 4796: @209499
     /* 209499 */   GIM_Reject,
     /* 209500 */ // Label 4794: @209500
     /* 209500 */ GIM_Reject,
     /* 209501 */ // Label 4751: @209501
     /* 209501 */ GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(209676),
     /* 209506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 209509 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(209565), // Rule ID 2457 //
     /* 209514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209529 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209536 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209549 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 209552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209554 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209563 */     GIR_RootConstrainSelectedInstOperands,
     /* 209564 */     // GIR_Coverage, 2457,
     /* 209564 */     GIR_EraseRootFromParent_Done,
     /* 209565 */   // Label 4798: @209565
     /* 209565 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(209621), // Rule ID 12075 //
     /* 209570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209585 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209588 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209592 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209605 */     // (fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 209605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 209608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209619 */     GIR_RootConstrainSelectedInstOperands,
     /* 209620 */     // GIR_Coverage, 12075,
     /* 209620 */     GIR_EraseRootFromParent_Done,
     /* 209621 */   // Label 4799: @209621
     /* 209621 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(209648), // Rule ID 2455 //
     /* 209626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 209629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 209637 */     // (fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 209637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 209642 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209646 */     GIR_RootConstrainSelectedInstOperands,
     /* 209647 */     // GIR_Coverage, 2455,
     /* 209647 */     GIR_Done,
     /* 209648 */   // Label 4800: @209648
     /* 209648 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(209675), // Rule ID 12071 //
     /* 209653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 209656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209664 */     // (fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 209664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 209669 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209673 */     GIR_RootConstrainSelectedInstOperands,
     /* 209674 */     // GIR_Coverage, 12071,
     /* 209674 */     GIR_Done,
     /* 209675 */   // Label 4801: @209675
     /* 209675 */   GIM_Reject,
     /* 209676 */ // Label 4797: @209676
     /* 209676 */ GIM_Reject,
     /* 209677 */ // Label 4752: @209677
     /* 209677 */ GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(209765),
     /* 209682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 209685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209689 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(209741), // Rule ID 12051 //
     /* 209694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209705 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209708 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209725 */     // (fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 209725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 209728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209739 */     GIR_RootConstrainSelectedInstOperands,
     /* 209740 */     // GIR_Coverage, 12051,
     /* 209740 */     GIR_EraseRootFromParent_Done,
     /* 209741 */   // Label 4803: @209741
     /* 209741 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(209764), // Rule ID 12047 //
     /* 209746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209753 */     // (fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 209753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 209758 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209762 */     GIR_RootConstrainSelectedInstOperands,
     /* 209763 */     // GIR_Coverage, 12047,
     /* 209763 */     GIR_Done,
     /* 209764 */   // Label 4804: @209764
     /* 209764 */   GIM_Reject,
     /* 209765 */ // Label 4802: @209765
     /* 209765 */ GIM_Reject,
     /* 209766 */ // Label 4753: @209766
     /* 209766 */ GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(209854),
     /* 209771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 209774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209778 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(209830), // Rule ID 12027 //
     /* 209783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209794 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209797 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209801 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209807 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209814 */     // (fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 209814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 209817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209828 */     GIR_RootConstrainSelectedInstOperands,
     /* 209829 */     // GIR_Coverage, 12027,
     /* 209829 */     GIR_EraseRootFromParent_Done,
     /* 209830 */   // Label 4806: @209830
     /* 209830 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(209853), // Rule ID 12023 //
     /* 209835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 209838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 209842 */     // (fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 209842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 209847 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209851 */     GIR_RootConstrainSelectedInstOperands,
     /* 209852 */     // GIR_Coverage, 12023,
     /* 209852 */     GIR_Done,
     /* 209853 */   // Label 4807: @209853
     /* 209853 */   GIM_Reject,
     /* 209854 */ // Label 4805: @209854
     /* 209854 */ GIM_Reject,
     /* 209855 */ // Label 4754: @209855
     /* 209855 */ GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(209943),
     /* 209860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 209863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209867 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(209919), // Rule ID 12039 //
     /* 209872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209883 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209886 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209890 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209896 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209903 */     // (fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 209903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 209906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209908 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 209912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 209917 */     GIR_RootConstrainSelectedInstOperands,
     /* 209918 */     // GIR_Coverage, 12039,
     /* 209918 */     GIR_EraseRootFromParent_Done,
     /* 209919 */   // Label 4809: @209919
     /* 209919 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(209942), // Rule ID 12035 //
     /* 209924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 209927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209931 */     // (fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 209931 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 209936 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 209940 */     GIR_RootConstrainSelectedInstOperands,
     /* 209941 */     // GIR_Coverage, 12035,
     /* 209941 */     GIR_Done,
     /* 209942 */   // Label 4810: @209942
     /* 209942 */   GIM_Reject,
     /* 209943 */ // Label 4808: @209943
     /* 209943 */ GIM_Reject,
     /* 209944 */ // Label 4755: @209944
     /* 209944 */ GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(210032),
     /* 209949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 209952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 209956 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(210008), // Rule ID 12003 //
     /* 209961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 209964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 209968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 209972 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 209975 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 209979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 209983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 209985 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 209992 */     // (fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 209992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 209995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 210001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210006 */     GIR_RootConstrainSelectedInstOperands,
     /* 210007 */     // GIR_Coverage, 12003,
     /* 210007 */     GIR_EraseRootFromParent_Done,
     /* 210008 */   // Label 4812: @210008
     /* 210008 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(210031), // Rule ID 11999 //
     /* 210013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 210020 */     // (fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 210020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 210025 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210029 */     GIR_RootConstrainSelectedInstOperands,
     /* 210030 */     // GIR_Coverage, 11999,
     /* 210030 */     GIR_Done,
     /* 210031 */   // Label 4813: @210031
     /* 210031 */   GIM_Reject,
     /* 210032 */ // Label 4811: @210032
     /* 210032 */ GIM_Reject,
     /* 210033 */ // Label 4756: @210033
     /* 210033 */ GIM_Reject,
     /* 210034 */ // Label 68: @210034
     /* 210034 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4827*/ GIMT_Encode4(214963),
     /* 210045 */ /*GILLT_s16*//*Label 4814*/ GIMT_Encode4(210129),
     /* 210049 */ /*GILLT_s32*//*Label 4815*/ GIMT_Encode4(210289),
     /* 210053 */ /*GILLT_s64*//*Label 4816*/ GIMT_Encode4(211194),
     /* 210057 */ /*GILLT_s80*//*Label 4817*/ GIMT_Encode4(212243), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210069 */ /*GILLT_v2s64*//*Label 4818*/ GIMT_Encode4(212809), GIMT_Encode4(0),
     /* 210077 */ /*GILLT_v4s32*//*Label 4819*/ GIMT_Encode4(213163),
     /* 210081 */ /*GILLT_v4s64*//*Label 4820*/ GIMT_Encode4(213517), GIMT_Encode4(0),
     /* 210089 */ /*GILLT_v8s16*//*Label 4821*/ GIMT_Encode4(213840),
     /* 210093 */ /*GILLT_v8s32*//*Label 4822*/ GIMT_Encode4(214000),
     /* 210097 */ /*GILLT_v8s64*//*Label 4823*/ GIMT_Encode4(214323), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210109 */ /*GILLT_v16s16*//*Label 4824*/ GIMT_Encode4(214483),
     /* 210113 */ /*GILLT_v16s32*//*Label 4825*/ GIMT_Encode4(214643), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 210125 */ /*GILLT_v32s16*//*Label 4826*/ GIMT_Encode4(214803),
     /* 210129 */ // Label 4814: @210129
     /* 210129 */ GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(210288),
     /* 210134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 210137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 210140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210144 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(210202), // Rule ID 24249 //
     /* 210149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210160 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210163 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210167 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210177 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210184 */     // (strict_fadd:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210191 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210200 */     GIR_RootConstrainSelectedInstOperands,
     /* 210201 */     // GIR_Coverage, 24249,
     /* 210201 */     GIR_EraseRootFromParent_Done,
     /* 210202 */   // Label 4829: @210202
     /* 210202 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(210260), // Rule ID 5954 //
     /* 210207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210235 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210242 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSHZrm),
     /* 210245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210249 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210258 */     GIR_RootConstrainSelectedInstOperands,
     /* 210259 */     // GIR_Coverage, 5954,
     /* 210259 */     GIR_EraseRootFromParent_Done,
     /* 210260 */   // Label 4830: @210260
     /* 210260 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(210287), // Rule ID 5952 //
     /* 210265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 210268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 210276 */     // (strict_fadd:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VADDSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 210276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSHZrr),
     /* 210281 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 210285 */     GIR_RootConstrainSelectedInstOperands,
     /* 210286 */     // GIR_Coverage, 5952,
     /* 210286 */     GIR_Done,
     /* 210287 */   // Label 4831: @210287
     /* 210287 */   GIM_Reject,
     /* 210288 */ // Label 4828: @210288
     /* 210288 */ GIM_Reject,
     /* 210289 */ // Label 4815: @210289
     /* 210289 */ GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(211193),
     /* 210294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210300 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(210365), // Rule ID 23246 //
     /* 210305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210320 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210327 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210344 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210349 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210351 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210363 */     GIR_RootConstrainSelectedInstOperands,
     /* 210364 */     // GIR_Coverage, 23246,
     /* 210364 */     GIR_EraseRootFromParent_Done,
     /* 210365 */   // Label 4833: @210365
     /* 210365 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(210430), // Rule ID 23248 //
     /* 210370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210385 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210402 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210409 */     // (strict_fadd:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210414 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210428 */     GIR_RootConstrainSelectedInstOperands,
     /* 210429 */     // GIR_Coverage, 23248,
     /* 210429 */     GIR_EraseRootFromParent_Done,
     /* 210430 */   // Label 4834: @210430
     /* 210430 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(210495), // Rule ID 23236 //
     /* 210435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210450 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210453 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210457 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210467 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210474 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210479 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210481 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210493 */     GIR_RootConstrainSelectedInstOperands,
     /* 210494 */     // GIR_Coverage, 23236,
     /* 210494 */     GIR_EraseRootFromParent_Done,
     /* 210495 */   // Label 4835: @210495
     /* 210495 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(210557), // Rule ID 23381 //
     /* 210500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210515 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210518 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210522 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210532 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210539 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210546 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210555 */     GIR_RootConstrainSelectedInstOperands,
     /* 210556 */     // GIR_Coverage, 23381,
     /* 210556 */     GIR_EraseRootFromParent_Done,
     /* 210557 */   // Label 4836: @210557
     /* 210557 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(210619), // Rule ID 23385 //
     /* 210562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210601 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210606 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210608 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210617 */     GIR_RootConstrainSelectedInstOperands,
     /* 210618 */     // GIR_Coverage, 23385,
     /* 210618 */     GIR_EraseRootFromParent_Done,
     /* 210619 */   // Label 4837: @210619
     /* 210619 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(210681), // Rule ID 24245 //
     /* 210624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 210627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 210635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210639 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210642 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210646 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 210654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210663 */     // (strict_fadd:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 210666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210668 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 210670 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210679 */     GIR_RootConstrainSelectedInstOperands,
     /* 210680 */     // GIR_Coverage, 24245,
     /* 210680 */     GIR_EraseRootFromParent_Done,
     /* 210681 */   // Label 4838: @210681
     /* 210681 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(210746), // Rule ID 920 //
     /* 210686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210705 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 210712 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210718 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210725 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m32),
     /* 210728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210730 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210732 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210744 */     GIR_RootConstrainSelectedInstOperands,
     /* 210745 */     // GIR_Coverage, 920,
     /* 210745 */     GIR_EraseRootFromParent_Done,
     /* 210746 */   // Label 4839: @210746
     /* 210746 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(210811), // Rule ID 922 //
     /* 210751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 210770 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 210777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210783 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210790 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m32),
     /* 210793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210795 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210797 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210804 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210809 */     GIR_RootConstrainSelectedInstOperands,
     /* 210810 */     // GIR_Coverage, 922,
     /* 210810 */     GIR_EraseRootFromParent_Done,
     /* 210811 */   // Label 4840: @210811
     /* 210811 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(210876), // Rule ID 910 //
     /* 210816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 210819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 210827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210835 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210838 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210842 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210855 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32m),
     /* 210858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210860 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 210869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210874 */     GIR_RootConstrainSelectedInstOperands,
     /* 210875 */     // GIR_Coverage, 910,
     /* 210875 */     GIR_EraseRootFromParent_Done,
     /* 210876 */   // Label 4841: @210876
     /* 210876 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(210938), // Rule ID 2160 //
     /* 210881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 210884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210900 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210903 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210907 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210920 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSrm),
     /* 210923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210925 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210927 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210936 */     GIR_RootConstrainSelectedInstOperands,
     /* 210937 */     // GIR_Coverage, 2160,
     /* 210937 */     GIR_EraseRootFromParent_Done,
     /* 210938 */   // Label 4842: @210938
     /* 210938 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(211000), // Rule ID 2168 //
     /* 210943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 210946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 210954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 210958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 210962 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 210965 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 210969 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 210973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210975 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 210982 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 210982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSSrm),
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 210987 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 210989 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 210993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 210998 */     GIR_RootConstrainSelectedInstOperands,
     /* 210999 */     // GIR_Coverage, 2168,
     /* 210999 */     GIR_EraseRootFromParent_Done,
     /* 211000 */   // Label 4843: @211000
     /* 211000 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(211062), // Rule ID 5916 //
     /* 211005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211024 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211027 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211031 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211044 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSSZrm),
     /* 211047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211049 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211051 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211060 */     GIR_RootConstrainSelectedInstOperands,
     /* 211061 */     // GIR_Coverage, 5916,
     /* 211061 */     GIR_EraseRootFromParent_Done,
     /* 211062 */   // Label 4844: @211062
     /* 211062 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(211099), // Rule ID 886 //
     /* 211067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 211070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 211082 */     // (strict_fadd:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (ADD_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 211082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp32),
     /* 211087 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 211093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 211097 */     GIR_RootConstrainSelectedInstOperands,
     /* 211098 */     // GIR_Coverage, 886,
     /* 211098 */     GIR_Done,
     /* 211099 */   // Label 4845: @211099
     /* 211099 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(211130), // Rule ID 2158 //
     /* 211104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211119 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSrr),
     /* 211124 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211128 */     GIR_RootConstrainSelectedInstOperands,
     /* 211129 */     // GIR_Coverage, 2158,
     /* 211129 */     GIR_Done,
     /* 211130 */   // Label 4846: @211130
     /* 211130 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(211161), // Rule ID 2166 //
     /* 211135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 211138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 211150 */     // (strict_fadd:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (ADDSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 211150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSSrr),
     /* 211155 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211159 */     GIR_RootConstrainSelectedInstOperands,
     /* 211160 */     // GIR_Coverage, 2166,
     /* 211160 */     GIR_Done,
     /* 211161 */   // Label 4847: @211161
     /* 211161 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(211192), // Rule ID 5914 //
     /* 211166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 211181 */     // (strict_fadd:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VADDSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 211181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSSZrr),
     /* 211186 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 211190 */     GIR_RootConstrainSelectedInstOperands,
     /* 211191 */     // GIR_Coverage, 5914,
     /* 211191 */     GIR_Done,
     /* 211192 */   // Label 4848: @211192
     /* 211192 */   GIM_Reject,
     /* 211193 */ // Label 4832: @211193
     /* 211193 */ GIM_Reject,
     /* 211194 */ // Label 4816: @211194
     /* 211194 */ GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(212242),
     /* 211199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211205 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(211270), // Rule ID 23250 //
     /* 211210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211225 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211232 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211249 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211254 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211268 */     GIR_RootConstrainSelectedInstOperands,
     /* 211269 */     // GIR_Coverage, 23250,
     /* 211269 */     GIR_EraseRootFromParent_Done,
     /* 211270 */   // Label 4850: @211270
     /* 211270 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(211335), // Rule ID 23252 //
     /* 211275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211290 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211297 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211307 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211314 */     // (strict_fadd:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211319 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211321 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211333 */     GIR_RootConstrainSelectedInstOperands,
     /* 211334 */     // GIR_Coverage, 23252,
     /* 211334 */     GIR_EraseRootFromParent_Done,
     /* 211335 */   // Label 4851: @211335
     /* 211335 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(211400), // Rule ID 23238 //
     /* 211340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211355 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211358 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211362 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211379 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211384 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211386 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211393 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211398 */     GIR_RootConstrainSelectedInstOperands,
     /* 211399 */     // GIR_Coverage, 23238,
     /* 211399 */     GIR_EraseRootFromParent_Done,
     /* 211400 */   // Label 4852: @211400
     /* 211400 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(211472), // Rule ID 23240 //
     /* 211405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211423 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211427 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211451 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211456 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211458 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211462 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211470 */     GIR_RootConstrainSelectedInstOperands,
     /* 211471 */     // GIR_Coverage, 23240,
     /* 211471 */     GIR_EraseRootFromParent_Done,
     /* 211472 */   // Label 4853: @211472
     /* 211472 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(211534), // Rule ID 23383 //
     /* 211477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211509 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211516 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211521 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211523 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211532 */     GIR_RootConstrainSelectedInstOperands,
     /* 211533 */     // GIR_Coverage, 23383,
     /* 211533 */     GIR_EraseRootFromParent_Done,
     /* 211534 */   // Label 4854: @211534
     /* 211534 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(211596), // Rule ID 23387 //
     /* 211539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211554 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211557 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211561 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211578 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 211581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211583 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211585 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211589 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211594 */     GIR_RootConstrainSelectedInstOperands,
     /* 211595 */     // GIR_Coverage, 23387,
     /* 211595 */     GIR_EraseRootFromParent_Done,
     /* 211596 */   // Label 4855: @211596
     /* 211596 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(211658), // Rule ID 24247 //
     /* 211601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 211604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 211612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211616 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211619 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211623 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 211631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211633 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211640 */     // (strict_fadd:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 211643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211645 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 211647 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211656 */     GIR_RootConstrainSelectedInstOperands,
     /* 211657 */     // GIR_Coverage, 24247,
     /* 211657 */     GIR_EraseRootFromParent_Done,
     /* 211658 */   // Label 4856: @211658
     /* 211658 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(211723), // Rule ID 924 //
     /* 211663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211682 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 211689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211702 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m64),
     /* 211705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211721 */     GIR_RootConstrainSelectedInstOperands,
     /* 211722 */     // GIR_Coverage, 924,
     /* 211722 */     GIR_EraseRootFromParent_Done,
     /* 211723 */   // Label 4857: @211723
     /* 211723 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(211788), // Rule ID 926 //
     /* 211728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 211747 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211754 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211767 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m64),
     /* 211770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211772 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211774 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211786 */     GIR_RootConstrainSelectedInstOperands,
     /* 211787 */     // GIR_Coverage, 926,
     /* 211787 */     GIR_EraseRootFromParent_Done,
     /* 211788 */   // Label 4858: @211788
     /* 211788 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(211853), // Rule ID 912 //
     /* 211793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211812 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211819 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211832 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADD_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m),
     /* 211835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211837 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211851 */     GIR_RootConstrainSelectedInstOperands,
     /* 211852 */     // GIR_Coverage, 912,
     /* 211852 */     GIR_EraseRootFromParent_Done,
     /* 211853 */   // Label 4859: @211853
     /* 211853 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(211925), // Rule ID 914 //
     /* 211858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 211861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 211869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211877 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211880 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211884 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 211891 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211904 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64m32),
     /* 211907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211909 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211911 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 211918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211923 */     GIR_RootConstrainSelectedInstOperands,
     /* 211924 */     // GIR_Coverage, 914,
     /* 211924 */     GIR_EraseRootFromParent_Done,
     /* 211925 */   // Label 4860: @211925
     /* 211925 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(211987), // Rule ID 2164 //
     /* 211930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 211933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 211945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 211949 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 211952 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 211956 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 211960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211962 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 211969 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 211969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDrm),
     /* 211972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 211974 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 211976 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 211980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 211985 */     GIR_RootConstrainSelectedInstOperands,
     /* 211986 */     // GIR_Coverage, 2164,
     /* 211986 */     GIR_EraseRootFromParent_Done,
     /* 211987 */   // Label 4861: @211987
     /* 211987 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(212049), // Rule ID 2172 //
     /* 211992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 211995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 211999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212011 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212014 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212018 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212024 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212031 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (ADDSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADDSDrm),
     /* 212034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212036 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212038 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212047 */     GIR_RootConstrainSelectedInstOperands,
     /* 212048 */     // GIR_Coverage, 2172,
     /* 212048 */     GIR_EraseRootFromParent_Done,
     /* 212049 */   // Label 4862: @212049
     /* 212049 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(212111), // Rule ID 5935 //
     /* 212054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212073 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212076 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212080 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212086 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212093 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDSDZrm),
     /* 212096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212109 */     GIR_RootConstrainSelectedInstOperands,
     /* 212110 */     // GIR_Coverage, 5935,
     /* 212110 */     GIR_EraseRootFromParent_Done,
     /* 212111 */   // Label 4863: @212111
     /* 212111 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(212148), // Rule ID 888 //
     /* 212116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 212119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 212131 */     // (strict_fadd:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (ADD_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 212131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp64),
     /* 212136 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212142 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212146 */     GIR_RootConstrainSelectedInstOperands,
     /* 212147 */     // GIR_Coverage, 888,
     /* 212147 */     GIR_Done,
     /* 212148 */   // Label 4864: @212148
     /* 212148 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(212179), // Rule ID 2162 //
     /* 212153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 212156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212168 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDrr),
     /* 212173 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212177 */     GIR_RootConstrainSelectedInstOperands,
     /* 212178 */     // GIR_Coverage, 2162,
     /* 212178 */     GIR_Done,
     /* 212179 */   // Label 4865: @212179
     /* 212179 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(212210), // Rule ID 2170 //
     /* 212184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 212187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 212199 */     // (strict_fadd:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (ADDSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 212199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDSDrr),
     /* 212204 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212208 */     GIR_RootConstrainSelectedInstOperands,
     /* 212209 */     // GIR_Coverage, 2170,
     /* 212209 */     GIR_Done,
     /* 212210 */   // Label 4866: @212210
     /* 212210 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(212241), // Rule ID 5933 //
     /* 212215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 212218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 212230 */     // (strict_fadd:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VADDSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 212230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDSDZrr),
     /* 212235 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 212239 */     GIR_RootConstrainSelectedInstOperands,
     /* 212240 */     // GIR_Coverage, 5933,
     /* 212240 */     GIR_Done,
     /* 212241 */   // Label 4867: @212241
     /* 212241 */   GIM_Reject,
     /* 212242 */ // Label 4849: @212242
     /* 212242 */ GIM_Reject,
     /* 212243 */ // Label 4817: @212243
     /* 212243 */ GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(212808),
     /* 212248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 212251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 212254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212258 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(212319), // Rule ID 23254 //
     /* 212263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212274 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212281 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212298 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212303 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212317 */     GIR_RootConstrainSelectedInstOperands,
     /* 212318 */     // GIR_Coverage, 23254,
     /* 212318 */     GIR_EraseRootFromParent_Done,
     /* 212319 */   // Label 4869: @212319
     /* 212319 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(212380), // Rule ID 23256 //
     /* 212324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212335 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212342 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212352 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212359 */     // (strict_fadd:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212364 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212378 */     GIR_RootConstrainSelectedInstOperands,
     /* 212379 */     // GIR_Coverage, 23256,
     /* 212379 */     GIR_EraseRootFromParent_Done,
     /* 212380 */   // Label 4870: @212380
     /* 212380 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(212448), // Rule ID 23242 //
     /* 212385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212396 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212399 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212403 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212420 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212427 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212432 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212446 */     GIR_RootConstrainSelectedInstOperands,
     /* 212447 */     // GIR_Coverage, 23242,
     /* 212447 */     GIR_EraseRootFromParent_Done,
     /* 212448 */   // Label 4871: @212448
     /* 212448 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(212516), // Rule ID 23244 //
     /* 212453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212464 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212467 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212471 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212495 */     // (strict_fadd:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212500 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212502 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212509 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212514 */     GIR_RootConstrainSelectedInstOperands,
     /* 212515 */     // GIR_Coverage, 23244,
     /* 212515 */     GIR_EraseRootFromParent_Done,
     /* 212516 */   // Label 4872: @212516
     /* 212516 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(212577), // Rule ID 928 //
     /* 212521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212536 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 212543 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212549 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212556 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (ADD_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI16m80),
     /* 212559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212561 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212563 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212575 */     GIR_RootConstrainSelectedInstOperands,
     /* 212576 */     // GIR_Coverage, 928,
     /* 212576 */     GIR_EraseRootFromParent_Done,
     /* 212577 */   // Label 4873: @212577
     /* 212577 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(212638), // Rule ID 930 //
     /* 212582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 212597 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212604 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212617 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (ADD_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_FpI32m80),
     /* 212620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212622 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212624 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212636 */     GIR_RootConstrainSelectedInstOperands,
     /* 212637 */     // GIR_Coverage, 930,
     /* 212637 */     GIR_EraseRootFromParent_Done,
     /* 212638 */   // Label 4874: @212638
     /* 212638 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(212706), // Rule ID 916 //
     /* 212643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212658 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212661 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212665 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 212672 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212685 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (ADD_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m32),
     /* 212688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212696 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212699 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212704 */     GIR_RootConstrainSelectedInstOperands,
     /* 212705 */     // GIR_Coverage, 916,
     /* 212705 */     GIR_EraseRootFromParent_Done,
     /* 212706 */   // Label 4875: @212706
     /* 212706 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(212774), // Rule ID 918 //
     /* 212711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212726 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212729 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212733 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 212740 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212753 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (ADD_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80m64),
     /* 212756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212758 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 212767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212772 */     GIR_RootConstrainSelectedInstOperands,
     /* 212773 */     // GIR_Coverage, 918,
     /* 212773 */     GIR_EraseRootFromParent_Done,
     /* 212774 */   // Label 4876: @212774
     /* 212774 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(212807), // Rule ID 890 //
     /* 212779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 212782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 212790 */     // (strict_fadd:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (ADD_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 212790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADD_Fp80),
     /* 212795 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 212801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 212805 */     GIR_RootConstrainSelectedInstOperands,
     /* 212806 */     // GIR_Coverage, 890,
     /* 212806 */     GIR_Done,
     /* 212807 */   // Label 4877: @212807
     /* 212807 */   GIM_Reject,
     /* 212808 */ // Label 4868: @212808
     /* 212808 */ GIM_Reject,
     /* 212809 */ // Label 4818: @212809
     /* 212809 */ GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(213162),
     /* 212814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 212817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 212820 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(212882), // Rule ID 23371 //
     /* 212825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212857 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212864 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212869 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212871 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212880 */     GIR_RootConstrainSelectedInstOperands,
     /* 212881 */     // GIR_Coverage, 23371,
     /* 212881 */     GIR_EraseRootFromParent_Done,
     /* 212882 */   // Label 4879: @212882
     /* 212882 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(212944), // Rule ID 24295 //
     /* 212887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 212890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 212898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212902 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212905 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212909 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 212917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212919 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212926 */     // (strict_fadd:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 212929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212931 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 212933 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 212942 */     GIR_RootConstrainSelectedInstOperands,
     /* 212943 */     // GIR_Coverage, 24295,
     /* 212943 */     GIR_EraseRootFromParent_Done,
     /* 212944 */   // Label 4880: @212944
     /* 212944 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(213006), // Rule ID 2140 //
     /* 212949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 212952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 212960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 212968 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 212971 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 212975 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 212979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212981 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 212988 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 212988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDrm),
     /* 212991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 212993 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 212995 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 212999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213004 */     GIR_RootConstrainSelectedInstOperands,
     /* 213005 */     // GIR_Coverage, 2140,
     /* 213005 */     GIR_EraseRootFromParent_Done,
     /* 213006 */   // Label 4881: @213006
     /* 213006 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(213068), // Rule ID 6308 //
     /* 213011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213030 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213037 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213050 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rm),
     /* 213053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213055 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213057 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213066 */     GIR_RootConstrainSelectedInstOperands,
     /* 213067 */     // GIR_Coverage, 6308,
     /* 213067 */     GIR_EraseRootFromParent_Done,
     /* 213068 */   // Label 4882: @213068
     /* 213068 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(213099), // Rule ID 2138 //
     /* 213073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213088 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDrr),
     /* 213093 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213097 */     GIR_RootConstrainSelectedInstOperands,
     /* 213098 */     // GIR_Coverage, 2138,
     /* 213098 */     GIR_Done,
     /* 213099 */   // Label 4883: @213099
     /* 213099 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(213130), // Rule ID 2154 //
     /* 213104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 213107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213119 */     // (strict_fadd:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (ADDPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 213119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPDrr),
     /* 213124 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213128 */     GIR_RootConstrainSelectedInstOperands,
     /* 213129 */     // GIR_Coverage, 2154,
     /* 213129 */     GIR_Done,
     /* 213130 */   // Label 4884: @213130
     /* 213130 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(213161), // Rule ID 6304 //
     /* 213135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213150 */     // (strict_fadd:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VADDPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 213150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ128rr),
     /* 213155 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213159 */     GIR_RootConstrainSelectedInstOperands,
     /* 213160 */     // GIR_Coverage, 6304,
     /* 213160 */     GIR_Done,
     /* 213161 */   // Label 4885: @213161
     /* 213161 */   GIM_Reject,
     /* 213162 */ // Label 4878: @213162
     /* 213162 */ GIM_Reject,
     /* 213163 */ // Label 4819: @213163
     /* 213163 */ GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(213516),
     /* 213168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 213171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 213174 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(213236), // Rule ID 23369 //
     /* 213179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213218 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213225 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213234 */     GIR_RootConstrainSelectedInstOperands,
     /* 213235 */     // GIR_Coverage, 23369,
     /* 213235 */     GIR_EraseRootFromParent_Done,
     /* 213236 */   // Label 4887: @213236
     /* 213236 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(213298), // Rule ID 24279 //
     /* 213241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213256 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213259 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213263 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213273 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213280 */     // (strict_fadd:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213285 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213287 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213296 */     GIR_RootConstrainSelectedInstOperands,
     /* 213297 */     // GIR_Coverage, 24279,
     /* 213297 */     GIR_EraseRootFromParent_Done,
     /* 213298 */   // Label 4888: @213298
     /* 213298 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(213360), // Rule ID 2136 //
     /* 213303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213342 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSrm),
     /* 213345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213347 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213358 */     GIR_RootConstrainSelectedInstOperands,
     /* 213359 */     // GIR_Coverage, 2136,
     /* 213359 */     GIR_EraseRootFromParent_Done,
     /* 213360 */   // Label 4889: @213360
     /* 213360 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(213422), // Rule ID 6284 //
     /* 213365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213384 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213391 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213397 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213404 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rm),
     /* 213407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213409 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213411 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213420 */     GIR_RootConstrainSelectedInstOperands,
     /* 213421 */     // GIR_Coverage, 6284,
     /* 213421 */     GIR_EraseRootFromParent_Done,
     /* 213422 */   // Label 4890: @213422
     /* 213422 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(213453), // Rule ID 2134 //
     /* 213427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213442 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213442 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSrr),
     /* 213447 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213451 */     GIR_RootConstrainSelectedInstOperands,
     /* 213452 */     // GIR_Coverage, 2134,
     /* 213452 */     GIR_Done,
     /* 213453 */   // Label 4891: @213453
     /* 213453 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(213484), // Rule ID 2150 //
     /* 213458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 213461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 213473 */     // (strict_fadd:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (ADDPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 213473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::ADDPSrr),
     /* 213478 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213482 */     GIR_RootConstrainSelectedInstOperands,
     /* 213483 */     // GIR_Coverage, 2150,
     /* 213483 */     GIR_Done,
     /* 213484 */   // Label 4892: @213484
     /* 213484 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(213515), // Rule ID 6280 //
     /* 213489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213504 */     // (strict_fadd:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VADDPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 213504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ128rr),
     /* 213509 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213513 */     GIR_RootConstrainSelectedInstOperands,
     /* 213514 */     // GIR_Coverage, 6280,
     /* 213514 */     GIR_Done,
     /* 213515 */   // Label 4893: @213515
     /* 213515 */   GIM_Reject,
     /* 213516 */ // Label 4886: @213516
     /* 213516 */ GIM_Reject,
     /* 213517 */ // Label 4820: @213517
     /* 213517 */ GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(213839),
     /* 213522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 213525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 213528 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(213590), // Rule ID 23375 //
     /* 213533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213548 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213551 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213555 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213572 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213577 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213579 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213588 */     GIR_RootConstrainSelectedInstOperands,
     /* 213589 */     // GIR_Coverage, 23375,
     /* 213589 */     GIR_EraseRootFromParent_Done,
     /* 213590 */   // Label 4895: @213590
     /* 213590 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(213652), // Rule ID 24303 //
     /* 213595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213610 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213617 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213627 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213634 */     // (strict_fadd:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213639 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213641 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213650 */     GIR_RootConstrainSelectedInstOperands,
     /* 213651 */     // GIR_Coverage, 24303,
     /* 213651 */     GIR_EraseRootFromParent_Done,
     /* 213652 */   // Label 4896: @213652
     /* 213652 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(213714), // Rule ID 2148 //
     /* 213657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213676 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213679 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213683 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213696 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDYrm),
     /* 213699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213712 */     GIR_RootConstrainSelectedInstOperands,
     /* 213713 */     // GIR_Coverage, 2148,
     /* 213713 */     GIR_EraseRootFromParent_Done,
     /* 213714 */   // Label 4897: @213714
     /* 213714 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(213776), // Rule ID 6320 //
     /* 213719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213738 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213741 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213745 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213751 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213758 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rm),
     /* 213761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213765 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213774 */     GIR_RootConstrainSelectedInstOperands,
     /* 213775 */     // GIR_Coverage, 6320,
     /* 213775 */     GIR_EraseRootFromParent_Done,
     /* 213776 */   // Label 4898: @213776
     /* 213776 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(213807), // Rule ID 2146 //
     /* 213781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 213784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 213796 */     // (strict_fadd:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VADDPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 213796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDYrr),
     /* 213801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213805 */     GIR_RootConstrainSelectedInstOperands,
     /* 213806 */     // GIR_Coverage, 2146,
     /* 213806 */     GIR_Done,
     /* 213807 */   // Label 4899: @213807
     /* 213807 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(213838), // Rule ID 6316 //
     /* 213812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 213815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 213827 */     // (strict_fadd:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VADDPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 213827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZ256rr),
     /* 213832 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213836 */     GIR_RootConstrainSelectedInstOperands,
     /* 213837 */     // GIR_Coverage, 6316,
     /* 213837 */     GIR_Done,
     /* 213838 */   // Label 4900: @213838
     /* 213838 */   GIM_Reject,
     /* 213839 */ // Label 4894: @213839
     /* 213839 */ GIM_Reject,
     /* 213840 */ // Label 4821: @213840
     /* 213840 */ GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(213999),
     /* 213845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 213848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 213851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213855 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(213913), // Rule ID 24319 //
     /* 213860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 213867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213871 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213874 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213878 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213888 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213895 */     // (strict_fadd:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213900 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 213902 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213911 */     GIR_RootConstrainSelectedInstOperands,
     /* 213912 */     // GIR_Coverage, 24319,
     /* 213912 */     GIR_EraseRootFromParent_Done,
     /* 213913 */   // Label 4902: @213913
     /* 213913 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(213971), // Rule ID 6344 //
     /* 213918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 213933 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 213936 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 213940 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 213944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213946 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 213953 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 213953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rm),
     /* 213956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 213958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 213960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 213964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 213969 */     GIR_RootConstrainSelectedInstOperands,
     /* 213970 */     // GIR_Coverage, 6344,
     /* 213970 */     GIR_EraseRootFromParent_Done,
     /* 213971 */   // Label 4903: @213971
     /* 213971 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(213998), // Rule ID 6340 //
     /* 213976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 213979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 213987 */     // (strict_fadd:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VADDPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 213987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ128rr),
     /* 213992 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 213996 */     GIR_RootConstrainSelectedInstOperands,
     /* 213997 */     // GIR_Coverage, 6340,
     /* 213997 */     GIR_Done,
     /* 213998 */   // Label 4904: @213998
     /* 213998 */   GIM_Reject,
     /* 213999 */ // Label 4901: @213999
     /* 213999 */ GIM_Reject,
     /* 214000 */ // Label 4822: @214000
     /* 214000 */ GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(214322),
     /* 214005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 214008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 214011 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(214073), // Rule ID 23373 //
     /* 214016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214031 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214034 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214038 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214048 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214055 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214060 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214071 */     GIR_RootConstrainSelectedInstOperands,
     /* 214072 */     // GIR_Coverage, 23373,
     /* 214072 */     GIR_EraseRootFromParent_Done,
     /* 214073 */   // Label 4906: @214073
     /* 214073 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(214135), // Rule ID 24287 //
     /* 214078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214093 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214096 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214117 */     // (strict_fadd:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214122 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214133 */     GIR_RootConstrainSelectedInstOperands,
     /* 214134 */     // GIR_Coverage, 24287,
     /* 214134 */     GIR_EraseRootFromParent_Done,
     /* 214135 */   // Label 4907: @214135
     /* 214135 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(214197), // Rule ID 2144 //
     /* 214140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214179 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSYrm),
     /* 214182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214195 */     GIR_RootConstrainSelectedInstOperands,
     /* 214196 */     // GIR_Coverage, 2144,
     /* 214196 */     GIR_EraseRootFromParent_Done,
     /* 214197 */   // Label 4908: @214197
     /* 214197 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(214259), // Rule ID 6296 //
     /* 214202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214221 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214228 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214234 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214241 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rm),
     /* 214244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214246 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214248 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214252 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214257 */     GIR_RootConstrainSelectedInstOperands,
     /* 214258 */     // GIR_Coverage, 6296,
     /* 214258 */     GIR_EraseRootFromParent_Done,
     /* 214259 */   // Label 4909: @214259
     /* 214259 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(214290), // Rule ID 2142 //
     /* 214264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 214267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 214279 */     // (strict_fadd:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VADDPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 214279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSYrr),
     /* 214284 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214288 */     GIR_RootConstrainSelectedInstOperands,
     /* 214289 */     // GIR_Coverage, 2142,
     /* 214289 */     GIR_Done,
     /* 214290 */   // Label 4910: @214290
     /* 214290 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(214321), // Rule ID 6292 //
     /* 214295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 214298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214310 */     // (strict_fadd:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VADDPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 214310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZ256rr),
     /* 214315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214319 */     GIR_RootConstrainSelectedInstOperands,
     /* 214320 */     // GIR_Coverage, 6292,
     /* 214320 */     GIR_Done,
     /* 214321 */   // Label 4911: @214321
     /* 214321 */   GIM_Reject,
     /* 214322 */ // Label 4905: @214322
     /* 214322 */ GIM_Reject,
     /* 214323 */ // Label 4823: @214323
     /* 214323 */ GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(214482),
     /* 214328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 214331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 214334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214338 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(214396), // Rule ID 24271 //
     /* 214343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214354 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214357 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214361 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214378 */     // (strict_fadd:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214383 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214394 */     GIR_RootConstrainSelectedInstOperands,
     /* 214395 */     // GIR_Coverage, 24271,
     /* 214395 */     GIR_EraseRootFromParent_Done,
     /* 214396 */   // Label 4913: @214396
     /* 214396 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(214454), // Rule ID 6272 //
     /* 214401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214416 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214419 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214423 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214429 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214436 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPDZrm),
     /* 214439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214441 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214443 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214452 */     GIR_RootConstrainSelectedInstOperands,
     /* 214453 */     // GIR_Coverage, 6272,
     /* 214453 */     GIR_EraseRootFromParent_Done,
     /* 214454 */   // Label 4914: @214454
     /* 214454 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(214481), // Rule ID 6268 //
     /* 214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214470 */     // (strict_fadd:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VADDPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 214470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPDZrr),
     /* 214475 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214479 */     GIR_RootConstrainSelectedInstOperands,
     /* 214480 */     // GIR_Coverage, 6268,
     /* 214480 */     GIR_Done,
     /* 214481 */   // Label 4915: @214481
     /* 214481 */   GIM_Reject,
     /* 214482 */ // Label 4912: @214482
     /* 214482 */ GIM_Reject,
     /* 214483 */ // Label 4824: @214483
     /* 214483 */ GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(214642),
     /* 214488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 214491 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 214494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214498 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(214556), // Rule ID 24327 //
     /* 214503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214531 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214538 */     // (strict_fadd:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214545 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214554 */     GIR_RootConstrainSelectedInstOperands,
     /* 214555 */     // GIR_Coverage, 24327,
     /* 214555 */     GIR_EraseRootFromParent_Done,
     /* 214556 */   // Label 4917: @214556
     /* 214556 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(214614), // Rule ID 6356 //
     /* 214561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214576 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214583 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214589 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214596 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rm),
     /* 214599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214601 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214603 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214612 */     GIR_RootConstrainSelectedInstOperands,
     /* 214613 */     // GIR_Coverage, 6356,
     /* 214613 */     GIR_EraseRootFromParent_Done,
     /* 214614 */   // Label 4918: @214614
     /* 214614 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(214641), // Rule ID 6352 //
     /* 214619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 214622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 214630 */     // (strict_fadd:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VADDPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 214630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZ256rr),
     /* 214635 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214639 */     GIR_RootConstrainSelectedInstOperands,
     /* 214640 */     // GIR_Coverage, 6352,
     /* 214640 */     GIR_Done,
     /* 214641 */   // Label 4919: @214641
     /* 214641 */   GIM_Reject,
     /* 214642 */ // Label 4916: @214642
     /* 214642 */ GIM_Reject,
     /* 214643 */ // Label 4825: @214643
     /* 214643 */ GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(214802),
     /* 214648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 214651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 214654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214658 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(214716), // Rule ID 24263 //
     /* 214663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214698 */     // (strict_fadd:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214703 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214705 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214709 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214714 */     GIR_RootConstrainSelectedInstOperands,
     /* 214715 */     // GIR_Coverage, 24263,
     /* 214715 */     GIR_EraseRootFromParent_Done,
     /* 214716 */   // Label 4921: @214716
     /* 214716 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(214774), // Rule ID 6260 //
     /* 214721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214736 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214739 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214743 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214749 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214756 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPSZrm),
     /* 214759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214761 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214763 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214772 */     GIR_RootConstrainSelectedInstOperands,
     /* 214773 */     // GIR_Coverage, 6260,
     /* 214773 */     GIR_EraseRootFromParent_Done,
     /* 214774 */   // Label 4922: @214774
     /* 214774 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(214801), // Rule ID 6256 //
     /* 214779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 214782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214790 */     // (strict_fadd:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VADDPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 214790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPSZrr),
     /* 214795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214799 */     GIR_RootConstrainSelectedInstOperands,
     /* 214800 */     // GIR_Coverage, 6256,
     /* 214800 */     GIR_Done,
     /* 214801 */   // Label 4923: @214801
     /* 214801 */   GIM_Reject,
     /* 214802 */ // Label 4920: @214802
     /* 214802 */ GIM_Reject,
     /* 214803 */ // Label 4826: @214803
     /* 214803 */ GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(214962),
     /* 214808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 214811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 214814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214818 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(214876), // Rule ID 24311 //
     /* 214823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 214830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214834 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214837 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214841 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214858 */     // (strict_fadd:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214863 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 214865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214874 */     GIR_RootConstrainSelectedInstOperands,
     /* 214875 */     // GIR_Coverage, 24311,
     /* 214875 */     GIR_EraseRootFromParent_Done,
     /* 214876 */   // Label 4925: @214876
     /* 214876 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(214934), // Rule ID 6332 //
     /* 214881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 214896 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 214899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 214903 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 214907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214909 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 214916 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VADDPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 214916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VADDPHZrm),
     /* 214919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214921 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 214923 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 214927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 214932 */     GIR_RootConstrainSelectedInstOperands,
     /* 214933 */     // GIR_Coverage, 6332,
     /* 214933 */     GIR_EraseRootFromParent_Done,
     /* 214934 */   // Label 4926: @214934
     /* 214934 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(214961), // Rule ID 6328 //
     /* 214939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 214942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 214950 */     // (strict_fadd:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VADDPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 214950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VADDPHZrr),
     /* 214955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 214959 */     GIR_RootConstrainSelectedInstOperands,
     /* 214960 */     // GIR_Coverage, 6328,
     /* 214960 */     GIR_Done,
     /* 214961 */   // Label 4927: @214961
     /* 214961 */   GIM_Reject,
     /* 214962 */ // Label 4924: @214962
     /* 214962 */ GIM_Reject,
     /* 214963 */ // Label 4827: @214963
     /* 214963 */ GIM_Reject,
     /* 214964 */ // Label 69: @214964
     /* 214964 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 4941*/ GIMT_Encode4(218653),
     /* 214975 */ /*GILLT_s16*//*Label 4928*/ GIMT_Encode4(215059),
     /* 214979 */ /*GILLT_s32*//*Label 4929*/ GIMT_Encode4(215157),
     /* 214983 */ /*GILLT_s64*//*Label 4930*/ GIMT_Encode4(215876),
     /* 214987 */ /*GILLT_s80*//*Label 4931*/ GIMT_Encode4(216739), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 214999 */ /*GILLT_v2s64*//*Label 4932*/ GIMT_Encode4(217305), GIMT_Encode4(0),
     /* 215007 */ /*GILLT_v4s32*//*Label 4933*/ GIMT_Encode4(217535),
     /* 215011 */ /*GILLT_v4s64*//*Label 4934*/ GIMT_Encode4(217765), GIMT_Encode4(0),
     /* 215019 */ /*GILLT_v8s16*//*Label 4935*/ GIMT_Encode4(217964),
     /* 215023 */ /*GILLT_v8s32*//*Label 4936*/ GIMT_Encode4(218062),
     /* 215027 */ /*GILLT_v8s64*//*Label 4937*/ GIMT_Encode4(218261), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215039 */ /*GILLT_v16s16*//*Label 4938*/ GIMT_Encode4(218359),
     /* 215043 */ /*GILLT_v16s32*//*Label 4939*/ GIMT_Encode4(218457), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 215055 */ /*GILLT_v32s16*//*Label 4940*/ GIMT_Encode4(218555),
     /* 215059 */ // Label 4928: @215059
     /* 215059 */ GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(215156),
     /* 215064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 215067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 215070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215078 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(215132), // Rule ID 6068 //
     /* 215083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215094 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215097 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215101 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215107 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215114 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrm),
     /* 215117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215119 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215130 */     GIR_RootConstrainSelectedInstOperands,
     /* 215131 */     // GIR_Coverage, 6068,
     /* 215131 */     GIR_EraseRootFromParent_Done,
     /* 215132 */   // Label 4943: @215132
     /* 215132 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(215155), // Rule ID 6066 //
     /* 215137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 215140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 215144 */     // (strict_fsub:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VSUBSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 215144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSHZrr),
     /* 215149 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215153 */     GIR_RootConstrainSelectedInstOperands,
     /* 215154 */     // GIR_Coverage, 6066,
     /* 215154 */     GIR_Done,
     /* 215155 */   // Label 4944: @215155
     /* 215155 */   GIM_Reject,
     /* 215156 */ // Label 4942: @215156
     /* 215156 */ GIM_Reject,
     /* 215157 */ // Label 4929: @215157
     /* 215157 */ GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(215875),
     /* 215162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 215165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 215168 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(215233), // Rule ID 964 //
     /* 215173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215188 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215195 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215205 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215212 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m32),
     /* 215215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215219 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215231 */     GIR_RootConstrainSelectedInstOperands,
     /* 215232 */     // GIR_Coverage, 964,
     /* 215232 */     GIR_EraseRootFromParent_Done,
     /* 215233 */   // Label 4946: @215233
     /* 215233 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(215298), // Rule ID 966 //
     /* 215238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215253 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215260 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215270 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215277 */     // (strict_fsub:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m32),
     /* 215280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215282 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215284 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215291 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215296 */     GIR_RootConstrainSelectedInstOperands,
     /* 215297 */     // GIR_Coverage, 966,
     /* 215297 */     GIR_EraseRootFromParent_Done,
     /* 215298 */   // Label 4947: @215298
     /* 215298 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(215363), // Rule ID 954 //
     /* 215303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215318 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215325 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215342 */     // (strict_fsub:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (SUBR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp32m),
     /* 215345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215347 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215349 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215361 */     GIR_RootConstrainSelectedInstOperands,
     /* 215362 */     // GIR_Coverage, 954,
     /* 215362 */     GIR_EraseRootFromParent_Done,
     /* 215363 */   // Label 4948: @215363
     /* 215363 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(215428), // Rule ID 942 //
     /* 215368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215387 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215394 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215407 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m32),
     /* 215410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215412 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215414 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215426 */     GIR_RootConstrainSelectedInstOperands,
     /* 215427 */     // GIR_Coverage, 942,
     /* 215427 */     GIR_EraseRootFromParent_Done,
     /* 215428 */   // Label 4949: @215428
     /* 215428 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(215493), // Rule ID 944 //
     /* 215433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215452 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215459 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215465 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215472 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m32),
     /* 215475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215477 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215479 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215483 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215491 */     GIR_RootConstrainSelectedInstOperands,
     /* 215492 */     // GIR_Coverage, 944,
     /* 215492 */     GIR_EraseRootFromParent_Done,
     /* 215493 */   // Label 4950: @215493
     /* 215493 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(215558), // Rule ID 932 //
     /* 215498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215517 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215520 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215524 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215537 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32m),
     /* 215540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215544 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215556 */     GIR_RootConstrainSelectedInstOperands,
     /* 215557 */     // GIR_Coverage, 932,
     /* 215557 */     GIR_EraseRootFromParent_Done,
     /* 215558 */   // Label 4951: @215558
     /* 215558 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(215620), // Rule ID 2240 //
     /* 215563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215602 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSrm),
     /* 215605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215618 */     GIR_RootConstrainSelectedInstOperands,
     /* 215619 */     // GIR_Coverage, 2240,
     /* 215619 */     GIR_EraseRootFromParent_Done,
     /* 215620 */   // Label 4952: @215620
     /* 215620 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(215682), // Rule ID 2248 //
     /* 215625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215664 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSSrm),
     /* 215667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215680 */     GIR_RootConstrainSelectedInstOperands,
     /* 215681 */     // GIR_Coverage, 2248,
     /* 215681 */     GIR_EraseRootFromParent_Done,
     /* 215682 */   // Label 4953: @215682
     /* 215682 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(215744), // Rule ID 6030 //
     /* 215687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 215702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 215706 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 215709 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 215713 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215719 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215726 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrm),
     /* 215729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215731 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 215733 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215742 */     GIR_RootConstrainSelectedInstOperands,
     /* 215743 */     // GIR_Coverage, 6030,
     /* 215743 */     GIR_EraseRootFromParent_Done,
     /* 215744 */   // Label 4954: @215744
     /* 215744 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(215781), // Rule ID 892 //
     /* 215749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 215752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 215764 */     // (strict_fsub:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (SUB_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 215764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp32),
     /* 215769 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 215775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 215779 */     GIR_RootConstrainSelectedInstOperands,
     /* 215780 */     // GIR_Coverage, 892,
     /* 215780 */     GIR_Done,
     /* 215781 */   // Label 4955: @215781
     /* 215781 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(215812), // Rule ID 2238 //
     /* 215786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 215789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215801 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VSUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSrr),
     /* 215806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215810 */     GIR_RootConstrainSelectedInstOperands,
     /* 215811 */     // GIR_Coverage, 2238,
     /* 215811 */     GIR_Done,
     /* 215812 */   // Label 4956: @215812
     /* 215812 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(215843), // Rule ID 2246 //
     /* 215817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 215820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 215832 */     // (strict_fsub:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (SUBSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 215832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSSrr),
     /* 215837 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215841 */     GIR_RootConstrainSelectedInstOperands,
     /* 215842 */     // GIR_Coverage, 2246,
     /* 215842 */     GIR_Done,
     /* 215843 */   // Label 4957: @215843
     /* 215843 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(215874), // Rule ID 6028 //
     /* 215848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 215851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 215863 */     // (strict_fsub:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VSUBSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 215863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSSZrr),
     /* 215868 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 215872 */     GIR_RootConstrainSelectedInstOperands,
     /* 215873 */     // GIR_Coverage, 6028,
     /* 215873 */     GIR_Done,
     /* 215874 */   // Label 4958: @215874
     /* 215874 */   GIM_Reject,
     /* 215875 */ // Label 4945: @215875
     /* 215875 */ GIM_Reject,
     /* 215876 */ // Label 4930: @215876
     /* 215876 */ GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(216738),
     /* 215881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 215884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 215887 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(215952), // Rule ID 968 //
     /* 215892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215907 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 215914 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215924 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215931 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m64),
     /* 215934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215936 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 215938 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 215942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 215945 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 215950 */     GIR_RootConstrainSelectedInstOperands,
     /* 215951 */     // GIR_Coverage, 968,
     /* 215951 */     GIR_EraseRootFromParent_Done,
     /* 215952 */   // Label 4960: @215952
     /* 215952 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(216017), // Rule ID 970 //
     /* 215957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 215960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 215968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 215972 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 215979 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 215983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 215987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 215989 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 215996 */     // (strict_fsub:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 215996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m64),
     /* 215999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216001 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216003 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216007 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216015 */     GIR_RootConstrainSelectedInstOperands,
     /* 216016 */     // GIR_Coverage, 970,
     /* 216016 */     GIR_EraseRootFromParent_Done,
     /* 216017 */   // Label 4961: @216017
     /* 216017 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(216082), // Rule ID 956 //
     /* 216022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216037 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216044 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216054 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216061 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m),
     /* 216064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216066 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216068 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216080 */     GIR_RootConstrainSelectedInstOperands,
     /* 216081 */     // GIR_Coverage, 956,
     /* 216081 */     GIR_EraseRootFromParent_Done,
     /* 216082 */   // Label 4962: @216082
     /* 216082 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(216154), // Rule ID 958 //
     /* 216087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216105 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216109 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216116 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216126 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216133 */     // (strict_fsub:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (SUBR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp64m32),
     /* 216136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216138 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216140 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216144 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216152 */     GIR_RootConstrainSelectedInstOperands,
     /* 216153 */     // GIR_Coverage, 958,
     /* 216153 */     GIR_EraseRootFromParent_Done,
     /* 216154 */   // Label 4963: @216154
     /* 216154 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(216219), // Rule ID 946 //
     /* 216159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216178 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216185 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216198 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m64),
     /* 216201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216203 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216217 */     GIR_RootConstrainSelectedInstOperands,
     /* 216218 */     // GIR_Coverage, 946,
     /* 216218 */     GIR_EraseRootFromParent_Done,
     /* 216219 */   // Label 4964: @216219
     /* 216219 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(216284), // Rule ID 948 //
     /* 216224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216243 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216250 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216256 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216263 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m64),
     /* 216266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216268 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216270 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216282 */     GIR_RootConstrainSelectedInstOperands,
     /* 216283 */     // GIR_Coverage, 948,
     /* 216283 */     GIR_EraseRootFromParent_Done,
     /* 216284 */   // Label 4965: @216284
     /* 216284 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(216349), // Rule ID 934 //
     /* 216289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216308 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216315 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216321 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216328 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUB_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m),
     /* 216331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216333 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216335 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216347 */     GIR_RootConstrainSelectedInstOperands,
     /* 216348 */     // GIR_Coverage, 934,
     /* 216348 */     GIR_EraseRootFromParent_Done,
     /* 216349 */   // Label 4966: @216349
     /* 216349 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(216421), // Rule ID 936 //
     /* 216354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216373 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216376 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216380 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216387 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216393 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216400 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64m32),
     /* 216403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216405 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216407 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216419 */     GIR_RootConstrainSelectedInstOperands,
     /* 216420 */     // GIR_Coverage, 936,
     /* 216420 */     GIR_EraseRootFromParent_Done,
     /* 216421 */   // Label 4967: @216421
     /* 216421 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(216483), // Rule ID 2244 //
     /* 216426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216445 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216448 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216452 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216458 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216465 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDrm),
     /* 216468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216470 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216472 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216481 */     GIR_RootConstrainSelectedInstOperands,
     /* 216482 */     // GIR_Coverage, 2244,
     /* 216482 */     GIR_EraseRootFromParent_Done,
     /* 216483 */   // Label 4968: @216483
     /* 216483 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(216545), // Rule ID 2252 //
     /* 216488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216507 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216510 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216514 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216520 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216527 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SUBSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBSDrm),
     /* 216530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216532 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216534 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216543 */     GIR_RootConstrainSelectedInstOperands,
     /* 216544 */     // GIR_Coverage, 2252,
     /* 216544 */     GIR_EraseRootFromParent_Done,
     /* 216545 */   // Label 4969: @216545
     /* 216545 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(216607), // Rule ID 6049 //
     /* 216550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 216565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216589 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrm),
     /* 216592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 216596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216605 */     GIR_RootConstrainSelectedInstOperands,
     /* 216606 */     // GIR_Coverage, 6049,
     /* 216606 */     GIR_EraseRootFromParent_Done,
     /* 216607 */   // Label 4970: @216607
     /* 216607 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(216644), // Rule ID 894 //
     /* 216612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 216615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 216627 */     // (strict_fsub:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (SUB_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 216627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp64),
     /* 216632 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 216638 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 216642 */     GIR_RootConstrainSelectedInstOperands,
     /* 216643 */     // GIR_Coverage, 894,
     /* 216643 */     GIR_Done,
     /* 216644 */   // Label 4971: @216644
     /* 216644 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(216675), // Rule ID 2242 //
     /* 216649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 216652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216664 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VSUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDrr),
     /* 216669 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216673 */     GIR_RootConstrainSelectedInstOperands,
     /* 216674 */     // GIR_Coverage, 2242,
     /* 216674 */     GIR_Done,
     /* 216675 */   // Label 4972: @216675
     /* 216675 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(216706), // Rule ID 2250 //
     /* 216680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 216683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 216695 */     // (strict_fsub:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (SUBSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 216695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBSDrr),
     /* 216700 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216704 */     GIR_RootConstrainSelectedInstOperands,
     /* 216705 */     // GIR_Coverage, 2250,
     /* 216705 */     GIR_Done,
     /* 216706 */   // Label 4973: @216706
     /* 216706 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(216737), // Rule ID 6047 //
     /* 216711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 216714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 216726 */     // (strict_fsub:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VSUBSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 216726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBSDZrr),
     /* 216731 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 216735 */     GIR_RootConstrainSelectedInstOperands,
     /* 216736 */     // GIR_Coverage, 6047,
     /* 216736 */     GIR_Done,
     /* 216737 */   // Label 4974: @216737
     /* 216737 */   GIM_Reject,
     /* 216738 */ // Label 4959: @216738
     /* 216738 */ GIM_Reject,
     /* 216739 */ // Label 4931: @216739
     /* 216739 */ GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(217304),
     /* 216744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 216747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 216750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216754 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(216815), // Rule ID 972 //
     /* 216759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216770 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 216777 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216787 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216794 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI16m80),
     /* 216797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216799 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216801 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216813 */     GIR_RootConstrainSelectedInstOperands,
     /* 216814 */     // GIR_Coverage, 972,
     /* 216814 */     GIR_EraseRootFromParent_Done,
     /* 216815 */   // Label 4976: @216815
     /* 216815 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(216876), // Rule ID 974 //
     /* 216820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 216831 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216838 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216848 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216855 */     // (strict_fsub:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_FpI32m80),
     /* 216858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216874 */     GIR_RootConstrainSelectedInstOperands,
     /* 216875 */     // GIR_Coverage, 974,
     /* 216875 */     GIR_EraseRootFromParent_Done,
     /* 216876 */   // Label 4977: @216876
     /* 216876 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(216944), // Rule ID 960 //
     /* 216881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216892 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216895 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216899 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 216906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216916 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216923 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m32),
     /* 216926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216928 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216930 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 216934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 216937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 216942 */     GIR_RootConstrainSelectedInstOperands,
     /* 216943 */     // GIR_Coverage, 960,
     /* 216943 */     GIR_EraseRootFromParent_Done,
     /* 216944 */   // Label 4978: @216944
     /* 216944 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(217012), // Rule ID 962 //
     /* 216949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 216952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 216956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 216960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 216963 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 216967 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 216974 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 216978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 216982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 216984 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 216991 */     // (strict_fsub:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (SUBR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 216991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUBR_Fp80m64),
     /* 216994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216996 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 216998 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217010 */     GIR_RootConstrainSelectedInstOperands,
     /* 217011 */     // GIR_Coverage, 962,
     /* 217011 */     GIR_EraseRootFromParent_Done,
     /* 217012 */   // Label 4979: @217012
     /* 217012 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(217073), // Rule ID 950 //
     /* 217017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217032 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 217039 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217052 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (SUB_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI16m80),
     /* 217055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217057 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217059 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217071 */     GIR_RootConstrainSelectedInstOperands,
     /* 217072 */     // GIR_Coverage, 950,
     /* 217072 */     GIR_EraseRootFromParent_Done,
     /* 217073 */   // Label 4980: @217073
     /* 217073 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(217134), // Rule ID 952 //
     /* 217078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 217093 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217100 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217113 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (SUB_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_FpI32m80),
     /* 217116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217118 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217120 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217132 */     GIR_RootConstrainSelectedInstOperands,
     /* 217133 */     // GIR_Coverage, 952,
     /* 217133 */     GIR_EraseRootFromParent_Done,
     /* 217134 */   // Label 4981: @217134
     /* 217134 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(217202), // Rule ID 938 //
     /* 217139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217154 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217157 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217161 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 217168 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217174 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217181 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (SUB_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m32),
     /* 217184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217186 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217200 */     GIR_RootConstrainSelectedInstOperands,
     /* 217201 */     // GIR_Coverage, 938,
     /* 217201 */     GIR_EraseRootFromParent_Done,
     /* 217202 */   // Label 4982: @217202
     /* 217202 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(217270), // Rule ID 940 //
     /* 217207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217225 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217229 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 217236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217242 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217249 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (SUB_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80m64),
     /* 217252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217254 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 217263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217268 */     GIR_RootConstrainSelectedInstOperands,
     /* 217269 */     // GIR_Coverage, 940,
     /* 217269 */     GIR_EraseRootFromParent_Done,
     /* 217270 */   // Label 4983: @217270
     /* 217270 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(217303), // Rule ID 896 //
     /* 217275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 217278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 217286 */     // (strict_fsub:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (SUB_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 217286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUB_Fp80),
     /* 217291 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 217297 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 217301 */     GIR_RootConstrainSelectedInstOperands,
     /* 217302 */     // GIR_Coverage, 896,
     /* 217302 */     GIR_Done,
     /* 217303 */   // Label 4984: @217303
     /* 217303 */   GIM_Reject,
     /* 217304 */ // Label 4975: @217304
     /* 217304 */ GIM_Reject,
     /* 217305 */ // Label 4932: @217305
     /* 217305 */ GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(217534),
     /* 217310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 217316 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(217378), // Rule ID 2220 //
     /* 217321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217340 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217343 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217347 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217360 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDrm),
     /* 217363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217365 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217367 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217376 */     GIR_RootConstrainSelectedInstOperands,
     /* 217377 */     // GIR_Coverage, 2220,
     /* 217377 */     GIR_EraseRootFromParent_Done,
     /* 217378 */   // Label 4986: @217378
     /* 217378 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(217440), // Rule ID 6542 //
     /* 217383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217402 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217405 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217409 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217422 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rm),
     /* 217425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217438 */     GIR_RootConstrainSelectedInstOperands,
     /* 217439 */     // GIR_Coverage, 6542,
     /* 217439 */     GIR_EraseRootFromParent_Done,
     /* 217440 */   // Label 4987: @217440
     /* 217440 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(217471), // Rule ID 2218 //
     /* 217445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217460 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VSUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDrr),
     /* 217465 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217469 */     GIR_RootConstrainSelectedInstOperands,
     /* 217470 */     // GIR_Coverage, 2218,
     /* 217470 */     GIR_Done,
     /* 217471 */   // Label 4988: @217471
     /* 217471 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(217502), // Rule ID 2234 //
     /* 217476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 217479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217491 */     // (strict_fsub:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (SUBPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 217491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPDrr),
     /* 217496 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217500 */     GIR_RootConstrainSelectedInstOperands,
     /* 217501 */     // GIR_Coverage, 2234,
     /* 217501 */     GIR_Done,
     /* 217502 */   // Label 4989: @217502
     /* 217502 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(217533), // Rule ID 6538 //
     /* 217507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217522 */     // (strict_fsub:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VSUBPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 217522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ128rr),
     /* 217527 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217531 */     GIR_RootConstrainSelectedInstOperands,
     /* 217532 */     // GIR_Coverage, 6538,
     /* 217532 */     GIR_Done,
     /* 217533 */   // Label 4990: @217533
     /* 217533 */   GIM_Reject,
     /* 217534 */ // Label 4985: @217534
     /* 217534 */ GIM_Reject,
     /* 217535 */ // Label 4933: @217535
     /* 217535 */ GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(217764),
     /* 217540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 217543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217546 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(217608), // Rule ID 2216 //
     /* 217551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217570 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217573 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217577 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217583 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217590 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSrm),
     /* 217593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217595 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217606 */     GIR_RootConstrainSelectedInstOperands,
     /* 217607 */     // GIR_Coverage, 2216,
     /* 217607 */     GIR_EraseRootFromParent_Done,
     /* 217608 */   // Label 4992: @217608
     /* 217608 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(217670), // Rule ID 6518 //
     /* 217613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217632 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217635 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217639 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217652 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rm),
     /* 217655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217657 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217659 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217668 */     GIR_RootConstrainSelectedInstOperands,
     /* 217669 */     // GIR_Coverage, 6518,
     /* 217669 */     GIR_EraseRootFromParent_Done,
     /* 217670 */   // Label 4993: @217670
     /* 217670 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(217701), // Rule ID 2214 //
     /* 217675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217690 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VSUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217690 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSrr),
     /* 217695 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217699 */     GIR_RootConstrainSelectedInstOperands,
     /* 217700 */     // GIR_Coverage, 2214,
     /* 217700 */     GIR_Done,
     /* 217701 */   // Label 4994: @217701
     /* 217701 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(217732), // Rule ID 2230 //
     /* 217706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 217709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 217721 */     // (strict_fsub:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (SUBPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 217721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SUBPSrr),
     /* 217726 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217730 */     GIR_RootConstrainSelectedInstOperands,
     /* 217731 */     // GIR_Coverage, 2230,
     /* 217731 */     GIR_Done,
     /* 217732 */   // Label 4995: @217732
     /* 217732 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(217763), // Rule ID 6514 //
     /* 217737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217752 */     // (strict_fsub:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VSUBPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 217752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ128rr),
     /* 217757 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217761 */     GIR_RootConstrainSelectedInstOperands,
     /* 217762 */     // GIR_Coverage, 6514,
     /* 217762 */     GIR_Done,
     /* 217763 */   // Label 4996: @217763
     /* 217763 */   GIM_Reject,
     /* 217764 */ // Label 4991: @217764
     /* 217764 */ GIM_Reject,
     /* 217765 */ // Label 4934: @217765
     /* 217765 */ GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(217963),
     /* 217770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 217773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 217776 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(217838), // Rule ID 2228 //
     /* 217781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217820 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrm),
     /* 217823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217825 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217827 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217831 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217836 */     GIR_RootConstrainSelectedInstOperands,
     /* 217837 */     // GIR_Coverage, 2228,
     /* 217837 */     GIR_EraseRootFromParent_Done,
     /* 217838 */   // Label 4998: @217838
     /* 217838 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(217900), // Rule ID 6554 //
     /* 217843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 217865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 217869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 217873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 217875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 217882 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 217882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rm),
     /* 217885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 217889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 217893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 217898 */     GIR_RootConstrainSelectedInstOperands,
     /* 217899 */     // GIR_Coverage, 6554,
     /* 217899 */     GIR_EraseRootFromParent_Done,
     /* 217900 */   // Label 4999: @217900
     /* 217900 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(217931), // Rule ID 2226 //
     /* 217905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 217908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 217920 */     // (strict_fsub:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VSUBPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 217920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDYrr),
     /* 217925 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217929 */     GIR_RootConstrainSelectedInstOperands,
     /* 217930 */     // GIR_Coverage, 2226,
     /* 217930 */     GIR_Done,
     /* 217931 */   // Label 5000: @217931
     /* 217931 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(217962), // Rule ID 6550 //
     /* 217936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 217939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 217951 */     // (strict_fsub:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VSUBPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 217951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZ256rr),
     /* 217956 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 217960 */     GIR_RootConstrainSelectedInstOperands,
     /* 217961 */     // GIR_Coverage, 6550,
     /* 217961 */     GIR_Done,
     /* 217962 */   // Label 5001: @217962
     /* 217962 */   GIM_Reject,
     /* 217963 */ // Label 4997: @217963
     /* 217963 */ GIM_Reject,
     /* 217964 */ // Label 4935: @217964
     /* 217964 */ GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(218061),
     /* 217969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 217972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 217983 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(218037), // Rule ID 6578 //
     /* 217988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 217991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 217995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 217999 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218002 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218006 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218012 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218019 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rm),
     /* 218022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218024 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218026 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218035 */     GIR_RootConstrainSelectedInstOperands,
     /* 218036 */     // GIR_Coverage, 6578,
     /* 218036 */     GIR_EraseRootFromParent_Done,
     /* 218037 */   // Label 5003: @218037
     /* 218037 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(218060), // Rule ID 6574 //
     /* 218042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 218049 */     // (strict_fsub:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VSUBPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 218049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ128rr),
     /* 218054 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218058 */     GIR_RootConstrainSelectedInstOperands,
     /* 218059 */     // GIR_Coverage, 6574,
     /* 218059 */     GIR_Done,
     /* 218060 */   // Label 5004: @218060
     /* 218060 */   GIM_Reject,
     /* 218061 */ // Label 5002: @218061
     /* 218061 */ GIM_Reject,
     /* 218062 */ // Label 4936: @218062
     /* 218062 */ GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(218260),
     /* 218067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 218070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 218073 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(218135), // Rule ID 2224 //
     /* 218078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218097 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218100 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218110 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218117 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrm),
     /* 218120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218122 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218124 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218133 */     GIR_RootConstrainSelectedInstOperands,
     /* 218134 */     // GIR_Coverage, 2224,
     /* 218134 */     GIR_EraseRootFromParent_Done,
     /* 218135 */   // Label 5006: @218135
     /* 218135 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(218197), // Rule ID 6530 //
     /* 218140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218159 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218162 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218166 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218179 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rm),
     /* 218182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218186 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218195 */     GIR_RootConstrainSelectedInstOperands,
     /* 218196 */     // GIR_Coverage, 6530,
     /* 218196 */     GIR_EraseRootFromParent_Done,
     /* 218197 */   // Label 5007: @218197
     /* 218197 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(218228), // Rule ID 2222 //
     /* 218202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 218205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 218217 */     // (strict_fsub:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VSUBPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 218217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSYrr),
     /* 218222 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218226 */     GIR_RootConstrainSelectedInstOperands,
     /* 218227 */     // GIR_Coverage, 2222,
     /* 218227 */     GIR_Done,
     /* 218228 */   // Label 5008: @218228
     /* 218228 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(218259), // Rule ID 6526 //
     /* 218233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 218236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218248 */     // (strict_fsub:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VSUBPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 218248 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZ256rr),
     /* 218253 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218257 */     GIR_RootConstrainSelectedInstOperands,
     /* 218258 */     // GIR_Coverage, 6526,
     /* 218258 */     GIR_Done,
     /* 218259 */   // Label 5009: @218259
     /* 218259 */   GIM_Reject,
     /* 218260 */ // Label 5005: @218260
     /* 218260 */ GIM_Reject,
     /* 218261 */ // Label 4937: @218261
     /* 218261 */ GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(218358),
     /* 218266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 218269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 218272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218280 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(218334), // Rule ID 6506 //
     /* 218285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218316 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrm),
     /* 218319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218332 */     GIR_RootConstrainSelectedInstOperands,
     /* 218333 */     // GIR_Coverage, 6506,
     /* 218333 */     GIR_EraseRootFromParent_Done,
     /* 218334 */   // Label 5011: @218334
     /* 218334 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(218357), // Rule ID 6502 //
     /* 218339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218346 */     // (strict_fsub:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VSUBPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 218346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPDZrr),
     /* 218351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218355 */     GIR_RootConstrainSelectedInstOperands,
     /* 218356 */     // GIR_Coverage, 6502,
     /* 218356 */     GIR_Done,
     /* 218357 */   // Label 5012: @218357
     /* 218357 */   GIM_Reject,
     /* 218358 */ // Label 5010: @218358
     /* 218358 */ GIM_Reject,
     /* 218359 */ // Label 4938: @218359
     /* 218359 */ GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(218456),
     /* 218364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 218367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 218370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218378 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(218432), // Rule ID 6590 //
     /* 218383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218394 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218397 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218401 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218414 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rm),
     /* 218417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218419 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218430 */     GIR_RootConstrainSelectedInstOperands,
     /* 218431 */     // GIR_Coverage, 6590,
     /* 218431 */     GIR_EraseRootFromParent_Done,
     /* 218432 */   // Label 5014: @218432
     /* 218432 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(218455), // Rule ID 6586 //
     /* 218437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 218440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 218444 */     // (strict_fsub:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VSUBPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 218444 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZ256rr),
     /* 218449 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218453 */     GIR_RootConstrainSelectedInstOperands,
     /* 218454 */     // GIR_Coverage, 6586,
     /* 218454 */     GIR_Done,
     /* 218455 */   // Label 5015: @218455
     /* 218455 */   GIM_Reject,
     /* 218456 */ // Label 5013: @218456
     /* 218456 */ GIM_Reject,
     /* 218457 */ // Label 4939: @218457
     /* 218457 */ GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(218554),
     /* 218462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 218465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 218468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218476 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(218530), // Rule ID 6494 //
     /* 218481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218492 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218499 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218512 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrm),
     /* 218515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218519 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218528 */     GIR_RootConstrainSelectedInstOperands,
     /* 218529 */     // GIR_Coverage, 6494,
     /* 218529 */     GIR_EraseRootFromParent_Done,
     /* 218530 */   // Label 5017: @218530
     /* 218530 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(218553), // Rule ID 6490 //
     /* 218535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 218538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218542 */     // (strict_fsub:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VSUBPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 218542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPSZrr),
     /* 218547 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218551 */     GIR_RootConstrainSelectedInstOperands,
     /* 218552 */     // GIR_Coverage, 6490,
     /* 218552 */     GIR_Done,
     /* 218553 */   // Label 5018: @218553
     /* 218553 */   GIM_Reject,
     /* 218554 */ // Label 5016: @218554
     /* 218554 */ GIM_Reject,
     /* 218555 */ // Label 4940: @218555
     /* 218555 */ GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(218652),
     /* 218560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 218563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 218566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218574 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(218628), // Rule ID 6566 //
     /* 218579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218590 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218593 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218597 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218610 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSUBPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrm),
     /* 218613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218615 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218617 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218626 */     GIR_RootConstrainSelectedInstOperands,
     /* 218627 */     // GIR_Coverage, 6566,
     /* 218627 */     GIR_EraseRootFromParent_Done,
     /* 218628 */   // Label 5020: @218628
     /* 218628 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(218651), // Rule ID 6562 //
     /* 218633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 218640 */     // (strict_fsub:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VSUBPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 218640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSUBPHZrr),
     /* 218645 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218649 */     GIR_RootConstrainSelectedInstOperands,
     /* 218650 */     // GIR_Coverage, 6562,
     /* 218650 */     GIR_Done,
     /* 218651 */   // Label 5021: @218651
     /* 218651 */   GIM_Reject,
     /* 218652 */ // Label 5019: @218652
     /* 218652 */ GIM_Reject,
     /* 218653 */ // Label 4941: @218653
     /* 218653 */ GIM_Reject,
     /* 218654 */ // Label 70: @218654
     /* 218654 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5035*/ GIMT_Encode4(223583),
     /* 218665 */ /*GILLT_s16*//*Label 5022*/ GIMT_Encode4(218749),
     /* 218669 */ /*GILLT_s32*//*Label 5023*/ GIMT_Encode4(218909),
     /* 218673 */ /*GILLT_s64*//*Label 5024*/ GIMT_Encode4(219814),
     /* 218677 */ /*GILLT_s80*//*Label 5025*/ GIMT_Encode4(220863), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218689 */ /*GILLT_v2s64*//*Label 5026*/ GIMT_Encode4(221429), GIMT_Encode4(0),
     /* 218697 */ /*GILLT_v4s32*//*Label 5027*/ GIMT_Encode4(221783),
     /* 218701 */ /*GILLT_v4s64*//*Label 5028*/ GIMT_Encode4(222137), GIMT_Encode4(0),
     /* 218709 */ /*GILLT_v8s16*//*Label 5029*/ GIMT_Encode4(222460),
     /* 218713 */ /*GILLT_v8s32*//*Label 5030*/ GIMT_Encode4(222620),
     /* 218717 */ /*GILLT_v8s64*//*Label 5031*/ GIMT_Encode4(222943), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218729 */ /*GILLT_v16s16*//*Label 5032*/ GIMT_Encode4(223103),
     /* 218733 */ /*GILLT_v16s32*//*Label 5033*/ GIMT_Encode4(223263), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 218745 */ /*GILLT_v32s16*//*Label 5034*/ GIMT_Encode4(223423),
     /* 218749 */ // Label 5022: @218749
     /* 218749 */ GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(218908),
     /* 218754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 218757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 218760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218764 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(218822), // Rule ID 24255 //
     /* 218769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218780 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218783 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218787 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218797 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218804 */     // (strict_fmul:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218809 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218811 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218820 */     GIR_RootConstrainSelectedInstOperands,
     /* 218821 */     // GIR_Coverage, 24255,
     /* 218821 */     GIR_EraseRootFromParent_Done,
     /* 218822 */   // Label 5037: @218822
     /* 218822 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(218880), // Rule ID 6011 //
     /* 218827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 218838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 218842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 218845 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 218849 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218855 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218862 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSHZrm),
     /* 218865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218867 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 218869 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218878 */     GIR_RootConstrainSelectedInstOperands,
     /* 218879 */     // GIR_Coverage, 6011,
     /* 218879 */     GIR_EraseRootFromParent_Done,
     /* 218880 */   // Label 5038: @218880
     /* 218880 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(218907), // Rule ID 6009 //
     /* 218885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 218888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 218896 */     // (strict_fmul:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VMULSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 218896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSHZrr),
     /* 218901 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 218905 */     GIR_RootConstrainSelectedInstOperands,
     /* 218906 */     // GIR_Coverage, 6009,
     /* 218906 */     GIR_Done,
     /* 218907 */   // Label 5039: @218907
     /* 218907 */   GIM_Reject,
     /* 218908 */ // Label 5036: @218908
     /* 218908 */ GIM_Reject,
     /* 218909 */ // Label 5023: @218909
     /* 218909 */ GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(219813),
     /* 218914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 218917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218920 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(218985), // Rule ID 23268 //
     /* 218925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 218936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 218940 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 218947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 218951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 218957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 218964 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 218964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 218967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218969 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 218971 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 218975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 218978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 218983 */     GIR_RootConstrainSelectedInstOperands,
     /* 218984 */     // GIR_Coverage, 23268,
     /* 218984 */     GIR_EraseRootFromParent_Done,
     /* 218985 */   // Label 5041: @218985
     /* 218985 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(219050), // Rule ID 23270 //
     /* 218990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 218993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 218997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219005 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219012 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219029 */     // (strict_fmul:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219034 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219036 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219048 */     GIR_RootConstrainSelectedInstOperands,
     /* 219049 */     // GIR_Coverage, 23270,
     /* 219049 */     GIR_EraseRootFromParent_Done,
     /* 219050 */   // Label 5042: @219050
     /* 219050 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(219115), // Rule ID 23258 //
     /* 219055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219087 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219094 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219099 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219101 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219113 */     GIR_RootConstrainSelectedInstOperands,
     /* 219114 */     // GIR_Coverage, 23258,
     /* 219114 */     GIR_EraseRootFromParent_Done,
     /* 219115 */   // Label 5043: @219115
     /* 219115 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(219177), // Rule ID 23401 //
     /* 219120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219159 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219164 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219175 */     GIR_RootConstrainSelectedInstOperands,
     /* 219176 */     // GIR_Coverage, 23401,
     /* 219176 */     GIR_EraseRootFromParent_Done,
     /* 219177 */   // Label 5044: @219177
     /* 219177 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(219239), // Rule ID 23405 //
     /* 219182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219197 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219200 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219204 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219221 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219226 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219228 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219237 */     GIR_RootConstrainSelectedInstOperands,
     /* 219238 */     // GIR_Coverage, 23405,
     /* 219238 */     GIR_EraseRootFromParent_Done,
     /* 219239 */   // Label 5045: @219239
     /* 219239 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(219301), // Rule ID 24251 //
     /* 219244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219259 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219262 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219266 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219276 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219283 */     // (strict_fmul:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219288 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219290 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219299 */     GIR_RootConstrainSelectedInstOperands,
     /* 219300 */     // GIR_Coverage, 24251,
     /* 219300 */     GIR_EraseRootFromParent_Done,
     /* 219301 */   // Label 5046: @219301
     /* 219301 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(219366), // Rule ID 986 //
     /* 219306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219325 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219332 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219338 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219345 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m32),
     /* 219348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219350 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219356 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219364 */     GIR_RootConstrainSelectedInstOperands,
     /* 219365 */     // GIR_Coverage, 986,
     /* 219365 */     GIR_EraseRootFromParent_Done,
     /* 219366 */   // Label 5047: @219366
     /* 219366 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(219431), // Rule ID 988 //
     /* 219371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219390 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219403 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219410 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m32),
     /* 219413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219429 */     GIR_RootConstrainSelectedInstOperands,
     /* 219430 */     // GIR_Coverage, 988,
     /* 219430 */     GIR_EraseRootFromParent_Done,
     /* 219431 */   // Label 5048: @219431
     /* 219431 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(219496), // Rule ID 976 //
     /* 219436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219455 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219458 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219462 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219475 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32m),
     /* 219478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219480 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219494 */     GIR_RootConstrainSelectedInstOperands,
     /* 219495 */     // GIR_Coverage, 976,
     /* 219495 */     GIR_EraseRootFromParent_Done,
     /* 219496 */   // Label 5049: @219496
     /* 219496 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(219558), // Rule ID 2200 //
     /* 219501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219520 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219523 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219527 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219533 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219540 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSrm),
     /* 219543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219545 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219556 */     GIR_RootConstrainSelectedInstOperands,
     /* 219557 */     // GIR_Coverage, 2200,
     /* 219557 */     GIR_EraseRootFromParent_Done,
     /* 219558 */   // Label 5050: @219558
     /* 219558 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(219620), // Rule ID 2208 //
     /* 219563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219582 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219589 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219602 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSSrm),
     /* 219605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219607 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219609 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219618 */     GIR_RootConstrainSelectedInstOperands,
     /* 219619 */     // GIR_Coverage, 2208,
     /* 219619 */     GIR_EraseRootFromParent_Done,
     /* 219620 */   // Label 5051: @219620
     /* 219620 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(219682), // Rule ID 5973 //
     /* 219625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 219640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219644 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219647 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219651 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219657 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219664 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSSZrm),
     /* 219667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219669 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 219671 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219675 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219680 */     GIR_RootConstrainSelectedInstOperands,
     /* 219681 */     // GIR_Coverage, 5973,
     /* 219681 */     GIR_EraseRootFromParent_Done,
     /* 219682 */   // Label 5052: @219682
     /* 219682 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(219719), // Rule ID 898 //
     /* 219687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 219690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 219702 */     // (strict_fmul:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (MUL_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 219702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp32),
     /* 219707 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 219713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 219717 */     GIR_RootConstrainSelectedInstOperands,
     /* 219718 */     // GIR_Coverage, 898,
     /* 219718 */     GIR_Done,
     /* 219719 */   // Label 5053: @219719
     /* 219719 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(219750), // Rule ID 2198 //
     /* 219724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 219727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219739 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VMULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSrr),
     /* 219744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219748 */     GIR_RootConstrainSelectedInstOperands,
     /* 219749 */     // GIR_Coverage, 2198,
     /* 219749 */     GIR_Done,
     /* 219750 */   // Label 5054: @219750
     /* 219750 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(219781), // Rule ID 2206 //
     /* 219755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 219758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 219770 */     // (strict_fmul:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (MULSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 219770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSSrr),
     /* 219775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219779 */     GIR_RootConstrainSelectedInstOperands,
     /* 219780 */     // GIR_Coverage, 2206,
     /* 219780 */     GIR_Done,
     /* 219781 */   // Label 5055: @219781
     /* 219781 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(219812), // Rule ID 5971 //
     /* 219786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 219789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 219801 */     // (strict_fmul:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VMULSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 219801 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSSZrr),
     /* 219806 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 219810 */     GIR_RootConstrainSelectedInstOperands,
     /* 219811 */     // GIR_Coverage, 5971,
     /* 219811 */     GIR_Done,
     /* 219812 */   // Label 5056: @219812
     /* 219812 */   GIM_Reject,
     /* 219813 */ // Label 5040: @219813
     /* 219813 */ GIM_Reject,
     /* 219814 */ // Label 5024: @219814
     /* 219814 */ GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(220862),
     /* 219819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 219822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 219825 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(219890), // Rule ID 23272 //
     /* 219830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219845 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 219852 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219869 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 219872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219874 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219888 */     GIR_RootConstrainSelectedInstOperands,
     /* 219889 */     // GIR_Coverage, 23272,
     /* 219889 */     GIR_EraseRootFromParent_Done,
     /* 219890 */   // Label 5058: @219890
     /* 219890 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(219955), // Rule ID 23274 //
     /* 219895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 219910 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 219917 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219934 */     // (strict_fmul:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 219937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219939 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 219941 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 219945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 219948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 219953 */     GIR_RootConstrainSelectedInstOperands,
     /* 219954 */     // GIR_Coverage, 23274,
     /* 219954 */     GIR_EraseRootFromParent_Done,
     /* 219955 */   // Label 5059: @219955
     /* 219955 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(220020), // Rule ID 23260 //
     /* 219960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 219963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 219971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 219975 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 219978 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 219982 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 219986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 219990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 219992 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 219999 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 219999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 220002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220004 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220006 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220018 */     GIR_RootConstrainSelectedInstOperands,
     /* 220019 */     // GIR_Coverage, 23260,
     /* 220019 */     GIR_EraseRootFromParent_Done,
     /* 220020 */   // Label 5060: @220020
     /* 220020 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(220092), // Rule ID 23262 //
     /* 220025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220040 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220043 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220047 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220054 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220064 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220071 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220078 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220090 */     GIR_RootConstrainSelectedInstOperands,
     /* 220091 */     // GIR_Coverage, 23262,
     /* 220091 */     GIR_EraseRootFromParent_Done,
     /* 220092 */   // Label 5061: @220092
     /* 220092 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(220154), // Rule ID 23403 //
     /* 220097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220129 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220136 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220141 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220143 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220152 */     GIR_RootConstrainSelectedInstOperands,
     /* 220153 */     // GIR_Coverage, 23403,
     /* 220153 */     GIR_EraseRootFromParent_Done,
     /* 220154 */   // Label 5062: @220154
     /* 220154 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(220216), // Rule ID 23407 //
     /* 220159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220174 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220181 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220198 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220203 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220205 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220214 */     GIR_RootConstrainSelectedInstOperands,
     /* 220215 */     // GIR_Coverage, 23407,
     /* 220215 */     GIR_EraseRootFromParent_Done,
     /* 220216 */   // Label 5063: @220216
     /* 220216 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(220278), // Rule ID 24253 //
     /* 220221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220236 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220239 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220243 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220253 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220260 */     // (strict_fmul:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220267 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220276 */     GIR_RootConstrainSelectedInstOperands,
     /* 220277 */     // GIR_Coverage, 24253,
     /* 220277 */     GIR_EraseRootFromParent_Done,
     /* 220278 */   // Label 5064: @220278
     /* 220278 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(220343), // Rule ID 990 //
     /* 220283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220302 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220309 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220322 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m64),
     /* 220325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220327 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220329 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220341 */     GIR_RootConstrainSelectedInstOperands,
     /* 220342 */     // GIR_Coverage, 990,
     /* 220342 */     GIR_EraseRootFromParent_Done,
     /* 220343 */   // Label 5065: @220343
     /* 220343 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(220408), // Rule ID 992 //
     /* 220348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220367 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220374 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220380 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220387 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m64),
     /* 220390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220392 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220406 */     GIR_RootConstrainSelectedInstOperands,
     /* 220407 */     // GIR_Coverage, 992,
     /* 220407 */     GIR_EraseRootFromParent_Done,
     /* 220408 */   // Label 5066: @220408
     /* 220408 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(220473), // Rule ID 978 //
     /* 220413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220432 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220435 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220439 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220452 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MUL_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m),
     /* 220455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220457 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220459 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220471 */     GIR_RootConstrainSelectedInstOperands,
     /* 220472 */     // GIR_Coverage, 978,
     /* 220472 */     GIR_EraseRootFromParent_Done,
     /* 220473 */   // Label 5067: @220473
     /* 220473 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(220545), // Rule ID 980 //
     /* 220478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220497 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220500 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220504 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220511 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220517 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220524 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64m32),
     /* 220527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220529 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220543 */     GIR_RootConstrainSelectedInstOperands,
     /* 220544 */     // GIR_Coverage, 980,
     /* 220544 */     GIR_EraseRootFromParent_Done,
     /* 220545 */   // Label 5068: @220545
     /* 220545 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(220607), // Rule ID 2204 //
     /* 220550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220569 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220576 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220582 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220589 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDrm),
     /* 220592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220594 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220596 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220600 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220605 */     GIR_RootConstrainSelectedInstOperands,
     /* 220606 */     // GIR_Coverage, 2204,
     /* 220606 */     GIR_EraseRootFromParent_Done,
     /* 220607 */   // Label 5069: @220607
     /* 220607 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(220669), // Rule ID 2212 //
     /* 220612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220631 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220634 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220638 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220644 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220651 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (MULSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MULSDrm),
     /* 220654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220656 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220667 */     GIR_RootConstrainSelectedInstOperands,
     /* 220668 */     // GIR_Coverage, 2212,
     /* 220668 */     GIR_EraseRootFromParent_Done,
     /* 220669 */   // Label 5070: @220669
     /* 220669 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(220731), // Rule ID 5992 //
     /* 220674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 220689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 220693 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 220696 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 220700 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220713 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULSDZrm),
     /* 220716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 220720 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220729 */     GIR_RootConstrainSelectedInstOperands,
     /* 220730 */     // GIR_Coverage, 5992,
     /* 220730 */     GIR_EraseRootFromParent_Done,
     /* 220731 */   // Label 5071: @220731
     /* 220731 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(220768), // Rule ID 900 //
     /* 220736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 220739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 220751 */     // (strict_fmul:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (MUL_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 220751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp64),
     /* 220756 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 220762 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 220766 */     GIR_RootConstrainSelectedInstOperands,
     /* 220767 */     // GIR_Coverage, 900,
     /* 220767 */     GIR_Done,
     /* 220768 */   // Label 5072: @220768
     /* 220768 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(220799), // Rule ID 2202 //
     /* 220773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 220776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220788 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VMULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDrr),
     /* 220793 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220797 */     GIR_RootConstrainSelectedInstOperands,
     /* 220798 */     // GIR_Coverage, 2202,
     /* 220798 */     GIR_Done,
     /* 220799 */   // Label 5073: @220799
     /* 220799 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(220830), // Rule ID 2210 //
     /* 220804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 220807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 220819 */     // (strict_fmul:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (MULSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 220819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULSDrr),
     /* 220824 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220828 */     GIR_RootConstrainSelectedInstOperands,
     /* 220829 */     // GIR_Coverage, 2210,
     /* 220829 */     GIR_Done,
     /* 220830 */   // Label 5074: @220830
     /* 220830 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(220861), // Rule ID 5990 //
     /* 220835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 220838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 220850 */     // (strict_fmul:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VMULSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 220850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULSDZrr),
     /* 220855 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 220859 */     GIR_RootConstrainSelectedInstOperands,
     /* 220860 */     // GIR_Coverage, 5990,
     /* 220860 */     GIR_Done,
     /* 220861 */   // Label 5075: @220861
     /* 220861 */   GIM_Reject,
     /* 220862 */ // Label 5057: @220862
     /* 220862 */ GIM_Reject,
     /* 220863 */ // Label 5025: @220863
     /* 220863 */ GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(221428),
     /* 220868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 220871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 220874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220878 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(220939), // Rule ID 23276 //
     /* 220883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220894 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 220901 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220918 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 220921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220923 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220925 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220937 */     GIR_RootConstrainSelectedInstOperands,
     /* 220938 */     // GIR_Coverage, 23276,
     /* 220938 */     GIR_EraseRootFromParent_Done,
     /* 220939 */   // Label 5077: @220939
     /* 220939 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(221000), // Rule ID 23278 //
     /* 220944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 220947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 220951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 220955 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 220962 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 220966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 220970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 220972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 220979 */     // (strict_fmul:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 220979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 220982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 220986 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 220990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 220993 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 220998 */     GIR_RootConstrainSelectedInstOperands,
     /* 220999 */     // GIR_Coverage, 23278,
     /* 220999 */     GIR_EraseRootFromParent_Done,
     /* 221000 */   // Label 5078: @221000
     /* 221000 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(221068), // Rule ID 23264 //
     /* 221005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221016 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221019 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221023 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221040 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221047 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221052 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221054 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221061 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221066 */     GIR_RootConstrainSelectedInstOperands,
     /* 221067 */     // GIR_Coverage, 23264,
     /* 221067 */     GIR_EraseRootFromParent_Done,
     /* 221068 */   // Label 5079: @221068
     /* 221068 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(221136), // Rule ID 23266 //
     /* 221073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221084 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221087 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221091 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221098 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221108 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221115 */     // (strict_fmul:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221120 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221122 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221134 */     GIR_RootConstrainSelectedInstOperands,
     /* 221135 */     // GIR_Coverage, 23266,
     /* 221135 */     GIR_EraseRootFromParent_Done,
     /* 221136 */   // Label 5080: @221136
     /* 221136 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(221197), // Rule ID 994 //
     /* 221141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221156 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 221163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221169 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221176 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (MUL_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI16m80),
     /* 221179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221181 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221183 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221195 */     GIR_RootConstrainSelectedInstOperands,
     /* 221196 */     // GIR_Coverage, 994,
     /* 221196 */     GIR_EraseRootFromParent_Done,
     /* 221197 */   // Label 5081: @221197
     /* 221197 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(221258), // Rule ID 996 //
     /* 221202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 221217 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221224 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221230 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221237 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (MUL_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_FpI32m80),
     /* 221240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221242 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221256 */     GIR_RootConstrainSelectedInstOperands,
     /* 221257 */     // GIR_Coverage, 996,
     /* 221257 */     GIR_EraseRootFromParent_Done,
     /* 221258 */   // Label 5082: @221258
     /* 221258 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(221326), // Rule ID 982 //
     /* 221263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221278 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221281 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221285 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 221292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221305 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (MUL_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m32),
     /* 221308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221310 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221312 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221324 */     GIR_RootConstrainSelectedInstOperands,
     /* 221325 */     // GIR_Coverage, 982,
     /* 221325 */     GIR_EraseRootFromParent_Done,
     /* 221326 */   // Label 5083: @221326
     /* 221326 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(221394), // Rule ID 984 //
     /* 221331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221346 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221349 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221353 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 221360 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221373 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (MUL_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80m64),
     /* 221376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221378 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221380 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 221387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221392 */     GIR_RootConstrainSelectedInstOperands,
     /* 221393 */     // GIR_Coverage, 984,
     /* 221393 */     GIR_EraseRootFromParent_Done,
     /* 221394 */   // Label 5084: @221394
     /* 221394 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(221427), // Rule ID 902 //
     /* 221399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 221402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 221410 */     // (strict_fmul:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (MUL_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 221410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MUL_Fp80),
     /* 221415 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 221421 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 221425 */     GIR_RootConstrainSelectedInstOperands,
     /* 221426 */     // GIR_Coverage, 902,
     /* 221426 */     GIR_Done,
     /* 221427 */   // Label 5085: @221427
     /* 221427 */   GIM_Reject,
     /* 221428 */ // Label 5076: @221428
     /* 221428 */ GIM_Reject,
     /* 221429 */ // Label 5026: @221429
     /* 221429 */ GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(221782),
     /* 221434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 221437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 221440 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(221502), // Rule ID 23391 //
     /* 221445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221460 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221463 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221467 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221477 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221484 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221489 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221500 */     GIR_RootConstrainSelectedInstOperands,
     /* 221501 */     // GIR_Coverage, 23391,
     /* 221501 */     GIR_EraseRootFromParent_Done,
     /* 221502 */   // Label 5087: @221502
     /* 221502 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(221564), // Rule ID 24367 //
     /* 221507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221522 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221525 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221529 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221539 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221546 */     // (strict_fmul:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221551 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221553 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221562 */     GIR_RootConstrainSelectedInstOperands,
     /* 221563 */     // GIR_Coverage, 24367,
     /* 221563 */     GIR_EraseRootFromParent_Done,
     /* 221564 */   // Label 5088: @221564
     /* 221564 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(221626), // Rule ID 2180 //
     /* 221569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221588 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221591 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221595 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221608 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDrm),
     /* 221611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221613 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221624 */     GIR_RootConstrainSelectedInstOperands,
     /* 221625 */     // GIR_Coverage, 2180,
     /* 221625 */     GIR_EraseRootFromParent_Done,
     /* 221626 */   // Label 5089: @221626
     /* 221626 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(221688), // Rule ID 6425 //
     /* 221631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221650 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221657 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221663 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221670 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rm),
     /* 221673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221675 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221686 */     GIR_RootConstrainSelectedInstOperands,
     /* 221687 */     // GIR_Coverage, 6425,
     /* 221687 */     GIR_EraseRootFromParent_Done,
     /* 221688 */   // Label 5090: @221688
     /* 221688 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(221719), // Rule ID 2178 //
     /* 221693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221708 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VMULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDrr),
     /* 221713 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221717 */     GIR_RootConstrainSelectedInstOperands,
     /* 221718 */     // GIR_Coverage, 2178,
     /* 221718 */     GIR_Done,
     /* 221719 */   // Label 5091: @221719
     /* 221719 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(221750), // Rule ID 2194 //
     /* 221724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 221727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221739 */     // (strict_fmul:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (MULPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 221739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPDrr),
     /* 221744 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221748 */     GIR_RootConstrainSelectedInstOperands,
     /* 221749 */     // GIR_Coverage, 2194,
     /* 221749 */     GIR_Done,
     /* 221750 */   // Label 5092: @221750
     /* 221750 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(221781), // Rule ID 6421 //
     /* 221755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221770 */     // (strict_fmul:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VMULPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 221770 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ128rr),
     /* 221775 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 221779 */     GIR_RootConstrainSelectedInstOperands,
     /* 221780 */     // GIR_Coverage, 6421,
     /* 221780 */     GIR_Done,
     /* 221781 */   // Label 5093: @221781
     /* 221781 */   GIM_Reject,
     /* 221782 */ // Label 5086: @221782
     /* 221782 */ GIM_Reject,
     /* 221783 */ // Label 5027: @221783
     /* 221783 */ GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(222136),
     /* 221788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 221791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 221794 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(221856), // Rule ID 23389 //
     /* 221799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221814 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221817 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221821 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221831 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221838 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221843 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221845 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221854 */     GIR_RootConstrainSelectedInstOperands,
     /* 221855 */     // GIR_Coverage, 23389,
     /* 221855 */     GIR_EraseRootFromParent_Done,
     /* 221856 */   // Label 5095: @221856
     /* 221856 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(221918), // Rule ID 24351 //
     /* 221861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 221872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221876 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221879 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221883 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221893 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221900 */     // (strict_fmul:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 221903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221905 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 221907 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221916 */     GIR_RootConstrainSelectedInstOperands,
     /* 221917 */     // GIR_Coverage, 24351,
     /* 221917 */     GIR_EraseRootFromParent_Done,
     /* 221918 */   // Label 5096: @221918
     /* 221918 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(221980), // Rule ID 2176 //
     /* 221923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 221926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 221934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 221938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 221942 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 221945 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 221949 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 221953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 221955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 221962 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 221962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSrm),
     /* 221965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 221967 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 221969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 221973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 221978 */     GIR_RootConstrainSelectedInstOperands,
     /* 221979 */     // GIR_Coverage, 2176,
     /* 221979 */     GIR_EraseRootFromParent_Done,
     /* 221980 */   // Label 5097: @221980
     /* 221980 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(222042), // Rule ID 6401 //
     /* 221985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 221988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 221996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222004 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222007 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222011 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222024 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rm),
     /* 222027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222031 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222035 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222040 */     GIR_RootConstrainSelectedInstOperands,
     /* 222041 */     // GIR_Coverage, 6401,
     /* 222041 */     GIR_EraseRootFromParent_Done,
     /* 222042 */   // Label 5098: @222042
     /* 222042 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(222073), // Rule ID 2174 //
     /* 222047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222062 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VMULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSrr),
     /* 222067 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222071 */     GIR_RootConstrainSelectedInstOperands,
     /* 222072 */     // GIR_Coverage, 2174,
     /* 222072 */     GIR_Done,
     /* 222073 */   // Label 5099: @222073
     /* 222073 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(222104), // Rule ID 2190 //
     /* 222078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 222081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 222093 */     // (strict_fmul:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (MULPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 222093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::MULPSrr),
     /* 222098 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222102 */     GIR_RootConstrainSelectedInstOperands,
     /* 222103 */     // GIR_Coverage, 2190,
     /* 222103 */     GIR_Done,
     /* 222104 */   // Label 5100: @222104
     /* 222104 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(222135), // Rule ID 6397 //
     /* 222109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222124 */     // (strict_fmul:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VMULPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 222124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ128rr),
     /* 222129 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222133 */     GIR_RootConstrainSelectedInstOperands,
     /* 222134 */     // GIR_Coverage, 6397,
     /* 222134 */     GIR_Done,
     /* 222135 */   // Label 5101: @222135
     /* 222135 */   GIM_Reject,
     /* 222136 */ // Label 5094: @222136
     /* 222136 */ GIM_Reject,
     /* 222137 */ // Label 5028: @222137
     /* 222137 */ GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(222459),
     /* 222142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 222145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 222148 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(222210), // Rule ID 23395 //
     /* 222153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222168 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222175 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222185 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222192 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222197 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222199 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222208 */     GIR_RootConstrainSelectedInstOperands,
     /* 222209 */     // GIR_Coverage, 23395,
     /* 222209 */     GIR_EraseRootFromParent_Done,
     /* 222210 */   // Label 5103: @222210
     /* 222210 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(222272), // Rule ID 24375 //
     /* 222215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222230 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222233 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222237 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222247 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222254 */     // (strict_fmul:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222259 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222261 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222270 */     GIR_RootConstrainSelectedInstOperands,
     /* 222271 */     // GIR_Coverage, 24375,
     /* 222271 */     GIR_EraseRootFromParent_Done,
     /* 222272 */   // Label 5104: @222272
     /* 222272 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(222334), // Rule ID 2188 //
     /* 222277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222296 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222299 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222303 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222309 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222316 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDYrm),
     /* 222319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222321 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222323 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222332 */     GIR_RootConstrainSelectedInstOperands,
     /* 222333 */     // GIR_Coverage, 2188,
     /* 222333 */     GIR_EraseRootFromParent_Done,
     /* 222334 */   // Label 5105: @222334
     /* 222334 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(222396), // Rule ID 6437 //
     /* 222339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222358 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222361 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222365 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222371 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222378 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rm),
     /* 222381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222385 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222394 */     GIR_RootConstrainSelectedInstOperands,
     /* 222395 */     // GIR_Coverage, 6437,
     /* 222395 */     GIR_EraseRootFromParent_Done,
     /* 222396 */   // Label 5106: @222396
     /* 222396 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(222427), // Rule ID 2186 //
     /* 222401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222416 */     // (strict_fmul:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VMULPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 222416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDYrr),
     /* 222421 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222425 */     GIR_RootConstrainSelectedInstOperands,
     /* 222426 */     // GIR_Coverage, 2186,
     /* 222426 */     GIR_Done,
     /* 222427 */   // Label 5107: @222427
     /* 222427 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(222458), // Rule ID 6433 //
     /* 222432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222447 */     // (strict_fmul:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VMULPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 222447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZ256rr),
     /* 222452 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222456 */     GIR_RootConstrainSelectedInstOperands,
     /* 222457 */     // GIR_Coverage, 6433,
     /* 222457 */     GIR_Done,
     /* 222458 */   // Label 5108: @222458
     /* 222458 */   GIM_Reject,
     /* 222459 */ // Label 5102: @222459
     /* 222459 */ GIM_Reject,
     /* 222460 */ // Label 5029: @222460
     /* 222460 */ GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(222619),
     /* 222465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 222468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 222471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222475 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(222533), // Rule ID 24391 //
     /* 222480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222491 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222498 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222508 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222515 */     // (strict_fmul:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222520 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222522 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222531 */     GIR_RootConstrainSelectedInstOperands,
     /* 222532 */     // GIR_Coverage, 24391,
     /* 222532 */     GIR_EraseRootFromParent_Done,
     /* 222533 */   // Label 5110: @222533
     /* 222533 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(222591), // Rule ID 6461 //
     /* 222538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222553 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222556 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222560 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222573 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rm),
     /* 222576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222578 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222580 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222589 */     GIR_RootConstrainSelectedInstOperands,
     /* 222590 */     // GIR_Coverage, 6461,
     /* 222590 */     GIR_EraseRootFromParent_Done,
     /* 222591 */   // Label 5111: @222591
     /* 222591 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(222618), // Rule ID 6457 //
     /* 222596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 222599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 222607 */     // (strict_fmul:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VMULPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 222607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ128rr),
     /* 222612 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222616 */     GIR_RootConstrainSelectedInstOperands,
     /* 222617 */     // GIR_Coverage, 6457,
     /* 222617 */     GIR_Done,
     /* 222618 */   // Label 5112: @222618
     /* 222618 */   GIM_Reject,
     /* 222619 */ // Label 5109: @222619
     /* 222619 */ GIM_Reject,
     /* 222620 */ // Label 5030: @222620
     /* 222620 */ GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(222942),
     /* 222625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 222628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 222631 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(222693), // Rule ID 23393 //
     /* 222636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222651 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222654 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222658 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222668 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222675 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222680 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222682 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222691 */     GIR_RootConstrainSelectedInstOperands,
     /* 222692 */     // GIR_Coverage, 23393,
     /* 222692 */     GIR_EraseRootFromParent_Done,
     /* 222693 */   // Label 5114: @222693
     /* 222693 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(222755), // Rule ID 24359 //
     /* 222698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222713 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222716 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222737 */     // (strict_fmul:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222742 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 222744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222753 */     GIR_RootConstrainSelectedInstOperands,
     /* 222754 */     // GIR_Coverage, 24359,
     /* 222754 */     GIR_EraseRootFromParent_Done,
     /* 222755 */   // Label 5115: @222755
     /* 222755 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(222817), // Rule ID 2184 //
     /* 222760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222799 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSYrm),
     /* 222802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222815 */     GIR_RootConstrainSelectedInstOperands,
     /* 222816 */     // GIR_Coverage, 2184,
     /* 222816 */     GIR_EraseRootFromParent_Done,
     /* 222817 */   // Label 5116: @222817
     /* 222817 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(222879), // Rule ID 6413 //
     /* 222822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 222837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222841 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222844 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222848 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222854 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222861 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rm),
     /* 222864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 222866 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 222868 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 222872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 222877 */     GIR_RootConstrainSelectedInstOperands,
     /* 222878 */     // GIR_Coverage, 6413,
     /* 222878 */     GIR_EraseRootFromParent_Done,
     /* 222879 */   // Label 5117: @222879
     /* 222879 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(222910), // Rule ID 2182 //
     /* 222884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 222887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 222899 */     // (strict_fmul:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VMULPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 222899 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSYrr),
     /* 222904 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222908 */     GIR_RootConstrainSelectedInstOperands,
     /* 222909 */     // GIR_Coverage, 2182,
     /* 222909 */     GIR_Done,
     /* 222910 */   // Label 5118: @222910
     /* 222910 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(222941), // Rule ID 6409 //
     /* 222915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 222918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 222930 */     // (strict_fmul:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VMULPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 222930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZ256rr),
     /* 222935 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 222939 */     GIR_RootConstrainSelectedInstOperands,
     /* 222940 */     // GIR_Coverage, 6409,
     /* 222940 */     GIR_Done,
     /* 222941 */   // Label 5119: @222941
     /* 222941 */   GIM_Reject,
     /* 222942 */ // Label 5113: @222942
     /* 222942 */ GIM_Reject,
     /* 222943 */ // Label 5031: @222943
     /* 222943 */ GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(223102),
     /* 222948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 222951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 222954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222958 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(223016), // Rule ID 24343 //
     /* 222963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 222966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 222970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 222974 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 222977 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 222981 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 222985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 222989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 222991 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 222998 */     // (strict_fmul:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 222998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 223001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223003 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223005 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223014 */     GIR_RootConstrainSelectedInstOperands,
     /* 223015 */     // GIR_Coverage, 24343,
     /* 223015 */     GIR_EraseRootFromParent_Done,
     /* 223016 */   // Label 5121: @223016
     /* 223016 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(223074), // Rule ID 6389 //
     /* 223021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223043 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223049 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223056 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPDZrm),
     /* 223059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223061 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223063 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223072 */     GIR_RootConstrainSelectedInstOperands,
     /* 223073 */     // GIR_Coverage, 6389,
     /* 223073 */     GIR_EraseRootFromParent_Done,
     /* 223074 */   // Label 5122: @223074
     /* 223074 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(223101), // Rule ID 6385 //
     /* 223079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223090 */     // (strict_fmul:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VMULPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 223090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPDZrr),
     /* 223095 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223099 */     GIR_RootConstrainSelectedInstOperands,
     /* 223100 */     // GIR_Coverage, 6385,
     /* 223100 */     GIR_Done,
     /* 223101 */   // Label 5123: @223101
     /* 223101 */   GIM_Reject,
     /* 223102 */ // Label 5120: @223102
     /* 223102 */ GIM_Reject,
     /* 223103 */ // Label 5032: @223103
     /* 223103 */ GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(223262),
     /* 223108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 223111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 223114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223118 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(223176), // Rule ID 24399 //
     /* 223123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223134 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223141 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223151 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223158 */     // (strict_fmul:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223163 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223165 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223174 */     GIR_RootConstrainSelectedInstOperands,
     /* 223175 */     // GIR_Coverage, 24399,
     /* 223175 */     GIR_EraseRootFromParent_Done,
     /* 223176 */   // Label 5125: @223176
     /* 223176 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(223234), // Rule ID 6473 //
     /* 223181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223196 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223199 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223209 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223216 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rm),
     /* 223219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223221 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223232 */     GIR_RootConstrainSelectedInstOperands,
     /* 223233 */     // GIR_Coverage, 6473,
     /* 223233 */     GIR_EraseRootFromParent_Done,
     /* 223234 */   // Label 5126: @223234
     /* 223234 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(223261), // Rule ID 6469 //
     /* 223239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 223242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 223250 */     // (strict_fmul:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VMULPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 223250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZ256rr),
     /* 223255 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223259 */     GIR_RootConstrainSelectedInstOperands,
     /* 223260 */     // GIR_Coverage, 6469,
     /* 223260 */     GIR_Done,
     /* 223261 */   // Label 5127: @223261
     /* 223261 */   GIM_Reject,
     /* 223262 */ // Label 5124: @223262
     /* 223262 */ GIM_Reject,
     /* 223263 */ // Label 5033: @223263
     /* 223263 */ GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(223422),
     /* 223268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 223271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 223274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223278 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(223336), // Rule ID 24335 //
     /* 223283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223294 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223297 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223301 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223318 */     // (strict_fmul:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223323 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223325 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223334 */     GIR_RootConstrainSelectedInstOperands,
     /* 223335 */     // GIR_Coverage, 24335,
     /* 223335 */     GIR_EraseRootFromParent_Done,
     /* 223336 */   // Label 5129: @223336
     /* 223336 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(223394), // Rule ID 6377 //
     /* 223341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223356 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223359 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223369 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223376 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPSZrm),
     /* 223379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223381 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223383 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223392 */     GIR_RootConstrainSelectedInstOperands,
     /* 223393 */     // GIR_Coverage, 6377,
     /* 223393 */     GIR_EraseRootFromParent_Done,
     /* 223394 */   // Label 5130: @223394
     /* 223394 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(223421), // Rule ID 6373 //
     /* 223399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 223402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223410 */     // (strict_fmul:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VMULPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 223410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPSZrr),
     /* 223415 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223419 */     GIR_RootConstrainSelectedInstOperands,
     /* 223420 */     // GIR_Coverage, 6373,
     /* 223420 */     GIR_Done,
     /* 223421 */   // Label 5131: @223421
     /* 223421 */   GIM_Reject,
     /* 223422 */ // Label 5128: @223422
     /* 223422 */ GIM_Reject,
     /* 223423 */ // Label 5034: @223423
     /* 223423 */ GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(223582),
     /* 223428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 223431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 223434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223438 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(223496), // Rule ID 24383 //
     /* 223443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223478 */     // (strict_fmul:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223483 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223485 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223494 */     GIR_RootConstrainSelectedInstOperands,
     /* 223495 */     // GIR_Coverage, 24383,
     /* 223495 */     GIR_EraseRootFromParent_Done,
     /* 223496 */   // Label 5133: @223496
     /* 223496 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(223554), // Rule ID 6449 //
     /* 223501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223516 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223519 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223523 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223529 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223536 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VMULPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VMULPHZrm),
     /* 223539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223541 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223543 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223552 */     GIR_RootConstrainSelectedInstOperands,
     /* 223553 */     // GIR_Coverage, 6449,
     /* 223553 */     GIR_EraseRootFromParent_Done,
     /* 223554 */   // Label 5134: @223554
     /* 223554 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(223581), // Rule ID 6445 //
     /* 223559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 223570 */     // (strict_fmul:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VMULPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 223570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VMULPHZrr),
     /* 223575 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223579 */     GIR_RootConstrainSelectedInstOperands,
     /* 223580 */     // GIR_Coverage, 6445,
     /* 223580 */     GIR_Done,
     /* 223581 */   // Label 5135: @223581
     /* 223581 */   GIM_Reject,
     /* 223582 */ // Label 5132: @223582
     /* 223582 */ GIM_Reject,
     /* 223583 */ // Label 5035: @223583
     /* 223583 */ GIM_Reject,
     /* 223584 */ // Label 71: @223584
     /* 223584 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5149*/ GIMT_Encode4(227273),
     /* 223595 */ /*GILLT_s16*//*Label 5136*/ GIMT_Encode4(223679),
     /* 223599 */ /*GILLT_s32*//*Label 5137*/ GIMT_Encode4(223777),
     /* 223603 */ /*GILLT_s64*//*Label 5138*/ GIMT_Encode4(224496),
     /* 223607 */ /*GILLT_s80*//*Label 5139*/ GIMT_Encode4(225359), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223619 */ /*GILLT_v2s64*//*Label 5140*/ GIMT_Encode4(225925), GIMT_Encode4(0),
     /* 223627 */ /*GILLT_v4s32*//*Label 5141*/ GIMT_Encode4(226155),
     /* 223631 */ /*GILLT_v4s64*//*Label 5142*/ GIMT_Encode4(226385), GIMT_Encode4(0),
     /* 223639 */ /*GILLT_v8s16*//*Label 5143*/ GIMT_Encode4(226584),
     /* 223643 */ /*GILLT_v8s32*//*Label 5144*/ GIMT_Encode4(226682),
     /* 223647 */ /*GILLT_v8s64*//*Label 5145*/ GIMT_Encode4(226881), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223659 */ /*GILLT_v16s16*//*Label 5146*/ GIMT_Encode4(226979),
     /* 223663 */ /*GILLT_v16s32*//*Label 5147*/ GIMT_Encode4(227077), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 223675 */ /*GILLT_v32s16*//*Label 5148*/ GIMT_Encode4(227175),
     /* 223679 */ // Label 5136: @223679
     /* 223679 */ GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(223776),
     /* 223684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 223687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 223690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223698 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(223752), // Rule ID 6125 //
     /* 223703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 223710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223727 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223734 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSHZrm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrm),
     /* 223737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223739 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 223741 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223745 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223750 */     GIR_RootConstrainSelectedInstOperands,
     /* 223751 */     // GIR_Coverage, 6125,
     /* 223751 */     GIR_EraseRootFromParent_Done,
     /* 223752 */   // Label 5151: @223752
     /* 223752 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(223775), // Rule ID 6123 //
     /* 223757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 223760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 223764 */     // (strict_fdiv:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VDIVSHZrr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)
     /* 223764 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSHZrr),
     /* 223769 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 223773 */     GIR_RootConstrainSelectedInstOperands,
     /* 223774 */     // GIR_Coverage, 6123,
     /* 223774 */     GIR_Done,
     /* 223775 */   // Label 5152: @223775
     /* 223775 */   GIM_Reject,
     /* 223776 */ // Label 5150: @223776
     /* 223776 */ GIM_Reject,
     /* 223777 */ // Label 5137: @223777
     /* 223777 */ GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(224495),
     /* 223782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 223785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 223788 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(223853), // Rule ID 1030 //
     /* 223793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223808 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 223815 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223825 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223832 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m32),
     /* 223835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223837 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223839 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223851 */     GIR_RootConstrainSelectedInstOperands,
     /* 223852 */     // GIR_Coverage, 1030,
     /* 223852 */     GIR_EraseRootFromParent_Done,
     /* 223853 */   // Label 5154: @223853
     /* 223853 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(223918), // Rule ID 1032 //
     /* 223858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 223873 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 223880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223897 */     // (strict_fdiv:{ *:[f32] } (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m32),
     /* 223900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223902 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223904 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223916 */     GIR_RootConstrainSelectedInstOperands,
     /* 223917 */     // GIR_Coverage, 1032,
     /* 223917 */     GIR_EraseRootFromParent_Done,
     /* 223918 */   // Label 5155: @223918
     /* 223918 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(223983), // Rule ID 1020 //
     /* 223923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 223934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 223938 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 223941 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 223945 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 223949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 223955 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 223962 */     // (strict_fdiv:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP32:{ *:[f32] }:$src1)  =>  (DIVR_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 223962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp32m),
     /* 223965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 223967 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 223969 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 223973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 223976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 223981 */     GIR_RootConstrainSelectedInstOperands,
     /* 223982 */     // GIR_Coverage, 1020,
     /* 223982 */     GIR_EraseRootFromParent_Done,
     /* 223983 */   // Label 5156: @223983
     /* 223983 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(224048), // Rule ID 1008 //
     /* 223988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 223991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 223999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224007 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224014 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224027 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m32),
     /* 224030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224032 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224034 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224046 */     GIR_RootConstrainSelectedInstOperands,
     /* 224047 */     // GIR_Coverage, 1008,
     /* 224047 */     GIR_EraseRootFromParent_Done,
     /* 224048 */   // Label 5157: @224048
     /* 224048 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(224113), // Rule ID 1010 //
     /* 224053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224072 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224079 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224085 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224092 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m32),
     /* 224095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224099 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224111 */     GIR_RootConstrainSelectedInstOperands,
     /* 224112 */     // GIR_Coverage, 1010,
     /* 224112 */     GIR_EraseRootFromParent_Done,
     /* 224113 */   // Label 5158: @224113
     /* 224113 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(224178), // Rule ID 998 //
     /* 224118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224137 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224144 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224157 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp32m:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32m),
     /* 224160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224164 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224171 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224176 */     GIR_RootConstrainSelectedInstOperands,
     /* 224177 */     // GIR_Coverage, 998,
     /* 224177 */     GIR_EraseRootFromParent_Done,
     /* 224178 */   // Label 5159: @224178
     /* 224178 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(224240), // Rule ID 2280 //
     /* 224183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224202 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224205 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224209 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224215 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224222 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSrm),
     /* 224225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224238 */     GIR_RootConstrainSelectedInstOperands,
     /* 224239 */     // GIR_Coverage, 2280,
     /* 224239 */     GIR_EraseRootFromParent_Done,
     /* 224240 */   // Label 5160: @224240
     /* 224240 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(224302), // Rule ID 2288 //
     /* 224245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224271 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224277 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224284 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSSrm:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSSrm),
     /* 224287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224289 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224291 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224300 */     GIR_RootConstrainSelectedInstOperands,
     /* 224301 */     // GIR_Coverage, 2288,
     /* 224301 */     GIR_EraseRootFromParent_Done,
     /* 224302 */   // Label 5161: @224302
     /* 224302 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(224364), // Rule ID 6087 //
     /* 224307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224326 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224329 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224333 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224339 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224346 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSSZrm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrm),
     /* 224349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224351 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224353 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224362 */     GIR_RootConstrainSelectedInstOperands,
     /* 224363 */     // GIR_Coverage, 6087,
     /* 224363 */     GIR_EraseRootFromParent_Done,
     /* 224364 */   // Label 5162: @224364
     /* 224364 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(224401), // Rule ID 904 //
     /* 224369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 224372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 224384 */     // (strict_fdiv:{ *:[f32] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)  =>  (DIV_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src1, RFP32:{ *:[f32] }:$src2)
     /* 224384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp32),
     /* 224389 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 224395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 224399 */     GIR_RootConstrainSelectedInstOperands,
     /* 224400 */     // GIR_Coverage, 904,
     /* 224400 */     GIR_Done,
     /* 224401 */   // Label 5163: @224401
     /* 224401 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(224432), // Rule ID 2278 //
     /* 224406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 224409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224421 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VDIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSrr),
     /* 224426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224430 */     GIR_RootConstrainSelectedInstOperands,
     /* 224431 */     // GIR_Coverage, 2278,
     /* 224431 */     GIR_Done,
     /* 224432 */   // Label 5164: @224432
     /* 224432 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(224463), // Rule ID 2286 //
     /* 224437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 224440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 224452 */     // (strict_fdiv:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (DIVSSrr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)
     /* 224452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSSrr),
     /* 224457 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224461 */     GIR_RootConstrainSelectedInstOperands,
     /* 224462 */     // GIR_Coverage, 2286,
     /* 224462 */     GIR_Done,
     /* 224463 */   // Label 5165: @224463
     /* 224463 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(224494), // Rule ID 6085 //
     /* 224468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 224471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 224483 */     // (strict_fdiv:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VDIVSSZrr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)
     /* 224483 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSSZrr),
     /* 224488 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 224492 */     GIR_RootConstrainSelectedInstOperands,
     /* 224493 */     // GIR_Coverage, 6085,
     /* 224493 */     GIR_Done,
     /* 224494 */   // Label 5166: @224494
     /* 224494 */   GIM_Reject,
     /* 224495 */ // Label 5153: @224495
     /* 224495 */ GIM_Reject,
     /* 224496 */ // Label 5138: @224496
     /* 224496 */ GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(225358),
     /* 224501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 224504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224507 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(224572), // Rule ID 1034 //
     /* 224512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224527 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224534 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224544 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224551 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m64),
     /* 224554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224556 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224558 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224565 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224570 */     GIR_RootConstrainSelectedInstOperands,
     /* 224571 */     // GIR_Coverage, 1034,
     /* 224571 */     GIR_EraseRootFromParent_Done,
     /* 224572 */   // Label 5168: @224572
     /* 224572 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(224637), // Rule ID 1036 //
     /* 224577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224592 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224599 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224616 */     // (strict_fdiv:{ *:[f64] } (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m64),
     /* 224619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224621 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224623 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224635 */     GIR_RootConstrainSelectedInstOperands,
     /* 224636 */     // GIR_Coverage, 1036,
     /* 224636 */     GIR_EraseRootFromParent_Done,
     /* 224637 */   // Label 5169: @224637
     /* 224637 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(224702), // Rule ID 1022 //
     /* 224642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224657 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224660 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224664 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224681 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m),
     /* 224684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224686 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224688 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224695 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224700 */     GIR_RootConstrainSelectedInstOperands,
     /* 224701 */     // GIR_Coverage, 1022,
     /* 224701 */     GIR_EraseRootFromParent_Done,
     /* 224702 */   // Label 5170: @224702
     /* 224702 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(224774), // Rule ID 1024 //
     /* 224707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 224718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224722 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224725 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224729 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224753 */     // (strict_fdiv:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP64:{ *:[f64] }:$src1)  =>  (DIVR_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp64m32),
     /* 224756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224758 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 224760 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224772 */     GIR_RootConstrainSelectedInstOperands,
     /* 224773 */     // GIR_Coverage, 1024,
     /* 224773 */     GIR_EraseRootFromParent_Done,
     /* 224774 */   // Label 5171: @224774
     /* 224774 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(224839), // Rule ID 1012 //
     /* 224779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224798 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 224805 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224811 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224818 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m64),
     /* 224821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224823 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224825 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224837 */     GIR_RootConstrainSelectedInstOperands,
     /* 224838 */     // GIR_Coverage, 1012,
     /* 224838 */     GIR_EraseRootFromParent_Done,
     /* 224839 */   // Label 5172: @224839
     /* 224839 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(224904), // Rule ID 1014 //
     /* 224844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 224863 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 224870 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224876 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224883 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m64),
     /* 224886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224888 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224890 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224897 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224902 */     GIR_RootConstrainSelectedInstOperands,
     /* 224903 */     // GIR_Coverage, 1014,
     /* 224903 */     GIR_EraseRootFromParent_Done,
     /* 224904 */   // Label 5173: @224904
     /* 224904 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(224969), // Rule ID 1000 //
     /* 224909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224928 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224931 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 224935 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 224939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 224941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 224948 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIV_Fp64m:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 224948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m),
     /* 224951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 224955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 224959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 224962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 224967 */     GIR_RootConstrainSelectedInstOperands,
     /* 224968 */     // GIR_Coverage, 1000,
     /* 224968 */     GIR_EraseRootFromParent_Done,
     /* 224969 */   // Label 5174: @224969
     /* 224969 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(225041), // Rule ID 1002 //
     /* 224974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 224977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 224985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 224989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 224993 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 224996 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225000 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225007 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225013 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225020 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp64m32:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64m32),
     /* 225023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225025 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225027 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225039 */     GIR_RootConstrainSelectedInstOperands,
     /* 225040 */     // GIR_Coverage, 1002,
     /* 225040 */     GIR_EraseRootFromParent_Done,
     /* 225041 */   // Label 5175: @225041
     /* 225041 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(225103), // Rule ID 2284 //
     /* 225046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225065 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225072 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225078 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225085 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDrm),
     /* 225088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225090 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225092 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225101 */     GIR_RootConstrainSelectedInstOperands,
     /* 225102 */     // GIR_Coverage, 2284,
     /* 225102 */     GIR_EraseRootFromParent_Done,
     /* 225103 */   // Label 5176: @225103
     /* 225103 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(225165), // Rule ID 2292 //
     /* 225108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225127 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225134 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225140 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225147 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (DIVSDrm:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVSDrm),
     /* 225150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225152 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225163 */     GIR_RootConstrainSelectedInstOperands,
     /* 225164 */     // GIR_Coverage, 2292,
     /* 225164 */     GIR_EraseRootFromParent_Done,
     /* 225165 */   // Label 5177: @225165
     /* 225165 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(225227), // Rule ID 6106 //
     /* 225170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225189 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225192 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225196 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225202 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225209 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVSDZrm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrm),
     /* 225212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225214 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225225 */     GIR_RootConstrainSelectedInstOperands,
     /* 225226 */     // GIR_Coverage, 6106,
     /* 225226 */     GIR_EraseRootFromParent_Done,
     /* 225227 */   // Label 5178: @225227
     /* 225227 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(225264), // Rule ID 906 //
     /* 225232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 225235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 225247 */     // (strict_fdiv:{ *:[f64] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)  =>  (DIV_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src1, RFP64:{ *:[f64] }:$src2)
     /* 225247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp64),
     /* 225252 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225258 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225262 */     GIR_RootConstrainSelectedInstOperands,
     /* 225263 */     // GIR_Coverage, 906,
     /* 225263 */     GIR_Done,
     /* 225264 */   // Label 5179: @225264
     /* 225264 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(225295), // Rule ID 2282 //
     /* 225269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 225272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225284 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VDIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDrr),
     /* 225289 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225293 */     GIR_RootConstrainSelectedInstOperands,
     /* 225294 */     // GIR_Coverage, 2282,
     /* 225294 */     GIR_Done,
     /* 225295 */   // Label 5180: @225295
     /* 225295 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(225326), // Rule ID 2290 //
     /* 225300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 225303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 225315 */     // (strict_fdiv:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (DIVSDrr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)
     /* 225315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVSDrr),
     /* 225320 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225324 */     GIR_RootConstrainSelectedInstOperands,
     /* 225325 */     // GIR_Coverage, 2290,
     /* 225325 */     GIR_Done,
     /* 225326 */   // Label 5181: @225326
     /* 225326 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(225357), // Rule ID 6104 //
     /* 225331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 225334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 225346 */     // (strict_fdiv:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VDIVSDZrr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)
     /* 225346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVSDZrr),
     /* 225351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 225355 */     GIR_RootConstrainSelectedInstOperands,
     /* 225356 */     // GIR_Coverage, 6104,
     /* 225356 */     GIR_Done,
     /* 225357 */   // Label 5182: @225357
     /* 225357 */   GIM_Reject,
     /* 225358 */ // Label 5167: @225358
     /* 225358 */ GIM_Reject,
     /* 225359 */ // Label 5139: @225359
     /* 225359 */ GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(225924),
     /* 225364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 225367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s80,
     /* 225370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225374 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(225435), // Rule ID 1038 //
     /* 225379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225390 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225397 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225407 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225414 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI16m80),
     /* 225417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225419 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225421 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225433 */     GIR_RootConstrainSelectedInstOperands,
     /* 225434 */     // GIR_Coverage, 1038,
     /* 225434 */     GIR_EraseRootFromParent_Done,
     /* 225435 */   // Label 5184: @225435
     /* 225435 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(225496), // Rule ID 1040 //
     /* 225440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225451 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225475 */     // (strict_fdiv:{ *:[f80] } (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_FpI32m80),
     /* 225478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225482 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225494 */     GIR_RootConstrainSelectedInstOperands,
     /* 225495 */     // GIR_Coverage, 1040,
     /* 225495 */     GIR_EraseRootFromParent_Done,
     /* 225496 */   // Label 5185: @225496
     /* 225496 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(225564), // Rule ID 1026 //
     /* 225501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225512 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225515 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225519 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225526 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225543 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m32),
     /* 225546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225548 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225557 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225562 */     GIR_RootConstrainSelectedInstOperands,
     /* 225563 */     // GIR_Coverage, 1026,
     /* 225563 */     GIR_EraseRootFromParent_Done,
     /* 225564 */   // Label 5186: @225564
     /* 225564 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(225632), // Rule ID 1028 //
     /* 225569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 225576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225580 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225583 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225587 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225594 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225604 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225611 */     // (strict_fdiv:{ *:[f80] } (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>, RFP80:{ *:[f80] }:$src1)  =>  (DIVR_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIVR_Fp80m64),
     /* 225614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 225618 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225630 */     GIR_RootConstrainSelectedInstOperands,
     /* 225631 */     // GIR_Coverage, 1028,
     /* 225631 */     GIR_EraseRootFromParent_Done,
     /* 225632 */   // Label 5187: @225632
     /* 225632 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(225693), // Rule ID 1016 //
     /* 225637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225652 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 225659 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225665 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225672 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild16>>)  =>  (DIV_FpI16m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI16m80),
     /* 225675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225677 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225679 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225691 */     GIR_RootConstrainSelectedInstOperands,
     /* 225692 */     // GIR_Coverage, 1016,
     /* 225692 */     GIR_EraseRootFromParent_Done,
     /* 225693 */   // Label 5188: @225693
     /* 225693 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(225754), // Rule ID 1018 //
     /* 225698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(X86::G_FILD),
     /* 225713 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225720 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225726 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225733 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_X86fild32>>)  =>  (DIV_FpI32m80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_FpI32m80),
     /* 225736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225738 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225740 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225752 */     GIR_RootConstrainSelectedInstOperands,
     /* 225753 */     // GIR_Coverage, 1018,
     /* 225753 */     GIR_EraseRootFromParent_Done,
     /* 225754 */   // Label 5189: @225754
     /* 225754 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(225822), // Rule ID 1004 //
     /* 225759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225774 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225777 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225781 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 225788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225801 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf32>>)  =>  (DIV_Fp80m32:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m32),
     /* 225804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225806 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225808 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225820 */     GIR_RootConstrainSelectedInstOperands,
     /* 225821 */     // GIR_Coverage, 1004,
     /* 225821 */     GIR_EraseRootFromParent_Done,
     /* 225822 */   // Label 5190: @225822
     /* 225822 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(225890), // Rule ID 1006 //
     /* 225827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225842 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225845 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225849 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 225856 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225869 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, (ld:{ *:[f80] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadf64>>)  =>  (DIV_Fp80m64:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80m64),
     /* 225872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225874 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 225883 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225888 */     GIR_RootConstrainSelectedInstOperands,
     /* 225889 */     // GIR_Coverage, 1006,
     /* 225889 */     GIR_EraseRootFromParent_Done,
     /* 225890 */   // Label 5191: @225890
     /* 225890 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(225923), // Rule ID 908 //
     /* 225895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 225898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 225906 */     // (strict_fdiv:{ *:[f80] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)  =>  (DIV_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src1, RFP80:{ *:[f80] }:$src2)
     /* 225906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIV_Fp80),
     /* 225911 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 225917 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 225921 */     GIR_RootConstrainSelectedInstOperands,
     /* 225922 */     // GIR_Coverage, 908,
     /* 225922 */     GIR_Done,
     /* 225923 */   // Label 5192: @225923
     /* 225923 */   GIM_Reject,
     /* 225924 */ // Label 5183: @225924
     /* 225924 */ GIM_Reject,
     /* 225925 */ // Label 5140: @225925
     /* 225925 */ GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(226154),
     /* 225930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 225933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225936 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(225998), // Rule ID 2260 //
     /* 225941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 225944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 225952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 225956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 225960 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 225963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 225967 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 225971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 225973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 225980 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDrm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 225980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDrm),
     /* 225983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 225985 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 225987 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 225991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 225996 */     GIR_RootConstrainSelectedInstOperands,
     /* 225997 */     // GIR_Coverage, 2260,
     /* 225997 */     GIR_EraseRootFromParent_Done,
     /* 225998 */   // Label 5194: @225998
     /* 225998 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(226060), // Rule ID 6659 //
     /* 226003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226022 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226029 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226035 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226042 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ128rm:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rm),
     /* 226045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226047 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226058 */     GIR_RootConstrainSelectedInstOperands,
     /* 226059 */     // GIR_Coverage, 6659,
     /* 226059 */     GIR_EraseRootFromParent_Done,
     /* 226060 */   // Label 5195: @226060
     /* 226060 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(226091), // Rule ID 2258 //
     /* 226065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226080 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VDIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDrr),
     /* 226085 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226089 */     GIR_RootConstrainSelectedInstOperands,
     /* 226090 */     // GIR_Coverage, 2258,
     /* 226090 */     GIR_Done,
     /* 226091 */   // Label 5196: @226091
     /* 226091 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(226122), // Rule ID 2274 //
     /* 226096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 226099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226111 */     // (strict_fdiv:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (DIVPDrr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)
     /* 226111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPDrr),
     /* 226116 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226120 */     GIR_RootConstrainSelectedInstOperands,
     /* 226121 */     // GIR_Coverage, 2274,
     /* 226121 */     GIR_Done,
     /* 226122 */   // Label 5197: @226122
     /* 226122 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(226153), // Rule ID 6655 //
     /* 226127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226142 */     // (strict_fdiv:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VDIVPDZ128rr:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)
     /* 226142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ128rr),
     /* 226147 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226151 */     GIR_RootConstrainSelectedInstOperands,
     /* 226152 */     // GIR_Coverage, 6655,
     /* 226152 */     GIR_Done,
     /* 226153 */   // Label 5198: @226153
     /* 226153 */   GIM_Reject,
     /* 226154 */ // Label 5193: @226154
     /* 226154 */ GIM_Reject,
     /* 226155 */ // Label 5141: @226155
     /* 226155 */ GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(226384),
     /* 226160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 226163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 226166 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(226228), // Rule ID 2256 //
     /* 226171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226210 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSrm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSrm),
     /* 226213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226215 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226226 */     GIR_RootConstrainSelectedInstOperands,
     /* 226227 */     // GIR_Coverage, 2256,
     /* 226227 */     GIR_EraseRootFromParent_Done,
     /* 226228 */   // Label 5200: @226228
     /* 226228 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(226290), // Rule ID 6635 //
     /* 226233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226252 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226255 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226259 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226272 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ128rm:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rm),
     /* 226275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226277 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226279 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226283 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226288 */     GIR_RootConstrainSelectedInstOperands,
     /* 226289 */     // GIR_Coverage, 6635,
     /* 226289 */     GIR_EraseRootFromParent_Done,
     /* 226290 */   // Label 5201: @226290
     /* 226290 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(226321), // Rule ID 2254 //
     /* 226295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226310 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VDIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226310 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSrr),
     /* 226315 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226319 */     GIR_RootConstrainSelectedInstOperands,
     /* 226320 */     // GIR_Coverage, 2254,
     /* 226320 */     GIR_Done,
     /* 226321 */   // Label 5202: @226321
     /* 226321 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(226352), // Rule ID 2270 //
     /* 226326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 226329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 226341 */     // (strict_fdiv:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (DIVPSrr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)
     /* 226341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::DIVPSrr),
     /* 226346 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226350 */     GIR_RootConstrainSelectedInstOperands,
     /* 226351 */     // GIR_Coverage, 2270,
     /* 226351 */     GIR_Done,
     /* 226352 */   // Label 5203: @226352
     /* 226352 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(226383), // Rule ID 6631 //
     /* 226357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226372 */     // (strict_fdiv:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VDIVPSZ128rr:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)
     /* 226372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ128rr),
     /* 226377 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226381 */     GIR_RootConstrainSelectedInstOperands,
     /* 226382 */     // GIR_Coverage, 6631,
     /* 226382 */     GIR_Done,
     /* 226383 */   // Label 5204: @226383
     /* 226383 */   GIM_Reject,
     /* 226384 */ // Label 5199: @226384
     /* 226384 */ GIM_Reject,
     /* 226385 */ // Label 5142: @226385
     /* 226385 */ GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(226583),
     /* 226390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 226393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 226396 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(226458), // Rule ID 2268 //
     /* 226401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226420 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226423 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226427 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226440 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDYrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrm),
     /* 226443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226445 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226447 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226456 */     GIR_RootConstrainSelectedInstOperands,
     /* 226457 */     // GIR_Coverage, 2268,
     /* 226457 */     GIR_EraseRootFromParent_Done,
     /* 226458 */   // Label 5206: @226458
     /* 226458 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(226520), // Rule ID 6671 //
     /* 226463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226482 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226485 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226489 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226502 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZ256rm:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rm),
     /* 226505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226507 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226509 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226518 */     GIR_RootConstrainSelectedInstOperands,
     /* 226519 */     // GIR_Coverage, 6671,
     /* 226519 */     GIR_EraseRootFromParent_Done,
     /* 226520 */   // Label 5207: @226520
     /* 226520 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(226551), // Rule ID 2266 //
     /* 226525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226540 */     // (strict_fdiv:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VDIVPDYrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)
     /* 226540 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDYrr),
     /* 226545 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226549 */     GIR_RootConstrainSelectedInstOperands,
     /* 226550 */     // GIR_Coverage, 2266,
     /* 226550 */     GIR_Done,
     /* 226551 */   // Label 5208: @226551
     /* 226551 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(226582), // Rule ID 6667 //
     /* 226556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226571 */     // (strict_fdiv:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VDIVPDZ256rr:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)
     /* 226571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZ256rr),
     /* 226576 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226580 */     GIR_RootConstrainSelectedInstOperands,
     /* 226581 */     // GIR_Coverage, 6667,
     /* 226581 */     GIR_Done,
     /* 226582 */   // Label 5209: @226582
     /* 226582 */   GIM_Reject,
     /* 226583 */ // Label 5205: @226583
     /* 226583 */ GIM_Reject,
     /* 226584 */ // Label 5143: @226584
     /* 226584 */ GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(226681),
     /* 226589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 226592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 226595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226603 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(226657), // Rule ID 6695 //
     /* 226608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226619 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226622 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226626 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226632 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226639 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ128rm:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rm),
     /* 226642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226644 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226646 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226655 */     GIR_RootConstrainSelectedInstOperands,
     /* 226656 */     // GIR_Coverage, 6695,
     /* 226656 */     GIR_EraseRootFromParent_Done,
     /* 226657 */   // Label 5211: @226657
     /* 226657 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(226680), // Rule ID 6691 //
     /* 226662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 226665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 226669 */     // (strict_fdiv:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VDIVPHZ128rr:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)
     /* 226669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ128rr),
     /* 226674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226678 */     GIR_RootConstrainSelectedInstOperands,
     /* 226679 */     // GIR_Coverage, 6691,
     /* 226679 */     GIR_Done,
     /* 226680 */   // Label 5212: @226680
     /* 226680 */   GIM_Reject,
     /* 226681 */ // Label 5210: @226681
     /* 226681 */ GIM_Reject,
     /* 226682 */ // Label 5144: @226682
     /* 226682 */ GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(226880),
     /* 226687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 226690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 226693 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(226755), // Rule ID 2264 //
     /* 226698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226717 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226737 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSYrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrm),
     /* 226740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226742 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226744 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226753 */     GIR_RootConstrainSelectedInstOperands,
     /* 226754 */     // GIR_Coverage, 2264,
     /* 226754 */     GIR_EraseRootFromParent_Done,
     /* 226755 */   // Label 5214: @226755
     /* 226755 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(226817), // Rule ID 6647 //
     /* 226760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226779 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226782 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226792 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226799 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZ256rm:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rm),
     /* 226802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226804 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226806 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226815 */     GIR_RootConstrainSelectedInstOperands,
     /* 226816 */     // GIR_Coverage, 6647,
     /* 226816 */     GIR_EraseRootFromParent_Done,
     /* 226817 */   // Label 5215: @226817
     /* 226817 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(226848), // Rule ID 2262 //
     /* 226822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 226825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 226837 */     // (strict_fdiv:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VDIVPSYrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)
     /* 226837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSYrr),
     /* 226842 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226846 */     GIR_RootConstrainSelectedInstOperands,
     /* 226847 */     // GIR_Coverage, 2262,
     /* 226847 */     GIR_Done,
     /* 226848 */   // Label 5216: @226848
     /* 226848 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(226879), // Rule ID 6643 //
     /* 226853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 226856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226868 */     // (strict_fdiv:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VDIVPSZ256rr:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)
     /* 226868 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZ256rr),
     /* 226873 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226877 */     GIR_RootConstrainSelectedInstOperands,
     /* 226878 */     // GIR_Coverage, 6643,
     /* 226878 */     GIR_Done,
     /* 226879 */   // Label 5217: @226879
     /* 226879 */   GIM_Reject,
     /* 226880 */ // Label 5213: @226880
     /* 226880 */ GIM_Reject,
     /* 226881 */ // Label 5145: @226881
     /* 226881 */ GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(226978),
     /* 226886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 226889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 226892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226900 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(226954), // Rule ID 6623 //
     /* 226905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 226912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 226916 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 226919 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 226923 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 226927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 226929 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 226936 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPDZrm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 226936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrm),
     /* 226939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 226941 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 226943 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 226947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 226952 */     GIR_RootConstrainSelectedInstOperands,
     /* 226953 */     // GIR_Coverage, 6623,
     /* 226953 */     GIR_EraseRootFromParent_Done,
     /* 226954 */   // Label 5219: @226954
     /* 226954 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(226977), // Rule ID 6619 //
     /* 226959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 226962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 226966 */     // (strict_fdiv:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VDIVPDZrr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)
     /* 226966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPDZrr),
     /* 226971 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 226975 */     GIR_RootConstrainSelectedInstOperands,
     /* 226976 */     // GIR_Coverage, 6619,
     /* 226976 */     GIR_Done,
     /* 226977 */   // Label 5220: @226977
     /* 226977 */   GIM_Reject,
     /* 226978 */ // Label 5218: @226978
     /* 226978 */ GIM_Reject,
     /* 226979 */ // Label 5146: @226979
     /* 226979 */ GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(227076),
     /* 226984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 226987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 226990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 226998 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(227052), // Rule ID 6707 //
     /* 227003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227014 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227017 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227021 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227027 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227034 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZ256rm:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rm),
     /* 227037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227050 */     GIR_RootConstrainSelectedInstOperands,
     /* 227051 */     // GIR_Coverage, 6707,
     /* 227051 */     GIR_EraseRootFromParent_Done,
     /* 227052 */   // Label 5222: @227052
     /* 227052 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(227075), // Rule ID 6703 //
     /* 227057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 227060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 227064 */     // (strict_fdiv:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VDIVPHZ256rr:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)
     /* 227064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZ256rr),
     /* 227069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227073 */     GIR_RootConstrainSelectedInstOperands,
     /* 227074 */     // GIR_Coverage, 6703,
     /* 227074 */     GIR_Done,
     /* 227075 */   // Label 5223: @227075
     /* 227075 */   GIM_Reject,
     /* 227076 */ // Label 5221: @227076
     /* 227076 */ GIM_Reject,
     /* 227077 */ // Label 5147: @227077
     /* 227077 */ GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(227174),
     /* 227082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 227085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 227088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227096 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(227150), // Rule ID 6611 //
     /* 227101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227112 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227115 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227119 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227125 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227132 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPSZrm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrm),
     /* 227135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227137 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227139 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227148 */     GIR_RootConstrainSelectedInstOperands,
     /* 227149 */     // GIR_Coverage, 6611,
     /* 227149 */     GIR_EraseRootFromParent_Done,
     /* 227150 */   // Label 5225: @227150
     /* 227150 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(227173), // Rule ID 6607 //
     /* 227155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227162 */     // (strict_fdiv:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VDIVPSZrr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)
     /* 227162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPSZrr),
     /* 227167 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227171 */     GIR_RootConstrainSelectedInstOperands,
     /* 227172 */     // GIR_Coverage, 6607,
     /* 227172 */     GIR_Done,
     /* 227173 */   // Label 5226: @227173
     /* 227173 */   GIM_Reject,
     /* 227174 */ // Label 5224: @227174
     /* 227174 */ GIM_Reject,
     /* 227175 */ // Label 5148: @227175
     /* 227175 */ GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(227272),
     /* 227180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 227183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 227186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227194 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(227248), // Rule ID 6683 //
     /* 227199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227210 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227213 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227217 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227230 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VDIVPHZrm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, addr:{ *:[iPTR] }:$src2)
     /* 227230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrm),
     /* 227233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227235 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227237 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227241 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227246 */     GIR_RootConstrainSelectedInstOperands,
     /* 227247 */     // GIR_Coverage, 6683,
     /* 227247 */     GIR_EraseRootFromParent_Done,
     /* 227248 */   // Label 5228: @227248
     /* 227248 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(227271), // Rule ID 6679 //
     /* 227253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 227260 */     // (strict_fdiv:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VDIVPHZrr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)
     /* 227260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VDIVPHZrr),
     /* 227265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 227269 */     GIR_RootConstrainSelectedInstOperands,
     /* 227270 */     // GIR_Coverage, 6679,
     /* 227270 */     GIR_Done,
     /* 227271 */   // Label 5229: @227271
     /* 227271 */   GIM_Reject,
     /* 227272 */ // Label 5227: @227272
     /* 227272 */ GIM_Reject,
     /* 227273 */ // Label 5149: @227273
     /* 227273 */ GIM_Reject,
     /* 227274 */ // Label 72: @227274
     /* 227274 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5242*/ GIMT_Encode4(233261),
     /* 227285 */ /*GILLT_s16*//*Label 5230*/ GIMT_Encode4(227369),
     /* 227289 */ /*GILLT_s32*//*Label 5231*/ GIMT_Encode4(227614),
     /* 227293 */ /*GILLT_s64*//*Label 5232*/ GIMT_Encode4(228351), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227309 */ /*GILLT_v2s64*//*Label 5233*/ GIMT_Encode4(229088), GIMT_Encode4(0),
     /* 227317 */ /*GILLT_v4s32*//*Label 5234*/ GIMT_Encode4(229825),
     /* 227321 */ /*GILLT_v4s64*//*Label 5235*/ GIMT_Encode4(230562), GIMT_Encode4(0),
     /* 227329 */ /*GILLT_v8s16*//*Label 5236*/ GIMT_Encode4(231299),
     /* 227333 */ /*GILLT_v8s32*//*Label 5237*/ GIMT_Encode4(231544),
     /* 227337 */ /*GILLT_v8s64*//*Label 5238*/ GIMT_Encode4(232281), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227349 */ /*GILLT_v16s16*//*Label 5239*/ GIMT_Encode4(232526),
     /* 227353 */ /*GILLT_v16s32*//*Label 5240*/ GIMT_Encode4(232771), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 227365 */ /*GILLT_v32s16*//*Label 5241*/ GIMT_Encode4(233016),
     /* 227369 */ // Label 5230: @227369
     /* 227369 */ GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(227613),
     /* 227374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 227377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 227380 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 227383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227387 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(227451), // Rule ID 10157 //
     /* 227392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227403 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227410 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227431 */     // (strict_fma:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2)  =>  (VFMADD132SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SHZm),
     /* 227434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227438 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227449 */     GIR_RootConstrainSelectedInstOperands,
     /* 227450 */     // GIR_Coverage, 10157,
     /* 227450 */     GIR_EraseRootFromParent_Done,
     /* 227451 */   // Label 5244: @227451
     /* 227451 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(227515), // Rule ID 10155 //
     /* 227456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227471 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227474 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227478 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227488 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227495 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR16X:{ *:[f16] }:$src1)  =>  (VFMADD231SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SHZm),
     /* 227498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227500 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227502 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227504 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227508 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227513 */     GIR_RootConstrainSelectedInstOperands,
     /* 227514 */     // GIR_Coverage, 10155,
     /* 227514 */     GIR_EraseRootFromParent_Done,
     /* 227515 */   // Label 5245: @227515
     /* 227515 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(227579), // Rule ID 10152 //
     /* 227520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 227535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227539 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227542 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227546 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227552 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227559 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SHZm:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZm),
     /* 227562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227564 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227566 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227568 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227577 */     GIR_RootConstrainSelectedInstOperands,
     /* 227578 */     // GIR_Coverage, 10152,
     /* 227578 */     GIR_EraseRootFromParent_Done,
     /* 227579 */   // Label 5246: @227579
     /* 227579 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(227612), // Rule ID 10150 //
     /* 227584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 227587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 227599 */     // (strict_fma:{ *:[f16] } FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src3)  =>  (VFMADD213SHZr:{ *:[f16] } FR16X:{ *:[f16] }:$src1, FR16X:{ *:[f16] }:$src2, FR16X:{ *:[f16] }:$src3)
     /* 227599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SHZr),
     /* 227602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227604 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227606 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227608 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227610 */     GIR_RootConstrainSelectedInstOperands,
     /* 227611 */     // GIR_Coverage, 10150,
     /* 227611 */     GIR_EraseRootFromParent_Done,
     /* 227612 */   // Label 5247: @227612
     /* 227612 */   GIM_Reject,
     /* 227613 */ // Label 5243: @227613
     /* 227613 */ GIM_Reject,
     /* 227614 */ // Label 5231: @227614
     /* 227614 */ GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(228350),
     /* 227619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 227622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 227625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 227628 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(227696), // Rule ID 1303 //
     /* 227633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227648 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227651 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227655 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227676 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2)  =>  (VFMADD132SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSm),
     /* 227679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227681 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227683 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227685 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227694 */     GIR_RootConstrainSelectedInstOperands,
     /* 227695 */     // GIR_Coverage, 1303,
     /* 227695 */     GIR_EraseRootFromParent_Done,
     /* 227696 */   // Label 5249: @227696
     /* 227696 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(227764), // Rule ID 10139 //
     /* 227701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227716 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227719 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227723 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227744 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2)  =>  (VFMADD132SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SSZm),
     /* 227747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227749 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227751 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 227753 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227757 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227762 */     GIR_RootConstrainSelectedInstOperands,
     /* 227763 */     // GIR_Coverage, 10139,
     /* 227763 */     GIR_EraseRootFromParent_Done,
     /* 227764 */   // Label 5250: @227764
     /* 227764 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(227832), // Rule ID 23280 //
     /* 227769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 227780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227784 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227787 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227791 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227805 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227812 */     // (strict_fma:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227817 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 227819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227823 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227825 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227830 */     GIR_RootConstrainSelectedInstOperands,
     /* 227831 */     // GIR_Coverage, 23280,
     /* 227831 */     GIR_EraseRootFromParent_Done,
     /* 227832 */   // Label 5251: @227832
     /* 227832 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(227900), // Rule ID 1301 //
     /* 227837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 227840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227856 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227863 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227880 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src1)  =>  (VFMADD231SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 227880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSm),
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227885 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 227887 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 227889 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 227893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227898 */     GIR_RootConstrainSelectedInstOperands,
     /* 227899 */     // GIR_Coverage, 1301,
     /* 227899 */     GIR_EraseRootFromParent_Done,
     /* 227900 */   // Label 5252: @227900
     /* 227900 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(227968), // Rule ID 1365 //
     /* 227905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 227908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227924 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227927 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227931 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 227935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 227939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 227941 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 227948 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4mr:{ *:[f32] } FR32:{ *:[f32] }:$src1, addr:{ *:[iPTR] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 227948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4mr),
     /* 227951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 227953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 227955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 227959 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 227961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 227966 */     GIR_RootConstrainSelectedInstOperands,
     /* 227967 */     // GIR_Coverage, 1365,
     /* 227967 */     GIR_EraseRootFromParent_Done,
     /* 227968 */   // Label 5253: @227968
     /* 227968 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(228036), // Rule ID 10137 //
     /* 227973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 227976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 227984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 227988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 227992 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 227995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 227999 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228016 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR32X:{ *:[f32] }:$src1)  =>  (VFMADD231SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SSZm),
     /* 228019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228021 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228023 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228034 */     GIR_RootConstrainSelectedInstOperands,
     /* 228035 */     // GIR_Coverage, 10137,
     /* 228035 */     GIR_EraseRootFromParent_Done,
     /* 228036 */   // Label 5254: @228036
     /* 228036 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(228104), // Rule ID 1299 //
     /* 228041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228064 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228071 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228077 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228084 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSm),
     /* 228087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228091 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228093 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228102 */     GIR_RootConstrainSelectedInstOperands,
     /* 228103 */     // GIR_Coverage, 1299,
     /* 228103 */     GIR_EraseRootFromParent_Done,
     /* 228104 */   // Label 5255: @228104
     /* 228104 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(228172), // Rule ID 1363 //
     /* 228109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228132 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228135 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228139 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228145 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228152 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSS4rm:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rm),
     /* 228155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228159 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228161 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228170 */     GIR_RootConstrainSelectedInstOperands,
     /* 228171 */     // GIR_Coverage, 1363,
     /* 228171 */     GIR_EraseRootFromParent_Done,
     /* 228172 */   // Label 5256: @228172
     /* 228172 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(228240), // Rule ID 10134 //
     /* 228177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228200 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228203 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228207 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228220 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SSZm:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZm),
     /* 228223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228225 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228227 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228229 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228238 */     GIR_RootConstrainSelectedInstOperands,
     /* 228239 */     // GIR_Coverage, 10134,
     /* 228239 */     GIR_EraseRootFromParent_Done,
     /* 228240 */   // Label 5257: @228240
     /* 228240 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(228277), // Rule ID 1297 //
     /* 228245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228264 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src3)  =>  (VFMADD213SSr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSr),
     /* 228267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228269 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228271 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228273 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228275 */     GIR_RootConstrainSelectedInstOperands,
     /* 228276 */     // GIR_Coverage, 1297,
     /* 228276 */     GIR_EraseRootFromParent_Done,
     /* 228277 */   // Label 5258: @228277
     /* 228277 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(228312), // Rule ID 1361 //
     /* 228282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 228301 */     // (strict_fma:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)  =>  (VFMADDSS4rr:{ *:[f32] } FR32:{ *:[f32] }:$src1, FR32:{ *:[f32] }:$src2, FR32:{ *:[f32] }:$src3)
     /* 228301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSS4rr),
     /* 228306 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 228310 */     GIR_RootConstrainSelectedInstOperands,
     /* 228311 */     // GIR_Coverage, 1361,
     /* 228311 */     GIR_Done,
     /* 228312 */   // Label 5259: @228312
     /* 228312 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(228349), // Rule ID 10132 //
     /* 228317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 228336 */     // (strict_fma:{ *:[f32] } FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src3)  =>  (VFMADD213SSZr:{ *:[f32] } FR32X:{ *:[f32] }:$src1, FR32X:{ *:[f32] }:$src2, FR32X:{ *:[f32] }:$src3)
     /* 228336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SSZr),
     /* 228339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228341 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228343 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228345 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228347 */     GIR_RootConstrainSelectedInstOperands,
     /* 228348 */     // GIR_Coverage, 10132,
     /* 228348 */     GIR_EraseRootFromParent_Done,
     /* 228349 */   // Label 5260: @228349
     /* 228349 */   GIM_Reject,
     /* 228350 */ // Label 5248: @228350
     /* 228350 */ GIM_Reject,
     /* 228351 */ // Label 5232: @228351
     /* 228351 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(229087),
     /* 228356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 228359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 228362 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 228365 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(228433), // Rule ID 1311 //
     /* 228370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228406 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228413 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2)  =>  (VFMADD132SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDm),
     /* 228416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228418 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228420 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228422 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228426 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228431 */     GIR_RootConstrainSelectedInstOperands,
     /* 228432 */     // GIR_Coverage, 1311,
     /* 228432 */     GIR_EraseRootFromParent_Done,
     /* 228433 */   // Label 5262: @228433
     /* 228433 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(228501), // Rule ID 10148 //
     /* 228438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228453 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228456 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228460 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228474 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228481 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2)  =>  (VFMADD132SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132SDZm),
     /* 228484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228486 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228488 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 228490 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228499 */     GIR_RootConstrainSelectedInstOperands,
     /* 228500 */     // GIR_Coverage, 10148,
     /* 228500 */     GIR_EraseRootFromParent_Done,
     /* 228501 */   // Label 5263: @228501
     /* 228501 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(228569), // Rule ID 23308 //
     /* 228506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 228517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228521 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228524 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228528 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228549 */     // (strict_fma:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228554 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228560 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228567 */     GIR_RootConstrainSelectedInstOperands,
     /* 228568 */     // GIR_Coverage, 23308,
     /* 228568 */     GIR_EraseRootFromParent_Done,
     /* 228569 */   // Label 5264: @228569
     /* 228569 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(228637), // Rule ID 1309 //
     /* 228574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228593 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228600 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228610 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228617 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src1)  =>  (VFMADD231SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDm),
     /* 228620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228622 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228624 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228626 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228635 */     GIR_RootConstrainSelectedInstOperands,
     /* 228636 */     // GIR_Coverage, 1309,
     /* 228636 */     GIR_EraseRootFromParent_Done,
     /* 228637 */   // Label 5265: @228637
     /* 228637 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(228705), // Rule ID 1449 //
     /* 228642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228678 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228685 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4mr:{ *:[f64] } FR64:{ *:[f64] }:$src1, addr:{ *:[iPTR] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 228685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4mr),
     /* 228688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228690 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228692 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 228696 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 228698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228703 */     GIR_RootConstrainSelectedInstOperands,
     /* 228704 */     // GIR_Coverage, 1449,
     /* 228704 */     GIR_EraseRootFromParent_Done,
     /* 228705 */   // Label 5266: @228705
     /* 228705 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(228773), // Rule ID 10146 //
     /* 228710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 228725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228729 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228732 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228736 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228746 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228753 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, FR64X:{ *:[f64] }:$src1)  =>  (VFMADD231SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231SDZm),
     /* 228756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228758 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 228760 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228762 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228766 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228771 */     GIR_RootConstrainSelectedInstOperands,
     /* 228772 */     // GIR_Coverage, 10146,
     /* 228772 */     GIR_EraseRootFromParent_Done,
     /* 228773 */   // Label 5267: @228773
     /* 228773 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(228841), // Rule ID 1307 //
     /* 228778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228801 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228804 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228808 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228814 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228821 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDm),
     /* 228824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228830 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228839 */     GIR_RootConstrainSelectedInstOperands,
     /* 228840 */     // GIR_Coverage, 1307,
     /* 228840 */     GIR_EraseRootFromParent_Done,
     /* 228841 */   // Label 5268: @228841
     /* 228841 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(228909), // Rule ID 1447 //
     /* 228846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 228849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228882 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228889 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDSD4rm:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rm),
     /* 228892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 228896 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 228898 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228907 */     GIR_RootConstrainSelectedInstOperands,
     /* 228908 */     // GIR_Coverage, 1447,
     /* 228908 */     GIR_EraseRootFromParent_Done,
     /* 228909 */   // Label 5269: @228909
     /* 228909 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(228977), // Rule ID 10143 //
     /* 228914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 228917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 228929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 228933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 228937 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 228940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 228944 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 228948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 228950 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 228957 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213SDZm:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 228957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZm),
     /* 228960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 228962 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 228964 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 228966 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 228970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 228975 */     GIR_RootConstrainSelectedInstOperands,
     /* 228976 */     // GIR_Coverage, 10143,
     /* 228976 */     GIR_EraseRootFromParent_Done,
     /* 228977 */   // Label 5270: @228977
     /* 228977 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(229014), // Rule ID 1305 //
     /* 228982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoAVX512_NoFMA4),
     /* 228985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 228997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229001 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src3)  =>  (VFMADD213SDr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 229001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDr),
     /* 229004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229012 */     GIR_RootConstrainSelectedInstOperands,
     /* 229013 */     // GIR_Coverage, 1305,
     /* 229013 */     GIR_EraseRootFromParent_Done,
     /* 229014 */   // Label 5271: @229014
     /* 229014 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(229049), // Rule ID 1445 //
     /* 229019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoAVX512),
     /* 229022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 229038 */     // (strict_fma:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)  =>  (VFMADDSD4rr:{ *:[f64] } FR64:{ *:[f64] }:$src1, FR64:{ *:[f64] }:$src2, FR64:{ *:[f64] }:$src3)
     /* 229038 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDSD4rr),
     /* 229043 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229047 */     GIR_RootConstrainSelectedInstOperands,
     /* 229048 */     // GIR_Coverage, 1445,
     /* 229048 */     GIR_Done,
     /* 229049 */   // Label 5272: @229049
     /* 229049 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(229086), // Rule ID 10141 //
     /* 229054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 229057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 229073 */     // (strict_fma:{ *:[f64] } FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src3)  =>  (VFMADD213SDZr:{ *:[f64] } FR64X:{ *:[f64] }:$src1, FR64X:{ *:[f64] }:$src2, FR64X:{ *:[f64] }:$src3)
     /* 229073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213SDZr),
     /* 229076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229078 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229080 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229082 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229084 */     GIR_RootConstrainSelectedInstOperands,
     /* 229085 */     // GIR_Coverage, 10141,
     /* 229085 */     GIR_EraseRootFromParent_Done,
     /* 229086 */   // Label 5273: @229086
     /* 229086 */   GIM_Reject,
     /* 229087 */ // Label 5261: @229087
     /* 229087 */ GIM_Reject,
     /* 229088 */ // Label 5233: @229088
     /* 229088 */ GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(229824),
     /* 229093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 229096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 229099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 229102 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(229170), // Rule ID 1191 //
     /* 229107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229150 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDm),
     /* 229153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229157 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229168 */     GIR_RootConstrainSelectedInstOperands,
     /* 229169 */     // GIR_Coverage, 1191,
     /* 229169 */     GIR_EraseRootFromParent_Done,
     /* 229170 */   // Label 5275: @229170
     /* 229170 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(229238), // Rule ID 9680 //
     /* 229175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229190 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229193 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229197 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229211 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229218 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2)  =>  (VFMADD132PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ128m),
     /* 229221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229223 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229225 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229227 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229236 */     GIR_RootConstrainSelectedInstOperands,
     /* 229237 */     // GIR_Coverage, 9680,
     /* 229237 */     GIR_EraseRootFromParent_Done,
     /* 229238 */   // Label 5276: @229238
     /* 229238 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(229306), // Rule ID 23316 //
     /* 229243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229258 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229261 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229265 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229286 */     // (strict_fma:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229291 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229293 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229297 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229304 */     GIR_RootConstrainSelectedInstOperands,
     /* 229305 */     // GIR_Coverage, 23316,
     /* 229305 */     GIR_EraseRootFromParent_Done,
     /* 229306 */   // Label 5277: @229306
     /* 229306 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(229374), // Rule ID 1189 //
     /* 229311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229347 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229354 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDm),
     /* 229357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229359 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229361 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229372 */     GIR_RootConstrainSelectedInstOperands,
     /* 229373 */     // GIR_Coverage, 1189,
     /* 229373 */     GIR_EraseRootFromParent_Done,
     /* 229374 */   // Label 5278: @229374
     /* 229374 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(229442), // Rule ID 1473 //
     /* 229379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229398 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229401 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229405 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229415 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229422 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4mr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4mr),
     /* 229425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229429 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 229433 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229440 */     GIR_RootConstrainSelectedInstOperands,
     /* 229441 */     // GIR_Coverage, 1473,
     /* 229441 */     GIR_EraseRootFromParent_Done,
     /* 229442 */   // Label 5279: @229442
     /* 229442 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(229510), // Rule ID 9140 //
     /* 229447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229466 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229469 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229473 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229483 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229490 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v2f64] }:$src1)  =>  (VFMADD231PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ128m),
     /* 229493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229495 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 229497 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229499 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229508 */     GIR_RootConstrainSelectedInstOperands,
     /* 229509 */     // GIR_Coverage, 9140,
     /* 229509 */     GIR_EraseRootFromParent_Done,
     /* 229510 */   // Label 5280: @229510
     /* 229510 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(229578), // Rule ID 1187 //
     /* 229515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229538 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229545 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229551 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229558 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDm),
     /* 229561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229563 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229567 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229576 */     GIR_RootConstrainSelectedInstOperands,
     /* 229577 */     // GIR_Coverage, 1187,
     /* 229577 */     GIR_EraseRootFromParent_Done,
     /* 229578 */   // Label 5281: @229578
     /* 229578 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(229646), // Rule ID 1471 //
     /* 229583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229606 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229609 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229613 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229619 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229626 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4rm:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rm),
     /* 229629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229631 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 229633 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 229635 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229639 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229644 */     GIR_RootConstrainSelectedInstOperands,
     /* 229645 */     // GIR_Coverage, 1471,
     /* 229645 */     GIR_EraseRootFromParent_Done,
     /* 229646 */   // Label 5282: @229646
     /* 229646 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(229714), // Rule ID 8513 //
     /* 229651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 229670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229674 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229677 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229681 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229694 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ128m:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128m),
     /* 229697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229699 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229701 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229712 */     GIR_RootConstrainSelectedInstOperands,
     /* 229713 */     // GIR_Coverage, 8513,
     /* 229713 */     GIR_EraseRootFromParent_Done,
     /* 229714 */   // Label 5283: @229714
     /* 229714 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(229751), // Rule ID 1185 //
     /* 229719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229738 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDr),
     /* 229741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229743 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229745 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229747 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229749 */     GIR_RootConstrainSelectedInstOperands,
     /* 229750 */     // GIR_Coverage, 1185,
     /* 229750 */     GIR_EraseRootFromParent_Done,
     /* 229751 */   // Label 5284: @229751
     /* 229751 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(229786), // Rule ID 1469 //
     /* 229756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229775 */     // (strict_fma:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)  =>  (VFMADDPD4rr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src1, VR128:{ *:[v2f64] }:$src2, VR128:{ *:[v2f64] }:$src3)
     /* 229775 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4rr),
     /* 229780 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 229784 */     GIR_RootConstrainSelectedInstOperands,
     /* 229785 */     // GIR_Coverage, 1469,
     /* 229785 */     GIR_Done,
     /* 229786 */   // Label 5285: @229786
     /* 229786 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(229823), // Rule ID 8509 //
     /* 229791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229810 */     // (strict_fma:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src3)  =>  (VFMADD213PDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src1, VR128X:{ *:[v2f64] }:$src2, VR128X:{ *:[v2f64] }:$src3)
     /* 229810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ128r),
     /* 229813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229815 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 229819 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 229821 */     GIR_RootConstrainSelectedInstOperands,
     /* 229822 */     // GIR_Coverage, 8509,
     /* 229822 */     GIR_EraseRootFromParent_Done,
     /* 229823 */   // Label 5286: @229823
     /* 229823 */   GIM_Reject,
     /* 229824 */ // Label 5274: @229824
     /* 229824 */ GIM_Reject,
     /* 229825 */ // Label 5234: @229825
     /* 229825 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(230561),
     /* 229830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 229833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 229836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 229839 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(229907), // Rule ID 1143 //
     /* 229844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 229847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229859 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229887 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSm),
     /* 229890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229892 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229894 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229896 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229905 */     GIR_RootConstrainSelectedInstOperands,
     /* 229906 */     // GIR_Coverage, 1143,
     /* 229906 */     GIR_EraseRootFromParent_Done,
     /* 229907 */   // Label 5288: @229907
     /* 229907 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(229975), // Rule ID 9648 //
     /* 229912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 229915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229927 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229930 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 229934 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 229938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 229946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 229955 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2)  =>  (VFMADD132PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 229955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ128m),
     /* 229958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 229960 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 229962 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 229964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 229968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 229973 */     GIR_RootConstrainSelectedInstOperands,
     /* 229974 */     // GIR_Coverage, 9648,
     /* 229974 */     GIR_EraseRootFromParent_Done,
     /* 229975 */   // Label 5289: @229975
     /* 229975 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(230043), // Rule ID 23288 //
     /* 229980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 229983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 229987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 229991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 229995 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 229998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230002 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230023 */     // (strict_fma:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230028 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230030 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230034 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230041 */     GIR_RootConstrainSelectedInstOperands,
     /* 230042 */     // GIR_Coverage, 23288,
     /* 230042 */     GIR_EraseRootFromParent_Done,
     /* 230043 */   // Label 5290: @230043
     /* 230043 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(230111), // Rule ID 1141 //
     /* 230048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230067 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230070 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230074 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230084 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230091 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSm),
     /* 230094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230096 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230098 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230100 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230104 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230109 */     GIR_RootConstrainSelectedInstOperands,
     /* 230110 */     // GIR_Coverage, 1141,
     /* 230110 */     GIR_EraseRootFromParent_Done,
     /* 230111 */   // Label 5291: @230111
     /* 230111 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(230179), // Rule ID 1389 //
     /* 230116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230152 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230159 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4mr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4mr),
     /* 230162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230164 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230166 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230170 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230177 */     GIR_RootConstrainSelectedInstOperands,
     /* 230178 */     // GIR_Coverage, 1389,
     /* 230178 */     GIR_EraseRootFromParent_Done,
     /* 230179 */   // Label 5292: @230179
     /* 230179 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(230247), // Rule ID 9108 //
     /* 230184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230203 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230206 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230210 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230220 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230227 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v4f32] }:$src1)  =>  (VFMADD231PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ128m),
     /* 230230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230232 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230234 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230236 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230245 */     GIR_RootConstrainSelectedInstOperands,
     /* 230246 */     // GIR_Coverage, 9108,
     /* 230246 */     GIR_EraseRootFromParent_Done,
     /* 230247 */   // Label 5293: @230247
     /* 230247 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(230315), // Rule ID 1139 //
     /* 230252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230275 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230282 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230288 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230295 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSm),
     /* 230298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230300 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230302 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230304 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230313 */     GIR_RootConstrainSelectedInstOperands,
     /* 230314 */     // GIR_Coverage, 1139,
     /* 230314 */     GIR_EraseRootFromParent_Done,
     /* 230315 */   // Label 5294: @230315
     /* 230315 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(230383), // Rule ID 1387 //
     /* 230320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230343 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230346 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230350 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230356 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230363 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4rm:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rm),
     /* 230366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230368 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230370 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 230372 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230381 */     GIR_RootConstrainSelectedInstOperands,
     /* 230382 */     // GIR_Coverage, 1387,
     /* 230382 */     GIR_EraseRootFromParent_Done,
     /* 230383 */   // Label 5295: @230383
     /* 230383 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(230451), // Rule ID 8474 //
     /* 230388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 230407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230411 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230414 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230418 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230431 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ128m:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128m),
     /* 230434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230436 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230438 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230440 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230449 */     GIR_RootConstrainSelectedInstOperands,
     /* 230450 */     // GIR_Coverage, 8474,
     /* 230450 */     GIR_EraseRootFromParent_Done,
     /* 230451 */   // Label 5296: @230451
     /* 230451 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(230488), // Rule ID 1137 //
     /* 230456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230475 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSr),
     /* 230478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230480 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230482 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230484 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230486 */     GIR_RootConstrainSelectedInstOperands,
     /* 230487 */     // GIR_Coverage, 1137,
     /* 230487 */     GIR_EraseRootFromParent_Done,
     /* 230488 */   // Label 5297: @230488
     /* 230488 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(230523), // Rule ID 1385 //
     /* 230493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 230512 */     // (strict_fma:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)  =>  (VFMADDPS4rr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src1, VR128:{ *:[v4f32] }:$src2, VR128:{ *:[v4f32] }:$src3)
     /* 230512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4rr),
     /* 230517 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 230521 */     GIR_RootConstrainSelectedInstOperands,
     /* 230522 */     // GIR_Coverage, 1385,
     /* 230522 */     GIR_Done,
     /* 230523 */   // Label 5298: @230523
     /* 230523 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(230560), // Rule ID 8470 //
     /* 230528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 230547 */     // (strict_fma:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src3)  =>  (VFMADD213PSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src1, VR128X:{ *:[v4f32] }:$src2, VR128X:{ *:[v4f32] }:$src3)
     /* 230547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ128r),
     /* 230550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230552 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230554 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230556 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230558 */     GIR_RootConstrainSelectedInstOperands,
     /* 230559 */     // GIR_Coverage, 8470,
     /* 230559 */     GIR_EraseRootFromParent_Done,
     /* 230560 */   // Label 5299: @230560
     /* 230560 */   GIM_Reject,
     /* 230561 */ // Label 5287: @230561
     /* 230561 */ GIM_Reject,
     /* 230562 */ // Label 5235: @230562
     /* 230562 */ GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(231298),
     /* 230567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 230570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s64,
     /* 230573 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s64,
     /* 230576 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(230644), // Rule ID 1199 //
     /* 230581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230596 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230599 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230603 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230624 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDYm),
     /* 230627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230629 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230631 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230633 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230642 */     GIR_RootConstrainSelectedInstOperands,
     /* 230643 */     // GIR_Coverage, 1199,
     /* 230643 */     GIR_EraseRootFromParent_Done,
     /* 230644 */   // Label 5301: @230644
     /* 230644 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(230712), // Rule ID 9670 //
     /* 230649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230664 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230667 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230671 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230685 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230692 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2)  =>  (VFMADD132PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZ256m),
     /* 230695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230697 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230699 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 230701 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230710 */     GIR_RootConstrainSelectedInstOperands,
     /* 230711 */     // GIR_Coverage, 9670,
     /* 230711 */     GIR_EraseRootFromParent_Done,
     /* 230712 */   // Label 5302: @230712
     /* 230712 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(230780), // Rule ID 23318 //
     /* 230717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 230728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230732 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230735 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230739 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230753 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230760 */     // (strict_fma:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 230767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230771 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230778 */     GIR_RootConstrainSelectedInstOperands,
     /* 230779 */     // GIR_Coverage, 23318,
     /* 230779 */     GIR_EraseRootFromParent_Done,
     /* 230780 */   // Label 5303: @230780
     /* 230780 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(230848), // Rule ID 1197 //
     /* 230785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230804 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230807 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230811 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230821 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230828 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDYm),
     /* 230831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230833 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230835 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230837 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230846 */     GIR_RootConstrainSelectedInstOperands,
     /* 230847 */     // GIR_Coverage, 1197,
     /* 230847 */     GIR_EraseRootFromParent_Done,
     /* 230848 */   // Label 5304: @230848
     /* 230848 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(230916), // Rule ID 1479 //
     /* 230853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 230856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230889 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230896 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Ymr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 230896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Ymr),
     /* 230899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230901 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 230903 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 230907 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 230909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230914 */     GIR_RootConstrainSelectedInstOperands,
     /* 230915 */     // GIR_Coverage, 1479,
     /* 230915 */     GIR_EraseRootFromParent_Done,
     /* 230916 */   // Label 5305: @230916
     /* 230916 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(230984), // Rule ID 9130 //
     /* 230921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 230924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 230940 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 230943 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 230947 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 230951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 230955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230957 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 230964 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v4f64] }:$src1)  =>  (VFMADD231PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 230964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZ256m),
     /* 230967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230969 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 230971 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 230973 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 230977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 230982 */     GIR_RootConstrainSelectedInstOperands,
     /* 230983 */     // GIR_Coverage, 9130,
     /* 230983 */     GIR_EraseRootFromParent_Done,
     /* 230984 */   // Label 5306: @230984
     /* 230984 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(231052), // Rule ID 1195 //
     /* 230989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 230992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 230996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231012 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231019 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231025 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231032 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDYm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYm),
     /* 231035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231037 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231041 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231045 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231050 */     GIR_RootConstrainSelectedInstOperands,
     /* 231051 */     // GIR_Coverage, 1195,
     /* 231051 */     GIR_EraseRootFromParent_Done,
     /* 231052 */   // Label 5307: @231052
     /* 231052 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(231120), // Rule ID 1477 //
     /* 231057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231080 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231083 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231087 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231093 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231100 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPD4Yrm:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrm),
     /* 231103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231105 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231107 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 231109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231113 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231118 */     GIR_RootConstrainSelectedInstOperands,
     /* 231119 */     // GIR_Coverage, 1477,
     /* 231119 */     GIR_EraseRootFromParent_Done,
     /* 231120 */   // Label 5308: @231120
     /* 231120 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(231188), // Rule ID 8501 //
     /* 231125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231148 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231151 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231155 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231168 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZ256m:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256m),
     /* 231171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231173 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231175 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231177 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231186 */     GIR_RootConstrainSelectedInstOperands,
     /* 231187 */     // GIR_Coverage, 8501,
     /* 231187 */     GIR_EraseRootFromParent_Done,
     /* 231188 */   // Label 5309: @231188
     /* 231188 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(231225), // Rule ID 1193 //
     /* 231193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231212 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDYr),
     /* 231215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231217 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231219 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231221 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231223 */     GIR_RootConstrainSelectedInstOperands,
     /* 231224 */     // GIR_Coverage, 1193,
     /* 231224 */     GIR_EraseRootFromParent_Done,
     /* 231225 */   // Label 5310: @231225
     /* 231225 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(231260), // Rule ID 1475 //
     /* 231230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231249 */     // (strict_fma:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)  =>  (VFMADDPD4Yrr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src1, VR256:{ *:[v4f64] }:$src2, VR256:{ *:[v4f64] }:$src3)
     /* 231249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPD4Yrr),
     /* 231254 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 231258 */     GIR_RootConstrainSelectedInstOperands,
     /* 231259 */     // GIR_Coverage, 1475,
     /* 231259 */     GIR_Done,
     /* 231260 */   // Label 5311: @231260
     /* 231260 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(231297), // Rule ID 8497 //
     /* 231265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231284 */     // (strict_fma:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src3)  =>  (VFMADD213PDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src1, VR256X:{ *:[v4f64] }:$src2, VR256X:{ *:[v4f64] }:$src3)
     /* 231284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZ256r),
     /* 231287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231289 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231293 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231295 */     GIR_RootConstrainSelectedInstOperands,
     /* 231296 */     // GIR_Coverage, 8497,
     /* 231296 */     GIR_EraseRootFromParent_Done,
     /* 231297 */   // Label 5312: @231297
     /* 231297 */   GIM_Reject,
     /* 231298 */ // Label 5300: @231298
     /* 231298 */ GIM_Reject,
     /* 231299 */ // Label 5236: @231299
     /* 231299 */ GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(231543),
     /* 231304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 231307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231310 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231317 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(231381), // Rule ID 9616 //
     /* 231322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231333 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231336 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231340 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231354 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231361 */     // (strict_fma:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2)  =>  (VFMADD132PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ128m),
     /* 231364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231366 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231368 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231379 */     GIR_RootConstrainSelectedInstOperands,
     /* 231380 */     // GIR_Coverage, 9616,
     /* 231380 */     GIR_EraseRootFromParent_Done,
     /* 231381 */   // Label 5314: @231381
     /* 231381 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(231445), // Rule ID 9076 //
     /* 231386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231401 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231404 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231408 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231418 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231425 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR128X:{ *:[v8f16] }:$src1)  =>  (VFMADD231PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ128m),
     /* 231428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231430 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231432 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231434 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231438 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231443 */     GIR_RootConstrainSelectedInstOperands,
     /* 231444 */     // GIR_Coverage, 9076,
     /* 231444 */     GIR_EraseRootFromParent_Done,
     /* 231445 */   // Label 5315: @231445
     /* 231445 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(231509), // Rule ID 8435 //
     /* 231450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231469 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231472 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231476 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231489 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ128m:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128m),
     /* 231492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231494 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231496 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231507 */     GIR_RootConstrainSelectedInstOperands,
     /* 231508 */     // GIR_Coverage, 8435,
     /* 231508 */     GIR_EraseRootFromParent_Done,
     /* 231509 */   // Label 5316: @231509
     /* 231509 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(231542), // Rule ID 8431 //
     /* 231514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 231517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 231529 */     // (strict_fma:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src3)  =>  (VFMADD213PHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src1, VR128X:{ *:[v8f16] }:$src2, VR128X:{ *:[v8f16] }:$src3)
     /* 231529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ128r),
     /* 231532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231534 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231536 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231538 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231540 */     GIR_RootConstrainSelectedInstOperands,
     /* 231541 */     // GIR_Coverage, 8431,
     /* 231541 */     GIR_EraseRootFromParent_Done,
     /* 231542 */   // Label 5317: @231542
     /* 231542 */   GIM_Reject,
     /* 231543 */ // Label 5313: @231543
     /* 231543 */ GIM_Reject,
     /* 231544 */ // Label 5237: @231544
     /* 231544 */ GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(232280),
     /* 231549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 231552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s32,
     /* 231555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s32,
     /* 231558 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(231626), // Rule ID 1151 //
     /* 231563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231578 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231581 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231585 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231599 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231606 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSYm),
     /* 231609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231611 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231613 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231615 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231624 */     GIR_RootConstrainSelectedInstOperands,
     /* 231625 */     // GIR_Coverage, 1151,
     /* 231625 */     GIR_EraseRootFromParent_Done,
     /* 231626 */   // Label 5319: @231626
     /* 231626 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(231694), // Rule ID 9638 //
     /* 231631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231646 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231649 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231653 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231667 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231674 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2)  =>  (VFMADD132PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZ256m),
     /* 231677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231679 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231681 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 231683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231692 */     GIR_RootConstrainSelectedInstOperands,
     /* 231693 */     // GIR_Coverage, 9638,
     /* 231693 */     GIR_EraseRootFromParent_Done,
     /* 231694 */   // Label 5320: @231694
     /* 231694 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(231762), // Rule ID 23290 //
     /* 231699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 231710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231714 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231717 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231721 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231735 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231742 */     // (strict_fma:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 231749 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231753 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231760 */     GIR_RootConstrainSelectedInstOperands,
     /* 231761 */     // GIR_Coverage, 23290,
     /* 231761 */     GIR_EraseRootFromParent_Done,
     /* 231762 */   // Label 5321: @231762
     /* 231762 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(231830), // Rule ID 1149 //
     /* 231767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231786 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231789 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231793 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231810 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSYm),
     /* 231813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231815 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231819 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231828 */     GIR_RootConstrainSelectedInstOperands,
     /* 231829 */     // GIR_Coverage, 1149,
     /* 231829 */     GIR_EraseRootFromParent_Done,
     /* 231830 */   // Label 5322: @231830
     /* 231830 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(231898), // Rule ID 1395 //
     /* 231835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 231838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231854 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231857 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231861 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231871 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231878 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src2)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Ymr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, addr:{ *:[iPTR] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 231878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Ymr),
     /* 231881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231883 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 231885 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src2
     /* 231889 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 231891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231896 */     GIR_RootConstrainSelectedInstOperands,
     /* 231897 */     // GIR_Coverage, 1395,
     /* 231897 */     GIR_EraseRootFromParent_Done,
     /* 231898 */   // Label 5323: @231898
     /* 231898 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(231966), // Rule ID 9098 //
     /* 231903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 231906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 231918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231922 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231925 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 231929 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 231933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 231937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 231939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 231946 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v8f32] }:$src1)  =>  (VFMADD231PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 231946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZ256m),
     /* 231949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231951 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 231953 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 231955 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 231959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 231964 */     GIR_RootConstrainSelectedInstOperands,
     /* 231965 */     // GIR_Coverage, 9098,
     /* 231965 */     GIR_EraseRootFromParent_Done,
     /* 231966 */   // Label 5324: @231966
     /* 231966 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(232034), // Rule ID 1147 //
     /* 231971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 231974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 231986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 231990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 231994 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 231997 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232001 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232007 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232014 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSYm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYm),
     /* 232017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232019 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232021 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232023 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232032 */     GIR_RootConstrainSelectedInstOperands,
     /* 232033 */     // GIR_Coverage, 1147,
     /* 232033 */     GIR_EraseRootFromParent_Done,
     /* 232034 */   // Label 5325: @232034
     /* 232034 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(232102), // Rule ID 1393 //
     /* 232039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232062 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232065 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232069 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232082 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADDPS4Yrm:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrm),
     /* 232085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 232089 */     GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 232091 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232100 */     GIR_RootConstrainSelectedInstOperands,
     /* 232101 */     // GIR_Coverage, 1393,
     /* 232101 */     GIR_EraseRootFromParent_Done,
     /* 232102 */   // Label 5326: @232102
     /* 232102 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(232170), // Rule ID 8462 //
     /* 232107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232130 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232133 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232137 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232150 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZ256m:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256m),
     /* 232153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232155 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232157 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232159 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232168 */     GIR_RootConstrainSelectedInstOperands,
     /* 232169 */     // GIR_Coverage, 8462,
     /* 232169 */     GIR_EraseRootFromParent_Done,
     /* 232170 */   // Label 5327: @232170
     /* 232170 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(232207), // Rule ID 1145 //
     /* 232175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA_NoFMA4_NoVLX),
     /* 232178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232194 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSYr),
     /* 232197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232199 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232201 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232203 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232205 */     GIR_RootConstrainSelectedInstOperands,
     /* 232206 */     // GIR_Coverage, 1145,
     /* 232206 */     GIR_EraseRootFromParent_Done,
     /* 232207 */   // Label 5328: @232207
     /* 232207 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(232242), // Rule ID 1391 //
     /* 232212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFMA4_NoVLX),
     /* 232215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 232231 */     // (strict_fma:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)  =>  (VFMADDPS4Yrr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src1, VR256:{ *:[v8f32] }:$src2, VR256:{ *:[v8f32] }:$src3)
     /* 232231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VFMADDPS4Yrr),
     /* 232236 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 232240 */     GIR_RootConstrainSelectedInstOperands,
     /* 232241 */     // GIR_Coverage, 1391,
     /* 232241 */     GIR_Done,
     /* 232242 */   // Label 5329: @232242
     /* 232242 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(232279), // Rule ID 8458 //
     /* 232247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_HasVLX),
     /* 232250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232266 */     // (strict_fma:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src3)  =>  (VFMADD213PSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src1, VR256X:{ *:[v8f32] }:$src2, VR256X:{ *:[v8f32] }:$src3)
     /* 232266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZ256r),
     /* 232269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232271 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232273 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232275 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232277 */     GIR_RootConstrainSelectedInstOperands,
     /* 232278 */     // GIR_Coverage, 8458,
     /* 232278 */     GIR_EraseRootFromParent_Done,
     /* 232279 */   // Label 5330: @232279
     /* 232279 */   GIM_Reject,
     /* 232280 */ // Label 5318: @232280
     /* 232280 */ GIM_Reject,
     /* 232281 */ // Label 5238: @232281
     /* 232281 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(232525),
     /* 232286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 232289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s64,
     /* 232292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s64,
     /* 232295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232299 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(232363), // Rule ID 9658 //
     /* 232304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232315 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232318 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232322 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232336 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232343 */     // (strict_fma:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2)  =>  (VFMADD132PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PDZm),
     /* 232346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232348 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232350 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232352 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232361 */     GIR_RootConstrainSelectedInstOperands,
     /* 232362 */     // GIR_Coverage, 9658,
     /* 232362 */     GIR_EraseRootFromParent_Done,
     /* 232363 */   // Label 5332: @232363
     /* 232363 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(232427), // Rule ID 9118 //
     /* 232368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232383 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232386 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232390 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232400 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232407 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v8f64] }:$src1)  =>  (VFMADD231PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PDZm),
     /* 232410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232412 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232414 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232416 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232425 */     GIR_RootConstrainSelectedInstOperands,
     /* 232426 */     // GIR_Coverage, 9118,
     /* 232426 */     GIR_EraseRootFromParent_Done,
     /* 232427 */   // Label 5333: @232427
     /* 232427 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(232491), // Rule ID 8486 //
     /* 232432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232451 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232454 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232458 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232471 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PDZm:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZm),
     /* 232474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232478 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232480 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232489 */     GIR_RootConstrainSelectedInstOperands,
     /* 232490 */     // GIR_Coverage, 8486,
     /* 232490 */     GIR_EraseRootFromParent_Done,
     /* 232491 */   // Label 5334: @232491
     /* 232491 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(232524), // Rule ID 8482 //
     /* 232496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232511 */     // (strict_fma:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src3)  =>  (VFMADD213PDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src1, VR512:{ *:[v8f64] }:$src2, VR512:{ *:[v8f64] }:$src3)
     /* 232511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PDZr),
     /* 232514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232518 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232520 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232522 */     GIR_RootConstrainSelectedInstOperands,
     /* 232523 */     // GIR_Coverage, 8482,
     /* 232523 */     GIR_EraseRootFromParent_Done,
     /* 232524 */   // Label 5335: @232524
     /* 232524 */   GIM_Reject,
     /* 232525 */ // Label 5331: @232525
     /* 232525 */ GIM_Reject,
     /* 232526 */ // Label 5239: @232526
     /* 232526 */ GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(232770),
     /* 232531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 232534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s16,
     /* 232537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s16,
     /* 232540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232544 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(232608), // Rule ID 9606 //
     /* 232549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232560 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232563 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232567 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232588 */     // (strict_fma:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2)  =>  (VFMADD132PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZ256m),
     /* 232591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232593 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232595 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232597 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232606 */     GIR_RootConstrainSelectedInstOperands,
     /* 232607 */     // GIR_Coverage, 9606,
     /* 232607 */     GIR_EraseRootFromParent_Done,
     /* 232608 */   // Label 5337: @232608
     /* 232608 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(232672), // Rule ID 9066 //
     /* 232613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232628 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232631 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232652 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR256X:{ *:[v16f16] }:$src1)  =>  (VFMADD231PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZ256m),
     /* 232655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232657 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232659 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232670 */     GIR_RootConstrainSelectedInstOperands,
     /* 232671 */     // GIR_Coverage, 9066,
     /* 232671 */     GIR_EraseRootFromParent_Done,
     /* 232672 */   // Label 5338: @232672
     /* 232672 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(232736), // Rule ID 8423 //
     /* 232677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232696 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232699 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232703 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232709 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232716 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZ256m:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256m),
     /* 232719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232721 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232723 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232725 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232734 */     GIR_RootConstrainSelectedInstOperands,
     /* 232735 */     // GIR_Coverage, 8423,
     /* 232735 */     GIR_EraseRootFromParent_Done,
     /* 232736 */   // Label 5339: @232736
     /* 232736 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(232769), // Rule ID 8419 //
     /* 232741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 232744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 232756 */     // (strict_fma:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src3)  =>  (VFMADD213PHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src1, VR256X:{ *:[v16f16] }:$src2, VR256X:{ *:[v16f16] }:$src3)
     /* 232756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZ256r),
     /* 232759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232763 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232765 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 232767 */     GIR_RootConstrainSelectedInstOperands,
     /* 232768 */     // GIR_Coverage, 8419,
     /* 232768 */     GIR_EraseRootFromParent_Done,
     /* 232769 */   // Label 5340: @232769
     /* 232769 */   GIM_Reject,
     /* 232770 */ // Label 5336: @232770
     /* 232770 */ GIM_Reject,
     /* 232771 */ // Label 5240: @232771
     /* 232771 */ GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(233015),
     /* 232776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 232779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s32,
     /* 232782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s32,
     /* 232785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232789 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(232853), // Rule ID 9626 //
     /* 232794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 232801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232805 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232808 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232812 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232833 */     // (strict_fma:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2)  =>  (VFMADD132PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PSZm),
     /* 232836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232838 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232840 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 232842 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232851 */     GIR_RootConstrainSelectedInstOperands,
     /* 232852 */     // GIR_Coverage, 9626,
     /* 232852 */     GIR_EraseRootFromParent_Done,
     /* 232853 */   // Label 5342: @232853
     /* 232853 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(232917), // Rule ID 9086 //
     /* 232858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 232869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232873 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232876 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232880 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232897 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v16f32] }:$src1)  =>  (VFMADD231PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PSZm),
     /* 232900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232902 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 232904 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232910 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232915 */     GIR_RootConstrainSelectedInstOperands,
     /* 232916 */     // GIR_Coverage, 9086,
     /* 232916 */     GIR_EraseRootFromParent_Done,
     /* 232917 */   // Label 5343: @232917
     /* 232917 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(232981), // Rule ID 8447 //
     /* 232922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 232937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 232941 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 232944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 232948 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 232952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 232954 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 232961 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PSZm:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 232961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZm),
     /* 232964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232966 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 232968 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 232970 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 232974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 232979 */     GIR_RootConstrainSelectedInstOperands,
     /* 232980 */     // GIR_Coverage, 8447,
     /* 232980 */     GIR_EraseRootFromParent_Done,
     /* 232981 */   // Label 5344: @232981
     /* 232981 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(233014), // Rule ID 8443 //
     /* 232986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 232989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 232997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233001 */     // (strict_fma:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src3)  =>  (VFMADD213PSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src1, VR512:{ *:[v16f32] }:$src2, VR512:{ *:[v16f32] }:$src3)
     /* 233001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PSZr),
     /* 233004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233006 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233008 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233010 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 233012 */     GIR_RootConstrainSelectedInstOperands,
     /* 233013 */     // GIR_Coverage, 8443,
     /* 233013 */     GIR_EraseRootFromParent_Done,
     /* 233014 */   // Label 5345: @233014
     /* 233014 */   GIM_Reject,
     /* 233015 */ // Label 5341: @233015
     /* 233015 */ GIM_Reject,
     /* 233016 */ // Label 5241: @233016
     /* 233016 */ GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(233260),
     /* 233021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 233024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v32s16,
     /* 233027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v32s16,
     /* 233030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233034 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(233098), // Rule ID 9594 //
     /* 233039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233050 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233053 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233057 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233071 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233078 */     // (strict_fma:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2)  =>  (VFMADD132PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD132PHZm),
     /* 233081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233083 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233085 */     GIR_RootToRootCopy, /*OpIdx*/3, // src2
     /* 233087 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233096 */     GIR_RootConstrainSelectedInstOperands,
     /* 233097 */     // GIR_Coverage, 9594,
     /* 233097 */     GIR_EraseRootFromParent_Done,
     /* 233098 */   // Label 5347: @233098
     /* 233098 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(233162), // Rule ID 9054 //
     /* 233103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 233114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233118 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233121 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233125 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233135 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233142 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>, VR512:{ *:[v32f16] }:$src1)  =>  (VFMADD231PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD231PHZm),
     /* 233145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233147 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 233149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233160 */     GIR_RootConstrainSelectedInstOperands,
     /* 233161 */     // GIR_Coverage, 9054,
     /* 233161 */     GIR_EraseRootFromParent_Done,
     /* 233162 */   // Label 5348: @233162
     /* 233162 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(233226), // Rule ID 8408 //
     /* 233167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 233182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233186 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233193 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233206 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src3)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VFMADD213PHZm:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, addr:{ *:[iPTR] }:$src3)
     /* 233206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZm),
     /* 233209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233211 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233213 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233215 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src3
     /* 233219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233224 */     GIR_RootConstrainSelectedInstOperands,
     /* 233225 */     // GIR_Coverage, 8408,
     /* 233225 */     GIR_EraseRootFromParent_Done,
     /* 233226 */   // Label 5349: @233226
     /* 233226 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(233259), // Rule ID 8404 //
     /* 233231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 233246 */     // (strict_fma:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src3)  =>  (VFMADD213PHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src1, VR512:{ *:[v32f16] }:$src2, VR512:{ *:[v32f16] }:$src3)
     /* 233246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VFMADD213PHZr),
     /* 233249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233251 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 233253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src2
     /* 233255 */     GIR_RootToRootCopy, /*OpIdx*/3, // src3
     /* 233257 */     GIR_RootConstrainSelectedInstOperands,
     /* 233258 */     // GIR_Coverage, 8404,
     /* 233258 */     GIR_EraseRootFromParent_Done,
     /* 233259 */   // Label 5350: @233259
     /* 233259 */   GIM_Reject,
     /* 233260 */ // Label 5346: @233260
     /* 233260 */ GIM_Reject,
     /* 233261 */ // Label 5242: @233261
     /* 233261 */ GIM_Reject,
     /* 233262 */ // Label 73: @233262
     /* 233262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(23), /*)*//*default:*//*Label 5364*/ GIMT_Encode4(235430),
     /* 233273 */ /*GILLT_s16*//*Label 5351*/ GIMT_Encode4(233357),
     /* 233277 */ /*GILLT_s32*//*Label 5352*/ GIMT_Encode4(233478),
     /* 233281 */ /*GILLT_s64*//*Label 5353*/ GIMT_Encode4(233834),
     /* 233285 */ /*GILLT_s80*//*Label 5354*/ GIMT_Encode4(234190), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233297 */ /*GILLT_v2s64*//*Label 5355*/ GIMT_Encode4(234227), GIMT_Encode4(0),
     /* 233305 */ /*GILLT_v4s32*//*Label 5356*/ GIMT_Encode4(234430),
     /* 233309 */ /*GILLT_v4s64*//*Label 5357*/ GIMT_Encode4(234633), GIMT_Encode4(0),
     /* 233317 */ /*GILLT_v8s16*//*Label 5358*/ GIMT_Encode4(234809),
     /* 233321 */ /*GILLT_v8s32*//*Label 5359*/ GIMT_Encode4(234898),
     /* 233325 */ /*GILLT_v8s64*//*Label 5360*/ GIMT_Encode4(235074), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233337 */ /*GILLT_v16s16*//*Label 5361*/ GIMT_Encode4(235163),
     /* 233341 */ /*GILLT_v16s32*//*Label 5362*/ GIMT_Encode4(235252), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 233353 */ /*GILLT_v32s16*//*Label 5363*/ GIMT_Encode4(235341),
     /* 233357 */ // Label 5351: @233357
     /* 233357 */ GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(233477),
     /* 233362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 233365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233369 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(233438), // Rule ID 21420 //
     /* 233374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_OptForSize),
     /* 233377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233385 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233388 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233392 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233398 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233405 */     // (strict_fsqrt:{ *:[f16] } (ld:{ *:[f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSHZm:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), addr:{ *:[iPTR] }:$src)
     /* 233405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZm),
     /* 233422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233427 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233431 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233436 */     GIR_RootConstrainSelectedInstOperands,
     /* 233437 */     // GIR_Coverage, 21420,
     /* 233437 */     GIR_EraseRootFromParent_Done,
     /* 233438 */   // Label 5366: @233438
     /* 233438 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(233476), // Rule ID 21418 //
     /* 233443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 233446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR16XRegClassID),
     /* 233450 */     // (strict_fsqrt:{ *:[f16] } FR16X:{ *:[f16] }:$src)  =>  (VSQRTSHZr:{ *:[f16] } (IMPLICIT_DEF:{ *:[f16] }), FR16X:{ *:[f16] }:$src)
     /* 233450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 233453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSHZr),
     /* 233467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233472 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233474 */     GIR_RootConstrainSelectedInstOperands,
     /* 233475 */     // GIR_Coverage, 21418,
     /* 233475 */     GIR_EraseRootFromParent_Done,
     /* 233476 */   // Label 5367: @233476
     /* 233476 */   GIM_Reject,
     /* 233477 */ // Label 5365: @233477
     /* 233477 */ GIM_Reject,
     /* 233478 */ // Label 5352: @233478
     /* 233478 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(233833),
     /* 233483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 233486 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(233542), // Rule ID 2448 //
     /* 233491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE1),
     /* 233494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233506 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233509 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233513 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233519 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233526 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSSm:{ *:[f32] } addr:{ *:[iPTR] }:$src1)
     /* 233526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSSm),
     /* 233529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233531 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233540 */     GIR_RootConstrainSelectedInstOperands,
     /* 233541 */     // GIR_Coverage, 2448,
     /* 233541 */     GIR_EraseRootFromParent_Done,
     /* 233542 */   // Label 5369: @233542
     /* 233542 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(233615), // Rule ID 18276 //
     /* 233547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233562 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233565 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233569 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233575 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233582 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSm),
     /* 233599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233604 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233613 */     GIR_RootConstrainSelectedInstOperands,
     /* 233614 */     // GIR_Coverage, 18276,
     /* 233614 */     GIR_EraseRootFromParent_Done,
     /* 233615 */   // Label 5370: @233615
     /* 233615 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(233688), // Rule ID 21424 //
     /* 233620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233635 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233638 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233642 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233648 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233655 */     // (strict_fsqrt:{ *:[f32] } (ld:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSSZm:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), addr:{ *:[iPTR] }:$src)
     /* 233655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZm),
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233677 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233686 */     GIR_RootConstrainSelectedInstOperands,
     /* 233687 */     // GIR_Coverage, 21424,
     /* 233687 */     GIR_EraseRootFromParent_Done,
     /* 233688 */   // Label 5371: @233688
     /* 233688 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(233721), // Rule ID 1048 //
     /* 233693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 233696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 233704 */     // (strict_fsqrt:{ *:[f32] } RFP32:{ *:[f32] }:$src)  =>  (SQRT_Fp32:{ *:[f32] }:{ *:[i16] } RFP32:{ *:[f32] }:$src)
     /* 233704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp32),
     /* 233709 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 233715 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 233719 */     GIR_RootConstrainSelectedInstOperands,
     /* 233720 */     // GIR_Coverage, 1048,
     /* 233720 */     GIR_Done,
     /* 233721 */   // Label 5372: @233721
     /* 233721 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(233748), // Rule ID 2446 //
     /* 233726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 233729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233737 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src1)  =>  (SQRTSSr:{ *:[f32] } FR32:{ *:[f32] }:$src1)
     /* 233737 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSSr),
     /* 233742 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 233746 */     GIR_RootConstrainSelectedInstOperands,
     /* 233747 */     // GIR_Coverage, 2446,
     /* 233747 */     GIR_Done,
     /* 233748 */   // Label 5373: @233748
     /* 233748 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(233790), // Rule ID 18274 //
     /* 233753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 233756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32RegClassID),
     /* 233764 */     // (strict_fsqrt:{ *:[f32] } FR32:{ *:[f32] }:$src)  =>  (VSQRTSSr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32:{ *:[f32] }:$src)
     /* 233764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSr),
     /* 233781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233786 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233788 */     GIR_RootConstrainSelectedInstOperands,
     /* 233789 */     // GIR_Coverage, 18274,
     /* 233789 */     GIR_EraseRootFromParent_Done,
     /* 233790 */   // Label 5374: @233790
     /* 233790 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(233832), // Rule ID 21422 //
     /* 233795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 233798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR32XRegClassID),
     /* 233806 */     // (strict_fsqrt:{ *:[f32] } FR32X:{ *:[f32] }:$src)  =>  (VSQRTSSZr:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FR32X:{ *:[f32] }:$src)
     /* 233806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 233809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSSZr),
     /* 233823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233828 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 233830 */     GIR_RootConstrainSelectedInstOperands,
     /* 233831 */     // GIR_Coverage, 21422,
     /* 233831 */     GIR_EraseRootFromParent_Done,
     /* 233832 */   // Label 5375: @233832
     /* 233832 */   GIM_Reject,
     /* 233833 */ // Label 5368: @233833
     /* 233833 */ GIM_Reject,
     /* 233834 */ // Label 5353: @233834
     /* 233834 */ GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(234189),
     /* 233839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 233842 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(233898), // Rule ID 2464 //
     /* 233847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseSSE2),
     /* 233850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233862 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233865 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233869 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233875 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233882 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src1)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SQRTSDm:{ *:[f64] } addr:{ *:[iPTR] }:$src1)
     /* 233882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::SQRTSDm),
     /* 233885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233887 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src1
     /* 233891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233896 */     GIR_RootConstrainSelectedInstOperands,
     /* 233897 */     // GIR_Coverage, 2464,
     /* 233897 */     GIR_EraseRootFromParent_Done,
     /* 233898 */   // Label 5377: @233898
     /* 233898 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(233971), // Rule ID 18280 //
     /* 233903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptForSize_UseAVX),
     /* 233906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 233910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233918 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233921 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233925 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 233929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 233931 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 233938 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 233938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 233941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 233945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 233950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 233952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDm),
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 233960 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 233964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 233969 */     GIR_RootConstrainSelectedInstOperands,
     /* 233970 */     // GIR_Coverage, 18280,
     /* 233970 */     GIR_EraseRootFromParent_Done,
     /* 233971 */   // Label 5378: @233971
     /* 233971 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(234044), // Rule ID 21428 //
     /* 233976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512_OptForSize),
     /* 233979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 233983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 233987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 233991 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 233994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 233998 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234004 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234011 */     // (strict_fsqrt:{ *:[f64] } (ld:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTSDZm:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), addr:{ *:[iPTR] }:$src)
     /* 234011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZm),
     /* 234028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234033 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234042 */     GIR_RootConstrainSelectedInstOperands,
     /* 234043 */     // GIR_Coverage, 21428,
     /* 234043 */     GIR_EraseRootFromParent_Done,
     /* 234044 */   // Label 5379: @234044
     /* 234044 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(234077), // Rule ID 1050 //
     /* 234049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 234052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 234060 */     // (strict_fsqrt:{ *:[f64] } RFP64:{ *:[f64] }:$src)  =>  (SQRT_Fp64:{ *:[f64] }:{ *:[i16] } RFP64:{ *:[f64] }:$src)
     /* 234060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp64),
     /* 234065 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234071 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234075 */     GIR_RootConstrainSelectedInstOperands,
     /* 234076 */     // GIR_Coverage, 1050,
     /* 234076 */     GIR_Done,
     /* 234077 */   // Label 5380: @234077
     /* 234077 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(234104), // Rule ID 2462 //
     /* 234082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234093 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src1)  =>  (SQRTSDr:{ *:[f64] } FR64:{ *:[f64] }:$src1)
     /* 234093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTSDr),
     /* 234098 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234102 */     GIR_RootConstrainSelectedInstOperands,
     /* 234103 */     // GIR_Coverage, 2462,
     /* 234103 */     GIR_Done,
     /* 234104 */   // Label 5381: @234104
     /* 234104 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(234146), // Rule ID 18278 //
     /* 234109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseAVX),
     /* 234112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64RegClassID),
     /* 234120 */     // (strict_fsqrt:{ *:[f64] } FR64:{ *:[f64] }:$src)  =>  (VSQRTSDr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64:{ *:[f64] }:$src)
     /* 234120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDr),
     /* 234137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234142 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234144 */     GIR_RootConstrainSelectedInstOperands,
     /* 234145 */     // GIR_Coverage, 18278,
     /* 234145 */     GIR_EraseRootFromParent_Done,
     /* 234146 */   // Label 5382: @234146
     /* 234146 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(234188), // Rule ID 21426 //
     /* 234151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 234154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::FR64XRegClassID),
     /* 234162 */     // (strict_fsqrt:{ *:[f64] } FR64X:{ *:[f64] }:$src)  =>  (VSQRTSDZr:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), FR64X:{ *:[f64] }:$src)
     /* 234162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 234165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 234169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 234174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 234176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTSDZr),
     /* 234179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 234184 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 234186 */     GIR_RootConstrainSelectedInstOperands,
     /* 234187 */     // GIR_Coverage, 21426,
     /* 234187 */     GIR_EraseRootFromParent_Done,
     /* 234188 */   // Label 5383: @234188
     /* 234188 */   GIM_Reject,
     /* 234189 */ // Label 5376: @234189
     /* 234189 */ GIM_Reject,
     /* 234190 */ // Label 5354: @234190
     /* 234190 */ GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(234226), // Rule ID 1052 //
     /* 234195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 234198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s80,
     /* 234201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 234209 */   // (strict_fsqrt:{ *:[f80] } RFP80:{ *:[f80] }:$src)  =>  (SQRT_Fp80:{ *:[f80] }:{ *:[i16] } RFP80:{ *:[f80] }:$src)
     /* 234209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRT_Fp80),
     /* 234214 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(X86::FPSW), GIMT_Encode2(RegState::Dead),
     /* 234220 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::FPCW),
     /* 234224 */   GIR_RootConstrainSelectedInstOperands,
     /* 234225 */   // GIR_Coverage, 1052,
     /* 234225 */   GIR_Done,
     /* 234226 */ // Label 5384: @234226
     /* 234226 */ GIM_Reject,
     /* 234227 */ // Label 5355: @234227
     /* 234227 */ GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(234429),
     /* 234232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 234235 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(234291), // Rule ID 2468 //
     /* 234240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234255 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234258 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234275 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDm:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDm),
     /* 234278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234284 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234289 */     GIR_RootConstrainSelectedInstOperands,
     /* 234290 */     // GIR_Coverage, 2468,
     /* 234290 */     GIR_EraseRootFromParent_Done,
     /* 234291 */   // Label 5386: @234291
     /* 234291 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(234347), // Rule ID 12086 //
     /* 234296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234311 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234314 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234318 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234331 */     // (strict_fsqrt:{ *:[v2f64] } (ld:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ128m:{ *:[v2f64] } addr:{ *:[iPTR] }:$src)
     /* 234331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128m),
     /* 234334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234336 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234345 */     GIR_RootConstrainSelectedInstOperands,
     /* 234346 */     // GIR_Coverage, 12086,
     /* 234346 */     GIR_EraseRootFromParent_Done,
     /* 234347 */   // Label 5387: @234347
     /* 234347 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(234374), // Rule ID 2466 //
     /* 234352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234363 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (VSQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDr),
     /* 234368 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234372 */     GIR_RootConstrainSelectedInstOperands,
     /* 234373 */     // GIR_Coverage, 2466,
     /* 234373 */     GIR_Done,
     /* 234374 */   // Label 5388: @234374
     /* 234374 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(234401), // Rule ID 2474 //
     /* 234379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE2),
     /* 234382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234390 */     // (strict_fsqrt:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)  =>  (SQRTPDr:{ *:[v2f64] } VR128:{ *:[v2f64] }:$src)
     /* 234390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPDr),
     /* 234395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234399 */     GIR_RootConstrainSelectedInstOperands,
     /* 234400 */     // GIR_Coverage, 2474,
     /* 234400 */     GIR_Done,
     /* 234401 */   // Label 5389: @234401
     /* 234401 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(234428), // Rule ID 12082 //
     /* 234406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234417 */     // (strict_fsqrt:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)  =>  (VSQRTPDZ128r:{ *:[v2f64] } VR128X:{ *:[v2f64] }:$src)
     /* 234417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ128r),
     /* 234422 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234426 */     GIR_RootConstrainSelectedInstOperands,
     /* 234427 */     // GIR_Coverage, 12082,
     /* 234427 */     GIR_Done,
     /* 234428 */   // Label 5390: @234428
     /* 234428 */   GIM_Reject,
     /* 234429 */ // Label 5385: @234429
     /* 234429 */ GIM_Reject,
     /* 234430 */ // Label 5356: @234430
     /* 234430 */ GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(234632),
     /* 234435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 234438 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(234494), // Rule ID 2452 //
     /* 234443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234458 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234461 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234465 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234471 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234478 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSm:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSm),
     /* 234481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234483 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234492 */     GIR_RootConstrainSelectedInstOperands,
     /* 234493 */     // GIR_Coverage, 2452,
     /* 234493 */     GIR_EraseRootFromParent_Done,
     /* 234494 */   // Label 5392: @234494
     /* 234494 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(234550), // Rule ID 12062 //
     /* 234499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234514 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234521 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234534 */     // (strict_fsqrt:{ *:[v4f32] } (ld:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ128m:{ *:[v4f32] } addr:{ *:[iPTR] }:$src)
     /* 234534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128m),
     /* 234537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234539 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234548 */     GIR_RootConstrainSelectedInstOperands,
     /* 234549 */     // GIR_Coverage, 12062,
     /* 234549 */     GIR_EraseRootFromParent_Done,
     /* 234550 */   // Label 5393: @234550
     /* 234550 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(234577), // Rule ID 2450 //
     /* 234555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234566 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (VSQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSr),
     /* 234571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234575 */     GIR_RootConstrainSelectedInstOperands,
     /* 234576 */     // GIR_Coverage, 2450,
     /* 234576 */     GIR_Done,
     /* 234577 */   // Label 5394: @234577
     /* 234577 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(234604), // Rule ID 2458 //
     /* 234582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSSE1),
     /* 234585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128RegClassID),
     /* 234593 */     // (strict_fsqrt:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)  =>  (SQRTPSr:{ *:[v4f32] } VR128:{ *:[v4f32] }:$src)
     /* 234593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::SQRTPSr),
     /* 234598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234602 */     GIR_RootConstrainSelectedInstOperands,
     /* 234603 */     // GIR_Coverage, 2458,
     /* 234603 */     GIR_Done,
     /* 234604 */   // Label 5395: @234604
     /* 234604 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(234631), // Rule ID 12058 //
     /* 234609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234620 */     // (strict_fsqrt:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)  =>  (VSQRTPSZ128r:{ *:[v4f32] } VR128X:{ *:[v4f32] }:$src)
     /* 234620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ128r),
     /* 234625 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234629 */     GIR_RootConstrainSelectedInstOperands,
     /* 234630 */     // GIR_Coverage, 12058,
     /* 234630 */     GIR_Done,
     /* 234631 */   // Label 5396: @234631
     /* 234631 */   GIM_Reject,
     /* 234632 */ // Label 5391: @234632
     /* 234632 */ GIM_Reject,
     /* 234633 */ // Label 5357: @234633
     /* 234633 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(234808),
     /* 234638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s64,
     /* 234641 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(234697), // Rule ID 2472 //
     /* 234646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234661 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234668 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234674 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234681 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDYm:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYm),
     /* 234684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234686 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234695 */     GIR_RootConstrainSelectedInstOperands,
     /* 234696 */     // GIR_Coverage, 2472,
     /* 234696 */     GIR_EraseRootFromParent_Done,
     /* 234697 */   // Label 5398: @234697
     /* 234697 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(234753), // Rule ID 12098 //
     /* 234702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234717 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234720 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234724 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234737 */     // (strict_fsqrt:{ *:[v4f64] } (ld:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZ256m:{ *:[v4f64] } addr:{ *:[iPTR] }:$src)
     /* 234737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256m),
     /* 234740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234742 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234751 */     GIR_RootConstrainSelectedInstOperands,
     /* 234752 */     // GIR_Coverage, 12098,
     /* 234752 */     GIR_EraseRootFromParent_Done,
     /* 234753 */   // Label 5399: @234753
     /* 234753 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(234780), // Rule ID 2470 //
     /* 234758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234769 */     // (strict_fsqrt:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)  =>  (VSQRTPDYr:{ *:[v4f64] } VR256:{ *:[v4f64] }:$src)
     /* 234769 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDYr),
     /* 234774 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234778 */     GIR_RootConstrainSelectedInstOperands,
     /* 234779 */     // GIR_Coverage, 2470,
     /* 234779 */     GIR_Done,
     /* 234780 */   // Label 5400: @234780
     /* 234780 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(234807), // Rule ID 12094 //
     /* 234785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234796 */     // (strict_fsqrt:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)  =>  (VSQRTPDZ256r:{ *:[v4f64] } VR256X:{ *:[v4f64] }:$src)
     /* 234796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZ256r),
     /* 234801 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234805 */     GIR_RootConstrainSelectedInstOperands,
     /* 234806 */     // GIR_Coverage, 12094,
     /* 234806 */     GIR_Done,
     /* 234807 */   // Label 5401: @234807
     /* 234807 */   GIM_Reject,
     /* 234808 */ // Label 5397: @234808
     /* 234808 */ GIM_Reject,
     /* 234809 */ // Label 5358: @234809
     /* 234809 */ GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(234897),
     /* 234814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 234817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234821 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(234873), // Rule ID 12014 //
     /* 234826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234837 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234844 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234857 */     // (strict_fsqrt:{ *:[v8f16] } (ld:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ128m:{ *:[v8f16] } addr:{ *:[iPTR] }:$src)
     /* 234857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128m),
     /* 234860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234862 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234871 */     GIR_RootConstrainSelectedInstOperands,
     /* 234872 */     // GIR_Coverage, 12014,
     /* 234872 */     GIR_EraseRootFromParent_Done,
     /* 234873 */   // Label 5403: @234873
     /* 234873 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(234896), // Rule ID 12010 //
     /* 234878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 234881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR128XRegClassID),
     /* 234885 */     // (strict_fsqrt:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)  =>  (VSQRTPHZ128r:{ *:[v8f16] } VR128X:{ *:[v8f16] }:$src)
     /* 234885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ128r),
     /* 234890 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 234894 */     GIR_RootConstrainSelectedInstOperands,
     /* 234895 */     // GIR_Coverage, 12010,
     /* 234895 */     GIR_Done,
     /* 234896 */   // Label 5404: @234896
     /* 234896 */   GIM_Reject,
     /* 234897 */ // Label 5402: @234897
     /* 234897 */ GIM_Reject,
     /* 234898 */ // Label 5359: @234898
     /* 234898 */ GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(235073),
     /* 234903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s32,
     /* 234906 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(234962), // Rule ID 2456 //
     /* 234911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 234914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 234918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234926 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234933 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234939 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 234946 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSYm:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 234946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYm),
     /* 234949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234951 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 234955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 234960 */     GIR_RootConstrainSelectedInstOperands,
     /* 234961 */     // GIR_Coverage, 2456,
     /* 234961 */     GIR_EraseRootFromParent_Done,
     /* 234962 */   // Label 5406: @234962
     /* 234962 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(235018), // Rule ID 12074 //
     /* 234967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 234970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 234974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 234978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 234982 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 234985 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 234989 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 234993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 234995 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235002 */     // (strict_fsqrt:{ *:[v8f32] } (ld:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZ256m:{ *:[v8f32] } addr:{ *:[iPTR] }:$src)
     /* 235002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256m),
     /* 235005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235007 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235016 */     GIR_RootConstrainSelectedInstOperands,
     /* 235017 */     // GIR_Coverage, 12074,
     /* 235017 */     GIR_EraseRootFromParent_Done,
     /* 235018 */   // Label 5407: @235018
     /* 235018 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(235045), // Rule ID 2454 //
     /* 235023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX_NoVLX),
     /* 235026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235030 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256RegClassID),
     /* 235034 */     // (strict_fsqrt:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)  =>  (VSQRTPSYr:{ *:[v8f32] } VR256:{ *:[v8f32] }:$src)
     /* 235034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSYr),
     /* 235039 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235043 */     GIR_RootConstrainSelectedInstOperands,
     /* 235044 */     // GIR_Coverage, 2454,
     /* 235044 */     GIR_Done,
     /* 235045 */   // Label 5408: @235045
     /* 235045 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(235072), // Rule ID 12070 //
     /* 235050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVLX),
     /* 235053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235061 */     // (strict_fsqrt:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)  =>  (VSQRTPSZ256r:{ *:[v8f32] } VR256X:{ *:[v8f32] }:$src)
     /* 235061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZ256r),
     /* 235066 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235070 */     GIR_RootConstrainSelectedInstOperands,
     /* 235071 */     // GIR_Coverage, 12070,
     /* 235071 */     GIR_Done,
     /* 235072 */   // Label 5409: @235072
     /* 235072 */   GIM_Reject,
     /* 235073 */ // Label 5405: @235073
     /* 235073 */ GIM_Reject,
     /* 235074 */ // Label 5360: @235074
     /* 235074 */ GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(235162),
     /* 235079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s64,
     /* 235082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235086 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(235138), // Rule ID 12050 //
     /* 235091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235102 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235105 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235109 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235115 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235122 */     // (strict_fsqrt:{ *:[v8f64] } (ld:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPDZm:{ *:[v8f64] } addr:{ *:[iPTR] }:$src)
     /* 235122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZm),
     /* 235125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235127 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235136 */     GIR_RootConstrainSelectedInstOperands,
     /* 235137 */     // GIR_Coverage, 12050,
     /* 235137 */     GIR_EraseRootFromParent_Done,
     /* 235138 */   // Label 5411: @235138
     /* 235138 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(235161), // Rule ID 12046 //
     /* 235143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235150 */     // (strict_fsqrt:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)  =>  (VSQRTPDZr:{ *:[v8f64] } VR512:{ *:[v8f64] }:$src)
     /* 235150 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPDZr),
     /* 235155 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235159 */     GIR_RootConstrainSelectedInstOperands,
     /* 235160 */     // GIR_Coverage, 12046,
     /* 235160 */     GIR_Done,
     /* 235161 */   // Label 5412: @235161
     /* 235161 */   GIM_Reject,
     /* 235162 */ // Label 5410: @235162
     /* 235162 */ GIM_Reject,
     /* 235163 */ // Label 5361: @235163
     /* 235163 */ GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(235251),
     /* 235168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s16,
     /* 235171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235175 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(235227), // Rule ID 12026 //
     /* 235180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235191 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235194 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235198 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235204 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235211 */     // (strict_fsqrt:{ *:[v16f16] } (ld:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZ256m:{ *:[v16f16] } addr:{ *:[iPTR] }:$src)
     /* 235211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256m),
     /* 235214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235216 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235225 */     GIR_RootConstrainSelectedInstOperands,
     /* 235226 */     // GIR_Coverage, 12026,
     /* 235226 */     GIR_EraseRootFromParent_Done,
     /* 235227 */   // Label 5414: @235227
     /* 235227 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(235250), // Rule ID 12022 //
     /* 235232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasVLX),
     /* 235235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR256XRegClassID),
     /* 235239 */     // (strict_fsqrt:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)  =>  (VSQRTPHZ256r:{ *:[v16f16] } VR256X:{ *:[v16f16] }:$src)
     /* 235239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZ256r),
     /* 235244 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235248 */     GIR_RootConstrainSelectedInstOperands,
     /* 235249 */     // GIR_Coverage, 12022,
     /* 235249 */     GIR_Done,
     /* 235250 */   // Label 5415: @235250
     /* 235250 */   GIM_Reject,
     /* 235251 */ // Label 5413: @235251
     /* 235251 */ GIM_Reject,
     /* 235252 */ // Label 5362: @235252
     /* 235252 */ GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(235340),
     /* 235257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s32,
     /* 235260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235264 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(235316), // Rule ID 12038 //
     /* 235269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235280 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235283 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235287 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235300 */     // (strict_fsqrt:{ *:[v16f32] } (ld:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPSZm:{ *:[v16f32] } addr:{ *:[iPTR] }:$src)
     /* 235300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZm),
     /* 235303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235305 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235314 */     GIR_RootConstrainSelectedInstOperands,
     /* 235315 */     // GIR_Coverage, 12038,
     /* 235315 */     GIR_EraseRootFromParent_Done,
     /* 235316 */   // Label 5417: @235316
     /* 235316 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(235339), // Rule ID 12034 //
     /* 235321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAVX512),
     /* 235324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235328 */     // (strict_fsqrt:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)  =>  (VSQRTPSZr:{ *:[v16f32] } VR512:{ *:[v16f32] }:$src)
     /* 235328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPSZr),
     /* 235333 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235337 */     GIR_RootConstrainSelectedInstOperands,
     /* 235338 */     // GIR_Coverage, 12034,
     /* 235338 */     GIR_Done,
     /* 235339 */   // Label 5418: @235339
     /* 235339 */   GIM_Reject,
     /* 235340 */ // Label 5416: @235340
     /* 235340 */ GIM_Reject,
     /* 235341 */ // Label 5363: @235341
     /* 235341 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(235429),
     /* 235346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v32s16,
     /* 235349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235353 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(235405), // Rule ID 12002 //
     /* 235358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 235365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 235369 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 235372 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 235376 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 235380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 235382 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235389 */     // (strict_fsqrt:{ *:[v32f16] } (ld:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (VSQRTPHZm:{ *:[v32f16] } addr:{ *:[iPTR] }:$src)
     /* 235389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZm),
     /* 235392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235394 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 235403 */     GIR_RootConstrainSelectedInstOperands,
     /* 235404 */     // GIR_Coverage, 12002,
     /* 235404 */     GIR_EraseRootFromParent_Done,
     /* 235405 */   // Label 5420: @235405
     /* 235405 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(235428), // Rule ID 11998 //
     /* 235410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 235413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(X86::VR512RegClassID),
     /* 235417 */     // (strict_fsqrt:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)  =>  (VSQRTPHZr:{ *:[v32f16] } VR512:{ *:[v32f16] }:$src)
     /* 235417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::VSQRTPHZr),
     /* 235422 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(X86::MXCSR),
     /* 235426 */     GIR_RootConstrainSelectedInstOperands,
     /* 235427 */     // GIR_Coverage, 11998,
     /* 235427 */     GIR_Done,
     /* 235428 */   // Label 5421: @235428
     /* 235428 */   GIM_Reject,
     /* 235429 */ // Label 5419: @235429
     /* 235429 */ GIM_Reject,
     /* 235430 */ // Label 5364: @235430
     /* 235430 */ GIM_Reject,
     /* 235431 */ // Label 74: @235431
     /* 235431 */ GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(235443), // Rule ID 17074 //
     /* 235436 */   // (trap)  =>  (TRAP)
     /* 235436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::TRAP),
     /* 235441 */   GIR_RootConstrainSelectedInstOperands,
     /* 235442 */   // GIR_Coverage, 17074,
     /* 235442 */   GIR_Done,
     /* 235443 */ // Label 5422: @235443
     /* 235443 */ GIM_Reject,
     /* 235444 */ // Label 75: @235444
     /* 235444 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(235459), // Rule ID 22377 //
     /* 235449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotPS),
     /* 235452 */   // (debugtrap)  =>  (INT3)
     /* 235452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::INT3),
     /* 235457 */   GIR_RootConstrainSelectedInstOperands,
     /* 235458 */   // GIR_Coverage, 22377,
     /* 235458 */   GIR_Done,
     /* 235459 */ // Label 5423: @235459
     /* 235459 */ GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(235479), // Rule ID 22378 //
     /* 235464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsPS),
     /* 235467 */   // (debugtrap)  =>  (INT 65:{ *:[i8] })
     /* 235467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::INT),
     /* 235470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/65,
     /* 235473 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235477 */   GIR_RootConstrainSelectedInstOperands,
     /* 235478 */   // GIR_Coverage, 22378,
     /* 235478 */   GIR_EraseRootFromParent_Done,
     /* 235479 */ // Label 5424: @235479
     /* 235479 */ GIM_Reject,
     /* 235480 */ // Label 76: @235480
     /* 235480 */ GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(235495), // Rule ID 17076 //
     /* 235485 */   // MIs[0] kind
     /* 235485 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 235488 */   // (ubsantrap (timm:{ *:[i32] }):$kind)  =>  (UBSAN_UD1 (timm:{ *:[i32] }):$kind)
     /* 235488 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(X86::UBSAN_UD1),
     /* 235493 */   GIR_RootConstrainSelectedInstOperands,
     /* 235494 */   // GIR_Coverage, 17076,
     /* 235494 */   GIR_Done,
     /* 235495 */ // Label 5425: @235495
     /* 235495 */ GIM_Reject,
     /* 235496 */ // Label 77: @235496
     /* 235496 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5429*/ GIMT_Encode4(235954),
     /* 235507 */ /*GILLT_s32*//*Label 5426*/ GIMT_Encode4(235519),
     /* 235511 */ /*GILLT_s64*//*Label 5427*/ GIMT_Encode4(235664),
     /* 235515 */ /*GILLT_s80*//*Label 5428*/ GIMT_Encode4(235809),
     /* 235519 */ // Label 5426: @235519
     /* 235519 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(235567), // Rule ID 1086 //
     /* 235524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235527 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235549 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m32),
     /* 235552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235554 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235558 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235561 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235565 */   GIR_RootConstrainSelectedInstOperands,
     /* 235566 */   // GIR_Coverage, 1086,
     /* 235566 */   GIR_EraseRootFromParent_Done,
     /* 235567 */ // Label 5430: @235567
     /* 235567 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(235615), // Rule ID 1087 //
     /* 235572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235575 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235586 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235590 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235597 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m32),
     /* 235600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235602 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235606 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235609 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235613 */   GIR_RootConstrainSelectedInstOperands,
     /* 235614 */   // GIR_Coverage, 1087,
     /* 235614 */   GIR_EraseRootFromParent_Done,
     /* 235615 */ // Label 5431: @235615
     /* 235615 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(235663), // Rule ID 1088 //
     /* 235620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf32),
     /* 235623 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235645 */   // (X86fild:{ *:[f32] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m32:{ *:[f32] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m32),
     /* 235648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235650 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235654 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235657 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235661 */   GIR_RootConstrainSelectedInstOperands,
     /* 235662 */   // GIR_Coverage, 1088,
     /* 235662 */   GIR_EraseRootFromParent_Done,
     /* 235663 */ // Label 5432: @235663
     /* 235663 */ GIM_Reject,
     /* 235664 */ // Label 5427: @235664
     /* 235664 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(235712), // Rule ID 1089 //
     /* 235669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235672 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235694 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m64),
     /* 235697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235699 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235703 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235706 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235710 */   GIR_RootConstrainSelectedInstOperands,
     /* 235711 */   // GIR_Coverage, 1089,
     /* 235711 */   GIR_EraseRootFromParent_Done,
     /* 235712 */ // Label 5433: @235712
     /* 235712 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(235760), // Rule ID 1090 //
     /* 235717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235742 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m64),
     /* 235745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235747 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235751 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235758 */   GIR_RootConstrainSelectedInstOperands,
     /* 235759 */   // GIR_Coverage, 1090,
     /* 235759 */   GIR_EraseRootFromParent_Done,
     /* 235760 */ // Label 5434: @235760
     /* 235760 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(235808), // Rule ID 1091 //
     /* 235765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_FPStackf64),
     /* 235768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 235779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235790 */   // (X86fild:{ *:[f64] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m64:{ *:[f64] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m64),
     /* 235793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235795 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235799 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235802 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235806 */   GIR_RootConstrainSelectedInstOperands,
     /* 235807 */   // GIR_Coverage, 1091,
     /* 235807 */   GIR_EraseRootFromParent_Done,
     /* 235808 */ // Label 5435: @235808
     /* 235808 */ GIM_Reject,
     /* 235809 */ // Label 5428: @235809
     /* 235809 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(235857), // Rule ID 1092 //
     /* 235814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235817 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235832 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235839 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild16>>  =>  (ILD_Fp16m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp16m80),
     /* 235842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235844 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235848 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235855 */   GIR_RootConstrainSelectedInstOperands,
     /* 235856 */   // GIR_Coverage, 1092,
     /* 235856 */   GIR_EraseRootFromParent_Done,
     /* 235857 */ // Label 5436: @235857
     /* 235857 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(235905), // Rule ID 1093 //
     /* 235862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235865 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 235872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235876 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235880 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235887 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild32>>  =>  (ILD_Fp32m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp32m80),
     /* 235890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235892 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235896 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235899 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235903 */   GIR_RootConstrainSelectedInstOperands,
     /* 235904 */   // GIR_Coverage, 1093,
     /* 235904 */   GIR_EraseRootFromParent_Done,
     /* 235905 */ // Label 5437: @235905
     /* 235905 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(235953), // Rule ID 1094 //
     /* 235910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasX87),
     /* 235913 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 235920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 235924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235928 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 235935 */   // (X86fild:{ *:[f80] } addr:{ *:[iPTR] }:$src)<<P:Predicate_X86fild64>>  =>  (ILD_Fp64m80:{ *:[f80] }:{ *:[i16] } addr:{ *:[iPTR] }:$src)
     /* 235935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ILD_Fp64m80),
     /* 235938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235940 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // src
     /* 235944 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 235947 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 235951 */   GIR_RootConstrainSelectedInstOperands,
     /* 235952 */   // GIR_Coverage, 1094,
     /* 235952 */   GIR_EraseRootFromParent_Done,
     /* 235953 */ // Label 5438: @235953
     /* 235953 */ GIM_Reject,
     /* 235954 */ // Label 5429: @235954
     /* 235954 */ GIM_Reject,
     /* 235955 */ // Label 78: @235955
     /* 235955 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(6), /*)*//*default:*//*Label 5442*/ GIMT_Encode4(236818),
     /* 235966 */ /*GILLT_s32*//*Label 5439*/ GIMT_Encode4(235978),
     /* 235970 */ /*GILLT_s64*//*Label 5440*/ GIMT_Encode4(236258),
     /* 235974 */ /*GILLT_s80*//*Label 5441*/ GIMT_Encode4(236538),
     /* 235978 */ // Label 5439: @235978
     /* 235978 */ GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(236023), // Rule ID 873 //
     /* 235983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 235990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 235994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 235998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236005 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP32_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT16_IN_MEM),
     /* 236008 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236012 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236014 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236021 */   GIR_RootConstrainSelectedInstOperands,
     /* 236022 */   // GIR_Coverage, 873,
     /* 236022 */   GIR_EraseRootFromParent_Done,
     /* 236023 */ // Label 5443: @236023
     /* 236023 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(236068), // Rule ID 874 //
     /* 236028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236039 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236043 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236050 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP32_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT32_IN_MEM),
     /* 236053 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236057 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236059 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236062 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236066 */   GIR_RootConstrainSelectedInstOperands,
     /* 236067 */   // GIR_Coverage, 874,
     /* 236067 */   GIR_EraseRootFromParent_Done,
     /* 236068 */ // Label 5444: @236068
     /* 236068 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(236113), // Rule ID 875 //
     /* 236073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236095 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP32_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP32:{ *:[f32] }:$src)
     /* 236095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP32_TO_INT64_IN_MEM),
     /* 236098 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236102 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236104 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236107 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236111 */   GIR_RootConstrainSelectedInstOperands,
     /* 236112 */   // GIR_Coverage, 875,
     /* 236112 */   GIR_EraseRootFromParent_Done,
     /* 236113 */ // Label 5445: @236113
     /* 236113 */ GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(236161), // Rule ID 1107 //
     /* 236118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236121 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236136 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236143 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m32),
     /* 236146 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236150 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236152 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236159 */   GIR_RootConstrainSelectedInstOperands,
     /* 236160 */   // GIR_Coverage, 1107,
     /* 236160 */   GIR_EraseRootFromParent_Done,
     /* 236161 */ // Label 5446: @236161
     /* 236161 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(236209), // Rule ID 1108 //
     /* 236166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236169 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236180 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236184 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236191 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m32),
     /* 236194 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236198 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236200 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236203 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236207 */   GIR_RootConstrainSelectedInstOperands,
     /* 236208 */   // GIR_Coverage, 1108,
     /* 236208 */   GIR_EraseRootFromParent_Done,
     /* 236209 */ // Label 5447: @236209
     /* 236209 */ GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(236257), // Rule ID 1109 //
     /* 236214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236217 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP32RegClassID),
     /* 236228 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236232 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236239 */   // (X86fp_to_mem RFP32:{ *:[f32] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m32:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP32:{ *:[f32] }:$src)
     /* 236239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m32),
     /* 236242 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236246 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236248 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236251 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236255 */   GIR_RootConstrainSelectedInstOperands,
     /* 236256 */   // GIR_Coverage, 1109,
     /* 236256 */   GIR_EraseRootFromParent_Done,
     /* 236257 */ // Label 5448: @236257
     /* 236257 */ GIM_Reject,
     /* 236258 */ // Label 5440: @236258
     /* 236258 */ GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(236303), // Rule ID 876 //
     /* 236263 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236274 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236278 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236285 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP64_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT16_IN_MEM),
     /* 236288 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236292 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236294 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236301 */   GIR_RootConstrainSelectedInstOperands,
     /* 236302 */   // GIR_Coverage, 876,
     /* 236302 */   GIR_EraseRootFromParent_Done,
     /* 236303 */ // Label 5449: @236303
     /* 236303 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(236348), // Rule ID 877 //
     /* 236308 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236330 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP64_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT32_IN_MEM),
     /* 236333 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236337 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236339 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236342 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236346 */   GIR_RootConstrainSelectedInstOperands,
     /* 236347 */   // GIR_Coverage, 877,
     /* 236347 */   GIR_EraseRootFromParent_Done,
     /* 236348 */ // Label 5450: @236348
     /* 236348 */ GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(236393), // Rule ID 878 //
     /* 236353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236375 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP64_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP64:{ *:[f64] }:$src)
     /* 236375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP64_TO_INT64_IN_MEM),
     /* 236378 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236382 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236384 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236391 */   GIR_RootConstrainSelectedInstOperands,
     /* 236392 */   // GIR_Coverage, 878,
     /* 236392 */   GIR_EraseRootFromParent_Done,
     /* 236393 */ // Label 5451: @236393
     /* 236393 */ GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(236441), // Rule ID 1110 //
     /* 236398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236401 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236412 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236416 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236423 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m64),
     /* 236426 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236430 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236432 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236435 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236439 */   GIR_RootConstrainSelectedInstOperands,
     /* 236440 */   // GIR_Coverage, 1110,
     /* 236440 */   GIR_EraseRootFromParent_Done,
     /* 236441 */ // Label 5452: @236441
     /* 236441 */ GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(236489), // Rule ID 1111 //
     /* 236446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236460 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236464 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236471 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m64),
     /* 236474 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236478 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236480 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236483 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236487 */   GIR_RootConstrainSelectedInstOperands,
     /* 236488 */   // GIR_Coverage, 1111,
     /* 236488 */   GIR_EraseRootFromParent_Done,
     /* 236489 */ // Label 5453: @236489
     /* 236489 */ GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(236537), // Rule ID 1112 //
     /* 236494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236497 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP64RegClassID),
     /* 236508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236519 */   // (X86fp_to_mem RFP64:{ *:[f64] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m64:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP64:{ *:[f64] }:$src)
     /* 236519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m64),
     /* 236522 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236526 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236528 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236535 */   GIR_RootConstrainSelectedInstOperands,
     /* 236536 */   // GIR_Coverage, 1112,
     /* 236536 */   GIR_EraseRootFromParent_Done,
     /* 236537 */ // Label 5454: @236537
     /* 236537 */ GIM_Reject,
     /* 236538 */ // Label 5441: @236538
     /* 236538 */ GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(236583), // Rule ID 879 //
     /* 236543 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236565 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i16mem>>  =>  (FP80_TO_INT16_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT16_IN_MEM),
     /* 236568 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236572 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236574 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236581 */   GIR_RootConstrainSelectedInstOperands,
     /* 236582 */   // GIR_Coverage, 879,
     /* 236582 */   GIR_EraseRootFromParent_Done,
     /* 236583 */ // Label 5455: @236583
     /* 236583 */ GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(236628), // Rule ID 880 //
     /* 236588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236610 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i32mem>>  =>  (FP80_TO_INT32_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT32_IN_MEM),
     /* 236613 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236617 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236619 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236622 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236626 */   GIR_RootConstrainSelectedInstOperands,
     /* 236627 */   // GIR_Coverage, 880,
     /* 236627 */   GIR_EraseRootFromParent_Done,
     /* 236628 */ // Label 5456: @236628
     /* 236628 */ GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(236673), // Rule ID 881 //
     /* 236633 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236644 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236648 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236655 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$dst)<<P:Predicate_X86fp_to_i64mem>>  =>  (FP80_TO_INT64_IN_MEM:{ *:[i32] } addr:{ *:[iPTR] }:$dst, RFP80:{ *:[f80] }:$src)
     /* 236655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FP80_TO_INT64_IN_MEM),
     /* 236658 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236662 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236664 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::EFLAGS*/0,
     /* 236667 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236671 */   GIR_RootConstrainSelectedInstOperands,
     /* 236672 */   // GIR_Coverage, 881,
     /* 236672 */   GIR_EraseRootFromParent_Done,
     /* 236673 */ // Label 5457: @236673
     /* 236673 */ GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(236721), // Rule ID 1113 //
     /* 236678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 236688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236692 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236696 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236703 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i16mem>>  =>  (ISTT_Fp16m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp16m80),
     /* 236706 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236710 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236712 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236719 */   GIR_RootConstrainSelectedInstOperands,
     /* 236720 */   // GIR_Coverage, 1113,
     /* 236720 */   GIR_EraseRootFromParent_Done,
     /* 236721 */ // Label 5458: @236721
     /* 236721 */ GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(236769), // Rule ID 1114 //
     /* 236726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236729 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 236736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236740 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236744 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236751 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i32mem>>  =>  (ISTT_Fp32m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp32m80),
     /* 236754 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236758 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236760 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236767 */   GIR_RootConstrainSelectedInstOperands,
     /* 236768 */   // GIR_Coverage, 1114,
     /* 236768 */   GIR_EraseRootFromParent_Done,
     /* 236769 */ // Label 5459: @236769
     /* 236769 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(236817), // Rule ID 1115 //
     /* 236774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSE3),
     /* 236777 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 236784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(X86::RFP80RegClassID),
     /* 236788 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 236792 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236799 */   // (X86fp_to_mem RFP80:{ *:[f80] }:$src, addr:{ *:[iPTR] }:$op)<<P:Predicate_X86fp_to_i64mem>>  =>  (ISTT_Fp64m80:{ *:[i16] } addr:{ *:[iPTR] }:$op, RFP80:{ *:[f80] }:$src)
     /* 236799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::ISTT_Fp64m80),
     /* 236802 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // op
     /* 236806 */   GIR_RootToRootCopy, /*OpIdx*/0, // src
     /* 236808 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236811 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236815 */   GIR_RootConstrainSelectedInstOperands,
     /* 236816 */   // GIR_Coverage, 1115,
     /* 236816 */   GIR_EraseRootFromParent_Done,
     /* 236817 */ // Label 5460: @236817
     /* 236817 */ GIM_Reject,
     /* 236818 */ // Label 5442: @236818
     /* 236818 */ GIM_Reject,
     /* 236819 */ // Label 79: @236819
     /* 236819 */ GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(236851), // Rule ID 1131 //
     /* 236824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /* 236828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/0, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addr),
     /* 236835 */   // (X86fp_cwd_get16 addr:{ *:[iPTR] }:$dst)  =>  (FNSTCW16m:{ *:[i16] } addr:{ *:[iPTR] }:$dst)
     /* 236835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(X86::FNSTCW16m),
     /* 236838 */   GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // dst
     /* 236842 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for X86::FPSW*/0,
     /* 236845 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 236849 */   GIR_RootConstrainSelectedInstOperands,
     /* 236850 */   // GIR_Coverage, 1131,
     /* 236850 */   GIR_EraseRootFromParent_Done,
     /* 236851 */ // Label 5461: @236851
     /* 236851 */ GIM_Reject,
     /* 236852 */ // Label 80: @236852
     /* 236852 */ GIM_Reject,
     /* 236853 */ }; // Size: 236853 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const X86Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const X86Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
